(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[  25590354,     561573]
NotebookOptionsPosition[  25422990,     559105]
NotebookOutlinePosition[  25423369,     559122]
CellTagsIndexPosition[  25423326,     559119]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData["Exit"], "Input",ExpressionUUID->"dd850679-1c42-4d05-9c90-343324dcc8aa"],

Cell[CellGroupData[{

Cell[TextData[{
 "The CTensor notation in ",
 StyleBox["xCoba",
  FontSlant->"Italic"]
}], "Section",ExpressionUUID->"fb98dd1d-7f42-4647-b073-c027d32c6c22"],

Cell[CellGroupData[{

Cell["1. Basic ideas", "Subsection",ExpressionUUID->"12900e24-d9d5-48b0-9dce-c94a7ffa32b4"],

Cell[CellGroupData[{

Cell["1.1. Setup", "Subsubsection",ExpressionUUID->"a56c5381-8ed5-4256-bbee-3319327c8384"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"<<", "xAct`xCoba`"}]], "Input",ExpressionUUID->"6e86452c-cc64-43e8-b934-bda791638f3a"],

Cell[CellGroupData[{

Cell[BoxData["\<\"------------------------------------------------------------\
\"\>"], "Print",ExpressionUUID->"adc1681e-18b7-4770-8d68-b5a3a53deb16"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Package xAct`xPerm`  version \"\>", 
   "\[InvisibleSpace]", "\<\"1.2.3\"\>", "\[InvisibleSpace]", "\<\", \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"2015", ",", "8", ",", "23"}], "}"}]}],
  SequenceForm["Package xAct`xPerm`  version ", "1.2.3", ", ", {2015, 8, 23}],
  
  Editable->False]], "Print",ExpressionUUID->"cfee9b16-b9d0-4a8c-89ce-\
cab6e2d20ccb"],

Cell[BoxData["\<\"CopyRight (C) 2003-2015, Jose M. Martin-Garcia, under the \
General Public License.\"\>"], "Print",ExpressionUUID->"13d439ad-cbd6-4730-\
a2a7-62ee81a2c5ca"],

Cell[BoxData["\<\"Connecting to external mac executable...\"\>"], "Print",ExpressionUUID->"0626933e-9138-46b0-aca0-053f41fb9a2e"],

Cell[BoxData["\<\"Connection established.\"\>"], "Print",ExpressionUUID->"ef2369c1-243d-43a1-9e2d-d96398ebc70d"],

Cell[BoxData["\<\"------------------------------------------------------------\
\"\>"], "Print",ExpressionUUID->"b6d74b84-e63c-45de-88d4-5215bd07ca69"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Package xAct`xTensor`  version \"\>", 
   "\[InvisibleSpace]", "\<\"1.1.3\"\>", "\[InvisibleSpace]", "\<\", \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"2018", ",", "2", ",", "28"}], "}"}]}],
  SequenceForm[
  "Package xAct`xTensor`  version ", "1.1.3", ", ", {2018, 2, 28}],
  Editable->False]], "Print",ExpressionUUID->"f013c6cd-22df-41f0-a832-\
32f4b6ded85e"],

Cell[BoxData["\<\"CopyRight (C) 2002-2018, Jose M. Martin-Garcia, under the \
General Public License.\"\>"], "Print",ExpressionUUID->"62cb4867-5282-4fbf-\
8de9-4e50764fabd1"],

Cell[BoxData["\<\"------------------------------------------------------------\
\"\>"], "Print",ExpressionUUID->"499a9353-3774-41b1-9fd9-b9f74acd0cd4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Package xAct`xCoba`  version \"\>", 
   "\[InvisibleSpace]", "\<\"0.8.4\"\>", "\[InvisibleSpace]", "\<\", \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"2018", ",", "2", ",", "28"}], "}"}]}],
  SequenceForm["Package xAct`xCoba`  version ", "0.8.4", ", ", {2018, 2, 28}],
  
  Editable->False]], "Print",ExpressionUUID->"dc0ac610-ebee-4a47-ab09-\
d0ade2d41bc9"],

Cell[BoxData["\<\"CopyRight (C) 2005-2018, David Yllanes and Jose M. \
Martin-Garcia, under the General Public License.\"\>"], "Print",ExpressionUUID\
->"622ddad7-04b3-4635-87d1-cbc6968af3a9"],

Cell[BoxData["\<\"------------------------------------------------------------\
\"\>"], "Print",ExpressionUUID->"d1e3d131-6ec4-42e4-aa85-0cd45cdd2159"],

Cell[BoxData["\<\"These packages come with ABSOLUTELY NO WARRANTY; for \
details type Disclaimer[]. This is free software, and you are welcome to \
redistribute it under certain conditions. See the General Public License for \
details.\"\>"], "Print",ExpressionUUID->"f6539115-d966-4246-9222-\
a7ff76c69bd8"],

Cell[BoxData["\<\"------------------------------------------------------------\
\"\>"], "Print",ExpressionUUID->"0b1b0af5-f42d-411a-882b-711a21d0f1f3"]
}, Open  ]]
}, Open  ]],

Cell["Deactivate def/undef messages:", "Text",ExpressionUUID->"ef27e68e-55fc-4439-91a9-337e63abf187"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"$PrePrint", "=", "ScreenDollarIndices"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"$DefInfoQ", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"$UndefInfoQ", "=", "False"}], ";"}]}], "Input",ExpressionUUID->\
"1a27909d-1cf5-4278-9469-de67d4f21aa9"],

Cell["Prepare a manifold:", "Text",ExpressionUUID->"9c988b6d-d275-4e76-93c2-3b78fa777615"],

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M", ",", "4", ",", 
   RowBox[{"IndexRange", "[", 
    RowBox[{"a", ",", "n"}], "]"}]}], "]"}]], "Input",ExpressionUUID->\
"c536ee93-a30c-4216-bfde-7c89f05cb095"],

Cell["and two bases in its tangent bundle:", "Text",ExpressionUUID->"66978966-457a-426e-b645-7ada3da199f1"],

Cell[BoxData[
 RowBox[{"DefBasis", "[", 
  RowBox[{"red", ",", "TangentM", ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"BasisColor", "\[Rule]", "Red"}]}], "]"}]], "Input",ExpressionUUID-\
>"0b2eb4cf-ce0c-43d9-a4fc-f714e1c8260e"],

Cell[BoxData[
 RowBox[{"DefBasis", "[", 
  RowBox[{"blue", ",", "TangentM", ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"BasisColor", "\[Rule]", "Blue"}]}], "]"}]], "Input",ExpressionUUID\
->"6d7c186a-4771-4b52-b62a-c1e031c2874d"]
}, Closed]],

Cell[CellGroupData[{

Cell["1.2. Algebra", "Subsubsection",ExpressionUUID->"c4e4573b-4cae-4f75-9ad2-cc259b048c21"],

Cell[TextData[{
 "The basic construction in ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 " is a tensor field of the form head[indices]. ",
 StyleBox["xCoba",
  FontSlant->"Italic"],
 " now accepts the same structure, but the head can be an expression \
containing a tensor described by an array of components in a given list of \
bases."
}], "Text",ExpressionUUID->"0ab38c02-d133-42d2-81e2-892a3be7b10f"],

Cell[TextData[{
 "\[Bullet] This a vector field. An additional argument is automatically \
added, the ",
 StyleBox["added tensor weight",
  FontSlant->"Italic"],
 ", zero by default:"
}], "Text",ExpressionUUID->"e495e735-c64e-4d38-88be-244c6b8435df"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"v", "=", 
  RowBox[{"CTensor", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
    RowBox[{"{", "red", "}"}]}], "]"}]}]], "Input",ExpressionUUID->"165aa8d2-\
a0f7-40f6-b84e-9cc85e29a34a"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
   RowBox[{"{", "red", "}"}], ",", "0"}], "]"}]], "Output",ExpressionUUID->\
"86956409-94b0-4fe0-bc60-4a7d20cac73a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xTensorQ", "[", "v", "]"}]], "Input",ExpressionUUID->"f790bbb3-72ef-4dae-8465-09c362c3076a"],

Cell[BoxData["True"], "Output",ExpressionUUID->"f01609bf-e095-4f19-8d2e-453b8c00dc15"]
}, Open  ]],

Cell[TextData[{
 "\[Bullet] By default the object is not formatted. It is typeset when we add \
the index, as usual in ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 ":"
}], "Text",ExpressionUUID->"d81b14e8-5d28-4ee5-9475-2276cecf92ad"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"v", "[", "a", "]"}]], "Input",ExpressionUUID->"b9d92507-cdeb-426b-8df1-2575f3b11090"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["1",
            RowBox[{
              RowBox[{"{", "1", "}"}], "\[Rule]", "1"}]],
           Annotation[#, {1} -> 1, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["2",
            RowBox[{
              RowBox[{"{", "2", "}"}], "\[Rule]", "2"}]],
           Annotation[#, {2} -> 2, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["3",
            RowBox[{
              RowBox[{"{", "3", "}"}], "\[Rule]", "3"}]],
           Annotation[#, {3} -> 3, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["4",
            RowBox[{
              RowBox[{"{", "4", "}"}], "\[Rule]", "4"}]],
           Annotation[#, {4} -> 4, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {
           1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {"a"},
         {" "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{1, 2, 3, 4}, {$CellContext`red}, 0][$CellContext`a],
  Editable->False]], "Output",ExpressionUUID->"4349b7ad-32b4-4c8c-ba64-\
4d1dd38a6880"]
}, Open  ]],

Cell["\<\
The red vertical bars indicate that components correspond to the red basis, \
whose color is Red:\
\>", "Text",ExpressionUUID->"df7121e4-1b51-4e1e-adf3-d78cd50d431a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BasisColor", "[", "red", "]"}]], "Input",ExpressionUUID->"a1317791-f4be-4474-bd65-9c1d18f2f3f6"],

Cell[BoxData[
 InterpretationBox[
  ButtonBox[
   TooltipBox[
    GraphicsBox[{
      {GrayLevel[0], RectangleBox[{0, 0}]}, 
      {GrayLevel[0], RectangleBox[{1, -1}]}, 
      {RGBColor[1, 0, 0], RectangleBox[{0, -1}, {2, 1}]}},
     AspectRatio->1,
     DefaultBaseStyle->"ColorSwatchGraphics",
     Frame->True,
     FrameStyle->RGBColor[0.6666666666666666, 0., 0.],
     FrameTicks->None,
     ImageSize->
      Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
        AbsoluteCurrentValue[Magnification]}],
     PlotRangePadding->None],
    StyleBox[
     RowBox[{"RGBColor", "[", 
       RowBox[{"1", ",", "0", ",", "0"}], "]"}], NumberMarks -> False]],
   Appearance->None,
   BaseStyle->{},
   BaselinePosition->Baseline,
   ButtonFunction:>With[{Typeset`box$ = EvaluationBox[]}, 
     If[
      Not[
       AbsoluteCurrentValue["Deployed"]], 
      SelectionMove[Typeset`box$, All, Expression]; 
      FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
      FrontEnd`Private`$ColorSelectorInitialColor = RGBColor[1, 0, 0]; 
      FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
      MathLink`CallFrontEnd[
        FrontEnd`AttachCell[Typeset`box$, 
         FrontEndResource["RGBColorValueSelector"], {0, {Left, Bottom}}, {
         Left, Top}, 
         "ClosingActions" -> {
          "SelectionDeparture", "ParentChanged", "EvaluatorQuit"}]]]],
   DefaultBaseStyle->{},
   Evaluator->Automatic,
   Method->"Preemptive"],
  RGBColor[1, 0, 0],
  Editable->False,
  Selectable->False]], "Output",ExpressionUUID->"ab93432c-0b0d-4d52-9a86-\
d4faa11aa320"]
}, Open  ]],

Cell["\[Bullet] This is a 2-tensor:", "Text",ExpressionUUID->"b0f0bf3e-b3f1-4807-b397-26ff28e9b412"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SeedRandom", "[", "100", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"S", "=", 
  RowBox[{"CTensor", "[", 
   RowBox[{
    RowBox[{"RandomInteger", "[", 
     RowBox[{"10", ",", 
      RowBox[{"{", 
       RowBox[{"4", ",", "4"}], "}"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"red", ",", " ", 
      RowBox[{"-", "red"}]}], "}"}]}], "]"}]}]}], "Input",ExpressionUUID->\
"8b88f491-919a-4fe0-843b-8d0f622b34c8"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "3", ",", "4", ",", "7"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "10", ",", "1", ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "5", ",", "6", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "8", ",", "9", ",", "10"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"red", ",", 
     RowBox[{"-", "red"}]}], "}"}], ",", "0"}], "]"}]], "Output",ExpressionUUI\
D->"e12c5cd7-11fb-4030-b5dd-bdbb8079dad4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"S", "[", 
  RowBox[{"a", ",", 
   RowBox[{"-", "b"}]}], "]"}]], "Input",ExpressionUUID->"83a116af-ed79-41e9-\
bdeb-fbc192e06dfe"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["3",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", "3"}]],
           Annotation[#, {1, 2} -> 3, "Tooltip"]& ], 
          TagBox[
           TooltipBox["4",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "3"}], "}"}], "\[Rule]", "4"}]],
           Annotation[#, {1, 3} -> 4, "Tooltip"]& ], 
          TagBox[
           TooltipBox["7",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "4"}], "}"}], "\[Rule]", "7"}]],
           Annotation[#, {1, 4} -> 7, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["3",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", "3"}]],
           Annotation[#, {2, 1} -> 3, "Tooltip"]& ], 
          TagBox[
           TooltipBox["10",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", "10"}]],
           Annotation[#, {2, 2} -> 10, "Tooltip"]& ], 
          TagBox[
           TooltipBox["1",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "3"}], "}"}], "\[Rule]", "1"}]],
           Annotation[#, {2, 3} -> 1, "Tooltip"]& ], 
          TagBox[
           TooltipBox["3",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "4"}], "}"}], "\[Rule]", "3"}]],
           Annotation[#, {2, 4} -> 3, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["4",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "1"}], "}"}], "\[Rule]", "4"}]],
           Annotation[#, {3, 1} -> 4, "Tooltip"]& ], 
          TagBox[
           TooltipBox["5",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "2"}], "}"}], "\[Rule]", "5"}]],
           Annotation[#, {3, 2} -> 5, "Tooltip"]& ], 
          TagBox[
           TooltipBox["6",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "3"}], "}"}], "\[Rule]", "6"}]],
           Annotation[#, {3, 3} -> 6, "Tooltip"]& ], 
          TagBox[
           TooltipBox["2",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "4"}], "}"}], "\[Rule]", "2"}]],
           Annotation[#, {3, 4} -> 2, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["1",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "1"}], "}"}], "\[Rule]", "1"}]],
           Annotation[#, {4, 1} -> 1, "Tooltip"]& ], 
          TagBox[
           TooltipBox["8",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "2"}], "}"}], "\[Rule]", "8"}]],
           Annotation[#, {4, 2} -> 8, "Tooltip"]& ], 
          TagBox[
           TooltipBox["9",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "3"}], "}"}], "\[Rule]", "9"}]],
           Annotation[#, {4, 3} -> 9, "Tooltip"]& ], 
          TagBox[
           TooltipBox["10",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "4"}], "}"}], "\[Rule]", "10"}]],
           Annotation[#, {4, 4} -> 10, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {"a", " "},
         {" ", "b"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{0, 3, 4, 7}, {3, 10, 1, 3}, {4, 5, 6, 2}, {1, 8, 9, 
   10}}, {$CellContext`red, -$CellContext`red}, 
   0][$CellContext`a, -$CellContext`b],
  Editable->False]], "Output",ExpressionUUID->"f0622e5b-b807-418d-b70b-\
1c1900628a9b"]
}, Open  ]],

Cell["\<\
Note that the standard representation of a matrix {{1}, {2}} and a vector {1, \
2} coincide in MatrixForm, but not in this CTensor formatting:\
\>", "Text",ExpressionUUID->"1d98bb43-9a01-4748-9f0c-119d244eca19"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"MatrixForm", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", "1", "}"}], ",", 
      RowBox[{"{", "2", "}"}]}], "}"}], "]"}], ",", 
   RowBox[{"MatrixForm", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], "]"}]}], "}"}]], "Input",ExpressionUUID->\
"88da6a6c-61ff-4d5a-91ea-d9786a95aa63"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"1"},
       {"2"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]], ",", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", 
     TagBox[GridBox[{
        {"1"},
        {"2"}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
         "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.5599999999999999]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      Column], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}], "}"}]], "Output",ExpressionUUID->"847f52f9-\
01ca-46e6-8988-e9346d7b3c6e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"CTensor", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", "1", "}"}], ",", 
        RowBox[{"{", "2", "}"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"red", ",", "blue"}], "}"}]}], "]"}], "[", 
    RowBox[{"a", ",", "b"}], "]"}], ",", 
   RowBox[{
    RowBox[{"CTensor", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "2"}], "}"}], ",", 
      RowBox[{"{", "red", "}"}]}], "]"}], "[", "a", "]"}]}], "}"}]], "Input",E\
xpressionUUID->"5b9b092b-4cc1-4337-9fc3-0b263c457f6c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox[GridBox[{
           {
            TagBox[
             TooltipBox["1",
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", "1"}]],
             Annotation[#, {1, 1} -> 1, "Tooltip"]& ]},
           {
            TagBox[
             TooltipBox["2",
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", "2"}]],
             Annotation[#, {2, 1} -> 2, "Tooltip"]& ]}
          },
          AutoDelete->False,
          
          GridBoxDividers->{
           "ColumnsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}, 
            "RowsIndexed" -> {
             1 -> RGBColor[0, 0, 1], 3 -> RGBColor[0, 0, 1]}}],
         FontSize->Small], 
        StyleBox[GridBox[{
           {"a", "b"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xCoba`CTensor[{{1}, {2}}, {$CellContext`red, $CellContext`blue}, 
     0][$CellContext`a, $CellContext`b],
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox[GridBox[{
           {
            TagBox[
             TooltipBox["1",
              RowBox[{
                RowBox[{"{", "1", "}"}], "\[Rule]", "1"}]],
             Annotation[#, {1} -> 1, "Tooltip"]& ]},
           {
            TagBox[
             TooltipBox["2",
              RowBox[{
                RowBox[{"{", "2", "}"}], "\[Rule]", "2"}]],
             Annotation[#, {2} -> 2, "Tooltip"]& ]}
          },
          AutoDelete->False,
          
          GridBoxDividers->{
           "ColumnsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}],
         FontSize->Small], 
        StyleBox[GridBox[{
           {"a"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xCoba`CTensor[{1, 2}, {$CellContext`red}, 0][$CellContext`a],
    Editable->False]}], "}"}]], "Output",ExpressionUUID->"2a8ac984-15e4-48fe-\
a40e-31eaf09d6f48"]
}, Open  ]],

Cell["\<\
The vertical bars correspond to the first index and the horizontal bars \
correspond to the second index. If more indices are present then we nest the \
colored bars, as MatrixForm does. Use the variable $CTensorRepresentation to \
switch between typesetting forms:\
\>", "Text",ExpressionUUID->"41297a39-c4e3-4cbb-bd55-bc7aa80b2452"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"$CTensorRepresentation", "=", "\"\<MatrixForm\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CTensor", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", "1", "}"}], ",", 
        RowBox[{"{", "2", "}"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", "3", "}"}], ",", 
        RowBox[{"{", "4", "}"}]}], "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"red", ",", "red", ",", "blue"}], "}"}]}], "]"}], "[", 
  RowBox[{"a", ",", "b", ",", "c"}], "]"}]}], "Input",ExpressionUUID->\
"b5f3ee3a-5b12-4224-8f02-dad888ce28f7"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[
       TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
           {
            RowBox[{"(", "\[NoBreak]", 
             TagBox[GridBox[{
                {
                 TagBox[
                  TooltipBox["1",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    "1"}]],
                  Annotation[#, {1, 1, 1} -> 1, "Tooltip"]& ]}
               },
               
               GridBoxAlignment->{
                "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.4]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}],
              Column], "\[NoBreak]", ")"}], 
            RowBox[{"(", "\[NoBreak]", 
             TagBox[GridBox[{
                {
                 TagBox[
                  TooltipBox["2",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    "2"}]],
                  Annotation[#, {1, 2, 1} -> 2, "Tooltip"]& ]}
               },
               
               GridBoxAlignment->{
                "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.4]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}],
              Column], "\[NoBreak]", ")"}]},
           {
            RowBox[{"(", "\[NoBreak]", 
             TagBox[GridBox[{
                {
                 TagBox[
                  TooltipBox["3",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    "3"}]],
                  Annotation[#, {2, 1, 1} -> 3, "Tooltip"]& ]}
               },
               
               GridBoxAlignment->{
                "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.4]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}],
              Column], "\[NoBreak]", ")"}], 
            RowBox[{"(", "\[NoBreak]", 
             TagBox[GridBox[{
                {
                 TagBox[
                  TooltipBox["4",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    "4"}]],
                  Annotation[#, {2, 2, 1} -> 4, "Tooltip"]& ]}
               },
               
               GridBoxAlignment->{
                "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.4]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}],
              Column], "\[NoBreak]", ")"}]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.7]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
        Function[BoxForm`e$, 
         MatrixForm[BoxForm`e$]]],
       StripOnInput->False,
       FontSize->Small], 
      StyleBox[GridBox[{
         {"a", "b", "c"},
         {" ", " ", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{{1}, {2}}, {{3}, {
   4}}}, {$CellContext`red, $CellContext`red, $CellContext`blue}, 
   0][$CellContext`a, $CellContext`b, $CellContext`c],
  Editable->False]], "Output",ExpressionUUID->"ea89b720-49ea-4643-8094-\
81df6ef5c9fe"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"$CTensorRepresentation", "=", "\"\<ColorBasisForm\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CTensor", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", "1", "}"}], ",", 
        RowBox[{"{", "2", "}"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", "3", "}"}], ",", 
        RowBox[{"{", "4", "}"}]}], "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"red", ",", "red", ",", "blue"}], "}"}]}], "]"}], "[", 
  RowBox[{"a", ",", "b", ",", "c"}], "]"}]}], "Input",ExpressionUUID->\
"f8bedb07-6b34-4b90-916d-9db4f0658a71"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {GridBox[{
            {
             TagBox[
              TooltipBox["1",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", "1"}]],
              Annotation[#, {1, 1, 1} -> 1, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 2 -> RGBColor[0, 0, 1]}}], GridBox[{
            {
             TagBox[
              TooltipBox["2",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", "2"}]],
              Annotation[#, {1, 2, 1} -> 2, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 2 -> RGBColor[0, 0, 1]}}]},
         {GridBox[{
            {
             TagBox[
              TooltipBox["3",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", "3"}]],
              Annotation[#, {2, 1, 1} -> 3, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 2 -> RGBColor[0, 0, 1]}}], GridBox[{
            {
             TagBox[
              TooltipBox["4",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", "4"}]],
              Annotation[#, {2, 2, 1} -> 4, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 2 -> RGBColor[0, 0, 1]}}]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {"a", "b", "c"},
         {" ", " ", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{{1}, {2}}, {{3}, {
   4}}}, {$CellContext`red, $CellContext`red, $CellContext`blue}, 
   0][$CellContext`a, $CellContext`b, $CellContext`c],
  Editable->False]], "Output",ExpressionUUID->"d155d30f-31c2-4378-a1e5-\
e96029e39999"]
}, Open  ]],

Cell[TextData[{
 "Operations with c-tensors proceed as usual in ",
 StyleBox["xAct",
  FontSlant->"Italic"],
 ", using indices to indicate contractions or transpositions."
}], "Text",ExpressionUUID->"66bdda0e-6c2d-41e3-9f96-02190149acf5"],

Cell["\[Bullet] Compute the trace of a tensor:", "Text",ExpressionUUID->"0929df7b-a1bf-4548-9768-2ddd981640e6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"S", "[", 
  RowBox[{"a", ",", 
   RowBox[{"-", "a"}]}], "]"}]], "Input",ExpressionUUID->"5bdedb97-e7d8-497a-\
b7ed-51b9c59761bb"],

Cell[BoxData["26"], "Output",ExpressionUUID->"cf7a6dd5-f59d-471f-8a37-be9d4e2495f6"]
}, Open  ]],

Cell["\[Bullet] Contract two tensors:", "Text",ExpressionUUID->"47620db7-1479-4f32-bc6f-dc1ba9b9c4d9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"S", "[", 
   RowBox[{"a", ",", 
    RowBox[{"-", "b"}]}], "]"}], 
  RowBox[{"v", "[", "b", "]"}]}]], "Input",ExpressionUUID->"13828dec-67cb-\
4996-9aa3-6e0aa80e592c"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["46",
            RowBox[{
              RowBox[{"{", "1", "}"}], "\[Rule]", "46"}]],
           Annotation[#, {1} -> 46, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["38",
            RowBox[{
              RowBox[{"{", "2", "}"}], "\[Rule]", "38"}]],
           Annotation[#, {2} -> 38, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["40",
            RowBox[{
              RowBox[{"{", "3", "}"}], "\[Rule]", "40"}]],
           Annotation[#, {3} -> 40, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["84",
            RowBox[{
              RowBox[{"{", "4", "}"}], "\[Rule]", "84"}]],
           Annotation[#, {4} -> 84, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {
           1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {"a"},
         {" "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{46, 38, 40, 84}, {$CellContext`red}, 0][$CellContext`a],
  
  Editable->False]], "Output",ExpressionUUID->"a9c048af-417c-4510-a2b6-\
cf02e6af19ca"]
}, Open  ]],

Cell["\[Bullet] Multiply two tensors (their tensor product):", "Text",ExpressionUUID->"7676e574-c9b6-4bf6-9796-0ff4e64d7adc"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "[", 
   RowBox[{"a_", ",", "b_"}], "]"}], "=", 
  RowBox[{
   RowBox[{"v", "[", "a", "]"}], 
   RowBox[{"v", "[", "b", "]"}]}]}]], "Input",ExpressionUUID->"96b37544-729a-\
4500-a5bc-672e8f94751e"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["1",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", "1"}]],
           Annotation[#, {1, 1} -> 1, "Tooltip"]& ], 
          TagBox[
           TooltipBox["2",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", "2"}]],
           Annotation[#, {1, 2} -> 2, "Tooltip"]& ], 
          TagBox[
           TooltipBox["3",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "3"}], "}"}], "\[Rule]", "3"}]],
           Annotation[#, {1, 3} -> 3, "Tooltip"]& ], 
          TagBox[
           TooltipBox["4",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "4"}], "}"}], "\[Rule]", "4"}]],
           Annotation[#, {1, 4} -> 4, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["2",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", "2"}]],
           Annotation[#, {2, 1} -> 2, "Tooltip"]& ], 
          TagBox[
           TooltipBox["4",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", "4"}]],
           Annotation[#, {2, 2} -> 4, "Tooltip"]& ], 
          TagBox[
           TooltipBox["6",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "3"}], "}"}], "\[Rule]", "6"}]],
           Annotation[#, {2, 3} -> 6, "Tooltip"]& ], 
          TagBox[
           TooltipBox["8",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "4"}], "}"}], "\[Rule]", "8"}]],
           Annotation[#, {2, 4} -> 8, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["3",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "1"}], "}"}], "\[Rule]", "3"}]],
           Annotation[#, {3, 1} -> 3, "Tooltip"]& ], 
          TagBox[
           TooltipBox["6",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "2"}], "}"}], "\[Rule]", "6"}]],
           Annotation[#, {3, 2} -> 6, "Tooltip"]& ], 
          TagBox[
           TooltipBox["9",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "3"}], "}"}], "\[Rule]", "9"}]],
           Annotation[#, {3, 3} -> 9, "Tooltip"]& ], 
          TagBox[
           TooltipBox["12",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "4"}], "}"}], "\[Rule]", "12"}]],
           Annotation[#, {3, 4} -> 12, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["4",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "1"}], "}"}], "\[Rule]", "4"}]],
           Annotation[#, {4, 1} -> 4, "Tooltip"]& ], 
          TagBox[
           TooltipBox["8",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "2"}], "}"}], "\[Rule]", "8"}]],
           Annotation[#, {4, 2} -> 8, "Tooltip"]& ], 
          TagBox[
           TooltipBox["12",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "3"}], "}"}], "\[Rule]", "12"}]],
           Annotation[#, {4, 3} -> 12, "Tooltip"]& ], 
          TagBox[
           TooltipBox["16",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "4"}], "}"}], "\[Rule]", "16"}]],
           Annotation[#, {4, 4} -> 16, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {"a", "b"},
         {" ", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{1, 2, 3, 4}, {2, 4, 6, 8}, {3, 6, 9, 12}, {4, 8, 12, 
   16}}, {$CellContext`red, $CellContext`red}, 
   0][$CellContext`a, $CellContext`b],
  Editable->False]], "Output",ExpressionUUID->"2de08423-b89c-4c33-857a-\
1ad153c9765d"]
}, Open  ]],

Cell["\[Bullet] This is a symmetric tensor:", "Text",ExpressionUUID->"05efb439-ec84-476c-8760-7876498018e1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "[", 
   RowBox[{"a", ",", "b"}], "]"}], "\[Equal]", 
  RowBox[{"T", "[", 
   RowBox[{"b", ",", "a"}], "]"}]}]], "Input",ExpressionUUID->"74adb551-29e0-\
4a17-a9d7-6a2eeda46476"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {
       StyleBox[GridBox[{
          {
           TagBox[
            TooltipBox["1",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", "1"}]],
            Annotation[#, {1, 1} -> 1, "Tooltip"]& ], 
           TagBox[
            TooltipBox["2",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", "2"}]],
            Annotation[#, {1, 2} -> 2, "Tooltip"]& ], 
           TagBox[
            TooltipBox["3",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"1", ",", "3"}], "}"}], "\[Rule]", "3"}]],
            Annotation[#, {1, 3} -> 3, "Tooltip"]& ], 
           TagBox[
            TooltipBox["4",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"1", ",", "4"}], "}"}], "\[Rule]", "4"}]],
            Annotation[#, {1, 4} -> 4, "Tooltip"]& ]},
          {
           TagBox[
            TooltipBox["2",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", "2"}]],
            Annotation[#, {2, 1} -> 2, "Tooltip"]& ], 
           TagBox[
            TooltipBox["4",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", "4"}]],
            Annotation[#, {2, 2} -> 4, "Tooltip"]& ], 
           TagBox[
            TooltipBox["6",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"2", ",", "3"}], "}"}], "\[Rule]", "6"}]],
            Annotation[#, {2, 3} -> 6, "Tooltip"]& ], 
           TagBox[
            TooltipBox["8",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"2", ",", "4"}], "}"}], "\[Rule]", "8"}]],
            Annotation[#, {2, 4} -> 8, "Tooltip"]& ]},
          {
           TagBox[
            TooltipBox["3",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"3", ",", "1"}], "}"}], "\[Rule]", "3"}]],
            Annotation[#, {3, 1} -> 3, "Tooltip"]& ], 
           TagBox[
            TooltipBox["6",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"3", ",", "2"}], "}"}], "\[Rule]", "6"}]],
            Annotation[#, {3, 2} -> 6, "Tooltip"]& ], 
           TagBox[
            TooltipBox["9",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"3", ",", "3"}], "}"}], "\[Rule]", "9"}]],
            Annotation[#, {3, 3} -> 9, "Tooltip"]& ], 
           TagBox[
            TooltipBox["12",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"3", ",", "4"}], "}"}], "\[Rule]", "12"}]],
            Annotation[#, {3, 4} -> 12, "Tooltip"]& ]},
          {
           TagBox[
            TooltipBox["4",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"4", ",", "1"}], "}"}], "\[Rule]", "4"}]],
            Annotation[#, {4, 1} -> 4, "Tooltip"]& ], 
           TagBox[
            TooltipBox["8",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"4", ",", "2"}], "}"}], "\[Rule]", "8"}]],
            Annotation[#, {4, 2} -> 8, "Tooltip"]& ], 
           TagBox[
            TooltipBox["12",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"4", ",", "3"}], "}"}], "\[Rule]", "12"}]],
            Annotation[#, {4, 3} -> 12, "Tooltip"]& ], 
           TagBox[
            TooltipBox["16",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"4", ",", "4"}], "}"}], "\[Rule]", "16"}]],
            Annotation[#, {4, 4} -> 16, "Tooltip"]& ]}
         },
         AutoDelete->False,
         GridBoxDividers->{
          "ColumnsIndexed" -> {
            1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}, 
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}],
        FontSize->Small], 
       StyleBox[GridBox[{
          {"a", "b"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xCoba`CTensor[{{1, 2, 3, 4}, {2, 4, 6, 8}, {3, 6, 9, 12}, {4, 8, 12, 
    16}}, {$CellContext`red, $CellContext`red}, 
    0][$CellContext`a, $CellContext`b],
   Editable->False], "\[Equal]", 
  InterpretationBox[
   StyleBox[GridBox[{
      {
       StyleBox[GridBox[{
          {
           TagBox[
            TooltipBox["1",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", "1"}]],
            Annotation[#, {1, 1} -> 1, "Tooltip"]& ], 
           TagBox[
            TooltipBox["2",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", "2"}]],
            Annotation[#, {1, 2} -> 2, "Tooltip"]& ], 
           TagBox[
            TooltipBox["3",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"1", ",", "3"}], "}"}], "\[Rule]", "3"}]],
            Annotation[#, {1, 3} -> 3, "Tooltip"]& ], 
           TagBox[
            TooltipBox["4",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"1", ",", "4"}], "}"}], "\[Rule]", "4"}]],
            Annotation[#, {1, 4} -> 4, "Tooltip"]& ]},
          {
           TagBox[
            TooltipBox["2",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", "2"}]],
            Annotation[#, {2, 1} -> 2, "Tooltip"]& ], 
           TagBox[
            TooltipBox["4",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", "4"}]],
            Annotation[#, {2, 2} -> 4, "Tooltip"]& ], 
           TagBox[
            TooltipBox["6",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"2", ",", "3"}], "}"}], "\[Rule]", "6"}]],
            Annotation[#, {2, 3} -> 6, "Tooltip"]& ], 
           TagBox[
            TooltipBox["8",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"2", ",", "4"}], "}"}], "\[Rule]", "8"}]],
            Annotation[#, {2, 4} -> 8, "Tooltip"]& ]},
          {
           TagBox[
            TooltipBox["3",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"3", ",", "1"}], "}"}], "\[Rule]", "3"}]],
            Annotation[#, {3, 1} -> 3, "Tooltip"]& ], 
           TagBox[
            TooltipBox["6",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"3", ",", "2"}], "}"}], "\[Rule]", "6"}]],
            Annotation[#, {3, 2} -> 6, "Tooltip"]& ], 
           TagBox[
            TooltipBox["9",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"3", ",", "3"}], "}"}], "\[Rule]", "9"}]],
            Annotation[#, {3, 3} -> 9, "Tooltip"]& ], 
           TagBox[
            TooltipBox["12",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"3", ",", "4"}], "}"}], "\[Rule]", "12"}]],
            Annotation[#, {3, 4} -> 12, "Tooltip"]& ]},
          {
           TagBox[
            TooltipBox["4",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"4", ",", "1"}], "}"}], "\[Rule]", "4"}]],
            Annotation[#, {4, 1} -> 4, "Tooltip"]& ], 
           TagBox[
            TooltipBox["8",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"4", ",", "2"}], "}"}], "\[Rule]", "8"}]],
            Annotation[#, {4, 2} -> 8, "Tooltip"]& ], 
           TagBox[
            TooltipBox["12",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"4", ",", "3"}], "}"}], "\[Rule]", "12"}]],
            Annotation[#, {4, 3} -> 12, "Tooltip"]& ], 
           TagBox[
            TooltipBox["16",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"4", ",", "4"}], "}"}], "\[Rule]", "16"}]],
            Annotation[#, {4, 4} -> 16, "Tooltip"]& ]}
         },
         AutoDelete->False,
         GridBoxDividers->{
          "ColumnsIndexed" -> {
            1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}, 
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}],
        FontSize->Small], 
       StyleBox[GridBox[{
          {"b", "a"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xCoba`CTensor[{{1, 2, 3, 4}, {2, 4, 6, 8}, {3, 6, 9, 12}, {4, 8, 12, 
    16}}, {$CellContext`red, $CellContext`red}, 
    0][$CellContext`b, $CellContext`a],
   Editable->False]}]], "Output",ExpressionUUID->"3ea464a7-d711-4330-9fc1-\
28a545d0dcec"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", "ToCanonical"}]], "Input",ExpressionUUID->"1c82269a-1e10-4f9a-91b9-28503b9924db"],

Cell[BoxData["True"], "Output",ExpressionUUID->"a398dbff-0c6d-4b89-93a1-df36512675d3"]
}, Open  ]],

Cell["\[Bullet] In sums there is automatic reordering of indices:", "Text",ExpressionUUID->"321c2c73-b63e-406b-9dc5-d013cdfa565d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "[", 
   RowBox[{"a", ",", "b"}], "]"}], "-", 
  RowBox[{"T", "[", 
   RowBox[{"b", ",", "a"}], "]"}]}]], "Input",ExpressionUUID->"2cfadac6-2ef5-\
4e0f-ac4e-19b3dcffeedc"],

Cell[BoxData["0"], "Output",ExpressionUUID->"b42f87e7-ddfd-4cd6-bded-cc22a5a85fbe"]
}, Open  ]],

Cell[TextData[{
 "\[Bullet] Note that the previous expression returned 0, and not a CTensor \
with an array of zeros. This is to follow the standard behaviour of ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 ":"
}], "Text",ExpressionUUID->"efc83a62-3080-45ab-8f81-bbed06272d8a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"v", "[", "a", "]"}], 
   RowBox[{"v", "[", "b", "]"}]}], "-", 
  RowBox[{
   RowBox[{"v", "[", "b", "]"}], 
   RowBox[{"v", "[", "a", "]"}]}]}]], "Input",ExpressionUUID->"1c6c695d-9115-\
4a30-939c-c27c8bbc753d"],

Cell[BoxData["0"], "Output",ExpressionUUID->"fe91d877-78ad-49db-9033-579d2ce4e1b6"]
}, Open  ]],

Cell[TextData[{
 "The CTensor notation is an alternative to the \[OpenCurlyDoubleQuote]linear \
combination notation\[CloseCurlyDoubleQuote] in ",
 StyleBox["xCoba",
  FontSlant->"Italic"],
 ". It is possible to change between both notations."
}], "Text",ExpressionUUID->"7a072495-0ca5-415f-a33c-17888d776c51"],

Cell["\<\
\[Bullet] Expand a CTensor into a linear combination of bases objects, and \
then back.\
\>", "Text",ExpressionUUID->"e531980a-d6f1-432c-8022-c2015c5519cc"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"v", "[", "a", "]"}]], "Input",ExpressionUUID->"b1adb84f-bf1f-4a9e-8900-e203de52a72c"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["1",
            RowBox[{
              RowBox[{"{", "1", "}"}], "\[Rule]", "1"}]],
           Annotation[#, {1} -> 1, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["2",
            RowBox[{
              RowBox[{"{", "2", "}"}], "\[Rule]", "2"}]],
           Annotation[#, {2} -> 2, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["3",
            RowBox[{
              RowBox[{"{", "3", "}"}], "\[Rule]", "3"}]],
           Annotation[#, {3} -> 3, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["4",
            RowBox[{
              RowBox[{"{", "4", "}"}], "\[Rule]", "4"}]],
           Annotation[#, {4} -> 4, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {
           1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {"a"},
         {" "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{1, 2, 3, 4}, {$CellContext`red}, 0][$CellContext`a],
  Editable->False]], "Output",ExpressionUUID->"bb803c29-b3c3-472c-8457-\
a573a6b7ffd9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BasisExpand", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", "red", "}"}]}], "]"}]], "Input",ExpressionUUID->"4e42a73c-\
a114-43d3-a55d-3a0a20fbc850"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"e", 
       StyleBox[GridBox[{
          {" ", "a"},
          {
           StyleBox["0",
            FontColor->RGBColor[1., 0., 0.]], " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`Basis[{0, -$CellContext`red}, $CellContext`a],
   Editable->False], "+", 
  RowBox[{"2", " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"e", 
        StyleBox[GridBox[{
           {" ", "a"},
           {
            StyleBox["1",
             FontColor->RGBColor[1., 0., 0.]], " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Basis[{1, -$CellContext`red}, $CellContext`a],
    Editable->False]}], "+", 
  RowBox[{"3", " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"e", 
        StyleBox[GridBox[{
           {" ", "a"},
           {
            StyleBox["2",
             FontColor->RGBColor[1., 0., 0.]], " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Basis[{2, -$CellContext`red}, $CellContext`a],
    Editable->False]}], "+", 
  RowBox[{"4", " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"e", 
        StyleBox[GridBox[{
           {" ", "a"},
           {
            StyleBox["3",
             FontColor->RGBColor[1., 0., 0.]], " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Basis[{3, -$CellContext`red}, $CellContext`a],
    Editable->False]}]}]], "Output",ExpressionUUID->"85a553df-5ea6-4fdf-9131-\
752b87d400ae"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%%", "//", "ToBasisExpand"}]], "Input",ExpressionUUID->"9eea2aa0-225b-4a68-a093-805365050c3a"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"e", 
       StyleBox[GridBox[{
          {" ", "a"},
          {
           StyleBox["0",
            FontColor->RGBColor[1., 0., 0.]], " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`Basis[{0, -$CellContext`red}, $CellContext`a],
   Editable->False], "+", 
  RowBox[{"2", " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"e", 
        StyleBox[GridBox[{
           {" ", "a"},
           {
            StyleBox["1",
             FontColor->RGBColor[1., 0., 0.]], " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Basis[{1, -$CellContext`red}, $CellContext`a],
    Editable->False]}], "+", 
  RowBox[{"3", " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"e", 
        StyleBox[GridBox[{
           {" ", "a"},
           {
            StyleBox["2",
             FontColor->RGBColor[1., 0., 0.]], " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Basis[{2, -$CellContext`red}, $CellContext`a],
    Editable->False]}], "+", 
  RowBox[{"4", " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"e", 
        StyleBox[GridBox[{
           {" ", "a"},
           {
            StyleBox["3",
             FontColor->RGBColor[1., 0., 0.]], " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Basis[{3, -$CellContext`red}, $CellContext`a],
    Editable->False]}]}]], "Output",ExpressionUUID->"a3a8ba3b-cffb-4fa8-a771-\
49efb649a4cc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FromBasisExpand", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", "red", "}"}]}], "]"}]], "Input",ExpressionUUID->"e7541faf-\
1064-4ec0-a228-647e37704b37"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["1",
            RowBox[{
              RowBox[{"{", "1", "}"}], "\[Rule]", "1"}]],
           Annotation[#, {1} -> 1, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["2",
            RowBox[{
              RowBox[{"{", "2", "}"}], "\[Rule]", "2"}]],
           Annotation[#, {2} -> 2, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["3",
            RowBox[{
              RowBox[{"{", "3", "}"}], "\[Rule]", "3"}]],
           Annotation[#, {3} -> 3, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["4",
            RowBox[{
              RowBox[{"{", "4", "}"}], "\[Rule]", "4"}]],
           Annotation[#, {4} -> 4, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {
           1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {"a"},
         {" "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{1, 2, 3, 4}, {$CellContext`red}, 0][$CellContext`a],
  Editable->False]], "Output",ExpressionUUID->"9e0ae923-bdcd-4e9f-8226-\
e27c191079cf"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["1.3. A metric field", "Subsubsection",ExpressionUUID->"bbad4ff0-9a95-487d-b684-132c52ef8cb6"],

Cell["\[Bullet] Define a coordinate system:", "Text",ExpressionUUID->"5f2a9822-aefe-40e9-b648-0c084d9c2c90"],

Cell[BoxData[
 RowBox[{"DefChart", "[", 
  RowBox[{"ch", ",", "M", ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"t", "[", "]"}], ",", 
     RowBox[{"r", "[", "]"}], ",", 
     RowBox[{"\[Theta]", "[", "]"}], ",", 
     RowBox[{"\[Phi]", "[", "]"}]}], "}"}], ",", 
   RowBox[{"ChartColor", "\[Rule]", "Brown"}]}], "]"}]], "Input",ExpressionUUI\
D->"16ef8119-7018-4600-ae0c-9b63ac171ef6"],

Cell["\[Bullet] Now define a metric field, the Schwarzschild metric:", "Text",ExpressionUUID->"03bb7142-0853-4dcb-889c-7d613025f837"],

Cell[BoxData[
 RowBox[{"DefConstantSymbol", "[", 
  RowBox[{"mass", ",", 
   RowBox[{"PrintAs", "\[Rule]", "\"\<M\>\""}]}], "]"}]], "Input",ExpressionUU\
ID->"0c749e99-4e6c-4f81-bee8-e9f468815b5f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"met", "=", 
   RowBox[{"CTensor", "[", 
    RowBox[{
     RowBox[{"DiagonalMatrix", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         RowBox[{"2", 
          RowBox[{"mass", "/", 
           RowBox[{"r", "[", "]"}]}]}]}], ",", 
        RowBox[{"1", "/", 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"2", 
            RowBox[{"mass", "/", 
             RowBox[{"r", "[", "]"}]}]}]}], ")"}]}], ",", 
        RowBox[{
         RowBox[{"r", "[", "]"}], "^", "2"}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"r", "[", "]"}], "^", "2"}], 
         RowBox[{
          RowBox[{"Sin", "[", 
           RowBox[{"\[Theta]", "[", "]"}], "]"}], "^", "2"}]}]}], "}"}], 
      "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "ch"}], ",", 
       RowBox[{"-", "ch"}]}], "}"}]}], "]"}]}], ";"}]], "Input",ExpressionUUID\
->"fcd08836-ab89-476a-8975-c2881af3a34f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"met", "[", 
  RowBox[{
   RowBox[{"-", "a"}], ",", 
   RowBox[{"-", "b"}]}], "]"}]], "Input",ExpressionUUID->"f7826553-fde2-41b3-\
b2f7-488981eb395e"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox[
            RowBox[{
             RowBox[{"-", "1"}], "+", 
             FractionBox[
              RowBox[{"2", " ", 
               InterpretationBox[
                StyleBox["M",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`mass,
                Editable->False]}], 
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False]]}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
              RowBox[{
                RowBox[{"-", "1"}], "+", 
                FractionBox[
                 RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False]}], 
                 InterpretationBox[
                  StyleBox[
                  "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`r[], Editable -> False]]}]}]],
           
           Annotation[#, {1, 1} -> -1 + 2 $CellContext`mass/$CellContext`r[], 
            "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 4} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            FractionBox["1", 
             RowBox[{"1", "-", 
              FractionBox[
               RowBox[{"2", " ", 
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`mass,
                 Editable->False]}], 
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False]]}]],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
              FractionBox["1", 
               RowBox[{"1", "-", 
                 FractionBox[
                  RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False]}], 
                  InterpretationBox[
                   StyleBox[
                   "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`r[], Editable -> False]]}]]}]],
           
           Annotation[#, {2, 
             2} -> (1 - 2 $CellContext`mass/$CellContext`r[])^(-1), 
            "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 4} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            SuperscriptBox[
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False], "2"],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "3"}], "}"}], "\[Rule]", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox[
                "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                $CellContext`r[], Editable -> False], "2"]}]],
           Annotation[#, {3, 3} -> $CellContext`r[]^2, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 4} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{
             SuperscriptBox[
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], "2"], " ", 
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["Sin",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                Sin,
                Editable->False], "[", 
               InterpretationBox[
                StyleBox["\[Theta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Theta][],
                Editable->False], "]"}], "2"]}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "4"}], "}"}], "\[Rule]", 
              RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox[
                  "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`r[], Editable -> False], "2"], " ", 
                SuperscriptBox[
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"Sin"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Sin, Editable -> False], "[", 
                   InterpretationBox[
                    StyleBox[
                    "\[Theta]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Theta][], Editable -> False], "]"}], 
                 "2"]}]}]],
           Annotation[#, {4, 4} -> $CellContext`r[]^2 Sin[
                $CellContext`\[Theta][]]^2, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {
           1 -> RGBColor[0.6, 0.4, 0.2], 5 -> RGBColor[0.6, 0.4, 0.2]}, 
          "RowsIndexed" -> {
           1 -> RGBColor[0.6, 0.4, 0.2], 5 -> RGBColor[0.6, 0.4, 0.2]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {" ", " "},
         {"a", "b"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{-1 + 2 $CellContext`mass/$CellContext`r[], 0, 0, 0}, {
    0, (1 - 2 $CellContext`mass/$CellContext`r[])^(-1), 0, 0}, {
    0, 0, $CellContext`r[]^2, 0}, {0, 0, 0, $CellContext`r[]^2 Sin[
        $CellContext`\[Theta][]]^2}}, {-$CellContext`ch, -$CellContext`ch}, 
   0][-$CellContext`a, -$CellContext`b],
  Editable->False]], "Output",ExpressionUUID->"a6d8ee2f-acbd-46cb-a192-\
0900da125c03"]
}, Open  ]],

Cell["\<\
\[Bullet] We associate the metric to the manifold. Some properties of the \
metric are precomputed and cached (this is roughly the C-version of \
DefMetric):\
\>", "Text",ExpressionUUID->"783989b7-b712-4d43-bd48-ef6c77c4da08"],

Cell[BoxData[
 RowBox[{"SetCMetric", "[", 
  RowBox[{"met", ",", "ch", ",", 
   RowBox[{"SignatureOfMetric", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"3", ",", "1", ",", "0"}], "}"}]}]}], "]"}]], "Input",ExpressionU\
UID->"65771983-f760-4090-92b2-a5033d5d0f20"],

Cell["\<\
\[Bullet] Now that we have a metric, raising and lowering indices produces \
the expected result:\
\>", "Text",ExpressionUUID->"04af4414-05ae-43b4-9db7-fe4a6ae21e9b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"V", "=", 
  RowBox[{"CTensor", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"0", ",", 
      RowBox[{"r", "[", "]"}], ",", "0", ",", "0"}], "}"}], ",", 
    RowBox[{"{", "ch", "}"}]}], "]"}]}]], "Input",ExpressionUUID->"3088145e-\
af6e-4f46-a4be-d16bad31aced"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", "ch", "}"}], ",", "0"}], "]"}]], "Output",ExpressionUUID->\
"fc1c4d80-6a7f-4726-a201-388a4bbc3085"]
}, Open  ]],

Cell["The change is automatically computed:", "Text",ExpressionUUID->"1103015e-79bf-4306-ad44-d925026fa5cf"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"V", "[", "a", "]"}], ",", 
   RowBox[{"V", "[", 
    RowBox[{"-", "a"}], "]"}]}], "}"}]], "Input",ExpressionUUID->"dd693f39-\
3253-42a2-93e3-222209ddfdba"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox[GridBox[{
           {
            TagBox[
             TooltipBox["0",
              RowBox[{
                RowBox[{"{", "1", "}"}], "\[Rule]", "0"}]],
             Annotation[#, {1} -> 0, "Tooltip"]& ]},
           {
            TagBox[
             TooltipBox[
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False],
              RowBox[{
                RowBox[{"{", "2", "}"}], "\[Rule]", 
                InterpretationBox[
                 StyleBox["r", AutoSpacing -> False, ShowAutoStyles -> False], 
                 $CellContext`r[], Editable -> False]}]],
             Annotation[#, {2} -> $CellContext`r[], "Tooltip"]& ]},
           {
            TagBox[
             TooltipBox["0",
              RowBox[{
                RowBox[{"{", "3", "}"}], "\[Rule]", "0"}]],
             Annotation[#, {3} -> 0, "Tooltip"]& ]},
           {
            TagBox[
             TooltipBox["0",
              RowBox[{
                RowBox[{"{", "4", "}"}], "\[Rule]", "0"}]],
             Annotation[#, {4} -> 0, "Tooltip"]& ]}
          },
          AutoDelete->False,
          
          GridBoxDividers->{
           "ColumnsIndexed" -> {
             1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}],
         FontSize->Small], 
        StyleBox[GridBox[{
           {"a"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xCoba`CTensor[{0, 
      $CellContext`r[], 0, 0}, {$CellContext`ch}, 0][$CellContext`a],
    Editable->False], ",", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox[GridBox[{
           {
            TagBox[
             TooltipBox["0",
              RowBox[{
                RowBox[{"{", "1", "}"}], "\[Rule]", "0"}]],
             Annotation[#, {1} -> 0, "Tooltip"]& ]},
           {
            TagBox[
             TooltipBox[
              FractionBox[
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False], 
               RowBox[{"1", "-", 
                FractionBox[
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`mass,
                   Editable->False]}], 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]]}]],
              RowBox[{
                RowBox[{"{", "2", "}"}], "\[Rule]", 
                FractionBox[
                 InterpretationBox[
                  StyleBox[
                  "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`r[], Editable -> False], 
                 RowBox[{"1", "-", 
                   FractionBox[
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False]}], 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]]}]]}]],
             
             Annotation[#, {
               2} -> (1 - 
                 2 $CellContext`mass/$CellContext`r[])^(-1) $CellContext`r[], 
              "Tooltip"]& ]},
           {
            TagBox[
             TooltipBox["0",
              RowBox[{
                RowBox[{"{", "3", "}"}], "\[Rule]", "0"}]],
             Annotation[#, {3} -> 0, "Tooltip"]& ]},
           {
            TagBox[
             TooltipBox["0",
              RowBox[{
                RowBox[{"{", "4", "}"}], "\[Rule]", "0"}]],
             Annotation[#, {4} -> 0, "Tooltip"]& ]}
          },
          AutoDelete->False,
          
          GridBoxDividers->{
           "ColumnsIndexed" -> {
             1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}],
         FontSize->Small], 
        StyleBox[GridBox[{
           {" "},
           {"a"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xCoba`CTensor[{
     0, (1 - 2 $CellContext`mass/$CellContext`r[])^(-1) $CellContext`r[], 0, 
      0}, {-$CellContext`ch}, 0][-$CellContext`a],
    Editable->False]}], "}"}]], "Output",ExpressionUUID->"bcd944d1-c1f2-47af-\
84b3-2e68044c487f"]
}, Open  ]],

Cell["This is a contraction:", "Text",ExpressionUUID->"cb823a76-74a4-4350-871f-0b5b692b42f9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"V", "[", "a", "]"}], 
  RowBox[{"V", "[", 
   RowBox[{"-", "a"}], "]"}]}]], "Input",ExpressionUUID->"3c17cd50-6552-40d6-\
ab6f-d70609574252"],

Cell[BoxData[
 FractionBox[
  SuperscriptBox[
   InterpretationBox[
    StyleBox["r",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`r[],
    Editable->False], "2"], 
  RowBox[{"1", "-", 
   FractionBox[
    RowBox[{"2", " ", 
     InterpretationBox[
      StyleBox["M",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`mass,
      Editable->False]}], 
    InterpretationBox[
     StyleBox["r",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`r[],
     Editable->False]]}]]], "Output",ExpressionUUID->"7f8703a1-d7a1-4682-aed8-\
312ed65bf349"]
}, Open  ]],

Cell["If we raise one index of the metric we get the identity:", "Text",ExpressionUUID->"a97f493a-e0e9-4390-828a-bd6eeea68a32"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"met", "[", 
  RowBox[{
   RowBox[{"-", "a"}], ",", "b"}], "]"}]], "Input",ExpressionUUID->"9bf46615-\
8dcf-416d-9556-0b36df8d545d"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["1",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", "1"}]],
           Annotation[#, {1, 1} -> 1, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 4} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["1",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", "1"}]],
           Annotation[#, {2, 2} -> 1, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 4} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["1",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "3"}], "}"}], "\[Rule]", "1"}]],
           Annotation[#, {3, 3} -> 1, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 4} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["1",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "4"}], "}"}], "\[Rule]", "1"}]],
           Annotation[#, {4, 4} -> 1, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {
           1 -> RGBColor[0.6, 0.4, 0.2], 5 -> RGBColor[0.6, 0.4, 0.2]}, 
          "RowsIndexed" -> {
           1 -> RGBColor[0.6, 0.4, 0.2], 5 -> RGBColor[0.6, 0.4, 0.2]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {" ", "b"},
         {"a", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{1, 0, 0, 0}, {0, 1, 0, 0}, {0, 0, 1, 0}, {0, 0, 0, 
   1}}, {-$CellContext`ch, $CellContext`ch}, 
   0][-$CellContext`a, $CellContext`b],
  Editable->False]], "Output",ExpressionUUID->"d8132c18-311d-4323-910c-\
06c1a60af65d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"met", "[", 
  RowBox[{"a", ",", "b"}], "]"}]], "Input",ExpressionUUID->"deac5a6c-bb9f-48da-84d8-abd892435a83"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox[
            FractionBox[
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False], 
             RowBox[{
              RowBox[{"2", " ", 
               InterpretationBox[
                StyleBox["M",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`mass,
                Editable->False]}], "-", 
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False]}]],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
              FractionBox[
               InterpretationBox[
                StyleBox[
                "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                $CellContext`r[], Editable -> False], 
               RowBox[{
                 RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False]}], "-", 
                 InterpretationBox[
                  StyleBox[
                  "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`r[], Editable -> False]}]]}]],
           
           Annotation[#, {1, 
             1} -> (2 $CellContext`mass - $CellContext`r[])^(-1) \
$CellContext`r[], "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 4} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{"1", "-", 
             FractionBox[
              RowBox[{"2", " ", 
               InterpretationBox[
                StyleBox["M",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`mass,
                Editable->False]}], 
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False]]}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
              RowBox[{"1", "-", 
                FractionBox[
                 RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False]}], 
                 InterpretationBox[
                  StyleBox[
                  "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`r[], Editable -> False]]}]}]],
           
           Annotation[#, {2, 2} -> 1 - 2 $CellContext`mass/$CellContext`r[], 
            "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 4} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            FractionBox["1", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], "2"]],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "3"}], "}"}], "\[Rule]", 
              FractionBox["1", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["r", AutoSpacing -> False, ShowAutoStyles -> False], 
                 $CellContext`r[], Editable -> False], "2"]]}]],
           Annotation[#, {3, 3} -> $CellContext`r[]^(-2), "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 4} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            FractionBox[
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["Csc",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                Csc,
                Editable->False], "[", 
               InterpretationBox[
                StyleBox["\[Theta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Theta][],
                Editable->False], "]"}], "2"], 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], "2"]],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "4"}], "}"}], "\[Rule]", 
              FractionBox[
               SuperscriptBox[
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"Csc"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Csc, Editable -> False], "[", 
                  InterpretationBox[
                   StyleBox[
                   "\[Theta]", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`\[Theta][], Editable -> False], "]"}], "2"], 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["r", AutoSpacing -> False, ShowAutoStyles -> False], 
                 $CellContext`r[], Editable -> False], "2"]]}]],
           Annotation[#, {4, 4} -> Csc[
                $CellContext`\[Theta][]]^2 $CellContext`r[]^(-2), 
            "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {
           1 -> RGBColor[0.6, 0.4, 0.2], 5 -> RGBColor[0.6, 0.4, 0.2]}, 
          "RowsIndexed" -> {
           1 -> RGBColor[0.6, 0.4, 0.2], 5 -> RGBColor[0.6, 0.4, 0.2]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {"a", "b"},
         {" ", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{(
       2 $CellContext`mass - $CellContext`r[])^(-1) $CellContext`r[], 0, 0, 
     0}, {0, 1 - 2 $CellContext`mass/$CellContext`r[], 0, 0}, {
    0, 0, $CellContext`r[]^(-2), 0}, {0, 0, 0, Csc[
        $CellContext`\[Theta][]]^2 $CellContext`r[]^(-2)}}, {$CellContext`ch, \
$CellContext`ch}, 0][$CellContext`a, $CellContext`b],
  Editable->False]], "Output",ExpressionUUID->"deab6ae0-c8c2-4b1d-9429-\
c9820cafe534"]
}, Open  ]],

Cell["\[Bullet] Some properties of the metric:", "Text",ExpressionUUID->"fa19c409-b26a-47b2-bdca-bdfc8e2cf9a2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Determinant", "[", 
  RowBox[{"met", ",", "ch"}], "]"}]], "Input",ExpressionUUID->"59b3da92-0cc8-\
460a-8a14-33b26642e946"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "4"]}], " ", 
    SuperscriptBox[
     RowBox[{
      InterpretationBox[
       StyleBox["Sin",
        ShowAutoStyles->False,
        AutoSpacing->False],
       Sin,
       Editable->False], "[", 
      InterpretationBox[
       StyleBox["\[Theta]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Theta][],
       Editable->False], "]"}], "2"]}], ",", 
   RowBox[{"{", "}"}], ",", 
   RowBox[{"2", " ", "ch"}]}], "]"}]], "Output",ExpressionUUID->"e5c09895-\
8a7f-43c4-8c0e-3f86fc8eac21"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SignDetOfMetric", "[", "met", "]"}]], "Input",ExpressionUUID->"ae388769-f76b-4f64-a404-183823e31f51"],

Cell[BoxData[
 RowBox[{"-", "1"}]], "Output",ExpressionUUID->"42086c93-cab7-4252-891f-71f458b87fe3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SignatureOfMetric", "[", "met", "]"}]], "Input",ExpressionUUID->"09cd3165-b354-4581-af33-c36ce2437320"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"3", ",", "1", ",", "0"}], "}"}]], "Output",ExpressionUUID->\
"6e66beab-2744-4897-941f-ae0b48e27a76"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["1.4. Covariant derivatives", "Subsubsection",ExpressionUUID->"7ca90206-71af-41db-a244-1e0deb51ae61"],

Cell[TextData[{
 "Given a covariant derivative operator we can give any other by supplying a \
Christoffel tensor. ",
 StyleBox["xCoba",
  FontSlant->"Italic"],
 " can handle such transformations using the construction CCovD[covd, \
christoffel, metric], where the third argument specifies a metric tensor, in \
case the Christoffel derives from it."
}], "Text",ExpressionUUID->"98269a25-89bd-4c61-856c-9a5f4a6e68b3"],

Cell["\<\
\[Bullet] This is the Levi-Civita connection associated to the metric:\
\>", "Text",ExpressionUUID->"fbf78665-b9ba-444e-9c2f-c4e0cb9b0837"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"cd", "=", 
  RowBox[{"CovDOfMetric", "[", "met", "]"}]}]], "Input",ExpressionUUID->\
"76efc5b1-8bd9-45d9-9c87-b8dab4175840"],

Cell[BoxData[
 RowBox[{"CCovD", "[", 
  RowBox[{"PDch", ",", 
   RowBox[{"CTensor", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"-", 
            FractionBox[
             InterpretationBox[
              StyleBox["M",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`mass,
              Editable->False], 
             RowBox[{
              RowBox[{"2", " ", 
               InterpretationBox[
                StyleBox["M",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`mass,
                Editable->False], " ", 
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False]}], "-", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False], "2"]}]]}], ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             InterpretationBox[
              StyleBox["M",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`mass,
              Editable->False], 
             RowBox[{
              RowBox[{"2", " ", 
               InterpretationBox[
                StyleBox["M",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`mass,
                Editable->False], " ", 
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False]}], "-", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False], "2"]}]]}], ",", "0", ",", "0", ",", "0"}], 
          "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            RowBox[{
             InterpretationBox[
              StyleBox["M",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`mass,
              Editable->False], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "2"}], " ", 
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`mass,
                 Editable->False]}], "+", 
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False]}], ")"}]}], 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False], "3"]], ",", "0", ",", "0", ",", "0"}], "}"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           FractionBox[
            InterpretationBox[
             StyleBox["M",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`mass,
             Editable->False], 
            RowBox[{
             RowBox[{"2", " ", 
              InterpretationBox[
               StyleBox["M",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`mass,
               Editable->False], " ", 
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False]}], "-", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], "2"]}]], ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", 
           RowBox[{
            RowBox[{"2", " ", 
             InterpretationBox[
              StyleBox["M",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`mass,
              Editable->False]}], "-", 
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False]}], ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", 
               InterpretationBox[
                StyleBox["M",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`mass,
                Editable->False]}], "-", 
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False]}], ")"}], " ", 
            SuperscriptBox[
             RowBox[{
              InterpretationBox[
               StyleBox["Sin",
                ShowAutoStyles->False,
                AutoSpacing->False],
               Sin,
               Editable->False], "[", 
              InterpretationBox[
               StyleBox["\[Theta]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Theta][],
               Editable->False], "]"}], "2"]}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", 
           FractionBox["1", 
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False]], ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           FractionBox["1", 
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False]], ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", 
           RowBox[{
            RowBox[{"-", 
             RowBox[{
              InterpretationBox[
               StyleBox["Cos",
                ShowAutoStyles->False,
                AutoSpacing->False],
               Cos,
               Editable->False], "[", 
              InterpretationBox[
               StyleBox["\[Theta]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Theta][],
               Editable->False], "]"}]}], " ", 
            RowBox[{
             InterpretationBox[
              StyleBox["Sin",
               ShowAutoStyles->False,
               AutoSpacing->False],
              Sin,
              Editable->False], "[", 
             InterpretationBox[
              StyleBox["\[Theta]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Theta][],
              Editable->False], "]"}]}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", 
           FractionBox["1", 
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False]]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", 
           RowBox[{
            InterpretationBox[
             StyleBox["Cot",
              ShowAutoStyles->False,
              AutoSpacing->False],
             Cot,
             Editable->False], "[", 
            InterpretationBox[
             StyleBox["\[Theta]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Theta][],
             Editable->False], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           FractionBox["1", 
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False]], ",", 
           RowBox[{
            InterpretationBox[
             StyleBox["Cot",
              ShowAutoStyles->False,
              AutoSpacing->False],
             Cot,
             Editable->False], "[", 
            InterpretationBox[
             StyleBox["\[Theta]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Theta][],
             Editable->False], "]"}], ",", "0"}], "}"}]}], "}"}]}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"ch", ",", 
       RowBox[{"-", "ch"}], ",", 
       RowBox[{"-", "ch"}]}], "}"}], ",", "0"}], "]"}], ",", 
   RowBox[{"CTensor", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          FractionBox[
           RowBox[{"2", " ", 
            InterpretationBox[
             StyleBox["M",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`mass,
             Editable->False]}], 
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False]]}], ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         FractionBox["1", 
          RowBox[{"1", "-", 
           FractionBox[
            RowBox[{"2", " ", 
             InterpretationBox[
              StyleBox["M",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`mass,
              Editable->False]}], 
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False]]}]], ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], "2"], ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", 
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], "2"], " ", 
          SuperscriptBox[
           RowBox[{
            InterpretationBox[
             StyleBox["Sin",
              ShowAutoStyles->False,
              AutoSpacing->False],
             Sin,
             Editable->False], "[", 
            InterpretationBox[
             StyleBox["\[Theta]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Theta][],
             Editable->False], "]"}], "2"]}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "ch"}], ",", 
       RowBox[{"-", "ch"}]}], "}"}], ",", "0"}], "]"}]}], "]"}]], "Output",Exp\
ressionUUID->"a52a63cb-cede-4785-87be-602dc8fe3777"]
}, Open  ]],

Cell[TextData[{
 "\[Bullet] Now we can use it to compute covariant derivatives of tensor \
fields. The notation is identical to that used in ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 ":"
}], "Text",ExpressionUUID->"a82c1392-9425-44e9-998f-3be610d604d1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"cd", "[", 
   RowBox[{"-", "a"}], "]"}], "[", 
  RowBox[{"V", "[", "b", "]"}], "]"}]], "Input",ExpressionUUID->"bf472f24-\
40d3-401e-9bb3-7573309bbafe"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox[
            RowBox[{"-", 
             FractionBox[
              InterpretationBox[
               StyleBox["M",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`mass,
               Editable->False], 
              RowBox[{
               RowBox[{"2", " ", 
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`mass,
                 Editable->False]}], "-", 
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False]}]]}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
              RowBox[{"-", 
                FractionBox[
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], $CellContext`mass, Editable -> False], 
                 RowBox[{
                   RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False]}], "-", 
                   InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}]]}]}]],
           
           Annotation[#, {1, 1} -> -$CellContext`mass/(
             2 $CellContext`mass - $CellContext`r[]), "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 4} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{"1", "+", 
             FractionBox[
              InterpretationBox[
               StyleBox["M",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`mass,
               Editable->False], 
              RowBox[{
               RowBox[{"2", " ", 
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`mass,
                 Editable->False]}], "-", 
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False]}]]}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
              RowBox[{"1", "+", 
                FractionBox[
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], $CellContext`mass, Editable -> False], 
                 RowBox[{
                   RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False]}], "-", 
                   InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}]]}]}]],
           
           Annotation[#, {2, 2} -> 
            1 + $CellContext`mass/(2 $CellContext`mass - $CellContext`r[]), 
            "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 4} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["1",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "3"}], "}"}], "\[Rule]", "1"}]],
           Annotation[#, {3, 3} -> 1, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 4} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["1",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "4"}], "}"}], "\[Rule]", "1"}]],
           Annotation[#, {4, 4} -> 1, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {
           1 -> RGBColor[0.6, 0.4, 0.2], 5 -> RGBColor[0.6, 0.4, 0.2]}, 
          "RowsIndexed" -> {
           1 -> RGBColor[0.6, 0.4, 0.2], 5 -> RGBColor[0.6, 0.4, 0.2]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {"b", " "},
         {" ", "a"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{-$CellContext`mass/(
     2 $CellContext`mass - $CellContext`r[]), 0, 0, 0}, {
    0, 1 + $CellContext`mass/(2 $CellContext`mass - $CellContext`r[]), 0, 
     0}, {0, 0, 1, 0}, {0, 0, 0, 1}}, {$CellContext`ch, -$CellContext`ch}, 
   0][$CellContext`b, -$CellContext`a],
  Editable->False]], "Output",ExpressionUUID->"8c69c896-7288-4101-84a8-\
285e96a63564"]
}, Open  ]],

Cell["\[Bullet] The covariant derivative of the metric field is zero:", "Text",ExpressionUUID->"67733ccf-c4ea-4436-b4d7-2ef1d67d887b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"cd", "[", 
   RowBox[{"-", "a"}], "]"}], "[", 
  RowBox[{"met", "[", 
   RowBox[{
    RowBox[{"-", "b"}], ",", 
    RowBox[{"-", "c"}]}], "]"}], "]"}]], "Input",ExpressionUUID->"730ad0d5-\
af4e-4117-9bdc-a5082987e7b7"],

Cell[BoxData["0"], "Output",ExpressionUUID->"f1d5d733-3361-4a54-9d14-1366392e739b"]
}, Open  ]],

Cell["\[Bullet] Commuting covariant derivatives:", "Text",ExpressionUUID->"51a26cde-7f4c-46ea-a31e-3de667fe2e6f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"commV", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"cd", "[", 
      RowBox[{"-", "b"}], "]"}], "@", 
     RowBox[{
      RowBox[{"cd", "[", 
       RowBox[{"-", "a"}], "]"}], "@", 
      RowBox[{"V", "[", "c", "]"}]}]}], "-", 
    RowBox[{
     RowBox[{"cd", "[", 
      RowBox[{"-", "a"}], "]"}], "@", 
     RowBox[{
      RowBox[{"cd", "[", 
       RowBox[{"-", "b"}], "]"}], "@", 
      RowBox[{"V", "[", "c", "]"}]}]}]}], "//", "Simplify"}]}]], "Input",Expre\
ssionUUID->"045ef4a1-a917-46fe-a074-d93f3eb880e0"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               FractionBox[
                RowBox[{"2", " ", 
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`mass,
                  Editable->False]}], 
                RowBox[{
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`mass,
                   Editable->False], " ", 
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False]}], "-", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "2"]}]],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False]}], 
                  RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}]]}]],
              
              Annotation[#, {1, 1, 2} -> 
               2 $CellContext`mass/(
                2 $CellContext`mass $CellContext`r[] - $CellContext`r[]^2), 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "3"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 3} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "4"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}], 
          GridBox[{
            {
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                FractionBox[
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`mass,
                   Editable->False]}], 
                 RowBox[{
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`mass,
                    Editable->False], " ", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}], "-", 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False]}], 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}]]}]}]],
              Annotation[#, {1, 2, 1} -> (-2) $CellContext`mass/(
                2 $CellContext`mass $CellContext`r[] - $CellContext`r[]^2), 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 2} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "3"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 3} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "4"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}], 
          GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "1"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 1} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "2"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 2} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "3"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 3} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "4"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}], 
          GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "1"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 1} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "2"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 2} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "3"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 3} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "4"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}]},
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 1} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 2} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "3"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 3} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "4"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}], 
          GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 1} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 2} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "3"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 3} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "4"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}], 
          GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "1"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 1} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "2"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 2} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "3"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 3} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "4"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}], 
          GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "1"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 1} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "2"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 2} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "3"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 3} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "4"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}]},
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "1"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 1} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "2"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 2} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "3"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 3} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "4"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}], 
          GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "1"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 1} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "2"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 2} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               FractionBox[
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`mass,
                 Editable->False], 
                RowBox[{
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`mass,
                   Editable->False], " ", 
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False]}], "-", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "2"]}]],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "3"}], "}"}], "\[Rule]", 
                 FractionBox[
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False], 
                  RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}]]}]],
              
              Annotation[#, {3, 2, 3} -> $CellContext`mass/(
                2 $CellContext`mass $CellContext`r[] - $CellContext`r[]^2), 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "4"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}], 
          GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "1"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 1} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                FractionBox[
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`mass,
                  Editable->False], 
                 RowBox[{
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`mass,
                    Editable->False], " ", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}], "-", 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False], 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}]]}]}]],
              
              Annotation[#, {3, 3, 2} -> -$CellContext`mass/(
                2 $CellContext`mass $CellContext`r[] - $CellContext`r[]^2), 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "3"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 3} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "4"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}], 
          GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "1"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {3, 4, 1} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "2"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {3, 4, 2} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "3"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {3, 4, 3} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "4"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {3, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}]},
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "1"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 1} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "2"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 2} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "3"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 3} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "4"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}], 
          GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "1"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {4, 2, 1} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "2"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {4, 2, 2} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "3"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {4, 2, 3} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               FractionBox[
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`mass,
                 Editable->False], 
                RowBox[{
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`mass,
                   Editable->False], " ", 
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False]}], "-", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "2"]}]],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "4"}], "}"}], "\[Rule]", 
                 FractionBox[
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False], 
                  RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}]]}]],
              
              Annotation[#, {4, 2, 4} -> $CellContext`mass/(
                2 $CellContext`mass $CellContext`r[] - $CellContext`r[]^2), 
               "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}], 
          GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "1"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {4, 3, 1} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "2"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {4, 3, 2} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "3"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {4, 3, 3} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "4"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {4, 3, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}], 
          GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "1"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 1} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                FractionBox[
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`mass,
                  Editable->False], 
                 RowBox[{
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`mass,
                    Editable->False], " ", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}], "-", 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False], 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}]]}]}]],
              
              Annotation[#, {4, 4, 2} -> -$CellContext`mass/(
                2 $CellContext`mass $CellContext`r[] - $CellContext`r[]^2), 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "3"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 3} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "4"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {
           1 -> RGBColor[0.6, 0.4, 0.2], 5 -> RGBColor[0.6, 0.4, 0.2]}, 
          "RowsIndexed" -> {
           1 -> RGBColor[0.6, 0.4, 0.2], 5 -> RGBColor[0.6, 0.4, 0.2]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {"c", " ", " "},
         {" ", "a", "b"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{{
     0, 2 $CellContext`mass/(
      2 $CellContext`mass $CellContext`r[] - $CellContext`r[]^2), 0, 
      0}, {(-2) $CellContext`mass/(
      2 $CellContext`mass $CellContext`r[] - $CellContext`r[]^2), 0, 0, 0}, {
     0, 0, 0, 0}, {0, 0, 0, 0}}, {{0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}, {
    0, 0, 0, 0}}, {{0, 0, 0, 0}, {
     0, 0, $CellContext`mass/(
      2 $CellContext`mass $CellContext`r[] - $CellContext`r[]^2), 0}, {
     0, -$CellContext`mass/(
      2 $CellContext`mass $CellContext`r[] - $CellContext`r[]^2), 0, 0}, {0, 
     0, 0, 0}}, {{0, 0, 0, 0}, {
     0, 0, 0, $CellContext`mass/(
      2 $CellContext`mass $CellContext`r[] - $CellContext`r[]^2)}, {0, 0, 0, 
     0}, {0, -$CellContext`mass/(
      2 $CellContext`mass $CellContext`r[] - $CellContext`r[]^2), 0, 
      0}}}, {$CellContext`ch, -$CellContext`ch, -$CellContext`ch}, 
   0][$CellContext`c, -$CellContext`a, -$CellContext`b],
  Editable->False]], "Output",ExpressionUUID->"d4e15b74-3545-4b22-aae2-\
b9d475ed6dac"]
}, Open  ]],

Cell["\<\
\[Bullet] We can check that the result coincides with the expected \
contraction with the Riemann tensor of the connection:\
\>", "Text",ExpressionUUID->"1dcbb78c-fa34-4dbb-a0f2-1935ad04cefe"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"commV", "==", 
  RowBox[{
   RowBox[{
    RowBox[{"Riemann", "[", "cd", "]"}], "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "d"}], ",", "c"}], "]"}], 
   RowBox[{"V", "[", "d", "]"}]}]}]], "Input",ExpressionUUID->"a6a89cc0-1ae8-\
46e5-a07b-ea1c9ec46c87"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {
       StyleBox[GridBox[{
          {GridBox[{
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {1, 1, 1} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox[
                FractionBox[
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`mass,
                   Editable->False]}], 
                 RowBox[{
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`mass,
                    Editable->False], " ", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}], "-", 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                  FractionBox[
                   RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False]}], 
                   RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}]]}]],
               
               Annotation[#, {1, 1, 2} -> 
                2 $CellContext`mass/(
                 2 $CellContext`mass $CellContext`r[] - $CellContext`r[]^2), 
                "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "3"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {1, 1, 3} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "4"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {1, 1, 4} -> 0, "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}], 
           GridBox[{
             {
              TagBox[
               TooltipBox[
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`mass,
                    Editable->False]}], 
                  RowBox[{
                   RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`mass,
                    Editable->False], " ", 
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}], "-", 
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]]}],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                  RowBox[{"-", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False]}], 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}]]}]}]],
               
               Annotation[#, {1, 2, 1} -> (-2) $CellContext`mass/(
                 2 $CellContext`mass $CellContext`r[] - $CellContext`r[]^2), 
                "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {1, 2, 2} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "3"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {1, 2, 3} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "4"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {1, 2, 4} -> 0, "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}], 
           GridBox[{
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "3", ",", "1"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {1, 3, 1} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "3", ",", "2"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {1, 3, 2} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "3", ",", "3"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {1, 3, 3} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "3", ",", "4"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {1, 3, 4} -> 0, "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}], 
           GridBox[{
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "4", ",", "1"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {1, 4, 1} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "4", ",", "2"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {1, 4, 2} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "4", ",", "3"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {1, 4, 3} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "4", ",", "4"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {1, 4, 4} -> 0, "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}]},
          
          {GridBox[{
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {2, 1, 1} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {2, 1, 2} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "3"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {2, 1, 3} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "4"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {2, 1, 4} -> 0, "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}], 
           GridBox[{
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {2, 2, 1} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {2, 2, 2} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "3"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {2, 2, 3} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "4"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {2, 2, 4} -> 0, "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}], 
           GridBox[{
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "3", ",", "1"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {2, 3, 1} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "3", ",", "2"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {2, 3, 2} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "3", ",", "3"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {2, 3, 3} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "3", ",", "4"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {2, 3, 4} -> 0, "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}], 
           GridBox[{
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "4", ",", "1"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {2, 4, 1} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "4", ",", "2"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {2, 4, 2} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "4", ",", "3"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {2, 4, 3} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "4", ",", "4"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {2, 4, 4} -> 0, "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[0.6, 0.4, 0.2], 2 -> 
                RGBColor[0.6, 0.4, 0.2]}}]},
          {GridBox[{
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"3", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {3, 1, 1} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"3", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {3, 1, 2} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"3", ",", "1", ",", "3"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {3, 1, 3} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"3", ",", "1", ",", "4"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {3, 1, 4} -> 0, "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}], 
           GridBox[{
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"3", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {3, 2, 1} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"3", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {3, 2, 2} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox[
                FractionBox[
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`mass,
                  Editable->False], 
                 RowBox[{
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`mass,
                    Editable->False], " ", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}], "-", 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"3", ",", "2", ",", "3"}], "}"}], "\[Rule]", 
                  FractionBox[
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False], 
                   RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}]]}]],
               
               Annotation[#, {3, 2, 3} -> $CellContext`mass/(
                 2 $CellContext`mass $CellContext`r[] - $CellContext`r[]^2), 
                "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"3", ",", "2", ",", "4"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {3, 2, 4} -> 0, "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}], 
           GridBox[{
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"3", ",", "3", ",", "1"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {3, 3, 1} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox[
                RowBox[{"-", 
                 FractionBox[
                  InterpretationBox[
                   StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`mass,
                   Editable->False], 
                  RowBox[{
                   RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`mass,
                    Editable->False], " ", 
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}], "-", 
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]]}],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"3", ",", "3", ",", "2"}], "}"}], "\[Rule]", 
                  RowBox[{"-", 
                    FractionBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False], 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}]]}]}]],
               
               Annotation[#, {3, 3, 2} -> -$CellContext`mass/(
                 2 $CellContext`mass $CellContext`r[] - $CellContext`r[]^2), 
                "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"3", ",", "3", ",", "3"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {3, 3, 3} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"3", ",", "3", ",", "4"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {3, 3, 4} -> 0, "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}], 
           GridBox[{
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"3", ",", "4", ",", "1"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {3, 4, 1} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"3", ",", "4", ",", "2"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {3, 4, 2} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"3", ",", "4", ",", "3"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {3, 4, 3} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"3", ",", "4", ",", "4"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {3, 4, 4} -> 0, "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[0.6, 0.4, 0.2], 2 -> 
                RGBColor[0.6, 0.4, 0.2]}}]},
          {GridBox[{
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"4", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {4, 1, 1} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"4", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {4, 1, 2} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"4", ",", "1", ",", "3"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {4, 1, 3} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"4", ",", "1", ",", "4"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {4, 1, 4} -> 0, "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}], 
           GridBox[{
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"4", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {4, 2, 1} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"4", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {4, 2, 2} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"4", ",", "2", ",", "3"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {4, 2, 3} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox[
                FractionBox[
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`mass,
                  Editable->False], 
                 RowBox[{
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`mass,
                    Editable->False], " ", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}], "-", 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"4", ",", "2", ",", "4"}], "}"}], "\[Rule]", 
                  FractionBox[
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False], 
                   RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}]]}]],
               
               Annotation[#, {4, 2, 4} -> $CellContext`mass/(
                 2 $CellContext`mass $CellContext`r[] - $CellContext`r[]^2), 
                "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}], 
           GridBox[{
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"4", ",", "3", ",", "1"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {4, 3, 1} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"4", ",", "3", ",", "2"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {4, 3, 2} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"4", ",", "3", ",", "3"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {4, 3, 3} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"4", ",", "3", ",", "4"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {4, 3, 4} -> 0, "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}], 
           GridBox[{
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"4", ",", "4", ",", "1"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {4, 4, 1} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox[
                RowBox[{"-", 
                 FractionBox[
                  InterpretationBox[
                   StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`mass,
                   Editable->False], 
                  RowBox[{
                   RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`mass,
                    Editable->False], " ", 
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}], "-", 
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]]}],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"4", ",", "4", ",", "2"}], "}"}], "\[Rule]", 
                  RowBox[{"-", 
                    FractionBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False], 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}]]}]}]],
               Annotation[#, {4, 4, 2} -> -$CellContext`mass/(
                 2 $CellContext`mass $CellContext`r[] - $CellContext`r[]^2), 
                "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"4", ",", "4", ",", "3"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {4, 4, 3} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"4", ",", "4", ",", "4"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {4, 4, 4} -> 0, "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}]}
         },
         AutoDelete->False,
         GridBoxDividers->{
          "ColumnsIndexed" -> {
            1 -> RGBColor[0.6, 0.4, 0.2], 5 -> RGBColor[0.6, 0.4, 0.2]}, 
           "RowsIndexed" -> {
            1 -> RGBColor[0.6, 0.4, 0.2], 5 -> RGBColor[0.6, 0.4, 0.2]}}],
        FontSize->Small], 
       StyleBox[GridBox[{
          {"c", " ", " "},
          {" ", "a", "b"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xCoba`CTensor[{{{
      0, 2 $CellContext`mass/(
       2 $CellContext`mass $CellContext`r[] - $CellContext`r[]^2), 0, 
       0}, {(-2) $CellContext`mass/(
       2 $CellContext`mass $CellContext`r[] - $CellContext`r[]^2), 0, 0, 0}, {
      0, 0, 0, 0}, {0, 0, 0, 0}}, {{0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}, {
     0, 0, 0, 0}}, {{0, 0, 0, 0}, {
      0, 0, $CellContext`mass/(
       2 $CellContext`mass $CellContext`r[] - $CellContext`r[]^2), 0}, {
      0, -$CellContext`mass/(
       2 $CellContext`mass $CellContext`r[] - $CellContext`r[]^2), 0, 0}, {0, 
      0, 0, 0}}, {{0, 0, 0, 0}, {
      0, 0, 0, $CellContext`mass/(
       2 $CellContext`mass $CellContext`r[] - $CellContext`r[]^2)}, {0, 0, 0, 
      0}, {0, -$CellContext`mass/(
       2 $CellContext`mass $CellContext`r[] - $CellContext`r[]^2), 0, 
       0}}}, {$CellContext`ch, -$CellContext`ch, -$CellContext`ch}, 
    0][$CellContext`c, -$CellContext`a, -$CellContext`b],
   Editable->False], "\[Equal]", 
  InterpretationBox[
   StyleBox[GridBox[{
      {
       StyleBox[GridBox[{
          {GridBox[{
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {1, 1, 1} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {1, 1, 2} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "3"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {1, 1, 3} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "4"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {1, 1, 4} -> 0, "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}], 
           GridBox[{
             {
              TagBox[
               TooltipBox[
                FractionBox[
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`mass,
                   Editable->False]}], 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`mass,
                    Editable->False]}], "-", 
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}], ")"}], " ", 
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False]}]],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                  FractionBox[
                   RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False]}], 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}]]}]],
               
               Annotation[#, {1, 2, 1} -> 
                2 $CellContext`mass (
                   2 $CellContext`mass - \
$CellContext`r[])^(-1)/$CellContext`r[], "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {1, 2, 2} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "3"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {1, 2, 3} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "4"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {1, 2, 4} -> 0, "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}], 
           GridBox[{
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "3", ",", "1"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {1, 3, 1} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "3", ",", "2"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {1, 3, 2} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "3", ",", "3"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {1, 3, 3} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "3", ",", "4"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {1, 3, 4} -> 0, "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}], 
           GridBox[{
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "4", ",", "1"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {1, 4, 1} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "4", ",", "2"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {1, 4, 2} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "4", ",", "3"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {1, 4, 3} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "4", ",", "4"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {1, 4, 4} -> 0, "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[0.6, 0.4, 0.2], 2 -> 
                RGBColor[0.6, 0.4, 0.2]}}]},
          {GridBox[{
             {
              TagBox[
               TooltipBox[
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`mass,
                    Editable->False]}], 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`mass,
                    Editable->False]}], "-", 
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}], ")"}], " ", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}]]}],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                  RowBox[{"-", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False]}], 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}]]}]}]],
               
               Annotation[#, {2, 1, 
                 1} -> (-2) $CellContext`mass (
                   2 $CellContext`mass - \
$CellContext`r[])^(-1)/$CellContext`r[], "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {2, 1, 2} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "3"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {2, 1, 3} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "4"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {2, 1, 4} -> 0, "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}], 
           GridBox[{
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {2, 2, 1} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {2, 2, 2} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "3"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {2, 2, 3} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "4"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {2, 2, 4} -> 0, "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}], 
           GridBox[{
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "3", ",", "1"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {2, 3, 1} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "3", ",", "2"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {2, 3, 2} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox[
                FractionBox[
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`mass,
                  Editable->False], 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`mass,
                    Editable->False]}], "-", 
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}], ")"}], " ", 
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False]}]],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "3", ",", "3"}], "}"}], "\[Rule]", 
                  FractionBox[
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False], 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}]]}]],
               
               Annotation[#, {2, 3, 
                 3} -> $CellContext`mass (
                   2 $CellContext`mass - \
$CellContext`r[])^(-1)/$CellContext`r[], "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "3", ",", "4"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {2, 3, 4} -> 0, "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}], 
           GridBox[{
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "4", ",", "1"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {2, 4, 1} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "4", ",", "2"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {2, 4, 2} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "4", ",", "3"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {2, 4, 3} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox[
                FractionBox[
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`mass,
                  Editable->False], 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`mass,
                    Editable->False]}], "-", 
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}], ")"}], " ", 
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False]}]],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "4", ",", "4"}], "}"}], "\[Rule]", 
                  FractionBox[
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False], 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}]]}]],
               
               Annotation[#, {2, 4, 
                 4} -> $CellContext`mass (
                   2 $CellContext`mass - \
$CellContext`r[])^(-1)/$CellContext`r[], "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[0.6, 0.4, 0.2], 2 -> 
                RGBColor[0.6, 0.4, 0.2]}}]},
          {GridBox[{
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"3", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {3, 1, 1} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"3", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {3, 1, 2} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"3", ",", "1", ",", "3"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {3, 1, 3} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"3", ",", "1", ",", "4"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {3, 1, 4} -> 0, "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}], 
           GridBox[{
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"3", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {3, 2, 1} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"3", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {3, 2, 2} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox[
                RowBox[{"-", 
                 FractionBox[
                  InterpretationBox[
                   StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`mass,
                   Editable->False], 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`mass,
                    Editable->False]}], "-", 
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}], ")"}], " ", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}]]}],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"3", ",", "2", ",", "3"}], "}"}], "\[Rule]", 
                  RowBox[{"-", 
                    FractionBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False], 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}]]}]}]],
               
               Annotation[#, {3, 2, 
                 3} -> -$CellContext`mass (
                   2 $CellContext`mass - \
$CellContext`r[])^(-1)/$CellContext`r[], "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"3", ",", "2", ",", "4"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {3, 2, 4} -> 0, "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}], 
           GridBox[{
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"3", ",", "3", ",", "1"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {3, 3, 1} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"3", ",", "3", ",", "2"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {3, 3, 2} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"3", ",", "3", ",", "3"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {3, 3, 3} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"3", ",", "3", ",", "4"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {3, 3, 4} -> 0, "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}], 
           GridBox[{
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"3", ",", "4", ",", "1"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {3, 4, 1} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"3", ",", "4", ",", "2"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {3, 4, 2} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"3", ",", "4", ",", "3"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {3, 4, 3} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"3", ",", "4", ",", "4"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {3, 4, 4} -> 0, "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[0.6, 0.4, 0.2], 2 -> 
                RGBColor[0.6, 0.4, 0.2]}}]},
          {GridBox[{
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"4", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {4, 1, 1} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"4", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {4, 1, 2} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"4", ",", "1", ",", "3"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {4, 1, 3} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"4", ",", "1", ",", "4"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {4, 1, 4} -> 0, "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}], 
           GridBox[{
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"4", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {4, 2, 1} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"4", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {4, 2, 2} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"4", ",", "2", ",", "3"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {4, 2, 3} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox[
                RowBox[{"-", 
                 FractionBox[
                  InterpretationBox[
                   StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`mass,
                   Editable->False], 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`mass,
                    Editable->False]}], "-", 
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}], ")"}], " ", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}]]}],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"4", ",", "2", ",", "4"}], "}"}], "\[Rule]", 
                  RowBox[{"-", 
                    FractionBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False], 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}]]}]}]],
               
               Annotation[#, {4, 2, 
                 4} -> -$CellContext`mass (
                   2 $CellContext`mass - \
$CellContext`r[])^(-1)/$CellContext`r[], "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}], 
           GridBox[{
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"4", ",", "3", ",", "1"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {4, 3, 1} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"4", ",", "3", ",", "2"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {4, 3, 2} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"4", ",", "3", ",", "3"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {4, 3, 3} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"4", ",", "3", ",", "4"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {4, 3, 4} -> 0, "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}], 
           GridBox[{
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"4", ",", "4", ",", "1"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {4, 4, 1} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"4", ",", "4", ",", "2"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {4, 4, 2} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"4", ",", "4", ",", "3"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {4, 4, 3} -> 0, "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["0",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"4", ",", "4", ",", "4"}], "}"}], "\[Rule]", 
                  "0"}]],
               Annotation[#, {4, 4, 4} -> 0, "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[0.6, 0.4, 0.2], 2 -> RGBColor[0.6, 0.4, 0.2]}}]}
         },
         AutoDelete->False,
         GridBoxDividers->{
          "ColumnsIndexed" -> {
            1 -> RGBColor[0.6, 0.4, 0.2], 5 -> RGBColor[0.6, 0.4, 0.2]}, 
           "RowsIndexed" -> {
            1 -> RGBColor[0.6, 0.4, 0.2], 5 -> RGBColor[0.6, 0.4, 0.2]}}],
        FontSize->Small], 
       StyleBox[GridBox[{
          {" ", " ", "c"},
          {"a", "b", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xCoba`CTensor[{{{0, 0, 0, 0}, {
      2 $CellContext`mass (
         2 $CellContext`mass - $CellContext`r[])^(-1)/$CellContext`r[], 0, 0, 
       0}, {0, 0, 0, 0}, {0, 0, 0, 
      0}}, {{(-2) $CellContext`mass (
         2 $CellContext`mass - $CellContext`r[])^(-1)/$CellContext`r[], 0, 0, 
       0}, {0, 0, 0, 0}, {
      0, 0, $CellContext`mass (
         2 $CellContext`mass - $CellContext`r[])^(-1)/$CellContext`r[], 0}, {
      0, 0, 0, $CellContext`mass (
         2 $CellContext`mass - $CellContext`r[])^(-1)/$CellContext`r[]}}, {{0,
       0, 0, 0}, {
      0, 0, -$CellContext`mass (
         2 $CellContext`mass - $CellContext`r[])^(-1)/$CellContext`r[], 0}, {
      0, 0, 0, 0}, {0, 0, 0, 0}}, {{0, 0, 0, 0}, {
      0, 0, 
       0, -$CellContext`mass (
         2 $CellContext`mass - $CellContext`r[])^(-1)/$CellContext`r[]}, {0, 
      0, 0, 0}, {0, 0, 0, 
      0}}}, {-$CellContext`ch, -$CellContext`ch, $CellContext`ch}, 
    0][-$CellContext`a, -$CellContext`b, $CellContext`c],
   Editable->False]}]], "Output",ExpressionUUID->"a1f6f0ee-e06c-4ef7-9f19-\
c74254803bc4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", "Simplify"}]], "Input",ExpressionUUID->"2b1c1ce3-7405-4c8b-a9ed-c45d439d3a4c"],

Cell[BoxData["True"], "Output",ExpressionUUID->"8a3fea87-1ae6-4c2e-b173-3dda7d97a54f"]
}, Open  ]],

Cell["\[Bullet] Being a Levi-Civita connection, it has zero torsion:", "Text",ExpressionUUID->"3c52aed0-891e-4041-b4de-307b2e2e8c7b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Torsion", "[", "cd", "]"}], "[", 
  RowBox[{"a", ",", 
   RowBox[{"-", "b"}], ",", 
   RowBox[{"-", "c"}]}], "]"}]], "Input",ExpressionUUID->"68137498-23a7-4276-\
a9bf-fcdd0768de83"],

Cell[BoxData["0"], "Output",ExpressionUUID->"65d9dd7b-1854-40ac-a3a2-05ceae100d70"]
}, Open  ]],

Cell["\[Bullet] The Schwarzschild metric is Ricci-flat:", "Text",ExpressionUUID->"38bf0981-b409-42b3-a113-396e7c5e8156"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Ricci", "[", "cd", "]"}], "[", 
  RowBox[{
   RowBox[{"-", "a"}], ",", 
   RowBox[{"-", "b"}]}], "]"}]], "Input",ExpressionUUID->"50eca37c-e830-4283-\
a8b6-c5cff4833207"],

Cell[BoxData["0"], "Output",ExpressionUUID->"b3c9e351-1f2d-4c73-99c7-310346a8f1bf"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["1.5. Cleanup", "Subsubsection",ExpressionUUID->"77b28e3e-51fa-407f-916e-8ea0440d11f7"],

Cell["Remove the structures defined through Def commands:", "Text",ExpressionUUID->"6505eda3-6976-4a89-9fd1-1fd023439398"],

Cell[BoxData[
 RowBox[{"UnsetCMetric", "[", "met", "]"}]], "Input",ExpressionUUID->"93891727-6827-44f6-aac3-4cf02f346831"],

Cell[BoxData[
 RowBox[{"UndefConstantSymbol", "[", "mass", "]"}]], "Input",ExpressionUUID->"e6670f2b-ec81-4a33-a35f-a0cceff5a5b2"],

Cell[BoxData[
 RowBox[{"UndefChart", "[", "ch", "]"}]], "Input",ExpressionUUID->"2f04506e-a681-42ca-be49-9793de8d1977"],

Cell[BoxData[
 RowBox[{"UndefBasis", "[", "red", "]"}]], "Input",ExpressionUUID->"0be7eb56-c6b6-49d1-ab45-8a1dac6ec7cf"],

Cell[BoxData[
 RowBox[{"UndefBasis", "[", "blue", "]"}]], "Input",ExpressionUUID->"89a0c184-6cc6-4940-b2ff-1568639529c7"],

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M", "]"}]], "Input",ExpressionUUID->"0ef1c1ba-2868-4f95-b63f-fc5f770b3612"],

Cell["Remove the expressions we have defined interactively:", "Text",ExpressionUUID->"f09f8222-226a-4c1a-968e-7ac0bf1c302d"],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{
  "commV", ",", "cd", ",", "V", ",", "v", ",", "met", ",", "S", ",", "T"}], 
  "]"}]], "Input",ExpressionUUID->"b918b0ca-3235-41c4-ac38-3c7db0a9b49a"],

Cell["Clear the cache:", "Text",ExpressionUUID->"120f6191-e3f1-481a-a8b0-8a920d634ecb"],

Cell[BoxData[
 RowBox[{"ClearxCobaCache", "[", "All", "]"}]], "Input",ExpressionUUID->"39287e4b-5a84-468d-98dd-eaf0f82a1199"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["2. Tensors", "Subsection",ExpressionUUID->"5ed7bbd1-8381-4486-ba9c-601d02a9d6e0"],

Cell[CellGroupData[{

Cell["2.1. CTensor expressions", "Subsubsection",ExpressionUUID->"7c959dd8-37dd-422c-aba9-8490132a68cb"],

Cell["\<\
The head CTensor provides an alternative to the use of FoldedRule and \
ToValues. It describes a tensor by giving an array of components in some \
bases. A third argument adds density weight.\
\>", "Text",ExpressionUUID->"8d230a8b-359a-4150-b24f-963b93598124"],

Cell["\<\
\[Bullet] Define a manifold with a basis field for its tangent bundle:\
\>", "Text",ExpressionUUID->"1afdfcf6-ca23-429f-a78c-374b27693560"],

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M", ",", "4", ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"141d7104-3697-4d14-8992-4f1f0b523baf"],

Cell[BoxData[
 RowBox[{"DefBasis", "[", 
  RowBox[{"B", ",", "TangentM", ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "2", ",", "3"}], "}"}]}], "]"}]], "Input",Expr\
essionUUID->"f931a117-2794-477e-ac64-ed04ad5fcbfe"],

Cell["\[Bullet] Define some scalar field on the manifold:", "Text",ExpressionUUID->"d61a4566-14f4-4aa3-a45e-05ed83ba6a9d"],

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"s", "[", "]"}], ",", "M"}], "]"}]], "Input",ExpressionUUID->\
"3b3f8e21-01da-4745-a413-219384169ae9"],

Cell["\<\
\[Bullet] This is a vector field on M. It automatically adds the third \
argument, meaning that there is no added density weight:\
\>", "Text",ExpressionUUID->"4728ac42-1578-404f-8a2e-955414ff0f77"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"v", "=", 
  RowBox[{"CTensor", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"0", ",", 
      RowBox[{"I", " ", 
       RowBox[{"s", "[", "]"}]}], ",", "1", ",", 
      RowBox[{"3", 
       RowBox[{
        RowBox[{"s", "[", "]"}], "^", "2"}]}]}], "}"}], ",", 
    RowBox[{"{", "B", "}"}]}], "]"}]}]], "Input",ExpressionUUID->"6b8c34b1-\
1fc5-479b-b619-8eb1e2790994"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"\[ImaginaryI]", " ", 
      InterpretationBox[
       StyleBox["s",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`s[],
       Editable->False]}], ",", "1", ",", 
     RowBox[{"3", " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["s",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`s[],
        Editable->False], "2"]}]}], "}"}], ",", 
   RowBox[{"{", "B", "}"}], ",", "0"}], "]"}]], "Output",ExpressionUUID->\
"c7d68cf1-35a2-49aa-bd97-a5bec9d9b6d1"]
}, Open  ]],

Cell[TextData[{
 "\[Bullet] This object is now treated by ",
 StyleBox["xAct",
  FontSlant->"Italic"],
 " as a head v declared with DefTensor:"
}], "Text",ExpressionUUID->"74103247-8b5f-45e6-97be-935b04f2d900"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xTensorQ", "[", "v", "]"}]], "Input",ExpressionUUID->"56b96a5f-7005-4e0b-852f-db43f8a8f852"],

Cell[BoxData["True"], "Output",ExpressionUUID->"ca56e033-ee05-4e1f-84ec-c48dc0d41402"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SlotsOfTensor", "[", "v", "]"}]], "Input",ExpressionUUID->"dafe208e-3b68-4d53-8a8c-452af3a376e2"],

Cell[BoxData[
 RowBox[{"{", 
  InterpretationBox[
   StyleBox["\[DoubleStruckCapitalT]M",
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`TangentM,
   Editable->False], "}"}]], "Output",ExpressionUUID->"0da0a11d-dd59-4431-\
93c1-50bd648d2ae2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SymmetryGroupOfTensor", "[", "v", "]"}]], "Input",ExpressionUUID->"5523d4e7-51f3-4f9c-ae47-4cbc163b5d9f"],

Cell[BoxData[
 RowBox[{"StrongGenSet", "[", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"GenSet", "[", "]"}]}], "]"}]], "Output",ExpressionUUID->"9bbb091c-\
0931-4706-ac91-0e037ec4dbc6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DependenciesOfTensor", "[", "v", "]"}]], "Input",ExpressionUUID->"3608cff1-6e92-44a0-949c-5bdf2e3cbe25"],

Cell[BoxData[
 RowBox[{"{", "M", "}"}]], "Output",ExpressionUUID->"f5abbc6f-23e9-45b8-8209-108f36a7ec6c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"WeightOfTensor", "[", "v", "]"}]], "Input",ExpressionUUID->"3d94abf3-5d77-4b7e-9036-f7e900893cc1"],

Cell[BoxData["0"], "Output",ExpressionUUID->"05929b9a-496c-425c-bdd8-7ef52b6570ce"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Dagger", "[", "v", "]"}]], "Input",ExpressionUUID->"93c2796f-c6c2-49f0-82fc-03af2082cebf"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{
      RowBox[{"-", "\[ImaginaryI]"}], " ", 
      InterpretationBox[
       StyleBox["s",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`s[],
       Editable->False]}], ",", "1", ",", 
     RowBox[{"3", " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["s",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`s[],
        Editable->False], "2"]}]}], "}"}], ",", 
   RowBox[{"{", "B", "}"}], ",", "0"}], "]"}]], "Output",ExpressionUUID->\
"4924c692-6372-4b1d-9783-bb51d14432ba"]
}, Open  ]],

Cell["\<\
\[Bullet] We can have a higher-rank tensor. Let us also make it a density of \
weight +2 in the basis B:\
\>", "Text",ExpressionUUID->"7ef064c6-9c97-4e8f-a948-6fcca5b89979"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"A", "=", 
  RowBox[{"CTensor", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"s", "[", "]"}], 
     RowBox[{"Array", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Signature", "[", 
         RowBox[{"{", "##", "}"}], "]"}], "&"}], ",", 
       RowBox[{"{", 
        RowBox[{"4", ",", "4", ",", "4"}], "}"}]}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "B"}], ",", 
      RowBox[{"-", "B"}]}], "}"}], ",", 
    RowBox[{"2", "B"}]}], "]"}]}]], "Input",ExpressionUUID->"5160a158-2bed-\
4d12-9009-92d2b9766918"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", 
         InterpretationBox[
          StyleBox["s",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`s[],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["s",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`s[],
          Editable->False]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"-", 
          InterpretationBox[
           StyleBox["s",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`s[],
           Editable->False]}], ",", "0", ",", 
         InterpretationBox[
          StyleBox["s",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`s[],
          Editable->False]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"-", 
          InterpretationBox[
           StyleBox["s",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`s[],
           Editable->False]}], ",", 
         RowBox[{"-", 
          InterpretationBox[
           StyleBox["s",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`s[],
           Editable->False]}], ",", "0"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", 
         RowBox[{"-", 
          InterpretationBox[
           StyleBox["s",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`s[],
           Editable->False]}], ",", 
         RowBox[{"-", 
          InterpretationBox[
           StyleBox["s",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`s[],
           Editable->False]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         InterpretationBox[
          StyleBox["s",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`s[],
          Editable->False], ",", "0", ",", "0", ",", 
         InterpretationBox[
          StyleBox["s",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`s[],
          Editable->False]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         InterpretationBox[
          StyleBox["s",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`s[],
          Editable->False], ",", "0", ",", 
         RowBox[{"-", 
          InterpretationBox[
           StyleBox["s",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`s[],
           Editable->False]}], ",", "0"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", 
         InterpretationBox[
          StyleBox["s",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`s[],
          Editable->False], ",", "0", ",", 
         RowBox[{"-", 
          InterpretationBox[
           StyleBox["s",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`s[],
           Editable->False]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", 
          InterpretationBox[
           StyleBox["s",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`s[],
           Editable->False]}], ",", "0", ",", "0", ",", 
         RowBox[{"-", 
          InterpretationBox[
           StyleBox["s",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`s[],
           Editable->False]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         InterpretationBox[
          StyleBox["s",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`s[],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["s",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`s[],
          Editable->False], ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", 
         InterpretationBox[
          StyleBox["s",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`s[],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["s",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`s[],
          Editable->False], ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", 
          InterpretationBox[
           StyleBox["s",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`s[],
           Editable->False]}], ",", "0", ",", 
         InterpretationBox[
          StyleBox["s",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`s[],
          Editable->False], ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", 
          InterpretationBox[
           StyleBox["s",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`s[],
           Editable->False]}], ",", 
         RowBox[{"-", 
          InterpretationBox[
           StyleBox["s",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`s[],
           Editable->False]}], ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}]}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "B"}]}], "}"}], ",", 
   RowBox[{"2", " ", "B"}]}], "]"}]], "Output",ExpressionUUID->"e98cdbd1-6496-\
484e-ad06-f02d195f0a26"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xTensorQ", "[", "A", "]"}]], "Input",ExpressionUUID->"eaf0bb20-2b7b-4088-af7e-1fce299b87c5"],

Cell[BoxData["True"], "Output",ExpressionUUID->"0ea61de3-ad62-4786-ad61-1f83258f831e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SlotsOfTensor", "[", "A", "]"}]], "Input",ExpressionUUID->"5aadad1b-3db4-42da-8ca7-0b940814dba8"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", 
    InterpretationBox[
     StyleBox["\[DoubleStruckCapitalT]M",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`TangentM,
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox["\[DoubleStruckCapitalT]M",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`TangentM,
     Editable->False]}], ",", 
   RowBox[{"-", 
    InterpretationBox[
     StyleBox["\[DoubleStruckCapitalT]M",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`TangentM,
     Editable->False]}]}], "}"}]], "Output",ExpressionUUID->"c83e799b-3eef-\
4b69-bbd0-c385dc441874"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SymmetryGroupOfTensor", "[", "A", "]"}]], "Input",ExpressionUUID->"22d93194-4a40-421d-addf-a1e9b10ba392"],

Cell[BoxData[
 RowBox[{"StrongGenSet", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"GenSet", "[", 
    RowBox[{
     InterpretationBox[
      StyleBox[
       RowBox[{"-", 
        RowBox[{"(", "1", ",", "2", ")"}]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      -xAct`xPerm`Cycles[{1, 2}],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox[
       RowBox[{"-", 
        RowBox[{"(", "2", ",", "3", ")"}]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      -xAct`xPerm`Cycles[{2, 3}],
      Editable->False]}], "]"}]}], "]"}]], "Output",ExpressionUUID->"ce8f36d9-\
e415-44bb-b591-c389343b8e95"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DependenciesOfTensor", "[", "A", "]"}]], "Input",ExpressionUUID->"4751f3f4-fc11-451a-8a9a-3e3b58b3c141"],

Cell[BoxData[
 RowBox[{"{", "M", "}"}]], "Output",ExpressionUUID->"eb64bda6-dc3d-4802-b03e-66eeabf18f97"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"WeightOfTensor", "[", "A", "]"}]], "Input",ExpressionUUID->"8a443890-aa6d-44f9-b590-3736d50fe4bf"],

Cell[BoxData[
 RowBox[{"2", " ", "B"}]], "Output",ExpressionUUID->"e7db05a5-3001-4f1b-80df-07279721465b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Dagger", "[", "A", "]"}], "===", "A"}]], "Input",ExpressionUUID->\
"6f7632e7-f981-40b7-bc75-b37f821e1f9d"],

Cell[BoxData["True"], "Output",ExpressionUUID->"818fde38-27a7-4031-a50d-179a4eeefb45"]
}, Open  ]],

Cell["\<\
\[Bullet] A CTensor with an array of zeros is replaced by the head Zero, \
which autoconverts to 0 when given indices:\
\>", "Text",ExpressionUUID->"f296838a-945b-47c1-826b-a27a1d0b9547"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"B", ",", "B"}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"db45d5eb-5d8f-4d03-8b04-64f362ce5407"],

Cell[BoxData["Zero"], "Output",ExpressionUUID->"24e33e7d-97ee-413c-925b-d74bfd166028"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Zero", "[", 
  RowBox[{"a", ",", "b"}], "]"}]], "Input",ExpressionUUID->"e6e741e1-4909-\
44b3-8b84-ed53dc20c636"],

Cell[BoxData["0"], "Output",ExpressionUUID->"7160982b-3df6-4d07-8ff6-d7b20765e223"]
}, Open  ]],

Cell["\<\
\[Bullet] A CTensor containing a scalar is automatically converted into the \
scalar:\
\>", "Text",ExpressionUUID->"004f5540-e1cd-42bf-a55a-25a814a06428"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CTensor", "[", 
   RowBox[{
    RowBox[{"s", "[", "]"}], ",", 
    RowBox[{"{", "}"}]}], "]"}], "[", "]"}]], "Input",ExpressionUUID->\
"740a61e3-29ba-429e-824e-b4a54badd41e"],

Cell[BoxData[
 InterpretationBox[
  StyleBox["s",
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`s[],
  Editable->False]], "Output",ExpressionUUID->"e4dda758-85ad-4342-af5c-\
8e401b8114ab"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", "InputForm"}]], "Input",ExpressionUUID->"07877824-ad76-4c16-979c-80555aa93990"],

Cell["s[]", "Output",ExpressionUUID->"31598936-36f4-47ac-b05a-ca430daca09a"]
}, Open  ]],

Cell["\[Bullet] However, if it is a scalar density then we cannot do that:", \
"Text",ExpressionUUID->"340f01dc-7a14-437b-8da4-662984703670"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CTensor", "[", 
   RowBox[{
    RowBox[{"s", "[", "]"}], ",", 
    RowBox[{"{", "}"}], ",", "B"}], "]"}], "[", "]"}]], "Input",ExpressionUUID\
->"7abd9cde-50ba-4234-a056-14a0adb495ad"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   OverscriptBox[
    InterpretationBox[
     StyleBox["s",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`s[],
     Editable->False], 
    StyleBox["~",
     FontColor->RGBColor[1., 0., 0.]]],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[
   $CellContext`s[], {}, $CellContext`B][],
  Editable->False]], "Output",ExpressionUUID->"8f8c1693-a008-401b-8d6e-\
0f35669406a7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", "InputForm"}]], "Input",ExpressionUUID->"403e3652-2bc7-4fe7-af78-c382ea64a21f"],

Cell["CTensor[s[], {}, B][]", "Output",ExpressionUUID->"e6111a3e-7e89-4dd8-8660-0ec78c7c7094"]
}, Open  ]],

Cell["\[Bullet] A self-consistency check:", "Text",ExpressionUUID->"8b6429f0-cbf5-4fc9-b196-b945538d5462"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CTensor", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "2"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3", ",", "4"}], "}"}]}], "}"}], ",", 
    RowBox[{"{", "B", "}"}]}], "]"}], "//", "Catch"}]], "Input",ExpressionUUID\
->"d4ce6744-ea99-4805-926a-126d098fb150"],

Cell[BoxData[
 TemplateBox[{
  "CTensor","nobd",
   "\"Incompatible number of bases \\!\\(\\*RowBox[{\\\"1\\\"}]\\) and array \
depth \\!\\(\\*RowBox[{\\\"2\\\"}]\\).\"",2,81,1,19248039995900841960,"Local",
   "xAct`xCoba`CTensor"},
  "MessageTemplate2"]], "Message", \
"MSG",ExpressionUUID->"cc39164a-1723-4ccd-90ad-0a615846b0a7"]
}, Open  ]],

Cell["\<\
Finally, note that there is no collection of the CTensor objects existing in \
a given session. In particular they do not appear in the list $Tensors.\
\>", "Text",ExpressionUUID->"bddb7097-0541-4d66-9e9c-06129d74441c"]
}, Closed]],

Cell[CellGroupData[{

Cell["2.2. Indexed CTensor expressions", "Subsubsection",ExpressionUUID->"6169964c-0c5f-4274-9979-fa25d0936ea5"],

Cell[TextData[{
 "Following the standard behaviour in ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 ", the CTensor expressions have a special typesetting when indices are \
added. This is just MatrixForm, which uses:\n\tT[a]\t\t(Column)\n\tT[a, b]\t\t\
(Column-Row)\n\tT[a, b, c]\t(Column-Row)-(Column)\n\t...\t\t..."
}], "Text",ExpressionUUID->"3f8c5ca3-ac6b-4a8e-b249-7ab0e8214eca"],

Cell[TextData[{
 "\[Bullet] Vectors (both covariant and contravariant) are represented as \
columns. In ",
 StyleBox["xAct",
  FontSlant->"Italic"],
 " we use the index height to distinguish upper/lower, and never to \
distinguish rows from columns in a matrix."
}], "Text",ExpressionUUID->"d6f4b4f4-df15-4b74-8325-3777539d645e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"v", "[", "a", "]"}]], "Input",ExpressionUUID->"c4d0920f-8ffe-4a9b-9057-5613f8ea333f"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", "1", "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox[
            RowBox[{"\[ImaginaryI]", " ", 
             InterpretationBox[
              StyleBox["s",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`s[],
              Editable->False]}],
            RowBox[{
              RowBox[{"{", "2", "}"}], "\[Rule]", 
              RowBox[{"\[ImaginaryI]", " ", 
                InterpretationBox[
                 StyleBox["s", AutoSpacing -> False, ShowAutoStyles -> False], 
                 $CellContext`s[], Editable -> False]}]}]],
           Annotation[#, {2} -> Complex[0, 1] $CellContext`s[], "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["1",
            RowBox[{
              RowBox[{"{", "3", "}"}], "\[Rule]", "1"}]],
           Annotation[#, {3} -> 1, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox[
            RowBox[{"3", " ", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["s",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`s[],
               Editable->False], "2"]}],
            RowBox[{
              RowBox[{"{", "4", "}"}], "\[Rule]", 
              RowBox[{"3", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox[
                  "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`s[], Editable -> False], "2"]}]}]],
           Annotation[#, {4} -> 3 $CellContext`s[]^2, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {
           1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {"a"},
         {" "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{
   0, Complex[0, 1] $CellContext`s[], 1, 
    3 $CellContext`s[]^2}, {$CellContext`B}, 0][$CellContext`a],
  Editable->False]], "Output",ExpressionUUID->"f97eed27-d287-4643-ac25-\
19517b0bfdce"]
}, Open  ]],

Cell["\<\
The color of the lines denote the basis associated to the components:\
\>", "Text",ExpressionUUID->"a5181b4b-b500-4b57-bb91-65fe9075b019"],

Cell[CellGroupData[{

Cell[BoxData["v"], "Input",ExpressionUUID->"2bcac57f-ba2f-40e1-ac78-6269adfc2f8f"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"\[ImaginaryI]", " ", 
      InterpretationBox[
       StyleBox["s",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`s[],
       Editable->False]}], ",", "1", ",", 
     RowBox[{"3", " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["s",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`s[],
        Editable->False], "2"]}]}], "}"}], ",", 
   RowBox[{"{", "B", "}"}], ",", "0"}], "]"}]], "Output",ExpressionUUID->\
"253b1fb9-0117-43ff-9f7c-3158594424e7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BasisColor", "[", "B", "]"}]], "Input",ExpressionUUID->"ac6436bf-8542-44e4-bf75-0e8604255a33"],

Cell[BoxData[
 InterpretationBox[
  ButtonBox[
   TooltipBox[
    GraphicsBox[{
      {GrayLevel[0], RectangleBox[{0, 0}]}, 
      {GrayLevel[0], RectangleBox[{1, -1}]}, 
      {RGBColor[1, 0, 0], RectangleBox[{0, -1}, {2, 1}]}},
     AspectRatio->1,
     DefaultBaseStyle->"ColorSwatchGraphics",
     Frame->True,
     FrameStyle->RGBColor[0.6666666666666666, 0., 0.],
     FrameTicks->None,
     ImageSize->
      Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
        AbsoluteCurrentValue[Magnification]}],
     PlotRangePadding->None],
    StyleBox[
     RowBox[{"RGBColor", "[", 
       RowBox[{"1", ",", "0", ",", "0"}], "]"}], NumberMarks -> False]],
   Appearance->None,
   BaseStyle->{},
   BaselinePosition->Baseline,
   ButtonFunction:>With[{Typeset`box$ = EvaluationBox[]}, 
     If[
      Not[
       AbsoluteCurrentValue["Deployed"]], 
      SelectionMove[Typeset`box$, All, Expression]; 
      FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
      FrontEnd`Private`$ColorSelectorInitialColor = RGBColor[1, 0, 0]; 
      FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
      MathLink`CallFrontEnd[
        FrontEnd`AttachCell[Typeset`box$, 
         FrontEndResource["RGBColorValueSelector"], {0, {Left, Bottom}}, {
         Left, Top}, 
         "ClosingActions" -> {
          "SelectionDeparture", "ParentChanged", "EvaluatorQuit"}]]]],
   DefaultBaseStyle->{},
   Evaluator->Automatic,
   Method->"Preemptive"],
  RGBColor[1, 0, 0],
  Editable->False,
  Selectable->False]], "Output",ExpressionUUID->"b9f696a5-3076-47d6-bfdb-\
78f1168becc1"]
}, Open  ]],

Cell["\<\
\[Bullet] Higher-order tensors. Note the double tilde, representing weight +2 \
in the basis B:\
\>", "Text",ExpressionUUID->"8bf973d8-afec-4cbe-b646-74ed59032fa5"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"A", "[", 
  RowBox[{
   RowBox[{"-", "a"}], ",", 
   RowBox[{"-", "b"}], ",", 
   RowBox[{"-", "c"}]}], "]"}]], "Input",ExpressionUUID->"f6aba3af-192e-4f88-\
82a1-7b4c030a78e6"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      OverscriptBox[
       OverscriptBox[
        StyleBox[GridBox[{
           {GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {1, 1, 1} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {1, 1, 2} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "3"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {1, 1, 3} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "4"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {1, 1, 4} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {1, 2, 1} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {1, 2, 2} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox[
                 InterpretationBox[
                  StyleBox["s",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`s[],
                  Editable->False],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "3"}], "}"}], "\[Rule]", 
                   InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False]}]],
                Annotation[#, {1, 2, 3} -> $CellContext`s[], "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox[
                 InterpretationBox[
                  StyleBox["s",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`s[],
                  Editable->False],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "4"}], "}"}], "\[Rule]", 
                   InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False]}]],
                Annotation[#, {1, 2, 4} -> $CellContext`s[], "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "3", ",", "1"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {1, 3, 1} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox[
                 RowBox[{"-", 
                  InterpretationBox[
                   StyleBox["s",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`s[],
                   Editable->False]}],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "3", ",", "2"}], "}"}], "\[Rule]", 
                   RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False]}]}]],
                Annotation[#, {1, 3, 2} -> -$CellContext`s[], "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "3", ",", "3"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {1, 3, 3} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox[
                 InterpretationBox[
                  StyleBox["s",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`s[],
                  Editable->False],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "3", ",", "4"}], "}"}], "\[Rule]", 
                   InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False]}]],
                Annotation[#, {1, 3, 4} -> $CellContext`s[], "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "4", ",", "1"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {1, 4, 1} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox[
                 RowBox[{"-", 
                  InterpretationBox[
                   StyleBox["s",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`s[],
                   Editable->False]}],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "4", ",", "2"}], "}"}], "\[Rule]", 
                   RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False]}]}]],
                Annotation[#, {1, 4, 2} -> -$CellContext`s[], "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox[
                 RowBox[{"-", 
                  InterpretationBox[
                   StyleBox["s",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`s[],
                   Editable->False]}],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "4", ",", "3"}], "}"}], "\[Rule]", 
                   RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False]}]}]],
                Annotation[#, {1, 4, 3} -> -$CellContext`s[], "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "4", ",", "4"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {1, 4, 4} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
           {GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {2, 1, 1} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {2, 1, 2} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox[
                 RowBox[{"-", 
                  InterpretationBox[
                   StyleBox["s",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`s[],
                   Editable->False]}],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "3"}], "}"}], "\[Rule]", 
                   RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False]}]}]],
                Annotation[#, {2, 1, 3} -> -$CellContext`s[], "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox[
                 RowBox[{"-", 
                  InterpretationBox[
                   StyleBox["s",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`s[],
                   Editable->False]}],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "4"}], "}"}], "\[Rule]", 
                   RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False]}]}]],
                Annotation[#, {2, 1, 4} -> -$CellContext`s[], "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {2, 2, 1} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {2, 2, 2} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "3"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {2, 2, 3} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "4"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {2, 2, 4} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox[
                 InterpretationBox[
                  StyleBox["s",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`s[],
                  Editable->False],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "3", ",", "1"}], "}"}], "\[Rule]", 
                   InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False]}]],
                Annotation[#, {2, 3, 1} -> $CellContext`s[], "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "3", ",", "2"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {2, 3, 2} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "3", ",", "3"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {2, 3, 3} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox[
                 InterpretationBox[
                  StyleBox["s",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`s[],
                  Editable->False],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "3", ",", "4"}], "}"}], "\[Rule]", 
                   InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False]}]],
                Annotation[#, {2, 3, 4} -> $CellContext`s[], "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox[
                 InterpretationBox[
                  StyleBox["s",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`s[],
                  Editable->False],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "4", ",", "1"}], "}"}], "\[Rule]", 
                   InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False]}]],
                Annotation[#, {2, 4, 1} -> $CellContext`s[], "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "4", ",", "2"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {2, 4, 2} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox[
                 RowBox[{"-", 
                  InterpretationBox[
                   StyleBox["s",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`s[],
                   Editable->False]}],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "4", ",", "3"}], "}"}], "\[Rule]", 
                   RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False]}]}]],
                Annotation[#, {2, 4, 3} -> -$CellContext`s[], "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "4", ",", "4"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {2, 4, 4} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
           {GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {3, 1, 1} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox[
                 InterpretationBox[
                  StyleBox["s",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`s[],
                  Editable->False],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                   InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False]}]],
                Annotation[#, {3, 1, 2} -> $CellContext`s[], "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "1", ",", "3"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {3, 1, 3} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox[
                 RowBox[{"-", 
                  InterpretationBox[
                   StyleBox["s",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`s[],
                   Editable->False]}],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "1", ",", "4"}], "}"}], "\[Rule]", 
                   RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False]}]}]],
                Annotation[#, {3, 1, 4} -> -$CellContext`s[], "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox[
                 RowBox[{"-", 
                  InterpretationBox[
                   StyleBox["s",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`s[],
                   Editable->False]}],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                   RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False]}]}]],
                Annotation[#, {3, 2, 1} -> -$CellContext`s[], "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {3, 2, 2} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "2", ",", "3"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {3, 2, 3} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox[
                 RowBox[{"-", 
                  InterpretationBox[
                   StyleBox["s",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`s[],
                   Editable->False]}],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "2", ",", "4"}], "}"}], "\[Rule]", 
                   RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False]}]}]],
                Annotation[#, {3, 2, 4} -> -$CellContext`s[], "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "3", ",", "1"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {3, 3, 1} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "3", ",", "2"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {3, 3, 2} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "3", ",", "3"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {3, 3, 3} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "3", ",", "4"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {3, 3, 4} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox[
                 InterpretationBox[
                  StyleBox["s",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`s[],
                  Editable->False],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "4", ",", "1"}], "}"}], "\[Rule]", 
                   InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False]}]],
                Annotation[#, {3, 4, 1} -> $CellContext`s[], "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox[
                 InterpretationBox[
                  StyleBox["s",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`s[],
                  Editable->False],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "4", ",", "2"}], "}"}], "\[Rule]", 
                   InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False]}]],
                Annotation[#, {3, 4, 2} -> $CellContext`s[], "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "4", ",", "3"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {3, 4, 3} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "4", ",", "4"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {3, 4, 4} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
           {GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {4, 1, 1} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox[
                 InterpretationBox[
                  StyleBox["s",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`s[],
                  Editable->False],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                   InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False]}]],
                Annotation[#, {4, 1, 2} -> $CellContext`s[], "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox[
                 InterpretationBox[
                  StyleBox["s",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`s[],
                  Editable->False],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "1", ",", "3"}], "}"}], "\[Rule]", 
                   InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False]}]],
                Annotation[#, {4, 1, 3} -> $CellContext`s[], "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "1", ",", "4"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {4, 1, 4} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox[
                 RowBox[{"-", 
                  InterpretationBox[
                   StyleBox["s",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`s[],
                   Editable->False]}],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                   RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False]}]}]],
                Annotation[#, {4, 2, 1} -> -$CellContext`s[], "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {4, 2, 2} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox[
                 InterpretationBox[
                  StyleBox["s",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`s[],
                  Editable->False],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "2", ",", "3"}], "}"}], "\[Rule]", 
                   InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False]}]],
                Annotation[#, {4, 2, 3} -> $CellContext`s[], "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "2", ",", "4"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {4, 2, 4} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox[
                 RowBox[{"-", 
                  InterpretationBox[
                   StyleBox["s",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`s[],
                   Editable->False]}],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "3", ",", "1"}], "}"}], "\[Rule]", 
                   RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False]}]}]],
                Annotation[#, {4, 3, 1} -> -$CellContext`s[], "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox[
                 RowBox[{"-", 
                  InterpretationBox[
                   StyleBox["s",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`s[],
                   Editable->False]}],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "3", ",", "2"}], "}"}], "\[Rule]", 
                   RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False]}]}]],
                Annotation[#, {4, 3, 2} -> -$CellContext`s[], "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "3", ",", "3"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {4, 3, 3} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "3", ",", "4"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {4, 3, 4} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "4", ",", "1"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {4, 4, 1} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "4", ",", "2"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {4, 4, 2} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "4", ",", "3"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {4, 4, 3} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "4", ",", "4"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {4, 4, 4} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
          },
          AutoDelete->False,
          
          GridBoxDividers->{
           "ColumnsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}, 
            "RowsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}],
         FontSize->Small], 
        StyleBox["~",
         FontColor->RGBColor[1., 0., 0.]]], 
       StyleBox["~",
        FontColor->RGBColor[1., 0., 0.]]], 
      StyleBox[GridBox[{
         {" ", " ", " "},
         {"a", "b", "c"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{{0, 0, 0, 0}, {0, 0, 
      $CellContext`s[], 
      $CellContext`s[]}, {0, -$CellContext`s[], 0, 
      $CellContext`s[]}, {0, -$CellContext`s[], -$CellContext`s[], 0}}, {{
     0, 0, -$CellContext`s[], -$CellContext`s[]}, {0, 0, 0, 0}, {
      $CellContext`s[], 0, 0, 
      $CellContext`s[]}, {
      $CellContext`s[], 0, -$CellContext`s[], 0}}, {{0, 
      $CellContext`s[], 0, -$CellContext`s[]}, {-$CellContext`s[], 0, 
      0, -$CellContext`s[]}, {0, 0, 0, 0}, {
      $CellContext`s[], 
      $CellContext`s[], 0, 0}}, {{0, 
      $CellContext`s[], 
      $CellContext`s[], 0}, {-$CellContext`s[], 0, 
      $CellContext`s[], 0}, {-$CellContext`s[], -$CellContext`s[], 0, 0}, {0, 
     0, 0, 0}}}, {-$CellContext`B, -$CellContext`B, -$CellContext`B}, 
   2 $CellContext`B][-$CellContext`a, -$CellContext`b, -$CellContext`c],
  Editable->False]], "Output",ExpressionUUID->"ce88d985-252f-46ac-8d2b-\
9dbd1e10c827"]
}, Open  ]],

Cell["\<\
All three indices use the same basis B, so all lines in the representation \
are red.\
\>", "Text",ExpressionUUID->"44b82922-b73b-4f8d-9130-ae5f268e6da2"],

Cell[CellGroupData[{

Cell[BoxData["A"], "Input",ExpressionUUID->"7233428d-228d-4b9c-8d04-d9e1c54fe33e"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", 
         InterpretationBox[
          StyleBox["s",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`s[],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["s",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`s[],
          Editable->False]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"-", 
          InterpretationBox[
           StyleBox["s",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`s[],
           Editable->False]}], ",", "0", ",", 
         InterpretationBox[
          StyleBox["s",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`s[],
          Editable->False]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"-", 
          InterpretationBox[
           StyleBox["s",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`s[],
           Editable->False]}], ",", 
         RowBox[{"-", 
          InterpretationBox[
           StyleBox["s",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`s[],
           Editable->False]}], ",", "0"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", 
         RowBox[{"-", 
          InterpretationBox[
           StyleBox["s",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`s[],
           Editable->False]}], ",", 
         RowBox[{"-", 
          InterpretationBox[
           StyleBox["s",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`s[],
           Editable->False]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         InterpretationBox[
          StyleBox["s",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`s[],
          Editable->False], ",", "0", ",", "0", ",", 
         InterpretationBox[
          StyleBox["s",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`s[],
          Editable->False]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         InterpretationBox[
          StyleBox["s",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`s[],
          Editable->False], ",", "0", ",", 
         RowBox[{"-", 
          InterpretationBox[
           StyleBox["s",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`s[],
           Editable->False]}], ",", "0"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", 
         InterpretationBox[
          StyleBox["s",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`s[],
          Editable->False], ",", "0", ",", 
         RowBox[{"-", 
          InterpretationBox[
           StyleBox["s",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`s[],
           Editable->False]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", 
          InterpretationBox[
           StyleBox["s",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`s[],
           Editable->False]}], ",", "0", ",", "0", ",", 
         RowBox[{"-", 
          InterpretationBox[
           StyleBox["s",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`s[],
           Editable->False]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         InterpretationBox[
          StyleBox["s",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`s[],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["s",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`s[],
          Editable->False], ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", 
         InterpretationBox[
          StyleBox["s",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`s[],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["s",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`s[],
          Editable->False], ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", 
          InterpretationBox[
           StyleBox["s",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`s[],
           Editable->False]}], ",", "0", ",", 
         InterpretationBox[
          StyleBox["s",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`s[],
          Editable->False], ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", 
          InterpretationBox[
           StyleBox["s",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`s[],
           Editable->False]}], ",", 
         RowBox[{"-", 
          InterpretationBox[
           StyleBox["s",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`s[],
           Editable->False]}], ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}]}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "B"}], ",", 
     RowBox[{"-", "B"}]}], "}"}], ",", 
   RowBox[{"2", " ", "B"}]}], "]"}]], "Output",ExpressionUUID->"11d27137-f235-\
419f-bef1-dd426a506e74"]
}, Open  ]],

Cell["\<\
Note that odd indices correspond to vertical lines and even indices \
correspond to horizontal lines. This is nonstandard, but as we said it helps \
in distinguishing a matrix {n, 1} from a vector, etc:\
\>", "Text",ExpressionUUID->"e02f4be7-6524-433c-92e7-0c047b642a7f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"MatrixForm", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", "1", "}"}], ",", 
      RowBox[{"{", "2", "}"}]}], "}"}], "]"}], ",", 
   RowBox[{"MatrixForm", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], "]"}]}], "}"}]], "Input",ExpressionUUID->\
"68d57cc4-56c1-4f6f-b4a0-cd17a73d0f9c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"1"},
       {"2"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]], ",", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", 
     TagBox[GridBox[{
        {"1"},
        {"2"}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
         "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.5599999999999999]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      Column], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}], "}"}]], "Output",ExpressionUUID->"02a281bb-\
eef3-44e2-a383-b8613b419876"]
}, Open  ]],

Cell["\<\
\[Bullet] This type of representation can get difficult to understand for \
ranks beyond 2. To help with that you can hover over a given element with the \
mouse, and you will get positional information.\
\>", "Text",ExpressionUUID->"c95ad66e-9517-4d46-ac2d-be4bff11851e"],

Cell["\<\
\[Bullet] To avoid formatted tensors getting too large, a given component \
will not be typeset if its ByteCount is larger than a given predefined limit \
(that you can configure):\
\>", "Text",ExpressionUUID->"53172226-827a-4a5a-b91e-105ba1154da0"],

Cell[CellGroupData[{

Cell[BoxData["$LargeComponentSize"], "Input",ExpressionUUID->"19b1a999-f73f-46b9-ac49-84316d2cd7aa"],

Cell[BoxData["1000"], "Output",ExpressionUUID->"98373e74-619d-4dbb-b21d-df433259d264"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$LargeComponentString"], "Input",ExpressionUUID->"b6d1903c-f66d-473f-89c8-8e70928e731f"],

Cell[BoxData["\<\"\[GrayCircle]\"\>"], "Output",ExpressionUUID->"79b2592c-d4d4-4288-8304-e388a78aba2e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"s", "[", "]"}], "+", "1"}], ")"}], "^", "4"}], ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"s", "[", "]"}], "+", "1"}], ")"}], "^", "5"}], ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"s", "[", "]"}], "+", "1"}], ")"}], "^", "6"}], ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"s", "[", "]"}], "+", "1"}], ")"}], "^", "7"}]}], "}"}], "//", 
  "Expand"}]], "Input",ExpressionUUID->"9f5f5df8-bc6e-417a-964b-1852f35730a7"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"1", "+", 
    RowBox[{"4", " ", 
     InterpretationBox[
      StyleBox["s",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`s[],
      Editable->False]}], "+", 
    RowBox[{"6", " ", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["s",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`s[],
       Editable->False], "2"]}], "+", 
    RowBox[{"4", " ", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["s",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`s[],
       Editable->False], "3"]}], "+", 
    SuperscriptBox[
     InterpretationBox[
      StyleBox["s",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`s[],
      Editable->False], "4"]}], ",", 
   RowBox[{"1", "+", 
    RowBox[{"5", " ", 
     InterpretationBox[
      StyleBox["s",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`s[],
      Editable->False]}], "+", 
    RowBox[{"10", " ", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["s",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`s[],
       Editable->False], "2"]}], "+", 
    RowBox[{"10", " ", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["s",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`s[],
       Editable->False], "3"]}], "+", 
    RowBox[{"5", " ", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["s",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`s[],
       Editable->False], "4"]}], "+", 
    SuperscriptBox[
     InterpretationBox[
      StyleBox["s",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`s[],
      Editable->False], "5"]}], ",", 
   RowBox[{"1", "+", 
    RowBox[{"6", " ", 
     InterpretationBox[
      StyleBox["s",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`s[],
      Editable->False]}], "+", 
    RowBox[{"15", " ", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["s",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`s[],
       Editable->False], "2"]}], "+", 
    RowBox[{"20", " ", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["s",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`s[],
       Editable->False], "3"]}], "+", 
    RowBox[{"15", " ", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["s",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`s[],
       Editable->False], "4"]}], "+", 
    RowBox[{"6", " ", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["s",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`s[],
       Editable->False], "5"]}], "+", 
    SuperscriptBox[
     InterpretationBox[
      StyleBox["s",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`s[],
      Editable->False], "6"]}], ",", 
   RowBox[{"1", "+", 
    RowBox[{"7", " ", 
     InterpretationBox[
      StyleBox["s",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`s[],
      Editable->False]}], "+", 
    RowBox[{"21", " ", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["s",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`s[],
       Editable->False], "2"]}], "+", 
    RowBox[{"35", " ", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["s",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`s[],
       Editable->False], "3"]}], "+", 
    RowBox[{"35", " ", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["s",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`s[],
       Editable->False], "4"]}], "+", 
    RowBox[{"21", " ", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["s",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`s[],
       Editable->False], "5"]}], "+", 
    RowBox[{"7", " ", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["s",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`s[],
       Editable->False], "6"]}], "+", 
    SuperscriptBox[
     InterpretationBox[
      StyleBox["s",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`s[],
      Editable->False], "7"]}]}], "}"}]], "Output",ExpressionUUID->"4dfd674c-\
2fd9-4afd-b432-8cf5384f8007"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ByteCount", "/@", "%"}]], "Input",ExpressionUUID->"c62d1c58-b58a-435d-863d-c1b1d14e6393"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"688", ",", "880", ",", "1072", ",", "1264"}], "}"}]], "Output",Expr\
essionUUID->"3d498d44-ad99-4ce7-b36b-c0a8914c97d1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CTensor", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"s", "[", "]"}], "+", "1"}], ")"}], "^", "4"}], ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"s", "[", "]"}], "+", "1"}], ")"}], "^", "5"}], ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"s", "[", "]"}], "+", "1"}], ")"}], "^", "6"}], ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"s", "[", "]"}], "+", "1"}], ")"}], "^", "7"}]}], "}"}], 
     ",", 
     RowBox[{"{", "B", "}"}]}], "]"}], "[", "a", "]"}], "//", 
  "Expand"}]], "Input",ExpressionUUID->"83b623f3-d20b-41d6-8eee-f4afe8487551"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox[
            RowBox[{"1", "+", 
             RowBox[{"4", " ", 
              InterpretationBox[
               StyleBox["s",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`s[],
               Editable->False]}], "+", 
             RowBox[{"6", " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["s",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`s[],
                Editable->False], "2"]}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["s",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`s[],
                Editable->False], "3"]}], "+", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["s",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`s[],
               Editable->False], "4"]}],
            RowBox[{
              RowBox[{"{", "1", "}"}], "\[Rule]", 
              RowBox[{"1", "+", 
                RowBox[{"4", " ", 
                  InterpretationBox[
                   StyleBox[
                   "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`s[], Editable -> False]}], "+", 
                RowBox[{"6", " ", 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False], "2"]}], "+", 
                RowBox[{"4", " ", 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False], "3"]}], "+", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox[
                  "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`s[], Editable -> False], "4"]}]}]],
           
           Annotation[#, {1} -> 
            1 + 4 $CellContext`s[] + 6 $CellContext`s[]^2 + 
             4 $CellContext`s[]^3 + $CellContext`s[]^4, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox[
            RowBox[{"1", "+", 
             RowBox[{"5", " ", 
              InterpretationBox[
               StyleBox["s",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`s[],
               Editable->False]}], "+", 
             RowBox[{"10", " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["s",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`s[],
                Editable->False], "2"]}], "+", 
             RowBox[{"10", " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["s",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`s[],
                Editable->False], "3"]}], "+", 
             RowBox[{"5", " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["s",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`s[],
                Editable->False], "4"]}], "+", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["s",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`s[],
               Editable->False], "5"]}],
            RowBox[{
              RowBox[{"{", "2", "}"}], "\[Rule]", 
              RowBox[{"1", "+", 
                RowBox[{"5", " ", 
                  InterpretationBox[
                   StyleBox[
                   "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`s[], Editable -> False]}], "+", 
                RowBox[{"10", " ", 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False], "2"]}], "+", 
                RowBox[{"10", " ", 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False], "3"]}], "+", 
                RowBox[{"5", " ", 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False], "4"]}], "+", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox[
                  "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`s[], Editable -> False], "5"]}]}]],
           
           Annotation[#, {2} -> 
            1 + 5 $CellContext`s[] + 10 $CellContext`s[]^2 + 
             10 $CellContext`s[]^3 + 
             5 $CellContext`s[]^4 + $CellContext`s[]^5, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", "3", "}"}], "\[Rule]", 
              RowBox[{"1", "+", 
                RowBox[{"6", " ", 
                  InterpretationBox[
                   StyleBox[
                   "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`s[], Editable -> False]}], "+", 
                RowBox[{"15", " ", 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False], "2"]}], "+", 
                RowBox[{"20", " ", 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False], "3"]}], "+", 
                RowBox[{"15", " ", 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False], "4"]}], "+", 
                RowBox[{"6", " ", 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False], "5"]}], "+", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox[
                  "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`s[], Editable -> False], "6"]}]}]],
           
           Annotation[#, {3} -> 
            1 + 6 $CellContext`s[] + 15 $CellContext`s[]^2 + 
             20 $CellContext`s[]^3 + 15 $CellContext`s[]^4 + 
             6 $CellContext`s[]^5 + $CellContext`s[]^6, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", "4", "}"}], "\[Rule]", 
              RowBox[{"1", "+", 
                RowBox[{"7", " ", 
                  InterpretationBox[
                   StyleBox[
                   "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`s[], Editable -> False]}], "+", 
                RowBox[{"21", " ", 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False], "2"]}], "+", 
                RowBox[{"35", " ", 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False], "3"]}], "+", 
                RowBox[{"35", " ", 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False], "4"]}], "+", 
                RowBox[{"21", " ", 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False], "5"]}], "+", 
                RowBox[{"7", " ", 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False], "6"]}], "+", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox[
                  "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`s[], Editable -> False], "7"]}]}]],
           
           Annotation[#, {4} -> 
            1 + 7 $CellContext`s[] + 21 $CellContext`s[]^2 + 
             35 $CellContext`s[]^3 + 35 $CellContext`s[]^4 + 
             21 $CellContext`s[]^5 + 
             7 $CellContext`s[]^6 + $CellContext`s[]^7, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {
           1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {"a"},
         {" "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{
   1 + 4 $CellContext`s[] + 6 $CellContext`s[]^2 + 
    4 $CellContext`s[]^3 + $CellContext`s[]^4, 1 + 5 $CellContext`s[] + 
    10 $CellContext`s[]^2 + 10 $CellContext`s[]^3 + 
    5 $CellContext`s[]^4 + $CellContext`s[]^5, 1 + 6 $CellContext`s[] + 
    15 $CellContext`s[]^2 + 20 $CellContext`s[]^3 + 15 $CellContext`s[]^4 + 
    6 $CellContext`s[]^5 + $CellContext`s[]^6, 1 + 7 $CellContext`s[] + 
    21 $CellContext`s[]^2 + 35 $CellContext`s[]^3 + 35 $CellContext`s[]^4 + 
    21 $CellContext`s[]^5 + 
    7 $CellContext`s[]^6 + $CellContext`s[]^7}, {$CellContext`B}, 
   0][$CellContext`a],
  Editable->False]], "Output",ExpressionUUID->"3b6250db-65ff-448a-b570-\
1cd4a87e4647"]
}, Open  ]],

Cell["\<\
\[Bullet] Still, hovering over the \[OpenCurlyDoubleQuote]hidden component\
\[CloseCurlyDoubleQuote] will show you what it actually is.\
\>", "Text",ExpressionUUID->"57614af5-afab-4778-b5c8-2ffbd766fb98"],

Cell["\<\
\[Bullet] As usual in xTensor, you can choose your own formatting for the \
tensor:\
\>", "Text",ExpressionUUID->"1fb680b8-5cb6-40b9-93b9-bd18a303b061"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"v", "[", "a", "]"}]], "Input",ExpressionUUID->"317f5e48-178f-45dd-b559-b175d8b69d97"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", "1", "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox[
            RowBox[{"\[ImaginaryI]", " ", 
             InterpretationBox[
              StyleBox["s",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`s[],
              Editable->False]}],
            RowBox[{
              RowBox[{"{", "2", "}"}], "\[Rule]", 
              RowBox[{"\[ImaginaryI]", " ", 
                InterpretationBox[
                 StyleBox["s", AutoSpacing -> False, ShowAutoStyles -> False], 
                 $CellContext`s[], Editable -> False]}]}]],
           Annotation[#, {2} -> Complex[0, 1] $CellContext`s[], "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["1",
            RowBox[{
              RowBox[{"{", "3", "}"}], "\[Rule]", "1"}]],
           Annotation[#, {3} -> 1, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox[
            RowBox[{"3", " ", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["s",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`s[],
               Editable->False], "2"]}],
            RowBox[{
              RowBox[{"{", "4", "}"}], "\[Rule]", 
              RowBox[{"3", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox[
                  "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`s[], Editable -> False], "2"]}]}]],
           Annotation[#, {4} -> 3 $CellContext`s[]^2, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {
           1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {"a"},
         {" "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{
   0, Complex[0, 1] $CellContext`s[], 1, 
    3 $CellContext`s[]^2}, {$CellContext`B}, 0][$CellContext`a],
  Editable->False]], "Output",ExpressionUUID->"6509c785-fbbc-41e3-a3fd-\
1de8f8b4f232"]
}, Open  ]],

Cell["\<\
We need to use Evaluate because PrintAs has attribute HoldFirst:\
\>", "Text",ExpressionUUID->"d0738c2b-ec4f-47d3-8c87-4614e2d8a12f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PrintAs", "[", 
    RowBox[{"Evaluate", "[", "v", "]"}], "]"}], "^=", 
   "\"\<\[DoubleStruckCapitalV]\>\""}], ";"}]], "Input",ExpressionUUID->\
"c11fa16d-0305-40cf-8dbe-e97bf1c75c29"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"v", "[", "a", "]"}]], "Input",ExpressionUUID->"7b3aea58-1229-4fb5-a265-d56a3e26b1aa"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {"\[DoubleStruckCapitalV]", 
      StyleBox[GridBox[{
         {"a"},
         {" "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{
   0, Complex[0, 1] $CellContext`s[], 1, 
    3 $CellContext`s[]^2}, {$CellContext`B}, 0][$CellContext`a],
  Editable->False]], "Output",ExpressionUUID->"a44187bb-4fe7-47c8-bc4e-\
414b1a0ca23b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", "InputForm"}]], "Input",ExpressionUUID->"f52588c5-2a26-4f11-a986-87bf29b7b1ac"],

Cell["CTensor[{0, I*s[], 1, 3*s[]^2}, {B}, 0][a]", "Output",ExpressionUUID->"36588b76-de9e-4d4a-b68f-e71538b525fe"]
}, Open  ]],

Cell["\<\
\[Bullet] That definition was actually stored as an upvalue of CTensor. You \
can remove it as follows:\
\>", "Text",ExpressionUUID->"72c72cd3-be63-4855-a364-75cffb093861"],

Cell[BoxData[
 RowBox[{"CTensor", "/:", 
  RowBox[{
   RowBox[{"PrintAs", "[", 
    RowBox[{"Evaluate", "[", "v", "]"}], "]"}], "=."}]}]], "Input",ExpressionU\
UID->"d39c9191-a050-46e4-bac3-9274f2f8c7c0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"v", "[", "a", "]"}]], "Input",ExpressionUUID->"c4f4c37e-ff62-4785-b9e9-a3d6dd3f1275"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", "1", "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox[
            RowBox[{"\[ImaginaryI]", " ", 
             InterpretationBox[
              StyleBox["s",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`s[],
              Editable->False]}],
            RowBox[{
              RowBox[{"{", "2", "}"}], "\[Rule]", 
              RowBox[{"\[ImaginaryI]", " ", 
                InterpretationBox[
                 StyleBox["s", AutoSpacing -> False, ShowAutoStyles -> False], 
                 $CellContext`s[], Editable -> False]}]}]],
           Annotation[#, {2} -> Complex[0, 1] $CellContext`s[], "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["1",
            RowBox[{
              RowBox[{"{", "3", "}"}], "\[Rule]", "1"}]],
           Annotation[#, {3} -> 1, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox[
            RowBox[{"3", " ", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["s",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`s[],
               Editable->False], "2"]}],
            RowBox[{
              RowBox[{"{", "4", "}"}], "\[Rule]", 
              RowBox[{"3", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox[
                  "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`s[], Editable -> False], "2"]}]}]],
           Annotation[#, {4} -> 3 $CellContext`s[]^2, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {
           1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {"a"},
         {" "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{
   0, Complex[0, 1] $CellContext`s[], 1, 
    3 $CellContext`s[]^2}, {$CellContext`B}, 0][$CellContext`a],
  Editable->False]], "Output",ExpressionUUID->"4c1cf8af-28f7-4339-89b5-\
11816b330638"]
}, Open  ]],

Cell["\<\
\[Bullet] Components of a CTensor may be other tensors, as long as there are \
no free indices:\
\>", "Text",ExpressionUUID->"b7cda333-f245-43bf-9b2b-1215784a68a2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CTensor", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", 
      RowBox[{"Basis", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "a"}], ",", 
          RowBox[{"-", "B"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"b", ",", "B"}], "}"}]}], "]"}], ",", 
      RowBox[{"3", 
       RowBox[{"s", "[", "]"}]}], ",", "0"}], "}"}], ",", 
    RowBox[{"{", "B", "}"}]}], "]"}], "[", "c", "]"}]], "Input",ExpressionUUID\
->"acc7070a-2505-476f-9bb3-f24b94d9bd14"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["1",
            RowBox[{
              RowBox[{"{", "1", "}"}], "\[Rule]", "1"}]],
           Annotation[#, {1} -> 1, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox[
            InterpretationBox[
             StyleBox[GridBox[{
                {"e", 
                 StyleBox[GridBox[{
                    {" ", 
                    StyleBox["b",
                    FontColor->RGBColor[1., 0., 0.]]},
                    {
                    StyleBox["a",
                    FontColor->RGBColor[1., 0., 0.]], " "}
                   },
                   GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                  FontSize->Rational[39, 4]]}
               },
               
               GridBoxAlignment->{
                "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {{Center}}, "RowsIndexed" -> {}},
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.4]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}],
              ShowAutoStyles->False,
              AutoSpacing->False],
             
             xAct`xTensor`Basis[{-$CellContext`a, -$CellContext`B}, \
{$CellContext`b, $CellContext`B}],
             Editable->False],
            RowBox[{
              RowBox[{"{", "2", "}"}], "\[Rule]", 
              InterpretationBox[
               StyleBox[
                GridBox[{{"e", 
                   StyleBox[
                    
                    GridBox[{{
                    " ", "\!\(\*StyleBox[\"b\",FontColor->RGBColor[1., 0., \
0.]]\)"}, {"\!\(\*StyleBox[\"a\",FontColor->RGBColor[1., 0., 0.]]\)", " "}}, 
                    RowSpacings -> 0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                 Center], AutoSpacing -> False, ShowAutoStyles -> False], 
               
               xAct`xTensor`Basis[{-$CellContext`a, -$CellContext`B}, \
{$CellContext`b, $CellContext`B}], Editable -> False]}]],
           
           Annotation[#, {2} -> 
            xAct`xTensor`Basis[{-$CellContext`a, -$CellContext`B}, \
{$CellContext`b, $CellContext`B}], "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox[
            RowBox[{"3", " ", 
             InterpretationBox[
              StyleBox["s",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`s[],
              Editable->False]}],
            RowBox[{
              RowBox[{"{", "3", "}"}], "\[Rule]", 
              RowBox[{"3", " ", 
                InterpretationBox[
                 StyleBox["s", AutoSpacing -> False, ShowAutoStyles -> False], 
                 $CellContext`s[], Editable -> False]}]}]],
           Annotation[#, {3} -> 3 $CellContext`s[], "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", "4", "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4} -> 0, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {
           1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {"c"},
         {" "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{1, 
    xAct`xTensor`Basis[{-$CellContext`a, -$CellContext`B}, {$CellContext`b, \
$CellContext`B}], 3 $CellContext`s[], 0}, {$CellContext`B}, 0][$CellContext`c],
  Editable->False]], "Output",ExpressionUUID->"a06003ce-33dd-49a6-96ef-\
ded56e1adc99"]
}, Open  ]],

Cell[TextData[{
 "Loading ",
 StyleBox["xTerior",
  FontSlant->"Italic"],
 ", the components can also be differential forms, but not tensor-valued \
differential forms."
}], "Text",ExpressionUUID->"b8658ef6-ade4-4639-b5f4-98511a68ad42"],

Cell["\[Bullet] Self-consistency checks:", "Text",ExpressionUUID->"233d9259-0833-4d9e-b397-90614c4b9da0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"v", "[", 
   RowBox[{"a", ",", "b"}], "]"}], "//", "Catch"}]], "Input",ExpressionUUID->\
"0b1552a8-7e9a-41af-b6ec-7affd3df3dea"],

Cell[BoxData[
 TemplateBox[{
  "CTensor","nobi",
   "\"Incompatible number of bases \\!\\(\\*RowBox[{\\\"1\\\"}]\\) and \
indices \\!\\(\\*RowBox[{\\\"2\\\"}]\\).\"",2,100,2,19248039995900841960,
   "Local","xAct`xCoba`CTensor"},
  "MessageTemplate2"]], "Message", \
"MSG",ExpressionUUID->"bbfb0a86-dad6-4e98-bae2-2a7370461fc1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"v", "[", 
   RowBox[{"-", "a"}], "]"}], "//", "Catch"}]], "Input",ExpressionUUID->\
"6ef84cf2-f42e-4d17-a3aa-78afa9c6ae44"],

Cell[BoxData[
 TemplateBox[{
  "MetricsOfVBundle","missing",
   "\"There is no \\!\\(\\*RowBox[{\\\"\\\\\\\"metric\\\\\\\"\\\"}]\\) in \\!\
\\(\\*InterpretationBox[StyleBox[\\\"\[DoubleStruckCapitalT]M\\\", \
Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], TangentM, \
Rule[Editable, False]]\\).\"",2,101,3,19248039995900841960,"Local",
   "xAct`xTensor`MetricsOfVBundle"},
  "MessageTemplate2"]], "Message", \
"MSG",ExpressionUUID->"98024ffa-9326-46b9-9dec-90be2450de86"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["2.3. Basic operations", "Subsubsection",ExpressionUUID->"74b040fb-5046-4994-885f-15db19cb2b19"],

Cell[TextData[{
 "Standard algebraic operations proceed with identical notations to those in ",
 StyleBox["xTensor",
  FontSlant->"Italic"],
 ". "
}], "Text",ExpressionUUID->"228c234e-0901-41f2-ae43-6c9b4decd6d9"],

Cell["\<\
\[Bullet] Scalar expressions are automatically multiplied by CTensor objects:\
\
\>", "Text",ExpressionUUID->"dd3198c3-ede0-4117-ab05-dd423d055bfa"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"v", "[", "a", "]"}]], "Input",ExpressionUUID->"8a8ecb01-1bcc-4017-9909-83cf3b6287bd"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", "1", "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox[
            RowBox[{"\[ImaginaryI]", " ", 
             InterpretationBox[
              StyleBox["s",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`s[],
              Editable->False]}],
            RowBox[{
              RowBox[{"{", "2", "}"}], "\[Rule]", 
              RowBox[{"\[ImaginaryI]", " ", 
                InterpretationBox[
                 StyleBox["s", AutoSpacing -> False, ShowAutoStyles -> False], 
                 $CellContext`s[], Editable -> False]}]}]],
           Annotation[#, {2} -> Complex[0, 1] $CellContext`s[], "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["1",
            RowBox[{
              RowBox[{"{", "3", "}"}], "\[Rule]", "1"}]],
           Annotation[#, {3} -> 1, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox[
            RowBox[{"3", " ", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["s",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`s[],
               Editable->False], "2"]}],
            RowBox[{
              RowBox[{"{", "4", "}"}], "\[Rule]", 
              RowBox[{"3", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox[
                  "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`s[], Editable -> False], "2"]}]}]],
           Annotation[#, {4} -> 3 $CellContext`s[]^2, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {
           1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {"a"},
         {" "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{
   0, Complex[0, 1] $CellContext`s[], 1, 
    3 $CellContext`s[]^2}, {$CellContext`B}, 0][$CellContext`a],
  Editable->False]], "Output",ExpressionUUID->"57955973-2ec9-4bd2-8dc5-\
938efe8ecb55"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "7"}], 
  RowBox[{
   RowBox[{"s", "[", "]"}], "^", "2"}], 
  RowBox[{"v", "[", "a", "]"}]}]], "Input",ExpressionUUID->"e1c624c5-b761-\
4638-924c-107dba4395d7"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", "1", "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox[
            RowBox[{
             RowBox[{"-", "7"}], " ", "\[ImaginaryI]", " ", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["s",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`s[],
               Editable->False], "3"]}],
            RowBox[{
              RowBox[{"{", "2", "}"}], "\[Rule]", 
              RowBox[{
                RowBox[{"-", "7"}], " ", "\[ImaginaryI]", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox[
                  "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`s[], Editable -> False], "3"]}]}]],
           
           Annotation[#, {2} -> Complex[0, -7] $CellContext`s[]^3, 
            "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox[
            RowBox[{
             RowBox[{"-", "7"}], " ", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["s",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`s[],
               Editable->False], "2"]}],
            RowBox[{
              RowBox[{"{", "3", "}"}], "\[Rule]", 
              RowBox[{
                RowBox[{"-", "7"}], " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox[
                  "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`s[], Editable -> False], "2"]}]}]],
           Annotation[#, {3} -> (-7) $CellContext`s[]^2, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox[
            RowBox[{
             RowBox[{"-", "21"}], " ", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["s",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`s[],
               Editable->False], "4"]}],
            RowBox[{
              RowBox[{"{", "4", "}"}], "\[Rule]", 
              RowBox[{
                RowBox[{"-", "21"}], " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox[
                  "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`s[], Editable -> False], "4"]}]}]],
           Annotation[#, {4} -> (-21) $CellContext`s[]^4, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {
           1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {"a"},
         {" "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{
   0, Complex[
     0, -7] $CellContext`s[]^3, (-7) $CellContext`s[]^2, (-21) \
$CellContext`s[]^4}, {$CellContext`B}, 0][$CellContext`a],
  Editable->False]], "Output",ExpressionUUID->"2c354b3c-e4fb-4bed-b62a-\
30a7aaac2982"]
}, Open  ]],

Cell["\[Bullet] Add CTensor expressions with the same index configuration:", \
"Text",ExpressionUUID->"0cafd586-9f82-4600-ad63-88f7019fd1ca"],

Cell[BoxData[
 RowBox[{
  RowBox[{"w", "=", 
   RowBox[{"CTensor", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Pi", ",", "E", ",", "I", ",", "1"}], "}"}], ",", 
     RowBox[{"{", "B", "}"}]}], "]"}]}], ";"}]], "Input",ExpressionUUID->\
"e0d47a26-a0c9-40f4-9b8c-79d295f9e8c0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"v", "[", "a", "]"}], "+", 
  RowBox[{"3", 
   RowBox[{"w", "[", "a", "]"}]}]}]], "Input",ExpressionUUID->"9a436ce9-dd56-\
4ab7-a83d-afbc089fcea2"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox[
            RowBox[{"3", " ", "\[Pi]"}],
            RowBox[{
              RowBox[{"{", "1", "}"}], "\[Rule]", 
              RowBox[{"3", " ", "\[Pi]"}]}]],
           Annotation[#, {1} -> 3 Pi, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox[
            RowBox[{
             RowBox[{"3", " ", "\[ExponentialE]"}], "+", 
             RowBox[{"\[ImaginaryI]", " ", 
              InterpretationBox[
               StyleBox["s",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`s[],
               Editable->False]}]}],
            RowBox[{
              RowBox[{"{", "2", "}"}], "\[Rule]", 
              RowBox[{
                RowBox[{"3", " ", "\[ExponentialE]"}], "+", 
                RowBox[{"\[ImaginaryI]", " ", 
                  InterpretationBox[
                   StyleBox[
                   "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`s[], Editable -> False]}]}]}]],
           
           Annotation[#, {2} -> 3 E + Complex[0, 1] $CellContext`s[], 
            "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox[
            RowBox[{"1", "+", 
             RowBox[{"3", " ", "\[ImaginaryI]"}]}],
            RowBox[{
              RowBox[{"{", "3", "}"}], "\[Rule]", 
              RowBox[{"1", "+", 
                RowBox[{"3", " ", "\[ImaginaryI]"}]}]}]],
           Annotation[#, {3} -> Complex[1, 3], "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox[
            RowBox[{"3", "+", 
             RowBox[{"3", " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["s",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`s[],
                Editable->False], "2"]}]}],
            RowBox[{
              RowBox[{"{", "4", "}"}], "\[Rule]", 
              RowBox[{"3", "+", 
                RowBox[{"3", " ", 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False], "2"]}]}]}]],
           Annotation[#, {4} -> 3 + 3 $CellContext`s[]^2, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {
           1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {"a"},
         {" "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{3 Pi, 3 E + Complex[0, 1] $CellContext`s[], 
    Complex[1, 3], 3 + 3 $CellContext`s[]^2}, {$CellContext`B}, 
   0][$CellContext`a],
  Editable->False]], "Output",ExpressionUUID->"25cea661-b282-4ca8-ad41-\
3b6bb1030b9b"]
}, Open  ]],

Cell["\<\
\[Bullet] Sometimes it may happen that the tensors have the same indices, but \
in a different order. Then we reorder one of them:\
\>", "Text",ExpressionUUID->"8f7590f7-8662-4822-b187-9460c6b597b9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "=", 
   RowBox[{"CTensor", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"3", ",", "4"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"B", ",", "B"}], "}"}]}], "]"}]}], ";"}]], "Input",ExpressionUUI\
D->"5cbdb200-db40-4b59-acc2-d8a9c290150a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "[", 
   RowBox[{"a", ",", "b"}], "]"}], "+", 
  RowBox[{"T", "[", 
   RowBox[{"b", ",", "a"}], "]"}]}]], "Input",ExpressionUUID->"589e188c-4964-\
43a5-bd80-5a42da749d3d"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["2",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", "2"}]],
           Annotation[#, {1, 1} -> 2, "Tooltip"]& ], 
          TagBox[
           TooltipBox["5",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", "5"}]],
           Annotation[#, {1, 2} -> 5, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["5",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", "5"}]],
           Annotation[#, {2, 1} -> 5, "Tooltip"]& ], 
          TagBox[
           TooltipBox["8",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", "8"}]],
           Annotation[#, {2, 2} -> 8, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {"a", "b"},
         {" ", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{2, 5}, {5, 8}}, {$CellContext`B, $CellContext`B}, 
   0][$CellContext`a, $CellContext`b],
  Editable->False]], "Output",ExpressionUUID->"863d59c9-e40a-4ebc-9951-\
a916628b79e9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "[", 
   RowBox[{"a", ",", "b"}], "]"}], "-", 
  RowBox[{"T", "[", 
   RowBox[{"b", ",", "a"}], "]"}]}]], "Input",ExpressionUUID->"8bbf21dc-bce0-\
43f6-b2eb-311413abeb8c"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{"-", "1"}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
              RowBox[{"-", "1"}]}]],
           Annotation[#, {1, 2} -> -1, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["1",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", "1"}]],
           Annotation[#, {2, 1} -> 1, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 2} -> 0, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {"a", "b"},
         {" ", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{0, -1}, {1, 0}}, {$CellContext`B, $CellContext`B}, 
   0][$CellContext`a, $CellContext`b],
  Editable->False]], "Output",ExpressionUUID->"60ae110b-254a-4674-8d5d-\
2ffb667961be"]
}, Open  ]],

Cell["\<\
\[Bullet] However, we do not move the indices by default, because that may \
interfere with the canonicalizer. The function ToCCanonical is needed then, \
to sort the indices as determined by IndexSort:\
\>", "Text",ExpressionUUID->"64e12b37-52cf-456c-8ecc-4e1955b73819"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"T", "[", 
  RowBox[{"b", ",", "a"}], "]"}]], "Input",ExpressionUUID->"95de87c6-be26-4ab5-b331-cb7007f416f5"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["1",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", "1"}]],
           Annotation[#, {1, 1} -> 1, "Tooltip"]& ], 
          TagBox[
           TooltipBox["2",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", "2"}]],
           Annotation[#, {1, 2} -> 2, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["3",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", "3"}]],
           Annotation[#, {2, 1} -> 3, "Tooltip"]& ], 
          TagBox[
           TooltipBox["4",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", "4"}]],
           Annotation[#, {2, 2} -> 4, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {"b", "a"},
         {" ", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{1, 2}, {3, 4}}, {$CellContext`B, $CellContext`B}, 
   0][$CellContext`b, $CellContext`a],
  Editable->False]], "Output",ExpressionUUID->"66ee1588-30ff-4cc9-9576-\
a8bdeab39b74"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", "ToCCanonical"}]], "Input",ExpressionUUID->"d4b1d64a-e903-4136-a73f-4d463c3cf23b"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["1",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", "1"}]],
           Annotation[#, {1, 1} -> 1, "Tooltip"]& ], 
          TagBox[
           TooltipBox["3",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", "3"}]],
           Annotation[#, {1, 2} -> 3, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["2",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", "2"}]],
           Annotation[#, {2, 1} -> 2, "Tooltip"]& ], 
          TagBox[
           TooltipBox["4",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", "4"}]],
           Annotation[#, {2, 2} -> 4, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {"a", "b"},
         {" ", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{1, 3}, {2, 4}}, {$CellContext`B, $CellContext`B}, 
   0][$CellContext`a, $CellContext`b],
  Editable->False]], "Output",ExpressionUUID->"dbf963e1-880f-4acf-9ed0-\
7faa041cb491"]
}, Open  ]],

Cell["\<\
Note that ToCanonical is a different operation, based on the existence of \
symmetry of the tensor. In this case there is no symmetry and hence \
ToCanonical does nothing:\
\>", "Text",ExpressionUUID->"d916cb66-e346-48f2-b445-67af64db1d02"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%%", "//", "ToCanonical"}]], "Input",ExpressionUUID->"b712143a-5ef0-453c-92dc-b4cc5f67bd52"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["1",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", "1"}]],
           Annotation[#, {1, 1} -> 1, "Tooltip"]& ], 
          TagBox[
           TooltipBox["2",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", "2"}]],
           Annotation[#, {1, 2} -> 2, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["3",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", "3"}]],
           Annotation[#, {2, 1} -> 3, "Tooltip"]& ], 
          TagBox[
           TooltipBox["4",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", "4"}]],
           Annotation[#, {2, 2} -> 4, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {"b", "a"},
         {" ", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{1, 2}, {3, 4}}, {$CellContext`B, $CellContext`B}, 
   0][$CellContext`b, $CellContext`a],
  Editable->False]], "Output",ExpressionUUID->"82287c28-3319-4329-b7cd-\
2cc76a3eb1b8"]
}, Open  ]],

Cell["\<\
\[Bullet] Times multiplication of two CTensor objects triggers their \
immediate tensor product:\
\>", "Text",ExpressionUUID->"6fbe5222-b96a-4830-ba94-70ba138afbee"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"v", "[", "a", "]"}], 
  RowBox[{"v", "[", "b", "]"}]}]], "Input",ExpressionUUID->"7a23604d-c239-\
4761-9352-2f60bf170040"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 4} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{"-", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["s",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`s[],
               Editable->False], "2"]}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
              RowBox[{"-", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox[
                  "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`s[], Editable -> False], "2"]}]}]],
           Annotation[#, {2, 2} -> -$CellContext`s[]^2, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{"\[ImaginaryI]", " ", 
             InterpretationBox[
              StyleBox["s",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`s[],
              Editable->False]}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "3"}], "}"}], "\[Rule]", 
              RowBox[{"\[ImaginaryI]", " ", 
                InterpretationBox[
                 StyleBox["s", AutoSpacing -> False, ShowAutoStyles -> False], 
                 $CellContext`s[], Editable -> False]}]}]],
           
           Annotation[#, {2, 3} -> Complex[0, 1] $CellContext`s[], 
            "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{"3", " ", "\[ImaginaryI]", " ", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["s",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`s[],
               Editable->False], "3"]}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "4"}], "}"}], "\[Rule]", 
              RowBox[{"3", " ", "\[ImaginaryI]", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox[
                  "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`s[], Editable -> False], "3"]}]}]],
           
           Annotation[#, {2, 4} -> Complex[0, 3] $CellContext`s[]^3, 
            "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{"\[ImaginaryI]", " ", 
             InterpretationBox[
              StyleBox["s",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`s[],
              Editable->False]}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "2"}], "}"}], "\[Rule]", 
              RowBox[{"\[ImaginaryI]", " ", 
                InterpretationBox[
                 StyleBox["s", AutoSpacing -> False, ShowAutoStyles -> False], 
                 $CellContext`s[], Editable -> False]}]}]],
           
           Annotation[#, {3, 2} -> Complex[0, 1] $CellContext`s[], 
            "Tooltip"]& ], 
          TagBox[
           TooltipBox["1",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "3"}], "}"}], "\[Rule]", "1"}]],
           Annotation[#, {3, 3} -> 1, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{"3", " ", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["s",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`s[],
               Editable->False], "2"]}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "4"}], "}"}], "\[Rule]", 
              RowBox[{"3", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox[
                  "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`s[], Editable -> False], "2"]}]}]],
           Annotation[#, {3, 4} -> 3 $CellContext`s[]^2, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{"3", " ", "\[ImaginaryI]", " ", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["s",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`s[],
               Editable->False], "3"]}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "2"}], "}"}], "\[Rule]", 
              RowBox[{"3", " ", "\[ImaginaryI]", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox[
                  "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`s[], Editable -> False], "3"]}]}]],
           
           Annotation[#, {4, 2} -> Complex[0, 3] $CellContext`s[]^3, 
            "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{"3", " ", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["s",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`s[],
               Editable->False], "2"]}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "3"}], "}"}], "\[Rule]", 
              RowBox[{"3", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox[
                  "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`s[], Editable -> False], "2"]}]}]],
           Annotation[#, {4, 3} -> 3 $CellContext`s[]^2, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{"9", " ", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["s",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`s[],
               Editable->False], "4"]}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "4"}], "}"}], "\[Rule]", 
              RowBox[{"9", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox[
                  "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`s[], Editable -> False], "4"]}]}]],
           Annotation[#, {4, 4} -> 9 $CellContext`s[]^4, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {"a", "b"},
         {" ", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{0, 0, 0, 0}, {
    0, -$CellContext`s[]^2, Complex[0, 1] $CellContext`s[], 
     Complex[0, 3] $CellContext`s[]^3}, {
    0, Complex[0, 1] $CellContext`s[], 1, 3 $CellContext`s[]^2}, {
    0, Complex[0, 3] $CellContext`s[]^3, 3 $CellContext`s[]^2, 
     9 $CellContext`s[]^4}}, {$CellContext`B, $CellContext`B}, 
   0][$CellContext`a, $CellContext`b],
  Editable->False]], "Output",ExpressionUUID->"970eec32-66c6-4509-a596-\
484f397feb56"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"v", "[", "a", "]"}], 
  RowBox[{"T", "[", 
   RowBox[{"b", ",", "c"}], "]"}]}]], "Input",ExpressionUUID->"ac690413-4694-\
4920-ae09-5511e5e55c67"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{"\[ImaginaryI]", " ", 
                InterpretationBox[
                 StyleBox["s",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`s[],
                 Editable->False]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{"\[ImaginaryI]", " ", 
                   InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False]}]}]],
              
              Annotation[#, {1, 1, 2} -> Complex[0, 1] $CellContext`s[], 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["1",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "3"}], "}"}], "\[Rule]", "1"}]],
              Annotation[#, {1, 1, 3} -> 1, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{"3", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["s",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`s[],
                  Editable->False], "2"]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "4"}], "}"}], "\[Rule]", 
                 RowBox[{"3", " ", 
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False], "2"]}]}]],
              Annotation[#, {1, 1, 4} -> 3 $CellContext`s[]^2, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 1} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                InterpretationBox[
                 StyleBox["s",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`s[],
                 Editable->False]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{"2", " ", "\[ImaginaryI]", " ", 
                   InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False]}]}]],
              
              Annotation[#, {1, 2, 2} -> Complex[0, 2] $CellContext`s[], 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["2",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "3"}], "}"}], "\[Rule]", "2"}]],
              Annotation[#, {1, 2, 3} -> 2, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{"6", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["s",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`s[],
                  Editable->False], "2"]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "4"}], "}"}], "\[Rule]", 
                 RowBox[{"6", " ", 
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False], "2"]}]}]],
              Annotation[#, {1, 2, 4} -> 6 $CellContext`s[]^2, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 1} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{"3", " ", "\[ImaginaryI]", " ", 
                InterpretationBox[
                 StyleBox["s",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`s[],
                 Editable->False]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{"3", " ", "\[ImaginaryI]", " ", 
                   InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False]}]}]],
              Annotation[#, {2, 1, 2} -> Complex[0, 3] $CellContext`s[], 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["3",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "3"}], "}"}], "\[Rule]", "3"}]],
              Annotation[#, {2, 1, 3} -> 3, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{"9", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["s",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`s[],
                  Editable->False], "2"]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "4"}], "}"}], "\[Rule]", 
                 RowBox[{"9", " ", 
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False], "2"]}]}]],
              Annotation[#, {2, 1, 4} -> 9 $CellContext`s[]^2, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 1} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{"4", " ", "\[ImaginaryI]", " ", 
                InterpretationBox[
                 StyleBox["s",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`s[],
                 Editable->False]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{"4", " ", "\[ImaginaryI]", " ", 
                   InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False]}]}]],
              
              Annotation[#, {2, 2, 2} -> Complex[0, 4] $CellContext`s[], 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["4",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "3"}], "}"}], "\[Rule]", "4"}]],
              Annotation[#, {2, 2, 3} -> 4, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{"12", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["s",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`s[],
                  Editable->False], "2"]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "4"}], "}"}], "\[Rule]", 
                 RowBox[{"12", " ", 
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False], "2"]}]}]],
              
              Annotation[#, {2, 2, 4} -> 12 $CellContext`s[]^2, 
               "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {"b", "c", "a"},
         {" ", " ", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{{
     0, Complex[0, 1] $CellContext`s[], 1, 3 $CellContext`s[]^2}, {
     0, Complex[0, 2] $CellContext`s[], 2, 6 $CellContext`s[]^2}}, {{
     0, Complex[0, 3] $CellContext`s[], 3, 9 $CellContext`s[]^2}, {
     0, Complex[0, 4] $CellContext`s[], 4, 
      12 $CellContext`s[]^2}}}, {$CellContext`B, $CellContext`B, \
$CellContext`B}, 0][$CellContext`b, $CellContext`c, $CellContext`a],
  Editable->False]], "Output",ExpressionUUID->"dcdb50d7-5bf1-4760-b733-\
7fbb9e545ea9"]
}, Open  ]],

Cell["\<\
\[Bullet] Finally, contractions are denoted by repeated staggered indices:\
\>", "Text",ExpressionUUID->"50242606-8c2e-433b-879d-5731cc216f35"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"A", "[", 
   RowBox[{
    RowBox[{"-", "a"}], ",", 
    RowBox[{"-", "b"}], ",", 
    RowBox[{"-", "c"}]}], "]"}], 
  RowBox[{"v", "[", "b", "]"}]}]], "Input",ExpressionUUID->"1a2b163a-15fb-\
4ec3-88e9-f2fe9533e272"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      OverscriptBox[
       OverscriptBox[
        StyleBox[GridBox[{
           {
            TagBox[
             TooltipBox["0",
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", "0"}]],
             Annotation[#, {1, 1} -> 0, "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              RowBox[{
               RowBox[{"-", 
                InterpretationBox[
                 StyleBox["s",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`s[],
                 Editable->False]}], "-", 
               RowBox[{"3", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["s",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`s[],
                  Editable->False], "3"]}]}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                RowBox[{
                  RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False]}], "-", 
                  RowBox[{"3", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False], "3"]}]}]}]],
             
             Annotation[#, {1, 2} -> -$CellContext`s[] - 3 $CellContext`s[]^3,
               "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              RowBox[{
               RowBox[{"\[ImaginaryI]", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["s",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`s[],
                  Editable->False], "2"]}], "-", 
               RowBox[{"3", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["s",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`s[],
                  Editable->False], "3"]}]}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"1", ",", "3"}], "}"}], "\[Rule]", 
                RowBox[{
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False], "2"]}], "-", 
                  RowBox[{"3", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False], "3"]}]}]}]],
             
             Annotation[#, {1, 3} -> 
              Complex[0, 1] $CellContext`s[]^2 - 3 $CellContext`s[]^3, 
              "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["s",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`s[],
                Editable->False], "+", 
               RowBox[{"\[ImaginaryI]", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["s",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`s[],
                  Editable->False], "2"]}]}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"1", ",", "4"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                   "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`s[], Editable -> False], "+", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False], "2"]}]}]}]],
             
             Annotation[#, {1, 4} -> $CellContext`s[] + 
               Complex[0, 1] $CellContext`s[]^2, "Tooltip"]& ]},
           {
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["s",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`s[],
                Editable->False], "+", 
               RowBox[{"3", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["s",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`s[],
                  Editable->False], "3"]}]}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                   "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`s[], Editable -> False], "+", 
                  RowBox[{"3", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False], "3"]}]}]}]],
             Annotation[#, {2, 1} -> $CellContext`s[] + 3 $CellContext`s[]^3, 
              "Tooltip"]& ], 
            TagBox[
             TooltipBox["0",
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", "0"}]],
             Annotation[#, {2, 2} -> 0, "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              RowBox[{
               RowBox[{"-", "3"}], " ", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["s",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`s[],
                 Editable->False], "3"]}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "3"}], "}"}], "\[Rule]", 
                RowBox[{
                  RowBox[{"-", "3"}], " ", 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False], "3"]}]}]],
             Annotation[#, {2, 3} -> (-3) $CellContext`s[]^3, "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              InterpretationBox[
               StyleBox["s",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`s[],
               Editable->False],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "4"}], "}"}], "\[Rule]", 
                InterpretationBox[
                 StyleBox["s", AutoSpacing -> False, ShowAutoStyles -> False], 
                 $CellContext`s[], Editable -> False]}]],
             Annotation[#, {2, 4} -> $CellContext`s[], "Tooltip"]& ]},
           {
            TagBox[
             TooltipBox[
              RowBox[{
               RowBox[{
                RowBox[{"-", "\[ImaginaryI]"}], " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["s",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`s[],
                  Editable->False], "2"]}], "+", 
               RowBox[{"3", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["s",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`s[],
                  Editable->False], "3"]}]}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"3", ",", "1"}], "}"}], "\[Rule]", 
                RowBox[{
                  RowBox[{
                    RowBox[{"-", "\[ImaginaryI]"}], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False], "2"]}], "+", 
                  RowBox[{"3", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False], "3"]}]}]}]],
             
             Annotation[#, {3, 1} -> 
              Complex[0, -1] $CellContext`s[]^2 + 3 $CellContext`s[]^3, 
              "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              RowBox[{"3", " ", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["s",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`s[],
                 Editable->False], "3"]}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"3", ",", "2"}], "}"}], "\[Rule]", 
                RowBox[{"3", " ", 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False], "3"]}]}]],
             Annotation[#, {3, 2} -> 3 $CellContext`s[]^3, "Tooltip"]& ], 
            TagBox[
             TooltipBox["0",
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"3", ",", "3"}], "}"}], "\[Rule]", "0"}]],
             Annotation[#, {3, 3} -> 0, "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              RowBox[{
               RowBox[{"-", "\[ImaginaryI]"}], " ", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["s",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`s[],
                 Editable->False], "2"]}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"3", ",", "4"}], "}"}], "\[Rule]", 
                RowBox[{
                  RowBox[{"-", "\[ImaginaryI]"}], " ", 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False], "2"]}]}]],
             
             Annotation[#, {3, 4} -> Complex[0, -1] $CellContext`s[]^2, 
              "Tooltip"]& ]},
           {
            TagBox[
             TooltipBox[
              RowBox[{
               RowBox[{"-", 
                InterpretationBox[
                 StyleBox["s",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`s[],
                 Editable->False]}], "-", 
               RowBox[{"\[ImaginaryI]", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["s",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`s[],
                  Editable->False], "2"]}]}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"4", ",", "1"}], "}"}], "\[Rule]", 
                RowBox[{
                  RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False]}], "-", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False], "2"]}]}]}]],
             
             Annotation[#, {4, 1} -> -$CellContext`s[] + 
               Complex[0, -1] $CellContext`s[]^2, "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              RowBox[{"-", 
               InterpretationBox[
                StyleBox["s",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`s[],
                Editable->False]}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"4", ",", "2"}], "}"}], "\[Rule]", 
                RowBox[{"-", 
                  InterpretationBox[
                   StyleBox[
                   "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`s[], Editable -> False]}]}]],
             Annotation[#, {4, 2} -> -$CellContext`s[], "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              RowBox[{"\[ImaginaryI]", " ", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["s",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`s[],
                 Editable->False], "2"]}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"4", ",", "3"}], "}"}], "\[Rule]", 
                RowBox[{"\[ImaginaryI]", " ", 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False], "2"]}]}]],
             
             Annotation[#, {4, 3} -> Complex[0, 1] $CellContext`s[]^2, 
              "Tooltip"]& ], 
            TagBox[
             TooltipBox["0",
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"4", ",", "4"}], "}"}], "\[Rule]", "0"}]],
             Annotation[#, {4, 4} -> 0, "Tooltip"]& ]}
          },
          AutoDelete->False,
          
          GridBoxDividers->{
           "ColumnsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}, 
            "RowsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}],
         FontSize->Small], 
        StyleBox["~",
         FontColor->RGBColor[1., 0., 0.]]], 
       StyleBox["~",
        FontColor->RGBColor[1., 0., 0.]]], 
      StyleBox[GridBox[{
         {" ", " "},
         {"a", "c"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{
    0, -$CellContext`s[] - 3 $CellContext`s[]^3, 
     Complex[0, 1] $CellContext`s[]^2 - 
     3 $CellContext`s[]^3, $CellContext`s[] + 
     Complex[0, 1] $CellContext`s[]^2}, {$CellContext`s[] + 
     3 $CellContext`s[]^3, 0, (-3) $CellContext`s[]^3, 
     $CellContext`s[]}, {
    Complex[0, -1] $CellContext`s[]^2 + 3 $CellContext`s[]^3, 
     3 $CellContext`s[]^3, 0, 
     Complex[0, -1] $CellContext`s[]^2}, {-$CellContext`s[] + 
     Complex[0, -1] $CellContext`s[]^2, -$CellContext`s[], 
     Complex[0, 1] $CellContext`s[]^2, 
     0}}, {-$CellContext`B, -$CellContext`B}, 
   2 $CellContext`B][-$CellContext`a, -$CellContext`c],
  Editable->False]], "Output",ExpressionUUID->"8993a73c-a531-480d-8543-\
20897a2da24e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", " ", 
  RowBox[{"v", "[", "c", "]"}]}]], "Input",ExpressionUUID->"d52a1ea9-8504-4468-85fb-166949cffa03"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      OverscriptBox[
       OverscriptBox[
        StyleBox[GridBox[{
           {
            TagBox[
             TooltipBox["\<\"\[GrayCircle]\"\>",
              RowBox[{
                RowBox[{"{", "1", "}"}], "\[Rule]", 
                RowBox[{
                  RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False], "2"]}], "-", 
                  RowBox[{"3", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False], "3"]}], "+", 
                  RowBox[{"3", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False], "+", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False], "2"]}]}], ")"}]}], 
                  "+", 
                  RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False]}], "-", 
                    RowBox[{"3", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "s", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`s[], Editable -> False], "3"]}]}], 
                    ")"}]}]}]}]],
             
             Annotation[#, {1} -> 
              Complex[0, 1] $CellContext`s[]^2 - 3 $CellContext`s[]^3 + 
               3 $CellContext`s[]^2 ($CellContext`s[] + 
                 Complex[0, 1] $CellContext`s[]^2) + 
               Complex[0, 1] $CellContext`s[] (-$CellContext`s[] - 
                 3 $CellContext`s[]^3), "Tooltip"]& ]},
           {
            TagBox[
             TooltipBox["0",
              RowBox[{
                RowBox[{"{", "2", "}"}], "\[Rule]", "0"}]],
             Annotation[#, {2} -> 0, "Tooltip"]& ]},
           {
            TagBox[
             TooltipBox["0",
              RowBox[{
                RowBox[{"{", "3", "}"}], "\[Rule]", "0"}]],
             Annotation[#, {3} -> 0, "Tooltip"]& ]},
           {
            TagBox[
             TooltipBox["0",
              RowBox[{
                RowBox[{"{", "4", "}"}], "\[Rule]", "0"}]],
             Annotation[#, {4} -> 0, "Tooltip"]& ]}
          },
          AutoDelete->False,
          
          GridBoxDividers->{
           "ColumnsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}],
         FontSize->Small], 
        StyleBox["~",
         FontColor->RGBColor[1., 0., 0.]]], 
       StyleBox["~",
        FontColor->RGBColor[1., 0., 0.]]], 
      StyleBox[GridBox[{
         {" "},
         {"a"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{
   Complex[0, 1] $CellContext`s[]^2 - 3 $CellContext`s[]^3 + 
    3 $CellContext`s[]^2 ($CellContext`s[] + 
      Complex[0, 1] $CellContext`s[]^2) + 
    Complex[0, 1] $CellContext`s[] (-$CellContext`s[] - 3 $CellContext`s[]^3),
     0, 0, 0}, {-$CellContext`B}, 2 $CellContext`B][-$CellContext`a],
  Editable->False]], "Output",ExpressionUUID->"6ec21c66-8ce2-441d-8796-\
04c1e5054f69"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", "Simplify"}]], "Input",ExpressionUUID->"1e01107a-5547-4d7a-a7a1-3385a610af97"],

Cell[BoxData["0"], "Output",ExpressionUUID->"507311c7-5df1-4614-8567-8b004b89d5af"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["2.4. Metric", "Subsubsection",ExpressionUUID->"bca63889-fe4e-4c21-b0a4-388150e2c97a"],

Cell["\<\
Once we have a metric field in our problem, there are many more things we can \
do. In this section we focus on how to set a metric field, and which other \
tensors are algebraically related to it. We can specify a metric field in \
several possible ways. We start with the simpler case of a metric given in a \
coordinate chart. We shall use the example of spherical angles on the \
2-sphere.\
\>", "Text",ExpressionUUID->"f799e780-c163-4138-b3c7-4366fe1d20c6"],

Cell["\[Bullet] Define the S2 manifold, with script indices:", "Text",ExpressionUUID->"4bd80f2e-19e4-41db-a165-884c0eb1d1ac"],

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"S2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{
    "\[ScriptA]", ",", "\[ScriptB]", ",", "\[ScriptC]", ",", "\[ScriptD]", 
     ",", "\[ScriptE]", ",", "\[ScriptF]"}], "}"}]}], "]"}]], "Input",Expressi\
onUUID->"72b4b84b-c494-4eb4-967b-10fac8cc932e"],

Cell["\[Bullet] Define the chart:", "Text",ExpressionUUID->"edd59579-0fc5-4d50-b789-22c236f6ffae"],

Cell[BoxData[
 RowBox[{"DefChart", "[", 
  RowBox[{"sph", ",", "S2", ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\[Theta]", "[", "]"}], ",", 
     RowBox[{"\[Phi]", "[", "]"}]}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"2b5abe7e-e593-4e89-a59a-65e15d4e2a16"],

Cell["\<\
\[Bullet] Construct a metric field, that is a symmetric covariant 2-tensor:\
\>", "Text",ExpressionUUID->"c81d1b42-5d11-46ef-9a92-f78abb346162"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"met", "=", 
  RowBox[{"CTensor", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", 
        RowBox[{
         RowBox[{"Sin", "[", 
          RowBox[{"\[Theta]", "[", "]"}], "]"}], "^", "2"}]}], "}"}]}], "}"}],
     ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "sph"}], ",", 
      RowBox[{"-", "sph"}]}], "}"}]}], "]"}]}]], "Input",ExpressionUUID->\
"e2b24f6c-809a-42d4-a8dd-de6261718e7b"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       SuperscriptBox[
        RowBox[{
         InterpretationBox[
          StyleBox["Sin",
           ShowAutoStyles->False,
           AutoSpacing->False],
          Sin,
          Editable->False], "[", 
         InterpretationBox[
          StyleBox["\[Theta]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[Theta][],
          Editable->False], "]"}], "2"]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "sph"}], ",", 
     RowBox[{"-", "sph"}]}], "}"}], ",", "0"}], "]"}]], "Output",ExpressionUUI\
D->"820e6ea9-f6fa-45be-9887-aba83825b3c8"]
}, Open  ]],

Cell["\[Bullet] This is the inverse metric:", "Text",ExpressionUUID->"4f5e77f3-cec9-4afd-8a18-a075d38a0d63"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"imet", "=", 
  RowBox[{"Inv", "[", "met", "]"}]}]], "Input",ExpressionUUID->"de5e07ce-fa08-\
4d69-a07d-8cbb6cbc19b1"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       SuperscriptBox[
        RowBox[{
         InterpretationBox[
          StyleBox["Csc",
           ShowAutoStyles->False,
           AutoSpacing->False],
          Csc,
          Editable->False], "[", 
         InterpretationBox[
          StyleBox["\[Theta]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[Theta][],
          Editable->False], "]"}], "2"]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"sph", ",", "sph"}], "}"}], ",", "0"}], "]"}]], "Output",Expressio\
nUUID->"12cacf48-bea3-4148-ba81-d319aba01cb4"]
}, Open  ]],

Cell["\[Bullet] Check that they are indeed inverses:", "Text",ExpressionUUID->"dea64438-fc84-4f2e-a8ac-fbf6affabcce"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"met", "[", 
   RowBox[{
    RowBox[{"-", "a"}], ",", 
    RowBox[{"-", "b"}]}], "]"}], 
  RowBox[{"imet", "[", 
   RowBox[{"b", ",", "c"}], "]"}]}]], "Input",ExpressionUUID->"af0c8444-e838-\
4758-b257-b0da5710e1d6"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["1",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", "1"}]],
           Annotation[#, {1, 1} -> 1, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 2} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["1",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", "1"}]],
           Annotation[#, {2, 2} -> 1, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {"c", " "},
         {" ", "a"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{1, 0}, {0, 1}}, {$CellContext`sph, -$CellContext`sph}, 
   0][$CellContext`c, -$CellContext`a],
  Editable->False]], "Output",ExpressionUUID->"efcdf8f9-eeec-4b96-a1fb-\
a61c609bf167"]
}, Open  ]],

Cell["\<\
\[Bullet] We can also compute the metric determinant, which is a density of \
weight +2 in the given chart (note the third argument of CTensor in the \
result):\
\>", "Text",ExpressionUUID->"6427ab91-0b2e-4836-9e3a-72d8e8b16540"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Determinant", "[", 
  RowBox[{"met", ",", "sph"}], "]"}]], "Input",ExpressionUUID->"8793a338-2cf3-\
4ec8-b7ce-92da9cde20a9"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   SuperscriptBox[
    RowBox[{
     InterpretationBox[
      StyleBox["Sin",
       ShowAutoStyles->False,
       AutoSpacing->False],
      Sin,
      Editable->False], "[", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False], "]"}], "2"], ",", 
   RowBox[{"{", "}"}], ",", 
   RowBox[{"2", " ", "sph"}]}], "]"}]], "Output",ExpressionUUID->"0bd9c277-\
a0c5-4be3-81e7-95bd9994694a"]
}, Open  ]],

Cell["\<\
\[Bullet] Or the epsilon tensor, which is a pure tensor, and not a density:\
\>", "Text",ExpressionUUID->"f4bcd84f-8f77-4337-971b-a25f7f933abf"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"epsilon", "[", "met", "]"}]], "Input",ExpressionUUID->"bab8c900-eaba-4bc0-9eed-84ee4fc8fbb2"],

Cell[BoxData[
 TemplateBox[{
  "SignDetOfMetric","num",
   "\"Cannot determine sign of determinant of matrix \\!\\(\\*RowBox[{\\\"{\\\
\", RowBox[{RowBox[{\\\"{\\\", RowBox[{\\\"1\\\", \\\",\\\", \\\"0\\\"}], \
\\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \
SuperscriptBox[RowBox[{InterpretationBox[StyleBox[RowBox[{\\\"Sin\\\"}], \
Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], Sin, Rule[Editable, \
False]], \\\"[\\\", InterpretationBox[StyleBox[\\\"\[Theta]\\\", \
Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], \\\\[Theta][], \
Rule[Editable, False]], \\\"]\\\"}], \\\"2\\\"]}], \\\"}\\\"}]}], \\\"}\\\"}]\
\\). Assuming +1.\"",2,123,4,19248039995900841960,"Local",
   "xAct`xTensor`SignDetOfMetric"},
  "MessageTemplate2"]], "Message", \
"MSG",ExpressionUUID->"5f608f1a-70c7-4aaa-9e20-01e0c2a208a2"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   InterpretationBox[
    RowBox[{
     TagBox["SparseArray",
      "SummaryHead"], "[", 
     DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = 
      "Ready"}, 
      TemplateBox[{PaneSelectorBox[{False -> GridBox[{{
              PaneBox[
               ButtonBox[
                DynamicBox[
                 FEPrivate`FrontEndResource[
                 "FEBitmaps", "SquarePlusIconMedium"]], 
                ButtonFunction :> (Typeset`open$$ = True), Appearance -> None,
                 Evaluator -> Automatic, Method -> "Preemptive"], 
               Alignment -> {Center, Center}, ImageSize -> 
               Dynamic[{
                 Automatic, 
                  3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                   Magnification])}]], 
              GraphicsBox[
               
               RasterBox[{{{0.5, 0., 0.}, {0.235431, 0.32765, 0.833291}}, {{
                0.235431, 0.32765, 0.833291}, {0.5, 0., 0.}}}, {{0, 0}, {2, 
                2}}, {0, 1}], AspectRatio -> 1, Axes -> False, Frame -> False,
                FrameLabel -> {None, None}, FrameStyle -> Directive[
                 Opacity[0.5], 
                 Thickness[Tiny], 
                 RGBColor[0.368417, 0.506779, 0.709798]], 
               FrameTicks -> {{None, None}, {None, None}}, GridLinesStyle -> 
               Directive[
                 GrayLevel[0.5, 0.4]], ImageSize -> 
               Dynamic[{
                 Automatic, 
                  3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                   Magnification])}], 
               Method -> {
                "AxisPadding" -> Scaled[0.02], "DefaultBoundaryStyle" -> 
                 Automatic, "DefaultPlotStyle" -> Automatic, "DomainPadding" -> 
                 Scaled[0.02], "RangePadding" -> Scaled[0.05]}], 
              GridBox[{{
                 RowBox[{
                   TagBox[
                   "\"Specified elements: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["2", "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Dimensions: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox[
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2"}], "}"}], "SummaryItem"]}]}}, 
               GridBoxAlignment -> {
                "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
               False, GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               GridBoxSpacings -> {
                "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
               BaseStyle -> {
                ShowStringCharacters -> False, NumberMarks -> False, 
                 PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
            GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
            GridBoxItemSize -> {
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
            BaselinePosition -> {1, 1}], True -> GridBox[{{
              PaneBox[
               ButtonBox[
                DynamicBox[
                 FEPrivate`FrontEndResource[
                 "FEBitmaps", "SquareMinusIconMedium"]], 
                ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                None, Evaluator -> Automatic, Method -> "Preemptive"], 
               Alignment -> {Center, Center}, ImageSize -> 
               Dynamic[{
                 Automatic, 
                  3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                   Magnification])}]], 
              GraphicsBox[
               
               RasterBox[{{{0.5, 0., 0.}, {0.235431, 0.32765, 0.833291}}, {{
                0.235431, 0.32765, 0.833291}, {0.5, 0., 0.}}}, {{0, 0}, {2, 
                2}}, {0, 1}], AspectRatio -> 1, Axes -> False, Frame -> False,
                FrameLabel -> {None, None}, FrameStyle -> Directive[
                 Opacity[0.5], 
                 Thickness[Tiny], 
                 RGBColor[0.368417, 0.506779, 0.709798]], 
               FrameTicks -> {{None, None}, {None, None}}, GridLinesStyle -> 
               Directive[
                 GrayLevel[0.5, 0.4]], ImageSize -> 
               Dynamic[{
                 Automatic, 
                  3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                   Magnification])}], 
               Method -> {
                "AxisPadding" -> Scaled[0.02], "DefaultBoundaryStyle" -> 
                 Automatic, "DefaultPlotStyle" -> Automatic, "DomainPadding" -> 
                 Scaled[0.02], "RangePadding" -> Scaled[0.05]}], 
              GridBox[{{
                 RowBox[{
                   TagBox[
                   "\"Specified elements: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["2", "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Dimensions: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox[
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2"}], "}"}], "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Default: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["0", "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Density: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["0.5`", "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Elements:\"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["\"\"", "SummaryItem"]}]}, {
                 TagBox[
                  TagBox[
                   GridBox[{{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                    StyleBox[
                    PaneBox[
                    SqrtBox[
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Sin"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Sin, Editable -> False], "[", 
                    InterpretationBox[
                    StyleBox[
                    "\[Theta]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Theta][], Editable -> False], "]"}], "2"]],
                     ContentPadding -> False, FrameMargins -> 0, StripOnInput -> 
                    True, BaselinePosition -> Baseline, 
                    ImageSize -> {{1, 300}, Automatic}], LineBreakWithin -> 
                    False]}]}, {
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                    StyleBox[
                    PaneBox[
                    RowBox[{"-", 
                    SqrtBox[
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Sin"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Sin, Editable -> False], "[", 
                    InterpretationBox[
                    StyleBox[
                    "\[Theta]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Theta][], Editable -> False], "]"}], 
                    "2"]]}], ContentPadding -> False, FrameMargins -> 0, 
                    StripOnInput -> True, BaselinePosition -> Baseline, 
                    ImageSize -> {{1, 300}, Automatic}], LineBreakWithin -> 
                    False]}]}}, GridBoxAlignment -> {"Columns" -> {{Left}}}, 
                    DefaultBaseStyle -> "Column", 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                   "Column"], "SummaryItem"]}}, 
               GridBoxAlignment -> {
                "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
               False, GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               GridBoxSpacings -> {
                "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
               BaseStyle -> {
                ShowStringCharacters -> False, NumberMarks -> False, 
                 PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
            GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
            GridBoxItemSize -> {
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
            BaselinePosition -> {1, 1}]}, 
         Dynamic[Typeset`open$$], ImageSize -> Automatic]},
       "SummaryPanel"],
      DynamicModuleValues:>{}], "]"}],
    SparseArray[
    Automatic, {2, 2}, 0, {
     1, {{0, 1, 2}, {{2}, {1}}}, {(Sin[$CellContext`\[Theta][]]^2)^
       Rational[1, 2], -(Sin[$CellContext`\[Theta][]]^2)^Rational[1, 2]}}],
    Editable->False,
    SelectWithContents->True,
    Selectable->False], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "sph"}], ",", 
     RowBox[{"-", "sph"}]}], "}"}], ",", "0"}], "]"}]], "Output",ExpressionUUI\
D->"ea61c747-af2b-4a76-9142-78f5fd245532"]
}, Open  ]],

Cell["\<\
It is constructed as a SparseArray. Use Normal to get the corresponding \
normal array:\
\>", "Text",ExpressionUUID->"fd6c5295-2819-43ae-982f-8156212ac94e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", "Normal"}]], "Input",ExpressionUUID->"e422fffc-3c27-408c-a9f4-085064ba390e"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", 
       SqrtBox[
        SuperscriptBox[
         RowBox[{
          InterpretationBox[
           StyleBox["Sin",
            ShowAutoStyles->False,
            AutoSpacing->False],
           Sin,
           Editable->False], "[", 
          InterpretationBox[
           StyleBox["\[Theta]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Theta][],
           Editable->False], "]"}], "2"]]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        SqrtBox[
         SuperscriptBox[
          RowBox[{
           InterpretationBox[
            StyleBox["Sin",
             ShowAutoStyles->False,
             AutoSpacing->False],
            Sin,
            Editable->False], "[", 
           InterpretationBox[
            StyleBox["\[Theta]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`\[Theta][],
            Editable->False], "]"}], "2"]]}], ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "sph"}], ",", 
     RowBox[{"-", "sph"}]}], "}"}], ",", "0"}], "]"}]], "Output",ExpressionUUI\
D->"001f4126-3b96-409a-a11b-78c6e47f2ca0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{"%", ",", 
   RowBox[{
    RowBox[{"Sin", "[", 
     RowBox[{"\[Theta]", "[", "]"}], "]"}], ">", "0"}]}], "]"}]], "Input",Expr\
essionUUID->"46243fb3-fc0d-481d-9e88-d32b3a274239"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{
        InterpretationBox[
         StyleBox["Sin",
          ShowAutoStyles->False,
          AutoSpacing->False],
         Sin,
         Editable->False], "[", 
        InterpretationBox[
         StyleBox["\[Theta]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Theta][],
         Editable->False], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{
         InterpretationBox[
          StyleBox["Sin",
           ShowAutoStyles->False,
           AutoSpacing->False],
          Sin,
          Editable->False], "[", 
         InterpretationBox[
          StyleBox["\[Theta]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[Theta][],
          Editable->False], "]"}]}], ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "sph"}], ",", 
     RowBox[{"-", "sph"}]}], "}"}], ",", "0"}], "]"}]], "Output",ExpressionUUI\
D->"683fbc24-4655-4c57-b6b8-560da516ee54"]
}, Open  ]],

Cell[TextData[{
 "So far the metric field we have is just a normal tensor field, and ",
 StyleBox["xCoba",
  FontSlant->"Italic"],
 " does not know yet that it is going to play any special role. In order to \
declare it as special we need to use SetCMetric, the component equivalent of \
DefMetric."
}], "Text",ExpressionUUID->"b2502bad-0b45-4f75-a86f-d9e275f6b495"],

Cell["\<\
\[Bullet] Declare met as the first-metric of the tangent bundle TangentS2. \
This will precompute a number of objects associated to the metric.\
\>", "Text",ExpressionUUID->"2b3b0cdd-035d-4732-a030-7ab68563d972"],

Cell[BoxData[
 RowBox[{"SetCMetric", "[", 
  RowBox[{"met", ",", "sph", ",", 
   RowBox[{"SignatureOfMetric", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"2", ",", "0", ",", "0"}], "}"}]}]}], "]"}]], "Input",ExpressionU\
UID->"17bba426-4ef5-474f-8d1e-c729e3229d00"],

Cell["\<\
\[Bullet] Now we can raise and lower indices, because we know what the metric \
is.\
\>", "Text",ExpressionUUID->"efacfa61-eefe-42ac-8683-76defe10bd6a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"V", "=", 
  RowBox[{"CTensor", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], ",", 
    RowBox[{"{", "sph", "}"}]}], "]"}]}]], "Input",ExpressionUUID->"e5fae051-\
0dee-4abd-af63-3481bfb20711"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", "sph", "}"}], ",", "0"}], "]"}]], "Output",ExpressionUUID->\
"291daecb-60e0-4f29-a45c-8deec5335843"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"V", "[", "a", "]"}]], "Input",ExpressionUUID->"fb6201c1-f498-44d4-a1f8-76c7f89d5f60"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["1",
            RowBox[{
              RowBox[{"{", "1", "}"}], "\[Rule]", "1"}]],
           Annotation[#, {1} -> 1, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["2",
            RowBox[{
              RowBox[{"{", "2", "}"}], "\[Rule]", "2"}]],
           Annotation[#, {2} -> 2, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {
           1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {"a"},
         {" "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{1, 2}, {$CellContext`sph}, 0][$CellContext`a],
  Editable->False]], "Output",ExpressionUUID->"9881a402-ad09-4c78-86b4-\
fad2ae3b67f4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"V", "[", 
  RowBox[{"-", "a"}], "]"}]], "Input",ExpressionUUID->"9e69d616-1a44-4468-b566-190cc0e3c8e8"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["1",
            RowBox[{
              RowBox[{"{", "1", "}"}], "\[Rule]", "1"}]],
           Annotation[#, {1} -> 1, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox[
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["Sin",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                Sin,
                Editable->False], "[", 
               InterpretationBox[
                StyleBox["\[Theta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Theta][],
                Editable->False], "]"}], "2"]}],
            RowBox[{
              RowBox[{"{", "2", "}"}], "\[Rule]", 
              RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"Sin"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Sin, Editable -> False], "[", 
                   InterpretationBox[
                    StyleBox[
                    "\[Theta]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Theta][], Editable -> False], "]"}], 
                 "2"]}]}]],
           Annotation[#, {2} -> 2 Sin[
                $CellContext`\[Theta][]]^2, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {
           1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {" "},
         {"a"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{1, 2 Sin[
       $CellContext`\[Theta][]]^2}, {-$CellContext`sph}, 0][-$CellContext`a],
  Editable->False]], "Output",ExpressionUUID->"271cfdc1-712c-4656-b6c2-\
8565a0c8d405"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"met", "[", 
   RowBox[{
    RowBox[{"-", "a"}], ",", 
    RowBox[{"-", "b"}]}], "]"}], 
  RowBox[{"V", "[", "b", "]"}]}]], "Input",ExpressionUUID->"1ecd167e-d121-\
4826-99eb-c9ec841607a9"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["1",
            RowBox[{
              RowBox[{"{", "1", "}"}], "\[Rule]", "1"}]],
           Annotation[#, {1} -> 1, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox[
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["Sin",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                Sin,
                Editable->False], "[", 
               InterpretationBox[
                StyleBox["\[Theta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Theta][],
                Editable->False], "]"}], "2"]}],
            RowBox[{
              RowBox[{"{", "2", "}"}], "\[Rule]", 
              RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"Sin"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Sin, Editable -> False], "[", 
                   InterpretationBox[
                    StyleBox[
                    "\[Theta]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Theta][], Editable -> False], "]"}], 
                 "2"]}]}]],
           Annotation[#, {2} -> 2 Sin[
                $CellContext`\[Theta][]]^2, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {
           1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {" "},
         {"a"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{1, 2 Sin[
       $CellContext`\[Theta][]]^2}, {-$CellContext`sph}, 0][-$CellContext`a],
  Editable->False]], "Output",ExpressionUUID->"975addba-97cf-4e8e-ac8f-\
fc91811c52bc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", " ", 
  RowBox[{"imet", "[", 
   RowBox[{"a", ",", "b"}], "]"}]}]], "Input",ExpressionUUID->"6d7e0202-49dc-\
48aa-9421-6563357c99ba"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["1",
            RowBox[{
              RowBox[{"{", "1", "}"}], "\[Rule]", "1"}]],
           Annotation[#, {1} -> 1, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["2",
            RowBox[{
              RowBox[{"{", "2", "}"}], "\[Rule]", "2"}]],
           Annotation[#, {2} -> 2, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {
           1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {"b"},
         {" "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{1, 2}, {$CellContext`sph}, 0][$CellContext`b],
  Editable->False]], "Output",ExpressionUUID->"9db1dc47-abd6-4c44-ad19-\
a877f17afdc4"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["2.5. ToCTensor: changes of bases and height", "Subsubsection",ExpressionUUID->"a6d6f0f4-86c9-4d00-affb-7cb29a446f88"],

Cell["\<\
One of the most useful features of xCoba in comparison with other tensor CASs \
is its ability to manipulate several bases simultaneously and tensor \
components in different, even mixed bases. We can also have CTensor objects \
expressed in different bases, and we can easily change those bases, \
effectively implementing the basic tensorial transformation law. Note that \
this changes simultaenously bases and components, such that the changes \
compensate mutually and the actual tensor is left unchanged. Hence we are \
referring to passive changes.\
\>", "Text",ExpressionUUID->"0242abc9-e8fb-47cd-b516-0f633ff8a9b6"],

Cell["\<\
\[Bullet] Introduce a second frame on the sphere. To avoid discussing \
coordinate dependencies, we choose it to be a rigid transformation. Note how \
the transformation is provided: the new frame is associated to the first \
tensor slot, and in covariant form:\
\>", "Text",ExpressionUUID->"a8543bc8-574b-4597-a26a-5f1f4138a2ab"],

Cell[BoxData[
 RowBox[{"DefBasis", "[", 
  RowBox[{"sph2", ",", "TangentS2", ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"BasisChange", "\[Rule]", 
    RowBox[{"CTensor", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"2", ",", "1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "3"}], ",", "2"}], "}"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "sph2"}], ",", "sph"}], "}"}]}], "]"}]}], ",", 
   RowBox[{"BasisColor", "\[Rule]", "Blue"}]}], "]"}]], "Input",ExpressionUUID\
->"89f3c1b7-d819-455a-a16f-e360c9f47e66"],

Cell["\[Bullet] This is a vector field on the sphere:", "Text",ExpressionUUID->"16a8b881-c27b-44b3-a1dc-c2ee677e17bc"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"v", "=", 
  RowBox[{"CTensor", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "1"}], "}"}], ",", 
    RowBox[{"{", "sph", "}"}]}], "]"}]}]], "Input",ExpressionUUID->"52f77bdf-\
4f08-4dd4-8de9-2253adb39b65"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", "sph", "}"}], ",", "0"}], "]"}]], "Output",ExpressionUUID->\
"4f8388e4-d89e-47a7-bfd6-d7c84621cf67"]
}, Open  ]],

Cell["\[Bullet] Change it to the new frame:", "Text",ExpressionUUID->"a0dd83d8-21b0-4a0e-a756-8f3f55ca3568"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCTensor", "[", 
  RowBox[{"v", ",", 
   RowBox[{"{", "sph2", "}"}]}], "]"}]], "Input",ExpressionUUID->"79ed9ff7-\
1a86-49e3-aa30-cfa86896b317"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     FractionBox["5", "7"], ",", 
     FractionBox["1", "7"]}], "}"}], ",", 
   RowBox[{"{", "sph2", "}"}], ",", "0"}], "]"}]], "Output",ExpressionUUID->\
"15fcef6f-3935-4c55-b67f-abda9c285b2f"]
}, Open  ]],

Cell["\[Bullet] Change it back to the original frame:", "Text",ExpressionUUID->"55ec00c5-ee1b-45d4-8ef6-a1d3d4fc67e9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCTensor", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", "sph", "}"}]}], "]"}]], "Input",ExpressionUUID->"7f3ebad3-\
0013-479e-ab43-d2e42dbaa806"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", "sph", "}"}], ",", "0"}], "]"}]], "Output",ExpressionUUID->\
"a167bc87-4179-47e9-9f91-3d033a73a4b9"]
}, Open  ]],

Cell["\[Bullet] The identity tensor in the sph frame:", "Text",ExpressionUUID->"e7784f3e-219e-4c0b-8fcd-0fb8dcb2fe70"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCTensor", "[", 
  RowBox[{"delta", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "sph"}], ",", "sph"}], "}"}]}], "]"}]], "Input",ExpressionUU\
ID->"70de3f46-d8c5-4290-a4d0-e1210959f057"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "sph"}], ",", "sph"}], "}"}], ",", "0"}], "]"}]], "Output",E\
xpressionUUID->"01160e67-6742-49c2-8fb2-bda5c91015d5"]
}, Open  ]],

Cell["\[Bullet] Its components do not change under a change of basis:", "Text",ExpressionUUID->"b44992d4-1caa-44a5-89d5-c04d2885e4f9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCTensor", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "sph2"}], ",", "sph2"}], "}"}]}], "]"}]], "Input",Expression\
UUID->"d4dd7230-c00a-46b0-bae6-0e6b7f974464"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "sph2"}], ",", "sph2"}], "}"}], ",", "0"}], "]"}]], "Output",\
ExpressionUUID->"41a6be7a-d514-4958-b33f-a3dbe47df0c6"]
}, Open  ]],

Cell["\[Bullet] The components of the metric do change:", "Text",ExpressionUUID->"785dc785-7fcf-4d0c-85d2-bb27b5fd5bf8"],

Cell[CellGroupData[{

Cell[BoxData["met"], "Input",ExpressionUUID->"50c64c12-d951-4515-8ae5-65a098c70121"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       SuperscriptBox[
        RowBox[{
         InterpretationBox[
          StyleBox["Sin",
           ShowAutoStyles->False,
           AutoSpacing->False],
          Sin,
          Editable->False], "[", 
         InterpretationBox[
          StyleBox["\[Theta]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[Theta][],
          Editable->False], "]"}], "2"]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "sph"}], ",", 
     RowBox[{"-", "sph"}]}], "}"}], ",", "0"}], "]"}]], "Output",ExpressionUUI\
D->"9be680b8-1e96-42c8-8871-3e5fb1c879dc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCTensor", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "sph2"}], ",", 
     RowBox[{"-", "sph2"}]}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"764306ad-f502-41b1-9574-1ea3e83820e0"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"4", "+", 
        SuperscriptBox[
         RowBox[{
          InterpretationBox[
           StyleBox["Sin",
            ShowAutoStyles->False,
            AutoSpacing->False],
           Sin,
           Editable->False], "[", 
          InterpretationBox[
           StyleBox["\[Theta]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Theta][],
           Editable->False], "]"}], "2"]}], ",", 
       RowBox[{
        RowBox[{"-", "6"}], "+", 
        RowBox[{"2", " ", 
         SuperscriptBox[
          RowBox[{
           InterpretationBox[
            StyleBox["Sin",
             ShowAutoStyles->False,
             AutoSpacing->False],
            Sin,
            Editable->False], "[", 
           InterpretationBox[
            StyleBox["\[Theta]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`\[Theta][],
            Editable->False], "]"}], "2"]}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "6"}], "+", 
        RowBox[{"2", " ", 
         SuperscriptBox[
          RowBox[{
           InterpretationBox[
            StyleBox["Sin",
             ShowAutoStyles->False,
             AutoSpacing->False],
            Sin,
            Editable->False], "[", 
           InterpretationBox[
            StyleBox["\[Theta]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`\[Theta][],
            Editable->False], "]"}], "2"]}]}], ",", 
       RowBox[{"9", "+", 
        RowBox[{"4", " ", 
         SuperscriptBox[
          RowBox[{
           InterpretationBox[
            StyleBox["Sin",
             ShowAutoStyles->False,
             AutoSpacing->False],
            Sin,
            Editable->False], "[", 
           InterpretationBox[
            StyleBox["\[Theta]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`\[Theta][],
            Editable->False], "]"}], "2"]}]}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "sph2"}], ",", 
     RowBox[{"-", "sph2"}]}], "}"}], ",", "0"}], "]"}]], "Output",ExpressionUU\
ID->"57be8e6d-143f-477f-a194-d27a435a51ac"]
}, Open  ]],

Cell["\<\
\[Bullet] We can also use CTensor to change the hight of the slots of a \
tensor. Effectively that absorbs metric factors:\
\>", "Text",ExpressionUUID->"7fb27912-f701-4efe-85d7-eefba13a0401"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCTensor", "[", 
  RowBox[{"met", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "sph2"}], ",", "sph2"}], "}"}]}], "]"}]], "Input",Expression\
UUID->"358c3871-77bf-48a6-8da8-536fcf6c6fdf"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "sph2"}], ",", "sph2"}], "}"}], ",", "0"}], "]"}]], "Output",\
ExpressionUUID->"ffd78b80-c14f-4a01-aaec-101d03ad5521"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["v"], "Input",ExpressionUUID->"7d0cdd53-1bfa-4533-8bde-bde2be9c3327"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", "sph", "}"}], ",", "0"}], "]"}]], "Output",ExpressionUUID->\
"164e81bc-1853-4826-82e6-e1731de4117c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCTensor", "[", 
  RowBox[{"v", ",", 
   RowBox[{"{", 
    RowBox[{"-", "sph"}], "}"}]}], "]"}]], "Input",ExpressionUUID->"133f5e14-\
85e9-4900-a063-451e0111429a"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", 
     SuperscriptBox[
      RowBox[{
       InterpretationBox[
        StyleBox["Sin",
         ShowAutoStyles->False,
         AutoSpacing->False],
        Sin,
        Editable->False], "[", 
       InterpretationBox[
        StyleBox["\[Theta]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Theta][],
        Editable->False], "]"}], "2"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"-", "sph"}], "}"}], ",", "0"}], "]"}]], "Output",ExpressionUUID->\
"7df0c12f-924f-41c2-8938-4df1ba7f6fff"]
}, Open  ]],

Cell["\<\
\[Bullet] Finally, we can also use ToCTensor to expand a tensor into its \
components:\
\>", "Text",ExpressionUUID->"1b2ab81c-9025-49a2-adfc-9a1e95e5c9c0"],

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{"\[ScriptA]", ",", 
     RowBox[{"-", "\[ScriptB]"}]}], "]"}], ",", "S2"}], "]"}]], "Input",Expres\
sionUUID->"e3a76a4f-79af-46a0-b174-4c0aa60ee427"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCTensor", "[", 
  RowBox[{"S", ",", 
   RowBox[{"{", 
    RowBox[{"sph", ",", 
     RowBox[{"-", "sph2"}]}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"b96408b9-c5cc-4a29-be5d-eab32b5ec65d"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"S", 
            StyleBox[GridBox[{
               {
                StyleBox["1",
                 FontColor->RGBColor[1., 0., 0.]], " "},
               {" ", 
                StyleBox["1",
                 FontColor->RGBColor[0., 0., 1.]]}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`S[{1, $CellContext`sph}, {1, -$CellContext`sph2}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"S", 
            StyleBox[GridBox[{
               {
                StyleBox["1",
                 FontColor->RGBColor[1., 0., 0.]], " "},
               {" ", 
                StyleBox["2",
                 FontColor->RGBColor[0., 0., 1.]]}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`S[{1, $CellContext`sph}, {2, -$CellContext`sph2}],
        Editable->False]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"S", 
            StyleBox[GridBox[{
               {
                StyleBox["2",
                 FontColor->RGBColor[1., 0., 0.]], " "},
               {" ", 
                StyleBox["1",
                 FontColor->RGBColor[0., 0., 1.]]}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`S[{2, $CellContext`sph}, {1, -$CellContext`sph2}],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"S", 
            StyleBox[GridBox[{
               {
                StyleBox["2",
                 FontColor->RGBColor[1., 0., 0.]], " "},
               {" ", 
                StyleBox["2",
                 FontColor->RGBColor[0., 0., 1.]]}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`S[{2, $CellContext`sph}, {2, -$CellContext`sph2}],
        Editable->False]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"sph", ",", 
     RowBox[{"-", "sph2"}]}], "}"}], ",", "0"}], "]"}]], "Output",ExpressionUU\
ID->"6c6ff3a4-d4b1-46a0-af90-2ab4284e6666"]
}, Open  ]],

Cell["\[Bullet] Compare with the result from ComponentArray:", "Text",ExpressionUUID->"5dfb437d-a50c-488b-a063-a2c992188c98"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ComponentArray", "[", 
  RowBox[{"S", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"\[ScriptA]", ",", "sph"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "\[ScriptB]"}], ",", 
      RowBox[{"-", "sph2"}]}], "}"}]}], "]"}], "]"}]], "Input",ExpressionUUID-\
>"a92cc83b-1770-4d24-810d-ebbf1c8ae2df"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {"S", 
          StyleBox[GridBox[{
             {
              StyleBox["1",
               FontColor->RGBColor[1., 0., 0.]], " "},
             {" ", 
              StyleBox["1",
               FontColor->RGBColor[0., 0., 1.]]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`S[{1, $CellContext`sph}, {1, -$CellContext`sph2}],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"S", 
          StyleBox[GridBox[{
             {
              StyleBox["1",
               FontColor->RGBColor[1., 0., 0.]], " "},
             {" ", 
              StyleBox["2",
               FontColor->RGBColor[0., 0., 1.]]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`S[{1, $CellContext`sph}, {2, -$CellContext`sph2}],
      Editable->False]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {"S", 
          StyleBox[GridBox[{
             {
              StyleBox["2",
               FontColor->RGBColor[1., 0., 0.]], " "},
             {" ", 
              StyleBox["1",
               FontColor->RGBColor[0., 0., 1.]]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`S[{2, $CellContext`sph}, {1, -$CellContext`sph2}],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"S", 
          StyleBox[GridBox[{
             {
              StyleBox["2",
               FontColor->RGBColor[1., 0., 0.]], " "},
             {" ", 
              StyleBox["2",
               FontColor->RGBColor[0., 0., 1.]]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`S[{2, $CellContext`sph}, {2, -$CellContext`sph2}],
      Editable->False]}], "}"}]}], "}"}]], "Output",ExpressionUUID->"3eea1927-\
5250-4656-a020-a723038777f6"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["2.6. Extracting components", "Subsubsection",ExpressionUUID->"97b16043-f684-454c-b371-43ff35dd67b0"],

Cell["\<\
Closely related to the problem of changes of bases we have that of extraction \
of particular components. If necessary, a change of basis will be performed \
automatically.\
\>", "Text",ExpressionUUID->"ae15dff6-63fb-4a59-a483-93fbad828e8e"],

Cell["\[Bullet] Extract a component of the metric in the same bases:", "Text",ExpressionUUID->"e0300adb-165b-4d9e-ae0e-344b80f1b8e6"],

Cell[CellGroupData[{

Cell[BoxData["met"], "Input",ExpressionUUID->"7b0a1ac3-592d-443f-90a4-ce1df3e72353"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       SuperscriptBox[
        RowBox[{
         InterpretationBox[
          StyleBox["Sin",
           ShowAutoStyles->False,
           AutoSpacing->False],
          Sin,
          Editable->False], "[", 
         InterpretationBox[
          StyleBox["\[Theta]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[Theta][],
          Editable->False], "]"}], "2"]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "sph"}], ",", 
     RowBox[{"-", "sph"}]}], "}"}], ",", "0"}], "]"}]], "Output",ExpressionUUI\
D->"c29ad18a-36aa-40ad-a91d-cdff160ea6a2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"met", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"-", "sph"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"-", "sph"}]}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"51f3ad70-0649-4506-a35e-2f3bc6161a70"],

Cell[BoxData[
 SuperscriptBox[
  RowBox[{
   InterpretationBox[
    StyleBox["Sin",
     ShowAutoStyles->False,
     AutoSpacing->False],
    Sin,
    Editable->False], "[", 
   InterpretationBox[
    StyleBox["\[Theta]",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`\[Theta][],
    Editable->False], "]"}], "2"]], "Output",ExpressionUUID->"a569a7a7-db0a-\
4044-bfd7-8a6b03eae092"]
}, Open  ]],

Cell["\[Bullet] Extract a component in a different basis:", "Text",ExpressionUUID->"184ea674-bb58-442f-9206-87e854b11549"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"met", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"-", "sph2"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"-", "sph2"}]}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"22257414-f055-4d7f-822f-d3ab78d9820a"],

Cell[BoxData[
 RowBox[{"9", "+", 
  RowBox[{"4", " ", 
   SuperscriptBox[
    RowBox[{
     InterpretationBox[
      StyleBox["Sin",
       ShowAutoStyles->False,
       AutoSpacing->False],
      Sin,
      Editable->False], "[", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False], "]"}], "2"]}]}]], "Output",ExpressionUUID->"25c086bf-\
7ad3-4cc9-af19-4ad343795784"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ToCTensor", "[", 
   RowBox[{"met", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "sph2"}], ",", 
      RowBox[{"-", "sph2"}]}], "}"}]}], "]"}], "[", 
  RowBox[{
   RowBox[{"-", "\[ScriptA]"}], ",", 
   RowBox[{"-", "\[ScriptB]"}]}], "]"}]], "Input",ExpressionUUID->"38f5f286-\
f955-453d-80ea-62df83df93cb"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox[
            RowBox[{"4", "+", 
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["Sin",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                Sin,
                Editable->False], "[", 
               InterpretationBox[
                StyleBox["\[Theta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Theta][],
                Editable->False], "]"}], "2"]}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
              RowBox[{"4", "+", 
                SuperscriptBox[
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"Sin"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Sin, Editable -> False], "[", 
                   InterpretationBox[
                    StyleBox[
                    "\[Theta]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Theta][], Editable -> False], "]"}], 
                 "2"]}]}]],
           Annotation[#, {1, 1} -> 4 + Sin[
                $CellContext`\[Theta][]]^2, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{
             RowBox[{"-", "6"}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["Sin",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 Sin,
                 Editable->False], "[", 
                InterpretationBox[
                 StyleBox["\[Theta]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Theta][],
                 Editable->False], "]"}], "2"]}]}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
              RowBox[{
                RowBox[{"-", "6"}], "+", 
                RowBox[{"2", " ", 
                  SuperscriptBox[
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Sin"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Sin, Editable -> False], "[", 
                    InterpretationBox[
                    StyleBox[
                    "\[Theta]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Theta][], Editable -> False], "]"}], 
                   "2"]}]}]}]],
           Annotation[#, {1, 2} -> -6 + 2 Sin[
                 $CellContext`\[Theta][]]^2, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox[
            RowBox[{
             RowBox[{"-", "6"}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["Sin",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 Sin,
                 Editable->False], "[", 
                InterpretationBox[
                 StyleBox["\[Theta]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Theta][],
                 Editable->False], "]"}], "2"]}]}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
              RowBox[{
                RowBox[{"-", "6"}], "+", 
                RowBox[{"2", " ", 
                  SuperscriptBox[
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Sin"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Sin, Editable -> False], "[", 
                    InterpretationBox[
                    StyleBox[
                    "\[Theta]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Theta][], Editable -> False], "]"}], 
                   "2"]}]}]}]],
           Annotation[#, {2, 1} -> -6 + 2 Sin[
                 $CellContext`\[Theta][]]^2, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{"9", "+", 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["Sin",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 Sin,
                 Editable->False], "[", 
                InterpretationBox[
                 StyleBox["\[Theta]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Theta][],
                 Editable->False], "]"}], "2"]}]}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
              RowBox[{"9", "+", 
                RowBox[{"4", " ", 
                  SuperscriptBox[
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Sin"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Sin, Editable -> False], "[", 
                    InterpretationBox[
                    StyleBox[
                    "\[Theta]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Theta][], Editable -> False], "]"}], 
                   "2"]}]}]}]],
           Annotation[#, {2, 2} -> 9 + 4 Sin[
                 $CellContext`\[Theta][]]^2, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[0, 0, 1], 3 -> RGBColor[0, 0, 1]},
           "RowsIndexed" -> {1 -> RGBColor[0, 0, 1], 3 -> RGBColor[0, 0, 1]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {" ", " "},
         {"\[ScriptA]", "\[ScriptB]"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{4 + Sin[
        $CellContext`\[Theta][]]^2, -6 + 2 Sin[
         $CellContext`\[Theta][]]^2}, {-6 + 2 Sin[
         $CellContext`\[Theta][]]^2, 9 + 4 Sin[
         $CellContext`\[Theta][]]^2}}, {-$CellContext`sph2, \
-$CellContext`sph2}, 0][-$CellContext`\[ScriptA], -$CellContext`\[ScriptB]],
  Editable->False]], "Output",ExpressionUUID->"e6a7b91d-6d56-43ef-b935-\
e8821ec68ad0"]
}, Open  ]],

Cell["\[Bullet] A mixture of bases:", "Text",ExpressionUUID->"d1478478-43f1-49f0-8ea5-8d48191d159f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"met", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"-", "sph"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"-", "sph2"}]}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"2e2a6bdf-acff-405d-9595-86fcb40cec24"],

Cell[BoxData[
 RowBox[{"-", "3"}]], "Output",ExpressionUUID->"fc841c74-85f6-4aa1-a76f-ac5226cc56b7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ToCTensor", "[", 
   RowBox[{"met", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "sph"}], ",", 
      RowBox[{"-", "sph2"}]}], "}"}]}], "]"}], "[", 
  RowBox[{
   RowBox[{"-", "\[ScriptA]"}], ",", 
   RowBox[{"-", "\[ScriptB]"}]}], "]"}]], "Input",ExpressionUUID->"1bafdd1c-\
d8cc-4d72-97a9-afb9a00d3628"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["2",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", "2"}]],
           Annotation[#, {1, 1} -> 2, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{"-", "3"}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
              RowBox[{"-", "3"}]}]],
           Annotation[#, {1, 2} -> -3, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox[
            SuperscriptBox[
             RowBox[{
              InterpretationBox[
               StyleBox["Sin",
                ShowAutoStyles->False,
                AutoSpacing->False],
               Sin,
               Editable->False], "[", 
              InterpretationBox[
               StyleBox["\[Theta]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Theta][],
               Editable->False], "]"}], "2"],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
              SuperscriptBox[
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"Sin"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], Sin, Editable -> False], "[", 
                 InterpretationBox[
                  StyleBox[
                  "\[Theta]", AutoSpacing -> False, ShowAutoStyles -> 
                   False], 
                  $CellContext`\[Theta][], Editable -> False], "]"}], "2"]}]],
           
           Annotation[#, {2, 1} -> Sin[
               $CellContext`\[Theta][]]^2, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["Sin",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                Sin,
                Editable->False], "[", 
               InterpretationBox[
                StyleBox["\[Theta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Theta][],
                Editable->False], "]"}], "2"]}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
              RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"Sin"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Sin, Editable -> False], "[", 
                   InterpretationBox[
                    StyleBox[
                    "\[Theta]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Theta][], Editable -> False], "]"}], 
                 "2"]}]}]],
           Annotation[#, {2, 2} -> 2 Sin[
                $CellContext`\[Theta][]]^2, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[0, 0, 1], 3 -> RGBColor[0, 0, 1]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {" ", " "},
         {"\[ScriptA]", "\[ScriptB]"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{2, -3}, {Sin[
       $CellContext`\[Theta][]]^2, 2 Sin[
        $CellContext`\[Theta][]]^2}}, {-$CellContext`sph, -$CellContext`sph2},
    0][-$CellContext`\[ScriptA], -$CellContext`\[ScriptB]],
  Editable->False]], "Output",ExpressionUUID->"7bb1052f-3288-4204-89b0-\
deb72f4524bd"]
}, Open  ]],

Cell["\[Bullet] We can extract a sub-CTensor expression:", "Text",ExpressionUUID->"6b887a04-5ec9-45e2-8c4b-817462531d6c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"met", "[", 
  RowBox[{
   RowBox[{"-", "\[ScriptA]"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"-", "sph2"}]}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"27f46a65-97c2-43e1-8c21-474d8e0169ba"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["2",
            RowBox[{
              RowBox[{"{", "1", "}"}], "\[Rule]", "2"}]],
           Annotation[#, {1} -> 2, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox[
            SuperscriptBox[
             RowBox[{
              InterpretationBox[
               StyleBox["Sin",
                ShowAutoStyles->False,
                AutoSpacing->False],
               Sin,
               Editable->False], "[", 
              InterpretationBox[
               StyleBox["\[Theta]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Theta][],
               Editable->False], "]"}], "2"],
            RowBox[{
              RowBox[{"{", "2", "}"}], "\[Rule]", 
              SuperscriptBox[
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"Sin"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], Sin, Editable -> False], "[", 
                 InterpretationBox[
                  StyleBox[
                  "\[Theta]", AutoSpacing -> False, ShowAutoStyles -> 
                   False], 
                  $CellContext`\[Theta][], Editable -> False], "]"}], "2"]}]],
           
           Annotation[#, {2} -> Sin[
               $CellContext`\[Theta][]]^2, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {
           1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {" "},
         {"\[ScriptA]"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{2, Sin[
      $CellContext`\[Theta][]]^2}, {-$CellContext`sph}, 
   0][-$CellContext`\[ScriptA]],
  Editable->False]], "Output",ExpressionUUID->"703fa52b-361b-458b-809c-\
93e462fb4508"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"met", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"-", "sph"}]}], "}"}], ",", 
   RowBox[{"-", "\[ScriptA]"}]}], "]"}]], "Input",ExpressionUUID->"91a1c69b-\
7f8b-4df4-b4eb-97ae1c864ac7"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", "1", "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox[
            SuperscriptBox[
             RowBox[{
              InterpretationBox[
               StyleBox["Sin",
                ShowAutoStyles->False,
                AutoSpacing->False],
               Sin,
               Editable->False], "[", 
              InterpretationBox[
               StyleBox["\[Theta]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Theta][],
               Editable->False], "]"}], "2"],
            RowBox[{
              RowBox[{"{", "2", "}"}], "\[Rule]", 
              SuperscriptBox[
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"Sin"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], Sin, Editable -> False], "[", 
                 InterpretationBox[
                  StyleBox[
                  "\[Theta]", AutoSpacing -> False, ShowAutoStyles -> 
                   False], 
                  $CellContext`\[Theta][], Editable -> False], "]"}], "2"]}]],
           
           Annotation[#, {2} -> Sin[
               $CellContext`\[Theta][]]^2, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {
           1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {" "},
         {"\[ScriptA]"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{0, Sin[
      $CellContext`\[Theta][]]^2}, {-$CellContext`sph}, 
   0][-$CellContext`\[ScriptA]],
  Editable->False]], "Output",ExpressionUUID->"a34f8641-42cf-492c-a011-\
f591dd9b3a98"]
}, Open  ]],

Cell["\<\
\[Bullet] Using b-indices will produce an expansion into basis objects:\
\>", "Text",ExpressionUUID->"92d03bdb-878c-49a4-8b0a-b433c611bb96"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"met", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\[ScriptA]", ",", 
     RowBox[{"-", "sph"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\[ScriptB]", ",", 
     RowBox[{"-", "sph"}]}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"6ed971af-6d5b-4a07-bd41-05fbd35479c2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"e", 
        StyleBox[GridBox[{
           {" ", 
            StyleBox["1",
             FontColor->RGBColor[1., 0., 0.]]},
           {
            StyleBox["\[ScriptA]",
             FontColor->RGBColor[1., 0., 0.]], " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Basis[{$CellContext`\[ScriptA], -$CellContext`sph}, {
     1, $CellContext`sph}],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"e", 
        StyleBox[GridBox[{
           {" ", 
            StyleBox["1",
             FontColor->RGBColor[1., 0., 0.]]},
           {
            StyleBox["\[ScriptB]",
             FontColor->RGBColor[1., 0., 0.]], " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Basis[{$CellContext`\[ScriptB], -$CellContext`sph}, {
     1, $CellContext`sph}],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"e", 
        StyleBox[GridBox[{
           {" ", 
            StyleBox["2",
             FontColor->RGBColor[1., 0., 0.]]},
           {
            StyleBox["\[ScriptA]",
             FontColor->RGBColor[1., 0., 0.]], " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Basis[{$CellContext`\[ScriptA], -$CellContext`sph}, {
     2, $CellContext`sph}],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"e", 
        StyleBox[GridBox[{
           {" ", 
            StyleBox["2",
             FontColor->RGBColor[1., 0., 0.]]},
           {
            StyleBox["\[ScriptB]",
             FontColor->RGBColor[1., 0., 0.]], " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Basis[{$CellContext`\[ScriptB], -$CellContext`sph}, {
     2, $CellContext`sph}],
    Editable->False], " ", 
   SuperscriptBox[
    RowBox[{
     InterpretationBox[
      StyleBox["Sin",
       ShowAutoStyles->False,
       AutoSpacing->False],
      Sin,
      Editable->False], "[", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False], "]"}], "2"]}]}]], "Output",ExpressionUUID->"6d49f7ca-\
0913-4d6f-9db7-c1f6555d5aeb"]
}, Open  ]],

Cell["\<\
\[Bullet] The same result can be obtained directly from the abstract-index \
expression using the following syntax:\
\>", "Text",ExpressionUUID->"6088bd8b-9f79-46d9-9f4d-e1e836dd3cea"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"met", "[", 
  RowBox[{
   RowBox[{"-", "\[ScriptA]"}], ",", 
   RowBox[{"-", "\[ScriptB]"}]}], "]"}]], "Input",ExpressionUUID->"1ec7a26d-\
21e9-4930-ba91-47e42c9cf77e"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["1",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", "1"}]],
           Annotation[#, {1, 1} -> 1, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 2} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            SuperscriptBox[
             RowBox[{
              InterpretationBox[
               StyleBox["Sin",
                ShowAutoStyles->False,
                AutoSpacing->False],
               Sin,
               Editable->False], "[", 
              InterpretationBox[
               StyleBox["\[Theta]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Theta][],
               Editable->False], "]"}], "2"],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
              SuperscriptBox[
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"Sin"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], Sin, Editable -> False], "[", 
                 InterpretationBox[
                  StyleBox[
                  "\[Theta]", AutoSpacing -> False, ShowAutoStyles -> 
                   False], 
                  $CellContext`\[Theta][], Editable -> False], "]"}], "2"]}]],
           
           Annotation[#, {2, 2} -> Sin[
               $CellContext`\[Theta][]]^2, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {" ", " "},
         {"\[ScriptA]", "\[ScriptB]"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{1, 0}, {0, Sin[
       $CellContext`\[Theta][]]^2}}, {-$CellContext`sph, -$CellContext`sph}, 
   0][-$CellContext`\[ScriptA], -$CellContext`\[ScriptB]],
  Editable->False]], "Output",ExpressionUUID->"73696d69-fa89-48d8-9042-\
f56c7ce7d7fe"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", "ToBasisExpand"}]], "Input",ExpressionUUID->"b0419eaf-c192-4a52-bd17-dbd7d702b174"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"e", 
        StyleBox[GridBox[{
           {" ", 
            StyleBox["1",
             FontColor->RGBColor[1., 0., 0.]]},
           {"\[ScriptA]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Basis[-$CellContext`\[ScriptA], {1, $CellContext`sph}],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"e", 
        StyleBox[GridBox[{
           {" ", 
            StyleBox["1",
             FontColor->RGBColor[1., 0., 0.]]},
           {"\[ScriptB]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Basis[-$CellContext`\[ScriptB], {1, $CellContext`sph}],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"e", 
        StyleBox[GridBox[{
           {" ", 
            StyleBox["2",
             FontColor->RGBColor[1., 0., 0.]]},
           {"\[ScriptA]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Basis[-$CellContext`\[ScriptA], {2, $CellContext`sph}],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"e", 
        StyleBox[GridBox[{
           {" ", 
            StyleBox["2",
             FontColor->RGBColor[1., 0., 0.]]},
           {"\[ScriptB]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Basis[-$CellContext`\[ScriptB], {2, $CellContext`sph}],
    Editable->False], " ", 
   SuperscriptBox[
    RowBox[{
     InterpretationBox[
      StyleBox["Sin",
       ShowAutoStyles->False,
       AutoSpacing->False],
      Sin,
      Editable->False], "[", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False], "]"}], "2"]}]}]], "Output",ExpressionUUID->"45159ae7-\
f12b-4c35-a8fc-afc23585379a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FromBasisExpand", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "sph"}], ",", 
     RowBox[{"-", "sph"}]}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"f697863b-4547-4160-b986-3dc48a3abdea"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["1",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", "1"}]],
           Annotation[#, {1, 1} -> 1, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 2} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            SuperscriptBox[
             RowBox[{
              InterpretationBox[
               StyleBox["Sin",
                ShowAutoStyles->False,
                AutoSpacing->False],
               Sin,
               Editable->False], "[", 
              InterpretationBox[
               StyleBox["\[Theta]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Theta][],
               Editable->False], "]"}], "2"],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
              SuperscriptBox[
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"Sin"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], Sin, Editable -> False], "[", 
                 InterpretationBox[
                  StyleBox[
                  "\[Theta]", AutoSpacing -> False, ShowAutoStyles -> 
                   False], 
                  $CellContext`\[Theta][], Editable -> False], "]"}], "2"]}]],
           
           Annotation[#, {2, 2} -> Sin[
               $CellContext`\[Theta][]]^2, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {" ", " "},
         {"\[ScriptA]", "\[ScriptB]"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{1, 0}, {0, Sin[
       $CellContext`\[Theta][]]^2}}, {-$CellContext`sph, -$CellContext`sph}, 
   0][-$CellContext`\[ScriptA], -$CellContext`\[ScriptB]],
  Editable->False]], "Output",ExpressionUUID->"c7374a5f-f193-426e-90e2-\
df6c67de4629"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["2.7. Cleanup", "Subsubsection",ExpressionUUID->"e796c820-b2e7-4048-94bd-7839eb847cda"],

Cell["Undefine S2:", "Text",ExpressionUUID->"b8aebb3b-74f5-4d35-87b3-414dfd6c09c4"],

Cell[BoxData[
 RowBox[{"UndefBasis", "[", "sph2", "]"}]], "Input",ExpressionUUID->"f9688776-b262-4194-b958-fc229e57edd2"],

Cell[BoxData[
 RowBox[{"UndefChart", "[", "sph", "]"}]], "Input",ExpressionUUID->"c09b74e7-8885-45a4-8254-e2dc9b70379d"],

Cell[BoxData[
 RowBox[{"UndefTensor", "[", "S", "]"}]], "Input",ExpressionUUID->"cbf1f5f1-2be0-4ee4-b170-d7a9896ba713"],

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "S2", "]"}]], "Input",ExpressionUUID->"f9d53db7-aecb-434f-871c-a1dffb3889c8"],

Cell["Undefine M:", "Text",ExpressionUUID->"0333e380-a8d6-4363-9711-57647c2477d3"],

Cell[BoxData[
 RowBox[{"UndefBasis", "[", "B", "]"}]], "Input",ExpressionUUID->"8e0e8fed-e07b-4906-a56c-48d60edb9482"],

Cell[BoxData[
 RowBox[{"UndefTensor", "[", "s", "]"}]], "Input",ExpressionUUID->"28088fc1-93f3-4dcf-8cce-b999748d6246"],

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M", "]"}]], "Input",ExpressionUUID->"d2501bbf-9e0b-42ac-b089-6e22080b8da2"],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{
  "A", ",", "T", ",", "v", ",", "V", ",", "w", ",", "met", ",", "imet"}], 
  "]"}]], "Input",ExpressionUUID->"217251f7-ea44-40eb-bd07-e992a0a7f0d8"],

Cell[BoxData[
 RowBox[{"ClearxCobaCache", "[", "All", "]"}]], "Input",ExpressionUUID->"419eeed8-f504-4d47-afdf-7231766f85e5"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["3. Covariant derivatives", "Subsection",ExpressionUUID->"01eb46be-cc7d-41d9-a962-2fdbfa12545b"],

Cell[CellGroupData[{

Cell["3.1. CCovD expressions", "Subsubsection",ExpressionUUID->"af240dda-201d-49bc-a7de-259bac6fe361"],

Cell["\<\
The key idea is to represent a covariant derivative as another connection \
plus a Christoffel CTensor expressing the relation between those two. \
Optionally, we can also specify a metric CTensor, in case the connection is \
associated to it.\
\>", "Text",ExpressionUUID->"3791cb2b-a55e-4151-8a3b-c9cd4b2837e9"],

Cell["\[Bullet] Define polar coordinates on the 2-plane:", "Text",ExpressionUUID->"6ccc7ba7-5bc5-4e81-9116-3159adf6bc08"],

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"E2", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"a12e1e89-3791-4a9e-91f6-8101471c0521"],

Cell[BoxData[
 RowBox[{"DefChart", "[", 
  RowBox[{"polar", ",", "E2", ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"r", "[", "]"}], ",", 
     RowBox[{"\[Theta]", "[", "]"}]}], "}"}]}], "]"}]], "Input",ExpressionUUID\
->"bd98b2af-94d4-4fd4-b9d7-d9ff70807e8c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"met", "=", 
  RowBox[{"CTensor", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", 
        RowBox[{
         RowBox[{"r", "[", "]"}], "^", "2"}]}], "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "polar"}], ",", 
      RowBox[{"-", "polar"}]}], "}"}]}], "]"}]}]], "Input",ExpressionUUID->\
"8e4644aa-30e8-4cb1-82dc-f256997c56d7"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], "2"]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "polar"}], ",", 
     RowBox[{"-", "polar"}]}], "}"}], ",", "0"}], "]"}]], "Output",ExpressionU\
UID->"408edab3-7b79-467e-9468-9861eda66697"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"SetCMetric", "[", 
  RowBox[{"met", ",", "polar", ",", 
   RowBox[{"SignatureOfMetric", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"2", ",", "0", ",", "0"}], "}"}]}]}], "]"}]], "Input",ExpressionU\
UID->"0ec11f19-2d03-4482-b2e6-047b07c4258e"],

Cell["\<\
\[Bullet] This is the Levi-Civita connection of the metric. We see it has \
three arguments: the derivative of the coordinate basis, a Christoffel tensor \
and the metric itself.\
\>", "Text",ExpressionUUID->"a16a3aa6-2c85-42d0-99fc-e999c317acf0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"cd", "=", 
  RowBox[{"CovDOfMetric", "[", "met", "]"}]}]], "Input",ExpressionUUID->\
"4ff8b86d-ea47-41f8-bd8b-c5b8a063af55"],

Cell[BoxData[
 RowBox[{"CCovD", "[", 
  RowBox[{"PDpolar", ",", 
   RowBox[{"CTensor", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"-", 
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False]}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", 
           FractionBox["1", 
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False]]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox["1", 
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False]], ",", "0"}], "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"polar", ",", 
       RowBox[{"-", "polar"}], ",", 
       RowBox[{"-", "polar"}]}], "}"}], ",", "0"}], "]"}], ",", 
   RowBox[{"CTensor", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], "2"]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "polar"}], ",", 
       RowBox[{"-", "polar"}]}], "}"}], ",", "0"}], "]"}]}], "]"}]], "Output",\
ExpressionUUID->"d89de0e3-eafd-4dfc-ade1-5a0d88811521"]
}, Open  ]],

Cell["\<\
\[Bullet] This derivative operator can be now used normally to perform \
operations:\
\>", "Text",ExpressionUUID->"569d1a70-1912-4a6c-a81a-3a83f048647e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"cd", "[", 
   RowBox[{"-", "a"}], "]"}], "[", 
  RowBox[{
   RowBox[{"r", "[", "]"}], "^", "3"}], "]"}]], "Input",ExpressionUUID->\
"d95bdbaf-4c48-4e06-9556-73a59194d2d3"],

Cell[BoxData[
 RowBox[{"3", " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"e", 
       StyleBox[GridBox[{
          {" ", 
           StyleBox["1",
            FontColor->RGBColor[1., 0., 0.]]},
          {"a", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`Basis[-$CellContext`a, {1, $CellContext`polar}],
   Editable->False], " ", 
  SuperscriptBox[
   InterpretationBox[
    StyleBox["r",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`r[],
    Editable->False], "2"]}]], "Output",ExpressionUUID->"5a41f271-0e04-45d9-\
833d-69b02eb29fd0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"cd", "[", 
   RowBox[{"-", "a"}], "]"}], "[", 
  RowBox[{
   RowBox[{"CTensor", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", "polar", "}"}]}], "]"}], "[", "b", "]"}], "]"}]], "Input",Ex\
pressionUUID->"9795aa24-02e0-491d-8f23-020b1dc8a141"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 2} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            FractionBox["1", 
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False]],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
              FractionBox["1", 
               InterpretationBox[
                StyleBox[
                "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                $CellContext`r[], Editable -> False]]}]],
           Annotation[#, {2, 2} -> $CellContext`r[]^(-1), "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {"b", " "},
         {" ", "a"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{0, 0}, {
    0, $CellContext`r[]^(-1)}}, {$CellContext`polar, -$CellContext`polar}, 
   0][$CellContext`b, -$CellContext`a],
  Editable->False]], "Output",ExpressionUUID->"ddaa6d15-e0a2-4938-aaed-\
8a72b185e0da"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"cd", "[", 
   RowBox[{"-", "a"}], "]"}], "[", 
  RowBox[{"met", "[", 
   RowBox[{
    RowBox[{"-", "b"}], ",", 
    RowBox[{"-", "c"}]}], "]"}], "]"}]], "Input",ExpressionUUID->"1286ab42-\
8f18-438d-b3f7-c2f49c0ba70c"],

Cell[BoxData["0"], "Output",ExpressionUUID->"56f206b2-5c24-4746-abd8-de0cfd084d40"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"cd", "[", 
   RowBox[{"-", "a"}], "]"}], "@", 
  RowBox[{
   RowBox[{"cd", "[", 
    RowBox[{"-", "b"}], "]"}], "@", 
   RowBox[{
    RowBox[{"CTensor", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", 
        RowBox[{"r", "[", "]"}]}], "}"}], ",", 
      RowBox[{"{", "polar", "}"}]}], "]"}], "[", "c", "]"}]}]}]], "Input",Expr\
essionUUID->"a3db7985-9892-47ab-9c9a-a092b9bd5000"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{"-", 
                   InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}]}]],
              Annotation[#, {1, 1, 2} -> -$CellContext`r[], "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{"-", 
                   InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}]}]],
              Annotation[#, {1, 2, 1} -> -$CellContext`r[], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
         {GridBox[{
            {
             TagBox[
              TooltipBox[
               FractionBox["2", 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                 FractionBox["2", 
                  InterpretationBox[
                   StyleBox[
                   "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`r[], Editable -> False]]}]],
              Annotation[#, {2, 1, 1} -> 2/$CellContext`r[], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 1} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                 InterpretationBox[
                  StyleBox[
                  "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`r[], Editable -> False]}]],
              Annotation[#, {2, 2, 2} -> $CellContext`r[], "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {"c", " ", " "},
         {" ", "b", "a"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{{0, -$CellContext`r[]}, {-$CellContext`r[], 0}}, {{
     2/$CellContext`r[], 0}, {0, 
      $CellContext`r[]}}}, {$CellContext`polar, -$CellContext`polar, \
-$CellContext`polar}, 0][$CellContext`c, -$CellContext`b, -$CellContext`a],
  Editable->False]], "Output",ExpressionUUID->"f3e887c6-385a-4926-ab81-\
1e17d1b21ffa"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", "ToCCanonical"}]], "Input",ExpressionUUID->"47d79c10-c7fc-461a-bb1b-99ff92cda64c"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               FractionBox["2", 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                 FractionBox["2", 
                  InterpretationBox[
                   StyleBox[
                   "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`r[], Editable -> False]]}]],
              Annotation[#, {1, 1, 2} -> 2/$CellContext`r[], "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{"-", 
                   InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}]}]],
              Annotation[#, {1, 2, 1} -> -$CellContext`r[], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
         {GridBox[{
            {
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{"-", 
                   InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}]}]],
              Annotation[#, {2, 1, 1} -> -$CellContext`r[], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 1} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                 InterpretationBox[
                  StyleBox[
                  "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`r[], Editable -> False]}]],
              Annotation[#, {2, 2, 2} -> $CellContext`r[], "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {" ", " ", "c"},
         {"a", "b", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{{
     0, 2/$CellContext`r[]}, {-$CellContext`r[], 0}}, {{-$CellContext`r[], 
      0}, {0, 
      $CellContext`r[]}}}, {-$CellContext`polar, -$CellContext`polar, \
$CellContext`polar}, 0][-$CellContext`a, -$CellContext`b, $CellContext`c],
  Editable->False]], "Output",ExpressionUUID->"b9f42090-7eb2-45d9-8dea-\
53f54e103084"]
}, Open  ]],

Cell["\<\
\[Bullet] CCovD derivatives are typeset with the \[Gradient] character, and \
have a tooltip:\
\>", "Text",ExpressionUUID->"c5c7ea12-c089-4112-8217-d68514879655"],

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"v", "[", "a", "]"}], ",", "E2"}], "]"}]], "Input",ExpressionUUID->\
"c99594c9-e9a4-4dae-94cd-ec641b0e6f9f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"cd", "[", 
   RowBox[{"-", "a"}], "]"}], "[", 
  RowBox[{"v", "[", "b", "]"}], "]"}]], "Input",ExpressionUUID->"06c1890a-\
f2ef-4f4d-ba26-d3dd0d48016e"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    SubscriptBox[
     TooltipBox["\[Gradient]",
      RowBox[{"CCovD", "[", "PDpolar", ",", 
        StyleBox[
         GridBox[{{
            GridBox[{{
               TagBox[
                TooltipBox["0", 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                   "0"}]], Annotation[#, {1, 1, 1} -> 0, "Tooltip"]& ]}, {
               TagBox[
                TooltipBox["0", 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                   "0"}]], Annotation[#, {1, 1, 2} -> 0, "Tooltip"]& ]}}, 
             AutoDelete -> False, 
             GridBoxDividers -> {
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], 
            GridBox[{{
               TagBox[
                TooltipBox["0", 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                   "0"}]], Annotation[#, {1, 2, 1} -> 0, "Tooltip"]& ]}, {
               TagBox[
                TooltipBox[
                 RowBox[{"-", 
                   InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                   RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}]}]], 
                Annotation[#, {1, 2, 2} -> -$CellContext`r[], "Tooltip"]& ]}},
              AutoDelete -> False, 
             GridBoxDividers -> {
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}, {
            GridBox[{{
               TagBox[
                TooltipBox["0", 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                   "0"}]], Annotation[#, {2, 1, 1} -> 0, "Tooltip"]& ]}, {
               TagBox[
                TooltipBox[
                 FractionBox["1", 
                  InterpretationBox[
                   StyleBox[
                   "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`r[], Editable -> False]], 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                   FractionBox["1", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]]}]], 
                Annotation[#, {2, 1, 2} -> $CellContext`r[]^(-1), 
                 "Tooltip"]& ]}}, AutoDelete -> False, 
             GridBoxDividers -> {
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], 
            GridBox[{{
               TagBox[
                TooltipBox[
                 FractionBox["1", 
                  InterpretationBox[
                   StyleBox[
                   "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`r[], Editable -> False]], 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                   FractionBox["1", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]]}]], 
                Annotation[#, {2, 2, 1} -> $CellContext`r[]^(-1), 
                 "Tooltip"]& ]}, {
               TagBox[
                TooltipBox["0", 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                   "0"}]], Annotation[#, {2, 2, 2} -> 0, "Tooltip"]& ]}}, 
             AutoDelete -> False, 
             GridBoxDividers -> {
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}}, 
          AutoDelete -> False, 
          GridBoxDividers -> {
           "ColumnsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
            "RowsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], Small], ",", 
        StyleBox[
         GridBox[{{
            TagBox[
             TooltipBox["1", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", "1"}]], 
             Annotation[#, {1, 1} -> 1, "Tooltip"]& ], 
            TagBox[
             TooltipBox["0", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", "0"}]], 
             Annotation[#, {1, 2} -> 0, "Tooltip"]& ]}, {
            TagBox[
             TooltipBox["0", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", "0"}]], 
             Annotation[#, {2, 1} -> 0, "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              SuperscriptBox[
               InterpretationBox[
                StyleBox[
                "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                $CellContext`r[], Editable -> False], "2"], 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox[
                  "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`r[], Editable -> False], "2"]}]], 
             Annotation[#, {2, 2} -> $CellContext`r[]^2, "Tooltip"]& ]}}, 
          AutoDelete -> False, 
          GridBoxDividers -> {
           "ColumnsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
            "RowsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], Small], 
        "]"}]], "a"], GridBox[{
      {"v", 
       StyleBox[GridBox[{
          {"b"},
          {" "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CCovD[$CellContext`PDpolar, 
   xAct`xCoba`CTensor[{{{0, 0}, {0, -$CellContext`r[]}}, {{
      0, $CellContext`r[]^(-1)}, {$CellContext`r[]^(-1), 
       0}}}, {$CellContext`polar, -$CellContext`polar, -$CellContext`polar}, 
    0], 
   xAct`xCoba`CTensor[{{1, 0}, {
     0, $CellContext`r[]^2}}, {-$CellContext`polar, -$CellContext`polar}, 
    0]][-$CellContext`a][
   $CellContext`v[$CellContext`b]],
  Editable->False]], "Output",ExpressionUUID->"3cd7390c-5e64-4cf2-8a0e-\
e2b2b8c608f0"]
}, Open  ]],

Cell["\<\
\[Bullet] Expansion is not automatic, as usual in xTensor, and must be asked \
for explicitly:\
\>", "Text",ExpressionUUID->"567382f4-4d0a-4d0f-9106-3da6f2d1b362"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ChangeCovD", "[", 
  RowBox[{"%", ",", "cd", ",", "PDpolar"}], "]"}]], "Input",ExpressionUUID->\
"6759677b-628f-41b7-97fb-e8baceacb41b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"c"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[$CellContext`c],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox[GridBox[{
           {GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {1, 1, 1} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {1, 1, 2} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {1, 2, 1} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox[
                 RowBox[{"-", 
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False]}],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                   RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}]}]],
                Annotation[#, {1, 2, 2} -> -$CellContext`r[], "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
           {GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {2, 1, 1} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox[
                 FractionBox["1", 
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False]],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                   FractionBox["1", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]]}]],
                
                Annotation[#, {2, 1, 2} -> $CellContext`r[]^(-1), 
                 "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox[
                 FractionBox["1", 
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False]],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                   FractionBox["1", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]]}]],
                
                Annotation[#, {2, 2, 1} -> $CellContext`r[]^(-1), 
                 "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {2, 2, 2} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
          },
          AutoDelete->False,
          
          GridBoxDividers->{
           "ColumnsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
            "RowsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
         FontSize->Small], 
        StyleBox[GridBox[{
           {"b", " ", " "},
           {" ", "a", "c"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xCoba`CTensor[{{{0, 0}, {0, -$CellContext`r[]}}, {{
       0, $CellContext`r[]^(-1)}, {$CellContext`r[]^(-1), 
        0}}}, {$CellContext`polar, -$CellContext`polar, -$CellContext`polar}, 
     0][$CellContext`b, -$CellContext`a, -$CellContext`c],
    Editable->False]}], "+", 
  InterpretationBox[
   StyleBox[
    RowBox[{
     SubscriptBox[
      StyleBox["\[ScriptCapitalD]",
       FontColor->RGBColor[1., 0., 0.]], "a"], GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"b"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`PDpolar[-$CellContext`a][
    $CellContext`v[$CellContext`b]],
   Editable->False]}]], "Output",ExpressionUUID->"07aea66f-a701-4db1-8e26-\
e52ebaad5e89"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ChangeCovD", "[", 
  RowBox[{"%", ",", "PDpolar", ",", "cd"}], "]"}]], "Input",ExpressionUUID->\
"8df43f75-5a10-4b2d-806c-f457bf7df670"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"c"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[$CellContext`c],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox[GridBox[{
           {GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {1, 1, 1} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {1, 1, 2} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {1, 2, 1} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox[
                 RowBox[{"-", 
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False]}],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                   RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}]}]],
                Annotation[#, {1, 2, 2} -> -$CellContext`r[], "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
           {GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {2, 1, 1} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox[
                 FractionBox["1", 
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False]],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                   FractionBox["1", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]]}]],
                
                Annotation[#, {2, 1, 2} -> $CellContext`r[]^(-1), 
                 "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox[
                 FractionBox["1", 
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False]],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                   FractionBox["1", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]]}]],
                
                Annotation[#, {2, 2, 1} -> $CellContext`r[]^(-1), 
                 "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {2, 2, 2} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
          },
          AutoDelete->False,
          
          GridBoxDividers->{
           "ColumnsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
            "RowsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
         FontSize->Small], 
        StyleBox[GridBox[{
           {"b", " ", " "},
           {" ", "a", "c"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xCoba`CTensor[{{{0, 0}, {0, -$CellContext`r[]}}, {{
       0, $CellContext`r[]^(-1)}, {$CellContext`r[]^(-1), 
        0}}}, {$CellContext`polar, -$CellContext`polar, -$CellContext`polar}, 
     0][$CellContext`b, -$CellContext`a, -$CellContext`c],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"c"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[$CellContext`c],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox[GridBox[{
           {GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {1, 1, 1} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {1, 1, 2} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {1, 2, 1} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                   InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}]],
                Annotation[#, {1, 2, 2} -> $CellContext`r[], "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
           {GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {2, 1, 1} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox[
                 RowBox[{"-", 
                  FractionBox["1", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]]}],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                   RowBox[{"-", 
                    FractionBox["1", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]]}]}]],
                
                Annotation[#, {2, 1, 2} -> (-1)/$CellContext`r[], 
                 "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox[
                 RowBox[{"-", 
                  FractionBox["1", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]]}],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                   RowBox[{"-", 
                    FractionBox["1", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]]}]}]],
                
                Annotation[#, {2, 2, 1} -> (-1)/$CellContext`r[], 
                 "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {2, 2, 2} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
          },
          AutoDelete->False,
          
          GridBoxDividers->{
           "ColumnsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
            "RowsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
         FontSize->Small], 
        StyleBox[GridBox[{
           {"b", " ", " "},
           {" ", "a", "c"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xCoba`CTensor[{{{0, 0}, {0, 
        $CellContext`r[]}}, {{
       0, (-1)/$CellContext`r[]}, {(-1)/$CellContext`r[], 
        0}}}, {$CellContext`polar, -$CellContext`polar, -$CellContext`polar}, 
     0][$CellContext`b, -$CellContext`a, -$CellContext`c],
    Editable->False]}], "+", 
  InterpretationBox[
   StyleBox[
    RowBox[{
     SubscriptBox[
      TooltipBox["\[Gradient]",
       RowBox[{"CCovD", "[", "PDpolar", ",", 
         StyleBox[
          GridBox[{{
             GridBox[{{
                TagBox[
                 TooltipBox["0", 
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    "0"}]], Annotation[#, {1, 1, 1} -> 0, "Tooltip"]& ]}, {
                TagBox[
                 TooltipBox["0", 
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    "0"}]], Annotation[#, {1, 1, 2} -> 0, "Tooltip"]& ]}}, 
              AutoDelete -> False, 
              GridBoxDividers -> {
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], 
             GridBox[{{
                TagBox[
                 TooltipBox["0", 
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    "0"}]], Annotation[#, {1, 2, 1} -> 0, "Tooltip"]& ]}, {
                TagBox[
                 TooltipBox[
                  RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], 
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}]}]], 
                 Annotation[#, {1, 2, 2} -> -$CellContext`r[], 
                  "Tooltip"]& ]}}, AutoDelete -> False, 
              GridBoxDividers -> {
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}, {
             GridBox[{{
                TagBox[
                 TooltipBox["0", 
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    "0"}]], Annotation[#, {2, 1, 1} -> 0, "Tooltip"]& ]}, {
                TagBox[
                 TooltipBox[
                  FractionBox["1", 
                   InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]], 
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox["1", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]]}]], 
                 Annotation[#, {2, 1, 2} -> $CellContext`r[]^(-1), 
                  "Tooltip"]& ]}}, AutoDelete -> False, 
              GridBoxDividers -> {
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], 
             GridBox[{{
                TagBox[
                 TooltipBox[
                  FractionBox["1", 
                   InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]], 
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox["1", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]]}]], 
                 Annotation[#, {2, 2, 1} -> $CellContext`r[]^(-1), 
                  "Tooltip"]& ]}, {
                TagBox[
                 TooltipBox["0", 
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    "0"}]], Annotation[#, {2, 2, 2} -> 0, "Tooltip"]& ]}}, 
              AutoDelete -> False, 
              GridBoxDividers -> {
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}}, 
           AutoDelete -> False, 
           GridBoxDividers -> {
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], Small], ",", 
         
         StyleBox[
          GridBox[{{
             TagBox[
              TooltipBox["1", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", "1"}]], 
              Annotation[#, {1, 1} -> 1, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", "0"}]], 
              Annotation[#, {1, 2} -> 0, "Tooltip"]& ]}, {
             TagBox[
              TooltipBox["0", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", "0"}]], 
              Annotation[#, {2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["r", AutoSpacing -> False, ShowAutoStyles -> False], 
                 $CellContext`r[], Editable -> False], "2"], 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox[
                   "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`r[], Editable -> False], "2"]}]], 
              Annotation[#, {2, 2} -> $CellContext`r[]^2, "Tooltip"]& ]}}, 
           AutoDelete -> False, 
           GridBoxDividers -> {
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], Small], 
         "]"}]], "a"], GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"b"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xCoba`CCovD[$CellContext`PDpolar, 
    xAct`xCoba`CTensor[{{{0, 0}, {0, -$CellContext`r[]}}, {{
       0, $CellContext`r[]^(-1)}, {$CellContext`r[]^(-1), 
        0}}}, {$CellContext`polar, -$CellContext`polar, -$CellContext`polar}, 
     0], 
    xAct`xCoba`CTensor[{{1, 0}, {
      0, $CellContext`r[]^2}}, {-$CellContext`polar, -$CellContext`polar}, 
     0]][-$CellContext`a][
    $CellContext`v[$CellContext`b]],
   Editable->False]}]], "Output",ExpressionUUID->"16e1ead9-f02d-4ba3-b120-\
423d4883c6f8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", "ToCanonical"}]], "Input",ExpressionUUID->"b5959255-2fbe-49c3-8a5c-0e210617ece3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"c"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[$CellContext`c],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox[GridBox[{
           {GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {1, 1, 1} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {1, 1, 2} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {1, 2, 1} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox[
                 RowBox[{"-", 
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False]}],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                   RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}]}]],
                Annotation[#, {1, 2, 2} -> -$CellContext`r[], "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
           {GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {2, 1, 1} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox[
                 FractionBox["1", 
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False]],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                   FractionBox["1", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]]}]],
                
                Annotation[#, {2, 1, 2} -> $CellContext`r[]^(-1), 
                 "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox[
                 FractionBox["1", 
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False]],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                   FractionBox["1", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]]}]],
                
                Annotation[#, {2, 2, 1} -> $CellContext`r[]^(-1), 
                 "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {2, 2, 2} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
          },
          AutoDelete->False,
          
          GridBoxDividers->{
           "ColumnsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
            "RowsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
         FontSize->Small], 
        StyleBox[GridBox[{
           {"b", " ", " "},
           {" ", "a", "c"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xCoba`CTensor[{{{0, 0}, {0, -$CellContext`r[]}}, {{
       0, $CellContext`r[]^(-1)}, {$CellContext`r[]^(-1), 
        0}}}, {$CellContext`polar, -$CellContext`polar, -$CellContext`polar}, 
     0][$CellContext`b, -$CellContext`a, -$CellContext`c],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"c"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[$CellContext`c],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox[GridBox[{
           {GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {1, 1, 1} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {1, 1, 2} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {1, 2, 1} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                   InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}]],
                Annotation[#, {1, 2, 2} -> $CellContext`r[], "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
           {GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {2, 1, 1} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox[
                 RowBox[{"-", 
                  FractionBox["1", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]]}],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                   RowBox[{"-", 
                    FractionBox["1", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]]}]}]],
                
                Annotation[#, {2, 1, 2} -> (-1)/$CellContext`r[], 
                 "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox[
                 RowBox[{"-", 
                  FractionBox["1", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]]}],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                   RowBox[{"-", 
                    FractionBox["1", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]]}]}]],
                
                Annotation[#, {2, 2, 1} -> (-1)/$CellContext`r[], 
                 "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {2, 2, 2} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
          },
          AutoDelete->False,
          
          GridBoxDividers->{
           "ColumnsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
            "RowsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
         FontSize->Small], 
        StyleBox[GridBox[{
           {"b", " ", " "},
           {" ", "a", "c"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xCoba`CTensor[{{{0, 0}, {0, 
        $CellContext`r[]}}, {{
       0, (-1)/$CellContext`r[]}, {(-1)/$CellContext`r[], 
        0}}}, {$CellContext`polar, -$CellContext`polar, -$CellContext`polar}, 
     0][$CellContext`b, -$CellContext`a, -$CellContext`c],
    Editable->False]}], "+", 
  InterpretationBox[
   StyleBox[
    RowBox[{
     SubscriptBox[
      TooltipBox["\[Gradient]",
       RowBox[{"CCovD", "[", "PDpolar", ",", 
         StyleBox[
          GridBox[{{
             GridBox[{{
                TagBox[
                 TooltipBox["0", 
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    "0"}]], Annotation[#, {1, 1, 1} -> 0, "Tooltip"]& ]}, {
                TagBox[
                 TooltipBox["0", 
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    "0"}]], Annotation[#, {1, 1, 2} -> 0, "Tooltip"]& ]}}, 
              AutoDelete -> False, 
              GridBoxDividers -> {
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], 
             GridBox[{{
                TagBox[
                 TooltipBox["0", 
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    "0"}]], Annotation[#, {1, 2, 1} -> 0, "Tooltip"]& ]}, {
                TagBox[
                 TooltipBox[
                  RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], 
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}]}]], 
                 Annotation[#, {1, 2, 2} -> -$CellContext`r[], 
                  "Tooltip"]& ]}}, AutoDelete -> False, 
              GridBoxDividers -> {
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}, {
             GridBox[{{
                TagBox[
                 TooltipBox["0", 
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    "0"}]], Annotation[#, {2, 1, 1} -> 0, "Tooltip"]& ]}, {
                TagBox[
                 TooltipBox[
                  FractionBox["1", 
                   InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]], 
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox["1", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]]}]], 
                 Annotation[#, {2, 1, 2} -> $CellContext`r[]^(-1), 
                  "Tooltip"]& ]}}, AutoDelete -> False, 
              GridBoxDividers -> {
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], 
             GridBox[{{
                TagBox[
                 TooltipBox[
                  FractionBox["1", 
                   InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]], 
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox["1", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]]}]], 
                 Annotation[#, {2, 2, 1} -> $CellContext`r[]^(-1), 
                  "Tooltip"]& ]}, {
                TagBox[
                 TooltipBox["0", 
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    "0"}]], Annotation[#, {2, 2, 2} -> 0, "Tooltip"]& ]}}, 
              AutoDelete -> False, 
              GridBoxDividers -> {
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}}, 
           AutoDelete -> False, 
           GridBoxDividers -> {
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], Small], ",", 
         
         StyleBox[
          GridBox[{{
             TagBox[
              TooltipBox["1", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", "1"}]], 
              Annotation[#, {1, 1} -> 1, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", "0"}]], 
              Annotation[#, {1, 2} -> 0, "Tooltip"]& ]}, {
             TagBox[
              TooltipBox["0", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", "0"}]], 
              Annotation[#, {2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["r", AutoSpacing -> False, ShowAutoStyles -> False], 
                 $CellContext`r[], Editable -> False], "2"], 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox[
                   "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`r[], Editable -> False], "2"]}]], 
              Annotation[#, {2, 2} -> $CellContext`r[]^2, "Tooltip"]& ]}}, 
           AutoDelete -> False, 
           GridBoxDividers -> {
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], Small], 
         "]"}]], "a"], GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"b"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xCoba`CCovD[$CellContext`PDpolar, 
    xAct`xCoba`CTensor[{{{0, 0}, {0, -$CellContext`r[]}}, {{
       0, $CellContext`r[]^(-1)}, {$CellContext`r[]^(-1), 
        0}}}, {$CellContext`polar, -$CellContext`polar, -$CellContext`polar}, 
     0], 
    xAct`xCoba`CTensor[{{1, 0}, {
      0, $CellContext`r[]^2}}, {-$CellContext`polar, -$CellContext`polar}, 
     0]][-$CellContext`a][
    $CellContext`v[$CellContext`b]],
   Editable->False]}]], "Output",ExpressionUUID->"50ad733e-83f6-40d1-bde2-\
e87e0f3dbf75"]
}, Open  ]],

Cell["\<\
[This is an interesting problem. The two CTensor expresions should cancel, \
but they don\[CloseCurlyQuote]t (TODO). We need to force them together:]\
\>", "Text",ExpressionUUID->"6e52b122-ca97-48ef-b619-378710544d2f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{"%", ",", "_v", ",", "Simplify"}], "]"}]], "Input",ExpressionUUID->\
"a4d3681b-1919-4b4b-a003-5b734e7b8feb"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    SubscriptBox[
     TooltipBox["\[Gradient]",
      RowBox[{"CCovD", "[", "PDpolar", ",", 
        StyleBox[
         GridBox[{{
            GridBox[{{
               TagBox[
                TooltipBox["0", 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                   "0"}]], Annotation[#, {1, 1, 1} -> 0, "Tooltip"]& ]}, {
               TagBox[
                TooltipBox["0", 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                   "0"}]], Annotation[#, {1, 1, 2} -> 0, "Tooltip"]& ]}}, 
             AutoDelete -> False, 
             GridBoxDividers -> {
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], 
            GridBox[{{
               TagBox[
                TooltipBox["0", 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                   "0"}]], Annotation[#, {1, 2, 1} -> 0, "Tooltip"]& ]}, {
               TagBox[
                TooltipBox[
                 RowBox[{"-", 
                   InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                   RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}]}]], 
                Annotation[#, {1, 2, 2} -> -$CellContext`r[], "Tooltip"]& ]}},
              AutoDelete -> False, 
             GridBoxDividers -> {
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}, {
            GridBox[{{
               TagBox[
                TooltipBox["0", 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                   "0"}]], Annotation[#, {2, 1, 1} -> 0, "Tooltip"]& ]}, {
               TagBox[
                TooltipBox[
                 FractionBox["1", 
                  InterpretationBox[
                   StyleBox[
                   "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`r[], Editable -> False]], 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                   FractionBox["1", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]]}]], 
                Annotation[#, {2, 1, 2} -> $CellContext`r[]^(-1), 
                 "Tooltip"]& ]}}, AutoDelete -> False, 
             GridBoxDividers -> {
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], 
            GridBox[{{
               TagBox[
                TooltipBox[
                 FractionBox["1", 
                  InterpretationBox[
                   StyleBox[
                   "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`r[], Editable -> False]], 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                   FractionBox["1", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]]}]], 
                Annotation[#, {2, 2, 1} -> $CellContext`r[]^(-1), 
                 "Tooltip"]& ]}, {
               TagBox[
                TooltipBox["0", 
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                   "0"}]], Annotation[#, {2, 2, 2} -> 0, "Tooltip"]& ]}}, 
             AutoDelete -> False, 
             GridBoxDividers -> {
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}}, 
          AutoDelete -> False, 
          GridBoxDividers -> {
           "ColumnsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
            "RowsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], Small], ",", 
        StyleBox[
         GridBox[{{
            TagBox[
             TooltipBox["1", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", "1"}]], 
             Annotation[#, {1, 1} -> 1, "Tooltip"]& ], 
            TagBox[
             TooltipBox["0", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", "0"}]], 
             Annotation[#, {1, 2} -> 0, "Tooltip"]& ]}, {
            TagBox[
             TooltipBox["0", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", "0"}]], 
             Annotation[#, {2, 1} -> 0, "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              SuperscriptBox[
               InterpretationBox[
                StyleBox[
                "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                $CellContext`r[], Editable -> False], "2"], 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox[
                  "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`r[], Editable -> False], "2"]}]], 
             Annotation[#, {2, 2} -> $CellContext`r[]^2, "Tooltip"]& ]}}, 
          AutoDelete -> False, 
          GridBoxDividers -> {
           "ColumnsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
            "RowsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], Small], 
        "]"}]], "a"], GridBox[{
      {"v", 
       StyleBox[GridBox[{
          {"b"},
          {" "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CCovD[$CellContext`PDpolar, 
   xAct`xCoba`CTensor[{{{0, 0}, {0, -$CellContext`r[]}}, {{
      0, $CellContext`r[]^(-1)}, {$CellContext`r[]^(-1), 
       0}}}, {$CellContext`polar, -$CellContext`polar, -$CellContext`polar}, 
    0], 
   xAct`xCoba`CTensor[{{1, 0}, {
     0, $CellContext`r[]^2}}, {-$CellContext`polar, -$CellContext`polar}, 
    0]][-$CellContext`a][
   $CellContext`v[$CellContext`b]],
  Editable->False]], "Output",ExpressionUUID->"e8356fd9-5170-4788-b95b-\
dd1ae5c0f558"]
}, Open  ]],

Cell["We can mix abstract and CTensor Christoffels:", "Text",ExpressionUUID->"81884a8e-f186-4cbe-9f62-085bec08b2e6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ChangeCovD", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"cd", "[", 
     RowBox[{"-", "a"}], "]"}], "[", 
    RowBox[{"v", "[", "b", "]"}], "]"}], ",", "cd"}], "]"}]], "Input",Expressi\
onUUID->"1619782b-c208-47f9-928a-a2f9c6921fd2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"c"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`v[$CellContext`c],
    Editable->False], " ", 
   RowBox[{"(", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {
          RowBox[{"\[CapitalGamma]", "[", 
           StyleBox["\[ScriptCapitalD]",
            FontColor->RGBColor[1., 0., 0.]], "]"}], 
          StyleBox[GridBox[{
             {"b", " ", " "},
             {" ", "a", "c"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`ChristoffelPDpolar[$CellContext`b, -$CellContext`a, \
-$CellContext`c],
      Editable->False], "+", 
     InterpretationBox[
      StyleBox[GridBox[{
         {
          StyleBox[GridBox[{
             {GridBox[{
                {
                 TagBox[
                  TooltipBox["0",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    "0"}]],
                  Annotation[#, {1, 1, 1} -> 0, "Tooltip"]& ]},
                {
                 TagBox[
                  TooltipBox["0",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    "0"}]],
                  Annotation[#, {1, 1, 2} -> 0, "Tooltip"]& ]}
               },
               AutoDelete->False,
               
               GridBoxDividers->{
                "ColumnsIndexed" -> {
                  1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], 
              GridBox[{
                {
                 TagBox[
                  TooltipBox["0",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    "0"}]],
                  Annotation[#, {1, 2, 1} -> 0, "Tooltip"]& ]},
                {
                 TagBox[
                  TooltipBox[
                   RowBox[{"-", 
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}],
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    RowBox[{"-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}]}]],
                  
                  Annotation[#, {1, 2, 2} -> -$CellContext`r[], 
                   "Tooltip"]& ]}
               },
               AutoDelete->False,
               
               GridBoxDividers->{
                "ColumnsIndexed" -> {
                  1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
             {GridBox[{
                {
                 TagBox[
                  TooltipBox["0",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    "0"}]],
                  Annotation[#, {2, 1, 1} -> 0, "Tooltip"]& ]},
                {
                 TagBox[
                  TooltipBox[
                   FractionBox["1", 
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]],
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox["1", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]]}]],
                  
                  Annotation[#, {2, 1, 2} -> $CellContext`r[]^(-1), 
                   "Tooltip"]& ]}
               },
               AutoDelete->False,
               
               GridBoxDividers->{
                "ColumnsIndexed" -> {
                  1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], 
              GridBox[{
                {
                 TagBox[
                  TooltipBox[
                   FractionBox["1", 
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]],
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox["1", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]]}]],
                  
                  Annotation[#, {2, 2, 1} -> $CellContext`r[]^(-1), 
                   "Tooltip"]& ]},
                {
                 TagBox[
                  TooltipBox["0",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    "0"}]],
                  Annotation[#, {2, 2, 2} -> 0, "Tooltip"]& ]}
               },
               AutoDelete->False,
               
               GridBoxDividers->{
                "ColumnsIndexed" -> {
                  1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
              "RowsIndexed" -> {
               1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
           FontSize->Small], 
          StyleBox[GridBox[{
             {"b", " ", " "},
             {" ", "a", "c"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                 Offset[0.]}}, "RowsIndexed" -> {}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Center}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xCoba`CTensor[{{{0, 0}, {0, -$CellContext`r[]}}, {{
         0, $CellContext`r[]^(-1)}, {$CellContext`r[]^(-1), 
          0}}}, {$CellContext`polar, -$CellContext`polar, \
-$CellContext`polar}, 0][$CellContext`b, -$CellContext`a, -$CellContext`c],
      Editable->False]}], ")"}]}], "+", 
  InterpretationBox[
   StyleBox[
    RowBox[{
     SubscriptBox["\[PartialD]", "a"], GridBox[{
       {"v", 
        StyleBox[GridBox[{
           {"b"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xTensor`PD[-$CellContext`a][
    $CellContext`v[$CellContext`b]],
   Editable->False]}]], "Output",ExpressionUUID->"5528fdce-e323-4283-a469-\
d0dc2f25ae6f"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["3.2. Torsion and curvature", "Subsubsection",ExpressionUUID->"aa8d0c0f-540a-43bc-9c7b-c5df10eb698d"],

Cell["\<\
\[Bullet] Compute the torsion of the covariant derivative. It is a \
torsion-free derivative:\
\>", "Text",ExpressionUUID->"ddafaf57-fe4f-4663-a991-4a43e6e46f50"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Torsion", "[", "cd", "]"}]], "Input",ExpressionUUID->"9be20c86-9d32-467c-b8bb-b5c72423dbc3"],

Cell[BoxData["Zero"], "Output",ExpressionUUID->"a91a7795-dce9-4b49-a814-226a79f2efb6"]
}, Open  ]],

Cell["\<\
\[Bullet] Compute the curvature of the covariant derivative. It is flat\
\>", "Text",ExpressionUUID->"bdfea921-bd71-4304-9947-386f12dd6b0c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Riemann", "[", "cd", "]"}]], "Input",ExpressionUUID->"4529a539-107f-4048-b717-93017e1bda95"],

Cell[BoxData["Zero"], "Output",ExpressionUUID->"6236be11-4822-4f50-b865-ec261ef4c8db"]
}, Open  ]],

Cell["\[Bullet] Suppose we introduce a new metric:", "Text",ExpressionUUID->"7126ceb5-6172-4f70-b74d-6160e4f78214"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MET", "=", 
  RowBox[{"CTensor", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", 
        RowBox[{
         RowBox[{"r", "[", "]"}], "^", "4"}]}], "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "polar"}], ",", 
      RowBox[{"-", "polar"}]}], "}"}]}], "]"}]}]], "Input",ExpressionUUID->\
"af088a77-a867-4c7f-b5a4-2213600419a3"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], "4"]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "polar"}], ",", 
     RowBox[{"-", "polar"}]}], "}"}], ",", "0"}], "]"}]], "Output",ExpressionU\
UID->"1b23164a-7553-42d4-b7ad-7dfd1bcd58f7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CD", "=", 
  RowBox[{"CovDOfMetric", "[", "MET", "]"}]}]], "Input",ExpressionUUID->\
"e7a7744d-be69-4eff-ae1f-baa3dca0706b"],

Cell[BoxData[
 RowBox[{"CCovD", "[", 
  RowBox[{"PDpolar", ",", 
   RowBox[{"CTensor", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False], "3"]}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", 
           FractionBox["2", 
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False]]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox["2", 
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False]], ",", "0"}], "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"polar", ",", 
       RowBox[{"-", "polar"}], ",", 
       RowBox[{"-", "polar"}]}], "}"}], ",", "0"}], "]"}], ",", 
   RowBox[{"CTensor", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], "4"]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "polar"}], ",", 
       RowBox[{"-", "polar"}]}], "}"}], ",", "0"}], "]"}]}], "]"}]], "Output",\
ExpressionUUID->"24e311bb-6451-4d80-8c9a-261791e355de"]
}, Open  ]],

Cell["\[Bullet] It is still torsionless:", "Text",ExpressionUUID->"8935c0be-8ba2-42dc-a95d-d40ab38aa357"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Torsion", "[", "CD", "]"}], "[", 
  RowBox[{"a", ",", 
   RowBox[{"-", "b"}], ",", 
   RowBox[{"-", "c"}]}], "]"}]], "Input",ExpressionUUID->"7912cd9b-38ad-4cdc-\
a487-9a7ccfedde5d"],

Cell[BoxData["0"], "Output",ExpressionUUID->"db5e15d4-7fbb-4e87-8590-9261eadcf9c0"]
}, Open  ]],

Cell["\[Bullet] But now it has curvature:", "Text",ExpressionUUID->"a9832359-2401-4bc4-9b53-3d7871439f93"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Riemann", "[", "CD", "]"}], "[", 
  RowBox[{
   RowBox[{"-", "a"}], ",", 
   RowBox[{"-", "b"}], ",", 
   RowBox[{"-", "c"}], ",", "d"}], "]"}]], "Input",ExpressionUUID->"1ce37c57-\
7b58-45de-b280-775f3ebe8beb"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1, 2} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                FractionBox["2", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "2"]]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox["2", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]]}]}]],
              
              Annotation[#, {1, 2, 1, 2} -> (-2) $CellContext`r[]^(-2), 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{"2", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "2"]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"2", " ", 
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}]}]],
              
              Annotation[#, {1, 2, 2, 1} -> 2 $CellContext`r[]^2, 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}]},
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               FractionBox["2", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "2"]],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 FractionBox["2", 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]]}]],
              
              Annotation[#, {2, 1, 1, 2} -> 2 $CellContext`r[]^(-2), 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{
                RowBox[{"-", "2"}], " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "2"]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{
                   RowBox[{"-", "2"}], " ", 
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}]}]],
              
              Annotation[#, {2, 1, 2, 1} -> (-2) $CellContext`r[]^2, 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 1, 2} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {" ", " ", " ", "d"},
         {"a", "b", "c", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{{{0, 0}, {0, 
     0}}, {{0, (-2) $CellContext`r[]^(-2)}, {2 $CellContext`r[]^2, 0}}}, {{{
      0, 2 $CellContext`r[]^(-2)}, {(-2) $CellContext`r[]^2, 0}}, {{0, 0}, {0,
      0}}}}, {-$CellContext`polar, -$CellContext`polar, -$CellContext`polar, \
$CellContext`polar}, 
   0][-$CellContext`a, -$CellContext`b, -$CellContext`c, $CellContext`d],
  Editable->False]], "Output",ExpressionUUID->"e58821db-3052-45f9-a4ab-\
09d80d083fc3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"RiemannDown", "[", "CD", "]"}], "[", 
  RowBox[{
   RowBox[{"-", "a"}], ",", 
   RowBox[{"-", "b"}], ",", 
   RowBox[{"-", "c"}], ",", 
   RowBox[{"-", "d"}]}], "]"}]], "Input",ExpressionUUID->"9d3b3a0e-b344-4c51-\
81f8-1f5c815c028a"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1, 2} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                RowBox[{"-", "2"}], " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "2"]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{
                   RowBox[{"-", "2"}], " ", 
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}]}]],
              
              Annotation[#, {1, 2, 1, 2} -> (-2) $CellContext`r[]^2, 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{"2", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "2"]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"2", " ", 
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}]}]],
              
              Annotation[#, {1, 2, 2, 1} -> 2 $CellContext`r[]^2, 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}]},
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{"2", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "2"]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"2", " ", 
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}]}]],
              
              Annotation[#, {2, 1, 1, 2} -> 2 $CellContext`r[]^2, 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{
                RowBox[{"-", "2"}], " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "2"]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{
                   RowBox[{"-", "2"}], " ", 
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}]}]],
              
              Annotation[#, {2, 1, 2, 1} -> (-2) $CellContext`r[]^2, 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 1, 2} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {" ", " ", " ", " "},
         {"a", "b", "c", "d"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{{{0, 0}, {0, 
     0}}, {{0, (-2) $CellContext`r[]^2}, {2 $CellContext`r[]^2, 0}}}, {{{
      0, 2 $CellContext`r[]^2}, {(-2) $CellContext`r[]^2, 0}}, {{0, 0}, {0, 
     0}}}}, {-$CellContext`polar, -$CellContext`polar, -$CellContext`polar, \
-$CellContext`polar}, 
   0][-$CellContext`a, -$CellContext`b, -$CellContext`c, -$CellContext`d],
  Editable->False]], "Output",ExpressionUUID->"bb5f49ab-c977-4d4e-82fa-\
2d34723b0d01"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Ricci", "[", "CD", "]"}], "[", 
  RowBox[{
   RowBox[{"-", "a"}], ",", 
   RowBox[{"-", "b"}]}], "]"}]], "Input",ExpressionUUID->"d1307a8c-748f-4228-\
96cc-b485a71f5fa3"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox[
            RowBox[{"-", 
             FractionBox["2", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False], "2"]]}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
              RowBox[{"-", 
                FractionBox["2", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox[
                   "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`r[], Editable -> False], "2"]]}]}]],
           Annotation[#, {1, 1} -> (-2) $CellContext`r[]^(-2), "Tooltip"]& ], 
          
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 2} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{
             RowBox[{"-", "2"}], " ", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], "2"]}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
              RowBox[{
                RowBox[{"-", "2"}], " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox[
                  "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`r[], Editable -> False], "2"]}]}]],
           Annotation[#, {2, 2} -> (-2) $CellContext`r[]^2, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {" ", " "},
         {"a", "b"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{(-2) $CellContext`r[]^(-2), 0}, {
    0, (-2) $CellContext`r[]^2}}, {-$CellContext`polar, -$CellContext`polar}, 
   0][-$CellContext`a, -$CellContext`b],
  Editable->False]], "Output",ExpressionUUID->"8a14833f-57b9-4d33-9771-\
98ebe4fdd202"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"RicciScalar", "[", "CD", "]"}], "[", "]"}]], "Input",ExpressionUUID\
->"785ec728-1c6c-43f1-afda-324b7563f668"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox["4", 
   SuperscriptBox[
    InterpretationBox[
     StyleBox["r",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`r[],
     Editable->False], "2"]]}]], "Output",ExpressionUUID->"bf332a4a-54d7-4d62-\
a87c-2fc69d3e2a19"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["3.3. Cleanup", "Subsubsection",ExpressionUUID->"c03062c3-48b5-4998-bc4b-553a0b216818"],

Cell[BoxData[
 RowBox[{"UndefChart", "[", "polar", "]"}]], "Input",ExpressionUUID->"297494aa-12f4-49f0-8236-cb946f56526a"],

Cell[BoxData[
 RowBox[{"UndefTensor", "[", "v", "]"}]], "Input",ExpressionUUID->"2d49f9f0-0f27-4eec-ab17-191bc9df7e8c"],

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "E2", "]"}]], "Input",ExpressionUUID->"2f5b8841-ee89-4441-8e0a-8c9bdf492ada"],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"cd", ",", "CD", ",", "met", ",", "MET"}], "]"}]], "Input",Expressio\
nUUID->"14a3cb33-0630-4108-bc57-e0dc00117aa6"],

Cell[BoxData[
 RowBox[{"ClearxCobaCache", "[", "All", "]"}]], "Input",ExpressionUUID->"ba8fe05c-96ff-4939-824d-4a3ab71a0f77"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["4. Curvature computations", "Subsection",ExpressionUUID->"16db1a3d-bccd-4e44-a636-50b4ad1a9092"],

Cell["\<\
This is probably the most important computation in GR, and we need to do it \
in a simple and fast enough way. Each example in this section is prepared to \
be evaluated independently of the rest of the notebook, and hence there are \
respective Needs commands.\
\>", "Text",ExpressionUUID->"c4a50e8c-37f4-4776-8a85-e256bfbd7d05"],

Cell["\<\
To have info messages from the caching system, activate this cell:\
\>", "Text",ExpressionUUID->"9c6f6974-15cb-4fdc-9d35-960393d226ee"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$xCobaCacheVerbose", "=", "True"}], ";"}]], "Input",
 Evaluatable->False,ExpressionUUID->"1cb09ff9-44cb-438e-bdea-5f2c44422e7d"],

Cell["To see messages from MetricCompute activate this cell:", "Text",ExpressionUUID->"d24a2a4b-47cb-412b-8fba-6d4d9fdee56a"],

Cell[BoxData[
 RowBox[{"SetOptions", "[", 
  RowBox[{"MetricCompute", ",", 
   RowBox[{"Verbose", "\[Rule]", "True"}]}], "]"}]], "Input",
 Evaluatable->False,ExpressionUUID->"0ba63123-5448-4705-be77-09f63ba5e2d3"],

Cell[CellGroupData[{

Cell["4.1. Kerr-Newman in the rotating frame", "Subsubsection",ExpressionUUID->"946e877a-5088-4a19-aa0e-98ae3b6d7114"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<xAct`xCoba`\>\"", "]"}]], "Input",ExpressionUUID->"b3884d04-5227-427e-9f87-eb665d9c3dc1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$DefInfoQ", "=", 
   RowBox[{"$UndefInfoQ", "=", "False"}]}], ";"}]], "Input",ExpressionUUID->\
"603df35f-0fbe-432b-9995-9ca822008a4c"],

Cell["Define a 4d manifold:", "Text",ExpressionUUID->"eb453612-ee59-431e-9a9f-7b163fcd22ea"],

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M", ",", "4", ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"7e1599a4-2877-44d8-aa63-9469d435191b"],

Cell["Boyer-Lindquist coordinates:", "Text",ExpressionUUID->"a7c63827-d8b5-4e0b-917f-d03a6ab6cce2"],

Cell[BoxData[
 RowBox[{"DefChart", "[", 
  RowBox[{"BL", ",", "M", ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"t", "[", "]"}], ",", 
     RowBox[{"r", "[", "]"}], ",", 
     RowBox[{"\[Theta]", "[", "]"}], ",", 
     RowBox[{"\[Phi]", "[", "]"}]}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"40f0916e-9b30-4309-93ae-e66b30634c5f"],

Cell[BoxData[{
 RowBox[{"DefConstantSymbol", "[", 
  RowBox[{"Mass", ",", 
   RowBox[{"PrintAs", "\[Rule]", "\"\<M\>\""}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefConstantSymbol", "[", 
  RowBox[{"Rotation", ",", 
   RowBox[{"PrintAs", "\[Rule]", "\"\<a\>\""}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefConstantSymbol", "[", 
  RowBox[{"Charge", ",", 
   RowBox[{"PrintAs", "\[Rule]", "\"\<Q\>\""}]}], "]"}]}], "Input",ExpressionU\
UID->"4ffee666-98a7-4225-9c39-476cc7111dfd"],

Cell["Change of basis:", "Text",ExpressionUUID->"6562e22e-b78e-413f-af95-40649f50d312"],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Rho]2", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"r", "[", "]"}], "^", "2"}], "+", 
    RowBox[{
     RowBox[{"Rotation", "^", "2"}], 
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"\[Theta]", "[", "]"}], "]"}], "^", "2"}]}]}]}], 
  ";"}]], "Input",ExpressionUUID->"58831832-c124-4cbe-b7e5-addfdef30319"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"change", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      FractionBox[
       RowBox[{
        RowBox[{
         RowBox[{"r", "[", "]"}], "^", "2"}], "+", 
        RowBox[{"Rotation", "^", "2"}]}], "\[Rho]2"], ",", "0", ",", "0", ",", 
      FractionBox["Rotation", "\[Rho]2"]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Rotation", " ", 
       RowBox[{
        RowBox[{"Sin", "[", 
         RowBox[{"\[Theta]", "[", "]"}], "]"}], "^", "2"}]}], ",", "0", ",", 
      "0", ",", "1"}], "}"}]}], "}"}]}]], "Input",ExpressionUUID->"f92e736b-\
ff73-489c-99af-a57c0187c384"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     FractionBox[
      RowBox[{
       SuperscriptBox[
        InterpretationBox[
         StyleBox["a",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Rotation,
         Editable->False], "2"], "+", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], "2"]}], 
      RowBox[{
       RowBox[{
        SuperscriptBox[
         InterpretationBox[
          StyleBox["a",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Rotation,
          Editable->False], "2"], " ", 
        SuperscriptBox[
         RowBox[{
          InterpretationBox[
           StyleBox["Cos",
            ShowAutoStyles->False,
            AutoSpacing->False],
           Cos,
           Editable->False], "[", 
          InterpretationBox[
           StyleBox["\[Theta]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Theta][],
           Editable->False], "]"}], "2"]}], "+", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], "2"]}]], ",", "0", ",", "0", ",", 
     FractionBox[
      InterpretationBox[
       StyleBox["a",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`Rotation,
       Editable->False], 
      RowBox[{
       RowBox[{
        SuperscriptBox[
         InterpretationBox[
          StyleBox["a",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Rotation,
          Editable->False], "2"], " ", 
        SuperscriptBox[
         RowBox[{
          InterpretationBox[
           StyleBox["Cos",
            ShowAutoStyles->False,
            AutoSpacing->False],
           Cos,
           Editable->False], "[", 
          InterpretationBox[
           StyleBox["\[Theta]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Theta][],
           Editable->False], "]"}], "2"]}], "+", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], "2"]}]]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      InterpretationBox[
       StyleBox["a",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`Rotation,
       Editable->False], " ", 
      SuperscriptBox[
       RowBox[{
        InterpretationBox[
         StyleBox["Sin",
          ShowAutoStyles->False,
          AutoSpacing->False],
         Sin,
         Editable->False], "[", 
        InterpretationBox[
         StyleBox["\[Theta]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Theta][],
         Editable->False], "]"}], "2"]}], ",", "0", ",", "0", ",", "1"}], 
    "}"}]}], "}"}]], "Output",ExpressionUUID->"f38e5fc6-5336-4633-81d5-\
e9aaeba7c74b"]
}, Open  ]],

Cell["\<\
Now define a frame in terms of the BL coordinates. Note that we need to \
provide the frame in a very specific way:\
\>", "Text",ExpressionUUID->"e8cc138e-3ae2-4269-9306-229f91818529"],

Cell[BoxData[
 RowBox[{"DefBasis", "[", 
  RowBox[{"frame", ",", "TangentM", ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"BasisColor", "\[Rule]", 
    RowBox[{"RGBColor", "[", 
     RowBox[{"0", ",", "0", ",", "1"}], "]"}]}], ",", 
   RowBox[{"BasisChange", "\[Rule]", 
    RowBox[{"CTensor", "[", 
     RowBox[{"change", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "frame"}], ",", "BL"}], "}"}]}], "]"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"6acfc4a5-3244-4967-a657-3f6c5fe9c4e8"],

Cell["This explains the change we have provided:", "Text",ExpressionUUID->"41a4e9ab-6e6d-4f61-9484-60de83929c0f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCTensor", "[", 
  RowBox[{"Basis", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "frame"}], ",", "BL"}], "}"}]}], "]"}]], "Input",ExpressionU\
UID->"c43519c5-4aed-4365-a997-81c29cc96d90"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       FractionBox[
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["a",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Rotation,
           Editable->False], "2"], "+", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], "2"]}], 
        RowBox[{
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["a",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Rotation,
            Editable->False], "2"], " ", 
          SuperscriptBox[
           RowBox[{
            InterpretationBox[
             StyleBox["Cos",
              ShowAutoStyles->False,
              AutoSpacing->False],
             Cos,
             Editable->False], "[", 
            InterpretationBox[
             StyleBox["\[Theta]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Theta][],
             Editable->False], "]"}], "2"]}], "+", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], "2"]}]], ",", "0", ",", "0", ",", 
       FractionBox[
        InterpretationBox[
         StyleBox["a",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Rotation,
         Editable->False], 
        RowBox[{
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["a",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Rotation,
            Editable->False], "2"], " ", 
          SuperscriptBox[
           RowBox[{
            InterpretationBox[
             StyleBox["Cos",
              ShowAutoStyles->False,
              AutoSpacing->False],
             Cos,
             Editable->False], "[", 
            InterpretationBox[
             StyleBox["\[Theta]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Theta][],
             Editable->False], "]"}], "2"]}], "+", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], "2"]}]]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        InterpretationBox[
         StyleBox["a",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Rotation,
         Editable->False], " ", 
        SuperscriptBox[
         RowBox[{
          InterpretationBox[
           StyleBox["Sin",
            ShowAutoStyles->False,
            AutoSpacing->False],
           Sin,
           Editable->False], "[", 
          InterpretationBox[
           StyleBox["\[Theta]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Theta][],
           Editable->False], "]"}], "2"]}], ",", "0", ",", "0", ",", "1"}], 
      "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "frame"}], ",", "BL"}], "}"}], ",", "0"}], "]"}]], "Output",\
ExpressionUUID->"a748dca6-0e36-4d02-beaf-d83cd082136c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ToCTensor", "[", 
   RowBox[{"Basis", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "BL"}], ",", "frame"}], "}"}]}], "]"}], "//", 
  "Simplify"}]], "Input",ExpressionUUID->"6add6ba9-fa15-4cee-8549-\
7c8db4a880bb"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0", ",", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"2", " ", 
          InterpretationBox[
           StyleBox["a",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Rotation,
           Editable->False]}], 
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["a",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Rotation,
            Editable->False], "2"], "+", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["a",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Rotation,
             Editable->False], "2"], " ", 
           RowBox[{
            InterpretationBox[
             StyleBox["Cos",
              ShowAutoStyles->False,
              AutoSpacing->False],
             Cos,
             Editable->False], "[", 
            RowBox[{"2", " ", 
             InterpretationBox[
              StyleBox["\[Theta]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Theta][],
              Editable->False]}], "]"}]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False], "2"]}]}]]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         InterpretationBox[
          StyleBox["a",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Rotation,
          Editable->False]}], " ", 
        SuperscriptBox[
         RowBox[{
          InterpretationBox[
           StyleBox["Sin",
            ShowAutoStyles->False,
            AutoSpacing->False],
           Sin,
           Editable->False], "[", 
          InterpretationBox[
           StyleBox["\[Theta]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Theta][],
           Editable->False], "]"}], "2"]}], ",", "0", ",", "0", ",", 
       FractionBox[
        RowBox[{"2", " ", 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["a",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Rotation,
             Editable->False], "2"], "+", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False], "2"]}], ")"}]}], 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["a",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Rotation,
           Editable->False], "2"], "+", 
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["a",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Rotation,
            Editable->False], "2"], " ", 
          RowBox[{
           InterpretationBox[
            StyleBox["Cos",
             ShowAutoStyles->False,
             AutoSpacing->False],
            Cos,
            Editable->False], "[", 
           RowBox[{"2", " ", 
            InterpretationBox[
             StyleBox["\[Theta]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Theta][],
             Editable->False]}], "]"}]}], "+", 
         RowBox[{"2", " ", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], "2"]}]}]]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "BL"}], ",", "frame"}], "}"}], ",", "0"}], "]"}]], "Output",\
ExpressionUUID->"b18a7b83-d020-40cb-8dc8-e40b47aa818b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCTensor", "[", 
  RowBox[{
   RowBox[{"CTensor", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"vt", ",", "vr", ",", "v\[Theta]", ",", "v\[Phi]"}], "}"}], ",", 
     RowBox[{"{", "BL", "}"}]}], "]"}], ",", 
   RowBox[{"{", "frame", "}"}]}], "]"}]], "Input",ExpressionUUID->"c9f91c2a-\
010e-479d-9959-32a366c675c0"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"vt", "-", 
      RowBox[{
       InterpretationBox[
        StyleBox["a",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`Rotation,
        Editable->False], " ", "v\[Phi]", " ", 
       SuperscriptBox[
        RowBox[{
         InterpretationBox[
          StyleBox["Sin",
           ShowAutoStyles->False,
           AutoSpacing->False],
          Sin,
          Editable->False], "[", 
         InterpretationBox[
          StyleBox["\[Theta]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[Theta][],
          Editable->False], "]"}], "2"]}]}], ",", "vr", ",", "v\[Theta]", ",", 
     FractionBox[
      RowBox[{"2", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", 
           InterpretationBox[
            StyleBox["a",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Rotation,
            Editable->False]}], " ", "vt"}], "+", 
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["a",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Rotation,
            Editable->False], "2"], " ", "v\[Phi]"}], "+", 
         RowBox[{"v\[Phi]", " ", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], "2"]}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox[
        InterpretationBox[
         StyleBox["a",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Rotation,
         Editable->False], "2"], "+", 
       RowBox[{
        SuperscriptBox[
         InterpretationBox[
          StyleBox["a",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Rotation,
          Editable->False], "2"], " ", 
        RowBox[{
         InterpretationBox[
          StyleBox["Cos",
           ShowAutoStyles->False,
           AutoSpacing->False],
          Cos,
          Editable->False], "[", 
         RowBox[{"2", " ", 
          InterpretationBox[
           StyleBox["\[Theta]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Theta][],
           Editable->False]}], "]"}]}], "+", 
       RowBox[{"2", " ", 
        SuperscriptBox[
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False], "2"]}]}]]}], "}"}], ",", 
   RowBox[{"{", "frame", "}"}], ",", "0"}], "]"}]], "Output",ExpressionUUID->\
"210cd751-2645-4f34-8ee5-cec0a1302f62"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"vt", ",", "vr", ",", "v\[Theta]", ",", "v\[Phi]"}], "]"}]], "Input",\
ExpressionUUID->"d11e843d-8986-4a01-8bb4-a604607f4c85"],

Cell["The metric tensor is diagonal in this frame:", "Text",ExpressionUUID->"9adb66bd-d77c-4929-882d-152b317c4fd6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"factor", "=", 
   RowBox[{
    FractionBox[
     RowBox[{
      RowBox[{"r", "[", "]"}], "^", "2"}], "\[Rho]2"], 
    RowBox[{"(", 
     RowBox[{"1", "-", 
      FractionBox[
       RowBox[{"2", "Mass"}], 
       RowBox[{"r", "[", "]"}]], "+", 
      FractionBox[
       RowBox[{
        RowBox[{"Rotation", "^", "2"}], "+", 
        RowBox[{"Charge", "^", "2"}]}], 
       RowBox[{
        RowBox[{"r", "[", "]"}], "^", "2"}]]}], ")"}]}]}], ";"}]], "Input",Exp\
ressionUUID->"6ebd11d5-4600-4db7-9420-9e1b3fe90d7a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"metric", "=", 
  RowBox[{"CTensor", "[", 
   RowBox[{
    RowBox[{"DiagonalMatrix", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "factor"}], ",", 
       RowBox[{"1", "/", "factor"}], ",", "\[Rho]2", ",", 
       RowBox[{"\[Rho]2", " ", 
        RowBox[{
         RowBox[{"Sin", "[", 
          RowBox[{"\[Theta]", "[", "]"}], "]"}], "^", "2"}]}]}], "}"}], "]"}],
     ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "frame"}], ",", 
      RowBox[{"-", "frame"}]}], "}"}], ",", "0"}], "]"}]}]], "Input",Expressio\
nUUID->"0e469695-83ec-48a1-9d46-4ef6900f4d74"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox[
               InterpretationBox[
                StyleBox["Q",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Charge,
                Editable->False], "2"], "+", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["a",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Rotation,
                Editable->False], "2"]}], 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], "2"]], "-", 
            FractionBox[
             RowBox[{"2", " ", 
              InterpretationBox[
               StyleBox["M",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Mass,
               Editable->False]}], 
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False]]}], ")"}], " ", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], "2"]}], 
         RowBox[{
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["a",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Rotation,
             Editable->False], "2"], " ", 
           SuperscriptBox[
            RowBox[{
             InterpretationBox[
              StyleBox["Cos",
               ShowAutoStyles->False,
               AutoSpacing->False],
              Cos,
              Editable->False], "[", 
             InterpretationBox[
              StyleBox["\[Theta]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Theta][],
              Editable->False], "]"}], "2"]}], "+", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], "2"]}]]}], ",", "0", ",", "0", ",", "0"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       FractionBox[
        RowBox[{
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["a",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Rotation,
            Editable->False], "2"], " ", 
          SuperscriptBox[
           RowBox[{
            InterpretationBox[
             StyleBox["Cos",
              ShowAutoStyles->False,
              AutoSpacing->False],
             Cos,
             Editable->False], "[", 
            InterpretationBox[
             StyleBox["\[Theta]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Theta][],
             Editable->False], "]"}], "2"]}], "+", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], "2"]}], 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", "+", 
           FractionBox[
            RowBox[{
             SuperscriptBox[
              InterpretationBox[
               StyleBox["Q",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Charge,
               Editable->False], "2"], "+", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["a",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Rotation,
               Editable->False], "2"]}], 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False], "2"]], "-", 
           FractionBox[
            RowBox[{"2", " ", 
             InterpretationBox[
              StyleBox["M",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Mass,
              Editable->False]}], 
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False]]}], ")"}], " ", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], "2"]}]], ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["a",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Rotation,
           Editable->False], "2"], " ", 
         SuperscriptBox[
          RowBox[{
           InterpretationBox[
            StyleBox["Cos",
             ShowAutoStyles->False,
             AutoSpacing->False],
            Cos,
            Editable->False], "[", 
           InterpretationBox[
            StyleBox["\[Theta]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`\[Theta][],
            Editable->False], "]"}], "2"]}], "+", 
        SuperscriptBox[
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False], "2"]}], ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["a",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Rotation,
             Editable->False], "2"], " ", 
           SuperscriptBox[
            RowBox[{
             InterpretationBox[
              StyleBox["Cos",
               ShowAutoStyles->False,
               AutoSpacing->False],
              Cos,
              Editable->False], "[", 
             InterpretationBox[
              StyleBox["\[Theta]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Theta][],
              Editable->False], "]"}], "2"]}], "+", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], "2"]}], ")"}], " ", 
        SuperscriptBox[
         RowBox[{
          InterpretationBox[
           StyleBox["Sin",
            ShowAutoStyles->False,
            AutoSpacing->False],
           Sin,
           Editable->False], "[", 
          InterpretationBox[
           StyleBox["\[Theta]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Theta][],
           Editable->False], "]"}], "2"]}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "frame"}], ",", 
     RowBox[{"-", "frame"}]}], "}"}], ",", "0"}], "]"}]], "Output",ExpressionU\
UID->"19ac0a56-9ff9-431d-b974-1db28bd565c2"]
}, Open  ]],

Cell["\<\
Now set this metric as the first-metric of the TangentM bundle:\
\>", "Text",ExpressionUUID->"34671351-a0b2-4be7-81ce-041283cc15fa"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"SetCMetric", "[", 
   RowBox[{"metric", ",", "BL", ",", 
    RowBox[{"SignatureOfMetric", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"3", ",", "1", ",", "0"}], "}"}]}]}], "]"}], "//", 
  "Timing"}]], "Input",ExpressionUUID->"688170f6-15d7-41d8-b1ea-64ece524b752"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.589386`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"fb777e1e-bf30-4f28-9ee9-6c8df732408f"]
}, Open  ]],

Cell["The coordinated metric tensor is nondiagonal:", "Text",ExpressionUUID->"f063371e-6d9f-4cc5-9e19-675db7102e8d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCTensor", "[", 
  RowBox[{"metric", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "BL"}], ",", 
     RowBox[{"-", "BL"}]}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"180a2e3a-7392-425b-8690-d1a354937c36"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"2", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox[
             InterpretationBox[
              StyleBox["Q",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Charge,
              Editable->False], "2"], "+", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["a",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Rotation,
              Editable->False], "2"], "-", 
            RowBox[{"2", " ", 
             InterpretationBox[
              StyleBox["M",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Mass,
              Editable->False], " ", 
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False]}], "+", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False], "2"], "-", 
            RowBox[{
             SuperscriptBox[
              InterpretationBox[
               StyleBox["a",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Rotation,
               Editable->False], "2"], " ", 
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["Sin",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                Sin,
                Editable->False], "[", 
               InterpretationBox[
                StyleBox["\[Theta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Theta][],
                Editable->False], "]"}], "2"]}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["a",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Rotation,
            Editable->False], "2"], "+", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["a",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Rotation,
             Editable->False], "2"], " ", 
           RowBox[{
            InterpretationBox[
             StyleBox["Cos",
              ShowAutoStyles->False,
              AutoSpacing->False],
             Cos,
             Editable->False], "[", 
            RowBox[{"2", " ", 
             InterpretationBox[
              StyleBox["\[Theta]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Theta][],
              Editable->False]}], "]"}]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False], "2"]}]}]]}], ",", "0", ",", "0", ",", 
       FractionBox[
        RowBox[{"2", " ", 
         InterpretationBox[
          StyleBox["a",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Rotation,
          Editable->False], " ", 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["Q",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Charge,
             Editable->False], "2"], "-", 
           RowBox[{"2", " ", 
            InterpretationBox[
             StyleBox["M",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Mass,
             Editable->False], " ", 
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False]}]}], ")"}], " ", 
         SuperscriptBox[
          RowBox[{
           InterpretationBox[
            StyleBox["Sin",
             ShowAutoStyles->False,
             AutoSpacing->False],
            Sin,
            Editable->False], "[", 
           InterpretationBox[
            StyleBox["\[Theta]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`\[Theta][],
            Editable->False], "]"}], "2"]}], 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["a",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Rotation,
           Editable->False], "2"], "+", 
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["a",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Rotation,
            Editable->False], "2"], " ", 
          RowBox[{
           InterpretationBox[
            StyleBox["Cos",
             ShowAutoStyles->False,
             AutoSpacing->False],
            Cos,
            Editable->False], "[", 
           RowBox[{"2", " ", 
            InterpretationBox[
             StyleBox["\[Theta]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Theta][],
             Editable->False]}], "]"}]}], "+", 
         RowBox[{"2", " ", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], "2"]}]}]]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       FractionBox[
        RowBox[{
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["a",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Rotation,
            Editable->False], "2"], " ", 
          SuperscriptBox[
           RowBox[{
            InterpretationBox[
             StyleBox["Cos",
              ShowAutoStyles->False,
              AutoSpacing->False],
             Cos,
             Editable->False], "[", 
            InterpretationBox[
             StyleBox["\[Theta]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Theta][],
             Editable->False], "]"}], "2"]}], "+", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], "2"]}], 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["Q",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Charge,
           Editable->False], "2"], "+", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["a",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Rotation,
           Editable->False], "2"], "-", 
         RowBox[{"2", " ", 
          InterpretationBox[
           StyleBox["M",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Mass,
           Editable->False], " ", 
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False]}], "+", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], "2"]}]], ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["a",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Rotation,
           Editable->False], "2"], " ", 
         SuperscriptBox[
          RowBox[{
           InterpretationBox[
            StyleBox["Cos",
             ShowAutoStyles->False,
             AutoSpacing->False],
            Cos,
            Editable->False], "[", 
           InterpretationBox[
            StyleBox["\[Theta]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`\[Theta][],
            Editable->False], "]"}], "2"]}], "+", 
        SuperscriptBox[
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False], "2"]}], ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       FractionBox[
        RowBox[{"2", " ", 
         InterpretationBox[
          StyleBox["a",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Rotation,
          Editable->False], " ", 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["Q",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Charge,
             Editable->False], "2"], "-", 
           RowBox[{"2", " ", 
            InterpretationBox[
             StyleBox["M",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Mass,
             Editable->False], " ", 
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False]}]}], ")"}], " ", 
         SuperscriptBox[
          RowBox[{
           InterpretationBox[
            StyleBox["Sin",
             ShowAutoStyles->False,
             AutoSpacing->False],
            Sin,
            Editable->False], "[", 
           InterpretationBox[
            StyleBox["\[Theta]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`\[Theta][],
            Editable->False], "]"}], "2"]}], 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["a",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Rotation,
           Editable->False], "2"], "+", 
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["a",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Rotation,
            Editable->False], "2"], " ", 
          RowBox[{
           InterpretationBox[
            StyleBox["Cos",
             ShowAutoStyles->False,
             AutoSpacing->False],
            Cos,
            Editable->False], "[", 
           RowBox[{"2", " ", 
            InterpretationBox[
             StyleBox["\[Theta]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Theta][],
             Editable->False]}], "]"}]}], "+", 
         RowBox[{"2", " ", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], "2"]}]}]], ",", "0", ",", "0", ",", 
       RowBox[{
        FractionBox[
         RowBox[{"2", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox[
              InterpretationBox[
               StyleBox["a",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Rotation,
               Editable->False], "2"], "+", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], "2"]}], ")"}], "2"], " ", 
          SuperscriptBox[
           RowBox[{
            InterpretationBox[
             StyleBox["Sin",
              ShowAutoStyles->False,
              AutoSpacing->False],
             Sin,
             Editable->False], "[", 
            InterpretationBox[
             StyleBox["\[Theta]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Theta][],
             Editable->False], "]"}], "2"]}], 
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["a",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Rotation,
            Editable->False], "2"], "+", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["a",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Rotation,
             Editable->False], "2"], " ", 
           RowBox[{
            InterpretationBox[
             StyleBox["Cos",
              ShowAutoStyles->False,
              AutoSpacing->False],
             Cos,
             Editable->False], "[", 
            RowBox[{"2", " ", 
             InterpretationBox[
              StyleBox["\[Theta]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Theta][],
              Editable->False]}], "]"}]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False], "2"]}]}]], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["a",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Rotation,
            Editable->False], "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox[
             InterpretationBox[
              StyleBox["Q",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Charge,
              Editable->False], "2"], "+", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["a",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Rotation,
              Editable->False], "2"], "+", 
            RowBox[{
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "2"}], " ", 
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False]}], "+", 
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False]}], ")"}]}]}], ")"}], " ", 
          SuperscriptBox[
           RowBox[{
            InterpretationBox[
             StyleBox["Sin",
              ShowAutoStyles->False,
              AutoSpacing->False],
             Sin,
             Editable->False], "[", 
            InterpretationBox[
             StyleBox["\[Theta]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Theta][],
             Editable->False], "]"}], "4"]}], 
         RowBox[{
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["a",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Rotation,
             Editable->False], "2"], " ", 
           SuperscriptBox[
            RowBox[{
             InterpretationBox[
              StyleBox["Cos",
               ShowAutoStyles->False,
               AutoSpacing->False],
              Cos,
              Editable->False], "[", 
             InterpretationBox[
              StyleBox["\[Theta]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Theta][],
              Editable->False], "]"}], "2"]}], "+", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], "2"]}]]}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "BL"}], ",", 
     RowBox[{"-", "BL"}]}], "}"}], ",", "0"}], "]"}]], "Output",ExpressionUUID\
->"cfe08472-73eb-4e2b-afac-00df35aed157"]
}, Open  ]],

Cell["Compute curvature tensors:", "Text",ExpressionUUID->"257ab56c-e2f7-4571-aa4a-36c507728777"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MetricCompute", "[", 
   RowBox[{"metric", ",", "BL", ",", "All", ",", 
    RowBox[{"Parallelize", "\[Rule]", "True"}]}], "]"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"c0d3dd71-7a91-47c5-80dc-\
2d27929e1c27"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"6.507265`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"07bc8d64-b39e-4fb9-8f89-401806c3767d"]
}, Open  ]],

Cell["\<\
That computed and simplified everything, including the Kretschman scalar and \
the first covariant derivative of the Riemann tensor. All those results are \
now cached. If we do it again it takes nothing:\
\>", "Text",ExpressionUUID->"1dddc67b-4cb7-4a5d-9e5e-a50a2e599b95"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MetricCompute", "[", 
   RowBox[{"metric", ",", "BL", ",", "All"}], "]"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"ad3f8c5f-d29d-43d7-8a1d-\
f6ca14671c0f"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.032615`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"7d7c03c9-1b17-4beb-a833-4b58e79500ce"]
}, Open  ]],

Cell["Extract information:", "Text",ExpressionUUID->"7b64b8c8-bf67-4e62-8c71-1f77a52ce73f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"cd", "=", 
   RowBox[{"CovDOfMetric", "[", "metric", "]"}]}], ";"}]], "Input",ExpressionU\
UID->"94babfc7-3724-4b7e-a6ba-a18f08ec607f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"RicciScalar", "[", "cd", "]"}], "[", "]"}]], "Input",ExpressionUUID\
->"c37ee9f8-6fce-4c66-badc-4592ae6e16de"],

Cell[BoxData["0"], "Output",ExpressionUUID->"75f9fdf0-e429-4f59-a718-e0aebab19944"]
}, Open  ]],

Cell["The Ricci tensor is again diagonal in this frame:", "Text",ExpressionUUID->"f6cc2349-a999-48a2-8aa4-08d1e2ac4a06"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Ricci", "[", "cd", "]"}]], "Input",ExpressionUUID->"1298d990-ce3c-46da-a3a9-d5481861cef3"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       FractionBox[
        RowBox[{"8", " ", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["Q",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Charge,
           Editable->False], "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["Q",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Charge,
             Editable->False], "2"], "+", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["a",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Rotation,
             Editable->False], "2"], "+", 
           RowBox[{
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "2"}], " ", 
               InterpretationBox[
                StyleBox["M",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Mass,
                Editable->False]}], "+", 
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False]}], ")"}]}]}], ")"}]}], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["a",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Rotation,
             Editable->False], "2"], "+", 
           RowBox[{
            SuperscriptBox[
             InterpretationBox[
              StyleBox["a",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Rotation,
              Editable->False], "2"], " ", 
            RowBox[{
             InterpretationBox[
              StyleBox["Cos",
               ShowAutoStyles->False,
               AutoSpacing->False],
              Cos,
              Editable->False], "[", 
             RowBox[{"2", " ", 
              InterpretationBox[
               StyleBox["\[Theta]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Theta][],
               Editable->False]}], "]"}]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False], "2"]}]}], ")"}], "3"]], ",", "0", ",", "0", 
       ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"2", " ", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["Q",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Charge,
            Editable->False], "2"]}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox[
             InterpretationBox[
              StyleBox["a",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Rotation,
              Editable->False], "2"], "+", 
            RowBox[{
             SuperscriptBox[
              InterpretationBox[
               StyleBox["a",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Rotation,
               Editable->False], "2"], " ", 
             RowBox[{
              InterpretationBox[
               StyleBox["Cos",
                ShowAutoStyles->False,
                AutoSpacing->False],
               Cos,
               Editable->False], "[", 
              RowBox[{"2", " ", 
               InterpretationBox[
                StyleBox["\[Theta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Theta][],
                Editable->False]}], "]"}]}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], "2"]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox[
             InterpretationBox[
              StyleBox["Q",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Charge,
              Editable->False], "2"], "+", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["a",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Rotation,
              Editable->False], "2"], "+", 
            RowBox[{
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "2"}], " ", 
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False]}], "+", 
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False]}], ")"}]}]}], ")"}]}]]}], ",", "0", ",", 
       "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", 
       FractionBox[
        RowBox[{"2", " ", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["Q",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Charge,
           Editable->False], "2"]}], 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["a",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Rotation,
           Editable->False], "2"], "+", 
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["a",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Rotation,
            Editable->False], "2"], " ", 
          RowBox[{
           InterpretationBox[
            StyleBox["Cos",
             ShowAutoStyles->False,
             AutoSpacing->False],
            Cos,
            Editable->False], "[", 
           RowBox[{"2", " ", 
            InterpretationBox[
             StyleBox["\[Theta]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Theta][],
             Editable->False]}], "]"}]}], "+", 
         RowBox[{"2", " ", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], "2"]}]}]], ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", 
       FractionBox[
        RowBox[{"2", " ", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["Q",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Charge,
           Editable->False], "2"], " ", 
         SuperscriptBox[
          RowBox[{
           InterpretationBox[
            StyleBox["Sin",
             ShowAutoStyles->False,
             AutoSpacing->False],
            Sin,
            Editable->False], "[", 
           InterpretationBox[
            StyleBox["\[Theta]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`\[Theta][],
            Editable->False], "]"}], "2"]}], 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["a",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Rotation,
           Editable->False], "2"], "+", 
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["a",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Rotation,
            Editable->False], "2"], " ", 
          RowBox[{
           InterpretationBox[
            StyleBox["Cos",
             ShowAutoStyles->False,
             AutoSpacing->False],
            Cos,
            Editable->False], "[", 
           RowBox[{"2", " ", 
            InterpretationBox[
             StyleBox["\[Theta]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Theta][],
             Editable->False]}], "]"}]}], "+", 
         RowBox[{"2", " ", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], "2"]}]}]]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "frame"}], ",", 
     RowBox[{"-", "frame"}]}], "}"}], ",", "0"}], "]"}]], "Output",ExpressionU\
UID->"e2f61a64-88b5-4fb8-81ee-116798c674b0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "[", 
  RowBox[{
   RowBox[{"-", "a"}], ",", 
   RowBox[{"-", "b"}]}], "]"}]], "Input",ExpressionUUID->"8979b816-37cc-48ea-\
839d-e39c15826125"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{"8", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"Q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Charge, Editable -> False], "2"], 
                 " ", 
                 RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Charge, Editable -> False], "2"], 
                    "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"a"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Rotation, Editable -> False], "2"], 
                    "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}], 
                   ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"a"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Rotation, Editable -> False], "2"], 
                    "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"a"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Rotation, Editable -> False], "2"], 
                    " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Cos"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Cos, Editable -> False], "[", 
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    "\[Theta]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Theta][], Editable -> False]}], "]"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}]}], ")"}], 
                "3"]]}]],
           
           Annotation[#, {1, 1} -> 
            8 $CellContext`Charge^2 ($CellContext`Rotation^2 + \
$CellContext`Rotation^2 Cos[2 $CellContext`\[Theta][]] + 
               2 $CellContext`r[]^2)^(-3) ($CellContext`Charge^2 + \
$CellContext`Rotation^2 + $CellContext`r[] ((-2) $CellContext`Mass + \
$CellContext`r[])), "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 4} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
              RowBox[{"-", 
                FractionBox[
                 RowBox[{"2", " ", 
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Charge, Editable -> False], "2"]}], 
                 RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"a"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Rotation, Editable -> False], "2"], 
                    "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"a"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Rotation, Editable -> False], "2"], 
                    " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Cos"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Cos, Editable -> False], "[", 
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    "\[Theta]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Theta][], Editable -> False]}], "]"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}]}], ")"}], 
                   " ", 
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Charge, Editable -> False], "2"], 
                    "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"a"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Rotation, Editable -> False], "2"], 
                    "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}], 
                    ")"}]}]]}]}]],
           
           Annotation[#, {2, 
             2} -> (-2) $CellContext`Charge^2 ($CellContext`Rotation^2 + \
$CellContext`Rotation^2 Cos[2 $CellContext`\[Theta][]] + 
               2 $CellContext`r[]^2)^(-1)/($CellContext`Charge^2 + \
$CellContext`Rotation^2 + $CellContext`r[] ((-2) $CellContext`Mass + \
$CellContext`r[])), "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 4} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            FractionBox[
             RowBox[{"2", " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["Q",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Charge,
                Editable->False], "2"]}], 
             RowBox[{
              SuperscriptBox[
               InterpretationBox[
                StyleBox["a",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Rotation,
                Editable->False], "2"], "+", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["a",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Rotation,
                 Editable->False], "2"], " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["Cos",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 Cos,
                 Editable->False], "[", 
                RowBox[{"2", " ", 
                 InterpretationBox[
                  StyleBox["\[Theta]",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`\[Theta][],
                  Editable->False]}], "]"}]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False], "2"]}]}]],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "3"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{"2", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"Q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Charge, Editable -> False], "2"]}], 
               RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"a"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Rotation, Editable -> False], "2"], 
                 "+", 
                 RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"a"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Rotation, Editable -> False], "2"], 
                   " ", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Cos"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Cos, Editable -> False], "[", 
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    "\[Theta]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Theta][], Editable -> False]}], "]"}]}], 
                 "+", 
                 RowBox[{"2", " ", 
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}]}]]}]],
           
           Annotation[#, {3, 3} -> 
            2 $CellContext`Charge^2/($CellContext`Rotation^2 + \
$CellContext`Rotation^2 Cos[2 $CellContext`\[Theta][]] + 
             2 $CellContext`r[]^2), "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 4} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "4"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{"2", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"Q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Charge, Editable -> False], "2"], 
                 " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Sin"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Sin, Editable -> False], "[", 
                    InterpretationBox[
                    StyleBox[
                    "\[Theta]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Theta][], Editable -> False], "]"}], 
                  "2"]}], 
               RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"a"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Rotation, Editable -> False], "2"], 
                 "+", 
                 RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"a"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Rotation, Editable -> False], "2"], 
                   " ", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Cos"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Cos, Editable -> False], "[", 
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    "\[Theta]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Theta][], Editable -> False]}], "]"}]}], 
                 "+", 
                 RowBox[{"2", " ", 
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}]}]]}]],
           
           Annotation[#, {4, 4} -> 
            2 $CellContext`Charge^2 ($CellContext`Rotation^2 + \
$CellContext`Rotation^2 Cos[2 $CellContext`\[Theta][]] + 
               2 $CellContext`r[]^2)^(-1) Sin[
                $CellContext`\[Theta][]]^2, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]},
           "RowsIndexed" -> {1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {" ", " "},
         {"a", "b"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{
    8 $CellContext`Charge^2 ($CellContext`Rotation^2 + \
$CellContext`Rotation^2 Cos[2 $CellContext`\[Theta][]] + 
       2 $CellContext`r[]^2)^(-3) ($CellContext`Charge^2 + \
$CellContext`Rotation^2 + $CellContext`r[] ((-2) $CellContext`Mass + \
$CellContext`r[])), 0, 0, 0}, {
    0, (-2) $CellContext`Charge^2 ($CellContext`Rotation^2 + \
$CellContext`Rotation^2 Cos[2 $CellContext`\[Theta][]] + 
       2 $CellContext`r[]^2)^(-1)/($CellContext`Charge^2 + \
$CellContext`Rotation^2 + $CellContext`r[] ((-2) $CellContext`Mass + \
$CellContext`r[])), 0, 0}, {
    0, 0, 2 $CellContext`Charge^2/($CellContext`Rotation^2 + \
$CellContext`Rotation^2 Cos[2 $CellContext`\[Theta][]] + 
     2 $CellContext`r[]^2), 0}, {
    0, 0, 0, 2 $CellContext`Charge^2 ($CellContext`Rotation^2 + \
$CellContext`Rotation^2 Cos[2 $CellContext`\[Theta][]] + 
       2 $CellContext`r[]^2)^(-1) Sin[
        $CellContext`\[Theta][]]^2}}, {-$CellContext`frame, \
-$CellContext`frame}, 0][-$CellContext`a, -$CellContext`b],
  Editable->False]], "Output",ExpressionUUID->"13ed93e6-f047-4605-892e-\
38e9d8687348"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Kretschmann", "[", "cd", "]"}], "[", "]"}]], "Input",ExpressionUUID\
->"8794c980-7e57-4d22-9fd2-df9b007f6c76"],

Cell[BoxData[
 RowBox[{"-", 
  RowBox[{
   FractionBox["1", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox[
        InterpretationBox[
         StyleBox["a",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Rotation,
         Editable->False], "2"], "+", 
       RowBox[{
        SuperscriptBox[
         InterpretationBox[
          StyleBox["a",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Rotation,
          Editable->False], "2"], " ", 
        RowBox[{
         InterpretationBox[
          StyleBox["Cos",
           ShowAutoStyles->False,
           AutoSpacing->False],
          Cos,
          Editable->False], "[", 
         RowBox[{"2", " ", 
          InterpretationBox[
           StyleBox["\[Theta]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Theta][],
           Editable->False]}], "]"}]}], "+", 
       RowBox[{"2", " ", 
        SuperscriptBox[
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False], "2"]}]}], ")"}], "6"]], 
   RowBox[{"32", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "42"}], " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["Q",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Charge,
         Editable->False], "4"], " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["a",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Rotation,
         Editable->False], "4"]}], "+", 
      RowBox[{"30", " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["M",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Mass,
         Editable->False], "2"], " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["a",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Rotation,
         Editable->False], "6"]}], "+", 
      RowBox[{"3", " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["M",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Mass,
         Editable->False], "2"], " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["a",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Rotation,
         Editable->False], "6"], " ", 
       RowBox[{
        InterpretationBox[
         StyleBox["Cos",
          ShowAutoStyles->False,
          AutoSpacing->False],
         Cos,
         Editable->False], "[", 
        RowBox[{"6", " ", 
         InterpretationBox[
          StyleBox["\[Theta]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[Theta][],
          Editable->False]}], "]"}]}], "+", 
      RowBox[{"360", " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["Q",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Charge,
         Editable->False], "2"], " ", 
       InterpretationBox[
        StyleBox["M",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`Mass,
        Editable->False], " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["a",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Rotation,
         Editable->False], "4"], " ", 
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False]}], "+", 
      RowBox[{"272", " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["Q",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Charge,
         Editable->False], "4"], " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["a",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Rotation,
         Editable->False], "2"], " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], "2"]}], "-", 
      RowBox[{"540", " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["M",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Mass,
         Editable->False], "2"], " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["a",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Rotation,
         Editable->False], "4"], " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], "2"]}], "-", 
      RowBox[{"960", " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["Q",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Charge,
         Editable->False], "2"], " ", 
       InterpretationBox[
        StyleBox["M",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`Mass,
        Editable->False], " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["a",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Rotation,
         Editable->False], "2"], " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], "3"]}], "-", 
      RowBox[{"112", " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["Q",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Charge,
         Editable->False], "4"], " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], "4"]}], "+", 
      RowBox[{"720", " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["M",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Mass,
         Editable->False], "2"], " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["a",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Rotation,
         Editable->False], "2"], " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], "4"]}], "+", 
      RowBox[{"192", " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["Q",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Charge,
         Editable->False], "2"], " ", 
       InterpretationBox[
        StyleBox["M",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`Mass,
        Editable->False], " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], "5"]}], "-", 
      RowBox[{"96", " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["M",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Mass,
         Editable->False], "2"], " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], "6"]}], "+", 
      RowBox[{"2", " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["a",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Rotation,
         Editable->False], "4"], " ", 
       RowBox[{
        InterpretationBox[
         StyleBox["Cos",
          ShowAutoStyles->False,
          AutoSpacing->False],
         Cos,
         Editable->False], "[", 
        RowBox[{"4", " ", 
         InterpretationBox[
          StyleBox["\[Theta]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[Theta][],
          Editable->False]}], "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "7"}], " ", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["Q",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Charge,
            Editable->False], "4"]}], "+", 
         RowBox[{"60", " ", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["Q",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Charge,
            Editable->False], "2"], " ", 
          InterpretationBox[
           StyleBox["M",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Mass,
           Editable->False], " ", 
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False]}], "+", 
         RowBox[{"9", " ", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["M",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Mass,
            Editable->False], "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox[
             InterpretationBox[
              StyleBox["a",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Rotation,
              Editable->False], "2"], "-", 
            RowBox[{"10", " ", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], "2"]}]}], ")"}]}]}], ")"}]}], "+", 
      RowBox[{
       SuperscriptBox[
        InterpretationBox[
         StyleBox["a",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Rotation,
         Editable->False], "2"], " ", 
       RowBox[{
        InterpretationBox[
         StyleBox["Cos",
          ShowAutoStyles->False,
          AutoSpacing->False],
         Cos,
         Editable->False], "[", 
        RowBox[{"2", " ", 
         InterpretationBox[
          StyleBox["\[Theta]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[Theta][],
          Editable->False]}], "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "8"}], " ", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["Q",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Charge,
            Editable->False], "4"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"7", " ", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["a",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Rotation,
               Editable->False], "2"]}], "-", 
            RowBox[{"34", " ", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], "2"]}]}], ")"}]}], "+", 
         RowBox[{"480", " ", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["Q",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Charge,
            Editable->False], "2"], " ", 
          InterpretationBox[
           StyleBox["M",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Mass,
           Editable->False], " ", 
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox[
             InterpretationBox[
              StyleBox["a",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Rotation,
              Editable->False], "2"], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], "2"]}]}], ")"}]}], "+", 
         RowBox[{"45", " ", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["M",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Mass,
            Editable->False], "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox[
             InterpretationBox[
              StyleBox["a",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Rotation,
              Editable->False], "4"], "-", 
            RowBox[{"16", " ", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["a",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Rotation,
               Editable->False], "2"], " ", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], "2"]}], "+", 
            RowBox[{"16", " ", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], "4"]}]}], ")"}]}]}], ")"}]}]}], 
     ")"}]}]}]}]], "Output",ExpressionUUID->"38830260-75e7-4224-b8e3-\
0146652c2952"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Riemann", "[", "cd", "]"}]], "Input",ExpressionUUID->"6852fa8e-9d39-43f8-9e26-28edb5d7de52"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"-", 
            FractionBox[
             RowBox[{"8", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["Q",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Charge,
                  Editable->False], "2"], "+", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], "+", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False]}], "+", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}], ")"}]}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "6"}], " ", 
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]}], "+", 
                RowBox[{"4", " ", 
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "3"]}], "+", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["Q",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Charge,
                    Editable->False], "2"], "-", 
                   RowBox[{"6", " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False], " ", 
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}]}], ")"}]}], "+", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["Q",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Charge,
                   Editable->False], "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], "-", 
                   RowBox[{"6", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], "+", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "2"]}]}], ")"}], "4"]]}], ",", "0", ",", 
           "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             RowBox[{"2", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "6"}], " ", 
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]}], "+", 
                RowBox[{"4", " ", 
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "3"]}], "+", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["Q",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Charge,
                    Editable->False], "2"], "-", 
                   RowBox[{"6", " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False], " ", 
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}]}], ")"}]}], "+", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["Q",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Charge,
                   Editable->False], "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], "-", 
                   RowBox[{"6", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], "+", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    Cos,
                    Editable->False], "[", 
                   RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}]}], "+", 
                 RowBox[{"2", " ", 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}], "2"], " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["Q",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Charge,
                  Editable->False], "2"], "+", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], "+", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False]}], "+", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}], ")"}]}]}], ")"}]}]]}], ",", "0", ",", 
           "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", 
           RowBox[{"-", 
            FractionBox[
             RowBox[{"8", " ", 
              InterpretationBox[
               StyleBox["a",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Rotation,
               Editable->False], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["Cot",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                Cot,
                Editable->False], "[", 
               InterpretationBox[
                StyleBox["\[Theta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Theta][],
                Editable->False], "]"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{"4", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["Q",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Charge,
                   Editable->False], "2"], " ", 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]}], "+", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], "-", 
                   RowBox[{"6", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], "+", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "2"]}]}], ")"}], "3"]]}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", 
           FractionBox[
            RowBox[{"4", " ", 
             InterpretationBox[
              StyleBox["a",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Rotation,
              Editable->False], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["Cos",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  Cos,
                  Editable->False], "[", 
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`\[Theta][],
                   Editable->False]}], "]"}]}], "+", 
               RowBox[{"4", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["Q",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Charge,
                  Editable->False], "2"], " ", 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]}], "+", 
               RowBox[{
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], "-", 
                  RowBox[{"6", " ", 
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], ")"}], " ", 
             RowBox[{
              InterpretationBox[
               StyleBox["Sin",
                ShowAutoStyles->False,
                AutoSpacing->False],
               Sin,
               Editable->False], "[", 
              RowBox[{"2", " ", 
               InterpretationBox[
                StyleBox["\[Theta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Theta][],
                Editable->False]}], "]"}]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["a",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Rotation,
                 Editable->False], "2"], "+", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["Cos",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  Cos,
                  Editable->False], "[", 
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`\[Theta][],
                   Editable->False]}], "]"}]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "2"]}]}], ")"}], "3"]], ",", "0"}], 
          "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", 
           FractionBox[
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["Q",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Charge,
                 Editable->False], "2"], "+", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["a",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Rotation,
                 Editable->False], "2"], "+", 
               RowBox[{
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "2"}], " ", 
                   InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False]}], "+", 
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False]}], ")"}]}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "3"}], " ", 
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]}], "+", 
               RowBox[{"2", " ", 
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "3"]}], "+", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["Cos",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  Cos,
                  Editable->False], "[", 
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`\[Theta][],
                   Editable->False]}], "]"}], " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["Q",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Charge,
                    Editable->False], "2"], "-", 
                  RowBox[{"3", " ", 
                   InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False], " ", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}]}], ")"}]}], "+", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["Q",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Charge,
                  Editable->False], "2"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], "-", 
                  RowBox[{"2", " ", 
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], ")"}]}], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{
                   InterpretationBox[
                    StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    Cos,
                    Editable->False], "[", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False], "]"}], "2"]}], "+", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "2"]}], ")"}], "4"]}]], ",", "0"}], "}"}],
          ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", 
           RowBox[{"-", 
            FractionBox[
             RowBox[{"4", " ", 
              InterpretationBox[
               StyleBox["a",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Rotation,
               Editable->False], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["Cot",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                Cot,
                Editable->False], "[", 
               InterpretationBox[
                StyleBox["\[Theta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Theta][],
                Editable->False], "]"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{"4", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["Q",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Charge,
                   Editable->False], "2"], " ", 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]}], "+", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], "-", 
                   RowBox[{"6", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], "+", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "2"]}]}], ")"}], "3"]]}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", "3"}], " ", 
              InterpretationBox[
               StyleBox["M",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Mass,
               Editable->False], " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["a",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Rotation,
                Editable->False], "2"], " ", 
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False]}], "+", 
             RowBox[{"2", " ", 
              InterpretationBox[
               StyleBox["M",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Mass,
               Editable->False], " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False], "3"]}], "+", 
             RowBox[{
              SuperscriptBox[
               InterpretationBox[
                StyleBox["a",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Rotation,
                Editable->False], "2"], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["Cos",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                Cos,
                Editable->False], "[", 
               RowBox[{"2", " ", 
                InterpretationBox[
                 StyleBox["\[Theta]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Theta][],
                 Editable->False]}], "]"}], " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["Q",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Charge,
                  Editable->False], "2"], "-", 
                RowBox[{"3", " ", 
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]}]}], ")"}]}], "+", 
             RowBox[{
              SuperscriptBox[
               InterpretationBox[
                StyleBox["Q",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Charge,
                Editable->False], "2"], " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], "-", 
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "2"]}]}], ")"}]}]}], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{
                   InterpretationBox[
                    StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    Cos,
                    Editable->False], "[", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False], "]"}], "2"]}], "+", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "2"]}], ")"}], "2"]}]], ",", "0", ",", 
           "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           FractionBox[
            RowBox[{"2", " ", 
             InterpretationBox[
              StyleBox["a",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Rotation,
              Editable->False], " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["Q",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Charge,
                 Editable->False], "2"], "+", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["a",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Rotation,
                 Editable->False], "2"], "+", 
               RowBox[{
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "2"}], " ", 
                   InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False]}], "+", 
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False]}], ")"}]}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["Cos",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  Cos,
                  Editable->False], "[", 
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`\[Theta][],
                   Editable->False]}], "]"}]}], "+", 
               RowBox[{"4", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["Q",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Charge,
                  Editable->False], "2"], " ", 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]}], "+", 
               RowBox[{
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], "-", 
                  RowBox[{"6", " ", 
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], ")"}], " ", 
             RowBox[{
              InterpretationBox[
               StyleBox["Sin",
                ShowAutoStyles->False,
                AutoSpacing->False],
               Sin,
               Editable->False], "[", 
              RowBox[{"2", " ", 
               InterpretationBox[
                StyleBox["\[Theta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Theta][],
                Editable->False]}], "]"}]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["a",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Rotation,
                 Editable->False], "2"], "+", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["Cos",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  Cos,
                  Editable->False], "[", 
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`\[Theta][],
                   Editable->False]}], "]"}]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "2"]}]}], ")"}], "3"]], ",", "0", ",", 
           "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", 
           FractionBox[
            RowBox[{"8", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["Q",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Charge,
                 Editable->False], "2"], "+", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["a",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Rotation,
                 Editable->False], "2"], "+", 
               RowBox[{
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "2"}], " ", 
                   InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False]}], "+", 
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False]}], ")"}]}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "3"}], " ", 
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]}], "+", 
               RowBox[{"2", " ", 
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "3"]}], "+", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["Cos",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  Cos,
                  Editable->False], "[", 
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`\[Theta][],
                   Editable->False]}], "]"}], " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["Q",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Charge,
                    Editable->False], "2"], "-", 
                  RowBox[{"3", " ", 
                   InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False], " ", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}]}], ")"}]}], "+", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["Q",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Charge,
                  Editable->False], "2"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], "-", 
                  RowBox[{"2", " ", 
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], ")"}]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["a",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Rotation,
                 Editable->False], "2"], "+", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["Cos",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  Cos,
                  Editable->False], "[", 
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`\[Theta][],
                   Editable->False]}], "]"}]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "2"]}]}], ")"}], "4"]]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", 
           FractionBox[
            RowBox[{"2", " ", 
             InterpretationBox[
              StyleBox["a",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Rotation,
              Editable->False], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["Cos",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  Cos,
                  Editable->False], "[", 
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`\[Theta][],
                   Editable->False]}], "]"}]}], "+", 
               RowBox[{"4", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["Q",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Charge,
                  Editable->False], "2"], " ", 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]}], "+", 
               RowBox[{
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], "-", 
                  RowBox[{"6", " ", 
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], ")"}], " ", 
             RowBox[{
              InterpretationBox[
               StyleBox["Sin",
                ShowAutoStyles->False,
                AutoSpacing->False],
               Sin,
               Editable->False], "[", 
              RowBox[{"2", " ", 
               InterpretationBox[
                StyleBox["\[Theta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Theta][],
                Editable->False]}], "]"}]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["a",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Rotation,
                 Editable->False], "2"], "+", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["Cos",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  Cos,
                  Editable->False], "[", 
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`\[Theta][],
                   Editable->False]}], "]"}]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "2"]}]}], ")"}], "3"]], ",", "0"}], "}"}],
          ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"-", 
            FractionBox[
             RowBox[{"2", " ", 
              InterpretationBox[
               StyleBox["a",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Rotation,
               Editable->False], " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["Q",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Charge,
                  Editable->False], "2"], "+", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], "+", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False]}], "+", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}], ")"}]}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{"4", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["Q",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Charge,
                   Editable->False], "2"], " ", 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]}], "+", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], "-", 
                   RowBox[{"6", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], ")"}], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["Sin",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                Sin,
                Editable->False], "[", 
               RowBox[{"2", " ", 
                InterpretationBox[
                 StyleBox["\[Theta]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Theta][],
                 Editable->False]}], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], "+", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "2"]}]}], ")"}], "3"]]}], ",", "0", ",", 
           "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            RowBox[{"2", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "3"}], " ", 
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]}], "+", 
               RowBox[{"2", " ", 
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "3"]}], "+", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["Cos",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  Cos,
                  Editable->False], "[", 
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`\[Theta][],
                   Editable->False]}], "]"}], " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["Q",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Charge,
                    Editable->False], "2"], "-", 
                  RowBox[{"3", " ", 
                   InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False], " ", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}]}], ")"}]}], "+", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["Q",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Charge,
                  Editable->False], "2"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], "-", 
                  RowBox[{"2", " ", 
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], ")"}], " ", 
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["Sin",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                Sin,
                Editable->False], "[", 
               InterpretationBox[
                StyleBox["\[Theta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Theta][],
                Editable->False], "]"}], "2"]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["a",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Rotation,
                 Editable->False], "2"], "+", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["Cos",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  Cos,
                  Editable->False], "[", 
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`\[Theta][],
                   Editable->False]}], "]"}]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "2"]}]}], ")"}], "2"]], ",", "0", ",", 
           "0", ",", "0"}], "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", 
           FractionBox[
            RowBox[{"8", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["Q",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Charge,
                 Editable->False], "2"], "+", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["a",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Rotation,
                 Editable->False], "2"], "+", 
               RowBox[{
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "2"}], " ", 
                   InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False]}], "+", 
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False]}], ")"}]}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "6"}], " ", 
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]}], "+", 
               RowBox[{"4", " ", 
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "3"]}], "+", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["Cos",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  Cos,
                  Editable->False], "[", 
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`\[Theta][],
                   Editable->False]}], "]"}], " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["Q",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Charge,
                    Editable->False], "2"], "-", 
                  RowBox[{"6", " ", 
                   InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False], " ", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}]}], ")"}]}], "+", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["Q",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Charge,
                  Editable->False], "2"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], "-", 
                  RowBox[{"6", " ", 
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], ")"}]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["a",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Rotation,
                 Editable->False], "2"], "+", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["Cos",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  Cos,
                  Editable->False], "[", 
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`\[Theta][],
                   Editable->False]}], "]"}]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "2"]}]}], ")"}], "4"]], ",", "0", ",", 
           "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            RowBox[{"2", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "6"}], " ", 
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]}], "+", 
               RowBox[{"4", " ", 
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "3"]}], "+", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["Cos",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  Cos,
                  Editable->False], "[", 
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`\[Theta][],
                   Editable->False]}], "]"}], " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["Q",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Charge,
                    Editable->False], "2"], "-", 
                  RowBox[{"6", " ", 
                   InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False], " ", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}]}], ")"}]}], "+", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["Q",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Charge,
                  Editable->False], "2"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], "-", 
                  RowBox[{"6", " ", 
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], ")"}]}], 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], "+", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "2"]}]}], ")"}], "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["Q",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Charge,
                 Editable->False], "2"], "+", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["a",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Rotation,
                 Editable->False], "2"], "+", 
               RowBox[{
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "2"}], " ", 
                   InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False]}], "+", 
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False]}], ")"}]}]}], ")"}]}]], ",", "0", ",", 
           "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", 
           FractionBox[
            RowBox[{"8", " ", 
             InterpretationBox[
              StyleBox["a",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Rotation,
              Editable->False], " ", 
             RowBox[{
              InterpretationBox[
               StyleBox["Cot",
                ShowAutoStyles->False,
                AutoSpacing->False],
               Cot,
               Editable->False], "[", 
              InterpretationBox[
               StyleBox["\[Theta]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Theta][],
               Editable->False], "]"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["Cos",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  Cos,
                  Editable->False], "[", 
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`\[Theta][],
                   Editable->False]}], "]"}]}], "+", 
               RowBox[{"4", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["Q",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Charge,
                  Editable->False], "2"], " ", 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]}], "+", 
               RowBox[{
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], "-", 
                  RowBox[{"6", " ", 
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], ")"}]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["a",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Rotation,
                 Editable->False], "2"], "+", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["Cos",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  Cos,
                  Editable->False], "[", 
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`\[Theta][],
                   Editable->False]}], "]"}]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "2"]}]}], ")"}], "3"]]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", 
           RowBox[{"-", 
            FractionBox[
             RowBox[{"4", " ", 
              InterpretationBox[
               StyleBox["a",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Rotation,
               Editable->False], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{"4", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["Q",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Charge,
                   Editable->False], "2"], " ", 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]}], "+", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], "-", 
                   RowBox[{"6", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], ")"}], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["Sin",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                Sin,
                Editable->False], "[", 
               RowBox[{"2", " ", 
                InterpretationBox[
                 StyleBox["\[Theta]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Theta][],
                 Editable->False]}], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], "+", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "2"]}]}], ")"}], "3"]]}], ",", "0"}], 
          "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", 
           FractionBox[
            RowBox[{"4", " ", 
             InterpretationBox[
              StyleBox["a",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Rotation,
              Editable->False], " ", 
             RowBox[{
              InterpretationBox[
               StyleBox["Cot",
                ShowAutoStyles->False,
                AutoSpacing->False],
               Cot,
               Editable->False], "[", 
              InterpretationBox[
               StyleBox["\[Theta]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Theta][],
               Editable->False], "]"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["Cos",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  Cos,
                  Editable->False], "[", 
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`\[Theta][],
                   Editable->False]}], "]"}]}], "+", 
               RowBox[{"4", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["Q",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Charge,
                  Editable->False], "2"], " ", 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]}], "+", 
               RowBox[{
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], "-", 
                  RowBox[{"6", " ", 
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], ")"}]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["a",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Rotation,
                 Editable->False], "2"], "+", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["Cos",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  Cos,
                  Editable->False], "[", 
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`\[Theta][],
                   Editable->False]}], "]"}]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "2"]}]}], ")"}], "3"]]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", 
           RowBox[{"-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", "3"}], " ", 
               InterpretationBox[
                StyleBox["M",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Mass,
                Editable->False], " ", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["a",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Rotation,
                 Editable->False], "2"], " ", 
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False]}], "+", 
              RowBox[{"2", " ", 
               InterpretationBox[
                StyleBox["M",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Mass,
                Editable->False], " ", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False], "3"]}], "+", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["a",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Rotation,
                 Editable->False], "2"], " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["Cos",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 Cos,
                 Editable->False], "[", 
                RowBox[{"2", " ", 
                 InterpretationBox[
                  StyleBox["\[Theta]",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`\[Theta][],
                  Editable->False]}], "]"}], " ", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["Q",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Charge,
                   Editable->False], "2"], "-", 
                 RowBox[{"3", " ", 
                  InterpretationBox[
                   StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Mass,
                   Editable->False], " ", 
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False]}]}], ")"}]}], "+", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["Q",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Charge,
                 Editable->False], "2"], " ", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], "-", 
                 RowBox[{"2", " ", 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], " ", 
                  SuperscriptBox[
                   RowBox[{
                    InterpretationBox[
                    StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    Cos,
                    Editable->False], "[", 
                    InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False], "]"}], "2"]}], "+", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "2"]}], ")"}], "2"], " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["Q",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Charge,
                  Editable->False], "2"], "+", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], "+", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False]}], "+", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}], ")"}]}]}], ")"}]}]]}], ",", "0"}], 
          "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", "3"}], " ", 
              InterpretationBox[
               StyleBox["M",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Mass,
               Editable->False], " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["a",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Rotation,
                Editable->False], "2"], " ", 
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False]}], "+", 
             RowBox[{"2", " ", 
              InterpretationBox[
               StyleBox["M",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Mass,
               Editable->False], " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False], "3"]}], "+", 
             RowBox[{
              SuperscriptBox[
               InterpretationBox[
                StyleBox["a",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Rotation,
                Editable->False], "2"], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["Cos",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                Cos,
                Editable->False], "[", 
               RowBox[{"2", " ", 
                InterpretationBox[
                 StyleBox["\[Theta]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Theta][],
                 Editable->False]}], "]"}], " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["Q",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Charge,
                  Editable->False], "2"], "-", 
                RowBox[{"3", " ", 
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]}]}], ")"}]}], "+", 
             RowBox[{
              SuperscriptBox[
               InterpretationBox[
                StyleBox["Q",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Charge,
                Editable->False], "2"], " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], "-", 
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "2"]}]}], ")"}]}]}], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{
                   InterpretationBox[
                    StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    Cos,
                    Editable->False], "[", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False], "]"}], "2"]}], "+", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "2"]}], ")"}], "2"]}]], ",", "0", ",", 
           "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            RowBox[{
             InterpretationBox[
              StyleBox["a",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Rotation,
              Editable->False], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["Cos",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  Cos,
                  Editable->False], "[", 
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`\[Theta][],
                   Editable->False]}], "]"}]}], "+", 
               RowBox[{"4", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["Q",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Charge,
                  Editable->False], "2"], " ", 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]}], "+", 
               RowBox[{
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], "-", 
                  RowBox[{"6", " ", 
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], ")"}], " ", 
             RowBox[{
              InterpretationBox[
               StyleBox["Sin",
                ShowAutoStyles->False,
                AutoSpacing->False],
               Sin,
               Editable->False], "[", 
              RowBox[{"2", " ", 
               InterpretationBox[
                StyleBox["\[Theta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Theta][],
                Editable->False]}], "]"}]}], 
            RowBox[{"2", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["a",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Rotation,
                 Editable->False], "2"], "+", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["Cos",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  Cos,
                  Editable->False], "[", 
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`\[Theta][],
                   Editable->False]}], "]"}]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "2"]}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["Q",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Charge,
                 Editable->False], "2"], "+", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["a",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Rotation,
                 Editable->False], "2"], "+", 
               RowBox[{
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "2"}], " ", 
                   InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False]}], "+", 
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False]}], ")"}]}]}], ")"}]}]], ",", "0", ",", 
           "0", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", 
           RowBox[{"-", 
            FractionBox[
             RowBox[{"2", " ", 
              InterpretationBox[
               StyleBox["a",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Rotation,
               Editable->False], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{"4", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["Q",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Charge,
                   Editable->False], "2"], " ", 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]}], "+", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], "-", 
                   RowBox[{"6", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], ")"}], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["Sin",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                Sin,
                Editable->False], "[", 
               RowBox[{"2", " ", 
                InterpretationBox[
                 StyleBox["\[Theta]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Theta][],
                 Editable->False]}], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], "+", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "2"]}]}], ")"}], "3"]]}], ",", "0"}], 
          "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", 
           FractionBox[
            RowBox[{
             RowBox[{"6", " ", 
              InterpretationBox[
               StyleBox["M",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Mass,
               Editable->False], " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["a",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Rotation,
                Editable->False], "2"], " ", 
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False]}], "-", 
             RowBox[{"4", " ", 
              InterpretationBox[
               StyleBox["M",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Mass,
               Editable->False], " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False], "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["a",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Rotation,
                Editable->False], "2"], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["Cos",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                Cos,
                Editable->False], "[", 
               RowBox[{"2", " ", 
                InterpretationBox[
                 StyleBox["\[Theta]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Theta][],
                 Editable->False]}], "]"}], " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["Q",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Charge,
                  Editable->False], "2"], "-", 
                RowBox[{"3", " ", 
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]}]}], ")"}]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["Q",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Charge,
                Editable->False], "2"], " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], "-", 
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "2"]}]}], ")"}]}]}], 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], "+", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "2"]}]}], ")"}], "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["Q",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Charge,
                 Editable->False], "2"], "+", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["a",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Rotation,
                 Editable->False], "2"], "+", 
               RowBox[{
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "2"}], " ", 
                   InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False]}], "+", 
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False]}], ")"}]}]}], ")"}]}]]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             RowBox[{
              InterpretationBox[
               StyleBox["a",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Rotation,
               Editable->False], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{"4", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["Q",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Charge,
                   Editable->False], "2"], " ", 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]}], "+", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], "-", 
                   RowBox[{"6", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], ")"}], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["Sin",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                Sin,
                Editable->False], "[", 
               RowBox[{"2", " ", 
                InterpretationBox[
                 StyleBox["\[Theta]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Theta][],
                 Editable->False]}], "]"}]}], 
             RowBox[{"2", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], "+", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "2"]}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["Q",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Charge,
                  Editable->False], "2"], "+", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], "+", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False]}], "+", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}], ")"}]}]}], ")"}]}]]}], ",", "0", ",", 
           "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           FractionBox[
            RowBox[{"2", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "3"}], " ", 
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]}], "+", 
               RowBox[{"2", " ", 
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "3"]}], "+", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["Cos",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  Cos,
                  Editable->False], "[", 
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`\[Theta][],
                   Editable->False]}], "]"}], " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["Q",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Charge,
                    Editable->False], "2"], "-", 
                  RowBox[{"3", " ", 
                   InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False], " ", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}]}], ")"}]}], "+", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["Q",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Charge,
                  Editable->False], "2"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], "-", 
                  RowBox[{"2", " ", 
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], ")"}], " ", 
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["Sin",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                Sin,
                Editable->False], "[", 
               InterpretationBox[
                StyleBox["\[Theta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Theta][],
                Editable->False], "]"}], "2"]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["a",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Rotation,
                 Editable->False], "2"], "+", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["Cos",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  Cos,
                  Editable->False], "[", 
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`\[Theta][],
                   Editable->False]}], "]"}]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "2"]}]}], ")"}], "2"]], ",", "0", ",", 
           "0"}], "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", 
           RowBox[{"-", 
            FractionBox[
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["Q",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Charge,
                  Editable->False], "2"], "+", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], "+", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False]}], "+", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}], ")"}]}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "3"}], " ", 
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]}], "+", 
                RowBox[{"2", " ", 
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "3"]}], "+", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["Q",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Charge,
                    Editable->False], "2"], "-", 
                   RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False], " ", 
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}]}], ")"}]}], "+", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["Q",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Charge,
                   Editable->False], "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], ")"}]}], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], " ", 
                  SuperscriptBox[
                   RowBox[{
                    InterpretationBox[
                    StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    Cos,
                    Editable->False], "[", 
                    InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False], "]"}], "2"]}], "+", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "2"]}], ")"}], "4"]}]]}], ",", "0"}], 
          "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", 
           FractionBox[
            RowBox[{"4", " ", 
             InterpretationBox[
              StyleBox["a",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Rotation,
              Editable->False], " ", 
             RowBox[{
              InterpretationBox[
               StyleBox["Cot",
                ShowAutoStyles->False,
                AutoSpacing->False],
               Cot,
               Editable->False], "[", 
              InterpretationBox[
               StyleBox["\[Theta]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Theta][],
               Editable->False], "]"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["Cos",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  Cos,
                  Editable->False], "[", 
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`\[Theta][],
                   Editable->False]}], "]"}]}], "+", 
               RowBox[{"4", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["Q",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Charge,
                  Editable->False], "2"], " ", 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]}], "+", 
               RowBox[{
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], "-", 
                  RowBox[{"6", " ", 
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], ")"}]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["a",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Rotation,
                 Editable->False], "2"], "+", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["Cos",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  Cos,
                  Editable->False], "[", 
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`\[Theta][],
                   Editable->False]}], "]"}]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "2"]}]}], ")"}], "3"]]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", "3"}], " ", 
               InterpretationBox[
                StyleBox["M",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Mass,
                Editable->False], " ", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["a",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Rotation,
                 Editable->False], "2"], " ", 
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False]}], "+", 
              RowBox[{"2", " ", 
               InterpretationBox[
                StyleBox["M",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Mass,
                Editable->False], " ", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False], "3"]}], "+", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["a",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Rotation,
                 Editable->False], "2"], " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["Cos",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 Cos,
                 Editable->False], "[", 
                RowBox[{"2", " ", 
                 InterpretationBox[
                  StyleBox["\[Theta]",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`\[Theta][],
                  Editable->False]}], "]"}], " ", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["Q",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Charge,
                   Editable->False], "2"], "-", 
                 RowBox[{"3", " ", 
                  InterpretationBox[
                   StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Mass,
                   Editable->False], " ", 
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False]}]}], ")"}]}], "+", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["Q",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Charge,
                 Editable->False], "2"], " ", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], "-", 
                 RowBox[{"2", " ", 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], " ", 
                  SuperscriptBox[
                   RowBox[{
                    InterpretationBox[
                    StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    Cos,
                    Editable->False], "[", 
                    InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False], "]"}], "2"]}], "+", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "2"]}], ")"}], "2"]}]]}], ",", "0", ",", 
           "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"-", 
            FractionBox[
             RowBox[{"2", " ", 
              InterpretationBox[
               StyleBox["a",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Rotation,
               Editable->False], " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["Q",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Charge,
                  Editable->False], "2"], "+", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], "+", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False]}], "+", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}], ")"}]}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{"4", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["Q",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Charge,
                   Editable->False], "2"], " ", 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]}], "+", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], "-", 
                   RowBox[{"6", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], ")"}], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["Sin",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                Sin,
                Editable->False], "[", 
               RowBox[{"2", " ", 
                InterpretationBox[
                 StyleBox["\[Theta]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Theta][],
                 Editable->False]}], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], "+", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "2"]}]}], ")"}], "3"]]}], ",", "0", ",", 
           "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", 
           RowBox[{"-", 
            FractionBox[
             RowBox[{"4", " ", 
              InterpretationBox[
               StyleBox["a",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Rotation,
               Editable->False], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["Cot",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                Cot,
                Editable->False], "[", 
               InterpretationBox[
                StyleBox["\[Theta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Theta][],
                Editable->False], "]"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{"4", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["Q",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Charge,
                   Editable->False], "2"], " ", 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]}], "+", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], "-", 
                   RowBox[{"6", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], "+", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "2"]}]}], ")"}], "3"]]}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", "3"}], " ", 
              InterpretationBox[
               StyleBox["M",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Mass,
               Editable->False], " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["a",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Rotation,
                Editable->False], "2"], " ", 
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False]}], "+", 
             RowBox[{"2", " ", 
              InterpretationBox[
               StyleBox["M",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Mass,
               Editable->False], " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False], "3"]}], "+", 
             RowBox[{
              SuperscriptBox[
               InterpretationBox[
                StyleBox["a",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Rotation,
                Editable->False], "2"], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["Cos",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                Cos,
                Editable->False], "[", 
               RowBox[{"2", " ", 
                InterpretationBox[
                 StyleBox["\[Theta]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Theta][],
                 Editable->False]}], "]"}], " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["Q",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Charge,
                  Editable->False], "2"], "-", 
                RowBox[{"3", " ", 
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]}]}], ")"}]}], "+", 
             RowBox[{
              SuperscriptBox[
               InterpretationBox[
                StyleBox["Q",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Charge,
                Editable->False], "2"], " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], "-", 
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "2"]}]}], ")"}]}]}], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{
                   InterpretationBox[
                    StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    Cos,
                    Editable->False], "[", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False], "]"}], "2"]}], "+", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "2"]}], ")"}], "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["Q",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Charge,
                 Editable->False], "2"], "+", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["a",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Rotation,
                 Editable->False], "2"], "+", 
               RowBox[{
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "2"}], " ", 
                   InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False]}], "+", 
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False]}], ")"}]}]}], ")"}]}]], ",", "0"}], "}"}],
          ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", "3"}], " ", 
               InterpretationBox[
                StyleBox["M",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Mass,
                Editable->False], " ", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["a",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Rotation,
                 Editable->False], "2"], " ", 
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False]}], "+", 
              RowBox[{"2", " ", 
               InterpretationBox[
                StyleBox["M",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Mass,
                Editable->False], " ", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False], "3"]}], "+", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["a",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Rotation,
                 Editable->False], "2"], " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["Cos",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 Cos,
                 Editable->False], "[", 
                RowBox[{"2", " ", 
                 InterpretationBox[
                  StyleBox["\[Theta]",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`\[Theta][],
                  Editable->False]}], "]"}], " ", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["Q",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Charge,
                   Editable->False], "2"], "-", 
                 RowBox[{"3", " ", 
                  InterpretationBox[
                   StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Mass,
                   Editable->False], " ", 
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False]}]}], ")"}]}], "+", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["Q",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Charge,
                 Editable->False], "2"], " ", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], "-", 
                 RowBox[{"2", " ", 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], " ", 
                  SuperscriptBox[
                   RowBox[{
                    InterpretationBox[
                    StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    Cos,
                    Editable->False], "[", 
                    InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False], "]"}], "2"]}], "+", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "2"]}], ")"}], "2"]}]]}], ",", "0", ",", 
           "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             RowBox[{
              InterpretationBox[
               StyleBox["a",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Rotation,
               Editable->False], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{"4", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["Q",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Charge,
                   Editable->False], "2"], " ", 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]}], "+", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], "-", 
                   RowBox[{"6", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], ")"}], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["Sin",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                Sin,
                Editable->False], "[", 
               RowBox[{"2", " ", 
                InterpretationBox[
                 StyleBox["\[Theta]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Theta][],
                 Editable->False]}], "]"}]}], 
             RowBox[{"2", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], "+", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "2"]}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["Q",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Charge,
                  Editable->False], "2"], "+", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], "+", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False]}], "+", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}], ")"}]}]}], ")"}]}]]}], ",", "0", ",", 
           "0", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"-", 
            FractionBox[
             RowBox[{"4", " ", 
              InterpretationBox[
               StyleBox["a",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Rotation,
               Editable->False], " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["Q",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Charge,
                  Editable->False], "2"], "+", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], "+", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False]}], "+", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}], ")"}]}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{"4", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["Q",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Charge,
                   Editable->False], "2"], " ", 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]}], "+", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], "-", 
                   RowBox[{"6", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], ")"}], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["Sin",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                Sin,
                Editable->False], "[", 
               RowBox[{"2", " ", 
                InterpretationBox[
                 StyleBox["\[Theta]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Theta][],
                 Editable->False]}], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], "+", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "2"]}]}], ")"}], "3"]]}], ",", "0", ",", 
           "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             RowBox[{
              InterpretationBox[
               StyleBox["a",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Rotation,
               Editable->False], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{"4", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["Q",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Charge,
                   Editable->False], "2"], " ", 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]}], "+", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], "-", 
                   RowBox[{"6", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], ")"}], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["Sin",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                Sin,
                Editable->False], "[", 
               RowBox[{"2", " ", 
                InterpretationBox[
                 StyleBox["\[Theta]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Theta][],
                 Editable->False]}], "]"}]}], 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], "+", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "2"]}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["Q",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Charge,
                  Editable->False], "2"], "+", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], "+", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False]}], "+", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}], ")"}]}]}], ")"}]}]]}], ",", "0", ",", 
           "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", 
           RowBox[{"-", 
            FractionBox[
             RowBox[{"2", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["Q",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Charge,
                  Editable->False], "2"], "-", 
                RowBox[{"2", " ", 
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "3"}], " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"]}], "-", 
                RowBox[{"3", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "2"]}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], "+", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "2"]}]}], ")"}], "2"]]}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", 
           RowBox[{"-", 
            FractionBox[
             RowBox[{"2", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["Q",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Charge,
                  Editable->False], "2"], "-", 
                RowBox[{"2", " ", 
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"3", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"]}], "+", 
                RowBox[{"3", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}]}], "-", 
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "2"]}]}], ")"}], " ", 
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["Sin",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 Sin,
                 Editable->False], "[", 
                InterpretationBox[
                 StyleBox["\[Theta]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Theta][],
                 Editable->False], "]"}], "2"]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], "+", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "2"]}]}], ")"}], "2"]]}], ",", "0"}], 
          "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", 
           RowBox[{"-", 
            FractionBox[
             RowBox[{"8", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["Q",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Charge,
                  Editable->False], "2"], "+", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], "+", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False]}], "+", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}], ")"}]}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "3"}], " ", 
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]}], "+", 
                RowBox[{"2", " ", 
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "3"]}], "+", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["Q",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Charge,
                    Editable->False], "2"], "-", 
                   RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False], " ", 
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}]}], ")"}]}], "+", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["Q",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Charge,
                   Editable->False], "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], "+", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "2"]}]}], ")"}], "4"]]}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", 
           RowBox[{"-", 
            FractionBox[
             RowBox[{"2", " ", 
              InterpretationBox[
               StyleBox["a",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Rotation,
               Editable->False], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{"4", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["Q",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Charge,
                   Editable->False], "2"], " ", 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]}], "+", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], "-", 
                   RowBox[{"6", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], ")"}], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["Sin",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                Sin,
                Editable->False], "[", 
               RowBox[{"2", " ", 
                InterpretationBox[
                 StyleBox["\[Theta]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Theta][],
                 Editable->False]}], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], "+", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "2"]}]}], ")"}], "3"]]}], ",", "0"}], 
          "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           FractionBox[
            RowBox[{"2", " ", 
             InterpretationBox[
              StyleBox["a",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Rotation,
              Editable->False], " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["Q",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Charge,
                 Editable->False], "2"], "+", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["a",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Rotation,
                 Editable->False], "2"], "+", 
               RowBox[{
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "2"}], " ", 
                   InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False]}], "+", 
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False]}], ")"}]}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["Cos",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  Cos,
                  Editable->False], "[", 
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`\[Theta][],
                   Editable->False]}], "]"}]}], "+", 
               RowBox[{"4", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["Q",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Charge,
                  Editable->False], "2"], " ", 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]}], "+", 
               RowBox[{
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], "-", 
                  RowBox[{"6", " ", 
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], ")"}], " ", 
             RowBox[{
              InterpretationBox[
               StyleBox["Sin",
                ShowAutoStyles->False,
                AutoSpacing->False],
               Sin,
               Editable->False], "[", 
              RowBox[{"2", " ", 
               InterpretationBox[
                StyleBox["\[Theta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Theta][],
                Editable->False]}], "]"}]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["a",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Rotation,
                 Editable->False], "2"], "+", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["Cos",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  Cos,
                  Editable->False], "[", 
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`\[Theta][],
                   Editable->False]}], "]"}]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "2"]}]}], ")"}], "3"]], ",", "0", ",", 
           "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             RowBox[{"2", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "3"}], " ", 
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]}], "+", 
                RowBox[{"2", " ", 
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "3"]}], "+", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["Q",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Charge,
                    Editable->False], "2"], "-", 
                   RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False], " ", 
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}]}], ")"}]}], "+", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["Q",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Charge,
                   Editable->False], "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], ")"}], " ", 
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["Sin",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 Sin,
                 Editable->False], "[", 
                InterpretationBox[
                 StyleBox["\[Theta]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Theta][],
                 Editable->False], "]"}], "2"]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], "+", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "2"]}]}], ")"}], "2"]]}], ",", "0", ",", 
           "0", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", 
           FractionBox[
            RowBox[{"2", " ", 
             InterpretationBox[
              StyleBox["a",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Rotation,
              Editable->False], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["Cos",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  Cos,
                  Editable->False], "[", 
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`\[Theta][],
                   Editable->False]}], "]"}]}], "+", 
               RowBox[{"4", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["Q",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Charge,
                  Editable->False], "2"], " ", 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]}], "+", 
               RowBox[{
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], "-", 
                  RowBox[{"6", " ", 
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], ")"}], " ", 
             RowBox[{
              InterpretationBox[
               StyleBox["Sin",
                ShowAutoStyles->False,
                AutoSpacing->False],
               Sin,
               Editable->False], "[", 
              RowBox[{"2", " ", 
               InterpretationBox[
                StyleBox["\[Theta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Theta][],
                Editable->False]}], "]"}]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["a",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Rotation,
                 Editable->False], "2"], "+", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["Cos",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  Cos,
                  Editable->False], "[", 
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`\[Theta][],
                   Editable->False]}], "]"}]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "2"]}]}], ")"}], "3"]], ",", "0"}], "}"}],
          ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", 
           RowBox[{"-", 
            FractionBox[
             RowBox[{
              RowBox[{"6", " ", 
               InterpretationBox[
                StyleBox["M",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Mass,
                Editable->False], " ", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["a",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Rotation,
                 Editable->False], "2"], " ", 
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False]}], "-", 
              RowBox[{"4", " ", 
               InterpretationBox[
                StyleBox["M",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Mass,
                Editable->False], " ", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False], "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["a",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Rotation,
                 Editable->False], "2"], " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["Cos",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 Cos,
                 Editable->False], "[", 
                RowBox[{"2", " ", 
                 InterpretationBox[
                  StyleBox["\[Theta]",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`\[Theta][],
                  Editable->False]}], "]"}], " ", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["Q",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Charge,
                   Editable->False], "2"], "-", 
                 RowBox[{"3", " ", 
                  InterpretationBox[
                   StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Mass,
                   Editable->False], " ", 
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False]}]}], ")"}]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["Q",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Charge,
                 Editable->False], "2"], " ", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], "-", 
                 RowBox[{"2", " ", 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], 
             RowBox[{
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], "+", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    Cos,
                    Editable->False], "[", 
                   RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}]}], "+", 
                 RowBox[{"2", " ", 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}], "2"], " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["Q",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Charge,
                  Editable->False], "2"], "+", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], "+", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False]}], "+", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}], ")"}]}]}], ")"}]}]]}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            RowBox[{
             InterpretationBox[
              StyleBox["a",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Rotation,
              Editable->False], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["Cos",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  Cos,
                  Editable->False], "[", 
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`\[Theta][],
                   Editable->False]}], "]"}]}], "+", 
               RowBox[{"4", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["Q",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Charge,
                  Editable->False], "2"], " ", 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]}], "+", 
               RowBox[{
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], "-", 
                  RowBox[{"6", " ", 
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], ")"}], " ", 
             RowBox[{
              InterpretationBox[
               StyleBox["Sin",
                ShowAutoStyles->False,
                AutoSpacing->False],
               Sin,
               Editable->False], "[", 
              RowBox[{"2", " ", 
               InterpretationBox[
                StyleBox["\[Theta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Theta][],
                Editable->False]}], "]"}]}], 
            RowBox[{"2", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["a",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Rotation,
                 Editable->False], "2"], "+", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["Cos",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  Cos,
                  Editable->False], "[", 
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`\[Theta][],
                   Editable->False]}], "]"}]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "2"]}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["Q",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Charge,
                 Editable->False], "2"], "+", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["a",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Rotation,
                 Editable->False], "2"], "+", 
               RowBox[{
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "2"}], " ", 
                   InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False]}], "+", 
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False]}], ")"}]}]}], ")"}]}]], ",", "0", ",", 
           "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"-", 
            FractionBox[
             RowBox[{"2", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "3"}], " ", 
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]}], "+", 
                RowBox[{"2", " ", 
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "3"]}], "+", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["Q",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Charge,
                    Editable->False], "2"], "-", 
                   RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False], " ", 
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}]}], ")"}]}], "+", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["Q",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Charge,
                   Editable->False], "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], ")"}], " ", 
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["Sin",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 Sin,
                 Editable->False], "[", 
                InterpretationBox[
                 StyleBox["\[Theta]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Theta][],
                 Editable->False], "]"}], "2"]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], "+", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["Cos",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   Cos,
                   Editable->False], "[", 
                  RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "2"]}]}], ")"}], "2"]]}], ",", "0", ",", 
           "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", 
           FractionBox[
            RowBox[{"4", " ", 
             InterpretationBox[
              StyleBox["a",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Rotation,
              Editable->False], " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["Q",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Charge,
                 Editable->False], "2"], "+", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["a",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Rotation,
                 Editable->False], "2"], "+", 
               RowBox[{
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "2"}], " ", 
                   InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False]}], "+", 
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False]}], ")"}]}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["Cos",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  Cos,
                  Editable->False], "[", 
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`\[Theta][],
                   Editable->False]}], "]"}]}], "+", 
               RowBox[{"4", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["Q",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Charge,
                  Editable->False], "2"], " ", 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]}], "+", 
               RowBox[{
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], "-", 
                  RowBox[{"6", " ", 
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], ")"}], " ", 
             RowBox[{
              InterpretationBox[
               StyleBox["Sin",
                ShowAutoStyles->False,
                AutoSpacing->False],
               Sin,
               Editable->False], "[", 
              RowBox[{"2", " ", 
               InterpretationBox[
                StyleBox["\[Theta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Theta][],
                Editable->False]}], "]"}]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["a",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Rotation,
                 Editable->False], "2"], "+", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["Cos",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  Cos,
                  Editable->False], "[", 
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`\[Theta][],
                   Editable->False]}], "]"}]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "2"]}]}], ")"}], "3"]], ",", "0", ",", 
           "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            RowBox[{
             InterpretationBox[
              StyleBox["a",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Rotation,
              Editable->False], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["Cos",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  Cos,
                  Editable->False], "[", 
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`\[Theta][],
                   Editable->False]}], "]"}]}], "+", 
               RowBox[{"4", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["Q",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Charge,
                  Editable->False], "2"], " ", 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]}], "+", 
               RowBox[{
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Rotation,
                    Editable->False], "2"], "-", 
                  RowBox[{"6", " ", 
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]}], ")"}]}]}], ")"}], " ", 
             RowBox[{
              InterpretationBox[
               StyleBox["Sin",
                ShowAutoStyles->False,
                AutoSpacing->False],
               Sin,
               Editable->False], "[", 
              RowBox[{"2", " ", 
               InterpretationBox[
                StyleBox["\[Theta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Theta][],
                Editable->False]}], "]"}]}], 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["a",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Rotation,
                 Editable->False], "2"], "+", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["Cos",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  Cos,
                  Editable->False], "[", 
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`\[Theta][],
                   Editable->False]}], "]"}]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "2"]}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["Q",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Charge,
                 Editable->False], "2"], "+", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["a",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Rotation,
                 Editable->False], "2"], "+", 
               RowBox[{
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "2"}], " ", 
                   InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False]}], "+", 
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False]}], ")"}]}]}], ")"}]}]], ",", "0", ",", 
           "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", 
           FractionBox[
            RowBox[{"2", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["Q",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Charge,
                 Editable->False], "2"], "-", 
               RowBox[{"2", " ", 
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], " ", 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "3"}], " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"]}], "-", 
               RowBox[{"3", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["Cos",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  Cos,
                  Editable->False], "[", 
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`\[Theta][],
                   Editable->False]}], "]"}]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "2"]}]}], ")"}]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["a",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Rotation,
                 Editable->False], "2"], "+", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["Cos",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  Cos,
                  Editable->False], "[", 
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`\[Theta][],
                   Editable->False]}], "]"}]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "2"]}]}], ")"}], "2"]]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", 
           FractionBox[
            RowBox[{"2", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["Q",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Charge,
                 Editable->False], "2"], "-", 
               RowBox[{"2", " ", 
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], " ", 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"3", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"]}], "+", 
               RowBox[{"3", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["Cos",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  Cos,
                  Editable->False], "[", 
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`\[Theta][],
                   Editable->False]}], "]"}]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "2"]}]}], ")"}], " ", 
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["Sin",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                Sin,
                Editable->False], "[", 
               InterpretationBox[
                StyleBox["\[Theta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Theta][],
                Editable->False], "]"}], "2"]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["a",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Rotation,
                 Editable->False], "2"], "+", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["Cos",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  Cos,
                  Editable->False], "[", 
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`\[Theta][],
                   Editable->False]}], "]"}]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "2"]}]}], ")"}], "2"]], ",", "0"}], 
          "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}]}], 
      "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "frame"}], ",", 
     RowBox[{"-", "frame"}], ",", 
     RowBox[{"-", "frame"}], ",", "frame"}], "}"}], ",", "0"}], 
  "]"}]], "Output",ExpressionUUID->"e8811d00-8a1e-48be-a5e6-d01c29de9762"]
}, Open  ]],

Cell["Check the Bianchi identity:", "Text",ExpressionUUID->"fcca58b1-25ef-4582-9113-bb08ddaef2be"],

Cell[BoxData[
 RowBox[{
  RowBox[{"cdriemdown", "=", 
   RowBox[{"TensorDerivative", "[", 
    RowBox[{
     RowBox[{"RiemannDown", "[", "cd", "]"}], ",", "cd"}], "]"}]}], 
  ";"}]], "Input",ExpressionUUID->"2ad84f4a-6fc3-48f3-8ec3-525a978a7810"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"cdriemdown", "[", 
     RowBox[{
      RowBox[{"-", "a"}], ",", 
      RowBox[{"-", "b"}], ",", 
      RowBox[{"-", "c"}], ",", 
      RowBox[{"-", "d"}], ",", 
      RowBox[{"-", "e"}]}], "]"}], "+", 
    RowBox[{"cdriemdown", "[", 
     RowBox[{
      RowBox[{"-", "b"}], ",", 
      RowBox[{"-", "c"}], ",", 
      RowBox[{"-", "a"}], ",", 
      RowBox[{"-", "d"}], ",", 
      RowBox[{"-", "e"}]}], "]"}], "+", 
    RowBox[{"cdriemdown", "[", 
     RowBox[{
      RowBox[{"-", "c"}], ",", 
      RowBox[{"-", "a"}], ",", 
      RowBox[{"-", "b"}], ",", 
      RowBox[{"-", "d"}], ",", 
      RowBox[{"-", "e"}]}], "]"}]}], "//", "Simplify"}], "//", 
  "Timing"}]], "Input",ExpressionUUID->"a480ba8c-d490-471d-99b4-26c63fd6054e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.007106`", ",", "0"}], "}"}]], "Output",ExpressionUUID->"8d4e43f4-\
0691-4d3b-995a-d7086110cad3"]
}, Open  ]],

Cell["Clean up:", "Text",ExpressionUUID->"d9067f14-7725-4050-87d3-999b411aa4f5"],

Cell[BoxData[
 RowBox[{"UnsetCMetric", "[", "metric", "]"}]], "Input",ExpressionUUID->"f4d09861-8c7b-444e-8579-1f83fb755182"],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{
  "metric", ",", "cd", ",", "factor", ",", "\[Rho]2", ",", "change", ",", 
   "cdriemdown"}], "]"}]], "Input",ExpressionUUID->"8f9fbfe2-c79d-47e5-a5df-\
8e6cea3bcb8d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefConstantSymbol", "[", 
   RowBox[{"{", 
    RowBox[{"Mass", ",", "Rotation", ",", "Charge"}], "}"}], "]"}], 
  ";"}]], "Input",ExpressionUUID->"ab4283b5-5256-4fab-a404-1dda05472990"],

Cell[BoxData[
 RowBox[{"UndefBasis", "[", "frame", "]"}]], "Input",ExpressionUUID->"9a912ec4-5d2b-41b9-8a6d-a65276ddec6a"],

Cell[BoxData[
 RowBox[{"UndefChart", "[", "BL", "]"}]], "Input",ExpressionUUID->"cb4db2dc-9b6c-41cb-9592-94b6b920d429"],

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M", "]"}]], "Input",ExpressionUUID->"171a2aed-f1d9-4300-865e-ec0ab1638a71"],

Cell["Clear the cache:", "Text",ExpressionUUID->"9ccd2355-9c15-44ac-98fd-18f6fb4e625e"],

Cell[BoxData[
 RowBox[{"ClearxCobaCache", "[", "All", "]"}]], "Input",ExpressionUUID->"0ec9c9b4-7291-41e6-a2fd-0201704a65cd"]
}, Closed]],

Cell[CellGroupData[{

Cell["4.2. General 2d metric connection with torsion", "Subsubsection",ExpressionUUID->"da9aeebf-8b52-4c1d-b5e6-e1e320aed1cd"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<xAct`xCoba`\>\"", "]"}]], "Input",ExpressionUUID->"2df56329-73ec-4513-9109-c724b9014f49"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$DefInfoQ", "=", 
   RowBox[{"$UndefInfoQ", "=", "False"}]}], ";"}]], "Input",ExpressionUUID->\
"a4181ad7-ea56-4667-9685-b370776e3791"],

Cell["Define a 2d manifold:", "Text",ExpressionUUID->"74162809-8680-46df-b4ab-fe6c0d535cee"],

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"1bc516fe-d590-494c-9c9d-1706b99001fc"],

Cell["with a general chart:", "Text",ExpressionUUID->"7b5214a2-e727-485b-b55e-0af9685d44b2"],

Cell[BoxData[
 RowBox[{"DefChart", "[", 
  RowBox[{"gen", ",", "M", ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x", "[", "]"}], ",", 
     RowBox[{"y", "[", "]"}]}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"e95202bf-1edb-4443-baa4-67d476fcd998"],

Cell["Let us now work with a fully general metric:", "Text",ExpressionUUID->"6c2fea67-c6d8-482c-8d68-162ee8e828d5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefScalarFunction", "/@", 
   RowBox[{"{", 
    RowBox[{"gxx", ",", "gxy", ",", "gyy"}], "}"}]}], ";"}]], "Input",Expressi\
onUUID->"3297831c-356f-4bf7-a1ad-b1f857ae511b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"metric", "=", 
    RowBox[{"CTensor", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"gxx", "[", 
           RowBox[{
            RowBox[{"x", "[", "]"}], ",", 
            RowBox[{"y", "[", "]"}]}], "]"}], ",", 
          RowBox[{"gxy", "[", 
           RowBox[{
            RowBox[{"x", "[", "]"}], ",", 
            RowBox[{"y", "[", "]"}]}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"gxy", "[", 
           RowBox[{
            RowBox[{"x", "[", "]"}], ",", 
            RowBox[{"y", "[", "]"}]}], "]"}], ",", 
          RowBox[{"gyy", "[", 
           RowBox[{
            RowBox[{"x", "[", "]"}], ",", 
            RowBox[{"y", "[", "]"}]}], "]"}]}], "}"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "gen"}], ",", 
        RowBox[{"-", "gen"}]}], "}"}]}], "]"}]}], ")"}], "[", 
  RowBox[{
   RowBox[{"-", "a"}], ",", 
   RowBox[{"-", "b"}]}], "]"}]], "Input",ExpressionUUID->"a360bb2c-dcf1-4dc0-\
8cd2-122120989c5c"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox[
            RowBox[{
             InterpretationBox[
              StyleBox["gxx",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxx,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                  False], $CellContext`gxx, Editable -> False], "[", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                   "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`x[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                   "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`y[], Editable -> False]}], "]"}]}]],
           Annotation[#, {1, 1} -> $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]], "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{
             InterpretationBox[
              StyleBox["gxy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxy,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                  False], $CellContext`gxy, Editable -> False], "[", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                   "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`x[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                   "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`y[], Editable -> False]}], "]"}]}]],
           Annotation[#, {1, 2} -> $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]], "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox[
            RowBox[{
             InterpretationBox[
              StyleBox["gxy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxy,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                  False], $CellContext`gxy, Editable -> False], "[", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                   "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`x[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                   "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`y[], Editable -> False]}], "]"}]}]],
           Annotation[#, {2, 1} -> $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]], "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{
             InterpretationBox[
              StyleBox["gyy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gyy,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                  False], $CellContext`gyy, Editable -> False], "[", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                   "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`x[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                   "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`y[], Editable -> False]}], "]"}]}]],
           Annotation[#, {2, 2} -> $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]], "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {" ", " "},
         {"a", "b"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{
     $CellContext`gxx[
      $CellContext`x[], 
      $CellContext`y[]], 
     $CellContext`gxy[
      $CellContext`x[], 
      $CellContext`y[]]}, {
     $CellContext`gxy[
      $CellContext`x[], 
      $CellContext`y[]], 
     $CellContext`gyy[
      $CellContext`x[], 
      $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 
   0][-$CellContext`a, -$CellContext`b],
  Editable->False]], "Output",ExpressionUUID->"41659e77-7641-464b-97a2-\
81d925b1d981"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SymmetryGroupOfTensor", "[", "metric", "]"}]], "Input",ExpressionUUID->"5a8b72c0-4db1-4e17-990a-094d1e454f22"],

Cell[BoxData[
 RowBox[{"StrongGenSet", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"GenSet", "[", 
    InterpretationBox[
     StyleBox[
      RowBox[{"(", "1", ",", "2", ")"}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xPerm`Cycles[{1, 2}],
     Editable->False], "]"}]}], "]"}]], "Output",ExpressionUUID->"bd68bd28-\
6e93-4b88-b344-6d8eea5e7351"]
}, Open  ]],

Cell["\<\
In this case we will also have torsion, a general torsion tensor:\
\>", "Text",ExpressionUUID->"17106acf-564a-4a52-9bfc-8066e7551f83"],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefScalarFunction", "/@", 
   RowBox[{"{", 
    RowBox[{"T112", ",", "T212"}], "}"}]}], ";"}]], "Input",ExpressionUUID->\
"760753ed-9e70-4ff1-87b6-95c9ab1926da"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"torsion", "=", 
    RowBox[{"CTensor", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", 
            RowBox[{"T112", "[", 
             RowBox[{
              RowBox[{"x", "[", "]"}], ",", 
              RowBox[{"y", "[", "]"}]}], "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", 
             RowBox[{"T112", "[", 
              RowBox[{
               RowBox[{"x", "[", "]"}], ",", 
               RowBox[{"y", "[", "]"}]}], "]"}]}], ",", "0"}], "}"}]}], "}"}],
         ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", 
            RowBox[{"T212", "[", 
             RowBox[{
              RowBox[{"x", "[", "]"}], ",", 
              RowBox[{"y", "[", "]"}]}], "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", 
             RowBox[{"T212", "[", 
              RowBox[{
               RowBox[{"x", "[", "]"}], ",", 
               RowBox[{"y", "[", "]"}]}], "]"}]}], ",", "0"}], "}"}]}], 
         "}"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"gen", ",", 
        RowBox[{"-", "gen"}], ",", 
        RowBox[{"-", "gen"}]}], "}"}]}], "]"}]}], ")"}], "[", 
  RowBox[{"a", ",", 
   RowBox[{"-", "b"}], ",", 
   RowBox[{"-", "c"}]}], "]"}]], "Input",ExpressionUUID->"a5ecdfa5-c718-462f-\
ae15-f545b4ea84cc"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["T112",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`T112,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 1, 2} -> $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["T112",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`T112,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{"-", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]],
              Annotation[#, {1, 2, 1} -> -$CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 1} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["T212",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`T212,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 1, 2} -> $CellContext`T212[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["T212",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`T212,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{"-", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]],
              Annotation[#, {2, 2, 1} -> -$CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {"a", " ", " "},
         {" ", "b", "c"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{{0, 
      $CellContext`T112[
       $CellContext`x[], 
       $CellContext`y[]]}, {-$CellContext`T112[
        $CellContext`x[], 
        $CellContext`y[]], 0}}, {{0, 
      $CellContext`T212[
       $CellContext`x[], 
       $CellContext`y[]]}, {-$CellContext`T212[
        $CellContext`x[], 
        $CellContext`y[]], 
      0}}}, {$CellContext`gen, -$CellContext`gen, -$CellContext`gen}, 
   0][$CellContext`a, -$CellContext`b, -$CellContext`c],
  Editable->False]], "Output",ExpressionUUID->"3b4d5483-91a7-463b-b509-\
3cbe676fbff4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SymmetryGroupOfTensor", "[", "torsion", "]"}]], "Input",ExpressionUU\
ID->"526bcaf6-daff-4318-8d7e-5726868b70e0"],

Cell[BoxData[
 RowBox[{"StrongGenSet", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", "3"}], "}"}], ",", 
   RowBox[{"GenSet", "[", 
    InterpretationBox[
     StyleBox[
      RowBox[{"-", 
       RowBox[{"(", "2", ",", "3", ")"}]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     -xAct`xPerm`Cycles[{2, 3}],
     Editable->False], "]"}]}], "]"}]], "Output",ExpressionUUID->"e74320c3-\
b0f6-4ae0-88cb-a0bf6717494f"]
}, Open  ]],

Cell["Declare the corresponding metric connection with torsion:", "Text",ExpressionUUID->"a858c619-c7fd-4857-bc01-10066c7679c3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"SetCMetric", "[", 
   RowBox[{"metric", ",", "torsion", ",", "gen"}], "]"}], "//", 
  "Timing"}]], "Input",ExpressionUUID->"136dcce8-57ff-4319-b67f-132a1fb99f0d"],

Cell[BoxData[
 TemplateBox[{
  "SignatureOfMetric","num",
   "\"Cannot determine signature of matrix \\!\\(\\*RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \
RowBox[{RowBox[{InterpretationBox[StyleBox[RowBox[{\\\"gxx\\\"}], \
Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], gxx, Rule[Editable, \
False]], \\\"[\\\", RowBox[{InterpretationBox[StyleBox[\\\"x\\\", \
Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], x[], Rule[Editable, \
False]], \\\",\\\", InterpretationBox[StyleBox[\\\"y\\\", Rule[AutoSpacing, \
False], Rule[ShowAutoStyles, False]], y[], Rule[Editable, False]]}], \
\\\"]\\\"}], \\\",\\\", \
RowBox[{InterpretationBox[StyleBox[RowBox[{\\\"gxy\\\"}], Rule[AutoSpacing, \
False], Rule[ShowAutoStyles, False]], gxy, Rule[Editable, False]], \\\"[\\\", \
RowBox[{InterpretationBox[StyleBox[\\\"x\\\", Rule[AutoSpacing, False], \
Rule[ShowAutoStyles, False]], x[], Rule[Editable, False]], \\\",\\\", \
InterpretationBox[StyleBox[\\\"y\\\", Rule[AutoSpacing, False], \
Rule[ShowAutoStyles, False]], y[], Rule[Editable, False]]}], \\\"]\\\"}]}], \
\\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \
RowBox[{RowBox[{InterpretationBox[StyleBox[RowBox[{\\\"gxy\\\"}], \
Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], gxy, Rule[Editable, \
False]], \\\"[\\\", RowBox[{InterpretationBox[StyleBox[\\\"x\\\", \
Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], x[], Rule[Editable, \
False]], \\\",\\\", InterpretationBox[StyleBox[\\\"y\\\", Rule[AutoSpacing, \
False], Rule[ShowAutoStyles, False]], y[], Rule[Editable, False]]}], \
\\\"]\\\"}], \\\",\\\", \
RowBox[{InterpretationBox[StyleBox[RowBox[{\\\"gyy\\\"}], Rule[AutoSpacing, \
False], Rule[ShowAutoStyles, False]], gyy, Rule[Editable, False]], \\\"[\\\", \
RowBox[{InterpretationBox[StyleBox[\\\"x\\\", Rule[AutoSpacing, False], \
Rule[ShowAutoStyles, False]], x[], Rule[Editable, False]], \\\",\\\", \
InterpretationBox[StyleBox[\\\"y\\\", Rule[AutoSpacing, False], \
Rule[ShowAutoStyles, False]], y[], Rule[Editable, False]]}], \\\"]\\\"}]}], \
\\\"}\\\"}]}], \\\"}\\\"}]\\). Assuming Euclidean signature.\"",2,243,5,
   19248039995900841960,"Local","xAct`xTensor`SignatureOfMetric"},
  "MessageTemplate2"]], "Message", \
"MSG",ExpressionUUID->"2a6a5b8a-2f14-46c9-a851-c6e756ba33f3"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.124767`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"57d1e141-9002-4749-bd0e-ba6fcb007669"]
}, Open  ]],

Cell["\<\
This is now the covariant derivative associated to the metric:\
\>", "Text",ExpressionUUID->"01a76dbe-6b1d-4073-b0e1-d0bae4dbf029"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"cd", "=", 
  RowBox[{"CovDOfMetric", "[", "metric", "]"}]}]], "Input",ExpressionUUID->\
"f8564750-6e0a-458b-b700-6324fe7e5ee8"],

Cell[BoxData[
 RowBox[{"CCovD", "[", 
  RowBox[{"PDgen", ",", 
   RowBox[{"CTensor", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"2", " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gxx,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gxy,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`T112,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`T212,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gyy,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                   TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                   MultilineFunction->None], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gxy,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}]}], ")"}], "/", 
              RowBox[{"(", 
               RowBox[{"2", " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "-", 
                  RowBox[{
                   RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], ")"}]}], ")"}]}], 
           ",", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", "2"}], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["gxx",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxx,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["gyy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gyy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["T112",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`T112,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}], "-", 
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gyy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gyy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], 
                TagBox[
                 RowBox[{"(", 
                  RowBox[{"0", ",", "1"}], ")"}],
                 Derivative],
                MultilineFunction->None], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}], "+", 
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "2"}], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gyy,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`T212,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gyy,
                   Editable->False], 
                  TagBox[
                   RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                   Derivative],
                  MultilineFunction->None], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}]}], ")"}]}]}], 
            RowBox[{"2", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}], "2"], "-", 
               RowBox[{
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxx",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxx,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["gyy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gyy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}]}]}], ")"}]}]]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", "2"}], " ", 
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], "2"], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["T112",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`T112,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}], "-", 
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gyy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gyy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], 
                TagBox[
                 RowBox[{"(", 
                  RowBox[{"0", ",", "1"}], ")"}],
                 Derivative],
                MultilineFunction->None], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}], "+", 
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "2"}], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gyy,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`T212,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gyy,
                   Editable->False], 
                  TagBox[
                   RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                   Derivative],
                  MultilineFunction->None], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}]}], ")"}]}]}], 
            RowBox[{"2", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}], "2"], "-", 
               RowBox[{
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxx",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxx,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["gyy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gyy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}]}]}], ")"}]}]], ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"-", "2"}], " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                   TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                   MultilineFunction->None], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}], "+", 
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"-", "2"}], " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                   TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                   MultilineFunction->None], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"2", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gxy,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "-", 
                RowBox[{
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gxx,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gyy,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], ")"}]}]}], 
          "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", 
               SuperscriptBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxx",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxx,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}], "2"], " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["T112",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`T112,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}]}], "+", 
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["gxx",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxx,
                  Editable->False], 
                 TagBox[
                  RowBox[{"(", 
                   RowBox[{"1", ",", "0"}], ")"}],
                  Derivative],
                 MultilineFunction->None], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}]}], "+", 
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"2", " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                   TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                   MultilineFunction->None], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"2", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gxy,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "-", 
                RowBox[{
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gxx,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gyy,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], ")"}]}], ",", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"2", " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gxy,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`T212,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gxx,
                   Editable->False], 
                  TagBox[
                   RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                   Derivative],
                  MultilineFunction->None], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gxx",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxx,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"2", " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gxy,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`T112,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gyy,
                   Editable->False], 
                  TagBox[
                   RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                   Derivative],
                  MultilineFunction->None], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}]}], ")"}]}]}], 
            RowBox[{"2", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}], "2"], "-", 
               RowBox[{
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxx",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxx,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["gyy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gyy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}]}]}], ")"}]}]]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], 
                TagBox[
                 RowBox[{"(", 
                  RowBox[{"0", ",", "1"}], ")"}],
                 Derivative],
                MultilineFunction->None], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}], "+", 
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gxx",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxx,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"2", " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gxy,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`T112,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{"2", " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gyy,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`T212,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gyy,
                   Editable->False], 
                  TagBox[
                   RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                   Derivative],
                  MultilineFunction->None], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}]}], ")"}]}]}], 
            RowBox[{"2", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}], "2"], "-", 
               RowBox[{
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxx",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxx,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["gyy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gyy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}]}]}], ")"}]}]], ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", 
               SuperscriptBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}], "2"], " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["T112",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`T112,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}]}], "-", 
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["gyy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gyy,
                  Editable->False], 
                 TagBox[
                  RowBox[{"(", 
                   RowBox[{"0", ",", "1"}], ")"}],
                  Derivative],
                 MultilineFunction->None], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}]}], "+", 
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"2", " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                   TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                   MultilineFunction->None], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"2", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gxy,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "-", 
                RowBox[{
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gxx,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gyy,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], ")"}]}]}], 
          "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"gen", ",", 
       RowBox[{"-", "gen"}], ",", 
       RowBox[{"-", "gen"}]}], "}"}], ",", "0"}], "]"}], ",", 
   RowBox[{"CTensor", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          InterpretationBox[
           StyleBox["gxx",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gxx,
           Editable->False], "[", 
          RowBox[{
           InterpretationBox[
            StyleBox["x",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x[],
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["y",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`y[],
            Editable->False]}], "]"}], ",", 
         RowBox[{
          InterpretationBox[
           StyleBox["gxy",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gxy,
           Editable->False], "[", 
          RowBox[{
           InterpretationBox[
            StyleBox["x",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x[],
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["y",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`y[],
            Editable->False]}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          InterpretationBox[
           StyleBox["gxy",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gxy,
           Editable->False], "[", 
          RowBox[{
           InterpretationBox[
            StyleBox["x",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x[],
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["y",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`y[],
            Editable->False]}], "]"}], ",", 
         RowBox[{
          InterpretationBox[
           StyleBox["gyy",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gyy,
           Editable->False], "[", 
          RowBox[{
           InterpretationBox[
            StyleBox["x",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x[],
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["y",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`y[],
            Editable->False]}], "]"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "gen"}], ",", 
       RowBox[{"-", "gen"}]}], "}"}], ",", "0"}], "]"}]}], "]"}]], "Output",Ex\
pressionUUID->"10a0d2a3-5546-44af-a3a5-368d4de51ef3"]
}, Open  ]],

Cell["It has the torsion we provided:", "Text",ExpressionUUID->"4b5bc727-effd-41ec-9024-5c66a404edb1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Torsion", "[", "cd", "]"}], "===", "torsion"}]], "Input",Expression\
UUID->"a1817a78-148c-4599-aba2-fd2c6ca71196"],

Cell[BoxData["True"], "Output",ExpressionUUID->"3b888d93-4a3e-4671-a12c-e3811b9436fd"]
}, Open  ]],

Cell["The Christoffel tensor is not symmetric:", "Text",ExpressionUUID->"06fc9fe2-d1b2-47d5-9ef1-c338651e46ad"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"christoffel", "=", 
  RowBox[{"Christoffel", "[", 
   RowBox[{"cd", ",", "PDgen"}], "]"}]}]], "Input",ExpressionUUID->"4ceba1e9-\
bbdf-4cf8-8edb-04a80b199066"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["T112",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`T112,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}], "2"], " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["T212",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`T212,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}]}], "+", 
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["gxx",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxx,
                  Editable->False], 
                 TagBox[
                  RowBox[{"(", 
                   RowBox[{"1", ",", "0"}], ")"}],
                  Derivative],
                 MultilineFunction->None], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}]}], "+", 
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                   TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                   MultilineFunction->None], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"2", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gxy,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "-", 
                RowBox[{
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gxx,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gyy,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], ")"}]}], ")"}]}], 
         ",", 
         FractionBox[
          RowBox[{
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            RowBox[{
             InterpretationBox[
              StyleBox["gxx",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxx,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}], " ", 
            RowBox[{
             InterpretationBox[
              StyleBox["gyy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gyy,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}], " ", 
            RowBox[{
             InterpretationBox[
              StyleBox["T112",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`T112,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}]}], "-", 
           RowBox[{
            RowBox[{
             InterpretationBox[
              StyleBox["gyy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gyy,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}], " ", 
            RowBox[{
             SuperscriptBox[
              InterpretationBox[
               StyleBox["gxx",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxx,
               Editable->False], 
              TagBox[
               RowBox[{"(", 
                RowBox[{"0", ",", "1"}], ")"}],
               Derivative],
              MultilineFunction->None], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}]}], "+", 
           RowBox[{
            RowBox[{
             InterpretationBox[
              StyleBox["gxy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxy,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "2"}], " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["T212",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`T212,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}]}], "+", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], 
                TagBox[
                 RowBox[{"(", 
                  RowBox[{"1", ",", "0"}], ")"}],
                 Derivative],
                MultilineFunction->None], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}], ")"}]}]}], 
          RowBox[{"2", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], "2"], "-", 
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gxx",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxx,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["gyy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gyy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}]}], ")"}]}]]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         FractionBox[
          RowBox[{
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            SuperscriptBox[
             RowBox[{
              InterpretationBox[
               StyleBox["gxy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}], "2"], " ", 
            RowBox[{
             InterpretationBox[
              StyleBox["T112",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`T112,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}]}], "-", 
           RowBox[{
            RowBox[{
             InterpretationBox[
              StyleBox["gyy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gyy,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}], " ", 
            RowBox[{
             SuperscriptBox[
              InterpretationBox[
               StyleBox["gxx",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxx,
               Editable->False], 
              TagBox[
               RowBox[{"(", 
                RowBox[{"0", ",", "1"}], ")"}],
               Derivative],
              MultilineFunction->None], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}]}], "+", 
           RowBox[{
            RowBox[{
             InterpretationBox[
              StyleBox["gxy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxy,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "2"}], " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["T212",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`T212,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}]}], "+", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], 
                TagBox[
                 RowBox[{"(", 
                  RowBox[{"1", ",", "0"}], ")"}],
                 Derivative],
                MultilineFunction->None], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}], ")"}]}]}], 
          RowBox[{"2", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], "2"], "-", 
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gxx",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxx,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["gyy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gyy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}]}], ")"}]}]], ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{
              InterpretationBox[
               StyleBox["gxy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "2"}], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["gyy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gyy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["T112",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`T112,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}]}], "+", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["gyy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gyy,
                  Editable->False], 
                 TagBox[
                  RowBox[{"(", 
                   RowBox[{"0", ",", "1"}], ")"}],
                  Derivative],
                 MultilineFunction->None], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}]}], ")"}]}], "+", 
            RowBox[{
             RowBox[{
              InterpretationBox[
               StyleBox["gyy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gyy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "2"}], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["gyy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gyy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["T212",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`T212,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}]}], "-", 
               RowBox[{"2", " ", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gxy,
                   Editable->False], 
                  TagBox[
                   RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                   Derivative],
                  MultilineFunction->None], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}]}], "+", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["gyy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gyy,
                  Editable->False], 
                 TagBox[
                  RowBox[{"(", 
                   RowBox[{"1", ",", "0"}], ")"}],
                  Derivative],
                 MultilineFunction->None], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}]}], ")"}]}]}], ")"}], "/", 
          RowBox[{"(", 
           RowBox[{"2", " ", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], "2"], "-", 
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}]}]}], ")"}]}], ")"}]}]}], "}"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         FractionBox[
          RowBox[{
           RowBox[{"2", " ", 
            SuperscriptBox[
             RowBox[{
              InterpretationBox[
               StyleBox["gxx",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxx,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}], "2"], " ", 
            RowBox[{
             InterpretationBox[
              StyleBox["T112",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`T112,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}]}], "+", 
           RowBox[{
            RowBox[{
             InterpretationBox[
              StyleBox["gxy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxy,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}], " ", 
            RowBox[{
             SuperscriptBox[
              InterpretationBox[
               StyleBox["gxx",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxx,
               Editable->False], 
              TagBox[
               RowBox[{"(", 
                RowBox[{"1", ",", "0"}], ")"}],
               Derivative],
              MultilineFunction->None], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}]}], "+", 
           RowBox[{
            RowBox[{
             InterpretationBox[
              StyleBox["gxx",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxx,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["T212",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`T212,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}]}], "+", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], 
                TagBox[
                 RowBox[{"(", 
                  RowBox[{"0", ",", "1"}], ")"}],
                 Derivative],
                MultilineFunction->None], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], "-", 
              RowBox[{"2", " ", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["gxy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxy,
                  Editable->False], 
                 TagBox[
                  RowBox[{"(", 
                   RowBox[{"1", ",", "0"}], ")"}],
                  Derivative],
                 MultilineFunction->None], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}]}]}], ")"}]}]}], 
          RowBox[{"2", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], "2"], "-", 
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gxx",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxx,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["gyy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gyy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}]}], ")"}]}]], ",", 
         FractionBox[
          RowBox[{
           RowBox[{
            RowBox[{
             InterpretationBox[
              StyleBox["gxy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxy,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["T212",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`T212,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}]}], "+", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], 
                TagBox[
                 RowBox[{"(", 
                  RowBox[{"0", ",", "1"}], ")"}],
                 Derivative],
                MultilineFunction->None], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}], ")"}]}], "+", 
           RowBox[{
            RowBox[{
             InterpretationBox[
              StyleBox["gxx",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxx,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["T112",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`T112,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}]}], "-", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], 
                TagBox[
                 RowBox[{"(", 
                  RowBox[{"1", ",", "0"}], ")"}],
                 Derivative],
                MultilineFunction->None], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}], ")"}]}]}], 
          RowBox[{"2", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], "2"], "-", 
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gxx",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxx,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["gyy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gyy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}]}], ")"}]}]]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         FractionBox[
          RowBox[{
           RowBox[{
            RowBox[{
             InterpretationBox[
              StyleBox["gxy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxy,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}], " ", 
            RowBox[{
             SuperscriptBox[
              InterpretationBox[
               StyleBox["gxx",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxx,
               Editable->False], 
              TagBox[
               RowBox[{"(", 
                RowBox[{"0", ",", "1"}], ")"}],
               Derivative],
              MultilineFunction->None], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}]}], "+", 
           RowBox[{
            RowBox[{
             InterpretationBox[
              StyleBox["gxx",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxx,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["T112",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`T112,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}]}], "+", 
              RowBox[{"2", " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["T212",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`T212,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}]}], "-", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], 
                TagBox[
                 RowBox[{"(", 
                  RowBox[{"1", ",", "0"}], ")"}],
                 Derivative],
                MultilineFunction->None], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}], ")"}]}]}], 
          RowBox[{"2", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], "2"], "-", 
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gxx",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxx,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["gyy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gyy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}]}], ")"}]}]], ",", 
         FractionBox[
          RowBox[{
           RowBox[{"2", " ", 
            SuperscriptBox[
             RowBox[{
              InterpretationBox[
               StyleBox["gxy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}], "2"], " ", 
            RowBox[{
             InterpretationBox[
              StyleBox["T112",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`T112,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}]}], "-", 
           RowBox[{
            RowBox[{
             InterpretationBox[
              StyleBox["gxx",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxx,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}], " ", 
            RowBox[{
             SuperscriptBox[
              InterpretationBox[
               StyleBox["gyy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gyy,
               Editable->False], 
              TagBox[
               RowBox[{"(", 
                RowBox[{"0", ",", "1"}], ")"}],
               Derivative],
              MultilineFunction->None], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}]}], "+", 
           RowBox[{
            RowBox[{
             InterpretationBox[
              StyleBox["gxy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxy,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["T212",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`T212,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}]}], "+", 
              RowBox[{"2", " ", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["gxy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxy,
                  Editable->False], 
                 TagBox[
                  RowBox[{"(", 
                   RowBox[{"0", ",", "1"}], ")"}],
                  Derivative],
                 MultilineFunction->None], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}]}], "-", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], 
                TagBox[
                 RowBox[{"(", 
                  RowBox[{"1", ",", "0"}], ")"}],
                 Derivative],
                MultilineFunction->None], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}], ")"}]}]}], 
          RowBox[{"2", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], "2"], "-", 
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gxx",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxx,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["gyy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gyy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}]}], ")"}]}]]}], "}"}]}], "}"}]}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"gen", ",", 
     RowBox[{"-", "gen"}], ",", 
     RowBox[{"-", "gen"}]}], "}"}], ",", "0"}], "]"}]], "Output",ExpressionUUI\
D->"caba8118-7fcc-42eb-b800-39aaf5cc94b0"]
}, Open  ]],

Cell["\<\
Its antisymmetric part (actually twice it) is precisely given by the torsion:\
\
\>", "Text",ExpressionUUID->"a9ab312c-2ce9-4bb1-baaf-5c4fcd600f46"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"christoffel", "[", 
     RowBox[{"a", ",", 
      RowBox[{"-", "b"}], ",", 
      RowBox[{"-", "c"}]}], "]"}], "-", 
    RowBox[{"christoffel", "[", 
     RowBox[{"a", ",", 
      RowBox[{"-", "c"}], ",", 
      RowBox[{"-", "b"}]}], "]"}]}], "\[Equal]", 
   RowBox[{"torsion", "[", 
    RowBox[{"a", ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}]}], "]"}]}], "//", "Simplify"}]], "Input",ExpressionUUI\
D->"adda1516-bb0a-40bd-8b19-7100c07c3ef5"],

Cell[BoxData["True"], "Output",ExpressionUUID->"4888d7ad-01e5-4381-87e9-de0cfc79155d"]
}, Open  ]],

Cell["\<\
The connection is still associated to the metric, in the sense that it gives \
zero:\
\>", "Text",ExpressionUUID->"6a9a8d78-beb9-4cb1-80ba-f907b814f316"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TensorDerivative", "[", 
  RowBox[{"metric", ",", "cd"}], "]"}]], "Input",ExpressionUUID->"2116066b-\
5ca9-45c4-ae28-3b0eb905349a"],

Cell[BoxData["Zero"], "Output",ExpressionUUID->"24a8cb12-65f0-4aca-b3ac-ffcacf4208bb"]
}, Open  ]],

Cell["But now it has curvature:", "Text",ExpressionUUID->"c2d2b475-e61d-4cb7-9935-5c8cd5abd9c1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"riemann", "=", 
  RowBox[{"Riemann", "[", "cd", "]"}]}]], "Input",ExpressionUUID->"a6844b2e-\
43c1-4427-8728-d0b3f2bb6211"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"2", " ", 
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], "+", 
                  RowBox[{
                   RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}], "+", 
                  RowBox[{
                   RowBox[{
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}]}], 
                    ")"}]}], "+", 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "3"], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}], "+", 
                  RowBox[{"2", " ", 
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}], "+", 
                  RowBox[{
                   RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}]}], 
                 ")"}]}], ")"}], "/", 
              RowBox[{"(", 
               RowBox[{"4", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "-", 
                   RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}], "2"]}], ")"}]}], 
             ")"}]}], ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gxx",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxx,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], "+", 
                RowBox[{
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gyy,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "+", 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}], "+", 
                RowBox[{
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gxy,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                   RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}], "+", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}]}], 
                  ")"}]}], "+", 
                RowBox[{"4", " ", 
                 SuperscriptBox[
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "3"], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}], "+", 
                RowBox[{
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gxx,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                   SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "+", 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}]}], 
               ")"}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "-", 
                 RowBox[{
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}], "2"]}], ")"}]}]}], 
          "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 InterpretationBox[
                  StyleBox["gyy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gyy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"2", " ", 
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], "+", 
                  RowBox[{
                   RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}], "+", 
                  RowBox[{
                   RowBox[{
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}]}], 
                    ")"}]}], "+", 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "3"], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}], "+", 
                  RowBox[{"2", " ", 
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}], "+", 
                  RowBox[{
                   RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}]}], 
                 ")"}]}], ")"}], "/", 
              RowBox[{"(", 
               RowBox[{"4", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "-", 
                   RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}], "2"]}], ")"}]}], 
             ")"}]}], ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], "+", 
                RowBox[{
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gyy,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "+", 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}], "+", 
                RowBox[{
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gxy,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                   RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}], "+", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}]}], 
                  ")"}]}], "+", 
                RowBox[{"4", " ", 
                 SuperscriptBox[
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "3"], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}], "+", 
                RowBox[{
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gxx,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                   SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "+", 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}]}], 
               ")"}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "-", 
                 RowBox[{
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}], "2"]}], ")"}]}]}], 
          "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], "+", 
                RowBox[{
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gyy,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "+", 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}], "+", 
                RowBox[{
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gxy,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                   RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}], "+", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}]}], 
                  ")"}]}], "+", 
                RowBox[{"4", " ", 
                 SuperscriptBox[
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "3"], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}], "+", 
                RowBox[{
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gxx,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                   SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "+", 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}]}], 
               ")"}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "-", 
                 RowBox[{
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}], "2"]}], ")"}]}], 
           ",", 
           RowBox[{"-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxx",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxx,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"2", " ", 
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], "+", 
                  RowBox[{
                   RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}], "+", 
                  RowBox[{
                   RowBox[{
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}]}], 
                    ")"}]}], "+", 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "3"], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}], "+", 
                  RowBox[{"2", " ", 
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}], "+", 
                  RowBox[{
                   RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}]}], 
                 ")"}]}], ")"}], "/", 
              RowBox[{"(", 
               RowBox[{"4", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "-", 
                   RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}], "2"]}], ")"}]}], 
             ")"}]}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gyy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gyy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], "+", 
                RowBox[{
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gyy,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "+", 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}], "+", 
                RowBox[{
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gxy,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                   RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}], "+", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}]}], 
                  ")"}]}], "+", 
                RowBox[{"4", " ", 
                 SuperscriptBox[
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "3"], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}], "+", 
                RowBox[{
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gxx,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                   SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "+", 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                   RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}]}], 
               ")"}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "-", 
                 RowBox[{
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}], "2"]}], ")"}]}], 
           ",", 
           RowBox[{"-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"2", " ", 
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], "+", 
                  RowBox[{
                   RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}], "+", 
                  RowBox[{
                   RowBox[{
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}]}], 
                    ")"}]}], "+", 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "3"], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}], "+", 
                  RowBox[{"2", " ", 
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}], "+", 
                  RowBox[{
                   RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}]}], 
                 ")"}]}], ")"}], "/", 
              RowBox[{"(", 
               RowBox[{"4", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "-", 
                   RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}], "2"]}], ")"}]}], 
             ")"}]}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}]}], "}"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "gen"}], ",", 
     RowBox[{"-", "gen"}], ",", 
     RowBox[{"-", "gen"}], ",", "gen"}], "}"}], ",", "0"}], "]"}]], "Output",E\
xpressionUUID->"9dec9566-57ed-4522-a47a-d9d72be7a08a"]
}, Open  ]],

Cell["\<\
To analyze the symmetries of the result we need the Riemann with four indices \
down:\
\>", "Text",ExpressionUUID->"c9d81ef5-9424-431d-9a9c-ed612df1b7aa"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"riemanndown", "=", 
  RowBox[{"RiemannDown", "[", "cd", "]"}]}]], "Input",ExpressionUUID->\
"34aeb4aa-326f-4954-89e4-9e11d2a3e186"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               SuperscriptBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxx",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxx,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}], "2"], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"-", "2"}], " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                 RowBox[{"4", " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], "+", 
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", 
                  SuperscriptBox[
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"]}], "+", 
                 RowBox[{
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}], "+", 
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"2", " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                 RowBox[{
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                 RowBox[{"4", " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                 RowBox[{
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}], "-", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}]}], 
                ")"}]}], "-", 
              RowBox[{"4", " ", 
               SuperscriptBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}], "3"], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                   TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                   MultilineFunction->None], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                   TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                   MultilineFunction->None], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}], "2"], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"2", " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                   TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}],
                    Derivative],
                   MultilineFunction->None], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                   TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}],
                    Derivative],
                   MultilineFunction->None], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}], "-", 
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                 SuperscriptBox[
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "+", 
                 RowBox[{"4", " ", 
                  SuperscriptBox[
                   RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}]}], ")"}], 
            "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gxy,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "-", 
                RowBox[{
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gxx,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gyy,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], ")"}]}]}], "}"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", 
               SuperscriptBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxx",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxx,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}], "2"], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], "+", 
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "+", 
                 RowBox[{
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}], "+", 
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"-", "2"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                 RowBox[{
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                 RowBox[{"4", " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                 RowBox[{
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}], "+", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}]}], 
                ")"}]}], "+", 
              RowBox[{"4", " ", 
               SuperscriptBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}], "3"], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                   TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                   MultilineFunction->None], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                   TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                   MultilineFunction->None], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}], "2"], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"2", " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                   TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}],
                    Derivative],
                   MultilineFunction->None], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                   TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}],
                    Derivative],
                   MultilineFunction->None], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}], "+", 
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                 SuperscriptBox[
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "+", 
                 RowBox[{"4", " ", 
                  SuperscriptBox[
                   RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}]}], ")"}], 
            "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gxy,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "-", 
                RowBox[{
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gxx,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gyy,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], ")"}]}], ",", 
           "0"}], "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", 
               SuperscriptBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxx",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxx,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}], "2"], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], "+", 
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "+", 
                 RowBox[{
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}], "+", 
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"-", "2"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                 RowBox[{
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                 RowBox[{"4", " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                 RowBox[{
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}], "+", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}]}], 
                ")"}]}], "+", 
              RowBox[{"4", " ", 
               SuperscriptBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}], "3"], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                   TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                   MultilineFunction->None], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                   TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                   MultilineFunction->None], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}], "2"], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"2", " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                   TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}],
                    Derivative],
                   MultilineFunction->None], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                   TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}],
                    Derivative],
                   MultilineFunction->None], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}], "+", 
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                 SuperscriptBox[
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "+", 
                 RowBox[{"4", " ", 
                  SuperscriptBox[
                   RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}]}], ")"}], 
            "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gxy,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "-", 
                RowBox[{
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gxx,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gyy,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], ")"}]}]}], "}"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               SuperscriptBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxx",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxx,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}], "2"], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"-", "2"}], " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                 RowBox[{"4", " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], "+", 
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", 
                  SuperscriptBox[
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"]}], "+", 
                 RowBox[{
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}], "+", 
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"2", " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                 RowBox[{
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                 RowBox[{"4", " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                 RowBox[{
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}], "-", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}]}], 
                ")"}]}], "-", 
              RowBox[{"4", " ", 
               SuperscriptBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}], "3"], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                   TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                   MultilineFunction->None], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                   TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                   MultilineFunction->None], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}], "2"], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"2", " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                   TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}],
                    Derivative],
                   MultilineFunction->None], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                   TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}],
                    Derivative],
                   MultilineFunction->None], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}], "-", 
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                 SuperscriptBox[
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "+", 
                 RowBox[{"4", " ", 
                  SuperscriptBox[
                   RowBox[{
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T112,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`T212,
                    Editable->False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}]}], ")"}], 
            "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gxy,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "-", 
                RowBox[{
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gxx,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gyy,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}], ")"}]}], ",", 
           "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}]}], "}"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "gen"}], ",", 
     RowBox[{"-", "gen"}], ",", 
     RowBox[{"-", "gen"}], ",", 
     RowBox[{"-", "gen"}]}], "}"}], ",", "0"}], "]"}]], "Output",ExpressionUUI\
D->"93702785-dc53-46cd-8ff2-66a219cadadc"]
}, Open  ]],

Cell["Symmetry is complete in this 2d case:", "Text",ExpressionUUID->"25970f15-a0bf-4aaf-8ab1-a4edb1e3cdc5"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SymmetryGroupOfTensor", "[", "riemann", "]"}]], "Input",ExpressionUU\
ID->"d6c82b8b-f28e-4a04-ae96-73468a15f8b9"],

Cell[BoxData[
 RowBox[{"StrongGenSet", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"GenSet", "[", 
    InterpretationBox[
     StyleBox[
      RowBox[{"-", 
       RowBox[{"(", "1", ",", "2", ")"}]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     -xAct`xPerm`Cycles[{1, 2}],
     Editable->False], "]"}]}], "]"}]], "Output",ExpressionUUID->"cf5e1149-\
8aba-4fc4-acc4-01a85e96c020"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SymmetryGroupOfTensor", "[", "riemanndown", "]"}]], "Input",Expressi\
onUUID->"c4983cea-c516-497e-b0fe-26cac523b064"],

Cell[BoxData[
 RowBox[{"StrongGenSet", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3", ",", "1"}], "}"}], ",", 
   RowBox[{"GenSet", "[", 
    RowBox[{
     InterpretationBox[
      StyleBox[
       RowBox[{"-", 
        RowBox[{"(", "3", ",", "4", ")"}]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      -xAct`xPerm`Cycles[{3, 4}],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox[
       RowBox[{"-", 
        RowBox[{"(", "1", ",", "2", ")"}]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      -xAct`xPerm`Cycles[{1, 2}],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        RowBox[{"(", "1", ",", "3", ")"}], 
        RowBox[{"(", "2", ",", "4", ")"}]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xPerm`Cycles[{1, 3}, {2, 4}],
      Editable->False]}], "]"}]}], "]"}]], "Output",ExpressionUUID->"af25d06d-\
6452-41b3-b2bf-7a23e9fe774d"]
}, Open  ]],

Cell["Now compute everything:", "Text",ExpressionUUID->"1df0f23c-eb74-4f5c-a61f-1d2cec8b562c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MetricCompute", "[", 
   RowBox[{"metric", ",", "torsion", ",", "gen", ",", "All", ",", 
    RowBox[{"Parallelize", "\[Rule]", "True"}]}], "]"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"075fd3e3-87c0-4e9f-b995-\
34f6f914510f"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"7.765506`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"6f3ce1cb-be78-4c1a-8d5d-2f2c2cb04d04"]
}, Open  ]],

Cell["\<\
It is possible to see that the derivative of Riemann took almost 28 seconds \
to Simplify (all but 1 second of the total!)\
\>", "Text",ExpressionUUID->"a6137975-2efc-4739-9042-17dd0381ae61"],

Cell["There is Ricci-scalar curvature:", "Text",ExpressionUUID->"48941fa1-3ee2-4bb7-9d4f-bd5e69c158f6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"RicciScalar", "[", "cd", "]"}], "[", "]"}]], "Input",ExpressionUUID\
->"20cb2f7f-9e1a-4298-bc0e-02527fce0cfc"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"2", " ", 
     SuperscriptBox[
      RowBox[{
       InterpretationBox[
        StyleBox["gxx",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`gxx,
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["y",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`y[],
         Editable->False]}], "]"}], "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{
         InterpretationBox[
          StyleBox["T112",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`T112,
          Editable->False], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["y",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`y[],
           Editable->False]}], "]"}], " ", 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["gyy",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gyy,
           Editable->False], 
          TagBox[
           RowBox[{"(", 
            RowBox[{"0", ",", "1"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["y",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`y[],
           Editable->False]}], "]"}]}], "-", 
       RowBox[{"2", " ", 
        RowBox[{
         InterpretationBox[
          StyleBox["gyy",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`gyy,
          Editable->False], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["y",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`y[],
           Editable->False]}], "]"}], " ", 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["T112",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`T112,
           Editable->False], 
          TagBox[
           RowBox[{"(", 
            RowBox[{"0", ",", "1"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["y",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`y[],
           Editable->False]}], "]"}]}]}], ")"}]}], "+", 
    RowBox[{
     RowBox[{
      InterpretationBox[
       StyleBox["gyy",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`gyy,
       Editable->False], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["y",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`y[],
        Editable->False]}], "]"}], " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox[
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["gxx",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gxx,
           Editable->False], 
          TagBox[
           RowBox[{"(", 
            RowBox[{"0", ",", "1"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["y",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`y[],
           Editable->False]}], "]"}], "2"], "+", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["gxx",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gxx,
           Editable->False], 
          TagBox[
           RowBox[{"(", 
            RowBox[{"1", ",", "0"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["y",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`y[],
           Editable->False]}], "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "2"}], " ", 
           RowBox[{
            InterpretationBox[
             StyleBox["gyy",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`gyy,
             Editable->False], "[", 
            RowBox[{
             InterpretationBox[
              StyleBox["x",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`x[],
              Editable->False], ",", 
             InterpretationBox[
              StyleBox["y",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`y[],
              Editable->False]}], "]"}], " ", 
           RowBox[{
            InterpretationBox[
             StyleBox["T212",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`T212,
             Editable->False], "[", 
            RowBox[{
             InterpretationBox[
              StyleBox["x",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`x[],
              Editable->False], ",", 
             InterpretationBox[
              StyleBox["y",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`y[],
              Editable->False]}], "]"}]}], "-", 
          RowBox[{"2", " ", 
           RowBox[{
            SuperscriptBox[
             InterpretationBox[
              StyleBox["gxy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxy,
              Editable->False], 
             TagBox[
              RowBox[{"(", 
               RowBox[{"0", ",", "1"}], ")"}],
              Derivative],
             MultilineFunction->None], "[", 
            RowBox[{
             InterpretationBox[
              StyleBox["x",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`x[],
              Editable->False], ",", 
             InterpretationBox[
              StyleBox["y",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`y[],
              Editable->False]}], "]"}]}], "+", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["gyy",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`gyy,
             Editable->False], 
            TagBox[
             RowBox[{"(", 
              RowBox[{"1", ",", "0"}], ")"}],
             Derivative],
            MultilineFunction->None], "[", 
           RowBox[{
            InterpretationBox[
             StyleBox["x",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`x[],
             Editable->False], ",", 
            InterpretationBox[
             StyleBox["y",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`y[],
             Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}], "+", 
    RowBox[{
     RowBox[{
      InterpretationBox[
       StyleBox["gxy",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`gxy,
       Editable->False], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["y",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`y[],
        Editable->False]}], "]"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["gxx",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gxx,
           Editable->False], 
          TagBox[
           RowBox[{"(", 
            RowBox[{"0", ",", "1"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["y",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`y[],
           Editable->False]}], "]"}], " ", 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["gxy",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gxy,
           Editable->False], 
          TagBox[
           RowBox[{"(", 
            RowBox[{"0", ",", "1"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["y",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`y[],
           Editable->False]}], "]"}]}], "+", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["gyy",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gyy,
           Editable->False], 
          TagBox[
           RowBox[{"(", 
            RowBox[{"0", ",", "1"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["y",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`y[],
           Editable->False]}], "]"}], " ", 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["gxx",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gxx,
           Editable->False], 
          TagBox[
           RowBox[{"(", 
            RowBox[{"1", ",", "0"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["y",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`y[],
           Editable->False]}], "]"}]}], "+", 
       RowBox[{"4", " ", 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["gxy",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gxy,
           Editable->False], 
          TagBox[
           RowBox[{"(", 
            RowBox[{"0", ",", "1"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["y",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`y[],
           Editable->False]}], "]"}], " ", 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["gxy",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gxy,
           Editable->False], 
          TagBox[
           RowBox[{"(", 
            RowBox[{"1", ",", "0"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["y",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`y[],
           Editable->False]}], "]"}]}], "-", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["gxx",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gxx,
           Editable->False], 
          TagBox[
           RowBox[{"(", 
            RowBox[{"0", ",", "1"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["y",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`y[],
           Editable->False]}], "]"}], " ", 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["gyy",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gyy,
           Editable->False], 
          TagBox[
           RowBox[{"(", 
            RowBox[{"1", ",", "0"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["y",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`y[],
           Editable->False]}], "]"}]}], "-", 
       RowBox[{"2", " ", 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["gxy",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gxy,
           Editable->False], 
          TagBox[
           RowBox[{"(", 
            RowBox[{"1", ",", "0"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["y",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`y[],
           Editable->False]}], "]"}], " ", 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["gyy",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gyy,
           Editable->False], 
          TagBox[
           RowBox[{"(", 
            RowBox[{"1", ",", "0"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["y",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`y[],
           Editable->False]}], "]"}]}], "-", 
       RowBox[{"2", " ", 
        RowBox[{
         InterpretationBox[
          StyleBox["gxx",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`gxx,
          Editable->False], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["y",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`y[],
           Editable->False]}], "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", 
            RowBox[{
             InterpretationBox[
              StyleBox["T212",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`T212,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}]}], " ", 
           RowBox[{
            SuperscriptBox[
             InterpretationBox[
              StyleBox["gyy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gyy,
              Editable->False], 
             TagBox[
              RowBox[{"(", 
               RowBox[{"0", ",", "1"}], ")"}],
              Derivative],
             MultilineFunction->None], "[", 
            RowBox[{
             InterpretationBox[
              StyleBox["x",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`x[],
              Editable->False], ",", 
             InterpretationBox[
              StyleBox["y",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`y[],
              Editable->False]}], "]"}]}], "+", 
          RowBox[{
           RowBox[{
            InterpretationBox[
             StyleBox["T112",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`T112,
             Editable->False], "[", 
            RowBox[{
             InterpretationBox[
              StyleBox["x",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`x[],
              Editable->False], ",", 
             InterpretationBox[
              StyleBox["y",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`y[],
              Editable->False]}], "]"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], 
                TagBox[
                 RowBox[{"(", 
                  RowBox[{"0", ",", "1"}], ")"}],
                 Derivative],
                MultilineFunction->None], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}], "+", 
             RowBox[{
              SuperscriptBox[
               InterpretationBox[
                StyleBox["gyy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gyy,
                Editable->False], 
               TagBox[
                RowBox[{"(", 
                 RowBox[{"1", ",", "0"}], ")"}],
                Derivative],
               MultilineFunction->None], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}], "+", 
       RowBox[{"2", " ", 
        RowBox[{
         InterpretationBox[
          StyleBox["gyy",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`gyy,
          Editable->False], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["y",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`y[],
           Editable->False]}], "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", 
            RowBox[{
             InterpretationBox[
              StyleBox["T112",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`T112,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}]}], " ", 
           RowBox[{
            SuperscriptBox[
             InterpretationBox[
              StyleBox["gxx",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxx,
              Editable->False], 
             TagBox[
              RowBox[{"(", 
               RowBox[{"1", ",", "0"}], ")"}],
              Derivative],
             MultilineFunction->None], "[", 
            RowBox[{
             InterpretationBox[
              StyleBox["x",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`x[],
              Editable->False], ",", 
             InterpretationBox[
              StyleBox["y",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`y[],
              Editable->False]}], "]"}]}], "+", 
          RowBox[{
           RowBox[{
            InterpretationBox[
             StyleBox["T212",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`T212,
             Editable->False], "[", 
            RowBox[{
             InterpretationBox[
              StyleBox["x",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`x[],
              Editable->False], ",", 
             InterpretationBox[
              StyleBox["y",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`y[],
              Editable->False]}], "]"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              SuperscriptBox[
               InterpretationBox[
                StyleBox["gxx",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxx,
                Editable->False], 
               TagBox[
                RowBox[{"(", 
                 RowBox[{"0", ",", "1"}], ")"}],
                Derivative],
               MultilineFunction->None], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}], "+", 
             RowBox[{"2", " ", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], 
                TagBox[
                 RowBox[{"(", 
                  RowBox[{"1", ",", "0"}], ")"}],
                 Derivative],
                MultilineFunction->None], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}]}], ")"}]}], "-", 
          RowBox[{"2", " ", 
           RowBox[{
            InterpretationBox[
             StyleBox["gxx",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`gxx,
             Editable->False], "[", 
            RowBox[{
             InterpretationBox[
              StyleBox["x",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`x[],
              Editable->False], ",", 
             InterpretationBox[
              StyleBox["y",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`y[],
              Editable->False]}], "]"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              SuperscriptBox[
               InterpretationBox[
                StyleBox["T212",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`T212,
                Editable->False], 
               TagBox[
                RowBox[{"(", 
                 RowBox[{"0", ",", "1"}], ")"}],
                Derivative],
               MultilineFunction->None], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}], "-", 
             RowBox[{
              SuperscriptBox[
               InterpretationBox[
                StyleBox["T112",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`T112,
                Editable->False], 
               TagBox[
                RowBox[{"(", 
                 RowBox[{"1", ",", "0"}], ")"}],
                Derivative],
               MultilineFunction->None], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}]}], ")"}]}], 
    "+", 
    RowBox[{"4", " ", 
     SuperscriptBox[
      RowBox[{
       InterpretationBox[
        StyleBox["gxy",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`gxy,
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["y",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`y[],
         Editable->False]}], "]"}], "3"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        SuperscriptBox[
         InterpretationBox[
          StyleBox["T212",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`T212,
          Editable->False], 
         TagBox[
          RowBox[{"(", 
           RowBox[{"0", ",", "1"}], ")"}],
          Derivative],
         MultilineFunction->None], "[", 
        RowBox[{
         InterpretationBox[
          StyleBox["x",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x[],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["y",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`y[],
          Editable->False]}], "]"}], "-", 
       RowBox[{
        SuperscriptBox[
         InterpretationBox[
          StyleBox["T112",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`T112,
          Editable->False], 
         TagBox[
          RowBox[{"(", 
           RowBox[{"1", ",", "0"}], ")"}],
          Derivative],
         MultilineFunction->None], "[", 
        RowBox[{
         InterpretationBox[
          StyleBox["x",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x[],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["y",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`y[],
          Editable->False]}], "]"}]}], ")"}]}], "+", 
    RowBox[{"2", " ", 
     SuperscriptBox[
      RowBox[{
       InterpretationBox[
        StyleBox["gxy",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`gxy,
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["y",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`y[],
         Editable->False]}], "]"}], "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"2", " ", 
        RowBox[{
         InterpretationBox[
          StyleBox["T112",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`T112,
          Editable->False], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["y",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`y[],
           Editable->False]}], "]"}], " ", 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["gxx",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gxx,
           Editable->False], 
          TagBox[
           RowBox[{"(", 
            RowBox[{"0", ",", "1"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["y",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`y[],
           Editable->False]}], "]"}]}], "+", 
       RowBox[{"2", " ", 
        RowBox[{
         InterpretationBox[
          StyleBox["gxx",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`gxx,
          Editable->False], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["y",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`y[],
           Editable->False]}], "]"}], " ", 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["T112",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`T112,
           Editable->False], 
          TagBox[
           RowBox[{"(", 
            RowBox[{"0", ",", "1"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["y",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`y[],
           Editable->False]}], "]"}]}], "+", 
       RowBox[{
        SuperscriptBox[
         InterpretationBox[
          StyleBox["gxx",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`gxx,
          Editable->False], 
         TagBox[
          RowBox[{"(", 
           RowBox[{"0", ",", "2"}], ")"}],
          Derivative],
         MultilineFunction->None], "[", 
        RowBox[{
         InterpretationBox[
          StyleBox["x",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x[],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["y",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`y[],
          Editable->False]}], "]"}], "-", 
       RowBox[{"2", " ", 
        RowBox[{
         InterpretationBox[
          StyleBox["T212",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`T212,
          Editable->False], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["y",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`y[],
           Editable->False]}], "]"}], " ", 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["gyy",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gyy,
           Editable->False], 
          TagBox[
           RowBox[{"(", 
            RowBox[{"1", ",", "0"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["y",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`y[],
           Editable->False]}], "]"}]}], "-", 
       RowBox[{"2", " ", 
        RowBox[{
         InterpretationBox[
          StyleBox["gyy",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`gyy,
          Editable->False], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["y",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`y[],
           Editable->False]}], "]"}], " ", 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["T212",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`T212,
           Editable->False], 
          TagBox[
           RowBox[{"(", 
            RowBox[{"1", ",", "0"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["y",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`y[],
           Editable->False]}], "]"}]}], "-", 
       RowBox[{"2", " ", 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["gxy",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gxy,
           Editable->False], 
          TagBox[
           RowBox[{"(", 
            RowBox[{"1", ",", "1"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["y",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`y[],
           Editable->False]}], "]"}]}], "+", 
       RowBox[{
        SuperscriptBox[
         InterpretationBox[
          StyleBox["gyy",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`gyy,
          Editable->False], 
         TagBox[
          RowBox[{"(", 
           RowBox[{"2", ",", "0"}], ")"}],
          Derivative],
         MultilineFunction->None], "[", 
        RowBox[{
         InterpretationBox[
          StyleBox["x",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x[],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["y",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`y[],
          Editable->False]}], "]"}]}], ")"}]}], "+", 
    RowBox[{
     RowBox[{
      InterpretationBox[
       StyleBox["gxx",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`gxx,
       Editable->False], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["y",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`y[],
        Editable->False]}], "]"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["gxx",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gxx,
           Editable->False], 
          TagBox[
           RowBox[{"(", 
            RowBox[{"0", ",", "1"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["y",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`y[],
           Editable->False]}], "]"}], " ", 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["gyy",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gyy,
           Editable->False], 
          TagBox[
           RowBox[{"(", 
            RowBox[{"0", ",", "1"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["y",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`y[],
           Editable->False]}], "]"}]}], "-", 
       RowBox[{"2", " ", 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["gyy",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gyy,
           Editable->False], 
          TagBox[
           RowBox[{"(", 
            RowBox[{"0", ",", "1"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["y",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`y[],
           Editable->False]}], "]"}], " ", 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["gxy",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gxy,
           Editable->False], 
          TagBox[
           RowBox[{"(", 
            RowBox[{"1", ",", "0"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["y",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`y[],
           Editable->False]}], "]"}]}], "+", 
       SuperscriptBox[
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["gyy",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gyy,
           Editable->False], 
          TagBox[
           RowBox[{"(", 
            RowBox[{"1", ",", "0"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["y",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`y[],
           Editable->False]}], "]"}], "2"], "+", 
       RowBox[{"4", " ", 
        SuperscriptBox[
         RowBox[{
          InterpretationBox[
           StyleBox["gyy",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gyy,
           Editable->False], "[", 
          RowBox[{
           InterpretationBox[
            StyleBox["x",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x[],
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["y",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`y[],
            Editable->False]}], "]"}], "2"], " ", 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["T212",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`T212,
           Editable->False], 
          TagBox[
           RowBox[{"(", 
            RowBox[{"1", ",", "0"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["y",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`y[],
           Editable->False]}], "]"}]}], "-", 
       RowBox[{"2", " ", 
        RowBox[{
         InterpretationBox[
          StyleBox["gyy",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`gyy,
          Editable->False], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["y",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`y[],
           Editable->False]}], "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["gxx",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`gxx,
             Editable->False], 
            TagBox[
             RowBox[{"(", 
              RowBox[{"0", ",", "2"}], ")"}],
             Derivative],
            MultilineFunction->None], "[", 
           RowBox[{
            InterpretationBox[
             StyleBox["x",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`x[],
             Editable->False], ",", 
            InterpretationBox[
             StyleBox["y",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`y[],
             Editable->False]}], "]"}], "+", 
          RowBox[{
           RowBox[{
            InterpretationBox[
             StyleBox["T112",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`T112,
             Editable->False], "[", 
            RowBox[{
             InterpretationBox[
              StyleBox["x",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`x[],
              Editable->False], ",", 
             InterpretationBox[
              StyleBox["y",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`y[],
              Editable->False]}], "]"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              SuperscriptBox[
               InterpretationBox[
                StyleBox["gxx",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxx,
                Editable->False], 
               TagBox[
                RowBox[{"(", 
                 RowBox[{"0", ",", "1"}], ")"}],
                Derivative],
               MultilineFunction->None], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}], "-", 
             RowBox[{"2", " ", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], 
                TagBox[
                 RowBox[{"(", 
                  RowBox[{"1", ",", "0"}], ")"}],
                 Derivative],
                MultilineFunction->None], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}]}], ")"}]}], "+", 
          RowBox[{
           RowBox[{
            InterpretationBox[
             StyleBox["T212",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`T212,
             Editable->False], "[", 
            RowBox[{
             InterpretationBox[
              StyleBox["x",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`x[],
              Editable->False], ",", 
             InterpretationBox[
              StyleBox["y",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`y[],
              Editable->False]}], "]"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], 
                TagBox[
                 RowBox[{"(", 
                  RowBox[{"0", ",", "1"}], ")"}],
                 Derivative],
                MultilineFunction->None], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}], "-", 
             RowBox[{
              SuperscriptBox[
               InterpretationBox[
                StyleBox["gyy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gyy,
                Editable->False], 
               TagBox[
                RowBox[{"(", 
                 RowBox[{"1", ",", "0"}], ")"}],
                Derivative],
               MultilineFunction->None], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}]}], ")"}]}], "-", 
          RowBox[{"2", " ", 
           RowBox[{
            SuperscriptBox[
             InterpretationBox[
              StyleBox["gxy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxy,
              Editable->False], 
             TagBox[
              RowBox[{"(", 
               RowBox[{"1", ",", "1"}], ")"}],
              Derivative],
             MultilineFunction->None], "[", 
            RowBox[{
             InterpretationBox[
              StyleBox["x",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`x[],
              Editable->False], ",", 
             InterpretationBox[
              StyleBox["y",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`y[],
              Editable->False]}], "]"}]}], "+", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["gyy",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`gyy,
             Editable->False], 
            TagBox[
             RowBox[{"(", 
              RowBox[{"2", ",", "0"}], ")"}],
             Derivative],
            MultilineFunction->None], "[", 
           RowBox[{
            InterpretationBox[
             StyleBox["x",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`x[],
             Editable->False], ",", 
            InterpretationBox[
             StyleBox["y",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`y[],
             Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}]}], ")"}], "/", 
  RowBox[{"(", 
   RowBox[{"2", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox[
        RowBox[{
         InterpretationBox[
          StyleBox["gxy",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`gxy,
          Editable->False], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["y",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`y[],
           Editable->False]}], "]"}], "2"], "-", 
       RowBox[{
        RowBox[{
         InterpretationBox[
          StyleBox["gxx",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`gxx,
          Editable->False], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["y",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`y[],
           Editable->False]}], "]"}], " ", 
        RowBox[{
         InterpretationBox[
          StyleBox["gyy",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`gyy,
          Editable->False], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["y",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`y[],
           Editable->False]}], "]"}]}]}], ")"}], "2"]}], ")"}]}]], "Output",Ex\
pressionUUID->"9cfb7acd-c706-4667-9df6-783801eb2cb7"]
}, Open  ]],

Cell["But there is no Einstein tensor, even having torsion:", "Text",ExpressionUUID->"95825bce-2ae8-418c-aac7-921f51ed5e0f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Einstein", "[", "cd", "]"}], "[", 
  RowBox[{
   RowBox[{"-", "a"}], ",", 
   RowBox[{"-", "b"}]}], "]"}]], "Input",ExpressionUUID->"21638600-d6da-4c95-\
8203-f29a576bc3d1"],

Cell[BoxData["0"], "Output",ExpressionUUID->"c8e0ec1e-cff2-435e-9bdc-b840834417aa"]
}, Open  ]],

Cell["We can compare with the Levi-Civita connection:", "Text",ExpressionUUID->"05e1e0ca-3037-499c-817b-bfabba9dec65"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LCmetric", "=", 
  RowBox[{"LC", "[", "metric", "]"}]}]], "Input",ExpressionUUID->"40bbc31c-\
0c93-4364-b3d9-aefb36d8c829"],

Cell[BoxData[
 RowBox[{"CCovD", "[", 
  RowBox[{"PDgen", ",", 
   RowBox[{"CTensor", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["gxx",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxx,
                  Editable->False], 
                 TagBox[
                  RowBox[{"(", 
                   RowBox[{"1", ",", "0"}], ")"}],
                  Derivative],
                 MultilineFunction->None], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}]}], "+", 
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxx,
                    Editable->False], 
                   TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                   MultilineFunction->None], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "-", 
                 RowBox[{"2", " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}]}], 
             RowBox[{"2", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gxy,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "-", 
                RowBox[{
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gxx,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gyy,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}]]}], ",", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               RowBox[{
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}]}], " ", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], 
                TagBox[
                 RowBox[{"(", 
                  RowBox[{"0", ",", "1"}], ")"}],
                 Derivative],
                MultilineFunction->None], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}], "+", 
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], 
                TagBox[
                 RowBox[{"(", 
                  RowBox[{"1", ",", "0"}], ")"}],
                 Derivative],
                MultilineFunction->None], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}]}], 
            RowBox[{"2", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}], "2"], "-", 
               RowBox[{
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxx",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxx,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["gyy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gyy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}]}]}], ")"}]}]]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               RowBox[{
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}]}], " ", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], 
                TagBox[
                 RowBox[{"(", 
                  RowBox[{"0", ",", "1"}], ")"}],
                 Derivative],
                MultilineFunction->None], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}], "+", 
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], 
                TagBox[
                 RowBox[{"(", 
                  RowBox[{"1", ",", "0"}], ")"}],
                 Derivative],
                MultilineFunction->None], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}]}], 
            RowBox[{"2", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}], "2"], "-", 
               RowBox[{
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxx",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxx,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["gyy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gyy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}]}]}], ")"}]}]], ",", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], 
                TagBox[
                 RowBox[{"(", 
                  RowBox[{"0", ",", "1"}], ")"}],
                 Derivative],
                MultilineFunction->None], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}], "+", 
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gyy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gyy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "2"}], " ", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                   TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                   MultilineFunction->None], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gyy,
                   Editable->False], 
                  TagBox[
                   RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                   Derivative],
                  MultilineFunction->None], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}]}], ")"}]}]}], 
            RowBox[{"2", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}], "2"], "-", 
               RowBox[{
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxx",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxx,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["gyy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gyy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}]}]}], ")"}]}]]}], "}"}]}], "}"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], 
                TagBox[
                 RowBox[{"(", 
                  RowBox[{"1", ",", "0"}], ")"}],
                 Derivative],
                MultilineFunction->None], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}], "+", 
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gxx",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxx,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gxx,
                   Editable->False], 
                  TagBox[
                   RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                   Derivative],
                  MultilineFunction->None], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}], "-", 
                RowBox[{"2", " ", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                   TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                   MultilineFunction->None], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}]}], 
            RowBox[{"2", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}], "2"], "-", 
               RowBox[{
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxx",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxx,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}], " ", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["gyy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gyy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}]}]}], ")"}]}]], ",", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], 
                TagBox[
                 RowBox[{"(", 
                  RowBox[{"0", ",", "1"}], ")"}],
                 Derivative],
                MultilineFunction->None], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}], "-", 
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gxx",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxx,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], 
                TagBox[
                 RowBox[{"(", 
                  RowBox[{"1", ",", "0"}], ")"}],
                 Derivative],
                MultilineFunction->None], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}]}], 
            RowBox[{
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], "2"]}], "-", 
             RowBox[{"2", " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["gxx",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxx,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["gyy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gyy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}]}]]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], 
                TagBox[
                 RowBox[{"(", 
                  RowBox[{"0", ",", "1"}], ")"}],
                 Derivative],
                MultilineFunction->None], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}], "-", 
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gxx",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxx,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], 
                TagBox[
                 RowBox[{"(", 
                  RowBox[{"1", ",", "0"}], ")"}],
                 Derivative],
                MultilineFunction->None], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}]}], 
            RowBox[{
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], "2"]}], "-", 
             RowBox[{"2", " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["gxx",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxx,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["gyy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gyy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}]}]], ",", 
           RowBox[{"-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["gyy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gyy,
                  Editable->False], 
                 TagBox[
                  RowBox[{"(", 
                   RowBox[{"0", ",", "1"}], ")"}],
                  Derivative],
                 MultilineFunction->None], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}]}], "+", 
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"-", "2"}], " ", 
                  RowBox[{
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gxy,
                    Editable->False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                    MultilineFunction->None], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], "+", 
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`gyy,
                    Editable->False], 
                   TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                   MultilineFunction->None], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}], ")"}]}]}], 
             RowBox[{"2", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gxy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gxy,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], "2"], "-", 
                RowBox[{
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gxx",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gxx,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}], " ", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["gyy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`gyy,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}]}]}], ")"}]}]]}]}], "}"}]}], 
        "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"gen", ",", 
       RowBox[{"-", "gen"}], ",", 
       RowBox[{"-", "gen"}]}], "}"}], ",", "0"}], "]"}], ",", 
   RowBox[{"CTensor", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          InterpretationBox[
           StyleBox["gxx",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gxx,
           Editable->False], "[", 
          RowBox[{
           InterpretationBox[
            StyleBox["x",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x[],
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["y",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`y[],
            Editable->False]}], "]"}], ",", 
         RowBox[{
          InterpretationBox[
           StyleBox["gxy",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gxy,
           Editable->False], "[", 
          RowBox[{
           InterpretationBox[
            StyleBox["x",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x[],
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["y",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`y[],
            Editable->False]}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          InterpretationBox[
           StyleBox["gxy",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gxy,
           Editable->False], "[", 
          RowBox[{
           InterpretationBox[
            StyleBox["x",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x[],
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["y",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`y[],
            Editable->False]}], "]"}], ",", 
         RowBox[{
          InterpretationBox[
           StyleBox["gyy",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`gyy,
           Editable->False], "[", 
          RowBox[{
           InterpretationBox[
            StyleBox["x",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x[],
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["y",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`y[],
            Editable->False]}], "]"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "gen"}], ",", 
       RowBox[{"-", "gen"}]}], "}"}], ",", "0"}], "]"}]}], "]"}]], "Output",Ex\
pressionUUID->"e6443e6f-2ac1-4f06-9492-acccc6caa72b"]
}, Open  ]],

Cell["It is also associated to the metric:", "Text",ExpressionUUID->"f4201740-5e2a-4b8a-ae0e-f135ea2a4ce1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TensorDerivative", "[", 
  RowBox[{"metric", ",", "LCmetric"}], "]"}]], "Input",ExpressionUUID->\
"06c6bf48-f5c2-4e8f-bd0a-c87b6d6ac444"],

Cell[BoxData["Zero"], "Output",ExpressionUUID->"95bd4597-db1e-45b4-b37c-d7b9f2b51a0f"]
}, Open  ]],

Cell["and has a different Ricci scalar:", "Text",ExpressionUUID->"d030cd31-e1ec-4e27-810d-f2f163d8f5ad"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RicciScalar", "[", "LCmetric", "]"}]], "Input",ExpressionUUID->"7ec72f6f-e9f1-47da-a623-cb1383f2f99e"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{
        InterpretationBox[
         StyleBox["gxx",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`gxx,
         Editable->False], "[", 
        RowBox[{
         InterpretationBox[
          StyleBox["x",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x[],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["y",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`y[],
          Editable->False]}], "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["gxx",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`gxx,
             Editable->False], 
            TagBox[
             RowBox[{"(", 
              RowBox[{"0", ",", "1"}], ")"}],
             Derivative],
            MultilineFunction->None], "[", 
           RowBox[{
            InterpretationBox[
             StyleBox["x",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`x[],
             Editable->False], ",", 
            InterpretationBox[
             StyleBox["y",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`y[],
             Editable->False]}], "]"}], " ", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["gyy",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`gyy,
             Editable->False], 
            TagBox[
             RowBox[{"(", 
              RowBox[{"0", ",", "1"}], ")"}],
             Derivative],
            MultilineFunction->None], "[", 
           RowBox[{
            InterpretationBox[
             StyleBox["x",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`x[],
             Editable->False], ",", 
            InterpretationBox[
             StyleBox["y",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`y[],
             Editable->False]}], "]"}]}], "-", 
         RowBox[{"2", " ", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["gyy",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`gyy,
             Editable->False], 
            TagBox[
             RowBox[{"(", 
              RowBox[{"0", ",", "1"}], ")"}],
             Derivative],
            MultilineFunction->None], "[", 
           RowBox[{
            InterpretationBox[
             StyleBox["x",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`x[],
             Editable->False], ",", 
            InterpretationBox[
             StyleBox["y",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`y[],
             Editable->False]}], "]"}], " ", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["gxy",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`gxy,
             Editable->False], 
            TagBox[
             RowBox[{"(", 
              RowBox[{"1", ",", "0"}], ")"}],
             Derivative],
            MultilineFunction->None], "[", 
           RowBox[{
            InterpretationBox[
             StyleBox["x",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`x[],
             Editable->False], ",", 
            InterpretationBox[
             StyleBox["y",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`y[],
             Editable->False]}], "]"}]}], "+", 
         SuperscriptBox[
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["gyy",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`gyy,
             Editable->False], 
            TagBox[
             RowBox[{"(", 
              RowBox[{"1", ",", "0"}], ")"}],
             Derivative],
            MultilineFunction->None], "[", 
           RowBox[{
            InterpretationBox[
             StyleBox["x",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`x[],
             Editable->False], ",", 
            InterpretationBox[
             StyleBox["y",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`y[],
             Editable->False]}], "]"}], "2"]}], ")"}]}], "+", 
      RowBox[{
       RowBox[{
        InterpretationBox[
         StyleBox["gxy",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`gxy,
         Editable->False], "[", 
        RowBox[{
         InterpretationBox[
          StyleBox["x",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x[],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["y",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`y[],
          Editable->False]}], "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["gyy",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`gyy,
             Editable->False], 
            TagBox[
             RowBox[{"(", 
              RowBox[{"0", ",", "1"}], ")"}],
             Derivative],
            MultilineFunction->None], "[", 
           RowBox[{
            InterpretationBox[
             StyleBox["x",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`x[],
             Editable->False], ",", 
            InterpretationBox[
             StyleBox["y",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`y[],
             Editable->False]}], "]"}], " ", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["gxx",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`gxx,
             Editable->False], 
            TagBox[
             RowBox[{"(", 
              RowBox[{"1", ",", "0"}], ")"}],
             Derivative],
            MultilineFunction->None], "[", 
           RowBox[{
            InterpretationBox[
             StyleBox["x",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`x[],
             Editable->False], ",", 
            InterpretationBox[
             StyleBox["y",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`y[],
             Editable->False]}], "]"}]}], "+", 
         RowBox[{"2", " ", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["gxy",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`gxy,
             Editable->False], 
            TagBox[
             RowBox[{"(", 
              RowBox[{"1", ",", "0"}], ")"}],
             Derivative],
            MultilineFunction->None], "[", 
           RowBox[{
            InterpretationBox[
             StyleBox["x",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`x[],
             Editable->False], ",", 
            InterpretationBox[
             StyleBox["y",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`y[],
             Editable->False]}], "]"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", 
             RowBox[{
              SuperscriptBox[
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], 
               TagBox[
                RowBox[{"(", 
                 RowBox[{"0", ",", "1"}], ")"}],
                Derivative],
               MultilineFunction->None], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}]}], "-", 
            RowBox[{
             SuperscriptBox[
              InterpretationBox[
               StyleBox["gyy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gyy,
               Editable->False], 
              TagBox[
               RowBox[{"(", 
                RowBox[{"1", ",", "0"}], ")"}],
               Derivative],
              MultilineFunction->None], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}]}], ")"}]}], "-", 
         RowBox[{
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["gxx",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`gxx,
             Editable->False], 
            TagBox[
             RowBox[{"(", 
              RowBox[{"0", ",", "1"}], ")"}],
             Derivative],
            MultilineFunction->None], "[", 
           RowBox[{
            InterpretationBox[
             StyleBox["x",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`x[],
             Editable->False], ",", 
            InterpretationBox[
             StyleBox["y",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`y[],
             Editable->False]}], "]"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", 
             RowBox[{
              SuperscriptBox[
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], 
               TagBox[
                RowBox[{"(", 
                 RowBox[{"0", ",", "1"}], ")"}],
                Derivative],
               MultilineFunction->None], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}]}], "+", 
            RowBox[{
             SuperscriptBox[
              InterpretationBox[
               StyleBox["gyy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gyy,
               Editable->False], 
              TagBox[
               RowBox[{"(", 
                RowBox[{"1", ",", "0"}], ")"}],
               Derivative],
              MultilineFunction->None], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}], "+", 
      RowBox[{"2", " ", 
       SuperscriptBox[
        RowBox[{
         InterpretationBox[
          StyleBox["gxy",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`gxy,
          Editable->False], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["y",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`y[],
           Editable->False]}], "]"}], "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["gxx",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`gxx,
            Editable->False], 
           TagBox[
            RowBox[{"(", 
             RowBox[{"0", ",", "2"}], ")"}],
            Derivative],
           MultilineFunction->None], "[", 
          RowBox[{
           InterpretationBox[
            StyleBox["x",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x[],
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["y",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`y[],
            Editable->False]}], "]"}], "-", 
         RowBox[{"2", " ", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["gxy",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`gxy,
             Editable->False], 
            TagBox[
             RowBox[{"(", 
              RowBox[{"1", ",", "1"}], ")"}],
             Derivative],
            MultilineFunction->None], "[", 
           RowBox[{
            InterpretationBox[
             StyleBox["x",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`x[],
             Editable->False], ",", 
            InterpretationBox[
             StyleBox["y",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`y[],
             Editable->False]}], "]"}]}], "+", 
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["gyy",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`gyy,
            Editable->False], 
           TagBox[
            RowBox[{"(", 
             RowBox[{"2", ",", "0"}], ")"}],
            Derivative],
           MultilineFunction->None], "[", 
          RowBox[{
           InterpretationBox[
            StyleBox["x",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x[],
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["y",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`y[],
            Editable->False]}], "]"}]}], ")"}]}], "+", 
      RowBox[{
       RowBox[{
        InterpretationBox[
         StyleBox["gyy",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`gyy,
         Editable->False], "[", 
        RowBox[{
         InterpretationBox[
          StyleBox["x",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x[],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["y",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`y[],
          Editable->False]}], "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox[
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["gxx",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`gxx,
             Editable->False], 
            TagBox[
             RowBox[{"(", 
              RowBox[{"0", ",", "1"}], ")"}],
             Derivative],
            MultilineFunction->None], "[", 
           RowBox[{
            InterpretationBox[
             StyleBox["x",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`x[],
             Editable->False], ",", 
            InterpretationBox[
             StyleBox["y",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`y[],
             Editable->False]}], "]"}], "2"], "+", 
         RowBox[{
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["gxx",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`gxx,
             Editable->False], 
            TagBox[
             RowBox[{"(", 
              RowBox[{"1", ",", "0"}], ")"}],
             Derivative],
            MultilineFunction->None], "[", 
           RowBox[{
            InterpretationBox[
             StyleBox["x",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`x[],
             Editable->False], ",", 
            InterpretationBox[
             StyleBox["y",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`y[],
             Editable->False]}], "]"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "2"}], " ", 
             RowBox[{
              SuperscriptBox[
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], 
               TagBox[
                RowBox[{"(", 
                 RowBox[{"0", ",", "1"}], ")"}],
                Derivative],
               MultilineFunction->None], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}]}], "+", 
            RowBox[{
             SuperscriptBox[
              InterpretationBox[
               StyleBox["gyy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gyy,
               Editable->False], 
              TagBox[
               RowBox[{"(", 
                RowBox[{"1", ",", "0"}], ")"}],
               Derivative],
              MultilineFunction->None], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}]}], ")"}]}], "-", 
         RowBox[{"2", " ", 
          RowBox[{
           InterpretationBox[
            StyleBox["gxx",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`gxx,
            Editable->False], "[", 
           RowBox[{
            InterpretationBox[
             StyleBox["x",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`x[],
             Editable->False], ",", 
            InterpretationBox[
             StyleBox["y",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`y[],
             Editable->False]}], "]"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             SuperscriptBox[
              InterpretationBox[
               StyleBox["gxx",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxx,
               Editable->False], 
              TagBox[
               RowBox[{"(", 
                RowBox[{"0", ",", "2"}], ")"}],
               Derivative],
              MultilineFunction->None], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}], "-", 
            RowBox[{"2", " ", 
             RowBox[{
              SuperscriptBox[
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], 
               TagBox[
                RowBox[{"(", 
                 RowBox[{"1", ",", "1"}], ")"}],
                Derivative],
               MultilineFunction->None], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}]}], "+", 
            RowBox[{
             SuperscriptBox[
              InterpretationBox[
               StyleBox["gyy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gyy,
               Editable->False], 
              TagBox[
               RowBox[{"(", 
                RowBox[{"2", ",", "0"}], ")"}],
               Derivative],
              MultilineFunction->None], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}]}], ")"}], "/", 
    
    RowBox[{"(", 
     RowBox[{"2", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox[
          RowBox[{
           InterpretationBox[
            StyleBox["gxy",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`gxy,
            Editable->False], "[", 
           RowBox[{
            InterpretationBox[
             StyleBox["x",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`x[],
             Editable->False], ",", 
            InterpretationBox[
             StyleBox["y",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`y[],
             Editable->False]}], "]"}], "2"], "-", 
         RowBox[{
          RowBox[{
           InterpretationBox[
            StyleBox["gxx",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`gxx,
            Editable->False], "[", 
           RowBox[{
            InterpretationBox[
             StyleBox["x",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`x[],
             Editable->False], ",", 
            InterpretationBox[
             StyleBox["y",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`y[],
             Editable->False]}], "]"}], " ", 
          RowBox[{
           InterpretationBox[
            StyleBox["gyy",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`gyy,
            Editable->False], "[", 
           RowBox[{
            InterpretationBox[
             StyleBox["x",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`x[],
             Editable->False], ",", 
            InterpretationBox[
             StyleBox["y",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`y[],
             Editable->False]}], "]"}]}]}], ")"}], "2"]}], ")"}]}], ",", 
   RowBox[{"{", "}"}], ",", "0"}], "]"}]], "Output",ExpressionUUID->"5222e91d-\
f7b1-405f-abb8-47e31a8817a3"]
}, Open  ]],

Cell["The two connections are related by this Christoffel tensor:", "Text",ExpressionUUID->"415f5cca-c16b-4201-99e3-08b24e56cdb0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"chris", "=", 
  RowBox[{
   RowBox[{"Christoffel", "[", 
    RowBox[{"cd", ",", "LCmetric"}], "]"}], "//", "Simplify"}]}]], "Input",Exp\
ressionUUID->"4d438762-0f36-47b7-bb96-84cbd84d1bd3"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{
            RowBox[{
             InterpretationBox[
              StyleBox["gxy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxy,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["T112",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`T112,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}]}], "+", 
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["T212",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`T212,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}]}]}], ")"}]}], 
           RowBox[{
            SuperscriptBox[
             RowBox[{
              InterpretationBox[
               StyleBox["gxy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}], "2"], "-", 
            RowBox[{
             RowBox[{
              InterpretationBox[
               StyleBox["gxx",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxx,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}], " ", 
             RowBox[{
              InterpretationBox[
               StyleBox["gyy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gyy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}]}]}]]}], ",", 
         FractionBox[
          RowBox[{
           RowBox[{
            InterpretationBox[
             StyleBox["gyy",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`gyy,
             Editable->False], "[", 
            RowBox[{
             InterpretationBox[
              StyleBox["x",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`x[],
              Editable->False], ",", 
             InterpretationBox[
              StyleBox["y",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`y[],
              Editable->False]}], "]"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gxx",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxx,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["T112",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`T112,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}], "+", 
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["T212",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`T212,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}]}], ")"}]}], 
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox[
             RowBox[{
              InterpretationBox[
               StyleBox["gxy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}], "2"]}], "+", 
           RowBox[{
            RowBox[{
             InterpretationBox[
              StyleBox["gxx",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxx,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}], " ", 
            RowBox[{
             InterpretationBox[
              StyleBox["gyy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gyy,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}]}]}]]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{
            RowBox[{
             InterpretationBox[
              StyleBox["gxy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxy,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["T112",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`T112,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}]}], "+", 
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["T212",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`T212,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}]}]}], ")"}]}], 
           RowBox[{
            SuperscriptBox[
             RowBox[{
              InterpretationBox[
               StyleBox["gxy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}], "2"], "-", 
            RowBox[{
             RowBox[{
              InterpretationBox[
               StyleBox["gxx",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxx,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}], " ", 
             RowBox[{
              InterpretationBox[
               StyleBox["gyy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gyy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}]}]}]]}], ",", 
         FractionBox[
          RowBox[{
           RowBox[{
            InterpretationBox[
             StyleBox["gyy",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`gyy,
             Editable->False], "[", 
            RowBox[{
             InterpretationBox[
              StyleBox["x",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`x[],
              Editable->False], ",", 
             InterpretationBox[
              StyleBox["y",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`y[],
              Editable->False]}], "]"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["T112",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`T112,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}], "+", 
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gyy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gyy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["T212",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`T212,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}]}], ")"}]}], 
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox[
             RowBox[{
              InterpretationBox[
               StyleBox["gxy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}], "2"]}], "+", 
           RowBox[{
            RowBox[{
             InterpretationBox[
              StyleBox["gxx",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxx,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}], " ", 
            RowBox[{
             InterpretationBox[
              StyleBox["gyy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gyy,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}]}]}]]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         FractionBox[
          RowBox[{
           RowBox[{
            InterpretationBox[
             StyleBox["gxx",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`gxx,
             Editable->False], "[", 
            RowBox[{
             InterpretationBox[
              StyleBox["x",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`x[],
              Editable->False], ",", 
             InterpretationBox[
              StyleBox["y",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`y[],
              Editable->False]}], "]"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gxx",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxx,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["T112",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`T112,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}], "+", 
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["T212",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`T212,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox[
            RowBox[{
             InterpretationBox[
              StyleBox["gxy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxy,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}], "2"], "-", 
           RowBox[{
            RowBox[{
             InterpretationBox[
              StyleBox["gxx",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxx,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}], " ", 
            RowBox[{
             InterpretationBox[
              StyleBox["gyy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gyy,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}]}]}]], ",", 
         FractionBox[
          RowBox[{
           RowBox[{
            InterpretationBox[
             StyleBox["gxy",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`gxy,
             Editable->False], "[", 
            RowBox[{
             InterpretationBox[
              StyleBox["x",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`x[],
              Editable->False], ",", 
             InterpretationBox[
              StyleBox["y",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`y[],
              Editable->False]}], "]"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gxx",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxx,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["T112",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`T112,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}], "+", 
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["T212",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`T212,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox[
            RowBox[{
             InterpretationBox[
              StyleBox["gxy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxy,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}], "2"], "-", 
           RowBox[{
            RowBox[{
             InterpretationBox[
              StyleBox["gxx",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxx,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}], " ", 
            RowBox[{
             InterpretationBox[
              StyleBox["gyy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gyy,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}]}]}]]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         FractionBox[
          RowBox[{
           RowBox[{
            InterpretationBox[
             StyleBox["gxx",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`gxx,
             Editable->False], "[", 
            RowBox[{
             InterpretationBox[
              StyleBox["x",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`x[],
              Editable->False], ",", 
             InterpretationBox[
              StyleBox["y",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`y[],
              Editable->False]}], "]"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["T112",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`T112,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}], "+", 
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gyy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gyy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["T212",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`T212,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox[
            RowBox[{
             InterpretationBox[
              StyleBox["gxy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxy,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}], "2"], "-", 
           RowBox[{
            RowBox[{
             InterpretationBox[
              StyleBox["gxx",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxx,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}], " ", 
            RowBox[{
             InterpretationBox[
              StyleBox["gyy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gyy,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}]}]}]], ",", 
         FractionBox[
          RowBox[{
           RowBox[{
            InterpretationBox[
             StyleBox["gxy",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`gxy,
             Editable->False], "[", 
            RowBox[{
             InterpretationBox[
              StyleBox["x",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`x[],
              Editable->False], ",", 
             InterpretationBox[
              StyleBox["y",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`y[],
              Editable->False]}], "]"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["T112",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`T112,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}], "+", 
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gyy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gyy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["T212",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`T212,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox[
            RowBox[{
             InterpretationBox[
              StyleBox["gxy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxy,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}], "2"], "-", 
           RowBox[{
            RowBox[{
             InterpretationBox[
              StyleBox["gxx",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxx,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}], " ", 
            RowBox[{
             InterpretationBox[
              StyleBox["gyy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gyy,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}]}]}]]}], "}"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"gen", ",", 
     RowBox[{"-", "gen"}], ",", 
     RowBox[{"-", "gen"}]}], "}"}], ",", "0"}], "]"}]], "Output",ExpressionUUI\
D->"22f9503f-f19e-4f8d-9e7d-185af421ee0f"]
}, Open  ]],

Cell["Its antisymmetric part is the original torsion tensor:", "Text",ExpressionUUID->"83a5afdd-56b3-407f-9ace-d4c66a47b66c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"chris", "[", 
     RowBox[{"a", ",", 
      RowBox[{"-", "b"}], ",", 
      RowBox[{"-", "c"}]}], "]"}], "-", 
    RowBox[{"chris", "[", 
     RowBox[{"a", ",", 
      RowBox[{"-", "c"}], ",", 
      RowBox[{"-", "b"}]}], "]"}]}], "\[Equal]", 
   RowBox[{"torsion", "[", 
    RowBox[{"a", ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}]}], "]"}]}], "//", "Simplify"}]], "Input",ExpressionUUI\
D->"8ca55167-195b-4823-ab97-307efdd57999"],

Cell[BoxData["True"], "Output",ExpressionUUID->"cf06a684-ae0c-48fe-b78c-732062614adf"]
}, Open  ]],

Cell["Its symmetric part is a complicated object:", "Text",ExpressionUUID->"046cef0b-ade6-4e01-a479-c83af98e47df"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"chris", "[", 
    RowBox[{"a", ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}]}], "]"}], "+", 
   RowBox[{"chris", "[", 
    RowBox[{"a", ",", 
     RowBox[{"-", "c"}], ",", 
     RowBox[{"-", "b"}]}], "]"}]}], "//", "Simplify"}]], "Input",ExpressionUUI\
D->"e91a6835-ef13-4c1a-b32e-3750564875b2"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {GridBox[{
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]}]],
              Annotation[#, {1, 1, 1} -> (-2) $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]}]],
              Annotation[#, {1, 1, 2} -> -($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]}]],
              Annotation[#, {1, 2, 1} -> -($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                  RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
              Annotation[#, {1, 2, 2} -> 2 $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (-$CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
         {GridBox[{
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                  RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
              Annotation[#, {2, 1, 1} -> 2 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                  RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
              Annotation[#, {2, 1, 2} -> ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                  RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
              Annotation[#, {2, 2, 1} -> ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                  RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
              Annotation[#, {2, 2, 2} -> 2 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {"a", " ", " "},
         {" ", "b", "c"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{{(-2) $CellContext`gxy[
        $CellContext`x[], 
        $CellContext`y[]] ($CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[]]^2 - $CellContext`gxx[
          $CellContext`x[], 
          $CellContext`y[]] $CellContext`gyy[
          $CellContext`x[], 
          $CellContext`y[]])^(-1) ($CellContext`gxx[
          $CellContext`x[], 
          $CellContext`y[]] $CellContext`T112[
          $CellContext`x[], 
          $CellContext`y[]] + $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[]] $CellContext`T212[
          $CellContext`x[], 
          $CellContext`y[]]), -($CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[]]^2 - $CellContext`gxx[
          $CellContext`x[], 
          $CellContext`y[]] $CellContext`gyy[
          $CellContext`x[], 
          $CellContext`y[]])^(-1) ($CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[]]^2 $CellContext`T112[
          $CellContext`x[], 
          $CellContext`y[]] + $CellContext`gxx[
          $CellContext`x[], 
          $CellContext`y[]] $CellContext`gyy[
          $CellContext`x[], 
          $CellContext`y[]] $CellContext`T112[
          $CellContext`x[], 
          $CellContext`y[]] + 2 $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[]] $CellContext`gyy[
          $CellContext`x[], 
          $CellContext`y[]] $CellContext`T212[
          $CellContext`x[], 
          $CellContext`y[]])}, {-($CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[]]^2 - $CellContext`gxx[
          $CellContext`x[], 
          $CellContext`y[]] $CellContext`gyy[
          $CellContext`x[], 
          $CellContext`y[]])^(-1) ($CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[]]^2 $CellContext`T112[
          $CellContext`x[], 
          $CellContext`y[]] + $CellContext`gxx[
          $CellContext`x[], 
          $CellContext`y[]] $CellContext`gyy[
          $CellContext`x[], 
          $CellContext`y[]] $CellContext`T112[
          $CellContext`x[], 
          $CellContext`y[]] + 2 $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[]] $CellContext`gyy[
          $CellContext`x[], 
          $CellContext`y[]] $CellContext`T212[
          $CellContext`x[], 
          $CellContext`y[]]), 2 $CellContext`gyy[
        $CellContext`x[], 
        $CellContext`y[]] (-$CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[]]^2 + $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[]] $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[]])^(-1) ($CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[]] $CellContext`T112[
          $CellContext`x[], 
          $CellContext`y[]] + $CellContext`gyy[
          $CellContext`x[], 
          $CellContext`y[]] $CellContext`T212[
          $CellContext`x[], 
          $CellContext`y[]])}}, {{2 $CellContext`gxx[
        $CellContext`x[], 
        $CellContext`y[]] ($CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[]]^2 - $CellContext`gxx[
          $CellContext`x[], 
          $CellContext`y[]] $CellContext`gyy[
          $CellContext`x[], 
          $CellContext`y[]])^(-1) ($CellContext`gxx[
          $CellContext`x[], 
          $CellContext`y[]] $CellContext`T112[
          $CellContext`x[], 
          $CellContext`y[]] + $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[]] $CellContext`T212[
          $CellContext`x[], 
          $CellContext`y[]]), ($CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[]]^2 - $CellContext`gxx[
          $CellContext`x[], 
          $CellContext`y[]] $CellContext`gyy[
          $CellContext`x[], 
          $CellContext`y[]])^(-1) ($CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[]]^2 $CellContext`T212[
          $CellContext`x[], 
          $CellContext`y[]] + $CellContext`gxx[
          $CellContext`x[], 
          $CellContext`y[]] (2 $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[]] $CellContext`T112[
            $CellContext`x[], 
            $CellContext`y[]] + $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[]] $CellContext`T212[
            $CellContext`x[], 
            $CellContext`y[]]))}, {($CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[]]^2 - $CellContext`gxx[
          $CellContext`x[], 
          $CellContext`y[]] $CellContext`gyy[
          $CellContext`x[], 
          $CellContext`y[]])^(-1) ($CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[]]^2 $CellContext`T212[
          $CellContext`x[], 
          $CellContext`y[]] + $CellContext`gxx[
          $CellContext`x[], 
          $CellContext`y[]] (2 $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[]] $CellContext`T112[
            $CellContext`x[], 
            $CellContext`y[]] + $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[]] $CellContext`T212[
            $CellContext`x[], 
            $CellContext`y[]])), 2 $CellContext`gxy[
        $CellContext`x[], 
        $CellContext`y[]] ($CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[]]^2 - $CellContext`gxx[
          $CellContext`x[], 
          $CellContext`y[]] $CellContext`gyy[
          $CellContext`x[], 
          $CellContext`y[]])^(-1) ($CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[]] $CellContext`T112[
          $CellContext`x[], 
          $CellContext`y[]] + $CellContext`gyy[
          $CellContext`x[], 
          $CellContext`y[]] $CellContext`T212[
          $CellContext`x[], 
          $CellContext`y[]])}}}, {$CellContext`gen, -$CellContext`gen, \
-$CellContext`gen}, 0][$CellContext`a, -$CellContext`b, -$CellContext`c],
  Editable->False]], "Output",ExpressionUUID->"6cad2eee-9a22-4506-bf30-\
e6d439c663ec"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Head", "[", "%", "]"}]], "Input",ExpressionUUID->"045b9d2e-4e39-4503-87be-69aef118aaec"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"2", " ", 
            RowBox[{
             InterpretationBox[
              StyleBox["gxy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxy,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["T112",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`T112,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}]}], "+", 
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["T212",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`T212,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}]}]}], ")"}]}], 
           RowBox[{
            SuperscriptBox[
             RowBox[{
              InterpretationBox[
               StyleBox["gxy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}], "2"], "-", 
            RowBox[{
             RowBox[{
              InterpretationBox[
               StyleBox["gxx",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxx,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}], " ", 
             RowBox[{
              InterpretationBox[
               StyleBox["gyy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gyy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}]}]}]]}], ",", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{
            RowBox[{
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], "2"], " ", 
             RowBox[{
              InterpretationBox[
               StyleBox["T112",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`T112,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}]}], "+", 
            RowBox[{
             RowBox[{
              InterpretationBox[
               StyleBox["gxx",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxx,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}], " ", 
             RowBox[{
              InterpretationBox[
               StyleBox["gyy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gyy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}], " ", 
             RowBox[{
              InterpretationBox[
               StyleBox["T112",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`T112,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}]}], "+", 
            RowBox[{"2", " ", 
             RowBox[{
              InterpretationBox[
               StyleBox["gxy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}], " ", 
             RowBox[{
              InterpretationBox[
               StyleBox["gyy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gyy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}], " ", 
             RowBox[{
              InterpretationBox[
               StyleBox["T212",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`T212,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}]}]}], 
           RowBox[{
            SuperscriptBox[
             RowBox[{
              InterpretationBox[
               StyleBox["gxy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}], "2"], "-", 
            RowBox[{
             RowBox[{
              InterpretationBox[
               StyleBox["gxx",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxx,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}], " ", 
             RowBox[{
              InterpretationBox[
               StyleBox["gyy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gyy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}]}]}]]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{
            RowBox[{
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], "2"], " ", 
             RowBox[{
              InterpretationBox[
               StyleBox["T112",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`T112,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}]}], "+", 
            RowBox[{
             RowBox[{
              InterpretationBox[
               StyleBox["gxx",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxx,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}], " ", 
             RowBox[{
              InterpretationBox[
               StyleBox["gyy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gyy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}], " ", 
             RowBox[{
              InterpretationBox[
               StyleBox["T112",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`T112,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}]}], "+", 
            RowBox[{"2", " ", 
             RowBox[{
              InterpretationBox[
               StyleBox["gxy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}], " ", 
             RowBox[{
              InterpretationBox[
               StyleBox["gyy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gyy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}], " ", 
             RowBox[{
              InterpretationBox[
               StyleBox["T212",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`T212,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}]}]}], 
           RowBox[{
            SuperscriptBox[
             RowBox[{
              InterpretationBox[
               StyleBox["gxy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}], "2"], "-", 
            RowBox[{
             RowBox[{
              InterpretationBox[
               StyleBox["gxx",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxx,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}], " ", 
             RowBox[{
              InterpretationBox[
               StyleBox["gyy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gyy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}]}]}]]}], ",", 
         FractionBox[
          RowBox[{"2", " ", 
           RowBox[{
            InterpretationBox[
             StyleBox["gyy",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`gyy,
             Editable->False], "[", 
            RowBox[{
             InterpretationBox[
              StyleBox["x",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`x[],
              Editable->False], ",", 
             InterpretationBox[
              StyleBox["y",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`y[],
              Editable->False]}], "]"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["T112",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`T112,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}], "+", 
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gyy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gyy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["T212",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`T212,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}]}], ")"}]}], 
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox[
             RowBox[{
              InterpretationBox[
               StyleBox["gxy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}], "2"]}], "+", 
           RowBox[{
            RowBox[{
             InterpretationBox[
              StyleBox["gxx",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxx,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}], " ", 
            RowBox[{
             InterpretationBox[
              StyleBox["gyy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gyy,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}]}]}]]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         FractionBox[
          RowBox[{"2", " ", 
           RowBox[{
            InterpretationBox[
             StyleBox["gxx",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`gxx,
             Editable->False], "[", 
            RowBox[{
             InterpretationBox[
              StyleBox["x",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`x[],
              Editable->False], ",", 
             InterpretationBox[
              StyleBox["y",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`y[],
              Editable->False]}], "]"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gxx",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxx,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["T112",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`T112,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}], "+", 
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["T212",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`T212,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox[
            RowBox[{
             InterpretationBox[
              StyleBox["gxy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxy,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}], "2"], "-", 
           RowBox[{
            RowBox[{
             InterpretationBox[
              StyleBox["gxx",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxx,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}], " ", 
            RowBox[{
             InterpretationBox[
              StyleBox["gyy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gyy,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}]}]}]], ",", 
         FractionBox[
          RowBox[{
           RowBox[{
            SuperscriptBox[
             RowBox[{
              InterpretationBox[
               StyleBox["gxy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}], "2"], " ", 
            RowBox[{
             InterpretationBox[
              StyleBox["T212",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`T212,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}]}], "+", 
           RowBox[{
            RowBox[{
             InterpretationBox[
              StyleBox["gxx",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxx,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["T112",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`T112,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}]}], "+", 
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["T212",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`T212,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}]}]}], ")"}]}]}], 
          RowBox[{
           SuperscriptBox[
            RowBox[{
             InterpretationBox[
              StyleBox["gxy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxy,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}], "2"], "-", 
           RowBox[{
            RowBox[{
             InterpretationBox[
              StyleBox["gxx",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxx,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}], " ", 
            RowBox[{
             InterpretationBox[
              StyleBox["gyy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gyy,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}]}]}]]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         FractionBox[
          RowBox[{
           RowBox[{
            SuperscriptBox[
             RowBox[{
              InterpretationBox[
               StyleBox["gxy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}], "2"], " ", 
            RowBox[{
             InterpretationBox[
              StyleBox["T212",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`T212,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}]}], "+", 
           RowBox[{
            RowBox[{
             InterpretationBox[
              StyleBox["gxx",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxx,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["T112",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`T112,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}]}], "+", 
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{
                InterpretationBox[
                 StyleBox["T212",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`T212,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}]}]}], ")"}]}]}], 
          RowBox[{
           SuperscriptBox[
            RowBox[{
             InterpretationBox[
              StyleBox["gxy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxy,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}], "2"], "-", 
           RowBox[{
            RowBox[{
             InterpretationBox[
              StyleBox["gxx",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxx,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}], " ", 
            RowBox[{
             InterpretationBox[
              StyleBox["gyy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gyy,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}]}]}]], ",", 
         FractionBox[
          RowBox[{"2", " ", 
           RowBox[{
            InterpretationBox[
             StyleBox["gxy",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`gxy,
             Editable->False], "[", 
            RowBox[{
             InterpretationBox[
              StyleBox["x",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`x[],
              Editable->False], ",", 
             InterpretationBox[
              StyleBox["y",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`y[],
              Editable->False]}], "]"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["T112",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`T112,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}], "+", 
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["gyy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gyy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["T212",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`T212,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}]}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox[
            RowBox[{
             InterpretationBox[
              StyleBox["gxy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxy,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}], "2"], "-", 
           RowBox[{
            RowBox[{
             InterpretationBox[
              StyleBox["gxx",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxx,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}], " ", 
            RowBox[{
             InterpretationBox[
              StyleBox["gyy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gyy,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False]}], "]"}]}]}]]}], "}"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"gen", ",", 
     RowBox[{"-", "gen"}], ",", 
     RowBox[{"-", "gen"}]}], "}"}], ",", "0"}], "]"}]], "Output",ExpressionUUI\
D->"7c9bd401-901e-4e4e-9718-2c5ae5862981"]
}, Open  ]],

Cell["Note the following relations:", "Text",ExpressionUUID->"9a727545-4d86-4bfa-9a61-a273ce717591"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CovDOfMetric", "[", 
   RowBox[{"metric", ",", "Zero"}], "]"}], "===", "LCmetric"}]], "Input",Expre\
ssionUUID->"50b6a309-c669-4e9d-91de-63335b3fe4d6"],

Cell[BoxData["True"], "Output",ExpressionUUID->"5f3245c8-d20c-4a31-bf46-d5e6abb11814"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CovDOfMetric", "[", 
   RowBox[{"metric", ",", "torsion"}], "]"}], "===", "cd"}]], "Input",Expressi\
onUUID->"46123a57-6eaa-4712-87e0-5c070367e3c5"],

Cell[BoxData["True"], "Output",ExpressionUUID->"f189bb66-03f5-4185-a3b6-ffd5fa4c12dd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CovDOfMetric", "[", "metric", "]"}], "===", "cd"}]], "Input",Expres\
sionUUID->"50e486d6-a3db-4864-9289-b22207b6a547"],

Cell[BoxData["True"], "Output",ExpressionUUID->"2ef40a10-a610-4e8e-8707-0022fafa33a7"]
}, Open  ]],

Cell["Full cache table:", "Text",ExpressionUUID->"a5a9e91c-e97a-4565-991c-48df964becc2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PrintxCobaCache", "[", "]"}]], "Input",ExpressionUUID->"c60198fd-2a72-4821-b3c5-e6cf92b66f95"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {"1", 
     RowBox[{"\<\"ReportCompute\"\>", "[", 
      RowBox[{"\<\"ADChristoffel\"\>", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}]}], "]"}], "]"}], GridBox[{
       {
        RowBox[{"\[LeftSkeleton]", "4", "\[RightSkeleton]"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"2", 
     RowBox[{"\<\"ReportCompute\"\>", "[", 
      RowBox[{"\<\"CDRiemann\"\>", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}]}], "]"}], "]"}], GridBox[{
       {
        RowBox[{"\[LeftSkeleton]", "2", "\[RightSkeleton]"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"3", 
     RowBox[{"\<\"ReportCompute\"\>", "[", 
      RowBox[{"\<\"Christoffel\"\>", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}]}], "]"}], "]"}], GridBox[{
       {
        RowBox[{"\[LeftSkeleton]", "8", "\[RightSkeleton]"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"4", 
     RowBox[{"\<\"ReportCompute\"\>", "[", 
      RowBox[{"\<\"Christoffel\"\>", "[", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}]}], "]"}], "]"}], GridBox[{
       {
        RowBox[{"\[LeftSkeleton]", "8", "\[RightSkeleton]"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"5", 
     RowBox[{"\<\"ReportCompute\"\>", "[", 
      RowBox[{"\<\"DetMetric\"\>", "[", "]"}], "]"}], GridBox[{
       {
        RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"6", 
     RowBox[{"\<\"ReportCompute\"\>", "[", 
      RowBox[{"\<\"DMetric\"\>", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}]}], "]"}], "]"}], GridBox[{
       {
        RowBox[{"\[LeftSkeleton]", "6", "\[RightSkeleton]"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"7", 
     RowBox[{"\<\"ReportCompute\"\>", "[", 
      RowBox[{"\<\"Einstein\"\>", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}]}], "]"}], "]"}], GridBox[{
       {
        RowBox[{"\[LeftSkeleton]", "4", "\[RightSkeleton]"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"8", 
     RowBox[{"\<\"ReportCompute\"\>", "[", 
      RowBox[{"\<\"Kretschmann\"\>", "[", "]"}], "]"}], GridBox[{
       {
        RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"9", 
     RowBox[{"\<\"ReportCompute\"\>", "[", 
      RowBox[{"\<\"Metric\"\>", "[", 
       RowBox[{"1", ",", "1"}], "]"}], "]"}], GridBox[{
       {
        RowBox[{"\[LeftSkeleton]", "3", "\[RightSkeleton]"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"10", 
     RowBox[{"\<\"ReportCompute\"\>", "[", 
      RowBox[{"\<\"Ricci\"\>", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}]}], "]"}], "]"}], GridBox[{
       {
        RowBox[{"\[LeftSkeleton]", "4", "\[RightSkeleton]"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"11", 
     RowBox[{"\<\"ReportCompute\"\>", "[", 
      RowBox[{"\<\"RicciScalar\"\>", "[", "]"}], "]"}], GridBox[{
       {
        RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"12", 
     RowBox[{"\<\"ReportCompute\"\>", "[", 
      RowBox[{"\<\"Riemann\"\>", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}]}], "]"}], "]"}], GridBox[{
       {
        RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"13", 
     RowBox[{"\<\"ReportCompute\"\>", "[", 
      RowBox[{"\<\"Riemann\"\>", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}], ",", "1"}], "]"}], "]"}], GridBox[{
       {
        RowBox[{"\[LeftSkeleton]", "4", "\[RightSkeleton]"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"14", 
     RowBox[{"\<\"ReportCompute\"\>", "[", 
      RowBox[{"\<\"Riemann\"\>", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}], ",", "1", ",", "1"}], "]"}], "]"}], GridBox[{
       {
        RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"15", 
     RowBox[{"\<\"ReportCompute\"\>", "[", 
      RowBox[{"\<\"Torsion\"\>", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}]}], "]"}], "]"}], GridBox[{
       {
        RowBox[{"\[LeftSkeleton]", "2", "\[RightSkeleton]"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"16", 
     RowBox[{"\<\"ChartsOf\"\>", "[", 
      RowBox[{"{", 
       RowBox[{"\[LeftSkeleton]", "2", "\[RightSkeleton]"}], "}"}], "]"}], 
     TagBox[
      RowBox[{"{", "gen", "}"}],
      Short[#, 1]& ]},
    {"17", 
     RowBox[{"\<\"ChartsOf\"\>", "[", 
      RowBox[{"{", 
       RowBox[{"\[LeftSkeleton]", "2", "\[RightSkeleton]"}], "}"}], "]"}], 
     TagBox[
      RowBox[{"{", "gen", "}"}],
      Short[#, 1]& ]},
    {"18", 
     RowBox[{"\<\"ChartsOf\"\>", "[", 
      RowBox[{"{", 
       RowBox[{"\[LeftSkeleton]", "2", "\[RightSkeleton]"}], "}"}], "]"}], 
     TagBox[
      RowBox[{"{", "gen", "}"}],
      Short[#, 1]& ]},
    {"19", 
     TagBox[
      RowBox[{"Christoffel", "[", 
       RowBox[{
        RowBox[{"CCovD", "[", 
         RowBox[{"PDgen", ",", 
          StyleBox[GridBox[{
             {GridBox[{
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                  Annotation[#, {1, 1, 1} -> Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {1, 1, 2} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
               },
               AutoDelete->False,
               
               GridBoxDividers->{
                "ColumnsIndexed" -> {
                  1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], 
              GridBox[{
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {1, 2, 1} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {1, 2, 2} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
               },
               AutoDelete->False,
               
               GridBoxDividers->{
                "ColumnsIndexed" -> {
                  1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
             {GridBox[{
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {2, 1, 1} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {2, 1, 2} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
               },
               AutoDelete->False,
               
               GridBoxDividers->{
                "ColumnsIndexed" -> {
                  1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], 
              GridBox[{
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {2, 2, 1} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {2, 2, 2} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
               },
               AutoDelete->False,
               
               GridBoxDividers->{
                "ColumnsIndexed" -> {
                  1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
              "RowsIndexed" -> {
               1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
           FontSize->Small], ",", 
          StyleBox[GridBox[{
             {
              TagBox[
               TooltipBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxx",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxx,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
               Annotation[#, {1, 1} -> $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]], "Tooltip"]& ], 
              TagBox[
               TooltipBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
               Annotation[#, {1, 2} -> $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]], "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
               Annotation[#, {2, 1} -> $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]], "Tooltip"]& ], 
              TagBox[
               TooltipBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gyy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gyy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
               Annotation[#, {2, 2} -> $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]], "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
              "RowsIndexed" -> {
               1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
           FontSize->Small]}], "]"}], ",", "PDgen"}], "]"}],
      Short[#, 1]& ], 
     TagBox[
      StyleBox[GridBox[{
         {GridBox[{
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
              Annotation[#, {1, 1, 1} -> Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
              Annotation[#, {1, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
              Annotation[#, {1, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
              Annotation[#, {1, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
         {GridBox[{
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
              Annotation[#, {2, 1, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
              Annotation[#, {2, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
              Annotation[#, {2, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
              Annotation[#, {2, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
       FontSize->Small],
      Short[#, 1]& ]},
    {"20", 
     TagBox[
      RowBox[{"CovDOfMetric", "[", 
       StyleBox[GridBox[{
          {
           TagBox[
            TooltipBox[
             RowBox[{
              InterpretationBox[
               StyleBox["gxx",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxx,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}],
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], $CellContext`gxx, Editable -> False], "[", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                   InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
            Annotation[#, {1, 1} -> $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]], "Tooltip"]& ], 
           TagBox[
            TooltipBox[
             RowBox[{
              InterpretationBox[
               StyleBox["gxy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}],
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], $CellContext`gxy, Editable -> False], "[", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                   InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
            Annotation[#, {1, 2} -> $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]], "Tooltip"]& ]},
          {
           TagBox[
            TooltipBox[
             RowBox[{
              InterpretationBox[
               StyleBox["gxy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}],
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], $CellContext`gxy, Editable -> False], "[", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                   InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
            Annotation[#, {2, 1} -> $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]], "Tooltip"]& ], 
           TagBox[
            TooltipBox[
             RowBox[{
              InterpretationBox[
               StyleBox["gyy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gyy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}],
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], $CellContext`gyy, Editable -> False], "[", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                   InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
            Annotation[#, {2, 2} -> $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]], "Tooltip"]& ]}
         },
         AutoDelete->False,
         GridBoxDividers->{
          "ColumnsIndexed" -> {
            1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
        FontSize->Small], "]"}],
      Short[#, 1]& ], 
     TagBox[
      RowBox[{"CCovD", "[", 
       RowBox[{"PDgen", ",", 
        StyleBox[GridBox[{
           {GridBox[{
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                   RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                Annotation[#, {1, 1, 1} -> Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                Annotation[#, {1, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                Annotation[#, {1, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                Annotation[#, {1, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
           {GridBox[{
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                Annotation[#, {2, 1, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                Annotation[#, {2, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                Annotation[#, {2, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                Annotation[#, {2, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
          },
          AutoDelete->False,
          
          GridBoxDividers->{
           "ColumnsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
            "RowsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
         FontSize->Small], ",", 
        StyleBox[GridBox[{
           {
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxx",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxx,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {1, 1} -> $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {1, 2} -> $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ]},
           {
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {2, 1} -> $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gyy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gyy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {2, 2} -> $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ]}
          },
          AutoDelete->False,
          
          GridBoxDividers->{
           "ColumnsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
            "RowsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
         FontSize->Small]}], "]"}],
      Short[#, 1]& ]},
    {"21", 
     TagBox[
      RowBox[{"CovDOfMetric", "[", 
       RowBox[{
        StyleBox[GridBox[{
           {
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxx",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxx,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {1, 1} -> $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {1, 2} -> $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ]},
           {
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {2, 1} -> $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gyy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gyy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {2, 2} -> $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ]}
          },
          AutoDelete->False,
          
          GridBoxDividers->{
           "ColumnsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
            "RowsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
         FontSize->Small], ",", "Zero"}], "]"}],
      Short[#, 1]& ], 
     TagBox[
      RowBox[{"CCovD", "[", 
       RowBox[{"PDgen", ",", 
        StyleBox[GridBox[{
           {GridBox[{
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                   RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                Annotation[#, {1, 1, 1} -> Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                Annotation[#, {1, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (-$CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                Annotation[#, {1, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (-$CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                Annotation[#, {1, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
           {GridBox[{
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                Annotation[#, {2, 1, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
                Annotation[#, {2, 1, 2} -> (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
                Annotation[#, {2, 2, 1} -> (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                   RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                Annotation[#, {2, 2, 2} -> Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
          },
          AutoDelete->False,
          
          GridBoxDividers->{
           "ColumnsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
            "RowsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
         FontSize->Small], ",", 
        StyleBox[GridBox[{
           {
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxx",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxx,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {1, 1} -> $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {1, 2} -> $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ]},
           {
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {2, 1} -> $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gyy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gyy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {2, 2} -> $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ]}
          },
          AutoDelete->False,
          
          GridBoxDividers->{
           "ColumnsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
            "RowsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
         FontSize->Small]}], "]"}],
      Short[#, 1]& ]},
    {"22", 
     TagBox[
      RowBox[{"CovDOfMetric", "[", 
       RowBox[{
        StyleBox[GridBox[{
           {
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxx",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxx,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {1, 1} -> $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {1, 2} -> $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ]},
           {
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {2, 1} -> $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gyy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gyy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {2, 2} -> $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ]}
          },
          AutoDelete->False,
          
          GridBoxDividers->{
           "ColumnsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
            "RowsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
         FontSize->Small], ",", 
        StyleBox[GridBox[{
           {GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {1, 1, 1} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox[
                 RowBox[{
                  InterpretationBox[
                   StyleBox["T112",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`T112,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
                Annotation[#, {1, 1, 2} -> $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]], "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                   RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]],
                Annotation[#, {1, 2, 1} -> -$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]], "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {1, 2, 2} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
           {GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {2, 1, 1} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox[
                 RowBox[{
                  InterpretationBox[
                   StyleBox["T212",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`T212,
                   Editable->False], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`y[],
                    Editable->False]}], "]"}],
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
                Annotation[#, {2, 1, 2} -> $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]], "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                   RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]],
                Annotation[#, {2, 2, 1} -> -$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]], "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                   "0"}]],
                Annotation[#, {2, 2, 2} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
          },
          AutoDelete->False,
          
          GridBoxDividers->{
           "ColumnsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
            "RowsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
         FontSize->Small]}], "]"}],
      Short[#, 1]& ], 
     TagBox[
      RowBox[{"CCovD", "[", 
       RowBox[{"PDgen", ",", 
        StyleBox[GridBox[{
           {GridBox[{
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                   RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                Annotation[#, {1, 1, 1} -> Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                Annotation[#, {1, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                Annotation[#, {1, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                Annotation[#, {1, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
           {GridBox[{
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                Annotation[#, {2, 1, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                Annotation[#, {2, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                Annotation[#, {2, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                Annotation[#, {2, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
          },
          AutoDelete->False,
          
          GridBoxDividers->{
           "ColumnsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
            "RowsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
         FontSize->Small], ",", 
        StyleBox[GridBox[{
           {
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxx",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxx,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {1, 1} -> $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {1, 2} -> $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ]},
           {
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {2, 1} -> $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gyy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gyy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {2, 2} -> $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ]}
          },
          AutoDelete->False,
          
          GridBoxDividers->{
           "ColumnsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
            "RowsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
         FontSize->Small]}], "]"}],
      Short[#, 1]& ]},
    {"23", 
     TagBox[
      RowBox[{"Determinant", "[", 
       RowBox[{
        StyleBox[GridBox[{
           {
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxx",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxx,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {1, 1} -> $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {1, 2} -> $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ]},
           {
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {2, 1} -> $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gyy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gyy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {2, 2} -> $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ]}
          },
          AutoDelete->False,
          
          GridBoxDividers->{
           "ColumnsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
            "RowsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
         FontSize->Small], ",", "gen"}], "]"}],
      Short[#, 1]& ], 
     TagBox[
      OverscriptBox[
       OverscriptBox[
        RowBox[{"CTensor", "[", 
         RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], "]"}], 
        RowBox[{"\[LeftSkeleton]", "49", "\[RightSkeleton]"}]], 
       StyleBox["~",
        FontColor->RGBColor[1., 0., 0.]]],
      Short[#, 1]& ]},
    {"24", 
     TagBox[
      RowBox[{"Einstein", "[", 
       RowBox[{"CCovD", "[", 
        RowBox[{"PDgen", ",", 
         StyleBox[GridBox[{
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                 
                 Annotation[#, {1, 1, 1} -> 
                  Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 1, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small], ",", 
         StyleBox[GridBox[{
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 1} -> $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 2} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 1} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 2} -> $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small]}], "]"}], "]"}],
      Short[#, 1]& ], 
     TagBox["Zero",
      Short[#, 1]& ]},
    {"25", 
     TagBox[
      RowBox[{"Inv", "[", 
       StyleBox[GridBox[{
          {
           TagBox[
            TooltipBox[
             RowBox[{
              InterpretationBox[
               StyleBox["gxx",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxx,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}],
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], $CellContext`gxx, Editable -> False], "[", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                   InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
            Annotation[#, {1, 1} -> $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]], "Tooltip"]& ], 
           TagBox[
            TooltipBox[
             RowBox[{
              InterpretationBox[
               StyleBox["gxy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}],
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], $CellContext`gxy, Editable -> False], "[", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                   InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
            Annotation[#, {1, 2} -> $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]], "Tooltip"]& ]},
          {
           TagBox[
            TooltipBox[
             RowBox[{
              InterpretationBox[
               StyleBox["gxy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}],
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], $CellContext`gxy, Editable -> False], "[", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                   InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
            Annotation[#, {2, 1} -> $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]], "Tooltip"]& ], 
           TagBox[
            TooltipBox[
             RowBox[{
              InterpretationBox[
               StyleBox["gyy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gyy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}],
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], $CellContext`gyy, Editable -> False], "[", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                   InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
            Annotation[#, {2, 2} -> $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]], "Tooltip"]& ]}
         },
         AutoDelete->False,
         GridBoxDividers->{
          "ColumnsIndexed" -> {
            1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
        FontSize->Small], "]"}],
      Short[#, 1]& ], 
     TagBox[
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], $CellContext`gyy, Editable -> False], "[", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                   InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], 
               RowBox[{
                 RowBox[{"-", 
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                 "+", 
                 RowBox[{
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
           Annotation[#, {1, 1} -> $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]]/(-$CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]]^2 + $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]]), "Tooltip"]& ], 
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], $CellContext`gxy, Editable -> False], "[", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                   InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], 
               RowBox[{
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                 
                 RowBox[{
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
           Annotation[#, {1, 2} -> $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]/($CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]]^2 - $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]] $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]]), "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], $CellContext`gxy, Editable -> False], "[", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                   InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], 
               RowBox[{
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                 
                 RowBox[{
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
           Annotation[#, {2, 1} -> $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]/($CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]]^2 - $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]] $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]]), "Tooltip"]& ], 
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], $CellContext`gxx, Editable -> False], "[", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                   InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], 
               RowBox[{
                 RowBox[{"-", 
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                 "+", 
                 RowBox[{
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
           Annotation[#, {2, 2} -> $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]]/(-$CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]]^2 + $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]]), "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
       FontSize->Small],
      Short[#, 1]& ]},
    {"26", 
     TagBox[
      RowBox[{"Kretschmann", "[", 
       RowBox[{"CCovD", "[", 
        RowBox[{"PDgen", ",", 
         StyleBox[GridBox[{
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                 
                 Annotation[#, {1, 1, 1} -> 
                  Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 1, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small], ",", 
         StyleBox[GridBox[{
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 1} -> $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 2} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 1} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 2} -> $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small]}], "]"}], "]"}],
      Short[#, 1]& ], 
     TagBox[
      RowBox[{"CTensor", "[", 
       RowBox[{
        FractionBox[
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], "2"], " ", 
             RowBox[{"(", 
              RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], ")"}]}], 
            "+", 
            RowBox[{"\[LeftSkeleton]", "5", "\[RightSkeleton]"}]}], ")"}], 
          "2"], 
         RowBox[{"4", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], ")"}], 
           "4"]}]], ",", 
        RowBox[{"{", "}"}], ",", "0"}], "]"}],
      Short[#, 1]& ]},
    {"27", 
     TagBox[
      RowBox[{"LC", "[", 
       StyleBox[GridBox[{
          {
           TagBox[
            TooltipBox[
             RowBox[{
              InterpretationBox[
               StyleBox["gxx",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxx,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}],
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], $CellContext`gxx, Editable -> False], "[", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                   InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
            Annotation[#, {1, 1} -> $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]], "Tooltip"]& ], 
           TagBox[
            TooltipBox[
             RowBox[{
              InterpretationBox[
               StyleBox["gxy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}],
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], $CellContext`gxy, Editable -> False], "[", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                   InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
            Annotation[#, {1, 2} -> $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]], "Tooltip"]& ]},
          {
           TagBox[
            TooltipBox[
             RowBox[{
              InterpretationBox[
               StyleBox["gxy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}],
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], $CellContext`gxy, Editable -> False], "[", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                   InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
            Annotation[#, {2, 1} -> $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]], "Tooltip"]& ], 
           TagBox[
            TooltipBox[
             RowBox[{
              InterpretationBox[
               StyleBox["gyy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gyy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}],
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], $CellContext`gyy, Editable -> False], "[", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                   InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
            Annotation[#, {2, 2} -> $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]], "Tooltip"]& ]}
         },
         AutoDelete->False,
         GridBoxDividers->{
          "ColumnsIndexed" -> {
            1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
        FontSize->Small], "]"}],
      Short[#, 1]& ], 
     TagBox[
      RowBox[{"CCovD", "[", 
       RowBox[{"PDgen", ",", 
        StyleBox[GridBox[{
           {GridBox[{
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                   RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                Annotation[#, {1, 1, 1} -> Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                Annotation[#, {1, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (-$CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                Annotation[#, {1, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (-$CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                Annotation[#, {1, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
           {GridBox[{
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                Annotation[#, {2, 1, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
                Annotation[#, {2, 1, 2} -> (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
                Annotation[#, {2, 2, 1} -> (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                   RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                Annotation[#, {2, 2, 2} -> Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
          },
          AutoDelete->False,
          
          GridBoxDividers->{
           "ColumnsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
            "RowsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
         FontSize->Small], ",", 
        StyleBox[GridBox[{
           {
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxx",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxx,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {1, 1} -> $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {1, 2} -> $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ]},
           {
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {2, 1} -> $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gyy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gyy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {2, 2} -> $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ]}
          },
          AutoDelete->False,
          
          GridBoxDividers->{
           "ColumnsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
            "RowsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
         FontSize->Small]}], "]"}],
      Short[#, 1]& ]},
    {"28", 
     TagBox[
      RowBox[{"Ricci", "[", 
       RowBox[{"CCovD", "[", 
        RowBox[{"PDgen", ",", 
         StyleBox[GridBox[{
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                 
                 Annotation[#, {1, 1, 1} -> 
                  Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (-$CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (-$CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 1, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
                 Annotation[#, {2, 1, 2} -> (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
                 Annotation[#, {2, 2, 1} -> (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                 Annotation[#, {2, 2, 2} -> 
                  Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small], ",", 
         StyleBox[GridBox[{
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 1} -> $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 2} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 1} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 2} -> $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small]}], "]"}], "]"}],
      Short[#, 1]& ], 
     TagBox[
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                 RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
               RowBox[{"4", " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                  "2"]}]]}]],
           Annotation[#, {1, 1} -> Rational[1, 4] $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]] ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-2) ($CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]^2) + $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])) + 2 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) + $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))), "Tooltip"]& ], 
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                 RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
               RowBox[{"4", " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                  "2"]}]]}]],
           Annotation[#, {1, 2} -> Rational[1, 4] $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]] ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-2) ($CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]^2) + $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])) + 2 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) + $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))), "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                 RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
               RowBox[{"4", " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                  "2"]}]]}]],
           Annotation[#, {2, 1} -> Rational[1, 4] $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]] ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-2) ($CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]^2) + $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])) + 2 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) + $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))), "Tooltip"]& ], 
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                 RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
               RowBox[{"4", " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                  "2"]}]]}]],
           Annotation[#, {2, 2} -> Rational[1, 4] $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]] ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-2) ($CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]^2) + $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])) + 2 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) + $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))), "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
       FontSize->Small],
      Short[#, 1]& ]},
    {"29", 
     TagBox[
      RowBox[{"Ricci", "[", 
       RowBox[{"CCovD", "[", 
        RowBox[{"PDgen", ",", 
         StyleBox[GridBox[{
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                 
                 Annotation[#, {1, 1, 1} -> 
                  Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 1, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small], ",", 
         StyleBox[GridBox[{
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 1} -> $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 2} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 1} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 2} -> $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small]}], "]"}], "]"}],
      Short[#, 1]& ], 
     TagBox[
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                 RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                   ")"}]}], 
               RowBox[{"4", " ", 
                 RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                   ")"}]}]]}]],
           Annotation[#, {1, 1} -> Rational[1, 4] $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]] (-$CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ((-4) $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                 $CellContext`x[], 
                 $CellContext`y[]] - 4 $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                $CellContext`x[], 
                $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] - ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]] (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]])) + 4 $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + 
                Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])) ((-2) $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) + 4 $CellContext`T212[
                 $CellContext`x[], 
                 $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) 
               Derivative[0, 1][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] ((-2) $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                 $CellContext`x[], 
                 $CellContext`y[]] + 4 $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                 $CellContext`x[], 
                 $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]]), "Tooltip"]& ], 
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                 RowBox[{"(", 
                   RowBox[{
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                   ")"}]}], 
               RowBox[{"4", " ", 
                 RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                   ")"}]}]]}]],
           Annotation[#, {1, 2} -> Rational[1, 4] $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]] ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-1) (4 $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                 $CellContext`x[], 
                 $CellContext`y[]] + 4 $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                 $CellContext`x[], 
                 $CellContext`y[]] + 2 Derivative[0, 2][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) 
               Derivative[0, 1][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) 
               Derivative[0, 1][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])) (2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]) + 4 $CellContext`T212[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]) - 2 ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]])) ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] + 
               Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) - 4 $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                $CellContext`x[], 
                $CellContext`y[]] - 4 $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                $CellContext`x[], 
                $CellContext`y[]] - 4 Derivative[1, 1][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]] + 2 Derivative[2, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]), "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
              RowBox[{"-", 
                FractionBox[
                 RowBox[{
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                 RowBox[{"4", " ", 
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
           Annotation[#, {2, 1} -> Rational[-1, 4] $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]] ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-1) ((-4) $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                 $CellContext`x[], 
                 $CellContext`y[]] - 4 $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                $CellContext`x[], 
                $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] - ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]] (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]])) + 4 $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + 
                Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])) ((-2) $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) + 4 $CellContext`T212[
                 $CellContext`x[], 
                 $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) 
               Derivative[0, 1][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] ((-2) $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                 $CellContext`x[], 
                 $CellContext`y[]] + 4 $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                 $CellContext`x[], 
                 $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]]), "Tooltip"]& ], 
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
              RowBox[{"-", 
                FractionBox[
                 RowBox[{
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                 RowBox[{"4", " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
           Annotation[#, {2, 2} -> Rational[-1, 4] $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]] (-$CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) (4 $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                 $CellContext`x[], 
                 $CellContext`y[]] + 4 $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                 $CellContext`x[], 
                 $CellContext`y[]] + 2 Derivative[0, 2][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) 
               Derivative[0, 1][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) 
               Derivative[0, 1][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])) (2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]) + 4 $CellContext`T212[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]) - 2 ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]])) ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] + 
               Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) - 4 $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                $CellContext`x[], 
                $CellContext`y[]] - 4 $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                $CellContext`x[], 
                $CellContext`y[]] - 4 Derivative[1, 1][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]] + 2 Derivative[2, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]), "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
       FontSize->Small],
      Short[#, 1]& ]},
    {"30", 
     TagBox[
      RowBox[{"RicciScalar", "[", 
       RowBox[{"CCovD", "[", 
        RowBox[{"PDgen", ",", 
         StyleBox[GridBox[{
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                 
                 Annotation[#, {1, 1, 1} -> 
                  Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (-$CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (-$CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 1, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
                 Annotation[#, {2, 1, 2} -> (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
                 Annotation[#, {2, 2, 1} -> (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                 
                 Annotation[#, {2, 2, 2} -> 
                  Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small], ",", 
         StyleBox[GridBox[{
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 1} -> $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 2} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 1} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 2} -> $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small]}], "]"}], "]"}],
      Short[#, 1]& ], 
     TagBox[
      RowBox[{"CTensor", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{
           RowBox[{
            InterpretationBox[
             StyleBox["gxx",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`gxx,
             Editable->False], "[", 
            RowBox[{
             InterpretationBox[
              StyleBox["x",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`x[],
              Editable->False], ",", 
             InterpretationBox[
              StyleBox["y",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`y[],
              Editable->False]}], "]"}], " ", 
           RowBox[{"(", 
            RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], ")"}]}], 
          "+", 
          RowBox[{"\[LeftSkeleton]", "2", "\[RightSkeleton]"}], "+", 
          RowBox[{
           RowBox[{
            InterpretationBox[
             StyleBox["gyy",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`gyy,
             Editable->False], "[", 
            RowBox[{
             InterpretationBox[
              StyleBox["x",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`x[],
              Editable->False], ",", 
             InterpretationBox[
              StyleBox["y",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`y[],
              Editable->False]}], "]"}], " ", 
           RowBox[{"(", 
            RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], ")"}]}]}], 
         RowBox[{"2", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], ")"}], 
           "2"]}]], ",", 
        RowBox[{"{", "}"}], ",", "0"}], "]"}],
      Short[#, 1]& ]},
    {"31", 
     TagBox[
      RowBox[{"RicciScalar", "[", 
       RowBox[{"CCovD", "[", 
        RowBox[{"PDgen", ",", 
         StyleBox[GridBox[{
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                 
                 Annotation[#, {1, 1, 1} -> 
                  Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 1, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small], ",", 
         StyleBox[GridBox[{
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 1} -> $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 2} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 1} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 2} -> $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small]}], "]"}], "]"}],
      Short[#, 1]& ], 
     TagBox[
      RowBox[{"CTensor", "[", 
       RowBox[{
        FractionBox[
         RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], 
         RowBox[{"2", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], ")"}], 
           "2"]}]], ",", 
        RowBox[{"{", "}"}], ",", "0"}], "]"}],
      Short[#, 1]& ]},
    {"32", 
     TagBox[
      RowBox[{"Riemann", "[", 
       RowBox[{"CCovD", "[", 
        RowBox[{"PDgen", ",", 
         StyleBox[GridBox[{
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                 
                 Annotation[#, {1, 1, 1} -> 
                  Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (-$CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (-$CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 1, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
                 Annotation[#, {2, 1, 2} -> (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
                 Annotation[#, {2, 2, 1} -> (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                 
                 Annotation[#, {2, 2, 2} -> 
                  Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small], ",", 
         StyleBox[GridBox[{
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 1} -> $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 2} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 1} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 2} -> $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small]}], "]"}], "]"}],
      Short[#, 1]& ], 
     TagBox[
      StyleBox[GridBox[{
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1, 2} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]}]],
              Annotation[#, {1, 2, 1, 1} -> Rational[-1, 4] $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                  RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]],
              Annotation[#, {1, 2, 1, 2} -> Rational[1, 4] $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]}]],
              Annotation[#, {1, 2, 2, 1} -> Rational[-1, 4] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                  RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]],
              Annotation[#, {1, 2, 2, 2} -> Rational[1, 4] $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}]},
         {GridBox[{
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                  RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]],
              Annotation[#, {2, 1, 1, 1} -> Rational[1, 4] $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                  RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]],
              Annotation[#, {2, 1, 1, 2} -> Rational[1, 4] $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (-$CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                  RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]],
              Annotation[#, {2, 1, 2, 1} -> Rational[1, 4] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]}]],
              Annotation[#, {2, 1, 2, 2} -> Rational[-1, 4] $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 1, 2} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
       FontSize->Small],
      Short[#, 1]& ]},
    {"33", 
     TagBox[
      RowBox[{"Riemann", "[", 
       RowBox[{"CCovD", "[", 
        RowBox[{"PDgen", ",", 
         StyleBox[GridBox[{
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                 
                 Annotation[#, {1, 1, 1} -> 
                  Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 1, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small], ",", 
         StyleBox[GridBox[{
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 1} -> $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 2} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 1} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 2} -> $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small]}], "]"}], "]"}],
      Short[#, 1]& ], 
     TagBox[
      StyleBox[GridBox[{
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1, 2} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]}]],
              Annotation[#, {1, 2, 1, 1} -> Rational[-1, 4] $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                  RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]],
              Annotation[#, {1, 2, 1, 2} -> Rational[1, 4] $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]}]],
              Annotation[#, {1, 2, 2, 1} -> Rational[-1, 4] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                  RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]],
              Annotation[#, {1, 2, 2, 2} -> Rational[1, 4] $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}]},
         {GridBox[{
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                  RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]],
              Annotation[#, {2, 1, 1, 1} -> Rational[1, 4] $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]}]],
              Annotation[#, {2, 1, 1, 2} -> Rational[-1, 4] $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                  RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]],
              Annotation[#, {2, 1, 2, 1} -> Rational[1, 4] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]}]],
              Annotation[#, {2, 1, 2, 2} -> Rational[-1, 4] $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 1, 2} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
       FontSize->Small],
      Short[#, 1]& ]},
    {"34", 
     TagBox[
      RowBox[{"RiemannDown", "[", 
       RowBox[{"CCovD", "[", 
        RowBox[{"PDgen", ",", 
         StyleBox[GridBox[{
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                 
                 Annotation[#, {1, 1, 1} -> 
                  Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 1, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small], ",", 
         StyleBox[GridBox[{
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 1} -> $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 2} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 1} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 2} -> $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small]}], "]"}], "]"}],
      Short[#, 1]& ], 
     TagBox[
      StyleBox[GridBox[{
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1, 2} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], 
                  RowBox[{"4", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
              Annotation[#, {1, 2, 1, 2} -> Rational[1, 4] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                   Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], 
                  RowBox[{"4", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
              Annotation[#, {1, 2, 2, 1} -> Rational[1, 4] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}]},
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], 
                  RowBox[{"4", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
              Annotation[#, {2, 1, 1, 2} -> Rational[1, 4] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], 
                  RowBox[{"4", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
              Annotation[#, {2, 1, 2, 1} -> Rational[1, 4] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                   Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 1, 2} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
       FontSize->Small],
      Short[#, 1]& ]},
    {"35", 
     TagBox[
      RowBox[{"TensorDerivative", "[", 
       RowBox[{
        StyleBox[GridBox[{
           {
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxx",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxx,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {1, 1} -> $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {1, 2} -> $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ]},
           {
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {2, 1} -> $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gyy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gyy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {2, 2} -> $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ]}
          },
          AutoDelete->False,
          
          GridBoxDividers->{
           "ColumnsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
            "RowsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
         FontSize->Small], ",", 
        RowBox[{"CCovD", "[", 
         RowBox[{"PDgen", ",", 
          StyleBox[GridBox[{
             {GridBox[{
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                  Annotation[#, {1, 1, 1} -> Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {1, 1, 2} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (-$CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]}
               },
               AutoDelete->False,
               
               GridBoxDividers->{
                "ColumnsIndexed" -> {
                  1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], 
              GridBox[{
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {1, 2, 1} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (-$CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]},
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {1, 2, 2} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
               },
               AutoDelete->False,
               
               GridBoxDividers->{
                "ColumnsIndexed" -> {
                  1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
             {GridBox[{
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {2, 1, 1} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
                  Annotation[#, {2, 1, 2} -> (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]}
               },
               AutoDelete->False,
               
               GridBoxDividers->{
                "ColumnsIndexed" -> {
                  1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], 
              GridBox[{
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
                  Annotation[#, {2, 2, 1} -> (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]},
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                  Annotation[#, {2, 2, 2} -> Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
               },
               AutoDelete->False,
               
               GridBoxDividers->{
                "ColumnsIndexed" -> {
                  1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
              "RowsIndexed" -> {
               1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
           FontSize->Small], ",", 
          StyleBox[GridBox[{
             {
              TagBox[
               TooltipBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxx",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxx,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
               Annotation[#, {1, 1} -> $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]], "Tooltip"]& ], 
              TagBox[
               TooltipBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
               Annotation[#, {1, 2} -> $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]], "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
               Annotation[#, {2, 1} -> $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]], "Tooltip"]& ], 
              TagBox[
               TooltipBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gyy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gyy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
               Annotation[#, {2, 2} -> $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]], "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
              "RowsIndexed" -> {
               1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
           FontSize->Small]}], "]"}]}], "]"}],
      Short[#, 1]& ], 
     TagBox["Zero",
      Short[#, 1]& ]},
    {"36", 
     TagBox[
      RowBox[{"TensorDerivative", "[", 
       RowBox[{
        StyleBox[GridBox[{
           {
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxx",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxx,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {1, 1} -> $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {1, 2} -> $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ]},
           {
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {2, 1} -> $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gyy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gyy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {2, 2} -> $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ]}
          },
          AutoDelete->False,
          
          GridBoxDividers->{
           "ColumnsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
            "RowsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
         FontSize->Small], ",", 
        RowBox[{"CCovD", "[", 
         RowBox[{"PDgen", ",", 
          StyleBox[GridBox[{
             {GridBox[{
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                  Annotation[#, {1, 1, 1} -> Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {1, 1, 2} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
               },
               AutoDelete->False,
               
               GridBoxDividers->{
                "ColumnsIndexed" -> {
                  1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], 
              GridBox[{
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {1, 2, 1} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {1, 2, 2} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
               },
               AutoDelete->False,
               
               GridBoxDividers->{
                "ColumnsIndexed" -> {
                  1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
             {GridBox[{
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {2, 1, 1} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {2, 1, 2} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
               },
               AutoDelete->False,
               
               GridBoxDividers->{
                "ColumnsIndexed" -> {
                  1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], 
              GridBox[{
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {2, 2, 1} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {2, 2, 2} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
               },
               AutoDelete->False,
               
               GridBoxDividers->{
                "ColumnsIndexed" -> {
                  1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
              "RowsIndexed" -> {
               1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
           FontSize->Small], ",", 
          StyleBox[GridBox[{
             {
              TagBox[
               TooltipBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxx",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxx,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
               Annotation[#, {1, 1} -> $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]], "Tooltip"]& ], 
              TagBox[
               TooltipBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
               Annotation[#, {1, 2} -> $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]], "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
               Annotation[#, {2, 1} -> $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]], "Tooltip"]& ], 
              TagBox[
               TooltipBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gyy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gyy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
               Annotation[#, {2, 2} -> $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]], "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
              "RowsIndexed" -> {
               1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
           FontSize->Small]}], "]"}]}], "]"}],
      Short[#, 1]& ], 
     TagBox["Zero",
      Short[#, 1]& ]},
    {"37", 
     TagBox[
      RowBox[{"TensorDerivative", "[", 
       RowBox[{
        StyleBox[GridBox[{
           {GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 1, 1, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 1, 1, 2} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 1, 2, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 1, 2, 2} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
               "RowsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 2, 1, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1", ",", "2"}], "}"}], 
                   "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], 
                    RowBox[{"4", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                Annotation[#, {1, 2, 1, 2} -> Rational[1, 4] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2", ",", "1"}], "}"}], 
                   "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], 
                    RowBox[{"4", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                Annotation[#, {1, 2, 2, 1} -> Rational[1, 4] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 2, 2, 2} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
               "RowsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}]},
           {GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 1, 1, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1", ",", "2"}], "}"}], 
                   "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], 
                    RowBox[{"4", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                Annotation[#, {2, 1, 1, 2} -> Rational[1, 4] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2", ",", "1"}], "}"}], 
                   "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], 
                    RowBox[{"4", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                Annotation[#, {2, 1, 2, 1} -> Rational[1, 4] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 1, 2, 2} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
               "RowsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 2, 1, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 2, 1, 2} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 2, 2, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 2, 2, 2} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
               "RowsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}]}
          },
          AutoDelete->False,
          
          GridBoxDividers->{
           "ColumnsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
            "RowsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
         FontSize->Small], ",", 
        RowBox[{"CCovD", "[", 
         RowBox[{"PDgen", ",", 
          StyleBox[GridBox[{
             {GridBox[{
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                  Annotation[#, {1, 1, 1} -> Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {1, 1, 2} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
               },
               AutoDelete->False,
               
               GridBoxDividers->{
                "ColumnsIndexed" -> {
                  1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], 
              GridBox[{
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {1, 2, 1} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {1, 2, 2} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
               },
               AutoDelete->False,
               
               GridBoxDividers->{
                "ColumnsIndexed" -> {
                  1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
             {GridBox[{
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {2, 1, 1} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {2, 1, 2} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
               },
               AutoDelete->False,
               
               GridBoxDividers->{
                "ColumnsIndexed" -> {
                  1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], 
              GridBox[{
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {2, 2, 1} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {2, 2, 2} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
               },
               AutoDelete->False,
               
               GridBoxDividers->{
                "ColumnsIndexed" -> {
                  1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
              "RowsIndexed" -> {
               1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
           FontSize->Small], ",", 
          StyleBox[GridBox[{
             {
              TagBox[
               TooltipBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxx",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxx,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
               Annotation[#, {1, 1} -> $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]], "Tooltip"]& ], 
              TagBox[
               TooltipBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
               Annotation[#, {1, 2} -> $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]], "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
               Annotation[#, {2, 1} -> $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]], "Tooltip"]& ], 
              TagBox[
               TooltipBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gyy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gyy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
               Annotation[#, {2, 2} -> $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]], "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
              "RowsIndexed" -> {
               1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
           FontSize->Small]}], "]"}]}], "]"}],
      Short[#, 1]& ], 
     TagBox[
      StyleBox[GridBox[{
         {GridBox[{
            {GridBox[{
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "1"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {1, 1, 1, 1, 1} -> 0, "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "2"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {1, 1, 1, 1, 2} -> 0, "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1", ",", "2", ",", "1"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {1, 1, 1, 2, 1} -> 0, "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1", ",", "2", ",", "2"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {1, 1, 1, 2, 2} -> 0, "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
            {GridBox[{
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2", ",", "1", ",", "1"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {1, 1, 2, 1, 1} -> 0, "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2", ",", "1", ",", "2"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {1, 1, 2, 1, 2} -> 0, "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2", ",", "2", ",", "1"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {1, 1, 2, 2, 1} -> 0, "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2", ",", "2", ",", "2"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {1, 1, 2, 2, 2} -> 0, "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
           },
           AutoDelete->False,
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], GridBox[{
            {GridBox[{
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1", ",", "1", ",", "1"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {1, 2, 1, 1, 1} -> 0, "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1", ",", "1", ",", "2"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {1, 2, 1, 1, 2} -> 0, "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1", ",", "2", ",", "1"}], 
                    "}"}], "\[Rule]", 
                    RowBox[{
                    FractionBox["1", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"3", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}]],
                 
                 Annotation[#, {1, 2, 1, 2, 1} -> 
                  Rational[1, 4] ((-4) Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 
                    Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (-$CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 
                    4 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[2, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[3, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1", ",", "2", ",", "2"}], 
                    "}"}], "\[Rule]", 
                    RowBox[{
                    FractionBox["1", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "3"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}]],
                 
                 Annotation[#, {1, 2, 1, 2, 2} -> 
                  Rational[1, 4] ((-4) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 2][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 2][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 3][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 2][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 
                    4 Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (4 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 2][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 2][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[2, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "1"}], 
                    "}"}], "\[Rule]", 
                    RowBox[{
                    FractionBox["1", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"3", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}]],
                 
                 Annotation[#, {1, 2, 2, 1, 1} -> 
                  Rational[1, 4] (4 Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    4 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (-$CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 4 
                    Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 Derivative[2, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[3, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "2"}], 
                    "}"}], "\[Rule]", 
                    RowBox[{
                    FractionBox["1", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "3"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}]],
                 
                 Annotation[#, {1, 2, 2, 1, 2} -> 
                  Rational[1, 4] (4 Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 2][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 2][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 3][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 2][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 4 
                    Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 4 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (4 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 2][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 Derivative[1, 2][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 
                    2 Derivative[2, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2", ",", "2", ",", "1"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {1, 2, 2, 2, 1} -> 0, "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2", ",", "2", ",", "2"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {1, 2, 2, 2, 2} -> 0, "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}]},
         {GridBox[{
            {GridBox[{
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1", ",", "1", ",", "1"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {2, 1, 1, 1, 1} -> 0, "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1", ",", "1", ",", "2"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {2, 1, 1, 1, 2} -> 0, "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1", ",", "2", ",", "1"}], 
                    "}"}], "\[Rule]", 
                    RowBox[{
                    FractionBox["1", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"3", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}]],
                 
                 Annotation[#, {2, 1, 1, 2, 1} -> 
                  Rational[1, 4] (4 Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    4 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (-$CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 4 
                    Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 Derivative[2, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[3, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1", ",", "2", ",", "2"}], 
                    "}"}], "\[Rule]", 
                    RowBox[{
                    FractionBox["1", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "3"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}]],
                 
                 Annotation[#, {2, 1, 1, 2, 2} -> 
                  Rational[1, 4] (4 Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 2][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 2][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 3][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 2][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 4 
                    Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 4 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (4 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 2][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 Derivative[1, 2][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 
                    2 Derivative[2, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2", ",", "1", ",", "1"}], 
                    "}"}], "\[Rule]", 
                    RowBox[{
                    FractionBox["1", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"3", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}]],
                 
                 Annotation[#, {2, 1, 2, 1, 1} -> 
                  Rational[1, 4] ((-4) Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 
                    Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (-$CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 
                    4 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[2, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[3, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2", ",", "1", ",", "2"}], 
                    "}"}], "\[Rule]", 
                    RowBox[{
                    FractionBox["1", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "3"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}]],
                 
                 Annotation[#, {2, 1, 2, 1, 2} -> 
                  Rational[1, 4] ((-4) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 2][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 2][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 3][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 2][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 
                    4 Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (4 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 2][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 2][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[2, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2", ",", "2", ",", "1"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {2, 1, 2, 2, 1} -> 0, "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2", ",", "2", ",", "2"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {2, 1, 2, 2, 2} -> 0, "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], GridBox[{
            {GridBox[{
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1", ",", "1", ",", "1"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {2, 2, 1, 1, 1} -> 0, "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1", ",", "1", ",", "2"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {2, 2, 1, 1, 2} -> 0, "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1", ",", "2", ",", "1"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {2, 2, 1, 2, 1} -> 0, "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1", ",", "2", ",", "2"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {2, 2, 1, 2, 2} -> 0, "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
            {GridBox[{
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2", ",", "1", ",", "1"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {2, 2, 2, 1, 1} -> 0, "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2", ",", "1", ",", "2"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {2, 2, 2, 1, 2} -> 0, "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2", ",", "2", ",", "1"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {2, 2, 2, 2, 1} -> 0, "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2", ",", "2", ",", "2"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {2, 2, 2, 2, 2} -> 0, "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
       FontSize->Small],
      Short[#, 1]& ]},
    {"38", 
     TagBox[
      RowBox[{"ToCTensorOneSlot", "[", 
       RowBox[{
        StyleBox[GridBox[{
           {GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 1, 1, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 1, 1, 2} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 1, 2, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 1, 2, 2} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
               "RowsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1", ",", "1"}], "}"}], 
                   "\[Rule]", 
                   RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]}]],
                Annotation[#, {1, 2, 1, 1} -> Rational[-1, 4] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ], 
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1", ",", "2"}], "}"}], 
                   "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]],
                
                Annotation[#, {1, 2, 1, 2} -> 
                 Rational[1, 4] $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2", ",", "1"}], "}"}], 
                   "\[Rule]", 
                   RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]}]],
                Annotation[#, {1, 2, 2, 1} -> Rational[-1, 4] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ], 
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2", ",", "2"}], "}"}], 
                   "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]],
                
                Annotation[#, {1, 2, 2, 2} -> 
                 Rational[1, 4] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
               "RowsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}]},
           {GridBox[{
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1", ",", "1"}], "}"}], 
                   "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]],
                
                Annotation[#, {2, 1, 1, 1} -> 
                 Rational[1, 4] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ], 
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1", ",", "2"}], "}"}], 
                   "\[Rule]", 
                   RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]}]],
                Annotation[#, {2, 1, 1, 2} -> Rational[-1, 4] $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2", ",", "1"}], "}"}], 
                   "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]],
                
                Annotation[#, {2, 1, 2, 1} -> 
                 Rational[1, 4] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ], 
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2", ",", "2"}], "}"}], 
                   "\[Rule]", 
                   RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]}]],
                Annotation[#, {2, 1, 2, 2} -> Rational[-1, 4] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
               "RowsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 2, 1, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 2, 1, 2} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 2, 2, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 2, 2, 2} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
               "RowsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}]}
          },
          AutoDelete->False,
          
          GridBoxDividers->{
           "ColumnsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
            "RowsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
         FontSize->Small], ",", 
        RowBox[{"{", 
         RowBox[{"3", ",", 
          StyleBox[GridBox[{
             {
              TagBox[
               TooltipBox["\<\"\[GrayCircle]\"\>",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                  FractionBox[
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
               Annotation[#, {1, 1} -> $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]]/(-$CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ], 
              TagBox[
               TooltipBox["\<\"\[GrayCircle]\"\>",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                  FractionBox[
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], 
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
               Annotation[#, {1, 2} -> $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]/($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]]), "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["\<\"\[GrayCircle]\"\>",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                  FractionBox[
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], 
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
               Annotation[#, {2, 1} -> $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]/($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]]), "Tooltip"]& ], 
              TagBox[
               TooltipBox["\<\"\[GrayCircle]\"\>",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                  FractionBox[
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
               Annotation[#, {2, 2} -> $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]/(-$CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
              "RowsIndexed" -> {
               1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
           FontSize->Small]}], "}"}]}], "]"}],
      Short[#, 1]& ], 
     TagBox[
      StyleBox[GridBox[{
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1, 2} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], 
                  RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]],
              Annotation[#, {1, 2, 1, 2} -> Rational[1, 4] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]}]],
              
              Annotation[#, {1, 2, 2, 1} -> 
               Rational[-1, 4] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}]},
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]}]],
              
              Annotation[#, {2, 1, 1, 2} -> 
               Rational[-1, 4] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], 
                  RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]],
              Annotation[#, {2, 1, 2, 1} -> Rational[1, 4] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 1, 2} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
       FontSize->Small],
      Short[#, 1]& ]},
    {"39", 
     TagBox[
      RowBox[{"Torsion", "[", 
       RowBox[{"CCovD", "[", 
        RowBox[{"PDgen", ",", 
         StyleBox[GridBox[{
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                 
                 Annotation[#, {1, 1, 1} -> 
                  Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 1, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small], ",", 
         StyleBox[GridBox[{
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 1} -> $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 2} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 1} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 2} -> $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small]}], "]"}], "]"}],
      Short[#, 1]& ], 
     TagBox[
      StyleBox[GridBox[{
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["T112",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`T112,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 1, 2} -> $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{"-", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]],
              Annotation[#, {1, 2, 1} -> -$CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 1} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["T212",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`T212,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 1, 2} -> $CellContext`T212[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{"-", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]],
              Annotation[#, {2, 2, 1} -> -$CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
       FontSize->Small],
      Short[#, 1]& ]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  TableForm[{{
     "ReportCompute"[
      "ADChristoffel"[-1, -1, -1, -1]], {
      Skeleton[4]}}, {
     "ReportCompute"[
      "CDRiemann"[-1, -1, -1, -1, -1]], {
      Skeleton[2]}}, {
     "ReportCompute"[
      "Christoffel"[-1, -1, -1]], {
      Skeleton[8]}}, {
     "ReportCompute"[
      "Christoffel"[1, -1, -1]], {
      Skeleton[8]}}, {
     "ReportCompute"[
      "DetMetric"[]], {
      Skeleton[1]}}, {
     "ReportCompute"[
      "DMetric"[-1, -1, -1]], {
      Skeleton[6]}}, {
     "ReportCompute"[
      "Einstein"[-1, -1]], {
      Skeleton[4]}}, {
     "ReportCompute"[
      "Kretschmann"[]], {
      Skeleton[1]}}, {
     "ReportCompute"[
      "Metric"[1, 1]], {
      Skeleton[3]}}, {
     "ReportCompute"[
      "Ricci"[-1, -1]], {
      Skeleton[4]}}, {
     "ReportCompute"[
      "RicciScalar"[]], {
      Skeleton[1]}}, {
     "ReportCompute"[
      "Riemann"[-1, -1, -1, -1]], {
      Skeleton[1]}}, {
     "ReportCompute"[
      "Riemann"[-1, -1, -1, 1]], {
      Skeleton[4]}}, {
     "ReportCompute"[
      "Riemann"[-1, -1, 1, 1]], {
      Skeleton[1]}}, {
     "ReportCompute"[
      "Torsion"[-1, -1, -1]], {
      Skeleton[2]}}, {
     "ChartsOf"[
      Shallow[{{
         $CellContext`gxx[
          $CellContext`x[], 
          $CellContext`y[]], 
         $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[]]}, {
         $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[]], 
         $CellContext`gyy[
          $CellContext`x[], 
          $CellContext`y[]]}}, 1]], 
     Short[
      HoldForm[{$CellContext`gen}], 1]}, {
     "ChartsOf"[
      Shallow[{{{Rational[-1, 2] ($CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 - $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])^(-1) ($CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
              $CellContext`x[], 
              $CellContext`y[]] + $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
               $CellContext`x[], 
               $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
               $CellContext`x[], 
               $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 - $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])^(-1) (-$CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
              $CellContext`x[], 
              $CellContext`y[]] + $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
              $CellContext`x[], 
              $CellContext`y[]])}, {Rational[1, 2] ($CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 - $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])^(-1) (-$CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
              $CellContext`x[], 
              $CellContext`y[]] + $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
              $CellContext`x[], 
              $CellContext`y[]]), Rational[1, 2] ($CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 - $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])^(-1) ($CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
              $CellContext`x[], 
              $CellContext`y[]] + $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
               $CellContext`x[], 
               $CellContext`y[]]))}}, {{Rational[1, 2] ($CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 - $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])^(-1) ($CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
              $CellContext`x[], 
              $CellContext`y[]] + $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
               $CellContext`x[], 
               $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
               $CellContext`x[], 
               $CellContext`y[]])), (2 $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]]^2 - 2 $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])^(-1) ($CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
              $CellContext`x[], 
              $CellContext`y[]] - $CellContext`gxx[
             $CellContext`x[], 
             $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
             $CellContext`x[], 
             $CellContext`y[]])}, {(2 $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]]^2 - 2 $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])^(-1) ($CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
              $CellContext`x[], 
              $CellContext`y[]] - $CellContext`gxx[
             $CellContext`x[], 
             $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
             $CellContext`x[], 
             $CellContext`y[]]), Rational[-1, 2] ($CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 - $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])^(-1) ($CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
              $CellContext`x[], 
              $CellContext`y[]] + $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
               $CellContext`x[], 
               $CellContext`y[]]))}}}, 1]], 
     Short[
      HoldForm[{$CellContext`gen}], 1]}, {
     "ChartsOf"[
      Shallow[{{{Rational[-1, 2] ($CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 - $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])^(-1) (2 $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`T112[
              $CellContext`x[], 
              $CellContext`y[]] + 2 $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 $CellContext`T212[
              $CellContext`x[], 
              $CellContext`y[]] + $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
              $CellContext`x[], 
              $CellContext`y[]] + $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
               $CellContext`x[], 
               $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
               $CellContext`x[], 
               $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 - $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`T112[
              $CellContext`x[], 
              $CellContext`y[]] - $CellContext`gyy[
             $CellContext`x[], 
             $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
             $CellContext`x[], 
             $CellContext`y[]] + $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] ((-2) $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`T212[
                $CellContext`x[], 
                $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
               $CellContext`x[], 
               $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 - $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 $CellContext`T112[
              $CellContext`x[], 
              $CellContext`y[]] - $CellContext`gyy[
             $CellContext`x[], 
             $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
             $CellContext`x[], 
             $CellContext`y[]] + $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] ((-2) $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`T212[
                $CellContext`x[], 
                $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
               $CellContext`x[], 
               $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 - $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])^(-1) ($CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] ((-2) $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`T112[
                $CellContext`x[], 
                $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
               $CellContext`x[], 
               $CellContext`y[]]) + $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]] ((-2) $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`T212[
                $CellContext`x[], 
                $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
               $CellContext`x[], 
               $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
               $CellContext`x[], 
               $CellContext`y[]]))}}, {{Rational[1, 2] ($CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 - $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])^(-1) (2 $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]]^2 $CellContext`T112[
              $CellContext`x[], 
              $CellContext`y[]] + $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
              $CellContext`x[], 
              $CellContext`y[]] + $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] (2 $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`T212[
                $CellContext`x[], 
                $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
               $CellContext`x[], 
               $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
               $CellContext`x[], 
               $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 - $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])^(-1) ($CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] (2 $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`T212[
                $CellContext`x[], 
                $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
               $CellContext`x[], 
               $CellContext`y[]]) + $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] (2 $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`T112[
                $CellContext`x[], 
                $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
              $CellContext`x[], 
              $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 - $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])^(-1) ($CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
              $CellContext`x[], 
              $CellContext`y[]] + $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] (2 $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`T112[
                $CellContext`x[], 
                $CellContext`y[]] + 2 $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`T212[
                $CellContext`x[], 
                $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
              $CellContext`x[], 
              $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 - $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])^(-1) (2 $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 $CellContext`T112[
              $CellContext`x[], 
              $CellContext`y[]] - $CellContext`gxx[
             $CellContext`x[], 
             $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
             $CellContext`x[], 
             $CellContext`y[]] + $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] (2 $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`T212[
                $CellContext`x[], 
                $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
              $CellContext`x[], 
              $CellContext`y[]]))}}}, 1]], 
     Short[
      HoldForm[{$CellContext`gen}], 1]}, {
     Short[
      HoldForm[
       xAct`xTensor`Christoffel[
        xAct`xCoba`CCovD[$CellContext`PDgen, 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{{Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}}, {{
              Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}}}, {$CellContext`gen, \
-$CellContext`gen, -$CellContext`gen}, 0], 
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{
              $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]}, {
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 
            0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]], \
$CellContext`PDgen]], 1], 
     Short[
      HoldForm[
       RawBoxes[
        xAct`xCoba`Private`CTensorBoxes[
         xAct`xCoba`CTensor[{{{Rational[-1, 2] ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]] + 2 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 $CellContext`T212[
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]] - $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] + $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] ((-2) $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]] - $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] + $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] ((-2) $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-1) ($CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] ((-2) $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) + $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] ((-2) $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]))}}, {{Rational[1, 2] ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] (2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-1) ($CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] (2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]]) + $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] (2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-1) ($CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] (2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]] - $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]] + $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] (2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]))}}}, {$CellContext`gen, \
-$CellContext`gen, -$CellContext`gen}, 0], 
         xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]], 1]}, {
     Short[
      HoldForm[
       xAct`xTensor`CovDOfMetric[
        RawBoxes[
         xAct`xCoba`Private`CTensorBoxes[
          xAct`xCoba`CTensor[{{
             $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]], 
             $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]]}, {
             $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]], 
             $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 0],
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]]], 1], 
     Short[
      HoldForm[
       xAct`xCoba`CCovD[$CellContext`PDgen, 
        RawBoxes[
         xAct`xCoba`Private`CTensorBoxes[
          xAct`xCoba`CTensor[{{{Rational[-1, 2] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] - $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] - $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}}, {{Rational[1, 2] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]))}}}, {$CellContext`gen, \
-$CellContext`gen, -$CellContext`gen}, 0], 
          xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
        RawBoxes[
         xAct`xCoba`Private`CTensorBoxes[
          xAct`xCoba`CTensor[{{
             $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]], 
             $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]]}, {
             $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]], 
             $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 0],
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]]], 1]}, {
     Short[
      HoldForm[
       xAct`xTensor`CovDOfMetric[
        RawBoxes[
         xAct`xCoba`Private`CTensorBoxes[
          xAct`xCoba`CTensor[{{
             $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]], 
             $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]]}, {
             $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]], 
             $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 0],
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
        xAct`xTensor`Zero]], 1], 
     Short[
      HoldForm[
       xAct`xCoba`CCovD[$CellContext`PDgen, 
        RawBoxes[
         xAct`xCoba`Private`CTensorBoxes[
          xAct`xCoba`CTensor[{{{Rational[-1, 2] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ($CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) (-$CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])}, {Rational[1, 2] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) (-$CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]), Rational[1, 2] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}}, {{Rational[1, 2] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]])), (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]])}, {(2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]), Rational[-1, 2] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ($CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}}}, {$CellContext`gen, \
-$CellContext`gen, -$CellContext`gen}, 0], 
          xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
        RawBoxes[
         xAct`xCoba`Private`CTensorBoxes[
          xAct`xCoba`CTensor[{{
             $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]], 
             $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]]}, {
             $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]], 
             $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 0],
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]]], 1]}, {
     Short[
      HoldForm[
       xAct`xTensor`CovDOfMetric[
        RawBoxes[
         xAct`xCoba`Private`CTensorBoxes[
          xAct`xCoba`CTensor[{{
             $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]], 
             $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]]}, {
             $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]], 
             $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 0],
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
        RawBoxes[
         xAct`xCoba`Private`CTensorBoxes[
          xAct`xCoba`CTensor[{{{0, 
              $CellContext`T112[
               $CellContext`x[], 
               $CellContext`y[]]}, {-$CellContext`T112[
                $CellContext`x[], 
                $CellContext`y[]], 0}}, {{0, 
              $CellContext`T212[
               $CellContext`x[], 
               $CellContext`y[]]}, {-$CellContext`T212[
                $CellContext`x[], 
                $CellContext`y[]], 
              0}}}, {$CellContext`gen, -$CellContext`gen, -$CellContext`gen}, 
           0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]]], 1], 
     Short[
      HoldForm[
       xAct`xCoba`CCovD[$CellContext`PDgen, 
        RawBoxes[
         xAct`xCoba`Private`CTensorBoxes[
          xAct`xCoba`CTensor[{{{Rational[-1, 2] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] - $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] - $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}}, {{Rational[1, 2] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]))}}}, {$CellContext`gen, \
-$CellContext`gen, -$CellContext`gen}, 0], 
          xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
        RawBoxes[
         xAct`xCoba`Private`CTensorBoxes[
          xAct`xCoba`CTensor[{{
             $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]], 
             $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]]}, {
             $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]], 
             $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 0],
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]]], 1]}, {
     Short[
      HoldForm[
       xAct`xTensor`Determinant[
        RawBoxes[
         xAct`xCoba`Private`CTensorBoxes[
          xAct`xCoba`CTensor[{{
             $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]], 
             $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]]}, {
             $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]], 
             $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 0],
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], \
$CellContext`gen]], 1], 
     Short[
      HoldForm[
       RawBoxes[
        xAct`xCoba`Private`CTensorBoxes[
         xAct`xCoba`CTensor[-$CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]]^2 + $CellContext`gxx[
             $CellContext`x[], 
             $CellContext`y[]] $CellContext`gyy[
             $CellContext`x[], 
             $CellContext`y[]], {}, 2 $CellContext`gen], 
         xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]], 1]}, {
     Short[
      HoldForm[
       xAct`xTensor`Einstein[
        xAct`xCoba`CCovD[$CellContext`PDgen, 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{{Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}}, {{
              Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}}}, {$CellContext`gen, \
-$CellContext`gen, -$CellContext`gen}, 0], 
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{
              $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]}, {
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 
            0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]]]], 1], 
     Short[
      HoldForm[xAct`xTensor`Zero], 1]}, {
     Short[
      HoldForm[
       xAct`xTensor`Inv[
        RawBoxes[
         xAct`xCoba`Private`CTensorBoxes[
          xAct`xCoba`CTensor[{{
             $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]], 
             $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]]}, {
             $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]], 
             $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 0],
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]]], 1], 
     Short[
      HoldForm[
       RawBoxes[
        xAct`xCoba`Private`CTensorBoxes[
         xAct`xCoba`CTensor[{{$CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]]/(-$CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]]^2 + $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]] $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]]), $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]]/($CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 - $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])}, {$CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]]/($CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 - $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]]), $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]]/(-$CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]]^2 + $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]] $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]])}}, {$CellContext`gen, $CellContext`gen}, 0],
          xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]], 1]}, {
     Short[
      HoldForm[
       xAct`xTensor`Kretschmann[
        xAct`xCoba`CCovD[$CellContext`PDgen, 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{{Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}}, {{
              Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}}}, {$CellContext`gen, \
-$CellContext`gen, -$CellContext`gen}, 0], 
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{
              $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]}, {
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 
            0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]]]], 1], 
     Short[
      HoldForm[
       RawBoxes[
        xAct`xCoba`Private`CTensorBoxes[
         xAct`xCoba`CTensor[Rational[1, 4] ($CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 - $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])^(-4) (2 $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]]^2 ($CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]] - 2 $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                $CellContext`x[], 
                $CellContext`y[]]) + $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] ((-2) $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])) + $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]] - 2 $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] (-$CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])) + 2 $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] (-$CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]]))) + 4 $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                $CellContext`x[], 
                $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
               $CellContext`x[], 
               $CellContext`y[]]) + 2 $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]]^2 (2 $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] + 2 $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                 $CellContext`x[], 
                 $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] - 2 $CellContext`T212[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]] - 2 $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                $CellContext`x[], 
                $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]]) + $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]^2 + 4 $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                 $CellContext`x[], 
                 $CellContext`y[]] - 2 $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) - 2 Derivative[1, 1][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]])))^2, {}, 0], 
         xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]], 1]}, {
     Short[
      HoldForm[
       xAct`xTensor`LC[
        RawBoxes[
         xAct`xCoba`Private`CTensorBoxes[
          xAct`xCoba`CTensor[{{
             $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]], 
             $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]]}, {
             $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]], 
             $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 0],
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]]], 1], 
     Short[
      HoldForm[
       xAct`xCoba`CCovD[$CellContext`PDgen, 
        RawBoxes[
         xAct`xCoba`Private`CTensorBoxes[
          xAct`xCoba`CTensor[{{{Rational[-1, 2] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ($CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) (-$CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])}, {Rational[1, 2] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) (-$CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]), Rational[1, 2] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}}, {{Rational[1, 2] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]])), (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]])}, {(2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]), Rational[-1, 2] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ($CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}}}, {$CellContext`gen, \
-$CellContext`gen, -$CellContext`gen}, 0], 
          xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
        RawBoxes[
         xAct`xCoba`Private`CTensorBoxes[
          xAct`xCoba`CTensor[{{
             $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]], 
             $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]]}, {
             $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]], 
             $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 0],
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]]], 1]}, {
     Short[
      HoldForm[
       xAct`xTensor`Ricci[
        xAct`xCoba`CCovD[$CellContext`PDgen, 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{{Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (-$CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (-$CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}}, {{
              Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])}, {(2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]), Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}}}, {$CellContext`gen, \
-$CellContext`gen, -$CellContext`gen}, 0], 
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{
              $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]}, {
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 
            0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]]]], 1], 
     Short[
      HoldForm[
       RawBoxes[
        xAct`xCoba`Private`CTensorBoxes[
         xAct`xCoba`CTensor[{{Rational[1, 4] $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] ($CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]]^2 - $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]])^(-2) ($CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]^2) + $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])) + 2 $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]) + $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - 2 $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]))), Rational[1, 4] $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] ($CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]]^2 - $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]])^(-2) ($CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]^2) + $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])) + 2 $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]) + $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - 2 $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])))}, {Rational[1, 4] $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] ($CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]]^2 - $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]])^(-2) ($CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]^2) + $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])) + 2 $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]) + $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - 2 $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]))), Rational[1, 4] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]] ($CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]]^2 - $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]])^(-2) ($CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]^2) + $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])) + 2 $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]) + $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - 2 $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])))}}, {-$CellContext`gen, \
-$CellContext`gen}, 0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]], 
      1]}, {
     Short[
      HoldForm[
       xAct`xTensor`Ricci[
        xAct`xCoba`CCovD[$CellContext`PDgen, 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{{Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}}, {{
              Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}}}, {$CellContext`gen, \
-$CellContext`gen, -$CellContext`gen}, 0], 
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{
              $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]}, {
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 
            0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]]]], 1], 
     Short[
      HoldForm[
       RawBoxes[
        xAct`xCoba`Private`CTensorBoxes[
         xAct`xCoba`CTensor[{{Rational[1, 4] $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] (-$CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 + $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-1) ((-4) $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                $CellContext`x[], 
                $CellContext`y[]] - 4 $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
               $CellContext`x[], 
               $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
               $CellContext`x[], 
               $CellContext`y[]] - ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
               $CellContext`x[], 
               $CellContext`y[]] (2 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] (2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]])) + 4 $CellContext`T112[
                $CellContext`x[], 
                $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]]) + 2 ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]])) ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] + 
               Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) + ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])) ((-2) $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`T212[
                 $CellContext`x[], 
                 $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]) + 4 $CellContext`T212[
                $CellContext`x[], 
                $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]) + ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] ((-2) $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] - $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])) + 4 $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                $CellContext`x[], 
                $CellContext`y[]] + 4 $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                $CellContext`x[], 
                $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
               $CellContext`x[], 
               $CellContext`y[]]), Rational[1, 4] $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] ($CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]]^2 - $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]])^(-1) (4 $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                $CellContext`x[], 
                $CellContext`y[]] + 4 $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                $CellContext`x[], 
                $CellContext`y[]] + 2 Derivative[0, 2][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] + ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]] (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]])) + 4 $CellContext`T112[
                $CellContext`x[], 
                $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]]) + ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] (2 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])) + ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])) (2 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] + 2 $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]]) + 4 $CellContext`T212[
                $CellContext`x[], 
                $CellContext`y[]] (Derivative[0, 1][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]]) - 2 ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]] + 2 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 $CellContext`T212[
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]])) ($CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`T212[
                 $CellContext`x[], 
                 $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]] + 
              Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]) - 4 $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
               $CellContext`x[], 
               $CellContext`y[]] - 4 $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
               $CellContext`x[], 
               $CellContext`y[]] - 4 Derivative[1, 1][$CellContext`gxy][
               $CellContext`x[], 
               $CellContext`y[]] + 2 Derivative[2, 0][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]])}, {Rational[-1, 4] $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] ($CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]]^2 - $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]])^(-1) ((-4) $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                $CellContext`x[], 
                $CellContext`y[]] - 4 $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
               $CellContext`x[], 
               $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
               $CellContext`x[], 
               $CellContext`y[]] - ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
               $CellContext`x[], 
               $CellContext`y[]] (2 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] (2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]])) + 4 $CellContext`T112[
                $CellContext`x[], 
                $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]]) + 2 ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]])) ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] + 
               Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) + ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])) ((-2) $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`T212[
                 $CellContext`x[], 
                 $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]) + 4 $CellContext`T212[
                $CellContext`x[], 
                $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]) + ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] ((-2) $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] - $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])) + 4 $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                $CellContext`x[], 
                $CellContext`y[]] + 4 $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                $CellContext`x[], 
                $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
               $CellContext`x[], 
               $CellContext`y[]]), Rational[-1, 4] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]] (-$CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 + $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-1) (4 $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                $CellContext`x[], 
                $CellContext`y[]] + 4 $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                $CellContext`x[], 
                $CellContext`y[]] + 2 Derivative[0, 2][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] + ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]] (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]])) + 4 $CellContext`T112[
                $CellContext`x[], 
                $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]]) + ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] (2 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])) + ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])) (2 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] + 2 $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]]) + 4 $CellContext`T212[
                $CellContext`x[], 
                $CellContext`y[]] (Derivative[0, 1][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]]) - 2 ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]] + 2 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 $CellContext`T212[
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]])) ($CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`T212[
                 $CellContext`x[], 
                 $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]] + 
              Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]) - 4 $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
               $CellContext`x[], 
               $CellContext`y[]] - 4 $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
               $CellContext`x[], 
               $CellContext`y[]] - 4 Derivative[1, 1][$CellContext`gxy][
               $CellContext`x[], 
               $CellContext`y[]] + 2 Derivative[2, 0][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]])}}, {-$CellContext`gen, -$CellContext`gen}, 
          0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]], 1]}, {
     Short[
      HoldForm[
       xAct`xTensor`RicciScalar[
        xAct`xCoba`CCovD[$CellContext`PDgen, 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{{Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (-$CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (-$CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}}, {{
              Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])}, {(2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]), Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}}}, {$CellContext`gen, \
-$CellContext`gen, -$CellContext`gen}, 0], 
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{
              $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]}, {
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 
            0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]]]], 1], 
     Short[
      HoldForm[
       RawBoxes[
        xAct`xCoba`Private`CTensorBoxes[
         xAct`xCoba`CTensor[Rational[1, 2] ($CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 - $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])^(-2) ($CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
               $CellContext`x[], 
               $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
               $CellContext`x[], 
               $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]]^2) + $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
               $CellContext`x[], 
               $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]])) + 2 $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
               $CellContext`x[], 
               $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
               $CellContext`x[], 
               $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
               $CellContext`x[], 
               $CellContext`y[]]) + $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]) - 2 $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]]))), {}, 0], 
         xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]], 1]}, {
     Short[
      HoldForm[
       xAct`xTensor`RicciScalar[
        xAct`xCoba`CCovD[$CellContext`PDgen, 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{{Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}}, {{
              Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}}}, {$CellContext`gen, \
-$CellContext`gen, -$CellContext`gen}, 0], 
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{
              $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]}, {
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 
            0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]]]], 1], 
     Short[
      HoldForm[
       RawBoxes[
        xAct`xCoba`Private`CTensorBoxes[
         xAct`xCoba`CTensor[Rational[1, 2] ($CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 - $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])^(-2) (2 $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]]^2 ($CellContext`T112[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]] - 2 $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
               $CellContext`x[], 
               $CellContext`y[]]) + $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] ((-2) $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]])) + $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
               $CellContext`x[], 
               $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
               $CellContext`x[], 
               $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
               $CellContext`x[], 
               $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
               $CellContext`x[], 
               $CellContext`y[]] - 2 $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]] (-$CellContext`T212[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])) + 2 $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] (-$CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                 $CellContext`x[], 
                 $CellContext`y[]]))) + 4 $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
               $CellContext`x[], 
               $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
              $CellContext`x[], 
              $CellContext`y[]]) + 2 $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 (2 $CellContext`T112[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] + 2 $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                $CellContext`x[], 
                $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
               $CellContext`x[], 
               $CellContext`y[]] - 2 $CellContext`T212[
               $CellContext`x[], 
               $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
               $CellContext`x[], 
               $CellContext`y[]] - 2 $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
               $CellContext`x[], 
               $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
               $CellContext`x[], 
               $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
               $CellContext`x[], 
               $CellContext`y[]]) + $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
               $CellContext`x[], 
               $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
               $CellContext`x[], 
               $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]]^2 + 4 $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                $CellContext`x[], 
                $CellContext`y[]] - 2 $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] + $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]]) + $CellContext`T212[
                 $CellContext`x[], 
                 $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]) - 2 Derivative[1, 1][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]]))), {}, 0], 
         xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]], 1]}, {
     Short[
      HoldForm[
       xAct`xTensor`Riemann[
        xAct`xCoba`CCovD[$CellContext`PDgen, 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{{Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (-$CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (-$CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}}, {{
              Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])}, {(2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]), Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}}}, {$CellContext`gen, \
-$CellContext`gen, -$CellContext`gen}, 0], 
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{
              $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]}, {
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 
            0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]]]], 1], 
     Short[
      HoldForm[
       RawBoxes[
        xAct`xCoba`Private`CTensorBoxes[
         xAct`xCoba`CTensor[{{{{0, 0}, {0, 
            0}}, {{Rational[-1, 4] $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) ($CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), Rational[1, 4] $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) ($CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])))}, {Rational[-1, 4] $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) ($CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), Rational[1, 4] $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) ($CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])))}}}, {{{
             Rational[1, 4] $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) ($CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), Rational[1, 4] $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) (-$CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (-Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 2 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) - $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])))}, {Rational[1, 4] $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) ($CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), Rational[-1, 4] $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) ($CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])))}}, {{0, 0}, {0, 
            0}}}}, {-$CellContext`gen, -$CellContext`gen, -$CellContext`gen, \
$CellContext`gen}, 0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]], 
      1]}, {
     Short[
      HoldForm[
       xAct`xTensor`Riemann[
        xAct`xCoba`CCovD[$CellContext`PDgen, 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{{Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}}, {{
              Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}}}, {$CellContext`gen, \
-$CellContext`gen, -$CellContext`gen}, 0], 
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{
              $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]}, {
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 
            0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]]]], 1], 
     Short[
      HoldForm[
       RawBoxes[
        xAct`xCoba`Private`CTensorBoxes[
         xAct`xCoba`CTensor[{{{{0, 0}, {0, 
            0}}, {{Rational[-1, 4] $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]]) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                  Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), Rational[1, 4] $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]]) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                  Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])))}, {Rational[-1, 4] $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]]) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                  Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), Rational[1, 4] $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]]) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                  Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])))}}}, {{{
             Rational[1, 4] $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]]) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                  Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), Rational[-1, 4] $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]]) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                  Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])))}, {Rational[1, 4] $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]]) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                  Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), Rational[-1, 4] $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]]) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                  Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])))}}, {{0, 0}, {0, 
            0}}}}, {-$CellContext`gen, -$CellContext`gen, -$CellContext`gen, \
$CellContext`gen}, 0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]], 
      1]}, {
     Short[
      HoldForm[
       xAct`xTensor`RiemannDown[
        xAct`xCoba`CCovD[$CellContext`PDgen, 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{{Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}}, {{
              Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}}}, {$CellContext`gen, \
-$CellContext`gen, -$CellContext`gen}, 0], 
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{
              $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]}, {
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 
            0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]]]], 1], 
     Short[
      HoldForm[
       RawBoxes[
        xAct`xCoba`Private`CTensorBoxes[
         xAct`xCoba`CTensor[{{{{0, 0}, {0, 
            0}}, {{0, Rational[1, 4] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ($CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 4 Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) - 4 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                 $CellContext`x[], 
                 $CellContext`y[]]) - 2 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 (2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])))}, {Rational[1, 4] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]]) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                  Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), 0}}}, {{{
             0, Rational[1, 4] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]]) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                  Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])))}, {Rational[1, 4] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ($CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 4 Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) - 4 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                 $CellContext`x[], 
                 $CellContext`y[]]) - 2 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 (2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))), 0}}, {{0, 0}, {0, 
            0}}}}, {-$CellContext`gen, -$CellContext`gen, -$CellContext`gen, \
-$CellContext`gen}, 0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]], 
      1]}, {
     Short[
      HoldForm[
       xAct`xTensor`TensorDerivative[
        RawBoxes[
         xAct`xCoba`Private`CTensorBoxes[
          xAct`xCoba`CTensor[{{
             $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]], 
             $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]]}, {
             $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]], 
             $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 0],
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
        xAct`xCoba`CCovD[$CellContext`PDgen, 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{{Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (-$CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (-$CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}}, {{
              Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])}, {(2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]), Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}}}, {$CellContext`gen, \
-$CellContext`gen, -$CellContext`gen}, 0], 
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{
              $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]}, {
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 
            0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]]]], 1], 
     Short[
      HoldForm[xAct`xTensor`Zero], 1]}, {
     Short[
      HoldForm[
       xAct`xTensor`TensorDerivative[
        RawBoxes[
         xAct`xCoba`Private`CTensorBoxes[
          xAct`xCoba`CTensor[{{
             $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]], 
             $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]]}, {
             $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]], 
             $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 0],
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
        xAct`xCoba`CCovD[$CellContext`PDgen, 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{{Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}}, {{
              Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}}}, {$CellContext`gen, \
-$CellContext`gen, -$CellContext`gen}, 0], 
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{
              $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]}, {
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 
            0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]]]], 1], 
     Short[
      HoldForm[xAct`xTensor`Zero], 1]}, {
     Short[
      HoldForm[
       xAct`xTensor`TensorDerivative[
        RawBoxes[
         xAct`xCoba`Private`CTensorBoxes[
          
          xAct`xCoba`CTensor[{{{{0, 0}, {0, 
             0}}, {{0, Rational[1, 4] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) - 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]]) - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                  Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])))}, {Rational[1, 4] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                   Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), 0}}}, {{{
              0, Rational[1, 4] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                   Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])))}, {Rational[1, 4] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) - 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]]) - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                  Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), 0}}, {{0, 0}, {0, 
             0}}}}, {-$CellContext`gen, -$CellContext`gen, -$CellContext`gen, \
-$CellContext`gen}, 0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
        xAct`xCoba`CCovD[$CellContext`PDgen, 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{{Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}}, {{
              Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}}}, {$CellContext`gen, \
-$CellContext`gen, -$CellContext`gen}, 0], 
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{
              $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]}, {
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 
            0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]]]], 1], 
     Short[
      HoldForm[
       RawBoxes[
        xAct`xCoba`Private`CTensorBoxes[
         xAct`xCoba`CTensor[{{{{{0, 0}, {0, 0}}, {{0, 0}, {0, 
            0}}}, {{{0, 0}, {
              Rational[1, 4] ((-4) Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 4 Derivative[0, 1][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) (-$CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 
                4 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] + 
                4 (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + 
                4 (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) Derivative[1, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) Derivative[1, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 1][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 1][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 2][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] (-Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                   Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                  Rational[-1, 2] Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] (-Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) - $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[2, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[2, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 Derivative[2, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[3, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]), 
               Rational[1, 4] ((-4) Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] - 4 Derivative[0, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 2][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 2][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[0, 3][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 2][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 
                4 Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + 
                4 Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] (4 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] (-Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                  Rational[-1, 2] Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] (-Derivative[0, 2][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 Derivative[1, 2][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                   Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                   Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - 2 Derivative[2, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])}}, {{
              Rational[1, 4] (4 Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) (-$CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 4 
                Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]]) Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) Derivative[1, 0][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) Derivative[1, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) Derivative[1, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 Derivative[1, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 4 $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] (-Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                   Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + 
                 Rational[-1, 2] Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - 4 $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] (-Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 4 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[2, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[2, 0][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 Derivative[2, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + 2 Derivative[3, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]), 
               Rational[1, 4] (4 Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 2][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 2][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 Derivative[0, 3][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 2][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 4 
                Derivative[0, 1][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) - 4 Derivative[0, 1][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 2][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 4 Derivative[0, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] (4 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 4 $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] (-Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + 
                 Rational[-1, 2] Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - 4 $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] (-Derivative[0, 2][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 4 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 1][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 1][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 Derivative[1, 2][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 
                2 Derivative[2, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])}, {0, 0}}}}, {{{{0, 0}, {
              Rational[1, 4] (4 Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) (-$CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 4 
                Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]]) Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) Derivative[1, 0][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) Derivative[1, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) Derivative[1, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 Derivative[1, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 4 $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] (-Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                   Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + 
                 Rational[-1, 2] Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - 4 $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] (-Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 4 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[2, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[2, 0][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 Derivative[2, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + 2 Derivative[3, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]), 
               Rational[1, 4] (4 Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 2][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 2][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 Derivative[0, 3][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 2][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 4 
                Derivative[0, 1][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) - 4 Derivative[0, 1][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 2][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 4 Derivative[0, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] (4 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 4 $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] (-Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + 
                 Rational[-1, 2] Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - 4 $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] (-Derivative[0, 2][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 4 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 1][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 1][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 Derivative[1, 2][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 
                2 Derivative[2, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])}}, {{
              Rational[1, 4] ((-4) Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 4 Derivative[0, 1][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) (-$CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 
                4 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] + 
                4 (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + 
                4 (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) Derivative[1, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) Derivative[1, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 1][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 1][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 2][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] (-Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                   Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                  Rational[-1, 2] Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] (-Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) - $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[2, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[2, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 Derivative[2, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[3, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]), 
               Rational[1, 4] ((-4) Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] - 4 Derivative[0, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 2][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 2][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[0, 3][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 2][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 
                4 Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + 
                4 Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] (4 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] (-Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                  Rational[-1, 2] Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] (-Derivative[0, 2][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 Derivative[1, 2][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                   Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                   Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - 2 Derivative[2, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])}, {0, 0}}}, {{{0, 0}, {0, 0}}, {{0, 0}, {
            0, 0}}}}}, {-$CellContext`gen, -$CellContext`gen, \
-$CellContext`gen, -$CellContext`gen, -$CellContext`gen}, 0], 
         xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]], 1]}, {
     Short[
      HoldForm[
       xAct`xCoba`ToCTensorOneSlot[
        RawBoxes[
         xAct`xCoba`Private`CTensorBoxes[
          
          xAct`xCoba`CTensor[{{{{0, 0}, {0, 
             0}}, {{Rational[-1, 4] $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                   Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), Rational[1, 4] $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                   Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])))}, {Rational[-1, 4] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                   Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), Rational[1, 4] $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                   Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])))}}}, {{{
              Rational[1, 4] $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                   Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), Rational[-1, 4] $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                   Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])))}, {Rational[1, 4] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                   Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), Rational[-1, 4] $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                   Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])))}}, {{0, 0}, {0, 
             0}}}}, {-$CellContext`gen, -$CellContext`gen, -$CellContext`gen, \
$CellContext`gen}, 0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], {3, 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{$CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]]/(-$CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 + $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]]), $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]]/($CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]]^2 - $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]])}, {$CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]]/($CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]]^2 - $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]]), $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]]/(-$CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 + $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])}}, {$CellContext`gen, $CellContext`gen}, 
            0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]}]], 1], 
     Short[
      HoldForm[
       RawBoxes[
        xAct`xCoba`Private`CTensorBoxes[
         xAct`xCoba`CTensor[{{{{0, 0}, {0, 
            0}}, {{0, Rational[1, 4] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]]) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                  Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])))}, {
             Rational[-1, 4] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]]) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                  Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), 0}}}, {{{
             0, Rational[-1, 4] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]]) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                  Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])))}, {Rational[1, 4] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]]) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                  Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), 0}}, {{0, 0}, {0, 
            0}}}}, {-$CellContext`gen, -$CellContext`gen, $CellContext`gen, \
$CellContext`gen}, 0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]], 
      1]}, {
     Short[
      HoldForm[
       xAct`xTensor`Torsion[
        xAct`xCoba`CCovD[$CellContext`PDgen, 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{{Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}}, {{
              Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}}}, {$CellContext`gen, \
-$CellContext`gen, -$CellContext`gen}, 0], 
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{
              $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]}, {
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 
            0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]]]], 1], 
     Short[
      HoldForm[
       RawBoxes[
        xAct`xCoba`Private`CTensorBoxes[
         xAct`xCoba`CTensor[{{{0, 
             $CellContext`T112[
              $CellContext`x[], 
              $CellContext`y[]]}, {-$CellContext`T112[
               $CellContext`x[], 
               $CellContext`y[]], 0}}, {{0, 
             $CellContext`T212[
              $CellContext`x[], 
              $CellContext`y[]]}, {-$CellContext`T212[
               $CellContext`x[], 
               $CellContext`y[]], 
             0}}}, {$CellContext`gen, -$CellContext`gen, -$CellContext`gen}, 
          0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]], 1]}}, 
   TableHeadings -> {Automatic, None}]]], "Output",ExpressionUUID->"3c157461-\
53ef-4fe3-bad1-8e3b09c49a4e"]
}, Open  ]],

Cell["Remove the entries for CovDMetric:", "Text",ExpressionUUID->"75ae144c-8a9c-42cd-b653-b79c9c64313f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"List", "/@", 
  RowBox[{"Union", "[", 
   RowBox[{"First", "/@", 
    RowBox[{"Position", "[", 
     RowBox[{
      RowBox[{"DownValues", "[", "xCobaCacheTable", "]"}], ",", 
      "CovDOfMetric"}], "]"}]}], "]"}]}]], "Input",ExpressionUUID->"1a4c0b3f-\
0e75-41c4-905b-31c20de71068"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "20", "}"}], ",", 
   RowBox[{"{", "21", "}"}], ",", 
   RowBox[{"{", "22", "}"}]}], "}"}]], "Output",ExpressionUUID->"2bf09d0c-\
e360-4a23-85dd-83210e2042c7"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"ClearxCobaCache", "[", 
  RowBox[{"Evaluate", "[", "%", "]"}], "]"}]], "Input",ExpressionUUID->\
"4d72d9eb-6b48-4cef-8ef8-130f36262930"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PrintxCobaCache", "[", "]"}]], "Input",ExpressionUUID->"a8bcb955-2fd1-4e5c-a55b-3253b5a5ca8d"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {"1", 
     RowBox[{"\<\"ReportCompute\"\>", "[", 
      RowBox[{"\<\"ADChristoffel\"\>", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}]}], "]"}], "]"}], GridBox[{
       {
        RowBox[{"\[LeftSkeleton]", "4", "\[RightSkeleton]"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"2", 
     RowBox[{"\<\"ReportCompute\"\>", "[", 
      RowBox[{"\<\"CDRiemann\"\>", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}]}], "]"}], "]"}], GridBox[{
       {
        RowBox[{"\[LeftSkeleton]", "2", "\[RightSkeleton]"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"3", 
     RowBox[{"\<\"ReportCompute\"\>", "[", 
      RowBox[{"\<\"Christoffel\"\>", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}]}], "]"}], "]"}], GridBox[{
       {
        RowBox[{"\[LeftSkeleton]", "8", "\[RightSkeleton]"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"4", 
     RowBox[{"\<\"ReportCompute\"\>", "[", 
      RowBox[{"\<\"Christoffel\"\>", "[", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}]}], "]"}], "]"}], GridBox[{
       {
        RowBox[{"\[LeftSkeleton]", "8", "\[RightSkeleton]"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"5", 
     RowBox[{"\<\"ReportCompute\"\>", "[", 
      RowBox[{"\<\"DetMetric\"\>", "[", "]"}], "]"}], GridBox[{
       {
        RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"6", 
     RowBox[{"\<\"ReportCompute\"\>", "[", 
      RowBox[{"\<\"DMetric\"\>", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}]}], "]"}], "]"}], GridBox[{
       {
        RowBox[{"\[LeftSkeleton]", "6", "\[RightSkeleton]"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"7", 
     RowBox[{"\<\"ReportCompute\"\>", "[", 
      RowBox[{"\<\"Einstein\"\>", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}]}], "]"}], "]"}], GridBox[{
       {
        RowBox[{"\[LeftSkeleton]", "4", "\[RightSkeleton]"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"8", 
     RowBox[{"\<\"ReportCompute\"\>", "[", 
      RowBox[{"\<\"Kretschmann\"\>", "[", "]"}], "]"}], GridBox[{
       {
        RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"9", 
     RowBox[{"\<\"ReportCompute\"\>", "[", 
      RowBox[{"\<\"Metric\"\>", "[", 
       RowBox[{"1", ",", "1"}], "]"}], "]"}], GridBox[{
       {
        RowBox[{"\[LeftSkeleton]", "3", "\[RightSkeleton]"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"10", 
     RowBox[{"\<\"ReportCompute\"\>", "[", 
      RowBox[{"\<\"Ricci\"\>", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}]}], "]"}], "]"}], GridBox[{
       {
        RowBox[{"\[LeftSkeleton]", "4", "\[RightSkeleton]"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"11", 
     RowBox[{"\<\"ReportCompute\"\>", "[", 
      RowBox[{"\<\"RicciScalar\"\>", "[", "]"}], "]"}], GridBox[{
       {
        RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"12", 
     RowBox[{"\<\"ReportCompute\"\>", "[", 
      RowBox[{"\<\"Riemann\"\>", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}]}], "]"}], "]"}], GridBox[{
       {
        RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"13", 
     RowBox[{"\<\"ReportCompute\"\>", "[", 
      RowBox[{"\<\"Riemann\"\>", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}], ",", "1"}], "]"}], "]"}], GridBox[{
       {
        RowBox[{"\[LeftSkeleton]", "4", "\[RightSkeleton]"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"14", 
     RowBox[{"\<\"ReportCompute\"\>", "[", 
      RowBox[{"\<\"Riemann\"\>", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}], ",", "1", ",", "1"}], "]"}], "]"}], GridBox[{
       {
        RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"15", 
     RowBox[{"\<\"ReportCompute\"\>", "[", 
      RowBox[{"\<\"Torsion\"\>", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}]}], "]"}], "]"}], GridBox[{
       {
        RowBox[{"\[LeftSkeleton]", "2", "\[RightSkeleton]"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"16", 
     RowBox[{"\<\"ChartsOf\"\>", "[", 
      RowBox[{"{", 
       RowBox[{"\[LeftSkeleton]", "2", "\[RightSkeleton]"}], "}"}], "]"}], 
     TagBox[
      RowBox[{"{", "gen", "}"}],
      Short[#, 1]& ]},
    {"17", 
     RowBox[{"\<\"ChartsOf\"\>", "[", 
      RowBox[{"{", 
       RowBox[{"\[LeftSkeleton]", "2", "\[RightSkeleton]"}], "}"}], "]"}], 
     TagBox[
      RowBox[{"{", "gen", "}"}],
      Short[#, 1]& ]},
    {"18", 
     RowBox[{"\<\"ChartsOf\"\>", "[", 
      RowBox[{"{", 
       RowBox[{"\[LeftSkeleton]", "2", "\[RightSkeleton]"}], "}"}], "]"}], 
     TagBox[
      RowBox[{"{", "gen", "}"}],
      Short[#, 1]& ]},
    {"19", 
     TagBox[
      RowBox[{"Christoffel", "[", 
       RowBox[{
        RowBox[{"CCovD", "[", 
         RowBox[{"PDgen", ",", 
          StyleBox[GridBox[{
             {GridBox[{
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                  Annotation[#, {1, 1, 1} -> Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {1, 1, 2} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
               },
               AutoDelete->False,
               
               GridBoxDividers->{
                "ColumnsIndexed" -> {
                  1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], 
              GridBox[{
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {1, 2, 1} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {1, 2, 2} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
               },
               AutoDelete->False,
               
               GridBoxDividers->{
                "ColumnsIndexed" -> {
                  1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
             {GridBox[{
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {2, 1, 1} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {2, 1, 2} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
               },
               AutoDelete->False,
               
               GridBoxDividers->{
                "ColumnsIndexed" -> {
                  1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], 
              GridBox[{
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {2, 2, 1} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {2, 2, 2} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
               },
               AutoDelete->False,
               
               GridBoxDividers->{
                "ColumnsIndexed" -> {
                  1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
              "RowsIndexed" -> {
               1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
           FontSize->Small], ",", 
          StyleBox[GridBox[{
             {
              TagBox[
               TooltipBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxx",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxx,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
               Annotation[#, {1, 1} -> $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]], "Tooltip"]& ], 
              TagBox[
               TooltipBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
               Annotation[#, {1, 2} -> $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]], "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
               Annotation[#, {2, 1} -> $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]], "Tooltip"]& ], 
              TagBox[
               TooltipBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gyy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gyy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
               Annotation[#, {2, 2} -> $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]], "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
              "RowsIndexed" -> {
               1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
           FontSize->Small]}], "]"}], ",", "PDgen"}], "]"}],
      Short[#, 1]& ], 
     TagBox[
      StyleBox[GridBox[{
         {GridBox[{
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
              Annotation[#, {1, 1, 1} -> Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
              Annotation[#, {1, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
              Annotation[#, {1, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
              Annotation[#, {1, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
         {GridBox[{
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
              Annotation[#, {2, 1, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
              Annotation[#, {2, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
              Annotation[#, {2, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
              Annotation[#, {2, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
       FontSize->Small],
      Short[#, 1]& ]},
    {"20", 
     TagBox[
      RowBox[{"Determinant", "[", 
       RowBox[{
        StyleBox[GridBox[{
           {
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxx",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxx,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {1, 1} -> $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {1, 2} -> $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ]},
           {
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {2, 1} -> $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gyy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gyy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {2, 2} -> $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ]}
          },
          AutoDelete->False,
          
          GridBoxDividers->{
           "ColumnsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
            "RowsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
         FontSize->Small], ",", "gen"}], "]"}],
      Short[#, 1]& ], 
     TagBox[
      OverscriptBox[
       OverscriptBox[
        RowBox[{"CTensor", "[", 
         RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], "]"}], 
        RowBox[{"\[LeftSkeleton]", "49", "\[RightSkeleton]"}]], 
       StyleBox["~",
        FontColor->RGBColor[1., 0., 0.]]],
      Short[#, 1]& ]},
    {"21", 
     TagBox[
      RowBox[{"Einstein", "[", 
       RowBox[{"CCovD", "[", 
        RowBox[{"PDgen", ",", 
         StyleBox[GridBox[{
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                 
                 Annotation[#, {1, 1, 1} -> 
                  Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 1, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small], ",", 
         StyleBox[GridBox[{
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 1} -> $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 2} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 1} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 2} -> $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small]}], "]"}], "]"}],
      Short[#, 1]& ], 
     TagBox["Zero",
      Short[#, 1]& ]},
    {"22", 
     TagBox[
      RowBox[{"Inv", "[", 
       StyleBox[GridBox[{
          {
           TagBox[
            TooltipBox[
             RowBox[{
              InterpretationBox[
               StyleBox["gxx",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxx,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}],
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], $CellContext`gxx, Editable -> False], "[", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                   InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
            Annotation[#, {1, 1} -> $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]], "Tooltip"]& ], 
           TagBox[
            TooltipBox[
             RowBox[{
              InterpretationBox[
               StyleBox["gxy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}],
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], $CellContext`gxy, Editable -> False], "[", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                   InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
            Annotation[#, {1, 2} -> $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]], "Tooltip"]& ]},
          {
           TagBox[
            TooltipBox[
             RowBox[{
              InterpretationBox[
               StyleBox["gxy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}],
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], $CellContext`gxy, Editable -> False], "[", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                   InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
            Annotation[#, {2, 1} -> $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]], "Tooltip"]& ], 
           TagBox[
            TooltipBox[
             RowBox[{
              InterpretationBox[
               StyleBox["gyy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gyy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}],
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], $CellContext`gyy, Editable -> False], "[", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                   InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
            Annotation[#, {2, 2} -> $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]], "Tooltip"]& ]}
         },
         AutoDelete->False,
         GridBoxDividers->{
          "ColumnsIndexed" -> {
            1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
        FontSize->Small], "]"}],
      Short[#, 1]& ], 
     TagBox[
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], $CellContext`gyy, Editable -> False], "[", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                   InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], 
               RowBox[{
                 RowBox[{"-", 
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                 "+", 
                 RowBox[{
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
           Annotation[#, {1, 1} -> $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]]/(-$CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]]^2 + $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]]), "Tooltip"]& ], 
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], $CellContext`gxy, Editable -> False], "[", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                   InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], 
               RowBox[{
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                 
                 RowBox[{
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
           Annotation[#, {1, 2} -> $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]/($CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]]^2 - $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]] $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]]), "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], $CellContext`gxy, Editable -> False], "[", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                   InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], 
               RowBox[{
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                 
                 RowBox[{
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
           Annotation[#, {2, 1} -> $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]/($CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]]^2 - $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]] $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]]), "Tooltip"]& ], 
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], $CellContext`gxx, Editable -> False], "[", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                   InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], 
               RowBox[{
                 RowBox[{"-", 
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                 "+", 
                 RowBox[{
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
           Annotation[#, {2, 2} -> $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]]/(-$CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]]^2 + $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]]), "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
       FontSize->Small],
      Short[#, 1]& ]},
    {"23", 
     TagBox[
      RowBox[{"Kretschmann", "[", 
       RowBox[{"CCovD", "[", 
        RowBox[{"PDgen", ",", 
         StyleBox[GridBox[{
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                 
                 Annotation[#, {1, 1, 1} -> 
                  Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 1, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small], ",", 
         StyleBox[GridBox[{
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 1} -> $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 2} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 1} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 2} -> $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small]}], "]"}], "]"}],
      Short[#, 1]& ], 
     TagBox[
      RowBox[{"CTensor", "[", 
       RowBox[{
        FractionBox[
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], "2"], " ", 
             RowBox[{"(", 
              RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], ")"}]}], 
            "+", 
            RowBox[{"\[LeftSkeleton]", "5", "\[RightSkeleton]"}]}], ")"}], 
          "2"], 
         RowBox[{"4", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], ")"}], 
           "4"]}]], ",", 
        RowBox[{"{", "}"}], ",", "0"}], "]"}],
      Short[#, 1]& ]},
    {"24", 
     TagBox[
      RowBox[{"LC", "[", 
       StyleBox[GridBox[{
          {
           TagBox[
            TooltipBox[
             RowBox[{
              InterpretationBox[
               StyleBox["gxx",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxx,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}],
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], $CellContext`gxx, Editable -> False], "[", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                   InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
            Annotation[#, {1, 1} -> $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]], "Tooltip"]& ], 
           TagBox[
            TooltipBox[
             RowBox[{
              InterpretationBox[
               StyleBox["gxy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}],
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], $CellContext`gxy, Editable -> False], "[", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                   InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
            Annotation[#, {1, 2} -> $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]], "Tooltip"]& ]},
          {
           TagBox[
            TooltipBox[
             RowBox[{
              InterpretationBox[
               StyleBox["gxy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gxy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}],
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], $CellContext`gxy, Editable -> False], "[", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                   InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
            Annotation[#, {2, 1} -> $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]], "Tooltip"]& ], 
           TagBox[
            TooltipBox[
             RowBox[{
              InterpretationBox[
               StyleBox["gyy",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`gyy,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["y",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`y[],
                Editable->False]}], "]"}],
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], $CellContext`gyy, Editable -> False], "[", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                   InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
            Annotation[#, {2, 2} -> $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]], "Tooltip"]& ]}
         },
         AutoDelete->False,
         GridBoxDividers->{
          "ColumnsIndexed" -> {
            1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
        FontSize->Small], "]"}],
      Short[#, 1]& ], 
     TagBox[
      RowBox[{"CCovD", "[", 
       RowBox[{"PDgen", ",", 
        StyleBox[GridBox[{
           {GridBox[{
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                   RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                Annotation[#, {1, 1, 1} -> Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                Annotation[#, {1, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (-$CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                Annotation[#, {1, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (-$CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                Annotation[#, {1, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
           {GridBox[{
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                Annotation[#, {2, 1, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
                Annotation[#, {2, 1, 2} -> (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
                Annotation[#, {2, 2, 1} -> (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                   RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                Annotation[#, {2, 2, 2} -> Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
          },
          AutoDelete->False,
          
          GridBoxDividers->{
           "ColumnsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
            "RowsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
         FontSize->Small], ",", 
        StyleBox[GridBox[{
           {
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxx",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxx,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {1, 1} -> $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {1, 2} -> $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ]},
           {
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {2, 1} -> $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gyy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gyy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {2, 2} -> $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ]}
          },
          AutoDelete->False,
          
          GridBoxDividers->{
           "ColumnsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
            "RowsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
         FontSize->Small]}], "]"}],
      Short[#, 1]& ]},
    {"25", 
     TagBox[
      RowBox[{"Ricci", "[", 
       RowBox[{"CCovD", "[", 
        RowBox[{"PDgen", ",", 
         StyleBox[GridBox[{
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                 
                 Annotation[#, {1, 1, 1} -> 
                  Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (-$CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (-$CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 1, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
                 Annotation[#, {2, 1, 2} -> (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
                 Annotation[#, {2, 2, 1} -> (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                 
                 Annotation[#, {2, 2, 2} -> 
                  Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small], ",", 
         StyleBox[GridBox[{
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 1} -> $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 2} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 1} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 2} -> $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small]}], "]"}], "]"}],
      Short[#, 1]& ], 
     TagBox[
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                 RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
               RowBox[{"4", " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                  "2"]}]]}]],
           Annotation[#, {1, 1} -> Rational[1, 4] $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]] ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-2) ($CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]^2) + $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])) + 2 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) + $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))), "Tooltip"]& ], 
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                 RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
               RowBox[{"4", " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                  "2"]}]]}]],
           Annotation[#, {1, 2} -> Rational[1, 4] $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]] ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-2) ($CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]^2) + $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])) + 2 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) + $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))), "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                 RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
               RowBox[{"4", " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                  "2"]}]]}]],
           Annotation[#, {2, 1} -> Rational[1, 4] $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]] ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-2) ($CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]^2) + $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])) + 2 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) + $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))), "Tooltip"]& ], 
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                 RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
               RowBox[{"4", " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                  "2"]}]]}]],
           Annotation[#, {2, 2} -> Rational[1, 4] $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]] ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-2) ($CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]^2) + $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])) + 2 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) + $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))), "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
       FontSize->Small],
      Short[#, 1]& ]},
    {"26", 
     TagBox[
      RowBox[{"Ricci", "[", 
       RowBox[{"CCovD", "[", 
        RowBox[{"PDgen", ",", 
         StyleBox[GridBox[{
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                 
                 Annotation[#, {1, 1, 1} -> 
                  Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 1, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small], ",", 
         StyleBox[GridBox[{
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 1} -> $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 2} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 1} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 2} -> $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]}
           },
           AutoDelete->False,
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small]}], "]"}], "]"}],
      Short[#, 1]& ], 
     TagBox[
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                 RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                   ")"}]}], 
               RowBox[{"4", " ", 
                 RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                   ")"}]}]]}]],
           Annotation[#, {1, 1} -> Rational[1, 4] $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]] (-$CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ((-4) $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                 $CellContext`x[], 
                 $CellContext`y[]] - 4 $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                $CellContext`x[], 
                $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] - ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]] (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]])) + 4 $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + 
                Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])) ((-2) $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) + 4 $CellContext`T212[
                 $CellContext`x[], 
                 $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) 
               Derivative[0, 1][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] ((-2) $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                 $CellContext`x[], 
                 $CellContext`y[]] + 4 $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                 $CellContext`x[], 
                 $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]]), "Tooltip"]& ], 
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                 RowBox[{"(", 
                   RowBox[{
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                   ")"}]}], 
               RowBox[{"4", " ", 
                 RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                   ")"}]}]]}]],
           Annotation[#, {1, 2} -> Rational[1, 4] $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]] ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-1) (4 $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                 $CellContext`x[], 
                 $CellContext`y[]] + 4 $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                 $CellContext`x[], 
                 $CellContext`y[]] + 2 Derivative[0, 2][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) 
               Derivative[0, 1][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) 
               Derivative[0, 1][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])) (2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]) + 4 $CellContext`T212[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]) - 2 ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]])) ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] + 
               Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) - 4 $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                $CellContext`x[], 
                $CellContext`y[]] - 4 $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                $CellContext`x[], 
                $CellContext`y[]] - 4 Derivative[1, 1][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]] + 2 Derivative[2, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]), "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
              RowBox[{"-", 
                FractionBox[
                 RowBox[{
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                 RowBox[{"4", " ", 
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
           Annotation[#, {2, 1} -> Rational[-1, 4] $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]] ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-1) ((-4) $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                 $CellContext`x[], 
                 $CellContext`y[]] - 4 $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                $CellContext`x[], 
                $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] - ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]] (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]])) + 4 $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + 
                Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])) ((-2) $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) + 4 $CellContext`T212[
                 $CellContext`x[], 
                 $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) 
               Derivative[0, 1][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] ((-2) $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                 $CellContext`x[], 
                 $CellContext`y[]] + 4 $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                 $CellContext`x[], 
                 $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]]), "Tooltip"]& ], 
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
              RowBox[{"-", 
                FractionBox[
                 RowBox[{
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                 RowBox[{"4", " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
           Annotation[#, {2, 2} -> Rational[-1, 4] $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]] (-$CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) (4 $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                 $CellContext`x[], 
                 $CellContext`y[]] + 4 $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                 $CellContext`x[], 
                 $CellContext`y[]] + 2 Derivative[0, 2][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) 
               Derivative[0, 1][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) 
               Derivative[0, 1][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])) (2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]) + 4 $CellContext`T212[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]) - 2 ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]])) ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] + 
               Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) - 4 $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                $CellContext`x[], 
                $CellContext`y[]] - 4 $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                $CellContext`x[], 
                $CellContext`y[]] - 4 Derivative[1, 1][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]] + 2 Derivative[2, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]), "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
       FontSize->Small],
      Short[#, 1]& ]},
    {"27", 
     TagBox[
      RowBox[{"RicciScalar", "[", 
       RowBox[{"CCovD", "[", 
        RowBox[{"PDgen", ",", 
         StyleBox[GridBox[{
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                 
                 Annotation[#, {1, 1, 1} -> 
                  Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (-$CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (-$CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 1, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
                 Annotation[#, {2, 1, 2} -> (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
                 Annotation[#, {2, 2, 1} -> (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                 
                 Annotation[#, {2, 2, 2} -> 
                  Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small], ",", 
         StyleBox[GridBox[{
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 1} -> $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 2} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 1} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 2} -> $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small]}], "]"}], "]"}],
      Short[#, 1]& ], 
     TagBox[
      RowBox[{"CTensor", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{
           RowBox[{
            InterpretationBox[
             StyleBox["gxx",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`gxx,
             Editable->False], "[", 
            RowBox[{
             InterpretationBox[
              StyleBox["x",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`x[],
              Editable->False], ",", 
             InterpretationBox[
              StyleBox["y",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`y[],
              Editable->False]}], "]"}], " ", 
           RowBox[{"(", 
            RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], ")"}]}], 
          "+", 
          RowBox[{"\[LeftSkeleton]", "2", "\[RightSkeleton]"}], "+", 
          RowBox[{
           RowBox[{
            InterpretationBox[
             StyleBox["gyy",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`gyy,
             Editable->False], "[", 
            RowBox[{
             InterpretationBox[
              StyleBox["x",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`x[],
              Editable->False], ",", 
             InterpretationBox[
              StyleBox["y",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`y[],
              Editable->False]}], "]"}], " ", 
           RowBox[{"(", 
            RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], ")"}]}]}], 
         RowBox[{"2", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], ")"}], 
           "2"]}]], ",", 
        RowBox[{"{", "}"}], ",", "0"}], "]"}],
      Short[#, 1]& ]},
    {"28", 
     TagBox[
      RowBox[{"RicciScalar", "[", 
       RowBox[{"CCovD", "[", 
        RowBox[{"PDgen", ",", 
         StyleBox[GridBox[{
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                 
                 Annotation[#, {1, 1, 1} -> 
                  Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 1, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small], ",", 
         StyleBox[GridBox[{
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 1} -> $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 2} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 1} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 2} -> $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small]}], "]"}], "]"}],
      Short[#, 1]& ], 
     TagBox[
      RowBox[{"CTensor", "[", 
       RowBox[{
        FractionBox[
         RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], 
         RowBox[{"2", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], ")"}], 
           "2"]}]], ",", 
        RowBox[{"{", "}"}], ",", "0"}], "]"}],
      Short[#, 1]& ]},
    {"29", 
     TagBox[
      RowBox[{"Riemann", "[", 
       RowBox[{"CCovD", "[", 
        RowBox[{"PDgen", ",", 
         StyleBox[GridBox[{
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                 
                 Annotation[#, {1, 1, 1} -> 
                  Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (-$CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (-$CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 1, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
                 Annotation[#, {2, 1, 2} -> (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
                 Annotation[#, {2, 2, 1} -> (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                 
                 Annotation[#, {2, 2, 2} -> 
                  Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small], ",", 
         StyleBox[GridBox[{
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 1} -> $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 2} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 1} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 2} -> $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small]}], "]"}], "]"}],
      Short[#, 1]& ], 
     TagBox[
      StyleBox[GridBox[{
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1, 2} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]}]],
              Annotation[#, {1, 2, 1, 1} -> Rational[-1, 4] $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                  RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]],
              Annotation[#, {1, 2, 1, 2} -> Rational[1, 4] $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]}]],
              Annotation[#, {1, 2, 2, 1} -> Rational[-1, 4] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                  RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]],
              Annotation[#, {1, 2, 2, 2} -> Rational[1, 4] $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}]},
         {GridBox[{
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                  RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]],
              Annotation[#, {2, 1, 1, 1} -> Rational[1, 4] $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                  RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]],
              Annotation[#, {2, 1, 1, 2} -> Rational[1, 4] $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (-$CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                  RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]],
              Annotation[#, {2, 1, 2, 1} -> Rational[1, 4] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]}]],
              Annotation[#, {2, 1, 2, 2} -> Rational[-1, 4] $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 1, 2} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
       FontSize->Small],
      Short[#, 1]& ]},
    {"30", 
     TagBox[
      RowBox[{"Riemann", "[", 
       RowBox[{"CCovD", "[", 
        RowBox[{"PDgen", ",", 
         StyleBox[GridBox[{
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                 
                 Annotation[#, {1, 1, 1} -> 
                  Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 1, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small], ",", 
         StyleBox[GridBox[{
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 1} -> $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 2} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 1} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 2} -> $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small]}], "]"}], "]"}],
      Short[#, 1]& ], 
     TagBox[
      StyleBox[GridBox[{
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1, 2} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]}]],
              Annotation[#, {1, 2, 1, 1} -> Rational[-1, 4] $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                  RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]],
              Annotation[#, {1, 2, 1, 2} -> Rational[1, 4] $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]}]],
              Annotation[#, {1, 2, 2, 1} -> Rational[-1, 4] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                  RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]],
              Annotation[#, {1, 2, 2, 2} -> Rational[1, 4] $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}]},
         {GridBox[{
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                  RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]],
              Annotation[#, {2, 1, 1, 1} -> Rational[1, 4] $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]}]],
              Annotation[#, {2, 1, 1, 2} -> Rational[-1, 4] $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                  RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]],
              Annotation[#, {2, 1, 2, 1} -> Rational[1, 4] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]}]],
              Annotation[#, {2, 1, 2, 2} -> Rational[-1, 4] $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 1, 2} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
       FontSize->Small],
      Short[#, 1]& ]},
    {"31", 
     TagBox[
      RowBox[{"RiemannDown", "[", 
       RowBox[{"CCovD", "[", 
        RowBox[{"PDgen", ",", 
         StyleBox[GridBox[{
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                 
                 Annotation[#, {1, 1, 1} -> 
                  Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 1, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small], ",", 
         StyleBox[GridBox[{
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 1} -> $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 2} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 1} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 2} -> $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small]}], "]"}], "]"}],
      Short[#, 1]& ], 
     TagBox[
      StyleBox[GridBox[{
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1, 2} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], 
                  RowBox[{"4", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
              Annotation[#, {1, 2, 1, 2} -> Rational[1, 4] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                   Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], 
                  RowBox[{"4", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
              Annotation[#, {1, 2, 2, 1} -> Rational[1, 4] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}]},
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], 
                  RowBox[{"4", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
              Annotation[#, {2, 1, 1, 2} -> Rational[1, 4] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], 
                  RowBox[{"4", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
              Annotation[#, {2, 1, 2, 1} -> Rational[1, 4] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                   Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 1, 2} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
       FontSize->Small],
      Short[#, 1]& ]},
    {"32", 
     TagBox[
      RowBox[{"TensorDerivative", "[", 
       RowBox[{
        StyleBox[GridBox[{
           {
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxx",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxx,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {1, 1} -> $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {1, 2} -> $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ]},
           {
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {2, 1} -> $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gyy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gyy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {2, 2} -> $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ]}
          },
          AutoDelete->False,
          
          GridBoxDividers->{
           "ColumnsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
            "RowsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
         FontSize->Small], ",", 
        RowBox[{"CCovD", "[", 
         RowBox[{"PDgen", ",", 
          StyleBox[GridBox[{
             {GridBox[{
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                  Annotation[#, {1, 1, 1} -> Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {1, 1, 2} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (-$CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]}
               },
               AutoDelete->False,
               
               GridBoxDividers->{
                "ColumnsIndexed" -> {
                  1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], 
              GridBox[{
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {1, 2, 1} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (-$CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]},
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {1, 2, 2} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
               },
               AutoDelete->False,
               
               GridBoxDividers->{
                "ColumnsIndexed" -> {
                  1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
             {GridBox[{
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {2, 1, 1} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
                  Annotation[#, {2, 1, 2} -> (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]}
               },
               AutoDelete->False,
               
               GridBoxDividers->{
                "ColumnsIndexed" -> {
                  1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], 
              GridBox[{
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
                  Annotation[#, {2, 2, 1} -> (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]},
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                  Annotation[#, {2, 2, 2} -> Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
               },
               AutoDelete->False,
               
               GridBoxDividers->{
                "ColumnsIndexed" -> {
                  1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
              "RowsIndexed" -> {
               1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
           FontSize->Small], ",", 
          StyleBox[GridBox[{
             {
              TagBox[
               TooltipBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxx",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxx,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
               Annotation[#, {1, 1} -> $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]], "Tooltip"]& ], 
              TagBox[
               TooltipBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
               Annotation[#, {1, 2} -> $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]], "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
               Annotation[#, {2, 1} -> $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]], "Tooltip"]& ], 
              TagBox[
               TooltipBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gyy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gyy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
               Annotation[#, {2, 2} -> $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]], "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
              "RowsIndexed" -> {
               1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
           FontSize->Small]}], "]"}]}], "]"}],
      Short[#, 1]& ], 
     TagBox["Zero",
      Short[#, 1]& ]},
    {"33", 
     TagBox[
      RowBox[{"TensorDerivative", "[", 
       RowBox[{
        StyleBox[GridBox[{
           {
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxx",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxx,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {1, 1} -> $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {1, 2} -> $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ]},
           {
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gxy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gxy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {2, 1} -> $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              RowBox[{
               InterpretationBox[
                StyleBox["gyy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`gyy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["y",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`y[],
                 Editable->False]}], "]"}],
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
             Annotation[#, {2, 2} -> $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]], "Tooltip"]& ]}
          },
          AutoDelete->False,
          
          GridBoxDividers->{
           "ColumnsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
            "RowsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
         FontSize->Small], ",", 
        RowBox[{"CCovD", "[", 
         RowBox[{"PDgen", ",", 
          StyleBox[GridBox[{
             {GridBox[{
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                  Annotation[#, {1, 1, 1} -> Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {1, 1, 2} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
               },
               AutoDelete->False,
               
               GridBoxDividers->{
                "ColumnsIndexed" -> {
                  1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], 
              GridBox[{
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  Annotation[#, {1, 2, 1} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {1, 2, 2} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
               },
               AutoDelete->False,
               
               GridBoxDividers->{
                "ColumnsIndexed" -> {
                  1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
             {GridBox[{
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {2, 1, 1} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {2, 1, 2} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
               },
               AutoDelete->False,
               
               GridBoxDividers->{
                "ColumnsIndexed" -> {
                  1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], 
              GridBox[{
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {2, 2, 1} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {2, 2, 2} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
               },
               AutoDelete->False,
               
               GridBoxDividers->{
                "ColumnsIndexed" -> {
                  1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
              "RowsIndexed" -> {
               1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
           FontSize->Small], ",", 
          StyleBox[GridBox[{
             {
              TagBox[
               TooltipBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxx",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxx,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
               Annotation[#, {1, 1} -> $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]], "Tooltip"]& ], 
              TagBox[
               TooltipBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
               Annotation[#, {1, 2} -> $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]], "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
               Annotation[#, {2, 1} -> $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]], "Tooltip"]& ], 
              TagBox[
               TooltipBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gyy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gyy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
               Annotation[#, {2, 2} -> $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]], "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
              "RowsIndexed" -> {
               1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
           FontSize->Small]}], "]"}]}], "]"}],
      Short[#, 1]& ], 
     TagBox["Zero",
      Short[#, 1]& ]},
    {"34", 
     TagBox[
      RowBox[{"TensorDerivative", "[", 
       RowBox[{
        StyleBox[GridBox[{
           {GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 1, 1, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 1, 1, 2} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 1, 2, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 1, 2, 2} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
               "RowsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 2, 1, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1", ",", "2"}], "}"}], 
                   "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], 
                    RowBox[{"4", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                Annotation[#, {1, 2, 1, 2} -> Rational[1, 4] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2", ",", "1"}], "}"}], 
                   "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], 
                    RowBox[{"4", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                Annotation[#, {1, 2, 2, 1} -> Rational[1, 4] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 2, 2, 2} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
               "RowsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}]},
           {GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 1, 1, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1", ",", "2"}], "}"}], 
                   "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], 
                    RowBox[{"4", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                Annotation[#, {2, 1, 1, 2} -> Rational[1, 4] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2", ",", "1"}], "}"}], 
                   "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], 
                    RowBox[{"4", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                Annotation[#, {2, 1, 2, 1} -> Rational[1, 4] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 1, 2, 2} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
               "RowsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 2, 1, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 2, 1, 2} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 2, 2, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 2, 2, 2} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
               "RowsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}]}
          },
          AutoDelete->False,
          
          GridBoxDividers->{
           "ColumnsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
            "RowsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
         FontSize->Small], ",", 
        RowBox[{"CCovD", "[", 
         RowBox[{"PDgen", ",", 
          StyleBox[GridBox[{
             {GridBox[{
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                  Annotation[#, {1, 1, 1} -> Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {1, 1, 2} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
               },
               AutoDelete->False,
               
               GridBoxDividers->{
                "ColumnsIndexed" -> {
                  1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], 
              GridBox[{
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {1, 2, 1} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {1, 2, 2} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
               },
               AutoDelete->False,
               
               GridBoxDividers->{
                "ColumnsIndexed" -> {
                  1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
             {GridBox[{
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {2, 1, 1} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {2, 1, 2} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
               },
               AutoDelete->False,
               
               GridBoxDividers->{
                "ColumnsIndexed" -> {
                  1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], 
              GridBox[{
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {2, 2, 1} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
                {
                 TagBox[
                  TooltipBox["\<\"\[GrayCircle]\"\>",
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                  
                  Annotation[#, {2, 2, 2} -> 
                   Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
               },
               AutoDelete->False,
               
               GridBoxDividers->{
                "ColumnsIndexed" -> {
                  1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
              "RowsIndexed" -> {
               1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
           FontSize->Small], ",", 
          StyleBox[GridBox[{
             {
              TagBox[
               TooltipBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxx",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxx,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
               Annotation[#, {1, 1} -> $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]], "Tooltip"]& ], 
              TagBox[
               TooltipBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
               Annotation[#, {1, 2} -> $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]], "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gxy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gxy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
               Annotation[#, {2, 1} -> $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]], "Tooltip"]& ], 
              TagBox[
               TooltipBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["gyy",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`gyy,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False]}], "]"}],
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
               Annotation[#, {2, 2} -> $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]], "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
              "RowsIndexed" -> {
               1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
           FontSize->Small]}], "]"}]}], "]"}],
      Short[#, 1]& ], 
     TagBox[
      StyleBox[GridBox[{
         {GridBox[{
            {GridBox[{
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "1"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {1, 1, 1, 1, 1} -> 0, "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "2"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {1, 1, 1, 1, 2} -> 0, "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1", ",", "2", ",", "1"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {1, 1, 1, 2, 1} -> 0, "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1", ",", "2", ",", "2"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {1, 1, 1, 2, 2} -> 0, "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
            {GridBox[{
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2", ",", "1", ",", "1"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {1, 1, 2, 1, 1} -> 0, "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2", ",", "1", ",", "2"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {1, 1, 2, 1, 2} -> 0, "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2", ",", "2", ",", "1"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {1, 1, 2, 2, 1} -> 0, "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2", ",", "2", ",", "2"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {1, 1, 2, 2, 2} -> 0, "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], GridBox[{
            {GridBox[{
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1", ",", "1", ",", "1"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {1, 2, 1, 1, 1} -> 0, "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1", ",", "1", ",", "2"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {1, 2, 1, 1, 2} -> 0, "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1", ",", "2", ",", "1"}], 
                    "}"}], "\[Rule]", 
                    RowBox[{
                    FractionBox["1", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"3", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}]],
                 
                 Annotation[#, {1, 2, 1, 2, 1} -> 
                  Rational[1, 4] ((-4) Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 
                    Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (-$CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 
                    4 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[2, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[3, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1", ",", "2", ",", "2"}], 
                    "}"}], "\[Rule]", 
                    RowBox[{
                    FractionBox["1", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "3"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}]],
                 
                 Annotation[#, {1, 2, 1, 2, 2} -> 
                  Rational[1, 4] ((-4) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 2][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 2][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 3][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 2][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 
                    4 Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (4 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 2][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 2][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[2, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "1"}], 
                    "}"}], "\[Rule]", 
                    RowBox[{
                    FractionBox["1", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"3", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}]],
                 
                 Annotation[#, {1, 2, 2, 1, 1} -> 
                  Rational[1, 4] (4 Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    4 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (-$CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 4 
                    Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 Derivative[2, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[3, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "2"}], 
                    "}"}], "\[Rule]", 
                    RowBox[{
                    FractionBox["1", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "3"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}]],
                 
                 Annotation[#, {1, 2, 2, 1, 2} -> 
                  Rational[1, 4] (4 Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 2][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 2][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 3][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 2][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 4 
                    Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 4 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (4 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 2][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 Derivative[1, 2][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 
                    2 Derivative[2, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2", ",", "2", ",", "1"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {1, 2, 2, 2, 1} -> 0, "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2", ",", "2", ",", "2"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {1, 2, 2, 2, 2} -> 0, "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}]},
         {GridBox[{
            {GridBox[{
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1", ",", "1", ",", "1"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {2, 1, 1, 1, 1} -> 0, "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1", ",", "1", ",", "2"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {2, 1, 1, 1, 2} -> 0, "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1", ",", "2", ",", "1"}], 
                    "}"}], "\[Rule]", 
                    RowBox[{
                    FractionBox["1", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"3", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}]],
                 
                 Annotation[#, {2, 1, 1, 2, 1} -> 
                  Rational[1, 4] (4 Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    4 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (-$CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 4 
                    Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 Derivative[2, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[3, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1", ",", "2", ",", "2"}], 
                    "}"}], "\[Rule]", 
                    RowBox[{
                    FractionBox["1", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "3"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}]],
                 
                 Annotation[#, {2, 1, 1, 2, 2} -> 
                  Rational[1, 4] (4 Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 2][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 2][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 3][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 2][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 4 
                    Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 4 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (4 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 2][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 Derivative[1, 2][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 
                    2 Derivative[2, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2", ",", "1", ",", "1"}], 
                    "}"}], "\[Rule]", 
                    RowBox[{
                    FractionBox["1", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"3", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}]],
                 
                 Annotation[#, {2, 1, 2, 1, 1} -> 
                  Rational[1, 4] ((-4) Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 
                    Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (-$CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 
                    4 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[2, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[3, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2", ",", "1", ",", "2"}], 
                    "}"}], "\[Rule]", 
                    RowBox[{
                    FractionBox["1", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "3"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}]],
                 
                 Annotation[#, {2, 1, 2, 1, 2} -> 
                  Rational[1, 4] ((-4) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 2][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 2][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 3][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 2][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 
                    4 Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (4 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 2][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 2][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[2, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2", ",", "2", ",", "1"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {2, 1, 2, 2, 1} -> 0, "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2", ",", "2", ",", "2"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {2, 1, 2, 2, 2} -> 0, "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], GridBox[{
            {GridBox[{
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1", ",", "1", ",", "1"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {2, 2, 1, 1, 1} -> 0, "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1", ",", "1", ",", "2"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {2, 2, 1, 1, 2} -> 0, "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1", ",", "2", ",", "1"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {2, 2, 1, 2, 1} -> 0, "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1", ",", "2", ",", "2"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {2, 2, 1, 2, 2} -> 0, "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
            {GridBox[{
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2", ",", "1", ",", "1"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {2, 2, 2, 1, 1} -> 0, "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2", ",", "1", ",", "2"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {2, 2, 2, 1, 2} -> 0, "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2", ",", "2", ",", "1"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {2, 2, 2, 2, 1} -> 0, "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["0",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2", ",", "2", ",", "2"}], 
                    "}"}], "\[Rule]", "0"}]],
                 Annotation[#, {2, 2, 2, 2, 2} -> 0, "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
       FontSize->Small],
      Short[#, 1]& ]},
    {"35", 
     TagBox[
      RowBox[{"ToCTensorOneSlot", "[", 
       RowBox[{
        StyleBox[GridBox[{
           {GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 1, 1, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 1, 1, 2} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 1, 2, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 1, 2, 2} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
               "RowsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1", ",", "1"}], "}"}], 
                   "\[Rule]", 
                   RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]}]],
                Annotation[#, {1, 2, 1, 1} -> Rational[-1, 4] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ], 
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1", ",", "2"}], "}"}], 
                   "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]],
                
                Annotation[#, {1, 2, 1, 2} -> 
                 Rational[1, 4] $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2", ",", "1"}], "}"}], 
                   "\[Rule]", 
                   RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]}]],
                Annotation[#, {1, 2, 2, 1} -> Rational[-1, 4] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ], 
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2", ",", "2"}], "}"}], 
                   "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]],
                
                Annotation[#, {1, 2, 2, 2} -> 
                 Rational[1, 4] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
               "RowsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}]},
           {GridBox[{
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1", ",", "1"}], "}"}], 
                   "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]],
                
                Annotation[#, {2, 1, 1, 1} -> 
                 Rational[1, 4] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ], 
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1", ",", "2"}], "}"}], 
                   "\[Rule]", 
                   RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]}]],
                Annotation[#, {2, 1, 1, 2} -> Rational[-1, 4] $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2", ",", "1"}], "}"}], 
                   "\[Rule]", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]],
                
                Annotation[#, {2, 1, 2, 1} -> 
                 Rational[1, 4] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ], 
               TagBox[
                TooltipBox["\<\"\[GrayCircle]\"\>",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2", ",", "2"}], "}"}], 
                   "\[Rule]", 
                   RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]}]],
                Annotation[#, {2, 1, 2, 2} -> Rational[-1, 4] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
               "RowsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 2, 1, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 2, 1, 2} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 2, 2, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 2, 2, 2} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
               "RowsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}]}
          },
          AutoDelete->False,
          
          GridBoxDividers->{
           "ColumnsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
            "RowsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
         FontSize->Small], ",", 
        RowBox[{"{", 
         RowBox[{"3", ",", 
          StyleBox[GridBox[{
             {
              TagBox[
               TooltipBox["\<\"\[GrayCircle]\"\>",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                  FractionBox[
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
               Annotation[#, {1, 1} -> $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]]/(-$CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ], 
              TagBox[
               TooltipBox["\<\"\[GrayCircle]\"\>",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                  FractionBox[
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], 
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
               Annotation[#, {1, 2} -> $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]/($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]]), "Tooltip"]& ]},
             {
              TagBox[
               TooltipBox["\<\"\[GrayCircle]\"\>",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                  FractionBox[
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], 
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
               Annotation[#, {2, 1} -> $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]/($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]]), "Tooltip"]& ], 
              TagBox[
               TooltipBox["\<\"\[GrayCircle]\"\>",
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                  FractionBox[
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]]}]],
               Annotation[#, {2, 2} -> $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]/(-$CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]), "Tooltip"]& ]}
            },
            AutoDelete->False,
            
            GridBoxDividers->{
             "ColumnsIndexed" -> {
               1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
              "RowsIndexed" -> {
               1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
           FontSize->Small]}], "}"}]}], "]"}],
      Short[#, 1]& ], 
     TagBox[
      StyleBox[GridBox[{
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1, 2} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], 
                  RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]],
              Annotation[#, {1, 2, 1, 2} -> Rational[1, 4] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]}]],
              
              Annotation[#, {1, 2, 2, 1} -> 
               Rational[-1, 4] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}]},
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]}]],
              
              Annotation[#, {2, 1, 1, 2} -> 
               Rational[-1, 4] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], 
                  RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}]]}]],
              Annotation[#, {2, 1, 2, 1} -> Rational[1, 4] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                    Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 1, 2} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
       FontSize->Small],
      Short[#, 1]& ]},
    {"36", 
     TagBox[
      RowBox[{"Torsion", "[", 
       RowBox[{"CCovD", "[", 
        RowBox[{"PDgen", ",", 
         StyleBox[GridBox[{
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]}]],
                 
                 Annotation[#, {1, 1, 1} -> 
                  Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {1, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
            {GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 1, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 1, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 2, 1} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]},
               {
                TagBox[
                 TooltipBox["\<\"\[GrayCircle]\"\>",
                  RowBox[{
                    RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]]}]],
                 Annotation[#, {2, 2, 2} -> Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), "Tooltip"]& ]}
              },
              AutoDelete->False,
              
              GridBoxDividers->{
               "ColumnsIndexed" -> {
                 1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small], ",", 
         StyleBox[GridBox[{
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxx",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxx,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 1} -> $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 2} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gxy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gxy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 1} -> $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["gyy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`gyy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 2} -> $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
          FontSize->Small]}], "]"}], "]"}],
      Short[#, 1]& ], 
     TagBox[
      StyleBox[GridBox[{
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["T112",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`T112,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 1, 2} -> $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{"-", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]],
              Annotation[#, {1, 2, 1} -> -$CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 1} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["T212",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`T212,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 1, 2} -> $CellContext`T212[
                 $CellContext`x[], 
                 $CellContext`y[]], "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{"-", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False]}], "]"}]}]}]],
              Annotation[#, {2, 2, 1} -> -$CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 2} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 3 -> RGBColor[1, 0, 0]}}],
       FontSize->Small],
      Short[#, 1]& ]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  TableForm[{{
     "ReportCompute"[
      "ADChristoffel"[-1, -1, -1, -1]], {
      Skeleton[4]}}, {
     "ReportCompute"[
      "CDRiemann"[-1, -1, -1, -1, -1]], {
      Skeleton[2]}}, {
     "ReportCompute"[
      "Christoffel"[-1, -1, -1]], {
      Skeleton[8]}}, {
     "ReportCompute"[
      "Christoffel"[1, -1, -1]], {
      Skeleton[8]}}, {
     "ReportCompute"[
      "DetMetric"[]], {
      Skeleton[1]}}, {
     "ReportCompute"[
      "DMetric"[-1, -1, -1]], {
      Skeleton[6]}}, {
     "ReportCompute"[
      "Einstein"[-1, -1]], {
      Skeleton[4]}}, {
     "ReportCompute"[
      "Kretschmann"[]], {
      Skeleton[1]}}, {
     "ReportCompute"[
      "Metric"[1, 1]], {
      Skeleton[3]}}, {
     "ReportCompute"[
      "Ricci"[-1, -1]], {
      Skeleton[4]}}, {
     "ReportCompute"[
      "RicciScalar"[]], {
      Skeleton[1]}}, {
     "ReportCompute"[
      "Riemann"[-1, -1, -1, -1]], {
      Skeleton[1]}}, {
     "ReportCompute"[
      "Riemann"[-1, -1, -1, 1]], {
      Skeleton[4]}}, {
     "ReportCompute"[
      "Riemann"[-1, -1, 1, 1]], {
      Skeleton[1]}}, {
     "ReportCompute"[
      "Torsion"[-1, -1, -1]], {
      Skeleton[2]}}, {
     "ChartsOf"[
      Shallow[{{
         $CellContext`gxx[
          $CellContext`x[], 
          $CellContext`y[]], 
         $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[]]}, {
         $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[]], 
         $CellContext`gyy[
          $CellContext`x[], 
          $CellContext`y[]]}}, 1]], 
     Short[
      HoldForm[{$CellContext`gen}], 1]}, {
     "ChartsOf"[
      Shallow[{{{Rational[-1, 2] ($CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 - $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])^(-1) ($CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
              $CellContext`x[], 
              $CellContext`y[]] + $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
               $CellContext`x[], 
               $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
               $CellContext`x[], 
               $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 - $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])^(-1) (-$CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
              $CellContext`x[], 
              $CellContext`y[]] + $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
              $CellContext`x[], 
              $CellContext`y[]])}, {Rational[1, 2] ($CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 - $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])^(-1) (-$CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
              $CellContext`x[], 
              $CellContext`y[]] + $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
              $CellContext`x[], 
              $CellContext`y[]]), Rational[1, 2] ($CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 - $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])^(-1) ($CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
              $CellContext`x[], 
              $CellContext`y[]] + $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
               $CellContext`x[], 
               $CellContext`y[]]))}}, {{Rational[1, 2] ($CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 - $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])^(-1) ($CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
              $CellContext`x[], 
              $CellContext`y[]] + $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
               $CellContext`x[], 
               $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
               $CellContext`x[], 
               $CellContext`y[]])), (2 $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]]^2 - 2 $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])^(-1) ($CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
              $CellContext`x[], 
              $CellContext`y[]] - $CellContext`gxx[
             $CellContext`x[], 
             $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
             $CellContext`x[], 
             $CellContext`y[]])}, {(2 $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]]^2 - 2 $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])^(-1) ($CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
              $CellContext`x[], 
              $CellContext`y[]] - $CellContext`gxx[
             $CellContext`x[], 
             $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
             $CellContext`x[], 
             $CellContext`y[]]), Rational[-1, 2] ($CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 - $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])^(-1) ($CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
              $CellContext`x[], 
              $CellContext`y[]] + $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
               $CellContext`x[], 
               $CellContext`y[]]))}}}, 1]], 
     Short[
      HoldForm[{$CellContext`gen}], 1]}, {
     "ChartsOf"[
      Shallow[{{{Rational[-1, 2] ($CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 - $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])^(-1) (2 $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`T112[
              $CellContext`x[], 
              $CellContext`y[]] + 2 $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 $CellContext`T212[
              $CellContext`x[], 
              $CellContext`y[]] + $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
              $CellContext`x[], 
              $CellContext`y[]] + $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
               $CellContext`x[], 
               $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
               $CellContext`x[], 
               $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 - $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`T112[
              $CellContext`x[], 
              $CellContext`y[]] - $CellContext`gyy[
             $CellContext`x[], 
             $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
             $CellContext`x[], 
             $CellContext`y[]] + $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] ((-2) $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`T212[
                $CellContext`x[], 
                $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
               $CellContext`x[], 
               $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 - $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 $CellContext`T112[
              $CellContext`x[], 
              $CellContext`y[]] - $CellContext`gyy[
             $CellContext`x[], 
             $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
             $CellContext`x[], 
             $CellContext`y[]] + $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] ((-2) $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`T212[
                $CellContext`x[], 
                $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
               $CellContext`x[], 
               $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 - $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])^(-1) ($CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] ((-2) $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`T112[
                $CellContext`x[], 
                $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
               $CellContext`x[], 
               $CellContext`y[]]) + $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]] ((-2) $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`T212[
                $CellContext`x[], 
                $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
               $CellContext`x[], 
               $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
               $CellContext`x[], 
               $CellContext`y[]]))}}, {{Rational[1, 2] ($CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 - $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])^(-1) (2 $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]]^2 $CellContext`T112[
              $CellContext`x[], 
              $CellContext`y[]] + $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
              $CellContext`x[], 
              $CellContext`y[]] + $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] (2 $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`T212[
                $CellContext`x[], 
                $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
               $CellContext`x[], 
               $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
               $CellContext`x[], 
               $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 - $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])^(-1) ($CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] (2 $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`T212[
                $CellContext`x[], 
                $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
               $CellContext`x[], 
               $CellContext`y[]]) + $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] (2 $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`T112[
                $CellContext`x[], 
                $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
              $CellContext`x[], 
              $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 - $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])^(-1) ($CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
              $CellContext`x[], 
              $CellContext`y[]] + $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] (2 $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`T112[
                $CellContext`x[], 
                $CellContext`y[]] + 2 $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`T212[
                $CellContext`x[], 
                $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
              $CellContext`x[], 
              $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 - $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])^(-1) (2 $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 $CellContext`T112[
              $CellContext`x[], 
              $CellContext`y[]] - $CellContext`gxx[
             $CellContext`x[], 
             $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
             $CellContext`x[], 
             $CellContext`y[]] + $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] (2 $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`T212[
                $CellContext`x[], 
                $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
              $CellContext`x[], 
              $CellContext`y[]]))}}}, 1]], 
     Short[
      HoldForm[{$CellContext`gen}], 1]}, {
     Short[
      HoldForm[
       xAct`xTensor`Christoffel[
        xAct`xCoba`CCovD[$CellContext`PDgen, 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{{Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}}, {{
              Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}}}, {$CellContext`gen, \
-$CellContext`gen, -$CellContext`gen}, 0], 
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{
              $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]}, {
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 
            0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]], \
$CellContext`PDgen]], 1], 
     Short[
      HoldForm[
       RawBoxes[
        xAct`xCoba`Private`CTensorBoxes[
         xAct`xCoba`CTensor[{{{Rational[-1, 2] ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]] + 2 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 $CellContext`T212[
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]] - $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] + $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] ((-2) $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]] - $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] + $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] ((-2) $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-1) ($CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] ((-2) $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) + $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] ((-2) $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]))}}, {{Rational[1, 2] ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] (2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-1) ($CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] (2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]]) + $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] (2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-1) ($CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] (2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]] - $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]] + $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] (2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]))}}}, {$CellContext`gen, \
-$CellContext`gen, -$CellContext`gen}, 0], 
         xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]], 1]}, {
     Short[
      HoldForm[
       xAct`xTensor`Determinant[
        RawBoxes[
         xAct`xCoba`Private`CTensorBoxes[
          xAct`xCoba`CTensor[{{
             $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]], 
             $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]]}, {
             $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]], 
             $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 0],
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], \
$CellContext`gen]], 1], 
     Short[
      HoldForm[
       RawBoxes[
        xAct`xCoba`Private`CTensorBoxes[
         xAct`xCoba`CTensor[-$CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]]^2 + $CellContext`gxx[
             $CellContext`x[], 
             $CellContext`y[]] $CellContext`gyy[
             $CellContext`x[], 
             $CellContext`y[]], {}, 2 $CellContext`gen], 
         xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]], 1]}, {
     Short[
      HoldForm[
       xAct`xTensor`Einstein[
        xAct`xCoba`CCovD[$CellContext`PDgen, 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{{Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}}, {{
              Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}}}, {$CellContext`gen, \
-$CellContext`gen, -$CellContext`gen}, 0], 
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{
              $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]}, {
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 
            0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]]]], 1], 
     Short[
      HoldForm[xAct`xTensor`Zero], 1]}, {
     Short[
      HoldForm[
       xAct`xTensor`Inv[
        RawBoxes[
         xAct`xCoba`Private`CTensorBoxes[
          xAct`xCoba`CTensor[{{
             $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]], 
             $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]]}, {
             $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]], 
             $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 0],
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]]], 1], 
     Short[
      HoldForm[
       RawBoxes[
        xAct`xCoba`Private`CTensorBoxes[
         xAct`xCoba`CTensor[{{$CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]]/(-$CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]]^2 + $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]] $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]]), $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]]/($CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 - $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])}, {$CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]]/($CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 - $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]]), $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]]/(-$CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]]^2 + $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]] $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]])}}, {$CellContext`gen, $CellContext`gen}, 0],
          xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]], 1]}, {
     Short[
      HoldForm[
       xAct`xTensor`Kretschmann[
        xAct`xCoba`CCovD[$CellContext`PDgen, 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{{Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}}, {{
              Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}}}, {$CellContext`gen, \
-$CellContext`gen, -$CellContext`gen}, 0], 
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{
              $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]}, {
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 
            0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]]]], 1], 
     Short[
      HoldForm[
       RawBoxes[
        xAct`xCoba`Private`CTensorBoxes[
         xAct`xCoba`CTensor[Rational[1, 4] ($CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 - $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])^(-4) (2 $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]]^2 ($CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]] - 2 $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                $CellContext`x[], 
                $CellContext`y[]]) + $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] ((-2) $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])) + $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]] - 2 $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] (-$CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])) + 2 $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] (-$CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]]))) + 4 $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                $CellContext`x[], 
                $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
               $CellContext`x[], 
               $CellContext`y[]]) + 2 $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]]^2 (2 $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] + 2 $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                 $CellContext`x[], 
                 $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] - 2 $CellContext`T212[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]] - 2 $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                $CellContext`x[], 
                $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]]) + $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]^2 + 4 $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                 $CellContext`x[], 
                 $CellContext`y[]] - 2 $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) - 2 Derivative[1, 1][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]])))^2, {}, 0], 
         xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]], 1]}, {
     Short[
      HoldForm[
       xAct`xTensor`LC[
        RawBoxes[
         xAct`xCoba`Private`CTensorBoxes[
          xAct`xCoba`CTensor[{{
             $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]], 
             $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]]}, {
             $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]], 
             $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 0],
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]]], 1], 
     Short[
      HoldForm[
       xAct`xCoba`CCovD[$CellContext`PDgen, 
        RawBoxes[
         xAct`xCoba`Private`CTensorBoxes[
          xAct`xCoba`CTensor[{{{Rational[-1, 2] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ($CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) (-$CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])}, {Rational[1, 2] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) (-$CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]), Rational[1, 2] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}}, {{Rational[1, 2] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]])), (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]])}, {(2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]), Rational[-1, 2] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ($CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}}}, {$CellContext`gen, \
-$CellContext`gen, -$CellContext`gen}, 0], 
          xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
        RawBoxes[
         xAct`xCoba`Private`CTensorBoxes[
          xAct`xCoba`CTensor[{{
             $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]], 
             $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]]}, {
             $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]], 
             $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 0],
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]]], 1]}, {
     Short[
      HoldForm[
       xAct`xTensor`Ricci[
        xAct`xCoba`CCovD[$CellContext`PDgen, 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{{Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (-$CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (-$CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}}, {{
              Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])}, {(2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]), Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}}}, {$CellContext`gen, \
-$CellContext`gen, -$CellContext`gen}, 0], 
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{
              $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]}, {
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 
            0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]]]], 1], 
     Short[
      HoldForm[
       RawBoxes[
        xAct`xCoba`Private`CTensorBoxes[
         xAct`xCoba`CTensor[{{Rational[1, 4] $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] ($CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]]^2 - $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]])^(-2) ($CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]^2) + $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])) + 2 $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]) + $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - 2 $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]))), Rational[1, 4] $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] ($CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]]^2 - $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]])^(-2) ($CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]^2) + $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])) + 2 $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]) + $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - 2 $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])))}, {Rational[1, 4] $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] ($CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]]^2 - $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]])^(-2) ($CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]^2) + $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])) + 2 $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]) + $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - 2 $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]))), Rational[1, 4] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]] ($CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]]^2 - $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]])^(-2) ($CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]^2) + $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])) + 2 $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]) + $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - 2 $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])))}}, {-$CellContext`gen, \
-$CellContext`gen}, 0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]], 
      1]}, {
     Short[
      HoldForm[
       xAct`xTensor`Ricci[
        xAct`xCoba`CCovD[$CellContext`PDgen, 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{{Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}}, {{
              Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}}}, {$CellContext`gen, \
-$CellContext`gen, -$CellContext`gen}, 0], 
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{
              $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]}, {
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 
            0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]]]], 1], 
     Short[
      HoldForm[
       RawBoxes[
        xAct`xCoba`Private`CTensorBoxes[
         xAct`xCoba`CTensor[{{Rational[1, 4] $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] (-$CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 + $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-1) ((-4) $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                $CellContext`x[], 
                $CellContext`y[]] - 4 $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
               $CellContext`x[], 
               $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
               $CellContext`x[], 
               $CellContext`y[]] - ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
               $CellContext`x[], 
               $CellContext`y[]] (2 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] (2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]])) + 4 $CellContext`T112[
                $CellContext`x[], 
                $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]]) + 2 ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]])) ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] + 
               Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) + ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])) ((-2) $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`T212[
                 $CellContext`x[], 
                 $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]) + 4 $CellContext`T212[
                $CellContext`x[], 
                $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]) + ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] ((-2) $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] - $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])) + 4 $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                $CellContext`x[], 
                $CellContext`y[]] + 4 $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                $CellContext`x[], 
                $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
               $CellContext`x[], 
               $CellContext`y[]]), Rational[1, 4] $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] ($CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]]^2 - $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]])^(-1) (4 $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                $CellContext`x[], 
                $CellContext`y[]] + 4 $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                $CellContext`x[], 
                $CellContext`y[]] + 2 Derivative[0, 2][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] + ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]] (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]])) + 4 $CellContext`T112[
                $CellContext`x[], 
                $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]]) + ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] (2 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])) + ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])) (2 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] + 2 $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]]) + 4 $CellContext`T212[
                $CellContext`x[], 
                $CellContext`y[]] (Derivative[0, 1][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]]) - 2 ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]] + 2 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 $CellContext`T212[
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]])) ($CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`T212[
                 $CellContext`x[], 
                 $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]] + 
              Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]) - 4 $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
               $CellContext`x[], 
               $CellContext`y[]] - 4 $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
               $CellContext`x[], 
               $CellContext`y[]] - 4 Derivative[1, 1][$CellContext`gxy][
               $CellContext`x[], 
               $CellContext`y[]] + 2 Derivative[2, 0][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]])}, {Rational[-1, 4] $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] ($CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]]^2 - $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]])^(-1) ((-4) $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                $CellContext`x[], 
                $CellContext`y[]] - 4 $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
               $CellContext`x[], 
               $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
               $CellContext`x[], 
               $CellContext`y[]] - ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
               $CellContext`x[], 
               $CellContext`y[]] (2 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] (2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]])) + 4 $CellContext`T112[
                $CellContext`x[], 
                $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]]) + 2 ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]])) ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] + 
               Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) + ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])) ((-2) $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`T212[
                 $CellContext`x[], 
                 $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]) + 4 $CellContext`T212[
                $CellContext`x[], 
                $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]) + ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] ((-2) $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] - $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])) + 4 $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                $CellContext`x[], 
                $CellContext`y[]] + 4 $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                $CellContext`x[], 
                $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
               $CellContext`x[], 
               $CellContext`y[]]), Rational[-1, 4] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]] (-$CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 + $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-1) (4 $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                $CellContext`x[], 
                $CellContext`y[]] + 4 $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                $CellContext`x[], 
                $CellContext`y[]] + 2 Derivative[0, 2][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] + ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]] (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]])) + 4 $CellContext`T112[
                $CellContext`x[], 
                $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]]) + ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] (2 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])) + ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])) (2 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] + 2 $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]]) + 4 $CellContext`T212[
                $CellContext`x[], 
                $CellContext`y[]] (Derivative[0, 1][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]]) - 2 ($CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]] + 2 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 $CellContext`T212[
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]])) ($CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`T212[
                 $CellContext`x[], 
                 $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]] + 
              Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]) - 4 $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
               $CellContext`x[], 
               $CellContext`y[]] - 4 $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
               $CellContext`x[], 
               $CellContext`y[]] - 4 Derivative[1, 1][$CellContext`gxy][
               $CellContext`x[], 
               $CellContext`y[]] + 2 Derivative[2, 0][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]])}}, {-$CellContext`gen, -$CellContext`gen}, 
          0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]], 1]}, {
     Short[
      HoldForm[
       xAct`xTensor`RicciScalar[
        xAct`xCoba`CCovD[$CellContext`PDgen, 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{{Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (-$CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (-$CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}}, {{
              Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])}, {(2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]), Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}}}, {$CellContext`gen, \
-$CellContext`gen, -$CellContext`gen}, 0], 
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{
              $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]}, {
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 
            0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]]]], 1], 
     Short[
      HoldForm[
       RawBoxes[
        xAct`xCoba`Private`CTensorBoxes[
         xAct`xCoba`CTensor[Rational[1, 2] ($CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 - $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])^(-2) ($CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
               $CellContext`x[], 
               $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
               $CellContext`x[], 
               $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]]^2) + $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
               $CellContext`x[], 
               $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]])) + 2 $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
               $CellContext`x[], 
               $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
               $CellContext`x[], 
               $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
               $CellContext`x[], 
               $CellContext`y[]]) + $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]) - 2 $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]]))), {}, 0], 
         xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]], 1]}, {
     Short[
      HoldForm[
       xAct`xTensor`RicciScalar[
        xAct`xCoba`CCovD[$CellContext`PDgen, 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{{Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}}, {{
              Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}}}, {$CellContext`gen, \
-$CellContext`gen, -$CellContext`gen}, 0], 
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{
              $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]}, {
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 
            0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]]]], 1], 
     Short[
      HoldForm[
       RawBoxes[
        xAct`xCoba`Private`CTensorBoxes[
         xAct`xCoba`CTensor[Rational[1, 2] ($CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 - $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]])^(-2) (2 $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]]^2 ($CellContext`T112[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]] - 2 $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
               $CellContext`x[], 
               $CellContext`y[]]) + $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] ((-2) $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                 $CellContext`x[], 
                 $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]])) + $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
               $CellContext`x[], 
               $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
               $CellContext`x[], 
               $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
               $CellContext`x[], 
               $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
               $CellContext`x[], 
               $CellContext`y[]] - 2 $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]] (-$CellContext`T212[
                 $CellContext`x[], 
                 $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]] + $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])) + 2 $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] (-$CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                 $CellContext`x[], 
                 $CellContext`y[]]))) + 4 $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
               $CellContext`x[], 
               $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
              $CellContext`x[], 
              $CellContext`y[]]) + 2 $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]^2 (2 $CellContext`T112[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] + 2 $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                $CellContext`x[], 
                $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
               $CellContext`x[], 
               $CellContext`y[]] - 2 $CellContext`T212[
               $CellContext`x[], 
               $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
               $CellContext`x[], 
               $CellContext`y[]] - 2 $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
               $CellContext`x[], 
               $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
               $CellContext`x[], 
               $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
               $CellContext`x[], 
               $CellContext`y[]]) + $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
               $CellContext`x[], 
               $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
               $CellContext`x[], 
               $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]]^2 + 4 $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                $CellContext`x[], 
                $CellContext`y[]] - 2 $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                $CellContext`x[], 
                $CellContext`y[]] + $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]]) + $CellContext`T212[
                 $CellContext`x[], 
                 $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                 $CellContext`x[], 
                 $CellContext`y[]]) - 2 Derivative[1, 1][$CellContext`gxy][
                $CellContext`x[], 
                $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                $CellContext`x[], 
                $CellContext`y[]]))), {}, 0], 
         xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]], 1]}, {
     Short[
      HoldForm[
       xAct`xTensor`Riemann[
        xAct`xCoba`CCovD[$CellContext`PDgen, 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{{Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (-$CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (-$CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}}, {{
              Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])}, {(2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]), Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}}}, {$CellContext`gen, \
-$CellContext`gen, -$CellContext`gen}, 0], 
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{
              $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]}, {
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 
            0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]]]], 1], 
     Short[
      HoldForm[
       RawBoxes[
        xAct`xCoba`Private`CTensorBoxes[
         xAct`xCoba`CTensor[{{{{0, 0}, {0, 
            0}}, {{Rational[-1, 4] $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) ($CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), Rational[1, 4] $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) ($CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])))}, {Rational[-1, 4] $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) ($CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), Rational[1, 4] $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) ($CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])))}}}, {{{
             Rational[1, 4] $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) ($CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), Rational[1, 4] $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) (-$CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (-Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 2 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) - $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])))}, {Rational[1, 4] $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) ($CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), Rational[-1, 4] $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) ($CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])))}}, {{0, 0}, {0, 
            0}}}}, {-$CellContext`gen, -$CellContext`gen, -$CellContext`gen, \
$CellContext`gen}, 0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]], 
      1]}, {
     Short[
      HoldForm[
       xAct`xTensor`Riemann[
        xAct`xCoba`CCovD[$CellContext`PDgen, 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{{Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}}, {{
              Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}}}, {$CellContext`gen, \
-$CellContext`gen, -$CellContext`gen}, 0], 
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{
              $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]}, {
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 
            0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]]]], 1], 
     Short[
      HoldForm[
       RawBoxes[
        xAct`xCoba`Private`CTensorBoxes[
         xAct`xCoba`CTensor[{{{{0, 0}, {0, 
            0}}, {{Rational[-1, 4] $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]]) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                  Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), Rational[1, 4] $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]]) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                  Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])))}, {Rational[-1, 4] $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]]) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                  Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), Rational[1, 4] $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]]) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                  Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])))}}}, {{{
             Rational[1, 4] $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]]) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                  Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), Rational[-1, 4] $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]]) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                  Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])))}, {Rational[1, 4] $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]]) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                  Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), Rational[-1, 4] $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]]) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                  Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])))}}, {{0, 0}, {0, 
            0}}}}, {-$CellContext`gen, -$CellContext`gen, -$CellContext`gen, \
$CellContext`gen}, 0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]], 
      1]}, {
     Short[
      HoldForm[
       xAct`xTensor`RiemannDown[
        xAct`xCoba`CCovD[$CellContext`PDgen, 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{{Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}}, {{
              Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}}}, {$CellContext`gen, \
-$CellContext`gen, -$CellContext`gen}, 0], 
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{
              $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]}, {
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 
            0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]]]], 1], 
     Short[
      HoldForm[
       RawBoxes[
        xAct`xCoba`Private`CTensorBoxes[
         xAct`xCoba`CTensor[{{{{0, 0}, {0, 
            0}}, {{0, Rational[1, 4] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ($CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 4 Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) - 4 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                 $CellContext`x[], 
                 $CellContext`y[]]) - 2 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 (2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])))}, {Rational[1, 4] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]]) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                  Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), 0}}}, {{{
             0, Rational[1, 4] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]]) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                  Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])))}, {Rational[1, 4] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-1) ($CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 4 Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) - 4 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                 $CellContext`x[], 
                 $CellContext`y[]]) - 2 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 (2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) - $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))), 0}}, {{0, 0}, {0, 
            0}}}}, {-$CellContext`gen, -$CellContext`gen, -$CellContext`gen, \
-$CellContext`gen}, 0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]], 
      1]}, {
     Short[
      HoldForm[
       xAct`xTensor`TensorDerivative[
        RawBoxes[
         xAct`xCoba`Private`CTensorBoxes[
          xAct`xCoba`CTensor[{{
             $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]], 
             $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]]}, {
             $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]], 
             $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 0],
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
        xAct`xCoba`CCovD[$CellContext`PDgen, 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{{Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (-$CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (-$CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}}, {{
              Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])}, {(2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]), Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}}}, {$CellContext`gen, \
-$CellContext`gen, -$CellContext`gen}, 0], 
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{
              $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]}, {
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 
            0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]]]], 1], 
     Short[
      HoldForm[xAct`xTensor`Zero], 1]}, {
     Short[
      HoldForm[
       xAct`xTensor`TensorDerivative[
        RawBoxes[
         xAct`xCoba`Private`CTensorBoxes[
          xAct`xCoba`CTensor[{{
             $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[]], 
             $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]]}, {
             $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[]], 
             $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 0],
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
        xAct`xCoba`CCovD[$CellContext`PDgen, 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{{Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}}, {{
              Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}}}, {$CellContext`gen, \
-$CellContext`gen, -$CellContext`gen}, 0], 
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{
              $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]}, {
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 
            0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]]]], 1], 
     Short[
      HoldForm[xAct`xTensor`Zero], 1]}, {
     Short[
      HoldForm[
       xAct`xTensor`TensorDerivative[
        RawBoxes[
         xAct`xCoba`Private`CTensorBoxes[
          
          xAct`xCoba`CTensor[{{{{0, 0}, {0, 
             0}}, {{0, Rational[1, 4] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) - 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]]) - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                  Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])))}, {Rational[1, 4] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                   Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), 0}}}, {{{
              0, Rational[1, 4] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                   Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])))}, {Rational[1, 4] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) - 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]]) - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                  Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), 0}}, {{0, 0}, {0, 
             0}}}}, {-$CellContext`gen, -$CellContext`gen, -$CellContext`gen, \
-$CellContext`gen}, 0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
        xAct`xCoba`CCovD[$CellContext`PDgen, 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{{Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}}, {{
              Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}}}, {$CellContext`gen, \
-$CellContext`gen, -$CellContext`gen}, 0], 
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{
              $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]}, {
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 
            0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]]]], 1], 
     Short[
      HoldForm[
       RawBoxes[
        xAct`xCoba`Private`CTensorBoxes[
         xAct`xCoba`CTensor[{{{{{0, 0}, {0, 0}}, {{0, 0}, {0, 
            0}}}, {{{0, 0}, {
              Rational[1, 4] ((-4) Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 4 Derivative[0, 1][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) (-$CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 
                4 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] + 
                4 (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + 
                4 (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) Derivative[1, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) Derivative[1, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 1][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 1][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 2][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] (-Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                   Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                  Rational[-1, 2] Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] (-Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) - $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[2, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[2, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 Derivative[2, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[3, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]), 
               Rational[1, 4] ((-4) Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] - 4 Derivative[0, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 2][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 2][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[0, 3][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 2][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 
                4 Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + 
                4 Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] (4 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] (-Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                  Rational[-1, 2] Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] (-Derivative[0, 2][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 Derivative[1, 2][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                   Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                   Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - 2 Derivative[2, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])}}, {{
              Rational[1, 4] (4 Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) (-$CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 4 
                Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]]) Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) Derivative[1, 0][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) Derivative[1, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) Derivative[1, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 Derivative[1, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 4 $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] (-Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                   Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + 
                 Rational[-1, 2] Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - 4 $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] (-Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 4 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[2, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[2, 0][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 Derivative[2, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + 2 Derivative[3, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]), 
               Rational[1, 4] (4 Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 2][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 2][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 Derivative[0, 3][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 2][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 4 
                Derivative[0, 1][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) - 4 Derivative[0, 1][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 2][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 4 Derivative[0, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] (4 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 4 $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] (-Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + 
                 Rational[-1, 2] Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - 4 $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] (-Derivative[0, 2][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 4 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 1][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 1][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 Derivative[1, 2][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 
                2 Derivative[2, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])}, {0, 0}}}}, {{{{0, 0}, {
              Rational[1, 4] (4 Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) (-$CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 4 
                Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]]) Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) Derivative[1, 0][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) Derivative[1, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) Derivative[1, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 Derivative[1, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 4 $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] (-Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                   Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + 
                 Rational[-1, 2] Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - 4 $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] (-Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 4 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[2, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[2, 0][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 Derivative[2, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + 2 Derivative[3, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]), 
               Rational[1, 4] (4 Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 2][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 2][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 Derivative[0, 3][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 2][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 4 
                Derivative[0, 1][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) - 4 Derivative[0, 1][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 2][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 4 Derivative[0, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] (4 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 4 $CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[]] (-Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + 
                 Rational[-1, 2] Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - 4 $CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[]] (-Derivative[0, 2][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 4 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 1][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 1][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 Derivative[1, 2][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 
                2 Derivative[2, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])}}, {{
              Rational[1, 4] ((-4) Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 4 Derivative[0, 1][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) (-$CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 
                4 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] + 
                4 (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + 
                4 (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) Derivative[1, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) Derivative[1, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 1][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[1, 1][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[1, 2][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[2, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] (-Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                    Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                   Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                  Rational[-1, 2] Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] (-Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) - $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[2, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[2, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 Derivative[2, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[3, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]), 
               Rational[1, 4] ((-4) Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] - 4 Derivative[0, 1][$CellContext`gxy][
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 2][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]] - 4 $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 2][$CellContext`T212][
                  $CellContext`x[], 
                  $CellContext`y[]] - 2 Derivative[0, 3][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 2][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 
                4 Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-2) ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + 
                4 Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] (4 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] (-Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]]) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                  Rational[-1, 2] Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] (-Derivative[0, 2][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) - Derivative[0, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] + 4 Derivative[1, 2][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                   Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-4) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] - 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 2 ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + 
                   Rational[-1, 2] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + 4 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (-Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]])^(-1) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) - 2 Derivative[2, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]])}, {0, 0}}}, {{{0, 0}, {0, 0}}, {{0, 0}, {
            0, 0}}}}}, {-$CellContext`gen, -$CellContext`gen, \
-$CellContext`gen, -$CellContext`gen, -$CellContext`gen}, 0], 
         xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]], 1]}, {
     Short[
      HoldForm[
       xAct`xCoba`ToCTensorOneSlot[
        RawBoxes[
         xAct`xCoba`Private`CTensorBoxes[
          
          xAct`xCoba`CTensor[{{{{0, 0}, {0, 
             0}}, {{Rational[-1, 4] $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                   Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), Rational[1, 4] $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                   Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])))}, {Rational[-1, 4] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                   Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), Rational[1, 4] $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                   Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])))}}}, {{{
              Rational[1, 4] $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                   Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), Rational[-1, 4] $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                   Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])))}, {Rational[1, 4] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                   Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), Rational[-1, 4] $CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) 
                   Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                   Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])))}}, {{0, 0}, {0, 
             0}}}}, {-$CellContext`gen, -$CellContext`gen, -$CellContext`gen, \
$CellContext`gen}, 0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], {3, 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{$CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]]/(-$CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 + $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]]), $CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]]/($CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]]^2 - $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]])}, {$CellContext`gxy[
                $CellContext`x[], 
                $CellContext`y[]]/($CellContext`gxy[
                 $CellContext`x[], 
                 $CellContext`y[]]^2 - $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]] $CellContext`gyy[
                $CellContext`x[], 
                $CellContext`y[]]), $CellContext`gxx[
                $CellContext`x[], 
                $CellContext`y[]]/(-$CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]]^2 + $CellContext`gxx[
                 $CellContext`x[], 
                 $CellContext`y[]] $CellContext`gyy[
                 $CellContext`x[], 
                 $CellContext`y[]])}}, {$CellContext`gen, $CellContext`gen}, 
            0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]}]], 1], 
     Short[
      HoldForm[
       RawBoxes[
        xAct`xCoba`Private`CTensorBoxes[
         xAct`xCoba`CTensor[{{{{0, 0}, {0, 
            0}}, {{0, Rational[1, 4] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]]) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                  Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])))}, {
             Rational[-1, 4] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]]) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                  Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), 0}}}, {{{
             0, Rational[-1, 4] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]]) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                  Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])))}, {Rational[1, 4] ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]])^(-2) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + $CellContext`gxy[
                  $CellContext`x[], 
                  $CellContext`y[]] ((-2) Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 4 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (-$CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])) + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]]))) + 4 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^3 (Derivative[0, 1][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - Derivative[1, 0][$CellContext`T112][
                  $CellContext`x[], 
                  $CellContext`y[]]) + 2 $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]]^2 (2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`T112][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 2][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`T212][
                   $CellContext`x[], 
                   $CellContext`y[]] - 2 Derivative[1, 1][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]) + $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxy][
                   $CellContext`x[], 
                   $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]^2 + 4 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 Derivative[1, 0][$CellContext`T212][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 2][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] + $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] (2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) - 2 
                  Derivative[1, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[2, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))), 0}}, {{0, 0}, {0, 
            0}}}}, {-$CellContext`gen, -$CellContext`gen, $CellContext`gen, \
$CellContext`gen}, 0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]], 
      1]}, {
     Short[
      HoldForm[
       xAct`xTensor`Torsion[
        xAct`xCoba`CCovD[$CellContext`PDgen, 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{{Rational[-1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T212[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gyy[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[]]))}}, {{
              Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[1, 0][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]] - 2 Derivative[1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + Derivative[0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[]]) + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}, {Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) ($CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] Derivative[0, 1][$CellContext`gxx][
                   $CellContext`x[], 
                   $CellContext`y[]] + $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]])), Rational[1, 2] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[]] $CellContext`gyy[
                   $CellContext`x[], 
                   $CellContext`y[]])^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[]]^2 $CellContext`T112[
                   $CellContext`x[], 
                   $CellContext`y[]] - $CellContext`gxx[
                  $CellContext`x[], 
                  $CellContext`y[]] Derivative[0, 1][$CellContext`gyy][
                  $CellContext`x[], 
                  $CellContext`y[]] + $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[]] + 2 Derivative[0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[]] - Derivative[1, 0][$CellContext`gyy][
                   $CellContext`x[], 
                   $CellContext`y[]]))}}}, {$CellContext`gen, \
-$CellContext`gen, -$CellContext`gen}, 0], 
           xAct`xCoba`Private`$xCobaCacheLargeComponentSize]], 
         RawBoxes[
          xAct`xCoba`Private`CTensorBoxes[
           xAct`xCoba`CTensor[{{
              $CellContext`gxx[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]]}, {
              $CellContext`gxy[
               $CellContext`x[], 
               $CellContext`y[]], 
              $CellContext`gyy[
               $CellContext`x[], 
               $CellContext`y[]]}}, {-$CellContext`gen, -$CellContext`gen}, 
            0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]]]], 1], 
     Short[
      HoldForm[
       RawBoxes[
        xAct`xCoba`Private`CTensorBoxes[
         xAct`xCoba`CTensor[{{{0, 
             $CellContext`T112[
              $CellContext`x[], 
              $CellContext`y[]]}, {-$CellContext`T112[
               $CellContext`x[], 
               $CellContext`y[]], 0}}, {{0, 
             $CellContext`T212[
              $CellContext`x[], 
              $CellContext`y[]]}, {-$CellContext`T212[
               $CellContext`x[], 
               $CellContext`y[]], 
             0}}}, {$CellContext`gen, -$CellContext`gen, -$CellContext`gen}, 
          0], xAct`xCoba`Private`$xCobaCacheLargeComponentSize]]], 1]}}, 
   TableHeadings -> {Automatic, None}]]], "Output",ExpressionUUID->"5ec7d667-\
46c6-4fe5-8ba1-a61ba25dfbe1"]
}, Open  ]],

Cell["Clean up:", "Text",ExpressionUUID->"d05d2b5d-798c-4fb4-b968-c847bb40291d"],

Cell[BoxData[
 RowBox[{"UnsetCMetric", "[", "metric", "]"}]], "Input",ExpressionUUID->"17c77f6e-1056-4dce-84df-54c1687f32b1"],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{
  "metric", ",", "torsion", ",", "cd", ",", "christoffel", ",", "riemann", 
   ",", "riemanndown", ",", "chris", ",", "LCmetric"}], "]"}]], "Input",Expres\
sionUUID->"cbe5241f-5a36-48fe-bdea-b3eda66c3589"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefScalarFunction", "[", "$ScalarFunctions", "]"}], 
  ";"}]], "Input",ExpressionUUID->"8168cebf-6ac0-42bf-973c-26d722ea9d1d"],

Cell[BoxData[
 RowBox[{"UndefChart", "[", "gen", "]"}]], "Input",ExpressionUUID->"04d9a14b-9ce9-431b-b334-4053a9adb674"],

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M", "]"}]], "Input",ExpressionUUID->"e658af7b-b911-44f5-b6fa-befae59e8a23"],

Cell[BoxData[
 RowBox[{"ClearxCobaCache", "[", "All", "]"}]], "Input",ExpressionUUID->"b372d9b5-fe85-4099-995a-f9cce512b965"]
}, Closed]],

Cell[CellGroupData[{

Cell["4.3. General 3d metric connection with torsion", "Subsubsection",ExpressionUUID->"607bdf2e-5276-4f6d-b199-5ca097fea7b5"],

Cell["Now we repeat the same computation in the 3d case.", "Text",ExpressionUUID->"b4b70708-b196-4da8-b1de-8815840ef13a"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<xAct`xCoba`\>\"", "]"}]], "Input",ExpressionUUID->"5e98d7ad-4e48-425f-a7c6-1db94e7268c2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$DefInfoQ", "=", 
   RowBox[{"$UndefInfoQ", "=", "False"}]}], ";"}]], "Input",ExpressionUUID->\
"995727df-2f40-4854-84d3-b23036a395d9"],

Cell["Define a 3d manifold:", "Text",ExpressionUUID->"ed3e69ce-d19a-4223-8ab5-3883a9f4a587"],

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M", ",", "3", ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"841167af-3578-43b3-99e0-762f1db9cc00"],

Cell[BoxData[
 RowBox[{"DefChart", "[", 
  RowBox[{"gen", ",", "M", ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x", "[", "]"}], ",", 
     RowBox[{"y", "[", "]"}], ",", 
     RowBox[{"z", "[", "]"}]}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"7ccd07f6-a545-477d-a184-02a85cff4b0a"],

Cell["Let us work with the general 3d case:", "Text",ExpressionUUID->"55ed7a7d-6f18-4853-854c-838e21d1263d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefScalarFunction", "/@", 
   RowBox[{"{", 
    RowBox[{
    "gxx", ",", "gxy", ",", "gxz", ",", "gyy", ",", "gyz", ",", "gzz"}], 
    "}"}]}], ";"}]], "Input",ExpressionUUID->"84535cce-f26a-4603-8fde-\
512d32e8baae"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"metric", "=", 
    RowBox[{"CTensor", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"gxx", "[", 
           RowBox[{
            RowBox[{"x", "[", "]"}], ",", 
            RowBox[{"y", "[", "]"}], ",", 
            RowBox[{"z", "[", "]"}]}], "]"}], ",", 
          RowBox[{"gxy", "[", 
           RowBox[{
            RowBox[{"x", "[", "]"}], ",", 
            RowBox[{"y", "[", "]"}], ",", 
            RowBox[{"z", "[", "]"}]}], "]"}], ",", 
          RowBox[{"gxz", "[", 
           RowBox[{
            RowBox[{"x", "[", "]"}], ",", 
            RowBox[{"y", "[", "]"}], ",", 
            RowBox[{"z", "[", "]"}]}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"gxy", "[", 
           RowBox[{
            RowBox[{"x", "[", "]"}], ",", 
            RowBox[{"y", "[", "]"}], ",", 
            RowBox[{"z", "[", "]"}]}], "]"}], ",", 
          RowBox[{"gyy", "[", 
           RowBox[{
            RowBox[{"x", "[", "]"}], ",", 
            RowBox[{"y", "[", "]"}], ",", 
            RowBox[{"z", "[", "]"}]}], "]"}], ",", 
          RowBox[{"gyz", "[", 
           RowBox[{
            RowBox[{"x", "[", "]"}], ",", 
            RowBox[{"y", "[", "]"}], ",", 
            RowBox[{"z", "[", "]"}]}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"gxz", "[", 
           RowBox[{
            RowBox[{"x", "[", "]"}], ",", 
            RowBox[{"y", "[", "]"}], ",", 
            RowBox[{"z", "[", "]"}]}], "]"}], ",", 
          RowBox[{"gyz", "[", 
           RowBox[{
            RowBox[{"x", "[", "]"}], ",", 
            RowBox[{"y", "[", "]"}], ",", 
            RowBox[{"z", "[", "]"}]}], "]"}], ",", 
          RowBox[{"gzz", "[", 
           RowBox[{
            RowBox[{"x", "[", "]"}], ",", 
            RowBox[{"y", "[", "]"}], ",", 
            RowBox[{"z", "[", "]"}]}], "]"}]}], "}"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "gen"}], ",", 
        RowBox[{"-", "gen"}]}], "}"}]}], "]"}]}], ")"}], "[", 
  RowBox[{
   RowBox[{"-", "a"}], ",", 
   RowBox[{"-", "b"}]}], "]"}]], "Input",ExpressionUUID->"516662e3-ae66-40fd-\
9b29-9ac13e604741"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox[
            RowBox[{
             InterpretationBox[
              StyleBox["gxx",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxx,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["z",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`z[],
               Editable->False]}], "]"}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                  False], $CellContext`gxx, Editable -> False], "[", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                   "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`x[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                   "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`y[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                   "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`z[], Editable -> False]}], "]"}]}]],
           Annotation[#, {1, 1} -> $CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]], "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{
             InterpretationBox[
              StyleBox["gxy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxy,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["z",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`z[],
               Editable->False]}], "]"}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                  False], $CellContext`gxy, Editable -> False], "[", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                   "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`x[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                   "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`y[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                   "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`z[], Editable -> False]}], "]"}]}]],
           Annotation[#, {1, 2} -> $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]], "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{
             InterpretationBox[
              StyleBox["gxz",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxz,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["z",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`z[],
               Editable->False]}], "]"}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "3"}], "}"}], "\[Rule]", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                  False], $CellContext`gxz, Editable -> False], "[", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                   "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`x[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                   "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`y[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                   "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`z[], Editable -> False]}], "]"}]}]],
           Annotation[#, {1, 3} -> $CellContext`gxz[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]], "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox[
            RowBox[{
             InterpretationBox[
              StyleBox["gxy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxy,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["z",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`z[],
               Editable->False]}], "]"}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                  False], $CellContext`gxy, Editable -> False], "[", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                   "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`x[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                   "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`y[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                   "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`z[], Editable -> False]}], "]"}]}]],
           Annotation[#, {2, 1} -> $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]], "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{
             InterpretationBox[
              StyleBox["gyy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gyy,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["z",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`z[],
               Editable->False]}], "]"}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                  False], $CellContext`gyy, Editable -> False], "[", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                   "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`x[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                   "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`y[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                   "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`z[], Editable -> False]}], "]"}]}]],
           Annotation[#, {2, 2} -> $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]], "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{
             InterpretationBox[
              StyleBox["gyz",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gyz,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["z",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`z[],
               Editable->False]}], "]"}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "3"}], "}"}], "\[Rule]", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                  False], $CellContext`gyz, Editable -> False], "[", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                   "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`x[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                   "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`y[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                   "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`z[], Editable -> False]}], "]"}]}]],
           Annotation[#, {2, 3} -> $CellContext`gyz[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]], "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox[
            RowBox[{
             InterpretationBox[
              StyleBox["gxz",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gxz,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["z",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`z[],
               Editable->False]}], "]"}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "1"}], "}"}], "\[Rule]", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                  False], $CellContext`gxz, Editable -> False], "[", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                   "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`x[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                   "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`y[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                   "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`z[], Editable -> False]}], "]"}]}]],
           Annotation[#, {3, 1} -> $CellContext`gxz[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]], "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{
             InterpretationBox[
              StyleBox["gyz",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gyz,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["z",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`z[],
               Editable->False]}], "]"}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "2"}], "}"}], "\[Rule]", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                  False], $CellContext`gyz, Editable -> False], "[", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                   "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`x[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                   "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`y[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                   "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`z[], Editable -> False]}], "]"}]}]],
           Annotation[#, {3, 2} -> $CellContext`gyz[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]], "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{
             InterpretationBox[
              StyleBox["gzz",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`gzz,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["y",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`y[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["z",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`z[],
               Editable->False]}], "]"}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "3"}], "}"}], "\[Rule]", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                  False], $CellContext`gzz, Editable -> False], "[", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                   "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`x[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                   "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`y[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                   "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`z[], Editable -> False]}], "]"}]}]],
           Annotation[#, {3, 3} -> $CellContext`gzz[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]], "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 4 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 4 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {" ", " "},
         {"a", "b"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{
     $CellContext`gxx[
      $CellContext`x[], 
      $CellContext`y[], 
      $CellContext`z[]], 
     $CellContext`gxy[
      $CellContext`x[], 
      $CellContext`y[], 
      $CellContext`z[]], 
     $CellContext`gxz[
      $CellContext`x[], 
      $CellContext`y[], 
      $CellContext`z[]]}, {
     $CellContext`gxy[
      $CellContext`x[], 
      $CellContext`y[], 
      $CellContext`z[]], 
     $CellContext`gyy[
      $CellContext`x[], 
      $CellContext`y[], 
      $CellContext`z[]], 
     $CellContext`gyz[
      $CellContext`x[], 
      $CellContext`y[], 
      $CellContext`z[]]}, {
     $CellContext`gxz[
      $CellContext`x[], 
      $CellContext`y[], 
      $CellContext`z[]], 
     $CellContext`gyz[
      $CellContext`x[], 
      $CellContext`y[], 
      $CellContext`z[]], 
     $CellContext`gzz[
      $CellContext`x[], 
      $CellContext`y[], 
      $CellContext`z[]]}}, {-$CellContext`gen, -$CellContext`gen}, 
   0][-$CellContext`a, -$CellContext`b],
  Editable->False]], "Output",ExpressionUUID->"35059ab4-8d5e-4832-976f-\
f665cdef440b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SymmetryGroupOfTensor", "[", "metric", "]"}]], "Input",ExpressionUUID->"a4041dfc-b025-4111-a813-878d2f7bd99a"],

Cell[BoxData[
 RowBox[{"StrongGenSet", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"GenSet", "[", 
    InterpretationBox[
     StyleBox[
      RowBox[{"(", "1", ",", "2", ")"}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xPerm`Cycles[{1, 2}],
     Editable->False], "]"}]}], "]"}]], "Output",ExpressionUUID->"6956baed-\
f234-4a4a-b047-8eda708f5a87"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefScalarFunction", "/@", 
   RowBox[{"{", 
    RowBox[{
    "T112", ",", "T113", ",", "T123", ",", "T212", ",", "T213", ",", "T223", 
     ",", "T312", ",", "T313", ",", "T323"}], "}"}]}], ";"}]], "Input",Express\
ionUUID->"4b6b69c1-d17b-421e-9b7f-54b5c3059bf7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"torsion", "=", 
    RowBox[{"CTensor", "[", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", 
            RowBox[{"T112", "[", 
             RowBox[{
              RowBox[{"x", "[", "]"}], ",", 
              RowBox[{"y", "[", "]"}], ",", 
              RowBox[{"z", "[", "]"}]}], "]"}], ",", 
            RowBox[{"T113", "[", 
             RowBox[{
              RowBox[{"x", "[", "]"}], ",", 
              RowBox[{"y", "[", "]"}], ",", 
              RowBox[{"z", "[", "]"}]}], "]"}]}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", 
             RowBox[{"T112", "[", 
              RowBox[{
               RowBox[{"x", "[", "]"}], ",", 
               RowBox[{"y", "[", "]"}], ",", 
               RowBox[{"z", "[", "]"}]}], "]"}]}], ",", "0", ",", 
            RowBox[{"T123", "[", 
             RowBox[{
              RowBox[{"x", "[", "]"}], ",", 
              RowBox[{"y", "[", "]"}], ",", 
              RowBox[{"z", "[", "]"}]}], "]"}]}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", 
             RowBox[{"T113", "[", 
              RowBox[{
               RowBox[{"x", "[", "]"}], ",", 
               RowBox[{"y", "[", "]"}], ",", 
               RowBox[{"z", "[", "]"}]}], "]"}]}], ",", 
            RowBox[{"-", 
             RowBox[{"T123", "[", 
              RowBox[{
               RowBox[{"x", "[", "]"}], ",", 
               RowBox[{"y", "[", "]"}], ",", 
               RowBox[{"z", "[", "]"}]}], "]"}]}], ",", "0"}], "}"}]}], 
         "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", 
            RowBox[{"T212", "[", 
             RowBox[{
              RowBox[{"x", "[", "]"}], ",", 
              RowBox[{"y", "[", "]"}], ",", 
              RowBox[{"z", "[", "]"}]}], "]"}], ",", 
            RowBox[{"T213", "[", 
             RowBox[{
              RowBox[{"x", "[", "]"}], ",", 
              RowBox[{"y", "[", "]"}], ",", 
              RowBox[{"z", "[", "]"}]}], "]"}]}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", 
             RowBox[{"T212", "[", 
              RowBox[{
               RowBox[{"x", "[", "]"}], ",", 
               RowBox[{"y", "[", "]"}], ",", 
               RowBox[{"z", "[", "]"}]}], "]"}]}], ",", "0", ",", 
            RowBox[{"T223", "[", 
             RowBox[{
              RowBox[{"x", "[", "]"}], ",", 
              RowBox[{"y", "[", "]"}], ",", 
              RowBox[{"z", "[", "]"}]}], "]"}]}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", 
             RowBox[{"T213", "[", 
              RowBox[{
               RowBox[{"x", "[", "]"}], ",", 
               RowBox[{"y", "[", "]"}], ",", 
               RowBox[{"z", "[", "]"}]}], "]"}]}], ",", 
            RowBox[{"-", 
             RowBox[{"T223", "[", 
              RowBox[{
               RowBox[{"x", "[", "]"}], ",", 
               RowBox[{"y", "[", "]"}], ",", 
               RowBox[{"z", "[", "]"}]}], "]"}]}], ",", "0"}], "}"}]}], 
         "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", 
            RowBox[{"T312", "[", 
             RowBox[{
              RowBox[{"x", "[", "]"}], ",", 
              RowBox[{"y", "[", "]"}], ",", 
              RowBox[{"z", "[", "]"}]}], "]"}], ",", 
            RowBox[{"T313", "[", 
             RowBox[{
              RowBox[{"x", "[", "]"}], ",", 
              RowBox[{"y", "[", "]"}], ",", 
              RowBox[{"z", "[", "]"}]}], "]"}]}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", 
             RowBox[{"T312", "[", 
              RowBox[{
               RowBox[{"x", "[", "]"}], ",", 
               RowBox[{"y", "[", "]"}], ",", 
               RowBox[{"z", "[", "]"}]}], "]"}]}], ",", "0", ",", 
            RowBox[{"T323", "[", 
             RowBox[{
              RowBox[{"x", "[", "]"}], ",", 
              RowBox[{"y", "[", "]"}], ",", 
              RowBox[{"z", "[", "]"}]}], "]"}]}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", 
             RowBox[{"T313", "[", 
              RowBox[{
               RowBox[{"x", "[", "]"}], ",", 
               RowBox[{"y", "[", "]"}], ",", 
               RowBox[{"z", "[", "]"}]}], "]"}]}], ",", 
            RowBox[{"-", 
             RowBox[{"T323", "[", 
              RowBox[{
               RowBox[{"x", "[", "]"}], ",", 
               RowBox[{"y", "[", "]"}], ",", 
               RowBox[{"z", "[", "]"}]}], "]"}]}], ",", "0"}], "}"}]}], 
         "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"gen", ",", 
        RowBox[{"-", "gen"}], ",", 
        RowBox[{"-", "gen"}]}], "}"}]}], "]"}]}], ")"}], "[", 
  RowBox[{"a", ",", 
   RowBox[{"-", "b"}], ",", 
   RowBox[{"-", "c"}]}], "]"}]], "Input",ExpressionUUID->"3e3bd4cc-b938-402a-\
bb2f-2e163d0d8549"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["T112",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`T112,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["z",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`z[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 1, 2} -> $CellContext`T112[
                 $CellContext`x[], 
                 $CellContext`y[], 
                 $CellContext`z[]], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["T113",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`T113,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["z",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`z[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "3"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 1, 3} -> $CellContext`T113[
                 $CellContext`x[], 
                 $CellContext`y[], 
                 $CellContext`z[]], "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["T112",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`T112,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["z",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`z[],
                   Editable->False]}], "]"}]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{"-", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}]],
              Annotation[#, {1, 2, 1} -> -$CellContext`T112[
                  $CellContext`x[], 
                  $CellContext`y[], 
                  $CellContext`z[]], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 2} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["T123",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`T123,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["z",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`z[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "3"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]],
              Annotation[#, {1, 2, 3} -> $CellContext`T123[
                 $CellContext`x[], 
                 $CellContext`y[], 
                 $CellContext`z[]], "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["T113",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`T113,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["z",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`z[],
                   Editable->False]}], "]"}]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{"-", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}]],
              Annotation[#, {1, 3, 1} -> -$CellContext`T113[
                  $CellContext`x[], 
                  $CellContext`y[], 
                  $CellContext`z[]], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["T123",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`T123,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["z",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`z[],
                   Editable->False]}], "]"}]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{"-", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}]],
              Annotation[#, {1, 3, 2} -> -$CellContext`T123[
                  $CellContext`x[], 
                  $CellContext`y[], 
                  $CellContext`z[]], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "3"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 3} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 1} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["T212",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`T212,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["z",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`z[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 1, 2} -> $CellContext`T212[
                 $CellContext`x[], 
                 $CellContext`y[], 
                 $CellContext`z[]], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["T213",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`T213,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["z",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`z[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "3"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 1, 3} -> $CellContext`T213[
                 $CellContext`x[], 
                 $CellContext`y[], 
                 $CellContext`z[]], "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["T212",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`T212,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["z",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`z[],
                   Editable->False]}], "]"}]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{"-", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}]],
              Annotation[#, {2, 2, 1} -> -$CellContext`T212[
                  $CellContext`x[], 
                  $CellContext`y[], 
                  $CellContext`z[]], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 2} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["T223",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`T223,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["z",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`z[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "3"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]],
              Annotation[#, {2, 2, 3} -> $CellContext`T223[
                 $CellContext`x[], 
                 $CellContext`y[], 
                 $CellContext`z[]], "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["T213",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`T213,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["z",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`z[],
                   Editable->False]}], "]"}]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{"-", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}]],
              Annotation[#, {2, 3, 1} -> -$CellContext`T213[
                  $CellContext`x[], 
                  $CellContext`y[], 
                  $CellContext`z[]], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["T223",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`T223,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["z",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`z[],
                   Editable->False]}], "]"}]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{"-", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}]],
              Annotation[#, {2, 3, 2} -> -$CellContext`T223[
                  $CellContext`x[], 
                  $CellContext`y[], 
                  $CellContext`z[]], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "3"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 3} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "1"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 1} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["T312",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`T312,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["z",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`z[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]],
              Annotation[#, {3, 1, 2} -> $CellContext`T312[
                 $CellContext`x[], 
                 $CellContext`y[], 
                 $CellContext`z[]], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["T313",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`T313,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["z",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`z[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "3"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]],
              Annotation[#, {3, 1, 3} -> $CellContext`T313[
                 $CellContext`x[], 
                 $CellContext`y[], 
                 $CellContext`z[]], "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["T312",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`T312,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["z",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`z[],
                   Editable->False]}], "]"}]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{"-", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}]],
              Annotation[#, {3, 2, 1} -> -$CellContext`T312[
                  $CellContext`x[], 
                  $CellContext`y[], 
                  $CellContext`z[]], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "2"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 2} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["T323",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`T323,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["y",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`y[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["z",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`z[],
                  Editable->False]}], "]"}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "3"}], "}"}], "\[Rule]", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]],
              Annotation[#, {3, 2, 3} -> $CellContext`T323[
                 $CellContext`x[], 
                 $CellContext`y[], 
                 $CellContext`z[]], "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["T313",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`T313,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["z",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`z[],
                   Editable->False]}], "]"}]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "1"}], "}"}], "\[Rule]", 
                 RowBox[{"-", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}]],
              Annotation[#, {3, 3, 1} -> -$CellContext`T313[
                  $CellContext`x[], 
                  $CellContext`y[], 
                  $CellContext`z[]], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["T323",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`T323,
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["y",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`y[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["z",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`z[],
                   Editable->False]}], "]"}]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "2"}], "}"}], "\[Rule]", 
                 RowBox[{"-", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}]],
              Annotation[#, {3, 3, 2} -> -$CellContext`T323[
                  $CellContext`x[], 
                  $CellContext`y[], 
                  $CellContext`z[]], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "3"}], "}"}], "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 3} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 4 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 4 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {"a", " ", " "},
         {" ", "b", "c"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{{0, 
      $CellContext`T112[
       $CellContext`x[], 
       $CellContext`y[], 
       $CellContext`z[]], 
      $CellContext`T113[
       $CellContext`x[], 
       $CellContext`y[], 
       $CellContext`z[]]}, {-$CellContext`T112[
        $CellContext`x[], 
        $CellContext`y[], 
        $CellContext`z[]], 0, 
      $CellContext`T123[
       $CellContext`x[], 
       $CellContext`y[], 
       $CellContext`z[]]}, {-$CellContext`T113[
        $CellContext`x[], 
        $CellContext`y[], 
        $CellContext`z[]], -$CellContext`T123[
        $CellContext`x[], 
        $CellContext`y[], 
        $CellContext`z[]], 0}}, {{0, 
      $CellContext`T212[
       $CellContext`x[], 
       $CellContext`y[], 
       $CellContext`z[]], 
      $CellContext`T213[
       $CellContext`x[], 
       $CellContext`y[], 
       $CellContext`z[]]}, {-$CellContext`T212[
        $CellContext`x[], 
        $CellContext`y[], 
        $CellContext`z[]], 0, 
      $CellContext`T223[
       $CellContext`x[], 
       $CellContext`y[], 
       $CellContext`z[]]}, {-$CellContext`T213[
        $CellContext`x[], 
        $CellContext`y[], 
        $CellContext`z[]], -$CellContext`T223[
        $CellContext`x[], 
        $CellContext`y[], 
        $CellContext`z[]], 0}}, {{0, 
      $CellContext`T312[
       $CellContext`x[], 
       $CellContext`y[], 
       $CellContext`z[]], 
      $CellContext`T313[
       $CellContext`x[], 
       $CellContext`y[], 
       $CellContext`z[]]}, {-$CellContext`T312[
        $CellContext`x[], 
        $CellContext`y[], 
        $CellContext`z[]], 0, 
      $CellContext`T323[
       $CellContext`x[], 
       $CellContext`y[], 
       $CellContext`z[]]}, {-$CellContext`T313[
        $CellContext`x[], 
        $CellContext`y[], 
        $CellContext`z[]], -$CellContext`T323[
        $CellContext`x[], 
        $CellContext`y[], 
        $CellContext`z[]], 
      0}}}, {$CellContext`gen, -$CellContext`gen, -$CellContext`gen}, 
   0][$CellContext`a, -$CellContext`b, -$CellContext`c],
  Editable->False]], "Output",ExpressionUUID->"89afe602-34f3-4435-8625-\
0edb6df939d3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SymmetryGroupOfTensor", "[", "torsion", "]"}]], "Input",ExpressionUU\
ID->"4dcaa335-b77b-4c7c-be0a-925791f69a65"],

Cell[BoxData[
 RowBox[{"StrongGenSet", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", "3"}], "}"}], ",", 
   RowBox[{"GenSet", "[", 
    InterpretationBox[
     StyleBox[
      RowBox[{"-", 
       RowBox[{"(", "2", ",", "3", ")"}]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     -xAct`xPerm`Cycles[{2, 3}],
     Editable->False], "]"}]}], "]"}]], "Output",ExpressionUUID->"8531d67c-\
6da0-4cbc-88ba-0972b1ec7ad1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"SetCMetric", "[", 
   RowBox[{"metric", ",", "torsion", ",", "gen"}], "]"}], "//", 
  "Timing"}]], "Input",ExpressionUUID->"5fa0d359-1698-4c09-9f64-84aee48c07a5"],

Cell[BoxData[
 TemplateBox[{
  "SignatureOfMetric","num",
   "\"Cannot determine signature of matrix \\!\\(\\*RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \
RowBox[{RowBox[{InterpretationBox[StyleBox[RowBox[{\\\"gxx\\\"}], \
Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], gxx, Rule[Editable, \
False]], \\\"[\\\", RowBox[{InterpretationBox[StyleBox[\\\"x\\\", \
Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], x[], Rule[Editable, \
False]], \\\",\\\", InterpretationBox[StyleBox[\\\"y\\\", Rule[AutoSpacing, \
False], Rule[ShowAutoStyles, False]], y[], Rule[Editable, False]], \\\",\\\", \
InterpretationBox[StyleBox[\\\"z\\\", Rule[AutoSpacing, False], \
Rule[ShowAutoStyles, False]], z[], Rule[Editable, False]]}], \\\"]\\\"}], \
\\\",\\\", RowBox[{InterpretationBox[StyleBox[RowBox[{\\\"gxy\\\"}], \
Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], gxy, Rule[Editable, \
False]], \\\"[\\\", RowBox[{InterpretationBox[StyleBox[\\\"x\\\", \
Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], x[], Rule[Editable, \
False]], \\\",\\\", InterpretationBox[StyleBox[\\\"y\\\", Rule[AutoSpacing, \
False], Rule[ShowAutoStyles, False]], y[], Rule[Editable, False]], \\\",\\\", \
InterpretationBox[StyleBox[\\\"z\\\", Rule[AutoSpacing, False], \
Rule[ShowAutoStyles, False]], z[], Rule[Editable, False]]}], \\\"]\\\"}], \
\\\",\\\", RowBox[{InterpretationBox[StyleBox[RowBox[{\\\"gxz\\\"}], \
Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], gxz, Rule[Editable, \
False]], \\\"[\\\", RowBox[{InterpretationBox[StyleBox[\\\"x\\\", \
Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], x[], Rule[Editable, \
False]], \\\",\\\", InterpretationBox[StyleBox[\\\"y\\\", Rule[AutoSpacing, \
False], Rule[ShowAutoStyles, False]], y[], Rule[Editable, False]], \\\",\\\", \
InterpretationBox[StyleBox[\\\"z\\\", Rule[AutoSpacing, False], \
Rule[ShowAutoStyles, False]], z[], Rule[Editable, False]]}], \\\"]\\\"}]}], \
\\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \
RowBox[{RowBox[{InterpretationBox[StyleBox[RowBox[{\\\"gxy\\\"}], \
Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], gxy, Rule[Editable, \
False]], \\\"[\\\", RowBox[{InterpretationBox[StyleBox[\\\"x\\\", \
Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], x[], Rule[Editable, \
False]], \\\",\\\", InterpretationBox[StyleBox[\\\"y\\\", Rule[AutoSpacing, \
False], Rule[ShowAutoStyles, False]], y[], Rule[Editable, False]], \\\",\\\", \
InterpretationBox[StyleBox[\\\"z\\\", Rule[AutoSpacing, False], \
Rule[ShowAutoStyles, False]], z[], Rule[Editable, False]]}], \\\"]\\\"}], \
\\\",\\\", RowBox[{InterpretationBox[StyleBox[RowBox[{\\\"gyy\\\"}], \
Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], gyy, Rule[Editable, \
False]], \\\"[\\\", RowBox[{InterpretationBox[StyleBox[\\\"x\\\", \
Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], x[], Rule[Editable, \
False]], \\\",\\\", InterpretationBox[StyleBox[\\\"y\\\", Rule[AutoSpacing, \
False], Rule[ShowAutoStyles, False]], y[], Rule[Editable, False]], \\\",\\\", \
InterpretationBox[StyleBox[\\\"z\\\", Rule[AutoSpacing, False], \
Rule[ShowAutoStyles, False]], z[], Rule[Editable, False]]}], \\\"]\\\"}], \
\\\",\\\", RowBox[{InterpretationBox[StyleBox[RowBox[{\\\"gyz\\\"}], \
Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], gyz, Rule[Editable, \
False]], \\\"[\\\", RowBox[{InterpretationBox[StyleBox[\\\"x\\\", \
Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], x[], Rule[Editable, \
False]], \\\",\\\", InterpretationBox[StyleBox[\\\"y\\\", Rule[AutoSpacing, \
False], Rule[ShowAutoStyles, False]], y[], Rule[Editable, False]], \\\",\\\", \
InterpretationBox[StyleBox[\\\"z\\\", Rule[AutoSpacing, False], \
Rule[ShowAutoStyles, False]], z[], Rule[Editable, False]]}], \\\"]\\\"}]}], \
\\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \
RowBox[{RowBox[{InterpretationBox[StyleBox[RowBox[{\\\"gxz\\\"}], \
Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], gxz, Rule[Editable, \
False]], \\\"[\\\", RowBox[{InterpretationBox[StyleBox[\\\"x\\\", \
Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], x[], Rule[Editable, \
False]], \\\",\\\", InterpretationBox[StyleBox[\\\"y\\\", Rule[AutoSpacing, \
False], Rule[ShowAutoStyles, False]], y[], Rule[Editable, False]], \\\",\\\", \
InterpretationBox[StyleBox[\\\"z\\\", Rule[AutoSpacing, False], \
Rule[ShowAutoStyles, False]], z[], Rule[Editable, False]]}], \\\"]\\\"}], \
\\\",\\\", RowBox[{InterpretationBox[StyleBox[RowBox[{\\\"gyz\\\"}], \
Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], gyz, Rule[Editable, \
False]], \\\"[\\\", RowBox[{InterpretationBox[StyleBox[\\\"x\\\", \
Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], x[], Rule[Editable, \
False]], \\\",\\\", InterpretationBox[StyleBox[\\\"y\\\", Rule[AutoSpacing, \
False], Rule[ShowAutoStyles, False]], y[], Rule[Editable, False]], \\\",\\\", \
InterpretationBox[StyleBox[\\\"z\\\", Rule[AutoSpacing, False], \
Rule[ShowAutoStyles, False]], z[], Rule[Editable, False]]}], \\\"]\\\"}], \
\\\",\\\", RowBox[{InterpretationBox[StyleBox[RowBox[{\\\"gzz\\\"}], \
Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], gzz, Rule[Editable, \
False]], \\\"[\\\", RowBox[{InterpretationBox[StyleBox[\\\"x\\\", \
Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], x[], Rule[Editable, \
False]], \\\",\\\", InterpretationBox[StyleBox[\\\"y\\\", Rule[AutoSpacing, \
False], Rule[ShowAutoStyles, False]], y[], Rule[Editable, False]], \\\",\\\", \
InterpretationBox[StyleBox[\\\"z\\\", Rule[AutoSpacing, False], \
Rule[ShowAutoStyles, False]], z[], Rule[Editable, False]]}], \\\"]\\\"}]}], \
\\\"}\\\"}]}], \\\"}\\\"}]\\). Assuming Euclidean signature.\"",2,313,7,
   19248039995900841960,"Local","xAct`xTensor`SignatureOfMetric"},
  "MessageTemplate2"]], "Message", \
"MSG",ExpressionUUID->"30b7da91-ae36-43e8-8d0b-5a6f6835da28"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"4.671373`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"c3096f7b-e28e-4798-9e0a-f57d55ff494a"]
}, Open  ]],

Cell["\<\
This is now the covariant derivative associated to the metric:\
\>", "Text",ExpressionUUID->"60cc07da-6e57-4472-ab13-8db0c74b8eaa"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"cd", "=", 
     RowBox[{"CovDOfMetric", "[", "metric", "]"}]}], ";"}], ")"}], "//", 
  "Timing"}]], "Input",ExpressionUUID->"a7823ee5-00a0-433c-913e-23610568c43f"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.000176`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"fe001018-5587-4f3f-9c77-e0c3f6e2df22"]
}, Open  ]],

Cell["It has the torsion we provided:", "Text",ExpressionUUID->"47ad045b-1239-43a4-ac9c-bbddea175bfa"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Torsion", "[", "cd", "]"}], "===", "torsion"}]], "Input",Expression\
UUID->"032faee1-8e6e-4863-9744-b740b7800f4b"],

Cell[BoxData["True"], "Output",ExpressionUUID->"db44f576-4aaf-459d-b3a6-6315e5557ac0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"christoffel", "=", 
    RowBox[{"Christoffel", "[", 
     RowBox[{"cd", ",", "PDgen"}], "]"}]}], ")"}], "[", 
  RowBox[{"a", ",", 
   RowBox[{"-", "b"}], ",", 
   RowBox[{"-", "c"}]}], "]"}]], "Input",ExpressionUUID->"1b230da9-2ce3-42ce-\
8609-4c6bf391487b"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {GridBox[{
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}]]}]],
              Annotation[#, {1, 1, 1} -> Rational[1, 2] ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]))^(-1) (($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) Derivative[1, 0, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T312[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                   Derivative[0, 1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 
                   Derivative[1, 0, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) - ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T213[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T313[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                  Derivative[0, 0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 
                  Derivative[1, 0, 0][$CellContext`gxz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]])), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}]]}]],
              Annotation[#, {1, 1, 2} -> Rational[1, 2] ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]))^(-1) (($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T312[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                   Derivative[0, 1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + (-$CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) Derivative[1, 0, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) (-$CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T213[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T312[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T313[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) - Derivative[0, 0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                   Derivative[0, 1, 0][$CellContext`gxz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                   Derivative[1, 0, 0][$CellContext`gyz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]])), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "3"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}]]}]],
              Annotation[#, {1, 1, 3} -> Rational[1, 2] ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]))^(-1) (($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T213[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T313[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                   Derivative[0, 0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + (-$CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T213[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) - $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T312[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T313[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                   0, 1, 0][$CellContext`gxz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                   Derivative[1, 0, 0][$CellContext`gyz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) Derivative[1, 0, 0][$CellContext`gzz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]), "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}]]}]],
              Annotation[#, {1, 2, 1} -> Rational[1, 2] ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]))^(-1) (($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) Derivative[0, 1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T312[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                   1, 0, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) - ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T213[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T312[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T313[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                  0, 1, 0][$CellContext`gxz][
                   $CellContext`x[], 
                   $CellContext`y[], 
                   $CellContext`z[]] - Derivative[1, 0, 0][$CellContext`gyz][
                   $CellContext`x[], 
                   $CellContext`y[], 
                   $CellContext`z[]])), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}]]}]],
              Annotation[#, {1, 2, 2} -> Rational[1, 2] ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]))^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 ($CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + 2 $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] Derivative[0, 1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                    Derivative[0, 0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 
                    Derivative[0, 1, 0][$CellContext`gyz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]])) + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (2 $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`T312[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] Derivative[0, 1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (2 Derivative[0, 1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                    1, 0, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]])) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (2 $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T312[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) - $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (Derivative[0, 0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 
                    Derivative[0, 1, 0][$CellContext`gyz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ((-2) 
                    Derivative[0, 1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                    Derivative[1, 0, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]))), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "3"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}]]}]],
              Annotation[#, {1, 2, 3} -> Rational[1, 2] ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]))^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 ($CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (-$CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                    0, 1, 0][$CellContext`gzz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]])) + $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) - $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                    Derivative[0, 0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (-$CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + Derivative[0, 1, 0][$CellContext`gzz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]])) + ($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T213[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T312[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T313[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                   Derivative[0, 1, 0][$CellContext`gxz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                   1, 0, 0][$CellContext`gyz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]])), "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "1"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}]]}]],
              Annotation[#, {1, 3, 1} -> Rational[1, 2] ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]))^(-1) (($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) Derivative[0, 0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + (-$CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T213[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (-$CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) - $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T312[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T313[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                   0, 1, 0][$CellContext`gxz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                   Derivative[1, 0, 0][$CellContext`gyz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) ((-2) $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T213[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T313[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                   Derivative[1, 0, 0][$CellContext`gzz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]])), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "2"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}]]}]],
              Annotation[#, {1, 3, 2} -> Rational[1, 2] ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]))^(-1) ((-2) $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 ($CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (-$CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                    0, 1, 0][$CellContext`gzz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]])) + $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                    0, 0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (-$CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + Derivative[0, 1, 0][$CellContext`gzz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]])) + ($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) (-$CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T213[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T312[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T313[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                   Derivative[0, 1, 0][$CellContext`gxz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                   1, 0, 0][$CellContext`gyz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]])), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "3"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}]]}]],
              Annotation[#, {1, 3, 3} -> Rational[1, 2] ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]))^(-1) ((-2) $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^3 $CellContext`T213[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gyz[
                   $CellContext`x[], 
                   $CellContext`y[], 
                   $CellContext`z[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T213[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ((-2) $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                    Derivative[0, 0, 1][$CellContext`gzz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]])) + $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 ($CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ((-2) $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                    Derivative[0, 0, 1][$CellContext`gzz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ((-2) $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 
                    Derivative[0, 0, 1][$CellContext`gyz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                    Derivative[0, 1, 0][$CellContext`gzz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]])) + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 (2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T313[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                   2 Derivative[0, 0, 1][$CellContext`gxz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                   1, 0, 0][$CellContext`gzz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                    2 Derivative[0, 0, 1][$CellContext`gyz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                    0, 1, 0][$CellContext`gzz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ((-2) $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T313[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 
                    Derivative[0, 0, 1][$CellContext`gxz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                    Derivative[1, 0, 0][$CellContext`gzz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]))), "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
         {GridBox[{
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}]]}]],
              Annotation[#, {2, 1, 1} -> Rational[1, 2] ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]))^(-1) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 ($CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T213[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gxz[
                   $CellContext`x[], 
                   $CellContext`y[], 
                   $CellContext`z[]] (2 $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`T312[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] Derivative[1, 0, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (Derivative[0, 1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 
                    Derivative[1, 0, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ((-2) $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 ($CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`T313[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] Derivative[1, 0, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (Derivative[0, 0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 
                    Derivative[1, 0, 0][$CellContext`gxz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]])) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ((-2) $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T213[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + 2 $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T312[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T313[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) - $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] Derivative[0, 0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] Derivative[0, 1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] Derivative[1, 0, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] Derivative[1, 0, 0][$CellContext`gxz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]])), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}]]}]],
              Annotation[#, {2, 1, 2} -> Rational[1, 2] ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]))^(-1) (-($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T312[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                   Derivative[0, 1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) Derivative[1, 0, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + (-$CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) (-$CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T213[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T312[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T313[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) - Derivative[0, 0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                   Derivative[0, 1, 0][$CellContext`gxz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                   Derivative[1, 0, 0][$CellContext`gyz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]])), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "3"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}]]}]],
              Annotation[#, {2, 1, 3} -> Rational[1, 2] ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]))^(-1) (-($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T213[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T313[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                   Derivative[0, 0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T213[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) - $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T312[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T313[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                   0, 1, 0][$CellContext`gxz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                   Derivative[1, 0, 0][$CellContext`gyz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + (-$CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) Derivative[1, 0, 0][$CellContext`gzz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]), "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}]]}]],
              Annotation[#, {2, 2, 1} -> Rational[1, 2] ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]))^(-1) ((-$CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) Derivative[0, 1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T312[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                   Derivative[1, 0, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T213[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T312[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T313[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                   0, 1, 0][$CellContext`gxz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                   1, 0, 0][$CellContext`gyz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]])), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}]]}]],
              Annotation[#, {2, 2, 2} -> Rational[1, 2] ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]))^(-1) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 ($CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 
                  Derivative[0, 1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[], 
                   $CellContext`z[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] Derivative[0, 1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (Derivative[0, 0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 
                    Derivative[0, 1, 0][$CellContext`gyz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 
                    Derivative[0, 1, 0][$CellContext`gyz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T312[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                    2 Derivative[0, 1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                    1, 0, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]])) + $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T312[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 
                   Derivative[0, 1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                   Derivative[1, 0, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]])), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "3"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}]]}]],
              Annotation[#, {2, 2, 3} -> Rational[1, 2] ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]))^(-1) (($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                   Derivative[0, 0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + (-$CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) Derivative[0, 1, 0][$CellContext`gzz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + (-$CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T213[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T312[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T313[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                   Derivative[0, 1, 0][$CellContext`gxz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                   1, 0, 0][$CellContext`gyz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]])), "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "1"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}]]}]],
              Annotation[#, {2, 3, 1} -> Rational[1, 2] ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]))^(-1) ((-$CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) Derivative[0, 0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T213[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (-$CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) - $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T312[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T313[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                   0, 1, 0][$CellContext`gxz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                   Derivative[1, 0, 0][$CellContext`gyz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) (2 $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T213[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T313[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                   1, 0, 0][$CellContext`gzz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]])), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "2"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"3", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}]]}]],
              Annotation[#, {2, 3, 2} -> Rational[1, 2] ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]))^(-1) ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) - $CellContext`gxx[
                   $CellContext`x[], 
                   $CellContext`y[], 
                   $CellContext`z[]] (2 $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] Derivative[0, 0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                    0, 1, 0][$CellContext`gzz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]])) + $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (-$CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 3 $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) - Derivative[0, 1, 0][$CellContext`gzz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) - $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T213[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T312[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T313[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                    Derivative[0, 1, 0][$CellContext`gxz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                    1, 0, 0][$CellContext`gyz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (-$CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T213[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T312[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T313[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                   Derivative[0, 1, 0][$CellContext`gxz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                   1, 0, 0][$CellContext`gyz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]])), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "3"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}]]}]],
              Annotation[#, {2, 3, 3} -> Rational[1, 2] ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]))^(-1) (2 $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^3 $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 ((-2) $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + 2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                   2 Derivative[0, 0, 1][$CellContext`gyz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                   0, 1, 0][$CellContext`gzz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ((-2) $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                    Derivative[0, 0, 1][$CellContext`gzz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ((-2) $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 
                    Derivative[0, 0, 1][$CellContext`gyz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                    Derivative[0, 1, 0][$CellContext`gzz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (2 $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T213[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T313[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                   2 Derivative[0, 0, 1][$CellContext`gxz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                   1, 0, 0][$CellContext`gzz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ((-2) $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                    0, 0, 1][$CellContext`gzz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ((-2) $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T213[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T313[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 
                    Derivative[0, 0, 1][$CellContext`gxz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                    Derivative[1, 0, 0][$CellContext`gzz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]))), "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]},
         {GridBox[{
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}]]}]],
              Annotation[#, {3, 1, 1} -> Rational[1, 2] ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]))^(-1) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 ((-2) $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^3 $CellContext`T213[
                   $CellContext`x[], 
                   $CellContext`y[], 
                   $CellContext`z[]] + $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] Derivative[1, 0, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (2 $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`T312[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] Derivative[1, 0, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (Derivative[0, 1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 
                    Derivative[1, 0, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 (2 $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`T313[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) - Derivative[0, 0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                   2 Derivative[1, 0, 0][$CellContext`gxz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T213[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ((-2) $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T312[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T313[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] Derivative[0, 0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] Derivative[0, 1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] Derivative[1, 0, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] Derivative[1, 0, 0][$CellContext`gxz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]])), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "2"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}]]}]],
              Annotation[#, {3, 1, 2} -> Rational[1, 2] ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]))^(-1) (($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T312[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                   Derivative[0, 1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + (-$CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) Derivative[1, 0, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) (-$CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T213[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T312[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T313[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) - Derivative[0, 0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                   Derivative[0, 1, 0][$CellContext`gxz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                   Derivative[1, 0, 0][$CellContext`gyz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]])), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "3"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}]]}]],
              Annotation[#, {3, 1, 3} -> Rational[1, 2] ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]))^(-1) (($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T213[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T313[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                   Derivative[0, 0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + (-$CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T213[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) - $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T312[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T313[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                   0, 1, 0][$CellContext`gxz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                   Derivative[1, 0, 0][$CellContext`gyz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) Derivative[1, 0, 0][$CellContext`gzz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]), "Tooltip"]& ]}
           },
           AutoDelete->False,
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "1"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}]]}]],
              Annotation[#, {3, 2, 1} -> Rational[1, 2] ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]))^(-1) (($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) Derivative[0, 1, 0][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) (2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T312[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                   1, 0, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) - ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T213[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T312[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T313[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                  0, 1, 0][$CellContext`gxz][
                   $CellContext`x[], 
                   $CellContext`y[], 
                   $CellContext`z[]] - Derivative[1, 0, 0][$CellContext`gyz][
                   $CellContext`x[], 
                   $CellContext`y[], 
                   $CellContext`z[]])), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "2"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}]]}]],
              Annotation[#, {3, 2, 2} -> Rational[1, 2] ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]))^(-1) ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^3 $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] Derivative[0, 1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (2 $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                    Derivative[0, 0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 
                    Derivative[0, 1, 0][$CellContext`gyz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]])) - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 
                  Derivative[0, 1, 0][$CellContext`gyz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T312[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                   2 Derivative[0, 1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                   1, 0, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                    0, 1, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ((-2) $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T312[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 
                    Derivative[0, 1, 0][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                    Derivative[1, 0, 0][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]))), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "3"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{"3", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}]]}]],
              Annotation[#, {3, 2, 3} -> Rational[1, 2] ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]))^(-1) ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (2 $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                    Derivative[0, 0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (2 $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                    0, 1, 0][$CellContext`gzz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 (-$CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + Derivative[0, 1, 0][$CellContext`gzz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (-$CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 3 $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T213[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T312[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T313[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                    Derivative[0, 1, 0][$CellContext`gxz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                    1, 0, 0][$CellContext`gyz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]])) - $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[], 
                   $CellContext`z[]] $CellContext`gyz[
                   $CellContext`x[], 
                   $CellContext`y[], 
                   $CellContext`z[]] (-$CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T213[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T312[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T313[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                  Derivative[0, 1, 0][$CellContext`gxz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                  1, 0, 0][$CellContext`gyz][
                   $CellContext`x[], 
                   $CellContext`y[], 
                   $CellContext`z[]])), "Tooltip"]& ]}
           },
           AutoDelete->False,
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "1"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}]]}]],
              Annotation[#, {3, 3, 1} -> Rational[1, 2] ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]))^(-1) (($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) Derivative[0, 0, 1][$CellContext`gxx][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + (-$CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T213[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (-$CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) - $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T312[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T313[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (-$CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                   0, 1, 0][$CellContext`gxz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                   Derivative[1, 0, 0][$CellContext`gyz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + ($CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) ((-2) $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T213[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T313[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                   Derivative[1, 0, 0][$CellContext`gzz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]])), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "2"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T112"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T112, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T312"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T312, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T212"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T212, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["y", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}]]}]],
              Annotation[#, {3, 3, 2} -> Rational[1, 2] ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]))^(-1) ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] Derivative[0, 0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (2 $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                    0, 1, 0][$CellContext`gzz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]])) - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 ($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + 2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                  0, 1, 0][$CellContext`gzz][
                   $CellContext`x[], 
                   $CellContext`y[], 
                   $CellContext`z[]]) + $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ((-2) $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (-$CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T112[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gyy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T213[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T312[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T313[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                    Derivative[0, 1, 0][$CellContext`gxz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                    1, 0, 0][$CellContext`gyz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]])) - $CellContext`gxy[
                   $CellContext`x[], 
                   $CellContext`y[], 
                   $CellContext`z[]] $CellContext`gyz[
                   $CellContext`x[], 
                   $CellContext`y[], 
                   $CellContext`z[]] (-$CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T213[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T312[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T212[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T313[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gxy][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                  Derivative[0, 1, 0][$CellContext`gxz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                  1, 0, 0][$CellContext`gyz][
                   $CellContext`x[], 
                   $CellContext`y[], 
                   $CellContext`z[]])), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "3"}], "}"}], "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T123"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T123, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T113"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T113, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T223"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T223, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T323"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T323, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T213"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T213, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"T313"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`T313, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                  RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gxx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gxx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gyy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gyy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"gzz"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`gzz, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "y", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`y[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}]]}]],
              Annotation[#, {3, 3, 3} -> Rational[1, 2] ($CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]))^(-1) (2 $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 ($CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 
                  Derivative[0, 0, 1][$CellContext`gzz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (2 $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]^2 $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] Derivative[0, 0, 1][$CellContext`gzz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                    2 Derivative[0, 0, 1][$CellContext`gyz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                    0, 1, 0][$CellContext`gzz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]])) + $CellContext`gxz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (2 $CellContext`gxx[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T123[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ((-2) $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ($CellContext`T113[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + $CellContext`T223[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) - 2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T323[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 
                    Derivative[0, 0, 1][$CellContext`gyz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                    Derivative[0, 1, 0][$CellContext`gzz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]]) + $CellContext`gyy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] (2 $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T213[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T313[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                    2 Derivative[0, 0, 1][$CellContext`gxz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - Derivative[
                    1, 0, 0][$CellContext`gzz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]])) + $CellContext`gxy[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] ((-2) $CellContext`gyz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T213[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 $CellContext`gzz[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] $CellContext`T313[
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] - 2 
                   Derivative[0, 0, 1][$CellContext`gxz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]] + 
                   Derivative[1, 0, 0][$CellContext`gzz][
                    $CellContext`x[], 
                    $CellContext`y[], 
                    $CellContext`z[]])), "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 4 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 4 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {"a", " ", " "},
         {" ", "b", "c"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{{Rational[1, 2] ($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - 2 $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gxz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gyz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 - $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]))^(-1) (($CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 - $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) Derivative[1, 0, 0][$CellContext`gxx][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + ($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - $CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) (2 $CellContext`gxx[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T112[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + 2 $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T212[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + 2 $CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T312[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + Derivative[0, 1, 0][$CellContext`gxx][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - 2 Derivative[1, 0, 0][$CellContext`gxy][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) - ($CellContext`gxz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gyz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]]) (2 $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T113[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + 2 $CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T213[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + 2 $CellContext`gxz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T313[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + Derivative[0, 0, 1][$CellContext`gxx][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] - 2 Derivative[1, 0, 0][$CellContext`gxz][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]])), Rational[1, 2] ($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - 2 $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gxz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gyz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 - $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]))^(-1) (($CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 - $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) (2 $CellContext`gxx[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T112[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + 2 $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T212[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + 2 $CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T312[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + Derivative[0, 1, 0][$CellContext`gxx][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) + (-$CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) Derivative[1, 0, 0][$CellContext`gyy][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + ($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - $CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) (-$CellContext`gxx[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T123[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T212[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T213[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - $CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`T113[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`T223[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) + $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T312[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T313[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] ($CellContext`T112[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] - $CellContext`T323[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) - Derivative[0, 0, 1][$CellContext`gxy][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + Derivative[0, 1, 0][$CellContext`gxz][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + Derivative[1, 0, 0][$CellContext`gyz][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]])), Rational[1, 2] ($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - 2 $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gxz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gyz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 - $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]))^(-1) (($CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 - $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) (2 $CellContext`gxx[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T113[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + 2 $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T213[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + 2 $CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T313[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + Derivative[0, 0, 1][$CellContext`gxx][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) + (-$CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) ($CellContext`gxx[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T123[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T212[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T213[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] ($CellContext`T113[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] + $CellContext`T223[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]) - $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T312[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T313[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] (-$CellContext`T112[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] + $CellContext`T323[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gxy][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - Derivative[0, 1, 0][$CellContext`gxz][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + Derivative[1, 0, 0][$CellContext`gyz][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) + ($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - $CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) Derivative[1, 0, 0][$CellContext`gzz][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]])}, {Rational[1, 2] ($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - 2 $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gxz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gyz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 - $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]))^(-1) (($CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 - $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) Derivative[0, 1, 0][$CellContext`gxx][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + ($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - $CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) (2 $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T112[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + 2 $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T212[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + 2 $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T312[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - Derivative[1, 0, 0][$CellContext`gyy][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]]) - ($CellContext`gxz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gyz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]]) ($CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T123[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T212[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T213[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`T113[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`T223[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) + $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T312[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T313[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`T112[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`T323[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gxy][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] - Derivative[0, 1, 0][$CellContext`gxz][
         $CellContext`x[], 
         $CellContext`y[], 
         $CellContext`z[]] - Derivative[1, 0, 0][$CellContext`gyz][
         $CellContext`x[], 
         $CellContext`y[], 
         $CellContext`z[]])), Rational[1, 2] ($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - 2 $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gxz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gyz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 - $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]))^(-1) (2 $CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]^2 $CellContext`gyz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`T123[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] - 2 $CellContext`gyy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]]^2 ($CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T212[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T223[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) + $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] ((-2) $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] ($CellContext`gzz[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T112[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] + $CellContext`gxz[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T123[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]]) + 2 $CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 ($CellContext`T112[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] + $CellContext`T323[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]) + $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] Derivative[0, 1, 0][$CellContext`gyy][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] (2 $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T223[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] + Derivative[0, 0, 1][$CellContext`gyy][
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] - 2 Derivative[0, 1, 0][$CellContext`gyz][
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]])) + $CellContext`gyz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] (2 $CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 $CellContext`T312[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - $CellContext`gxz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] Derivative[0, 1, 0][$CellContext`gyy][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] (2 Derivative[0, 1, 0][$CellContext`gxy][
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] - Derivative[1, 0, 0][$CellContext`gyy][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]])) + $CellContext`gyy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] (2 $CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 $CellContext`T212[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - 2 $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`gzz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] $CellContext`T312[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] + $CellContext`gxz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] $CellContext`T323[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]) - $CellContext`gxz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] (Derivative[0, 0, 1][$CellContext`gyy][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - 2 Derivative[0, 1, 0][$CellContext`gyz][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) + $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] ((-2) Derivative[0, 1, 0][$CellContext`gxy][
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] + Derivative[1, 0, 0][$CellContext`gyy][
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]))), Rational[1, 2] ($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - 2 $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gxz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gyz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 - $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]))^(-1) (2 $CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]^2 $CellContext`gzz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`T123[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] ($CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 ($CellContext`T113[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] + $CellContext`T223[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]) + $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] ($CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] (-$CellContext`T113[
                $CellContext`x[], 
                $CellContext`y[], 
                $CellContext`z[]] + $CellContext`T223[
               $CellContext`x[], 
               $CellContext`y[], 
               $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gyy][
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]) + $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] (2 $CellContext`gzz[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T323[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] - Derivative[0, 1, 0][$CellContext`gzz][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]])) + $CellContext`gxz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] ($CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 ($CellContext`T112[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] - $CellContext`T323[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) - $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] (2 $CellContext`gxy[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] $CellContext`T123[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] + 2 $CellContext`gyy[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] $CellContext`T223[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] + Derivative[0, 0, 1][$CellContext`gyy][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) + $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] (-$CellContext`gzz[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] ($CellContext`T112[
               $CellContext`x[], 
               $CellContext`y[], 
               $CellContext`z[]] + $CellContext`T323[
               $CellContext`x[], 
               $CellContext`y[], 
               $CellContext`z[]]) + Derivative[0, 1, 0][$CellContext`gzz][
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]])) + ($CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 - $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) ($CellContext`gxx[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T123[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T213[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T312[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] ($CellContext`T212[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] + $CellContext`T313[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gxy][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + Derivative[0, 1, 0][$CellContext`gxz][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - Derivative[1, 0, 0][$CellContext`gyz][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]]))}, {Rational[1, 2] ($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - 2 $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gxz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gyz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 - $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]))^(-1) (($CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 - $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) Derivative[0, 0, 1][$CellContext`gxx][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + (-$CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) ($CellContext`gxx[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T123[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T212[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T213[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] (-$CellContext`T113[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] + $CellContext`T223[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]) - $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T312[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T313[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] (-$CellContext`T112[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] + $CellContext`T323[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gxy][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - Derivative[0, 1, 0][$CellContext`gxz][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + Derivative[1, 0, 0][$CellContext`gyz][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) + ($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - $CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) ((-2) $CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T113[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - 2 $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T213[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - 2 $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T313[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + Derivative[1, 0, 0][$CellContext`gzz][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]])), Rational[1, 2] ($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - 2 $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gxz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gyz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 - $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]))^(-1) ((-2) $CellContext`gxz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]^2 $CellContext`gyy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`T123[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] ($CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 ($CellContext`T113[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] + $CellContext`T223[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]) + $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] ($CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] (-$CellContext`T113[
                $CellContext`x[], 
                $CellContext`y[], 
                $CellContext`z[]] + $CellContext`T223[
               $CellContext`x[], 
               $CellContext`y[], 
               $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gyy][
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]) + $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] (2 $CellContext`gzz[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T323[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] - Derivative[0, 1, 0][$CellContext`gzz][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]])) + $CellContext`gxz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] ($CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 ($CellContext`T112[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] - $CellContext`T323[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) + $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] (2 $CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T123[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] - 2 $CellContext`gyy[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] $CellContext`T223[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] - Derivative[0, 0, 1][$CellContext`gyy][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) + $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] (-$CellContext`gzz[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] ($CellContext`T112[
               $CellContext`x[], 
               $CellContext`y[], 
               $CellContext`z[]] + $CellContext`T323[
               $CellContext`x[], 
               $CellContext`y[], 
               $CellContext`z[]]) + Derivative[0, 1, 0][$CellContext`gzz][
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]])) + ($CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 - $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) (-$CellContext`gxx[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T123[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T213[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T312[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] ($CellContext`T212[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] + $CellContext`T313[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gxy][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + Derivative[0, 1, 0][$CellContext`gxz][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - Derivative[1, 0, 0][$CellContext`gyz][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]])), Rational[1, 2] ($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - 2 $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gxz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gyz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 - $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]))^(-1) ((-2) $CellContext`gxz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]^2 $CellContext`gyz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`T123[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + 2 $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]^3 $CellContext`T213[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] - $CellContext`gyz[
         $CellContext`x[], 
         $CellContext`y[], 
         $CellContext`z[]] (2 $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T213[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ((-2) $CellContext`gzz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] $CellContext`T223[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] + Derivative[0, 0, 1][$CellContext`gzz][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]])) + $CellContext`gxz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] (2 $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T123[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + 2 $CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 ($CellContext`T113[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] - $CellContext`T223[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) + $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] ((-2) $CellContext`gzz[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T113[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] + Derivative[0, 0, 1][$CellContext`gzz][
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]) + $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] ((-2) $CellContext`gzz[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T323[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] - 2 Derivative[0, 0, 1][$CellContext`gyz][
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] + Derivative[0, 1, 0][$CellContext`gzz][
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]])) + $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]^2 (2 $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T313[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + 2 Derivative[0, 0, 1][$CellContext`gxz][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - Derivative[1, 0, 0][$CellContext`gzz][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]]) + $CellContext`gzz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] ($CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] (2 $CellContext`gzz[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T323[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] + 2 Derivative[0, 0, 1][$CellContext`gyz][
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] - Derivative[0, 1, 0][$CellContext`gzz][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) + $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] ((-2) $CellContext`gzz[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T313[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] - 2 Derivative[0, 0, 1][$CellContext`gxz][
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] + Derivative[1, 0, 0][$CellContext`gzz][
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]])))}}, {{Rational[1, 2] ($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - 2 $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gxz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gyz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 - $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]))^(-1) (2 $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]^2 ($CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T112[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T113[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) + 2 $CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]^2 $CellContext`gxz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`T213[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] - $CellContext`gxz[
         $CellContext`x[], 
         $CellContext`y[], 
         $CellContext`z[]] (2 $CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`T312[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] Derivative[1, 0, 0][$CellContext`gxx][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] (Derivative[0, 1, 0][$CellContext`gxx][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - 2 Derivative[1, 0, 0][$CellContext`gxy][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]])) + $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] ((-2) $CellContext`gxz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 ($CellContext`T212[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] - $CellContext`T313[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) + $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] Derivative[1, 0, 0][$CellContext`gxx][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] (Derivative[0, 0, 1][$CellContext`gxx][
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] - 2 Derivative[1, 0, 0][$CellContext`gxz][
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]])) + $CellContext`gxx[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] ((-2) $CellContext`gxz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 $CellContext`T112[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + 2 $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] ($CellContext`gzz[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T212[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] - $CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] $CellContext`T213[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]) + 2 $CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] ($CellContext`gxy[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T113[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] + $CellContext`gzz[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T312[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] - $CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] $CellContext`T313[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]) - $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] Derivative[0, 0, 1][$CellContext`gxx][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] Derivative[0, 1, 0][$CellContext`gxx][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - 2 $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] Derivative[1, 0, 0][$CellContext`gxy][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + 2 $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] Derivative[1, 0, 0][$CellContext`gxz][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]])), Rational[1, 2] ($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - 2 $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gxz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gyz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 - $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]))^(-1) (-($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - $CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) (2 $CellContext`gxx[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T112[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + 2 $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T212[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + 2 $CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T312[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + Derivative[0, 1, 0][$CellContext`gxx][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) + ($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 - $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) Derivative[1, 0, 0][$CellContext`gyy][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + (-$CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gxx[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) (-$CellContext`gxx[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T123[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T212[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T213[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - $CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`T113[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`T223[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) + $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T312[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T313[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] ($CellContext`T112[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] - $CellContext`T323[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) - Derivative[0, 0, 1][$CellContext`gxy][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + Derivative[0, 1, 0][$CellContext`gxz][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + Derivative[1, 0, 0][$CellContext`gyz][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]])), Rational[1, 2] ($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - 2 $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gxz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gyz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 - $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]))^(-1) (-($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - $CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) (2 $CellContext`gxx[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T113[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + 2 $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T213[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + 2 $CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T313[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + Derivative[0, 0, 1][$CellContext`gxx][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) + ($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 - $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) ($CellContext`gxx[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T123[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T212[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T213[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] ($CellContext`T113[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] + $CellContext`T223[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]) - $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T312[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T313[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] (-$CellContext`T112[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] + $CellContext`T323[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gxy][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - Derivative[0, 1, 0][$CellContext`gxz][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + Derivative[1, 0, 0][$CellContext`gyz][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) + (-$CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gxx[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) Derivative[1, 0, 0][$CellContext`gzz][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]])}, {Rational[1, 2] ($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - 2 $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gxz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gyz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 - $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]))^(-1) ((-$CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) Derivative[0, 1, 0][$CellContext`gxx][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + ($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 - $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) ((-2) $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T112[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - 2 $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T212[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - 2 $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T312[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + Derivative[1, 0, 0][$CellContext`gyy][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) + ($CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) ($CellContext`gxx[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T123[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T212[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T213[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] ($CellContext`T113[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] + $CellContext`T223[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]) + $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T312[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T313[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] ($CellContext`T112[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] + $CellContext`T323[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gxy][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - Derivative[0, 1, 0][$CellContext`gxz][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] - Derivative[1, 0, 0][$CellContext`gyz][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]])), Rational[1, 2] ($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - 2 $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gxz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gyz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 - $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]))^(-1) (2 $CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]^2 ($CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T112[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T123[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) + $CellContext`gxz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]^2 Derivative[0, 1, 0][$CellContext`gyy][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] - $CellContext`gxx[
         $CellContext`x[], 
         $CellContext`y[], 
         $CellContext`z[]] (2 $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T223[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + 2 $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`T323[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] Derivative[0, 1, 0][$CellContext`gyy][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] (Derivative[0, 0, 1][$CellContext`gyy][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - 2 Derivative[0, 1, 0][$CellContext`gyz][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]])) + $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] ((-2) $CellContext`gxx[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T123[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] (2 $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T223[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] - 2 $CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] ($CellContext`T112[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] - $CellContext`T323[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gyy][
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] - 2 Derivative[0, 1, 0][$CellContext`gyz][
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]) + $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] (2 $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T212[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] + 2 $CellContext`gyz[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T312[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] + 2 Derivative[0, 1, 0][$CellContext`gxy][
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] - Derivative[1, 0, 0][$CellContext`gyy][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]])) + $CellContext`gxz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gyz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] ((-2) $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T212[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - 2 $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T312[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - 2 Derivative[0, 1, 0][$CellContext`gxy][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + Derivative[1, 0, 0][$CellContext`gyy][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]])), Rational[1, 2] ($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - 2 $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gxz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gyz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 - $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]))^(-1) (($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 - $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) (2 $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T123[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + 2 $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T223[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + 2 $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T323[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + Derivative[0, 0, 1][$CellContext`gyy][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) + (-$CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gxx[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) Derivative[0, 1, 0][$CellContext`gzz][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + (-$CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) ($CellContext`gxx[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T123[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T212[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T213[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] ($CellContext`T113[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] + $CellContext`T223[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]) + $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T312[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T313[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] ($CellContext`T112[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] + $CellContext`T323[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gxy][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + Derivative[0, 1, 0][$CellContext`gxz][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - Derivative[1, 0, 0][$CellContext`gyz][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]]))}, {Rational[1, 2] ($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - 2 $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gxz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gyz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 - $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]))^(-1) ((-$CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) Derivative[0, 0, 1][$CellContext`gxx][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + ($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 - $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) ($CellContext`gxx[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T123[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T212[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T213[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] (-$CellContext`T113[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] + $CellContext`T223[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]) - $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T312[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T313[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] (-$CellContext`T112[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] + $CellContext`T323[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gxy][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - Derivative[0, 1, 0][$CellContext`gxz][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + Derivative[1, 0, 0][$CellContext`gyz][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) + ($CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) (2 $CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T113[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + 2 $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T213[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + 2 $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T313[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - Derivative[1, 0, 0][$CellContext`gzz][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]])), Rational[1, 2] ($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - 2 $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gxz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gyz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 - $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]))^(-1) ($CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]^2 $CellContext`gzz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] ($CellContext`T113[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - $CellContext`T223[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]]) + $CellContext`gxz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]^2 (2 $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T123[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] (-$CellContext`T112[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] + $CellContext`T323[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gyy][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) - $CellContext`gxx[
         $CellContext`x[], 
         $CellContext`y[], 
         $CellContext`z[]] (2 $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`T223[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] Derivative[0, 0, 1][$CellContext`gyy][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] (2 $CellContext`gzz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] $CellContext`T323[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] - Derivative[0, 1, 0][$CellContext`gzz][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]])) + $CellContext`gxz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] ($CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] (-$CellContext`gyz[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] ($CellContext`T113[
               $CellContext`x[], 
               $CellContext`y[], 
               $CellContext`z[]] - 3 $CellContext`T223[
               $CellContext`x[], 
               $CellContext`y[], 
               $CellContext`z[]]) + $CellContext`gzz[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] ($CellContext`T112[
               $CellContext`x[], 
               $CellContext`y[], 
               $CellContext`z[]] + $CellContext`T323[
               $CellContext`x[], 
               $CellContext`y[], 
               $CellContext`z[]]) - Derivative[0, 1, 0][$CellContext`gzz][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) - $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`gxx[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] $CellContext`T123[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] + $CellContext`gyy[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] $CellContext`T213[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] + $CellContext`gzz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] $CellContext`T312[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] + $CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] ($CellContext`T212[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] + $CellContext`T313[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gxy][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + Derivative[0, 1, 0][$CellContext`gxz][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - Derivative[1, 0, 0][$CellContext`gyz][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]])) + $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gzz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] (-$CellContext`gxx[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T123[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T213[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T312[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] ($CellContext`T212[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] + $CellContext`T313[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gxy][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + Derivative[0, 1, 0][$CellContext`gxz][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - Derivative[1, 0, 0][$CellContext`gyz][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]])), Rational[1, 2] ($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - 2 $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gxz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gyz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 - $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]))^(-1) (2 $CellContext`gxz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]^3 $CellContext`T123[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + $CellContext`gxz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]^2 ((-2) $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] ($CellContext`T113[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] - $CellContext`T223[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) + 2 $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T323[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + 2 Derivative[0, 0, 1][$CellContext`gyz][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - Derivative[0, 1, 0][$CellContext`gzz][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]]) + $CellContext`gxx[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] ($CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] ((-2) $CellContext`gzz[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T223[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] + Derivative[0, 0, 1][$CellContext`gzz][
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]) + $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] ((-2) $CellContext`gzz[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T323[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] - 2 Derivative[0, 0, 1][$CellContext`gyz][
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] + Derivative[0, 1, 0][$CellContext`gzz][
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]])) + $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gzz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] (2 $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T213[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + 2 $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T313[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + 2 Derivative[0, 0, 1][$CellContext`gxz][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - Derivative[1, 0, 0][$CellContext`gzz][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]]) + $CellContext`gxz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] ((-2) $CellContext`gxx[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T123[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] (2 $CellContext`gzz[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T113[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] - Derivative[0, 0, 1][$CellContext`gzz][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) + $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] ((-2) $CellContext`gyz[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T213[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] - 2 $CellContext`gzz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] $CellContext`T313[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] - 2 Derivative[0, 0, 1][$CellContext`gxz][
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] + Derivative[1, 0, 0][$CellContext`gzz][
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]])))}}, {{Rational[1, 2] ($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - 2 $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gxz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gyz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 - $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]))^(-1) ($CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]^2 ((-2) $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T112[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + 2 $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T113[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) - 2 $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]]^3 $CellContext`T213[
         $CellContext`x[], 
         $CellContext`y[], 
         $CellContext`z[]] + $CellContext`gxz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gyy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] Derivative[1, 0, 0][$CellContext`gxx][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] (2 $CellContext`gxz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 $CellContext`T312[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] Derivative[1, 0, 0][$CellContext`gxx][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] (Derivative[0, 1, 0][$CellContext`gxx][
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] - 2 Derivative[1, 0, 0][$CellContext`gxy][
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]])) + $CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]^2 (2 $CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] ($CellContext`T212[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] - $CellContext`T313[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) - Derivative[0, 0, 1][$CellContext`gxx][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + 2 Derivative[1, 0, 0][$CellContext`gxz][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) + $CellContext`gxx[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] ((-2) $CellContext`gxy[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 $CellContext`T113[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + 2 $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] ($CellContext`gxz[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T112[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] - $CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] $CellContext`T212[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] + $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T213[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]]) + $CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] ((-2) $CellContext`gyz[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T312[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] + 2 $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T313[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]]) + $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] Derivative[0, 0, 1][$CellContext`gxx][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] Derivative[0, 1, 0][$CellContext`gxx][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + 2 $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] Derivative[1, 0, 0][$CellContext`gxy][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - 2 $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] Derivative[1, 0, 0][$CellContext`gxz][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]])), Rational[1, 2] ($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - 2 $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gxz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gyz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 - $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]))^(-1) (($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - $CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) (2 $CellContext`gxx[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T112[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + 2 $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T212[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + 2 $CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T312[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + Derivative[0, 1, 0][$CellContext`gxx][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) + (-$CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gxx[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) Derivative[1, 0, 0][$CellContext`gyy][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + ($CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 - $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) (-$CellContext`gxx[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T123[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T212[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T213[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - $CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`T113[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`T223[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) + $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T312[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T313[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] ($CellContext`T112[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] - $CellContext`T323[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) - Derivative[0, 0, 1][$CellContext`gxy][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + Derivative[0, 1, 0][$CellContext`gxz][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + Derivative[1, 0, 0][$CellContext`gyz][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]])), Rational[1, 2] ($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - 2 $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gxz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gyz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 - $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]))^(-1) (($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - $CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) (2 $CellContext`gxx[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T113[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + 2 $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T213[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + 2 $CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T313[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + Derivative[0, 0, 1][$CellContext`gxx][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) + (-$CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gxx[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) ($CellContext`gxx[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T123[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T212[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T213[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] ($CellContext`T113[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] + $CellContext`T223[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]) - $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T312[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T313[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] (-$CellContext`T112[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] + $CellContext`T323[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gxy][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - Derivative[0, 1, 0][$CellContext`gxz][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + Derivative[1, 0, 0][$CellContext`gyz][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) + ($CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 - $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) Derivative[1, 0, 0][$CellContext`gzz][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]])}, {Rational[1, 2] ($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - 2 $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gxz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gyz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 - $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]))^(-1) (($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - $CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) Derivative[0, 1, 0][$CellContext`gxx][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + ($CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) (2 $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T112[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + 2 $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T212[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + 2 $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T312[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - Derivative[1, 0, 0][$CellContext`gyy][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]]) - ($CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]^2 - $CellContext`gxx[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gyy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]]) ($CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T123[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T212[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T213[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`T113[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`T223[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) + $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T312[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T313[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`T112[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`T323[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gxy][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] - Derivative[0, 1, 0][$CellContext`gxz][
         $CellContext`x[], 
         $CellContext`y[], 
         $CellContext`z[]] - Derivative[1, 0, 0][$CellContext`gyz][
         $CellContext`x[], 
         $CellContext`y[], 
         $CellContext`z[]])), Rational[1, 2] ($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - 2 $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gxz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gyz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 - $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]))^(-1) ((-2) $CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]^3 $CellContext`T123[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + $CellContext`gxx[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] (2 $CellContext`gyy[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 $CellContext`T223[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] Derivative[0, 1, 0][$CellContext`gyy][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] (2 $CellContext`gyz[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T323[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] + Derivative[0, 0, 1][$CellContext`gyy][
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] - 2 Derivative[0, 1, 0][$CellContext`gyz][
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]])) - $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]]^2 (2 $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T223[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + 2 $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`T112[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`T323[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gyy][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] - 2 Derivative[0, 1, 0][$CellContext`gyz][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]]) + $CellContext`gxz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gyy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] (2 $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T212[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + 2 $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T312[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + 2 Derivative[0, 1, 0][$CellContext`gxy][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - Derivative[1, 0, 0][$CellContext`gyy][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]]) + $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] (2 $CellContext`gxx[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T123[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] (2 $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T112[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] - Derivative[0, 1, 0][$CellContext`gyy][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) + $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] ((-2) $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T212[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] - 2 $CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] $CellContext`T312[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] - 2 Derivative[0, 1, 0][$CellContext`gxy][
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] + Derivative[1, 0, 0][$CellContext`gyy][
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]))), Rational[1, 2] ($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - 2 $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gxz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gyz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 - $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]))^(-1) ($CellContext`gxz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]^2 $CellContext`gyy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] ($CellContext`T112[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`T323[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) + $CellContext`gxx[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] ($CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] (2 $CellContext`gyz[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T323[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] + Derivative[0, 0, 1][$CellContext`gyy][
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]) + $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] (2 $CellContext`gyz[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T223[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] - Derivative[0, 1, 0][$CellContext`gzz][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]])) + $CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]^2 (-$CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] ($CellContext`T113[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] + $CellContext`T223[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]) + Derivative[0, 1, 0][$CellContext`gzz][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) + $CellContext`gxz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] ((-2) $CellContext`gxy[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 $CellContext`T123[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - $CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`gyy[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] (-$CellContext`T113[
               $CellContext`x[], 
               $CellContext`y[], 
               $CellContext`z[]] + $CellContext`T223[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]]) + $CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] ($CellContext`T112[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] + 3 $CellContext`T323[
               $CellContext`x[], 
               $CellContext`y[], 
               $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gyy][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) + $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] ($CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T123[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] + $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T213[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] + $CellContext`gzz[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T312[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] + $CellContext`gyz[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] ($CellContext`T212[
               $CellContext`x[], 
               $CellContext`y[], 
               $CellContext`z[]] + $CellContext`T313[
               $CellContext`x[], 
               $CellContext`y[], 
               $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gxy][
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] + Derivative[0, 1, 0][$CellContext`gxz][
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] - Derivative[1, 0, 0][$CellContext`gyz][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]])) - $CellContext`gxy[
         $CellContext`x[], 
         $CellContext`y[], 
         $CellContext`z[]] $CellContext`gyz[
         $CellContext`x[], 
         $CellContext`y[], 
         $CellContext`z[]] (-$CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T123[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T213[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T312[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`T212[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`T313[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gxy][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + Derivative[0, 1, 0][$CellContext`gxz][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] - Derivative[1, 0, 0][$CellContext`gyz][
         $CellContext`x[], 
         $CellContext`y[], 
         $CellContext`z[]]))}, {Rational[1, 2] ($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - 2 $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gxz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gyz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 - $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]))^(-1) (($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - $CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) Derivative[0, 0, 1][$CellContext`gxx][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + (-$CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gxx[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) ($CellContext`gxx[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T123[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T212[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T213[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] (-$CellContext`T113[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] + $CellContext`T223[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]) - $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T312[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T313[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] (-$CellContext`T112[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] + $CellContext`T323[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gxy][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - Derivative[0, 1, 0][$CellContext`gxz][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + Derivative[1, 0, 0][$CellContext`gyz][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) + ($CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 - $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) ((-2) $CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T113[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - 2 $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T213[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - 2 $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T313[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + Derivative[1, 0, 0][$CellContext`gzz][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]])), Rational[1, 2] ($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - 2 $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gxz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gyz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 - $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]))^(-1) ($CellContext`gxz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]^2 $CellContext`gyy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] ($CellContext`T112[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - $CellContext`T323[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]]) + $CellContext`gxx[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] ($CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] Derivative[0, 0, 1][$CellContext`gyy][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] (2 $CellContext`gyz[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T223[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] + 2 $CellContext`gzz[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T323[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] - Derivative[0, 1, 0][$CellContext`gzz][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]])) - $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]]^2 ($CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`T113[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`T223[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) + 2 $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T323[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - Derivative[0, 1, 0][$CellContext`gzz][
         $CellContext`x[], 
         $CellContext`y[], 
         $CellContext`z[]]) + $CellContext`gxz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] ((-2) $CellContext`gxy[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 $CellContext`T123[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - $CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`gyy[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] (-$CellContext`T113[
               $CellContext`x[], 
               $CellContext`y[], 
               $CellContext`z[]] + $CellContext`T223[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]]) + $CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] ($CellContext`T112[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] - $CellContext`T323[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gyy][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) + $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] ($CellContext`gxx[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T123[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] + $CellContext`gyy[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T213[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] + $CellContext`gzz[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T312[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] + $CellContext`gyz[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] ($CellContext`T212[
               $CellContext`x[], 
               $CellContext`y[], 
               $CellContext`z[]] + $CellContext`T313[
               $CellContext`x[], 
               $CellContext`y[], 
               $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gxy][
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] + Derivative[0, 1, 0][$CellContext`gxz][
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] - Derivative[1, 0, 0][$CellContext`gyz][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]])) - $CellContext`gxy[
         $CellContext`x[], 
         $CellContext`y[], 
         $CellContext`z[]] $CellContext`gyz[
         $CellContext`x[], 
         $CellContext`y[], 
         $CellContext`z[]] (-$CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T123[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T213[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T312[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gyz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`T212[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`T313[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]) + Derivative[0, 0, 1][$CellContext`gxy][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + Derivative[0, 1, 0][$CellContext`gxz][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] - Derivative[1, 0, 0][$CellContext`gyz][
         $CellContext`x[], 
         $CellContext`y[], 
         $CellContext`z[]])), Rational[1, 2] ($CellContext`gxz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - 2 $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gxz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gyz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]^2 $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gxx[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] ($CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 - $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gzz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]]))^(-1) (2 $CellContext`gxz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]^2 ($CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T113[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - $CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T123[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]) + $CellContext`gxy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]^2 Derivative[0, 0, 1][$CellContext`gzz][
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] + $CellContext`gxx[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] (2 $CellContext`gyz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]^2 $CellContext`T223[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - $CellContext`gyy[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] Derivative[0, 0, 1][$CellContext`gzz][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] (2 $CellContext`gzz[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T323[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] + 2 Derivative[0, 0, 1][$CellContext`gyz][
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] - Derivative[0, 1, 0][$CellContext`gzz][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]])) + $CellContext`gxz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] (2 $CellContext`gxx[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T123[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] + $CellContext`gxy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] ((-2) $CellContext`gyz[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] ($CellContext`T113[
               $CellContext`x[], 
               $CellContext`y[], 
               $CellContext`z[]] + $CellContext`T223[
               $CellContext`x[], 
               $CellContext`y[], 
               $CellContext`z[]]) - 2 $CellContext`gzz[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] $CellContext`T323[
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] - 2 Derivative[0, 0, 1][$CellContext`gyz][
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]] + Derivative[0, 1, 0][$CellContext`gzz][
             $CellContext`x[], 
             $CellContext`y[], 
             $CellContext`z[]]) + $CellContext`gyy[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] (2 $CellContext`gyz[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T213[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] + 2 $CellContext`gzz[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] $CellContext`T313[
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] + 2 Derivative[0, 0, 1][$CellContext`gxz][
              $CellContext`x[], 
              $CellContext`y[], 
              $CellContext`z[]] - Derivative[1, 0, 0][$CellContext`gzz][
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]])) + $CellContext`gxy[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] $CellContext`gyz[
          $CellContext`x[], 
          $CellContext`y[], 
          $CellContext`z[]] ((-2) $CellContext`gyz[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] $CellContext`T213[
            $CellContext`x[], 
            $CellContext`y[], 
            $CellContext`z[]] - 2 $CellContext`gzz[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] $CellContext`T313[
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] - 2 Derivative[0, 0, 1][$CellContext`gxz][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]] + Derivative[1, 0, 0][$CellContext`gzz][
           $CellContext`x[], 
           $CellContext`y[], 
           $CellContext`z[]]))}}}, {$CellContext`gen, -$CellContext`gen, \
-$CellContext`gen}, 0][$CellContext`a, -$CellContext`b, -$CellContext`c],
  Editable->False]], "Output",ExpressionUUID->"b40a950a-c3fa-45d5-b25c-\
f6b202290361"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"christoffel", "[", 
     RowBox[{"a", ",", 
      RowBox[{"-", "b"}], ",", 
      RowBox[{"-", "c"}]}], "]"}], "-", 
    RowBox[{"christoffel", "[", 
     RowBox[{"a", ",", 
      RowBox[{"-", "c"}], ",", 
      RowBox[{"-", "b"}]}], "]"}]}], "\[Equal]", 
   RowBox[{"torsion", "[", 
    RowBox[{"a", ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}]}], "]"}]}], "//", "Simplify"}]], "Input",ExpressionUUI\
D->"5e2c55be-db54-48b7-a92e-41db0cb7c4f0"],

Cell[BoxData["True"], "Output",ExpressionUUID->"37b97604-ef7e-4219-a9e7-dc14a64a2f0e"]
}, Open  ]],

Cell["The connection is associated to the metric:", "Text",ExpressionUUID->"fb14bec6-6e75-4923-b194-a3282a8a5286"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TensorDerivative", "[", 
  RowBox[{"metric", ",", "cd"}], "]"}]], "Input",ExpressionUUID->"f2171a25-\
2d26-42ee-998e-f34ff47d2b59"],

Cell[BoxData["Zero"], "Output",ExpressionUUID->"f80ff7a3-9fcd-49a7-ab59-6fb9be58f726"]
}, Open  ]],

Cell["\<\
Compute everything. We simplify using Together because Simplify is too slow \
in this case:\
\>", "Text",ExpressionUUID->"6c5c7079-22dd-4bf8-bbe7-987cbbe2f240"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MetricCompute", "[", 
   RowBox[{"metric", ",", "torsion", ",", "gen", ",", 
    RowBox[{"\"\<Riemann\>\"", "[", 
     RowBox[{
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}], ",", "1"}], "]"}], ",", 
    RowBox[{"CVSimplify", "\[Rule]", "Together"}], ",", 
    RowBox[{"Parallelize", "\[Rule]", "True"}]}], "]"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"43750bb8-7d2f-4d26-9c43-\
b8c977846dcf"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"6.904419`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"79d0da7f-be56-4486-933d-9321218601d8"]
}, Open  ]],

Cell["But now it has curvature:", "Text",ExpressionUUID->"57e32a65-929c-4fcc-99b8-128e399495ec"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"riemann", "=", 
     RowBox[{"Riemann", "[", "cd", "]"}]}], ")"}], ";"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"eb342a18-e1fa-4c37-b456-\
58afaa4576a9"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.000979`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"f06245cc-ffc3-4c1b-beaf-edb397b3c7a0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"riemanndown", "=", 
     RowBox[{"RiemannDown", "[", "cd", "]"}]}], ")"}], ";"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"9f4ffd26-9d64-4131-b66d-\
588204721b75"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.000384`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"5ecd9673-b746-4ce8-8b2a-072d8180bf9b"]
}, Open  ]],

Cell["Symmetry is NOT complete in this 3d case:", "Text",ExpressionUUID->"cfaaa7ed-5141-4ce7-8c9c-8f684462d738"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SymmetryGroupOfTensor", "[", "riemann", "]"}]], "Input",ExpressionUU\
ID->"7d0aa215-18ac-4087-aea8-266725299663"],

Cell[BoxData[
 RowBox[{"StrongGenSet", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"GenSet", "[", 
    InterpretationBox[
     StyleBox[
      RowBox[{"-", 
       RowBox[{"(", "1", ",", "2", ")"}]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     -xAct`xPerm`Cycles[{1, 2}],
     Editable->False], "]"}]}], "]"}]], "Output",ExpressionUUID->"bc1888f2-\
e504-4a0e-9925-34ae84c48373"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SymmetryGroupOfTensor", "[", "riemanndown", "]"}]], "Input",Expressi\
onUUID->"eb281b20-46da-411a-b65c-782977c07208"],

Cell[BoxData[
 RowBox[{"StrongGenSet", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3", ",", "1"}], "}"}], ",", 
   RowBox[{"GenSet", "[", 
    RowBox[{
     InterpretationBox[
      StyleBox[
       RowBox[{"-", 
        RowBox[{"(", "3", ",", "4", ")"}]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      -xAct`xPerm`Cycles[{3, 4}],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox[
       RowBox[{"-", 
        RowBox[{"(", "1", ",", "2", ")"}]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      -xAct`xPerm`Cycles[{1, 2}],
      Editable->False]}], "]"}]}], "]"}]], "Output",ExpressionUUID->"ad8d5981-\
4a83-4d53-90fe-7a2ba77be209"]
}, Open  ]],

Cell["Clean up:", "Text",ExpressionUUID->"d41add2a-8ef1-45eb-a32f-f2b8e4170b64"],

Cell[BoxData[
 RowBox[{"UnsetCMetric", "[", "metric", "]"}]], "Input",ExpressionUUID->"b80d9889-8feb-4271-90f6-0a7539553c6c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UndefScalarFunction", "/@", "$ScalarFunctions"}], ";"}]], "Input",E\
xpressionUUID->"b26baf97-da50-424a-adbe-590223c8f502"],

Cell[BoxData[
 RowBox[{"UndefChart", "[", "gen", "]"}]], "Input",ExpressionUUID->"9e05d0be-5789-4e9e-ad66-42b2ffa39937"],

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M", "]"}]], "Input",ExpressionUUID->"9499c0bc-9f23-4b20-b7cb-99d16d0274b3"],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{
  "metric", ",", "torsion", ",", "cd", ",", "christoffel", ",", "riemann", 
   ",", "riemanndown"}], "]"}]], "Input",ExpressionUUID->"4ac5b5e7-cc2f-4978-\
af68-d5a2794959c9"],

Cell[BoxData[
 RowBox[{"ClearxCobaCache", "[", "All", "]"}]], "Input",ExpressionUUID->"3330874e-7aa3-478e-ad31-b1ecc73b50d2"]
}, Closed]],

Cell[CellGroupData[{

Cell["4.4. A hard example: The Pomeransky-Senkov metric", "Subsubsection",ExpressionUUID->"689c67be-83e5-4ec6-97ad-369fbf73699f"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<xAct`xCoba`\>\"", "]"}]], "Input",ExpressionUUID->"c244aa2b-2380-4db3-b4c0-cdb8657ab5b8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$DefInfoQ", "=", 
   RowBox[{"$UndefInfoQ", "=", "False"}]}], ";"}]], "Input",ExpressionUUID->\
"79356c5f-0170-4456-8460-5f644907ab28"],

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M", ",", "5", ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"53052be0-5bbd-4bca-b0f4-8f79c72c2e1b"],

Cell[BoxData[
 RowBox[{"DefChart", "[", 
  RowBox[{"PS", ",", "M", ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"t", "[", "]"}], ",", 
     RowBox[{"x", "[", "]"}], ",", 
     RowBox[{"y", "[", "]"}], ",", 
     RowBox[{"\[Phi]", "[", "]"}], ",", 
     RowBox[{"\[Psi]", "[", "]"}]}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"2cb04f46-8acb-4708-9da1-6ba3466e7e3d"],

Cell[TextData[{
 "Formulas taken from [",
 ButtonBox["arXiv:0911.0802",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://arxiv.org/pdf/0911.0802v2.pdf"], None},
  ButtonNote->"http://arxiv.org/pdf/0911.0802v2.pdf"],
 "]:"
}], "Text",ExpressionUUID->"cbcf8c55-cc9a-4e9a-b035-fdf9fb708644"],

Cell[BoxData[
 RowBox[{"DefConstantSymbol", "[", 
  RowBox[{"{", 
   RowBox[{"\[Lambda]", ",", "\[Nu]", ",", "k"}], "}"}], "]"}]], "Input",Expre\
ssionUUID->"12d88a00-e2c7-4bc7-a83e-e185865db2c1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ds2", "=", 
   RowBox[{
    RowBox[{
     FractionBox[
      RowBox[{"2", " ", 
       RowBox[{"H", "[", 
        RowBox[{"x", ",", "y"}], "]"}], " ", 
       SuperscriptBox["k", "2"], " "}], 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"1", "-", "\[Nu]"}], ")"}], "2"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"x", "-", "y"}], ")"}], "2"]}]], 
     RowBox[{"(", 
      RowBox[{
       FractionBox[
        SuperscriptBox["dx", "2"], 
        RowBox[{"G", "[", "x", "]"}]], "-", 
       FractionBox[
        SuperscriptBox["dy", "2"], 
        RowBox[{"G", "[", "y", "]"}]]}], ")"}]}], "-", 
    RowBox[{"2", 
     FractionBox[
      RowBox[{"J", "[", 
       RowBox[{"x", ",", "y"}], "]"}], 
      RowBox[{"H", "[", 
       RowBox[{"y", ",", "x"}], "]"}]], "d\[Phi]", " ", "d\[Psi]"}], "-", 
    RowBox[{
     FractionBox[
      RowBox[{"H", "[", 
       RowBox[{"y", ",", "x"}], "]"}], 
      RowBox[{"H", "[", 
       RowBox[{"x", ",", "y"}], "]"}]], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"dt", "+", "\[CapitalOmega]"}], ")"}], "2"]}], "-", 
    RowBox[{
     FractionBox[
      RowBox[{"F", "[", 
       RowBox[{"x", ",", "y"}], "]"}], 
      RowBox[{"H", "[", 
       RowBox[{"y", ",", "x"}], "]"}]], " ", 
     SuperscriptBox["d\[Psi]", "2"]}], "+", 
    RowBox[{
     FractionBox[
      RowBox[{"F", "[", 
       RowBox[{"y", ",", "x"}], "]"}], 
      RowBox[{"H", "[", 
       RowBox[{"y", ",", "x"}], "]"}]], " ", 
     SuperscriptBox["d\[Phi]", "2"]}]}]}], ";"}]], "Input",ExpressionUUID->\
"888ad203-54ef-45bf-a263-6342d14ceaef"],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[CapitalOmega]", ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"M", "[", 
      RowBox[{"x", ",", "y"}], "]"}], " ", "d\[Psi]"}], "+", 
    RowBox[{
     RowBox[{"P", "[", 
      RowBox[{"x", ",", "y"}], "]"}], " ", "d\[Phi]"}]}]}], ";"}]], "Input",Ex\
pressionUUID->"befd86d4-6a63-43c4-8749-8d0ca8a78246"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"M", "[", 
    RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
   FractionBox[
    RowBox[{"2", " ", "k", " ", "\[Lambda]", " ", 
     SqrtBox[
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"\[Nu]", "+", "1"}], ")"}], "2"], "-", 
       SuperscriptBox["\[Lambda]", "2"]}]], " ", 
     RowBox[{"(", 
      RowBox[{"y", "+", "1"}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "\[Lambda]"}], "+", "\[Nu]", "-", 
       RowBox[{"2", " ", "\[Nu]", " ", "x"}], "+", 
       RowBox[{"\[Nu]", " ", "x", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"\[Lambda]", "+", "\[Nu]", "-", "1"}], ")"}], " ", "x"}], 
          "+", "2"}], ")"}], " ", "y"}], "-", "1"}], ")"}]}], 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", "\[Lambda]", "+", "\[Nu]"}], ")"}], " ", 
     RowBox[{"H", "[", 
      RowBox[{"y", ",", "x"}], "]"}]}]]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"P", "[", 
    RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
   FractionBox[
    RowBox[{"2", " ", "k", " ", "\[Lambda]", " ", 
     SqrtBox["\[Nu]"], " ", 
     SqrtBox[
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"\[Nu]", "+", "1"}], ")"}], "2"], "-", 
       SuperscriptBox["\[Lambda]", "2"]}]], " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["x", "2"], "-", "1"}], ")"}], " ", "y"}], 
    RowBox[{"H", "[", 
     RowBox[{"y", ",", "x"}], "]"}]]}], ";"}]}], "Input",ExpressionUUID->\
"e8caf613-4c17-4c8a-a2ed-d3e0fc067bce"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"H", "[", 
    RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
   RowBox[{
    SuperscriptBox["\[Lambda]", "2"], "+", 
    RowBox[{"2", " ", "\[Nu]", " ", 
     RowBox[{"(", 
      RowBox[{"1", "-", 
       SuperscriptBox["x", "2"]}], ")"}], " ", "y", " ", "\[Lambda]"}], "+", 
    RowBox[{"2", " ", "x", " ", 
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{
        SuperscriptBox["\[Nu]", "2"], " ", 
        SuperscriptBox["y", "2"]}]}], ")"}], " ", "\[Lambda]"}], "-", 
    SuperscriptBox["\[Nu]", "2"], "+", 
    RowBox[{"\[Nu]", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        SuperscriptBox["\[Lambda]", "2"]}], "-", 
       SuperscriptBox["\[Nu]", "2"], "+", "1"}], ")"}], " ", 
     SuperscriptBox["x", "2"], " ", 
     SuperscriptBox["y", "2"]}], "+", "1"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"F", "[", 
    RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
   RowBox[{
    FractionBox[
     RowBox[{"2", " ", 
      SuperscriptBox["k", "2"]}], 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"x", "-", "y"}], ")"}], "2"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"1", "-", "\[Nu]"}], ")"}], "2"]}]], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         SuperscriptBox["y", "2"]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"1", "-", "\[Nu]"}], ")"}], "2"], "-", 
            SuperscriptBox["\[Lambda]", "2"]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"\[Nu]", "+", "1"}], ")"}]}], "+", 
         RowBox[{"y", " ", "\[Lambda]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             SuperscriptBox["\[Lambda]", "2"]}], "-", 
            RowBox[{"3", " ", 
             SuperscriptBox["\[Nu]", "2"]}], "+", 
            RowBox[{"2", " ", "\[Nu]"}], "+", "1"}], ")"}]}]}], ")"}], " ", 
       RowBox[{"G", "[", "x", "]"}]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", 
           RowBox[{"(", 
            RowBox[{"1", "-", "\[Nu]"}], ")"}]}], " ", "\[Nu]", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["\[Lambda]", "2"], "+", 
            SuperscriptBox["\[Nu]", "2"], "-", "1"}], ")"}], " ", 
          SuperscriptBox["x", "4"]}], "+", 
         RowBox[{"\[Lambda]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", 
             SuperscriptBox["\[Nu]", "3"]}], "-", 
            RowBox[{"3", " ", 
             SuperscriptBox["\[Nu]", "2"]}], "-", 
            SuperscriptBox["\[Lambda]", "2"], "+", "1"}], ")"}], " ", 
          SuperscriptBox["x", "3"]}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"1", "-", "\[Nu]"}], ")"}], "2"], "-", 
            SuperscriptBox["\[Lambda]", "2"]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"\[Nu]", "+", "1"}], ")"}], " ", 
          SuperscriptBox["x", "2"]}], "+", 
         RowBox[{"\[Lambda]", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["\[Lambda]", "2"], "+", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"1", "-", "\[Nu]"}], ")"}], "2"]}], ")"}], " ", "x"}], 
         "+", 
         RowBox[{"2", " ", 
          SuperscriptBox["\[Lambda]", "2"]}]}], ")"}], " ", 
       RowBox[{"G", "[", "y", "]"}]}]}], ")"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"J", "[", 
    RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
   FractionBox[
    RowBox[{"2", " ", 
     SuperscriptBox["k", "2"], " ", 
     RowBox[{"(", 
      RowBox[{"1", "-", 
       SuperscriptBox["x", "2"]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{"1", "-", 
       SuperscriptBox["y", "2"]}], ")"}], " ", "\[Lambda]", " ", 
     SqrtBox["\[Nu]"], " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["\[Lambda]", "2"], "+", 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{"x", "+", "y"}], ")"}], " ", "\[Nu]", " ", "\[Lambda]"}], 
       "-", 
       SuperscriptBox["\[Nu]", "2"], "-", 
       RowBox[{"x", " ", "y", " ", "\[Nu]", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["\[Lambda]", "2"]}], "-", 
          SuperscriptBox["\[Nu]", "2"], "+", "1"}], ")"}]}], "+", "1"}], 
      ")"}]}], 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"x", "-", "y"}], ")"}], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "-", "\[Nu]"}], ")"}], "2"]}]]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"G", "[", "x_", "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", 
      SuperscriptBox["x", "2"]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"\[Nu]", " ", 
       SuperscriptBox["x", "2"]}], "+", 
      RowBox[{"\[Lambda]", " ", "x"}], "+", "1"}], ")"}]}]}], ";"}]}], "Input",\
ExpressionUUID->"065738be-17f0-43f9-a973-607888ecfb07"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"matrix", "=", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"CoefficientArrays", "[", 
         RowBox[{"ds2", ",", 
          RowBox[{"{", 
           RowBox[{
           "dt", ",", "dx", ",", "dy", ",", "d\[Phi]", ",", "d\[Psi]"}], 
           "}"}], ",", 
          RowBox[{"\"\<Symmetric\>\"", "\[Rule]", "True"}]}], "]"}], "[", 
        RowBox[{"[", "3", "]"}], "]"}], "//", "Normal"}], "//", 
      "Simplify"}]}], ";"}], ")"}], "//", "AbsoluteTiming"}]], "Input",Express\
ionUUID->"589317e4-b7e9-4dbf-942a-3d8596d15945"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2.132735`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"db993d08-3798-436d-91ef-8c32a01b2f67"]
}, Open  ]],

Cell["A check:", "Text",ExpressionUUID->"3eb0021f-0be2-40db-abf0-77ceacb346d6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ds2", "-", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"dt", ",", "dx", ",", "dy", ",", "d\[Phi]", ",", "d\[Psi]"}], 
      "}"}], ".", "matrix", ".", 
     RowBox[{"{", 
      RowBox[{"dt", ",", "dx", ",", "dy", ",", "d\[Phi]", ",", "d\[Psi]"}], 
      "}"}]}]}], "//", "Simplify"}], "//", "AbsoluteTiming"}]], "Input",Expres\
sionUUID->"ec057636-d78e-4ec5-8b94-7633734a0912"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.777638`", ",", "0"}], "}"}]], "Output",ExpressionUUID->"810bff37-\
d615-4d11-8dc3-f7de5465731b"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"met", "=", 
   RowBox[{"CTensor", "[", 
    RowBox[{
     RowBox[{"matrix", "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"x", "\[Rule]", 
         RowBox[{"x", "[", "]"}]}], ",", 
        RowBox[{"y", "\[Rule]", 
         RowBox[{"y", "[", "]"}]}]}], "}"}]}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "PS"}], ",", 
       RowBox[{"-", "PS"}]}], "}"}]}], "]"}]}], ";"}]], "Input",ExpressionUUID\
->"f39ccd96-4ad8-46fc-b19e-a5acb4f25239"],

Cell["\<\
Simplify is way too slow for this metric. In this case it is more useful to \
simplify with Together:\
\>", "Text",ExpressionUUID->"12c5240a-071d-4be3-99f2-e2c4563e871c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$CVSimplify", "=", "Together"}], ";"}]], "Input",ExpressionUUID->\
"887f5052-0295-4425-b1da-9d65c6aa4811"],

Cell["\<\
Inverse has a hard time with this matrix. Specify explicitly the signature:\
\>", "Text",ExpressionUUID->"5310526b-b2e3-48e5-807f-320b7506e06e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"SetCMetric", "[", 
   RowBox[{"met", ",", "PS", ",", 
    RowBox[{"SignatureOfMetric", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"4", ",", "1", ",", "0"}], "}"}]}], ",", 
    RowBox[{"Verbose", "\[Rule]", "True"}]}], "]"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"f0ac9abd-b00e-400c-a768-\
afe06d1a33c9"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** ReportCompute: \"\>", "\[InvisibleSpace]", 
   RowBox[{"\<\"Metric\"\>", "[", 
    RowBox[{"1", ",", "1"}], "]"}]}],
  SequenceForm["** ReportCompute: ", 
   "Metric"[1, 1]],
  Editable->False]], "Print",ExpressionUUID->"d5725dde-ccea-43c6-8fe0-\
3ea4dbe65451"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Constructed in \"\>", "\[InvisibleSpace]", "28.556424`", 
   "\[InvisibleSpace]", "\<\" seconds\"\>"}],
  SequenceForm["    Constructed in ", 28.556424, " seconds"],
  Editable->False]], "Print",ExpressionUUID->"8d96f0c0-cd8a-44a5-a06b-\
643ea1ebc35a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Applied \"\>", "\[InvisibleSpace]", "Together", 
   "\[InvisibleSpace]", "\<\" in \"\>", "\[InvisibleSpace]", "1.48219`", 
   "\[InvisibleSpace]", "\<\" seconds\"\>"}],
  SequenceForm["    Applied ", Together, " in ", 1.48219, " seconds"],
  Editable->False]], "Print",ExpressionUUID->"4bff6a57-5035-460d-88c8-\
36455a1d4d0a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Stored in \"\>", "\[InvisibleSpace]", "0.00134`", 
   "\[InvisibleSpace]", "\<\" seconds and \"\>", "\[InvisibleSpace]", 
   "234848", "\[InvisibleSpace]", "\<\" bytes\"\>"}],
  SequenceForm["    Stored in ", 0.00134, " seconds and ", 234848, " bytes"],
  Editable->False]], "Print",ExpressionUUID->"f39611aa-cd34-4275-8f0d-\
ecb5f4d089e8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** ReportCompute: \"\>", "\[InvisibleSpace]", 
   RowBox[{"\<\"DMetric\"\>", "[", 
    RowBox[{
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}]}], "]"}]}],
  SequenceForm["** ReportCompute: ", 
   "DMetric"[-1, -1, -1]],
  Editable->False]], "Print",ExpressionUUID->"eb24260e-acdc-4dcd-bcff-\
6de4d0a6715e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Constructed in \"\>", "\[InvisibleSpace]", "0.002916`", 
   "\[InvisibleSpace]", "\<\" seconds\"\>"}],
  SequenceForm["    Constructed in ", 0.002916, " seconds"],
  Editable->False]], "Print",ExpressionUUID->"e6bd050f-856d-4282-95dc-\
1ab6072a95c2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Applied \"\>", "\[InvisibleSpace]", "Together", 
   "\[InvisibleSpace]", "\<\" in \"\>", "\[InvisibleSpace]", "0.580662`", 
   "\[InvisibleSpace]", "\<\" seconds\"\>"}],
  SequenceForm["    Applied ", Together, " in ", 0.580662, " seconds"],
  Editable->False]], "Print",ExpressionUUID->"034b7548-c8c9-428c-a4cb-\
9827cb13a305"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** ReportCompute: \"\>", "\[InvisibleSpace]", 
   RowBox[{"\<\"Christoffel\"\>", "[", 
    RowBox[{
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}]}], "]"}]}],
  SequenceForm["** ReportCompute: ", 
   "Christoffel"[-1, -1, -1]],
  Editable->False]], "Print",ExpressionUUID->"3e9a63e6-e570-42b9-b2d8-\
a732526bad18"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Constructed in \"\>", "\[InvisibleSpace]", "0.002739`", 
   "\[InvisibleSpace]", "\<\" seconds\"\>"}],
  SequenceForm["    Constructed in ", 0.002739, " seconds"],
  Editable->False]], "Print",ExpressionUUID->"7126c9f1-b462-4de6-89fb-\
5ea409ee2ce7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Applied \"\>", "\[InvisibleSpace]", "Together", 
   "\[InvisibleSpace]", "\<\" in \"\>", "\[InvisibleSpace]", "0.703511`", 
   "\[InvisibleSpace]", "\<\" seconds\"\>"}],
  SequenceForm["    Applied ", Together, " in ", 0.703511, " seconds"],
  Editable->False]], "Print",ExpressionUUID->"f075da9f-bf45-479a-86c2-\
d3e39df4690a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** ReportCompute: \"\>", "\[InvisibleSpace]", 
   RowBox[{"\<\"Christoffel\"\>", "[", 
    RowBox[{"1", ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}]}], "]"}]}],
  SequenceForm["** ReportCompute: ", 
   "Christoffel"[1, -1, -1]],
  Editable->False]], "Print",ExpressionUUID->"2392d952-2441-41c1-adf6-\
4ce5adce5b10"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Constructed in \"\>", "\[InvisibleSpace]", "0.011167`", 
   "\[InvisibleSpace]", "\<\" seconds\"\>"}],
  SequenceForm["    Constructed in ", 0.011167, " seconds"],
  Editable->False]], "Print",ExpressionUUID->"759542c6-e3eb-4044-afc7-\
7dc52eae617f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Applied \"\>", "\[InvisibleSpace]", "Together", 
   "\[InvisibleSpace]", "\<\" in \"\>", "\[InvisibleSpace]", "2.913791`", 
   "\[InvisibleSpace]", "\<\" seconds\"\>"}],
  SequenceForm["    Applied ", Together, " in ", 2.913791, " seconds"],
  Editable->False]], "Print",ExpressionUUID->"eedad889-6aaf-4eb0-82f2-\
352d55be4404"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** ReportCompute: \"\>", 
   "\[InvisibleSpace]", "\<\"CovDOfMetric\"\>"}],
  SequenceForm["** ReportCompute: ", "CovDOfMetric"],
  Editable->False]], "Print",ExpressionUUID->"544fc494-cbf3-4462-babb-\
ff2fd6a865b1"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"34.463046`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"4532eaec-b0c4-4dd1-9b69-3154ed23a38e"]
}, Open  ]],

Cell["Now we compute all the way down to the Ricci tensor.", "Text",ExpressionUUID->"6c3e2749-cd19-4d75-9560-e5efe5bba892"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MetricCompute", "[", 
   RowBox[{"met", ",", "PS", ",", 
    RowBox[{"\"\<Ricci\>\"", "[", 
     RowBox[{
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}]}], "]"}], ",", 
    RowBox[{"Verbose", "\[Rule]", "True"}], ",", 
    RowBox[{"Parallelize", "\[Rule]", "True"}]}], "]"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"c5cfc235-5878-48c9-8416-\
ba58a1d391c8"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** ReportCompute: \"\>", "\[InvisibleSpace]", 
   RowBox[{"\<\"Metric\"\>", "[", 
    RowBox[{"1", ",", "1"}], "]"}]}],
  SequenceForm["** ReportCompute: ", 
   "Metric"[1, 1]],
  Editable->False]], "Print",ExpressionUUID->"5b4eb622-1bac-4766-a4c4-\
174390b28ce0"],

Cell[BoxData["\<\"    Already cached\"\>"], "Print",ExpressionUUID->"f42cebd0-7447-4fff-b649-ccae272c4d70"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** ReportCompute: \"\>", "\[InvisibleSpace]", 
   RowBox[{"\<\"DMetric\"\>", "[", 
    RowBox[{
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}]}], "]"}]}],
  SequenceForm["** ReportCompute: ", 
   "DMetric"[-1, -1, -1]],
  Editable->False]], "Print",ExpressionUUID->"63c7349d-3e77-4c37-bc64-\
690f0524dbcf"],

Cell[BoxData["\<\"    Already cached\"\>"], "Print",ExpressionUUID->"06be5aba-a8c9-4324-b232-14e4a2a00397"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** ReportCompute: \"\>", "\[InvisibleSpace]", 
   RowBox[{"\<\"DDMetric\"\>", "[", 
    RowBox[{
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}]}], "]"}]}],
  SequenceForm["** ReportCompute: ", 
   "DDMetric"[-1, -1, -1, -1]],
  Editable->False]], "Print",ExpressionUUID->"adf91ebd-fe00-42ba-9417-\
c0a8fe76824c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Constructed in \"\>", "\[InvisibleSpace]", "0.054882`", 
   "\[InvisibleSpace]", "\<\" seconds\"\>"}],
  SequenceForm["    Constructed in ", 0.054882, " seconds"],
  Editable->False]], "Print",ExpressionUUID->"e824de72-aa44-4b3c-a340-\
1180447c103e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Applied \"\>", "\[InvisibleSpace]", "Together", 
   "\[InvisibleSpace]", "\<\" in \"\>", "\[InvisibleSpace]", "4.745564`", 
   "\[InvisibleSpace]", "\<\" seconds\"\>"}],
  SequenceForm["    Applied ", Together, " in ", 4.745564, " seconds"],
  Editable->False]], "Print",ExpressionUUID->"4aff0834-7fde-4f38-b87a-\
af6fd82e6702"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** ReportCompute: \"\>", "\[InvisibleSpace]", 
   RowBox[{"\<\"Christoffel\"\>", "[", 
    RowBox[{
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}]}], "]"}]}],
  SequenceForm["** ReportCompute: ", 
   "Christoffel"[-1, -1, -1]],
  Editable->False]], "Print",ExpressionUUID->"e7c60326-ca1b-4759-bbf1-\
1ac298e1c2c8"],

Cell[BoxData["\<\"    Already cached\"\>"], "Print",ExpressionUUID->"b382300f-2994-4d21-923d-7ec747d030b0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** ReportCompute: \"\>", "\[InvisibleSpace]", 
   RowBox[{"\<\"Christoffel\"\>", "[", 
    RowBox[{"1", ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}]}], "]"}]}],
  SequenceForm["** ReportCompute: ", 
   "Christoffel"[1, -1, -1]],
  Editable->False]], "Print",ExpressionUUID->"6240d60c-e0af-4ff8-97c3-\
89875ddd251f"],

Cell[BoxData["\<\"    Already cached\"\>"], "Print",ExpressionUUID->"38e96f55-cdfa-4e50-b417-8764ae5454b8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** ReportCompute: \"\>", 
   "\[InvisibleSpace]", "\<\"CovDOfMetric\"\>"}],
  SequenceForm["** ReportCompute: ", "CovDOfMetric"],
  Editable->False]], "Print",ExpressionUUID->"d3d206bb-1de0-48c8-8d27-\
3418440566ec"],

Cell[BoxData["\<\"    Already cached\"\>"], "Print",ExpressionUUID->"0e60de9e-9bdf-48ca-b40f-fb3f57de8718"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** ReportCompute: \"\>", "\[InvisibleSpace]", 
   RowBox[{"\<\"Riemann\"\>", "[", 
    RowBox[{
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}]}], "]"}]}],
  SequenceForm["** ReportCompute: ", 
   "Riemann"[-1, -1, -1, -1]],
  Editable->False]], "Print",ExpressionUUID->"07ea4059-323d-49d0-93b6-\
11352799e78e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Constructed in \"\>", "\[InvisibleSpace]", "0.029762`", 
   "\[InvisibleSpace]", "\<\" seconds\"\>"}],
  SequenceForm["    Constructed in ", 0.029762, " seconds"],
  Editable->False]], "Print",ExpressionUUID->"2dcf1e98-484a-4392-8bf5-\
83b173949f00"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Applied \"\>", "\[InvisibleSpace]", "Together", 
   "\[InvisibleSpace]", "\<\" in \"\>", "\[InvisibleSpace]", "7.197298`", 
   "\[InvisibleSpace]", "\<\" seconds\"\>"}],
  SequenceForm["    Applied ", Together, " in ", 7.197298, " seconds"],
  Editable->False]], "Print",ExpressionUUID->"672c152c-9104-489b-a6b2-\
74a348ecb62c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Stored in \"\>", "\[InvisibleSpace]", "0.389878`", 
   "\[InvisibleSpace]", "\<\" seconds and \"\>", "\[InvisibleSpace]", 
   "95170840", "\[InvisibleSpace]", "\<\" bytes\"\>"}],
  SequenceForm[
  "    Stored in ", 0.389878, " seconds and ", 95170840, " bytes"],
  Editable->False]], "Print",ExpressionUUID->"b095e63b-1676-470d-9c7f-\
ff846b512b5a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** ReportCompute: \"\>", "\[InvisibleSpace]", 
   RowBox[{"\<\"Riemann\"\>", "[", 
    RowBox[{
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", "1"}], "]"}]}],
  SequenceForm["** ReportCompute: ", 
   "Riemann"[-1, -1, -1, 1]],
  Editable->False]], "Print",ExpressionUUID->"6074bc53-c4c7-4407-b122-\
3d7d2d3dc756"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Constructed in \"\>", "\[InvisibleSpace]", "0.075712`", 
   "\[InvisibleSpace]", "\<\" seconds\"\>"}],
  SequenceForm["    Constructed in ", 0.075712, " seconds"],
  Editable->False]], "Print",ExpressionUUID->"86891b20-ec73-4b56-bf09-\
c52954ed23c2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Applied \"\>", "\[InvisibleSpace]", "Together", 
   "\[InvisibleSpace]", "\<\" in \"\>", "\[InvisibleSpace]", "13.709224`", 
   "\[InvisibleSpace]", "\<\" seconds\"\>"}],
  SequenceForm["    Applied ", Together, " in ", 13.709224, " seconds"],
  Editable->False]], "Print",ExpressionUUID->"bd900c18-e0e9-4292-ad9c-\
4fc6eba7503f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Stored in \"\>", "\[InvisibleSpace]", "0.43973`", 
   "\[InvisibleSpace]", "\<\" seconds and \"\>", "\[InvisibleSpace]", 
   "117519088", "\[InvisibleSpace]", "\<\" bytes\"\>"}],
  SequenceForm[
  "    Stored in ", 0.43973, " seconds and ", 117519088, " bytes"],
  Editable->False]], "Print",ExpressionUUID->"5dc6c4b7-0ff6-474b-bedd-\
d5747b18186b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** ReportCompute: \"\>", "\[InvisibleSpace]", 
   RowBox[{"\<\"Ricci\"\>", "[", 
    RowBox[{
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}]}], "]"}]}],
  SequenceForm["** ReportCompute: ", 
   "Ricci"[-1, -1]],
  Editable->False]], "Print",ExpressionUUID->"e7ae67ca-8a95-4400-8e46-\
2713fc6ededc"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Constructed in \"\>", "\[InvisibleSpace]", "0.000756`", 
   "\[InvisibleSpace]", "\<\" seconds\"\>"}],
  SequenceForm["    Constructed in ", 0.000756, " seconds"],
  Editable->False]], "Print",ExpressionUUID->"8db26813-cf5b-4d7f-9640-\
1f8b5b720eb3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Applied \"\>", "\[InvisibleSpace]", "Together", 
   "\[InvisibleSpace]", "\<\" in \"\>", "\[InvisibleSpace]", "1.057951`", 
   "\[InvisibleSpace]", "\<\" seconds\"\>"}],
  SequenceForm["    Applied ", Together, " in ", 1.057951, " seconds"],
  Editable->False]], "Print",ExpressionUUID->"d5218eac-1900-4a3d-b82a-\
a76b26c816eb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Stored in \"\>", "\[InvisibleSpace]", "0.014053`", 
   "\[InvisibleSpace]", "\<\" seconds and \"\>", "\[InvisibleSpace]", "640", 
   "\[InvisibleSpace]", "\<\" bytes\"\>"}],
  SequenceForm["    Stored in ", 0.014053, " seconds and ", 640, " bytes"],
  Editable->False]], "Print",ExpressionUUID->"3c535dcb-a506-4015-98fc-\
f7c628618245"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"28.756738`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"11eeb89d-a889-469a-bbe5-74b5463d336a"]
}, Open  ]],

Cell["It is a Ricci-flat metric:", "Text",ExpressionUUID->"68998df6-b8df-4531-83e4-26afd11c9217"],

Cell[BoxData[
 RowBox[{
  RowBox[{"cd", "=", 
   RowBox[{"CovDOfMetric", "[", "met", "]"}]}], ";"}]], "Input",ExpressionUUID\
->"3d7427f7-3a69-45bf-848e-3ebe05af339e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Ricci", "[", "cd", "]"}]], "Input",ExpressionUUID->"55b8d905-55c8-448c-9a30-7b3284cfbdb3"],

Cell[BoxData["Zero"], "Output",ExpressionUUID->"b89c4487-706f-4845-af7b-086fddbeea73"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{
  "met", ",", "cd", ",", "dt", ",", "dx", ",", "dy", ",", "d\[Phi]", ",", 
   "d\[Psi]", ",", "ds2", ",", "F", ",", "G", ",", "H", ",", "J", ",", "P", 
   ",", "\[CapitalOmega]", ",", "matrix"}], "]"}]], "Input",ExpressionUUID->\
"78b42365-3129-4487-9aef-00c836c4cb48"],

Cell[BoxData[
 RowBox[{"UndefConstantSymbol", "[", 
  RowBox[{"{", 
   RowBox[{"\[Lambda]", ",", "\[Nu]", ",", "k"}], "}"}], "]"}]], "Input",Expre\
ssionUUID->"e6032f52-1840-438a-8194-ddca1d96799e"],

Cell[BoxData[
 RowBox[{"UndefChart", "[", "PS", "]"}]], "Input",ExpressionUUID->"75440453-ee80-42ad-8d78-e0d0a3153afc"],

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M", "]"}]], "Input",ExpressionUUID->"0ba4cf87-c7c2-46f6-8966-1302932f954b"],

Cell[BoxData[
 RowBox[{"ClearxCobaCache", "[", "All", "]"}]], "Input",ExpressionUUID->"4f1fab4f-3756-4a09-bfa4-3df4bb773191"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
4.5. A hard example: Kerr-Newman-deSitter in Boyer-Lindquist-like \
\[Theta]-coordinates\
\>", "Subsubsection",ExpressionUUID->"9d036867-c9f4-4cca-ba6d-6de5b3720599"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<xAct`xCoba`\>\"", "]"}]], "Input",ExpressionUUID->"d4a7d416-2a01-4290-933d-f4fb5e040067"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$DefInfoQ", "=", 
   RowBox[{"$UndefInfoQ", "=", "False"}]}], ";"}]], "Input",ExpressionUUID->\
"6644f7b9-0e86-4fb5-b507-87ba97b1734d"],

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M", ",", "4", ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"8e4b2a63-74ca-4ac9-a669-ff21aa5122b7"],

Cell[BoxData[
 RowBox[{"DefChart", "[", 
  RowBox[{"BL", ",", "M", ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"t", "[", "]"}], ",", 
     RowBox[{"r", "[", "]"}], ",", 
     RowBox[{"\[Theta]", "[", "]"}], ",", 
     RowBox[{"\[Phi]", "[", "]"}]}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"0431fee8-090f-4552-b5f9-b01453c82d6d"],

Cell[BoxData[{
 RowBox[{"DefConstantSymbol", "[", 
  RowBox[{"Mass", ",", 
   RowBox[{"PrintAs", "\[Rule]", "\"\<M\>\""}]}], "]"}], "\n", 
 RowBox[{"DefConstantSymbol", "[", 
  RowBox[{"Rotation", ",", 
   RowBox[{"PrintAs", "\[Rule]", "\"\<a\>\""}]}], "]"}], "\n", 
 RowBox[{"DefConstantSymbol", "[", 
  RowBox[{"Charge", ",", 
   RowBox[{"PrintAs", "\[Rule]", "\"\<Q\>\""}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefConstantSymbol", "[", 
  RowBox[{"CosmoC", ",", 
   RowBox[{"PrintAs", "\[Rule]", "\"\<\[CapitalLambda]\>\""}]}], 
  "]"}]}], "Input",ExpressionUUID->"a8eca314-70b2-4177-920d-a55422fdd44d"],

Cell["In Boyer\[Dash]Lindquist-like coordinates:", "Text",ExpressionUUID->"396513f9-2dad-4d97-9052-17775ba2f9da"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[CapitalXi]", "=", 
   RowBox[{"1", "+", 
    RowBox[{"CosmoC", " ", 
     RowBox[{
      RowBox[{"Rotation", "^", "2"}], "/", "3"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Deltar", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"CosmoC", " ", 
        RowBox[{
         RowBox[{
          RowBox[{"r", "[", "]"}], "^", "2"}], "/", "3"}]}]}], ")"}], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"r", "[", "]"}], "^", "2"}], "+", 
       RowBox[{"Rotation", "^", "2"}]}], ")"}]}], "+", 
    RowBox[{"Charge", "^", "2"}], "-", 
    RowBox[{"2", "\[CapitalXi]", " ", "Mass", " ", 
     RowBox[{"r", "[", "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Delta\[Theta]", "=", 
   RowBox[{"1", "+", 
    RowBox[{"CosmoC", " ", 
     RowBox[{"Rotation", "^", "2"}], 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", 
        RowBox[{"\[Theta]", "[", "]"}], "]"}], "^", "2"}], "/", "3"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Sigma", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"r", "[", "]"}], "^", "2"}], "+", 
    RowBox[{
     RowBox[{"Rotation", "^", "2"}], 
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"\[Theta]", "[", "]"}], "]"}], "^", "2"}]}]}]}], 
  ";"}]}], "Input",ExpressionUUID->"a3099149-ef68-4caa-8576-6e861cee3bc2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ds2", "=", 
   RowBox[{
    RowBox[{
     FractionBox["Sigma", "Deltar"], 
     RowBox[{"dr", "^", "2"}]}], "+", 
    RowBox[{
     FractionBox["Sigma", "Delta\[Theta]"], 
     RowBox[{"d\[Theta]", "^", "2"}]}], "+", 
    RowBox[{
     FractionBox[
      RowBox[{
       RowBox[{"Sin", "[", 
        RowBox[{"\[Theta]", "[", "]"}], "]"}], "^", "2"}], 
      RowBox[{
       RowBox[{"\[CapitalXi]", "^", "2"}], "Sigma"}]], "Delta\[Theta]", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Rotation", " ", "dt"}], "-", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"r", "[", "]"}], "^", "2"}], "+", 
           RowBox[{"Rotation", "^", "2"}]}], ")"}], "d\[Phi]"}]}], ")"}], "^",
       "2"}]}], "-", 
    RowBox[{
     FractionBox["Deltar", 
      RowBox[{
       RowBox[{"\[CapitalXi]", "^", "2"}], "Sigma"}]], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"dt", "-", 
        RowBox[{"Rotation", " ", 
         RowBox[{
          RowBox[{"Sin", "[", 
           RowBox[{"\[Theta]", "[", "]"}], "]"}], "^", "2"}], "d\[Phi]"}]}], 
       ")"}], "^", "2"}]}]}]}], ";"}]], "Input",ExpressionUUID->"3c2f674b-\
51d2-4f08-a380-e87684903fd8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixForm", "[", 
  RowBox[{"KNdSMatrix", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"CoefficientArrays", "[", 
       RowBox[{"ds2", ",", 
        RowBox[{"{", 
         RowBox[{"dt", ",", "dr", ",", "d\[Theta]", ",", "d\[Phi]"}], "}"}], 
        ",", 
        RowBox[{"\"\<Symmetric\>\"", "\[Rule]", "True"}]}], "]"}], "[", 
      RowBox[{"[", "3", "]"}], "]"}], "//", "Normal"}], "//", "Simplify"}]}], 
  "]"}]], "Input",ExpressionUUID->"2f46a003-9bea-4f1a-b485-d5b8c0923bbe"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox[
       RowBox[{"3", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "3"}], " ", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["Q",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Charge,
             Editable->False], "2"]}], "-", 
          RowBox[{"3", " ", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["a",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Rotation,
             Editable->False], "2"]}], "+", 
          RowBox[{"6", " ", 
           InterpretationBox[
            StyleBox["M",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Mass,
            Editable->False], " ", 
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False]}], "+", 
          RowBox[{"2", " ", 
           InterpretationBox[
            StyleBox["\[CapitalLambda]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`CosmoC,
            Editable->False], " ", 
           InterpretationBox[
            StyleBox["M",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Mass,
            Editable->False], " ", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["a",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Rotation,
             Editable->False], "2"], " ", 
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False]}], "-", 
          RowBox[{"3", " ", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False], "2"]}], "+", 
          RowBox[{
           InterpretationBox[
            StyleBox["\[CapitalLambda]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`CosmoC,
            Editable->False], " ", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["a",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Rotation,
             Editable->False], "2"], " ", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False], "2"]}], "+", 
          RowBox[{
           InterpretationBox[
            StyleBox["\[CapitalLambda]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`CosmoC,
            Editable->False], " ", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False], "4"]}], "+", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["a",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Rotation,
             Editable->False], "2"], " ", 
           RowBox[{"(", 
            RowBox[{"3", "+", 
             RowBox[{
              InterpretationBox[
               StyleBox["\[CapitalLambda]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`CosmoC,
               Editable->False], " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["a",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Rotation,
                Editable->False], "2"], " ", 
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["Cos",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 Cos,
                 Editable->False], "[", 
                InterpretationBox[
                 StyleBox["\[Theta]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Theta][],
                 Editable->False], "]"}], "2"]}]}], ")"}], " ", 
           SuperscriptBox[
            RowBox[{
             InterpretationBox[
              StyleBox["Sin",
               ShowAutoStyles->False,
               AutoSpacing->False],
              Sin,
              Editable->False], "[", 
             InterpretationBox[
              StyleBox["\[Theta]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Theta][],
              Editable->False], "]"}], "2"]}]}], ")"}]}], 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"3", "+", 
           RowBox[{
            InterpretationBox[
             StyleBox["\[CapitalLambda]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`CosmoC,
             Editable->False], " ", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["a",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Rotation,
              Editable->False], "2"]}]}], ")"}], "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["a",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Rotation,
             Editable->False], "2"], " ", 
           SuperscriptBox[
            RowBox[{
             InterpretationBox[
              StyleBox["Cos",
               ShowAutoStyles->False,
               AutoSpacing->False],
              Cos,
              Editable->False], "[", 
             InterpretationBox[
              StyleBox["\[Theta]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Theta][],
              Editable->False], "]"}], "2"]}], "+", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], "2"]}], ")"}]}]], "0", "0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"3", " ", 
         InterpretationBox[
          StyleBox["a",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Rotation,
          Editable->False], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "6"}], " ", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["Q",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Charge,
              Editable->False], "2"]}], "+", 
           RowBox[{
            InterpretationBox[
             StyleBox["\[CapitalLambda]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`CosmoC,
             Editable->False], " ", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["a",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Rotation,
              Editable->False], "4"]}], "+", 
           RowBox[{"12", " ", 
            InterpretationBox[
             StyleBox["M",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Mass,
             Editable->False], " ", 
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False]}], "+", 
           RowBox[{"4", " ", 
            InterpretationBox[
             StyleBox["\[CapitalLambda]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`CosmoC,
             Editable->False], " ", 
            InterpretationBox[
             StyleBox["M",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Mass,
             Editable->False], " ", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["a",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Rotation,
              Editable->False], "2"], " ", 
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False]}], "+", 
           RowBox[{"3", " ", 
            InterpretationBox[
             StyleBox["\[CapitalLambda]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`CosmoC,
             Editable->False], " ", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["a",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Rotation,
              Editable->False], "2"], " ", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False], "2"]}], "+", 
           RowBox[{"2", " ", 
            InterpretationBox[
             StyleBox["\[CapitalLambda]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`CosmoC,
             Editable->False], " ", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False], "4"]}], "+", 
           RowBox[{
            InterpretationBox[
             StyleBox["\[CapitalLambda]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`CosmoC,
             Editable->False], " ", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["a",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Rotation,
              Editable->False], "2"], " ", 
            RowBox[{
             InterpretationBox[
              StyleBox["Cos",
               ShowAutoStyles->False,
               AutoSpacing->False],
              Cos,
              Editable->False], "[", 
             RowBox[{"2", " ", 
              InterpretationBox[
               StyleBox["\[Theta]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Theta][],
               Editable->False]}], "]"}], " ", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox[
               InterpretationBox[
                StyleBox["a",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Rotation,
                Editable->False], "2"], "+", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False], "2"]}], ")"}]}]}], ")"}], " ", 
         SuperscriptBox[
          RowBox[{
           InterpretationBox[
            StyleBox["Sin",
             ShowAutoStyles->False,
             AutoSpacing->False],
            Sin,
            Editable->False], "[", 
           InterpretationBox[
            StyleBox["\[Theta]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`\[Theta][],
            Editable->False], "]"}], "2"]}], 
        RowBox[{"2", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"3", "+", 
            RowBox[{
             InterpretationBox[
              StyleBox["\[CapitalLambda]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`CosmoC,
              Editable->False], " ", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["a",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Rotation,
               Editable->False], "2"]}]}], ")"}], "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            SuperscriptBox[
             InterpretationBox[
              StyleBox["a",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Rotation,
              Editable->False], "2"], " ", 
            SuperscriptBox[
             RowBox[{
              InterpretationBox[
               StyleBox["Cos",
                ShowAutoStyles->False,
                AutoSpacing->False],
               Cos,
               Editable->False], "[", 
              InterpretationBox[
               StyleBox["\[Theta]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Theta][],
               Editable->False], "]"}], "2"]}], "+", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False], "2"]}], ")"}]}]]}]},
     {"0", 
      FractionBox[
       RowBox[{
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["a",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Rotation,
           Editable->False], "2"], " ", 
         SuperscriptBox[
          RowBox[{
           InterpretationBox[
            StyleBox["Cos",
             ShowAutoStyles->False,
             AutoSpacing->False],
            Cos,
            Editable->False], "[", 
           InterpretationBox[
            StyleBox["\[Theta]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`\[Theta][],
            Editable->False], "]"}], "2"]}], "+", 
        SuperscriptBox[
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False], "2"]}], 
       RowBox[{
        SuperscriptBox[
         InterpretationBox[
          StyleBox["Q",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Charge,
          Editable->False], "2"], "-", 
        RowBox[{
         FractionBox["2", "3"], " ", 
         InterpretationBox[
          StyleBox["M",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Mass,
          Editable->False], " ", 
         RowBox[{"(", 
          RowBox[{"3", "+", 
           RowBox[{
            InterpretationBox[
             StyleBox["\[CapitalLambda]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`CosmoC,
             Editable->False], " ", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["a",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Rotation,
              Editable->False], "2"]}]}], ")"}], " ", 
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["a",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Rotation,
             Editable->False], "2"], "+", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False], "2"]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           FractionBox[
            RowBox[{
             InterpretationBox[
              StyleBox["\[CapitalLambda]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`CosmoC,
              Editable->False], " ", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], "2"]}], "3"]}], ")"}]}]}]], "0", "0"},
     {"0", "0", 
      FractionBox[
       RowBox[{"3", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["a",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Rotation,
             Editable->False], "2"], " ", 
           SuperscriptBox[
            RowBox[{
             InterpretationBox[
              StyleBox["Cos",
               ShowAutoStyles->False,
               AutoSpacing->False],
              Cos,
              Editable->False], "[", 
             InterpretationBox[
              StyleBox["\[Theta]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Theta][],
              Editable->False], "]"}], "2"]}], "+", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], "2"]}], ")"}]}], 
       RowBox[{"3", "+", 
        RowBox[{
         InterpretationBox[
          StyleBox["\[CapitalLambda]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`CosmoC,
          Editable->False], " ", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["a",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Rotation,
           Editable->False], "2"], " ", 
         SuperscriptBox[
          RowBox[{
           InterpretationBox[
            StyleBox["Cos",
             ShowAutoStyles->False,
             AutoSpacing->False],
            Cos,
            Editable->False], "[", 
           InterpretationBox[
            StyleBox["\[Theta]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`\[Theta][],
            Editable->False], "]"}], "2"]}]}]], "0"},
     {
      RowBox[{"-", 
       FractionBox[
        RowBox[{"3", " ", 
         InterpretationBox[
          StyleBox["a",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Rotation,
          Editable->False], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "6"}], " ", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["Q",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Charge,
              Editable->False], "2"]}], "+", 
           RowBox[{
            InterpretationBox[
             StyleBox["\[CapitalLambda]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`CosmoC,
             Editable->False], " ", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["a",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Rotation,
              Editable->False], "4"]}], "+", 
           RowBox[{"12", " ", 
            InterpretationBox[
             StyleBox["M",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Mass,
             Editable->False], " ", 
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False]}], "+", 
           RowBox[{"4", " ", 
            InterpretationBox[
             StyleBox["\[CapitalLambda]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`CosmoC,
             Editable->False], " ", 
            InterpretationBox[
             StyleBox["M",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Mass,
             Editable->False], " ", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["a",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Rotation,
              Editable->False], "2"], " ", 
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False]}], "+", 
           RowBox[{"3", " ", 
            InterpretationBox[
             StyleBox["\[CapitalLambda]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`CosmoC,
             Editable->False], " ", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["a",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Rotation,
              Editable->False], "2"], " ", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False], "2"]}], "+", 
           RowBox[{"2", " ", 
            InterpretationBox[
             StyleBox["\[CapitalLambda]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`CosmoC,
             Editable->False], " ", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False], "4"]}], "+", 
           RowBox[{
            InterpretationBox[
             StyleBox["\[CapitalLambda]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`CosmoC,
             Editable->False], " ", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["a",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Rotation,
              Editable->False], "2"], " ", 
            RowBox[{
             InterpretationBox[
              StyleBox["Cos",
               ShowAutoStyles->False,
               AutoSpacing->False],
              Cos,
              Editable->False], "[", 
             RowBox[{"2", " ", 
              InterpretationBox[
               StyleBox["\[Theta]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Theta][],
               Editable->False]}], "]"}], " ", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox[
               InterpretationBox[
                StyleBox["a",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Rotation,
                Editable->False], "2"], "+", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False], "2"]}], ")"}]}]}], ")"}], " ", 
         SuperscriptBox[
          RowBox[{
           InterpretationBox[
            StyleBox["Sin",
             ShowAutoStyles->False,
             AutoSpacing->False],
            Sin,
            Editable->False], "[", 
           InterpretationBox[
            StyleBox["\[Theta]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`\[Theta][],
            Editable->False], "]"}], "2"]}], 
        RowBox[{"2", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"3", "+", 
            RowBox[{
             InterpretationBox[
              StyleBox["\[CapitalLambda]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`CosmoC,
              Editable->False], " ", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["a",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Rotation,
               Editable->False], "2"]}]}], ")"}], "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            SuperscriptBox[
             InterpretationBox[
              StyleBox["a",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Rotation,
              Editable->False], "2"], " ", 
            SuperscriptBox[
             RowBox[{
              InterpretationBox[
               StyleBox["Cos",
                ShowAutoStyles->False,
                AutoSpacing->False],
               Cos,
               Editable->False], "[", 
              InterpretationBox[
               StyleBox["\[Theta]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Theta][],
               Editable->False], "]"}], "2"]}], "+", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False], "2"]}], ")"}]}]]}], "0", "0", 
      FractionBox[
       RowBox[{"3", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "3"}], " ", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["Q",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Charge,
             Editable->False], "2"], " ", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["a",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Rotation,
             Editable->False], "2"]}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"3", "+", 
             RowBox[{
              InterpretationBox[
               StyleBox["\[CapitalLambda]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`CosmoC,
               Editable->False], " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["a",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Rotation,
                Editable->False], "2"]}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox[
              InterpretationBox[
               StyleBox["a",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Rotation,
               Editable->False], "4"], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False], "4"]}], "+", 
             RowBox[{
              SuperscriptBox[
               InterpretationBox[
                StyleBox["a",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Rotation,
                Editable->False], "2"], " ", 
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"2", " ", 
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False]}], "+", 
                RowBox[{"3", " ", 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]}]}], ")"}]}]}], ")"}]}], "+", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["a",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Rotation,
             Editable->False], "2"], " ", 
           RowBox[{
            InterpretationBox[
             StyleBox["Cos",
              ShowAutoStyles->False,
              AutoSpacing->False],
             Cos,
             Editable->False], "[", 
            RowBox[{"2", " ", 
             InterpretationBox[
              StyleBox["\[Theta]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Theta][],
              Editable->False]}], "]"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"3", " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["Q",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Charge,
                Editable->False], "2"]}], "+", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"3", "+", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["\[CapitalLambda]",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`CosmoC,
                  Editable->False], " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["a",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Rotation,
                   Editable->False], "2"]}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["a",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Rotation,
                  Editable->False], "2"], "-", 
                RowBox[{"2", " ", 
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]}], "+", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "2"]}], ")"}]}]}], ")"}]}]}], ")"}], " ", 
        
        SuperscriptBox[
         RowBox[{
          InterpretationBox[
           StyleBox["Sin",
            ShowAutoStyles->False,
            AutoSpacing->False],
           Sin,
           Editable->False], "[", 
          InterpretationBox[
           StyleBox["\[Theta]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Theta][],
           Editable->False], "]"}], "2"]}], 
       RowBox[{"2", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"3", "+", 
           RowBox[{
            InterpretationBox[
             StyleBox["\[CapitalLambda]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`CosmoC,
             Editable->False], " ", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["a",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Rotation,
              Editable->False], "2"]}]}], ")"}], "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["a",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Rotation,
             Editable->False], "2"], " ", 
           SuperscriptBox[
            RowBox[{
             InterpretationBox[
              StyleBox["Cos",
               ShowAutoStyles->False,
               AutoSpacing->False],
              Cos,
              Editable->False], "[", 
             InterpretationBox[
              StyleBox["\[Theta]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Theta][],
              Editable->False], "]"}], "2"]}], "+", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], "2"]}], ")"}]}]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",ExpressionUUID->"883810c0-02aa-452a-\
8a91-cfc3e7c4f735"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"met", "=", 
   RowBox[{"CTensor", "[", 
    RowBox[{"KNdSMatrix", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "BL"}], ",", 
       RowBox[{"-", "BL"}]}], "}"}]}], "]"}]}], ";"}]], "Input",ExpressionUUID\
->"3e8223dd-5335-4f2c-bf91-f5e9bb62ec2b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$CVSimplify", "=", "Together"}], ";"}]], "Input",ExpressionUUID->\
"95da9c51-6df1-4014-9b6d-930107e94b8a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"SetCMetric", "[", 
   RowBox[{"met", ",", "BL", ",", 
    RowBox[{"SignatureOfMetric", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"3", ",", "1", ",", "0"}], "}"}]}]}], "]"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"3c03c09c-3042-4569-bcaf-\
584a0092a557"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.776632`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"f8de657b-08e5-4363-b084-891149557fb1"]
}, Open  ]],

Cell["Compute Riemann tensor:", "Text",ExpressionUUID->"fe7996a8-b925-46af-baf5-71ade09e0dc6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MetricCompute", "[", 
   RowBox[{"met", ",", "BL", ",", 
    RowBox[{"\"\<Riemann\>\"", "[", 
     RowBox[{
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}], ",", "1"}], "]"}], ",", 
    RowBox[{"Verbose", "\[Rule]", "True"}]}], "]"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"be115185-9d7f-4f19-9f00-\
448de9e4cc42"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** ReportCompute: \"\>", "\[InvisibleSpace]", 
   RowBox[{"\<\"Metric\"\>", "[", 
    RowBox[{"1", ",", "1"}], "]"}]}],
  SequenceForm["** ReportCompute: ", 
   "Metric"[1, 1]],
  Editable->False]], "Print",ExpressionUUID->"b1ff4fd4-8f63-48fb-92cc-\
60c70a17f8d1"],

Cell[BoxData["\<\"    Already cached\"\>"], "Print",ExpressionUUID->"ff912030-38cf-46af-8071-3cb9b4118662"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** ReportCompute: \"\>", "\[InvisibleSpace]", 
   RowBox[{"\<\"DMetric\"\>", "[", 
    RowBox[{
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}]}], "]"}]}],
  SequenceForm["** ReportCompute: ", 
   "DMetric"[-1, -1, -1]],
  Editable->False]], "Print",ExpressionUUID->"284b4daa-e9bb-492b-9641-\
948dc7abdae9"],

Cell[BoxData["\<\"    Already cached\"\>"], "Print",ExpressionUUID->"125608e7-04bf-46c8-9da0-d2f1b649250d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** ReportCompute: \"\>", "\[InvisibleSpace]", 
   RowBox[{"\<\"DDMetric\"\>", "[", 
    RowBox[{
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}]}], "]"}]}],
  SequenceForm["** ReportCompute: ", 
   "DDMetric"[-1, -1, -1, -1]],
  Editable->False]], "Print",ExpressionUUID->"3f1292a7-6006-4768-b1e3-\
121664dd6d3a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Constructed in \"\>", "\[InvisibleSpace]", "0.004096`", 
   "\[InvisibleSpace]", "\<\" seconds\"\>"}],
  SequenceForm["    Constructed in ", 0.004096, " seconds"],
  Editable->False]], "Print",ExpressionUUID->"8c962884-a079-4ce5-a26d-\
7b179255ee21"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Applied \"\>", "\[InvisibleSpace]", "Together", 
   "\[InvisibleSpace]", "\<\" in \"\>", "\[InvisibleSpace]", "0.079314`", 
   "\[InvisibleSpace]", "\<\" seconds\"\>"}],
  SequenceForm["    Applied ", Together, " in ", 0.079314, " seconds"],
  Editable->False]], "Print",ExpressionUUID->"58a823c9-d40d-49d8-824a-\
13ddeb6ef557"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** ReportCompute: \"\>", "\[InvisibleSpace]", 
   RowBox[{"\<\"Christoffel\"\>", "[", 
    RowBox[{
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}]}], "]"}]}],
  SequenceForm["** ReportCompute: ", 
   "Christoffel"[-1, -1, -1]],
  Editable->False]], "Print",ExpressionUUID->"70037229-f75e-4cc8-a163-\
e9e120456a65"],

Cell[BoxData["\<\"    Already cached\"\>"], "Print",ExpressionUUID->"a998095a-efcf-44b1-9388-5d133cadf786"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** ReportCompute: \"\>", "\[InvisibleSpace]", 
   RowBox[{"\<\"Christoffel\"\>", "[", 
    RowBox[{"1", ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}]}], "]"}]}],
  SequenceForm["** ReportCompute: ", 
   "Christoffel"[1, -1, -1]],
  Editable->False]], "Print",ExpressionUUID->"ff7eead7-38b1-4fde-94e7-\
cd7918f939f7"],

Cell[BoxData["\<\"    Already cached\"\>"], "Print",ExpressionUUID->"10ecf00c-bbfd-45f3-b93f-ed93caa957c4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** ReportCompute: \"\>", 
   "\[InvisibleSpace]", "\<\"CovDOfMetric\"\>"}],
  SequenceForm["** ReportCompute: ", "CovDOfMetric"],
  Editable->False]], "Print",ExpressionUUID->"d4da6a14-cb65-41d0-ae32-\
d20bd88c2bc0"],

Cell[BoxData["\<\"    Already cached\"\>"], "Print",ExpressionUUID->"f73f2cc5-8d34-4f60-b3c9-4a4a00321492"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** ReportCompute: \"\>", "\[InvisibleSpace]", 
   RowBox[{"\<\"Riemann\"\>", "[", 
    RowBox[{
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}]}], "]"}]}],
  SequenceForm["** ReportCompute: ", 
   "Riemann"[-1, -1, -1, -1]],
  Editable->False]], "Print",ExpressionUUID->"c649fe06-b9fe-4ef5-b6ab-\
74fe41cae865"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Constructed in \"\>", "\[InvisibleSpace]", "0.003543`", 
   "\[InvisibleSpace]", "\<\" seconds\"\>"}],
  SequenceForm["    Constructed in ", 0.003543, " seconds"],
  Editable->False]], "Print",ExpressionUUID->"af020585-d017-40ca-8d08-\
ad52b5b1aff8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Applied \"\>", "\[InvisibleSpace]", "Together", 
   "\[InvisibleSpace]", "\<\" in \"\>", "\[InvisibleSpace]", "3.690539`", 
   "\[InvisibleSpace]", "\<\" seconds\"\>"}],
  SequenceForm["    Applied ", Together, " in ", 3.690539, " seconds"],
  Editable->False]], "Print",ExpressionUUID->"6826cdb7-0098-4c95-b89b-\
6c9280118484"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Stored in \"\>", "\[InvisibleSpace]", "0.700531`", 
   "\[InvisibleSpace]", "\<\" seconds and \"\>", "\[InvisibleSpace]", 
   "177578632", "\[InvisibleSpace]", "\<\" bytes\"\>"}],
  SequenceForm[
  "    Stored in ", 0.700531, " seconds and ", 177578632, " bytes"],
  Editable->False]], "Print",ExpressionUUID->"a2071fb2-88aa-4dba-8b8e-\
4826937a4b15"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** ReportCompute: \"\>", "\[InvisibleSpace]", 
   RowBox[{"\<\"Riemann\"\>", "[", 
    RowBox[{
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", "1"}], "]"}]}],
  SequenceForm["** ReportCompute: ", 
   "Riemann"[-1, -1, -1, 1]],
  Editable->False]], "Print",ExpressionUUID->"acd8b4e5-5598-4336-97f5-\
f516f263ce4f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Constructed in \"\>", "\[InvisibleSpace]", "0.100951`", 
   "\[InvisibleSpace]", "\<\" seconds\"\>"}],
  SequenceForm["    Constructed in ", 0.100951, " seconds"],
  Editable->False]], "Print",ExpressionUUID->"5c982023-89c6-4fc9-a534-\
963acef02be0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Applied \"\>", "\[InvisibleSpace]", "Together", 
   "\[InvisibleSpace]", "\<\" in \"\>", "\[InvisibleSpace]", "21.670113`", 
   "\[InvisibleSpace]", "\<\" seconds\"\>"}],
  SequenceForm["    Applied ", Together, " in ", 21.670113, " seconds"],
  Editable->False]], "Print",ExpressionUUID->"a019ce42-a9c7-4381-b99d-\
62423fa3fc9b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    Stored in \"\>", "\[InvisibleSpace]", "1.689447`", 
   "\[InvisibleSpace]", "\<\" seconds and \"\>", "\[InvisibleSpace]", 
   "341347392", "\[InvisibleSpace]", "\<\" bytes\"\>"}],
  SequenceForm[
  "    Stored in ", 1.689447, " seconds and ", 341347392, " bytes"],
  Editable->False]], "Print",ExpressionUUID->"bad8c5c5-e583-41f9-a190-\
ac449efb5b3f"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"30.450703`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"73776096-eff6-4e9c-9358-f811ed6e9eb5"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"CD", "=", 
   RowBox[{"CovDOfMetric", "[", "met", "]"}]}], ";"}]], "Input",ExpressionUUID\
->"ceb7d1be-bd69-45dd-a6ab-8eb1a56f7f10"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ByteCount", "[", 
  RowBox[{"Riemann", "[", "CD", "]"}], "]"}]], "Input",ExpressionUUID->\
"473d7b02-d38e-4be0-bcec-75f72b0cca66"],

Cell[BoxData["341351568"], "Output",ExpressionUUID->"c1fa57dc-43ea-4cd0-8c21-963cac0a6ed8"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"$CVSimplify", "=", "Identity"}], ";"}]], "Input",ExpressionUUID->\
"04fc80c0-e819-4297-a1e1-450b2728fcdd"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ricci", "=", 
    RowBox[{"Ricci", "[", "CD", "]"}]}], ";"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"1ebdb396-1ca0-4cc8-9f7c-\
b5e606ce251e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.168856`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"b3f184a3-6b7e-45c4-9bda-cb7314a985f6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Map", "[", 
   RowBox[{"ByteCount", ",", 
    RowBox[{"ricci", "[", 
     RowBox[{"[", "1", "]"}], "]"}], ",", 
    RowBox[{"{", "2", "}"}]}], "]"}], "//", "MatrixForm"}]], "Input",Expressio\
nUUID->"f14094d1-3690-4d7a-a734-96536fd0ce24"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"5950696", "16", "16", "8132840"},
     {"16", "23938592", "13212304", "16"},
     {"16", "13203752", "33457720", "16"},
     {"8132960", "16", "16", "11835624"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",ExpressionUUID->"477a6a71-f382-4371-\
8210-8dd0bb71a0cd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ricci", "=", 
    RowBox[{"Together", "[", "ricci", "]"}]}], ";"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"5ba1ab09-8dd7-4f7c-98fb-\
4d99c0414c59"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"14.846338`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"2c5ce4f2-6636-48e0-9265-1f28eabbaf17"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Map", "[", 
   RowBox[{"ByteCount", ",", 
    RowBox[{"ricci", "[", 
     RowBox[{"[", "1", "]"}], "]"}], ",", 
    RowBox[{"{", "2", "}"}]}], "]"}], "//", "MatrixForm"}]], "Input",Expressio\
nUUID->"dee6bf91-0b58-4a1f-8540-73204a0a41df"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"3560176", "16", "16", "4646296"},
     {"16", "13661528", "8069952", "16"},
     {"16", "8069952", "19769624", "16"},
     {"4646296", "16", "16", "7050752"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",ExpressionUUID->"328f1f7c-d25d-4e16-\
b23e-2d5575dca343"]
}, Open  ]],

Cell["\<\
We separate components to see which ones are harder. We see that we are \
missing the terms proportional to the charge:\
\>", "Text",ExpressionUUID->"0c99c66f-6057-4ffa-9ce1-62c0c8d3de49"],

Cell[BoxData[
 RowBox[{
  RowBox[{"diff", "=", 
   RowBox[{"ricci", "-", 
    RowBox[{"CosmoC", " ", "met"}]}]}], ";"}]], "Input",ExpressionUUID->\
"c9269579-2860-40d0-a232-c1607eda31d6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"diff", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"-", "BL"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"-", "BL"}]}], "}"}]}], "]"}], "//", "Simplify"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"9c783a3c-0ba1-4eff-ba3e-\
6d3be5186856"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"4.706979`", ",", 
   FractionBox[
    RowBox[{"3", " ", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["Q",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`Charge,
       Editable->False], "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"24", " ", 
        SuperscriptBox[
         InterpretationBox[
          StyleBox["Q",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Charge,
          Editable->False], "2"]}], "+", 
       RowBox[{"36", " ", 
        SuperscriptBox[
         InterpretationBox[
          StyleBox["a",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Rotation,
          Editable->False], "2"]}], "+", 
       RowBox[{
        InterpretationBox[
         StyleBox["\[CapitalLambda]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`CosmoC,
         Editable->False], " ", 
        SuperscriptBox[
         InterpretationBox[
          StyleBox["a",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Rotation,
          Editable->False], "4"]}], "-", 
       RowBox[{"12", " ", 
        SuperscriptBox[
         InterpretationBox[
          StyleBox["a",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Rotation,
          Editable->False], "2"], " ", 
        RowBox[{
         InterpretationBox[
          StyleBox["Cos",
           ShowAutoStyles->False,
           AutoSpacing->False],
          Cos,
          Editable->False], "[", 
         RowBox[{"2", " ", 
          InterpretationBox[
           StyleBox["\[Theta]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Theta][],
           Editable->False]}], "]"}]}], "-", 
       RowBox[{
        InterpretationBox[
         StyleBox["\[CapitalLambda]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`CosmoC,
         Editable->False], " ", 
        SuperscriptBox[
         InterpretationBox[
          StyleBox["a",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Rotation,
          Editable->False], "4"], " ", 
        RowBox[{
         InterpretationBox[
          StyleBox["Cos",
           ShowAutoStyles->False,
           AutoSpacing->False],
          Cos,
          Editable->False], "[", 
         RowBox[{"4", " ", 
          InterpretationBox[
           StyleBox["\[Theta]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Theta][],
           Editable->False]}], "]"}]}], "-", 
       RowBox[{"48", " ", 
        InterpretationBox[
         StyleBox["M",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Mass,
         Editable->False], " ", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False]}], "-", 
       RowBox[{"16", " ", 
        InterpretationBox[
         StyleBox["\[CapitalLambda]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`CosmoC,
         Editable->False], " ", 
        InterpretationBox[
         StyleBox["M",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Mass,
         Editable->False], " ", 
        SuperscriptBox[
         InterpretationBox[
          StyleBox["a",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Rotation,
          Editable->False], "2"], " ", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False]}], "+", 
       RowBox[{"24", " ", 
        SuperscriptBox[
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False], "2"]}], "-", 
       RowBox[{"8", " ", 
        InterpretationBox[
         StyleBox["\[CapitalLambda]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`CosmoC,
         Editable->False], " ", 
        SuperscriptBox[
         InterpretationBox[
          StyleBox["a",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Rotation,
          Editable->False], "2"], " ", 
        SuperscriptBox[
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False], "2"]}], "-", 
       RowBox[{"8", " ", 
        InterpretationBox[
         StyleBox["\[CapitalLambda]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`CosmoC,
         Editable->False], " ", 
        SuperscriptBox[
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False], "4"]}]}], ")"}]}], 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"3", "+", 
        RowBox[{
         InterpretationBox[
          StyleBox["\[CapitalLambda]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`CosmoC,
          Editable->False], " ", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["a",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Rotation,
           Editable->False], "2"]}]}], ")"}], "2"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox[
         InterpretationBox[
          StyleBox["a",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Rotation,
          Editable->False], "2"], "+", 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["a",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Rotation,
           Editable->False], "2"], " ", 
         RowBox[{
          InterpretationBox[
           StyleBox["Cos",
            ShowAutoStyles->False,
            AutoSpacing->False],
           Cos,
           Editable->False], "[", 
          RowBox[{"2", " ", 
           InterpretationBox[
            StyleBox["\[Theta]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`\[Theta][],
            Editable->False]}], "]"}]}], "+", 
        RowBox[{"2", " ", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], "2"]}]}], ")"}], "3"]}]]}], "}"}]], "Output",Expr\
essionUUID->"aa942ace-92fd-4e23-9778-dedef06f350f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"diff", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"-", "BL"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "BL"}]}], "}"}]}], "]"}], "//", "Simplify"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"7880bcc2-7359-4bff-91ff-\
8b5cb7411739"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.088334`", ",", "0"}], "}"}]], "Output",ExpressionUUID->"a347cefb-\
8f00-4d65-a245-9ba016f35a94"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"diff", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"-", "BL"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", 
       RowBox[{"-", "BL"}]}], "}"}]}], "]"}], "//", "Simplify"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"4f895cae-9cd0-4edc-9572-\
9ab3a31f62ac"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.085363`", ",", "0"}], "}"}]], "Output",ExpressionUUID->"c7ab9191-\
1872-428e-8ac8-4f2df3c3ae60"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"diff", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"-", "BL"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", 
       RowBox[{"-", "BL"}]}], "}"}]}], "]"}], "//", "Simplify"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"54a04513-af43-4adb-a7f6-\
feb9e97a3bad"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"7.59764`", ",", 
   RowBox[{"-", 
    FractionBox[
     RowBox[{"12", " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["Q",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`Charge,
        Editable->False], "2"], " ", 
      InterpretationBox[
       StyleBox["a",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`Rotation,
       Editable->False], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"6", " ", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["Q",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Charge,
           Editable->False], "2"]}], "+", 
        RowBox[{"12", " ", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["a",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Rotation,
           Editable->False], "2"]}], "+", 
        RowBox[{
         InterpretationBox[
          StyleBox["\[CapitalLambda]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`CosmoC,
          Editable->False], " ", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["a",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Rotation,
           Editable->False], "4"]}], "-", 
        RowBox[{"12", " ", 
         InterpretationBox[
          StyleBox["M",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Mass,
          Editable->False], " ", 
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False]}], "-", 
        RowBox[{"4", " ", 
         InterpretationBox[
          StyleBox["\[CapitalLambda]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`CosmoC,
          Editable->False], " ", 
         InterpretationBox[
          StyleBox["M",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Mass,
          Editable->False], " ", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["a",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Rotation,
           Editable->False], "2"], " ", 
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False]}], "+", 
        RowBox[{"12", " ", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], "2"]}], "-", 
        RowBox[{
         InterpretationBox[
          StyleBox["\[CapitalLambda]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`CosmoC,
          Editable->False], " ", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["a",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Rotation,
           Editable->False], "2"], " ", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], "2"]}], "-", 
        RowBox[{"2", " ", 
         InterpretationBox[
          StyleBox["\[CapitalLambda]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`CosmoC,
          Editable->False], " ", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], "4"]}], "+", 
        RowBox[{
         InterpretationBox[
          StyleBox["\[CapitalLambda]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`CosmoC,
          Editable->False], " ", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["a",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Rotation,
           Editable->False], "2"], " ", 
         RowBox[{
          InterpretationBox[
           StyleBox["Cos",
            ShowAutoStyles->False,
            AutoSpacing->False],
           Cos,
           Editable->False], "[", 
          RowBox[{"2", " ", 
           InterpretationBox[
            StyleBox["\[Theta]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`\[Theta][],
            Editable->False]}], "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["a",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Rotation,
             Editable->False], "2"], "+", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False], "2"]}], ")"}]}]}], ")"}], " ", 
      SuperscriptBox[
       RowBox[{
        InterpretationBox[
         StyleBox["Sin",
          ShowAutoStyles->False,
          AutoSpacing->False],
         Sin,
         Editable->False], "[", 
        InterpretationBox[
         StyleBox["\[Theta]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Theta][],
         Editable->False], "]"}], "2"]}], 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"3", "+", 
         RowBox[{
          InterpretationBox[
           StyleBox["\[CapitalLambda]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`CosmoC,
           Editable->False], " ", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["a",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Rotation,
            Editable->False], "2"]}]}], ")"}], "2"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["a",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Rotation,
           Editable->False], "2"], "+", 
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["a",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Rotation,
            Editable->False], "2"], " ", 
          RowBox[{
           InterpretationBox[
            StyleBox["Cos",
             ShowAutoStyles->False,
             AutoSpacing->False],
            Cos,
            Editable->False], "[", 
           RowBox[{"2", " ", 
            InterpretationBox[
             StyleBox["\[Theta]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Theta][],
             Editable->False]}], "]"}]}], "+", 
         RowBox[{"2", " ", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], "2"]}]}], ")"}], "3"]}]]}]}], "}"}]], "Output",E\
xpressionUUID->"0ebc0a61-77bb-4d19-af02-411ef6679fc0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"diff", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "BL"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "BL"}]}], "}"}]}], "]"}], "//", "Simplify"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"be99230a-9b0c-4e8d-82c0-\
15fdc60e9adc"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"14.072972`", ",", 
   FractionBox[
    RowBox[{"6", " ", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["Q",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`Charge,
       Editable->False], "2"]}], 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox[
        InterpretationBox[
         StyleBox["a",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Rotation,
         Editable->False], "2"], "+", 
       RowBox[{
        SuperscriptBox[
         InterpretationBox[
          StyleBox["a",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Rotation,
          Editable->False], "2"], " ", 
        RowBox[{
         InterpretationBox[
          StyleBox["Cos",
           ShowAutoStyles->False,
           AutoSpacing->False],
          Cos,
          Editable->False], "[", 
         RowBox[{"2", " ", 
          InterpretationBox[
           StyleBox["\[Theta]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Theta][],
           Editable->False]}], "]"}]}], "+", 
       RowBox[{"2", " ", 
        SuperscriptBox[
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False], "2"]}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "3"}], " ", 
        SuperscriptBox[
         InterpretationBox[
          StyleBox["Q",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Charge,
          Editable->False], "2"]}], "+", 
       RowBox[{
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"6", " ", 
           InterpretationBox[
            StyleBox["M",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Mass,
            Editable->False]}], "-", 
          RowBox[{"3", " ", 
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False]}], "+", 
          RowBox[{
           InterpretationBox[
            StyleBox["\[CapitalLambda]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`CosmoC,
            Editable->False], " ", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False], "3"]}]}], ")"}]}], "+", 
       RowBox[{
        SuperscriptBox[
         InterpretationBox[
          StyleBox["a",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Rotation,
          Editable->False], "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "3"}], "+", 
          RowBox[{
           InterpretationBox[
            StyleBox["\[CapitalLambda]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`CosmoC,
            Editable->False], " ", 
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", 
              InterpretationBox[
               StyleBox["M",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Mass,
               Editable->False]}], "+", 
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False]}], ")"}]}]}], ")"}]}]}], ")"}]}]]}], 
  "}"}]], "Output",ExpressionUUID->"03000617-f464-4c73-9f67-ccb33e6a8fe8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"diff", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "BL"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", 
       RowBox[{"-", "BL"}]}], "}"}]}], "]"}], "//", "Simplify"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"be711668-c60e-40de-a414-\
cdebd4ebee61"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"23.000121`", ",", "0"}], "}"}]], "Output",ExpressionUUID->\
"a70e97a6-7af6-492b-8f80-7d4a35f18e51"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"diff", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "BL"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", 
       RowBox[{"-", "BL"}]}], "}"}]}], "]"}], "//", "Simplify"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"04ac1864-e35f-4cb1-b6bd-\
af12ab2c7c7f"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.111836`", ",", "0"}], "}"}]], "Output",ExpressionUUID->"9568456a-\
e283-46cc-80ae-400472670aaf"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"diff", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", 
       RowBox[{"-", "BL"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", 
       RowBox[{"-", "BL"}]}], "}"}]}], "]"}], "//", "Simplify"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"1a9880ad-e359-4617-9543-\
2b2ba33f60a0"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"116.250683`", ",", 
   FractionBox[
    RowBox[{"12", " ", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["Q",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`Charge,
       Editable->False], "2"]}], 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"6", "+", 
       RowBox[{
        InterpretationBox[
         StyleBox["\[CapitalLambda]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`CosmoC,
         Editable->False], " ", 
        SuperscriptBox[
         InterpretationBox[
          StyleBox["a",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Rotation,
          Editable->False], "2"]}], "+", 
       RowBox[{
        InterpretationBox[
         StyleBox["\[CapitalLambda]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`CosmoC,
         Editable->False], " ", 
        SuperscriptBox[
         InterpretationBox[
          StyleBox["a",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Rotation,
          Editable->False], "2"], " ", 
        RowBox[{
         InterpretationBox[
          StyleBox["Cos",
           ShowAutoStyles->False,
           AutoSpacing->False],
          Cos,
          Editable->False], "[", 
         RowBox[{"2", " ", 
          InterpretationBox[
           StyleBox["\[Theta]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Theta][],
           Editable->False]}], "]"}]}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox[
        InterpretationBox[
         StyleBox["a",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Rotation,
         Editable->False], "2"], "+", 
       RowBox[{
        SuperscriptBox[
         InterpretationBox[
          StyleBox["a",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Rotation,
          Editable->False], "2"], " ", 
        RowBox[{
         InterpretationBox[
          StyleBox["Cos",
           ShowAutoStyles->False,
           AutoSpacing->False],
          Cos,
          Editable->False], "[", 
         RowBox[{"2", " ", 
          InterpretationBox[
           StyleBox["\[Theta]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Theta][],
           Editable->False]}], "]"}]}], "+", 
       RowBox[{"2", " ", 
        SuperscriptBox[
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False], "2"]}]}], ")"}]}]]}], "}"}]], "Output",ExpressionU\
UID->"8d89cabe-3d5e-4e8f-8830-74ab6fd015c1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"diff", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", 
       RowBox[{"-", "BL"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", 
       RowBox[{"-", "BL"}]}], "}"}]}], "]"}], "//", "Simplify"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"f61ced39-8291-447c-9e25-\
72c67d3f19a9"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.117903`", ",", "0"}], "}"}]], "Output",ExpressionUUID->"1bb2a98d-\
580a-4eb3-8ed5-919a84a1d0e6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"diff", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", 
       RowBox[{"-", "BL"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", 
       RowBox[{"-", "BL"}]}], "}"}]}], "]"}], "//", "Simplify"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"0218550f-7f25-4c94-afe5-\
decd4a15f9de"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"11.618748`", ",", 
   RowBox[{"-", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"12", " ", 
        SuperscriptBox[
         InterpretationBox[
          StyleBox["Q",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Charge,
          Editable->False], "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "3"}], " ", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["Q",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Charge,
             Editable->False], "2"], " ", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["a",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Rotation,
             Editable->False], "2"]}], "-", 
          RowBox[{"9", " ", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["a",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Rotation,
             Editable->False], "4"]}], "-", 
          RowBox[{
           InterpretationBox[
            StyleBox["\[CapitalLambda]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`CosmoC,
            Editable->False], " ", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["a",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Rotation,
             Editable->False], "6"]}], "+", 
          RowBox[{"6", " ", 
           InterpretationBox[
            StyleBox["M",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Mass,
            Editable->False], " ", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["a",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Rotation,
             Editable->False], "2"], " ", 
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False]}], "+", 
          RowBox[{"2", " ", 
           InterpretationBox[
            StyleBox["\[CapitalLambda]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`CosmoC,
            Editable->False], " ", 
           InterpretationBox[
            StyleBox["M",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Mass,
            Editable->False], " ", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["a",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Rotation,
             Editable->False], "4"], " ", 
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False]}], "-", 
          RowBox[{"15", " ", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["a",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Rotation,
             Editable->False], "2"], " ", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False], "2"]}], "-", 
          RowBox[{
           InterpretationBox[
            StyleBox["\[CapitalLambda]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`CosmoC,
            Editable->False], " ", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["a",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Rotation,
             Editable->False], "4"], " ", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False], "2"]}], "-", 
          RowBox[{"6", " ", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False], "4"]}], "-", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["a",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Rotation,
             Editable->False], "2"], " ", 
           RowBox[{
            InterpretationBox[
             StyleBox["Cos",
              ShowAutoStyles->False,
              AutoSpacing->False],
             Cos,
             Editable->False], "[", 
            RowBox[{"2", " ", 
             InterpretationBox[
              StyleBox["\[Theta]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Theta][],
              Editable->False]}], "]"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "3"}], " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["Q",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Charge,
                Editable->False], "2"]}], "+", 
             RowBox[{
              InterpretationBox[
               StyleBox["\[CapitalLambda]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`CosmoC,
               Editable->False], " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["a",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Rotation,
                Editable->False], "4"]}], "+", 
             RowBox[{
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"6", " ", 
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False]}], "-", 
                RowBox[{"3", " ", 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]}], "+", 
                RowBox[{"2", " ", 
                 InterpretationBox[
                  StyleBox["\[CapitalLambda]",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`CosmoC,
                  Editable->False], " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "3"]}]}], ")"}]}], "+", 
             RowBox[{
              SuperscriptBox[
               InterpretationBox[
                StyleBox["a",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Rotation,
                Editable->False], "2"], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "3"}], "+", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["\[CapitalLambda]",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`CosmoC,
                  Editable->False], " ", 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False]}], "+", 
                   RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], 
         ")"}], " ", 
        SuperscriptBox[
         RowBox[{
          InterpretationBox[
           StyleBox["Sin",
            ShowAutoStyles->False,
            AutoSpacing->False],
           Sin,
           Editable->False], "[", 
          InterpretationBox[
           StyleBox["\[Theta]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Theta][],
           Editable->False], "]"}], "2"]}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"3", "+", 
           RowBox[{
            InterpretationBox[
             StyleBox["\[CapitalLambda]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`CosmoC,
             Editable->False], " ", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["a",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Rotation,
              Editable->False], "2"]}]}], ")"}], "2"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["a",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Rotation,
             Editable->False], "2"], "+", 
           RowBox[{
            SuperscriptBox[
             InterpretationBox[
              StyleBox["a",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Rotation,
              Editable->False], "2"], " ", 
            RowBox[{
             InterpretationBox[
              StyleBox["Cos",
               ShowAutoStyles->False,
               AutoSpacing->False],
              Cos,
              Editable->False], "[", 
             RowBox[{"2", " ", 
              InterpretationBox[
               StyleBox["\[Theta]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Theta][],
               Editable->False]}], "]"}]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False], "2"]}]}], ")"}], "3"]}], ")"}]}], ")"}]}]}], 
  "}"}]], "Output",ExpressionUUID->"db7af5ca-a688-479c-babf-2ff897e44507"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{
  "met", ",", "\[CapitalXi]", ",", "ricci", ",", "diff", ",", "ds2", ",", 
   "dt", ",", "dr", ",", "d\[Theta]", ",", "d\[Phi]", ",", "Deltar", ",", 
   "Delta\[Theta]", ",", "Sigma", ",", "KNdSMatrix"}], "]"}]], "Input",Express\
ionUUID->"ad36e7ac-53b9-4ef9-a0a9-6c5593525ead"],

Cell[BoxData[
 RowBox[{"UndefConstantSymbol", "[", 
  RowBox[{"{", 
   RowBox[{"Mass", ",", "Rotation", ",", "Charge", ",", "CosmoC"}], "}"}], 
  "]"}]], "Input",ExpressionUUID->"d7b99a71-5e26-4515-a83a-9e1210da6ffd"],

Cell[BoxData[
 RowBox[{"UndefChart", "[", "BL", "]"}]], "Input",ExpressionUUID->"56476189-c58d-441d-a99e-c6aaa0bea7f4"],

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M", "]"}]], "Input",ExpressionUUID->"8962383c-fa2a-4645-8300-7c0e3bb9d198"],

Cell[BoxData[
 RowBox[{"ClearxCobaCache", "[", "All", "]"}]], "Input",ExpressionUUID->"dd60f0da-e3f8-485e-9572-064dcbd1a13d"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
4.6. A very (actually too) hard example: The black saturn metric\
\>", "Subsubsection",ExpressionUUID->"0d7d934a-35db-4da3-a76e-47173a118fa3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<xAct`xCoba`\>\"", "]"}]], "Input",ExpressionUUID->"6913f968-b614-44f7-af59-81c61ff578a2"],

Cell[CellGroupData[{

Cell[BoxData["\<\"------------------------------------------------------------\
\"\>"], "Print",ExpressionUUID->"93f4a2b6-be9f-464c-8ded-a58caa9d9ef3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Package xAct`xPerm`  version \"\>", 
   "\[InvisibleSpace]", "\<\"1.2.3\"\>", "\[InvisibleSpace]", "\<\", \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"2015", ",", "8", ",", "23"}], "}"}]}],
  SequenceForm["Package xAct`xPerm`  version ", "1.2.3", ", ", {2015, 8, 23}],
  
  Editable->False]], "Print",ExpressionUUID->"ea1a050b-68fe-4f03-a8be-\
71d9c3479c46"],

Cell[BoxData["\<\"CopyRight (C) 2003-2015, Jose M. Martin-Garcia, under the \
General Public License.\"\>"], "Print",ExpressionUUID->"5e53d258-d070-41a8-\
bbe9-d3fc3e50a4fc"],

Cell[BoxData["\<\"Connecting to external mac executable...\"\>"], "Print",ExpressionUUID->"8ffed047-61d1-499e-97f7-f2b185085ca7"],

Cell[BoxData["\<\"Connection established.\"\>"], "Print",ExpressionUUID->"91ca1bf1-0ece-4da5-ad92-3d074036ddfc"],

Cell[BoxData["\<\"------------------------------------------------------------\
\"\>"], "Print",ExpressionUUID->"c0d25827-4f28-4163-9063-a68eb2c86b05"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Package xAct`xTensor`  version \"\>", 
   "\[InvisibleSpace]", "\<\"1.1.2\"\>", "\[InvisibleSpace]", "\<\", \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"2015", ",", "8", ",", "23"}], "}"}]}],
  SequenceForm[
  "Package xAct`xTensor`  version ", "1.1.2", ", ", {2015, 8, 23}],
  Editable->False]], "Print",ExpressionUUID->"aea0eca4-cc40-41ed-8f97-\
ed663e366494"],

Cell[BoxData["\<\"CopyRight (C) 2002-2015, Jose M. Martin-Garcia, under the \
General Public License.\"\>"], "Print",ExpressionUUID->"ecd880b5-d190-43fa-\
b061-af06f29b097e"],

Cell[BoxData["\<\"------------------------------------------------------------\
\"\>"], "Print",ExpressionUUID->"68c5bc26-dfa2-46dd-8959-a52918105cbb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Package xAct`xCoba`  version \"\>", 
   "\[InvisibleSpace]", "\<\"0.8.3\"\>", "\[InvisibleSpace]", "\<\", \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"2015", ",", "8", ",", "23"}], "}"}]}],
  SequenceForm["Package xAct`xCoba`  version ", "0.8.3", ", ", {2015, 8, 23}],
  
  Editable->False]], "Print",ExpressionUUID->"a29c3fd4-7e47-48ac-899e-\
c82bcbb5fab7"],

Cell[BoxData["\<\"CopyRight (C) 2005-2014, David Yllanes and Jose M. \
Martin-Garcia, under the General Public License.\"\>"], "Print",ExpressionUUID\
->"6aaf9fac-ab47-496b-b251-ea861578a0a2"],

Cell[BoxData["\<\"------------------------------------------------------------\
\"\>"], "Print",ExpressionUUID->"e42b5ce0-9ef3-40f6-a769-99be29a4ea66"],

Cell[BoxData["\<\"These packages come with ABSOLUTELY NO WARRANTY; for \
details type Disclaimer[]. This is free software, and you are welcome to \
redistribute it under certain conditions. See the General Public License for \
details.\"\>"], "Print",ExpressionUUID->"7b6a13e0-024f-4982-8c6f-\
049287218b2e"],

Cell[BoxData["\<\"------------------------------------------------------------\
\"\>"], "Print",ExpressionUUID->"142aa7e0-abb8-4a38-a515-2ab927d45324"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"$DefInfoQ", "=", 
   RowBox[{"$UndefInfoQ", "=", "False"}]}], ";"}]], "Input",ExpressionUUID->\
"a4e844e4-329a-49fc-828e-c74ab19eb67b"],

Cell[TextData[{
 "Solution taken from [",
 ButtonBox["arXiv:0701035v2",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://arxiv.org/pdf/hep-th/0701035v2.pdf"], None},
  ButtonNote->"http://arxiv.org/pdf/hep-th/0701035v2.pdf"],
 "]. Thanks to Alfonso Garc\[IAcute]a-Parrado for the actual ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " formulas."
}], "Text",ExpressionUUID->"9caa07d0-b309-4c0e-8821-e2cf83a6db43"],

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M", ",", "5", ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"342966d7-9e8f-4441-aa91-f0bc52246443"],

Cell[BoxData[
 RowBox[{"DefChart", "[", 
  RowBox[{"BS", ",", "M", ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"t", "[", "]"}], ",", 
     RowBox[{"\[Rho]", "[", "]"}], ",", 
     RowBox[{"z", "[", "]"}], ",", 
     RowBox[{"\[Psi]", "[", "]"}], ",", 
     RowBox[{"\[Phi]", "[", "]"}]}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"5da829db-cdc8-449e-94da-9e64d33e2bc0"],

Cell[BoxData[
 RowBox[{"DefConstantSymbol", "[", 
  RowBox[{"{", 
   RowBox[{
   "ks", ",", "q", ",", "a1", ",", "a2", ",", "a3", ",", "a4", ",", "a5", ",",
     "c1", ",", "c2"}], "}"}], "]"}]], "Input",ExpressionUUID->"58c1e87a-4f84-\
469a-a746-784989105662"],

Cell[BoxData[
 RowBox[{"DefScalarFunction", "[", 
  RowBox[{"{", 
   RowBox[{
   "\[Mu]1", ",", "\[Mu]2", ",", "\[Mu]3", ",", "\[Mu]4", ",", "\[Mu]5", ",", 
    "M0", ",", "M1", ",", "M2", ",", "M3", ",", "M4", ",", "R1", ",", "R2", 
    ",", "Hx", ",", "Hy", ",", "Gx", ",", "Gy", ",", "\[Omega]\[Psi]", ",", 
    "P", ",", "F"}], "}"}], "]"}]], "Input",ExpressionUUID->"53f45de8-7f00-\
4368-a5d0-cd3afbec28f1"],

Cell["\<\
\[Mu] and R functions do not depend on any other functions. These functions \
are the only ones with explicit dependence in z:\
\>", "Text",ExpressionUUID->"f2bf46af-e19a-45a5-b0cf-25bc19ec8da9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Mu]Functions", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"\[Mu]1", "\[Rule]", 
      RowBox[{"Function", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\[Rho]", ",", "z"}], "}"}], ",", 
        RowBox[{
         RowBox[{"Sqrt", "[", 
          RowBox[{
           RowBox[{"\[Rho]", "^", "2"}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"z", "-", "a1"}], ")"}], "^", "2"}]}], "]"}], "-", 
         RowBox[{"(", 
          RowBox[{"z", "-", "a1"}], ")"}]}]}], "]"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"\[Mu]2", "\[Rule]", 
      RowBox[{"Function", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\[Rho]", ",", "z"}], "}"}], ",", 
        RowBox[{
         RowBox[{"Sqrt", "[", 
          RowBox[{
           RowBox[{"\[Rho]", "^", "2"}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"z", "-", "a2"}], ")"}], "^", "2"}]}], "]"}], "-", 
         RowBox[{"(", 
          RowBox[{"z", "-", "a2"}], ")"}]}]}], "]"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"\[Mu]3", "\[Rule]", 
      RowBox[{"Function", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\[Rho]", ",", "z"}], "}"}], ",", 
        RowBox[{
         RowBox[{"Sqrt", "[", 
          RowBox[{
           RowBox[{"\[Rho]", "^", "2"}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"z", "-", "a3"}], ")"}], "^", "2"}]}], "]"}], "-", 
         RowBox[{"(", 
          RowBox[{"z", "-", "a3"}], ")"}]}]}], "]"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"\[Mu]4", "\[Rule]", 
      RowBox[{"Function", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\[Rho]", ",", "z"}], "}"}], ",", 
        RowBox[{
         RowBox[{"Sqrt", "[", 
          RowBox[{
           RowBox[{"\[Rho]", "^", "2"}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"z", "-", "a4"}], ")"}], "^", "2"}]}], "]"}], "-", 
         RowBox[{"(", 
          RowBox[{"z", "-", "a4"}], ")"}]}]}], "]"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"\[Mu]5", "\[Rule]", 
      RowBox[{"Function", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\[Rho]", ",", "z"}], "}"}], ",", 
        RowBox[{
         RowBox[{"Sqrt", "[", 
          RowBox[{
           RowBox[{"\[Rho]", "^", "2"}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"z", "-", "a5"}], ")"}], "^", "2"}]}], "]"}], "-", 
         RowBox[{"(", 
          RowBox[{"z", "-", "a5"}], ")"}]}]}], "]"}]}]}], 
    "\[IndentingNewLine]", "}"}]}], ";"}]], "Input",ExpressionUUID->"f6f89abf-\
a805-4522-9c49-4dab99773923"],

Cell[BoxData[
 RowBox[{
  RowBox[{"RFunctions", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"R1", "\[Rule]", 
      RowBox[{"Function", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\[Rho]", ",", "z"}], "}"}], ",", 
        RowBox[{"Sqrt", "[", 
         RowBox[{
          RowBox[{"\[Rho]", "^", "2"}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"z", "-", "a1"}], ")"}], "^", "2"}]}], "]"}]}], "]"}]}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"R2", "\[Rule]", 
      RowBox[{"Function", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\[Rho]", ",", "z"}], "}"}], ",", 
        RowBox[{"Sqrt", "[", 
         RowBox[{
          RowBox[{"\[Rho]", "^", "2"}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"z", "-", "a2"}], ")"}], "^", "2"}]}], "]"}]}], "]"}]}]}],
     "\[IndentingNewLine]", "}"}]}], ";"}]], "Input",ExpressionUUID->\
"15819cc2-e637-4bf3-b817-a8f7be06fd90"],

Cell["\<\
The G, P, F and M functions are given in terms of \[Mu] functions:\
\>", "Text",ExpressionUUID->"a35cc1a6-f0fd-469d-8cdb-89bf390710c0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"GFunctions", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Gx", "\[Rule]", 
      RowBox[{"Function", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\[Rho]", ",", "z"}], "}"}], ",", 
        FractionBox[
         RowBox[{
          RowBox[{"\[Rho]", "^", "2"}], 
          RowBox[{"\[Mu]4", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}]}], 
         RowBox[{
          RowBox[{"\[Mu]3", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}], " ", 
          RowBox[{"\[Mu]5", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}]}]]}], "]"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Gy", "\[Rule]", 
      RowBox[{"Function", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\[Rho]", ",", "z"}], "}"}], ",", 
        FractionBox[
         RowBox[{
          RowBox[{"\[Mu]3", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}], 
          RowBox[{"\[Mu]5", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}]}], 
         RowBox[{"\[Mu]4", "[", 
          RowBox[{"\[Rho]", ",", "z"}], "]"}]]}], "]"}]}]}], 
    "\[IndentingNewLine]", "}"}]}], ";"}]], "Input",ExpressionUUID->"d2829250-\
b7ed-4e5d-89c4-d62e79565fae"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PFunction", "=", 
   RowBox[{"P", "\[Rule]", 
    RowBox[{"Function", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\[Rho]", ",", "z"}], "}"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"\[Mu]3", "[", 
            RowBox[{"\[Rho]", ",", "z"}], "]"}], 
           RowBox[{"\[Mu]4", "[", 
            RowBox[{"\[Rho]", ",", "z"}], "]"}]}], "+", 
          RowBox[{"\[Rho]", "^", "2"}]}], ")"}], "^", "2"}], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"\[Mu]1", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}], 
          RowBox[{"\[Mu]5", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}]}], "+", 
         RowBox[{"\[Rho]", "^", "2"}]}], ")"}], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"\[Mu]4", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}], 
          RowBox[{"\[Mu]5", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}]}], "+", 
         RowBox[{"\[Rho]", "^", "2"}]}], ")"}]}]}], "]"}]}]}], ";"}]], "Input",\
ExpressionUUID->"196795c7-2051-4901-8ff5-1e14d4a993da"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FFunction", "=", 
   RowBox[{"F", "\[Rule]", 
    RowBox[{"Function", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\[Rho]", ",", "z"}], "}"}], ",", 
      RowBox[{
       RowBox[{"\[Mu]1", "[", 
        RowBox[{"\[Rho]", ",", "z"}], "]"}], 
       RowBox[{"\[Mu]5", "[", 
        RowBox[{"\[Rho]", ",", "z"}], "]"}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"\[Mu]1", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}], "-", 
          RowBox[{"\[Mu]3", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}]}], ")"}], "^", "2"}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"\[Mu]2", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}], "-", 
          RowBox[{"\[Mu]4", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}]}], ")"}], "^", "2"}], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"\[Rho]", "^", "2"}], "+", 
         RowBox[{
          RowBox[{"\[Mu]1", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}], 
          RowBox[{"\[Mu]3", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}]}]}], ")"}], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"\[Rho]", "^", "2"}], "+", 
         RowBox[{
          RowBox[{"\[Mu]2", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}], 
          RowBox[{"\[Mu]3", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}]}]}], ")"}], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"\[Rho]", "^", "2"}], "+", 
         RowBox[{
          RowBox[{"\[Mu]1", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}], 
          RowBox[{"\[Mu]4", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}]}]}], ")"}], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"\[Rho]", "^", "2"}], "+", 
         RowBox[{
          RowBox[{"\[Mu]2", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}], 
          RowBox[{"\[Mu]4", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}]}]}], ")"}], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"\[Rho]", "^", "2"}], "+", 
         RowBox[{
          RowBox[{"\[Mu]2", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}], 
          RowBox[{"\[Mu]5", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}]}]}], ")"}], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"\[Rho]", "^", "2"}], "+", 
         RowBox[{
          RowBox[{"\[Mu]3", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}], 
          RowBox[{"\[Mu]5", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}]}]}], ")"}], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"\[Rho]", "^", "2"}], "+", 
         RowBox[{
          RowBox[{"\[Mu]1", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}], "^", "2"}]}], ")"}], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"\[Rho]", "^", "2"}], "+", 
         RowBox[{
          RowBox[{"\[Mu]2", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}], "^", "2"}]}], ")"}], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"\[Rho]", "^", "2"}], "+", 
         RowBox[{
          RowBox[{"\[Mu]3", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}], "^", "2"}]}], ")"}], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"\[Rho]", "^", "2"}], "+", 
         RowBox[{
          RowBox[{"\[Mu]4", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}], "^", "2"}]}], ")"}], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"\[Rho]", "^", "2"}], "+", 
         RowBox[{
          RowBox[{"\[Mu]5", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}], "^", "2"}]}], ")"}]}]}], 
     "]"}]}]}], ";"}]], "Input",ExpressionUUID->"77080c4b-ba79-4858-8d99-\
f044e49008ed"],

Cell[BoxData[
 RowBox[{
  RowBox[{"MFunctions", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"M0", "\[Rule]", 
      RowBox[{"Function", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\[Rho]", ",", "z"}], "}"}], ",", 
        RowBox[{
         RowBox[{"\[Mu]2", "[", 
          RowBox[{"\[Rho]", ",", "z"}], "]"}], 
         RowBox[{
          RowBox[{"\[Mu]5", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}], "^", "2"}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"\[Mu]1", "[", 
             RowBox[{"\[Rho]", ",", "z"}], "]"}], "-", 
            RowBox[{"\[Mu]3", "[", 
             RowBox[{"\[Rho]", ",", "z"}], "]"}]}], ")"}], "^", "2"}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"\[Mu]2", "[", 
             RowBox[{"\[Rho]", ",", "z"}], "]"}], "-", 
            RowBox[{"\[Mu]4", "[", 
             RowBox[{"\[Rho]", ",", "z"}], "]"}]}], ")"}], "^", "2"}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"\[Rho]", "^", "2"}], "+", 
            RowBox[{
             RowBox[{"\[Mu]1", "[", 
              RowBox[{"\[Rho]", ",", "z"}], "]"}], 
             RowBox[{"\[Mu]2", "[", 
              RowBox[{"\[Rho]", ",", "z"}], "]"}]}]}], ")"}], "^", "2"}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"\[Rho]", "^", "2"}], "+", 
            RowBox[{
             RowBox[{"\[Mu]1", "[", 
              RowBox[{"\[Rho]", ",", "z"}], "]"}], 
             RowBox[{"\[Mu]4", "[", 
              RowBox[{"\[Rho]", ",", "z"}], "]"}]}]}], ")"}], "^", "2"}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"\[Rho]", "^", "2"}], "+", 
            RowBox[{
             RowBox[{"\[Mu]2", "[", 
              RowBox[{"\[Rho]", ",", "z"}], "]"}], 
             RowBox[{"\[Mu]3", "[", 
              RowBox[{"\[Rho]", ",", "z"}], "]"}]}]}], ")"}], "^", "2"}]}]}], 
       "]"}]}], ",", 
     RowBox[{"M1", "\[Rule]", 
      RowBox[{"Function", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\[Rho]", ",", "z"}], "}"}], ",", 
        RowBox[{
         RowBox[{"\[Mu]2", "[", 
          RowBox[{"\[Rho]", ",", "z"}], "]"}], 
         RowBox[{"\[Mu]3", "[", 
          RowBox[{"\[Rho]", ",", "z"}], "]"}], 
         RowBox[{"\[Mu]4", "[", 
          RowBox[{"\[Rho]", ",", "z"}], "]"}], 
         RowBox[{"\[Mu]5", "[", 
          RowBox[{"\[Rho]", ",", "z"}], "]"}], 
         RowBox[{
          RowBox[{"\[Mu]1", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}], "^", "2"}], 
         RowBox[{"\[Rho]", "^", "2"}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"\[Mu]1", "[", 
             RowBox[{"\[Rho]", ",", "z"}], "]"}], "-", 
            RowBox[{"\[Mu]2", "[", 
             RowBox[{"\[Rho]", ",", "z"}], "]"}]}], ")"}], "^", "2"}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"\[Mu]2", "[", 
             RowBox[{"\[Rho]", ",", "z"}], "]"}], "-", 
            RowBox[{"\[Mu]4", "[", 
             RowBox[{"\[Rho]", ",", "z"}], "]"}]}], ")"}], "^", "2"}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"\[Mu]1", "[", 
             RowBox[{"\[Rho]", ",", "z"}], "]"}], "-", 
            RowBox[{"\[Mu]5", "[", 
             RowBox[{"\[Rho]", ",", "z"}], "]"}]}], ")"}], "^", "2"}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"\[Rho]", "^", "2"}], "+", 
            RowBox[{
             RowBox[{"\[Mu]2", "[", 
              RowBox[{"\[Rho]", ",", "z"}], "]"}], 
             RowBox[{"\[Mu]3", "[", 
              RowBox[{"\[Rho]", ",", "z"}], "]"}]}]}], ")"}], "^", "2"}]}]}], 
       "]"}]}], ",", 
     RowBox[{"M2", "\[Rule]", 
      RowBox[{"Function", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\[Rho]", ",", "z"}], "}"}], ",", 
        RowBox[{
         RowBox[{"\[Mu]2", "[", 
          RowBox[{"\[Rho]", ",", "z"}], "]"}], 
         RowBox[{"\[Mu]3", "[", 
          RowBox[{"\[Rho]", ",", "z"}], "]"}], 
         RowBox[{"\[Mu]4", "[", 
          RowBox[{"\[Rho]", ",", "z"}], "]"}], 
         RowBox[{"\[Mu]5", "[", 
          RowBox[{"\[Rho]", ",", "z"}], "]"}], 
         RowBox[{"\[Rho]", "^", "2"}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"\[Mu]1", "[", 
             RowBox[{"\[Rho]", ",", "z"}], "]"}], "-", 
            RowBox[{"\[Mu]2", "[", 
             RowBox[{"\[Rho]", ",", "z"}], "]"}]}], ")"}], "^", "2"}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"\[Mu]1", "[", 
             RowBox[{"\[Rho]", ",", "z"}], "]"}], "-", 
            RowBox[{"\[Mu]3", "[", 
             RowBox[{"\[Rho]", ",", "z"}], "]"}]}], ")"}], "^", "2"}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"\[Rho]", "^", "2"}], "+", 
            RowBox[{
             RowBox[{"\[Mu]1", "[", 
              RowBox[{"\[Rho]", ",", "z"}], "]"}], 
             RowBox[{"\[Mu]4", "[", 
              RowBox[{"\[Rho]", ",", "z"}], "]"}]}]}], ")"}], "^", "2"}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"\[Rho]", "^", "2"}], "+", 
            RowBox[{
             RowBox[{"\[Mu]2", "[", 
              RowBox[{"\[Rho]", ",", "z"}], "]"}], 
             RowBox[{"\[Mu]5", "[", 
              RowBox[{"\[Rho]", ",", "z"}], "]"}]}]}], ")"}], "^", "2"}]}]}], 
       "]"}]}], ",", 
     RowBox[{"M3", "\[Rule]", 
      RowBox[{"Function", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\[Rho]", ",", "z"}], "}"}], ",", 
        RowBox[{"2", 
         RowBox[{"\[Mu]1", "[", 
          RowBox[{"\[Rho]", ",", "z"}], "]"}], 
         RowBox[{"\[Mu]2", "[", 
          RowBox[{"\[Rho]", ",", "z"}], "]"}], 
         RowBox[{"\[Mu]3", "[", 
          RowBox[{"\[Rho]", ",", "z"}], "]"}], 
         RowBox[{"\[Mu]4", "[", 
          RowBox[{"\[Rho]", ",", "z"}], "]"}], 
         RowBox[{"\[Mu]5", "[", 
          RowBox[{"\[Rho]", ",", "z"}], "]"}], 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[Mu]1", "[", 
            RowBox[{"\[Rho]", ",", "z"}], "]"}], "-", 
           RowBox[{"\[Mu]3", "[", 
            RowBox[{"\[Rho]", ",", "z"}], "]"}]}], ")"}], 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[Mu]1", "[", 
            RowBox[{"\[Rho]", ",", "z"}], "]"}], "-", 
           RowBox[{"\[Mu]5", "[", 
            RowBox[{"\[Rho]", ",", "z"}], "]"}]}], ")"}], 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[Mu]2", "[", 
            RowBox[{"\[Rho]", ",", "z"}], "]"}], "-", 
           RowBox[{"\[Mu]4", "[", 
            RowBox[{"\[Rho]", ",", "z"}], "]"}]}], ")"}], 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[Rho]", "^", "2"}], "+", 
           RowBox[{
            RowBox[{"\[Mu]1", "[", 
             RowBox[{"\[Rho]", ",", "z"}], "]"}], "^", "2"}]}], ")"}], 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[Rho]", "^", "2"}], "+", 
           RowBox[{
            RowBox[{"\[Mu]2", "[", 
             RowBox[{"\[Rho]", ",", "z"}], "]"}], "^", "2"}]}], ")"}], 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[Rho]", "^", "2"}], "+", 
           RowBox[{
            RowBox[{"\[Mu]1", "[", 
             RowBox[{"\[Rho]", ",", "z"}], "]"}], 
            RowBox[{"\[Mu]4", "[", 
             RowBox[{"\[Rho]", ",", "z"}], "]"}]}]}], ")"}], 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[Rho]", "^", "2"}], "+", 
           RowBox[{
            RowBox[{"\[Mu]2", "[", 
             RowBox[{"\[Rho]", ",", "z"}], "]"}], 
            RowBox[{"\[Mu]3", "[", 
             RowBox[{"\[Rho]", ",", "z"}], "]"}]}]}], ")"}], 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[Rho]", "^", "2"}], "+", 
           RowBox[{
            RowBox[{"\[Mu]2", "[", 
             RowBox[{"\[Rho]", ",", "z"}], "]"}], 
            RowBox[{"\[Mu]5", "[", 
             RowBox[{"\[Rho]", ",", "z"}], "]"}]}]}], ")"}]}]}], "]"}]}], ",", 
     RowBox[{"M4", "\[Rule]", 
      RowBox[{"Function", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\[Rho]", ",", "z"}], "}"}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"\[Mu]1", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}], "^", "2"}], 
         RowBox[{"\[Mu]2", "[", 
          RowBox[{"\[Rho]", ",", "z"}], "]"}], 
         RowBox[{
          RowBox[{"\[Mu]3", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}], "^", "2"}], 
         RowBox[{
          RowBox[{"\[Mu]4", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}], "^", "2"}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"\[Mu]1", "[", 
             RowBox[{"\[Rho]", ",", "z"}], "]"}], "-", 
            RowBox[{"\[Mu]5", "[", 
             RowBox[{"\[Rho]", ",", "z"}], "]"}]}], ")"}], "^", "2"}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"\[Rho]", "^", "2"}], "+", 
            RowBox[{
             RowBox[{"\[Mu]1", "[", 
              RowBox[{"\[Rho]", ",", "z"}], "]"}], 
             RowBox[{"\[Mu]2", "[", 
              RowBox[{"\[Rho]", ",", "z"}], "]"}]}]}], ")"}], "^", "2"}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"\[Rho]", "^", "2"}], "+", 
            RowBox[{
             RowBox[{"\[Mu]2", "[", 
              RowBox[{"\[Rho]", ",", "z"}], "]"}], 
             RowBox[{"\[Mu]5", "[", 
              RowBox[{"\[Rho]", ",", "z"}], "]"}]}]}], ")"}], "^", "2"}]}]}], 
       "]"}]}]}], "\[IndentingNewLine]", "}"}]}], ";"}]], "Input",ExpressionUU\
ID->"342ec9e6-a707-4303-9161-936b2d3228f7"],

Cell["The H functions are given in terms of M, \[Mu], F functions:", "Text",ExpressionUUID->"938353fb-22a9-4282-9c2a-dd13e1bfd0da"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HFunctions", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Hx", "\[Rule]", 
      RowBox[{"Function", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\[Rho]", ",", "z"}], "}"}], ",", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"M0", "[", 
            RowBox[{"\[Rho]", ",", "z"}], "]"}], "+", 
           RowBox[{
            RowBox[{"c1", "^", "2"}], 
            RowBox[{"M1", "[", 
             RowBox[{"\[Rho]", ",", "z"}], "]"}]}], "+", 
           RowBox[{
            RowBox[{"c2", "^", "2"}], 
            RowBox[{"M2", "[", 
             RowBox[{"\[Rho]", ",", "z"}], "]"}]}], "+", 
           RowBox[{"c1", " ", "c2", " ", 
            RowBox[{"M3", "[", 
             RowBox[{"\[Rho]", ",", "z"}], "]"}]}], "+", 
           RowBox[{
            RowBox[{"c1", "^", "2"}], 
            RowBox[{"c2", "^", "2"}], 
            RowBox[{"M4", "[", 
             RowBox[{"\[Rho]", ",", "z"}], "]"}]}]}], ")"}], "/", 
         RowBox[{"F", "[", 
          RowBox[{"\[Rho]", ",", "z"}], "]"}]}]}], "]"}]}], ",", 
     RowBox[{"Hy", "\[Rule]", 
      RowBox[{"Function", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\[Rho]", ",", "z"}], "}"}], ",", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"M0", "[", 
             RowBox[{"\[Rho]", ",", "z"}], "]"}], 
            RowBox[{
             RowBox[{"\[Mu]1", "[", 
              RowBox[{"\[Rho]", ",", "z"}], "]"}], "/", 
             RowBox[{"\[Mu]2", "[", 
              RowBox[{"\[Rho]", ",", "z"}], "]"}]}]}], "-", 
           RowBox[{
            RowBox[{"c1", "^", "2"}], 
            RowBox[{"M1", "[", 
             RowBox[{"\[Rho]", ",", "z"}], "]"}], 
            RowBox[{
             RowBox[{"\[Rho]", "^", "2"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"\[Mu]1", "[", 
                RowBox[{"\[Rho]", ",", "z"}], "]"}], 
               RowBox[{"\[Mu]2", "[", 
                RowBox[{"\[Rho]", ",", "z"}], "]"}]}], ")"}]}]}], "-", 
           RowBox[{
            RowBox[{"c2", "^", "2"}], 
            RowBox[{"M2", "[", 
             RowBox[{"\[Rho]", ",", "z"}], "]"}], 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"\[Mu]1", "[", 
                RowBox[{"\[Rho]", ",", "z"}], "]"}], 
               RowBox[{"\[Mu]2", "[", 
                RowBox[{"\[Rho]", ",", "z"}], "]"}]}], ")"}], "/", 
             RowBox[{"\[Rho]", "^", "2"}]}]}], "+", 
           RowBox[{"c1", " ", "c2", " ", 
            RowBox[{"M3", "[", 
             RowBox[{"\[Rho]", ",", "z"}], "]"}]}], "+", 
           RowBox[{
            RowBox[{"c1", "^", "2"}], 
            RowBox[{"c2", "^", "2"}], 
            RowBox[{"M4", "[", 
             RowBox[{"\[Rho]", ",", "z"}], "]"}], 
            RowBox[{
             RowBox[{"\[Mu]2", "[", 
              RowBox[{"\[Rho]", ",", "z"}], "]"}], "/", 
             RowBox[{"\[Mu]1", "[", 
              RowBox[{"\[Rho]", ",", "z"}], "]"}]}]}]}], ")"}], 
         RowBox[{
          RowBox[{"\[Mu]3", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}], "/", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"\[Mu]4", "[", 
             RowBox[{"\[Rho]", ",", "z"}], "]"}], 
            RowBox[{"F", "[", 
             RowBox[{"\[Rho]", ",", "z"}], "]"}]}], ")"}]}]}]}], "]"}]}]}], 
    "\[IndentingNewLine]", "}"}]}], ";"}]], "Input",ExpressionUUID->"87e1e284-\
af59-4435-8a26-8931c20a6af9"],

Cell["\[Omega]\[Psi] is given in terms of R, M, F, G functions:", "Text",ExpressionUUID->"2e3bbd2a-6dcf-48eb-92c2-005de0326547"],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Omega]\[Psi]Function", "=", 
   RowBox[{"\[Omega]\[Psi]", "\[Rule]", 
    RowBox[{"Function", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\[Rho]", ",", "z"}], "}"}], ",", 
      RowBox[{"2", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"c1", " ", 
           RowBox[{"R1", "[", 
            RowBox[{"\[Rho]", ",", "z"}], "]"}], 
           RowBox[{"Sqrt", "[", 
            RowBox[{
             RowBox[{"M0", "[", 
              RowBox[{"\[Rho]", ",", "z"}], "]"}], 
             RowBox[{"M1", "[", 
              RowBox[{"\[Rho]", ",", "z"}], "]"}]}], "]"}]}], "-", 
          RowBox[{"c2", " ", 
           RowBox[{"R2", "[", 
            RowBox[{"\[Rho]", ",", "z"}], "]"}], 
           RowBox[{"Sqrt", "[", 
            RowBox[{
             RowBox[{"M0", "[", 
              RowBox[{"\[Rho]", ",", "z"}], "]"}], 
             RowBox[{"M2", "[", 
              RowBox[{"\[Rho]", ",", "z"}], "]"}]}], "]"}]}], "+", 
          RowBox[{
           RowBox[{"c1", "^", "2"}], "c2", " ", 
           RowBox[{"R2", "[", 
            RowBox[{"\[Rho]", ",", "z"}], "]"}], 
           RowBox[{"Sqrt", "[", 
            RowBox[{
             RowBox[{"M1", "[", 
              RowBox[{"\[Rho]", ",", "z"}], "]"}], 
             RowBox[{"M4", "[", 
              RowBox[{"\[Rho]", ",", "z"}], "]"}]}], "]"}]}], "-", 
          RowBox[{"c1", " ", 
           RowBox[{"c2", "^", "2"}], " ", 
           RowBox[{"R1", "[", 
            RowBox[{"\[Rho]", ",", "z"}], "]"}], 
           RowBox[{"Sqrt", "[", 
            RowBox[{
             RowBox[{"M2", "[", 
              RowBox[{"\[Rho]", ",", "z"}], "]"}], 
             RowBox[{"M4", "[", 
              RowBox[{"\[Rho]", ",", "z"}], "]"}]}], "]"}]}]}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"F", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}], 
          RowBox[{"Sqrt", "@", 
           RowBox[{"Gx", "[", 
            RowBox[{"\[Rho]", ",", "z"}], "]"}]}]}], ")"}]}]}]}], "]"}]}]}], 
  ";"}]], "Input",ExpressionUUID->"f47a0805-fd60-42e7-88c9-5426aab6b04a"],

Cell["\<\
The metric is given in terms of H, \[Omega]\[Psi], F, P, G functions (note \
that P and F appear together), meaning that in the end all functions are \
replaced by elementary functions:\
\>", "Text",ExpressionUUID->"4d9b4d84-1b6b-4a0d-9fc0-fc87337d1704"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BlackSaturn", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     FractionBox[
      RowBox[{"Hy", "[", 
       RowBox[{"\[Rho]", ",", "z"}], "]"}], 
      RowBox[{"Hx", "[", 
       RowBox[{"\[Rho]", ",", "z"}], "]"}]]}], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Basis", "[", 
       RowBox[{
        RowBox[{"-", "a"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "BS"}], "}"}]}], "]"}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          RowBox[{"\[Omega]\[Psi]", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}], 
          RowBox[{"Hy", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}]], "+", "q"}], ")"}], 
       RowBox[{"Basis", "[", 
        RowBox[{
         RowBox[{"-", "a"}], ",", 
         RowBox[{"{", 
          RowBox[{"3", ",", "BS"}], "}"}]}], "]"}]}]}], ")"}], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Basis", "[", 
       RowBox[{
        RowBox[{"-", "b"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "BS"}], "}"}]}], "]"}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          RowBox[{"\[Omega]\[Psi]", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}], 
          RowBox[{"Hy", "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}]], "+", "q"}], ")"}], 
       RowBox[{"Basis", "[", 
        RowBox[{
         RowBox[{"-", "b"}], ",", 
         RowBox[{"{", 
          RowBox[{"3", ",", "BS"}], "}"}]}], "]"}]}]}], ")"}]}], "+", 
   RowBox[{
    RowBox[{"Hx", "[", 
     RowBox[{"\[Rho]", ",", "z"}], "]"}], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"ks", "^", "2"}], 
       RowBox[{"P", "[", 
        RowBox[{"\[Rho]", ",", "z"}], "]"}], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"Basis", "[", 
           RowBox[{
            RowBox[{"-", "a"}], ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "BS"}], "}"}]}], "]"}], 
          RowBox[{"Basis", "[", 
           RowBox[{
            RowBox[{"-", "b"}], ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "BS"}], "}"}]}], "]"}]}], "+", 
         RowBox[{
          RowBox[{"Basis", "[", 
           RowBox[{
            RowBox[{"-", "a"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "BS"}], "}"}]}], "]"}], 
          RowBox[{"Basis", "[", 
           RowBox[{
            RowBox[{"-", "b"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "BS"}], "}"}]}], "]"}]}]}], ")"}]}], "+", 
      RowBox[{
       FractionBox[
        RowBox[{"Gy", "[", 
         RowBox[{"\[Rho]", ",", "z"}], "]"}], 
        RowBox[{"Hy", "[", 
         RowBox[{"\[Rho]", ",", "z"}], "]"}]], 
       RowBox[{"Basis", "[", 
        RowBox[{
         RowBox[{"-", "a"}], ",", 
         RowBox[{"{", 
          RowBox[{"3", ",", "BS"}], "}"}]}], "]"}], 
       RowBox[{"Basis", "[", 
        RowBox[{
         RowBox[{"-", "b"}], ",", 
         RowBox[{"{", 
          RowBox[{"3", ",", "BS"}], "}"}]}], "]"}]}], "+", 
      RowBox[{
       FractionBox[
        RowBox[{"Gx", "[", 
         RowBox[{"\[Rho]", ",", "z"}], "]"}], 
        RowBox[{"Hx", "[", 
         RowBox[{"\[Rho]", ",", "z"}], "]"}]], 
       RowBox[{"Basis", "[", 
        RowBox[{
         RowBox[{"-", "a"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "BS"}], "}"}]}], "]"}], 
       RowBox[{"Basis", "[", 
        RowBox[{
         RowBox[{"-", "b"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "BS"}], "}"}]}], "]"}]}]}], ")"}]}]}]}]], "Input",\
ExpressionUUID->"02a20b7d-50e2-4f75-b728-04a5fa4057a8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    InterpretationBox[
     StyleBox["Hx",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`Hx,
     Editable->False], "[", 
    RowBox[{"\[Rho]", ",", "z"}], "]"}], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"e", 
            StyleBox[GridBox[{
               {" ", 
                StyleBox["4",
                 FontColor->RGBColor[1., 0., 0.]]},
               {"a", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xTensor`Basis[-$CellContext`a, {4, $CellContext`BS}],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"e", 
            StyleBox[GridBox[{
               {" ", 
                StyleBox["4",
                 FontColor->RGBColor[1., 0., 0.]]},
               {"b", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xTensor`Basis[-$CellContext`b, {4, $CellContext`BS}],
        Editable->False], " ", 
       RowBox[{
        InterpretationBox[
         StyleBox["Gx",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Gx,
         Editable->False], "[", 
        RowBox[{"\[Rho]", ",", "z"}], "]"}]}], 
      RowBox[{
       InterpretationBox[
        StyleBox["Hx",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`Hx,
        Editable->False], "[", 
       RowBox[{"\[Rho]", ",", "z"}], "]"}]], "+", 
     FractionBox[
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"e", 
            StyleBox[GridBox[{
               {" ", 
                StyleBox["3",
                 FontColor->RGBColor[1., 0., 0.]]},
               {"a", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xTensor`Basis[-$CellContext`a, {3, $CellContext`BS}],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox[GridBox[{
           {"e", 
            StyleBox[GridBox[{
               {" ", 
                StyleBox["3",
                 FontColor->RGBColor[1., 0., 0.]]},
               {"b", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xTensor`Basis[-$CellContext`b, {3, $CellContext`BS}],
        Editable->False], " ", 
       RowBox[{
        InterpretationBox[
         StyleBox["Gy",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Gy,
         Editable->False], "[", 
        RowBox[{"\[Rho]", ",", "z"}], "]"}]}], 
      RowBox[{
       InterpretationBox[
        StyleBox["Hy",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`Hy,
        Editable->False], "[", 
       RowBox[{"\[Rho]", ",", "z"}], "]"}]], "+", 
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["ks",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`ks,
        Editable->False], "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         InterpretationBox[
          StyleBox[GridBox[{
             {"e", 
              StyleBox[GridBox[{
                 {" ", 
                  StyleBox["1",
                   FontColor->RGBColor[1., 0., 0.]]},
                 {"a", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Basis[-$CellContext`a, {1, $CellContext`BS}],
          Editable->False], " ", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"e", 
              StyleBox[GridBox[{
                 {" ", 
                  StyleBox["1",
                   FontColor->RGBColor[1., 0., 0.]]},
                 {"b", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Basis[-$CellContext`b, {1, $CellContext`BS}],
          Editable->False]}], "+", 
        RowBox[{
         InterpretationBox[
          StyleBox[GridBox[{
             {"e", 
              StyleBox[GridBox[{
                 {" ", 
                  StyleBox["2",
                   FontColor->RGBColor[1., 0., 0.]]},
                 {"a", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Basis[-$CellContext`a, {2, $CellContext`BS}],
          Editable->False], " ", 
         InterpretationBox[
          StyleBox[GridBox[{
             {"e", 
              StyleBox[GridBox[{
                 {" ", 
                  StyleBox["2",
                   FontColor->RGBColor[1., 0., 0.]]},
                 {"b", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ShowAutoStyles->False,
           AutoSpacing->False],
          xAct`xTensor`Basis[-$CellContext`b, {2, $CellContext`BS}],
          Editable->False]}]}], ")"}], " ", 
      RowBox[{
       InterpretationBox[
        StyleBox["P",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`P,
        Editable->False], "[", 
       RowBox[{"\[Rho]", ",", "z"}], "]"}]}]}], ")"}]}], "-", 
  FractionBox[
   RowBox[{
    RowBox[{
     InterpretationBox[
      StyleBox["Hy",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`Hy,
      Editable->False], "[", 
     RowBox[{"\[Rho]", ",", "z"}], "]"}], " ", 
    RowBox[{"(", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"e", 
           StyleBox[GridBox[{
              {" ", 
               StyleBox["0",
                FontColor->RGBColor[1., 0., 0.]]},
              {"a", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`xTensor`Basis[-$CellContext`a, {0, $CellContext`BS}],
       Editable->False], "+", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"e", 
            StyleBox[GridBox[{
               {" ", 
                StyleBox["3",
                 FontColor->RGBColor[1., 0., 0.]]},
               {"a", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xTensor`Basis[-$CellContext`a, {3, $CellContext`BS}],
        Editable->False], " ", 
       RowBox[{"(", 
        RowBox[{
         InterpretationBox[
          StyleBox["q",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`q,
          Editable->False], "+", 
         FractionBox[
          RowBox[{
           InterpretationBox[
            StyleBox["\[Omega]\[Psi]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`\[Omega]\[Psi],
            Editable->False], "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}], 
          RowBox[{
           InterpretationBox[
            StyleBox["Hy",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Hy,
            Editable->False], "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}]]}], ")"}]}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"e", 
           StyleBox[GridBox[{
              {" ", 
               StyleBox["0",
                FontColor->RGBColor[1., 0., 0.]]},
              {"b", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`xTensor`Basis[-$CellContext`b, {0, $CellContext`BS}],
       Editable->False], "+", 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"e", 
            StyleBox[GridBox[{
               {" ", 
                StyleBox["3",
                 FontColor->RGBColor[1., 0., 0.]]},
               {"b", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        xAct`xTensor`Basis[-$CellContext`b, {3, $CellContext`BS}],
        Editable->False], " ", 
       RowBox[{"(", 
        RowBox[{
         InterpretationBox[
          StyleBox["q",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`q,
          Editable->False], "+", 
         FractionBox[
          RowBox[{
           InterpretationBox[
            StyleBox["\[Omega]\[Psi]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`\[Omega]\[Psi],
            Editable->False], "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}], 
          RowBox[{
           InterpretationBox[
            StyleBox["Hy",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Hy,
            Editable->False], "[", 
           RowBox[{"\[Rho]", ",", "z"}], "]"}]]}], ")"}]}]}], ")"}]}], 
   RowBox[{
    InterpretationBox[
     StyleBox["Hx",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`Hx,
     Editable->False], "[", 
    RowBox[{"\[Rho]", ",", "z"}], "]"}]]}]], "Output",ExpressionUUID->\
"587bd23c-ad1a-434c-9fad-6e31e89a61be"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"matrix", "=", 
  RowBox[{
   RowBox[{"Coefficient", "[", 
    RowBox[{"BlackSaturn", ",", 
     RowBox[{
      RowBox[{"BasisArray", "[", 
       RowBox[{"BS", ",", "BS"}], "]"}], "[", 
      RowBox[{
       RowBox[{"-", "a"}], ",", 
       RowBox[{"-", "b"}]}], "]"}]}], "]"}], "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\[Rho]", "\[Rule]", 
      RowBox[{"\[Rho]", "[", "]"}]}], ",", 
     RowBox[{"z", "\[Rule]", 
      RowBox[{"z", "[", "]"}]}]}], "}"}]}]}]], "Input",ExpressionUUID->\
"cdf31114-ecea-4f51-bfb9-a610cb234226"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{
        InterpretationBox[
         StyleBox["Hy",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Hy,
         Editable->False], "[", 
        RowBox[{
         InterpretationBox[
          StyleBox["\[Rho]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[Rho][],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["z",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`z[],
          Editable->False]}], "]"}], 
       RowBox[{
        InterpretationBox[
         StyleBox["Hx",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Hx,
         Editable->False], "[", 
        RowBox[{
         InterpretationBox[
          StyleBox["\[Rho]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[Rho][],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["z",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`z[],
          Editable->False]}], "]"}]]}], ",", "0", ",", "0", ",", 
     RowBox[{"-", 
      FractionBox[
       RowBox[{
        RowBox[{
         InterpretationBox[
          StyleBox["Hy",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Hy,
          Editable->False], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["\[Rho]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Rho][],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["z",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`z[],
           Editable->False]}], "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          InterpretationBox[
           StyleBox["q",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`q,
           Editable->False], "+", 
          FractionBox[
           RowBox[{
            InterpretationBox[
             StyleBox["\[Omega]\[Psi]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Omega]\[Psi],
             Editable->False], "[", 
            RowBox[{
             InterpretationBox[
              StyleBox["\[Rho]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Rho][],
              Editable->False], ",", 
             InterpretationBox[
              StyleBox["z",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`z[],
              Editable->False]}], "]"}], 
           RowBox[{
            InterpretationBox[
             StyleBox["Hy",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Hy,
             Editable->False], "[", 
            RowBox[{
             InterpretationBox[
              StyleBox["\[Rho]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Rho][],
              Editable->False], ",", 
             InterpretationBox[
              StyleBox["z",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`z[],
              Editable->False]}], "]"}]]}], ")"}]}], 
       RowBox[{
        InterpretationBox[
         StyleBox["Hx",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Hx,
         Editable->False], "[", 
        RowBox[{
         InterpretationBox[
          StyleBox["\[Rho]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[Rho][],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["z",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`z[],
          Editable->False]}], "]"}]]}], ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["ks",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`ks,
        Editable->False], "2"], " ", 
      RowBox[{
       InterpretationBox[
        StyleBox["Hx",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`Hx,
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["\[Rho]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Rho][],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["z",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`z[],
         Editable->False]}], "]"}], " ", 
      RowBox[{
       InterpretationBox[
        StyleBox["P",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`P,
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["\[Rho]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Rho][],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["z",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`z[],
         Editable->False]}], "]"}]}], ",", "0", ",", "0", ",", "0"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", 
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["ks",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`ks,
        Editable->False], "2"], " ", 
      RowBox[{
       InterpretationBox[
        StyleBox["Hx",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`Hx,
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["\[Rho]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Rho][],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["z",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`z[],
         Editable->False]}], "]"}], " ", 
      RowBox[{
       InterpretationBox[
        StyleBox["P",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`P,
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["\[Rho]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Rho][],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["z",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`z[],
         Editable->False]}], "]"}]}], ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{
        RowBox[{
         InterpretationBox[
          StyleBox["Hy",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Hy,
          Editable->False], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["\[Rho]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Rho][],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["z",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`z[],
           Editable->False]}], "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          InterpretationBox[
           StyleBox["q",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`q,
           Editable->False], "+", 
          FractionBox[
           RowBox[{
            InterpretationBox[
             StyleBox["\[Omega]\[Psi]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Omega]\[Psi],
             Editable->False], "[", 
            RowBox[{
             InterpretationBox[
              StyleBox["\[Rho]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Rho][],
              Editable->False], ",", 
             InterpretationBox[
              StyleBox["z",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`z[],
              Editable->False]}], "]"}], 
           RowBox[{
            InterpretationBox[
             StyleBox["Hy",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Hy,
             Editable->False], "[", 
            RowBox[{
             InterpretationBox[
              StyleBox["\[Rho]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Rho][],
              Editable->False], ",", 
             InterpretationBox[
              StyleBox["z",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`z[],
              Editable->False]}], "]"}]]}], ")"}]}], 
       RowBox[{
        InterpretationBox[
         StyleBox["Hx",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Hx,
         Editable->False], "[", 
        RowBox[{
         InterpretationBox[
          StyleBox["\[Rho]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[Rho][],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["z",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`z[],
          Editable->False]}], "]"}]]}], ",", "0", ",", "0", ",", 
     RowBox[{
      FractionBox[
       RowBox[{
        RowBox[{
         InterpretationBox[
          StyleBox["Gy",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Gy,
          Editable->False], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["\[Rho]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Rho][],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["z",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`z[],
           Editable->False]}], "]"}], " ", 
        RowBox[{
         InterpretationBox[
          StyleBox["Hx",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Hx,
          Editable->False], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["\[Rho]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Rho][],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["z",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`z[],
           Editable->False]}], "]"}]}], 
       RowBox[{
        InterpretationBox[
         StyleBox["Hy",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Hy,
         Editable->False], "[", 
        RowBox[{
         InterpretationBox[
          StyleBox["\[Rho]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[Rho][],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["z",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`z[],
          Editable->False]}], "]"}]], "-", 
      FractionBox[
       RowBox[{
        RowBox[{
         InterpretationBox[
          StyleBox["Hy",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Hy,
          Editable->False], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["\[Rho]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Rho][],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["z",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`z[],
           Editable->False]}], "]"}], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           InterpretationBox[
            StyleBox["q",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`q,
            Editable->False], "+", 
           FractionBox[
            RowBox[{
             InterpretationBox[
              StyleBox["\[Omega]\[Psi]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Omega]\[Psi],
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["\[Rho]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Rho][],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["z",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`z[],
               Editable->False]}], "]"}], 
            RowBox[{
             InterpretationBox[
              StyleBox["Hy",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Hy,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["\[Rho]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Rho][],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["z",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`z[],
               Editable->False]}], "]"}]]}], ")"}], "2"]}], 
       RowBox[{
        InterpretationBox[
         StyleBox["Hx",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Hx,
         Editable->False], "[", 
        RowBox[{
         InterpretationBox[
          StyleBox["\[Rho]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[Rho][],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["z",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`z[],
          Editable->False]}], "]"}]]}], ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", 
     RowBox[{
      InterpretationBox[
       StyleBox["Gx",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`Gx,
       Editable->False], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Rho]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Rho][],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["z",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`z[],
        Editable->False]}], "]"}]}], "}"}]}], "}"}]], "Output",ExpressionUUID-\
>"31262468-bec5-48ef-a687-d2e37f8a31fc"]
}, Open  ]],

Cell["\<\
If we expand the metric into its elementary functions then the result is too \
big to handle, even with Together:\
\>", "Text",ExpressionUUID->"873bcb6a-1bcc-47ec-b544-f5910413d3ef"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ByteCount", "[", 
  RowBox[{"ematrix", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"matrix", "/.", "\[Omega]\[Psi]Function"}], "/.", 
          "HFunctions"}], "/.", "MFunctions"}], "/.", "FFunction"}], "/.", 
       "PFunction"}], "/.", "GFunctions"}], "/.", "RFunctions"}], "/.", 
    "\[Mu]Functions"}]}], "]"}]], "Input",ExpressionUUID->"89d8bdfc-00dd-4af8-\
81db-a42630efeae3"],

Cell[BoxData["996320"], "Output",ExpressionUUID->"f96cfd5c-9894-40d1-a7d7-ebee85b28c84"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Level", "[", 
   RowBox[{"ematrix", ",", 
    RowBox[{"{", 
     RowBox[{"-", "1"}], "}"}], ",", 
    RowBox[{"Heads", "\[Rule]", "True"}]}], "]"}], "//", "Union"}]], "Input",E\
xpressionUUID->"cfa25a36-6990-4ed6-8dde-ccec28fe9628"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "2"}], ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", 
    FractionBox["1", "2"]}], ",", "0", ",", 
   FractionBox["1", "2"], ",", "2", ",", "3", ",", "4", ",", 
   InterpretationBox[
    StyleBox["a1",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`a1,
    Editable->False], ",", 
   InterpretationBox[
    StyleBox["a2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`a2,
    Editable->False], ",", 
   InterpretationBox[
    StyleBox["a3",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`a3,
    Editable->False], ",", 
   InterpretationBox[
    StyleBox["a4",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`a4,
    Editable->False], ",", 
   InterpretationBox[
    StyleBox["a5",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`a5,
    Editable->False], ",", 
   InterpretationBox[
    StyleBox["c1",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`c1,
    Editable->False], ",", 
   InterpretationBox[
    StyleBox["c2",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`c2,
    Editable->False], ",", 
   InterpretationBox[
    StyleBox["ks",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ks,
    Editable->False], ",", "List", ",", "Plus", ",", 
   InterpretationBox[
    StyleBox["Power",
     ShowAutoStyles->False,
     AutoSpacing->False],
    Power,
    Editable->False], ",", 
   InterpretationBox[
    StyleBox["q",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`q,
    Editable->False], ",", "Times", ",", "z", ",", "\[Rho]"}], 
  "}"}]], "Output",ExpressionUUID->"6d971bb7-c749-47ee-92e0-4a73519b9e2e"]
}, Open  ]],

Cell["\<\
Instead, we will compute the Ricci tensor in the nonexpanded form and then \
replace the rules:\
\>", "Text",ExpressionUUID->"4df27674-7ab1-4448-91ed-e3acc5206565"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"met", "=", 
    RowBox[{"CTensor", "[", 
     RowBox[{"matrix", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "BS"}], ",", 
        RowBox[{"-", "BS"}]}], "}"}]}], "]"}]}], ")"}], "[", 
  RowBox[{
   RowBox[{"-", "a"}], ",", 
   RowBox[{"-", "b"}]}], "]"}]], "Input",ExpressionUUID->"67787685-a22c-46ac-\
9a73-9d06d94547fb"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox[
            RowBox[{"-", 
             FractionBox[
              RowBox[{
               InterpretationBox[
                StyleBox["Hy",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Hy,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["\[Rho]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Rho][],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["z",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`z[],
                 Editable->False]}], "]"}], 
              RowBox[{
               InterpretationBox[
                StyleBox["Hx",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Hx,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["\[Rho]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Rho][],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["z",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`z[],
                 Editable->False]}], "]"}]]}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
              RowBox[{"-", 
                FractionBox[
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]]}]}]],
           Annotation[#, {1, 1} -> -$CellContext`Hx[
                $CellContext`\[Rho][], 
                $CellContext`z[]]^(-1) $CellContext`Hy[
               $CellContext`\[Rho][], 
               $CellContext`z[]], "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{"-", 
             FractionBox[
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["Hy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Hy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["\[Rho]",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`\[Rho][],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["z",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`z[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{"(", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["q",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`q,
                  Editable->False], "+", 
                 FractionBox[
                  RowBox[{
                   InterpretationBox[
                    StyleBox["\[Omega]\[Psi]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Omega]\[Psi],
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["\[Rho]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Rho][],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["z",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`z[],
                    Editable->False]}], "]"}], 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["Hy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Hy,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["\[Rho]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Rho][],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["z",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`z[],
                    Editable->False]}], "]"}]]}], ")"}]}], 
              RowBox[{
               InterpretationBox[
                StyleBox["Hx",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Hx,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["\[Rho]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Rho][],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["z",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`z[],
                 Editable->False]}], "]"}]]}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "4"}], "}"}], "\[Rule]", 
              RowBox[{"-", 
                FractionBox[
                 RowBox[{
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], "+", 
                    FractionBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]]}], ")"}]}], 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]]}]}]],
           Annotation[#, {1, 4} -> -$CellContext`Hx[
                $CellContext`\[Rho][], 
                $CellContext`z[]]^(-1) $CellContext`Hy[
               $CellContext`\[Rho][], 
               $CellContext`z[]] ($CellContext`q + $CellContext`Hy[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^(-1) $CellContext`\[Omega]\[Psi][
                 $CellContext`\[Rho][], 
                 $CellContext`z[]]), "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "5"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 5} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{
             SuperscriptBox[
              InterpretationBox[
               StyleBox["ks",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`ks,
               Editable->False], "2"], " ", 
             RowBox[{
              InterpretationBox[
               StyleBox["Hx",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Hx,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["\[Rho]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Rho][],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["z",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`z[],
                Editable->False]}], "]"}], " ", 
             RowBox[{
              InterpretationBox[
               StyleBox["P",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`P,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["\[Rho]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Rho][],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["z",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`z[],
                Editable->False]}], "]"}]}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
              RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"ks"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], $CellContext`ks, Editable -> False], "2"], " ", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}]],
           Annotation[#, {2, 2} -> $CellContext`ks^2 $CellContext`Hx[
               $CellContext`\[Rho][], 
               $CellContext`z[]] $CellContext`P[
               $CellContext`\[Rho][], 
               $CellContext`z[]], "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 4} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "5"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 5} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{
             SuperscriptBox[
              InterpretationBox[
               StyleBox["ks",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`ks,
               Editable->False], "2"], " ", 
             RowBox[{
              InterpretationBox[
               StyleBox["Hx",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Hx,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["\[Rho]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Rho][],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["z",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`z[],
                Editable->False]}], "]"}], " ", 
             RowBox[{
              InterpretationBox[
               StyleBox["P",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`P,
               Editable->False], "[", 
              RowBox[{
               InterpretationBox[
                StyleBox["\[Rho]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Rho][],
                Editable->False], ",", 
               InterpretationBox[
                StyleBox["z",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`z[],
                Editable->False]}], "]"}]}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "3"}], "}"}], "\[Rule]", 
              RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"ks"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], $CellContext`ks, Editable -> False], "2"], " ", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}]],
           Annotation[#, {3, 3} -> $CellContext`ks^2 $CellContext`Hx[
               $CellContext`\[Rho][], 
               $CellContext`z[]] $CellContext`P[
               $CellContext`\[Rho][], 
               $CellContext`z[]], "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 4} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "5"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 5} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox[
            RowBox[{"-", 
             FractionBox[
              RowBox[{
               RowBox[{
                InterpretationBox[
                 StyleBox["Hy",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Hy,
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["\[Rho]",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`\[Rho][],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["z",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`z[],
                  Editable->False]}], "]"}], " ", 
               RowBox[{"(", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["q",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`q,
                  Editable->False], "+", 
                 FractionBox[
                  RowBox[{
                   InterpretationBox[
                    StyleBox["\[Omega]\[Psi]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Omega]\[Psi],
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["\[Rho]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Rho][],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["z",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`z[],
                    Editable->False]}], "]"}], 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["Hy",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Hy,
                    Editable->False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox["\[Rho]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Rho][],
                    Editable->False], ",", 
                    InterpretationBox[
                    StyleBox["z",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`z[],
                    Editable->False]}], "]"}]]}], ")"}]}], 
              RowBox[{
               InterpretationBox[
                StyleBox["Hx",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Hx,
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["\[Rho]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Rho][],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["z",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`z[],
                 Editable->False]}], "]"}]]}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "1"}], "}"}], "\[Rule]", 
              RowBox[{"-", 
                FractionBox[
                 RowBox[{
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], "+", 
                    FractionBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]]}], ")"}]}], 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]]}]}]],
           Annotation[#, {4, 1} -> -$CellContext`Hx[
                $CellContext`\[Rho][], 
                $CellContext`z[]]^(-1) $CellContext`Hy[
               $CellContext`\[Rho][], 
               $CellContext`z[]] ($CellContext`q + $CellContext`Hy[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^(-1) $CellContext`\[Omega]\[Psi][
                 $CellContext`\[Rho][], 
                 $CellContext`z[]]), "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "4"}], "}"}], "\[Rule]", 
              RowBox[{
                FractionBox[
                 RowBox[{
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]], "-", 
                FractionBox[
                 RowBox[{
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], "+", 
                    FractionBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]]}], ")"}], 
                    "2"]}], 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]]}]}]],
           Annotation[#, {4, 4} -> $CellContext`Gy[
                $CellContext`\[Rho][], 
                $CellContext`z[]] $CellContext`Hx[
                $CellContext`\[Rho][], 
                $CellContext`z[]]/$CellContext`Hy[
               $CellContext`\[Rho][], 
               $CellContext`z[]] - $CellContext`Hx[
                $CellContext`\[Rho][], 
                $CellContext`z[]]^(-1) $CellContext`Hy[
               $CellContext`\[Rho][], 
               $CellContext`z[]] ($CellContext`q + $CellContext`Hy[
                   $CellContext`\[Rho][], 
                   $CellContext`z[]]^(-1) $CellContext`\[Omega]\[Psi][
                  $CellContext`\[Rho][], 
                  $CellContext`z[]])^2, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "5"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 5} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"5", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {5, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"5", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {5, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"5", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {5, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"5", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {5, 4} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{
             InterpretationBox[
              StyleBox["Gx",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Gx,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["\[Rho]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Rho][],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["z",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`z[],
               Editable->False]}], "]"}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"5", ",", "5"}], "}"}], "\[Rule]", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                  False], $CellContext`Gx, Editable -> False], "[", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                   "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`\[Rho][], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                   "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`z[], Editable -> False]}], "]"}]}]],
           Annotation[#, {5, 5} -> $CellContext`Gx[
              $CellContext`\[Rho][], 
              $CellContext`z[]], "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 6 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 6 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {" ", " "},
         {"a", "b"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{-$CellContext`Hx[
        $CellContext`\[Rho][], 
        $CellContext`z[]]^(-1) $CellContext`Hy[
       $CellContext`\[Rho][], 
       $CellContext`z[]], 0, 0, -$CellContext`Hx[
        $CellContext`\[Rho][], 
        $CellContext`z[]]^(-1) $CellContext`Hy[
       $CellContext`\[Rho][], 
       $CellContext`z[]] ($CellContext`q + $CellContext`Hy[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^(-1) $CellContext`\[Omega]\[Psi][
         $CellContext`\[Rho][], 
         $CellContext`z[]]), 0}, {0, $CellContext`ks^2 $CellContext`Hx[
       $CellContext`\[Rho][], 
       $CellContext`z[]] $CellContext`P[
       $CellContext`\[Rho][], 
       $CellContext`z[]], 0, 0, 0}, {0, 0, $CellContext`ks^2 $CellContext`Hx[
       $CellContext`\[Rho][], 
       $CellContext`z[]] $CellContext`P[
       $CellContext`\[Rho][], 
       $CellContext`z[]], 0, 0}, {-$CellContext`Hx[
        $CellContext`\[Rho][], 
        $CellContext`z[]]^(-1) $CellContext`Hy[
       $CellContext`\[Rho][], 
       $CellContext`z[]] ($CellContext`q + $CellContext`Hy[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^(-1) $CellContext`\[Omega]\[Psi][
         $CellContext`\[Rho][], 
         $CellContext`z[]]), 0, 0, $CellContext`Gy[
        $CellContext`\[Rho][], 
        $CellContext`z[]] $CellContext`Hx[
        $CellContext`\[Rho][], 
        $CellContext`z[]]/$CellContext`Hy[
       $CellContext`\[Rho][], 
       $CellContext`z[]] - $CellContext`Hx[
        $CellContext`\[Rho][], 
        $CellContext`z[]]^(-1) $CellContext`Hy[
       $CellContext`\[Rho][], 
       $CellContext`z[]] ($CellContext`q + $CellContext`Hy[
           $CellContext`\[Rho][], 
           $CellContext`z[]]^(-1) $CellContext`\[Omega]\[Psi][
          $CellContext`\[Rho][], 
          $CellContext`z[]])^2, 0}, {0, 0, 0, 0, 
     $CellContext`Gx[
      $CellContext`\[Rho][], 
      $CellContext`z[]]}}, {-$CellContext`BS, -$CellContext`BS}, 
   0][-$CellContext`a, -$CellContext`b],
  Editable->False]], "Output",ExpressionUUID->"63ceda0a-7d8b-48c7-8a9a-\
ab8059c99524"]
}, Open  ]],

Cell["\<\
Actually, it is possible to multiply the H and \[Omega]\[Psi] functions by F \
and then F appears only dividing P in the metric, so that F could be \
reabsorbed in the definition of P, simplifying the form of some intermediate \
results, but we prefer to follow the original.\
\>", "Text",ExpressionUUID->"30d4a15c-d64a-45fe-969a-61279c66c49f"],

Cell["We still use Simplify everywhere:", "Text",ExpressionUUID->"6906dea0-543b-423d-98aa-054b045bd453"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"SetCMetric", "[", 
   RowBox[{"met", ",", "BS", ",", 
    RowBox[{"SignatureOfMetric", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"4", ",", "1", ",", "0"}], "}"}]}]}], "]"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"c4222b3f-8ac0-484c-9969-\
29826c40b31a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.317261`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"2d96c0ce-519f-4f47-bfc6-0035baaee093"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MetricCompute", "[", 
   RowBox[{"met", ",", "BS", ",", 
    RowBox[{"\"\<Ricci\>\"", "[", 
     RowBox[{
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}]}], "]"}]}], "]"}], "//", "AbsoluteTiming"}]], "Input",\
ExpressionUUID->"147bea10-9b16-41da-9a04-fff9774a7f28"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"21.606278`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"d2514252-8883-4992-bb45-3bc03d1ecc64"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"cd", "=", 
   RowBox[{"CovDOfMetric", "[", "met", "]"}]}], ";"}]], "Input",ExpressionUUID\
->"2b571e57-0c06-42de-a1b3-719c6afd815a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ricci", "=", 
   RowBox[{"Ricci", "[", "cd", "]"}]}], ";"}]], "Input",ExpressionUUID->\
"21f6937b-b073-417b-b079-612bb660aad8"],

Cell["Some components are already shown to be 0:", "Text",ExpressionUUID->"65e12a4e-77c1-4399-b4b4-df085cd0dcad"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ricci", "[", 
  RowBox[{
   RowBox[{"-", "a"}], ",", 
   RowBox[{"-", "b"}]}], "]"}]], "Input",ExpressionUUID->"81452e50-7b81-4fee-\
be41-22f9202f6d2b"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 RowBox[{
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}]}], ")"}]}], "+", 
                 RowBox[{
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], 
               RowBox[{"4", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"ks"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`ks, Editable -> False], "2"], " ", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "4"], " ", 
                 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]]}]],
           
           Annotation[#, {1, 1} -> 
            Rational[1, 4] $CellContext`ks^(-2) $CellContext`Gx[
                $CellContext`\[Rho][], 
                $CellContext`z[]]^(-1) $CellContext`Gy[
                $CellContext`\[Rho][], 
                $CellContext`z[]]^(-1) $CellContext`Hx[
                $CellContext`\[Rho][], 
                $CellContext`z[]]^(-4) $CellContext`Hy[
                $CellContext`\[Rho][], 
                $CellContext`z[]]^(-1) $CellContext`P[
                $CellContext`\[Rho][], 
                $CellContext`z[]]^(-1) ($CellContext`Gx[
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] (-$CellContext`Hx[
                   $CellContext`\[Rho][], 
                   $CellContext`z[]] $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 (Derivative[0, 1][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[0, 1][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[1, 0][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) + $CellContext`Hx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 $CellContext`Hy[
                   $CellContext`\[Rho][], 
                   $CellContext`z[]] (Derivative[0, 1][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[1, 0][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) + 2 $CellContext`\[Omega]\[Psi][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 (Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 + Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2) - 4 $CellContext`Hy[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]] $CellContext`\[Omega]\[Psi][
                  $CellContext`\[Rho][], 
                  $CellContext`z[]] (Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] 
                  Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] 
                  Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) + 2 $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 (
                  Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 + 
                  Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2)) + $CellContext`Gy[
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] (2 $CellContext`Gx[
                   $CellContext`\[Rho][], 
                   $CellContext`z[]] $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 (Derivative[0, 1][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 + Derivative[1, 0][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2) - $CellContext`Hx[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]] $CellContext`Hy[
                   $CellContext`\[Rho][], 
                   $CellContext`z[]]^2 (Derivative[0, 1][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[0, 1][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[1, 0][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + 2 $CellContext`Gx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 2][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[2, 0][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]])) + $CellContext`Hx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 ((-2) $CellContext`Gx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 + Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2) + $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 1][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[1, 0][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + 2 $CellContext`Gx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 2][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[2, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]))))), "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "4"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 RowBox[{
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                 RowBox[{
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], 
               RowBox[{"4", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"ks"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`ks, Editable -> False], "2"], " ", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "4"], " ", 
                 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]]}]],
           
           Annotation[#, {1, 4} -> 
            Rational[1, 4] $CellContext`ks^(-2) $CellContext`Gx[
                $CellContext`\[Rho][], 
                $CellContext`z[]]^(-1) $CellContext`Gy[
                $CellContext`\[Rho][], 
                $CellContext`z[]]^(-1) $CellContext`Hx[
                $CellContext`\[Rho][], 
                $CellContext`z[]]^(-4) $CellContext`Hy[
                $CellContext`\[Rho][], 
                $CellContext`z[]]^(-2) $CellContext`P[
                $CellContext`\[Rho][], 
                $CellContext`z[]]^(-1) ($CellContext`Gx[
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] (-$CellContext`Hx[
                   $CellContext`\[Rho][], 
                   $CellContext`z[]] $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 ($CellContext`q $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + $CellContext`\[Omega]\[Psi][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) (Derivative[0, 1][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[0, 1][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[1, 0][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) + $CellContext`Hx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 $CellContext`Hy[
                   $CellContext`\[Rho][], 
                   $CellContext`z[]] (2 $CellContext`\[Omega]\[Psi][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 1][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[1, 0][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) + $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 1][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] ($CellContext`q 
                    Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] - Derivative[
                    0, 1][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) + Derivative[1, 0][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] ($CellContext`q 
                    Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] - Derivative[
                    1, 0][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]))) + 2 ($CellContext`q $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + $CellContext`\[Omega]\[Psi][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) ($CellContext`\[Omega]\[Psi][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 (Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 + Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2) - 2 $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] $CellContext`\[Omega]\[Psi][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] 
                    Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] 
                    Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) + $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 (
                    Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 + 
                    Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2))) + $CellContext`Gy[
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] (2 $CellContext`Gx[
                   $CellContext`\[Rho][], 
                   $CellContext`z[]] $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 ($CellContext`q $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + $CellContext`\[Omega]\[Psi][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) (Derivative[0, 1][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 + Derivative[1, 0][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2) - $CellContext`Hx[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]] $CellContext`Hy[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]] ((-4) $CellContext`Gx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] $CellContext`\[Omega]\[Psi][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 1][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[1, 0][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) + $CellContext`q $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 (Derivative[0, 1][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[0, 1][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[1, 0][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + 2 $CellContext`Gx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 2][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[2, 0][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]])) + $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (4 $CellContext`Gx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 1][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] 
                    Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[1, 0][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] 
                    Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) + $CellContext`\[Omega]\[Psi][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 1][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[0, 1][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[1, 0][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + 2 $CellContext`Gx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 2][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[2, 0][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]])))) + $CellContext`Hx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 ((-2) $CellContext`q $CellContext`Gx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 + Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2) - 2 $CellContext`Gx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] $CellContext`\[Omega]\[Psi][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 + Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2) + $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 (Derivative[0, 1][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] ($CellContext`q 
                    Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + 
                    Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) + Derivative[1, 0][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] ($CellContext`q 
                    Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + 
                    Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) + 2 $CellContext`Gx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] ($CellContext`q 
                    Derivative[0, 2][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + 
                    Derivative[0, 2][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + $CellContext`q 
                    Derivative[2, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + 
                    Derivative[2, 0][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]))))), "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "5"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 5} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
              RowBox[{
                FractionBox["1", "4"], " ", 
                RowBox[{"(", 
                  RowBox[{
                    FractionBox[
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]], "+", 
                    FractionBox[
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]], "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]], "+", 
                    FractionBox[
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]], "-", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]}], 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]], "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]], "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}], 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]}]], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]]}], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]], "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]], "-", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]]}], 
                  ")"}]}]}]],
           Annotation[#, {2, 2} -> Rational[1, 4] ($CellContext`Gx[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^(-2) Derivative[1, 0][$CellContext`Gx][
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^2 + $CellContext`Gy[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^(-2) Derivative[1, 0][$CellContext`Gy][
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^2 - $CellContext`Gy[
                 $CellContext`\[Rho][], 
                 $CellContext`z[]]^(-1) $CellContext`Hx[
                 $CellContext`\[Rho][], 
                 $CellContext`z[]]^(-1) (Derivative[0, 1][$CellContext`Gy][
                  $CellContext`\[Rho][], 
                  $CellContext`z[]] Derivative[0, 1][$CellContext`Hx][
                  $CellContext`\[Rho][], 
                  $CellContext`z[]] + Derivative[1, 0][$CellContext`Gy][
                  $CellContext`\[Rho][], 
                  $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]) + 2 $CellContext`Gy[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^(-1) $CellContext`Hy[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^(-1) Derivative[1, 0][$CellContext`Gy][
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] + 4 $CellContext`Hx[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^(-1) $CellContext`Hy[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^(-1) Derivative[1, 0][$CellContext`Hx][
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] - 2 $CellContext`Hy[
                 $CellContext`\[Rho][], 
                 $CellContext`z[]]^(-2) Derivative[1, 0][$CellContext`Hy][
                 $CellContext`\[Rho][], 
                 $CellContext`z[]]^2 + 2 $CellContext`P[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^(-2) (Derivative[0, 1][$CellContext`P][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]]^2 + Derivative[1, 0][$CellContext`P][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]]^2) + 2 $CellContext`Gy[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^(-1) $CellContext`Hx[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^(-2) $CellContext`Hy[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^(-2) ($CellContext`\[Omega]\[Psi][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] - $CellContext`Hy[
                   $CellContext`\[Rho][], 
                   $CellContext`z[]] 
                 Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]])^2 + $CellContext`Gx[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^(-1) ($CellContext`Hx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^(-1) (-Derivative[0, 1][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[0, 1][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[1, 0][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) + $CellContext`P[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^(-1) (-Derivative[0, 1][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[0, 1][$CellContext`P][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[1, 0][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`P][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] - 2 $CellContext`P[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[2, 0][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]])) + $CellContext`Gy[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^(-1) $CellContext`P[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^(-1) (-Derivative[0, 1][$CellContext`Gy][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]] Derivative[0, 1][$CellContext`P][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]] + Derivative[1, 0][$CellContext`Gy][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]] Derivative[1, 0][$CellContext`P][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]] - 2 $CellContext`P[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]] Derivative[2, 0][$CellContext`Gy][
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]) + 2 $CellContext`Hx[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^(-2) (Derivative[0, 1][$CellContext`Hx][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]]^2 - $CellContext`Hx[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]] (Derivative[0, 2][$CellContext`Hx][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]] + Derivative[2, 0][$CellContext`Hx][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]])) - 2 $CellContext`P[
                 $CellContext`\[Rho][], 
                 $CellContext`z[]]^(-1) (Derivative[0, 2][$CellContext`P][
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] + Derivative[2, 0][$CellContext`P][
                 $CellContext`\[Rho][], 
                 $CellContext`z[]])), "Tooltip"]& ], 
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "3"}], "}"}], "\[Rule]", 
              RowBox[{
                FractionBox["1", "4"], " ", 
                RowBox[{"(", 
                  RowBox[{
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]], "+", 
                    FractionBox[
                    RowBox[{
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]]}], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]], "+", 
                    FractionBox[
                    RowBox[{
                    FractionBox[
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]], "-", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]], "+", 
                    FractionBox[
                    RowBox[{
                    FractionBox[
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]], "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]]}], 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]]}], 
                  ")"}]}]}]],
           Annotation[#, {2, 3} -> Rational[1, 4] ($CellContext`Gx[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^(-2) Derivative[0, 1][$CellContext`Gx][
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] Derivative[1, 0][$CellContext`Gx][
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] + $CellContext`Gx[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^(-1) ($CellContext`Hx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^(-1) (
                  Derivative[0, 1][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[0, 1][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) + $CellContext`P[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^(-1) (Derivative[0, 1][$CellContext`P][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[0, 1][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`P][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] - 2 $CellContext`P[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 1][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]])) + $CellContext`Hy[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^(-2) ($CellContext`Gy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^(-2) $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 Derivative[0, 1][$CellContext`Gy][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]] Derivative[1, 0][$CellContext`Gy][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]] - 2 $CellContext`Hx[
                   $CellContext`\[Rho][], 
                   $CellContext`z[]]^(-2) (-$CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[0, 1][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + $CellContext`Hx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) (-$CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + $CellContext`Hx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) + $CellContext`Gy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^(-1) ($CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 $CellContext`P[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^(-1) (Derivative[0, 1][$CellContext`P][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[0, 1][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`P][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) + 2 $CellContext`Hx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^(-2) ($CellContext`\[Omega]\[Psi][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] - $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] 
                    Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) ($CellContext`\[Omega]\[Psi][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] - $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] 
                    Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) + $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[0, 1][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] - 2 $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 1][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]])))), "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 4} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "5"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 5} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "2"}], "}"}], "\[Rule]", 
              RowBox[{
                FractionBox["1", "4"], " ", 
                RowBox[{"(", 
                  RowBox[{
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]], "+", 
                    FractionBox[
                    RowBox[{
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]]}], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]], "+", 
                    FractionBox[
                    RowBox[{
                    FractionBox[
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]], "-", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]], "+", 
                    FractionBox[
                    RowBox[{
                    FractionBox[
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]], "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]]}], 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]]}], 
                  ")"}]}]}]],
           Annotation[#, {3, 2} -> Rational[1, 4] ($CellContext`Gx[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^(-2) Derivative[0, 1][$CellContext`Gx][
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] Derivative[1, 0][$CellContext`Gx][
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] + $CellContext`Gx[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^(-1) ($CellContext`Hx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^(-1) (
                  Derivative[0, 1][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[0, 1][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) + $CellContext`P[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^(-1) (Derivative[0, 1][$CellContext`P][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[0, 1][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`P][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] - 2 $CellContext`P[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 1][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]])) + $CellContext`Hy[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^(-2) ($CellContext`Gy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^(-2) $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 Derivative[0, 1][$CellContext`Gy][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]] Derivative[1, 0][$CellContext`Gy][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]] - 2 $CellContext`Hx[
                   $CellContext`\[Rho][], 
                   $CellContext`z[]]^(-2) (-$CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[0, 1][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + $CellContext`Hx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) (-$CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + $CellContext`Hx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) + $CellContext`Gy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^(-1) ($CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 $CellContext`P[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^(-1) (Derivative[0, 1][$CellContext`P][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[0, 1][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`P][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) + 2 $CellContext`Hx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^(-2) ($CellContext`\[Omega]\[Psi][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] - $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] 
                    Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) ($CellContext`\[Omega]\[Psi][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] - $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] 
                    Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) + $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[0, 1][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] - 2 $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 1][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]])))), "Tooltip"]& ], 
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "3"}], "}"}], "\[Rule]", 
              RowBox[{
                FractionBox["1", "4"], " ", 
                RowBox[{"(", 
                  RowBox[{
                    FractionBox[
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]], "+", 
                    FractionBox[
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]], "-", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]}], 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]], "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], ")"}], 
                    "2"]}], 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]}]], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]], "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]}], 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]], "+", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]]}], 
                  ")"}]}]}]],
           Annotation[#, {3, 3} -> Rational[1, 4] ($CellContext`Gy[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^(-2) Derivative[0, 1][$CellContext`Gy][
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^2 + 4 $CellContext`Hx[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^(-1) $CellContext`Hy[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^(-1) Derivative[0, 1][$CellContext`Hx][
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] Derivative[0, 1][$CellContext`Hy][
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] - 2 $CellContext`Hy[
                 $CellContext`\[Rho][], 
                 $CellContext`z[]]^(-2) Derivative[0, 1][$CellContext`Hy][
                 $CellContext`\[Rho][], 
                 $CellContext`z[]]^2 + 2 $CellContext`Gy[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^(-1) $CellContext`Hx[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^(-2) $CellContext`Hy[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^(-2) ($CellContext`\[Omega]\[Psi][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] - $CellContext`Hy[
                   $CellContext`\[Rho][], 
                   $CellContext`z[]] 
                 Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]])^2 + $CellContext`Gx[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^(-2) (Derivative[0, 1][$CellContext`Gx][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]]^2 - 2 $CellContext`Gx[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]] Derivative[0, 2][$CellContext`Gx][
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]) + $CellContext`Gy[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^(-1) $CellContext`Hy[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^(-1) (
                2 Derivative[0, 1][$CellContext`Gy][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]] Derivative[0, 1][$CellContext`Hy][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]] - 2 $CellContext`Hy[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]] Derivative[0, 2][$CellContext`Gy][
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]) + 2 $CellContext`Hx[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^(-2) Derivative[1, 0][$CellContext`Hx][
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^2 - $CellContext`Gy[
                 $CellContext`\[Rho][], 
                 $CellContext`z[]]^(-1) $CellContext`Hx[
                 $CellContext`\[Rho][], 
                 $CellContext`z[]]^(-1) (Derivative[0, 1][$CellContext`Gy][
                  $CellContext`\[Rho][], 
                  $CellContext`z[]] Derivative[0, 1][$CellContext`Hx][
                  $CellContext`\[Rho][], 
                  $CellContext`z[]] + Derivative[1, 0][$CellContext`Gy][
                  $CellContext`\[Rho][], 
                  $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]) + $CellContext`Gy[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^(-1) $CellContext`P[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^(-1) (Derivative[0, 1][$CellContext`Gy][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]] Derivative[0, 1][$CellContext`P][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]] - Derivative[1, 0][$CellContext`Gy][
                  $CellContext`\[Rho][], 
                  $CellContext`z[]] Derivative[1, 0][$CellContext`P][
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]) + 2 $CellContext`P[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^(-2) (Derivative[0, 1][$CellContext`P][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]]^2 + Derivative[1, 0][$CellContext`P][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]]^2) + $CellContext`Gx[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^(-1) $CellContext`Hx[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^(-1) (Derivative[0, 1][$CellContext`Gx][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]] Derivative[0, 1][$CellContext`Hx][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]] - Derivative[1, 0][$CellContext`Gx][
                  $CellContext`\[Rho][], 
                  $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
                  $CellContext`\[Rho][], 
                  $CellContext`z[]] - 2 $CellContext`Gx[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]] (Derivative[0, 2][$CellContext`Hx][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]] + Derivative[2, 0][$CellContext`Hx][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]])) + $CellContext`Gx[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^(-1) $CellContext`P[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^(-1) (Derivative[0, 1][$CellContext`Gx][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]] Derivative[0, 1][$CellContext`P][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]] - Derivative[1, 0][$CellContext`Gx][
                  $CellContext`\[Rho][], 
                  $CellContext`z[]] Derivative[1, 0][$CellContext`P][
                  $CellContext`\[Rho][], 
                  $CellContext`z[]] - 2 $CellContext`Gx[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]] (Derivative[0, 2][$CellContext`P][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]] + Derivative[2, 0][$CellContext`P][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]]))), "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 4} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "5"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 5} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "1"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 RowBox[{
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                 RowBox[{
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], 
               RowBox[{"4", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"ks"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`ks, Editable -> False], "2"], " ", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "4"], " ", 
                 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]]}]],
           
           Annotation[#, {4, 1} -> 
            Rational[1, 4] $CellContext`ks^(-2) $CellContext`Gx[
                $CellContext`\[Rho][], 
                $CellContext`z[]]^(-1) $CellContext`Gy[
                $CellContext`\[Rho][], 
                $CellContext`z[]]^(-1) $CellContext`Hx[
                $CellContext`\[Rho][], 
                $CellContext`z[]]^(-4) $CellContext`Hy[
                $CellContext`\[Rho][], 
                $CellContext`z[]]^(-2) $CellContext`P[
                $CellContext`\[Rho][], 
                $CellContext`z[]]^(-1) ($CellContext`Gx[
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] (-$CellContext`Hx[
                   $CellContext`\[Rho][], 
                   $CellContext`z[]] $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 ($CellContext`q $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + $CellContext`\[Omega]\[Psi][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) (Derivative[0, 1][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[0, 1][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[1, 0][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) + $CellContext`Hx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 $CellContext`Hy[
                   $CellContext`\[Rho][], 
                   $CellContext`z[]] (2 $CellContext`\[Omega]\[Psi][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 1][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[1, 0][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) + $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 1][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] ($CellContext`q 
                    Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] - Derivative[
                    0, 1][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) + Derivative[1, 0][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] ($CellContext`q 
                    Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] - Derivative[
                    1, 0][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]))) + 2 ($CellContext`q $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + $CellContext`\[Omega]\[Psi][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) ($CellContext`\[Omega]\[Psi][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 (Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 + Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2) - 2 $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] $CellContext`\[Omega]\[Psi][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] 
                    Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] 
                    Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) + $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 (
                    Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 + 
                    Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2))) + $CellContext`Gy[
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] (2 $CellContext`Gx[
                   $CellContext`\[Rho][], 
                   $CellContext`z[]] $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 ($CellContext`q $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + $CellContext`\[Omega]\[Psi][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) (Derivative[0, 1][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 + Derivative[1, 0][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2) - $CellContext`Hx[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]] $CellContext`Hy[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]] ((-4) $CellContext`Gx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] $CellContext`\[Omega]\[Psi][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 1][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[1, 0][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) + $CellContext`q $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 (Derivative[0, 1][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[0, 1][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[1, 0][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + 2 $CellContext`Gx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 2][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[2, 0][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]])) + $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (4 $CellContext`Gx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 1][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] 
                    Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[1, 0][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] 
                    Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) + $CellContext`\[Omega]\[Psi][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 1][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[0, 1][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[1, 0][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + 2 $CellContext`Gx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 2][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[2, 0][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]])))) + $CellContext`Hx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 ((-2) $CellContext`q $CellContext`Gx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 + Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2) - 2 $CellContext`Gx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] $CellContext`\[Omega]\[Psi][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 + Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2) + $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 (Derivative[0, 1][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] ($CellContext`q 
                    Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + 
                    Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) + Derivative[1, 0][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] ($CellContext`q 
                    Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + 
                    Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) + 2 $CellContext`Gx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] ($CellContext`q 
                    Derivative[0, 2][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + 
                    Derivative[0, 2][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + $CellContext`q 
                    Derivative[2, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + 
                    Derivative[2, 0][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]))))), "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "4"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 RowBox[{
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "4"], " ", 
                    
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}], 
                    "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"3", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}], 
                    "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                 RowBox[{
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                   
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                   
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "-", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}], "-", 
                 RowBox[{
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "3"], " ", 
                    
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}], 
                    "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "4"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> False], 
                    
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "8"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"8", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]}], 
                    "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["z", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], "2"]}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]}], 
                    "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"q"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`q, Editable -> False], "2"], " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"]}], 
                    "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Omega]\[Psi]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Omega]\[Psi], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], 
               RowBox[{"4", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"ks"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`ks, Editable -> False], "2"], " ", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "4"], " ", 
                 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Hy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "3"], " ", 
                 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]]}]],
           
           Annotation[#, {4, 4} -> 
            Rational[1, 4] $CellContext`ks^(-2) $CellContext`Gx[
                $CellContext`\[Rho][], 
                $CellContext`z[]]^(-1) $CellContext`Gy[
                $CellContext`\[Rho][], 
                $CellContext`z[]]^(-1) $CellContext`Hx[
                $CellContext`\[Rho][], 
                $CellContext`z[]]^(-4) $CellContext`Hy[
                $CellContext`\[Rho][], 
                $CellContext`z[]]^(-3) $CellContext`P[
                $CellContext`\[Rho][], 
                $CellContext`z[]]^(-1) ($CellContext`Gx[
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] ($CellContext`Hx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^4 $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 (Derivative[0, 1][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 + Derivative[1, 0][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2) - $CellContext`Hx[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]] $CellContext`Hy[
                   $CellContext`\[Rho][], 
                   $CellContext`z[]]^2 ($CellContext`q $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + $CellContext`\[Omega]\[Psi][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]])^2 (Derivative[0, 1][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[0, 1][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[1, 0][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) + $CellContext`Hx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 $CellContext`Hy[
                   $CellContext`\[Rho][], 
                   $CellContext`z[]] ($CellContext`q $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + $CellContext`\[Omega]\[Psi][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) (3 $CellContext`\[Omega]\[Psi][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 1][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[1, 0][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) + $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 1][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] ($CellContext`q 
                    Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] - 2 
                    Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) + Derivative[1, 0][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] ($CellContext`q 
                    Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] - 2 
                    Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]))) + 2 ($CellContext`q $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + $CellContext`\[Omega]\[Psi][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]])^2 ($CellContext`\[Omega]\[Psi][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 (Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 + Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2) - 2 $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] $CellContext`\[Omega]\[Psi][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] 
                    Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] 
                    Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) + $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 (
                    Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 + 
                    Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2))) + $CellContext`Gy[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^2 $CellContext`Hx[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^2 (2 $CellContext`Gx[
                   $CellContext`\[Rho][], 
                   $CellContext`z[]] $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 (Derivative[0, 1][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 + Derivative[1, 0][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2) - $CellContext`Hx[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]] $CellContext`Hy[
                   $CellContext`\[Rho][], 
                   $CellContext`z[]]^2 (Derivative[0, 1][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[0, 1][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[1, 0][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + 2 $CellContext`Gx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 2][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[2, 0][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]])) + $CellContext`Hx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 ((-2) $CellContext`Gx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 + Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2) + $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 1][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[1, 0][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + 2 $CellContext`Gx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 2][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[2, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]])))) - $CellContext`Gy[
                $CellContext`\[Rho][], 
                $CellContext`z[]] $CellContext`Hy[
                $CellContext`\[Rho][], 
                $CellContext`z[]] ($CellContext`Gx[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]] $CellContext`Hx[
                   $CellContext`\[Rho][], 
                   $CellContext`z[]]^3 $CellContext`Hy[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]] (Derivative[0, 1][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[0, 1][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[1, 0][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) - 2 $CellContext`Gx[
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] $CellContext`Hy[
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] ($CellContext`q $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + $CellContext`\[Omega]\[Psi][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]])^2 (Derivative[0, 1][$CellContext`Hx][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]]^2 + Derivative[1, 0][$CellContext`Hx][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]]^2) + $CellContext`Hx[
                   $CellContext`\[Rho][], 
                   $CellContext`z[]]^4 (-$CellContext`Gx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 1][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[1, 0][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) + $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 1][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[0, 1][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[1, 0][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + 2 $CellContext`Gx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 2][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[2, 0][$CellContext`Gy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]))) + $CellContext`Hx[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]] ($CellContext`q $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + $CellContext`\[Omega]\[Psi][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]]) ((-8) $CellContext`Gx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] $CellContext`\[Omega]\[Psi][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 1][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[1, 0][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) + $CellContext`q $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 (Derivative[0, 1][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[0, 1][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[1, 0][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + 2 $CellContext`Gx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 2][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[2, 0][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]])) + $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (8 $CellContext`Gx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 1][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] 
                    Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[1, 0][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] 
                    Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) + $CellContext`\[Omega]\[Psi][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 1][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[0, 1][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[1, 0][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + 2 $CellContext`Gx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 2][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[2, 0][$CellContext`Hx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]])))) - $CellContext`Hx[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]]^2 (-$CellContext`\[Omega]\[Psi][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]] (4 $CellContext`Gx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] ($CellContext`q 
                    Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 + Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] 
                    Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] ($CellContext`q 
                    Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + 
                    Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]])) + $CellContext`\[Omega]\[Psi][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 1][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[1, 0][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + 2 $CellContext`Gx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 2][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[2, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]))) + $CellContext`q $CellContext`Hy[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 (Derivative[0, 1][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] ($CellContext`q 
                    Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + 
                    2 Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) + Derivative[1, 0][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] ($CellContext`q 
                    Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + 
                    2 Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) + 2 $CellContext`Gx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] ($CellContext`q 
                    Derivative[0, 2][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + 
                    2 Derivative[0, 2][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + $CellContext`q 
                    Derivative[2, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + 
                    2 Derivative[2, 0][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]])) + 2 $CellContext`Hy[
                   $CellContext`\[Rho][], 
                   $CellContext`z[]] ($CellContext`\[Omega]\[Psi][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (Derivative[0, 1][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] 
                    Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] + Derivative[1, 0][$CellContext`Gx][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] 
                    Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]) + $CellContext`Gx[
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] (-$CellContext`q^2 
                    Derivative[0, 1][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 + 
                    Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 + 2 $CellContext`\[Omega]\[Psi][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] 
                    Derivative[0, 2][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] - $CellContext`q^2 
                    Derivative[1, 0][$CellContext`Hy][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 + 
                    Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]^2 + 2 $CellContext`\[Omega]\[Psi][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]] 
                    Derivative[2, 0][$CellContext`\[Omega]\[Psi]][
                    $CellContext`\[Rho][], 
                    $CellContext`z[]]))))), "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "5"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 5} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"5", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {5, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"5", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {5, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"5", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {5, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"5", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {5, 4} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"5", ",", "5"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 RowBox[{
                   RowBox[{"-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], "+", 
                 RowBox[{
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "+", 
                    
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "2"], "-", 
                    
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], 
               RowBox[{"4", " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"ks"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`ks, Editable -> False], "2"], " ", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"Gx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gx, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"Gy"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Gy, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"Hx"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Hx, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}], " ", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"P"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`P, Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "\[Rho]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Rho][], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "z", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`z[], Editable -> False]}], "]"}]}]]}]],
           
           Annotation[#, {5, 5} -> 
            Rational[1, 4] $CellContext`ks^(-2) $CellContext`Gx[
                $CellContext`\[Rho][], 
                $CellContext`z[]]^(-1) $CellContext`Gy[
                $CellContext`\[Rho][], 
                $CellContext`z[]]^(-1) $CellContext`Hx[
                $CellContext`\[Rho][], 
                $CellContext`z[]]^(-1) $CellContext`P[
                $CellContext`\[Rho][], 
                $CellContext`z[]]^(-1) (-$CellContext`Gx[
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] (Derivative[0, 1][$CellContext`Gx][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]] Derivative[0, 1][$CellContext`Gy][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]] + Derivative[1, 0][$CellContext`Gx][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]] Derivative[1, 0][$CellContext`Gy][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]]) + $CellContext`Gy[
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] (Derivative[0, 1][$CellContext`Gx][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]]^2 + Derivative[1, 0][$CellContext`Gx][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]]^2 - 2 $CellContext`Gx[
                  $CellContext`\[Rho][], 
                  $CellContext`z[]] (Derivative[0, 2][$CellContext`Gx][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]] + Derivative[2, 0][$CellContext`Gx][
                   $CellContext`\[Rho][], 
                   $CellContext`z[]]))), "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 6 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 6 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {" ", " "},
         {"a", "b"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{Rational[1, 4] $CellContext`ks^(-2) $CellContext`Gx[
        $CellContext`\[Rho][], 
        $CellContext`z[]]^(-1) $CellContext`Gy[
        $CellContext`\[Rho][], 
        $CellContext`z[]]^(-1) $CellContext`Hx[
        $CellContext`\[Rho][], 
        $CellContext`z[]]^(-4) $CellContext`Hy[
        $CellContext`\[Rho][], 
        $CellContext`z[]]^(-1) $CellContext`P[
        $CellContext`\[Rho][], 
        $CellContext`z[]]^(-1) ($CellContext`Gx[
         $CellContext`\[Rho][], 
         $CellContext`z[]] (-$CellContext`Hx[
           $CellContext`\[Rho][], 
           $CellContext`z[]] $CellContext`Hy[
            $CellContext`\[Rho][], 
            $CellContext`z[]]^2 (Derivative[0, 1][$CellContext`Gy][
             $CellContext`\[Rho][], 
             $CellContext`z[]] Derivative[0, 1][$CellContext`Hx][
             $CellContext`\[Rho][], 
             $CellContext`z[]] + Derivative[1, 0][$CellContext`Gy][
             $CellContext`\[Rho][], 
             $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
             $CellContext`\[Rho][], 
             $CellContext`z[]]) + $CellContext`Hx[
            $CellContext`\[Rho][], 
            $CellContext`z[]]^2 $CellContext`Hy[
           $CellContext`\[Rho][], 
           $CellContext`z[]] (Derivative[0, 1][$CellContext`Gy][
             $CellContext`\[Rho][], 
             $CellContext`z[]] Derivative[0, 1][$CellContext`Hy][
             $CellContext`\[Rho][], 
             $CellContext`z[]] + Derivative[1, 0][$CellContext`Gy][
             $CellContext`\[Rho][], 
             $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
             $CellContext`\[Rho][], 
             $CellContext`z[]]) + 2 $CellContext`\[Omega]\[Psi][
            $CellContext`\[Rho][], 
            $CellContext`z[]]^2 (Derivative[0, 1][$CellContext`Hy][
             $CellContext`\[Rho][], 
             $CellContext`z[]]^2 + Derivative[1, 0][$CellContext`Hy][
             $CellContext`\[Rho][], 
             $CellContext`z[]]^2) - 4 $CellContext`Hy[
          $CellContext`\[Rho][], 
          $CellContext`z[]] $CellContext`\[Omega]\[Psi][
          $CellContext`\[Rho][], 
          $CellContext`z[]] (Derivative[0, 1][$CellContext`Hy][
            $CellContext`\[Rho][], 
            $CellContext`z[]] Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
            $CellContext`\[Rho][], 
            $CellContext`z[]] + Derivative[1, 0][$CellContext`Hy][
            $CellContext`\[Rho][], 
            $CellContext`z[]] Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
            $CellContext`\[Rho][], 
            $CellContext`z[]]) + 2 $CellContext`Hy[
            $CellContext`\[Rho][], 
            $CellContext`z[]]^2 (Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
             $CellContext`\[Rho][], 
             $CellContext`z[]]^2 + 
          Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
             $CellContext`\[Rho][], 
             $CellContext`z[]]^2)) + $CellContext`Gy[
         $CellContext`\[Rho][], 
         $CellContext`z[]] (2 $CellContext`Gx[
           $CellContext`\[Rho][], 
           $CellContext`z[]] $CellContext`Hy[
            $CellContext`\[Rho][], 
            $CellContext`z[]]^2 (Derivative[0, 1][$CellContext`Hx][
             $CellContext`\[Rho][], 
             $CellContext`z[]]^2 + Derivative[1, 0][$CellContext`Hx][
             $CellContext`\[Rho][], 
             $CellContext`z[]]^2) - $CellContext`Hx[
          $CellContext`\[Rho][], 
          $CellContext`z[]] $CellContext`Hy[
           $CellContext`\[Rho][], 
           $CellContext`z[]]^2 (Derivative[0, 1][$CellContext`Gx][
            $CellContext`\[Rho][], 
            $CellContext`z[]] Derivative[0, 1][$CellContext`Hx][
            $CellContext`\[Rho][], 
            $CellContext`z[]] + Derivative[1, 0][$CellContext`Gx][
            $CellContext`\[Rho][], 
            $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
            $CellContext`\[Rho][], 
            $CellContext`z[]] + 2 $CellContext`Gx[
            $CellContext`\[Rho][], 
            $CellContext`z[]] (Derivative[0, 2][$CellContext`Hx][
             $CellContext`\[Rho][], 
             $CellContext`z[]] + Derivative[2, 0][$CellContext`Hx][
             $CellContext`\[Rho][], 
             $CellContext`z[]])) + $CellContext`Hx[
            $CellContext`\[Rho][], 
            $CellContext`z[]]^2 ((-2) $CellContext`Gx[
             $CellContext`\[Rho][], 
             $CellContext`z[]] (Derivative[0, 1][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]]^2 + Derivative[1, 0][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]]^2) + $CellContext`Hy[
             $CellContext`\[Rho][], 
             $CellContext`z[]] (Derivative[0, 1][$CellContext`Gx][
               $CellContext`\[Rho][], 
               $CellContext`z[]] Derivative[0, 1][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] + Derivative[1, 0][$CellContext`Gx][
               $CellContext`\[Rho][], 
               $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] + 2 $CellContext`Gx[
               $CellContext`\[Rho][], 
               $CellContext`z[]] (Derivative[0, 2][$CellContext`Hy][
                $CellContext`\[Rho][], 
                $CellContext`z[]] + Derivative[2, 0][$CellContext`Hy][
                $CellContext`\[Rho][], 
                $CellContext`z[]]))))), 0, 0, 
     Rational[1, 4] $CellContext`ks^(-2) $CellContext`Gx[
        $CellContext`\[Rho][], 
        $CellContext`z[]]^(-1) $CellContext`Gy[
        $CellContext`\[Rho][], 
        $CellContext`z[]]^(-1) $CellContext`Hx[
        $CellContext`\[Rho][], 
        $CellContext`z[]]^(-4) $CellContext`Hy[
        $CellContext`\[Rho][], 
        $CellContext`z[]]^(-2) $CellContext`P[
        $CellContext`\[Rho][], 
        $CellContext`z[]]^(-1) ($CellContext`Gx[
         $CellContext`\[Rho][], 
         $CellContext`z[]] (-$CellContext`Hx[
           $CellContext`\[Rho][], 
           $CellContext`z[]] $CellContext`Hy[
            $CellContext`\[Rho][], 
            $CellContext`z[]]^2 ($CellContext`q $CellContext`Hy[
             $CellContext`\[Rho][], 
             $CellContext`z[]] + $CellContext`\[Omega]\[Psi][
            $CellContext`\[Rho][], 
            $CellContext`z[]]) (Derivative[0, 1][$CellContext`Gy][
             $CellContext`\[Rho][], 
             $CellContext`z[]] Derivative[0, 1][$CellContext`Hx][
             $CellContext`\[Rho][], 
             $CellContext`z[]] + Derivative[1, 0][$CellContext`Gy][
             $CellContext`\[Rho][], 
             $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
             $CellContext`\[Rho][], 
             $CellContext`z[]]) + $CellContext`Hx[
            $CellContext`\[Rho][], 
            $CellContext`z[]]^2 $CellContext`Hy[
           $CellContext`\[Rho][], 
           $CellContext`z[]] (2 $CellContext`\[Omega]\[Psi][
             $CellContext`\[Rho][], 
             $CellContext`z[]] (Derivative[0, 1][$CellContext`Gy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] Derivative[0, 1][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] + Derivative[1, 0][$CellContext`Gy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]]) + $CellContext`Hy[
             $CellContext`\[Rho][], 
             $CellContext`z[]] (Derivative[0, 1][$CellContext`Gy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] ($CellContext`q 
               Derivative[0, 1][$CellContext`Hy][
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] - Derivative[
              0, 1][$CellContext`\[Omega]\[Psi]][
               $CellContext`\[Rho][], 
               $CellContext`z[]]) + Derivative[1, 0][$CellContext`Gy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] ($CellContext`q 
               Derivative[1, 0][$CellContext`Hy][
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] - Derivative[
              1, 0][$CellContext`\[Omega]\[Psi]][
               $CellContext`\[Rho][], 
               $CellContext`z[]]))) + 2 ($CellContext`q $CellContext`Hy[
             $CellContext`\[Rho][], 
             $CellContext`z[]] + $CellContext`\[Omega]\[Psi][
            $CellContext`\[Rho][], 
            $CellContext`z[]]) ($CellContext`\[Omega]\[Psi][
              $CellContext`\[Rho][], 
              $CellContext`z[]]^2 (Derivative[0, 1][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]]^2 + Derivative[1, 0][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]]^2) - 2 $CellContext`Hy[
            $CellContext`\[Rho][], 
            $CellContext`z[]] $CellContext`\[Omega]\[Psi][
            $CellContext`\[Rho][], 
            $CellContext`z[]] (Derivative[0, 1][$CellContext`Hy][
              $CellContext`\[Rho][], 
              $CellContext`z[]] 
            Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
              $CellContext`\[Rho][], 
              $CellContext`z[]] + Derivative[1, 0][$CellContext`Hy][
              $CellContext`\[Rho][], 
              $CellContext`z[]] 
            Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
              $CellContext`\[Rho][], 
              $CellContext`z[]]) + $CellContext`Hy[
              $CellContext`\[Rho][], 
              $CellContext`z[]]^2 (
            Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
               $CellContext`\[Rho][], 
               $CellContext`z[]]^2 + 
            Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
               $CellContext`\[Rho][], 
               $CellContext`z[]]^2))) + $CellContext`Gy[
         $CellContext`\[Rho][], 
         $CellContext`z[]] (2 $CellContext`Gx[
           $CellContext`\[Rho][], 
           $CellContext`z[]] $CellContext`Hy[
            $CellContext`\[Rho][], 
            $CellContext`z[]]^2 ($CellContext`q $CellContext`Hy[
             $CellContext`\[Rho][], 
             $CellContext`z[]] + $CellContext`\[Omega]\[Psi][
            $CellContext`\[Rho][], 
            $CellContext`z[]]) (Derivative[0, 1][$CellContext`Hx][
             $CellContext`\[Rho][], 
             $CellContext`z[]]^2 + Derivative[1, 0][$CellContext`Hx][
             $CellContext`\[Rho][], 
             $CellContext`z[]]^2) - $CellContext`Hx[
          $CellContext`\[Rho][], 
          $CellContext`z[]] $CellContext`Hy[
          $CellContext`\[Rho][], 
          $CellContext`z[]] ((-4) $CellContext`Gx[
            $CellContext`\[Rho][], 
            $CellContext`z[]] $CellContext`\[Omega]\[Psi][
            $CellContext`\[Rho][], 
            $CellContext`z[]] (Derivative[0, 1][$CellContext`Hx][
              $CellContext`\[Rho][], 
              $CellContext`z[]] Derivative[0, 1][$CellContext`Hy][
              $CellContext`\[Rho][], 
              $CellContext`z[]] + Derivative[1, 0][$CellContext`Hx][
              $CellContext`\[Rho][], 
              $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
              $CellContext`\[Rho][], 
              $CellContext`z[]]) + $CellContext`q $CellContext`Hy[
             $CellContext`\[Rho][], 
             $CellContext`z[]]^2 (Derivative[0, 1][$CellContext`Gx][
              $CellContext`\[Rho][], 
              $CellContext`z[]] Derivative[0, 1][$CellContext`Hx][
              $CellContext`\[Rho][], 
              $CellContext`z[]] + Derivative[1, 0][$CellContext`Gx][
              $CellContext`\[Rho][], 
              $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
              $CellContext`\[Rho][], 
              $CellContext`z[]] + 2 $CellContext`Gx[
              $CellContext`\[Rho][], 
              $CellContext`z[]] (Derivative[0, 2][$CellContext`Hx][
               $CellContext`\[Rho][], 
               $CellContext`z[]] + Derivative[2, 0][$CellContext`Hx][
               $CellContext`\[Rho][], 
               $CellContext`z[]])) + $CellContext`Hy[
            $CellContext`\[Rho][], 
            $CellContext`z[]] (4 $CellContext`Gx[
              $CellContext`\[Rho][], 
              $CellContext`z[]] (Derivative[0, 1][$CellContext`Hx][
                $CellContext`\[Rho][], 
                $CellContext`z[]] 
              Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
                $CellContext`\[Rho][], 
                $CellContext`z[]] + Derivative[1, 0][$CellContext`Hx][
                $CellContext`\[Rho][], 
                $CellContext`z[]] 
              Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
                $CellContext`\[Rho][], 
                $CellContext`z[]]) + $CellContext`\[Omega]\[Psi][
              $CellContext`\[Rho][], 
              $CellContext`z[]] (Derivative[0, 1][$CellContext`Gx][
                $CellContext`\[Rho][], 
                $CellContext`z[]] Derivative[0, 1][$CellContext`Hx][
                $CellContext`\[Rho][], 
                $CellContext`z[]] + Derivative[1, 0][$CellContext`Gx][
                $CellContext`\[Rho][], 
                $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
                $CellContext`\[Rho][], 
                $CellContext`z[]] + 2 $CellContext`Gx[
                $CellContext`\[Rho][], 
                $CellContext`z[]] (Derivative[0, 2][$CellContext`Hx][
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] + Derivative[2, 0][$CellContext`Hx][
                 $CellContext`\[Rho][], 
                 $CellContext`z[]])))) + $CellContext`Hx[
            $CellContext`\[Rho][], 
            $CellContext`z[]]^2 ((-2) $CellContext`q $CellContext`Gx[
             $CellContext`\[Rho][], 
             $CellContext`z[]] $CellContext`Hy[
             $CellContext`\[Rho][], 
             $CellContext`z[]] (Derivative[0, 1][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]]^2 + Derivative[1, 0][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]]^2) - 2 $CellContext`Gx[
            $CellContext`\[Rho][], 
            $CellContext`z[]] $CellContext`\[Omega]\[Psi][
            $CellContext`\[Rho][], 
            $CellContext`z[]] (Derivative[0, 1][$CellContext`Hy][
              $CellContext`\[Rho][], 
              $CellContext`z[]]^2 + Derivative[1, 0][$CellContext`Hy][
              $CellContext`\[Rho][], 
              $CellContext`z[]]^2) + $CellContext`Hy[
              $CellContext`\[Rho][], 
              $CellContext`z[]]^2 (Derivative[0, 1][$CellContext`Gx][
               $CellContext`\[Rho][], 
               $CellContext`z[]] ($CellContext`q 
               Derivative[0, 1][$CellContext`Hy][
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] + 
              Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
                $CellContext`\[Rho][], 
                $CellContext`z[]]) + Derivative[1, 0][$CellContext`Gx][
               $CellContext`\[Rho][], 
               $CellContext`z[]] ($CellContext`q 
               Derivative[1, 0][$CellContext`Hy][
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] + 
              Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
                $CellContext`\[Rho][], 
                $CellContext`z[]]) + 2 $CellContext`Gx[
               $CellContext`\[Rho][], 
               $CellContext`z[]] ($CellContext`q 
               Derivative[0, 2][$CellContext`Hy][
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] + 
              Derivative[0, 2][$CellContext`\[Omega]\[Psi]][
                $CellContext`\[Rho][], 
                $CellContext`z[]] + $CellContext`q 
               Derivative[2, 0][$CellContext`Hy][
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] + 
              Derivative[2, 0][$CellContext`\[Omega]\[Psi]][
                $CellContext`\[Rho][], 
                $CellContext`z[]]))))), 0}, {
    0, Rational[1, 4] ($CellContext`Gx[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^(-2) Derivative[1, 0][$CellContext`Gx][
          $CellContext`\[Rho][], 
          $CellContext`z[]]^2 + $CellContext`Gy[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^(-2) Derivative[1, 0][$CellContext`Gy][
          $CellContext`\[Rho][], 
          $CellContext`z[]]^2 - $CellContext`Gy[
         $CellContext`\[Rho][], 
         $CellContext`z[]]^(-1) $CellContext`Hx[
         $CellContext`\[Rho][], 
         $CellContext`z[]]^(-1) (Derivative[0, 1][$CellContext`Gy][
          $CellContext`\[Rho][], 
          $CellContext`z[]] Derivative[0, 1][$CellContext`Hx][
          $CellContext`\[Rho][], 
          $CellContext`z[]] + Derivative[1, 0][$CellContext`Gy][
          $CellContext`\[Rho][], 
          $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
          $CellContext`\[Rho][], 
          $CellContext`z[]]) + 2 $CellContext`Gy[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^(-1) $CellContext`Hy[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^(-1) Derivative[1, 0][$CellContext`Gy][
         $CellContext`\[Rho][], 
         $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
         $CellContext`\[Rho][], 
         $CellContext`z[]] + 4 $CellContext`Hx[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^(-1) $CellContext`Hy[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^(-1) Derivative[1, 0][$CellContext`Hx][
         $CellContext`\[Rho][], 
         $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
         $CellContext`\[Rho][], 
         $CellContext`z[]] - 2 $CellContext`Hy[
         $CellContext`\[Rho][], 
         $CellContext`z[]]^(-2) Derivative[1, 0][$CellContext`Hy][
         $CellContext`\[Rho][], 
         $CellContext`z[]]^2 + 2 $CellContext`P[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^(-2) (Derivative[0, 1][$CellContext`P][
           $CellContext`\[Rho][], 
           $CellContext`z[]]^2 + Derivative[1, 0][$CellContext`P][
           $CellContext`\[Rho][], 
           $CellContext`z[]]^2) + 2 $CellContext`Gy[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^(-1) $CellContext`Hx[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^(-2) $CellContext`Hy[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^(-2) ($CellContext`\[Omega]\[Psi][
            $CellContext`\[Rho][], 
            $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
            $CellContext`\[Rho][], 
            $CellContext`z[]] - $CellContext`Hy[
           $CellContext`\[Rho][], 
           $CellContext`z[]] Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
           $CellContext`\[Rho][], 
           $CellContext`z[]])^2 + $CellContext`Gx[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^(-1) ($CellContext`Hx[
            $CellContext`\[Rho][], 
            $CellContext`z[]]^(-1) (-Derivative[0, 1][$CellContext`Gx][
             $CellContext`\[Rho][], 
             $CellContext`z[]] Derivative[0, 1][$CellContext`Hx][
             $CellContext`\[Rho][], 
             $CellContext`z[]] + Derivative[1, 0][$CellContext`Gx][
             $CellContext`\[Rho][], 
             $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
             $CellContext`\[Rho][], 
             $CellContext`z[]]) + $CellContext`P[
            $CellContext`\[Rho][], 
            $CellContext`z[]]^(-1) (-Derivative[0, 1][$CellContext`Gx][
             $CellContext`\[Rho][], 
             $CellContext`z[]] Derivative[0, 1][$CellContext`P][
             $CellContext`\[Rho][], 
             $CellContext`z[]] + Derivative[1, 0][$CellContext`Gx][
             $CellContext`\[Rho][], 
             $CellContext`z[]] Derivative[1, 0][$CellContext`P][
             $CellContext`\[Rho][], 
             $CellContext`z[]] - 2 $CellContext`P[
            $CellContext`\[Rho][], 
            $CellContext`z[]] Derivative[2, 0][$CellContext`Gx][
            $CellContext`\[Rho][], 
            $CellContext`z[]])) + $CellContext`Gy[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^(-1) $CellContext`P[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^(-1) (-Derivative[0, 1][$CellContext`Gy][
           $CellContext`\[Rho][], 
           $CellContext`z[]] Derivative[0, 1][$CellContext`P][
           $CellContext`\[Rho][], 
           $CellContext`z[]] + Derivative[1, 0][$CellContext`Gy][
           $CellContext`\[Rho][], 
           $CellContext`z[]] Derivative[1, 0][$CellContext`P][
           $CellContext`\[Rho][], 
           $CellContext`z[]] - 2 $CellContext`P[
          $CellContext`\[Rho][], 
          $CellContext`z[]] Derivative[2, 0][$CellContext`Gy][
          $CellContext`\[Rho][], 
          $CellContext`z[]]) + 2 $CellContext`Hx[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^(-2) (Derivative[0, 1][$CellContext`Hx][
           $CellContext`\[Rho][], 
           $CellContext`z[]]^2 - $CellContext`Hx[
          $CellContext`\[Rho][], 
          $CellContext`z[]] (Derivative[0, 2][$CellContext`Hx][
           $CellContext`\[Rho][], 
           $CellContext`z[]] + Derivative[2, 0][$CellContext`Hx][
           $CellContext`\[Rho][], 
           $CellContext`z[]])) - 2 $CellContext`P[
         $CellContext`\[Rho][], 
         $CellContext`z[]]^(-1) (Derivative[0, 2][$CellContext`P][
         $CellContext`\[Rho][], 
         $CellContext`z[]] + Derivative[2, 0][$CellContext`P][
         $CellContext`\[Rho][], 
         $CellContext`z[]])), Rational[1, 4] ($CellContext`Gx[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^(-2) Derivative[0, 1][$CellContext`Gx][
         $CellContext`\[Rho][], 
         $CellContext`z[]] Derivative[1, 0][$CellContext`Gx][
         $CellContext`\[Rho][], 
         $CellContext`z[]] + $CellContext`Gx[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^(-1) ($CellContext`Hx[
            $CellContext`\[Rho][], 
            $CellContext`z[]]^(-1) (Derivative[0, 1][$CellContext`Hx][
             $CellContext`\[Rho][], 
             $CellContext`z[]] Derivative[1, 0][$CellContext`Gx][
             $CellContext`\[Rho][], 
             $CellContext`z[]] + Derivative[0, 1][$CellContext`Gx][
             $CellContext`\[Rho][], 
             $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
             $CellContext`\[Rho][], 
             $CellContext`z[]]) + $CellContext`P[
            $CellContext`\[Rho][], 
            $CellContext`z[]]^(-1) (Derivative[0, 1][$CellContext`P][
             $CellContext`\[Rho][], 
             $CellContext`z[]] Derivative[1, 0][$CellContext`Gx][
             $CellContext`\[Rho][], 
             $CellContext`z[]] + Derivative[0, 1][$CellContext`Gx][
             $CellContext`\[Rho][], 
             $CellContext`z[]] Derivative[1, 0][$CellContext`P][
             $CellContext`\[Rho][], 
             $CellContext`z[]] - 2 $CellContext`P[
            $CellContext`\[Rho][], 
            $CellContext`z[]] Derivative[1, 1][$CellContext`Gx][
            $CellContext`\[Rho][], 
            $CellContext`z[]])) + $CellContext`Hy[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^(-2) ($CellContext`Gy[
            $CellContext`\[Rho][], 
            $CellContext`z[]]^(-2) $CellContext`Hy[
            $CellContext`\[Rho][], 
            $CellContext`z[]]^2 Derivative[0, 1][$CellContext`Gy][
           $CellContext`\[Rho][], 
           $CellContext`z[]] Derivative[1, 0][$CellContext`Gy][
           $CellContext`\[Rho][], 
           $CellContext`z[]] - 2 $CellContext`Hx[
           $CellContext`\[Rho][], 
           $CellContext`z[]]^(-2) (-$CellContext`Hy[
            $CellContext`\[Rho][], 
            $CellContext`z[]] Derivative[0, 1][$CellContext`Hx][
            $CellContext`\[Rho][], 
            $CellContext`z[]] + $CellContext`Hx[
            $CellContext`\[Rho][], 
            $CellContext`z[]] Derivative[0, 1][$CellContext`Hy][
            $CellContext`\[Rho][], 
            $CellContext`z[]]) (-$CellContext`Hy[
            $CellContext`\[Rho][], 
            $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
            $CellContext`\[Rho][], 
            $CellContext`z[]] + $CellContext`Hx[
            $CellContext`\[Rho][], 
            $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
            $CellContext`\[Rho][], 
            $CellContext`z[]]) + $CellContext`Gy[
            $CellContext`\[Rho][], 
            $CellContext`z[]]^(-1) ($CellContext`Hy[
              $CellContext`\[Rho][], 
              $CellContext`z[]]^2 $CellContext`P[
              $CellContext`\[Rho][], 
              $CellContext`z[]]^(-1) (Derivative[0, 1][$CellContext`P][
               $CellContext`\[Rho][], 
               $CellContext`z[]] Derivative[1, 0][$CellContext`Gy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] + Derivative[0, 1][$CellContext`Gy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] Derivative[1, 0][$CellContext`P][
               $CellContext`\[Rho][], 
               $CellContext`z[]]) + 2 $CellContext`Hx[
              $CellContext`\[Rho][], 
              $CellContext`z[]]^(-2) ($CellContext`\[Omega]\[Psi][
               $CellContext`\[Rho][], 
               $CellContext`z[]] Derivative[0, 1][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] - $CellContext`Hy[
              $CellContext`\[Rho][], 
              $CellContext`z[]] 
            Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
              $CellContext`\[Rho][], 
              $CellContext`z[]]) ($CellContext`\[Omega]\[Psi][
               $CellContext`\[Rho][], 
               $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] - $CellContext`Hy[
              $CellContext`\[Rho][], 
              $CellContext`z[]] 
            Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
              $CellContext`\[Rho][], 
              $CellContext`z[]]) + $CellContext`Hy[
             $CellContext`\[Rho][], 
             $CellContext`z[]] (Derivative[0, 1][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] Derivative[1, 0][$CellContext`Gy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] + Derivative[0, 1][$CellContext`Gy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] - 2 $CellContext`Hy[
              $CellContext`\[Rho][], 
              $CellContext`z[]] Derivative[1, 1][$CellContext`Gy][
              $CellContext`\[Rho][], 
              $CellContext`z[]])))), 0, 0}, {
    0, Rational[1, 4] ($CellContext`Gx[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^(-2) Derivative[0, 1][$CellContext`Gx][
         $CellContext`\[Rho][], 
         $CellContext`z[]] Derivative[1, 0][$CellContext`Gx][
         $CellContext`\[Rho][], 
         $CellContext`z[]] + $CellContext`Gx[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^(-1) ($CellContext`Hx[
            $CellContext`\[Rho][], 
            $CellContext`z[]]^(-1) (Derivative[0, 1][$CellContext`Hx][
             $CellContext`\[Rho][], 
             $CellContext`z[]] Derivative[1, 0][$CellContext`Gx][
             $CellContext`\[Rho][], 
             $CellContext`z[]] + Derivative[0, 1][$CellContext`Gx][
             $CellContext`\[Rho][], 
             $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
             $CellContext`\[Rho][], 
             $CellContext`z[]]) + $CellContext`P[
            $CellContext`\[Rho][], 
            $CellContext`z[]]^(-1) (Derivative[0, 1][$CellContext`P][
             $CellContext`\[Rho][], 
             $CellContext`z[]] Derivative[1, 0][$CellContext`Gx][
             $CellContext`\[Rho][], 
             $CellContext`z[]] + Derivative[0, 1][$CellContext`Gx][
             $CellContext`\[Rho][], 
             $CellContext`z[]] Derivative[1, 0][$CellContext`P][
             $CellContext`\[Rho][], 
             $CellContext`z[]] - 2 $CellContext`P[
            $CellContext`\[Rho][], 
            $CellContext`z[]] Derivative[1, 1][$CellContext`Gx][
            $CellContext`\[Rho][], 
            $CellContext`z[]])) + $CellContext`Hy[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^(-2) ($CellContext`Gy[
            $CellContext`\[Rho][], 
            $CellContext`z[]]^(-2) $CellContext`Hy[
            $CellContext`\[Rho][], 
            $CellContext`z[]]^2 Derivative[0, 1][$CellContext`Gy][
           $CellContext`\[Rho][], 
           $CellContext`z[]] Derivative[1, 0][$CellContext`Gy][
           $CellContext`\[Rho][], 
           $CellContext`z[]] - 2 $CellContext`Hx[
           $CellContext`\[Rho][], 
           $CellContext`z[]]^(-2) (-$CellContext`Hy[
            $CellContext`\[Rho][], 
            $CellContext`z[]] Derivative[0, 1][$CellContext`Hx][
            $CellContext`\[Rho][], 
            $CellContext`z[]] + $CellContext`Hx[
            $CellContext`\[Rho][], 
            $CellContext`z[]] Derivative[0, 1][$CellContext`Hy][
            $CellContext`\[Rho][], 
            $CellContext`z[]]) (-$CellContext`Hy[
            $CellContext`\[Rho][], 
            $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
            $CellContext`\[Rho][], 
            $CellContext`z[]] + $CellContext`Hx[
            $CellContext`\[Rho][], 
            $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
            $CellContext`\[Rho][], 
            $CellContext`z[]]) + $CellContext`Gy[
            $CellContext`\[Rho][], 
            $CellContext`z[]]^(-1) ($CellContext`Hy[
              $CellContext`\[Rho][], 
              $CellContext`z[]]^2 $CellContext`P[
              $CellContext`\[Rho][], 
              $CellContext`z[]]^(-1) (Derivative[0, 1][$CellContext`P][
               $CellContext`\[Rho][], 
               $CellContext`z[]] Derivative[1, 0][$CellContext`Gy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] + Derivative[0, 1][$CellContext`Gy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] Derivative[1, 0][$CellContext`P][
               $CellContext`\[Rho][], 
               $CellContext`z[]]) + 2 $CellContext`Hx[
              $CellContext`\[Rho][], 
              $CellContext`z[]]^(-2) ($CellContext`\[Omega]\[Psi][
               $CellContext`\[Rho][], 
               $CellContext`z[]] Derivative[0, 1][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] - $CellContext`Hy[
              $CellContext`\[Rho][], 
              $CellContext`z[]] 
            Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
              $CellContext`\[Rho][], 
              $CellContext`z[]]) ($CellContext`\[Omega]\[Psi][
               $CellContext`\[Rho][], 
               $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] - $CellContext`Hy[
              $CellContext`\[Rho][], 
              $CellContext`z[]] 
            Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
              $CellContext`\[Rho][], 
              $CellContext`z[]]) + $CellContext`Hy[
             $CellContext`\[Rho][], 
             $CellContext`z[]] (Derivative[0, 1][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] Derivative[1, 0][$CellContext`Gy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] + Derivative[0, 1][$CellContext`Gy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] - 2 $CellContext`Hy[
              $CellContext`\[Rho][], 
              $CellContext`z[]] Derivative[1, 1][$CellContext`Gy][
              $CellContext`\[Rho][], 
              $CellContext`z[]])))), Rational[1, 4] ($CellContext`Gy[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^(-2) Derivative[0, 1][$CellContext`Gy][
          $CellContext`\[Rho][], 
          $CellContext`z[]]^2 + 4 $CellContext`Hx[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^(-1) $CellContext`Hy[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^(-1) Derivative[0, 1][$CellContext`Hx][
         $CellContext`\[Rho][], 
         $CellContext`z[]] Derivative[0, 1][$CellContext`Hy][
         $CellContext`\[Rho][], 
         $CellContext`z[]] - 2 $CellContext`Hy[
         $CellContext`\[Rho][], 
         $CellContext`z[]]^(-2) Derivative[0, 1][$CellContext`Hy][
         $CellContext`\[Rho][], 
         $CellContext`z[]]^2 + 2 $CellContext`Gy[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^(-1) $CellContext`Hx[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^(-2) $CellContext`Hy[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^(-2) ($CellContext`\[Omega]\[Psi][
            $CellContext`\[Rho][], 
            $CellContext`z[]] Derivative[0, 1][$CellContext`Hy][
            $CellContext`\[Rho][], 
            $CellContext`z[]] - $CellContext`Hy[
           $CellContext`\[Rho][], 
           $CellContext`z[]] Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
           $CellContext`\[Rho][], 
           $CellContext`z[]])^2 + $CellContext`Gx[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^(-2) (Derivative[0, 1][$CellContext`Gx][
           $CellContext`\[Rho][], 
           $CellContext`z[]]^2 - 2 $CellContext`Gx[
          $CellContext`\[Rho][], 
          $CellContext`z[]] Derivative[0, 2][$CellContext`Gx][
          $CellContext`\[Rho][], 
          $CellContext`z[]]) + $CellContext`Gy[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^(-1) $CellContext`Hy[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^(-1) (2 Derivative[0, 1][$CellContext`Gy][
           $CellContext`\[Rho][], 
           $CellContext`z[]] Derivative[0, 1][$CellContext`Hy][
           $CellContext`\[Rho][], 
           $CellContext`z[]] - 2 $CellContext`Hy[
          $CellContext`\[Rho][], 
          $CellContext`z[]] Derivative[0, 2][$CellContext`Gy][
          $CellContext`\[Rho][], 
          $CellContext`z[]]) + 2 $CellContext`Hx[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^(-2) Derivative[1, 0][$CellContext`Hx][
          $CellContext`\[Rho][], 
          $CellContext`z[]]^2 - $CellContext`Gy[
         $CellContext`\[Rho][], 
         $CellContext`z[]]^(-1) $CellContext`Hx[
         $CellContext`\[Rho][], 
         $CellContext`z[]]^(-1) (Derivative[0, 1][$CellContext`Gy][
          $CellContext`\[Rho][], 
          $CellContext`z[]] Derivative[0, 1][$CellContext`Hx][
          $CellContext`\[Rho][], 
          $CellContext`z[]] + Derivative[1, 0][$CellContext`Gy][
          $CellContext`\[Rho][], 
          $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
          $CellContext`\[Rho][], 
          $CellContext`z[]]) + $CellContext`Gy[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^(-1) $CellContext`P[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^(-1) (Derivative[0, 1][$CellContext`Gy][
           $CellContext`\[Rho][], 
           $CellContext`z[]] Derivative[0, 1][$CellContext`P][
           $CellContext`\[Rho][], 
           $CellContext`z[]] - Derivative[1, 0][$CellContext`Gy][
          $CellContext`\[Rho][], 
          $CellContext`z[]] Derivative[1, 0][$CellContext`P][
          $CellContext`\[Rho][], 
          $CellContext`z[]]) + 2 $CellContext`P[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^(-2) (Derivative[0, 1][$CellContext`P][
           $CellContext`\[Rho][], 
           $CellContext`z[]]^2 + Derivative[1, 0][$CellContext`P][
           $CellContext`\[Rho][], 
           $CellContext`z[]]^2) + $CellContext`Gx[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^(-1) $CellContext`Hx[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^(-1) (Derivative[0, 1][$CellContext`Gx][
           $CellContext`\[Rho][], 
           $CellContext`z[]] Derivative[0, 1][$CellContext`Hx][
           $CellContext`\[Rho][], 
           $CellContext`z[]] - Derivative[1, 0][$CellContext`Gx][
          $CellContext`\[Rho][], 
          $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
          $CellContext`\[Rho][], 
          $CellContext`z[]] - 2 $CellContext`Gx[
          $CellContext`\[Rho][], 
          $CellContext`z[]] (Derivative[0, 2][$CellContext`Hx][
           $CellContext`\[Rho][], 
           $CellContext`z[]] + Derivative[2, 0][$CellContext`Hx][
           $CellContext`\[Rho][], 
           $CellContext`z[]])) + $CellContext`Gx[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^(-1) $CellContext`P[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^(-1) (Derivative[0, 1][$CellContext`Gx][
           $CellContext`\[Rho][], 
           $CellContext`z[]] Derivative[0, 1][$CellContext`P][
           $CellContext`\[Rho][], 
           $CellContext`z[]] - Derivative[1, 0][$CellContext`Gx][
          $CellContext`\[Rho][], 
          $CellContext`z[]] Derivative[1, 0][$CellContext`P][
          $CellContext`\[Rho][], 
          $CellContext`z[]] - 2 $CellContext`Gx[
          $CellContext`\[Rho][], 
          $CellContext`z[]] (Derivative[0, 2][$CellContext`P][
           $CellContext`\[Rho][], 
           $CellContext`z[]] + Derivative[2, 0][$CellContext`P][
           $CellContext`\[Rho][], 
           $CellContext`z[]]))), 0, 0}, {
    Rational[1, 4] $CellContext`ks^(-2) $CellContext`Gx[
        $CellContext`\[Rho][], 
        $CellContext`z[]]^(-1) $CellContext`Gy[
        $CellContext`\[Rho][], 
        $CellContext`z[]]^(-1) $CellContext`Hx[
        $CellContext`\[Rho][], 
        $CellContext`z[]]^(-4) $CellContext`Hy[
        $CellContext`\[Rho][], 
        $CellContext`z[]]^(-2) $CellContext`P[
        $CellContext`\[Rho][], 
        $CellContext`z[]]^(-1) ($CellContext`Gx[
         $CellContext`\[Rho][], 
         $CellContext`z[]] (-$CellContext`Hx[
           $CellContext`\[Rho][], 
           $CellContext`z[]] $CellContext`Hy[
            $CellContext`\[Rho][], 
            $CellContext`z[]]^2 ($CellContext`q $CellContext`Hy[
             $CellContext`\[Rho][], 
             $CellContext`z[]] + $CellContext`\[Omega]\[Psi][
            $CellContext`\[Rho][], 
            $CellContext`z[]]) (Derivative[0, 1][$CellContext`Gy][
             $CellContext`\[Rho][], 
             $CellContext`z[]] Derivative[0, 1][$CellContext`Hx][
             $CellContext`\[Rho][], 
             $CellContext`z[]] + Derivative[1, 0][$CellContext`Gy][
             $CellContext`\[Rho][], 
             $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
             $CellContext`\[Rho][], 
             $CellContext`z[]]) + $CellContext`Hx[
            $CellContext`\[Rho][], 
            $CellContext`z[]]^2 $CellContext`Hy[
           $CellContext`\[Rho][], 
           $CellContext`z[]] (2 $CellContext`\[Omega]\[Psi][
             $CellContext`\[Rho][], 
             $CellContext`z[]] (Derivative[0, 1][$CellContext`Gy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] Derivative[0, 1][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] + Derivative[1, 0][$CellContext`Gy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]]) + $CellContext`Hy[
             $CellContext`\[Rho][], 
             $CellContext`z[]] (Derivative[0, 1][$CellContext`Gy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] ($CellContext`q 
               Derivative[0, 1][$CellContext`Hy][
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] - Derivative[
              0, 1][$CellContext`\[Omega]\[Psi]][
               $CellContext`\[Rho][], 
               $CellContext`z[]]) + Derivative[1, 0][$CellContext`Gy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] ($CellContext`q 
               Derivative[1, 0][$CellContext`Hy][
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] - Derivative[
              1, 0][$CellContext`\[Omega]\[Psi]][
               $CellContext`\[Rho][], 
               $CellContext`z[]]))) + 2 ($CellContext`q $CellContext`Hy[
             $CellContext`\[Rho][], 
             $CellContext`z[]] + $CellContext`\[Omega]\[Psi][
            $CellContext`\[Rho][], 
            $CellContext`z[]]) ($CellContext`\[Omega]\[Psi][
              $CellContext`\[Rho][], 
              $CellContext`z[]]^2 (Derivative[0, 1][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]]^2 + Derivative[1, 0][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]]^2) - 2 $CellContext`Hy[
            $CellContext`\[Rho][], 
            $CellContext`z[]] $CellContext`\[Omega]\[Psi][
            $CellContext`\[Rho][], 
            $CellContext`z[]] (Derivative[0, 1][$CellContext`Hy][
              $CellContext`\[Rho][], 
              $CellContext`z[]] 
            Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
              $CellContext`\[Rho][], 
              $CellContext`z[]] + Derivative[1, 0][$CellContext`Hy][
              $CellContext`\[Rho][], 
              $CellContext`z[]] 
            Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
              $CellContext`\[Rho][], 
              $CellContext`z[]]) + $CellContext`Hy[
              $CellContext`\[Rho][], 
              $CellContext`z[]]^2 (
            Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
               $CellContext`\[Rho][], 
               $CellContext`z[]]^2 + 
            Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
               $CellContext`\[Rho][], 
               $CellContext`z[]]^2))) + $CellContext`Gy[
         $CellContext`\[Rho][], 
         $CellContext`z[]] (2 $CellContext`Gx[
           $CellContext`\[Rho][], 
           $CellContext`z[]] $CellContext`Hy[
            $CellContext`\[Rho][], 
            $CellContext`z[]]^2 ($CellContext`q $CellContext`Hy[
             $CellContext`\[Rho][], 
             $CellContext`z[]] + $CellContext`\[Omega]\[Psi][
            $CellContext`\[Rho][], 
            $CellContext`z[]]) (Derivative[0, 1][$CellContext`Hx][
             $CellContext`\[Rho][], 
             $CellContext`z[]]^2 + Derivative[1, 0][$CellContext`Hx][
             $CellContext`\[Rho][], 
             $CellContext`z[]]^2) - $CellContext`Hx[
          $CellContext`\[Rho][], 
          $CellContext`z[]] $CellContext`Hy[
          $CellContext`\[Rho][], 
          $CellContext`z[]] ((-4) $CellContext`Gx[
            $CellContext`\[Rho][], 
            $CellContext`z[]] $CellContext`\[Omega]\[Psi][
            $CellContext`\[Rho][], 
            $CellContext`z[]] (Derivative[0, 1][$CellContext`Hx][
              $CellContext`\[Rho][], 
              $CellContext`z[]] Derivative[0, 1][$CellContext`Hy][
              $CellContext`\[Rho][], 
              $CellContext`z[]] + Derivative[1, 0][$CellContext`Hx][
              $CellContext`\[Rho][], 
              $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
              $CellContext`\[Rho][], 
              $CellContext`z[]]) + $CellContext`q $CellContext`Hy[
             $CellContext`\[Rho][], 
             $CellContext`z[]]^2 (Derivative[0, 1][$CellContext`Gx][
              $CellContext`\[Rho][], 
              $CellContext`z[]] Derivative[0, 1][$CellContext`Hx][
              $CellContext`\[Rho][], 
              $CellContext`z[]] + Derivative[1, 0][$CellContext`Gx][
              $CellContext`\[Rho][], 
              $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
              $CellContext`\[Rho][], 
              $CellContext`z[]] + 2 $CellContext`Gx[
              $CellContext`\[Rho][], 
              $CellContext`z[]] (Derivative[0, 2][$CellContext`Hx][
               $CellContext`\[Rho][], 
               $CellContext`z[]] + Derivative[2, 0][$CellContext`Hx][
               $CellContext`\[Rho][], 
               $CellContext`z[]])) + $CellContext`Hy[
            $CellContext`\[Rho][], 
            $CellContext`z[]] (4 $CellContext`Gx[
              $CellContext`\[Rho][], 
              $CellContext`z[]] (Derivative[0, 1][$CellContext`Hx][
                $CellContext`\[Rho][], 
                $CellContext`z[]] 
              Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
                $CellContext`\[Rho][], 
                $CellContext`z[]] + Derivative[1, 0][$CellContext`Hx][
                $CellContext`\[Rho][], 
                $CellContext`z[]] 
              Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
                $CellContext`\[Rho][], 
                $CellContext`z[]]) + $CellContext`\[Omega]\[Psi][
              $CellContext`\[Rho][], 
              $CellContext`z[]] (Derivative[0, 1][$CellContext`Gx][
                $CellContext`\[Rho][], 
                $CellContext`z[]] Derivative[0, 1][$CellContext`Hx][
                $CellContext`\[Rho][], 
                $CellContext`z[]] + Derivative[1, 0][$CellContext`Gx][
                $CellContext`\[Rho][], 
                $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
                $CellContext`\[Rho][], 
                $CellContext`z[]] + 2 $CellContext`Gx[
                $CellContext`\[Rho][], 
                $CellContext`z[]] (Derivative[0, 2][$CellContext`Hx][
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] + Derivative[2, 0][$CellContext`Hx][
                 $CellContext`\[Rho][], 
                 $CellContext`z[]])))) + $CellContext`Hx[
            $CellContext`\[Rho][], 
            $CellContext`z[]]^2 ((-2) $CellContext`q $CellContext`Gx[
             $CellContext`\[Rho][], 
             $CellContext`z[]] $CellContext`Hy[
             $CellContext`\[Rho][], 
             $CellContext`z[]] (Derivative[0, 1][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]]^2 + Derivative[1, 0][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]]^2) - 2 $CellContext`Gx[
            $CellContext`\[Rho][], 
            $CellContext`z[]] $CellContext`\[Omega]\[Psi][
            $CellContext`\[Rho][], 
            $CellContext`z[]] (Derivative[0, 1][$CellContext`Hy][
              $CellContext`\[Rho][], 
              $CellContext`z[]]^2 + Derivative[1, 0][$CellContext`Hy][
              $CellContext`\[Rho][], 
              $CellContext`z[]]^2) + $CellContext`Hy[
              $CellContext`\[Rho][], 
              $CellContext`z[]]^2 (Derivative[0, 1][$CellContext`Gx][
               $CellContext`\[Rho][], 
               $CellContext`z[]] ($CellContext`q 
               Derivative[0, 1][$CellContext`Hy][
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] + 
              Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
                $CellContext`\[Rho][], 
                $CellContext`z[]]) + Derivative[1, 0][$CellContext`Gx][
               $CellContext`\[Rho][], 
               $CellContext`z[]] ($CellContext`q 
               Derivative[1, 0][$CellContext`Hy][
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] + 
              Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
                $CellContext`\[Rho][], 
                $CellContext`z[]]) + 2 $CellContext`Gx[
               $CellContext`\[Rho][], 
               $CellContext`z[]] ($CellContext`q 
               Derivative[0, 2][$CellContext`Hy][
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] + 
              Derivative[0, 2][$CellContext`\[Omega]\[Psi]][
                $CellContext`\[Rho][], 
                $CellContext`z[]] + $CellContext`q 
               Derivative[2, 0][$CellContext`Hy][
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] + 
              Derivative[2, 0][$CellContext`\[Omega]\[Psi]][
                $CellContext`\[Rho][], 
                $CellContext`z[]]))))), 0, 0, 
     Rational[1, 4] $CellContext`ks^(-2) $CellContext`Gx[
        $CellContext`\[Rho][], 
        $CellContext`z[]]^(-1) $CellContext`Gy[
        $CellContext`\[Rho][], 
        $CellContext`z[]]^(-1) $CellContext`Hx[
        $CellContext`\[Rho][], 
        $CellContext`z[]]^(-4) $CellContext`Hy[
        $CellContext`\[Rho][], 
        $CellContext`z[]]^(-3) $CellContext`P[
        $CellContext`\[Rho][], 
        $CellContext`z[]]^(-1) ($CellContext`Gx[
         $CellContext`\[Rho][], 
         $CellContext`z[]] ($CellContext`Hx[
            $CellContext`\[Rho][], 
            $CellContext`z[]]^4 $CellContext`Hy[
            $CellContext`\[Rho][], 
            $CellContext`z[]]^2 (Derivative[0, 1][$CellContext`Gy][
             $CellContext`\[Rho][], 
             $CellContext`z[]]^2 + Derivative[1, 0][$CellContext`Gy][
             $CellContext`\[Rho][], 
             $CellContext`z[]]^2) - $CellContext`Hx[
          $CellContext`\[Rho][], 
          $CellContext`z[]] $CellContext`Hy[
           $CellContext`\[Rho][], 
           $CellContext`z[]]^2 ($CellContext`q $CellContext`Hy[
             $CellContext`\[Rho][], 
             $CellContext`z[]] + $CellContext`\[Omega]\[Psi][
            $CellContext`\[Rho][], 
            $CellContext`z[]])^2 (Derivative[0, 1][$CellContext`Gy][
            $CellContext`\[Rho][], 
            $CellContext`z[]] Derivative[0, 1][$CellContext`Hx][
            $CellContext`\[Rho][], 
            $CellContext`z[]] + Derivative[1, 0][$CellContext`Gy][
            $CellContext`\[Rho][], 
            $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
            $CellContext`\[Rho][], 
            $CellContext`z[]]) + $CellContext`Hx[
            $CellContext`\[Rho][], 
            $CellContext`z[]]^2 $CellContext`Hy[
           $CellContext`\[Rho][], 
           $CellContext`z[]] ($CellContext`q $CellContext`Hy[
             $CellContext`\[Rho][], 
             $CellContext`z[]] + $CellContext`\[Omega]\[Psi][
            $CellContext`\[Rho][], 
            $CellContext`z[]]) (3 $CellContext`\[Omega]\[Psi][
             $CellContext`\[Rho][], 
             $CellContext`z[]] (Derivative[0, 1][$CellContext`Gy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] Derivative[0, 1][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] + Derivative[1, 0][$CellContext`Gy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]]) + $CellContext`Hy[
             $CellContext`\[Rho][], 
             $CellContext`z[]] (Derivative[0, 1][$CellContext`Gy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] ($CellContext`q 
               Derivative[0, 1][$CellContext`Hy][
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] - 2 
              Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
                $CellContext`\[Rho][], 
                $CellContext`z[]]) + Derivative[1, 0][$CellContext`Gy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] ($CellContext`q 
               Derivative[1, 0][$CellContext`Hy][
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] - 2 
              Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
                $CellContext`\[Rho][], 
                $CellContext`z[]]))) + 2 ($CellContext`q $CellContext`Hy[
              $CellContext`\[Rho][], 
              $CellContext`z[]] + $CellContext`\[Omega]\[Psi][
             $CellContext`\[Rho][], 
             $CellContext`z[]])^2 ($CellContext`\[Omega]\[Psi][
              $CellContext`\[Rho][], 
              $CellContext`z[]]^2 (Derivative[0, 1][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]]^2 + Derivative[1, 0][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]]^2) - 2 $CellContext`Hy[
            $CellContext`\[Rho][], 
            $CellContext`z[]] $CellContext`\[Omega]\[Psi][
            $CellContext`\[Rho][], 
            $CellContext`z[]] (Derivative[0, 1][$CellContext`Hy][
              $CellContext`\[Rho][], 
              $CellContext`z[]] 
            Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
              $CellContext`\[Rho][], 
              $CellContext`z[]] + Derivative[1, 0][$CellContext`Hy][
              $CellContext`\[Rho][], 
              $CellContext`z[]] 
            Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
              $CellContext`\[Rho][], 
              $CellContext`z[]]) + $CellContext`Hy[
              $CellContext`\[Rho][], 
              $CellContext`z[]]^2 (
            Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
               $CellContext`\[Rho][], 
               $CellContext`z[]]^2 + 
            Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
               $CellContext`\[Rho][], 
               $CellContext`z[]]^2))) + $CellContext`Gy[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^2 $CellContext`Hx[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^2 (2 $CellContext`Gx[
           $CellContext`\[Rho][], 
           $CellContext`z[]] $CellContext`Hy[
            $CellContext`\[Rho][], 
            $CellContext`z[]]^2 (Derivative[0, 1][$CellContext`Hx][
             $CellContext`\[Rho][], 
             $CellContext`z[]]^2 + Derivative[1, 0][$CellContext`Hx][
             $CellContext`\[Rho][], 
             $CellContext`z[]]^2) - $CellContext`Hx[
          $CellContext`\[Rho][], 
          $CellContext`z[]] $CellContext`Hy[
           $CellContext`\[Rho][], 
           $CellContext`z[]]^2 (Derivative[0, 1][$CellContext`Gx][
            $CellContext`\[Rho][], 
            $CellContext`z[]] Derivative[0, 1][$CellContext`Hx][
            $CellContext`\[Rho][], 
            $CellContext`z[]] + Derivative[1, 0][$CellContext`Gx][
            $CellContext`\[Rho][], 
            $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
            $CellContext`\[Rho][], 
            $CellContext`z[]] + 2 $CellContext`Gx[
            $CellContext`\[Rho][], 
            $CellContext`z[]] (Derivative[0, 2][$CellContext`Hx][
             $CellContext`\[Rho][], 
             $CellContext`z[]] + Derivative[2, 0][$CellContext`Hx][
             $CellContext`\[Rho][], 
             $CellContext`z[]])) + $CellContext`Hx[
            $CellContext`\[Rho][], 
            $CellContext`z[]]^2 ((-2) $CellContext`Gx[
             $CellContext`\[Rho][], 
             $CellContext`z[]] (Derivative[0, 1][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]]^2 + Derivative[1, 0][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]]^2) + $CellContext`Hy[
             $CellContext`\[Rho][], 
             $CellContext`z[]] (Derivative[0, 1][$CellContext`Gx][
               $CellContext`\[Rho][], 
               $CellContext`z[]] Derivative[0, 1][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] + Derivative[1, 0][$CellContext`Gx][
               $CellContext`\[Rho][], 
               $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] + 2 $CellContext`Gx[
               $CellContext`\[Rho][], 
               $CellContext`z[]] (Derivative[0, 2][$CellContext`Hy][
                $CellContext`\[Rho][], 
                $CellContext`z[]] + Derivative[2, 0][$CellContext`Hy][
                $CellContext`\[Rho][], 
                $CellContext`z[]])))) - $CellContext`Gy[
        $CellContext`\[Rho][], 
        $CellContext`z[]] $CellContext`Hy[
        $CellContext`\[Rho][], 
        $CellContext`z[]] ($CellContext`Gx[
          $CellContext`\[Rho][], 
          $CellContext`z[]] $CellContext`Hx[
           $CellContext`\[Rho][], 
           $CellContext`z[]]^3 $CellContext`Hy[
          $CellContext`\[Rho][], 
          $CellContext`z[]] (Derivative[0, 1][$CellContext`Gy][
            $CellContext`\[Rho][], 
            $CellContext`z[]] Derivative[0, 1][$CellContext`Hx][
            $CellContext`\[Rho][], 
            $CellContext`z[]] + Derivative[1, 0][$CellContext`Gy][
            $CellContext`\[Rho][], 
            $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
            $CellContext`\[Rho][], 
            $CellContext`z[]]) - 2 $CellContext`Gx[
         $CellContext`\[Rho][], 
         $CellContext`z[]] $CellContext`Hy[
         $CellContext`\[Rho][], 
         $CellContext`z[]] ($CellContext`q $CellContext`Hy[
            $CellContext`\[Rho][], 
            $CellContext`z[]] + $CellContext`\[Omega]\[Psi][
           $CellContext`\[Rho][], 
           $CellContext`z[]])^2 (Derivative[0, 1][$CellContext`Hx][
           $CellContext`\[Rho][], 
           $CellContext`z[]]^2 + Derivative[1, 0][$CellContext`Hx][
           $CellContext`\[Rho][], 
           $CellContext`z[]]^2) + $CellContext`Hx[
           $CellContext`\[Rho][], 
           $CellContext`z[]]^4 (-$CellContext`Gx[
            $CellContext`\[Rho][], 
            $CellContext`z[]] (Derivative[0, 1][$CellContext`Gy][
              $CellContext`\[Rho][], 
              $CellContext`z[]] Derivative[0, 1][$CellContext`Hy][
              $CellContext`\[Rho][], 
              $CellContext`z[]] + Derivative[1, 0][$CellContext`Gy][
              $CellContext`\[Rho][], 
              $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
              $CellContext`\[Rho][], 
              $CellContext`z[]]) + $CellContext`Hy[
            $CellContext`\[Rho][], 
            $CellContext`z[]] (Derivative[0, 1][$CellContext`Gx][
              $CellContext`\[Rho][], 
              $CellContext`z[]] Derivative[0, 1][$CellContext`Gy][
              $CellContext`\[Rho][], 
              $CellContext`z[]] + Derivative[1, 0][$CellContext`Gx][
              $CellContext`\[Rho][], 
              $CellContext`z[]] Derivative[1, 0][$CellContext`Gy][
              $CellContext`\[Rho][], 
              $CellContext`z[]] + 2 $CellContext`Gx[
              $CellContext`\[Rho][], 
              $CellContext`z[]] (Derivative[0, 2][$CellContext`Gy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] + Derivative[2, 0][$CellContext`Gy][
               $CellContext`\[Rho][], 
               $CellContext`z[]]))) + $CellContext`Hx[
          $CellContext`\[Rho][], 
          $CellContext`z[]] ($CellContext`q $CellContext`Hy[
            $CellContext`\[Rho][], 
            $CellContext`z[]] + $CellContext`\[Omega]\[Psi][
           $CellContext`\[Rho][], 
           $CellContext`z[]]) ((-8) $CellContext`Gx[
            $CellContext`\[Rho][], 
            $CellContext`z[]] $CellContext`\[Omega]\[Psi][
            $CellContext`\[Rho][], 
            $CellContext`z[]] (Derivative[0, 1][$CellContext`Hx][
              $CellContext`\[Rho][], 
              $CellContext`z[]] Derivative[0, 1][$CellContext`Hy][
              $CellContext`\[Rho][], 
              $CellContext`z[]] + Derivative[1, 0][$CellContext`Hx][
              $CellContext`\[Rho][], 
              $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
              $CellContext`\[Rho][], 
              $CellContext`z[]]) + $CellContext`q $CellContext`Hy[
             $CellContext`\[Rho][], 
             $CellContext`z[]]^2 (Derivative[0, 1][$CellContext`Gx][
              $CellContext`\[Rho][], 
              $CellContext`z[]] Derivative[0, 1][$CellContext`Hx][
              $CellContext`\[Rho][], 
              $CellContext`z[]] + Derivative[1, 0][$CellContext`Gx][
              $CellContext`\[Rho][], 
              $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
              $CellContext`\[Rho][], 
              $CellContext`z[]] + 2 $CellContext`Gx[
              $CellContext`\[Rho][], 
              $CellContext`z[]] (Derivative[0, 2][$CellContext`Hx][
               $CellContext`\[Rho][], 
               $CellContext`z[]] + Derivative[2, 0][$CellContext`Hx][
               $CellContext`\[Rho][], 
               $CellContext`z[]])) + $CellContext`Hy[
            $CellContext`\[Rho][], 
            $CellContext`z[]] (8 $CellContext`Gx[
              $CellContext`\[Rho][], 
              $CellContext`z[]] (Derivative[0, 1][$CellContext`Hx][
                $CellContext`\[Rho][], 
                $CellContext`z[]] 
              Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
                $CellContext`\[Rho][], 
                $CellContext`z[]] + Derivative[1, 0][$CellContext`Hx][
                $CellContext`\[Rho][], 
                $CellContext`z[]] 
              Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
                $CellContext`\[Rho][], 
                $CellContext`z[]]) + $CellContext`\[Omega]\[Psi][
              $CellContext`\[Rho][], 
              $CellContext`z[]] (Derivative[0, 1][$CellContext`Gx][
                $CellContext`\[Rho][], 
                $CellContext`z[]] Derivative[0, 1][$CellContext`Hx][
                $CellContext`\[Rho][], 
                $CellContext`z[]] + Derivative[1, 0][$CellContext`Gx][
                $CellContext`\[Rho][], 
                $CellContext`z[]] Derivative[1, 0][$CellContext`Hx][
                $CellContext`\[Rho][], 
                $CellContext`z[]] + 2 $CellContext`Gx[
                $CellContext`\[Rho][], 
                $CellContext`z[]] (Derivative[0, 2][$CellContext`Hx][
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] + Derivative[2, 0][$CellContext`Hx][
                 $CellContext`\[Rho][], 
                 $CellContext`z[]])))) - $CellContext`Hx[
          $CellContext`\[Rho][], 
          $CellContext`z[]]^2 (-$CellContext`\[Omega]\[Psi][
           $CellContext`\[Rho][], 
           $CellContext`z[]] (4 $CellContext`Gx[
             $CellContext`\[Rho][], 
             $CellContext`z[]] ($CellContext`q 
             Derivative[0, 1][$CellContext`Hy][
                $CellContext`\[Rho][], 
                $CellContext`z[]]^2 + Derivative[0, 1][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
               $CellContext`\[Rho][], 
               $CellContext`z[]] + Derivative[1, 0][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] ($CellContext`q 
               Derivative[1, 0][$CellContext`Hy][
                 $CellContext`\[Rho][], 
                 $CellContext`z[]] + 
              Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
                $CellContext`\[Rho][], 
                $CellContext`z[]])) + $CellContext`\[Omega]\[Psi][
             $CellContext`\[Rho][], 
             $CellContext`z[]] (Derivative[0, 1][$CellContext`Gx][
               $CellContext`\[Rho][], 
               $CellContext`z[]] Derivative[0, 1][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] + Derivative[1, 0][$CellContext`Gx][
               $CellContext`\[Rho][], 
               $CellContext`z[]] Derivative[1, 0][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] + 2 $CellContext`Gx[
               $CellContext`\[Rho][], 
               $CellContext`z[]] (Derivative[0, 2][$CellContext`Hy][
                $CellContext`\[Rho][], 
                $CellContext`z[]] + Derivative[2, 0][$CellContext`Hy][
                $CellContext`\[Rho][], 
                $CellContext`z[]]))) + $CellContext`q $CellContext`Hy[
            $CellContext`\[Rho][], 
            $CellContext`z[]]^2 (Derivative[0, 1][$CellContext`Gx][
             $CellContext`\[Rho][], 
             $CellContext`z[]] ($CellContext`q 
             Derivative[0, 1][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] + 
            2 Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
               $CellContext`\[Rho][], 
               $CellContext`z[]]) + Derivative[1, 0][$CellContext`Gx][
             $CellContext`\[Rho][], 
             $CellContext`z[]] ($CellContext`q 
             Derivative[1, 0][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] + 
            2 Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
               $CellContext`\[Rho][], 
               $CellContext`z[]]) + 2 $CellContext`Gx[
             $CellContext`\[Rho][], 
             $CellContext`z[]] ($CellContext`q 
             Derivative[0, 2][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] + 
            2 Derivative[0, 2][$CellContext`\[Omega]\[Psi]][
               $CellContext`\[Rho][], 
               $CellContext`z[]] + $CellContext`q 
             Derivative[2, 0][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]] + 
            2 Derivative[2, 0][$CellContext`\[Omega]\[Psi]][
               $CellContext`\[Rho][], 
               $CellContext`z[]])) + 2 $CellContext`Hy[
           $CellContext`\[Rho][], 
           $CellContext`z[]] ($CellContext`\[Omega]\[Psi][
             $CellContext`\[Rho][], 
             $CellContext`z[]] (Derivative[0, 1][$CellContext`Gx][
               $CellContext`\[Rho][], 
               $CellContext`z[]] Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
               $CellContext`\[Rho][], 
               $CellContext`z[]] + Derivative[1, 0][$CellContext`Gx][
               $CellContext`\[Rho][], 
               $CellContext`z[]] Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
               $CellContext`\[Rho][], 
               $CellContext`z[]]) + $CellContext`Gx[
             $CellContext`\[Rho][], 
             $CellContext`z[]] (-$CellContext`q^2 
             Derivative[0, 1][$CellContext`Hy][
                $CellContext`\[Rho][], 
                $CellContext`z[]]^2 + 
            Derivative[0, 1][$CellContext`\[Omega]\[Psi]][
               $CellContext`\[Rho][], 
               $CellContext`z[]]^2 + 2 $CellContext`\[Omega]\[Psi][
               $CellContext`\[Rho][], 
               $CellContext`z[]] Derivative[0, 2][$CellContext`\[Omega]\[Psi]][
               $CellContext`\[Rho][], 
               $CellContext`z[]] - $CellContext`q^2 
            Derivative[1, 0][$CellContext`Hy][
               $CellContext`\[Rho][], 
               $CellContext`z[]]^2 + 
            Derivative[1, 0][$CellContext`\[Omega]\[Psi]][
               $CellContext`\[Rho][], 
               $CellContext`z[]]^2 + 2 $CellContext`\[Omega]\[Psi][
               $CellContext`\[Rho][], 
               $CellContext`z[]] Derivative[2, 0][$CellContext`\[Omega]\[Psi]][
               $CellContext`\[Rho][], 
               $CellContext`z[]]))))), 0}, {
    0, 0, 0, 0, Rational[1, 4] $CellContext`ks^(-2) $CellContext`Gx[
        $CellContext`\[Rho][], 
        $CellContext`z[]]^(-1) $CellContext`Gy[
        $CellContext`\[Rho][], 
        $CellContext`z[]]^(-1) $CellContext`Hx[
        $CellContext`\[Rho][], 
        $CellContext`z[]]^(-1) $CellContext`P[
        $CellContext`\[Rho][], 
        $CellContext`z[]]^(-1) (-$CellContext`Gx[
         $CellContext`\[Rho][], 
         $CellContext`z[]] (Derivative[0, 1][$CellContext`Gx][
           $CellContext`\[Rho][], 
           $CellContext`z[]] Derivative[0, 1][$CellContext`Gy][
           $CellContext`\[Rho][], 
           $CellContext`z[]] + Derivative[1, 0][$CellContext`Gx][
           $CellContext`\[Rho][], 
           $CellContext`z[]] Derivative[1, 0][$CellContext`Gy][
           $CellContext`\[Rho][], 
           $CellContext`z[]]) + $CellContext`Gy[
         $CellContext`\[Rho][], 
         $CellContext`z[]] (Derivative[0, 1][$CellContext`Gx][
           $CellContext`\[Rho][], 
           $CellContext`z[]]^2 + Derivative[1, 0][$CellContext`Gx][
           $CellContext`\[Rho][], 
           $CellContext`z[]]^2 - 2 $CellContext`Gx[
          $CellContext`\[Rho][], 
          $CellContext`z[]] (Derivative[0, 2][$CellContext`Gx][
           $CellContext`\[Rho][], 
           $CellContext`z[]] + Derivative[2, 0][$CellContext`Gx][
           $CellContext`\[Rho][], 
           $CellContext`z[]])))}}, {-$CellContext`BS, -$CellContext`BS}, 
   0][-$CellContext`a, -$CellContext`b],
  Editable->False]], "Output",ExpressionUUID->"8285a2a1-1949-49e7-a7e3-\
4cb7264669c5"]
}, Open  ]],

Cell["Now we need to show that the rest are also zero:", "Text",ExpressionUUID->"7c7b75c8-57e5-4639-ac26-dc251eecc8e6"],

Cell["This is easy:", "Text",ExpressionUUID->"89ab99d2-6296-49f4-aa58-73062af27c04"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Numerator", "[", 
  RowBox[{"ricci", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"4", ",", 
      RowBox[{"-", "BS"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"4", ",", 
      RowBox[{"-", "BS"}]}], "}"}]}], "]"}], "]"}]], "Input",ExpressionUUID->\
"440ef40c-ef62-47ea-aaf0-7bece590b7af"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    RowBox[{
     InterpretationBox[
      StyleBox["Gx",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`Gx,
      Editable->False], "[", 
     RowBox[{
      InterpretationBox[
       StyleBox["\[Rho]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Rho][],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["z",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`z[],
       Editable->False]}], "]"}]}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{
       SuperscriptBox[
        InterpretationBox[
         StyleBox["Gx",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Gx,
         Editable->False], 
        TagBox[
         RowBox[{"(", 
          RowBox[{"0", ",", "1"}], ")"}],
         Derivative],
        MultilineFunction->None], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["\[Rho]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Rho][],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["z",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`z[],
         Editable->False]}], "]"}], " ", 
      RowBox[{
       SuperscriptBox[
        InterpretationBox[
         StyleBox["Gy",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Gy,
         Editable->False], 
        TagBox[
         RowBox[{"(", 
          RowBox[{"0", ",", "1"}], ")"}],
         Derivative],
        MultilineFunction->None], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["\[Rho]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Rho][],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["z",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`z[],
         Editable->False]}], "]"}]}], "+", 
     RowBox[{
      RowBox[{
       SuperscriptBox[
        InterpretationBox[
         StyleBox["Gx",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Gx,
         Editable->False], 
        TagBox[
         RowBox[{"(", 
          RowBox[{"1", ",", "0"}], ")"}],
         Derivative],
        MultilineFunction->None], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["\[Rho]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Rho][],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["z",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`z[],
         Editable->False]}], "]"}], " ", 
      RowBox[{
       SuperscriptBox[
        InterpretationBox[
         StyleBox["Gy",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Gy,
         Editable->False], 
        TagBox[
         RowBox[{"(", 
          RowBox[{"1", ",", "0"}], ")"}],
         Derivative],
        MultilineFunction->None], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["\[Rho]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Rho][],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["z",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`z[],
         Editable->False]}], "]"}]}]}], ")"}]}], "+", 
  RowBox[{
   RowBox[{
    InterpretationBox[
     StyleBox["Gy",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`Gy,
     Editable->False], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["\[Rho]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Rho][],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["z",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`z[],
      Editable->False]}], "]"}], " ", 
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox[
      RowBox[{
       SuperscriptBox[
        InterpretationBox[
         StyleBox["Gx",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Gx,
         Editable->False], 
        TagBox[
         RowBox[{"(", 
          RowBox[{"0", ",", "1"}], ")"}],
         Derivative],
        MultilineFunction->None], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["\[Rho]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Rho][],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["z",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`z[],
         Editable->False]}], "]"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{
       SuperscriptBox[
        InterpretationBox[
         StyleBox["Gx",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`Gx,
         Editable->False], 
        TagBox[
         RowBox[{"(", 
          RowBox[{"1", ",", "0"}], ")"}],
         Derivative],
        MultilineFunction->None], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["\[Rho]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Rho][],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["z",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`z[],
         Editable->False]}], "]"}], "2"], "-", 
     RowBox[{"2", " ", 
      RowBox[{
       InterpretationBox[
        StyleBox["Gx",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`Gx,
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["\[Rho]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Rho][],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["z",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`z[],
         Editable->False]}], "]"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["Gx",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Gx,
           Editable->False], 
          TagBox[
           RowBox[{"(", 
            RowBox[{"0", ",", "2"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["\[Rho]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Rho][],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["z",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`z[],
           Editable->False]}], "]"}], "+", 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["Gx",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Gx,
           Editable->False], 
          TagBox[
           RowBox[{"(", 
            RowBox[{"2", ",", "0"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["\[Rho]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Rho][],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["z",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`z[],
           Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}]}]], "Output",Expres\
sionUUID->"9bb7bff0-5182-4e57-a277-b06652efb37b"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"%", "/.", "GFunctions"}], "//", "Expand"}], ";"}]], "Input",Expres\
sionUUID->"ef107290-6235-4e63-9a11-1062fe931695"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"%", "/.", "\[Mu]Functions"}], "//", "Expand"}], ";"}]], "Input",Ex\
pressionUUID->"d46ea0bb-e087-4dd5-b1fe-6bd71074f37e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"%", "//", "Together"}], "//", "AbsoluteTiming"}]], "Input",Expressi\
onUUID->"3215ff84-cc57-4a46-acce-407f615b6901"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.187829`", ",", "0"}], "}"}]], "Output",ExpressionUUID->"47ddd61f-\
1330-408f-ab9e-8a4cd663f0f5"]
}, Open  ]],

Cell[TextData[{
 "However the other six independent components are too hard for ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " on a laptop. We just show that results are correct for generic values of \
the coefficients and variables. Those random values must be exact values, in \
order to get an exact zero. Well, the truth is that not even with integers we \
can get a zero, so we do it numerically in the end."
}], "Text",ExpressionUUID->"d193c5d4-a97e-4586-a0f5-62482051b4ae"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SeedRandom", "[", "123", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"random", "=", 
  RowBox[{"Thread", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "q", ",", "a1", ",", "a2", ",", "a3", ",", "a4", ",", "a5", ",", "c1", 
      ",", "c2", ",", "ks", ",", 
      RowBox[{"z", "[", "]"}], ",", 
      RowBox[{"\[Rho]", "[", "]"}]}], "}"}], "\[Rule]", 
    RowBox[{"RandomInteger", "[", 
     RowBox[{"100", ",", "11"}], "]"}]}], "]"}]}]}], "Input",ExpressionUUID->\
"b6f87063-4e01-4a66-bae5-faab5e4472a4"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    InterpretationBox[
     StyleBox["q",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`q,
     Editable->False], "\[Rule]", "58"}], ",", 
   RowBox[{
    InterpretationBox[
     StyleBox["a1",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`a1,
     Editable->False], "\[Rule]", "42"}], ",", 
   RowBox[{
    InterpretationBox[
     StyleBox["a2",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`a2,
     Editable->False], "\[Rule]", "64"}], ",", 
   RowBox[{
    InterpretationBox[
     StyleBox["a3",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`a3,
     Editable->False], "\[Rule]", "38"}], ",", 
   RowBox[{
    InterpretationBox[
     StyleBox["a4",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`a4,
     Editable->False], "\[Rule]", "60"}], ",", 
   RowBox[{
    InterpretationBox[
     StyleBox["a5",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`a5,
     Editable->False], "\[Rule]", "96"}], ",", 
   RowBox[{
    InterpretationBox[
     StyleBox["c1",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`c1,
     Editable->False], "\[Rule]", "15"}], ",", 
   RowBox[{
    InterpretationBox[
     StyleBox["c2",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`c2,
     Editable->False], "\[Rule]", "82"}], ",", 
   RowBox[{
    InterpretationBox[
     StyleBox["ks",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`ks,
     Editable->False], "\[Rule]", "75"}], ",", 
   RowBox[{
    InterpretationBox[
     StyleBox["z",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`z[],
     Editable->False], "\[Rule]", "25"}], ",", 
   RowBox[{
    InterpretationBox[
     StyleBox["\[Rho]",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`\[Rho][],
     Editable->False], "\[Rule]", "38"}]}], "}"}]], "Output",ExpressionUUID->\
"53efb4fd-604f-48e3-96de-9c1dc9033987"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"rules", "=", 
   RowBox[{"FoldedRule", "[", 
    RowBox[{
    "\[Omega]\[Psi]Function", ",", "HFunctions", ",", "MFunctions", ",", 
     "GFunctions", ",", "FFunction", ",", "PFunction", ",", "RFunctions", ",",
      "\[Mu]Functions"}], "]"}]}], ";"}]], "Input",ExpressionUUID->"bb17cd41-\
6061-45cf-967c-81a732468db6"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"r00", "=", 
   RowBox[{
    RowBox[{"ricci", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", 
        RowBox[{"-", "BS"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", 
        RowBox[{"-", "BS"}]}], "}"}]}], "]"}], "/.", "rules"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"r00n", "=", 
   RowBox[{"r00", "/.", "random"}]}], ";"}], "\n", 
 RowBox[{"N", "[", "r00n", "]"}]}], "Input",ExpressionUUID->"e831ade3-075c-\
4a31-927a-d69f1c6b8229"],

Cell[BoxData[
 RowBox[{"-", "1.33186851496873`*^-16"}]], "Output",ExpressionUUID->"a2729eb2-d7de-4012-8795-e5d833165ed7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"r11", "=", 
   RowBox[{
    RowBox[{"ricci", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"-", "BS"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"-", "BS"}]}], "}"}]}], "]"}], "/.", "rules"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"r11n", "=", 
   RowBox[{"r11", "/.", "random"}]}], ";"}], "\n", 
 RowBox[{"N", "[", "r11n", "]"}]}], "Input",ExpressionUUID->"639136d7-223a-\
47b9-a2cb-c5c3215081b5"],

Cell[BoxData[
 RowBox[{"-", "2.6152263704441736`*^-8"}]], "Output",ExpressionUUID->"951bab48-d8e0-41c5-a939-48be467b5137"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"r22", "=", 
   RowBox[{
    RowBox[{"ricci", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"2", ",", 
        RowBox[{"-", "BS"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", 
        RowBox[{"-", "BS"}]}], "}"}]}], "]"}], "/.", "rules"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"r22n", "=", 
   RowBox[{"r22", "/.", "random"}]}], ";"}], "\n", 
 RowBox[{"N", "[", "r22n", "]"}]}], "Input",ExpressionUUID->"3fc0e863-6e45-\
4972-b5a7-977f9785f5e7"],

Cell[BoxData[
 RowBox[{"-", "2.4848251858888837`*^-9"}]], "Output",ExpressionUUID->"e657903e-8b4d-42b6-a59b-078b2e6b406b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"r33", "=", 
   RowBox[{
    RowBox[{"ricci", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"3", ",", 
        RowBox[{"-", "BS"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3", ",", 
        RowBox[{"-", "BS"}]}], "}"}]}], "]"}], "/.", "rules"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"r33n", "=", 
   RowBox[{"r33", "/.", "random"}]}], ";"}], "\n", 
 RowBox[{"N", "[", "r33n", "]"}]}], "Input",ExpressionUUID->"3648f1ea-6729-\
4e73-911c-86bd6b54f534"],

Cell[BoxData[
 TemplateBox[{
  "General","munfl",
   "\"\\!\\(\\*RowBox[{\\\"1.9014124898247124`*^-274\\\", \\\" \\\", RowBox[{\
\\\"(\\\", RowBox[{\\\"-\\\", \\\"5.015323652800783`*^-68\\\"}], \
\\\")\\\"}]}]\\) is too small for machine precision arithmetic; replacing \
with machine number \\!\\(\\*RowBox[{\\\"0.`\\\"}]\\).\"",2,46,1,
   19248053738867224867,"Local"},
  "MessageTemplate"]], "Message", \
"MSG",ExpressionUUID->"85d6b2fb-fd4a-4d0a-92e3-2f4611ee070f"],

Cell[BoxData["0.`"], "Output",ExpressionUUID->"7351eedf-5ed3-4266-8803-f5429114a960"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"r12", "=", 
   RowBox[{
    RowBox[{"ricci", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"-", "BS"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", 
        RowBox[{"-", "BS"}]}], "}"}]}], "]"}], "/.", "rules"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"r12n", "=", 
   RowBox[{"r12", "/.", "random"}]}], ";"}], "\n", 
 RowBox[{"N", "[", "r12n", "]"}]}], "Input",ExpressionUUID->"194a695b-ffb8-\
467d-b3ff-ff246129d314"],

Cell[BoxData["8.341316658825552`*^-9"], "Output",ExpressionUUID->"cda01b30-f442-4398-98a9-ed7e9f1a4983"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"r03", "=", 
   RowBox[{
    RowBox[{"ricci", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", 
        RowBox[{"-", "BS"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3", ",", 
        RowBox[{"-", "BS"}]}], "}"}]}], "]"}], "/.", "rules"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"r03n", "=", 
   RowBox[{"r03", "/.", "random"}]}], ";"}], "\n", 
 RowBox[{"N", "[", "r03n", "]"}]}], "Input",ExpressionUUID->"0a2cb3d5-188d-\
4050-bdc2-2050d5422973"],

Cell[BoxData[
 RowBox[{"-", "7.685653221649808`*^-15"}]], "Output",ExpressionUUID->"90caeb62-63d5-433b-accd-0f0ef26f4fe7"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{
  "BlackSaturn", ",", "matrix", ",", "ematrix", ",", "FFunction", ",", 
   "GFunctions", ",", "HFunctions", ",", "PFunction", ",", "RFunctions", ",", 
   "MFunctions", ",", "\[Mu]Functions", ",", "\[Omega]\[Psi]Function", ",", 
   "met", ",", "cd", ",", "ricci", ",", "r00", ",", "r11", ",", "r22", ",", 
   "r33", ",", "r12", ",", "r03", ",", "r00n", ",", "r11n", ",", "r22n", ",", 
   "r33n", ",", "r12n", ",", "r03n", ",", "random", ",", "rules"}], 
  "]"}]], "Input",ExpressionUUID->"647eb465-2690-4e12-893f-88758bff364c"],

Cell[BoxData[
 RowBox[{"UndefScalarFunction", "[", 
  RowBox[{"{", 
   RowBox[{
   "\[Mu]1", ",", "\[Mu]2", ",", "\[Mu]3", ",", "\[Mu]4", ",", "\[Mu]5", ",", 
    "M0", ",", "M1", ",", "M2", ",", "M3", ",", "M4", ",", "R1", ",", "R2", 
    ",", "Hx", ",", "Hy", ",", "Gx", ",", "Gy", ",", "\[Omega]\[Psi]", ",", 
    "P", ",", "F"}], "}"}], "]"}]], "Input",ExpressionUUID->"cf945f3c-94d3-\
4b4e-ac8d-b6d788276c42"],

Cell[BoxData[
 RowBox[{"UndefConstantSymbol", "[", 
  RowBox[{"{", 
   RowBox[{
   "ks", ",", "q", ",", "a1", ",", "a2", ",", "a3", ",", "a4", ",", "a5", ",",
     "c1", ",", "c2"}], "}"}], "]"}]], "Input",ExpressionUUID->"81fbd756-e237-\
4596-9216-8d8268d9065f"],

Cell[BoxData[
 RowBox[{"UndefChart", "[", "BS", "]"}]], "Input",ExpressionUUID->"2e7bc041-4de3-43d5-966e-67f474947d24"],

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M", "]"}]], "Input",ExpressionUUID->"86995700-433e-431d-8462-c434bccd64ea"],

Cell[BoxData[
 RowBox[{"ClearxCobaCache", "[", "All", "]"}]], "Input",ExpressionUUID->"f94baf4d-88ab-4d7d-a519-6515985e8525"]
}, Closed]],

Cell[CellGroupData[{

Cell["4.7. An example with two bases", "Subsubsection",ExpressionUUID->"0ad2ed75-ce7a-4a18-960a-62d62c93e633"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<xAct`xCoba`\>\"", "]"}]], "Input",ExpressionUUID->"35c6b5e3-84fc-4689-b0d5-c5959257432e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$DefInfoQ", "=", 
   RowBox[{"$UndefInfoQ", "=", "False"}]}], ";"}]], "Input",ExpressionUUID->\
"be4cb538-0d51-4d70-b0f3-2da6b518420d"],

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M4", ",", "4", ",", 
   RowBox[{"{", 
    RowBox[{
    "\[Mu]", ",", "\[Nu]", ",", "\[Alpha]", ",", "\[Beta]", ",", "\[Gamma]", 
     ",", "\[Delta]", ",", "\[Lambda]"}], "}"}]}], "]"}]], "Input",ExpressionU\
UID->"6c830f30-c752-4a76-a923-ddd9312da703"],

Cell[BoxData[
 RowBox[{"DefConstantSymbol", "[", 
  RowBox[{"Mass", ",", 
   RowBox[{"PrintAs", "\[Rule]", "\"\<M\>\""}]}], "]"}]], "Input",ExpressionUU\
ID->"a3b64925-faf4-49b1-8a6f-78ee79c052da"],

Cell["This is the metric in the standard coordinates:", "Text",ExpressionUUID->"6a187ac5-259d-4157-852c-ff2588ef2edd"],

Cell[BoxData[
 RowBox[{"DefChart", "[", 
  RowBox[{"schw", ",", "M4", ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"t", "[", "]"}], ",", 
     RowBox[{"r", "[", "]"}], ",", 
     RowBox[{"\[Theta]", "[", "]"}], ",", 
     RowBox[{"\[Phi]", "[", "]"}]}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"ea959855-17f4-4976-8804-b3f4726003b2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixForm", "[", 
  RowBox[{"SchwarzschildMatrix", "=", 
   RowBox[{"DiagonalMatrix", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       RowBox[{"2", 
        RowBox[{"Mass", "/", 
         RowBox[{"r", "[", "]"}]}]}]}], ",", 
      RowBox[{"1", "/", 
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"2", 
          RowBox[{"Mass", "/", 
           RowBox[{"r", "[", "]"}]}]}]}], ")"}]}], ",", 
      RowBox[{
       RowBox[{"r", "[", "]"}], "^", "2"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"r", "[", "]"}], "^", "2"}], 
       RowBox[{
        RowBox[{"Sin", "[", 
         RowBox[{"\[Theta]", "[", "]"}], "]"}], "^", "2"}]}]}], "}"}], 
    "]"}]}], "]"}]], "Input",ExpressionUUID->"502efa99-ee4a-4230-85ff-\
ca22647587f4"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       FractionBox[
        RowBox[{"2", " ", 
         InterpretationBox[
          StyleBox["M",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`Mass,
          Editable->False]}], 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False]]}], "0", "0", "0"},
     {"0", 
      FractionBox["1", 
       RowBox[{"1", "-", 
        FractionBox[
         RowBox[{"2", " ", 
          InterpretationBox[
           StyleBox["M",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Mass,
           Editable->False]}], 
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False]]}]], "0", "0"},
     {"0", "0", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], "2"], "0"},
     {"0", "0", "0", 
      RowBox[{
       SuperscriptBox[
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], "2"], " ", 
       SuperscriptBox[
        RowBox[{
         InterpretationBox[
          StyleBox["Sin",
           ShowAutoStyles->False,
           AutoSpacing->False],
          Sin,
          Editable->False], "[", 
         InterpretationBox[
          StyleBox["\[Theta]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[Theta][],
          Editable->False], "]"}], "2"]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",ExpressionUUID->"9f187f8e-9ccd-4ffb-\
ac8c-9f96dbaa872f"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"$LargeComponentSize", "=", "2000"}], ";"}]], "Input",ExpressionUUID\
->"dd500ce7-ab82-4973-8207-5f67ecd4d0f6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"metric", "=", 
  RowBox[{"CTensor", "[", 
   RowBox[{"SchwarzschildMatrix", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "schw"}], ",", 
      RowBox[{"-", "schw"}]}], "}"}]}], "]"}]}]], "Input",ExpressionUUID->\
"d57ff74a-d720-48ee-841c-b89f2c00cb66"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        FractionBox[
         RowBox[{"2", " ", 
          InterpretationBox[
           StyleBox["M",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Mass,
           Editable->False]}], 
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False]]}], ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       FractionBox["1", 
        RowBox[{"1", "-", 
         FractionBox[
          RowBox[{"2", " ", 
           InterpretationBox[
            StyleBox["M",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Mass,
            Editable->False]}], 
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False]]}]], ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], "2"], ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", 
       RowBox[{
        SuperscriptBox[
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False], "2"], " ", 
        SuperscriptBox[
         RowBox[{
          InterpretationBox[
           StyleBox["Sin",
            ShowAutoStyles->False,
            AutoSpacing->False],
           Sin,
           Editable->False], "[", 
          InterpretationBox[
           StyleBox["\[Theta]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Theta][],
           Editable->False], "]"}], "2"]}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "schw"}], ",", 
     RowBox[{"-", "schw"}]}], "}"}], ",", "0"}], "]"}]], "Output",ExpressionUU\
ID->"014ba87c-76be-4463-b46a-46a0adaf74ee"]
}, Open  ]],

Cell["This is now the metric in an adapted frame:", "Text",ExpressionUUID->"d4e62922-8603-4c9b-9054-2f564371b6ad"],

Cell[BoxData[
 RowBox[{"DefBasis", "[", 
  RowBox[{"frame", ",", "TangentM4", ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"BasisColor", "\[Rule]", 
    RowBox[{"RGBColor", "[", 
     RowBox[{"0", ",", "0", ",", "1"}], "]"}]}], ",", 
   RowBox[{"BasisChange", "\[Rule]", 
    RowBox[{"CTensor", "[", 
     RowBox[{
      RowBox[{"DiagonalMatrix", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"1", "/", 
          RowBox[{"Sqrt", "[", 
           RowBox[{"1", "-", 
            RowBox[{"2", 
             RowBox[{"Mass", "/", 
              RowBox[{"r", "[", "]"}]}]}]}], "]"}]}], ",", 
         RowBox[{"Sqrt", "[", 
          RowBox[{"1", "-", 
           RowBox[{"2", 
            RowBox[{"Mass", "/", 
             RowBox[{"r", "[", "]"}]}]}]}], "]"}], ",", 
         RowBox[{"1", "/", 
          RowBox[{"r", "[", "]"}]}], ",", 
         RowBox[{
          RowBox[{"1", "/", 
           RowBox[{"r", "[", "]"}]}], "/", 
          RowBox[{"Sin", "[", 
           RowBox[{"\[Theta]", "[", "]"}], "]"}]}]}], "}"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "frame"}], ",", "schw"}], "}"}]}], "]"}]}]}], 
  "]"}]], "Input",ExpressionUUID->"6da63781-4065-4a08-b6c9-022526e9139f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"metricF", "=", 
  RowBox[{"CTensor", "[", 
   RowBox[{
    RowBox[{"DiagonalMatrix", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1"}], "}"}], "]"}], ",", 
    
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "frame"}], ",", 
      RowBox[{"-", "frame"}]}], "}"}], ",", "0"}], "]"}]}]], "Input",Expressio\
nUUID->"ad931b04-ea7c-4207-a3a0-8491cdcb7ea6"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "frame"}], ",", 
     RowBox[{"-", "frame"}]}], "}"}], ",", "0"}], "]"}]], "Output",ExpressionU\
UID->"710c4874-eaa0-4349-996b-b1aa955576d8"]
}, Open  ]],

Cell["\<\
We start by precomputing everything in advance for both expressions of the \
metric:\
\>", "Text",ExpressionUUID->"d502eb82-877e-4157-af03-e2607cb78dc3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MetricCompute", "[", 
   RowBox[{"metric", ",", "schw", ",", "All"}], "]"}], "//", 
  "Timing"}]], "Input",ExpressionUUID->"c841d8e9-45cc-4e31-b5ad-bbcc3b9bd14e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.16227`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"8b8d5580-bb70-45f5-b8ea-532c99b27deb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MetricCompute", "[", 
   RowBox[{"metricF", ",", "schw", ",", "All"}], "]"}], "//", 
  "Timing"}]], "Input",ExpressionUUID->"0ce3936b-948b-4b44-a970-b588db16e42e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.13401`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"9d2eb8c3-7f97-4214-beff-e5acbed48d15"]
}, Open  ]],

Cell["These are the metrics:", "Text",ExpressionUUID->"f8d67ce9-e37b-4c60-ade7-0fd4e36d9ade"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"metric", "[", 
  RowBox[{
   RowBox[{"-", "\[Alpha]"}], ",", 
   RowBox[{"-", "\[Beta]"}]}], "]"}]], "Input",ExpressionUUID->"3b71f9c0-66d4-\
490c-b024-69a23458185d"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox[
            RowBox[{
             RowBox[{"-", "1"}], "+", 
             FractionBox[
              RowBox[{"2", " ", 
               InterpretationBox[
                StyleBox["M",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Mass,
                Editable->False]}], 
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False]]}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
              RowBox[{
                RowBox[{"-", "1"}], "+", 
                FractionBox[
                 RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], 
                 InterpretationBox[
                  StyleBox[
                  "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`r[], Editable -> False]]}]}]],
           
           Annotation[#, {1, 1} -> -1 + 2 $CellContext`Mass/$CellContext`r[], 
            "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 4} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            FractionBox["1", 
             RowBox[{"1", "-", 
              FractionBox[
               RowBox[{"2", " ", 
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False]}], 
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False]]}]],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
              FractionBox["1", 
               RowBox[{"1", "-", 
                 FractionBox[
                  RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], 
                  InterpretationBox[
                   StyleBox[
                   "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`r[], Editable -> False]]}]]}]],
           
           Annotation[#, {2, 
             2} -> (1 - 2 $CellContext`Mass/$CellContext`r[])^(-1), 
            "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 4} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            SuperscriptBox[
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False], "2"],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "3"}], "}"}], "\[Rule]", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox[
                "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                $CellContext`r[], Editable -> False], "2"]}]],
           Annotation[#, {3, 3} -> $CellContext`r[]^2, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 4} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{
             SuperscriptBox[
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], "2"], " ", 
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["Sin",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                Sin,
                Editable->False], "[", 
               InterpretationBox[
                StyleBox["\[Theta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Theta][],
                Editable->False], "]"}], "2"]}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "4"}], "}"}], "\[Rule]", 
              RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox[
                  "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`r[], Editable -> False], "2"], " ", 
                SuperscriptBox[
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"Sin"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Sin, Editable -> False], "[", 
                   InterpretationBox[
                    StyleBox[
                    "\[Theta]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Theta][], Editable -> False], "]"}], 
                 "2"]}]}]],
           Annotation[#, {4, 4} -> $CellContext`r[]^2 Sin[
                $CellContext`\[Theta][]]^2, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {" ", " "},
         {"\[Alpha]", "\[Beta]"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{-1 + 2 $CellContext`Mass/$CellContext`r[], 0, 0, 0}, {
    0, (1 - 2 $CellContext`Mass/$CellContext`r[])^(-1), 0, 0}, {
    0, 0, $CellContext`r[]^2, 0}, {0, 0, 0, $CellContext`r[]^2 Sin[
        $CellContext`\[Theta][]]^2}}, {-$CellContext`schw, \
-$CellContext`schw}, 0][-$CellContext`\[Alpha], -$CellContext`\[Beta]],
  Editable->False]], "Output",ExpressionUUID->"6b3c2590-e24e-4809-b09d-\
041f6ea6e7a9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"metricF", "[", 
  RowBox[{
   RowBox[{"-", "\[Alpha]"}], ",", 
   RowBox[{"-", "\[Beta]"}]}], "]"}]], "Input",ExpressionUUID->"35f5e449-9861-\
4d2e-925a-ad81f41b8cf9"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox[
            RowBox[{"-", "1"}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
              RowBox[{"-", "1"}]}]],
           Annotation[#, {1, 1} -> -1, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 4} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["1",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", "1"}]],
           Annotation[#, {2, 2} -> 1, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 4} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["1",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "3"}], "}"}], "\[Rule]", "1"}]],
           Annotation[#, {3, 3} -> 1, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 4} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["1",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "4"}], "}"}], "\[Rule]", "1"}]],
           Annotation[#, {4, 4} -> 1, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]},
           "RowsIndexed" -> {1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {" ", " "},
         {"\[Alpha]", "\[Beta]"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{-1, 0, 0, 0}, {0, 1, 0, 0}, {0, 0, 1, 0}, {0, 0, 0, 
   1}}, {-$CellContext`frame, -$CellContext`frame}, 
   0][-$CellContext`\[Alpha], -$CellContext`\[Beta]],
  Editable->False]], "Output",ExpressionUUID->"30150ae4-bdc1-41b6-b752-\
3f4897145c4b"]
}, Open  ]],

Cell["and their inverses:", "Text",ExpressionUUID->"393fbeee-c7e3-4627-b252-97d4b5b94c79"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Inv", "[", "metric", "]"}], "[", 
  RowBox[{"\[Alpha]", ",", "\[Beta]"}], "]"}]], "Input",ExpressionUUID->\
"631bc208-a08e-4a06-b1ad-fc11383150bc"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox[
            FractionBox[
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False], 
             RowBox[{
              RowBox[{"2", " ", 
               InterpretationBox[
                StyleBox["M",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Mass,
                Editable->False]}], "-", 
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False]}]],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
              FractionBox[
               InterpretationBox[
                StyleBox[
                "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                $CellContext`r[], Editable -> False], 
               RowBox[{
                 RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "-", 
                 InterpretationBox[
                  StyleBox[
                  "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`r[], Editable -> False]}]]}]],
           
           Annotation[#, {1, 
             1} -> (2 $CellContext`Mass - $CellContext`r[])^(-1) \
$CellContext`r[], "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 4} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{"1", "-", 
             FractionBox[
              RowBox[{"2", " ", 
               InterpretationBox[
                StyleBox["M",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Mass,
                Editable->False]}], 
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False]]}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
              RowBox[{"1", "-", 
                FractionBox[
                 RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], 
                 InterpretationBox[
                  StyleBox[
                  "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`r[], Editable -> False]]}]}]],
           
           Annotation[#, {2, 2} -> 1 - 2 $CellContext`Mass/$CellContext`r[], 
            "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 4} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            FractionBox["1", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], "2"]],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "3"}], "}"}], "\[Rule]", 
              FractionBox["1", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["r", AutoSpacing -> False, ShowAutoStyles -> False], 
                 $CellContext`r[], Editable -> False], "2"]]}]],
           Annotation[#, {3, 3} -> $CellContext`r[]^(-2), "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 4} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            FractionBox[
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["Csc",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                Csc,
                Editable->False], "[", 
               InterpretationBox[
                StyleBox["\[Theta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Theta][],
                Editable->False], "]"}], "2"], 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], "2"]],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "4"}], "}"}], "\[Rule]", 
              FractionBox[
               SuperscriptBox[
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"Csc"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Csc, Editable -> False], "[", 
                  InterpretationBox[
                   StyleBox[
                   "\[Theta]", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`\[Theta][], Editable -> False], "]"}], "2"], 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["r", AutoSpacing -> False, ShowAutoStyles -> False], 
                 $CellContext`r[], Editable -> False], "2"]]}]],
           Annotation[#, {4, 4} -> Csc[
                $CellContext`\[Theta][]]^2 $CellContext`r[]^(-2), 
            "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {"\[Alpha]", "\[Beta]"},
         {" ", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{(
       2 $CellContext`Mass - $CellContext`r[])^(-1) $CellContext`r[], 0, 0, 
     0}, {0, 1 - 2 $CellContext`Mass/$CellContext`r[], 0, 0}, {
    0, 0, $CellContext`r[]^(-2), 0}, {0, 0, 0, Csc[
        $CellContext`\[Theta][]]^2 $CellContext`r[]^(-2)}}, \
{$CellContext`schw, $CellContext`schw}, 
   0][$CellContext`\[Alpha], $CellContext`\[Beta]],
  Editable->False]], "Output",ExpressionUUID->"2279dda6-3390-4d0f-8efe-\
63767e63484d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Inv", "[", "metricF", "]"}], "[", 
  RowBox[{"\[Alpha]", ",", "\[Beta]"}], "]"}]], "Input",ExpressionUUID->\
"599a56b3-d56c-4813-811c-25ec21242ff6"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox[
            RowBox[{"-", "1"}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
              RowBox[{"-", "1"}]}]],
           Annotation[#, {1, 1} -> -1, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 4} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["1",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", "1"}]],
           Annotation[#, {2, 2} -> 1, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 4} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["1",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "3"}], "}"}], "\[Rule]", "1"}]],
           Annotation[#, {3, 3} -> 1, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 4} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["1",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "4"}], "}"}], "\[Rule]", "1"}]],
           Annotation[#, {4, 4} -> 1, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]},
           "RowsIndexed" -> {1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {"\[Alpha]", "\[Beta]"},
         {" ", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{-1, 0, 0, 0}, {0, 1, 0, 0}, {0, 0, 1, 0}, {0, 0, 0, 
   1}}, {$CellContext`frame, $CellContext`frame}, 
   0][$CellContext`\[Alpha], $CellContext`\[Beta]],
  Editable->False]], "Output",ExpressionUUID->"eb15800b-0bbf-4274-ab89-\
b2b8fe819dd1"]
}, Open  ]],

Cell["\<\
Note that we do not use SetCMetric, and therefore we cannot raise and lower \
indices. In this way all metrics play an equivalent role.\
\>", "Text",ExpressionUUID->"8bfdc566-714e-4947-a7f0-23adb71c1c3b"],

Cell["The LeviCivita connections:", "Text",ExpressionUUID->"3f9c21f1-fe35-40d5-b5ff-0619d5c9085d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"cd", "=", 
   RowBox[{"CovDOfMetric", "[", "metric", "]"}]}], ";"}]], "Input",ExpressionU\
UID->"5e8d5934-1e23-4ea5-adff-fd69548fe594"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Torsion", "[", "cd", "]"}]], "Input",ExpressionUUID->"8d215dc7-e4ba-4622-9969-0847c3f38e9d"],

Cell[BoxData["Zero"], "Output",ExpressionUUID->"eaf3942d-c8d4-4670-8fce-4426502ba736"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"cdF", "=", 
   RowBox[{"CovDOfMetric", "[", "metricF", "]"}]}], ";"}]], "Input",Expression\
UUID->"f2fd3a9b-f8e8-4f6d-af88-806107ec5e1d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Torsion", "[", "cdF", "]"}]], "Input",ExpressionUUID->"cd9504ea-0e71-4ec3-986a-f4a25de9d2a5"],

Cell[BoxData["Zero"], "Output",ExpressionUUID->"723e5d9d-7636-4467-8656-489aa8e88da9"]
}, Open  ]],

Cell["\<\
Note the difference between a coordinated and a non-coordinated basis:\
\>", "Text",ExpressionUUID->"98f8cfea-acab-4df8-ba70-4a236fa8f74a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCTensor", "[", 
  RowBox[{"TorsionPDschw", ",", 
   RowBox[{"{", 
    RowBox[{"schw", ",", 
     RowBox[{"-", "schw"}], ",", 
     RowBox[{"-", "schw"}]}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"51e4681a-b402-4c02-bfa7-734e0d58d3a6"],

Cell[BoxData["Zero"], "Output",ExpressionUUID->"485b34cc-cc28-4c13-94ae-b4d0c93b5c8e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToCTensor", "[", 
  RowBox[{"TorsionPDframe", ",", 
   RowBox[{"{", 
    RowBox[{"frame", ",", 
     RowBox[{"-", "frame"}], ",", 
     RowBox[{"-", "frame"}]}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"87d6598d-d40b-42f9-bfc6-b300b0195c20"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"-", 
          FractionBox[
           InterpretationBox[
            StyleBox["M",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`Mass,
            Editable->False], 
           RowBox[{
            SqrtBox[
             RowBox[{"1", "-", 
              FractionBox[
               RowBox[{"2", " ", 
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False]}], 
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False]]}]], " ", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False], "2"]}]]}], ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         FractionBox[
          InterpretationBox[
           StyleBox["M",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Mass,
           Editable->False], 
          RowBox[{
           SqrtBox[
            RowBox[{"1", "-", 
             FractionBox[
              RowBox[{"2", " ", 
               InterpretationBox[
                StyleBox["M",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Mass,
                Editable->False]}], 
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False]]}]], " ", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False], "2"]}]], ",", "0", ",", "0", ",", "0"}], "}"}],
        ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", 
         FractionBox[
          SqrtBox[
           RowBox[{"1", "-", 
            FractionBox[
             RowBox[{"2", " ", 
              InterpretationBox[
               StyleBox["M",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Mass,
               Editable->False]}], 
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False]]}]], 
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False]], ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"-", 
          FractionBox[
           SqrtBox[
            RowBox[{"1", "-", 
             FractionBox[
              RowBox[{"2", " ", 
               InterpretationBox[
                StyleBox["M",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Mass,
                Editable->False]}], 
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False]]}]], 
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False]]}], ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", 
         FractionBox[
          SqrtBox[
           RowBox[{"1", "-", 
            FractionBox[
             RowBox[{"2", " ", 
              InterpretationBox[
               StyleBox["M",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Mass,
               Editable->False]}], 
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False]]}]], 
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False]]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", 
         FractionBox[
          RowBox[{
           InterpretationBox[
            StyleBox["Cot",
             ShowAutoStyles->False,
             AutoSpacing->False],
            Cot,
            Editable->False], "[", 
           InterpretationBox[
            StyleBox["\[Theta]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`\[Theta][],
            Editable->False], "]"}], 
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False]]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"-", 
          FractionBox[
           SqrtBox[
            RowBox[{"1", "-", 
             FractionBox[
              RowBox[{"2", " ", 
               InterpretationBox[
                StyleBox["M",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Mass,
                Editable->False]}], 
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False]]}]], 
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False]]}], ",", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{
            InterpretationBox[
             StyleBox["Cot",
              ShowAutoStyles->False,
              AutoSpacing->False],
             Cot,
             Editable->False], "[", 
            InterpretationBox[
             StyleBox["\[Theta]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Theta][],
             Editable->False], "]"}], 
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False]]}], ",", "0"}], "}"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"frame", ",", 
     RowBox[{"-", "frame"}], ",", 
     RowBox[{"-", "frame"}]}], "}"}], ",", "0"}], "]"}]], "Output",ExpressionU\
UID->"d9f95a53-8887-4804-8266-09d83071ae99"]
}, Open  ]],

Cell["\<\
Metric compatibility. We can use any form of the metric or the derivative:\
\>", "Text",ExpressionUUID->"6f9f6cb0-9a75-46f8-8a6b-12d375b5b759"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"cd", "[", 
   RowBox[{"-", "\[Mu]"}], "]"}], "[", 
  RowBox[{"metric", "[", 
   RowBox[{
    RowBox[{"-", "\[Alpha]"}], ",", 
    RowBox[{"-", "\[Beta]"}]}], "]"}], "]"}]], "Input",ExpressionUUID->\
"64616731-2a03-4e0d-a0aa-bf709b6ec645"],

Cell[BoxData["0"], "Output",ExpressionUUID->"9d0a6d30-fa0b-4811-b886-1b987613367e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"cdF", "[", 
   RowBox[{"-", "\[Mu]"}], "]"}], "[", 
  RowBox[{"metricF", "[", 
   RowBox[{
    RowBox[{"-", "\[Alpha]"}], ",", 
    RowBox[{"-", "\[Beta]"}]}], "]"}], "]"}]], "Input",ExpressionUUID->\
"9a41d661-b9a1-4ccf-be25-a34c0c77524f"],

Cell[BoxData["0"], "Output",ExpressionUUID->"6121f016-fccf-4f7e-bd25-54e7a203a788"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"cdF", "[", 
   RowBox[{"-", "\[Mu]"}], "]"}], "[", 
  RowBox[{"metric", "[", 
   RowBox[{
    RowBox[{"-", "\[Alpha]"}], ",", 
    RowBox[{"-", "\[Beta]"}]}], "]"}], "]"}]], "Input",ExpressionUUID->\
"611291b7-5e20-4d55-b256-ff3714669c24"],

Cell[BoxData["0"], "Output",ExpressionUUID->"b4ed4e21-a138-44e7-be52-c9f0d05ed455"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"cd", "[", 
   RowBox[{"-", "\[Mu]"}], "]"}], "[", 
  RowBox[{"metricF", "[", 
   RowBox[{
    RowBox[{"-", "\[Alpha]"}], ",", 
    RowBox[{"-", "\[Beta]"}]}], "]"}], "]"}]], "Input",ExpressionUUID->\
"cd6aa23d-a152-4379-8700-248eda9c15fa"],

Cell[BoxData["0"], "Output",ExpressionUUID->"97bf0361-eaf8-4f87-9cca-f093e735768d"]
}, Open  ]],

Cell["Riemann:", "Text",ExpressionUUID->"6162f825-b5d2-4547-996a-0c0150338ce1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"riem", "=", 
    RowBox[{"Simplify", "@", 
     RowBox[{"Riemann", "[", "cd", "]"}]}]}], ")"}], "[", 
  RowBox[{
   RowBox[{"-", "\[Alpha]"}], ",", 
   RowBox[{"-", "\[Beta]"}], ",", 
   RowBox[{"-", "\[Gamma]"}], ",", "\[Delta]"}], "]"}]], "Input",ExpressionUUI\
D->"d2b97670-72b4-4ff7-870e-51afdd10211c"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 2, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 2, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 3, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 3, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 3, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 4, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 4, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 4, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               FractionBox[
                RowBox[{"2", " ", 
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False]}], "-", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}], ")"}]}], 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "4"]],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}], 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "4"]]}]],
              
              Annotation[#, {1, 2, 1, 2} -> 
               2 $CellContext`Mass (
                 2 $CellContext`Mass - $CellContext`r[]) \
$CellContext`r[]^(-4), "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 1, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 1, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               FractionBox[
                RowBox[{"2", " ", 
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False]}], "-", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}], ")"}], " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "2"]}]],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], 
                  RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}]]}]],
              
              Annotation[#, {1, 2, 2, 1} -> 
               2 $CellContext`Mass (
                  2 $CellContext`Mass - $CellContext`r[])^(-1) \
$CellContext`r[]^(-2), "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 2, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 2, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 3, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 3, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 3, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 4, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 4, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 4, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 1, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               FractionBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False]}], "+", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}], ")"}]}], 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "4"]],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}], 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "4"]]}]],
              
              Annotation[#, {1, 3, 1, 
                3} -> $CellContext`Mass $CellContext`r[]^(-4) ((-2) \
$CellContext`Mass + $CellContext`r[]), "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 1, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 2, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 2, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               FractionBox[
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], 
                  InterpretationBox[
                   StyleBox[
                   "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`r[], Editable -> False]]}]],
              
              Annotation[#, {1, 3, 3, 
                1} -> $CellContext`Mass/$CellContext`r[], "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 3, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 3, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 4, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 4, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 4, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 1, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 1, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               FractionBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False]}], "+", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}], ")"}]}], 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "4"]],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}], 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "4"]]}]],
              
              Annotation[#, {1, 4, 1, 
                4} -> $CellContext`Mass $CellContext`r[]^(-4) ((-2) \
$CellContext`Mass + $CellContext`r[]), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 2, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 2, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 3, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 3, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 3, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               FractionBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 SuperscriptBox[
                  RowBox[{
                   InterpretationBox[
                    StyleBox["Sin",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    Sin,
                    Editable->False], "[", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False], "]"}], "2"]}], 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Sin"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Sin, Editable -> False], "[", 
                    InterpretationBox[
                    StyleBox[
                    "\[Theta]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Theta][], Editable -> False], "]"}], 
                    "2"]}], 
                  InterpretationBox[
                   StyleBox[
                   "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`r[], Editable -> False]]}]],
              
              Annotation[#, {1, 4, 4, 
                1} -> $CellContext`Mass $CellContext`r[]^(-1) Sin[
                   $CellContext`\[Theta][]]^2, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 4, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 4, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}]},
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               FractionBox[
                RowBox[{"2", " ", 
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False]}], "+", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}], ")"}]}], 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "4"]],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}], 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "4"]]}]],
              
              Annotation[#, {2, 1, 1, 2} -> 
               2 $CellContext`Mass $CellContext`r[]^(-4) ((-2) \
$CellContext`Mass + $CellContext`r[]), "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 1, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 1, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                FractionBox[
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Mass,
                   Editable->False]}], 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False]}], "-", 
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}], ")"}], " ", 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}]]}]}]],
              
              Annotation[#, {2, 1, 2, 
                1} -> (-2) $CellContext`Mass (
                  2 $CellContext`Mass - $CellContext`r[])^(-1) \
$CellContext`r[]^(-2), "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 2, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 2, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 3, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 3, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 3, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 4, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 4, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 4, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 1, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 1, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 1, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 2, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 2, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 3, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 3, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 3, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 4, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 4, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 4, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 1, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 1, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 1, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               FractionBox[
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False]}], "-", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}], ")"}], " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "2"]}]],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], 
                  RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}]]}]],
              
              Annotation[#, {2, 3, 2, 
                3} -> $CellContext`Mass (
                  2 $CellContext`Mass - $CellContext`r[])^(-1) \
$CellContext`r[]^(-2), "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 2, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 3, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               FractionBox[
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], 
                  InterpretationBox[
                   StyleBox[
                   "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`r[], Editable -> False]]}]],
              
              Annotation[#, {2, 3, 3, 
                2} -> $CellContext`Mass/$CellContext`r[], "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 3, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 4, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 4, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 4, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 1, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 1, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 1, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 2, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               FractionBox[
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False]}], "-", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}], ")"}], " ", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "2"]}]],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], 
                  RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}]]}]],
              
              Annotation[#, {2, 4, 2, 
                4} -> $CellContext`Mass (
                  2 $CellContext`Mass - $CellContext`r[])^(-1) \
$CellContext`r[]^(-2), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 3, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 3, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 3, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 4, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               FractionBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 SuperscriptBox[
                  RowBox[{
                   InterpretationBox[
                    StyleBox["Sin",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    Sin,
                    Editable->False], "[", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False], "]"}], "2"]}], 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Sin"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Sin, Editable -> False], "[", 
                    InterpretationBox[
                    StyleBox[
                    "\[Theta]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Theta][], Editable -> False], "]"}], 
                    "2"]}], 
                  InterpretationBox[
                   StyleBox[
                   "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`r[], Editable -> False]]}]],
              
              Annotation[#, {2, 4, 4, 
                2} -> $CellContext`Mass $CellContext`r[]^(-1) Sin[
                   $CellContext`\[Theta][]]^2, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 4, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}]},
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 1, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               FractionBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False]}], "-", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}], ")"}]}], 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "4"]],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}], 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "4"]]}]],
              
              Annotation[#, {3, 1, 1, 
                3} -> $CellContext`Mass (
                 2 $CellContext`Mass - $CellContext`r[]) \
$CellContext`r[]^(-4), "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 1, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 2, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 2, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                FractionBox[
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]]}]}]],
              
              Annotation[#, {3, 1, 3, 
                1} -> -$CellContext`Mass/$CellContext`r[], "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 3, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 3, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 4, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 4, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 4, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 1, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 1, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 1, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                FractionBox[
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False]}], "-", 
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}], ")"}], " ", 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}]]}]}]],
              
              Annotation[#, {3, 2, 2, 
                3} -> -$CellContext`Mass (
                  2 $CellContext`Mass - $CellContext`r[])^(-1) \
$CellContext`r[]^(-2), "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 2, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 3, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                FractionBox[
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]]}]}]],
              
              Annotation[#, {3, 2, 3, 
                2} -> -$CellContext`Mass/$CellContext`r[], "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 3, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 4, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 4, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 4, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 1, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 1, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 1, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 2, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 2, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 3, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 3, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 3, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 4, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 4, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 4, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 4, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 4, 1, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 4, 1, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 4, 1, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 4, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 4, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 4, 2, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 4, 2, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 4, 3, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 4, 3, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 4, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               FractionBox[
                RowBox[{"2", " ", 
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False]}], 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], 
                  InterpretationBox[
                   StyleBox[
                   "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`r[], Editable -> False]]}]],
              
              Annotation[#, {3, 4, 3, 4} -> 
               2 $CellContext`Mass/$CellContext`r[], "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 4, 4, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 4, 4, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                FractionBox[
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Mass,
                   Editable->False], " ", 
                  SuperscriptBox[
                   RowBox[{
                    InterpretationBox[
                    StyleBox["Sin",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    Sin,
                    Editable->False], "[", 
                    InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False], "]"}], "2"]}], 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Sin"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Sin, Editable -> False], "[", 
                    InterpretationBox[
                    StyleBox[
                    "\[Theta]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Theta][], Editable -> False], "]"}], 
                    "2"]}], 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]]}]}]],
              
              Annotation[#, {3, 4, 4, 
                3} -> (-2) $CellContext`Mass $CellContext`r[]^(-1) Sin[
                   $CellContext`\[Theta][]]^2, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 4, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}]},
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 1, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 1, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               FractionBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False]}], "-", 
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}], ")"}]}], 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "4"]],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}], 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "4"]]}]],
              
              Annotation[#, {4, 1, 1, 
                4} -> $CellContext`Mass (
                 2 $CellContext`Mass - $CellContext`r[]) \
$CellContext`r[]^(-4), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 2, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 2, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 3, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 3, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 3, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                FractionBox[
                 RowBox[{
                  InterpretationBox[
                   StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Mass,
                   Editable->False], " ", 
                  SuperscriptBox[
                   RowBox[{
                    InterpretationBox[
                    StyleBox["Sin",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    Sin,
                    Editable->False], "[", 
                    InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False], "]"}], "2"]}], 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Sin"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Sin, Editable -> False], "[", 
                    InterpretationBox[
                    StyleBox[
                    "\[Theta]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Theta][], Editable -> False], "]"}], 
                    "2"]}], 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]]}]}]],
              
              Annotation[#, {4, 1, 4, 
                1} -> -$CellContext`Mass $CellContext`r[]^(-1) Sin[
                   $CellContext`\[Theta][]]^2, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 4, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 4, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 2, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 2, 1, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 2, 1, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 2, 1, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 2, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 2, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 2, 2, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                FractionBox[
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`Mass,
                    Editable->False]}], "-", 
                    InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False]}], ")"}], " ", 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`r[],
                    Editable->False], "2"]}]]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}]]}]}]],
              
              Annotation[#, {4, 2, 2, 
                4} -> -$CellContext`Mass (
                  2 $CellContext`Mass - $CellContext`r[])^(-1) \
$CellContext`r[]^(-2), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 2, 3, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 2, 3, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 2, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 2, 3, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 2, 4, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                FractionBox[
                 RowBox[{
                  InterpretationBox[
                   StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Mass,
                   Editable->False], " ", 
                  SuperscriptBox[
                   RowBox[{
                    InterpretationBox[
                    StyleBox["Sin",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    Sin,
                    Editable->False], "[", 
                    InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False], "]"}], "2"]}], 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Sin"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Sin, Editable -> False], "[", 
                    InterpretationBox[
                    StyleBox[
                    "\[Theta]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Theta][], Editable -> False], "]"}], 
                    "2"]}], 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]]}]}]],
              
              Annotation[#, {4, 2, 4, 
                2} -> -$CellContext`Mass $CellContext`r[]^(-1) Sin[
                   $CellContext`\[Theta][]]^2, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 2, 4, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 2, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 3, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 3, 1, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 3, 1, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 3, 1, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 3, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 3, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 3, 2, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 3, 2, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 3, 3, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 3, 3, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 3, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                FractionBox[
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Mass,
                   Editable->False]}], 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]]}]}]],
              
              Annotation[#, {4, 3, 3, 
                4} -> (-2) $CellContext`Mass/$CellContext`r[], 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 3, 4, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 3, 4, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               FractionBox[
                RowBox[{"2", " ", 
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], " ", 
                 SuperscriptBox[
                  RowBox[{
                   InterpretationBox[
                    StyleBox["Sin",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    Sin,
                    Editable->False], "[", 
                   InterpretationBox[
                    StyleBox["\[Theta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Theta][],
                    Editable->False], "]"}], "2"]}], 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Sin"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Sin, Editable -> False], "[", 
                    InterpretationBox[
                    StyleBox[
                    "\[Theta]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Theta][], Editable -> False], "]"}], 
                    "2"]}], 
                  InterpretationBox[
                   StyleBox[
                   "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`r[], Editable -> False]]}]],
              
              Annotation[#, {4, 3, 4, 3} -> 
               2 $CellContext`Mass $CellContext`r[]^(-1) Sin[
                   $CellContext`\[Theta][]]^2, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 3, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 1, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 1, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 1, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 2, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 2, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 3, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 3, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 3, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 4, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 4, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 4, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {" ", " ", " ", "\[Delta]"},
         {"\[Alpha]", "\[Beta]", "\[Gamma]", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{{{0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 
     0}}, {{0, 
       2 $CellContext`Mass (
        2 $CellContext`Mass - $CellContext`r[]) $CellContext`r[]^(-4), 0, 
       0}, {2 $CellContext`Mass (
         2 $CellContext`Mass - $CellContext`r[])^(-1) $CellContext`r[]^(-2), 
       0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}}, {{
      0, 0, $CellContext`Mass $CellContext`r[]^(-4) ((-2) $CellContext`Mass + \
$CellContext`r[]), 0}, {0, 0, 0, 
      0}, {$CellContext`Mass/$CellContext`r[], 0, 0, 0}, {0, 0, 0, 0}}, {{
      0, 0, 0, $CellContext`Mass $CellContext`r[]^(-4) ((-2) \
$CellContext`Mass + $CellContext`r[])}, {0, 0, 0, 0}, {0, 0, 0, 
      0}, {$CellContext`Mass $CellContext`r[]^(-1) Sin[
          $CellContext`\[Theta][]]^2, 0, 0, 0}}}, {{{
      0, 2 $CellContext`Mass $CellContext`r[]^(-4) ((-2) $CellContext`Mass + \
$CellContext`r[]), 0, 
       0}, {(-2) $CellContext`Mass (
         2 $CellContext`Mass - $CellContext`r[])^(-1) $CellContext`r[]^(-2), 
       0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}}, {{0, 0, 0, 0}, {0, 0, 0, 0}, {0,
      0, 0, 0}, {0, 0, 0, 
     0}}, {{0, 0, 0, 0}, {
      0, 0, $CellContext`Mass (
         2 $CellContext`Mass - $CellContext`r[])^(-1) $CellContext`r[]^(-2), 
       0}, {0, $CellContext`Mass/$CellContext`r[], 0, 0}, {0, 0, 0, 0}}, {{0, 
      0, 0, 0}, {
      0, 0, 0, $CellContext`Mass (
         2 $CellContext`Mass - $CellContext`r[])^(-1) $CellContext`r[]^(-2)}, \
{0, 0, 0, 0}, {0, $CellContext`Mass $CellContext`r[]^(-1) Sin[
          $CellContext`\[Theta][]]^2, 0, 0}}}, {{{
      0, 0, $CellContext`Mass (
        2 $CellContext`Mass - $CellContext`r[]) $CellContext`r[]^(-4), 0}, {0,
       0, 0, 0}, {-$CellContext`Mass/$CellContext`r[], 0, 0, 0}, {0, 0, 0, 
      0}}, {{0, 0, 0, 0}, {
      0, 0, -$CellContext`Mass (
         2 $CellContext`Mass - $CellContext`r[])^(-1) $CellContext`r[]^(-2), 
       0}, {0, -$CellContext`Mass/$CellContext`r[], 0, 0}, {0, 0, 0, 0}}, {{0,
      0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 
     0}}, {{0, 0, 0, 0}, {0, 0, 0, 0}, {
      0, 0, 0, 2 $CellContext`Mass/$CellContext`r[]}, {
      0, 0, (-2) $CellContext`Mass $CellContext`r[]^(-1) Sin[
          $CellContext`\[Theta][]]^2, 0}}}, {{{
      0, 0, 0, $CellContext`Mass (
        2 $CellContext`Mass - $CellContext`r[]) $CellContext`r[]^(-4)}, {0, 0,
       0, 0}, {0, 0, 0, 0}, {-$CellContext`Mass $CellContext`r[]^(-1) Sin[
          $CellContext`\[Theta][]]^2, 0, 0, 0}}, {{0, 0, 0, 0}, {
      0, 0, 0, -$CellContext`Mass (
         2 $CellContext`Mass - $CellContext`r[])^(-1) $CellContext`r[]^(-2)}, \
{0, 0, 0, 0}, {0, -$CellContext`Mass $CellContext`r[]^(-1) Sin[
          $CellContext`\[Theta][]]^2, 0, 0}}, {{0, 0, 0, 0}, {0, 0, 0, 0}, {
      0, 0, 0, (-2) $CellContext`Mass/$CellContext`r[]}, {
      0, 0, 2 $CellContext`Mass $CellContext`r[]^(-1) Sin[
          $CellContext`\[Theta][]]^2, 0}}, {{0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0,
      0, 0}, {0, 0, 0, 
     0}}}}, {-$CellContext`schw, -$CellContext`schw, -$CellContext`schw, \
$CellContext`schw}, 
   0][-$CellContext`\[Alpha], -$CellContext`\[Beta], -$CellContext`\[Gamma], \
$CellContext`\[Delta]],
  Editable->False]], "Output",ExpressionUUID->"4c7399cb-7c63-4ad3-909f-\
d0cb9fc03b83"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"riemF", "=", 
    RowBox[{"Simplify", "@", 
     RowBox[{"Riemann", "[", "cdF", "]"}]}]}], ")"}], "[", 
  RowBox[{
   RowBox[{"-", "\[Alpha]"}], ",", 
   RowBox[{"-", "\[Beta]"}], ",", 
   RowBox[{"-", "\[Gamma]"}], ",", "\[Delta]"}], "]"}]], "Input",ExpressionUUI\
D->"6452f850-f6ef-41e9-9185-b84da4c140af"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 2, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 2, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 3, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 3, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 3, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 4, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 4, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 4, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                FractionBox[
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Mass,
                   Editable->False]}], 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "3"]]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "3"]]}]}]],
              
              Annotation[#, {1, 2, 1, 
                2} -> (-2) $CellContext`Mass $CellContext`r[]^(-3), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 1, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 1, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                FractionBox[
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Mass,
                   Editable->False]}], 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "3"]]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "3"]]}]}]],
              
              Annotation[#, {1, 2, 2, 
                1} -> (-2) $CellContext`Mass $CellContext`r[]^(-3), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 2, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 2, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 3, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 3, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 3, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 4, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 4, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 4, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 1, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               FractionBox[
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "3"]],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "3"]]}]],
              
              Annotation[#, {1, 3, 1, 
                3} -> $CellContext`Mass $CellContext`r[]^(-3), "Tooltip"]& ], 
             
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 1, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 2, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 2, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               FractionBox[
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "3"]],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "3"]]}]],
              
              Annotation[#, {1, 3, 3, 
                1} -> $CellContext`Mass $CellContext`r[]^(-3), "Tooltip"]& ], 
             
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 3, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 3, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 4, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 4, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 4, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 1, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 1, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               FractionBox[
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "3"]],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "3"]]}]],
              
              Annotation[#, {1, 4, 1, 
                4} -> $CellContext`Mass $CellContext`r[]^(-3), 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 2, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 2, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 3, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 3, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 3, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               FractionBox[
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "3"]],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "3"]]}]],
              
              Annotation[#, {1, 4, 4, 
                1} -> $CellContext`Mass $CellContext`r[]^(-3), "Tooltip"]& ], 
             
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 4, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 4, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}}]},
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               FractionBox[
                RowBox[{"2", " ", 
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False]}], 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "3"]],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "3"]]}]],
              
              Annotation[#, {2, 1, 1, 2} -> 
               2 $CellContext`Mass $CellContext`r[]^(-3), "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 1, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 1, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               FractionBox[
                RowBox[{"2", " ", 
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False]}], 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "3"]],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "3"]]}]],
              
              Annotation[#, {2, 1, 2, 1} -> 
               2 $CellContext`Mass $CellContext`r[]^(-3), "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 2, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 2, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 3, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 3, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 3, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 4, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 4, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 4, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 1, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 1, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 1, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 2, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 2, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 3, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 3, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 3, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 4, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 4, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 4, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 1, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 1, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 1, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                FractionBox[
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "3"]]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "3"]]}]}]],
              
              Annotation[#, {2, 3, 2, 
                3} -> -$CellContext`Mass $CellContext`r[]^(-3), "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 2, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 3, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               FractionBox[
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "3"]],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "3"]]}]],
              
              Annotation[#, {2, 3, 3, 
                2} -> $CellContext`Mass $CellContext`r[]^(-3), "Tooltip"]& ], 
             
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 3, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 4, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 4, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 4, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 1, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 1, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 1, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 2, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                FractionBox[
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "3"]]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "3"]]}]}]],
              
              Annotation[#, {2, 4, 2, 
                4} -> -$CellContext`Mass $CellContext`r[]^(-3), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 3, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 3, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 3, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 4, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               FractionBox[
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "3"]],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "3"]]}]],
              
              Annotation[#, {2, 4, 4, 
                2} -> $CellContext`Mass $CellContext`r[]^(-3), "Tooltip"]& ], 
             
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 4, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}}]},
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 1, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                FractionBox[
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "3"]]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "3"]]}]}]],
              
              Annotation[#, {3, 1, 1, 
                3} -> -$CellContext`Mass $CellContext`r[]^(-3), "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 1, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 2, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 2, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                FractionBox[
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "3"]]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "3"]]}]}]],
              
              Annotation[#, {3, 1, 3, 
                1} -> -$CellContext`Mass $CellContext`r[]^(-3), "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 3, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 3, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 4, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 4, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 4, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 1, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 1, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 1, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               FractionBox[
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "3"]],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "3"]]}]],
              
              Annotation[#, {3, 2, 2, 
                3} -> $CellContext`Mass $CellContext`r[]^(-3), "Tooltip"]& ], 
             
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 2, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 3, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                FractionBox[
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "3"]]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "3"]]}]}]],
              
              Annotation[#, {3, 2, 3, 
                2} -> -$CellContext`Mass $CellContext`r[]^(-3), "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 3, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 4, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 4, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 4, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 1, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 1, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 1, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 2, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 2, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 3, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 3, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 3, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 4, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 4, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 4, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 4, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 4, 1, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 4, 1, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 4, 1, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 4, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 4, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 4, 2, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 4, 2, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 4, 3, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 4, 3, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 4, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               FractionBox[
                RowBox[{"2", " ", 
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False]}], 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "3"]],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "3"]]}]],
              
              Annotation[#, {3, 4, 3, 4} -> 
               2 $CellContext`Mass $CellContext`r[]^(-3), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 4, 4, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 4, 4, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                FractionBox[
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Mass,
                   Editable->False]}], 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "3"]]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "3"]]}]}]],
              
              Annotation[#, {3, 4, 4, 
                3} -> (-2) $CellContext`Mass $CellContext`r[]^(-3), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 4, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}}]},
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 1, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 1, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                FractionBox[
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "3"]]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "3"]]}]}]],
              
              Annotation[#, {4, 1, 1, 
                4} -> -$CellContext`Mass $CellContext`r[]^(-3), "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 2, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 2, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 3, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 3, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 3, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                FractionBox[
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "3"]]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "3"]]}]}]],
              
              Annotation[#, {4, 1, 4, 
                1} -> -$CellContext`Mass $CellContext`r[]^(-3), "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 4, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 4, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 2, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 2, 1, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 2, 1, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 2, 1, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 2, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 2, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 2, 2, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               FractionBox[
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False], 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "3"]],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "3"]]}]],
              
              Annotation[#, {4, 2, 2, 
                4} -> $CellContext`Mass $CellContext`r[]^(-3), 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 2, 3, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 2, 3, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 2, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 2, 3, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 2, 4, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                FractionBox[
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False], 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "3"]]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False], 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "3"]]}]}]],
              
              Annotation[#, {4, 2, 4, 
                2} -> -$CellContext`Mass $CellContext`r[]^(-3), "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 2, 4, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 2, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 3, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 3, 1, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 3, 1, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 3, 1, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 3, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 3, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 3, 2, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 3, 2, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 3, 3, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 3, 3, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 3, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               RowBox[{"-", 
                FractionBox[
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`Mass,
                   Editable->False]}], 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox["r",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`r[],
                   Editable->False], "3"]]}],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "3"]]}]}]],
              
              Annotation[#, {4, 3, 3, 
                4} -> (-2) $CellContext`Mass $CellContext`r[]^(-3), 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 3, 4, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 3, 4, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox[
               FractionBox[
                RowBox[{"2", " ", 
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False]}], 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False], "3"]],
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`Mass, Editable -> False]}], 
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "3"]]}]],
              
              Annotation[#, {4, 3, 4, 3} -> 
               2 $CellContext`Mass $CellContext`r[]^(-3), "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 3, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 1, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 1, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 1, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 2, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 2, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 3, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 3, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 3, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 4, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 4, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 4, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}}]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]},
           "RowsIndexed" -> {1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {" ", " ", " ", "\[Delta]"},
         {"\[Alpha]", "\[Beta]", "\[Gamma]", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{{{0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 
     0}}, {{0, (-2) $CellContext`Mass $CellContext`r[]^(-3), 0, 
       0}, {(-2) $CellContext`Mass $CellContext`r[]^(-3), 0, 0, 0}, {0, 0, 0, 
      0}, {0, 0, 0, 0}}, {{
      0, 0, $CellContext`Mass $CellContext`r[]^(-3), 0}, {0, 0, 0, 
      0}, {$CellContext`Mass $CellContext`r[]^(-3), 0, 0, 0}, {0, 0, 0, 
      0}}, {{0, 0, 0, $CellContext`Mass $CellContext`r[]^(-3)}, {0, 0, 0, 
      0}, {0, 0, 0, 
      0}, {$CellContext`Mass $CellContext`r[]^(-3), 0, 0, 0}}}, {{{
      0, 2 $CellContext`Mass $CellContext`r[]^(-3), 0, 0}, {
      2 $CellContext`Mass $CellContext`r[]^(-3), 0, 0, 0}, {0, 0, 0, 0}, {0, 
      0, 0, 0}}, {{0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 
     0}}, {{0, 0, 0, 0}, {
      0, 0, -$CellContext`Mass $CellContext`r[]^(-3), 0}, {
      0, $CellContext`Mass $CellContext`r[]^(-3), 0, 0}, {0, 0, 0, 0}}, {{0, 
      0, 0, 0}, {0, 0, 0, -$CellContext`Mass $CellContext`r[]^(-3)}, {0, 0, 0,
       0}, {0, $CellContext`Mass $CellContext`r[]^(-3), 0, 0}}}, {{{
      0, 0, -$CellContext`Mass $CellContext`r[]^(-3), 0}, {0, 0, 0, 
      0}, {-$CellContext`Mass $CellContext`r[]^(-3), 0, 0, 0}, {0, 0, 0, 
      0}}, {{0, 0, 0, 0}, {
      0, 0, $CellContext`Mass $CellContext`r[]^(-3), 0}, {
      0, -$CellContext`Mass $CellContext`r[]^(-3), 0, 0}, {0, 0, 0, 0}}, {{0, 
     0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 
     0}}, {{0, 0, 0, 0}, {0, 0, 0, 0}, {
      0, 0, 0, 2 $CellContext`Mass $CellContext`r[]^(-3)}, {
      0, 0, (-2) $CellContext`Mass $CellContext`r[]^(-3), 0}}}, {{{
      0, 0, 0, -$CellContext`Mass $CellContext`r[]^(-3)}, {0, 0, 0, 0}, {0, 0,
       0, 0}, {-$CellContext`Mass $CellContext`r[]^(-3), 0, 0, 0}}, {{0, 0, 0,
       0}, {0, 0, 0, $CellContext`Mass $CellContext`r[]^(-3)}, {0, 0, 0, 0}, {
      0, -$CellContext`Mass $CellContext`r[]^(-3), 0, 0}}, {{0, 0, 0, 0}, {0, 
      0, 0, 0}, {0, 0, 0, (-2) $CellContext`Mass $CellContext`r[]^(-3)}, {
      0, 0, 2 $CellContext`Mass $CellContext`r[]^(-3), 0}}, {{0, 0, 0, 0}, {0,
      0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 
     0}}}}, {-$CellContext`frame, -$CellContext`frame, -$CellContext`frame, \
$CellContext`frame}, 
   0][-$CellContext`\[Alpha], -$CellContext`\[Beta], -$CellContext`\[Gamma], \
$CellContext`\[Delta]],
  Editable->False]], "Output",ExpressionUUID->"c286f32b-1f4b-41f6-8d2d-\
f79fc2d51c24"]
}, Open  ]],

Cell["They are the same tensor, modulo a change of basis:", "Text",ExpressionUUID->"18fb2c87-daff-4421-9d96-3d935324191a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ToCTensor", "[", 
   RowBox[{"riem", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "frame"}], ",", 
      RowBox[{"-", "frame"}], ",", 
      RowBox[{"-", "frame"}], ",", "frame"}], "}"}]}], "]"}], "==", 
  "riemF"}]], "Input",ExpressionUUID->"faf3eb61-6ccb-4506-adfd-9b12a5a0b0ed"],

Cell[BoxData["True"], "Output",ExpressionUUID->"caeac4bc-82d0-4792-887d-e6a9fdf3dd6b"]
}, Open  ]],

Cell["Ricci tensors:", "Text",ExpressionUUID->"ec143c67-1953-47b0-b09d-e93d4cdfb68b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Ricci", "[", "cd", "]"}]], "Input",ExpressionUUID->"0caf8af4-b32a-4522-93a3-c6468301830b"],

Cell[BoxData["Zero"], "Output",ExpressionUUID->"3f50d0bd-7490-426c-bf01-e1b2808c0a28"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Ricci", "[", "cdF", "]"}], "//", "Simplify"}]], "Input",ExpressionU\
UID->"a64b1edc-e304-475b-863d-7b74ee069f4f"],

Cell[BoxData["Zero"], "Output",ExpressionUUID->"071ca77c-302c-4160-a628-d6d110d6e1d5"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"UndefBasis", "[", "frame", "]"}]], "Input",ExpressionUUID->"a79ebafe-661a-48b0-ab35-5008166fa80b"],

Cell[BoxData[
 RowBox[{"UndefChart", "[", "schw", "]"}]], "Input",ExpressionUUID->"74094bf6-bdf7-4de9-8fb1-60fbb97fb50c"],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{
  "SchwarzschildMatrix", ",", "cd", ",", "cdF", ",", "metric", ",", "metricF",
    ",", "riem", ",", "riemF"}], "]"}]], "Input",ExpressionUUID->"d8938b7a-\
29d6-4293-a221-e379bbf22f3e"],

Cell[BoxData[
 RowBox[{"UndefConstantSymbol", "[", "Mass", "]"}]], "Input",ExpressionUUID->"aee87853-dd8d-4ee8-b1f5-6437c1b543b3"],

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M4", "]"}]], "Input",ExpressionUUID->"e45ac56d-d1bb-4cf3-876d-e23288467604"],

Cell[BoxData[
 RowBox[{"ClearxCobaCache", "[", "All", "]"}]], "Input",ExpressionUUID->"bb0c74e8-08b4-402f-bc1e-982492e78c8b"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["5. Examples comparing with RGTC, by Bonanos", "Subsection",ExpressionUUID->"f5bde83d-e9f5-4ba1-bced-fdbba5356522"],

Cell[TextData[{
 "In order to understand why we do what we do you need to read Bonanos\
\[CloseCurlyQuote] examples in the documentation of RGTC [",
 ButtonBox["link",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.inp.demokritos.gr/~sbonano/"], None},
  ButtonNote->"http://www.inp.demokritos.gr/~sbonano/"],
 "]."
}], "Text",ExpressionUUID->"73c4ef54-09b5-40d7-82bc-a9cbb3c8bd49"],

Cell[CellGroupData[{

Cell["5.0. Load xCoba", "Subsubsection",ExpressionUUID->"d4936e9b-37eb-4f2d-9bfd-438f5312488e"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<xAct`xCoba`\>\"", "]"}]], "Input",ExpressionUUID->"7eed4aa0-b100-422e-b9f4-5e1eb0fb267e"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"$DefInfoQ", "=", 
   RowBox[{"$UndefInfoQ", "=", "False"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"$PrePrint", "=", "ScreenDollarIndices"}], ";"}]}], "Input",Expressi\
onUUID->"9ff361b6-b92b-4812-bbe5-bc420b6ecce7"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
5.1. Flat spacetime in rotating prolate spheroidal coordinates\
\>", "Subsubsection",ExpressionUUID->"a796ae1d-021b-4f3c-b150-d23c08be16d3"],

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M", ",", "4", ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"47b8db42-7f2b-462a-9aca-4908dd1a7c2d"],

Cell[BoxData[
 RowBox[{"DefChart", "[", 
  RowBox[{"rps", ",", "M", ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"t", "[", "]"}], ",", 
     RowBox[{"\[Phi]", "[", "]"}], ",", 
     RowBox[{"\[Lambda]", "[", "]"}], ",", 
     RowBox[{"\[Mu]", "[", "]"}]}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"ffc67f63-116a-439f-9c19-97db4f8ab8e5"],

Cell[BoxData[
 RowBox[{"DefConstantSymbol", "[", "\[CapitalOmega]", "]"}]], "Input",Expressi\
onUUID->"dc18ca2c-74c6-4e02-988c-5a152b50a515"],

Cell[BoxData[
 RowBox[{
  RowBox[{"met", "=", 
   RowBox[{"CTensor", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"1", "-", 
          RowBox[{
           RowBox[{"\[CapitalOmega]", "^", "2"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"\[Lambda]", "[", "]"}], "^", "2"}], "-", "1"}], ")"}], 
           
           RowBox[{"(", 
            RowBox[{"1", "-", 
             RowBox[{
              RowBox[{"\[Mu]", "[", "]"}], "^", "2"}]}], ")"}]}]}], ",", 
         RowBox[{
          RowBox[{"-", "\[CapitalOmega]"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"\[Lambda]", "[", "]"}], "^", "2"}], "-", "1"}], ")"}], 
          RowBox[{"(", 
           RowBox[{"1", "-", 
            RowBox[{
             RowBox[{"\[Mu]", "[", "]"}], "^", "2"}]}], ")"}]}], ",", "0", 
         ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "\[CapitalOmega]"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"\[Lambda]", "[", "]"}], "^", "2"}], "-", "1"}], ")"}], 
          RowBox[{"(", 
           RowBox[{"1", "-", 
            RowBox[{
             RowBox[{"\[Mu]", "[", "]"}], "^", "2"}]}], ")"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"\[Lambda]", "[", "]"}], "^", "2"}], "-", "1"}], 
            ")"}]}], 
          RowBox[{"(", 
           RowBox[{"1", "-", 
            RowBox[{
             RowBox[{"\[Mu]", "[", "]"}], "^", "2"}]}], ")"}]}], ",", "0", 
         ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", 
         RowBox[{
          RowBox[{"-", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"\[Lambda]", "[", "]"}], "^", "2"}], "-", 
             RowBox[{
              RowBox[{"\[Mu]", "[", "]"}], "^", "2"}]}], ")"}]}], "/", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"\[Lambda]", "[", "]"}], "^", "2"}], "-", "1"}], ")"}]}],
          ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", 
         RowBox[{
          RowBox[{"-", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"\[Lambda]", "[", "]"}], "^", "2"}], "-", 
             RowBox[{
              RowBox[{"\[Mu]", "[", "]"}], "^", "2"}]}], ")"}]}], "/", 
          RowBox[{"(", 
           RowBox[{"1", "-", 
            RowBox[{
             RowBox[{"\[Mu]", "[", "]"}], "^", "2"}]}], ")"}]}]}], "}"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "rps"}], ",", 
       RowBox[{"-", "rps"}]}], "}"}]}], "]"}]}], ";"}]], "Input",ExpressionUUI\
D->"2fa40ded-f328-4557-b0a6-49efa3d3f5d7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"met", "[", 
  RowBox[{
   RowBox[{"-", "a"}], ",", 
   RowBox[{"-", "b"}]}], "]"}]], "Input",ExpressionUUID->"2f5767a7-7d09-4ca6-\
a28b-abc00b4a8c20"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox[
            RowBox[{"1", "-", 
             RowBox[{
              SuperscriptBox[
               InterpretationBox[
                StyleBox["\[CapitalOmega]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[CapitalOmega],
                Editable->False], "2"], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "1"}], "+", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["\[Lambda]",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`\[Lambda][],
                  Editable->False], "2"]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["\[Mu]",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`\[Mu][],
                  Editable->False], "2"]}], ")"}]}]}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
              RowBox[{"1", "-", 
                RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalOmega]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalOmega], 
                    Editable -> False], "2"], " ", 
                  RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "\[Lambda]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Lambda][], Editable -> False], "2"]}], 
                    ")"}], " ", 
                  RowBox[{"(", 
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "\[Mu]", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`\[Mu][], Editable -> False], "2"]}], 
                    ")"}]}]}]}]],
           
           Annotation[#, {1, 1} -> 
            1 - $CellContext`\[CapitalOmega]^2 (-1 + \
$CellContext`\[Lambda][]^2) (1 - $CellContext`\[Mu][]^2), "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{
             RowBox[{"-", 
              InterpretationBox[
               StyleBox["\[CapitalOmega]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[CapitalOmega],
               Editable->False]}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["\[Lambda]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Lambda][],
                 Editable->False], "2"]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{"1", "-", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["\[Mu]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Mu][],
                 Editable->False], "2"]}], ")"}]}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
              RowBox[{
                RowBox[{"-", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"\[CapitalOmega]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalOmega], 
                   Editable -> False]}], " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "\[Lambda]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Lambda][], Editable -> False], "2"]}], 
                  ")"}], " ", 
                RowBox[{"(", 
                  RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "\[Mu]", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`\[Mu][], Editable -> False], "2"]}], 
                  ")"}]}]}]],
           
           Annotation[#, {1, 
             2} -> -$CellContext`\[CapitalOmega] (-1 + \
$CellContext`\[Lambda][]^2) (1 - $CellContext`\[Mu][]^2), "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 4} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox[
            RowBox[{
             RowBox[{"-", 
              InterpretationBox[
               StyleBox["\[CapitalOmega]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[CapitalOmega],
               Editable->False]}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["\[Lambda]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Lambda][],
                 Editable->False], "2"]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{"1", "-", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["\[Mu]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Mu][],
                 Editable->False], "2"]}], ")"}]}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
              RowBox[{
                RowBox[{"-", 
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"\[CapitalOmega]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalOmega], 
                   Editable -> False]}], " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "\[Lambda]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Lambda][], Editable -> False], "2"]}], 
                  ")"}], " ", 
                RowBox[{"(", 
                  RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "\[Mu]", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`\[Mu][], Editable -> False], "2"]}], 
                  ")"}]}]}]],
           
           Annotation[#, {2, 
             1} -> -$CellContext`\[CapitalOmega] (-1 + \
$CellContext`\[Lambda][]^2) (1 - $CellContext`\[Mu][]^2), "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{
             RowBox[{"(", 
              RowBox[{"1", "-", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["\[Lambda]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Lambda][],
                 Editable->False], "2"]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{"1", "-", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["\[Mu]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Mu][],
                 Editable->False], "2"]}], ")"}]}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
              RowBox[{
                RowBox[{"(", 
                  RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "\[Lambda]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Lambda][], Editable -> False], "2"]}], 
                  ")"}], " ", 
                RowBox[{"(", 
                  RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "\[Mu]", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`\[Mu][], Editable -> False], "2"]}], 
                  ")"}]}]}]],
           
           Annotation[#, {2, 
             2} -> (1 - $CellContext`\[Lambda][]^2) (
              1 - $CellContext`\[Mu][]^2), "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 4} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            FractionBox[
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["\[Lambda]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Lambda][],
                 Editable->False], "2"]}], "+", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["\[Mu]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Mu][],
                Editable->False], "2"]}], 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["\[Lambda]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Lambda][],
                Editable->False], "2"]}]],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "3"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 RowBox[{"-", 
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "\[Lambda]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Lambda][], Editable -> False], "2"]}], "+", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox[
                   "\[Mu]", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`\[Mu][], Editable -> False], "2"]}], 
               RowBox[{
                 RowBox[{"-", "1"}], "+", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox[
                   "\[Lambda]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                   $CellContext`\[Lambda][], Editable -> False], "2"]}]]}]],
           
           Annotation[#, {3, 
             3} -> (-1 + $CellContext`\[Lambda][]^2)^(-1) (-$CellContext`\
\[Lambda][]^2 + $CellContext`\[Mu][]^2), "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 4} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            FractionBox[
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["\[Lambda]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Lambda][],
                 Editable->False], "2"]}], "+", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["\[Mu]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Mu][],
                Editable->False], "2"]}], 
             RowBox[{"1", "-", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["\[Mu]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Mu][],
                Editable->False], "2"]}]],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "4"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 RowBox[{"-", 
                   SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "\[Lambda]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Lambda][], Editable -> False], "2"]}], "+", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox[
                   "\[Mu]", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`\[Mu][], Editable -> False], "2"]}], 
               RowBox[{"1", "-", 
                 SuperscriptBox[
                  InterpretationBox[
                   StyleBox[
                   "\[Mu]", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`\[Mu][], Editable -> False], "2"]}]]}]],
           
           Annotation[#, {4, 
             4} -> (1 - $CellContext`\[Mu][]^2)^(-1) \
(-$CellContext`\[Lambda][]^2 + $CellContext`\[Mu][]^2), "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {" ", " "},
         {"a", "b"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{
    1 - $CellContext`\[CapitalOmega]^2 (-1 + $CellContext`\[Lambda][]^2) (
      1 - $CellContext`\[Mu][]^2), -$CellContext`\[CapitalOmega] (-1 + \
$CellContext`\[Lambda][]^2) (1 - $CellContext`\[Mu][]^2), 0, 
     0}, {-$CellContext`\[CapitalOmega] (-1 + $CellContext`\[Lambda][]^2) (
      1 - $CellContext`\[Mu][]^2), (1 - $CellContext`\[Lambda][]^2) (
      1 - $CellContext`\[Mu][]^2), 0, 0}, {
    0, 0, (-1 + $CellContext`\[Lambda][]^2)^(-1) (-$CellContext`\[Lambda][]^2 + \
$CellContext`\[Mu][]^2), 0}, {
    0, 0, 0, (
       1 - $CellContext`\[Mu][]^2)^(-1) (-$CellContext`\[Lambda][]^2 + \
$CellContext`\[Mu][]^2)}}, {-$CellContext`rps, -$CellContext`rps}, 
   0][-$CellContext`a, -$CellContext`b],
  Editable->False]], "Output",ExpressionUUID->"b5b7d89c-1329-4a19-8580-\
12fe5935e453"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"$CVSimplify", "=", "Simplify"}], ";"}]], "Input",ExpressionUUID->\
"c40d8558-a06f-45c2-b9e6-09075f663c11"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"SetCMetric", "[", 
   RowBox[{"met", ",", "rps", ",", 
    RowBox[{"SignatureOfMetric", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"3", ",", "1", ",", "0"}], "}"}]}]}], "]"}], "//", 
  "Timing"}]], "Input",ExpressionUUID->"d8ec23cb-6bee-46e0-8896-ea44e42f9963"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.078721`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"3cbb436c-4b22-4a29-ad22-1dac135c3869"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MetricCompute", "[", 
   RowBox[{"met", ",", "rps", ",", 
    RowBox[{"\"\<Riemann\>\"", "[", 
     RowBox[{
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}]}], "]"}]}], "]"}], "//", "Timing"}]], "Input",Express\
ionUUID->"0faa346a-375e-42b4-98be-0725ba1f3dd8"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.032156`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"b41fbd6d-9c1a-4538-a7be-e94d1997a9eb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"cd", "=", 
  RowBox[{"CovDOfMetric", "[", "met", "]"}]}]], "Input",ExpressionUUID->\
"ae83065f-1435-41bd-917f-de2e2d6d70bb"],

Cell[BoxData[
 RowBox[{"CCovD", "[", 
  RowBox[{"PDrps", ",", 
   RowBox[{"CTensor", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", 
           FractionBox[
            RowBox[{
             InterpretationBox[
              StyleBox["\[CapitalOmega]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[CapitalOmega],
              Editable->False], " ", 
             InterpretationBox[
              StyleBox["\[Lambda]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Lambda][],
              Editable->False]}], 
            RowBox[{
             RowBox[{"-", "1"}], "+", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["\[Lambda]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Lambda][],
               Editable->False], "2"]}]], ",", 
           FractionBox[
            RowBox[{
             InterpretationBox[
              StyleBox["\[CapitalOmega]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[CapitalOmega],
              Editable->False], " ", 
             InterpretationBox[
              StyleBox["\[Mu]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Mu][],
              Editable->False]}], 
            RowBox[{
             RowBox[{"-", "1"}], "+", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["\[Mu]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Mu][],
               Editable->False], "2"]}]]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", 
           FractionBox[
            InterpretationBox[
             StyleBox["\[Lambda]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Lambda][],
             Editable->False], 
            RowBox[{
             RowBox[{"-", "1"}], "+", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["\[Lambda]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Lambda][],
               Editable->False], "2"]}]], ",", 
           FractionBox[
            InterpretationBox[
             StyleBox["\[Mu]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Mu][],
             Editable->False], 
            RowBox[{
             RowBox[{"-", "1"}], "+", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["\[Mu]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Mu][],
               Editable->False], "2"]}]]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            RowBox[{
             InterpretationBox[
              StyleBox["\[CapitalOmega]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[CapitalOmega],
              Editable->False], " ", 
             InterpretationBox[
              StyleBox["\[Lambda]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Lambda][],
              Editable->False]}], 
            RowBox[{
             RowBox[{"-", "1"}], "+", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["\[Lambda]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Lambda][],
               Editable->False], "2"]}]], ",", 
           FractionBox[
            InterpretationBox[
             StyleBox["\[Lambda]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Lambda][],
             Editable->False], 
            RowBox[{
             RowBox[{"-", "1"}], "+", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["\[Lambda]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Lambda][],
               Editable->False], "2"]}]], ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            RowBox[{
             InterpretationBox[
              StyleBox["\[CapitalOmega]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[CapitalOmega],
              Editable->False], " ", 
             InterpretationBox[
              StyleBox["\[Mu]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Mu][],
              Editable->False]}], 
            RowBox[{
             RowBox[{"-", "1"}], "+", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["\[Mu]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Mu][],
               Editable->False], "2"]}]], ",", 
           FractionBox[
            InterpretationBox[
             StyleBox["\[Mu]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Mu][],
             Editable->False], 
            RowBox[{
             RowBox[{"-", "1"}], "+", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["\[Mu]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Mu][],
               Editable->False], "2"]}]], ",", "0", ",", "0"}], "}"}]}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            RowBox[{
             SuperscriptBox[
              InterpretationBox[
               StyleBox["\[CapitalOmega]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[CapitalOmega],
               Editable->False], "2"], " ", 
             InterpretationBox[
              StyleBox["\[Lambda]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Lambda][],
              Editable->False], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["\[Lambda]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Lambda][],
                 Editable->False], "2"]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["\[Mu]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Mu][],
                 Editable->False], "2"]}], ")"}]}], 
            RowBox[{
             SuperscriptBox[
              InterpretationBox[
               StyleBox["\[Lambda]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Lambda][],
               Editable->False], "2"], "-", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["\[Mu]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Mu][],
               Editable->False], "2"]}]], ",", 
           FractionBox[
            RowBox[{
             InterpretationBox[
              StyleBox["\[CapitalOmega]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[CapitalOmega],
              Editable->False], " ", 
             InterpretationBox[
              StyleBox["\[Lambda]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Lambda][],
              Editable->False], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["\[Lambda]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Lambda][],
                 Editable->False], "2"]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["\[Mu]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Mu][],
                 Editable->False], "2"]}], ")"}]}], 
            RowBox[{
             SuperscriptBox[
              InterpretationBox[
               StyleBox["\[Lambda]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Lambda][],
               Editable->False], "2"], "-", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["\[Mu]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Mu][],
               Editable->False], "2"]}]], ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            RowBox[{
             InterpretationBox[
              StyleBox["\[CapitalOmega]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[CapitalOmega],
              Editable->False], " ", 
             InterpretationBox[
              StyleBox["\[Lambda]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Lambda][],
              Editable->False], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["\[Lambda]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Lambda][],
                 Editable->False], "2"]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["\[Mu]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Mu][],
                 Editable->False], "2"]}], ")"}]}], 
            RowBox[{
             SuperscriptBox[
              InterpretationBox[
               StyleBox["\[Lambda]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Lambda][],
               Editable->False], "2"], "-", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["\[Mu]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Mu][],
               Editable->False], "2"]}]], ",", 
           FractionBox[
            RowBox[{
             InterpretationBox[
              StyleBox["\[Lambda]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Lambda][],
              Editable->False], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["\[Lambda]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Lambda][],
                 Editable->False], "2"]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["\[Mu]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Mu][],
                 Editable->False], "2"]}], ")"}]}], 
            RowBox[{
             SuperscriptBox[
              InterpretationBox[
               StyleBox["\[Lambda]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Lambda][],
               Editable->False], "2"], "-", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["\[Mu]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Mu][],
               Editable->False], "2"]}]], ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", 
           FractionBox[
            RowBox[{
             InterpretationBox[
              StyleBox["\[Lambda]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Lambda][],
              Editable->False], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["\[Mu]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Mu][],
                 Editable->False], "2"]}], ")"}]}], 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["\[Lambda]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Lambda][],
                 Editable->False], "2"]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["\[Lambda]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Lambda][],
                 Editable->False], "2"], "-", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["\[Mu]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Mu][],
                 Editable->False], "2"]}], ")"}]}]], ",", 
           FractionBox[
            InterpretationBox[
             StyleBox["\[Mu]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Mu][],
             Editable->False], 
            RowBox[{
             RowBox[{"-", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["\[Lambda]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Lambda][],
                Editable->False], "2"]}], "+", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["\[Mu]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Mu][],
               Editable->False], "2"]}]]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", 
           FractionBox[
            InterpretationBox[
             StyleBox["\[Mu]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Mu][],
             Editable->False], 
            RowBox[{
             RowBox[{"-", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["\[Lambda]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Lambda][],
                Editable->False], "2"]}], "+", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["\[Mu]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Mu][],
               Editable->False], "2"]}]], ",", 
           FractionBox[
            RowBox[{
             InterpretationBox[
              StyleBox["\[Lambda]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Lambda][],
              Editable->False], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["\[Lambda]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Lambda][],
                 Editable->False], "2"]}], ")"}]}], 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["\[Lambda]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Lambda][],
                 Editable->False], "2"], "-", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["\[Mu]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Mu][],
                 Editable->False], "2"]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["\[Mu]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Mu][],
                 Editable->False], "2"]}], ")"}]}]]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             RowBox[{
              SuperscriptBox[
               InterpretationBox[
                StyleBox["\[CapitalOmega]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[CapitalOmega],
                Editable->False], "2"], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "1"}], "+", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["\[Lambda]",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`\[Lambda][],
                  Editable->False], "2"]}], ")"}], " ", 
              InterpretationBox[
               StyleBox["\[Mu]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Mu][],
               Editable->False], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "1"}], "+", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["\[Mu]",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`\[Mu][],
                  Editable->False], "2"]}], ")"}]}], 
             RowBox[{
              SuperscriptBox[
               InterpretationBox[
                StyleBox["\[Lambda]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Lambda][],
                Editable->False], "2"], "-", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["\[Mu]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Mu][],
                Editable->False], "2"]}]]}], ",", 
           RowBox[{"-", 
            FractionBox[
             RowBox[{
              InterpretationBox[
               StyleBox["\[CapitalOmega]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[CapitalOmega],
               Editable->False], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "1"}], "+", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["\[Lambda]",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`\[Lambda][],
                  Editable->False], "2"]}], ")"}], " ", 
              InterpretationBox[
               StyleBox["\[Mu]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Mu][],
               Editable->False], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "1"}], "+", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["\[Mu]",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`\[Mu][],
                  Editable->False], "2"]}], ")"}]}], 
             RowBox[{
              SuperscriptBox[
               InterpretationBox[
                StyleBox["\[Lambda]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Lambda][],
                Editable->False], "2"], "-", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["\[Mu]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Mu][],
                Editable->False], "2"]}]]}], ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             RowBox[{
              InterpretationBox[
               StyleBox["\[CapitalOmega]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[CapitalOmega],
               Editable->False], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "1"}], "+", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["\[Lambda]",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`\[Lambda][],
                  Editable->False], "2"]}], ")"}], " ", 
              InterpretationBox[
               StyleBox["\[Mu]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Mu][],
               Editable->False], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "1"}], "+", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["\[Mu]",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`\[Mu][],
                  Editable->False], "2"]}], ")"}]}], 
             RowBox[{
              SuperscriptBox[
               InterpretationBox[
                StyleBox["\[Lambda]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Lambda][],
                Editable->False], "2"], "-", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["\[Mu]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Mu][],
                Editable->False], "2"]}]]}], ",", 
           FractionBox[
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["\[Lambda]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Lambda][],
                 Editable->False], "2"]}], ")"}], " ", 
             InterpretationBox[
              StyleBox["\[Mu]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Mu][],
              Editable->False], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["\[Mu]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Mu][],
                 Editable->False], "2"]}], ")"}]}], 
            RowBox[{
             RowBox[{"-", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["\[Lambda]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Lambda][],
                Editable->False], "2"]}], "+", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["\[Mu]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Mu][],
               Editable->False], "2"]}]], ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", 
           FractionBox[
            RowBox[{
             InterpretationBox[
              StyleBox["\[Mu]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Mu][],
              Editable->False], "-", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["\[Mu]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Mu][],
               Editable->False], "3"]}], 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["\[Lambda]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Lambda][],
                 Editable->False], "2"]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["\[Lambda]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Lambda][],
                 Editable->False], "2"], "-", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["\[Mu]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Mu][],
                 Editable->False], "2"]}], ")"}]}]], ",", 
           FractionBox[
            InterpretationBox[
             StyleBox["\[Lambda]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Lambda][],
             Editable->False], 
            RowBox[{
             SuperscriptBox[
              InterpretationBox[
               StyleBox["\[Lambda]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Lambda][],
               Editable->False], "2"], "-", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["\[Mu]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Mu][],
               Editable->False], "2"]}]]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", 
           FractionBox[
            InterpretationBox[
             StyleBox["\[Lambda]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Lambda][],
             Editable->False], 
            RowBox[{
             SuperscriptBox[
              InterpretationBox[
               StyleBox["\[Lambda]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Lambda][],
               Editable->False], "2"], "-", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["\[Mu]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Mu][],
               Editable->False], "2"]}]], ",", 
           RowBox[{"-", 
            FractionBox[
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "1"}], "+", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["\[Lambda]",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`\[Lambda][],
                  Editable->False], "2"]}], ")"}], " ", 
              InterpretationBox[
               StyleBox["\[Mu]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Mu][],
               Editable->False]}], 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["\[Lambda]",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`\[Lambda][],
                  Editable->False], "2"], "-", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["\[Mu]",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`\[Mu][],
                  Editable->False], "2"]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "1"}], "+", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["\[Mu]",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`\[Mu][],
                  Editable->False], "2"]}], ")"}]}]]}]}], "}"}]}], "}"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"rps", ",", 
       RowBox[{"-", "rps"}], ",", 
       RowBox[{"-", "rps"}]}], "}"}], ",", "0"}], "]"}], ",", 
   RowBox[{"CTensor", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"1", "-", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["\[CapitalOmega]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[CapitalOmega],
             Editable->False], "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["\[Lambda]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Lambda][],
               Editable->False], "2"]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{"1", "-", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["\[Mu]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Mu][],
               Editable->False], "2"]}], ")"}]}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           InterpretationBox[
            StyleBox["\[CapitalOmega]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`\[CapitalOmega],
            Editable->False]}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["\[Lambda]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Lambda][],
              Editable->False], "2"]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"1", "-", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["\[Mu]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Mu][],
              Editable->False], "2"]}], ")"}]}], ",", "0", ",", "0"}], "}"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"-", 
           InterpretationBox[
            StyleBox["\[CapitalOmega]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`\[CapitalOmega],
            Editable->False]}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["\[Lambda]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Lambda][],
              Editable->False], "2"]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"1", "-", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["\[Mu]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Mu][],
              Editable->False], "2"]}], ")"}]}], ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "-", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["\[Lambda]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Lambda][],
              Editable->False], "2"]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"1", "-", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["\[Mu]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Mu][],
              Editable->False], "2"]}], ")"}]}], ",", "0", ",", "0"}], "}"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", 
         FractionBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["\[Lambda]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Lambda][],
              Editable->False], "2"]}], "+", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["\[Mu]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Mu][],
             Editable->False], "2"]}], 
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["\[Lambda]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Lambda][],
             Editable->False], "2"]}]], ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", 
         FractionBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["\[Lambda]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Lambda][],
              Editable->False], "2"]}], "+", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["\[Mu]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Mu][],
             Editable->False], "2"]}], 
          RowBox[{"1", "-", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["\[Mu]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Mu][],
             Editable->False], "2"]}]]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "rps"}], ",", 
       RowBox[{"-", "rps"}]}], "}"}], ",", "0"}], "]"}]}], "]"}]], "Output",Ex\
pressionUUID->"f204a333-e98b-45ff-97a5-c036c48939f7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Riemann", "[", "cd", "]"}]], "Input",ExpressionUUID->"2b871737-90de-4ed0-adbf-1921aebb6d57"],

Cell[BoxData["Zero"], "Output",ExpressionUUID->"5c761e11-e9fc-4ae7-b3c1-1ad4d1391d43"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TensorDerivative", "[", 
  RowBox[{"met", ",", "cd"}], "]"}]], "Input",ExpressionUUID->"68d1b995-8ac0-\
4ea0-8174-2961ad8b1f7d"],

Cell[BoxData["Zero"], "Output",ExpressionUUID->"d7859c4d-a44a-4470-845f-66a749fbd402"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TensorDerivative", "[", 
  RowBox[{
   RowBox[{"Inv", "[", "met", "]"}], ",", "cd"}], "]"}]], "Input",ExpressionUU\
ID->"65b5af94-50df-4fd2-9686-12d5093dc324"],

Cell[BoxData["Zero"], "Output",ExpressionUUID->"6915e980-d723-4202-a9fa-c26547ba74e5"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"met", ",", "cd"}], "]"}]], "Input",ExpressionUUID->"634ed61b-2141-\
4bca-9717-9b63bdc52e92"],

Cell[BoxData[
 RowBox[{"UndefChart", "[", "rps", "]"}]], "Input",ExpressionUUID->"07560db3-6100-42a7-8923-00c03dd1b74f"],

Cell[BoxData[
 RowBox[{"UndefConstantSymbol", "[", "\[CapitalOmega]", "]"}]], "Input",Expres\
sionUUID->"d6ef7cdf-6998-48b1-a9fc-192e80439999"],

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M", "]"}]], "Input",ExpressionUUID->"65efd050-a3ec-4acb-b88b-9eba5d345640"],

Cell[BoxData[
 RowBox[{"ClearxCobaCache", "[", "All", "]"}]], "Input",ExpressionUUID->"bb2e15eb-26ea-491e-890d-971f65c6b661"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.2. Schwarzschild", "Subsubsection",ExpressionUUID->"1f076a01-f8fe-4770-b642-ae2037d152b8"],

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M", ",", "4", ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"2922a3ec-3a51-4d0e-9d9f-f5b7e4c4f2ee"],

Cell[BoxData[
 RowBox[{"DefChart", "[", 
  RowBox[{"sch", ",", "M", ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"t", "[", "]"}], ",", 
     RowBox[{"r", "[", "]"}], ",", 
     RowBox[{"\[Theta]", "[", "]"}], ",", 
     RowBox[{"\[Phi]", "[", "]"}]}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"cf4d8934-580e-4dea-94c9-84f2a4f16338"],

Cell[BoxData[
 RowBox[{"DefConstantSymbol", "[", "Mass", "]"}]], "Input",ExpressionUUID->"3e8e39f5-2f7b-43ba-8390-705e4029c0cb"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"met", "=", 
  RowBox[{"CTensor", "[", 
   RowBox[{
    RowBox[{"DiagonalMatrix", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "-", 
        RowBox[{"2", 
         RowBox[{"Mass", "/", 
          RowBox[{"r", "[", "]"}]}]}]}], ",", 
       RowBox[{
        RowBox[{"-", "1"}], "/", 
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"2", 
           RowBox[{"Mass", "/", 
            RowBox[{"r", "[", "]"}]}]}]}], ")"}]}], ",", 
       RowBox[{"-", 
        RowBox[{
         RowBox[{"r", "[", "]"}], "^", "2"}]}], ",", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{
          RowBox[{"r", "[", "]"}], "^", "2"}]}], 
        RowBox[{
         RowBox[{"Sin", "[", 
          RowBox[{"\[Theta]", "[", "]"}], "]"}], "^", "2"}]}]}], "}"}], "]"}],
     ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "sch"}], ",", 
      RowBox[{"-", "sch"}]}], "}"}]}], "]"}]}]], "Input",ExpressionUUID->\
"0c0efbc7-7bbe-4316-9bf4-b2edec60e62d"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "-", 
        FractionBox[
         RowBox[{"2", " ", 
          InterpretationBox[
           StyleBox["Mass",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`Mass,
           Editable->False]}], 
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False]]}], ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"-", 
        FractionBox["1", 
         RowBox[{"1", "-", 
          FractionBox[
           RowBox[{"2", " ", 
            InterpretationBox[
             StyleBox["Mass",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Mass,
             Editable->False]}], 
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False]]}]]}], ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", 
       RowBox[{"-", 
        SuperscriptBox[
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False], "2"]}], ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", 
       RowBox[{
        RowBox[{"-", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], "2"]}], " ", 
        SuperscriptBox[
         RowBox[{
          InterpretationBox[
           StyleBox["Sin",
            ShowAutoStyles->False,
            AutoSpacing->False],
           Sin,
           Editable->False], "[", 
          InterpretationBox[
           StyleBox["\[Theta]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Theta][],
           Editable->False], "]"}], "2"]}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "sch"}], ",", 
     RowBox[{"-", "sch"}]}], "}"}], ",", "0"}], "]"}]], "Output",ExpressionUUI\
D->"ec5925ac-a418-41a0-868a-6756eaf44531"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"$CVSimplify", "=", "Simplify"}], ";"}]], "Input",ExpressionUUID->\
"213a1a65-818b-4a95-8cae-e42e2efea6c1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"SetCMetric", "[", 
   RowBox[{"met", ",", "sch", ",", 
    RowBox[{"SignatureOfMetric", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"3", ",", "1", ",", "0"}], "}"}]}]}], "]"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"b2130f4c-94d7-4034-8431-\
8ce774e84bcd"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.038232`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"df39337b-17ab-4b7f-821c-9ab3f65bff4f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MetricCompute", "[", 
   RowBox[{"met", ",", "sch", ",", 
    RowBox[{"\"\<Weyl\>\"", "[", 
     RowBox[{
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}]}], "]"}]}], "]"}], "//", "AbsoluteTiming"}]], "Input",\
ExpressionUUID->"beb96232-4b20-4ff9-a5aa-9ffc4407f147"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.067424`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"03910076-99b3-4d9b-aa31-dc90a1b7fe04"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"cd", "=", 
  RowBox[{"CovDOfMetric", "[", "met", "]"}]}]], "Input",ExpressionUUID->\
"ae927348-5381-42ac-91a7-8659f9f57d89"],

Cell[BoxData[
 RowBox[{"CCovD", "[", 
  RowBox[{"PDsch", ",", 
   RowBox[{"CTensor", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"-", 
            FractionBox[
             InterpretationBox[
              StyleBox["Mass",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Mass,
              Editable->False], 
             RowBox[{
              RowBox[{"2", " ", 
               InterpretationBox[
                StyleBox["Mass",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Mass,
                Editable->False], " ", 
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False]}], "-", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False], "2"]}]]}], ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             InterpretationBox[
              StyleBox["Mass",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Mass,
              Editable->False], 
             RowBox[{
              RowBox[{"2", " ", 
               InterpretationBox[
                StyleBox["Mass",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Mass,
                Editable->False], " ", 
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False]}], "-", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False], "2"]}]]}], ",", "0", ",", "0", ",", "0"}], 
          "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            RowBox[{
             InterpretationBox[
              StyleBox["Mass",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Mass,
              Editable->False], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "2"}], " ", 
                InterpretationBox[
                 StyleBox["Mass",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False]}], "+", 
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False]}], ")"}]}], 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False], "3"]], ",", "0", ",", "0", ",", "0"}], "}"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           FractionBox[
            InterpretationBox[
             StyleBox["Mass",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Mass,
             Editable->False], 
            RowBox[{
             RowBox[{"2", " ", 
              InterpretationBox[
               StyleBox["Mass",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Mass,
               Editable->False], " ", 
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False]}], "-", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], "2"]}]], ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", 
           RowBox[{
            RowBox[{"2", " ", 
             InterpretationBox[
              StyleBox["Mass",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Mass,
              Editable->False]}], "-", 
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False]}], ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", 
               InterpretationBox[
                StyleBox["Mass",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`Mass,
                Editable->False]}], "-", 
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False]}], ")"}], " ", 
            SuperscriptBox[
             RowBox[{
              InterpretationBox[
               StyleBox["Sin",
                ShowAutoStyles->False,
                AutoSpacing->False],
               Sin,
               Editable->False], "[", 
              InterpretationBox[
               StyleBox["\[Theta]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Theta][],
               Editable->False], "]"}], "2"]}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", 
           FractionBox["1", 
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False]], ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           FractionBox["1", 
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False]], ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", 
           RowBox[{
            RowBox[{"-", 
             RowBox[{
              InterpretationBox[
               StyleBox["Cos",
                ShowAutoStyles->False,
                AutoSpacing->False],
               Cos,
               Editable->False], "[", 
              InterpretationBox[
               StyleBox["\[Theta]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Theta][],
               Editable->False], "]"}]}], " ", 
            RowBox[{
             InterpretationBox[
              StyleBox["Sin",
               ShowAutoStyles->False,
               AutoSpacing->False],
              Sin,
              Editable->False], "[", 
             InterpretationBox[
              StyleBox["\[Theta]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Theta][],
              Editable->False], "]"}]}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", 
           FractionBox["1", 
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False]]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", 
           RowBox[{
            InterpretationBox[
             StyleBox["Cot",
              ShowAutoStyles->False,
              AutoSpacing->False],
             Cot,
             Editable->False], "[", 
            InterpretationBox[
             StyleBox["\[Theta]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Theta][],
             Editable->False], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           FractionBox["1", 
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False]], ",", 
           RowBox[{
            InterpretationBox[
             StyleBox["Cot",
              ShowAutoStyles->False,
              AutoSpacing->False],
             Cot,
             Editable->False], "[", 
            InterpretationBox[
             StyleBox["\[Theta]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Theta][],
             Editable->False], "]"}], ",", "0"}], "}"}]}], "}"}]}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"sch", ",", 
       RowBox[{"-", "sch"}], ",", 
       RowBox[{"-", "sch"}]}], "}"}], ",", "0"}], "]"}], ",", 
   RowBox[{"CTensor", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"1", "-", 
          FractionBox[
           RowBox[{"2", " ", 
            InterpretationBox[
             StyleBox["Mass",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Mass,
             Editable->False]}], 
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False]]}], ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"-", 
          FractionBox["1", 
           RowBox[{"1", "-", 
            FractionBox[
             RowBox[{"2", " ", 
              InterpretationBox[
               StyleBox["Mass",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Mass,
               Editable->False]}], 
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False]]}]]}], ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", 
         RowBox[{"-", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], "2"]}], ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", 
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False], "2"]}], " ", 
          SuperscriptBox[
           RowBox[{
            InterpretationBox[
             StyleBox["Sin",
              ShowAutoStyles->False,
              AutoSpacing->False],
             Sin,
             Editable->False], "[", 
            InterpretationBox[
             StyleBox["\[Theta]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Theta][],
             Editable->False], "]"}], "2"]}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "sch"}], ",", 
       RowBox[{"-", "sch"}]}], "}"}], ",", "0"}], "]"}]}], "]"}]], "Output",Ex\
pressionUUID->"2a87a119-10d9-4e39-bdb3-134ce074615a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"riemann", "=", 
  RowBox[{"Riemann", "[", "cd", "]"}]}]], "Input",ExpressionUUID->"439020e8-\
7a45-47d9-bf9d-4e5346ebdd19"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", 
           FractionBox[
            RowBox[{"2", " ", 
             InterpretationBox[
              StyleBox["Mass",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Mass,
              Editable->False], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", " ", 
                InterpretationBox[
                 StyleBox["Mass",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False]}], "-", 
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False]}], ")"}]}], 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False], "4"]], ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            RowBox[{"2", " ", 
             InterpretationBox[
              StyleBox["Mass",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Mass,
              Editable->False]}], 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", " ", 
                InterpretationBox[
                 StyleBox["Mass",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False]}], "-", 
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False]}], ")"}], " ", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], "2"]}]], ",", "0", ",", "0", ",", "0"}], 
          "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", 
           FractionBox[
            RowBox[{
             InterpretationBox[
              StyleBox["Mass",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Mass,
              Editable->False], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "2"}], " ", 
                InterpretationBox[
                 StyleBox["Mass",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False]}], "+", 
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False]}], ")"}]}], 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False], "4"]], ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            InterpretationBox[
             StyleBox["Mass",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Mass,
             Editable->False], 
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False]], ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", 
           FractionBox[
            RowBox[{
             InterpretationBox[
              StyleBox["Mass",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Mass,
              Editable->False], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "2"}], " ", 
                InterpretationBox[
                 StyleBox["Mass",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False]}], "+", 
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False]}], ")"}]}], 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False], "4"]]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            RowBox[{
             InterpretationBox[
              StyleBox["Mass",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Mass,
              Editable->False], " ", 
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["Sin",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                Sin,
                Editable->False], "[", 
               InterpretationBox[
                StyleBox["\[Theta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Theta][],
                Editable->False], "]"}], "2"]}], 
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False]], ",", "0", ",", "0", ",", "0"}], "}"}]}], 
        "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"-", 
            FractionBox[
             RowBox[{"2", " ", 
              InterpretationBox[
               StyleBox["Mass",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Mass,
               Editable->False], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"2", " ", 
                 InterpretationBox[
                  StyleBox["Mass",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False]}], "-", 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]}], ")"}]}], 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], "4"]]}], ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             RowBox[{"2", " ", 
              InterpretationBox[
               StyleBox["Mass",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Mass,
               Editable->False]}], 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"2", " ", 
                 InterpretationBox[
                  StyleBox["Mass",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False]}], "-", 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]}], ")"}], " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False], "2"]}]]}], ",", "0", ",", "0", ",", "0"}], 
          "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", 
           FractionBox[
            InterpretationBox[
             StyleBox["Mass",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Mass,
             Editable->False], 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", " ", 
                InterpretationBox[
                 StyleBox["Mass",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False]}], "-", 
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False]}], ")"}], " ", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], "2"]}]], ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           FractionBox[
            InterpretationBox[
             StyleBox["Mass",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Mass,
             Editable->False], 
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False]], ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", 
           FractionBox[
            InterpretationBox[
             StyleBox["Mass",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`Mass,
             Editable->False], 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", " ", 
                InterpretationBox[
                 StyleBox["Mass",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`Mass,
                 Editable->False]}], "-", 
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False]}], ")"}], " ", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], "2"]}]]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           FractionBox[
            RowBox[{
             InterpretationBox[
              StyleBox["Mass",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Mass,
              Editable->False], " ", 
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["Sin",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                Sin,
                Editable->False], "[", 
               InterpretationBox[
                StyleBox["\[Theta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Theta][],
                Editable->False], "]"}], "2"]}], 
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False]], ",", "0", ",", "0"}], "}"}]}], "}"}]}], "}"}],
      ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", 
           RowBox[{"-", 
            FractionBox[
             RowBox[{
              InterpretationBox[
               StyleBox["Mass",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Mass,
               Editable->False], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "2"}], " ", 
                 InterpretationBox[
                  StyleBox["Mass",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False]}], "+", 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]}], ")"}]}], 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], "4"]]}], ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             InterpretationBox[
              StyleBox["Mass",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Mass,
              Editable->False], 
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False]]}], ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", 
           RowBox[{"-", 
            FractionBox[
             InterpretationBox[
              StyleBox["Mass",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Mass,
              Editable->False], 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"2", " ", 
                 InterpretationBox[
                  StyleBox["Mass",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False]}], "-", 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]}], ")"}], " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False], "2"]}]]}], ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"-", 
            FractionBox[
             InterpretationBox[
              StyleBox["Mass",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Mass,
              Editable->False], 
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False]]}], ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", 
           FractionBox[
            RowBox[{"2", " ", 
             InterpretationBox[
              StyleBox["Mass",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Mass,
              Editable->False]}], 
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False]]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", 
           RowBox[{"-", 
            FractionBox[
             RowBox[{"2", " ", 
              InterpretationBox[
               StyleBox["Mass",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Mass,
               Editable->False], " ", 
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["Sin",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 Sin,
                 Editable->False], "[", 
                InterpretationBox[
                 StyleBox["\[Theta]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Theta][],
                 Editable->False], "]"}], "2"]}], 
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False]]}], ",", "0"}], "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", 
           RowBox[{"-", 
            FractionBox[
             RowBox[{
              InterpretationBox[
               StyleBox["Mass",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Mass,
               Editable->False], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "2"}], " ", 
                 InterpretationBox[
                  StyleBox["Mass",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False]}], "+", 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]}], ")"}]}], 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], "4"]]}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             RowBox[{
              InterpretationBox[
               StyleBox["Mass",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Mass,
               Editable->False], " ", 
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["Sin",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 Sin,
                 Editable->False], "[", 
                InterpretationBox[
                 StyleBox["\[Theta]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Theta][],
                 Editable->False], "]"}], "2"]}], 
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False]]}], ",", "0", ",", "0", ",", "0"}], "}"}]}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", 
           RowBox[{"-", 
            FractionBox[
             InterpretationBox[
              StyleBox["Mass",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Mass,
              Editable->False], 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"2", " ", 
                 InterpretationBox[
                  StyleBox["Mass",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`Mass,
                  Editable->False]}], "-", 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]}], ")"}], " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False], "2"]}]]}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"-", 
            FractionBox[
             RowBox[{
              InterpretationBox[
               StyleBox["Mass",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Mass,
               Editable->False], " ", 
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["Sin",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 Sin,
                 Editable->False], "[", 
                InterpretationBox[
                 StyleBox["\[Theta]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Theta][],
                 Editable->False], "]"}], "2"]}], 
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False]]}], ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
       
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", 
           RowBox[{"-", 
            FractionBox[
             RowBox[{"2", " ", 
              InterpretationBox[
               StyleBox["Mass",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`Mass,
               Editable->False]}], 
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False]]}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", 
           FractionBox[
            RowBox[{"2", " ", 
             InterpretationBox[
              StyleBox["Mass",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`Mass,
              Editable->False], " ", 
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["Sin",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                Sin,
                Editable->False], "[", 
               InterpretationBox[
                StyleBox["\[Theta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Theta][],
                Editable->False], "]"}], "2"]}], 
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False]], ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}]}], 
      "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "sch"}], ",", 
     RowBox[{"-", "sch"}], ",", 
     RowBox[{"-", "sch"}], ",", "sch"}], "}"}], ",", "0"}], "]"}]], "Output",E\
xpressionUUID->"f55b0d6e-3d89-4b08-b782-c13510f38a2c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"riemann", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"-", "sch"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"-", "sch"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"-", "sch"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "sch"}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"fd779b76-80e2-4d6b-8030-3e5f2806bbcb"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox["Mass",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`Mass,
     Editable->False]}], 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", 
       InterpretationBox[
        StyleBox["Mass",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`Mass,
        Editable->False]}], "-", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False]}], ")"}], " ", 
    SuperscriptBox[
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], "2"]}]]}]], "Output",ExpressionUUID->"63aa8702-e868-\
424f-9f5e-12cd0bffaa8b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MetricCompute", "[", 
   RowBox[{"met", ",", "sch", ",", 
    RowBox[{"\"\<CDRiemann\>\"", "[", 
     RowBox[{
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}]}], "]"}]}], "]"}], "//", "AbsoluteTiming"}]], "Input",\
ExpressionUUID->"cab911fd-33ef-42f6-bfec-187862378fa0"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.057109`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"dfd96cef-c709-42fb-822e-76e0de790cae"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"cdriemann", "=", 
   RowBox[{"TensorDerivative", "[", 
    RowBox[{"riemann", ",", "cd"}], "]"}]}], ";"}]], "Input",ExpressionUUID->\
"4ccbf3f4-f224-41b3-851a-5a858356a7e6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"cdriemann", "[", 
     RowBox[{
      RowBox[{"-", "a"}], ",", 
      RowBox[{"-", "b"}], ",", 
      RowBox[{"-", "c"}], ",", 
      RowBox[{"-", "d"}], ",", 
      RowBox[{"-", "e"}]}], "]"}], "+", 
    RowBox[{"cdriemann", "[", 
     RowBox[{
      RowBox[{"-", "c"}], ",", 
      RowBox[{"-", "a"}], ",", 
      RowBox[{"-", "b"}], ",", 
      RowBox[{"-", "d"}], ",", 
      RowBox[{"-", "e"}]}], "]"}], "+", 
    RowBox[{"cdriemann", "[", 
     RowBox[{
      RowBox[{"-", "b"}], ",", 
      RowBox[{"-", "c"}], ",", 
      RowBox[{"-", "a"}], ",", 
      RowBox[{"-", "d"}], ",", 
      RowBox[{"-", "e"}]}], "]"}]}], "//", "Simplify"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"f3698a04-eb6b-473e-9666-\
9bbe557ce731"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.083019`", ",", "0"}], "}"}]], "Output",ExpressionUUID->"714aba52-\
c903-4538-a090-49b98be62c61"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"met", ",", "cd", ",", "riemann", ",", "cdriemann"}], 
  "]"}]], "Input",ExpressionUUID->"f77935ad-fced-4318-a4f8-966c3ebb52e1"],

Cell[BoxData[
 RowBox[{"UndefConstantSymbol", "[", "Mass", "]"}]], "Input",ExpressionUUID->"489b861b-cda8-4697-aba4-876fdc2259e1"],

Cell[BoxData[
 RowBox[{"UndefChart", "[", "sch", "]"}]], "Input",ExpressionUUID->"7ebfa86b-c0bb-4aec-ba24-fdf978bbf6fa"],

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M", "]"}]], "Input",ExpressionUUID->"9366acba-cab0-4a38-b414-eed103c1d2e2"],

Cell[BoxData[
 RowBox[{"ClearxCobaCache", "[", "All", "]"}]], "Input",ExpressionUUID->"05111cf8-5641-42f3-b4f2-635bf0702487"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.3. Schwarzschild with cosmological constant", "Subsubsection",ExpressionUUID->"23f6dd91-9974-45f6-8dbd-5969821455cf"],

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M", ",", "4", ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"4cd5f5c9-d4fa-47e9-9187-3fb5ac4f1c63"],

Cell[BoxData[
 RowBox[{"DefChart", "[", 
  RowBox[{"sch", ",", "M", ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"t", "[", "]"}], ",", 
     RowBox[{"r", "[", "]"}], ",", 
     RowBox[{"\[Theta]", "[", "]"}], ",", 
     RowBox[{"\[Phi]", "[", "]"}]}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"4d8ecc49-d258-48fd-b3c2-ff4825e78da9"],

Cell[BoxData[
 RowBox[{"DefConstantSymbol", "[", "\[CapitalMu]", "]"}]], "Input",ExpressionU\
UID->"476e2685-468f-4c6b-9c8c-17962b683484"],

Cell[BoxData[
 RowBox[{"DefConstantSymbol", "[", "\[CapitalLambda]", "]"}]], "Input",Express\
ionUUID->"69001dd4-f5ec-4d6f-8aad-19f5eeb479db"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"met", "=", 
  RowBox[{"CTensor", "[", 
   RowBox[{
    RowBox[{"DiagonalMatrix", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "-", 
        RowBox[{"2", 
         RowBox[{"\[CapitalMu]", "/", 
          RowBox[{"r", "[", "]"}]}]}], "-", 
        RowBox[{"\[CapitalLambda]", " ", 
         RowBox[{
          RowBox[{
           RowBox[{"r", "[", "]"}], "^", "2"}], "/", "3"}]}]}], ",", 
       RowBox[{
        RowBox[{"-", "1"}], "/", 
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"2", 
           RowBox[{"\[CapitalMu]", "/", 
            RowBox[{"r", "[", "]"}]}]}], "-", 
          RowBox[{"\[CapitalLambda]", " ", 
           RowBox[{
            RowBox[{
             RowBox[{"r", "[", "]"}], "^", "2"}], "/", "3"}]}]}], ")"}]}], 
       ",", 
       RowBox[{"-", 
        RowBox[{
         RowBox[{"r", "[", "]"}], "^", "2"}]}], ",", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{
          RowBox[{"r", "[", "]"}], "^", "2"}]}], 
        RowBox[{
         RowBox[{"Sin", "[", 
          RowBox[{"\[Theta]", "[", "]"}], "]"}], "^", "2"}]}]}], "}"}], "]"}],
     ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "sch"}], ",", 
      RowBox[{"-", "sch"}]}], "}"}]}], "]"}]}]], "Input",ExpressionUUID->\
"4caef56c-08cd-4f33-8699-6bb29318dc8d"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "-", 
        FractionBox[
         RowBox[{"2", " ", 
          InterpretationBox[
           StyleBox["\[CapitalMu]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[CapitalMu],
           Editable->False]}], 
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False]], "-", 
        FractionBox[
         RowBox[{
          InterpretationBox[
           StyleBox["\[CapitalLambda]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[CapitalLambda],
           Editable->False], " ", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], "2"]}], "3"]}], ",", "0", ",", "0", ",", "0"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"-", 
        FractionBox["1", 
         RowBox[{"1", "-", 
          FractionBox[
           RowBox[{"2", " ", 
            InterpretationBox[
             StyleBox["\[CapitalMu]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[CapitalMu],
             Editable->False]}], 
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False]], "-", 
          FractionBox[
           RowBox[{
            InterpretationBox[
             StyleBox["\[CapitalLambda]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[CapitalLambda],
             Editable->False], " ", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False], "2"]}], "3"]}]]}], ",", "0", ",", "0"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", 
       RowBox[{"-", 
        SuperscriptBox[
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False], "2"]}], ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", 
       RowBox[{
        RowBox[{"-", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], "2"]}], " ", 
        SuperscriptBox[
         RowBox[{
          InterpretationBox[
           StyleBox["Sin",
            ShowAutoStyles->False,
            AutoSpacing->False],
           Sin,
           Editable->False], "[", 
          InterpretationBox[
           StyleBox["\[Theta]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Theta][],
           Editable->False], "]"}], "2"]}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "sch"}], ",", 
     RowBox[{"-", "sch"}]}], "}"}], ",", "0"}], "]"}]], "Output",ExpressionUUI\
D->"6c4c8f7e-3811-4716-841f-41a6808f6a1c"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"$CVSimplify", "=", "Simplify"}], ";"}]], "Input",ExpressionUUID->\
"18aec5f2-4cbe-4d56-9441-0a12560d13ba"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"SetCMetric", "[", 
   RowBox[{"met", ",", "sch", ",", 
    RowBox[{"SignatureOfMetric", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"3", ",", "1", ",", "0"}], "}"}]}]}], "]"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"a013a42c-4d04-4395-8f7d-\
3825c4cf4100"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.057924`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"50c38814-b42e-496e-8c97-b9d9aace3b57"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MetricCompute", "[", 
   RowBox[{"met", ",", "sch", ",", 
    RowBox[{"\"\<CDRiemann\>\"", "[", 
     RowBox[{
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}]}], "]"}]}], "]"}], "//", "AbsoluteTiming"}]], "Input",\
ExpressionUUID->"af95ca88-ae91-498a-9e68-1d8ed62b339e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.118628`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"96e825c6-1f1b-45c2-8b89-c38879579610"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"cd", "=", 
   RowBox[{"CovDOfMetric", "[", "met", "]"}]}], ";"}]], "Input",ExpressionUUID\
->"8dc7626b-045e-4ebb-a970-45070de6f111"],

Cell[BoxData[
 RowBox[{
  RowBox[{"riemann", "=", 
   RowBox[{"Riemann", "[", "cd", "]"}]}], ";"}]], "Input",ExpressionUUID->\
"aa97dc6e-4e5e-482e-a042-87e58163a033"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"riemann", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"-", "sch"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"-", "sch"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"-", "sch"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "sch"}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"b8963743-0bed-4349-8752-39cae26b7810"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{
    RowBox[{"6", " ", 
     InterpretationBox[
      StyleBox["\[CapitalMu]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[CapitalMu],
      Editable->False]}], "+", 
    RowBox[{
     InterpretationBox[
      StyleBox["\[CapitalLambda]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[CapitalLambda],
      Editable->False], " ", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "3"]}]}], 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"6", " ", 
       InterpretationBox[
        StyleBox["\[CapitalMu]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[CapitalMu],
        Editable->False]}], "-", 
      RowBox[{"3", " ", 
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False]}], "+", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[CapitalLambda]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[CapitalLambda],
        Editable->False], " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], "3"]}]}], ")"}]}]]}]], "Output",ExpressionUUID->\
"1f014cf7-8845-4122-9c7c-e5789c4fbbe9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Ricci", "[", "cd", "]"}], "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"-", "sch"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"-", "sch"}]}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"910b7d96-e9d2-4acd-a33b-88f46601ac25"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox["\[CapitalLambda]",
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`\[CapitalLambda],
   Editable->False], " ", 
  SuperscriptBox[
   InterpretationBox[
    StyleBox["r",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`r[],
    Editable->False], "2"]}]], "Output",ExpressionUUID->"863ebde2-ca6c-4ac4-\
ac14-e653fd7f194c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"RicciScalar", "[", "cd", "]"}], "[", "]"}]], "Input",ExpressionUUID\
->"ab7ff0fb-c69a-4c4a-8cca-2216e82727ee"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "4"}], " ", 
  InterpretationBox[
   StyleBox["\[CapitalLambda]",
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`\[CapitalLambda],
   Editable->False]}]], "Output",ExpressionUUID->"fc7fbdac-7559-4cf3-8916-\
cecdec40ba6f"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"cdriemann", "=", 
   RowBox[{"TensorDerivative", "[", 
    RowBox[{"riemann", ",", "cd"}], "]"}]}], ";"}]], "Input",ExpressionUUID->\
"5ad9df2a-75b2-435b-954e-471f59472320"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"cdriemann", "[", 
     RowBox[{
      RowBox[{"-", "a"}], ",", 
      RowBox[{"-", "b"}], ",", 
      RowBox[{"-", "c"}], ",", 
      RowBox[{"-", "d"}], ",", 
      RowBox[{"-", "e"}]}], "]"}], "+", 
    RowBox[{"cdriemann", "[", 
     RowBox[{
      RowBox[{"-", "c"}], ",", 
      RowBox[{"-", "a"}], ",", 
      RowBox[{"-", "b"}], ",", 
      RowBox[{"-", "d"}], ",", 
      RowBox[{"-", "e"}]}], "]"}], "+", 
    RowBox[{"cdriemann", "[", 
     RowBox[{
      RowBox[{"-", "b"}], ",", 
      RowBox[{"-", "c"}], ",", 
      RowBox[{"-", "a"}], ",", 
      RowBox[{"-", "d"}], ",", 
      RowBox[{"-", "e"}]}], "]"}]}], "//", "Simplify"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"64c35874-3853-4b0a-a3d0-\
0080fdf061f2"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.087344`", ",", "0"}], "}"}]], "Output",ExpressionUUID->"cc65028d-\
78d0-4e88-baa4-dd9fc7dd6acb"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"weyl", "=", 
   RowBox[{"Weyl", "[", "cd", "]"}]}], ";"}]], "Input",ExpressionUUID->\
"28164c90-8b57-4552-a2ac-83f94aee6961"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"weyl", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}], ",", "c", ",", "d"}], "]"}], 
   RowBox[{"weyl", "[", 
    RowBox[{
     RowBox[{"-", "c"}], ",", 
     RowBox[{"-", "d"}], ",", "a", ",", "b"}], "]"}]}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"05e8ee7c-08cf-4e6e-b6fe-\
6499f7ffaee0"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.045841`", ",", 
   FractionBox[
    RowBox[{"48", " ", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["\[CapitalMu]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[CapitalMu],
       Editable->False], "2"]}], 
    SuperscriptBox[
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], "6"]]}], "}"}]], "Output",ExpressionUUID->"338730e9-\
1692-49e7-9532-437c1007b82c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"weyl", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}], ",", "c", ",", "d"}], "]"}], 
   RowBox[{"weyl", "[", 
    RowBox[{
     RowBox[{"-", "c"}], ",", 
     RowBox[{"-", "d"}], ",", "e", ",", "f"}], "]"}], 
   RowBox[{"weyl", "[", 
    RowBox[{
     RowBox[{"-", "e"}], ",", 
     RowBox[{"-", "f"}], ",", "a", ",", "b"}], "]"}]}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"82e3658f-0179-4608-81be-\
e3e06e6a9614"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.071464`", ",", 
   RowBox[{"-", 
    FractionBox[
     RowBox[{"96", " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[CapitalMu]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[CapitalMu],
        Editable->False], "3"]}], 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "9"]]}]}], "}"}]], "Output",ExpressionUUID->\
"47990165-858e-4ccf-a1e1-693ad5065bfe"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"met", ",", "cd", ",", "riemann", ",", "cdriemann", ",", "weyl"}], 
  "]"}]], "Input",ExpressionUUID->"33e9cd80-fa14-450a-b4e0-e17f78b8b2c0"],

Cell[BoxData[
 RowBox[{"UndefConstantSymbol", "[", "\[CapitalMu]", "]"}]], "Input",Expressio\
nUUID->"252ea43d-b762-4da7-ba25-c721d3eaeabb"],

Cell[BoxData[
 RowBox[{"UndefConstantSymbol", "[", "\[CapitalLambda]", "]"}]], "Input",Expre\
ssionUUID->"62015d3f-3a21-469a-9259-ecda02f975f9"],

Cell[BoxData[
 RowBox[{"UndefChart", "[", "sch", "]"}]], "Input",ExpressionUUID->"eb4de121-6d0e-46f9-8db9-d205b4df2f47"],

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M", "]"}]], "Input",ExpressionUUID->"b03b2641-479c-4e9a-b105-f1ec32541a47"],

Cell[BoxData[
 RowBox[{"ClearxCobaCache", "[", "All", "]"}]], "Input",ExpressionUUID->"1a30735e-9f44-47e5-9578-ed6f40eeaa8a"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.4. Robertson-Walker", "Subsubsection",ExpressionUUID->"69ea66d1-0075-43b4-86e9-4988e6aaccbe"],

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M", ",", "4", ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"a7a06305-ae21-44ff-b73f-f35ef3173255"],

Cell[BoxData[
 RowBox[{"DefChart", "[", 
  RowBox[{"com", ",", "M", ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"t", "[", "]"}], ",", 
     RowBox[{"r", "[", "]"}], ",", 
     RowBox[{"\[Theta]", "[", "]"}], ",", 
     RowBox[{"\[Phi]", "[", "]"}]}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"b0b1c779-5963-4cbe-8eee-20b024ad1d2c"],

Cell[BoxData[
 RowBox[{"DefConstantSymbol", "[", "\[Kappa]", "]"}]], "Input",ExpressionUUID->"afed29ee-53ba-4bb8-914c-8b86cac40ce4"],

Cell[BoxData[
 RowBox[{"DefScalarFunction", "[", "scale", "]"}]], "Input",ExpressionUUID->"44f178e0-5589-485a-86ac-f6b30c92dc53"],

Cell[BoxData[
 RowBox[{
  RowBox[{"met", "=", 
   RowBox[{"CTensor", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{
          RowBox[{"-", 
           RowBox[{
            RowBox[{"scale", "[", 
             RowBox[{"t", "[", "]"}], "]"}], "^", "2"}]}], "/", 
          RowBox[{"(", 
           RowBox[{"1", "-", 
            RowBox[{"\[Kappa]", " ", 
             RowBox[{
              RowBox[{"r", "[", "]"}], "^", "2"}]}]}], ")"}]}], ",", "0", ",",
          "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", 
         RowBox[{
          RowBox[{"-", 
           RowBox[{
            RowBox[{"scale", "[", 
             RowBox[{"t", "[", "]"}], "]"}], "^", "2"}]}], 
          RowBox[{
           RowBox[{"r", "[", "]"}], "^", "2"}]}], ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", 
         RowBox[{
          RowBox[{"-", 
           RowBox[{
            RowBox[{"r", "[", "]"}], "^", "2"}]}], 
          RowBox[{
           RowBox[{"scale", "[", 
            RowBox[{"t", "[", "]"}], "]"}], "^", "2"}], 
          RowBox[{
           RowBox[{"Sin", "[", 
            RowBox[{"\[Theta]", "[", "]"}], "]"}], "^", "2"}]}]}], "}"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "com"}], ",", 
       RowBox[{"-", "com"}]}], "}"}]}], "]"}]}], ";"}]], "Input",ExpressionUUI\
D->"733fc4b8-d0e1-417d-95d9-1b8402c9709b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$CVSimplify", "=", "Simplify"}], ";"}]], "Input",ExpressionUUID->\
"61006a03-bb7e-4b6e-881d-09f18b0a1703"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"SetCMetric", "[", 
   RowBox[{"met", ",", "com", ",", 
    RowBox[{"SignatureOfMetric", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"3", ",", "1", ",", "0"}], "}"}]}]}], "]"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"8d392b55-5b5e-43f3-ab85-\
124e81130458"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.0459`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"758ecb3d-2b8b-4c5c-a98e-ca03c4b47264"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MetricCompute", "[", 
   RowBox[{"met", ",", "com", ",", 
    RowBox[{"\"\<CDRiemann\>\"", "[", 
     RowBox[{
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}]}], "]"}]}], "]"}], "//", "AbsoluteTiming"}]], "Input",\
ExpressionUUID->"0b9eb105-2c42-4560-b57b-484abc53a1d4"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.19827`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"3ba8c857-1c0b-4698-a144-338bdbf47f4a"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"cd", "=", 
   RowBox[{"CovDOfMetric", "[", "met", "]"}]}], ";"}]], "Input",ExpressionUUID\
->"0b61efdd-0a88-4aec-9d22-3de3dfdb633f"],

Cell["The space is conformally flat:", "Text",ExpressionUUID->"eb51d8d7-0d75-4ce3-a481-11012b4be675"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Weyl", "[", "cd", "]"}]], "Input",ExpressionUUID->"7344efe8-99ed-4bcc-92d1-be2e0599f9e0"],

Cell[BoxData["Zero"], "Output",ExpressionUUID->"0bcbe5d5-8883-4e9d-aa4b-dd7ddcd5955f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Ricci", "[", "cd", "]"}], "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"-", "com"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"-", "com"}]}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"5de775f6-fd5d-47b3-a03a-a66fe5c0122e"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{"3", " ", 
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["scale",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`scale,
       Editable->False], "\[Prime]\[Prime]",
      MultilineFunction->None], "[", 
     InterpretationBox[
      StyleBox["t",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`t[],
      Editable->False], "]"}]}], 
   RowBox[{
    InterpretationBox[
     StyleBox["scale",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`scale,
     Editable->False], "[", 
    InterpretationBox[
     StyleBox["t",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`t[],
     Editable->False], "]"}]]}]], "Output",ExpressionUUID->"43e21c40-da4c-\
467a-bac0-d39c7fbe6495"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Einstein", "[", "cd", "]"}], "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"-", "com"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"-", "com"}]}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"dfe60ac7-4179-4489-8b1d-c89fefa8851e"],

Cell[BoxData[
 FractionBox[
  RowBox[{"3", " ", 
   RowBox[{"(", 
    RowBox[{
     InterpretationBox[
      StyleBox["\[Kappa]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Kappa],
      Editable->False], "+", 
     SuperscriptBox[
      RowBox[{
       SuperscriptBox[
        InterpretationBox[
         StyleBox["scale",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`scale,
         Editable->False], "\[Prime]",
        MultilineFunction->None], "[", 
       InterpretationBox[
        StyleBox["t",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`t[],
        Editable->False], "]"}], "2"]}], ")"}]}], 
  SuperscriptBox[
   RowBox[{
    InterpretationBox[
     StyleBox["scale",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`scale,
     Editable->False], "[", 
    InterpretationBox[
     StyleBox["t",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`t[],
     Editable->False], "]"}], "2"]]], "Output",ExpressionUUID->"d00834e6-8e47-\
4cbd-8659-69f6e5f7515a"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"cdriemann", "=", 
   RowBox[{"TensorDerivative", "[", 
    RowBox[{
     RowBox[{"RiemannDown", "[", "cd", "]"}], ",", "cd"}], "]"}]}], 
  ";"}]], "Input",ExpressionUUID->"08fcbaf8-af9c-4549-942d-41d7d145557a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"cdriemann", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}], ",", 
     RowBox[{"-", "d"}], ",", 
     RowBox[{"-", "e"}]}], "]"}], "+", 
   RowBox[{"cdriemann", "[", 
    RowBox[{
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}], ",", 
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "d"}], ",", 
     RowBox[{"-", "e"}]}], "]"}], "+", 
   RowBox[{"cdriemann", "[", 
    RowBox[{
     RowBox[{"-", "c"}], ",", 
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "d"}], ",", 
     RowBox[{"-", "e"}]}], "]"}]}], "//", "Simplify"}]], "Input",ExpressionUUI\
D->"654eda80-8695-4937-9583-54ed86805863"],

Cell[BoxData["0"], "Output",ExpressionUUID->"9b3cacda-9909-4413-afcd-73b630888736"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"met", ",", "cd", ",", "cdriemann"}], "]"}]], "Input",ExpressionUUID\
->"e5af2c21-2a26-42ac-89cf-4740ca544866"],

Cell[BoxData[
 RowBox[{"UndefConstantSymbol", "[", "\[Kappa]", "]"}]], "Input",ExpressionUUID->"c6135820-73fe-4f84-a5f3-20db7e33295b"],

Cell[BoxData[
 RowBox[{"UndefScalarFunction", "[", "scale", "]"}]], "Input",ExpressionUUID->"547b3c2b-8767-443b-a222-faaef712bd98"],

Cell[BoxData[
 RowBox[{"UndefChart", "[", "com", "]"}]], "Input",ExpressionUUID->"93df1120-b4dc-4ee6-bfeb-6d2004f7fc76"],

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M", "]"}]], "Input",ExpressionUUID->"8bea698a-230e-4bab-a154-88ce76aa26a5"],

Cell[BoxData[
 RowBox[{"ClearxCobaCache", "[", "All", "]"}]], "Input",ExpressionUUID->"49ac43b6-b629-4695-bb79-2d1892adb206"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.5. Conformally flat 5-dimensional metric", "Subsubsection",ExpressionUUID->"3742cd33-26c1-420b-a274-dacb1cab3b19"],

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M", ",", "5", ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"ac8517fc-3cb7-4367-8a5c-c6ac89a47eee"],

Cell[BoxData[
 RowBox[{"DefChart", "[", 
  RowBox[{"xs", ",", "M", ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x1", "[", "]"}], ",", 
     RowBox[{"x2", "[", "]"}], ",", 
     RowBox[{"x3", "[", "]"}], ",", 
     RowBox[{"x4", "[", "]"}], ",", 
     RowBox[{"x5", "[", "]"}]}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"8c9502ba-78f6-4d34-894d-d8b4099437a2"],

Cell[BoxData[
 RowBox[{"DefScalarFunction", "[", "\[CapitalOmega]", "]"}]], "Input",Expressi\
onUUID->"447b5b77-f879-4a14-ad31-fde629cdea23"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"met", "=", 
  RowBox[{"CTensor", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[CapitalOmega]", "[", 
       RowBox[{
        RowBox[{"x1", "[", "]"}], ",", 
        RowBox[{"x2", "[", "]"}], ",", 
        RowBox[{"x3", "[", "]"}], ",", 
        RowBox[{"x4", "[", "]"}], ",", 
        RowBox[{"x5", "[", "]"}]}], "]"}], "^", "2"}], 
     RowBox[{"IdentityMatrix", "[", "5", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "xs"}], ",", 
      RowBox[{"-", "xs"}]}], "}"}]}], "]"}]}]], "Input",ExpressionUUID->\
"299ce348-e793-4d0c-ac18-6a553b7790e7"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       SuperscriptBox[
        RowBox[{
         InterpretationBox[
          StyleBox["\[CapitalOmega]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[CapitalOmega],
          Editable->False], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x1",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x1[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["x2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x2[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["x3",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x3[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["x4",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x4[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["x5",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x5[],
           Editable->False]}], "]"}], "2"], ",", "0", ",", "0", ",", "0", ",",
        "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       SuperscriptBox[
        RowBox[{
         InterpretationBox[
          StyleBox["\[CapitalOmega]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[CapitalOmega],
          Editable->False], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x1",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x1[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["x2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x2[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["x3",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x3[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["x4",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x4[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["x5",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x5[],
           Editable->False]}], "]"}], "2"], ",", "0", ",", "0", ",", "0"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", 
       SuperscriptBox[
        RowBox[{
         InterpretationBox[
          StyleBox["\[CapitalOmega]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[CapitalOmega],
          Editable->False], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x1",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x1[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["x2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x2[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["x3",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x3[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["x4",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x4[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["x5",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x5[],
           Editable->False]}], "]"}], "2"], ",", "0", ",", "0"}], "}"}], ",", 
     
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", 
       SuperscriptBox[
        RowBox[{
         InterpretationBox[
          StyleBox["\[CapitalOmega]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[CapitalOmega],
          Editable->False], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x1",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x1[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["x2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x2[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["x3",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x3[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["x4",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x4[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["x5",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x5[],
           Editable->False]}], "]"}], "2"], ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", 
       SuperscriptBox[
        RowBox[{
         InterpretationBox[
          StyleBox["\[CapitalOmega]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[CapitalOmega],
          Editable->False], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["x1",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x1[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["x2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x2[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["x3",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x3[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["x4",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x4[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["x5",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x5[],
           Editable->False]}], "]"}], "2"]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "xs"}], ",", 
     RowBox[{"-", "xs"}]}], "}"}], ",", "0"}], "]"}]], "Output",ExpressionUUID\
->"5a9c078d-08fb-4843-8797-cfc988d3f447"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"$CVSimplify", "=", "Simplify"}], ";"}]], "Input",ExpressionUUID->\
"5af9489f-f066-431b-8125-03d5a3e0541c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"SetCMetric", "[", 
   RowBox[{"met", ",", "xs", ",", 
    RowBox[{"SignatureOfMetric", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"4", ",", "1", ",", "0"}], "}"}]}]}], "]"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"214d792a-dc77-4112-98eb-\
bff4bacf56d2"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.026258`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"56e3c156-7eb1-4911-9809-ad3db4efe334"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MetricCompute", "[", 
   RowBox[{"met", ",", "xs", ",", 
    RowBox[{"\"\<Weyl\>\"", "[", 
     RowBox[{
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}]}], "]"}]}], "]"}], "//", "AbsoluteTiming"}]], "Input",\
ExpressionUUID->"5ef4bc20-1a2f-426b-a366-72d28e8c9c57"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.583311`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"752e116f-69f9-4ebf-b437-45a43792a5d0"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"cd", "=", 
   RowBox[{"CovDOfMetric", "[", "met", "]"}]}], ";"}]], "Input",ExpressionUUID\
->"987e5b2f-bffd-44f2-b3da-42f35e0c444e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Weyl", "[", "cd", "]"}]], "Input",ExpressionUUID->"2457b3b2-0792-40b7-9876-bb8038cf0290"],

Cell[BoxData["Zero"], "Output",ExpressionUUID->"3797a011-346b-4688-aa02-54c93b741b9b"]
}, Open  ]],

Cell["Nonzero components of RiemannDown:", "Text",ExpressionUUID->"0958ad2e-1917-4817-a7a1-2a199bd80ed6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "[", 
  RowBox[{"nonzero", "=", 
   RowBox[{"DeleteCases", "[", 
    RowBox[{
     RowBox[{"Flatten", "@", 
      RowBox[{"First", "@", 
       RowBox[{"RiemannDown", "[", "cd", "]"}]}]}], ",", "0"}], "]"}]}], 
  "]"}]], "Input",ExpressionUUID->"fe1bd7cc-1a55-41d7-b83f-f199429e1a75"],

Cell[BoxData["280"], "Output",ExpressionUUID->"3838645f-6135-465b-a571-63d50b51ea23"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "[", 
  RowBox[{"differentnonzero", "=", 
   RowBox[{"DeleteDuplicates", "[", "nonzero", "]"}]}], "]"}]], "Input",Expres\
sionUUID->"3de8109c-2e3b-4742-8e2c-7ca67ff326e5"],

Cell[BoxData["40"], "Output",ExpressionUUID->"747bc38c-a06b-4cf5-b18a-513a0588bba6"]
}, Open  ]],

Cell["Apart from numerical factors:", "Text",ExpressionUUID->"8098a326-7a0c-4003-b85c-d633b446356d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Union", "[", 
   RowBox[{"differentnonzero", ",", 
    RowBox[{"SameTest", "\[Rule]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"NumericQ", "[", 
        RowBox[{"Simplify", "[", 
         RowBox[{"#1", "/", "#2"}], "]"}], "]"}], "&"}], ")"}]}]}], "]"}], "//",
   "Length"}]], "Input",ExpressionUUID->"b67b90af-99eb-4bb9-b7d9-\
8d6496d4e354"],

Cell[BoxData["20"], "Output",ExpressionUUID->"9ca83280-535d-4eab-889f-adebb7b81c33"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"RicciScalar", "[", "cd", "]"}], "[", "]"}]], "Input",ExpressionUUID\
->"7f44d335-4463-419a-aacf-be73ff813fdd"],

Cell[BoxData[
 RowBox[{"-", 
  RowBox[{
   FractionBox["1", 
    SuperscriptBox[
     RowBox[{
      InterpretationBox[
       StyleBox["\[CapitalOmega]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[CapitalOmega],
       Editable->False], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["x1",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x1[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["x2",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x2[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["x3",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x3[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["x4",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x4[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["x5",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x5[],
        Editable->False]}], "]"}], "4"]], 
   RowBox[{"4", " ", 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox[
       RowBox[{
        SuperscriptBox[
         InterpretationBox[
          StyleBox["\[CapitalOmega]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[CapitalOmega],
          Editable->False], 
         TagBox[
          RowBox[{"(", 
           RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "1"}], ")"}],
          Derivative],
         MultilineFunction->None], "[", 
        RowBox[{
         InterpretationBox[
          StyleBox["x1",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x1[],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["x2",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x2[],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["x3",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x3[],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["x4",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x4[],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["x5",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x5[],
          Editable->False]}], "]"}], "2"], "+", 
      SuperscriptBox[
       RowBox[{
        SuperscriptBox[
         InterpretationBox[
          StyleBox["\[CapitalOmega]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[CapitalOmega],
          Editable->False], 
         TagBox[
          RowBox[{"(", 
           RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "0"}], ")"}],
          Derivative],
         MultilineFunction->None], "[", 
        RowBox[{
         InterpretationBox[
          StyleBox["x1",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x1[],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["x2",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x2[],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["x3",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x3[],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["x4",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x4[],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["x5",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x5[],
          Editable->False]}], "]"}], "2"], "+", 
      SuperscriptBox[
       RowBox[{
        SuperscriptBox[
         InterpretationBox[
          StyleBox["\[CapitalOmega]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[CapitalOmega],
          Editable->False], 
         TagBox[
          RowBox[{"(", 
           RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "0"}], ")"}],
          Derivative],
         MultilineFunction->None], "[", 
        RowBox[{
         InterpretationBox[
          StyleBox["x1",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x1[],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["x2",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x2[],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["x3",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x3[],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["x4",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x4[],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["x5",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x5[],
          Editable->False]}], "]"}], "2"], "+", 
      SuperscriptBox[
       RowBox[{
        SuperscriptBox[
         InterpretationBox[
          StyleBox["\[CapitalOmega]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[CapitalOmega],
          Editable->False], 
         TagBox[
          RowBox[{"(", 
           RowBox[{"0", ",", "1", ",", "0", ",", "0", ",", "0"}], ")"}],
          Derivative],
         MultilineFunction->None], "[", 
        RowBox[{
         InterpretationBox[
          StyleBox["x1",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x1[],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["x2",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x2[],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["x3",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x3[],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["x4",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x4[],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["x5",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x5[],
          Editable->False]}], "]"}], "2"], "+", 
      SuperscriptBox[
       RowBox[{
        SuperscriptBox[
         InterpretationBox[
          StyleBox["\[CapitalOmega]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[CapitalOmega],
          Editable->False], 
         TagBox[
          RowBox[{"(", 
           RowBox[{"1", ",", "0", ",", "0", ",", "0", ",", "0"}], ")"}],
          Derivative],
         MultilineFunction->None], "[", 
        RowBox[{
         InterpretationBox[
          StyleBox["x1",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x1[],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["x2",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x2[],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["x3",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x3[],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["x4",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x4[],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["x5",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x5[],
          Editable->False]}], "]"}], "2"], "+", 
      RowBox[{"2", " ", 
       RowBox[{
        InterpretationBox[
         StyleBox["\[CapitalOmega]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[CapitalOmega],
         Editable->False], "[", 
        RowBox[{
         InterpretationBox[
          StyleBox["x1",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x1[],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["x2",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x2[],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["x3",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x3[],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["x4",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x4[],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["x5",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x5[],
          Editable->False]}], "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["\[CapitalOmega]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`\[CapitalOmega],
            Editable->False], 
           TagBox[
            RowBox[{"(", 
             RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "2"}], ")"}],
            Derivative],
           MultilineFunction->None], "[", 
          RowBox[{
           InterpretationBox[
            StyleBox["x1",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x1[],
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["x2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x2[],
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["x3",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x3[],
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["x4",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x4[],
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["x5",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x5[],
            Editable->False]}], "]"}], "+", 
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["\[CapitalOmega]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`\[CapitalOmega],
            Editable->False], 
           TagBox[
            RowBox[{"(", 
             RowBox[{"0", ",", "0", ",", "0", ",", "2", ",", "0"}], ")"}],
            Derivative],
           MultilineFunction->None], "[", 
          RowBox[{
           InterpretationBox[
            StyleBox["x1",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x1[],
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["x2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x2[],
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["x3",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x3[],
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["x4",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x4[],
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["x5",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x5[],
            Editable->False]}], "]"}], "+", 
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["\[CapitalOmega]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`\[CapitalOmega],
            Editable->False], 
           TagBox[
            RowBox[{"(", 
             RowBox[{"0", ",", "0", ",", "2", ",", "0", ",", "0"}], ")"}],
            Derivative],
           MultilineFunction->None], "[", 
          RowBox[{
           InterpretationBox[
            StyleBox["x1",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x1[],
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["x2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x2[],
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["x3",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x3[],
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["x4",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x4[],
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["x5",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x5[],
            Editable->False]}], "]"}], "+", 
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["\[CapitalOmega]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`\[CapitalOmega],
            Editable->False], 
           TagBox[
            RowBox[{"(", 
             RowBox[{"0", ",", "2", ",", "0", ",", "0", ",", "0"}], ")"}],
            Derivative],
           MultilineFunction->None], "[", 
          RowBox[{
           InterpretationBox[
            StyleBox["x1",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x1[],
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["x2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x2[],
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["x3",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x3[],
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["x4",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x4[],
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["x5",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x5[],
            Editable->False]}], "]"}], "+", 
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["\[CapitalOmega]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`\[CapitalOmega],
            Editable->False], 
           TagBox[
            RowBox[{"(", 
             RowBox[{"2", ",", "0", ",", "0", ",", "0", ",", "0"}], ")"}],
            Derivative],
           MultilineFunction->None], "[", 
          RowBox[{
           InterpretationBox[
            StyleBox["x1",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x1[],
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["x2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x2[],
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["x3",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x3[],
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["x4",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x4[],
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["x5",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x5[],
            Editable->False]}], "]"}]}], ")"}]}]}], ")"}]}]}]}]], "Output",Exp\
ressionUUID->"018d2b73-ba86-45ec-b20f-474e2f6bb9b5"]
}, Open  ]],

Cell["Constant curvature case:", "Text",ExpressionUUID->"4d0dca66-19e7-49aa-99e2-3895b0b8a738"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ccrule", "=", 
  RowBox[{"\[CapitalOmega]", "\[Rule]", 
   RowBox[{"Function", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x1", ",", "x2", ",", "x3", ",", "x4", ",", "x5"}], "}"}], ",", 
     
     RowBox[{"1", "/", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{
         RowBox[{"\[Kappa]", "/", "4"}], 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"x1", "^", "2"}], "+", 
           RowBox[{"x2", "^", "2"}], "+", 
           RowBox[{"x3", "^", "2"}], "+", 
           RowBox[{"x4", "^", "2"}], "+", 
           RowBox[{"x5", "^", "2"}]}], ")"}]}]}], ")"}]}]}], 
    "]"}]}]}]], "Input",ExpressionUUID->"721ae7f2-ae78-41de-b238-\
9ee009af16d9"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox["\[CapitalOmega]",
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`\[CapitalOmega],
   Editable->False], "\[Rule]", 
  RowBox[{"Function", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"x1", ",", "x2", ",", "x3", ",", "x4", ",", "x5"}], "}"}], ",", 
    FractionBox["1", 
     RowBox[{"1", "+", 
      RowBox[{
       FractionBox["1", "4"], " ", "\[Kappa]", " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["x1", "2"], "+", 
         SuperscriptBox["x2", "2"], "+", 
         SuperscriptBox["x3", "2"], "+", 
         SuperscriptBox["x4", "2"], "+", 
         SuperscriptBox["x5", "2"]}], ")"}]}]}]]}], "]"}]}]], "Output",Express\
ionUUID->"101e55c5-f848-425a-81a8-c707e529cb83"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"%%", "/.", "ccrule"}], "//", "Simplify"}]], "Input",ExpressionUUID-\
>"9bcf5aca-b89a-4a5d-a6bc-8c87491c6b1f"],

Cell[BoxData[
 RowBox[{"20", " ", "\[Kappa]"}]], "Output",ExpressionUUID->"4833e300-bc43-46e7-a73b-0e34517559a9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Ricci", "[", "cd", "]"}], "\[Equal]", 
    RowBox[{"4", "\[Kappa]", " ", "met"}]}], "/.", "ccrule"}], "//", 
  "Simplify"}]], "Input",ExpressionUUID->"eedd74ab-c2f5-4872-a035-\
4a94150a80e0"],

Cell[BoxData["True"], "Output",ExpressionUUID->"7cc13b00-413e-4fcf-87a2-515c4f182767"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{
  "ccrule", ",", "\[Kappa]", ",", "met", ",", "cd", ",", "nonzero", ",", 
   "differentnonzero"}], "]"}]], "Input",ExpressionUUID->"b089a02c-6e08-47f1-\
9cd9-1b0abe258a2b"],

Cell[BoxData[
 RowBox[{"UndefScalarFunction", "[", "\[CapitalOmega]", "]"}]], "Input",Expres\
sionUUID->"37bac93b-fc00-494e-b0c4-7f95f9d9d4e1"],

Cell[BoxData[
 RowBox[{"UndefChart", "[", "xs", "]"}]], "Input",ExpressionUUID->"534aa7f9-d7e2-4872-b9a2-2ece2bb98060"],

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M", "]"}]], "Input",ExpressionUUID->"fa2830ef-35e2-4b38-8274-9a3d2015f058"],

Cell[BoxData[
 RowBox[{"ClearxCobaCache", "[", "All", "]"}]], "Input",ExpressionUUID->"cc82fd06-1a0d-4a6f-ac93-fb514d4017c4"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.6. Kerr in Boyer-Lindquist x-coordinates", "Subsubsection",ExpressionUUID->"12a68b4a-08fc-407b-99df-8f1f7321e03a"],

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M", ",", "4", ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "e", ",", "d", ",", "f"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"b6c20777-3ef4-424a-8a15-7960dd077cbe"],

Cell[BoxData[
 RowBox[{"DefChart", "[", 
  RowBox[{"BL", ",", "M", ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"t", "[", "]"}], ",", 
     RowBox[{"r", "[", "]"}], ",", 
     RowBox[{"x", "[", "]"}], ",", 
     RowBox[{"\[Phi]", "[", "]"}]}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"b6114ce4-9371-4978-a665-82e2c602018d"],

Cell[BoxData[
 RowBox[{"DefConstantSymbol", "[", 
  RowBox[{"{", 
   RowBox[{"\[CapitalMu]", ",", "\[Alpha]"}], "}"}], "]"}]], "Input",Expressio\
nUUID->"0d7e1c71-0465-4eb6-9d15-9240595d0792"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Sigma", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"r", "[", "]"}], "^", "2"}], "+", 
    RowBox[{
     RowBox[{"\[Alpha]", "^", "2"}], 
     RowBox[{
      RowBox[{"x", "[", "]"}], "^", "2"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Delta", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"r", "[", "]"}], "^", "2"}], "+", 
    RowBox[{"\[Alpha]", "^", "2"}], "-", 
    RowBox[{"2", "\[CapitalMu]", " ", 
     RowBox[{"r", "[", "]"}]}]}]}], ";"}]}], "Input",ExpressionUUID->\
"ed7453e3-7959-4164-a10b-be1bc2d8a16f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"met", "=", 
  RowBox[{"CTensor", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"1", "-", 
         RowBox[{"2", "\[CapitalMu]", " ", 
          RowBox[{
           RowBox[{"r", "[", "]"}], "/", "Sigma"}]}]}], ",", "0", ",", "0", 
        ",", 
        RowBox[{"2", "\[Alpha]", " ", "\[CapitalMu]", " ", 
         RowBox[{"r", "[", "]"}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "-", 
            RowBox[{
             RowBox[{"x", "[", "]"}], "^", "2"}]}], ")"}], "/", "Sigma"}]}]}],
        "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", 
        RowBox[{
         RowBox[{"-", "Sigma"}], "/", "Delta"}], ",", "0", ",", "0"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", 
        RowBox[{
         RowBox[{"-", "Sigma"}], "/", 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{
            RowBox[{"x", "[", "]"}], "^", "2"}]}], ")"}]}], ",", "0"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"2", "\[Alpha]", " ", "\[CapitalMu]", " ", 
         RowBox[{"r", "[", "]"}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "-", 
            RowBox[{
             RowBox[{"x", "[", "]"}], "^", "2"}]}], ")"}], "/", "Sigma"}]}], 
        ",", "0", ",", "0", ",", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"(", 
           RowBox[{"1", "-", 
            RowBox[{
             RowBox[{"x", "[", "]"}], "^", "2"}]}], ")"}]}], 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"r", "[", "]"}], "^", "2"}], "+", 
           RowBox[{"\[Alpha]", "^", "2"}], "+", 
           RowBox[{"2", 
            RowBox[{"\[Alpha]", "^", "2"}], "\[CapitalMu]", " ", 
            RowBox[{"r", "[", "]"}], 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"1", "-", 
               RowBox[{
                RowBox[{"x", "[", "]"}], "^", "2"}]}], ")"}], "/", 
             "Sigma"}]}]}], ")"}]}]}], "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "BL"}], ",", 
      RowBox[{"-", "BL"}]}], "}"}]}], "]"}]}]], "Input",ExpressionUUID->\
"30ff07c8-e743-44f9-af98-740a48d64231"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "-", 
        FractionBox[
         RowBox[{"2", " ", 
          InterpretationBox[
           StyleBox["\[CapitalMu]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[CapitalMu],
           Editable->False], " ", 
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False]}], 
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], "2"], "+", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["\[Alpha]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Alpha],
             Editable->False], "2"], " ", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["x",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`x[],
             Editable->False], "2"]}]}]]}], ",", "0", ",", "0", ",", 
       FractionBox[
        RowBox[{"2", " ", 
         InterpretationBox[
          StyleBox["\[Alpha]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[Alpha],
          Editable->False], " ", 
         InterpretationBox[
          StyleBox["\[CapitalMu]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[CapitalMu],
          Editable->False], " ", 
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False], " ", 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["x",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`x[],
             Editable->False], "2"]}], ")"}]}], 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], "2"], "+", 
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["\[Alpha]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`\[Alpha],
            Editable->False], "2"], " ", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["x",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x[],
            Editable->False], "2"]}]}]]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       FractionBox[
        RowBox[{
         RowBox[{"-", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], "2"]}], "-", 
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["\[Alpha]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`\[Alpha],
            Editable->False], "2"], " ", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["x",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x[],
            Editable->False], "2"]}]}], 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["\[Alpha]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Alpha],
           Editable->False], "2"], "-", 
         RowBox[{"2", " ", 
          InterpretationBox[
           StyleBox["\[CapitalMu]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[CapitalMu],
           Editable->False], " ", 
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False]}], "+", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], "2"]}]], ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", 
       FractionBox[
        RowBox[{
         RowBox[{"-", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], "2"]}], "-", 
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["\[Alpha]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`\[Alpha],
            Editable->False], "2"], " ", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["x",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x[],
            Editable->False], "2"]}]}], 
        RowBox[{"1", "-", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], "2"]}]], ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       FractionBox[
        RowBox[{"2", " ", 
         InterpretationBox[
          StyleBox["\[Alpha]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[Alpha],
          Editable->False], " ", 
         InterpretationBox[
          StyleBox["\[CapitalMu]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[CapitalMu],
          Editable->False], " ", 
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False], " ", 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["x",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`x[],
             Editable->False], "2"]}], ")"}]}], 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], "2"], "+", 
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["\[Alpha]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`\[Alpha],
            Editable->False], "2"], " ", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["x",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x[],
            Editable->False], "2"]}]}]], ",", "0", ",", "0", ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["x",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x[],
            Editable->False], "2"]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["\[Alpha]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`\[Alpha],
            Editable->False], "2"], "+", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], "2"], "+", 
          FractionBox[
           RowBox[{"2", " ", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["\[Alpha]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Alpha],
              Editable->False], "2"], " ", 
            InterpretationBox[
             StyleBox["\[CapitalMu]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[CapitalMu],
             Editable->False], " ", 
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False], " ", 
            RowBox[{"(", 
             RowBox[{"1", "-", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], "2"]}], ")"}]}], 
           RowBox[{
            SuperscriptBox[
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False], "2"], "+", 
            RowBox[{
             SuperscriptBox[
              InterpretationBox[
               StyleBox["\[Alpha]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Alpha],
               Editable->False], "2"], " ", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], "2"]}]}]]}], ")"}]}]}], "}"}]}], "}"}], ",", 
   
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "BL"}], ",", 
     RowBox[{"-", "BL"}]}], "}"}], ",", "0"}], "]"}]], "Output",ExpressionUUID\
->"9a9338ef-5c3f-4578-9b9f-50ff9bb1b966"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"$CVSimplify", "=", "Simplify"}], ";"}]], "Input",ExpressionUUID->\
"dab2a559-913d-462d-9592-385f209d6c0b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"SetCMetric", "[", 
   RowBox[{"met", ",", "BL", ",", 
    RowBox[{"SignatureOfMetric", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"3", ",", "1", ",", "0"}], "}"}]}]}], "]"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"3a447a01-2d9a-4729-a091-\
104a7ac4b2b7"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.425828`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"921e251b-aaeb-4ddd-94ed-82ad28259b2c"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"MetricCompute", "[", 
  RowBox[{"met", ",", "BL", ",", 
   RowBox[{"\"\<Weyl\>\"", "[", 
    RowBox[{
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}]}], "]"}]}], "]"}]], "Input",ExpressionUUID->"dec48f3b-\
5377-4c53-a4da-121b93b71f2a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Ricci", "[", 
  RowBox[{"CovDOfMetric", "[", "met", "]"}], "]"}]], "Input",ExpressionUUID->\
"ab664741-753d-423e-9dd7-2205ab972e8e"],

Cell[BoxData["Zero"], "Output",ExpressionUUID->"630b328f-3280-44c9-be7e-8fef14f6640c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MetricCompute", "[", 
   RowBox[{"met", ",", "BL", ",", 
    RowBox[{"\"\<CDRiemann\>\"", "[", 
     RowBox[{
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}]}], "]"}]}], "]"}], "//", "AbsoluteTiming"}]], "Input",\
ExpressionUUID->"1684be53-32bc-4d62-a934-35644e083665"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.153513`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"e5040d74-c2ae-4e42-9c2d-eec604f93323"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"cd", "=", 
   RowBox[{"CovDOfMetric", "[", "met", "]"}]}], ";"}]], "Input",ExpressionUUID\
->"bea7c16d-9140-441a-ad41-304bf186c286"],

Cell[BoxData[
 RowBox[{
  RowBox[{"cdR", "=", 
   RowBox[{"TensorDerivative", "[", 
    RowBox[{
     RowBox[{"RiemannDown", "[", "cd", "]"}], ",", "cd"}], "]"}]}], 
  ";"}]], "Input",ExpressionUUID->"940ad7a3-0a1b-477b-82d8-db56b45e527d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"cdR", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}], ",", 
     RowBox[{"-", "d"}], ",", 
     RowBox[{"-", "e"}]}], "]"}], "+", 
   RowBox[{"cdR", "[", 
    RowBox[{
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}], ",", 
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "d"}], ",", 
     RowBox[{"-", "e"}]}], "]"}], "+", 
   RowBox[{"cdR", "[", 
    RowBox[{
     RowBox[{"-", "c"}], ",", 
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "d"}], ",", 
     RowBox[{"-", "e"}]}], "]"}]}], "//", "Simplify"}]], "Input",ExpressionUUI\
D->"a21cc8ce-2498-464b-91d6-0f4bbdd5b78d"],

Cell[BoxData["0"], "Output",ExpressionUUID->"c5748ead-167e-423b-a449-9a843af62312"]
}, Open  ]],

Cell["\<\
Find Killing vectors. Assume [r, x] dependence of the contravariant \
components of the Killings:\
\>", "Text",ExpressionUUID->"dea6c461-a06d-4570-bb47-25daa6d5032e"],

Cell[BoxData[
 RowBox[{"DefScalarFunction", "[", 
  RowBox[{"{", 
   RowBox[{"\[Xi]0", ",", "\[Xi]1", ",", "\[Xi]2", ",", "\[Xi]3"}], "}"}], 
  "]"}]], "Input",ExpressionUUID->"d7579109-332c-4f13-91ad-82ccd7fa8c42"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"\[Xi]", "=", 
    RowBox[{"CTensor", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"\[Xi]0", "[", 
         RowBox[{
          RowBox[{"r", "[", "]"}], ",", 
          RowBox[{"x", "[", "]"}]}], "]"}], ",", 
        RowBox[{"\[Xi]1", "[", 
         RowBox[{
          RowBox[{"r", "[", "]"}], ",", 
          RowBox[{"x", "[", "]"}]}], "]"}], ",", 
        RowBox[{"\[Xi]2", "[", 
         RowBox[{
          RowBox[{"r", "[", "]"}], ",", 
          RowBox[{"x", "[", "]"}]}], "]"}], ",", 
        RowBox[{"\[Xi]3", "[", 
         RowBox[{
          RowBox[{"r", "[", "]"}], ",", 
          RowBox[{"x", "[", "]"}]}], "]"}]}], "}"}], ",", 
      RowBox[{"{", "BL", "}"}]}], "]"}]}], ")"}], "[", "a", "]"}]], "Input",Ex\
pressionUUID->"8c4e8fca-be4a-49f8-83f3-fbb88da80b13"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox[
            RowBox[{
             InterpretationBox[
              StyleBox["\[Xi]0",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Xi]0,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False]}], "]"}],
            RowBox[{
              RowBox[{"{", "1", "}"}], "\[Rule]", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{"\[Xi]0"}], AutoSpacing -> False, ShowAutoStyles -> 
                  False], $CellContext`\[Xi]0, Editable -> False], "[", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                   "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`r[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                   "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`x[], Editable -> False]}], "]"}]}]],
           Annotation[#, {1} -> $CellContext`\[Xi]0[
              $CellContext`r[], 
              $CellContext`x[]], "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox[
            RowBox[{
             InterpretationBox[
              StyleBox["\[Xi]1",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Xi]1,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False]}], "]"}],
            RowBox[{
              RowBox[{"{", "2", "}"}], "\[Rule]", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{"\[Xi]1"}], AutoSpacing -> False, ShowAutoStyles -> 
                  False], $CellContext`\[Xi]1, Editable -> False], "[", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                   "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`r[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                   "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`x[], Editable -> False]}], "]"}]}]],
           Annotation[#, {2} -> $CellContext`\[Xi]1[
              $CellContext`r[], 
              $CellContext`x[]], "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox[
            RowBox[{
             InterpretationBox[
              StyleBox["\[Xi]2",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Xi]2,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False]}], "]"}],
            RowBox[{
              RowBox[{"{", "3", "}"}], "\[Rule]", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{"\[Xi]2"}], AutoSpacing -> False, ShowAutoStyles -> 
                  False], $CellContext`\[Xi]2, Editable -> False], "[", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                   "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`r[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                   "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`x[], Editable -> False]}], "]"}]}]],
           Annotation[#, {3} -> $CellContext`\[Xi]2[
              $CellContext`r[], 
              $CellContext`x[]], "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox[
            RowBox[{
             InterpretationBox[
              StyleBox["\[Xi]3",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Xi]3,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False]}], "]"}],
            RowBox[{
              RowBox[{"{", "4", "}"}], "\[Rule]", 
              RowBox[{
                InterpretationBox[
                 StyleBox[
                  RowBox[{"\[Xi]3"}], AutoSpacing -> False, ShowAutoStyles -> 
                  False], $CellContext`\[Xi]3, Editable -> False], "[", 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                   "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`r[], Editable -> False], ",", 
                  InterpretationBox[
                   StyleBox[
                   "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`x[], Editable -> False]}], "]"}]}]],
           Annotation[#, {4} -> $CellContext`\[Xi]3[
              $CellContext`r[], 
              $CellContext`x[]], "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {
           1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {"a"},
         {" "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{
    $CellContext`\[Xi]0[
     $CellContext`r[], 
     $CellContext`x[]], 
    $CellContext`\[Xi]1[
     $CellContext`r[], 
     $CellContext`x[]], 
    $CellContext`\[Xi]2[
     $CellContext`r[], 
     $CellContext`x[]], 
    $CellContext`\[Xi]3[
     $CellContext`r[], 
     $CellContext`x[]]}, {$CellContext`BL}, 0][$CellContext`a],
  Editable->False]], "Output",ExpressionUUID->"d10e1697-24e8-433a-bee4-\
a85e24edcebd"]
}, Open  ]],

Cell["We can compute the equations in two equivalent ways:", "Text",ExpressionUUID->"bb436d15-6df0-43ef-b346-8a4d74aba296"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"LieD", "[", 
     RowBox[{"\[Xi]", "[", "a", "]"}], "]"}], "[", 
    RowBox[{"met", "[", 
     RowBox[{
      RowBox[{"-", "a"}], ",", 
      RowBox[{"-", "b"}]}], "]"}], "]"}], "==", 
   RowBox[{
    RowBox[{
     RowBox[{"cd", "[", 
      RowBox[{"-", "a"}], "]"}], "[", 
     RowBox[{"\[Xi]", "[", 
      RowBox[{"-", "b"}], "]"}], "]"}], "+", 
    RowBox[{
     RowBox[{"cd", "[", 
      RowBox[{"-", "b"}], "]"}], "[", 
     RowBox[{"\[Xi]", "[", 
      RowBox[{"-", "a"}], "]"}], "]"}]}]}], "//", "Simplify"}]], "Input",Expre\
ssionUUID->"436c0ef0-3786-4a12-a8f1-392dc962d9e4"],

Cell[BoxData["True"], "Output",ExpressionUUID->"94ec639e-c9ff-4cb6-b722-053acd2e4b85"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Killing", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"First", "@", 
      RowBox[{"Head", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"cd", "[", 
          RowBox[{"-", "a"}], "]"}], "[", 
         RowBox[{"\[Xi]", "[", 
          RowBox[{"-", "b"}], "]"}], "]"}], "+", 
        RowBox[{
         RowBox[{"cd", "[", 
          RowBox[{"-", "b"}], "]"}], "[", 
         RowBox[{"\[Xi]", "[", 
          RowBox[{"-", "a"}], "]"}], "]"}]}], "]"}]}], "//", "Simplify"}], "//",
     "Flatten"}], "//", "DeleteDuplicates"}]}]], "Input",ExpressionUUID->\
"3109327e-b460-41d9-8c10-750c8545c0ca"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox[
    RowBox[{"2", " ", 
     InterpretationBox[
      StyleBox["\[CapitalMu]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[CapitalMu],
      Editable->False], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], "2"], "-", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["\[Alpha]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Alpha],
             Editable->False], "2"], " ", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["x",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`x[],
             Editable->False], "2"]}]}], ")"}], " ", 
        RowBox[{
         InterpretationBox[
          StyleBox["\[Xi]1",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[Xi]1,
          Editable->False], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False]}], "]"}]}], "+", 
       RowBox[{"2", " ", 
        SuperscriptBox[
         InterpretationBox[
          StyleBox["\[Alpha]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[Alpha],
          Editable->False], "2"], " ", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False], " ", 
        RowBox[{
         InterpretationBox[
          StyleBox["\[Xi]2",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[Xi]2,
          Editable->False], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False]}], "]"}]}]}], ")"}]}], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox[
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], "2"], "+", 
       RowBox[{
        SuperscriptBox[
         InterpretationBox[
          StyleBox["\[Alpha]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[Alpha],
          Editable->False], "2"], " ", 
        SuperscriptBox[
         InterpretationBox[
          StyleBox["x",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x[],
          Editable->False], "2"]}]}], ")"}], "2"]], ",", 
   FractionBox[
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "2"}], " ", 
         InterpretationBox[
          StyleBox["\[CapitalMu]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[CapitalMu],
          Editable->False], " ", 
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False]}], "+", 
        SuperscriptBox[
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False], "2"], "+", 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["\[Alpha]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Alpha],
           Editable->False], "2"], " ", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], "2"]}]}], ")"}], " ", 
      RowBox[{
       SuperscriptBox[
        InterpretationBox[
         StyleBox["\[Xi]0",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Xi]0,
         Editable->False], 
        TagBox[
         RowBox[{"(", 
          RowBox[{"1", ",", "0"}], ")"}],
         Derivative],
        MultilineFunction->None], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False]}], "]"}]}], "-", 
     RowBox[{"2", " ", 
      InterpretationBox[
       StyleBox["\[Alpha]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Alpha],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox["\[CapitalMu]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[CapitalMu],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox[
         InterpretationBox[
          StyleBox["x",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x[],
          Editable->False], "2"]}], ")"}], " ", 
      RowBox[{
       SuperscriptBox[
        InterpretationBox[
         StyleBox["\[Xi]3",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Xi]3,
         Editable->False], 
        TagBox[
         RowBox[{"(", 
          RowBox[{"1", ",", "0"}], ")"}],
         Derivative],
        MultilineFunction->None], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False]}], "]"}]}]}], 
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "2"], "+", 
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], "2"], " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], "2"]}]}]], ",", 
   FractionBox[
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "2"}], " ", 
         InterpretationBox[
          StyleBox["\[CapitalMu]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[CapitalMu],
          Editable->False], " ", 
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False]}], "+", 
        SuperscriptBox[
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False], "2"], "+", 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["\[Alpha]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Alpha],
           Editable->False], "2"], " ", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], "2"]}]}], ")"}], " ", 
      RowBox[{
       SuperscriptBox[
        InterpretationBox[
         StyleBox["\[Xi]0",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Xi]0,
         Editable->False], 
        TagBox[
         RowBox[{"(", 
          RowBox[{"0", ",", "1"}], ")"}],
         Derivative],
        MultilineFunction->None], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False]}], "]"}]}], "-", 
     RowBox[{"2", " ", 
      InterpretationBox[
       StyleBox["\[Alpha]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Alpha],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox["\[CapitalMu]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[CapitalMu],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox[
         InterpretationBox[
          StyleBox["x",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x[],
          Editable->False], "2"]}], ")"}], " ", 
      RowBox[{
       SuperscriptBox[
        InterpretationBox[
         StyleBox["\[Xi]3",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Xi]3,
         Editable->False], 
        TagBox[
         RowBox[{"(", 
          RowBox[{"0", ",", "1"}], ")"}],
         Derivative],
        MultilineFunction->None], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False]}], "]"}]}]}], 
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "2"], "+", 
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], "2"], " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], "2"]}]}]], ",", 
   RowBox[{"-", 
    FractionBox[
     RowBox[{"2", " ", 
      InterpretationBox[
       StyleBox["\[Alpha]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Alpha],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox["\[CapitalMu]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[CapitalMu],
       Editable->False], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["x",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`x[],
             Editable->False], "2"]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False], "2"]}], "+", 
           RowBox[{
            SuperscriptBox[
             InterpretationBox[
              StyleBox["\[Alpha]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Alpha],
              Editable->False], "2"], " ", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["x",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`x[],
              Editable->False], "2"]}]}], ")"}], " ", 
         RowBox[{
          InterpretationBox[
           StyleBox["\[Xi]1",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Xi]1,
           Editable->False], "[", 
          RowBox[{
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["x",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x[],
            Editable->False]}], "]"}]}], "+", 
        RowBox[{"2", " ", 
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False], " ", 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["\[Alpha]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Alpha],
             Editable->False], "2"], "+", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False], "2"]}], ")"}], " ", 
         InterpretationBox[
          StyleBox["x",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x[],
          Editable->False], " ", 
         RowBox[{
          InterpretationBox[
           StyleBox["\[Xi]2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Xi]2,
           Editable->False], "[", 
          RowBox[{
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["x",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x[],
            Editable->False]}], "]"}]}]}], ")"}]}], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox[
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False], "2"], "+", 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["\[Alpha]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Alpha],
           Editable->False], "2"], " ", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], "2"]}]}], ")"}], "2"]]}], ",", 
   RowBox[{"-", 
    FractionBox[
     RowBox[{"2", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", 
             InterpretationBox[
              StyleBox["\[CapitalMu]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[CapitalMu],
              Editable->False]}], " ", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False], "2"]}], "+", 
           RowBox[{
            SuperscriptBox[
             InterpretationBox[
              StyleBox["\[Alpha]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Alpha],
              Editable->False], "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], "+", 
              RowBox[{
               InterpretationBox[
                StyleBox["\[CapitalMu]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[CapitalMu],
                Editable->False], " ", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], "2"]}], "-", 
              RowBox[{
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False], " ", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], "2"]}]}], ")"}]}]}], ")"}], " ", 
         RowBox[{
          InterpretationBox[
           StyleBox["\[Xi]1",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Xi]1,
           Editable->False], "[", 
          RowBox[{
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], ",", 
           InterpretationBox[
            StyleBox["x",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x[],
            Editable->False]}], "]"}]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["\[Alpha]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Alpha],
             Editable->False], "2"], "+", 
           RowBox[{
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "2"}], " ", 
               InterpretationBox[
                StyleBox["\[CapitalMu]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[CapitalMu],
                Editable->False]}], "+", 
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            SuperscriptBox[
             InterpretationBox[
              StyleBox["\[Alpha]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Alpha],
              Editable->False], "2"], " ", 
            InterpretationBox[
             StyleBox["x",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`x[],
             Editable->False], " ", 
            RowBox[{
             InterpretationBox[
              StyleBox["\[Xi]2",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Xi]2,
              Editable->False], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False]}], "]"}]}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox[
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False], "2"], "+", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["\[Alpha]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Alpha],
                 Editable->False], "2"], " ", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["x",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x[],
                 Editable->False], "2"]}]}], ")"}], " ", 
            RowBox[{
             SuperscriptBox[
              InterpretationBox[
               StyleBox["\[Xi]1",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Xi]1,
               Editable->False], 
              TagBox[
               RowBox[{"(", 
                RowBox[{"1", ",", "0"}], ")"}],
               Derivative],
              MultilineFunction->None], "[", 
             RowBox[{
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], ",", 
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False]}], "]"}]}]}], ")"}]}]}], ")"}]}], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox[
         InterpretationBox[
          StyleBox["\[Alpha]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[Alpha],
          Editable->False], "2"], "+", 
        RowBox[{
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "2"}], " ", 
            InterpretationBox[
             StyleBox["\[CapitalMu]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[CapitalMu],
             Editable->False]}], "+", 
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False]}], ")"}]}]}], ")"}], "2"]]}], ",", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox[
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], "2"], "+", 
       RowBox[{
        SuperscriptBox[
         InterpretationBox[
          StyleBox["\[Alpha]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[Alpha],
          Editable->False], "2"], " ", 
        SuperscriptBox[
         InterpretationBox[
          StyleBox["x",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x[],
          Editable->False], "2"]}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["x",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`x[],
             Editable->False], "2"]}], ")"}]}], " ", 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["\[Xi]1",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Xi]1,
           Editable->False], 
          TagBox[
           RowBox[{"(", 
            RowBox[{"0", ",", "1"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False]}], "]"}]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["\[Alpha]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`\[Alpha],
            Editable->False], "2"], "+", 
          RowBox[{
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "2"}], " ", 
              InterpretationBox[
               StyleBox["\[CapitalMu]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[CapitalMu],
               Editable->False]}], "+", 
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False]}], ")"}]}]}], ")"}], " ", 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["\[Xi]2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Xi]2,
           Editable->False], 
          TagBox[
           RowBox[{"(", 
            RowBox[{"1", ",", "0"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False]}], "]"}]}]}], ")"}]}], 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox[
        InterpretationBox[
         StyleBox["\[Alpha]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Alpha],
         Editable->False], "2"], "+", 
       RowBox[{
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "2"}], " ", 
           InterpretationBox[
            StyleBox["\[CapitalMu]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`\[CapitalMu],
            Editable->False]}], "+", 
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False]}], ")"}]}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False], "2"]}], ")"}]}]], ",", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False], "2"]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        InterpretationBox[
         StyleBox["\[Alpha]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Alpha],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox["\[CapitalMu]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[CapitalMu],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], " ", 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["\[Xi]0",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Xi]0,
           Editable->False], 
          TagBox[
           RowBox[{"(", 
            RowBox[{"1", ",", "0"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False]}], "]"}]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], "4"], "+", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["\[Alpha]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Alpha],
             Editable->False], "4"], " ", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["x",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`x[],
             Editable->False], "2"]}], "+", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["\[Alpha]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Alpha],
             Editable->False], "2"], " ", 
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", 
              InterpretationBox[
               StyleBox["\[CapitalMu]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[CapitalMu],
               Editable->False]}], "+", 
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False], "-", 
             RowBox[{"2", " ", 
              InterpretationBox[
               StyleBox["\[CapitalMu]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[CapitalMu],
               Editable->False], " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], "2"]}], "+", 
             RowBox[{
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], "2"]}]}], ")"}]}]}], ")"}], " ", 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["\[Xi]3",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Xi]3,
           Editable->False], 
          TagBox[
           RowBox[{"(", 
            RowBox[{"1", ",", "0"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False]}], "]"}]}]}], ")"}]}], 
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "2"], "+", 
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], "2"], " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], "2"]}]}]], ",", 
   FractionBox[
    RowBox[{"2", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["x",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x[],
            Editable->False], "2"]}], ")"}], " ", 
        RowBox[{
         InterpretationBox[
          StyleBox["\[Xi]1",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[Xi]1,
          Editable->False], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False]}], "]"}]}], "-", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["\[Alpha]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`\[Alpha],
            Editable->False], "2"], "+", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], "2"]}], ")"}], " ", 
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False], " ", 
        RowBox[{
         InterpretationBox[
          StyleBox["\[Xi]2",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[Xi]2,
          Editable->False], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False]}], "]"}]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["x",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x[],
            Editable->False], "2"]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], "2"], "+", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["\[Alpha]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Alpha],
             Editable->False], "2"], " ", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["x",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`x[],
             Editable->False], "2"]}]}], ")"}], " ", 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["\[Xi]2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Xi]2,
           Editable->False], 
          TagBox[
           RowBox[{"(", 
            RowBox[{"0", ",", "1"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False]}], "]"}]}]}], ")"}]}], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False], "2"]}], ")"}], "2"]], ",", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False], "2"]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        InterpretationBox[
         StyleBox["\[Alpha]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Alpha],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox["\[CapitalMu]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[CapitalMu],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], " ", 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["\[Xi]0",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Xi]0,
           Editable->False], 
          TagBox[
           RowBox[{"(", 
            RowBox[{"0", ",", "1"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False]}], "]"}]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], "4"], "+", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["\[Alpha]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Alpha],
             Editable->False], "4"], " ", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["x",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`x[],
             Editable->False], "2"]}], "+", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["\[Alpha]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Alpha],
             Editable->False], "2"], " ", 
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", 
              InterpretationBox[
               StyleBox["\[CapitalMu]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[CapitalMu],
               Editable->False]}], "+", 
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False], "-", 
             RowBox[{"2", " ", 
              InterpretationBox[
               StyleBox["\[CapitalMu]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[CapitalMu],
               Editable->False], " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], "2"]}], "+", 
             RowBox[{
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], "2"]}]}], ")"}]}]}], ")"}], " ", 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["\[Xi]3",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Xi]3,
           Editable->False], 
          TagBox[
           RowBox[{"(", 
            RowBox[{"0", ",", "1"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False]}], "]"}]}]}], ")"}]}], 
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "2"], "+", 
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], "2"], " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], "2"]}]}]], ",", 
   RowBox[{
    FractionBox["1", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox[
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False], "2"], "+", 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["\[Alpha]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Alpha],
           Editable->False], "2"], " ", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], "2"]}]}], ")"}], "2"]], 
    RowBox[{"2", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["x",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`x[],
             Editable->False], "2"]}], ")"}]}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False], "5"]}], "+", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["\[Alpha]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Alpha],
             Editable->False], "2"], " ", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False], "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             InterpretationBox[
              StyleBox["\[CapitalMu]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[CapitalMu],
              Editable->False], "-", 
             RowBox[{
              InterpretationBox[
               StyleBox["\[CapitalMu]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[CapitalMu],
               Editable->False], " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], "2"]}], "-", 
             RowBox[{"2", " ", 
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], "2"]}]}], ")"}]}], "+", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["\[Alpha]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Alpha],
             Editable->False], "4"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False]}], " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], "4"]}], "+", 
             RowBox[{
              InterpretationBox[
               StyleBox["\[CapitalMu]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[CapitalMu],
               Editable->False], " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], "2"], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "1"}], "+", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], "2"]}], ")"}]}]}], ")"}]}]}], ")"}], " ", 
        
        RowBox[{
         InterpretationBox[
          StyleBox["\[Xi]1",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[Xi]1,
          Editable->False], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False]}], "]"}]}], "+", 
       RowBox[{
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False], " ", 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], "6"], "+", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["\[Alpha]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Alpha],
             Editable->False], "6"], " ", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["x",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`x[],
             Editable->False], "4"]}], "+", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["\[Alpha]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Alpha],
             Editable->False], "2"], " ", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False], "3"], " ", 
           RowBox[{"(", 
            RowBox[{
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False], "+", 
             RowBox[{"2", " ", 
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], "2"]}], "-", 
             RowBox[{"4", " ", 
              InterpretationBox[
               StyleBox["\[CapitalMu]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[CapitalMu],
               Editable->False], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "1"}], "+", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], "2"]}], ")"}]}]}], ")"}]}], "+", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["\[Alpha]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Alpha],
             Editable->False], "4"], " ", 
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], "2"], " ", 
              RowBox[{"(", 
               RowBox[{"2", "+", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], "2"]}], ")"}]}], "-", 
             RowBox[{"2", " ", 
              InterpretationBox[
               StyleBox["\[CapitalMu]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[CapitalMu],
               Editable->False], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "1"}], "+", 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["x",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x[],
                  Editable->False], "4"]}], ")"}]}]}], ")"}]}]}], ")"}], " ", 
        
        RowBox[{
         InterpretationBox[
          StyleBox["\[Xi]2",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[Xi]2,
          Editable->False], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False]}], "]"}]}]}], ")"}]}]}]}], "}"}]], "Output",Expres\
sionUUID->"624f4f40-91e6-4fd5-b7fe-c481714cc120"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Killing", "[", 
     RowBox[{"[", 
      RowBox[{"{", 
       RowBox[{"1", ",", "4"}], "}"}], "]"}], "]"}], "\[Equal]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\[Xi]1", "[", 
      RowBox[{
       RowBox[{"r", "[", "]"}], ",", 
       RowBox[{"x", "[", "]"}]}], "]"}], ",", 
     RowBox[{"\[Xi]2", "[", 
      RowBox[{
       RowBox[{"r", "[", "]"}], ",", 
       RowBox[{"x", "[", "]"}]}], "]"}]}], "}"}]}], "]"}]], "Input",Expression\
UUID->"2bf3ad48-3808-49e9-8eed-7f5615b12058"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{
      InterpretationBox[
       StyleBox["\[Xi]1",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Xi]1,
       Editable->False], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False]}], "]"}], "\[Rule]", "0"}], ",", 
    RowBox[{
     RowBox[{
      InterpretationBox[
       StyleBox["\[Xi]2",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Xi]2,
       Editable->False], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False]}], "]"}], "\[Rule]", "0"}]}], "}"}], "}"}]], "Output",\
ExpressionUUID->"0555e5c2-dd77-4e9c-9b63-892c9f213ff4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Killing", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Killing", "/.", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"\[Xi]1", "|", "\[Xi]2"}], ")"}], "\[Rule]", 
       RowBox[{"Function", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"r", ",", "x"}], "}"}], ",", "0"}], "]"}]}]}], "//", 
     "Simplify"}], "//", "DeleteDuplicates"}], "//", 
   RowBox[{
    RowBox[{"DeleteCases", "[", 
     RowBox[{"#", ",", "0"}], "]"}], "&"}]}]}]], "Input",ExpressionUUID->\
"2953969a-d3f3-414e-946b-94dc460470e7"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox[
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "2"}], " ", 
         InterpretationBox[
          StyleBox["\[CapitalMu]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[CapitalMu],
          Editable->False], " ", 
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False]}], "+", 
        SuperscriptBox[
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False], "2"], "+", 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["\[Alpha]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Alpha],
           Editable->False], "2"], " ", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], "2"]}]}], ")"}], " ", 
      RowBox[{
       SuperscriptBox[
        InterpretationBox[
         StyleBox["\[Xi]0",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Xi]0,
         Editable->False], 
        TagBox[
         RowBox[{"(", 
          RowBox[{"1", ",", "0"}], ")"}],
         Derivative],
        MultilineFunction->None], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False]}], "]"}]}], "-", 
     RowBox[{"2", " ", 
      InterpretationBox[
       StyleBox["\[Alpha]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Alpha],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox["\[CapitalMu]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[CapitalMu],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox[
         InterpretationBox[
          StyleBox["x",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x[],
          Editable->False], "2"]}], ")"}], " ", 
      RowBox[{
       SuperscriptBox[
        InterpretationBox[
         StyleBox["\[Xi]3",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Xi]3,
         Editable->False], 
        TagBox[
         RowBox[{"(", 
          RowBox[{"1", ",", "0"}], ")"}],
         Derivative],
        MultilineFunction->None], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False]}], "]"}]}]}], 
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "2"], "+", 
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], "2"], " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], "2"]}]}]], ",", 
   FractionBox[
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "2"}], " ", 
         InterpretationBox[
          StyleBox["\[CapitalMu]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[CapitalMu],
          Editable->False], " ", 
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False]}], "+", 
        SuperscriptBox[
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False], "2"], "+", 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["\[Alpha]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Alpha],
           Editable->False], "2"], " ", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], "2"]}]}], ")"}], " ", 
      RowBox[{
       SuperscriptBox[
        InterpretationBox[
         StyleBox["\[Xi]0",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Xi]0,
         Editable->False], 
        TagBox[
         RowBox[{"(", 
          RowBox[{"0", ",", "1"}], ")"}],
         Derivative],
        MultilineFunction->None], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False]}], "]"}]}], "-", 
     RowBox[{"2", " ", 
      InterpretationBox[
       StyleBox["\[Alpha]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Alpha],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox["\[CapitalMu]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[CapitalMu],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox[
         InterpretationBox[
          StyleBox["x",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x[],
          Editable->False], "2"]}], ")"}], " ", 
      RowBox[{
       SuperscriptBox[
        InterpretationBox[
         StyleBox["\[Xi]3",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Xi]3,
         Editable->False], 
        TagBox[
         RowBox[{"(", 
          RowBox[{"0", ",", "1"}], ")"}],
         Derivative],
        MultilineFunction->None], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False]}], "]"}]}]}], 
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "2"], "+", 
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], "2"], " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], "2"]}]}]], ",", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False], "2"]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        InterpretationBox[
         StyleBox["\[Alpha]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Alpha],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox["\[CapitalMu]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[CapitalMu],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], " ", 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["\[Xi]0",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Xi]0,
           Editable->False], 
          TagBox[
           RowBox[{"(", 
            RowBox[{"1", ",", "0"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False]}], "]"}]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], "4"], "+", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["\[Alpha]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Alpha],
             Editable->False], "4"], " ", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["x",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`x[],
             Editable->False], "2"]}], "+", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["\[Alpha]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Alpha],
             Editable->False], "2"], " ", 
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", 
              InterpretationBox[
               StyleBox["\[CapitalMu]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[CapitalMu],
               Editable->False]}], "+", 
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False], "-", 
             RowBox[{"2", " ", 
              InterpretationBox[
               StyleBox["\[CapitalMu]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[CapitalMu],
               Editable->False], " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], "2"]}], "+", 
             RowBox[{
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], "2"]}]}], ")"}]}]}], ")"}], " ", 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["\[Xi]3",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Xi]3,
           Editable->False], 
          TagBox[
           RowBox[{"(", 
            RowBox[{"1", ",", "0"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False]}], "]"}]}]}], ")"}]}], 
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "2"], "+", 
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], "2"], " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], "2"]}]}]], ",", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False], "2"]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        InterpretationBox[
         StyleBox["\[Alpha]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Alpha],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox["\[CapitalMu]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[CapitalMu],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], " ", 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["\[Xi]0",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Xi]0,
           Editable->False], 
          TagBox[
           RowBox[{"(", 
            RowBox[{"0", ",", "1"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False]}], "]"}]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], "4"], "+", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["\[Alpha]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Alpha],
             Editable->False], "4"], " ", 
           SuperscriptBox[
            InterpretationBox[
             StyleBox["x",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`x[],
             Editable->False], "2"]}], "+", 
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["\[Alpha]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Alpha],
             Editable->False], "2"], " ", 
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", 
              InterpretationBox[
               StyleBox["\[CapitalMu]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[CapitalMu],
               Editable->False]}], "+", 
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False], "-", 
             RowBox[{"2", " ", 
              InterpretationBox[
               StyleBox["\[CapitalMu]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[CapitalMu],
               Editable->False], " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], "2"]}], "+", 
             RowBox[{
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], " ", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["x",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`x[],
                Editable->False], "2"]}]}], ")"}]}]}], ")"}], " ", 
        RowBox[{
         SuperscriptBox[
          InterpretationBox[
           StyleBox["\[Xi]3",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Xi]3,
           Editable->False], 
          TagBox[
           RowBox[{"(", 
            RowBox[{"0", ",", "1"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], ",", 
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False]}], "]"}]}]}], ")"}]}], 
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "2"], "+", 
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], "2"], " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], "2"]}]}]]}], "}"}]], "Output",ExpressionUUID->\
"ce8785fb-5297-46a8-bf00-1ce786de1840"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{"Killing", "==", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Xi]0",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Xi]0,
        Editable->False], 
       TagBox[
        RowBox[{"(", 
         RowBox[{"1", ",", "0"}], ")"}],
        Derivative],
       MultilineFunction->None], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False]}], "]"}], ",", 
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Xi]0",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Xi]0,
        Editable->False], 
       TagBox[
        RowBox[{"(", 
         RowBox[{"0", ",", "1"}], ")"}],
        Derivative],
       MultilineFunction->None], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False]}], "]"}], ",", 
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Xi]3",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Xi]3,
        Editable->False], 
       TagBox[
        RowBox[{"(", 
         RowBox[{"1", ",", "0"}], ")"}],
        Derivative],
       MultilineFunction->None], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False]}], "]"}], ",", 
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Xi]3",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Xi]3,
        Editable->False], 
       TagBox[
        RowBox[{"(", 
         RowBox[{"0", ",", "1"}], ")"}],
        Derivative],
       MultilineFunction->None], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False]}], "]"}]}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"e5ecd1b4-44e5-4613-abd0-331066231bf6"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Xi]0",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Xi]0,
        Editable->False], 
       TagBox[
        RowBox[{"(", 
         RowBox[{"1", ",", "0"}], ")"}],
        Derivative],
       MultilineFunction->None], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False]}], "]"}], "\[Rule]", "0"}], ",", 
    RowBox[{
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Xi]0",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Xi]0,
        Editable->False], 
       TagBox[
        RowBox[{"(", 
         RowBox[{"0", ",", "1"}], ")"}],
        Derivative],
       MultilineFunction->None], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False]}], "]"}], "\[Rule]", "0"}], ",", 
    RowBox[{
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Xi]3",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Xi]3,
        Editable->False], 
       TagBox[
        RowBox[{"(", 
         RowBox[{"1", ",", "0"}], ")"}],
        Derivative],
       MultilineFunction->None], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False]}], "]"}], "\[Rule]", "0"}], ",", 
    RowBox[{
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Xi]3",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Xi]3,
        Editable->False], 
       TagBox[
        RowBox[{"(", 
         RowBox[{"0", ",", "1"}], ")"}],
        Derivative],
       MultilineFunction->None], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False]}], "]"}], "\[Rule]", "0"}]}], "}"}], "}"}]], "Output",\
ExpressionUUID->"69993895-7186-41a7-828a-50e8a33450ce"]
}, Open  ]],

Cell["We can check the result with a Lie derivative:", "Text",ExpressionUUID->"c1990146-b559-4a53-927d-60101f5fa43e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"LieD", "[", 
   RowBox[{
    RowBox[{"CTensor", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"C0", ",", "0", ",", "0", ",", "C3"}], "}"}], ",", 
      RowBox[{"{", "BL", "}"}]}], "]"}], "[", "a", "]"}], "]"}], "[", 
  RowBox[{"met", "[", 
   RowBox[{
    RowBox[{"-", "a"}], ",", 
    RowBox[{"-", "b"}]}], "]"}], "]"}]], "Input",ExpressionUUID->"4bec6753-\
b488-41a2-812c-9acdaa347566"],

Cell[BoxData["0"], "Output",ExpressionUUID->"9e518739-38de-4666-8c82-d89543dcfa12"]
}, Open  ]],

Cell["Clean up:", "Text",ExpressionUUID->"2723ee0a-925c-4b27-94b0-9a7252c09fe1"],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{
  "met", ",", "cdR", ",", "Sigma", ",", "Delta", ",", "\[Xi]", ",", "C0", ",",
    "C3", ",", "cd", ",", "Killing"}], "]"}]], "Input",ExpressionUUID->\
"4c1aca98-bea3-4672-97e5-07fb831e30f2"],

Cell[BoxData[
 RowBox[{"UndefScalarFunction", "[", 
  RowBox[{"{", 
   RowBox[{"\[Xi]0", ",", "\[Xi]1", ",", "\[Xi]2", ",", "\[Xi]3"}], "}"}], 
  "]"}]], "Input",ExpressionUUID->"466570f7-0f25-4808-a21f-e5d7f87805a0"],

Cell[BoxData[
 RowBox[{"UndefConstantSymbol", "[", 
  RowBox[{"{", 
   RowBox[{"\[Alpha]", ",", "\[CapitalMu]"}], "}"}], "]"}]], "Input",Expressio\
nUUID->"77c5ba21-e68d-483e-b1fc-54602e82564b"],

Cell[BoxData[
 RowBox[{"UndefChart", "[", "BL", "]"}]], "Input",ExpressionUUID->"6570dca1-3d84-4b0f-b432-f3ec47f7b815"],

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M", "]"}]], "Input",ExpressionUUID->"846650e9-15ba-498b-aa1e-c35a0d2063ae"],

Cell[BoxData[
 RowBox[{"ClearxCobaCache", "[", "All", "]"}]], "Input",ExpressionUUID->"062a0c73-a55e-4f12-8584-dfbf89c404cc"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.7. Floratos-Kehagias 8-dim Ricci-flat metric", "Subsubsection",ExpressionUUID->"8f88bf39-48c1-48ee-9898-f5e803776026"],

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M", ",", "8", ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"d16c1067-ba8f-4601-a22b-766bac137f9b"],

Cell[BoxData[
 RowBox[{"DefChart", "[", 
  RowBox[{"FK", ",", "M", ",", 
   RowBox[{"Range", "[", "8", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x1", "[", "]"}], ",", 
     RowBox[{"x2", "[", "]"}], ",", 
     RowBox[{"x3", "[", "]"}], ",", 
     RowBox[{"x4", "[", "]"}], ",", 
     RowBox[{"x5", "[", "]"}], ",", 
     RowBox[{"x6", "[", "]"}], ",", 
     RowBox[{"x7", "[", "]"}], ",", 
     RowBox[{"x8", "[", "]"}]}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"488ad71b-ac62-4e89-852d-95b98c40dd1c"],

Cell[BoxData[
 RowBox[{"DefScalarFunction", "[", 
  RowBox[{"{", 
   RowBox[{
   "\[Alpha]", ",", "\[Beta]", ",", "\[Chi]", ",", "\[Upsilon]", ",", 
    "\[Gamma]", ",", "\[Eta]"}], "}"}], "]"}]], "Input",ExpressionUUID->\
"7c04ef44-e65d-45f3-9996-1b0f6dc5bfad"],

Cell[BoxData[
 RowBox[{
  RowBox[{"met", "=", 
   RowBox[{"CTensor", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"\[Upsilon]", "^", "2"}], " ", 
           RowBox[{"\[Gamma]", "^", "2"}], " ", 
           RowBox[{"\[Eta]", "^", "2"}]}], ",", "0", ",", "0", ",", "0", ",", 
          "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          RowBox[{
           RowBox[{"\[Upsilon]", "^", "2"}], " ", 
           RowBox[{"\[Gamma]", "^", "2"}], 
           RowBox[{"\[Eta]", "^", "2"}]}], ",", "0", ",", "0", ",", "0", ",", 
          "0", ",", "0", ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", 
          RowBox[{"1", "/", 
           RowBox[{"\[Upsilon]", "^", "2"}]}], ",", "0", ",", "0", ",", "0", 
          ",", "0", ",", 
          RowBox[{"2", 
           RowBox[{"\[Alpha]", "/", 
            RowBox[{"\[Upsilon]", "^", "2"}]}]}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0", ",", 
          RowBox[{"1", "/", 
           RowBox[{"\[Gamma]", "^", "2"}]}], ",", 
          RowBox[{"2", 
           RowBox[{"\[Beta]", "/", 
            RowBox[{"\[Gamma]", "^", "2"}]}]}], ",", "0", ",", "0", ",", 
          "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0", ",", 
          RowBox[{"2", 
           RowBox[{"\[Beta]", "/", 
            RowBox[{"\[Gamma]", "^", "2"}]}]}], ",", 
          RowBox[{
           RowBox[{"\[Gamma]", "^", "2"}], "+", 
           RowBox[{"4", 
            RowBox[{
             RowBox[{"\[Beta]", "^", "2"}], "/", 
             RowBox[{"\[Gamma]", "^", "2"}]}]}]}], ",", "0", ",", "0", ",", 
          "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
          RowBox[{
           RowBox[{"\[Eta]", "^", "2"}], "+", 
           RowBox[{"4", 
            RowBox[{
             RowBox[{"\[Chi]", "^", "2"}], "/", 
             RowBox[{"\[Eta]", "^", "2"}]}]}]}], ",", 
          RowBox[{"2", 
           RowBox[{"\[Chi]", "/", 
            RowBox[{"\[Eta]", "^", "2"}]}]}], ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
          RowBox[{"2", 
           RowBox[{"\[Chi]", "/", 
            RowBox[{"\[Eta]", "^", "2"}]}]}], ",", 
          RowBox[{"1", "/", 
           RowBox[{"\[Eta]", "^", "2"}]}], ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", 
          RowBox[{"2", 
           RowBox[{"\[Alpha]", "/", 
            RowBox[{"\[Upsilon]", "^", "2"}]}]}], ",", "0", ",", "0", ",", 
          "0", ",", "0", ",", 
          RowBox[{
           RowBox[{"4", 
            RowBox[{
             RowBox[{"\[Alpha]", "^", "2"}], "/", 
             RowBox[{"\[Upsilon]", "^", "2"}]}]}], "+", 
           RowBox[{"\[Upsilon]", "^", "2"}]}]}], "}"}]}], "}"}], "/.", 
      RowBox[{
       RowBox[{"f", ":", 
        RowBox[{"(", 
         RowBox[{
         "\[Alpha]", "|", "\[Beta]", "|", "\[Chi]", "|", "\[Upsilon]", "|", 
          "\[Gamma]", "|", "\[Eta]"}], ")"}]}], "\[Rule]", 
       RowBox[{"f", "[", 
        RowBox[{
         RowBox[{"x1", "[", "]"}], ",", 
         RowBox[{"x2", "[", "]"}]}], "]"}]}]}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "FK"}], ",", 
       RowBox[{"-", "FK"}]}], "}"}]}], "]"}]}], ";"}]], "Input",ExpressionUUID\
->"0c2697e6-ea62-4ea0-8d2c-6d0750f1940c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"met", "[", 
  RowBox[{
   RowBox[{"-", "a"}], ",", 
   RowBox[{"-", "b"}]}], "]"}]], "Input",ExpressionUUID->"5723f60a-45b6-47eb-\
ae39-7095f06aaf84"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox[
            RowBox[{
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["\[Gamma]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Gamma],
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x1",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x1[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["x2",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x2[],
                 Editable->False]}], "]"}], "2"], " ", 
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["\[Eta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Eta],
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x1",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x1[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["x2",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x2[],
                 Editable->False]}], "]"}], "2"], " ", 
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["\[Upsilon]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Upsilon],
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x1",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x1[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["x2",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x2[],
                 Editable->False]}], "]"}], "2"]}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
              RowBox[{
                SuperscriptBox[
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                SuperscriptBox[
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                SuperscriptBox[
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}]}]],
           
           Annotation[#, {1, 1} -> $CellContext`\[Gamma][
                $CellContext`x1[], 
                $CellContext`x2[]]^2 $CellContext`\[Eta][
                $CellContext`x1[], 
                $CellContext`x2[]]^2 $CellContext`\[Upsilon][
                $CellContext`x1[], 
                $CellContext`x2[]]^2, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 4} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "5"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 5} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "6"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 6} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "7"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 7} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "8"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 8} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["\[Gamma]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Gamma],
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x1",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x1[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["x2",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x2[],
                 Editable->False]}], "]"}], "2"], " ", 
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["\[Eta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Eta],
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x1",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x1[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["x2",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x2[],
                 Editable->False]}], "]"}], "2"], " ", 
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["\[Upsilon]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Upsilon],
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x1",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x1[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["x2",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x2[],
                 Editable->False]}], "]"}], "2"]}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
              RowBox[{
                SuperscriptBox[
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                SuperscriptBox[
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                SuperscriptBox[
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}]}]],
           
           Annotation[#, {2, 2} -> $CellContext`\[Gamma][
                $CellContext`x1[], 
                $CellContext`x2[]]^2 $CellContext`\[Eta][
                $CellContext`x1[], 
                $CellContext`x2[]]^2 $CellContext`\[Upsilon][
                $CellContext`x1[], 
                $CellContext`x2[]]^2, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 4} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "5"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 5} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "6"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 6} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "7"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 7} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "8"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 8} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            FractionBox["1", 
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["\[Upsilon]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Upsilon],
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x1",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x1[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["x2",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x2[],
                 Editable->False]}], "]"}], "2"]],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "3"}], "}"}], "\[Rule]", 
              FractionBox["1", 
               SuperscriptBox[
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                   Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]]}]],
           Annotation[#, {3, 3} -> $CellContext`\[Upsilon][
               $CellContext`x1[], 
               $CellContext`x2[]]^(-2), "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 4} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "5"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 5} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "6"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 6} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "7"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 7} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            FractionBox[
             RowBox[{"2", " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["\[Alpha]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Alpha],
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x1",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x1[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["x2",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x2[],
                 Editable->False]}], "]"}]}], 
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["\[Upsilon]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Upsilon],
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x1",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x1[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["x2",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x2[],
                 Editable->False]}], "]"}], "2"]],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "8"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{"2", " ", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
               SuperscriptBox[
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                   Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]]}]],
           Annotation[#, {3, 8} -> 2 $CellContext`\[Alpha][
               $CellContext`x1[], 
               $CellContext`x2[]] $CellContext`\[Upsilon][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2), "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            FractionBox["1", 
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["\[Gamma]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Gamma],
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x1",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x1[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["x2",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x2[],
                 Editable->False]}], "]"}], "2"]],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "4"}], "}"}], "\[Rule]", 
              FractionBox["1", 
               SuperscriptBox[
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                   False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]]}]],
           Annotation[#, {4, 4} -> $CellContext`\[Gamma][
               $CellContext`x1[], 
               $CellContext`x2[]]^(-2), "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            FractionBox[
             RowBox[{"2", " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["\[Beta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Beta],
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x1",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x1[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["x2",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x2[],
                 Editable->False]}], "]"}]}], 
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["\[Gamma]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Gamma],
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x1",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x1[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["x2",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x2[],
                 Editable->False]}], "]"}], "2"]],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "5"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{"2", " ", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Beta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Beta], Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
               SuperscriptBox[
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                   False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]]}]],
           Annotation[#, {4, 5} -> 2 $CellContext`\[Beta][
               $CellContext`x1[], 
               $CellContext`x2[]] $CellContext`\[Gamma][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2), "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "6"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 6} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "7"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 7} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "8"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 8} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"5", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {5, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"5", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {5, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"5", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {5, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            FractionBox[
             RowBox[{"2", " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["\[Beta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Beta],
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x1",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x1[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["x2",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x2[],
                 Editable->False]}], "]"}]}], 
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["\[Gamma]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Gamma],
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x1",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x1[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["x2",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x2[],
                 Editable->False]}], "]"}], "2"]],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"5", ",", "4"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{"2", " ", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Beta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Beta], Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
               SuperscriptBox[
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                   False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]]}]],
           Annotation[#, {5, 4} -> 2 $CellContext`\[Beta][
               $CellContext`x1[], 
               $CellContext`x2[]] $CellContext`\[Gamma][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2), "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{
             FractionBox[
              RowBox[{"4", " ", 
               SuperscriptBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["\[Beta]",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`\[Beta],
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x1",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x1[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["x2",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x2[],
                   Editable->False]}], "]"}], "2"]}], 
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["\[Gamma]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Gamma],
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"]], "+", 
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["\[Gamma]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Gamma],
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x1",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x1[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["x2",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x2[],
                 Editable->False]}], "]"}], "2"]}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"5", ",", "5"}], "}"}], "\[Rule]", 
              RowBox[{
                FractionBox[
                 RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Beta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Beta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]], 
                "+", 
                SuperscriptBox[
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}]}]],
           
           Annotation[#, {5, 5} -> 4 $CellContext`\[Beta][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^2 $CellContext`\[Gamma][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^(-2) + $CellContext`\[Gamma][
                $CellContext`x1[], 
                $CellContext`x2[]]^2, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"5", ",", "6"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {5, 6} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"5", ",", "7"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {5, 7} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"5", ",", "8"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {5, 8} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"6", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {6, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"6", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {6, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"6", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {6, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"6", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {6, 4} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"6", ",", "5"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {6, 5} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["\[Eta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Eta],
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x1",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x1[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["x2",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x2[],
                 Editable->False]}], "]"}], "2"], "+", 
             FractionBox[
              RowBox[{"4", " ", 
               SuperscriptBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["\[Chi]",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`\[Chi],
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x1",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x1[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["x2",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x2[],
                   Editable->False]}], "]"}], "2"]}], 
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["\[Eta]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Eta],
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"]]}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"6", ",", "6"}], "}"}], "\[Rule]", 
              RowBox[{
                SuperscriptBox[
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], "+", 
                FractionBox[
                 RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]]}]}]],
           Annotation[#, {6, 6} -> $CellContext`\[Eta][
                $CellContext`x1[], 
                $CellContext`x2[]]^2 + 4 $CellContext`\[Eta][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^(-2) $CellContext`\[Chi][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^2, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            FractionBox[
             RowBox[{"2", " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["\[Chi]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Chi],
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x1",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x1[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["x2",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x2[],
                 Editable->False]}], "]"}]}], 
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["\[Eta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Eta],
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x1",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x1[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["x2",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x2[],
                 Editable->False]}], "]"}], "2"]],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"6", ",", "7"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{"2", " ", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
               SuperscriptBox[
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]]}]],
           Annotation[#, {6, 7} -> 2 $CellContext`\[Eta][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) $CellContext`\[Chi][
               $CellContext`x1[], 
               $CellContext`x2[]], "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"6", ",", "8"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {6, 8} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"7", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {7, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"7", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {7, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"7", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {7, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"7", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {7, 4} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"7", ",", "5"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {7, 5} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            FractionBox[
             RowBox[{"2", " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["\[Chi]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Chi],
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x1",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x1[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["x2",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x2[],
                 Editable->False]}], "]"}]}], 
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["\[Eta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Eta],
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x1",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x1[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["x2",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x2[],
                 Editable->False]}], "]"}], "2"]],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"7", ",", "6"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{"2", " ", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
               SuperscriptBox[
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]]}]],
           Annotation[#, {7, 6} -> 2 $CellContext`\[Eta][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) $CellContext`\[Chi][
               $CellContext`x1[], 
               $CellContext`x2[]], "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            FractionBox["1", 
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["\[Eta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Eta],
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x1",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x1[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["x2",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x2[],
                 Editable->False]}], "]"}], "2"]],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"7", ",", "7"}], "}"}], "\[Rule]", 
              FractionBox["1", 
               SuperscriptBox[
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]]}]],
           Annotation[#, {7, 7} -> $CellContext`\[Eta][
               $CellContext`x1[], 
               $CellContext`x2[]]^(-2), "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"7", ",", "8"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {7, 8} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"8", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {8, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"8", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {8, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            FractionBox[
             RowBox[{"2", " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["\[Alpha]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Alpha],
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x1",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x1[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["x2",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x2[],
                 Editable->False]}], "]"}]}], 
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["\[Upsilon]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Upsilon],
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x1",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x1[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["x2",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x2[],
                 Editable->False]}], "]"}], "2"]],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"8", ",", "3"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{"2", " ", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
               SuperscriptBox[
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                   Editable -> False], "[", 
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]]}]],
           Annotation[#, {8, 3} -> 2 $CellContext`\[Alpha][
               $CellContext`x1[], 
               $CellContext`x2[]] $CellContext`\[Upsilon][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2), "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"8", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {8, 4} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"8", ",", "5"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {8, 5} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"8", ",", "6"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {8, 6} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"8", ",", "7"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {8, 7} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{
             FractionBox[
              RowBox[{"4", " ", 
               SuperscriptBox[
                RowBox[{
                 InterpretationBox[
                  StyleBox["\[Alpha]",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`\[Alpha],
                  Editable->False], "[", 
                 RowBox[{
                  InterpretationBox[
                   StyleBox["x1",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x1[],
                   Editable->False], ",", 
                  InterpretationBox[
                   StyleBox["x2",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`x2[],
                   Editable->False]}], "]"}], "2"]}], 
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["\[Upsilon]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Upsilon],
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"]], "+", 
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["\[Upsilon]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Upsilon],
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x1",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x1[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["x2",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x2[],
                 Editable->False]}], "]"}], "2"]}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"8", ",", "8"}], "}"}], "\[Rule]", 
              RowBox[{
                FractionBox[
                 RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]], 
                "+", 
                SuperscriptBox[
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}]}]],
           
           Annotation[#, {8, 8} -> 4 $CellContext`\[Alpha][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^2 $CellContext`\[Upsilon][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^(-2) + $CellContext`\[Upsilon][
                $CellContext`x1[], 
                $CellContext`x2[]]^2, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 9 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 9 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {" ", " "},
         {"a", "b"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{$CellContext`\[Gamma][
        $CellContext`x1[], 
        $CellContext`x2[]]^2 $CellContext`\[Eta][
        $CellContext`x1[], 
        $CellContext`x2[]]^2 $CellContext`\[Upsilon][
        $CellContext`x1[], 
        $CellContext`x2[]]^2, 0, 0, 0, 0, 0, 0, 0}, {
    0, $CellContext`\[Gamma][
        $CellContext`x1[], 
        $CellContext`x2[]]^2 $CellContext`\[Eta][
        $CellContext`x1[], 
        $CellContext`x2[]]^2 $CellContext`\[Upsilon][
        $CellContext`x1[], 
        $CellContext`x2[]]^2, 0, 0, 0, 0, 0, 0}, {
    0, 0, $CellContext`\[Upsilon][
       $CellContext`x1[], 
       $CellContext`x2[]]^(-2), 0, 0, 0, 0, 2 $CellContext`\[Alpha][
       $CellContext`x1[], 
       $CellContext`x2[]] $CellContext`\[Upsilon][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2)}, {0, 0, 0, $CellContext`\[Gamma][
       $CellContext`x1[], 
       $CellContext`x2[]]^(-2), 2 $CellContext`\[Beta][
       $CellContext`x1[], 
       $CellContext`x2[]] $CellContext`\[Gamma][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2), 0, 0, 0}, {0, 0, 0, 2 $CellContext`\[Beta][
       $CellContext`x1[], 
       $CellContext`x2[]] $CellContext`\[Gamma][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2), 4 $CellContext`\[Beta][
         $CellContext`x1[], 
         $CellContext`x2[]]^2 $CellContext`\[Gamma][
         $CellContext`x1[], 
         $CellContext`x2[]]^(-2) + $CellContext`\[Gamma][
        $CellContext`x1[], 
        $CellContext`x2[]]^2, 0, 0, 0}, {0, 0, 0, 0, 0, $CellContext`\[Eta][
        $CellContext`x1[], 
        $CellContext`x2[]]^2 + 4 $CellContext`\[Eta][
         $CellContext`x1[], 
         $CellContext`x2[]]^(-2) $CellContext`\[Chi][
         $CellContext`x1[], 
         $CellContext`x2[]]^2, 2 $CellContext`\[Eta][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) $CellContext`\[Chi][
       $CellContext`x1[], 
       $CellContext`x2[]], 0}, {0, 0, 0, 0, 0, 2 $CellContext`\[Eta][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) $CellContext`\[Chi][
       $CellContext`x1[], 
       $CellContext`x2[]], $CellContext`\[Eta][
       $CellContext`x1[], 
       $CellContext`x2[]]^(-2), 0}, {0, 0, 2 $CellContext`\[Alpha][
       $CellContext`x1[], 
       $CellContext`x2[]] $CellContext`\[Upsilon][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2), 0, 0, 0, 0, 4 $CellContext`\[Alpha][
         $CellContext`x1[], 
         $CellContext`x2[]]^2 $CellContext`\[Upsilon][
         $CellContext`x1[], 
         $CellContext`x2[]]^(-2) + $CellContext`\[Upsilon][
        $CellContext`x1[], 
        $CellContext`x2[]]^2}}, {-$CellContext`FK, -$CellContext`FK}, 
   0][-$CellContext`a, -$CellContext`b],
  Editable->False]], "Output",ExpressionUUID->"a1f26f7c-161d-4781-a2ee-\
06509ce17218"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"$CVSimplify", "=", "Simplify"}], ";"}]], "Input",ExpressionUUID->\
"4a91eb24-afbf-4e39-8cbb-6d7d308922fe"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"SetCMetric", "[", 
   RowBox[{"met", ",", "FK", ",", 
    RowBox[{"SignatureOfMetric", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"7", ",", "1", ",", "0"}], "}"}]}]}], "]"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"720dd9ae-d81b-4685-8043-\
d9ee9d98d4b0"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.412763`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"8ba20255-f419-457a-ad7b-5c74d7af3521"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MetricCompute", "[", 
   RowBox[{"met", ",", "FK", ",", 
    RowBox[{"\"\<Weyl\>\"", "[", 
     RowBox[{
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}]}], "]"}], ",", 
    RowBox[{"Parallelize", "\[Rule]", "True"}]}], "]"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"35dacba5-8425-4e8c-bf69-\
00ea59287605"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"14.046771`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"269d040b-9f19-41eb-888d-fcecf657f99c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"ricci", "=", 
    RowBox[{"Ricci", "[", 
     RowBox[{"CovDOfMetric", "[", "met", "]"}], "]"}]}], ")"}], "[", 
  RowBox[{
   RowBox[{"-", "a"}], ",", 
   RowBox[{"-", "b"}]}], "]"}]], "Input",ExpressionUUID->"b2a2ad5c-80cf-4baf-\
bfd1-9c500189adc1"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
              RowBox[{
                RowBox[{"-", 
                  FractionBox[
                   RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Beta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Beta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "4"]]}], 
                "+", 
                FractionBox[
                 RowBox[{
                   SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], "-", 
                   SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]], 
                "+", 
                FractionBox[
                 RowBox[{
                   SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], "-", 
                   SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]], 
                "-", 
                FractionBox[
                 RowBox[{"2", " ", 
                   SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "4"]], 
                "-", 
                FractionBox[
                 RowBox[{
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "+", 
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]], "-", 
                FractionBox[
                 RowBox[{
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "+", 
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]], "-", 
                FractionBox[
                 RowBox[{
                   RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                   "+", 
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                    "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "3"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "4"]]}]}]],
           Annotation[#, {1, 1} -> (-2) $CellContext`\[Gamma][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^(-4) 
              Derivative[1, 0][$CellContext`\[Beta]][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^2 + $CellContext`\[Gamma][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^(-2) (
               Derivative[0, 1][$CellContext`\[Gamma]][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^2 - 
               Derivative[1, 0][$CellContext`\[Gamma]][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^2) + $CellContext`\[Eta][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^(-2) (
               Derivative[0, 1][$CellContext`\[Eta]][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^2 - Derivative[1, 0][$CellContext`\[Eta]][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^2) - 2 $CellContext`\[Eta][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-4) 
             Derivative[1, 0][$CellContext`\[Chi]][
                $CellContext`x1[], 
                $CellContext`x2[]]^2 - $CellContext`\[Gamma][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-1) (
              Derivative[0, 2][$CellContext`\[Gamma]][
                $CellContext`x1[], 
                $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Gamma]][
                $CellContext`x1[], 
                $CellContext`x2[]]) - $CellContext`\[Eta][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-1) (Derivative[0, 2][$CellContext`\[Eta]][
                $CellContext`x1[], 
                $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Eta]][
                $CellContext`x1[], 
                $CellContext`x2[]]) - $CellContext`\[Upsilon][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-4) (
              2 Derivative[1, 0][$CellContext`\[Alpha]][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^2 + $CellContext`\[Upsilon][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^2 (-
                 Derivative[0, 1][$CellContext`\[Upsilon]][
                    $CellContext`x1[], 
                    $CellContext`x2[]]^2 + 
                Derivative[1, 0][$CellContext`\[Upsilon]][
                   $CellContext`x1[], 
                   $CellContext`x2[]]^2) + $CellContext`\[Upsilon][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^3 (
                Derivative[0, 2][$CellContext`\[Upsilon]][
                  $CellContext`x1[], 
                  $CellContext`x2[]] + 
                Derivative[2, 0][$CellContext`\[Upsilon]][
                  $CellContext`x1[], 
                  $CellContext`x2[]])), "Tooltip"]& ], 
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
              RowBox[{
                RowBox[{"-", 
                  FractionBox[
                   RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "4"]]}], 
                "-", 
                FractionBox[
                 RowBox[{"2", " ", 
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Beta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Beta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Beta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Beta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "4"]], 
                "-", 
                FractionBox[
                 RowBox[{"2", " ", 
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]], 
                "-", 
                FractionBox[
                 RowBox[{"2", " ", 
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]], 
                "-", 
                FractionBox[
                 RowBox[{"2", " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "4"]]}]}]],
           Annotation[#, {1, 2} -> (-2) $CellContext`\[Upsilon][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^(-4) 
              Derivative[0, 1][$CellContext`\[Alpha]][
                $CellContext`x1[], 
                $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Alpha]][
                $CellContext`x1[], 
                $CellContext`x2[]] - 2 $CellContext`\[Gamma][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-4) Derivative[0, 1][$CellContext`\[Beta]][
               $CellContext`x1[], 
               $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Beta]][
               $CellContext`x1[], 
               $CellContext`x2[]] - 2 $CellContext`\[Gamma][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) 
             Derivative[0, 1][$CellContext`\[Gamma]][
               $CellContext`x1[], 
               $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Gamma]][
               $CellContext`x1[], 
               $CellContext`x2[]] - 2 $CellContext`\[Upsilon][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) 
             Derivative[0, 1][$CellContext`\[Upsilon]][
               $CellContext`x1[], 
               $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Upsilon]][
               $CellContext`x1[], 
               $CellContext`x2[]] - 2 $CellContext`\[Eta][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-4) ($CellContext`\[Eta][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^2 Derivative[0, 1][$CellContext`\[Eta]][
                 $CellContext`x1[], 
                 $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Eta]][
                 $CellContext`x1[], 
                 $CellContext`x2[]] + Derivative[0, 1][$CellContext`\[Chi]][
                 $CellContext`x1[], 
                 $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Chi]][
                 $CellContext`x1[], 
                 $CellContext`x2[]]), "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 4} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "5"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 5} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "6"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 6} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "7"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 7} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "8"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 8} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
              RowBox[{
                RowBox[{"-", 
                  FractionBox[
                   RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "4"]]}], 
                "-", 
                FractionBox[
                 RowBox[{"2", " ", 
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Beta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Beta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Beta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Beta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "4"]], 
                "-", 
                FractionBox[
                 RowBox[{"2", " ", 
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]], 
                "-", 
                FractionBox[
                 RowBox[{"2", " ", 
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]], 
                "-", 
                FractionBox[
                 RowBox[{"2", " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}]}], 
                    ")"}]}], 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "4"]]}]}]],
           Annotation[#, {2, 1} -> (-2) $CellContext`\[Upsilon][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^(-4) 
              Derivative[0, 1][$CellContext`\[Alpha]][
                $CellContext`x1[], 
                $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Alpha]][
                $CellContext`x1[], 
                $CellContext`x2[]] - 2 $CellContext`\[Gamma][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-4) Derivative[0, 1][$CellContext`\[Beta]][
               $CellContext`x1[], 
               $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Beta]][
               $CellContext`x1[], 
               $CellContext`x2[]] - 2 $CellContext`\[Gamma][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) 
             Derivative[0, 1][$CellContext`\[Gamma]][
               $CellContext`x1[], 
               $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Gamma]][
               $CellContext`x1[], 
               $CellContext`x2[]] - 2 $CellContext`\[Upsilon][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) 
             Derivative[0, 1][$CellContext`\[Upsilon]][
               $CellContext`x1[], 
               $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Upsilon]][
               $CellContext`x1[], 
               $CellContext`x2[]] - 2 $CellContext`\[Eta][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-4) ($CellContext`\[Eta][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^2 Derivative[0, 1][$CellContext`\[Eta]][
                 $CellContext`x1[], 
                 $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Eta]][
                 $CellContext`x1[], 
                 $CellContext`x2[]] + Derivative[0, 1][$CellContext`\[Chi]][
                 $CellContext`x1[], 
                 $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Chi]][
                 $CellContext`x1[], 
                 $CellContext`x2[]]), "Tooltip"]& ], 
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
              RowBox[{
                RowBox[{"-", 
                  FractionBox[
                   RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "4"]]}], 
                "-", 
                FractionBox[
                 RowBox[{"2", " ", 
                   SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "4"]], 
                "+", 
                FractionBox[
                 RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                   "+", 
                   SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]], 
                "+", 
                FractionBox[
                 RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                   "+", 
                   SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]], 
                "-", 
                FractionBox[
                 RowBox[{
                   RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Beta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Beta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                   "+", 
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], "-", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "4"]], 
                "-", 
                FractionBox[
                 RowBox[{
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "+", 
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]], "-", 
                FractionBox[
                 RowBox[{
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "+", 
                   RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]]}]}]],
           Annotation[#, {2, 2} -> (-2) $CellContext`\[Upsilon][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^(-4) 
              Derivative[0, 1][$CellContext`\[Alpha]][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^2 - 2 $CellContext`\[Eta][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-4) 
             Derivative[0, 1][$CellContext`\[Chi]][
                $CellContext`x1[], 
                $CellContext`x2[]]^2 + $CellContext`\[Eta][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^(-2) (-
                Derivative[0, 1][$CellContext`\[Eta]][
                   $CellContext`x1[], 
                   $CellContext`x2[]]^2 + 
               Derivative[1, 0][$CellContext`\[Eta]][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^2) + $CellContext`\[Upsilon][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^(-2) (-
                Derivative[0, 1][$CellContext`\[Upsilon]][
                   $CellContext`x1[], 
                   $CellContext`x2[]]^2 + 
               Derivative[1, 0][$CellContext`\[Upsilon]][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^2) - $CellContext`\[Gamma][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-4) (
              2 Derivative[0, 1][$CellContext`\[Beta]][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^2 + $CellContext`\[Gamma][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^2 (
                Derivative[0, 1][$CellContext`\[Gamma]][
                   $CellContext`x1[], 
                   $CellContext`x2[]]^2 - 
                Derivative[1, 0][$CellContext`\[Gamma]][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^2 + $CellContext`\[Gamma][
                   $CellContext`x1[], 
                   $CellContext`x2[]] (Derivative[0, 2][$CellContext`\[Gamma]][
                    $CellContext`x1[], 
                    $CellContext`x2[]] + 
                  Derivative[2, 0][$CellContext`\[Gamma]][
                    $CellContext`x1[], 
                    $CellContext`x2[]]))) - $CellContext`\[Eta][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-1) (Derivative[0, 2][$CellContext`\[Eta]][
                $CellContext`x1[], 
                $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Eta]][
                $CellContext`x1[], 
                $CellContext`x2[]]) - $CellContext`\[Upsilon][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-1) (
              Derivative[0, 2][$CellContext`\[Upsilon]][
                $CellContext`x1[], 
                $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Upsilon]][
                $CellContext`x1[], 
                $CellContext`x2[]]), "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 4} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "5"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 5} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "6"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 6} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "7"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 7} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "8"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 8} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "3"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 RowBox[{"2", " ", 
                   SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                 "+", 
                 RowBox[{"2", " ", 
                   SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                 "-", 
                 RowBox[{
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                 RowBox[{
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "3"], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
               RowBox[{
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "8"]}]]}]],
           Annotation[#, {3, 3} -> $CellContext`\[Gamma][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) $CellContext`\[Eta][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) $CellContext`\[Upsilon][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-8) (
              2 Derivative[0, 1][$CellContext`\[Alpha]][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^2 + 
              2 Derivative[1, 0][$CellContext`\[Alpha]][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^2 - $CellContext`\[Upsilon][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^2 (
               Derivative[0, 1][$CellContext`\[Upsilon]][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^2 + 
               Derivative[1, 0][$CellContext`\[Upsilon]][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^2) + $CellContext`\[Upsilon][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^3 (
                Derivative[0, 2][$CellContext`\[Upsilon]][
                  $CellContext`x1[], 
                  $CellContext`x2[]] + 
                Derivative[2, 0][$CellContext`\[Upsilon]][
                  $CellContext`x1[], 
                  $CellContext`x2[]])), "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 4} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "5"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 5} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "6"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 6} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "7"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 7} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "8"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "3"]}], 
                   " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                 RowBox[{"2", " ", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                    "-", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "3"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], 
               RowBox[{
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "8"]}]]}]],
           Annotation[#, {3, 8} -> $CellContext`\[Gamma][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) $CellContext`\[Eta][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) $CellContext`\[Upsilon][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-8) (-$CellContext`\[Upsilon][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^3 ((-4) 
                 Derivative[0, 1][$CellContext`\[Alpha]][
                   $CellContext`x1[], 
                   $CellContext`x2[]] 
                 Derivative[0, 1][$CellContext`\[Upsilon]][
                   $CellContext`x1[], 
                   $CellContext`x2[]] - 4 
                Derivative[1, 0][$CellContext`\[Alpha]][
                  $CellContext`x1[], 
                  $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Upsilon]][
                  $CellContext`x1[], 
                  $CellContext`x2[]] + $CellContext`\[Upsilon][
                   $CellContext`x1[], 
                   $CellContext`x2[]] (Derivative[0, 2][$CellContext`\[Alpha]][
                    $CellContext`x1[], 
                    $CellContext`x2[]] + 
                  Derivative[2, 0][$CellContext`\[Alpha]][
                    $CellContext`x1[], 
                    $CellContext`x2[]])) + 2 $CellContext`\[Alpha][
                 $CellContext`x1[], 
                 $CellContext`x2[]] (2 Derivative[0, 1][$CellContext`\[Alpha]][
                    $CellContext`x1[], 
                    $CellContext`x2[]]^2 + 
                2 Derivative[1, 0][$CellContext`\[Alpha]][
                    $CellContext`x1[], 
                    $CellContext`x2[]]^2 - $CellContext`\[Upsilon][
                   $CellContext`x1[], 
                   $CellContext`x2[]]^2 (
                 Derivative[0, 1][$CellContext`\[Upsilon]][
                    $CellContext`x1[], 
                    $CellContext`x2[]]^2 + 
                 Derivative[1, 0][$CellContext`\[Upsilon]][
                    $CellContext`x1[], 
                    $CellContext`x2[]]^2) + $CellContext`\[Upsilon][
                    $CellContext`x1[], 
                    $CellContext`x2[]]^3 (
                  Derivative[0, 2][$CellContext`\[Upsilon]][
                    $CellContext`x1[], 
                    $CellContext`x2[]] + 
                  Derivative[2, 0][$CellContext`\[Upsilon]][
                    $CellContext`x1[], 
                    $CellContext`x2[]]))), "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "4"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 RowBox[{"2", " ", 
                   SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Beta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Beta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                 "+", 
                 RowBox[{"2", " ", 
                   SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Beta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Beta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                 "-", 
                 RowBox[{
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                 RowBox[{
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "3"], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
               RowBox[{
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "8"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}]]}]],
           Annotation[#, {4, 4} -> $CellContext`\[Gamma][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-8) $CellContext`\[Eta][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) $CellContext`\[Upsilon][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) (
              2 Derivative[0, 1][$CellContext`\[Beta]][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^2 + 
              2 Derivative[1, 0][$CellContext`\[Beta]][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^2 - $CellContext`\[Gamma][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^2 (Derivative[0, 1][$CellContext`\[Gamma]][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^2 + 
               Derivative[1, 0][$CellContext`\[Gamma]][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^2) + $CellContext`\[Gamma][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^3 (
                Derivative[0, 2][$CellContext`\[Gamma]][
                  $CellContext`x1[], 
                  $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Gamma]][
                  $CellContext`x1[], 
                  $CellContext`x2[]])), "Tooltip"]& ], 
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "5"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "3"]}], 
                   " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Beta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Beta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Beta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Beta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Beta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Beta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Beta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Beta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                 RowBox[{"2", " ", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Beta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Beta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Beta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Beta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Beta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Beta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                    "-", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "3"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], 
               RowBox[{
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "8"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}]]}]],
           Annotation[#, {4, 5} -> $CellContext`\[Gamma][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-8) $CellContext`\[Eta][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) $CellContext`\[Upsilon][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) (-$CellContext`\[Gamma][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^3 ((-4) 
                 Derivative[0, 1][$CellContext`\[Beta]][
                   $CellContext`x1[], 
                   $CellContext`x2[]] 
                 Derivative[0, 1][$CellContext`\[Gamma]][
                   $CellContext`x1[], 
                   $CellContext`x2[]] - 4 
                Derivative[1, 0][$CellContext`\[Beta]][
                  $CellContext`x1[], 
                  $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Gamma]][
                  $CellContext`x1[], 
                  $CellContext`x2[]] + $CellContext`\[Gamma][
                   $CellContext`x1[], 
                   $CellContext`x2[]] (
                  Derivative[0, 2][$CellContext`\[Beta]][
                    $CellContext`x1[], 
                    $CellContext`x2[]] + 
                  Derivative[2, 0][$CellContext`\[Beta]][
                    $CellContext`x1[], 
                    $CellContext`x2[]])) + 2 $CellContext`\[Beta][
                 $CellContext`x1[], 
                 $CellContext`x2[]] (
                2 Derivative[0, 1][$CellContext`\[Beta]][
                    $CellContext`x1[], 
                    $CellContext`x2[]]^2 + 
                2 Derivative[1, 0][$CellContext`\[Beta]][
                    $CellContext`x1[], 
                    $CellContext`x2[]]^2 - $CellContext`\[Gamma][
                   $CellContext`x1[], 
                   $CellContext`x2[]]^2 (
                 Derivative[0, 1][$CellContext`\[Gamma]][
                    $CellContext`x1[], 
                    $CellContext`x2[]]^2 + 
                 Derivative[1, 0][$CellContext`\[Gamma]][
                    $CellContext`x1[], 
                    $CellContext`x2[]]^2) + $CellContext`\[Gamma][
                    $CellContext`x1[], 
                    $CellContext`x2[]]^3 (
                  Derivative[0, 2][$CellContext`\[Gamma]][
                    $CellContext`x1[], 
                    $CellContext`x2[]] + 
                  Derivative[2, 0][$CellContext`\[Gamma]][
                    $CellContext`x1[], 
                    $CellContext`x2[]]))), "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "6"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 6} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "7"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 7} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "8"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 8} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"5", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {5, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"5", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {5, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"5", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {5, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"5", ",", "4"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "3"]}], 
                   " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Beta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Beta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Beta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Beta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Beta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Beta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Beta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Beta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                 RowBox[{"2", " ", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Beta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Beta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Beta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Beta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Beta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Beta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                    "-", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "3"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], 
               RowBox[{
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "8"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}]]}]],
           Annotation[#, {5, 4} -> $CellContext`\[Gamma][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-8) $CellContext`\[Eta][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) $CellContext`\[Upsilon][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) (-$CellContext`\[Gamma][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^3 ((-4) 
                 Derivative[0, 1][$CellContext`\[Beta]][
                   $CellContext`x1[], 
                   $CellContext`x2[]] 
                 Derivative[0, 1][$CellContext`\[Gamma]][
                   $CellContext`x1[], 
                   $CellContext`x2[]] - 4 
                Derivative[1, 0][$CellContext`\[Beta]][
                  $CellContext`x1[], 
                  $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Gamma]][
                  $CellContext`x1[], 
                  $CellContext`x2[]] + $CellContext`\[Gamma][
                   $CellContext`x1[], 
                   $CellContext`x2[]] (
                  Derivative[0, 2][$CellContext`\[Beta]][
                    $CellContext`x1[], 
                    $CellContext`x2[]] + 
                  Derivative[2, 0][$CellContext`\[Beta]][
                    $CellContext`x1[], 
                    $CellContext`x2[]])) + 2 $CellContext`\[Beta][
                 $CellContext`x1[], 
                 $CellContext`x2[]] (
                2 Derivative[0, 1][$CellContext`\[Beta]][
                    $CellContext`x1[], 
                    $CellContext`x2[]]^2 + 
                2 Derivative[1, 0][$CellContext`\[Beta]][
                    $CellContext`x1[], 
                    $CellContext`x2[]]^2 - $CellContext`\[Gamma][
                   $CellContext`x1[], 
                   $CellContext`x2[]]^2 (
                 Derivative[0, 1][$CellContext`\[Gamma]][
                    $CellContext`x1[], 
                    $CellContext`x2[]]^2 + 
                 Derivative[1, 0][$CellContext`\[Gamma]][
                    $CellContext`x1[], 
                    $CellContext`x2[]]^2) + $CellContext`\[Gamma][
                    $CellContext`x1[], 
                    $CellContext`x2[]]^3 (
                  Derivative[0, 2][$CellContext`\[Gamma]][
                    $CellContext`x1[], 
                    $CellContext`x2[]] + 
                  Derivative[2, 0][$CellContext`\[Gamma]][
                    $CellContext`x1[], 
                    $CellContext`x2[]]))), "Tooltip"]& ], 
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"5", ",", "5"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 RowBox[{
                   RowBox[{"-", "4"}], " ", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Beta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Beta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "3"], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Beta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Beta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Beta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Beta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Beta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Beta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Beta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Beta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                 RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Beta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Beta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Beta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Beta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Beta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Beta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                    "-", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "3"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "-", 
                 RowBox[{
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "4"], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Beta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Beta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Beta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Beta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                    "-", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["x2", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "3"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], 
               RowBox[{
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "8"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}]]}]],
           Annotation[#, {5, 5} -> $CellContext`\[Gamma][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-8) $CellContext`\[Eta][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) $CellContext`\[Upsilon][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) ((-4) $CellContext`\[Beta][
                 $CellContext`x1[], 
                 $CellContext`x2[]] $CellContext`\[Gamma][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^3 ((-4) 
                 Derivative[0, 1][$CellContext`\[Beta]][
                   $CellContext`x1[], 
                   $CellContext`x2[]] 
                 Derivative[0, 1][$CellContext`\[Gamma]][
                   $CellContext`x1[], 
                   $CellContext`x2[]] - 4 
                Derivative[1, 0][$CellContext`\[Beta]][
                  $CellContext`x1[], 
                  $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Gamma]][
                  $CellContext`x1[], 
                  $CellContext`x2[]] + $CellContext`\[Gamma][
                   $CellContext`x1[], 
                   $CellContext`x2[]] (
                  Derivative[0, 2][$CellContext`\[Beta]][
                    $CellContext`x1[], 
                    $CellContext`x2[]] + 
                  Derivative[2, 0][$CellContext`\[Beta]][
                    $CellContext`x1[], 
                    $CellContext`x2[]])) + 4 $CellContext`\[Beta][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^2 (
                2 Derivative[0, 1][$CellContext`\[Beta]][
                    $CellContext`x1[], 
                    $CellContext`x2[]]^2 + 
                2 Derivative[1, 0][$CellContext`\[Beta]][
                    $CellContext`x1[], 
                    $CellContext`x2[]]^2 - $CellContext`\[Gamma][
                   $CellContext`x1[], 
                   $CellContext`x2[]]^2 (
                 Derivative[0, 1][$CellContext`\[Gamma]][
                    $CellContext`x1[], 
                    $CellContext`x2[]]^2 + 
                 Derivative[1, 0][$CellContext`\[Gamma]][
                    $CellContext`x1[], 
                    $CellContext`x2[]]^2) + $CellContext`\[Gamma][
                    $CellContext`x1[], 
                    $CellContext`x2[]]^3 (
                  Derivative[0, 2][$CellContext`\[Gamma]][
                    $CellContext`x1[], 
                    $CellContext`x2[]] + 
                  Derivative[2, 0][$CellContext`\[Gamma]][
                    $CellContext`x1[], 
                    $CellContext`x2[]])) - $CellContext`\[Gamma][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^4 (
               2 Derivative[0, 1][$CellContext`\[Beta]][
                   $CellContext`x1[], 
                   $CellContext`x2[]]^2 + 
               2 Derivative[1, 0][$CellContext`\[Beta]][
                   $CellContext`x1[], 
                   $CellContext`x2[]]^2 - $CellContext`\[Gamma][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^2 (
                Derivative[0, 1][$CellContext`\[Gamma]][
                   $CellContext`x1[], 
                   $CellContext`x2[]]^2 + 
                Derivative[1, 0][$CellContext`\[Gamma]][
                   $CellContext`x1[], 
                   $CellContext`x2[]]^2) + $CellContext`\[Gamma][
                   $CellContext`x1[], 
                   $CellContext`x2[]]^3 (
                 Derivative[0, 2][$CellContext`\[Gamma]][
                   $CellContext`x1[], 
                   $CellContext`x2[]] + 
                 Derivative[2, 0][$CellContext`\[Gamma]][
                   $CellContext`x1[], 
                   $CellContext`x2[]]))), "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"5", ",", "6"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {5, 6} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"5", ",", "7"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {5, 7} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"5", ",", "8"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {5, 8} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"6", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {6, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"6", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {6, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"6", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {6, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"6", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {6, 4} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"6", ",", "5"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {6, 5} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"6", ",", "6"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 RowBox[{
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "6"], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "-", 
                 RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                 RowBox[{"8", " ", 
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "-", 
                 RowBox[{
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "7"], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], ")"}]}],
                  "+", 
                 RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "3"], " ", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "-", 
                 RowBox[{"2", " ", 
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "4"], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], 
               RowBox[{
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "8"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}]]}]],
           Annotation[#, {6, 6} -> $CellContext`\[Gamma][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) $CellContext`\[Eta][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-8) $CellContext`\[Upsilon][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) ($CellContext`\[Eta][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^6 (
                Derivative[0, 1][$CellContext`\[Eta]][
                   $CellContext`x1[], 
                   $CellContext`x2[]]^2 + 
                Derivative[1, 0][$CellContext`\[Eta]][
                   $CellContext`x1[], 
                   $CellContext`x2[]]^2) - 4 $CellContext`\[Eta][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^2 $CellContext`\[Chi][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^2 (Derivative[0, 1][$CellContext`\[Eta]][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^2 + Derivative[1, 0][$CellContext`\[Eta]][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^2) + 8 $CellContext`\[Chi][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^2 (
                Derivative[0, 1][$CellContext`\[Chi]][
                   $CellContext`x1[], 
                   $CellContext`x2[]]^2 + 
                Derivative[1, 0][$CellContext`\[Chi]][
                   $CellContext`x1[], 
                   $CellContext`x2[]]^2) - $CellContext`\[Eta][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^7 (Derivative[0, 2][$CellContext`\[Eta]][
                 $CellContext`x1[], 
                 $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Eta]][
                 $CellContext`x1[], 
                 $CellContext`x2[]]) + 4 $CellContext`\[Eta][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^3 $CellContext`\[Chi][
                 $CellContext`x1[], 
                 $CellContext`x2[]] (4 Derivative[0, 1][$CellContext`\[Eta]][
                   $CellContext`x1[], 
                   $CellContext`x2[]] Derivative[0, 1][$CellContext`\[Chi]][
                   $CellContext`x1[], 
                   $CellContext`x2[]] + 
                4 Derivative[1, 0][$CellContext`\[Eta]][
                   $CellContext`x1[], 
                   $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Chi]][
                   $CellContext`x1[], 
                   $CellContext`x2[]] + $CellContext`\[Chi][
                   $CellContext`x1[], 
                   $CellContext`x2[]] (Derivative[0, 2][$CellContext`\[Eta]][
                    $CellContext`x1[], 
                    $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Eta]][
                    $CellContext`x1[], 
                    $CellContext`x2[]])) - 2 $CellContext`\[Eta][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^4 (Derivative[0, 1][$CellContext`\[Chi]][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^2 + Derivative[1, 0][$CellContext`\[Chi]][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^2 + 2 $CellContext`\[Chi][
                  $CellContext`x1[], 
                  $CellContext`x2[]] (Derivative[0, 2][$CellContext`\[Chi]][
                   $CellContext`x1[], 
                   $CellContext`x2[]] + 
                 Derivative[2, 0][$CellContext`\[Chi]][
                   $CellContext`x1[], 
                   $CellContext`x2[]]))), "Tooltip"]& ], 
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"6", ",", "7"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 RowBox[{
                   RowBox[{"-", "2"}], " ", 
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                 RowBox[{"4", " ", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                 RowBox[{"2", " ", 
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "3"], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "-", 
                 RowBox[{
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "4"], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
               RowBox[{
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "8"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}]]}]],
           Annotation[#, {6, 7} -> $CellContext`\[Gamma][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) $CellContext`\[Eta][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-8) $CellContext`\[Upsilon][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) ((-2) $CellContext`\[Eta][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^2 $CellContext`\[Chi][
                 $CellContext`x1[], 
                 $CellContext`x2[]] (Derivative[0, 1][$CellContext`\[Eta]][
                   $CellContext`x1[], 
                   $CellContext`x2[]]^2 + 
                Derivative[1, 0][$CellContext`\[Eta]][
                   $CellContext`x1[], 
                   $CellContext`x2[]]^2) + 4 $CellContext`\[Chi][
                 $CellContext`x1[], 
                 $CellContext`x2[]] (Derivative[0, 1][$CellContext`\[Chi]][
                   $CellContext`x1[], 
                   $CellContext`x2[]]^2 + 
                Derivative[1, 0][$CellContext`\[Chi]][
                   $CellContext`x1[], 
                   $CellContext`x2[]]^2) + 2 $CellContext`\[Eta][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^3 (
                2 Derivative[0, 1][$CellContext`\[Eta]][
                   $CellContext`x1[], 
                   $CellContext`x2[]] Derivative[0, 1][$CellContext`\[Chi]][
                   $CellContext`x1[], 
                   $CellContext`x2[]] + 
                2 Derivative[1, 0][$CellContext`\[Eta]][
                   $CellContext`x1[], 
                   $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Chi]][
                   $CellContext`x1[], 
                   $CellContext`x2[]] + $CellContext`\[Chi][
                   $CellContext`x1[], 
                   $CellContext`x2[]] (Derivative[0, 2][$CellContext`\[Eta]][
                    $CellContext`x1[], 
                    $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Eta]][
                    $CellContext`x1[], 
                    $CellContext`x2[]])) - $CellContext`\[Eta][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^4 (Derivative[0, 2][$CellContext`\[Chi]][
                 $CellContext`x1[], 
                 $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Chi]][
                 $CellContext`x1[], 
                 $CellContext`x2[]])), "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"6", ",", "8"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {6, 8} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"7", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {7, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"7", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {7, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"7", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {7, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"7", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {7, 4} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"7", ",", "5"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {7, 5} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"7", ",", "6"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 RowBox[{
                   RowBox[{"-", "2"}], " ", 
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox["x1", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                 RowBox[{"4", " ", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                 RowBox[{"2", " ", 
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "3"], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "-", 
                 RowBox[{
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "4"], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
               RowBox[{
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "8"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}]]}]],
           Annotation[#, {7, 6} -> $CellContext`\[Gamma][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) $CellContext`\[Eta][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-8) $CellContext`\[Upsilon][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) ((-2) $CellContext`\[Eta][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^2 $CellContext`\[Chi][
                 $CellContext`x1[], 
                 $CellContext`x2[]] (Derivative[0, 1][$CellContext`\[Eta]][
                   $CellContext`x1[], 
                   $CellContext`x2[]]^2 + 
                Derivative[1, 0][$CellContext`\[Eta]][
                   $CellContext`x1[], 
                   $CellContext`x2[]]^2) + 4 $CellContext`\[Chi][
                 $CellContext`x1[], 
                 $CellContext`x2[]] (Derivative[0, 1][$CellContext`\[Chi]][
                   $CellContext`x1[], 
                   $CellContext`x2[]]^2 + 
                Derivative[1, 0][$CellContext`\[Chi]][
                   $CellContext`x1[], 
                   $CellContext`x2[]]^2) + 2 $CellContext`\[Eta][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^3 (
                2 Derivative[0, 1][$CellContext`\[Eta]][
                   $CellContext`x1[], 
                   $CellContext`x2[]] Derivative[0, 1][$CellContext`\[Chi]][
                   $CellContext`x1[], 
                   $CellContext`x2[]] + 
                2 Derivative[1, 0][$CellContext`\[Eta]][
                   $CellContext`x1[], 
                   $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Chi]][
                   $CellContext`x1[], 
                   $CellContext`x2[]] + $CellContext`\[Chi][
                   $CellContext`x1[], 
                   $CellContext`x2[]] (Derivative[0, 2][$CellContext`\[Eta]][
                    $CellContext`x1[], 
                    $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Eta]][
                    $CellContext`x1[], 
                    $CellContext`x2[]])) - $CellContext`\[Eta][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^4 (Derivative[0, 2][$CellContext`\[Chi]][
                 $CellContext`x1[], 
                 $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Chi]][
                 $CellContext`x1[], 
                 $CellContext`x2[]])), "Tooltip"]& ], 
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"7", ",", "7"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                   " ", 
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                 RowBox[{"2", " ", 
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                 RowBox[{
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "3"], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], 
               RowBox[{
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "8"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}]]}]],
           Annotation[#, {7, 7} -> $CellContext`\[Gamma][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) $CellContext`\[Eta][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-8) $CellContext`\[Upsilon][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) (-$CellContext`\[Eta][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^2 (
                Derivative[0, 1][$CellContext`\[Eta]][
                   $CellContext`x1[], 
                   $CellContext`x2[]]^2 + 
                Derivative[1, 0][$CellContext`\[Eta]][
                   $CellContext`x1[], 
                   $CellContext`x2[]]^2) + 
              2 (Derivative[0, 1][$CellContext`\[Chi]][
                   $CellContext`x1[], 
                   $CellContext`x2[]]^2 + 
                Derivative[1, 0][$CellContext`\[Chi]][
                   $CellContext`x1[], 
                   $CellContext`x2[]]^2) + $CellContext`\[Eta][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^3 (
                Derivative[0, 2][$CellContext`\[Eta]][
                  $CellContext`x1[], 
                  $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Eta]][
                  $CellContext`x1[], 
                  $CellContext`x2[]])), "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"7", ",", "8"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {7, 8} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"8", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {8, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"8", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {8, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"8", ",", "3"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "3"]}], 
                   " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                 RowBox[{"2", " ", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                    "-", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "3"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}]}], 
               RowBox[{
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "8"]}]]}]],
           Annotation[#, {8, 3} -> $CellContext`\[Gamma][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) $CellContext`\[Eta][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) $CellContext`\[Upsilon][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-8) (-$CellContext`\[Upsilon][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^3 ((-4) 
                 Derivative[0, 1][$CellContext`\[Alpha]][
                   $CellContext`x1[], 
                   $CellContext`x2[]] 
                 Derivative[0, 1][$CellContext`\[Upsilon]][
                   $CellContext`x1[], 
                   $CellContext`x2[]] - 4 
                Derivative[1, 0][$CellContext`\[Alpha]][
                  $CellContext`x1[], 
                  $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Upsilon]][
                  $CellContext`x1[], 
                  $CellContext`x2[]] + $CellContext`\[Upsilon][
                   $CellContext`x1[], 
                   $CellContext`x2[]] (Derivative[0, 2][$CellContext`\[Alpha]][
                    $CellContext`x1[], 
                    $CellContext`x2[]] + 
                  Derivative[2, 0][$CellContext`\[Alpha]][
                    $CellContext`x1[], 
                    $CellContext`x2[]])) + 2 $CellContext`\[Alpha][
                 $CellContext`x1[], 
                 $CellContext`x2[]] (2 Derivative[0, 1][$CellContext`\[Alpha]][
                    $CellContext`x1[], 
                    $CellContext`x2[]]^2 + 
                2 Derivative[1, 0][$CellContext`\[Alpha]][
                    $CellContext`x1[], 
                    $CellContext`x2[]]^2 - $CellContext`\[Upsilon][
                   $CellContext`x1[], 
                   $CellContext`x2[]]^2 (
                 Derivative[0, 1][$CellContext`\[Upsilon]][
                    $CellContext`x1[], 
                    $CellContext`x2[]]^2 + 
                 Derivative[1, 0][$CellContext`\[Upsilon]][
                    $CellContext`x1[], 
                    $CellContext`x2[]]^2) + $CellContext`\[Upsilon][
                    $CellContext`x1[], 
                    $CellContext`x2[]]^3 (
                  Derivative[0, 2][$CellContext`\[Upsilon]][
                    $CellContext`x1[], 
                    $CellContext`x2[]] + 
                  Derivative[2, 0][$CellContext`\[Upsilon]][
                    $CellContext`x1[], 
                    $CellContext`x2[]]))), "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"8", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {8, 4} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"8", ",", "5"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {8, 5} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"8", ",", "6"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {8, 6} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"8", ",", "7"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {8, 7} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["\<\"\[GrayCircle]\"\>",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"8", ",", "8"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 RowBox[{
                   RowBox[{"-", "4"}], " ", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "3"], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "4"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], "-", 
                    RowBox[{"4", " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                 RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                    "-", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "3"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], 
                    ")"}]}]}], ")"}]}], "-", 
                 RowBox[{
                   SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "4"], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                    "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                    "-", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                    ")"}]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox["x2", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "3"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "2"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"2", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}], ")"}]}]}
                    ], ")"}]}]}], 
               RowBox[{
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "8"]}]]}]],
           Annotation[#, {8, 8} -> $CellContext`\[Gamma][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) $CellContext`\[Eta][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) $CellContext`\[Upsilon][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-8) ((-4) $CellContext`\[Alpha][
                 $CellContext`x1[], 
                 $CellContext`x2[]] $CellContext`\[Upsilon][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^3 ((-4) 
                 Derivative[0, 1][$CellContext`\[Alpha]][
                   $CellContext`x1[], 
                   $CellContext`x2[]] 
                 Derivative[0, 1][$CellContext`\[Upsilon]][
                   $CellContext`x1[], 
                   $CellContext`x2[]] - 4 
                Derivative[1, 0][$CellContext`\[Alpha]][
                  $CellContext`x1[], 
                  $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Upsilon]][
                  $CellContext`x1[], 
                  $CellContext`x2[]] + $CellContext`\[Upsilon][
                   $CellContext`x1[], 
                   $CellContext`x2[]] (Derivative[0, 2][$CellContext`\[Alpha]][
                    $CellContext`x1[], 
                    $CellContext`x2[]] + 
                  Derivative[2, 0][$CellContext`\[Alpha]][
                    $CellContext`x1[], 
                    $CellContext`x2[]])) + 4 $CellContext`\[Alpha][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^2 (
                2 Derivative[0, 1][$CellContext`\[Alpha]][
                    $CellContext`x1[], 
                    $CellContext`x2[]]^2 + 
                2 Derivative[1, 0][$CellContext`\[Alpha]][
                    $CellContext`x1[], 
                    $CellContext`x2[]]^2 - $CellContext`\[Upsilon][
                   $CellContext`x1[], 
                   $CellContext`x2[]]^2 (
                 Derivative[0, 1][$CellContext`\[Upsilon]][
                    $CellContext`x1[], 
                    $CellContext`x2[]]^2 + 
                 Derivative[1, 0][$CellContext`\[Upsilon]][
                    $CellContext`x1[], 
                    $CellContext`x2[]]^2) + $CellContext`\[Upsilon][
                    $CellContext`x1[], 
                    $CellContext`x2[]]^3 (
                  Derivative[0, 2][$CellContext`\[Upsilon]][
                    $CellContext`x1[], 
                    $CellContext`x2[]] + 
                  Derivative[2, 0][$CellContext`\[Upsilon]][
                    $CellContext`x1[], 
                    $CellContext`x2[]])) - $CellContext`\[Upsilon][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^4 (
               2 Derivative[0, 1][$CellContext`\[Alpha]][
                   $CellContext`x1[], 
                   $CellContext`x2[]]^2 + 
               2 Derivative[1, 0][$CellContext`\[Alpha]][
                   $CellContext`x1[], 
                   $CellContext`x2[]]^2 - $CellContext`\[Upsilon][
                  $CellContext`x1[], 
                  $CellContext`x2[]]^2 (
                Derivative[0, 1][$CellContext`\[Upsilon]][
                   $CellContext`x1[], 
                   $CellContext`x2[]]^2 + 
                Derivative[1, 0][$CellContext`\[Upsilon]][
                   $CellContext`x1[], 
                   $CellContext`x2[]]^2) + $CellContext`\[Upsilon][
                   $CellContext`x1[], 
                   $CellContext`x2[]]^3 (
                 Derivative[0, 2][$CellContext`\[Upsilon]][
                   $CellContext`x1[], 
                   $CellContext`x2[]] + 
                 Derivative[2, 0][$CellContext`\[Upsilon]][
                   $CellContext`x1[], 
                   $CellContext`x2[]]))), "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 9 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 9 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {" ", " "},
         {"a", "b"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{(-2) $CellContext`\[Gamma][
         $CellContext`x1[], 
         $CellContext`x2[]]^(-4) Derivative[1, 0][$CellContext`\[Beta]][
         $CellContext`x1[], 
         $CellContext`x2[]]^2 + $CellContext`\[Gamma][
         $CellContext`x1[], 
         $CellContext`x2[]]^(-2) (Derivative[0, 1][$CellContext`\[Gamma]][
          $CellContext`x1[], 
          $CellContext`x2[]]^2 - Derivative[1, 0][$CellContext`\[Gamma]][
         $CellContext`x1[], 
         $CellContext`x2[]]^2) + $CellContext`\[Eta][
         $CellContext`x1[], 
         $CellContext`x2[]]^(-2) (Derivative[0, 1][$CellContext`\[Eta]][
          $CellContext`x1[], 
          $CellContext`x2[]]^2 - Derivative[1, 0][$CellContext`\[Eta]][
         $CellContext`x1[], 
         $CellContext`x2[]]^2) - 2 $CellContext`\[Eta][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-4) Derivative[1, 0][$CellContext`\[Chi]][
        $CellContext`x1[], 
        $CellContext`x2[]]^2 - $CellContext`\[Gamma][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-1) (Derivative[0, 2][$CellContext`\[Gamma]][
        $CellContext`x1[], 
        $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Gamma]][
        $CellContext`x1[], 
        $CellContext`x2[]]) - $CellContext`\[Eta][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-1) (Derivative[0, 2][$CellContext`\[Eta]][
        $CellContext`x1[], 
        $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Eta]][
        $CellContext`x1[], 
        $CellContext`x2[]]) - $CellContext`\[Upsilon][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-4) (2 Derivative[1, 0][$CellContext`\[Alpha]][
          $CellContext`x1[], 
          $CellContext`x2[]]^2 + $CellContext`\[Upsilon][
          $CellContext`x1[], 
          $CellContext`x2[]]^2 (-Derivative[0, 1][$CellContext`\[Upsilon]][
            $CellContext`x1[], 
            $CellContext`x2[]]^2 + Derivative[1, 0][$CellContext`\[Upsilon]][
           $CellContext`x1[], 
           $CellContext`x2[]]^2) + $CellContext`\[Upsilon][
          $CellContext`x1[], 
          $CellContext`x2[]]^3 (Derivative[0, 2][$CellContext`\[Upsilon]][
          $CellContext`x1[], 
          $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Upsilon]][
          $CellContext`x1[], 
          $CellContext`x2[]])), (-2) $CellContext`\[Upsilon][
         $CellContext`x1[], 
         $CellContext`x2[]]^(-4) Derivative[0, 1][$CellContext`\[Alpha]][
        $CellContext`x1[], 
        $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Alpha]][
        $CellContext`x1[], 
        $CellContext`x2[]] - 2 $CellContext`\[Gamma][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-4) Derivative[0, 1][$CellContext`\[Beta]][
       $CellContext`x1[], 
       $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Beta]][
       $CellContext`x1[], 
       $CellContext`x2[]] - 2 $CellContext`\[Gamma][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) Derivative[0, 1][$CellContext`\[Gamma]][
       $CellContext`x1[], 
       $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Gamma]][
       $CellContext`x1[], 
       $CellContext`x2[]] - 2 $CellContext`\[Upsilon][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) Derivative[0, 1][$CellContext`\[Upsilon]][
       $CellContext`x1[], 
       $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Upsilon]][
       $CellContext`x1[], 
       $CellContext`x2[]] - 2 $CellContext`\[Eta][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-4) ($CellContext`\[Eta][
          $CellContext`x1[], 
          $CellContext`x2[]]^2 Derivative[0, 1][$CellContext`\[Eta]][
         $CellContext`x1[], 
         $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Eta]][
         $CellContext`x1[], 
         $CellContext`x2[]] + Derivative[0, 1][$CellContext`\[Chi]][
         $CellContext`x1[], 
         $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Chi]][
         $CellContext`x1[], 
         $CellContext`x2[]]), 0, 0, 0, 0, 0, 0}, {(-2) $CellContext`\[Upsilon][
         $CellContext`x1[], 
         $CellContext`x2[]]^(-4) Derivative[0, 1][$CellContext`\[Alpha]][
        $CellContext`x1[], 
        $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Alpha]][
        $CellContext`x1[], 
        $CellContext`x2[]] - 2 $CellContext`\[Gamma][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-4) Derivative[0, 1][$CellContext`\[Beta]][
       $CellContext`x1[], 
       $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Beta]][
       $CellContext`x1[], 
       $CellContext`x2[]] - 2 $CellContext`\[Gamma][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) Derivative[0, 1][$CellContext`\[Gamma]][
       $CellContext`x1[], 
       $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Gamma]][
       $CellContext`x1[], 
       $CellContext`x2[]] - 2 $CellContext`\[Upsilon][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) Derivative[0, 1][$CellContext`\[Upsilon]][
       $CellContext`x1[], 
       $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Upsilon]][
       $CellContext`x1[], 
       $CellContext`x2[]] - 2 $CellContext`\[Eta][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-4) ($CellContext`\[Eta][
          $CellContext`x1[], 
          $CellContext`x2[]]^2 Derivative[0, 1][$CellContext`\[Eta]][
         $CellContext`x1[], 
         $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Eta]][
         $CellContext`x1[], 
         $CellContext`x2[]] + Derivative[0, 1][$CellContext`\[Chi]][
         $CellContext`x1[], 
         $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Chi]][
         $CellContext`x1[], 
         $CellContext`x2[]]), (-2) $CellContext`\[Upsilon][
         $CellContext`x1[], 
         $CellContext`x2[]]^(-4) Derivative[0, 1][$CellContext`\[Alpha]][
         $CellContext`x1[], 
         $CellContext`x2[]]^2 - 2 $CellContext`\[Eta][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-4) Derivative[0, 1][$CellContext`\[Chi]][
        $CellContext`x1[], 
        $CellContext`x2[]]^2 + $CellContext`\[Eta][
         $CellContext`x1[], 
         $CellContext`x2[]]^(-2) (-Derivative[0, 1][$CellContext`\[Eta]][
           $CellContext`x1[], 
           $CellContext`x2[]]^2 + Derivative[1, 0][$CellContext`\[Eta]][
          $CellContext`x1[], 
          $CellContext`x2[]]^2) + $CellContext`\[Upsilon][
         $CellContext`x1[], 
         $CellContext`x2[]]^(-2) (-Derivative[0, 1][$CellContext`\[Upsilon]][
           $CellContext`x1[], 
           $CellContext`x2[]]^2 + Derivative[1, 0][$CellContext`\[Upsilon]][
          $CellContext`x1[], 
          $CellContext`x2[]]^2) - $CellContext`\[Gamma][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-4) (2 Derivative[0, 1][$CellContext`\[Beta]][
          $CellContext`x1[], 
          $CellContext`x2[]]^2 + $CellContext`\[Gamma][
          $CellContext`x1[], 
          $CellContext`x2[]]^2 (Derivative[0, 1][$CellContext`\[Gamma]][
           $CellContext`x1[], 
           $CellContext`x2[]]^2 - Derivative[1, 0][$CellContext`\[Gamma]][
          $CellContext`x1[], 
          $CellContext`x2[]]^2 + $CellContext`\[Gamma][
           $CellContext`x1[], 
           $CellContext`x2[]] (Derivative[0, 2][$CellContext`\[Gamma]][
            $CellContext`x1[], 
            $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Gamma]][
            $CellContext`x1[], 
            $CellContext`x2[]]))) - $CellContext`\[Eta][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-1) (Derivative[0, 2][$CellContext`\[Eta]][
        $CellContext`x1[], 
        $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Eta]][
        $CellContext`x1[], 
        $CellContext`x2[]]) - $CellContext`\[Upsilon][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-1) (Derivative[0, 2][$CellContext`\[Upsilon]][
        $CellContext`x1[], 
        $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Upsilon]][
        $CellContext`x1[], 
        $CellContext`x2[]]), 0, 0, 0, 0, 0, 0}, {0, 0, $CellContext`\[Gamma][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) $CellContext`\[Eta][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) $CellContext`\[Upsilon][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-8) (2 Derivative[0, 1][$CellContext`\[Alpha]][
          $CellContext`x1[], 
          $CellContext`x2[]]^2 + 2 Derivative[1, 0][$CellContext`\[Alpha]][
          $CellContext`x1[], 
          $CellContext`x2[]]^2 - $CellContext`\[Upsilon][
         $CellContext`x1[], 
         $CellContext`x2[]]^2 (Derivative[0, 1][$CellContext`\[Upsilon]][
          $CellContext`x1[], 
          $CellContext`x2[]]^2 + Derivative[1, 0][$CellContext`\[Upsilon]][
          $CellContext`x1[], 
          $CellContext`x2[]]^2) + $CellContext`\[Upsilon][
          $CellContext`x1[], 
          $CellContext`x2[]]^3 (Derivative[0, 2][$CellContext`\[Upsilon]][
          $CellContext`x1[], 
          $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Upsilon]][
          $CellContext`x1[], 
          $CellContext`x2[]])), 0, 0, 0, 0, $CellContext`\[Gamma][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) $CellContext`\[Eta][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) $CellContext`\[Upsilon][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-8) (-$CellContext`\[Upsilon][
          $CellContext`x1[], 
          $CellContext`x2[]]^3 ((-4) Derivative[0, 1][$CellContext`\[Alpha]][
           $CellContext`x1[], 
           $CellContext`x2[]] Derivative[0, 1][$CellContext`\[Upsilon]][
           $CellContext`x1[], 
           $CellContext`x2[]] - 4 Derivative[1, 0][$CellContext`\[Alpha]][
          $CellContext`x1[], 
          $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Upsilon]][
          $CellContext`x1[], 
          $CellContext`x2[]] + $CellContext`\[Upsilon][
           $CellContext`x1[], 
           $CellContext`x2[]] (Derivative[0, 2][$CellContext`\[Alpha]][
            $CellContext`x1[], 
            $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Alpha]][
            $CellContext`x1[], 
            $CellContext`x2[]])) + 2 $CellContext`\[Alpha][
         $CellContext`x1[], 
         $CellContext`x2[]] (2 Derivative[0, 1][$CellContext`\[Alpha]][
            $CellContext`x1[], 
            $CellContext`x2[]]^2 + 2 Derivative[1, 0][$CellContext`\[Alpha]][
            $CellContext`x1[], 
            $CellContext`x2[]]^2 - $CellContext`\[Upsilon][
           $CellContext`x1[], 
           $CellContext`x2[]]^2 (Derivative[0, 1][$CellContext`\[Upsilon]][
            $CellContext`x1[], 
            $CellContext`x2[]]^2 + Derivative[1, 0][$CellContext`\[Upsilon]][
            $CellContext`x1[], 
            $CellContext`x2[]]^2) + $CellContext`\[Upsilon][
            $CellContext`x1[], 
            $CellContext`x2[]]^3 (Derivative[0, 2][$CellContext`\[Upsilon]][
            $CellContext`x1[], 
            $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Upsilon]][
            $CellContext`x1[], 
            $CellContext`x2[]])))}, {0, 0, 0, $CellContext`\[Gamma][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-8) $CellContext`\[Eta][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) $CellContext`\[Upsilon][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) (2 Derivative[0, 1][$CellContext`\[Beta]][
          $CellContext`x1[], 
          $CellContext`x2[]]^2 + 2 Derivative[1, 0][$CellContext`\[Beta]][
          $CellContext`x1[], 
          $CellContext`x2[]]^2 - $CellContext`\[Gamma][
         $CellContext`x1[], 
         $CellContext`x2[]]^2 (Derivative[0, 1][$CellContext`\[Gamma]][
          $CellContext`x1[], 
          $CellContext`x2[]]^2 + Derivative[1, 0][$CellContext`\[Gamma]][
          $CellContext`x1[], 
          $CellContext`x2[]]^2) + $CellContext`\[Gamma][
          $CellContext`x1[], 
          $CellContext`x2[]]^3 (Derivative[0, 2][$CellContext`\[Gamma]][
          $CellContext`x1[], 
          $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Gamma]][
          $CellContext`x1[], 
          $CellContext`x2[]])), $CellContext`\[Gamma][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-8) $CellContext`\[Eta][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) $CellContext`\[Upsilon][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) (-$CellContext`\[Gamma][
          $CellContext`x1[], 
          $CellContext`x2[]]^3 ((-4) Derivative[0, 1][$CellContext`\[Beta]][
           $CellContext`x1[], 
           $CellContext`x2[]] Derivative[0, 1][$CellContext`\[Gamma]][
           $CellContext`x1[], 
           $CellContext`x2[]] - 4 Derivative[1, 0][$CellContext`\[Beta]][
          $CellContext`x1[], 
          $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Gamma]][
          $CellContext`x1[], 
          $CellContext`x2[]] + $CellContext`\[Gamma][
           $CellContext`x1[], 
           $CellContext`x2[]] (Derivative[0, 2][$CellContext`\[Beta]][
            $CellContext`x1[], 
            $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Beta]][
            $CellContext`x1[], 
            $CellContext`x2[]])) + 2 $CellContext`\[Beta][
         $CellContext`x1[], 
         $CellContext`x2[]] (2 Derivative[0, 1][$CellContext`\[Beta]][
            $CellContext`x1[], 
            $CellContext`x2[]]^2 + 2 Derivative[1, 0][$CellContext`\[Beta]][
            $CellContext`x1[], 
            $CellContext`x2[]]^2 - $CellContext`\[Gamma][
           $CellContext`x1[], 
           $CellContext`x2[]]^2 (Derivative[0, 1][$CellContext`\[Gamma]][
            $CellContext`x1[], 
            $CellContext`x2[]]^2 + Derivative[1, 0][$CellContext`\[Gamma]][
            $CellContext`x1[], 
            $CellContext`x2[]]^2) + $CellContext`\[Gamma][
            $CellContext`x1[], 
            $CellContext`x2[]]^3 (Derivative[0, 2][$CellContext`\[Gamma]][
            $CellContext`x1[], 
            $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Gamma]][
            $CellContext`x1[], 
            $CellContext`x2[]]))), 0, 0, 0}, {0, 0, 0, $CellContext`\[Gamma][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-8) $CellContext`\[Eta][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) $CellContext`\[Upsilon][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) (-$CellContext`\[Gamma][
          $CellContext`x1[], 
          $CellContext`x2[]]^3 ((-4) Derivative[0, 1][$CellContext`\[Beta]][
           $CellContext`x1[], 
           $CellContext`x2[]] Derivative[0, 1][$CellContext`\[Gamma]][
           $CellContext`x1[], 
           $CellContext`x2[]] - 4 Derivative[1, 0][$CellContext`\[Beta]][
          $CellContext`x1[], 
          $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Gamma]][
          $CellContext`x1[], 
          $CellContext`x2[]] + $CellContext`\[Gamma][
           $CellContext`x1[], 
           $CellContext`x2[]] (Derivative[0, 2][$CellContext`\[Beta]][
            $CellContext`x1[], 
            $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Beta]][
            $CellContext`x1[], 
            $CellContext`x2[]])) + 2 $CellContext`\[Beta][
         $CellContext`x1[], 
         $CellContext`x2[]] (2 Derivative[0, 1][$CellContext`\[Beta]][
            $CellContext`x1[], 
            $CellContext`x2[]]^2 + 2 Derivative[1, 0][$CellContext`\[Beta]][
            $CellContext`x1[], 
            $CellContext`x2[]]^2 - $CellContext`\[Gamma][
           $CellContext`x1[], 
           $CellContext`x2[]]^2 (Derivative[0, 1][$CellContext`\[Gamma]][
            $CellContext`x1[], 
            $CellContext`x2[]]^2 + Derivative[1, 0][$CellContext`\[Gamma]][
            $CellContext`x1[], 
            $CellContext`x2[]]^2) + $CellContext`\[Gamma][
            $CellContext`x1[], 
            $CellContext`x2[]]^3 (Derivative[0, 2][$CellContext`\[Gamma]][
            $CellContext`x1[], 
            $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Gamma]][
            $CellContext`x1[], 
            $CellContext`x2[]]))), $CellContext`\[Gamma][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-8) $CellContext`\[Eta][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) $CellContext`\[Upsilon][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) ((-4) $CellContext`\[Beta][
         $CellContext`x1[], 
         $CellContext`x2[]] $CellContext`\[Gamma][
          $CellContext`x1[], 
          $CellContext`x2[]]^3 ((-4) Derivative[0, 1][$CellContext`\[Beta]][
           $CellContext`x1[], 
           $CellContext`x2[]] Derivative[0, 1][$CellContext`\[Gamma]][
           $CellContext`x1[], 
           $CellContext`x2[]] - 4 Derivative[1, 0][$CellContext`\[Beta]][
          $CellContext`x1[], 
          $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Gamma]][
          $CellContext`x1[], 
          $CellContext`x2[]] + $CellContext`\[Gamma][
           $CellContext`x1[], 
           $CellContext`x2[]] (Derivative[0, 2][$CellContext`\[Beta]][
            $CellContext`x1[], 
            $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Beta]][
            $CellContext`x1[], 
            $CellContext`x2[]])) + 4 $CellContext`\[Beta][
          $CellContext`x1[], 
          $CellContext`x2[]]^2 (2 Derivative[0, 1][$CellContext`\[Beta]][
            $CellContext`x1[], 
            $CellContext`x2[]]^2 + 2 Derivative[1, 0][$CellContext`\[Beta]][
            $CellContext`x1[], 
            $CellContext`x2[]]^2 - $CellContext`\[Gamma][
           $CellContext`x1[], 
           $CellContext`x2[]]^2 (Derivative[0, 1][$CellContext`\[Gamma]][
            $CellContext`x1[], 
            $CellContext`x2[]]^2 + Derivative[1, 0][$CellContext`\[Gamma]][
            $CellContext`x1[], 
            $CellContext`x2[]]^2) + $CellContext`\[Gamma][
            $CellContext`x1[], 
            $CellContext`x2[]]^3 (Derivative[0, 2][$CellContext`\[Gamma]][
            $CellContext`x1[], 
            $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Gamma]][
            $CellContext`x1[], 
            $CellContext`x2[]])) - $CellContext`\[Gamma][
         $CellContext`x1[], 
         $CellContext`x2[]]^4 (2 Derivative[0, 1][$CellContext`\[Beta]][
           $CellContext`x1[], 
           $CellContext`x2[]]^2 + 2 Derivative[1, 0][$CellContext`\[Beta]][
           $CellContext`x1[], 
           $CellContext`x2[]]^2 - $CellContext`\[Gamma][
          $CellContext`x1[], 
          $CellContext`x2[]]^2 (Derivative[0, 1][$CellContext`\[Gamma]][
           $CellContext`x1[], 
           $CellContext`x2[]]^2 + Derivative[1, 0][$CellContext`\[Gamma]][
           $CellContext`x1[], 
           $CellContext`x2[]]^2) + $CellContext`\[Gamma][
           $CellContext`x1[], 
           $CellContext`x2[]]^3 (Derivative[0, 2][$CellContext`\[Gamma]][
           $CellContext`x1[], 
           $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Gamma]][
           $CellContext`x1[], 
           $CellContext`x2[]]))), 0, 0, 0}, {
    0, 0, 0, 0, 0, $CellContext`\[Gamma][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) $CellContext`\[Eta][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-8) $CellContext`\[Upsilon][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) ($CellContext`\[Eta][
          $CellContext`x1[], 
          $CellContext`x2[]]^6 (Derivative[0, 1][$CellContext`\[Eta]][
           $CellContext`x1[], 
           $CellContext`x2[]]^2 + Derivative[1, 0][$CellContext`\[Eta]][
           $CellContext`x1[], 
           $CellContext`x2[]]^2) - 4 $CellContext`\[Eta][
         $CellContext`x1[], 
         $CellContext`x2[]]^2 $CellContext`\[Chi][
         $CellContext`x1[], 
         $CellContext`x2[]]^2 (Derivative[0, 1][$CellContext`\[Eta]][
          $CellContext`x1[], 
          $CellContext`x2[]]^2 + Derivative[1, 0][$CellContext`\[Eta]][
          $CellContext`x1[], 
          $CellContext`x2[]]^2) + 8 $CellContext`\[Chi][
          $CellContext`x1[], 
          $CellContext`x2[]]^2 (Derivative[0, 1][$CellContext`\[Chi]][
           $CellContext`x1[], 
           $CellContext`x2[]]^2 + Derivative[1, 0][$CellContext`\[Chi]][
           $CellContext`x1[], 
           $CellContext`x2[]]^2) - $CellContext`\[Eta][
         $CellContext`x1[], 
         $CellContext`x2[]]^7 (Derivative[0, 2][$CellContext`\[Eta]][
         $CellContext`x1[], 
         $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Eta]][
         $CellContext`x1[], 
         $CellContext`x2[]]) + 4 $CellContext`\[Eta][
          $CellContext`x1[], 
          $CellContext`x2[]]^3 $CellContext`\[Chi][
         $CellContext`x1[], 
         $CellContext`x2[]] (4 Derivative[0, 1][$CellContext`\[Eta]][
           $CellContext`x1[], 
           $CellContext`x2[]] Derivative[0, 1][$CellContext`\[Chi]][
           $CellContext`x1[], 
           $CellContext`x2[]] + 4 Derivative[1, 0][$CellContext`\[Eta]][
           $CellContext`x1[], 
           $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Chi]][
           $CellContext`x1[], 
           $CellContext`x2[]] + $CellContext`\[Chi][
           $CellContext`x1[], 
           $CellContext`x2[]] (Derivative[0, 2][$CellContext`\[Eta]][
            $CellContext`x1[], 
            $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Eta]][
            $CellContext`x1[], 
            $CellContext`x2[]])) - 2 $CellContext`\[Eta][
         $CellContext`x1[], 
         $CellContext`x2[]]^4 (Derivative[0, 1][$CellContext`\[Chi]][
          $CellContext`x1[], 
          $CellContext`x2[]]^2 + Derivative[1, 0][$CellContext`\[Chi]][
          $CellContext`x1[], 
          $CellContext`x2[]]^2 + 2 $CellContext`\[Chi][
          $CellContext`x1[], 
          $CellContext`x2[]] (Derivative[0, 2][$CellContext`\[Chi]][
           $CellContext`x1[], 
           $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Chi]][
           $CellContext`x1[], 
           $CellContext`x2[]]))), $CellContext`\[Gamma][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) $CellContext`\[Eta][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-8) $CellContext`\[Upsilon][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) ((-2) $CellContext`\[Eta][
          $CellContext`x1[], 
          $CellContext`x2[]]^2 $CellContext`\[Chi][
         $CellContext`x1[], 
         $CellContext`x2[]] (Derivative[0, 1][$CellContext`\[Eta]][
           $CellContext`x1[], 
           $CellContext`x2[]]^2 + Derivative[1, 0][$CellContext`\[Eta]][
           $CellContext`x1[], 
           $CellContext`x2[]]^2) + 4 $CellContext`\[Chi][
         $CellContext`x1[], 
         $CellContext`x2[]] (Derivative[0, 1][$CellContext`\[Chi]][
           $CellContext`x1[], 
           $CellContext`x2[]]^2 + Derivative[1, 0][$CellContext`\[Chi]][
           $CellContext`x1[], 
           $CellContext`x2[]]^2) + 2 $CellContext`\[Eta][
          $CellContext`x1[], 
          $CellContext`x2[]]^3 (2 Derivative[0, 1][$CellContext`\[Eta]][
           $CellContext`x1[], 
           $CellContext`x2[]] Derivative[0, 1][$CellContext`\[Chi]][
           $CellContext`x1[], 
           $CellContext`x2[]] + 2 Derivative[1, 0][$CellContext`\[Eta]][
           $CellContext`x1[], 
           $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Chi]][
           $CellContext`x1[], 
           $CellContext`x2[]] + $CellContext`\[Chi][
           $CellContext`x1[], 
           $CellContext`x2[]] (Derivative[0, 2][$CellContext`\[Eta]][
            $CellContext`x1[], 
            $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Eta]][
            $CellContext`x1[], 
            $CellContext`x2[]])) - $CellContext`\[Eta][
         $CellContext`x1[], 
         $CellContext`x2[]]^4 (Derivative[0, 2][$CellContext`\[Chi]][
         $CellContext`x1[], 
         $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Chi]][
         $CellContext`x1[], 
         $CellContext`x2[]])), 0}, {0, 0, 0, 0, 0, $CellContext`\[Gamma][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) $CellContext`\[Eta][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-8) $CellContext`\[Upsilon][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) ((-2) $CellContext`\[Eta][
          $CellContext`x1[], 
          $CellContext`x2[]]^2 $CellContext`\[Chi][
         $CellContext`x1[], 
         $CellContext`x2[]] (Derivative[0, 1][$CellContext`\[Eta]][
           $CellContext`x1[], 
           $CellContext`x2[]]^2 + Derivative[1, 0][$CellContext`\[Eta]][
           $CellContext`x1[], 
           $CellContext`x2[]]^2) + 4 $CellContext`\[Chi][
         $CellContext`x1[], 
         $CellContext`x2[]] (Derivative[0, 1][$CellContext`\[Chi]][
           $CellContext`x1[], 
           $CellContext`x2[]]^2 + Derivative[1, 0][$CellContext`\[Chi]][
           $CellContext`x1[], 
           $CellContext`x2[]]^2) + 2 $CellContext`\[Eta][
          $CellContext`x1[], 
          $CellContext`x2[]]^3 (2 Derivative[0, 1][$CellContext`\[Eta]][
           $CellContext`x1[], 
           $CellContext`x2[]] Derivative[0, 1][$CellContext`\[Chi]][
           $CellContext`x1[], 
           $CellContext`x2[]] + 2 Derivative[1, 0][$CellContext`\[Eta]][
           $CellContext`x1[], 
           $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Chi]][
           $CellContext`x1[], 
           $CellContext`x2[]] + $CellContext`\[Chi][
           $CellContext`x1[], 
           $CellContext`x2[]] (Derivative[0, 2][$CellContext`\[Eta]][
            $CellContext`x1[], 
            $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Eta]][
            $CellContext`x1[], 
            $CellContext`x2[]])) - $CellContext`\[Eta][
         $CellContext`x1[], 
         $CellContext`x2[]]^4 (Derivative[0, 2][$CellContext`\[Chi]][
         $CellContext`x1[], 
         $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Chi]][
         $CellContext`x1[], 
         $CellContext`x2[]])), $CellContext`\[Gamma][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) $CellContext`\[Eta][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-8) $CellContext`\[Upsilon][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) (-$CellContext`\[Eta][
          $CellContext`x1[], 
          $CellContext`x2[]]^2 (Derivative[0, 1][$CellContext`\[Eta]][
           $CellContext`x1[], 
           $CellContext`x2[]]^2 + Derivative[1, 0][$CellContext`\[Eta]][
           $CellContext`x1[], 
           $CellContext`x2[]]^2) + 2 (Derivative[0, 1][$CellContext`\[Chi]][
           $CellContext`x1[], 
           $CellContext`x2[]]^2 + Derivative[1, 0][$CellContext`\[Chi]][
           $CellContext`x1[], 
           $CellContext`x2[]]^2) + $CellContext`\[Eta][
          $CellContext`x1[], 
          $CellContext`x2[]]^3 (Derivative[0, 2][$CellContext`\[Eta]][
          $CellContext`x1[], 
          $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Eta]][
          $CellContext`x1[], 
          $CellContext`x2[]])), 0}, {0, 0, $CellContext`\[Gamma][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) $CellContext`\[Eta][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) $CellContext`\[Upsilon][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-8) (-$CellContext`\[Upsilon][
          $CellContext`x1[], 
          $CellContext`x2[]]^3 ((-4) Derivative[0, 1][$CellContext`\[Alpha]][
           $CellContext`x1[], 
           $CellContext`x2[]] Derivative[0, 1][$CellContext`\[Upsilon]][
           $CellContext`x1[], 
           $CellContext`x2[]] - 4 Derivative[1, 0][$CellContext`\[Alpha]][
          $CellContext`x1[], 
          $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Upsilon]][
          $CellContext`x1[], 
          $CellContext`x2[]] + $CellContext`\[Upsilon][
           $CellContext`x1[], 
           $CellContext`x2[]] (Derivative[0, 2][$CellContext`\[Alpha]][
            $CellContext`x1[], 
            $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Alpha]][
            $CellContext`x1[], 
            $CellContext`x2[]])) + 2 $CellContext`\[Alpha][
         $CellContext`x1[], 
         $CellContext`x2[]] (2 Derivative[0, 1][$CellContext`\[Alpha]][
            $CellContext`x1[], 
            $CellContext`x2[]]^2 + 2 Derivative[1, 0][$CellContext`\[Alpha]][
            $CellContext`x1[], 
            $CellContext`x2[]]^2 - $CellContext`\[Upsilon][
           $CellContext`x1[], 
           $CellContext`x2[]]^2 (Derivative[0, 1][$CellContext`\[Upsilon]][
            $CellContext`x1[], 
            $CellContext`x2[]]^2 + Derivative[1, 0][$CellContext`\[Upsilon]][
            $CellContext`x1[], 
            $CellContext`x2[]]^2) + $CellContext`\[Upsilon][
            $CellContext`x1[], 
            $CellContext`x2[]]^3 (Derivative[0, 2][$CellContext`\[Upsilon]][
            $CellContext`x1[], 
            $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Upsilon]][
            $CellContext`x1[], 
            $CellContext`x2[]]))), 0, 0, 0, 0, $CellContext`\[Gamma][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) $CellContext`\[Eta][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) $CellContext`\[Upsilon][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-8) ((-4) $CellContext`\[Alpha][
         $CellContext`x1[], 
         $CellContext`x2[]] $CellContext`\[Upsilon][
          $CellContext`x1[], 
          $CellContext`x2[]]^3 ((-4) Derivative[0, 1][$CellContext`\[Alpha]][
           $CellContext`x1[], 
           $CellContext`x2[]] Derivative[0, 1][$CellContext`\[Upsilon]][
           $CellContext`x1[], 
           $CellContext`x2[]] - 4 Derivative[1, 0][$CellContext`\[Alpha]][
          $CellContext`x1[], 
          $CellContext`x2[]] Derivative[1, 0][$CellContext`\[Upsilon]][
          $CellContext`x1[], 
          $CellContext`x2[]] + $CellContext`\[Upsilon][
           $CellContext`x1[], 
           $CellContext`x2[]] (Derivative[0, 2][$CellContext`\[Alpha]][
            $CellContext`x1[], 
            $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Alpha]][
            $CellContext`x1[], 
            $CellContext`x2[]])) + 4 $CellContext`\[Alpha][
          $CellContext`x1[], 
          $CellContext`x2[]]^2 (2 Derivative[0, 1][$CellContext`\[Alpha]][
            $CellContext`x1[], 
            $CellContext`x2[]]^2 + 2 Derivative[1, 0][$CellContext`\[Alpha]][
            $CellContext`x1[], 
            $CellContext`x2[]]^2 - $CellContext`\[Upsilon][
           $CellContext`x1[], 
           $CellContext`x2[]]^2 (Derivative[0, 1][$CellContext`\[Upsilon]][
            $CellContext`x1[], 
            $CellContext`x2[]]^2 + Derivative[1, 0][$CellContext`\[Upsilon]][
            $CellContext`x1[], 
            $CellContext`x2[]]^2) + $CellContext`\[Upsilon][
            $CellContext`x1[], 
            $CellContext`x2[]]^3 (Derivative[0, 2][$CellContext`\[Upsilon]][
            $CellContext`x1[], 
            $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Upsilon]][
            $CellContext`x1[], 
            $CellContext`x2[]])) - $CellContext`\[Upsilon][
         $CellContext`x1[], 
         $CellContext`x2[]]^4 (2 Derivative[0, 1][$CellContext`\[Alpha]][
           $CellContext`x1[], 
           $CellContext`x2[]]^2 + 2 Derivative[1, 0][$CellContext`\[Alpha]][
           $CellContext`x1[], 
           $CellContext`x2[]]^2 - $CellContext`\[Upsilon][
          $CellContext`x1[], 
          $CellContext`x2[]]^2 (Derivative[0, 1][$CellContext`\[Upsilon]][
           $CellContext`x1[], 
           $CellContext`x2[]]^2 + Derivative[1, 0][$CellContext`\[Upsilon]][
           $CellContext`x1[], 
           $CellContext`x2[]]^2) + $CellContext`\[Upsilon][
           $CellContext`x1[], 
           $CellContext`x2[]]^3 (Derivative[0, 2][$CellContext`\[Upsilon]][
           $CellContext`x1[], 
           $CellContext`x2[]] + Derivative[2, 0][$CellContext`\[Upsilon]][
           $CellContext`x1[], 
           $CellContext`x2[]])))}}, {-$CellContext`FK, -$CellContext`FK}, 
   0][-$CellContext`a, -$CellContext`b],
  Editable->False]], "Output",ExpressionUUID->"a2dfa90a-b423-4af4-97c6-\
561eacb1f9bb"]
}, Open  ]],

Cell["These are the analiticity rules used by Bonanos:", "Text",ExpressionUUID->"81dac4d2-750f-4e39-bbbd-eb9ef4794135"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rules", "=", 
  RowBox[{"{", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"D", "[", 
      RowBox[{
       RowBox[{"\[Alpha]", "[", 
        RowBox[{
         RowBox[{"x1", "[", "]"}], ",", 
         RowBox[{"x2", "[", "]"}]}], "]"}], ",", 
       RowBox[{"x1", "[", "]"}]}], "]"}], "\[Rule]", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"\[Upsilon]", "[", 
        RowBox[{
         RowBox[{"x1", "[", "]"}], ",", 
         RowBox[{"x2", "[", "]"}]}], "]"}]}], 
      RowBox[{"D", "[", 
       RowBox[{
        RowBox[{"\[Upsilon]", "[", 
         RowBox[{
          RowBox[{"x1", "[", "]"}], ",", 
          RowBox[{"x2", "[", "]"}]}], "]"}], ",", 
        RowBox[{"x2", "[", "]"}]}], "]"}]}]}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"D", "[", 
      RowBox[{
       RowBox[{"\[Alpha]", "[", 
        RowBox[{
         RowBox[{"x1", "[", "]"}], ",", 
         RowBox[{"x2", "[", "]"}]}], "]"}], ",", 
       RowBox[{"x2", "[", "]"}]}], "]"}], "\[Rule]", "   ", 
     RowBox[{
      RowBox[{"\[Upsilon]", "[", 
       RowBox[{
        RowBox[{"x1", "[", "]"}], ",", 
        RowBox[{"x2", "[", "]"}]}], "]"}], 
      RowBox[{"D", "[", 
       RowBox[{
        RowBox[{"\[Upsilon]", "[", 
         RowBox[{
          RowBox[{"x1", "[", "]"}], ",", 
          RowBox[{"x2", "[", "]"}]}], "]"}], ",", 
        RowBox[{"x1", "[", "]"}]}], "]"}]}]}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"D", "[", 
      RowBox[{
       RowBox[{"\[Beta]", "[", 
        RowBox[{
         RowBox[{"x1", "[", "]"}], ",", 
         RowBox[{"x2", "[", "]"}]}], "]"}], ",", 
       RowBox[{"x1", "[", "]"}]}], "]"}], "\[Rule]", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"\[Gamma]", "[", 
        RowBox[{
         RowBox[{"x1", "[", "]"}], ",", 
         RowBox[{"x2", "[", "]"}]}], "]"}]}], 
      RowBox[{"D", "[", 
       RowBox[{
        RowBox[{"\[Gamma]", "[", 
         RowBox[{
          RowBox[{"x1", "[", "]"}], ",", 
          RowBox[{"x2", "[", "]"}]}], "]"}], ",", 
        RowBox[{"x2", "[", "]"}]}], "]"}]}]}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"D", "[", 
      RowBox[{
       RowBox[{"\[Beta]", "[", 
        RowBox[{
         RowBox[{"x1", "[", "]"}], ",", 
         RowBox[{"x2", "[", "]"}]}], "]"}], ",", 
       RowBox[{"x2", "[", "]"}]}], "]"}], "\[Rule]", "   ", 
     RowBox[{
      RowBox[{"\[Gamma]", "[", 
       RowBox[{
        RowBox[{"x1", "[", "]"}], ",", 
        RowBox[{"x2", "[", "]"}]}], "]"}], 
      RowBox[{"D", "[", 
       RowBox[{
        RowBox[{"\[Gamma]", "[", 
         RowBox[{
          RowBox[{"x1", "[", "]"}], ",", 
          RowBox[{"x2", "[", "]"}]}], "]"}], ",", 
        RowBox[{"x1", "[", "]"}]}], "]"}]}]}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"D", "[", 
      RowBox[{
       RowBox[{"\[Chi]", "[", 
        RowBox[{
         RowBox[{"x1", "[", "]"}], ",", 
         RowBox[{"x2", "[", "]"}]}], "]"}], ",", 
       RowBox[{"x1", "[", "]"}]}], "]"}], "\[Rule]", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"\[Eta]", "[", 
        RowBox[{
         RowBox[{"x1", "[", "]"}], ",", 
         RowBox[{"x2", "[", "]"}]}], "]"}]}], 
      RowBox[{"D", "[", 
       RowBox[{
        RowBox[{"\[Eta]", "[", 
         RowBox[{
          RowBox[{"x1", "[", "]"}], ",", 
          RowBox[{"x2", "[", "]"}]}], "]"}], ",", 
        RowBox[{"x2", "[", "]"}]}], "]"}]}]}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"D", "[", 
      RowBox[{
       RowBox[{"\[Chi]", "[", 
        RowBox[{
         RowBox[{"x1", "[", "]"}], ",", 
         RowBox[{"x2", "[", "]"}]}], "]"}], ",", 
       RowBox[{"x2", "[", "]"}]}], "]"}], "\[Rule]", "   ", 
     RowBox[{
      RowBox[{"\[Eta]", "[", 
       RowBox[{
        RowBox[{"x1", "[", "]"}], ",", 
        RowBox[{"x2", "[", "]"}]}], "]"}], 
      RowBox[{"D", "[", 
       RowBox[{
        RowBox[{"\[Eta]", "[", 
         RowBox[{
          RowBox[{"x1", "[", "]"}], ",", 
          RowBox[{"x2", "[", "]"}]}], "]"}], ",", 
        RowBox[{"x1", "[", "]"}]}], "]"}]}]}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Z_.", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"Derivative", "[", 
          RowBox[{"0", ",", "2"}], "]"}], "[", "G_", "]"}], "[", 
        RowBox[{
         RowBox[{"x1", "[", "]"}], ",", 
         RowBox[{"x2", "[", "]"}]}], "]"}]}], "+", 
      RowBox[{"Z_.", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"Derivative", "[", 
          RowBox[{"2", ",", "0"}], "]"}], "[", "G_", "]"}], "[", 
        RowBox[{
         RowBox[{"x1", "[", "]"}], ",", 
         RowBox[{"x2", "[", "]"}]}], "]"}]}]}], "\[RuleDelayed]", " ", 
     RowBox[{
      RowBox[{"-", "Z"}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"Derivative", "[", 
             RowBox[{"1", ",", "0"}], "]"}], "[", "G", "]"}], "[", 
           RowBox[{
            RowBox[{"x1", "[", "]"}], ",", 
            RowBox[{"x2", "[", "]"}]}], "]"}], "^", "2"}], "+", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"Derivative", "[", 
             RowBox[{"0", ",", "1"}], "]"}], "[", "G", "]"}], "[", 
           RowBox[{
            RowBox[{"x1", "[", "]"}], ",", 
            RowBox[{"x2", "[", "]"}]}], "]"}], "^", "2"}]}], ")"}], "/", 
       RowBox[{"G", "[", 
        RowBox[{
         RowBox[{"x1", "[", "]"}], ",", 
         RowBox[{"x2", "[", "]"}]}], "]"}]}]}]}]}], "\[IndentingNewLine]", 
   "}"}]}]], "Input",ExpressionUUID->"189781b9-f471-4c88-9826-ead5fe5db6cf"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["\[Alpha]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Alpha],
       Editable->False], 
      TagBox[
       RowBox[{"(", 
        RowBox[{"1", ",", "0"}], ")"}],
       Derivative],
      MultilineFunction->None], "[", 
     RowBox[{
      InterpretationBox[
       StyleBox["x1",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`x1[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["x2",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`x2[],
       Editable->False]}], "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Upsilon]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Upsilon],
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["x1",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x1[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["x2",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x2[],
         Editable->False]}], "]"}]}], " ", 
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Upsilon]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Upsilon],
        Editable->False], 
       TagBox[
        RowBox[{"(", 
         RowBox[{"0", ",", "1"}], ")"}],
        Derivative],
       MultilineFunction->None], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["x1",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x1[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["x2",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x2[],
        Editable->False]}], "]"}]}]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["\[Alpha]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Alpha],
       Editable->False], 
      TagBox[
       RowBox[{"(", 
        RowBox[{"0", ",", "1"}], ")"}],
       Derivative],
      MultilineFunction->None], "[", 
     RowBox[{
      InterpretationBox[
       StyleBox["x1",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`x1[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["x2",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`x2[],
       Editable->False]}], "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{
      InterpretationBox[
       StyleBox["\[Upsilon]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Upsilon],
       Editable->False], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["x1",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x1[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["x2",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x2[],
        Editable->False]}], "]"}], " ", 
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Upsilon]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Upsilon],
        Editable->False], 
       TagBox[
        RowBox[{"(", 
         RowBox[{"1", ",", "0"}], ")"}],
        Derivative],
       MultilineFunction->None], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["x1",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x1[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["x2",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x2[],
        Editable->False]}], "]"}]}]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["\[Beta]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Beta],
       Editable->False], 
      TagBox[
       RowBox[{"(", 
        RowBox[{"1", ",", "0"}], ")"}],
       Derivative],
      MultilineFunction->None], "[", 
     RowBox[{
      InterpretationBox[
       StyleBox["x1",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`x1[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["x2",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`x2[],
       Editable->False]}], "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Gamma]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Gamma],
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["x1",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x1[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["x2",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x2[],
         Editable->False]}], "]"}]}], " ", 
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Gamma]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Gamma],
        Editable->False], 
       TagBox[
        RowBox[{"(", 
         RowBox[{"0", ",", "1"}], ")"}],
        Derivative],
       MultilineFunction->None], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["x1",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x1[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["x2",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x2[],
        Editable->False]}], "]"}]}]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["\[Beta]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Beta],
       Editable->False], 
      TagBox[
       RowBox[{"(", 
        RowBox[{"0", ",", "1"}], ")"}],
       Derivative],
      MultilineFunction->None], "[", 
     RowBox[{
      InterpretationBox[
       StyleBox["x1",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`x1[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["x2",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`x2[],
       Editable->False]}], "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{
      InterpretationBox[
       StyleBox["\[Gamma]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Gamma],
       Editable->False], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["x1",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x1[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["x2",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x2[],
        Editable->False]}], "]"}], " ", 
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Gamma]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Gamma],
        Editable->False], 
       TagBox[
        RowBox[{"(", 
         RowBox[{"1", ",", "0"}], ")"}],
        Derivative],
       MultilineFunction->None], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["x1",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x1[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["x2",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x2[],
        Editable->False]}], "]"}]}]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["\[Chi]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Chi],
       Editable->False], 
      TagBox[
       RowBox[{"(", 
        RowBox[{"1", ",", "0"}], ")"}],
       Derivative],
      MultilineFunction->None], "[", 
     RowBox[{
      InterpretationBox[
       StyleBox["x1",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`x1[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["x2",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`x2[],
       Editable->False]}], "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Eta]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Eta],
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["x1",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x1[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["x2",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x2[],
         Editable->False]}], "]"}]}], " ", 
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Eta]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Eta],
        Editable->False], 
       TagBox[
        RowBox[{"(", 
         RowBox[{"0", ",", "1"}], ")"}],
        Derivative],
       MultilineFunction->None], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["x1",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x1[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["x2",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x2[],
        Editable->False]}], "]"}]}]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["\[Chi]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Chi],
       Editable->False], 
      TagBox[
       RowBox[{"(", 
        RowBox[{"0", ",", "1"}], ")"}],
       Derivative],
      MultilineFunction->None], "[", 
     RowBox[{
      InterpretationBox[
       StyleBox["x1",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`x1[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["x2",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`x2[],
       Editable->False]}], "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{
      InterpretationBox[
       StyleBox["\[Eta]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Eta],
       Editable->False], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["x1",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x1[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["x2",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x2[],
        Editable->False]}], "]"}], " ", 
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Eta]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Eta],
        Editable->False], 
       TagBox[
        RowBox[{"(", 
         RowBox[{"1", ",", "0"}], ")"}],
        Derivative],
       MultilineFunction->None], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["x1",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x1[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["x2",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x2[],
        Editable->False]}], "]"}]}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"Z_.", " ", 
      RowBox[{
       SuperscriptBox["G_", 
        TagBox[
         RowBox[{"(", 
          RowBox[{"0", ",", "2"}], ")"}],
         Derivative],
        MultilineFunction->None], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["x1",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x1[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["x2",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x2[],
         Editable->False]}], "]"}]}], "+", 
     RowBox[{"Z_.", " ", 
      RowBox[{
       SuperscriptBox["G_", 
        TagBox[
         RowBox[{"(", 
          RowBox[{"2", ",", "0"}], ")"}],
         Derivative],
        MultilineFunction->None], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["x1",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x1[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["x2",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x2[],
         Editable->False]}], "]"}]}]}], "\[RuleDelayed]", 
    RowBox[{"-", 
     FractionBox[
      RowBox[{"Z", " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox[
          RowBox[{
           SuperscriptBox["G", 
            TagBox[
             RowBox[{"(", 
              RowBox[{"1", ",", "0"}], ")"}],
             Derivative],
            MultilineFunction->None], "[", 
           RowBox[{
            InterpretationBox[
             StyleBox["x1",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`x1[],
             Editable->False], ",", 
            InterpretationBox[
             StyleBox["x2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`x2[],
             Editable->False]}], "]"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{
           SuperscriptBox["G", 
            TagBox[
             RowBox[{"(", 
              RowBox[{"0", ",", "1"}], ")"}],
             Derivative],
            MultilineFunction->None], "[", 
           RowBox[{
            InterpretationBox[
             StyleBox["x1",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`x1[],
             Editable->False], ",", 
            InterpretationBox[
             StyleBox["x2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`x2[],
             Editable->False]}], "]"}], "2"]}], ")"}]}], 
      RowBox[{"G", "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["x1",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x1[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["x2",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x2[],
         Editable->False]}], "]"}]]}]}]}], "}"}]], "Output",ExpressionUUID->\
"e744bee0-202a-431a-bcfc-163d98874cbf"]
}, Open  ]],

Cell["\<\
Using the first 6 rules we get that the Laplacians of \[Alpha], \[Beta], \
\[Gamma] vanish:\
\>", "Text",ExpressionUUID->"911b574c-1f79-4b59-b644-cea7318fd117"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"\[Alpha]", "[", 
      RowBox[{
       RowBox[{"x1", "[", "]"}], ",", 
       RowBox[{"x2", "[", "]"}]}], "]"}], ",", 
     RowBox[{"x1", "[", "]"}], ",", 
     RowBox[{"x1", "[", "]"}]}], "]"}], "+", 
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"\[Alpha]", "[", 
      RowBox[{
       RowBox[{"x1", "[", "]"}], ",", 
       RowBox[{"x2", "[", "]"}]}], "]"}], ",", 
     RowBox[{"x2", "[", "]"}], ",", 
     RowBox[{"x2", "[", "]"}]}], "]"}]}], "==", 
  RowBox[{
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"D", "[", 
       RowBox[{
        RowBox[{"\[Alpha]", "[", 
         RowBox[{
          RowBox[{"x1", "[", "]"}], ",", 
          RowBox[{"x2", "[", "]"}]}], "]"}], ",", 
        RowBox[{"x1", "[", "]"}]}], "]"}], "/.", "rules"}], ",", 
     RowBox[{"x1", "[", "]"}]}], "]"}], "+", 
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"D", "[", 
       RowBox[{
        RowBox[{"\[Alpha]", "[", 
         RowBox[{
          RowBox[{"x1", "[", "]"}], ",", 
          RowBox[{"x2", "[", "]"}]}], "]"}], ",", 
        RowBox[{"x2", "[", "]"}]}], "]"}], "/.", "rules"}], ",", 
     RowBox[{"x2", "[", "]"}]}], "]"}]}]}]], "Input",ExpressionUUID->\
"17691984-91bd-4ccf-b903-7b45d12764ee"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["\[Alpha]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Alpha],
      Editable->False], 
     TagBox[
      RowBox[{"(", 
       RowBox[{"0", ",", "2"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["x1",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`x1[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["x2",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`x2[],
      Editable->False]}], "]"}], "+", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["\[Alpha]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Alpha],
      Editable->False], 
     TagBox[
      RowBox[{"(", 
       RowBox[{"2", ",", "0"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["x1",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`x1[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["x2",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`x2[],
      Editable->False]}], "]"}]}], "\[Equal]", "0"}]], "Output",ExpressionUUID\
->"29cc4fc0-952b-4e18-ac4e-1fdd1cfe244e"]
}, Open  ]],

Cell["But using the last rule we also get:", "Text",ExpressionUUID->"965fa51e-b62b-4001-9efe-6830d3c249c6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"D", "[", 
     RowBox[{
      RowBox[{"\[Alpha]", "[", 
       RowBox[{
        RowBox[{"x1", "[", "]"}], ",", 
        RowBox[{"x2", "[", "]"}]}], "]"}], ",", 
      RowBox[{"x1", "[", "]"}], ",", 
      RowBox[{"x1", "[", "]"}]}], "]"}], "+", 
    RowBox[{"D", "[", 
     RowBox[{
      RowBox[{"\[Alpha]", "[", 
       RowBox[{
        RowBox[{"x1", "[", "]"}], ",", 
        RowBox[{"x2", "[", "]"}]}], "]"}], ",", 
      RowBox[{"x2", "[", "]"}], ",", 
      RowBox[{"x2", "[", "]"}]}], "]"}]}], "/.", "rules"}], "//", 
  "Simplify"}]], "Input",ExpressionUUID->"ce9d0f9b-a75f-4290-b674-\
aedaeaeb0e0b"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{
    SuperscriptBox[
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], 
       TagBox[
        RowBox[{"(", 
         RowBox[{"0", ",", "1"}], ")"}],
        Derivative],
       MultilineFunction->None], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["x1",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x1[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["x2",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x2[],
        Editable->False]}], "]"}], "2"], "+", 
    SuperscriptBox[
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], 
       TagBox[
        RowBox[{"(", 
         RowBox[{"1", ",", "0"}], ")"}],
        Derivative],
       MultilineFunction->None], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["x1",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x1[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["x2",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x2[],
        Editable->False]}], "]"}], "2"]}], 
   RowBox[{
    InterpretationBox[
     StyleBox["\[Alpha]",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`\[Alpha],
     Editable->False], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["x1",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`x1[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["x2",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`x2[],
      Editable->False]}], "]"}]]}]], "Output",ExpressionUUID->"48618b07-32f2-\
41d2-82d0-c3adf4defddb"]
}, Open  ]],

Cell["And then with the other rules:", "Text",ExpressionUUID->"d20b3e42-d6f6-4d59-ba1b-0b26f22d71d4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"%", "/.", "rules"}], "//", "Simplify"}]], "Input",ExpressionUUID->\
"3f40ddf2-e0a3-48bc-abb6-2cd43e00c471"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{
    SuperscriptBox[
     RowBox[{
      InterpretationBox[
       StyleBox["\[Upsilon]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Upsilon],
       Editable->False], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["x1",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x1[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["x2",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x2[],
        Editable->False]}], "]"}], "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox[
       RowBox[{
        SuperscriptBox[
         InterpretationBox[
          StyleBox["\[Upsilon]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[Upsilon],
          Editable->False], 
         TagBox[
          RowBox[{"(", 
           RowBox[{"0", ",", "1"}], ")"}],
          Derivative],
         MultilineFunction->None], "[", 
        RowBox[{
         InterpretationBox[
          StyleBox["x1",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x1[],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["x2",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x2[],
          Editable->False]}], "]"}], "2"], "+", 
      SuperscriptBox[
       RowBox[{
        SuperscriptBox[
         InterpretationBox[
          StyleBox["\[Upsilon]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[Upsilon],
          Editable->False], 
         TagBox[
          RowBox[{"(", 
           RowBox[{"1", ",", "0"}], ")"}],
          Derivative],
         MultilineFunction->None], "[", 
        RowBox[{
         InterpretationBox[
          StyleBox["x1",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x1[],
          Editable->False], ",", 
         InterpretationBox[
          StyleBox["x2",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x2[],
          Editable->False]}], "]"}], "2"]}], ")"}]}], 
   RowBox[{
    InterpretationBox[
     StyleBox["\[Alpha]",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`\[Alpha],
     Editable->False], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["x1",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`x1[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["x2",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`x2[],
      Editable->False]}], "]"}]]}]], "Output",ExpressionUUID->"5a44a203-2f5f-\
42df-ad41-d1890cc94161"]
}, Open  ]],

Cell["\<\
For some reason, for us the rules given by Bonanos are not enough:\
\>", "Text",ExpressionUUID->"8d087705-8da9-41b8-8dee-279293cf2274"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ricci", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}]}], "]"}], "//.", "rules"}], "//", 
  "Simplify"}]], "Input",ExpressionUUID->"8c7f8322-49c0-4dc2-8ece-\
080359f5047f"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 4} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "5"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 5} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "6"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 6} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "7"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 7} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "8"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 8} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 4} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "5"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 5} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "6"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 6} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "7"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 7} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "8"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 8} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 4} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "5"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 5} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "6"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 6} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "7"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 7} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            FractionBox[
             RowBox[{
              SuperscriptBox[
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["\[Upsilon]",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`\[Upsilon],
                  Editable->False], 
                 TagBox[
                  RowBox[{"(", 
                   RowBox[{"0", ",", "1"}], ")"}],
                  Derivative],
                 MultilineFunction->None], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"], "+", 
              SuperscriptBox[
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["\[Upsilon]",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`\[Upsilon],
                  Editable->False], 
                 TagBox[
                  RowBox[{"(", 
                   RowBox[{"1", ",", "0"}], ")"}],
                  Derivative],
                 MultilineFunction->None], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"]}], 
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["\[Alpha]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Alpha],
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x1",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x1[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["x2",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x2[],
                 Editable->False]}], "]"}], " ", 
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["\[Gamma]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Gamma],
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"], " ", 
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["\[Eta]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Eta],
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"], " ", 
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["\[Upsilon]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Upsilon],
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"]}]],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "8"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 SuperscriptBox[
                  RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], "+",
                  
                 SuperscriptBox[
                  RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
               RowBox[{
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}]]}]],
           Annotation[#, {3, 8} -> $CellContext`\[Alpha][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-1) $CellContext`\[Gamma][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) $CellContext`\[Eta][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) $CellContext`\[Upsilon][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) (
              Derivative[0, 1][$CellContext`\[Upsilon]][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^2 + 
              Derivative[1, 0][$CellContext`\[Upsilon]][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^2), "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 4} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            FractionBox[
             RowBox[{
              SuperscriptBox[
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["\[Gamma]",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`\[Gamma],
                  Editable->False], 
                 TagBox[
                  RowBox[{"(", 
                   RowBox[{"0", ",", "1"}], ")"}],
                  Derivative],
                 MultilineFunction->None], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"], "+", 
              SuperscriptBox[
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["\[Gamma]",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`\[Gamma],
                  Editable->False], 
                 TagBox[
                  RowBox[{"(", 
                   RowBox[{"1", ",", "0"}], ")"}],
                  Derivative],
                 MultilineFunction->None], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"]}], 
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["\[Beta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Beta],
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x1",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x1[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["x2",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x2[],
                 Editable->False]}], "]"}], " ", 
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["\[Gamma]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Gamma],
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"], " ", 
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["\[Eta]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Eta],
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"], " ", 
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["\[Upsilon]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Upsilon],
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"]}]],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "5"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 SuperscriptBox[
                  RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], "+", 
                 SuperscriptBox[
                  RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
               RowBox[{
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Beta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Beta], Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}]]}]],
           Annotation[#, {4, 5} -> $CellContext`\[Beta][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-1) $CellContext`\[Gamma][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) $CellContext`\[Eta][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) $CellContext`\[Upsilon][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) (
              Derivative[0, 1][$CellContext`\[Gamma]][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^2 + 
              Derivative[1, 0][$CellContext`\[Gamma]][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^2), "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "6"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 6} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "7"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 7} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "8"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 8} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"5", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {5, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"5", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {5, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"5", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {5, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            FractionBox[
             RowBox[{
              SuperscriptBox[
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["\[Gamma]",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`\[Gamma],
                  Editable->False], 
                 TagBox[
                  RowBox[{"(", 
                   RowBox[{"0", ",", "1"}], ")"}],
                  Derivative],
                 MultilineFunction->None], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"], "+", 
              SuperscriptBox[
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["\[Gamma]",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`\[Gamma],
                  Editable->False], 
                 TagBox[
                  RowBox[{"(", 
                   RowBox[{"1", ",", "0"}], ")"}],
                  Derivative],
                 MultilineFunction->None], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"]}], 
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["\[Beta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Beta],
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x1",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x1[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["x2",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x2[],
                 Editable->False]}], "]"}], " ", 
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["\[Gamma]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Gamma],
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"], " ", 
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["\[Eta]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Eta],
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"], " ", 
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["\[Upsilon]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Upsilon],
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"]}]],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"5", ",", "4"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 SuperscriptBox[
                  RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], "+", 
                 SuperscriptBox[
                  RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
               RowBox[{
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Beta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Beta], Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}]]}]],
           Annotation[#, {5, 4} -> $CellContext`\[Beta][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-1) $CellContext`\[Gamma][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) $CellContext`\[Eta][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) $CellContext`\[Upsilon][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) (
              Derivative[0, 1][$CellContext`\[Gamma]][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^2 + 
              Derivative[1, 0][$CellContext`\[Gamma]][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^2), "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            FractionBox[
             RowBox[{"4", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["\[Gamma]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Gamma],
                    Editable->False], 
                   TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                   MultilineFunction->None], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x1",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x1[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["x2",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x2[],
                    Editable->False]}], "]"}], "2"], "+", 
                SuperscriptBox[
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["\[Gamma]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Gamma],
                    Editable->False], 
                   TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                   MultilineFunction->None], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x1",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x1[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["x2",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x2[],
                    Editable->False]}], "]"}], "2"]}], ")"}]}], 
             RowBox[{
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["\[Gamma]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Gamma],
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"], " ", 
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["\[Eta]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Eta],
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"], " ", 
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["\[Upsilon]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Upsilon],
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"]}]],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"5", ",", "5"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{"4", " ", 
                 RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                   ")"}]}], 
               RowBox[{
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}]]}]],
           Annotation[#, {5, 5} -> 4 $CellContext`\[Gamma][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) $CellContext`\[Eta][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) $CellContext`\[Upsilon][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) (
              Derivative[0, 1][$CellContext`\[Gamma]][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^2 + 
              Derivative[1, 0][$CellContext`\[Gamma]][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^2), "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"5", ",", "6"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {5, 6} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"5", ",", "7"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {5, 7} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"5", ",", "8"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {5, 8} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"6", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {6, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"6", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {6, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"6", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {6, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"6", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {6, 4} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"6", ",", "5"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {6, 5} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            FractionBox[
             RowBox[{"4", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["\[Eta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Eta],
                    Editable->False], 
                   TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                   MultilineFunction->None], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x1",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x1[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["x2",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x2[],
                    Editable->False]}], "]"}], "2"], "+", 
                SuperscriptBox[
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["\[Eta]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Eta],
                    Editable->False], 
                   TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                   MultilineFunction->None], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x1",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x1[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["x2",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x2[],
                    Editable->False]}], "]"}], "2"]}], ")"}]}], 
             RowBox[{
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["\[Gamma]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Gamma],
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"], " ", 
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["\[Eta]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Eta],
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"], " ", 
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["\[Upsilon]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Upsilon],
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"]}]],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"6", ",", "6"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{"4", " ", 
                 RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                   ")"}]}], 
               RowBox[{
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}]]}]],
           Annotation[#, {6, 6} -> 4 $CellContext`\[Gamma][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) $CellContext`\[Eta][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) $CellContext`\[Upsilon][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) (Derivative[0, 1][$CellContext`\[Eta]][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^2 + 
              Derivative[1, 0][$CellContext`\[Eta]][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^2), "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            FractionBox[
             RowBox[{
              SuperscriptBox[
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["\[Eta]",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`\[Eta],
                  Editable->False], 
                 TagBox[
                  RowBox[{"(", 
                   RowBox[{"0", ",", "1"}], ")"}],
                  Derivative],
                 MultilineFunction->None], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"], "+", 
              SuperscriptBox[
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["\[Eta]",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`\[Eta],
                  Editable->False], 
                 TagBox[
                  RowBox[{"(", 
                   RowBox[{"1", ",", "0"}], ")"}],
                  Derivative],
                 MultilineFunction->None], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"]}], 
             RowBox[{
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["\[Gamma]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Gamma],
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"], " ", 
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["\[Eta]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Eta],
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"], " ", 
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["\[Upsilon]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Upsilon],
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["\[Chi]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Chi],
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x1",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x1[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["x2",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x2[],
                 Editable->False]}], "]"}]}]],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"6", ",", "7"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 SuperscriptBox[
                  RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], "+", 
                 SuperscriptBox[
                  RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
               RowBox[{
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}]]}]],
           Annotation[#, {6, 7} -> $CellContext`\[Gamma][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) $CellContext`\[Eta][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) $CellContext`\[Upsilon][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) $CellContext`\[Chi][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-1) (Derivative[0, 1][$CellContext`\[Eta]][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^2 + 
              Derivative[1, 0][$CellContext`\[Eta]][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^2), "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"6", ",", "8"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {6, 8} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"7", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {7, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"7", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {7, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"7", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {7, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"7", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {7, 4} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"7", ",", "5"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {7, 5} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            FractionBox[
             RowBox[{
              SuperscriptBox[
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["\[Eta]",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`\[Eta],
                  Editable->False], 
                 TagBox[
                  RowBox[{"(", 
                   RowBox[{"0", ",", "1"}], ")"}],
                  Derivative],
                 MultilineFunction->None], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"], "+", 
              SuperscriptBox[
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["\[Eta]",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`\[Eta],
                  Editable->False], 
                 TagBox[
                  RowBox[{"(", 
                   RowBox[{"1", ",", "0"}], ")"}],
                  Derivative],
                 MultilineFunction->None], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"]}], 
             RowBox[{
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["\[Gamma]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Gamma],
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"], " ", 
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["\[Eta]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Eta],
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"], " ", 
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["\[Upsilon]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Upsilon],
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"], " ", 
              RowBox[{
               InterpretationBox[
                StyleBox["\[Chi]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Chi],
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x1",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x1[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["x2",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x2[],
                 Editable->False]}], "]"}]}]],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"7", ",", "6"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 SuperscriptBox[
                  RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], "+", 
                 SuperscriptBox[
                  RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
               RowBox[{
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Chi]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Chi], Editable -> False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}]}]]}]],
           Annotation[#, {7, 6} -> $CellContext`\[Gamma][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) $CellContext`\[Eta][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) $CellContext`\[Upsilon][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) $CellContext`\[Chi][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-1) (Derivative[0, 1][$CellContext`\[Eta]][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^2 + 
              Derivative[1, 0][$CellContext`\[Eta]][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^2), "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"7", ",", "7"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {7, 7} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"7", ",", "8"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {7, 8} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"8", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {8, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"8", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {8, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            FractionBox[
             RowBox[{
              SuperscriptBox[
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["\[Upsilon]",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`\[Upsilon],
                  Editable->False], 
                 TagBox[
                  RowBox[{"(", 
                   RowBox[{"0", ",", "1"}], ")"}],
                  Derivative],
                 MultilineFunction->None], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"], "+", 
              SuperscriptBox[
               RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox["\[Upsilon]",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`\[Upsilon],
                  Editable->False], 
                 TagBox[
                  RowBox[{"(", 
                   RowBox[{"1", ",", "0"}], ")"}],
                  Derivative],
                 MultilineFunction->None], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"]}], 
             RowBox[{
              RowBox[{
               InterpretationBox[
                StyleBox["\[Alpha]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Alpha],
                Editable->False], "[", 
               RowBox[{
                InterpretationBox[
                 StyleBox["x1",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x1[],
                 Editable->False], ",", 
                InterpretationBox[
                 StyleBox["x2",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`x2[],
                 Editable->False]}], "]"}], " ", 
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["\[Gamma]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Gamma],
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"], " ", 
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["\[Eta]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Eta],
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"], " ", 
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["\[Upsilon]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Upsilon],
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"]}]],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"8", ",", "3"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 SuperscriptBox[
                  RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], "+", 
                 SuperscriptBox[
                  RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
               RowBox[{
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "[", 
                   RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}]]}]],
           Annotation[#, {8, 3} -> $CellContext`\[Alpha][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-1) $CellContext`\[Gamma][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) $CellContext`\[Eta][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) $CellContext`\[Upsilon][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) (
              Derivative[0, 1][$CellContext`\[Upsilon]][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^2 + 
              Derivative[1, 0][$CellContext`\[Upsilon]][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^2), "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"8", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {8, 4} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"8", ",", "5"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {8, 5} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"8", ",", "6"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {8, 6} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"8", ",", "7"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {8, 7} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            FractionBox[
             RowBox[{"4", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["\[Upsilon]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Upsilon],
                    Editable->False], 
                   TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}],
                    Derivative],
                   MultilineFunction->None], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x1",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x1[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["x2",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x2[],
                    Editable->False]}], "]"}], "2"], "+", 
                SuperscriptBox[
                 RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox["\[Upsilon]",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`\[Upsilon],
                    Editable->False], 
                   TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}],
                    Derivative],
                   MultilineFunction->None], "[", 
                  RowBox[{
                   InterpretationBox[
                    StyleBox["x1",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x1[],
                    Editable->False], ",", 
                   InterpretationBox[
                    StyleBox["x2",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                    $CellContext`x2[],
                    Editable->False]}], "]"}], "2"]}], ")"}]}], 
             RowBox[{
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["\[Gamma]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Gamma],
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"], " ", 
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["\[Eta]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Eta],
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"], " ", 
              SuperscriptBox[
               RowBox[{
                InterpretationBox[
                 StyleBox["\[Upsilon]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Upsilon],
                 Editable->False], "[", 
                RowBox[{
                 InterpretationBox[
                  StyleBox["x1",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x1[],
                  Editable->False], ",", 
                 InterpretationBox[
                  StyleBox["x2",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`x2[],
                  Editable->False]}], "]"}], "2"]}]],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"8", ",", "8"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{"4", " ", 
                 RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"0", ",", "1"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], "+", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], 
                    TagBox[
                    RowBox[{"(", 
                    RowBox[{"1", ",", "0"}], ")"}], Derivative], 
                    MultilineFunction -> None], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}], 
                   ")"}]}], 
               RowBox[{
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Gamma]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Gamma], Editable -> 
                    False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Eta]"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`\[Eta], Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Upsilon]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Upsilon], 
                    Editable -> False], "[", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "x1", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x1[], Editable -> False], ",", 
                    InterpretationBox[
                    StyleBox[
                    "x2", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x2[], Editable -> False]}], "]"}], "2"]}]]}]],
           Annotation[#, {8, 8} -> 4 $CellContext`\[Gamma][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) $CellContext`\[Eta][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) $CellContext`\[Upsilon][
                $CellContext`x1[], 
                $CellContext`x2[]]^(-2) (
              Derivative[0, 1][$CellContext`\[Upsilon]][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^2 + 
              Derivative[1, 0][$CellContext`\[Upsilon]][
                 $CellContext`x1[], 
                 $CellContext`x2[]]^2), "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 9 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 9 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {" ", " "},
         {"a", "b"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {
    0, 0, 0, 0, 0, 0, 0, $CellContext`\[Alpha][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-1) $CellContext`\[Gamma][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) $CellContext`\[Eta][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) $CellContext`\[Upsilon][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) (Derivative[0, 1][$CellContext`\[Upsilon]][
         $CellContext`x1[], 
         $CellContext`x2[]]^2 + Derivative[1, 0][$CellContext`\[Upsilon]][
         $CellContext`x1[], 
         $CellContext`x2[]]^2)}, {0, 0, 0, 0, $CellContext`\[Beta][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-1) $CellContext`\[Gamma][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) $CellContext`\[Eta][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) $CellContext`\[Upsilon][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) (Derivative[0, 1][$CellContext`\[Gamma]][
         $CellContext`x1[], 
         $CellContext`x2[]]^2 + Derivative[1, 0][$CellContext`\[Gamma]][
         $CellContext`x1[], 
         $CellContext`x2[]]^2), 0, 0, 0}, {0, 0, 0, $CellContext`\[Beta][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-1) $CellContext`\[Gamma][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) $CellContext`\[Eta][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) $CellContext`\[Upsilon][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) (Derivative[0, 1][$CellContext`\[Gamma]][
         $CellContext`x1[], 
         $CellContext`x2[]]^2 + Derivative[1, 0][$CellContext`\[Gamma]][
         $CellContext`x1[], 
         $CellContext`x2[]]^2), 4 $CellContext`\[Gamma][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) $CellContext`\[Eta][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) $CellContext`\[Upsilon][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) (Derivative[0, 1][$CellContext`\[Gamma]][
         $CellContext`x1[], 
         $CellContext`x2[]]^2 + Derivative[1, 0][$CellContext`\[Gamma]][
         $CellContext`x1[], 
         $CellContext`x2[]]^2), 0, 0, 0}, {
    0, 0, 0, 0, 0, 4 $CellContext`\[Gamma][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) $CellContext`\[Eta][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) $CellContext`\[Upsilon][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) (Derivative[0, 1][$CellContext`\[Eta]][
         $CellContext`x1[], 
         $CellContext`x2[]]^2 + Derivative[1, 0][$CellContext`\[Eta]][
         $CellContext`x1[], 
         $CellContext`x2[]]^2), $CellContext`\[Gamma][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) $CellContext`\[Eta][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) $CellContext`\[Upsilon][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) $CellContext`\[Chi][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-1) (Derivative[0, 1][$CellContext`\[Eta]][
         $CellContext`x1[], 
         $CellContext`x2[]]^2 + Derivative[1, 0][$CellContext`\[Eta]][
         $CellContext`x1[], 
         $CellContext`x2[]]^2), 0}, {0, 0, 0, 0, 0, $CellContext`\[Gamma][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) $CellContext`\[Eta][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) $CellContext`\[Upsilon][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) $CellContext`\[Chi][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-1) (Derivative[0, 1][$CellContext`\[Eta]][
         $CellContext`x1[], 
         $CellContext`x2[]]^2 + Derivative[1, 0][$CellContext`\[Eta]][
         $CellContext`x1[], 
         $CellContext`x2[]]^2), 0, 0}, {0, 0, $CellContext`\[Alpha][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-1) $CellContext`\[Gamma][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) $CellContext`\[Eta][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) $CellContext`\[Upsilon][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) (Derivative[0, 1][$CellContext`\[Upsilon]][
         $CellContext`x1[], 
         $CellContext`x2[]]^2 + Derivative[1, 0][$CellContext`\[Upsilon]][
         $CellContext`x1[], 
         $CellContext`x2[]]^2), 0, 0, 0, 0, 4 $CellContext`\[Gamma][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) $CellContext`\[Eta][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) $CellContext`\[Upsilon][
        $CellContext`x1[], 
        $CellContext`x2[]]^(-2) (Derivative[0, 1][$CellContext`\[Upsilon]][
         $CellContext`x1[], 
         $CellContext`x2[]]^2 + Derivative[1, 0][$CellContext`\[Upsilon]][
         $CellContext`x1[], 
         $CellContext`x2[]]^2)}}, {-$CellContext`FK, -$CellContext`FK}, 
   0][-$CellContext`a, -$CellContext`b],
  Editable->False]], "Output",ExpressionUUID->"4b426fc6-6d04-49b4-800e-e4124826edfc"]
}, Open  ]],

Cell["We need to add the implied rules:", "Text",ExpressionUUID->"b58a117a-1a53-44f0-97b9-5ca0c58a1545"],

Cell[BoxData[
 RowBox[{
  RowBox[{"rules2", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"D", "[", 
        RowBox[{
         RowBox[{"\[Upsilon]", "[", 
          RowBox[{
           RowBox[{"x1", "[", "]"}], ",", 
           RowBox[{"x2", "[", "]"}]}], "]"}], ",", 
         RowBox[{"x1", "[", "]"}]}], "]"}], "^", "2"}], "\[RuleDelayed]", 
      RowBox[{"-", 
       RowBox[{
        RowBox[{"D", "[", 
         RowBox[{
          RowBox[{"\[Upsilon]", "[", 
           RowBox[{
            RowBox[{"x1", "[", "]"}], ",", 
            RowBox[{"x2", "[", "]"}]}], "]"}], ",", 
          RowBox[{"x2", "[", "]"}]}], "]"}], "^", "2"}]}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"D", "[", 
        RowBox[{
         RowBox[{"\[Gamma]", "[", 
          RowBox[{
           RowBox[{"x1", "[", "]"}], ",", 
           RowBox[{"x2", "[", "]"}]}], "]"}], ",", 
         RowBox[{"x1", "[", "]"}]}], "]"}], "^", "2"}], "\[RuleDelayed]", 
      RowBox[{"-", 
       RowBox[{
        RowBox[{"D", "[", 
         RowBox[{
          RowBox[{"\[Gamma]", "[", 
           RowBox[{
            RowBox[{"x1", "[", "]"}], ",", 
            RowBox[{"x2", "[", "]"}]}], "]"}], ",", 
          RowBox[{"x2", "[", "]"}]}], "]"}], "^", "2"}]}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"D", "[", 
        RowBox[{
         RowBox[{"\[Eta]", "[", 
          RowBox[{
           RowBox[{"x1", "[", "]"}], ",", 
           RowBox[{"x2", "[", "]"}]}], "]"}], ",", 
         RowBox[{"x1", "[", "]"}]}], "]"}], "^", "2"}], "\[RuleDelayed]", 
      RowBox[{"-", 
       RowBox[{
        RowBox[{"D", "[", 
         RowBox[{
          RowBox[{"\[Eta]", "[", 
           RowBox[{
            RowBox[{"x1", "[", "]"}], ",", 
            RowBox[{"x2", "[", "]"}]}], "]"}], ",", 
          RowBox[{"x2", "[", "]"}]}], "]"}], "^", "2"}]}]}]}], 
    "\[IndentingNewLine]", "}"}]}], ";"}]], "Input",ExpressionUUID->"473f64e9-\
a59d-4689-854a-708fdf453f30"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ricci", "[", 
     RowBox[{
      RowBox[{"-", "a"}], ",", 
      RowBox[{"-", "b"}]}], "]"}], "//.", "rules"}], "//.", "rules2"}], "//", 
  "Simplify"}]], "Input",ExpressionUUID->"0434ebb2-cce3-48a1-bbe5-\
5200a53dfab5"],

Cell[BoxData["0"], "Output",ExpressionUUID->"82b580ec-b69b-41d5-aa3d-70fc5295139c"]
}, Open  ]],

Cell["\<\
That is all a bit fishy, but in principle it is not trivial given that the \
functions are complex. However, if the functions are complex I\
\[CloseCurlyQuote]m not sure the operations are correct because I would \
expect a Hermitian metric, and not just symmetric. The algorithms are not \
prepared to handle Hermitian metrics anyway...\
\>", "Text",ExpressionUUID->"d2d88d9e-3332-4a90-b43c-aa4022bb4b9e"],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{
  "met", ",", "ricci", ",", "rules", ",", "rules2", ",", "G", ",", "Z"}], 
  "]"}]], "Input",ExpressionUUID->"cc73771f-fe60-412c-a94f-bf40d0b2ef3c"],

Cell[BoxData[
 RowBox[{"UndefScalarFunction", "[", 
  RowBox[{"{", 
   RowBox[{
   "\[Alpha]", ",", "\[Beta]", ",", "\[Chi]", ",", "\[Gamma]", ",", "\[Eta]", 
    ",", "\[Upsilon]"}], "}"}], "]"}]], "Input",ExpressionUUID->"dc39aeeb-\
e00d-4d5b-91c2-d207ddadeb4e"],

Cell[BoxData[
 RowBox[{"UndefChart", "[", "FK", "]"}]], "Input",ExpressionUUID->"834faac8-b42f-4dab-b405-5bcfe775883f"],

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M", "]"}]], "Input",ExpressionUUID->"d19bb53e-3b41-436d-a0ea-cd61a05bcdca"],

Cell[BoxData[
 RowBox[{"ClearxCobaCache", "[", "All", "]"}]], "Input",ExpressionUUID->"063e2f7e-26c9-4095-8a32-c8ddf77d5663"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.8. Harrison metric II-A-7", "Subsubsection",ExpressionUUID->"39600f73-77f7-4c41-8c13-0643d5b61a53"],

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M", ",", "4", ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"c256c676-94bc-4fd9-b3dd-aab1a581d092"],

Cell[BoxData[
 RowBox[{"DefChart", "[", 
  RowBox[{"H", ",", "M", ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"t", "[", "]"}], ",", 
     RowBox[{"x", "[", "]"}], ",", 
     RowBox[{"y", "[", "]"}], ",", 
     RowBox[{"z", "[", "]"}]}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"def72ac7-d3b9-4336-9d80-5623bfbbc3fa"],

Cell[BoxData[
 RowBox[{"DefScalarFunction", "[", 
  RowBox[{"{", 
   RowBox[{"v", ",", "F2"}], "}"}], "]"}]], "Input",ExpressionUUID->"a988f2a6-\
f4f1-415d-b5bc-b9b61476f4b9"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"rt3", "=", 
   RowBox[{"Sqrt", "[", "3", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"F1", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"x", "[", "]"}], "/", "rt3"}], "-", 
    RowBox[{
     RowBox[{
      RowBox[{"t", "[", "]"}], "^", "2"}], "/", "12"}]}]}], " ", 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    SuperscriptBox["F2", "\[Prime]",
     MultilineFunction->None], "[", 
    RowBox[{"z", "[", "]"}], "]"}], "=", 
   RowBox[{
    RowBox[{"F2", "[", 
     RowBox[{"z", "[", "]"}], "]"}], 
    RowBox[{
     RowBox[{"v", "[", 
      RowBox[{"z", "[", "]"}], "]"}], "/", 
     RowBox[{"z", "[", "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    SuperscriptBox["v", "\[Prime]",
     MultilineFunction->None], "[", 
    RowBox[{"z", "[", "]"}], "]"}], "=", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"v", "[", 
         RowBox[{"z", "[", "]"}], "]"}], "^", "2"}], "-", "1"}], ")"}], "/", 
     RowBox[{"(", 
      RowBox[{"4", 
       RowBox[{"z", "[", "]"}]}], ")"}]}], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", "  ", 
       RowBox[{
        RowBox[{"v", "[", 
         RowBox[{"z", "[", "]"}], "]"}], "/", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"z", "[", "]"}], "-", "1"}], ")"}]}]}], "+", 
      RowBox[{"4", "/", "rt3"}]}], ")"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"n1t", "=", 
   RowBox[{"2", "+", "rt3"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"n1x", "=", 
   RowBox[{"1", "+", "rt3"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"n1y", "=", 
   RowBox[{"-", "rt3"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"n1z", "=", 
   RowBox[{"3", "+", "rt3"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"n2t", "=", 
   RowBox[{"1", "+", 
    RowBox[{"2", "/", "rt3"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"n2x", "=", 
   RowBox[{"1", "+", 
    RowBox[{"2", "/", "rt3"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"n2y", "=", 
   RowBox[{"-", "1"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"n2z", "=", 
   RowBox[{"1", "+", 
    RowBox[{"2", "/", "rt3"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"n3t", "=", 
   RowBox[{"1", "/", "rt3"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"n3x", "=", 
   RowBox[{"1", "+", 
    RowBox[{"1", "/", "rt3"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"n3y", "=", 
   RowBox[{
    RowBox[{"-", "1"}], "/", "rt3"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"n3z", "=", 
   RowBox[{"2", "+", 
    RowBox[{"1", "/", "rt3"}]}]}], ";"}]}], "Input",ExpressionUUID->"c5ed833e-\
3995-4a62-9081-0f857ead8527"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"met", "=", 
  RowBox[{"CTensor", "[", 
   RowBox[{
    RowBox[{"DiagonalMatrix", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"F1", "^", "n1t"}], " ", 
        RowBox[{
         RowBox[{"F2", "[", 
          RowBox[{"z", "[", "]"}], "]"}], "^", "n2t"}], 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "/", 
           RowBox[{"z", "[", "]"}]}], ")"}], "^", "n3t"}]}], ",", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"F1", "^", "n1x"}]}], " ", 
        RowBox[{
         RowBox[{"F2", "[", 
          RowBox[{"z", "[", "]"}], "]"}], "^", "n2x"}], 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "/", 
           RowBox[{"z", "[", "]"}]}], ")"}], "^", "n3x"}]}], ",", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"F1", "^", "n1y"}]}], " ", 
        RowBox[{
         RowBox[{"F2", "[", 
          RowBox[{"z", "[", "]"}], "]"}], "^", "n2y"}], 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "/", 
           RowBox[{"z", "[", "]"}]}], ")"}], "^", "n3y"}]}], ",", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"F1", "^", "n1z"}]}], " ", 
        RowBox[{
         RowBox[{"F2", "[", 
          RowBox[{"z", "[", "]"}], "]"}], "^", "n2z"}], 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "/", 
           RowBox[{"z", "[", "]"}]}], ")"}], "^", "n3z"}], 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"v", "[", 
             RowBox[{"z", "[", "]"}], "]"}], "^", "2"}], "-", "1"}], ")"}], 
         "/", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"z", "[", "]"}], "-", "1"}], ")"}]}]}]}], "}"}], "]"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "H"}], ",", 
      RowBox[{"-", "H"}]}], "}"}]}], "]"}]}]], "Input",ExpressionUUID->\
"cebfa4a9-4c25-41fc-a4b0-1157b5925dd3"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        SuperscriptBox[
         RowBox[{
          InterpretationBox[
           StyleBox["F2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`F2,
           Editable->False], "[", 
          InterpretationBox[
           StyleBox["z",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`z[],
           Editable->False], "]"}], 
         RowBox[{"1", "+", 
          FractionBox["2", 
           SqrtBox["3"]]}]], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             SuperscriptBox[
              InterpretationBox[
               StyleBox["t",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`t[],
               Editable->False], "2"], "12"]}], "+", 
           FractionBox[
            InterpretationBox[
             StyleBox["x",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`x[],
             Editable->False], 
            SqrtBox["3"]]}], ")"}], 
         RowBox[{"2", "+", 
          SqrtBox["3"]}]], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"-", 
           FractionBox["1", 
            InterpretationBox[
             StyleBox["z",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`z[],
             Editable->False]]}], ")"}], 
         FractionBox["1", 
          SqrtBox["3"]]]}], ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{
        RowBox[{"-", 
         SuperscriptBox[
          RowBox[{
           InterpretationBox[
            StyleBox["F2",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`F2,
            Editable->False], "[", 
           InterpretationBox[
            StyleBox["z",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`z[],
            Editable->False], "]"}], 
          RowBox[{"1", "+", 
           FractionBox["2", 
            SqrtBox["3"]]}]]}], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             SuperscriptBox[
              InterpretationBox[
               StyleBox["t",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`t[],
               Editable->False], "2"], "12"]}], "+", 
           FractionBox[
            InterpretationBox[
             StyleBox["x",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`x[],
             Editable->False], 
            SqrtBox["3"]]}], ")"}], 
         RowBox[{"1", "+", 
          SqrtBox["3"]}]], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"-", 
           FractionBox["1", 
            InterpretationBox[
             StyleBox["z",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`z[],
             Editable->False]]}], ")"}], 
         RowBox[{"1", "+", 
          FractionBox["1", 
           SqrtBox["3"]]}]]}], ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", 
              FractionBox[
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["t",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`t[],
                 Editable->False], "2"], "12"]}], "+", 
             FractionBox[
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], 
              SqrtBox["3"]]}], ")"}], 
           RowBox[{"-", 
            SqrtBox["3"]}]], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", 
             FractionBox["1", 
              InterpretationBox[
               StyleBox["z",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`z[],
               Editable->False]]}], ")"}], 
           RowBox[{"-", 
            FractionBox["1", 
             SqrtBox["3"]]}]]}], 
         RowBox[{
          InterpretationBox[
           StyleBox["F2",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`F2,
           Editable->False], "[", 
          InterpretationBox[
           StyleBox["z",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`z[],
           Editable->False], "]"}]]}], ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          SuperscriptBox[
           RowBox[{
            InterpretationBox[
             StyleBox["F2",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`F2,
             Editable->False], "[", 
            InterpretationBox[
             StyleBox["z",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`z[],
             Editable->False], "]"}], 
           RowBox[{"1", "+", 
            FractionBox["2", 
             SqrtBox["3"]]}]], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            SuperscriptBox[
             RowBox[{
              InterpretationBox[
               StyleBox["v",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`v,
               Editable->False], "[", 
              InterpretationBox[
               StyleBox["z",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`z[],
               Editable->False], "]"}], "2"]}], ")"}], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", 
              FractionBox[
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["t",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`t[],
                 Editable->False], "2"], "12"]}], "+", 
             FractionBox[
              InterpretationBox[
               StyleBox["x",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`x[],
               Editable->False], 
              SqrtBox["3"]]}], ")"}], 
           RowBox[{"3", "+", 
            SqrtBox["3"]}]], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", 
             FractionBox["1", 
              InterpretationBox[
               StyleBox["z",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`z[],
               Editable->False]]}], ")"}], 
           RowBox[{"2", "+", 
            FractionBox["1", 
             SqrtBox["3"]]}]]}], 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          InterpretationBox[
           StyleBox["z",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`z[],
           Editable->False]}]]}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "H"}], ",", 
     RowBox[{"-", "H"}]}], "}"}], ",", "0"}], "]"}]], "Output",ExpressionUUID-\
>"da2705b1-fced-4a98-bed3-5cbe443f7548"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"$CVSimplify", "=", "Simplify"}], ";"}]], "Input",ExpressionUUID->\
"5bb359e6-bacb-4717-b7cf-18080fa06cdf"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"SetCMetric", "[", 
   RowBox[{"met", ",", "H", ",", 
    RowBox[{"SignatureOfMetric", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"3", ",", "1", ",", "0"}], "}"}]}]}], "]"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"7fba5aa6-2668-4321-a181-\
be0fc7dd10d0"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"3.538416`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"3d3042b2-860f-4a17-965f-d5c1af9c309a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MetricCompute", "[", 
   RowBox[{"met", ",", "H", ",", 
    RowBox[{"\"\<Weyl\>\"", "[", 
     RowBox[{
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}]}], "]"}], ",", 
    RowBox[{"Parallelize", "\[Rule]", "True"}]}], "]"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"9f95d11a-f8f4-4af7-a5c5-\
3e81f96190f0"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"5.408557`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"eb8923c3-a510-42ce-98d9-1b4cfff40089"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Ricci", "[", 
  RowBox[{"CovDOfMetric", "[", "met", "]"}], "]"}]], "Input",ExpressionUUID->\
"875a7f04-27d9-4a00-a919-89a690abebb3"],

Cell[BoxData["Zero"], "Output",ExpressionUUID->"4745c8f3-41f3-4ff1-9639-65757101aeae"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Determinant", "[", 
   RowBox[{"met", ",", "H"}], "]"}], "[", "]"}]], "Input",ExpressionUUID->\
"0149f514-30b6-4e2c-8254-59ab7ee70440"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   OverscriptBox[
    OverscriptBox[
     FractionBox[
      RowBox[{
       SuperscriptBox[
        RowBox[{
         InterpretationBox[
          StyleBox["F2",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`F2,
          Editable->False], "[", 
         InterpretationBox[
          StyleBox["z",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`z[],
          Editable->False], "]"}], 
        RowBox[{"2", "+", 
         RowBox[{"2", " ", 
          SqrtBox["3"]}]}]], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox[
          RowBox[{
           InterpretationBox[
            StyleBox["v",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`v,
            Editable->False], "[", 
           InterpretationBox[
            StyleBox["z",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`z[],
            Editable->False], "]"}], "2"]}], ")"}], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox[
            SuperscriptBox[
             InterpretationBox[
              StyleBox["t",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`t[],
              Editable->False], "2"], "12"]}], "+", 
          FractionBox[
           InterpretationBox[
            StyleBox["x",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x[],
            Editable->False], 
           SqrtBox["3"]]}], ")"}], 
        RowBox[{"2", " ", 
         RowBox[{"(", 
          RowBox[{"3", "+", 
           SqrtBox["3"]}], ")"}]}]], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"-", 
          FractionBox["1", 
           InterpretationBox[
            StyleBox["z",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`z[],
            Editable->False]]}], ")"}], 
        RowBox[{"4", "+", 
         FractionBox["2", 
          SqrtBox["3"]]}]], " ", 
       InterpretationBox[
        StyleBox["z",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`z[],
        Editable->False]}], 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       InterpretationBox[
        StyleBox["z",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`z[],
        Editable->False]}]], 
     StyleBox["~",
      FontColor->RGBColor[1., 0., 0.]]], 
    StyleBox["~",
     FontColor->RGBColor[1., 0., 0.]]],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[$CellContext`F2[
      $CellContext`z[]]^(2 + 2 3^Rational[1, 2]) (-1 + $CellContext`v[
       $CellContext`z[]]^2) (Rational[-1, 12] $CellContext`t[]^2 + 
     3^Rational[-1, 2] $CellContext`x[])^(
     2 (3 + 3^Rational[
        1, 2])) (-1 + $CellContext`z[])^(-1) ((-1)/$CellContext`z[])^(4 + 
     2 3^Rational[-1, 2]) $CellContext`z[], {}, 2 $CellContext`H][],
  Editable->False]], "Output",ExpressionUUID->"bf1fbb90-592c-47fc-a32b-\
36177ee86ee6"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{
  "met", ",", "F1", ",", "n1", ",", "n2", ",", "n3", ",", "n1t", ",", "n1x", 
   ",", "n1y", ",", "n1z", ",", "n2t", ",", "n2x", ",", "n2y", ",", "n2z", 
   ",", "n3t", ",", "n3x", ",", "n3y", ",", "n3z", ",", "rt3"}], 
  "]"}]], "Input",ExpressionUUID->"3da659bb-e2b6-48ef-91dc-984114a9c5a6"],

Cell[BoxData[
 RowBox[{"UndefScalarFunction", "[", 
  RowBox[{"{", 
   RowBox[{"v", ",", "F2"}], "}"}], "]"}]], "Input",ExpressionUUID->"51b52eb3-\
7dff-4715-b762-ad53e8d53b07"],

Cell[BoxData[
 RowBox[{"UndefChart", "[", "H", "]"}]], "Input",ExpressionUUID->"fdd544e6-2eec-4d6e-a0d9-875a13e82894"],

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M", "]"}]], "Input",ExpressionUUID->"c1a3fef4-fa9a-4596-9948-6736954a41a8"],

Cell[BoxData[
 RowBox[{"ClearxCobaCache", "[", "All", "]"}]], "Input",ExpressionUUID->"f6c0197a-ed12-4401-bbac-bbc59a7eee7f"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.9. Bondi metric", "Subsubsection",ExpressionUUID->"ecff7a72-c148-40f1-9465-2d37ba41a7be"],

Cell["\<\
This is an example of a case in which using the default simplification \
provided by Simplify is hopelessly slow. Instead, we use Expand, bringing \
down timings from a few minutes to less than 1 second.\
\>", "Text",ExpressionUUID->"b4503a98-0e08-4224-872b-c91b8e7ae0ec"],

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M", ",", "4", ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"96aa55e5-643e-44e3-b964-f9d948709b06"],

Cell[BoxData[
 RowBox[{"DefChart", "[", 
  RowBox[{"bondi", ",", "M", ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"u", "[", "]"}], ",", 
     RowBox[{"r", "[", "]"}], ",", 
     RowBox[{"\[Theta]", "[", "]"}], ",", 
     RowBox[{"\[Phi]", "[", "]"}]}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"63e4939a-ade9-4e93-93fd-e8e7d47655d6"],

Cell[BoxData[
 RowBox[{"DefScalarFunction", "[", 
  RowBox[{"{", 
   RowBox[{"\[Beta]", ",", "V", ",", "\[Gamma]", ",", "U"}], "}"}], 
  "]"}]], "Input",ExpressionUUID->"86ca9985-8f22-4f73-9ef2-9cf9075a24bd"],

Cell[BoxData[
 RowBox[{
  RowBox[{"met", "=", 
   RowBox[{"CTensor", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"Exp", "[", 
            RowBox[{"2", " ", 
             RowBox[{"\[Beta]", "[", 
              RowBox[{
               RowBox[{"u", "[", "]"}], ",", 
               RowBox[{"r", "[", "]"}], ",", 
               RowBox[{"\[Theta]", "[", "]"}]}], "]"}]}], "]"}], 
           RowBox[{
            RowBox[{"V", "[", 
             RowBox[{
              RowBox[{"u", "[", "]"}], ",", 
              RowBox[{"r", "[", "]"}], ",", 
              RowBox[{"\[Theta]", "[", "]"}]}], "]"}], "/", 
            RowBox[{"r", "[", "]"}]}]}], "-", 
          RowBox[{
           RowBox[{
            RowBox[{"r", "[", "]"}], "^", "2"}], 
           RowBox[{"Exp", "[", 
            RowBox[{"2", 
             RowBox[{"\[Gamma]", "[", 
              RowBox[{
               RowBox[{"u", "[", "]"}], ",", 
               RowBox[{"r", "[", "]"}], ",", 
               RowBox[{"\[Theta]", "[", "]"}]}], "]"}]}], "]"}], 
           RowBox[{
            RowBox[{"U", "[", 
             RowBox[{
              RowBox[{"u", "[", "]"}], ",", 
              RowBox[{"r", "[", "]"}], ",", 
              RowBox[{"\[Theta]", "[", "]"}]}], "]"}], "^", "2"}]}]}], ",", 
         RowBox[{"Exp", "[", 
          RowBox[{"2", " ", 
           RowBox[{"\[Beta]", "[", 
            RowBox[{
             RowBox[{"u", "[", "]"}], ",", 
             RowBox[{"r", "[", "]"}], ",", 
             RowBox[{"\[Theta]", "[", "]"}]}], "]"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"r", "[", "]"}], "^", "2"}], 
          RowBox[{"Exp", "[", 
           RowBox[{"2", 
            RowBox[{"\[Gamma]", "[", 
             RowBox[{
              RowBox[{"u", "[", "]"}], ",", 
              RowBox[{"r", "[", "]"}], ",", 
              RowBox[{"\[Theta]", "[", "]"}]}], "]"}]}], "]"}], 
          RowBox[{"U", "[", 
           RowBox[{
            RowBox[{"u", "[", "]"}], ",", 
            RowBox[{"r", "[", "]"}], ",", 
            RowBox[{"\[Theta]", "[", "]"}]}], "]"}]}], ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Exp", "[", 
          RowBox[{"2", " ", 
           RowBox[{"\[Beta]", "[", 
            RowBox[{
             RowBox[{"u", "[", "]"}], ",", 
             RowBox[{"r", "[", "]"}], ",", 
             RowBox[{"\[Theta]", "[", "]"}]}], "]"}]}], "]"}], ",", "0", ",", 
         "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"r", "[", "]"}], "^", "2"}], 
          RowBox[{"Exp", "[", 
           RowBox[{"2", 
            RowBox[{"\[Gamma]", "[", 
             RowBox[{
              RowBox[{"u", "[", "]"}], ",", 
              RowBox[{"r", "[", "]"}], ",", 
              RowBox[{"\[Theta]", "[", "]"}]}], "]"}]}], "]"}], 
          RowBox[{"U", "[", 
           RowBox[{
            RowBox[{"u", "[", "]"}], ",", 
            RowBox[{"r", "[", "]"}], ",", 
            RowBox[{"\[Theta]", "[", "]"}]}], "]"}]}], ",", "0", ",", 
         RowBox[{
          RowBox[{"-", 
           RowBox[{
            RowBox[{"r", "[", "]"}], "^", "2"}]}], 
          RowBox[{"Exp", "[", 
           RowBox[{"2", 
            RowBox[{"\[Gamma]", "[", 
             RowBox[{
              RowBox[{"u", "[", "]"}], ",", 
              RowBox[{"r", "[", "]"}], ",", 
              RowBox[{"\[Theta]", "[", "]"}]}], "]"}]}], "]"}]}], ",", "0"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", 
         RowBox[{
          RowBox[{"-", 
           RowBox[{
            RowBox[{"r", "[", "]"}], "^", "2"}]}], 
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"-", "2"}], 
            RowBox[{"\[Gamma]", "[", 
             RowBox[{
              RowBox[{"u", "[", "]"}], ",", 
              RowBox[{"r", "[", "]"}], ",", 
              RowBox[{"\[Theta]", "[", "]"}]}], "]"}]}], "]"}], 
          RowBox[{
           RowBox[{"Sin", "[", 
            RowBox[{"\[Theta]", "[", "]"}], "]"}], "^", "2"}]}]}], "}"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "bondi"}], ",", 
       RowBox[{"-", "bondi"}]}], "}"}]}], "]"}]}], ";"}]], "Input",ExpressionU\
UID->"52754a5e-5db1-47f7-9e3b-2f891529059b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$CVSimplify", "=", "Expand"}], ";"}]], "Input",ExpressionUUID->\
"c2a8b746-8a1d-4e79-b9ad-4219d848d72c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"SetCMetric", "[", 
   RowBox[{"met", ",", "bondi", ",", 
    RowBox[{"SignatureOfMetric", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"3", ",", "1", ",", "0"}], "}"}]}]}], "]"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"c38d38f9-6aef-483c-a2bd-\
3a3de91012de"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.031449`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"c69ff87c-7445-4c58-af66-89f111c5afec"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MetricCompute", "[", 
   RowBox[{"met", ",", "bondi", ",", 
    RowBox[{"\"\<Einstein\>\"", "[", 
     RowBox[{
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}]}], "]"}]}], "]"}], "//", "AbsoluteTiming"}]], "Input",\
ExpressionUUID->"6097cc44-0c28-4b16-8f9f-d9344bca253f"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.152649`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"b1579a4b-4674-4513-8f41-8ed233713d60"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"cd", "=", 
   RowBox[{"CovDOfMetric", "[", "met", "]"}]}], ";"}]], "Input",ExpressionUUID\
->"1608e77a-6fa5-48bb-b96e-fb4b0bbd8270"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Einstein", "[", "cd", "]"}], "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "bondi"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"-", "bondi"}]}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"48554663-c0e9-4886-aa77-454a79bcc388"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{
     RowBox[{"-", "2"}], " ", 
     RowBox[{
      InterpretationBox[
       StyleBox["\[Beta]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Beta],
       Editable->False], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["u",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`u[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["\[Theta]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Theta][],
        Editable->False]}], "]"}]}]], " ", 
   RowBox[{
    InterpretationBox[
     StyleBox["U",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`U,
     Editable->False], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}]}], "-", 
  FractionBox[
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Beta]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Beta],
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["u",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["\[Theta]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Theta][],
         Editable->False]}], "]"}]}]], " ", 
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["V",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`V,
       Editable->False], 
      TagBox[
       RowBox[{"(", 
        RowBox[{"0", ",", "0", ",", "1"}], ")"}],
       Derivative],
      MultilineFunction->None], "[", 
     RowBox[{
      InterpretationBox[
       StyleBox["u",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`u[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["\[Theta]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Theta][],
       Editable->False]}], "]"}]}], 
   RowBox[{"2", " ", 
    SuperscriptBox[
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], "2"]}]], "+", 
  RowBox[{
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{
     RowBox[{"-", "2"}], " ", 
     RowBox[{
      InterpretationBox[
       StyleBox["\[Beta]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Beta],
       Editable->False], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["u",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`u[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["\[Theta]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Theta][],
        Editable->False]}], "]"}]}]], " ", 
   RowBox[{
    InterpretationBox[
     StyleBox["Cot",
      ShowAutoStyles->False,
      AutoSpacing->False],
     Cot,
     Editable->False], "[", 
    InterpretationBox[
     StyleBox["\[Theta]",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`\[Theta][],
     Editable->False], "]"}], " ", 
   RowBox[{
    InterpretationBox[
     StyleBox["U",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`U,
     Editable->False], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}], " ", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["\[Beta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Beta],
      Editable->False], 
     TagBox[
      RowBox[{"(", 
       RowBox[{"0", ",", "0", ",", "1"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}]}], "-", 
  FractionBox[
   RowBox[{"2", " ", 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Beta]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Beta],
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["u",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["\[Theta]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Theta][],
         Editable->False]}], "]"}]}]], " ", 
    RowBox[{
     InterpretationBox[
      StyleBox["V",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`V,
      Editable->False], "[", 
     RowBox[{
      InterpretationBox[
       StyleBox["u",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`u[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["\[Theta]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Theta][],
       Editable->False]}], "]"}], " ", 
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["\[Beta]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Beta],
       Editable->False], 
      TagBox[
       RowBox[{"(", 
        RowBox[{"0", ",", "0", ",", "1"}], ")"}],
       Derivative],
      MultilineFunction->None], "[", 
     RowBox[{
      InterpretationBox[
       StyleBox["u",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`u[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["\[Theta]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Theta][],
       Editable->False]}], "]"}]}], 
   SuperscriptBox[
    InterpretationBox[
     StyleBox["r",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`r[],
     Editable->False], "2"]], "+", 
  RowBox[{"3", " ", 
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{
     RowBox[{"-", "2"}], " ", 
     RowBox[{
      InterpretationBox[
       StyleBox["\[Beta]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Beta],
       Editable->False], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["u",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`u[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["\[Theta]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Theta][],
        Editable->False]}], "]"}]}]], " ", 
   RowBox[{
    InterpretationBox[
     StyleBox["Cot",
      ShowAutoStyles->False,
      AutoSpacing->False],
     Cot,
     Editable->False], "[", 
    InterpretationBox[
     StyleBox["\[Theta]",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`\[Theta][],
     Editable->False], "]"}], " ", 
   RowBox[{
    InterpretationBox[
     StyleBox["U",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`U,
     Editable->False], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}], " ", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["\[Gamma]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Gamma],
      Editable->False], 
     TagBox[
      RowBox[{"(", 
       RowBox[{"0", ",", "0", ",", "1"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}]}], "-", 
  RowBox[{"2", " ", 
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{
     RowBox[{"-", "2"}], " ", 
     RowBox[{
      InterpretationBox[
       StyleBox["\[Beta]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Beta],
       Editable->False], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["u",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`u[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["\[Theta]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Theta][],
        Editable->False]}], "]"}]}]], " ", 
   RowBox[{
    InterpretationBox[
     StyleBox["U",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`U,
     Editable->False], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}], " ", 
   SuperscriptBox[
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["\[Gamma]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Gamma],
       Editable->False], 
      TagBox[
       RowBox[{"(", 
        RowBox[{"0", ",", "0", ",", "1"}], ")"}],
       Derivative],
      MultilineFunction->None], "[", 
     RowBox[{
      InterpretationBox[
       StyleBox["u",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`u[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["\[Theta]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Theta][],
       Editable->False]}], "]"}], "2"]}], "-", 
  RowBox[{
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{
     RowBox[{"-", "2"}], " ", 
     RowBox[{
      InterpretationBox[
       StyleBox["\[Beta]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Beta],
       Editable->False], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["u",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`u[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["\[Theta]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Theta][],
        Editable->False]}], "]"}]}]], " ", 
   RowBox[{
    InterpretationBox[
     StyleBox["U",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`U,
     Editable->False], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}], " ", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["\[Beta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Beta],
      Editable->False], 
     TagBox[
      RowBox[{"(", 
       RowBox[{"0", ",", "0", ",", "2"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{
     RowBox[{"-", "2"}], " ", 
     RowBox[{
      InterpretationBox[
       StyleBox["\[Beta]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Beta],
       Editable->False], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["u",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`u[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["\[Theta]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Theta][],
        Editable->False]}], "]"}]}]], " ", 
   RowBox[{
    InterpretationBox[
     StyleBox["U",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`U,
     Editable->False], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}], " ", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["\[Gamma]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Gamma],
      Editable->False], 
     TagBox[
      RowBox[{"(", 
       RowBox[{"0", ",", "0", ",", "2"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "4"}], " ", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Beta]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Beta],
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["u",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["\[Theta]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Theta][],
         Editable->False]}], "]"}]}], "+", 
     RowBox[{"2", " ", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Gamma]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Gamma],
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["u",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["\[Theta]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Theta][],
         Editable->False]}], "]"}]}]}]], " ", 
   RowBox[{
    InterpretationBox[
     StyleBox["Cot",
      ShowAutoStyles->False,
      AutoSpacing->False],
     Cot,
     Editable->False], "[", 
    InterpretationBox[
     StyleBox["\[Theta]",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`\[Theta][],
     Editable->False], "]"}], " ", 
   SuperscriptBox[
    InterpretationBox[
     StyleBox["r",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`r[],
     Editable->False], "2"], " ", 
   RowBox[{
    InterpretationBox[
     StyleBox["U",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`U,
     Editable->False], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}], " ", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["U",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`U,
      Editable->False], 
     TagBox[
      RowBox[{"(", 
       RowBox[{"0", ",", "1", ",", "0"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "4"}], " ", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Beta]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Beta],
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["u",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["\[Theta]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Theta][],
         Editable->False]}], "]"}]}], "+", 
     RowBox[{"2", " ", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Gamma]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Gamma],
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["u",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["\[Theta]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Theta][],
         Editable->False]}], "]"}]}]}]], " ", 
   SuperscriptBox[
    InterpretationBox[
     StyleBox["r",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`r[],
     Editable->False], "2"], " ", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["U",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`U,
      Editable->False], 
     TagBox[
      RowBox[{"(", 
       RowBox[{"0", ",", "0", ",", "1"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}], " ", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["U",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`U,
      Editable->False], 
     TagBox[
      RowBox[{"(", 
       RowBox[{"0", ",", "1", ",", "0"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "4"}], " ", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Beta]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Beta],
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["u",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["\[Theta]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Theta][],
         Editable->False]}], "]"}]}], "+", 
     RowBox[{"2", " ", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Gamma]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Gamma],
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["u",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["\[Theta]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Theta][],
         Editable->False]}], "]"}]}]}]], " ", 
   SuperscriptBox[
    InterpretationBox[
     StyleBox["r",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`r[],
     Editable->False], "2"], " ", 
   RowBox[{
    InterpretationBox[
     StyleBox["U",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`U,
     Editable->False], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}], " ", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["\[Beta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Beta],
      Editable->False], 
     TagBox[
      RowBox[{"(", 
       RowBox[{"0", ",", "0", ",", "1"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}], " ", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["U",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`U,
      Editable->False], 
     TagBox[
      RowBox[{"(", 
       RowBox[{"0", ",", "1", ",", "0"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "4"}], " ", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Beta]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Beta],
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["u",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["\[Theta]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Theta][],
         Editable->False]}], "]"}]}], "+", 
     RowBox[{"2", " ", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Gamma]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Gamma],
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["u",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["\[Theta]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Theta][],
         Editable->False]}], "]"}]}]}]], " ", 
   SuperscriptBox[
    InterpretationBox[
     StyleBox["r",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`r[],
     Editable->False], "2"], " ", 
   RowBox[{
    InterpretationBox[
     StyleBox["U",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`U,
     Editable->False], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}], " ", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["\[Gamma]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Gamma],
      Editable->False], 
     TagBox[
      RowBox[{"(", 
       RowBox[{"0", ",", "0", ",", "1"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}], " ", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["U",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`U,
      Editable->False], 
     TagBox[
      RowBox[{"(", 
       RowBox[{"0", ",", "1", ",", "0"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}]}], "+", 
  FractionBox[
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Beta]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Beta],
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["u",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["\[Theta]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Theta][],
         Editable->False]}], "]"}]}]], " ", 
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["V",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`V,
       Editable->False], 
      TagBox[
       RowBox[{"(", 
        RowBox[{"0", ",", "0", ",", "1"}], ")"}],
       Derivative],
      MultilineFunction->None], "[", 
     RowBox[{
      InterpretationBox[
       StyleBox["u",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`u[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["\[Theta]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Theta][],
       Editable->False]}], "]"}], " ", 
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["\[Beta]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Beta],
       Editable->False], 
      TagBox[
       RowBox[{"(", 
        RowBox[{"0", ",", "1", ",", "0"}], ")"}],
       Derivative],
      MultilineFunction->None], "[", 
     RowBox[{
      InterpretationBox[
       StyleBox["u",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`u[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["\[Theta]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Theta][],
       Editable->False]}], "]"}]}], 
   InterpretationBox[
    StyleBox["r",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`r[],
    Editable->False]], "-", 
  FractionBox[
   RowBox[{"2", " ", 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Beta]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Beta],
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["u",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["\[Theta]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Theta][],
         Editable->False]}], "]"}]}]], " ", 
    RowBox[{
     InterpretationBox[
      StyleBox["Cot",
       ShowAutoStyles->False,
       AutoSpacing->False],
      Cot,
      Editable->False], "[", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False], "]"}], " ", 
    RowBox[{
     InterpretationBox[
      StyleBox["V",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`V,
      Editable->False], "[", 
     RowBox[{
      InterpretationBox[
       StyleBox["u",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`u[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["\[Theta]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Theta][],
       Editable->False]}], "]"}], " ", 
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["\[Gamma]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Gamma],
       Editable->False], 
      TagBox[
       RowBox[{"(", 
        RowBox[{"0", ",", "1", ",", "0"}], ")"}],
       Derivative],
      MultilineFunction->None], "[", 
     RowBox[{
      InterpretationBox[
       StyleBox["u",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`u[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["\[Theta]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Theta][],
       Editable->False]}], "]"}]}], 
   InterpretationBox[
    StyleBox["r",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`r[],
    Editable->False]], "-", 
  FractionBox[
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Beta]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Beta],
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["u",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["\[Theta]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Theta][],
         Editable->False]}], "]"}]}]], " ", 
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["V",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`V,
       Editable->False], 
      TagBox[
       RowBox[{"(", 
        RowBox[{"0", ",", "0", ",", "1"}], ")"}],
       Derivative],
      MultilineFunction->None], "[", 
     RowBox[{
      InterpretationBox[
       StyleBox["u",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`u[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["\[Theta]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Theta][],
       Editable->False]}], "]"}], " ", 
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["\[Gamma]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Gamma],
       Editable->False], 
      TagBox[
       RowBox[{"(", 
        RowBox[{"0", ",", "1", ",", "0"}], ")"}],
       Derivative],
      MultilineFunction->None], "[", 
     RowBox[{
      InterpretationBox[
       StyleBox["u",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`u[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["\[Theta]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Theta][],
       Editable->False]}], "]"}]}], 
   InterpretationBox[
    StyleBox["r",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`r[],
    Editable->False]], "+", 
  FractionBox[
   RowBox[{"2", " ", 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Beta]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Beta],
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["u",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["\[Theta]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Theta][],
         Editable->False]}], "]"}]}]], " ", 
    RowBox[{
     InterpretationBox[
      StyleBox["V",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`V,
      Editable->False], "[", 
     RowBox[{
      InterpretationBox[
       StyleBox["u",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`u[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["\[Theta]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Theta][],
       Editable->False]}], "]"}], " ", 
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["\[Gamma]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Gamma],
       Editable->False], 
      TagBox[
       RowBox[{"(", 
        RowBox[{"0", ",", "0", ",", "1"}], ")"}],
       Derivative],
      MultilineFunction->None], "[", 
     RowBox[{
      InterpretationBox[
       StyleBox["u",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`u[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["\[Theta]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Theta][],
       Editable->False]}], "]"}], " ", 
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["\[Gamma]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Gamma],
       Editable->False], 
      TagBox[
       RowBox[{"(", 
        RowBox[{"0", ",", "1", ",", "0"}], ")"}],
       Derivative],
      MultilineFunction->None], "[", 
     RowBox[{
      InterpretationBox[
       StyleBox["u",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`u[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["\[Theta]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Theta][],
       Editable->False]}], "]"}]}], 
   InterpretationBox[
    StyleBox["r",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`r[],
    Editable->False]], "-", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "4"}], " ", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Beta]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Beta],
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["u",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["\[Theta]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Theta][],
         Editable->False]}], "]"}]}], "+", 
     RowBox[{"2", " ", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Gamma]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Gamma],
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["u",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["\[Theta]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Theta][],
         Editable->False]}], "]"}]}]}]], " ", 
   SuperscriptBox[
    InterpretationBox[
     StyleBox["r",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`r[],
     Editable->False], "2"], " ", 
   RowBox[{
    InterpretationBox[
     StyleBox["U",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`U,
     Editable->False], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}], " ", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["U",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`U,
      Editable->False], 
     TagBox[
      RowBox[{"(", 
       RowBox[{"0", ",", "1", ",", "1"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}]}], "+", 
  FractionBox[
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Beta]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Beta],
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["u",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["\[Theta]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Theta][],
         Editable->False]}], "]"}]}]], " ", 
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["V",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`V,
       Editable->False], 
      TagBox[
       RowBox[{"(", 
        RowBox[{"0", ",", "1", ",", "1"}], ")"}],
       Derivative],
      MultilineFunction->None], "[", 
     RowBox[{
      InterpretationBox[
       StyleBox["u",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`u[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["\[Theta]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Theta][],
       Editable->False]}], "]"}]}], 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox["r",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`r[],
     Editable->False]}]], "+", 
  FractionBox[
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Beta]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Beta],
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["u",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["\[Theta]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Theta][],
         Editable->False]}], "]"}]}]], " ", 
    RowBox[{
     InterpretationBox[
      StyleBox["V",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`V,
      Editable->False], "[", 
     RowBox[{
      InterpretationBox[
       StyleBox["u",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`u[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["\[Theta]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Theta][],
       Editable->False]}], "]"}], " ", 
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["\[Beta]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Beta],
       Editable->False], 
      TagBox[
       RowBox[{"(", 
        RowBox[{"0", ",", "1", ",", "1"}], ")"}],
       Derivative],
      MultilineFunction->None], "[", 
     RowBox[{
      InterpretationBox[
       StyleBox["u",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`u[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["\[Theta]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Theta][],
       Editable->False]}], "]"}]}], 
   InterpretationBox[
    StyleBox["r",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`r[],
    Editable->False]], "-", 
  FractionBox[
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Beta]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Beta],
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["u",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["\[Theta]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Theta][],
         Editable->False]}], "]"}]}]], " ", 
    RowBox[{
     InterpretationBox[
      StyleBox["V",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`V,
      Editable->False], "[", 
     RowBox[{
      InterpretationBox[
       StyleBox["u",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`u[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["\[Theta]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Theta][],
       Editable->False]}], "]"}], " ", 
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["\[Gamma]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Gamma],
       Editable->False], 
      TagBox[
       RowBox[{"(", 
        RowBox[{"0", ",", "1", ",", "1"}], ")"}],
       Derivative],
      MultilineFunction->None], "[", 
     RowBox[{
      InterpretationBox[
       StyleBox["u",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`u[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["\[Theta]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Theta][],
       Editable->False]}], "]"}]}], 
   InterpretationBox[
    StyleBox["r",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`r[],
    Editable->False]], "+", 
  RowBox[{
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "4"}], " ", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Beta]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Beta],
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["u",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["\[Theta]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Theta][],
         Editable->False]}], "]"}]}], "+", 
     RowBox[{"2", " ", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Gamma]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Gamma],
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["u",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["\[Theta]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Theta][],
         Editable->False]}], "]"}]}]}]], " ", 
   SuperscriptBox[
    InterpretationBox[
     StyleBox["r",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`r[],
     Editable->False], "2"], " ", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["U",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`U,
      Editable->False], 
     TagBox[
      RowBox[{"(", 
       RowBox[{"0", ",", "1", ",", "0"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}], " ", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["\[Beta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Beta],
      Editable->False], 
     TagBox[
      RowBox[{"(", 
       RowBox[{"1", ",", "0", ",", "0"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}]}], "+", 
  RowBox[{"2", " ", 
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{
     RowBox[{"-", "2"}], " ", 
     RowBox[{
      InterpretationBox[
       StyleBox["\[Beta]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Beta],
       Editable->False], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["u",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`u[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["\[Theta]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Theta][],
        Editable->False]}], "]"}]}]], " ", 
   RowBox[{
    InterpretationBox[
     StyleBox["Cot",
      ShowAutoStyles->False,
      AutoSpacing->False],
     Cot,
     Editable->False], "[", 
    InterpretationBox[
     StyleBox["\[Theta]",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`\[Theta][],
     Editable->False], "]"}], " ", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["\[Gamma]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Gamma],
      Editable->False], 
     TagBox[
      RowBox[{"(", 
       RowBox[{"1", ",", "0", ",", "0"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}]}], "-", 
  RowBox[{"2", " ", 
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{
     RowBox[{"-", "2"}], " ", 
     RowBox[{
      InterpretationBox[
       StyleBox["\[Beta]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Beta],
       Editable->False], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["u",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`u[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["\[Theta]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Theta][],
        Editable->False]}], "]"}]}]], " ", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["\[Gamma]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Gamma],
      Editable->False], 
     TagBox[
      RowBox[{"(", 
       RowBox[{"0", ",", "0", ",", "1"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}], " ", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["\[Gamma]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Gamma],
      Editable->False], 
     TagBox[
      RowBox[{"(", 
       RowBox[{"1", ",", "0", ",", "0"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "4"}], " ", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Beta]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Beta],
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["u",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["\[Theta]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Theta][],
         Editable->False]}], "]"}]}], "+", 
     RowBox[{"2", " ", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Gamma]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Gamma],
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["u",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["\[Theta]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Theta][],
         Editable->False]}], "]"}]}]}]], " ", 
   SuperscriptBox[
    InterpretationBox[
     StyleBox["r",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`r[],
     Editable->False], "2"], " ", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["U",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`U,
      Editable->False], 
     TagBox[
      RowBox[{"(", 
       RowBox[{"0", ",", "1", ",", "0"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}], " ", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["\[Gamma]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Gamma],
      Editable->False], 
     TagBox[
      RowBox[{"(", 
       RowBox[{"1", ",", "0", ",", "0"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{
     RowBox[{"-", "2"}], " ", 
     RowBox[{
      InterpretationBox[
       StyleBox["\[Beta]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Beta],
       Editable->False], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["u",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`u[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["\[Theta]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Theta][],
        Editable->False]}], "]"}]}]], " ", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["\[Beta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Beta],
      Editable->False], 
     TagBox[
      RowBox[{"(", 
       RowBox[{"1", ",", "0", ",", "1"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{
     RowBox[{"-", "2"}], " ", 
     RowBox[{
      InterpretationBox[
       StyleBox["\[Beta]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Beta],
       Editable->False], "[", 
      RowBox[{
       InterpretationBox[
        StyleBox["u",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`u[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], ",", 
       InterpretationBox[
        StyleBox["\[Theta]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Theta][],
        Editable->False]}], "]"}]}]], " ", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["\[Gamma]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Gamma],
      Editable->False], 
     TagBox[
      RowBox[{"(", 
       RowBox[{"1", ",", "0", ",", "1"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "4"}], " ", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Beta]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Beta],
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["u",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["\[Theta]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Theta][],
         Editable->False]}], "]"}]}], "+", 
     RowBox[{"2", " ", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Gamma]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Gamma],
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["u",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["\[Theta]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Theta][],
         Editable->False]}], "]"}]}]}]], " ", 
   SuperscriptBox[
    InterpretationBox[
     StyleBox["r",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`r[],
     Editable->False], "2"], " ", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["U",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`U,
      Editable->False], 
     TagBox[
      RowBox[{"(", 
       RowBox[{"1", ",", "1", ",", "0"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}]}]}]], "Output",ExpressionUUID->"7e384298-2bb5-\
43a1-8e95-8c58ca5f51c7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Einstein", "[", "cd", "]"}], "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"-", "bondi"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"-", "bondi"}]}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"1632aa3a-3f35-422f-9360-a804b9ea988f"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"2", " ", 
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["\[Beta]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Beta],
       Editable->False], 
      TagBox[
       RowBox[{"(", 
        RowBox[{"0", ",", "0", ",", "1"}], ")"}],
       Derivative],
      MultilineFunction->None], "[", 
     RowBox[{
      InterpretationBox[
       StyleBox["u",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`u[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], ",", 
      InterpretationBox[
       StyleBox["\[Theta]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Theta][],
       Editable->False]}], "]"}]}], 
   InterpretationBox[
    StyleBox["r",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`r[],
    Editable->False]], "+", 
  RowBox[{"2", " ", 
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Beta]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Beta],
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["u",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["\[Theta]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Theta][],
         Editable->False]}], "]"}]}], "+", 
     RowBox[{"2", " ", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Gamma]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Gamma],
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["u",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["\[Theta]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Theta][],
         Editable->False]}], "]"}]}]}]], " ", 
   InterpretationBox[
    StyleBox["r",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`r[],
    Editable->False], " ", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["U",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`U,
      Editable->False], 
     TagBox[
      RowBox[{"(", 
       RowBox[{"0", ",", "1", ",", "0"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Beta]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Beta],
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["u",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["\[Theta]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Theta][],
         Editable->False]}], "]"}]}], "+", 
     RowBox[{"2", " ", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Gamma]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Gamma],
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["u",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["\[Theta]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Theta][],
         Editable->False]}], "]"}]}]}]], " ", 
   SuperscriptBox[
    InterpretationBox[
     StyleBox["r",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`r[],
     Editable->False], "2"], " ", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["U",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`U,
      Editable->False], 
     TagBox[
      RowBox[{"(", 
       RowBox[{"0", ",", "1", ",", "0"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}], " ", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["\[Beta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Beta],
      Editable->False], 
     TagBox[
      RowBox[{"(", 
       RowBox[{"0", ",", "1", ",", "0"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}]}], "+", 
  RowBox[{"2", " ", 
   RowBox[{
    InterpretationBox[
     StyleBox["Cot",
      ShowAutoStyles->False,
      AutoSpacing->False],
     Cot,
     Editable->False], "[", 
    InterpretationBox[
     StyleBox["\[Theta]",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`\[Theta][],
     Editable->False], "]"}], " ", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["\[Gamma]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Gamma],
      Editable->False], 
     TagBox[
      RowBox[{"(", 
       RowBox[{"0", ",", "1", ",", "0"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["\[Gamma]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Gamma],
      Editable->False], 
     TagBox[
      RowBox[{"(", 
       RowBox[{"0", ",", "0", ",", "1"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}], " ", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["\[Gamma]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Gamma],
      Editable->False], 
     TagBox[
      RowBox[{"(", 
       RowBox[{"0", ",", "1", ",", "0"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Beta]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Beta],
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["u",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["\[Theta]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Theta][],
         Editable->False]}], "]"}]}], "+", 
     RowBox[{"2", " ", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Gamma]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Gamma],
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["u",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["\[Theta]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Theta][],
         Editable->False]}], "]"}]}]}]], " ", 
   SuperscriptBox[
    InterpretationBox[
     StyleBox["r",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`r[],
     Editable->False], "2"], " ", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["U",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`U,
      Editable->False], 
     TagBox[
      RowBox[{"(", 
       RowBox[{"0", ",", "1", ",", "0"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}], " ", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["\[Gamma]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Gamma],
      Editable->False], 
     TagBox[
      RowBox[{"(", 
       RowBox[{"0", ",", "1", ",", "0"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    InterpretationBox[
     StyleBox["\[Beta]",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`\[Beta],
     Editable->False], 
    TagBox[
     RowBox[{"(", 
      RowBox[{"0", ",", "1", ",", "1"}], ")"}],
     Derivative],
    MultilineFunction->None], "[", 
   RowBox[{
    InterpretationBox[
     StyleBox["u",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`u[],
     Editable->False], ",", 
    InterpretationBox[
     StyleBox["r",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`r[],
     Editable->False], ",", 
    InterpretationBox[
     StyleBox["\[Theta]",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`\[Theta][],
     Editable->False]}], "]"}], "+", 
  RowBox[{
   SuperscriptBox[
    InterpretationBox[
     StyleBox["\[Gamma]",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`\[Gamma],
     Editable->False], 
    TagBox[
     RowBox[{"(", 
      RowBox[{"0", ",", "1", ",", "1"}], ")"}],
     Derivative],
    MultilineFunction->None], "[", 
   RowBox[{
    InterpretationBox[
     StyleBox["u",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`u[],
     Editable->False], ",", 
    InterpretationBox[
     StyleBox["r",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`r[],
     Editable->False], ",", 
    InterpretationBox[
     StyleBox["\[Theta]",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`\[Theta][],
     Editable->False]}], "]"}], "+", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Beta]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Beta],
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["u",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["\[Theta]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Theta][],
         Editable->False]}], "]"}]}], "+", 
     RowBox[{"2", " ", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Gamma]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Gamma],
        Editable->False], "[", 
       RowBox[{
        InterpretationBox[
         StyleBox["u",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`u[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], ",", 
        InterpretationBox[
         StyleBox["\[Theta]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Theta][],
         Editable->False]}], "]"}]}]}]], " ", 
   SuperscriptBox[
    InterpretationBox[
     StyleBox["r",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`r[],
     Editable->False], "2"], " ", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["U",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`U,
      Editable->False], 
     TagBox[
      RowBox[{"(", 
       RowBox[{"0", ",", "2", ",", "0"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{
     InterpretationBox[
      StyleBox["u",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`u[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], ",", 
     InterpretationBox[
      StyleBox["\[Theta]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Theta][],
      Editable->False]}], "]"}]}]}]], "Output",ExpressionUUID->"e966791a-b4a1-\
4aa1-a485-2754550cf077"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TensorDerivative", "[", 
  RowBox[{"met", ",", "cd"}], "]"}]], "Input",ExpressionUUID->"70643e2b-c907-\
4059-846a-c20bdd1549e9"],

Cell[BoxData["Zero"], "Output",ExpressionUUID->"1779f3cd-c856-465f-99da-220b7be1e99a"]
}, Open  ]],

Cell["Check the Bianchi identities:", "Text",ExpressionUUID->"c6e1ef3d-c82a-4ace-a522-44d6240be544"],

Cell[BoxData[
 RowBox[{
  RowBox[{"riemann", "=", 
   RowBox[{"RiemannDown", "[", "cd", "]"}]}], ";"}]], "Input",ExpressionUUID->\
"b1166140-cc7a-4d62-afd7-2c3c1a4b749d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"cdriemann", "=", 
    RowBox[{"TensorDerivative", "[", 
     RowBox[{"riemann", ",", "cd"}], "]"}]}], ";"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"dcf18ff6-52a9-43d6-961a-\
2586130cfc42"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"3.942782`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"e4f2e264-21d2-485f-9d3d-2494ec950f25"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"cdriemann", "[", 
     RowBox[{
      RowBox[{"-", "a"}], ",", 
      RowBox[{"-", "b"}], ",", 
      RowBox[{"-", "c"}], ",", 
      RowBox[{"-", "d"}], ",", 
      RowBox[{"-", "e"}]}], "]"}], "+", 
    RowBox[{"cdriemann", "[", 
     RowBox[{
      RowBox[{"-", "b"}], ",", 
      RowBox[{"-", "c"}], ",", 
      RowBox[{"-", "a"}], ",", 
      RowBox[{"-", "d"}], ",", 
      RowBox[{"-", "e"}]}], "]"}], "+", 
    RowBox[{"cdriemann", "[", 
     RowBox[{
      RowBox[{"-", "c"}], ",", 
      RowBox[{"-", "a"}], ",", 
      RowBox[{"-", "b"}], ",", 
      RowBox[{"-", "d"}], ",", 
      RowBox[{"-", "e"}]}], "]"}]}], "//", "Expand"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"af5c06dc-0a69-4243-9b43-\
84f35f9e2eb3"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.289353`", ",", "0"}], "}"}]], "Output",ExpressionUUID->"c664491a-\
9869-4ba6-8afc-d501a5e5871b"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"met", ",", "cd", ",", "riemann", ",", "cdriemann"}], 
  "]"}]], "Input",ExpressionUUID->"0c8c73aa-1cdb-4d8f-abfa-d01c70bc21c6"],

Cell[BoxData[
 RowBox[{"UndefScalarFunction", "[", "$ScalarFunctions", "]"}]], "Input",Expre\
ssionUUID->"0152c6ff-820f-4e1f-a8b3-b224906d9938"],

Cell[BoxData[
 RowBox[{"UndefChart", "[", "bondi", "]"}]], "Input",ExpressionUUID->"43cade0a-d9bd-40ec-bab1-e373f737d135"],

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M", "]"}]], "Input",ExpressionUUID->"1b6c2fe5-651e-4156-b41f-40e78d8b80ef"],

Cell[BoxData[
 RowBox[{"ClearxCobaCache", "[", "All", "]"}]], "Input",ExpressionUUID->"ee1235a9-ab96-43e0-ab88-e161240c4a05"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.10. Kerr again in Boyer-Lindquist \[Theta]-coordinates", \
"Subsubsection",ExpressionUUID->"5cac6c92-541b-4445-a6c8-8b0917f22b41"],

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M", ",", "4", ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"1c65f7ad-1f22-4cf1-b70b-bc52a03c4ad9"],

Cell[BoxData[
 RowBox[{"DefChart", "[", 
  RowBox[{"BL", ",", "M", ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"u", "[", "]"}], ",", 
     RowBox[{"r", "[", "]"}], ",", 
     RowBox[{"\[Theta]", "[", "]"}], ",", 
     RowBox[{"\[Phi]", "[", "]"}]}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"39de21ac-60c4-47a0-97eb-b77151a13eae"],

Cell[BoxData[
 RowBox[{"DefConstantSymbol", "[", 
  RowBox[{"{", 
   RowBox[{"\[Alpha]", ",", "\[CapitalMu]"}], "}"}], "]"}]], "Input",Expressio\
nUUID->"9a4b3123-228b-4f8f-838f-3d44a277fa7c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"met", "=", 
  RowBox[{"CTensor", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"1", "-", 
         FractionBox[
          RowBox[{"2", " ", "\[CapitalMu]", " ", 
           RowBox[{"r", "[", "]"}]}], 
          RowBox[{
           SuperscriptBox[
            RowBox[{"r", "[", "]"}], "2"], "+", 
           RowBox[{
            SuperscriptBox["\[Alpha]", "2"], " ", 
            SuperscriptBox[
             RowBox[{"Cos", "[", 
              RowBox[{"\[Theta]", "[", "]"}], "]"}], "2"]}]}]]}], ",", "1", 
        ",", "0", ",", 
        FractionBox[
         RowBox[{"2", "\[Alpha]", "  ", "\[CapitalMu]", " ", 
          RowBox[{"r", "[", "]"}], " ", 
          RowBox[{
           RowBox[{"Sin", "[", 
            RowBox[{"\[Theta]", "[", "]"}], "]"}], "^", "2"}]}], 
         RowBox[{
          SuperscriptBox[
           RowBox[{"r", "[", "]"}], "2"], "+", 
          RowBox[{
           SuperscriptBox["\[Alpha]", "2"], " ", 
           SuperscriptBox[
            RowBox[{"Cos", "[", 
             RowBox[{"\[Theta]", "[", "]"}], "]"}], "2"]}]}]]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "0", ",", 
        RowBox[{
         RowBox[{"-", "\[Alpha]"}], "  ", 
         RowBox[{
          RowBox[{"Sin", "[", 
           RowBox[{"\[Theta]", "[", "]"}], "]"}], "^", "2"}]}]}], "}"}], ",", 
      
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", 
        RowBox[{"-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"r", "[", "]"}], "^", "2"}], "+", 
           RowBox[{
            RowBox[{"\[Alpha]", "^", "2"}], 
            RowBox[{
             RowBox[{"Cos", "[", 
              RowBox[{"\[Theta]", "[", "]"}], "]"}], "^", "2"}]}]}], ")"}]}], 
        ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        FractionBox[
         RowBox[{"2", "\[Alpha]", " ", "\[CapitalMu]", " ", 
          RowBox[{"r", "[", "]"}], " ", 
          RowBox[{
           RowBox[{"Sin", "[", 
            RowBox[{"\[Theta]", "[", "]"}], "]"}], "^", "2"}]}], 
         RowBox[{
          SuperscriptBox[
           RowBox[{"r", "[", "]"}], "2"], "+", 
          RowBox[{
           SuperscriptBox["\[Alpha]", "2"], " ", 
           SuperscriptBox[
            RowBox[{"Cos", "[", 
             RowBox[{"\[Theta]", "[", "]"}], "]"}], "2"]}]}]], ",", 
        RowBox[{
         RowBox[{"-", "\[Alpha]"}], "  ", 
         RowBox[{
          RowBox[{"Sin", "[", 
           RowBox[{"\[Theta]", "[", "]"}], "]"}], "^", "2"}]}], ",", "0", ",", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{
           RowBox[{"Sin", "[", 
            RowBox[{"\[Theta]", "[", "]"}], "]"}], "^", "2"}]}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", 
             SuperscriptBox["\[Alpha]", "2"], " ", "\[CapitalMu]", " ", 
             RowBox[{"r", "[", "]"}]}], "+", 
            RowBox[{
             SuperscriptBox["\[Alpha]", "2"], " ", 
             SuperscriptBox[
              RowBox[{"r", "[", "]"}], "2"]}], "+", 
            SuperscriptBox[
             RowBox[{"r", "[", "]"}], "4"], "+", 
            RowBox[{
             SuperscriptBox["\[Alpha]", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["\[Alpha]", "2"], "-", 
               RowBox[{"2", " ", "\[CapitalMu]", " ", 
                RowBox[{"r", "[", "]"}]}], "+", 
               SuperscriptBox[
                RowBox[{"r", "[", "]"}], "2"]}], ")"}], " ", 
             SuperscriptBox[
              RowBox[{"Cos", "[", 
               RowBox[{"\[Theta]", "[", "]"}], "]"}], "2"]}]}], ")"}], "/", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox[
             RowBox[{"r", "[", "]"}], "2"], "+", 
            RowBox[{
             SuperscriptBox["\[Alpha]", "2"], " ", 
             SuperscriptBox[
              RowBox[{"Cos", "[", 
               RowBox[{"\[Theta]", "[", "]"}], "]"}], "2"]}]}], ")"}]}]}]}], 
       "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "BL"}], ",", 
      RowBox[{"-", "BL"}]}], "}"}]}], "]"}]}]], "Input",ExpressionUUID->\
"7587024d-5cc0-43a6-9777-d6cbb53d740a"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "-", 
        FractionBox[
         RowBox[{"2", " ", 
          InterpretationBox[
           StyleBox["\[CapitalMu]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[CapitalMu],
           Editable->False], " ", 
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False]}], 
         RowBox[{
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["\[Alpha]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Alpha],
             Editable->False], "2"], " ", 
           SuperscriptBox[
            RowBox[{
             InterpretationBox[
              StyleBox["Cos",
               ShowAutoStyles->False,
               AutoSpacing->False],
              Cos,
              Editable->False], "[", 
             InterpretationBox[
              StyleBox["\[Theta]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Theta][],
              Editable->False], "]"}], "2"]}], "+", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], "2"]}]]}], ",", "1", ",", "0", ",", 
       FractionBox[
        RowBox[{"2", " ", 
         InterpretationBox[
          StyleBox["\[Alpha]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[Alpha],
          Editable->False], " ", 
         InterpretationBox[
          StyleBox["\[CapitalMu]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[CapitalMu],
          Editable->False], " ", 
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False], " ", 
         SuperscriptBox[
          RowBox[{
           InterpretationBox[
            StyleBox["Sin",
             ShowAutoStyles->False,
             AutoSpacing->False],
            Sin,
            Editable->False], "[", 
           InterpretationBox[
            StyleBox["\[Theta]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`\[Theta][],
            Editable->False], "]"}], "2"]}], 
        RowBox[{
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["\[Alpha]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`\[Alpha],
            Editable->False], "2"], " ", 
          SuperscriptBox[
           RowBox[{
            InterpretationBox[
             StyleBox["Cos",
              ShowAutoStyles->False,
              AutoSpacing->False],
             Cos,
             Editable->False], "[", 
            InterpretationBox[
             StyleBox["\[Theta]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Theta][],
             Editable->False], "]"}], "2"]}], "+", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], "2"]}]]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0", ",", 
       RowBox[{
        RowBox[{"-", 
         InterpretationBox[
          StyleBox["\[Alpha]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[Alpha],
          Editable->False]}], " ", 
        SuperscriptBox[
         RowBox[{
          InterpretationBox[
           StyleBox["Sin",
            ShowAutoStyles->False,
            AutoSpacing->False],
           Sin,
           Editable->False], "[", 
          InterpretationBox[
           StyleBox["\[Theta]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Theta][],
           Editable->False], "]"}], "2"]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["\[Alpha]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`\[Alpha],
            Editable->False], "2"]}], " ", 
         SuperscriptBox[
          RowBox[{
           InterpretationBox[
            StyleBox["Cos",
             ShowAutoStyles->False,
             AutoSpacing->False],
            Cos,
            Editable->False], "[", 
           InterpretationBox[
            StyleBox["\[Theta]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`\[Theta][],
            Editable->False], "]"}], "2"]}], "-", 
        SuperscriptBox[
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False], "2"]}], ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       FractionBox[
        RowBox[{"2", " ", 
         InterpretationBox[
          StyleBox["\[Alpha]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[Alpha],
          Editable->False], " ", 
         InterpretationBox[
          StyleBox["\[CapitalMu]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[CapitalMu],
          Editable->False], " ", 
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False], " ", 
         SuperscriptBox[
          RowBox[{
           InterpretationBox[
            StyleBox["Sin",
             ShowAutoStyles->False,
             AutoSpacing->False],
            Sin,
            Editable->False], "[", 
           InterpretationBox[
            StyleBox["\[Theta]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`\[Theta][],
            Editable->False], "]"}], "2"]}], 
        RowBox[{
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["\[Alpha]",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`\[Alpha],
            Editable->False], "2"], " ", 
          SuperscriptBox[
           RowBox[{
            InterpretationBox[
             StyleBox["Cos",
              ShowAutoStyles->False,
              AutoSpacing->False],
             Cos,
             Editable->False], "[", 
            InterpretationBox[
             StyleBox["\[Theta]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Theta][],
             Editable->False], "]"}], "2"]}], "+", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], "2"]}]], ",", 
       RowBox[{
        RowBox[{"-", 
         InterpretationBox[
          StyleBox["\[Alpha]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[Alpha],
          Editable->False]}], " ", 
        SuperscriptBox[
         RowBox[{
          InterpretationBox[
           StyleBox["Sin",
            ShowAutoStyles->False,
            AutoSpacing->False],
           Sin,
           Editable->False], "[", 
          InterpretationBox[
           StyleBox["\[Theta]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Theta][],
           Editable->False], "]"}], "2"]}], ",", "0", ",", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["\[Alpha]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Alpha],
               Editable->False], "2"], " ", 
             InterpretationBox[
              StyleBox["\[CapitalMu]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[CapitalMu],
              Editable->False], " ", 
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False]}], "+", 
            RowBox[{
             SuperscriptBox[
              InterpretationBox[
               StyleBox["\[Alpha]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Alpha],
               Editable->False], "2"], " ", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], "2"]}], "+", 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False], "4"], "+", 
            RowBox[{
             SuperscriptBox[
              InterpretationBox[
               StyleBox["\[Alpha]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Alpha],
               Editable->False], "2"], " ", 
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["Cos",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                Cos,
                Editable->False], "[", 
               InterpretationBox[
                StyleBox["\[Theta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Theta][],
                Editable->False], "]"}], "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["\[Alpha]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[Alpha],
                 Editable->False], "2"], "-", 
               RowBox[{"2", " ", 
                InterpretationBox[
                 StyleBox["\[CapitalMu]",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`\[CapitalMu],
                 Editable->False], " ", 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]}], "+", 
               SuperscriptBox[
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False], "2"]}], ")"}]}]}], ")"}], " ", 
          SuperscriptBox[
           RowBox[{
            InterpretationBox[
             StyleBox["Sin",
              ShowAutoStyles->False,
              AutoSpacing->False],
             Sin,
             Editable->False], "[", 
            InterpretationBox[
             StyleBox["\[Theta]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Theta][],
             Editable->False], "]"}], "2"]}], 
         RowBox[{
          RowBox[{
           SuperscriptBox[
            InterpretationBox[
             StyleBox["\[Alpha]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Alpha],
             Editable->False], "2"], " ", 
           SuperscriptBox[
            RowBox[{
             InterpretationBox[
              StyleBox["Cos",
               ShowAutoStyles->False,
               AutoSpacing->False],
              Cos,
              Editable->False], "[", 
             InterpretationBox[
              StyleBox["\[Theta]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Theta][],
              Editable->False], "]"}], "2"]}], "+", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], "2"]}]]}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "BL"}], ",", 
     RowBox[{"-", "BL"}]}], "}"}], ",", "0"}], "]"}]], "Output",ExpressionUUID\
->"133a5c87-3332-43cb-8b1a-3eed1ab89d64"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"$CVSimplify", "=", "Simplify"}], ";"}]], "Input",ExpressionUUID->\
"2438b02b-c061-4967-8059-c15d2d6a3f8b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"SetCMetric", "[", 
   RowBox[{"met", ",", "BL", ",", 
    RowBox[{"SignatureOfMetric", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"3", ",", "1", ",", "0"}], "}"}]}]}], "]"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"515913a5-016e-487f-a6c9-\
07ef185facbc"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.844833`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"3d3abc6e-07bb-42ca-8e45-4ae23572849d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MetricCompute", "[", 
   RowBox[{"met", ",", "BL", ",", 
    RowBox[{"\"\<Ricci\>\"", "[", 
     RowBox[{
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}]}], "]"}]}], "]"}], "//", "AbsoluteTiming"}]], "Input",\
ExpressionUUID->"2d4640c2-79cf-40dd-ac69-791d8326ecf1"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"6.504173`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"022429d2-4bd9-4d78-bd32-6c2282a1c257"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Ricci", "[", 
  RowBox[{"CovDOfMetric", "[", "met", "]"}], "]"}]], "Input",ExpressionUUID->\
"a565dd84-fa28-4f16-815c-2fb825eafb9e"],

Cell[BoxData["Zero"], "Output",ExpressionUUID->"28a8d136-7421-4de0-8dd5-924f6b78d5a4"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", "met", "]"}]], "Input",ExpressionUUID->"d0992348-7fd7-4bfe-b92d-fda8a5fb7604"],

Cell[BoxData[
 RowBox[{"UndefConstantSymbol", "[", 
  RowBox[{"{", 
   RowBox[{"\[Alpha]", ",", "\[CapitalMu]"}], "}"}], "]"}]], "Input",Expressio\
nUUID->"02e32f9c-3f7c-44b6-8294-e6c4a753ab79"],

Cell[BoxData[
 RowBox[{"UndefChart", "[", "BL", "]"}]], "Input",ExpressionUUID->"08ac544b-6168-41f0-a272-96f406cfae08"],

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M", "]"}]], "Input",ExpressionUUID->"3201dc53-b65e-4d38-b334-f812e98c6558"],

Cell[BoxData[
 RowBox[{"ClearxCobaCache", "[", "All", "]"}]], "Input",ExpressionUUID->"5cfb4456-1c1e-4d58-8581-8cf30c1e6e36"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.11. Kerr in a rotating frame", "Subsubsection",ExpressionUUID->"93b220e5-639a-4e55-b7f8-01666140afc0"],

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M", ",", "4", ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"6b1524e6-d92c-49c5-ac37-8aeca6326b55"],

Cell[BoxData[
 RowBox[{"DefChart", "[", 
  RowBox[{"BL", ",", "M", ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"t", "[", "]"}], ",", 
     RowBox[{"r", "[", "]"}], ",", 
     RowBox[{"x", "[", "]"}], ",", 
     RowBox[{"\[Phi]", "[", "]"}]}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"a4222e57-0bfd-45a3-a99f-e05d8a925286"],

Cell[BoxData[
 RowBox[{"DefConstantSymbol", "[", 
  RowBox[{"{", 
   RowBox[{"\[Alpha]", ",", "\[CapitalMu]"}], "}"}], "]"}]], "Input",Expressio\
nUUID->"f9727074-ed6d-4c03-a31e-88e53a58c73d"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Sigma", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"r", "[", "]"}], "^", "2"}], "+", 
    RowBox[{
     RowBox[{"\[Alpha]", "^", "2"}], 
     RowBox[{
      RowBox[{"x", "[", "]"}], "^", "2"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Delta", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"r", "[", "]"}], "^", "2"}], "+", 
    RowBox[{"\[Alpha]", "^", "2"}], "-", 
    RowBox[{"2", "\[CapitalMu]", " ", 
     RowBox[{"r", "[", "]"}]}]}]}], ";"}]}], "Input",ExpressionUUID->\
"43a258e7-f8f2-4864-a8c7-8aa0827591a2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$CVSimplify", "=", "Simplify"}], ";"}]], "Input",ExpressionUUID->\
"9f5c65c3-edf4-411b-92be-59821166b8fd"],

Cell[BoxData[
 RowBox[{"DefBasis", "[", 
  RowBox[{"R", ",", "TangentM", ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"BasisColor", "\[Rule]", "Blue"}], ",", 
   RowBox[{"BasisChange", "\[Rule]", 
    RowBox[{"CTensor", "[", 
     RowBox[{
      RowBox[{"Transpose", "@", 
       RowBox[{"Inverse", "@", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "0", ",", 
            RowBox[{"2", "\[Alpha]", " ", "\[CapitalMu]", " ", 
             RowBox[{"r", "[", "]"}], 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{
                 RowBox[{"x", "[", "]"}], "^", "2"}]}], ")"}], "/", 
              RowBox[{"(", 
               RowBox[{"Sigma", "-", 
                RowBox[{"2", "\[CapitalMu]", " ", 
                 RowBox[{"r", "[", "]"}]}]}], ")"}]}]}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]}]}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "R"}], ",", "BL"}], "}"}]}], "]"}]}]}], "]"}]], "Input",E\
xpressionUUID->"9d25ff27-5e31-4f5c-be41-60cc17d0ca82"],

Cell[BoxData[
 RowBox[{
  RowBox[{"met", "=", 
   RowBox[{"CTensor", "[", 
    RowBox[{
     RowBox[{"DiagonalMatrix", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"1", "-", 
         RowBox[{"2", "\[CapitalMu]", " ", 
          RowBox[{
           RowBox[{"r", "[", "]"}], "/", "Sigma"}]}]}], ",", 
        RowBox[{
         RowBox[{"-", "Sigma"}], "/", "Delta"}], ",", 
        RowBox[{
         RowBox[{"-", "Sigma"}], "/", 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{
            RowBox[{"x", "[", "]"}], "^", "2"}]}], ")"}]}], ",", 
        RowBox[{
         RowBox[{"-", "Delta"}], " ", "Sigma", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "-", 
            RowBox[{
             RowBox[{"x", "[", "]"}], "^", "2"}]}], ")"}], "/", 
          RowBox[{"(", 
           RowBox[{"Sigma", "-", 
            RowBox[{"2", "\[CapitalMu]", " ", 
             RowBox[{"r", "[", "]"}]}]}], ")"}]}]}]}], "}"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "R"}], ",", 
       RowBox[{"-", "R"}]}], "}"}]}], "]"}]}], ";"}]], "Input",ExpressionUUID-\
>"41f00e28-8e0a-4890-9fd6-d466ac95bb41"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"SetCMetric", "[", 
   RowBox[{"met", ",", "BL", ",", 
    RowBox[{"SignatureOfMetric", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"3", ",", "1", ",", "0"}], "}"}]}]}], "]"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"3a689043-7ef5-46be-aea2-\
c9c0a251e24d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.635894`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"dee88f74-f377-4051-9ee1-1051bd772c29"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MetricCompute", "[", 
   RowBox[{"met", ",", "BL", ",", 
    RowBox[{"\"\<Weyl\>\"", "[", 
     RowBox[{
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}]}], "]"}]}], "]"}], "//", "AbsoluteTiming"}]], "Input",\
ExpressionUUID->"b126ff0e-c1f0-41c9-ae61-1c71e30adf16"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2.067364`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"f9a196ce-da03-41d2-997d-7a26912cae6b"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"cd", "=", 
   RowBox[{"CovDOfMetric", "[", "met", "]"}]}], ";"}]], "Input",ExpressionUUID\
->"2f540de1-5f33-4299-bb79-b6a4e6c5cba1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Ricci", "[", "cd", "]"}]], "Input",ExpressionUUID->"6137c1fd-c5d2-4db9-8e81-740953df2d6d"],

Cell[BoxData["Zero"], "Output",ExpressionUUID->"003320a2-b157-40a0-b4f6-e4fd89ce1477"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"met", ",", "Delta", ",", "Sigma", ",", "cd"}], "]"}]], "Input",Expr\
essionUUID->"4ede5afd-a63b-4ace-8e33-5e556cc41fef"],

Cell[BoxData[
 RowBox[{"UndefConstantSymbol", "[", 
  RowBox[{"{", 
   RowBox[{"\[Alpha]", ",", "\[CapitalMu]"}], "}"}], "]"}]], "Input",Expressio\
nUUID->"c83a276f-d081-43aa-aab6-2fe09e9669d3"],

Cell[BoxData[
 RowBox[{"UndefChart", "[", "BL", "]"}]], "Input",ExpressionUUID->"7537f762-80b8-4486-ad0f-907eeacda3ff"],

Cell[BoxData[
 RowBox[{"UndefBasis", "[", "R", "]"}]], "Input",ExpressionUUID->"8cd90a8e-c6c6-4d95-875d-f5e55ab2bd9f"],

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M", "]"}]], "Input",ExpressionUUID->"fc863c88-ef21-4bc4-936d-4a6d9e8599d3"],

Cell[BoxData[
 RowBox[{"ClearxCobaCache", "[", "All", "]"}]], "Input",ExpressionUUID->"7e81b978-3a00-48ae-868f-161ad9ac38e8"]
}, Closed]],

Cell[CellGroupData[{

Cell["5.12. Kerr in a null frame", "Subsubsection",ExpressionUUID->"85872dc2-ac6e-4601-b577-c8e979ffd89a"],

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M", ",", "4", ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f"}], "}"}]}], 
  "]"}]], "Input",ExpressionUUID->"a77e6cb3-9180-4f8c-be21-84c3ebc0721a"],

Cell[BoxData[
 RowBox[{"DefChart", "[", 
  RowBox[{"BL", ",", "M", ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"t", "[", "]"}], ",", 
     RowBox[{"r", "[", "]"}], ",", 
     RowBox[{"x", "[", "]"}], ",", 
     RowBox[{"\[Phi]", "[", "]"}]}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"1560ee65-7e29-41ec-be20-6f018a65013e"],

Cell[BoxData[
 RowBox[{"DefConstantSymbol", "[", 
  RowBox[{"{", 
   RowBox[{"\[Alpha]", ",", "\[CapitalMu]"}], "}"}], "]"}]], "Input",Expressio\
nUUID->"fe30879b-77d1-4f5b-a9a2-b6a9b91118ff"],

Cell[BoxData[
 RowBox[{"DefBasis", "[", 
  RowBox[{"NP", ",", "TangentM", ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
   RowBox[{"BasisColor", "\[Rule]", "Blue"}], ",", 
   RowBox[{"BasisChange", "\[Rule]", 
    RowBox[{"CTensor", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            FractionBox[
             RowBox[{
              SuperscriptBox[
               RowBox[{"r", "[", "]"}], "2"], "+", 
              RowBox[{
               SuperscriptBox["\[Alpha]", "2"], " ", 
               SuperscriptBox[
                RowBox[{"x", "[", "]"}], "2"]}]}], 
             RowBox[{" ", 
              SqrtBox[
               RowBox[{
                RowBox[{
                 RowBox[{"-", "2"}], " ", "\[CapitalMu]", " ", 
                 RowBox[{"r", "[", "]"}]}], "+", 
                SuperscriptBox[
                 RowBox[{"r", "[", "]"}], "2"], "+", 
                RowBox[{
                 SuperscriptBox["\[Alpha]", "2"], " ", 
                 SuperscriptBox[
                  RowBox[{"x", "[", "]"}], "2"]}]}]]}]], ",", 
            RowBox[{"-", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["\[Alpha]", "2"], "+", 
               RowBox[{
                RowBox[{"r", "[", "]"}], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "2"}], " ", "\[CapitalMu]"}], "+", 
                  RowBox[{"r", "[", "]"}]}], ")"}]}]}]]}], ",", "0", ",", 
            "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            FractionBox[
             RowBox[{
              SuperscriptBox[
               RowBox[{"r", "[", "]"}], "2"], "+", 
              RowBox[{
               SuperscriptBox["\[Alpha]", "2"], " ", 
               SuperscriptBox[
                RowBox[{"x", "[", "]"}], "2"]}]}], 
             SqrtBox[
              RowBox[{
               RowBox[{
                RowBox[{"-", "2"}], " ", "\[CapitalMu]", " ", 
                RowBox[{"r", "[", "]"}]}], "+", 
               SuperscriptBox[
                RowBox[{"r", "[", "]"}], "2"], "+", 
               RowBox[{
                SuperscriptBox["\[Alpha]", "2"], " ", 
                SuperscriptBox[
                 RowBox[{"x", "[", "]"}], "2"]}]}]]], ",", 
            SqrtBox[
             RowBox[{
              SuperscriptBox["\[Alpha]", "2"], "+", 
              RowBox[{
               RowBox[{"r", "[", "]"}], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"-", "2"}], " ", "\[CapitalMu]"}], "+", 
                 RowBox[{"r", "[", "]"}]}], ")"}]}]}]], ",", "0", ",", "0"}], 
           "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            FractionBox[
             RowBox[{
             "2", "\[ImaginaryI]", " ", "\[Alpha]", " ", "\[CapitalMu]", " ", 
              
              RowBox[{"r", "[", "]"}], " ", 
              SqrtBox[
               RowBox[{"1", "-", 
                SuperscriptBox[
                 RowBox[{"x", "[", "]"}], "2"]}]]}], 
             RowBox[{
              SqrtBox[
               RowBox[{
                SuperscriptBox["\[Alpha]", "2"], "+", 
                RowBox[{
                 RowBox[{"r", "[", "]"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "2"}], " ", "\[CapitalMu]"}], "+", 
                   RowBox[{"r", "[", "]"}]}], ")"}]}]}]], " ", 
              SqrtBox[
               RowBox[{
                RowBox[{
                 RowBox[{"-", "2"}], " ", "\[CapitalMu]", " ", 
                 RowBox[{"r", "[", "]"}]}], "+", 
                SuperscriptBox[
                 RowBox[{"r", "[", "]"}], "2"], "+", 
                RowBox[{
                 SuperscriptBox["\[Alpha]", "2"], " ", 
                 SuperscriptBox[
                  RowBox[{"x", "[", "]"}], "2"]}]}]]}]], ",", "0", ",", 
            SqrtBox[
             RowBox[{"1", "-", 
              SuperscriptBox[
               RowBox[{"x", "[", "]"}], "2"]}]], ",", 
            RowBox[{"-", 
             FractionBox[
              RowBox[{"\[ImaginaryI]", " ", 
               SqrtBox[
                RowBox[{
                 RowBox[{
                  RowBox[{"-", "2"}], " ", "\[CapitalMu]", " ", 
                  RowBox[{"r", "[", "]"}]}], "+", 
                 SuperscriptBox[
                  RowBox[{"r", "[", "]"}], "2"], "+", 
                 RowBox[{
                  SuperscriptBox["\[Alpha]", "2"], " ", 
                  SuperscriptBox[
                   RowBox[{"x", "[", "]"}], "2"]}]}]]}], 
              RowBox[{
               SqrtBox[
                RowBox[{
                 SuperscriptBox["\[Alpha]", "2"], "+", 
                 RowBox[{
                  RowBox[{"r", "[", "]"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "\[CapitalMu]"}], "+", 
                    RowBox[{"r", "[", "]"}]}], ")"}]}]}]], " ", 
               SqrtBox[
                RowBox[{"1", "-", 
                 SuperscriptBox[
                  RowBox[{"x", "[", "]"}], "2"]}]]}]]}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", 
             FractionBox[
              RowBox[{
              "2", "\[ImaginaryI]", " ", "\[Alpha]", " ", "\[CapitalMu]", " ", 
               RowBox[{"r", "[", "]"}], " ", 
               SqrtBox[
                RowBox[{"1", "-", 
                 SuperscriptBox[
                  RowBox[{"x", "[", "]"}], "2"]}]]}], 
              RowBox[{
               SqrtBox[
                RowBox[{
                 SuperscriptBox["\[Alpha]", "2"], "+", 
                 RowBox[{
                  RowBox[{"r", "[", "]"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "\[CapitalMu]"}], "+", 
                    RowBox[{"r", "[", "]"}]}], ")"}]}]}]], 
               SqrtBox[
                RowBox[{
                 RowBox[{
                  RowBox[{"-", "2"}], " ", "\[CapitalMu]", " ", 
                  RowBox[{"r", "[", "]"}]}], "+", 
                 SuperscriptBox[
                  RowBox[{"r", "[", "]"}], "2"], "+", 
                 RowBox[{
                  SuperscriptBox["\[Alpha]", "2"], " ", 
                  SuperscriptBox[
                   RowBox[{"x", "[", "]"}], "2"]}]}]]}]]}], ",", "0", ",", 
            SqrtBox[
             RowBox[{"1", "-", 
              SuperscriptBox[
               RowBox[{"x", "[", "]"}], "2"]}]], ",", 
            FractionBox[
             RowBox[{"\[ImaginaryI]", " ", 
              SqrtBox[
               RowBox[{
                RowBox[{
                 RowBox[{"-", "2"}], " ", "\[CapitalMu]", " ", 
                 RowBox[{"r", "[", "]"}]}], "+", 
                SuperscriptBox[
                 RowBox[{"r", "[", "]"}], "2"], "+", 
                RowBox[{
                 SuperscriptBox["\[Alpha]", "2"], " ", 
                 SuperscriptBox[
                  RowBox[{"x", "[", "]"}], "2"]}]}]]}], 
             RowBox[{
              SqrtBox[
               RowBox[{
                SuperscriptBox["\[Alpha]", "2"], "+", 
                RowBox[{
                 RowBox[{"r", "[", "]"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "2"}], " ", "\[CapitalMu]"}], "+", 
                   RowBox[{"r", "[", "]"}]}], ")"}]}]}]], " ", 
              SqrtBox[
               RowBox[{"1", "-", 
                SuperscriptBox[
                 RowBox[{"x", "[", "]"}], "2"]}]]}]]}], "}"}]}], "}"}], "/", 
        SqrtBox[
         RowBox[{
          SuperscriptBox[
           RowBox[{"r", "[", "]"}], "2"], "+", 
          RowBox[{
           SuperscriptBox["\[Alpha]", "2"], " ", 
           SuperscriptBox[
            RowBox[{"x", "[", "]"}], "2"]}]}]]}], "/", 
       SqrtBox["2"]}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "NP"}], ",", "BL"}], "}"}]}], "]"}]}]}], "]"}]], "Input",\
ExpressionUUID->"1b42fbb6-497f-42dd-b30a-ce9f5ce1aea3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"met", "=", 
    RowBox[{"CTensor", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0", ",", 
          RowBox[{"-", "1"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", 
          RowBox[{"-", "1"}], ",", "0"}], "}"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "NP"}], ",", 
        RowBox[{"-", "NP"}]}], "}"}]}], "]"}]}], ")"}], "[", 
  RowBox[{
   RowBox[{"-", "a"}], ",", 
   RowBox[{"-", "b"}]}], "]"}]], "Input",ExpressionUUID->"1f301bdc-465c-4333-\
8261-3c56faf6b4e7"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["1",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", "1"}]],
           Annotation[#, {1, 2} -> 1, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 4} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["1",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", "1"}]],
           Annotation[#, {2, 1} -> 1, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 4} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{"-", "1"}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "4"}], "}"}], "\[Rule]", 
              RowBox[{"-", "1"}]}]],
           Annotation[#, {3, 4} -> -1, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{"-", "1"}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "3"}], "}"}], "\[Rule]", 
              RowBox[{"-", "1"}]}]],
           Annotation[#, {4, 3} -> -1, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 4} -> 0, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]},
           "RowsIndexed" -> {1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {" ", " "},
         {"a", "b"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{0, 1, 0, 0}, {1, 0, 0, 0}, {0, 0, 0, -1}, {0, 0, -1, 
   0}}, {-$CellContext`NP, -$CellContext`NP}, 
   0][-$CellContext`a, -$CellContext`b],
  Editable->False]], "Output",ExpressionUUID->"054c61b7-1230-4dcc-a1c4-\
dce646339354"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"$CVSimplify", "=", "Simplify"}], ";"}]], "Input",ExpressionUUID->\
"9dccea9f-05de-4cc7-8695-cdb193f3f5d8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MetricCompute", "[", 
   RowBox[{"met", ",", "BL", ",", "All", ",", 
    RowBox[{"Parallelize", "\[Rule]", "True"}]}], "]"}], "//", 
  "AbsoluteTiming"}]], "Input",ExpressionUUID->"f3ee22e1-b33b-4b2f-83c6-\
f087335d7736"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"6.949212`", ",", "Null"}], "}"}]], "Output",ExpressionUUID->\
"89f74d5e-80e0-461c-977b-855a8a052998"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"cd", "=", 
   RowBox[{"CovDOfMetric", "[", "met", "]"}]}], ";"}]], "Input",ExpressionUUID\
->"c79d8bd7-94bd-40a9-8e94-00b651f1d174"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Einstein", "[", "cd", "]"}], "[", 
  RowBox[{
   RowBox[{"-", "a"}], ",", 
   RowBox[{"-", "b"}]}], "]"}]], "Input",ExpressionUUID->"7bf765db-af32-425b-\
a400-5fb8b58bc80e"],

Cell[BoxData["0"], "Output",ExpressionUUID->"2d0d9dc7-ee7a-49ae-9a6a-7fe45e1581e6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Kretschmann", "[", "cd", "]"}], "[", "]"}]], "Input",ExpressionUUID\
->"019b4d75-51e6-4fae-b6a7-0a11e5a5dd97"],

Cell[BoxData[
 FractionBox[
  RowBox[{"48", " ", 
   SuperscriptBox[
    InterpretationBox[
     StyleBox["\[CapitalMu]",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`\[CapitalMu],
     Editable->False], "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "6"], "-", 
     RowBox[{"15", " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], "2"], " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], "4"], " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], "2"]}], "+", 
     RowBox[{"15", " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], "4"], " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], "2"], " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], "4"]}], "-", 
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], "6"], " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], "6"]}]}], ")"}]}], 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "2"], "+", 
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], "2"], " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], "2"]}]}], ")"}], "6"]]], "Output",ExpressionUUID->\
"448f2b6f-3a63-423d-9a51-89cffaa81aaf"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"cdRiemann", "=", 
   RowBox[{"TensorDerivative", "[", 
    RowBox[{
     RowBox[{"RiemannDown", "[", "cd", "]"}], ",", "cd"}], "]"}]}], 
  ";"}]], "Input",ExpressionUUID->"d1ffea02-ddfe-4ef2-91b0-299b16d2ca31"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"cdRiemann", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}], ",", 
     RowBox[{"-", "d"}], ",", 
     RowBox[{"-", "e"}]}], "]"}], "+", 
   RowBox[{"cdRiemann", "[", 
    RowBox[{
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}], ",", 
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "d"}], ",", 
     RowBox[{"-", "e"}]}], "]"}], "+", 
   RowBox[{"cdRiemann", "[", 
    RowBox[{
     RowBox[{"-", "c"}], ",", 
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "d"}], ",", 
     RowBox[{"-", "e"}]}], "]"}]}], "//", "Simplify"}]], "Input",ExpressionUUI\
D->"accc27d5-4375-4edd-bc69-da5ee1101b3a"],

Cell[BoxData["0"], "Output",ExpressionUUID->"baa32ed9-c7f6-4fd3-94ec-19a8bf7205d9"]
}, Open  ]],

Cell["The NP scalars for Kerr (with some choice of signs...):", "Text",ExpressionUUID->"cd07a007-d780-4709-b7c5-bb33cb0fadcb"],

Cell[BoxData[
 RowBox[{"SetCMetric", "[", 
  RowBox[{"met", ",", "BL"}], "]"}]], "Input",ExpressionUUID->"146736f8-a107-\
4d98-8747-8e048a52bc66"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"l", "=", 
   RowBox[{"CTensor", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"-", "NP"}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"n", "=", 
   RowBox[{"CTensor", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"-", "NP"}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"m", "=", 
   RowBox[{"CTensor", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"-", "NP"}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mbar", "=", 
   RowBox[{"CTensor", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"-", "NP"}], "}"}]}], "]"}]}], ";"}]}], "Input",ExpressionUUID->\
"fdca994d-b9c0-4a15-bacf-98ae7c70f57c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"met", "[", 
   RowBox[{
    RowBox[{"-", "a"}], ",", 
    RowBox[{"-", "b"}]}], "]"}], "\[Equal]", 
  RowBox[{
   RowBox[{
    RowBox[{"l", "[", 
     RowBox[{"-", "a"}], "]"}], 
    RowBox[{"n", "[", 
     RowBox[{"-", "b"}], "]"}]}], "+", 
   RowBox[{
    RowBox[{"l", "[", 
     RowBox[{"-", "b"}], "]"}], 
    RowBox[{"n", "[", 
     RowBox[{"-", "a"}], "]"}]}], "-", 
   RowBox[{
    RowBox[{"m", "[", 
     RowBox[{"-", "a"}], "]"}], 
    RowBox[{"mbar", "[", 
     RowBox[{"-", "b"}], "]"}]}], "-", 
   RowBox[{
    RowBox[{"m", "[", 
     RowBox[{"-", "b"}], "]"}], 
    RowBox[{"mbar", "[", 
     RowBox[{"-", "a"}], "]"}]}]}]}]], "Input",ExpressionUUID->"a8ff9705-6e33-\
471c-94b2-c05efe6fb22b"],

Cell[BoxData["True"], "Output",ExpressionUUID->"04925be7-437e-4e4e-8b78-edbe2d1d962d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NP\[Kappa]", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     RowBox[{"m", "[", "a", "]"}]}], 
    RowBox[{"l", "[", "b", "]"}], 
    RowBox[{
     RowBox[{"cd", "[", 
      RowBox[{"-", "b"}], "]"}], "[", 
     RowBox[{"l", "[", 
      RowBox[{"-", "a"}], "]"}], "]"}]}], "//", "Simplify"}]}]], "Input",Expre\
ssionUUID->"731eb763-52db-4849-971e-efeb3e37bc89"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{
    InterpretationBox[
     StyleBox["\[Alpha]",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`\[Alpha],
     Editable->False], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], "2"]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "2"}], " ", 
       InterpretationBox[
        StyleBox["\[CapitalMu]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[CapitalMu],
        Editable->False], " ", 
       RowBox[{"(", 
        RowBox[{
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False], "-", 
         RowBox[{"\[ImaginaryI]", " ", 
          InterpretationBox[
           StyleBox["\[Alpha]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Alpha],
           Editable->False], " ", 
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False]}]}], ")"}]}], "+", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "\[ImaginaryI]"}], " ", 
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False]}], "+", 
         RowBox[{
          InterpretationBox[
           StyleBox["\[Alpha]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Alpha],
           Editable->False], " ", 
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False]}]}], ")"}]}]}], ")"}]}], 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "\[ImaginaryI]"}], " ", 
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False]}], "+", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False]}]}], ")"}], " ", 
    SqrtBox[
     RowBox[{"2", "-", 
      RowBox[{"2", " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False], "2"]}]}]], " ", 
    SqrtBox[
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], "2"], "+", 
      RowBox[{
       SuperscriptBox[
        InterpretationBox[
         StyleBox["\[Alpha]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Alpha],
         Editable->False], "2"], " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False], "2"]}]}]], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "2"}], " ", 
       InterpretationBox[
        StyleBox["\[CapitalMu]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[CapitalMu],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False]}], "+", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], "2"], "+", 
      RowBox[{
       SuperscriptBox[
        InterpretationBox[
         StyleBox["\[Alpha]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Alpha],
         Editable->False], "2"], " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False], "2"]}]}], ")"}]}]]}]], "Output",ExpressionUUID->\
"4f9408e0-71c2-410f-b98b-2fae9a2dcdf8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NP\[Tau]", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     RowBox[{"m", "[", "a", "]"}]}], 
    RowBox[{"n", "[", "b", "]"}], 
    RowBox[{
     RowBox[{"cd", "[", 
      RowBox[{"-", "b"}], "]"}], "[", 
     RowBox[{"l", "[", 
      RowBox[{"-", "a"}], "]"}], "]"}]}], "//", "Simplify"}]}]], "Input",Expre\
ssionUUID->"7a67d7ee-ff00-4338-941d-4e5d9d7e6cfb"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   SuperscriptBox[
    InterpretationBox[
     StyleBox["\[Alpha]",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`\[Alpha],
     Editable->False], "2"], " ", 
   InterpretationBox[
    StyleBox["x",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`x[],
    Editable->False], " ", 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["x",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`x[],
       Editable->False], "2"]}]]}], 
  RowBox[{
   SqrtBox["2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"4", " ", 
      InterpretationBox[
       StyleBox["\[CapitalMu]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[CapitalMu],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False]}], "-", 
     RowBox[{"2", " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], "2"]}], "-", 
     RowBox[{"2", " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], "2"], " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], "2"]}]}], ")"}], " ", 
   SqrtBox[
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "2"], "+", 
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], "2"], " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], "2"]}]}]]}]]], "Output",ExpressionUUID->"adf1ea0b-\
fc55-4186-91df-5e62a1b5ee3a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NP\[Sigma]", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     RowBox[{"m", "[", "a", "]"}]}], 
    RowBox[{"m", "[", "b", "]"}], 
    RowBox[{
     RowBox[{"cd", "[", 
      RowBox[{"-", "b"}], "]"}], "[", 
     RowBox[{"l", "[", 
      RowBox[{"-", "a"}], "]"}], "]"}]}], "//", "Simplify"}]}]], "Input",Expre\
ssionUUID->"f8fdf400-048e-4a32-9cae-e65774626219"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   SuperscriptBox[
    InterpretationBox[
     StyleBox["\[Alpha]",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`\[Alpha],
     Editable->False], "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     InterpretationBox[
      StyleBox["\[CapitalMu]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[CapitalMu],
      Editable->False], "-", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["x",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`x[],
       Editable->False], "2"]}], ")"}]}], 
  RowBox[{"2", " ", 
   SqrtBox["2"], " ", 
   SqrtBox[
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["\[Alpha]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Alpha],
       Editable->False], "2"], "+", 
     RowBox[{
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "2"}], " ", 
         InterpretationBox[
          StyleBox["\[CapitalMu]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[CapitalMu],
          Editable->False]}], "+", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False]}], ")"}]}]}]], " ", 
   SqrtBox[
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "2"], "+", 
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], "2"], " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], "2"]}]}]], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      InterpretationBox[
       StyleBox["\[CapitalMu]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[CapitalMu],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False]}], "+", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "2"], "+", 
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], "2"], " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], "2"]}]}], ")"}]}]]], "Output",ExpressionUUID->\
"580b8062-106b-4ffc-bdb0-0b461d97fbbe"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NP\[Rho]", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     RowBox[{"m", "[", "a", "]"}]}], 
    RowBox[{"mbar", "[", "b", "]"}], 
    RowBox[{
     RowBox[{"cd", "[", 
      RowBox[{"-", "b"}], "]"}], "[", 
     RowBox[{"l", "[", 
      RowBox[{"-", "a"}], "]"}], "]"}]}], "//", "Simplify"}]}]], "Input",Expre\
ssionUUID->"09743b26-e319-4813-8306-3795adf26362"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{
    RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
    SuperscriptBox[
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], "2"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        InterpretationBox[
         StyleBox["\[CapitalMu]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[CapitalMu],
         Editable->False]}], "+", 
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False]}], ")"}], "2"]}], "+", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox["\[Alpha]",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`\[Alpha],
     Editable->False], " ", 
    SuperscriptBox[
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "2"}], " ", 
       InterpretationBox[
        StyleBox["\[CapitalMu]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[CapitalMu],
        Editable->False]}], "+", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False]}], ")"}], " ", 
    InterpretationBox[
     StyleBox["x",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`x[],
     Editable->False]}], "+", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["\[Alpha]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Alpha],
      Editable->False], "3"], " ", 
    InterpretationBox[
     StyleBox["x",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`x[],
     Editable->False], " ", 
    RowBox[{"(", 
     RowBox[{
      InterpretationBox[
       StyleBox["\[CapitalMu]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[CapitalMu],
       Editable->False], "+", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "-", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[CapitalMu]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[CapitalMu],
        Editable->False], " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False], "2"]}], "+", 
      RowBox[{
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False], "2"]}]}], ")"}]}], "+", 
   RowBox[{"\[ImaginaryI]", " ", 
    SuperscriptBox[
     InterpretationBox[
      StyleBox["\[Alpha]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Alpha],
      Editable->False], "2"], " ", 
    InterpretationBox[
     StyleBox["r",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`r[],
     Editable->False], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False]}], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], "2"]}], ")"}]}], "+", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[CapitalMu]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[CapitalMu],
        Editable->False], " ", 
       RowBox[{"(", 
        RowBox[{"3", "+", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], "2"]}], ")"}]}]}], ")"}]}]}], 
  RowBox[{"2", " ", 
   SqrtBox["2"], " ", 
   SqrtBox[
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["\[Alpha]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Alpha],
       Editable->False], "2"], "+", 
     RowBox[{
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "2"}], " ", 
         InterpretationBox[
          StyleBox["\[CapitalMu]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[CapitalMu],
          Editable->False]}], "+", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False]}], ")"}]}]}]], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "\[ImaginaryI]"}], " ", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False]}], "+", 
     RowBox[{
      InterpretationBox[
       StyleBox["\[Alpha]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Alpha],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox["x",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`x[],
       Editable->False]}]}], ")"}], " ", 
   SqrtBox[
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "2"], "+", 
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], "2"], " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], "2"]}]}]], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      InterpretationBox[
       StyleBox["\[CapitalMu]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[CapitalMu],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False]}], "+", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "2"], "+", 
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], "2"], " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], "2"]}]}], ")"}]}]]], "Output",ExpressionUUID->\
"d9ddf9bf-d6b6-40cf-a32a-04a2b13f7da6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NP\[Pi]", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     RowBox[{"mbar", "[", "a", "]"}]}], 
    RowBox[{"l", "[", "b", "]"}], 
    RowBox[{
     RowBox[{"cd", "[", 
      RowBox[{"-", "b"}], "]"}], "[", 
     RowBox[{"n", "[", 
      RowBox[{"-", "a"}], "]"}], "]"}]}], "//", "Simplify"}]}]], "Input",Expre\
ssionUUID->"cd3e8206-c815-46bc-951c-66995aff901c"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   SuperscriptBox[
    InterpretationBox[
     StyleBox["\[Alpha]",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`\[Alpha],
     Editable->False], "2"], " ", 
   InterpretationBox[
    StyleBox["x",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`x[],
    Editable->False], " ", 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["x",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`x[],
       Editable->False], "2"]}]]}], 
  RowBox[{
   SqrtBox["2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"4", " ", 
      InterpretationBox[
       StyleBox["\[CapitalMu]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[CapitalMu],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False]}], "-", 
     RowBox[{"2", " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], "2"]}], "-", 
     RowBox[{"2", " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], "2"], " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], "2"]}]}], ")"}], " ", 
   SqrtBox[
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "2"], "+", 
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], "2"], " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], "2"]}]}]]}]]], "Output",ExpressionUUID->"925514fa-\
5aff-479c-a3d6-8586b7a5fb51"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NP\[Nu]", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     RowBox[{"mbar", "[", "a", "]"}]}], 
    RowBox[{"n", "[", "b", "]"}], 
    RowBox[{
     RowBox[{"cd", "[", 
      RowBox[{"-", "b"}], "]"}], "[", 
     RowBox[{"n", "[", 
      RowBox[{"-", "a"}], "]"}], "]"}]}], "//", "Simplify"}]}]], "Input",Expre\
ssionUUID->"c4958191-5b2a-4c9e-b15b-3fe0fb87e801"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{
    InterpretationBox[
     StyleBox["\[Alpha]",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`\[Alpha],
     Editable->False], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], "2"]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "2"}], " ", 
       InterpretationBox[
        StyleBox["\[CapitalMu]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[CapitalMu],
        Editable->False], " ", 
       RowBox[{"(", 
        RowBox[{
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False], "-", 
         RowBox[{"\[ImaginaryI]", " ", 
          InterpretationBox[
           StyleBox["\[Alpha]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Alpha],
           Editable->False], " ", 
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False]}]}], ")"}]}], "+", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "\[ImaginaryI]"}], " ", 
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False]}], "+", 
         RowBox[{
          InterpretationBox[
           StyleBox["\[Alpha]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[Alpha],
           Editable->False], " ", 
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False]}]}], ")"}]}]}], ")"}]}], 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "\[ImaginaryI]"}], " ", 
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False]}], "+", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False]}]}], ")"}], " ", 
    SqrtBox[
     RowBox[{"2", "-", 
      RowBox[{"2", " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False], "2"]}]}]], " ", 
    SqrtBox[
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], "2"], "+", 
      RowBox[{
       SuperscriptBox[
        InterpretationBox[
         StyleBox["\[Alpha]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Alpha],
         Editable->False], "2"], " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False], "2"]}]}]], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "2"}], " ", 
       InterpretationBox[
        StyleBox["\[CapitalMu]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[CapitalMu],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False]}], "+", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], "2"], "+", 
      RowBox[{
       SuperscriptBox[
        InterpretationBox[
         StyleBox["\[Alpha]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Alpha],
         Editable->False], "2"], " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False], "2"]}]}], ")"}]}]]}]], "Output",ExpressionUUID->\
"5c4d2ed8-cd9c-4be5-83d5-87d20866ef42"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NP\[Mu]", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     RowBox[{"mbar", "[", "a", "]"}]}], 
    RowBox[{"m", "[", "b", "]"}], 
    RowBox[{
     RowBox[{"cd", "[", 
      RowBox[{"-", "b"}], "]"}], "[", 
     RowBox[{"n", "[", 
      RowBox[{"-", "a"}], "]"}], "]"}]}], "//", "Simplify"}]}]], "Input",Expre\
ssionUUID->"0bb8328a-abfa-4eec-8ca3-aa1bb19532ca"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{
    RowBox[{
     RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "2"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "2"}], " ", 
         InterpretationBox[
          StyleBox["\[CapitalMu]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[CapitalMu],
          Editable->False]}], "+", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False]}], ")"}], "2"]}], "+", 
    RowBox[{"2", " ", 
     InterpretationBox[
      StyleBox["\[Alpha]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Alpha],
      Editable->False], " ", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        InterpretationBox[
         StyleBox["\[CapitalMu]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[CapitalMu],
         Editable->False]}], "+", 
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False]}], ")"}], " ", 
     InterpretationBox[
      StyleBox["x",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`x[],
      Editable->False]}], "+", 
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["\[Alpha]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Alpha],
       Editable->False], "3"], " ", 
     InterpretationBox[
      StyleBox["x",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`x[],
      Editable->False], " ", 
     RowBox[{"(", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[CapitalMu]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[CapitalMu],
        Editable->False], "+", 
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], "-", 
       RowBox[{
        InterpretationBox[
         StyleBox["\[CapitalMu]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[CapitalMu],
         Editable->False], " ", 
        SuperscriptBox[
         InterpretationBox[
          StyleBox["x",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x[],
          Editable->False], "2"]}], "+", 
       RowBox[{
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], " ", 
        SuperscriptBox[
         InterpretationBox[
          StyleBox["x",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`x[],
          Editable->False], "2"]}]}], ")"}]}], "+", 
    RowBox[{"\[ImaginaryI]", " ", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["\[Alpha]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Alpha],
       Editable->False], "2"], " ", 
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False]}], " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["x",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x[],
            Editable->False], "2"]}], ")"}]}], "+", 
       RowBox[{
        InterpretationBox[
         StyleBox["\[CapitalMu]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[CapitalMu],
         Editable->False], " ", 
        RowBox[{"(", 
         RowBox[{"3", "+", 
          SuperscriptBox[
           InterpretationBox[
            StyleBox["x",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`x[],
            Editable->False], "2"]}], ")"}]}]}], ")"}]}]}], 
   RowBox[{"2", " ", 
    SqrtBox["2"], " ", 
    SqrtBox[
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], "2"], "+", 
      RowBox[{
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "2"}], " ", 
          InterpretationBox[
           StyleBox["\[CapitalMu]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[CapitalMu],
           Editable->False]}], "+", 
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False]}], ")"}]}]}]], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "\[ImaginaryI]"}], " ", 
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False]}], "+", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False]}]}], ")"}], " ", 
    SqrtBox[
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], "2"], "+", 
      RowBox[{
       SuperscriptBox[
        InterpretationBox[
         StyleBox["\[Alpha]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Alpha],
         Editable->False], "2"], " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False], "2"]}]}]], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "2"}], " ", 
       InterpretationBox[
        StyleBox["\[CapitalMu]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[CapitalMu],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False]}], "+", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], "2"], "+", 
      RowBox[{
       SuperscriptBox[
        InterpretationBox[
         StyleBox["\[Alpha]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Alpha],
         Editable->False], "2"], " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False], "2"]}]}], ")"}]}]]}]], "Output",ExpressionUUID->\
"6c597654-73eb-4a07-bcdd-c5a015107469"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NP\[Lambda]", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     RowBox[{"mbar", "[", "a", "]"}]}], 
    RowBox[{"mbar", "[", "b", "]"}], 
    RowBox[{
     RowBox[{"cd", "[", 
      RowBox[{"-", "b"}], "]"}], "[", 
     RowBox[{"n", "[", 
      RowBox[{"-", "a"}], "]"}], "]"}]}], "//", "Simplify"}]}]], "Input",Expre\
ssionUUID->"57745a16-f0a6-45bb-b484-54b4b95b772e"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["\[Alpha]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Alpha],
      Editable->False], "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      InterpretationBox[
       StyleBox["\[CapitalMu]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[CapitalMu],
       Editable->False], "-", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], "2"]}], ")"}]}], 
   RowBox[{"2", " ", 
    SqrtBox["2"], " ", 
    SqrtBox[
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], "2"], "+", 
      RowBox[{
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "2"}], " ", 
          InterpretationBox[
           StyleBox["\[CapitalMu]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[CapitalMu],
           Editable->False]}], "+", 
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False]}], ")"}]}]}]], " ", 
    SqrtBox[
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], "2"], "+", 
      RowBox[{
       SuperscriptBox[
        InterpretationBox[
         StyleBox["\[Alpha]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Alpha],
         Editable->False], "2"], " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False], "2"]}]}]], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "2"}], " ", 
       InterpretationBox[
        StyleBox["\[CapitalMu]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[CapitalMu],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False]}], "+", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], "2"], "+", 
      RowBox[{
       SuperscriptBox[
        InterpretationBox[
         StyleBox["\[Alpha]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Alpha],
         Editable->False], "2"], " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False], "2"]}]}], ")"}]}]]}]], "Output",ExpressionUUID->\
"a15307a2-96ee-41f2-8396-6d4edad412f0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NP\[Epsilon]", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"-", "1"}], "/", "2"}], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"n", "[", "a", "]"}], 
       RowBox[{"l", "[", "b", "]"}], 
       RowBox[{
        RowBox[{"cd", "[", 
         RowBox[{"-", "b"}], "]"}], "[", 
        RowBox[{"l", "[", 
         RowBox[{"-", "a"}], "]"}], "]"}]}], "-", 
      RowBox[{
       RowBox[{"mbar", "[", "a", "]"}], 
       RowBox[{"l", "[", "b", "]"}], 
       RowBox[{
        RowBox[{"cd", "[", 
         RowBox[{"-", "b"}], "]"}], "[", 
        RowBox[{"m", "[", 
         RowBox[{"-", "a"}], "]"}], "]"}]}]}], ")"}]}], "//", 
   "Simplify"}]}]], "Input",ExpressionUUID->"3bac5169-21b6-4927-9f10-\
28df031f424b"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   InterpretationBox[
    StyleBox["\[CapitalMu]",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`\[CapitalMu],
    Editable->False], " ", 
   SqrtBox[
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["\[Alpha]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Alpha],
       Editable->False], "2"], "+", 
     RowBox[{
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "2"}], " ", 
         InterpretationBox[
          StyleBox["\[CapitalMu]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[CapitalMu],
          Editable->False]}], "+", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False]}], ")"}]}]}]], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"\[ImaginaryI]", " ", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False]}], "+", 
     RowBox[{
      InterpretationBox[
       StyleBox["\[Alpha]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Alpha],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox["x",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`x[],
       Editable->False]}]}], ")"}]}], 
  RowBox[{"2", " ", 
   SqrtBox["2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "\[ImaginaryI]"}], " ", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False]}], "+", 
     RowBox[{
      InterpretationBox[
       StyleBox["\[Alpha]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Alpha],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox["x",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`x[],
       Editable->False]}]}], ")"}], " ", 
   SqrtBox[
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "2"], "+", 
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], "2"], " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], "2"]}]}]], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      InterpretationBox[
       StyleBox["\[CapitalMu]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[CapitalMu],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False]}], "+", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "2"], "+", 
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], "2"], " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], "2"]}]}], ")"}]}]]], "Output",ExpressionUUID->\
"4ad06b20-063d-462a-8724-2cc6e3cbdcc9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NP\[Gamma]", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"-", "1"}], "/", "2"}], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"n", "[", "a", "]"}], 
       RowBox[{"n", "[", "b", "]"}], 
       RowBox[{
        RowBox[{"cd", "[", 
         RowBox[{"-", "b"}], "]"}], "[", 
        RowBox[{"l", "[", 
         RowBox[{"-", "a"}], "]"}], "]"}]}], "-", 
      RowBox[{
       RowBox[{"mbar", "[", "a", "]"}], 
       RowBox[{"n", "[", "b", "]"}], 
       RowBox[{
        RowBox[{"cd", "[", 
         RowBox[{"-", "b"}], "]"}], "[", 
        RowBox[{"m", "[", 
         RowBox[{"-", "a"}], "]"}], "]"}]}]}], ")"}]}], "//", 
   "Simplify"}]}]], "Input",ExpressionUUID->"d129cceb-557d-444e-b5bc-\
e496318ca620"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   InterpretationBox[
    StyleBox["\[CapitalMu]",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`\[CapitalMu],
    Editable->False], " ", 
   SqrtBox[
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["\[Alpha]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Alpha],
       Editable->False], "2"], "+", 
     RowBox[{
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "2"}], " ", 
         InterpretationBox[
          StyleBox["\[CapitalMu]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[CapitalMu],
          Editable->False]}], "+", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False]}], ")"}]}]}]], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"\[ImaginaryI]", " ", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False]}], "+", 
     RowBox[{
      InterpretationBox[
       StyleBox["\[Alpha]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Alpha],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox["x",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`x[],
       Editable->False]}]}], ")"}]}], 
  RowBox[{"2", " ", 
   SqrtBox["2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "\[ImaginaryI]"}], " ", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False]}], "+", 
     RowBox[{
      InterpretationBox[
       StyleBox["\[Alpha]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Alpha],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox["x",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`x[],
       Editable->False]}]}], ")"}], " ", 
   SqrtBox[
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "2"], "+", 
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], "2"], " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], "2"]}]}]], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      InterpretationBox[
       StyleBox["\[CapitalMu]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[CapitalMu],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False]}], "+", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "2"], "+", 
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], "2"], " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], "2"]}]}], ")"}]}]]], "Output",ExpressionUUID->\
"286e7b6e-d131-4064-ab18-f8167a9f21cb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NP\[Beta]", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"-", "1"}], "/", "2"}], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"n", "[", "a", "]"}], 
       RowBox[{"m", "[", "b", "]"}], 
       RowBox[{
        RowBox[{"cd", "[", 
         RowBox[{"-", "b"}], "]"}], "[", 
        RowBox[{"l", "[", 
         RowBox[{"-", "a"}], "]"}], "]"}]}], "-", 
      RowBox[{
       RowBox[{"mbar", "[", "a", "]"}], 
       RowBox[{"m", "[", "b", "]"}], 
       RowBox[{
        RowBox[{"cd", "[", 
         RowBox[{"-", "b"}], "]"}], "[", 
        RowBox[{"m", "[", 
         RowBox[{"-", "a"}], "]"}], "]"}]}]}], ")"}]}], "//", 
   "Simplify"}]}]], "Input",ExpressionUUID->"aec137b8-5444-4b29-a0ce-\
54eba613600e"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{
    RowBox[{"-", "\[ImaginaryI]"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", 
       InterpretationBox[
        StyleBox["\[CapitalMu]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[CapitalMu],
        Editable->False]}], "-", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False]}], ")"}], " ", 
    SuperscriptBox[
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], "2"], " ", 
    InterpretationBox[
     StyleBox["x",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`x[],
     Editable->False]}], "-", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["\[Alpha]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Alpha],
      Editable->False], "3"], " ", 
    SuperscriptBox[
     InterpretationBox[
      StyleBox["x",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`x[],
      Editable->False], "4"]}], "-", 
   RowBox[{
    InterpretationBox[
     StyleBox["\[Alpha]",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`\[Alpha],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox["r",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`r[],
     Editable->False], " ", 
    RowBox[{"(", 
     RowBox[{
      InterpretationBox[
       StyleBox["\[CapitalMu]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[CapitalMu],
       Editable->False], "-", 
      RowBox[{"3", " ", 
       InterpretationBox[
        StyleBox["\[CapitalMu]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[CapitalMu],
        Editable->False], " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False], "2"]}], "+", 
      RowBox[{
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False], "2"]}]}], ")"}]}], "+", 
   RowBox[{"\[ImaginaryI]", " ", 
    SuperscriptBox[
     InterpretationBox[
      StyleBox["\[Alpha]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Alpha],
      Editable->False], "2"], " ", 
    InterpretationBox[
     StyleBox["x",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`x[],
     Editable->False], " ", 
    RowBox[{"(", 
     RowBox[{
      InterpretationBox[
       StyleBox["\[CapitalMu]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[CapitalMu],
       Editable->False], "-", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[CapitalMu]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[CapitalMu],
        Editable->False], " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False], "2"]}], "+", 
      RowBox[{
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False], "2"]}]}], ")"}]}]}], 
  RowBox[{"2", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "\[ImaginaryI]"}], " ", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False]}], "+", 
     RowBox[{
      InterpretationBox[
       StyleBox["\[Alpha]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Alpha],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox["x",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`x[],
       Editable->False]}]}], ")"}], " ", 
   SqrtBox[
    RowBox[{"2", "-", 
     RowBox[{"2", " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], "2"]}]}]], " ", 
   SqrtBox[
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "2"], "+", 
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], "2"], " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], "2"]}]}]], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      InterpretationBox[
       StyleBox["\[CapitalMu]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[CapitalMu],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False]}], "+", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "2"], "+", 
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], "2"], " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], "2"]}]}], ")"}]}]]], "Output",ExpressionUUID->\
"590fc136-5a40-4c7a-a472-5bb988968e3e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NP\[Alpha]", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"-", "1"}], "/", "2"}], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"n", "[", "a", "]"}], 
       RowBox[{"mbar", "[", "b", "]"}], 
       RowBox[{
        RowBox[{"cd", "[", 
         RowBox[{"-", "b"}], "]"}], "[", 
        RowBox[{"l", "[", 
         RowBox[{"-", "a"}], "]"}], "]"}]}], "-", 
      RowBox[{
       RowBox[{"mbar", "[", "a", "]"}], 
       RowBox[{"mbar", "[", "b", "]"}], 
       RowBox[{
        RowBox[{"cd", "[", 
         RowBox[{"-", "b"}], "]"}], "[", 
        RowBox[{"m", "[", 
         RowBox[{"-", "a"}], "]"}], "]"}]}]}], ")"}]}], "//", 
   "Simplify"}]}]], "Input",ExpressionUUID->"2a0d481b-5b02-42a1-9582-\
7efea880ed4f"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"\[ImaginaryI]", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", 
       InterpretationBox[
        StyleBox["\[CapitalMu]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[CapitalMu],
        Editable->False]}], "-", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False]}], ")"}], " ", 
    SuperscriptBox[
     InterpretationBox[
      StyleBox["r",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`r[],
      Editable->False], "2"], " ", 
    InterpretationBox[
     StyleBox["x",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`x[],
     Editable->False]}], "+", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox["\[Alpha]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Alpha],
      Editable->False], "3"], " ", 
    SuperscriptBox[
     InterpretationBox[
      StyleBox["x",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`x[],
      Editable->False], "4"]}], "+", 
   RowBox[{
    InterpretationBox[
     StyleBox["\[Alpha]",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`\[Alpha],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox["r",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`r[],
     Editable->False], " ", 
    RowBox[{"(", 
     RowBox[{
      InterpretationBox[
       StyleBox["\[CapitalMu]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[CapitalMu],
       Editable->False], "-", 
      RowBox[{"3", " ", 
       InterpretationBox[
        StyleBox["\[CapitalMu]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[CapitalMu],
        Editable->False], " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False], "2"]}], "+", 
      RowBox[{
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False], "2"]}]}], ")"}]}], "-", 
   RowBox[{"\[ImaginaryI]", " ", 
    SuperscriptBox[
     InterpretationBox[
      StyleBox["\[Alpha]",
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`\[Alpha],
      Editable->False], "2"], " ", 
    InterpretationBox[
     StyleBox["x",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`x[],
     Editable->False], " ", 
    RowBox[{"(", 
     RowBox[{
      InterpretationBox[
       StyleBox["\[CapitalMu]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[CapitalMu],
       Editable->False], "-", 
      RowBox[{
       InterpretationBox[
        StyleBox["\[CapitalMu]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[CapitalMu],
        Editable->False], " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False], "2"]}], "+", 
      RowBox[{
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False], "2"]}]}], ")"}]}]}], 
  RowBox[{"2", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "\[ImaginaryI]"}], " ", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False]}], "+", 
     RowBox[{
      InterpretationBox[
       StyleBox["\[Alpha]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Alpha],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox["x",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`x[],
       Editable->False]}]}], ")"}], " ", 
   SqrtBox[
    RowBox[{"2", "-", 
     RowBox[{"2", " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], "2"]}]}]], " ", 
   SqrtBox[
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "2"], "+", 
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], "2"], " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], "2"]}]}]], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      InterpretationBox[
       StyleBox["\[CapitalMu]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[CapitalMu],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False]}], "+", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "2"], "+", 
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], "2"], " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], "2"]}]}], ")"}]}]]], "Output",ExpressionUUID->\
"99f1121a-d9c1-4f4c-b243-18479bc4be94"]
}, Open  ]],

Cell["NP propagation equations (16):", "Text",ExpressionUUID->"5d0726a5-4c5f-476d-82ee-f3a0fcac3c1a"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"NPDl", "[", "expr_", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "a", "}"}], ",", 
     RowBox[{
      RowBox[{"l", "[", "a", "]"}], 
      RowBox[{
       RowBox[{"cd", "[", 
        RowBox[{"-", "a"}], "]"}], "[", "expr", "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"NPDn", "[", "expr_", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "a", "}"}], ",", 
     RowBox[{
      RowBox[{"n", "[", "a", "]"}], 
      RowBox[{
       RowBox[{"cd", "[", 
        RowBox[{"-", "a"}], "]"}], "[", "expr", "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"NPDm", "[", "expr_", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "a", "}"}], ",", 
     RowBox[{
      RowBox[{"m", "[", "a", "]"}], 
      RowBox[{
       RowBox[{"cd", "[", 
        RowBox[{"-", "a"}], "]"}], "[", "expr", "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"NPDb", "[", "expr_", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "a", "}"}], ",", 
     RowBox[{
      RowBox[{"mbar", "[", "a", "]"}], 
      RowBox[{
       RowBox[{"cd", "[", 
        RowBox[{"-", "a"}], "]"}], "[", "expr", "]"}]}]}], "]"}]}], 
  ";"}]}], "Input",ExpressionUUID->"daeb90f3-8857-43f0-96d7-98f82e5eda3c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPDl", "[", 
    RowBox[{"l", "[", "a", "]"}], "]"}], "\[Equal]", 
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      RowBox[{"(", 
       RowBox[{"NP\[Epsilon]", "+", 
        RowBox[{"Dagger", "[", "NP\[Epsilon]", "]"}]}], ")"}]}], 
     RowBox[{"l", "[", "a", "]"}]}], "+", " ", 
    RowBox[{
     RowBox[{"Dagger", "[", "NP\[Kappa]", "]"}], 
     RowBox[{"m", "[", "a", "]"}]}], "+", " ", 
    RowBox[{"NP\[Kappa]", " ", 
     RowBox[{"mbar", "[", "a", "]"}]}]}]}], "//", "Simplify"}]], "Input",Expre\
ssionUUID->"83117622-98a3-448f-aae9-dcea6fe17667"],

Cell[BoxData["True"], "Output",ExpressionUUID->"533e86a1-19be-4dc3-a41a-89a1427af52c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPDn", "[", 
    RowBox[{"l", "[", "a", "]"}], "]"}], "\[Equal]", 
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      RowBox[{"(", 
       RowBox[{"NP\[Gamma]", "+", 
        RowBox[{"Dagger", "[", "NP\[Gamma]", "]"}]}], ")"}]}], 
     RowBox[{"l", "[", "a", "]"}]}], "+", " ", 
    RowBox[{
     RowBox[{"Dagger", "[", "NP\[Tau]", "]"}], 
     RowBox[{"m", "[", "a", "]"}]}], "+", " ", 
    RowBox[{"NP\[Tau]", " ", 
     RowBox[{"mbar", "[", "a", "]"}]}]}]}], "//", "Simplify"}]], "Input",Expre\
ssionUUID->"aa48a8d4-36b8-47c2-af4d-faf31e74b7fe"],

Cell[BoxData["True"], "Output",ExpressionUUID->"2eb13621-4651-4d2f-8137-22912c2bdfc9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPDm", "[", 
    RowBox[{"l", "[", "a", "]"}], "]"}], "\[Equal]", 
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      RowBox[{"(", 
       RowBox[{"NP\[Beta]", "+", 
        RowBox[{"Dagger", "[", "NP\[Alpha]", "]"}]}], ")"}]}], 
     RowBox[{"l", "[", "a", "]"}]}], "+", " ", 
    RowBox[{
     RowBox[{"Dagger", "[", "NP\[Rho]", "]"}], 
     RowBox[{"m", "[", "a", "]"}]}], "+", " ", 
    RowBox[{"NP\[Sigma]", " ", 
     RowBox[{"mbar", "[", "a", "]"}]}]}]}], "//", "Simplify"}]], "Input",Expre\
ssionUUID->"7a26a0a3-1a07-4381-b091-02a4bffc6fe4"],

Cell[BoxData["True"], "Output",ExpressionUUID->"271aa7df-4b02-4935-82aa-a9b4aa879890"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPDb", "[", 
    RowBox[{"l", "[", "a", "]"}], "]"}], "\[Equal]", 
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      RowBox[{"(", 
       RowBox[{"NP\[Alpha]", "+", 
        RowBox[{"Dagger", "[", "NP\[Beta]", "]"}]}], ")"}]}], 
     RowBox[{"l", "[", "a", "]"}]}], "+", " ", 
    RowBox[{
     RowBox[{"Dagger", "[", "NP\[Sigma]", "]"}], 
     RowBox[{"m", "[", "a", "]"}]}], "+", " ", 
    RowBox[{"NP\[Rho]", " ", 
     RowBox[{"mbar", "[", "a", "]"}]}]}]}], "//", "Simplify"}]], "Input",Expre\
ssionUUID->"f8f5cdf4-fabe-4572-86e2-f7f606a1c8c4"],

Cell[BoxData["True"], "Output",ExpressionUUID->"7770d626-44a5-4d56-a100-0b75519185e6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPDl", "[", 
    RowBox[{"n", "[", "a", "]"}], "]"}], "\[Equal]", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"NP\[Epsilon]", "+", 
       RowBox[{"Dagger", "[", "NP\[Epsilon]", "]"}]}], ")"}], 
     RowBox[{"n", "[", "a", "]"}]}], "+", 
    RowBox[{"NP\[Pi]", " ", 
     RowBox[{"m", "[", "a", "]"}]}], "+", 
    RowBox[{
     RowBox[{"Dagger", "[", "NP\[Pi]", "]"}], " ", 
     RowBox[{"mbar", "[", "a", "]"}]}]}]}], "//", "Simplify"}]], "Input",Expre\
ssionUUID->"f36bbac0-2034-4cf1-9cf1-03927c1243d9"],

Cell[BoxData["True"], "Output",ExpressionUUID->"560eeae2-47d3-42fd-a07a-626095644dfc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPDn", "[", 
    RowBox[{"n", "[", "a", "]"}], "]"}], "\[Equal]", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"NP\[Gamma]", "+", 
       RowBox[{"Dagger", "[", "NP\[Gamma]", "]"}]}], ")"}], 
     RowBox[{"n", "[", "a", "]"}]}], "+", " ", 
    RowBox[{"NP\[Nu]", " ", 
     RowBox[{"m", "[", "a", "]"}]}], "+", 
    RowBox[{
     RowBox[{"Dagger", "[", "NP\[Nu]", "]"}], " ", 
     RowBox[{"mbar", "[", "a", "]"}]}]}]}], "//", "Simplify"}]], "Input",Expre\
ssionUUID->"1bacb82d-4073-4a8c-b839-b45757c85f59"],

Cell[BoxData["True"], "Output",ExpressionUUID->"0386cdc2-c8f7-4df7-afbf-0dcc5e8b281d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPDm", "[", 
    RowBox[{"n", "[", "a", "]"}], "]"}], "\[Equal]", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"NP\[Beta]", "+", 
       RowBox[{"Dagger", "[", "NP\[Alpha]", "]"}]}], ")"}], 
     RowBox[{"n", "[", "a", "]"}]}], "+", 
    RowBox[{"NP\[Mu]", " ", 
     RowBox[{"m", "[", "a", "]"}]}], "+", 
    RowBox[{
     RowBox[{"Dagger", "[", "NP\[Lambda]", "]"}], " ", 
     RowBox[{"mbar", "[", "a", "]"}]}]}]}], "//", "Simplify"}]], "Input",Expre\
ssionUUID->"dac06bc2-1270-439e-a680-4f49c8a98d06"],

Cell[BoxData["True"], "Output",ExpressionUUID->"38a3daec-f32f-45fe-9bbb-92cde6ba1db9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPDb", "[", 
    RowBox[{"n", "[", "a", "]"}], "]"}], "\[Equal]", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"NP\[Alpha]", "+", 
       RowBox[{"Dagger", "[", "NP\[Beta]", "]"}]}], ")"}], 
     RowBox[{"n", "[", "a", "]"}]}], "+", " ", 
    RowBox[{"NP\[Lambda]", " ", 
     RowBox[{"m", "[", "a", "]"}]}], "+", 
    RowBox[{
     RowBox[{"Dagger", "[", "NP\[Mu]", "]"}], " ", 
     RowBox[{"mbar", "[", "a", "]"}]}]}]}], "//", "Simplify"}]], "Input",Expre\
ssionUUID->"abc71972-f4fe-415a-8611-9bf6619f47c0"],

Cell[BoxData["True"], "Output",ExpressionUUID->"135cbdc7-a50d-435c-a49a-364289d492ac"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPDl", "[", 
    RowBox[{"m", "[", "a", "]"}], "]"}], "\[Equal]", 
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      RowBox[{"(", 
       RowBox[{"NP\[Epsilon]", "-", 
        RowBox[{"Dagger", "[", "NP\[Epsilon]", "]"}]}], ")"}]}], 
     RowBox[{"m", "[", "a", "]"}]}], "+", 
    RowBox[{
     RowBox[{"Dagger", "[", "NP\[Pi]", "]"}], " ", 
     RowBox[{"l", "[", "a", "]"}]}], "+", 
    RowBox[{"NP\[Kappa]", " ", 
     RowBox[{"n", "[", "a", "]"}]}]}]}], "//", "Simplify"}]], "Input",Expressi\
onUUID->"b9bbd701-107f-4fb5-a37c-7d60757ed45b"],

Cell[BoxData["True"], "Output",ExpressionUUID->"86b7f01a-215d-4698-855b-754fbb13e48f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPDn", "[", 
    RowBox[{"m", "[", "a", "]"}], "]"}], "\[Equal]", 
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      RowBox[{"(", 
       RowBox[{"NP\[Gamma]", "-", 
        RowBox[{"Dagger", "[", "NP\[Gamma]", "]"}]}], ")"}]}], 
     RowBox[{"m", "[", "a", "]"}]}], "+", 
    RowBox[{
     RowBox[{"Dagger", "[", "NP\[Nu]", "]"}], " ", 
     RowBox[{"l", "[", "a", "]"}]}], "+", 
    RowBox[{"NP\[Tau]", " ", 
     RowBox[{"n", "[", "a", "]"}]}]}]}], "//", "Simplify"}]], "Input",Expressi\
onUUID->"72435a32-0885-4880-88ad-3768c2672336"],

Cell[BoxData["True"], "Output",ExpressionUUID->"7b25dda7-ca97-4702-8404-f6ff06873cc0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPDm", "[", 
    RowBox[{"m", "[", "a", "]"}], "]"}], "\[Equal]", 
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      RowBox[{"(", 
       RowBox[{"NP\[Beta]", "-", 
        RowBox[{"Dagger", "[", "NP\[Alpha]", "]"}]}], ")"}]}], 
     RowBox[{"m", "[", "a", "]"}]}], "+", 
    RowBox[{
     RowBox[{"Dagger", "[", "NP\[Lambda]", "]"}], 
     RowBox[{"l", "[", "a", "]"}]}], "+", 
    RowBox[{"NP\[Sigma]", " ", 
     RowBox[{"n", "[", "a", "]"}]}]}]}], "//", "Simplify"}]], "Input",Expressi\
onUUID->"d4fde197-258d-467a-a369-589e7bb3ecc0"],

Cell[BoxData["True"], "Output",ExpressionUUID->"3d8a9fed-917f-4f52-8e07-a85035d5f48e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPDb", "[", 
    RowBox[{"m", "[", "a", "]"}], "]"}], "\[Equal]", 
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      RowBox[{"(", 
       RowBox[{"NP\[Alpha]", "-", 
        RowBox[{"Dagger", "[", "NP\[Beta]", "]"}]}], ")"}]}], 
     RowBox[{"m", "[", "a", "]"}]}], "+", " ", 
    RowBox[{
     RowBox[{"Dagger", "[", "NP\[Mu]", "]"}], " ", 
     RowBox[{"l", "[", "a", "]"}]}], "+", 
    RowBox[{"NP\[Rho]", " ", 
     RowBox[{"n", "[", "a", "]"}]}]}]}], "//", "Simplify"}]], "Input",Expressi\
onUUID->"577bdc3a-b265-4d98-9f72-80d4da67a64b"],

Cell[BoxData["True"], "Output",ExpressionUUID->"5eba5731-4d86-4fe6-9c4d-4469e0ca653d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPDl", "[", 
    RowBox[{"mbar", "[", "a", "]"}], "]"}], "\[Equal]", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"NP\[Epsilon]", "-", 
       RowBox[{"Dagger", "[", "NP\[Epsilon]", "]"}]}], ")"}], 
     RowBox[{"mbar", "[", "a", "]"}]}], "+", 
    RowBox[{"NP\[Pi]", " ", 
     RowBox[{"l", "[", "a", "]"}]}], "+", 
    RowBox[{
     RowBox[{"Dagger", "[", "NP\[Kappa]", "]"}], " ", 
     RowBox[{"n", "[", "a", "]"}]}]}]}], "//", "Simplify"}]], "Input",Expressi\
onUUID->"8d4b4712-a2c9-458b-ba3a-8dfc4066db98"],

Cell[BoxData["True"], "Output",ExpressionUUID->"8f05d7f3-ec1e-4935-9385-d6aeb57df3bd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPDn", "[", 
    RowBox[{"mbar", "[", "a", "]"}], "]"}], "\[Equal]", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"NP\[Gamma]", "-", 
       RowBox[{"Dagger", "[", "NP\[Gamma]", "]"}]}], ")"}], 
     RowBox[{"mbar", "[", "a", "]"}]}], "+", 
    RowBox[{"NP\[Nu]", " ", 
     RowBox[{"l", "[", "a", "]"}]}], "+", 
    RowBox[{
     RowBox[{"Dagger", "[", "NP\[Tau]", "]"}], " ", 
     RowBox[{"n", "[", "a", "]"}]}]}]}], "//", "Simplify"}]], "Input",Expressi\
onUUID->"b820811d-994f-4f1c-b02c-c363f6193102"],

Cell[BoxData["True"], "Output",ExpressionUUID->"446b8787-d1a5-4683-a4f4-8efa58630f98"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPDm", "[", 
    RowBox[{"mbar", "[", "a", "]"}], "]"}], "\[Equal]", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"NP\[Beta]", "-", 
       RowBox[{"Dagger", "[", "NP\[Alpha]", "]"}]}], ")"}], 
     RowBox[{"mbar", "[", "a", "]"}]}], "+", 
    RowBox[{"NP\[Mu]", " ", 
     RowBox[{"l", "[", "a", "]"}]}], "+", 
    RowBox[{
     RowBox[{"Dagger", "[", "NP\[Rho]", "]"}], " ", 
     RowBox[{"n", "[", "a", "]"}]}]}]}], "//", "Simplify"}]], "Input",Expressi\
onUUID->"777367fc-86c3-4114-b99a-d2cb46e26cad"],

Cell[BoxData["True"], "Output",ExpressionUUID->"739588ef-bb9b-4897-97bc-9f8557877b20"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPDb", "[", 
    RowBox[{"mbar", "[", "a", "]"}], "]"}], "\[Equal]", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"NP\[Alpha]", "-", 
       RowBox[{"Dagger", "[", "NP\[Beta]", "]"}]}], ")"}], 
     RowBox[{"mbar", "[", "a", "]"}]}], "+", 
    RowBox[{"NP\[Lambda]", " ", 
     RowBox[{"l", "[", "a", "]"}]}], "+", 
    RowBox[{
     RowBox[{"Dagger", "[", "NP\[Sigma]", "]"}], " ", 
     RowBox[{"n", "[", "a", "]"}]}]}]}], "//", "Simplify"}]], "Input",Expressi\
onUUID->"665cb4d4-770f-4392-9af9-f0a146c915d1"],

Cell[BoxData["True"], "Output",ExpressionUUID->"397b659a-4633-4b3c-b5f2-34b2a2bdc554"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"weyl", "=", 
   RowBox[{"Weyl", "[", "cd", "]"}]}], ";"}]], "Input",ExpressionUUID->\
"032e8499-7733-450f-acf3-7ef21fb35f40"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$LargeComponentSize", "=", "1000"}], ";"}]], "Input",ExpressionUUID\
->"34540822-e42b-4a2b-9ac9-235b5ae63cc5"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"weyl", "[", 
  RowBox[{
   RowBox[{"-", "a"}], ",", 
   RowBox[{"-", "b"}], ",", 
   RowBox[{"-", "c"}], ",", 
   RowBox[{"-", "d"}]}], "]"}]], "Input",ExpressionUUID->"24adc5b5-47fb-46ab-\
99d7-339007d4e3b0"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 1, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 2, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 2, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 3, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 3, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 3, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 4, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 4, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 4, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "1", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 1, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}], "+", 
                    RowBox[{"3", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}]}], 
                    ")"}]}], 
                  RowBox[{
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], ")"}], 
                    "3"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {1, 2, 1, 
                2} -> $CellContext`\[CapitalMu] $CellContext`r[] \
($CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (-$CellContext`r[]^2 + 
                 3 $CellContext`\[Alpha]^2 $CellContext`x[]^2) (
                 2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) \
$CellContext`r[] + $CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", "\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "+", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              Annotation[#, {1, 2, 1, 3} -> Complex[0, 
                  Rational[
                  3, 2]] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] ($CellContext`r[] + 
                  Complex[0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (
                  1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {1, 2, 1, 4} -> 
               Rational[-3, 
                  2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, 1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}], "+", 
                    RowBox[{"3", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], ")"}], 
                    "3"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {1, 2, 2, 
                1} -> -$CellContext`\[CapitalMu] $CellContext`r[] \
($CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (-$CellContext`r[]^2 + 
                 3 $CellContext`\[Alpha]^2 $CellContext`x[]^2) (
                 2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) \
$CellContext`r[] + $CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {1, 2, 2, 3} -> 
               Rational[-3, 
                  2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, 1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", "\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "+", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              Annotation[#, {1, 2, 2, 4} -> Complex[0, 
                  Rational[
                  3, 2]] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] ($CellContext`r[] + 
                  Complex[0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (
                  1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", "\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "+", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              Annotation[#, {1, 2, 3, 1} -> Complex[0, 
                  
                  Rational[-3, 
                   2]] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] ($CellContext`r[] + 
                  Complex[0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (
                  1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {1, 2, 3, 2} -> 
               Rational[
                 3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, 1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "3"}], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}]}], 
                    ")"}]}], 
                  RowBox[{
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], ")"}], 
                    "3"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {1, 2, 3, 4} -> 
               Complex[
                 0, 1] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
$CellContext`x[] ((-3) $CellContext`r[]^2 + $CellContext`\[Alpha]^2 \
$CellContext`x[]^2) ($CellContext`r[]^2 + $CellContext`\[Alpha]^2 \
$CellContext`x[]^2)^(-3) ((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
                 2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) \
$CellContext`r[] + $CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {1, 2, 4, 1} -> 
               Rational[
                 3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, 1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", "\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "+", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              Annotation[#, {1, 2, 4, 2} -> Complex[0, 
                  
                  Rational[-3, 
                   2]] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] ($CellContext`r[] + 
                  Complex[0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (
                  1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "3"}], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], ")"}], 
                    "3"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {1, 2, 4, 3} -> 
               Complex[
                 0, -1] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
$CellContext`x[] ((-3) $CellContext`r[]^2 + $CellContext`\[Alpha]^2 \
$CellContext`x[]^2) ($CellContext`r[]^2 + $CellContext`\[Alpha]^2 \
$CellContext`x[]^2)^(-3) ((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
                 2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) \
$CellContext`r[] + $CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "2", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 2, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", "\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "+", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              Annotation[#, {1, 3, 1, 2} -> Complex[0, 
                  Rational[
                  3, 2]] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] ($CellContext`r[] + 
                  Complex[0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (
                  1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "+", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {1, 3, 1, 3} -> 
               Rational[
                 3, 2] $CellContext`\[Alpha]^2 $CellContext`\[CapitalMu] \
($CellContext`r[] + 
                  Complex[
                    0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (-1 + \
$CellContext`x[]^2)/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 1, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", "\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "+", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              Annotation[#, {1, 3, 2, 1} -> Complex[0, 
                  
                  Rational[-3, 
                   2]] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] ($CellContext`r[] + 
                  Complex[0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (
                  1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 2, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}]}], 
                    ")"}]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "+", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {1, 3, 2, 4} -> 
               Rational[
                 1, 2] $CellContext`\[CapitalMu] ($CellContext`r[] + 
                  Complex[
                    0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
                 2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) \
$CellContext`r[] + $CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "+", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {1, 3, 3, 1} -> 
               Rational[-3, 
                  2] $CellContext`\[Alpha]^2 $CellContext`\[CapitalMu] \
($CellContext`r[] + 
                  Complex[
                    0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (-1 + \
$CellContext`x[]^2)/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 3, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "\[ImaginaryI]"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {1, 3, 3, 4} -> 
               Rational[
                 3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, -1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 4, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}]}], 
                    ")"}]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "+", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {1, 3, 4, 2} -> 
               Rational[-1, 2] $CellContext`\[CapitalMu] ($CellContext`r[] + 
                  Complex[
                    0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
                 2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) \
$CellContext`r[] + $CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "\[ImaginaryI]"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {1, 3, 4, 3} -> 
               Rational[-3, 
                  2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, -1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 3, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {1, 4, 1, 2} -> 
               Rational[-3, 
                  2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, 1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 1, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "-", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {1, 4, 1, 4} -> 
               Rational[
                 3, 2] $CellContext`\[Alpha]^2 $CellContext`\[CapitalMu] \
($CellContext`r[] + 
                  Complex[
                    0, -1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (-1 + \
$CellContext`x[]^2)/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox["r", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              Annotation[#, {1, 4, 2, 1} -> 
               Rational[
                 3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, 1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}]}], 
                    ")"}]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "-", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {1, 4, 2, 3} -> 
               Rational[
                 1, 2] $CellContext`\[CapitalMu] ($CellContext`r[] + 
                  Complex[
                    0, -1] $CellContext`\[Alpha] $CellContext`x[])^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
                 2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) \
$CellContext`r[] + $CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 2, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 3, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}]}], 
                    ")"}]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "-", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {1, 4, 3, 2} -> 
               Rational[-1, 2] $CellContext`\[CapitalMu] ($CellContext`r[] + 
                  Complex[
                    0, -1] $CellContext`\[Alpha] $CellContext`x[])^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
                 2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) \
$CellContext`r[] + $CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {1, 4, 3, 4} -> 
               Rational[-3, 
                  2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, 1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "-", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {1, 4, 4, 1} -> 
               Rational[-3, 
                  2] $CellContext`\[Alpha]^2 $CellContext`\[CapitalMu] \
($CellContext`r[] + 
                  Complex[
                    0, -1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (-1 + \
$CellContext`x[]^2)/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 4, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {1, 4, 4, 3} -> 
               Rational[
                 3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, 1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"1", ",", "4", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {1, 4, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}}]},
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}], "+", 
                    RowBox[{"3", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], ")"}], 
                    "3"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {2, 1, 1, 
                2} -> -$CellContext`\[CapitalMu] $CellContext`r[] \
($CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (-$CellContext`r[]^2 + 
                 3 $CellContext`\[Alpha]^2 $CellContext`x[]^2) (
                 2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) \
$CellContext`r[] + $CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", "\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "+", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              Annotation[#, {2, 1, 1, 3} -> Complex[0, 
                  
                  Rational[-3, 
                   2]] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] ($CellContext`r[] + 
                  Complex[0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (
                  1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {2, 1, 1, 4} -> 
               Rational[
                 3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, 1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}], "+", 
                    RowBox[{"3", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}]}], 
                    ")"}]}], 
                  RowBox[{
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], ")"}], 
                    "3"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {2, 1, 2, 
                1} -> $CellContext`\[CapitalMu] $CellContext`r[] \
($CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (-$CellContext`r[]^2 + 
                 3 $CellContext`\[Alpha]^2 $CellContext`x[]^2) (
                 2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) \
$CellContext`r[] + $CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {2, 1, 2, 3} -> 
               Rational[
                 3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, 1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", "\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "+", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              Annotation[#, {2, 1, 2, 4} -> Complex[0, 
                  
                  Rational[-3, 
                   2]] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] ($CellContext`r[] + 
                  Complex[0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (
                  1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", "\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "+", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              Annotation[#, {2, 1, 3, 1} -> Complex[0, 
                  Rational[
                  3, 2]] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] ($CellContext`r[] + 
                  Complex[0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (
                  1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {2, 1, 3, 2} -> 
               Rational[-3, 
                  2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, 1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "3"}], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], ")"}], 
                    "3"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {2, 1, 3, 4} -> 
               Complex[
                 0, -1] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
$CellContext`x[] ((-3) $CellContext`r[]^2 + $CellContext`\[Alpha]^2 \
$CellContext`x[]^2) ($CellContext`r[]^2 + $CellContext`\[Alpha]^2 \
$CellContext`x[]^2)^(-3) ((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
                 2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) \
$CellContext`r[] + $CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {2, 1, 4, 1} -> 
               Rational[-3, 
                  2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, 1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", "\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "+", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              Annotation[#, {2, 1, 4, 2} -> Complex[0, 
                  Rational[
                  3, 2]] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] ($CellContext`r[] + 
                  Complex[0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (
                  1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "3"}], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}]}], 
                    ")"}]}], 
                  RowBox[{
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], ")"}], 
                    "3"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {2, 1, 4, 3} -> 
               Complex[
                 0, 1] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
$CellContext`x[] ((-3) $CellContext`r[]^2 + $CellContext`\[Alpha]^2 \
$CellContext`x[]^2) ($CellContext`r[]^2 + $CellContext`\[Alpha]^2 \
$CellContext`x[]^2)^(-3) ((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
                 2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) \
$CellContext`r[] + $CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "1", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 1, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 1, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 1, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 1, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 2, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 2, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 3, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 3, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 3, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 4, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 4, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 4, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "2", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 2, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox["r", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {2, 3, 1, 2} -> 
               Rational[-3, 
                  2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, 1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 1, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}]}], 
                    ")"}]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "-", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {2, 3, 1, 4} -> 
               Rational[
                 1, 2] $CellContext`\[CapitalMu] ($CellContext`r[] + 
                  Complex[
                    0, -1] $CellContext`\[Alpha] $CellContext`x[])^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
                 2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) \
$CellContext`r[] + $CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {2, 3, 2, 1} -> 
               Rational[
                 3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, 1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "-", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {2, 3, 2, 3} -> 
               Rational[
                 3, 2] $CellContext`\[Alpha]^2 $CellContext`\[CapitalMu] \
($CellContext`r[] + 
                  Complex[
                    0, -1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (-1 + \
$CellContext`x[]^2)/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 2, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 3, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "-", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {2, 3, 3, 2} -> 
               Rational[-3, 
                  2] $CellContext`\[Alpha]^2 $CellContext`\[CapitalMu] \
($CellContext`r[] + 
                  Complex[
                    0, -1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (-1 + \
$CellContext`x[]^2)/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {2, 3, 3, 4} -> 
               Rational[-3, 
                  2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, 1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}]}], 
                    ")"}]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "-", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {2, 3, 4, 1} -> 
               Rational[-1, 2] $CellContext`\[CapitalMu] ($CellContext`r[] + 
                  Complex[
                    0, -1] $CellContext`\[Alpha] $CellContext`x[])^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
                 2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) \
$CellContext`r[] + $CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 4, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {2, 3, 4, 3} -> 
               Rational[
                 3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, 1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "3", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 3, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", "\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "+", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              Annotation[#, {2, 4, 1, 2} -> Complex[0, 
                  Rational[
                  3, 2]] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] ($CellContext`r[] + 
                  Complex[0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (
                  1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}]}], 
                    ")"}]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "+", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {2, 4, 1, 3} -> 
               Rational[
                 1, 2] $CellContext`\[CapitalMu] ($CellContext`r[] + 
                  Complex[
                    0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
                 2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) \
$CellContext`r[] + $CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 1, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", "\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "+", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              Annotation[#, {2, 4, 2, 1} -> Complex[0, 
                  
                  Rational[-3, 
                   2]] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] ($CellContext`r[] + 
                  Complex[0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (
                  1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 2, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "+", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {2, 4, 2, 4} -> 
               Rational[
                 3, 2] $CellContext`\[Alpha]^2 $CellContext`\[CapitalMu] \
($CellContext`r[] + 
                  Complex[
                    0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (-1 + \
$CellContext`x[]^2)/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox["r", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}]}], 
                    ")"}]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "+", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {2, 4, 3, 1} -> 
               Rational[-1, 2] $CellContext`\[CapitalMu] ($CellContext`r[] + 
                  Complex[
                    0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
                 2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) \
$CellContext`r[] + $CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 3, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox["r", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "\[ImaginaryI]"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {2, 4, 3, 4} -> 
               Rational[
                 3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, -1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 4, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "+", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox["r", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {2, 4, 4, 2} -> 
               Rational[-3, 
                  2] $CellContext`\[Alpha]^2 $CellContext`\[CapitalMu] \
($CellContext`r[] + 
                  Complex[
                    0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (-1 + \
$CellContext`x[]^2)/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "\[ImaginaryI]"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {2, 4, 4, 3} -> 
               Rational[-3, 
                  2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, -1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"2", ",", "4", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {2, 4, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}}]},
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", "\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "+", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              Annotation[#, {3, 1, 1, 2} -> Complex[0, 
                  
                  Rational[-3, 
                   2]] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] ($CellContext`r[] + 
                  Complex[0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (
                  1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "+", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {3, 1, 1, 3} -> 
               Rational[-3, 
                  2] $CellContext`\[Alpha]^2 $CellContext`\[CapitalMu] \
($CellContext`r[] + 
                  Complex[
                    0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (-1 + \
$CellContext`x[]^2)/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 1, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", "\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "+", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              Annotation[#, {3, 1, 2, 1} -> Complex[0, 
                  Rational[
                  3, 2]] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] ($CellContext`r[] + 
                  Complex[0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (
                  1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 2, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}]}], 
                    ")"}]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "+", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {3, 1, 2, 4} -> 
               Rational[-1, 2] $CellContext`\[CapitalMu] ($CellContext`r[] + 
                  Complex[
                    0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
                 2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) \
$CellContext`r[] + $CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "+", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {3, 1, 3, 1} -> 
               Rational[
                 3, 2] $CellContext`\[Alpha]^2 $CellContext`\[CapitalMu] \
($CellContext`r[] + 
                  Complex[
                    0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (-1 + \
$CellContext`x[]^2)/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 3, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "\[ImaginaryI]"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {3, 1, 3, 4} -> 
               Rational[-3, 
                  2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, -1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 4, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}]}], 
                    ")"}]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "+", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {3, 1, 4, 2} -> 
               Rational[
                 1, 2] $CellContext`\[CapitalMu] ($CellContext`r[] + 
                  Complex[
                    0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
                 2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) \
$CellContext`r[] + $CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "\[ImaginaryI]"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {3, 1, 4, 3} -> 
               Rational[
                 3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, -1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 1, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {3, 2, 1, 2} -> 
               Rational[
                 3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, 1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 1, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}]}], 
                    ")"}]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "-", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {3, 2, 1, 4} -> 
               Rational[-1, 2] $CellContext`\[CapitalMu] ($CellContext`r[] + 
                  Complex[
                    0, -1] $CellContext`\[Alpha] $CellContext`x[])^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
                 2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) \
$CellContext`r[] + $CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {3, 2, 2, 1} -> 
               Rational[-3, 
                  2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, 1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "-", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {3, 2, 2, 3} -> 
               Rational[-3, 
                  2] $CellContext`\[Alpha]^2 $CellContext`\[CapitalMu] \
($CellContext`r[] + 
                  Complex[
                    0, -1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (-1 + \
$CellContext`x[]^2)/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 2, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 3, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "-", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {3, 2, 3, 2} -> 
               Rational[
                 3, 2] $CellContext`\[Alpha]^2 $CellContext`\[CapitalMu] \
($CellContext`r[] + Complex[
                    0, -1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (-1 + \
$CellContext`x[]^2)/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {3, 2, 3, 4} -> 
               Rational[
                 3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, 1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}]}], 
                    ")"}]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "-", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {3, 2, 4, 1} -> 
               Rational[
                 1, 2] $CellContext`\[CapitalMu] ($CellContext`r[] + 
                  Complex[
                    0, -1] $CellContext`\[Alpha] $CellContext`x[])^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
                 2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) \
$CellContext`r[] + $CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 4, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox["r", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {3, 2, 4, 3} -> 
               Rational[-3, 
                  2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, 1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "2", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 2, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 1, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 1, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 1, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 2, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 2, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 3, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 3, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 3, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 4, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 4, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 4, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "3", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 3, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 4, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "3"}], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}]}], 
                    ")"}]}], 
                  RowBox[{
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], ")"}], 
                    "3"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {3, 4, 1, 2} -> 
               Complex[
                 0, 1] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
$CellContext`x[] ((-3) $CellContext`r[]^2 + $CellContext`\[Alpha]^2 \
$CellContext`x[]^2) ($CellContext`r[]^2 + $CellContext`\[Alpha]^2 \
$CellContext`x[]^2)^(-3) ((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
                 2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) \
$CellContext`r[] + $CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "\[ImaginaryI]"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {3, 4, 1, 3} -> 
               Rational[
                 3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, -1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {3, 4, 1, 4} -> 
               Rational[-3, 
                  2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, 1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "3"}], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], ")"}], 
                    "3"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {3, 4, 2, 1} -> 
               Complex[
                 0, -1] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
$CellContext`x[] ((-3) $CellContext`r[]^2 + $CellContext`\[Alpha]^2 \
$CellContext`x[]^2) ($CellContext`r[]^2 + $CellContext`\[Alpha]^2 \
$CellContext`x[]^2)^(-3) ((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
                 2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) \
$CellContext`r[] + $CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 4, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {3, 4, 2, 3} -> 
               Rational[-3, 
                  2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, 1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "\[ImaginaryI]"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {3, 4, 2, 4} -> 
               Rational[
                 3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, -1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "\[ImaginaryI]"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {3, 4, 3, 1} -> 
               Rational[-3, 
                  2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, -1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {3, 4, 3, 2} -> 
               Rational[
                 3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, 1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 4, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}], "+", 
                    RowBox[{"3", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}]}], 
                    ")"}]}], 
                  RowBox[{
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], ")"}], 
                    "3"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {3, 4, 3, 
                4} -> $CellContext`\[CapitalMu] $CellContext`r[] \
($CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (-$CellContext`r[]^2 + 
                 3 $CellContext`\[Alpha]^2 $CellContext`x[]^2) (
                 2 (
                   2 $CellContext`\[CapitalMu] - $CellContext`r[]) \
$CellContext`r[] + $CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {3, 4, 4, 1} -> 
               Rational[
                 3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, 1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "\[ImaginaryI]"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {3, 4, 4, 2} -> 
               Rational[-3, 
                  2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, -1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}], "+", 
                    RowBox[{"3", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], ")"}], 
                    "3"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {3, 4, 4, 
                3} -> -$CellContext`\[CapitalMu] $CellContext`r[] \
($CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (-$CellContext`r[]^2 + 
                 3 $CellContext`\[Alpha]^2 $CellContext`x[]^2) (
                 2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) \
$CellContext`r[] + $CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"3", ",", "4", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {3, 4, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}}]},
         {GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {4, 1, 1, 2} -> 
               Rational[
                 3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, 1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 1, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "-", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {4, 1, 1, 4} -> 
               Rational[-3, 
                  2] $CellContext`\[Alpha]^2 $CellContext`\[CapitalMu] \
($CellContext`r[] + 
                  Complex[
                    0, -1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (-1 + \
$CellContext`x[]^2)/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {4, 1, 2, 1} -> 
               Rational[-3, 
                  2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, 1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}]}], 
                    ")"}]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "-", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {4, 1, 2, 3} -> 
               Rational[-1, 2] $CellContext`\[CapitalMu] ($CellContext`r[] + 
                  Complex[
                    0, -1] $CellContext`\[Alpha] $CellContext`x[])^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
                 2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) \
$CellContext`r[] + $CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 2, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 3, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}]}], 
                    ")"}]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "-", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {4, 1, 3, 2} -> 
               Rational[
                 1, 2] $CellContext`\[CapitalMu] ($CellContext`r[] + 
                  Complex[
                    0, -1] $CellContext`\[Alpha] $CellContext`x[])^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
                 2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) \
$CellContext`r[] + $CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {4, 1, 3, 4} -> 
               Rational[
                 3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, 1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "-", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {4, 1, 4, 1} -> 
               Rational[
                 3, 2] $CellContext`\[Alpha]^2 $CellContext`\[CapitalMu] \
($CellContext`r[] + Complex[
                    0, -1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (-1 + \
$CellContext`x[]^2)/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 4, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {4, 1, 4, 3} -> 
               Rational[-3, 
                  2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, 1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "1", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 1, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 2, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", "\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "+", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              Annotation[#, {4, 2, 1, 2} -> Complex[0, 
                  
                  Rational[-3, 
                   2]] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] ($CellContext`r[] + 
                  Complex[0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (
                  1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}]}], 
                    ")"}]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "+", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {4, 2, 1, 3} -> 
               Rational[-1, 2] $CellContext`\[CapitalMu] ($CellContext`r[] + 
                  Complex[
                    0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
                 2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) \
$CellContext`r[] + $CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 2, 1, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", "\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "+", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              Annotation[#, {4, 2, 2, 1} -> Complex[0, 
                  Rational[
                  3, 2]] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] ($CellContext`r[] + 
                  Complex[0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (
                  1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 2, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 2, 2, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "+", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {4, 2, 2, 4} -> 
               Rational[-3, 
                  2] $CellContext`\[Alpha]^2 $CellContext`\[CapitalMu] \
($CellContext`r[] + 
                  Complex[
                    0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (-1 + \
$CellContext`x[]^2)/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}]}], 
                    ")"}]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "+", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {4, 2, 3, 1} -> 
               Rational[
                 1, 2] $CellContext`\[CapitalMu] ($CellContext`r[] + 
                  Complex[
                    0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
                 2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) \
$CellContext`r[] + $CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 2, 3, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 2, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "\[ImaginaryI]"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox["x", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {4, 2, 3, 4} -> 
               Rational[-3, 
                  2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, -1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 2, 4, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "+", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {4, 2, 4, 2} -> 
               Rational[
                 3, 2] $CellContext`\[Alpha]^2 $CellContext`\[CapitalMu] \
($CellContext`r[] + 
                  Complex[
                    0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (-1 + \
$CellContext`x[]^2)/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "\[ImaginaryI]"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {4, 2, 4, 3} -> 
               Rational[
                 3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, -1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "2", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 2, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 3, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "3"}], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], ")"}], 
                    "3"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {4, 3, 1, 2} -> 
               Complex[
                 0, -1] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
$CellContext`x[] ((-3) $CellContext`r[]^2 + $CellContext`\[Alpha]^2 \
$CellContext`x[]^2) ($CellContext`r[]^2 + $CellContext`\[Alpha]^2 \
$CellContext`x[]^2)^(-3) ((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
                 2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) \
$CellContext`r[] + $CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox["r", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "\[ImaginaryI]"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {4, 3, 1, 3} -> 
               Rational[-3, 
                  2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, -1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {4, 3, 1, 4} -> 
               Rational[
                 3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, 1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "3"}], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}]}], 
                    ")"}]}], 
                  RowBox[{
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], ")"}], 
                    "3"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {4, 3, 2, 1} -> 
               Complex[
                 0, 1] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
$CellContext`x[] ((-3) $CellContext`r[]^2 + $CellContext`\[Alpha]^2 \
$CellContext`x[]^2) ($CellContext`r[]^2 + $CellContext`\[Alpha]^2 \
$CellContext`x[]^2)^(-3) ((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
                 2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) \
$CellContext`r[] + $CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 3, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {4, 3, 2, 3} -> 
               Rational[
                 3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, 1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "\[ImaginaryI]"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {4, 3, 2, 4} -> 
               Rational[-3, 
                  2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, -1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "\[ImaginaryI]"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {4, 3, 3, 1} -> 
               Rational[
                 3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, -1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {4, 3, 3, 2} -> 
               Rational[-3, 
                  2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, 1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 3, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}], "+", 
                    RowBox[{"3", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}]}], 
                    ")"}]}], 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], ")"}], 
                    "3"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox["r", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {4, 3, 3, 
                4} -> -$CellContext`\[CapitalMu] $CellContext`r[] \
($CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (-$CellContext`r[]^2 + 
                 3 $CellContext`\[Alpha]^2 $CellContext`x[]^2) (
                 2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) \
$CellContext`r[] + $CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 
               "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"-", 
                   FractionBox[
                    RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                    RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[ImaginaryI]", " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]}]],
              
              Annotation[#, {4, 3, 4, 1} -> 
               Rational[-3, 
                  2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, 1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}]], " ", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]]}], 
                  RowBox[{"2", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "\[ImaginaryI]"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False]}]}], ")"}], "3"], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {4, 3, 4, 2} -> 
               Rational[
                 3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
                 Rational[1, 2] (
                  Complex[
                    0, -1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
                 Rational[
                  1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["\<\"\[GrayCircle]\"\>",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", 
                 FractionBox[
                  RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}], "+", 
                    RowBox[{"3", " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], ")"}], 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}], ")"}]}]}], 
                    ")"}]}], 
                  RowBox[{
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], ")"}], 
                    "3"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[CapitalMu]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[CapitalMu], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], "+", 
                    RowBox[{
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"\[Alpha]"}], AutoSpacing -> False, 
                    ShowAutoStyles -> False], $CellContext`\[Alpha], Editable -> 
                    False], "2"], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "x", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`x[], Editable -> False], "2"]}]}], 
                    ")"}]}]]}]],
              
              Annotation[#, {4, 3, 4, 
                3} -> $CellContext`\[CapitalMu] $CellContext`r[] \
($CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (-$CellContext`r[]^2 + 
                 3 $CellContext`\[Alpha]^2 $CellContext`x[]^2) (
                 2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) \
$CellContext`r[] + $CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 
               "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "3", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 3, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}}], GridBox[{
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "1", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 1, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "1", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 1, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "1", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 1, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "1", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 1, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "2", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 2, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "2", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 2, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "2", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 2, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "2", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 2, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "3", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 3, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "3", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 3, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "3", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 3, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "3", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 3, 4} -> 0, "Tooltip"]& ]},
            {
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "4", ",", "1"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 4, 1} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "4", ",", "2"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 4, 2} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "4", ",", "3"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 4, 3} -> 0, "Tooltip"]& ], 
             TagBox[
              TooltipBox["0",
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"4", ",", "4", ",", "4", ",", "4"}], "}"}], 
                 "\[Rule]", "0"}]],
              Annotation[#, {4, 4, 4, 4} -> 0, "Tooltip"]& ]}
           },
           AutoDelete->False,
           
           GridBoxDividers->{
            "ColumnsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}, 
             "RowsIndexed" -> {
              1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}}]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]},
           "RowsIndexed" -> {1 -> RGBColor[0, 0, 1], 5 -> RGBColor[0, 0, 1]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {" ", " ", " ", " "},
         {"a", "b", "c", "d"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{{{0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 
     0}}, {{0, $CellContext`\[CapitalMu] $CellContext`r[] ($CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-3) ((-2) $CellContext`\
\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + $CellContext`\[Alpha]^2 \
$CellContext`x[]^2)^(-1) (-$CellContext`r[]^2 + 
        3 $CellContext`\[Alpha]^2 $CellContext`x[]^2) (
        2 (
          2 $CellContext`\[CapitalMu] - $CellContext`r[]) $CellContext`r[] + \
$CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), Complex[0, 
         Rational[
         3, 2]] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] ($CellContext`r[] + 
         Complex[0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (
         1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
       Rational[-3, 
         2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, 
            1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)}, \
{-$CellContext`\[CapitalMu] $CellContext`r[] ($CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-3) ((-2) $CellContext`\
\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + $CellContext`\[Alpha]^2 \
$CellContext`x[]^2)^(-1) (-$CellContext`r[]^2 + 
        3 $CellContext`\[Alpha]^2 $CellContext`x[]^2) (
        2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) $CellContext`r[] + \
$CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 0, 
       Rational[-3, 
         2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, 
            1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), Complex[0, 
         Rational[
         3, 2]] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] ($CellContext`r[] + 
         Complex[0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (
         1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)}, {Complex[0, 
         Rational[-3, 
          2]] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] ($CellContext`r[] + 
         Complex[0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (
         1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
       Rational[
        3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, 
            1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 0, 
       Complex[0, 
         1] $CellContext`\[Alpha] $CellContext`\[CapitalMu] $CellContext`x[] \
((-3) $CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2) \
($CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
        2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) $CellContext`r[] + \
$CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2))}, {
      Rational[3, 
         2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, 
            1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), Complex[0, 
         Rational[-3, 
          2]] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] ($CellContext`r[] + 
         Complex[0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (
         1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
       Complex[0, -1] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
$CellContext`x[] ((-3) $CellContext`r[]^2 + $CellContext`\[Alpha]^2 \
$CellContext`x[]^2) ($CellContext`r[]^2 + $CellContext`\[Alpha]^2 \
$CellContext`x[]^2)^(-3) ((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
        2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) $CellContext`r[] + \
$CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 0}}, {{0, Complex[0, 
         Rational[
         3, 2]] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] ($CellContext`r[] + 
         Complex[0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (
         1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
       Rational[
        3, 2] $CellContext`\[Alpha]^2 $CellContext`\[CapitalMu] \
($CellContext`r[] + 
         Complex[0, 
            1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (-1 + \
$CellContext`x[]^2)/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 0}, {
      Complex[0, 
         Rational[-3, 
          2]] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] ($CellContext`r[] + 
         Complex[0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (
         1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 0, 0, 
       Rational[
        1, 2] $CellContext`\[CapitalMu] ($CellContext`r[] + 
         Complex[0, 
            1] $CellContext`\[Alpha] $CellContext`x[])^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
        2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) $CellContext`r[] + \
$CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2))}, {
      Rational[-3, 
         2] $CellContext`\[Alpha]^2 $CellContext`\[CapitalMu] \
($CellContext`r[] + 
         Complex[0, 
            1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (-1 + \
$CellContext`x[]^2)/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 0, 0, 
       Rational[
        3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, -1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)}, {
      0, Rational[-1, 2] $CellContext`\[CapitalMu] ($CellContext`r[] + 
         Complex[0, 
            1] $CellContext`\[Alpha] $CellContext`x[])^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
        2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) $CellContext`r[] + \
$CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 
       Rational[-3, 
         2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, -1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 0}}, {{
      0, Rational[-3, 
         2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, 
            1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 0, 
       Rational[
        3, 2] $CellContext`\[Alpha]^2 $CellContext`\[CapitalMu] \
($CellContext`r[] + 
         Complex[0, -1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (-1 + \
$CellContext`x[]^2)/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)}, {
      Rational[3, 
         2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, 
            1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 0, 
       Rational[
        1, 2] $CellContext`\[CapitalMu] ($CellContext`r[] + 
         Complex[0, -1] $CellContext`\[Alpha] $CellContext`x[])^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
        2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) $CellContext`r[] + \
$CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 0}, {
      0, Rational[-1, 2] $CellContext`\[CapitalMu] ($CellContext`r[] + 
         Complex[
           0, -1] $CellContext`\[Alpha] $CellContext`x[])^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
        2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) $CellContext`r[] + \
$CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 0, 
       Rational[-3, 
         2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, 
            1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)}, {
      Rational[-3, 
         2] $CellContext`\[Alpha]^2 $CellContext`\[CapitalMu] \
($CellContext`r[] + 
         Complex[0, -1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (-1 + \
$CellContext`x[]^2)/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 0, 
       Rational[
        3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, 
            1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 0}}}, {{{
      0, -$CellContext`\[CapitalMu] $CellContext`r[] ($CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-3) ((-2) $CellContext`\
\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + $CellContext`\[Alpha]^2 \
$CellContext`x[]^2)^(-1) (-$CellContext`r[]^2 + 
        3 $CellContext`\[Alpha]^2 $CellContext`x[]^2) (
        2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) $CellContext`r[] + \
$CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), Complex[0, 
         Rational[-3, 
          2]] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] ($CellContext`r[] + 
         Complex[0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (
         1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
       Rational[
        3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, 
            1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)}, \
{$CellContext`\[CapitalMu] $CellContext`r[] ($CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-3) ((-2) $CellContext`\
\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + $CellContext`\[Alpha]^2 \
$CellContext`x[]^2)^(-1) (-$CellContext`r[]^2 + 
        3 $CellContext`\[Alpha]^2 $CellContext`x[]^2) (
        2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) $CellContext`r[] + \
$CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 0, 
       Rational[
        3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, 
            1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), Complex[0, 
         Rational[-3, 
          2]] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] ($CellContext`r[] + 
         Complex[0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (
         1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)}, {Complex[0, 
         Rational[
         3, 2]] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] ($CellContext`r[] + 
         Complex[0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (
         1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
       Rational[-3, 
         2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, 
            1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 0, 
       Complex[0, -1] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
$CellContext`x[] ((-3) $CellContext`r[]^2 + $CellContext`\[Alpha]^2 \
$CellContext`x[]^2) ($CellContext`r[]^2 + $CellContext`\[Alpha]^2 \
$CellContext`x[]^2)^(-3) ((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
        2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) $CellContext`r[] + \
$CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2))}, {
      Rational[-3, 
         2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, 
            1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), Complex[0, 
         Rational[
         3, 2]] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] ($CellContext`r[] + 
         Complex[0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (
         1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
       Complex[0, 
         1] $CellContext`\[Alpha] $CellContext`\[CapitalMu] $CellContext`x[] \
((-3) $CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2) \
($CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
        2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) $CellContext`r[] + \
$CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 0}}, {{0, 0, 0, 0}, {0, 0,
      0, 0}, {0, 0, 0, 0}, {0, 0, 0, 
     0}}, {{0, 
       Rational[-3, 
         2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, 
            1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 0, 
       Rational[
        1, 2] $CellContext`\[CapitalMu] ($CellContext`r[] + 
         Complex[0, -1] $CellContext`\[Alpha] $CellContext`x[])^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
        2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) $CellContext`r[] + \
$CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2))}, {
      Rational[
        3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, 
            1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 0, 
       Rational[
        3, 2] $CellContext`\[Alpha]^2 $CellContext`\[CapitalMu] \
($CellContext`r[] + 
         Complex[0, -1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (-1 + \
$CellContext`x[]^2)/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 0}, {
      0, Rational[-3, 
         2] $CellContext`\[Alpha]^2 $CellContext`\[CapitalMu] \
($CellContext`r[] + 
         Complex[0, -1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (-1 + \
$CellContext`x[]^2)/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 0, 
       Rational[-3, 
         2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, 
            1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)}, {
      Rational[-1, 2] $CellContext`\[CapitalMu] ($CellContext`r[] + 
         Complex[0, -1] $CellContext`\[Alpha] $CellContext`x[])^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
        2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) $CellContext`r[] + \
$CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 0, 
       Rational[
        3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, 
            1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 0}}, {{
      0, Complex[0, 
         Rational[
         3, 2]] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] ($CellContext`r[] + 
         Complex[0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (
         1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
       Rational[
        1, 2] $CellContext`\[CapitalMu] ($CellContext`r[] + 
         Complex[0, 
            1] $CellContext`\[Alpha] $CellContext`x[])^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
        2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) $CellContext`r[] + \
$CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 0}, {Complex[0, 
         Rational[-3, 
          2]] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] ($CellContext`r[] + 
         Complex[0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (
         1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 0, 0, 
       Rational[
        3, 2] $CellContext`\[Alpha]^2 $CellContext`\[CapitalMu] \
($CellContext`r[] + 
         Complex[0, 
            1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (-1 + \
$CellContext`x[]^2)/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)}, {
      Rational[-1, 2] $CellContext`\[CapitalMu] ($CellContext`r[] + 
         Complex[0, 
            1] $CellContext`\[Alpha] $CellContext`x[])^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
        2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) $CellContext`r[] + \
$CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 0, 0, 
       Rational[
        3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, -1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)}, {
      0, Rational[-3, 
         2] $CellContext`\[Alpha]^2 $CellContext`\[CapitalMu] \
($CellContext`r[] + 
         Complex[0, 
            1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (-1 + \
$CellContext`x[]^2)/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
       Rational[-3, 
         2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, -1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 0}}}, {{{
      0, Complex[0, 
         Rational[-3, 
          2]] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] ($CellContext`r[] + 
         Complex[0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (
         1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
       Rational[-3, 
         2] $CellContext`\[Alpha]^2 $CellContext`\[CapitalMu] \
($CellContext`r[] + 
         Complex[0, 
            1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (-1 + \
$CellContext`x[]^2)/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 0}, {
      Complex[0, 
         Rational[
         3, 2]] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] ($CellContext`r[] + 
         Complex[0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (
         1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 0, 0, 
       Rational[-1, 2] $CellContext`\[CapitalMu] ($CellContext`r[] + 
         Complex[0, 
            1] $CellContext`\[Alpha] $CellContext`x[])^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
        2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) $CellContext`r[] + \
$CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2))}, {
      Rational[3, 
         2] $CellContext`\[Alpha]^2 $CellContext`\[CapitalMu] \
($CellContext`r[] + 
         Complex[0, 
            1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (-1 + \
$CellContext`x[]^2)/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 0, 0, 
       Rational[-3, 
         2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, -1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)}, {
      0, Rational[
        1, 2] $CellContext`\[CapitalMu] ($CellContext`r[] + 
         Complex[0, 
            1] $CellContext`\[Alpha] $CellContext`x[])^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
        2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) $CellContext`r[] + \
$CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 
       Rational[
        3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, -1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 0}}, {{
      0, Rational[
        3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, 
            1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 0, 
       Rational[-1, 2] $CellContext`\[CapitalMu] ($CellContext`r[] + 
         Complex[0, -1] $CellContext`\[Alpha] $CellContext`x[])^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
        2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) $CellContext`r[] + \
$CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2))}, {
      Rational[-3, 
         2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, 
            1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 0, 
       Rational[-3, 
         2] $CellContext`\[Alpha]^2 $CellContext`\[CapitalMu] \
($CellContext`r[] + 
         Complex[0, -1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (-1 + \
$CellContext`x[]^2)/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 0}, {
      0, Rational[
        3, 2] $CellContext`\[Alpha]^2 $CellContext`\[CapitalMu] \
($CellContext`r[] + 
         Complex[0, -1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (-1 + \
$CellContext`x[]^2)/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 0, 
       Rational[
        3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, 
            1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)}, {
      Rational[1, 2] $CellContext`\[CapitalMu] ($CellContext`r[] + 
         Complex[0, -1] $CellContext`\[Alpha] $CellContext`x[])^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
        2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) $CellContext`r[] + \
$CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 0, 
       Rational[-3, 
         2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, 
            1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 0}}, {{0, 0,
      0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 
     0}}, {{0, 
       Complex[0, 
         1] $CellContext`\[Alpha] $CellContext`\[CapitalMu] $CellContext`x[] \
((-3) $CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2) \
($CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
        2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) $CellContext`r[] + \
$CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 
       Rational[
        3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, -1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
       Rational[-3, 
         2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, 
            1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)}, {
      Complex[0, -1] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
$CellContext`x[] ((-3) $CellContext`r[]^2 + $CellContext`\[Alpha]^2 \
$CellContext`x[]^2) ($CellContext`r[]^2 + $CellContext`\[Alpha]^2 \
$CellContext`x[]^2)^(-3) ((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
        2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) $CellContext`r[] + \
$CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 0, 
       Rational[-3, 
         2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, 
            1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
       Rational[
        3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, -1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)}, {
      Rational[-3, 
         2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, -1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
       Rational[
        3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, 
            1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
       0, $CellContext`\[CapitalMu] $CellContext`r[] ($CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-3) ((-2) $CellContext`\
\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + $CellContext`\[Alpha]^2 \
$CellContext`x[]^2)^(-1) (-$CellContext`r[]^2 + 
        3 $CellContext`\[Alpha]^2 $CellContext`x[]^2) (
        2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) $CellContext`r[] + \
$CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2))}, {
      Rational[3, 
         2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, 
            1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
       Rational[-3, 
         2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, -1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), \
-$CellContext`\[CapitalMu] $CellContext`r[] ($CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-3) ((-2) $CellContext`\
\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + $CellContext`\[Alpha]^2 \
$CellContext`x[]^2)^(-1) (-$CellContext`r[]^2 + 
        3 $CellContext`\[Alpha]^2 $CellContext`x[]^2) (
        2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) $CellContext`r[] + \
$CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 0}}}, {{{
      0, Rational[
        3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, 
            1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 0, 
       Rational[-3, 
         2] $CellContext`\[Alpha]^2 $CellContext`\[CapitalMu] \
($CellContext`r[] + 
         Complex[0, -1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (-1 + \
$CellContext`x[]^2)/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)}, {
      Rational[-3, 
         2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, 
            1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 0, 
       Rational[-1, 2] $CellContext`\[CapitalMu] ($CellContext`r[] + 
         Complex[0, -1] $CellContext`\[Alpha] $CellContext`x[])^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
        2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) $CellContext`r[] + \
$CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 0}, {
      0, Rational[
        1, 2] $CellContext`\[CapitalMu] ($CellContext`r[] + 
         Complex[0, -1] $CellContext`\[Alpha] $CellContext`x[])^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
        2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) $CellContext`r[] + \
$CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 0, 
       Rational[
        3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, 
            1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)}, {
      Rational[
        3, 2] $CellContext`\[Alpha]^2 $CellContext`\[CapitalMu] \
($CellContext`r[] + 
         Complex[0, -1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (-1 + \
$CellContext`x[]^2)/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 0, 
       Rational[-3, 
         2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, 
            1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 0}}, {{
      0, Complex[0, 
         Rational[-3, 
          2]] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] ($CellContext`r[] + 
         Complex[0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (
         1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
       Rational[-1, 2] $CellContext`\[CapitalMu] ($CellContext`r[] + 
         Complex[0, 
            1] $CellContext`\[Alpha] $CellContext`x[])^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
        2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) $CellContext`r[] + \
$CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 0}, {Complex[0, 
         Rational[
         3, 2]] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
($CellContext`\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] ($CellContext`r[] + 
         Complex[0, 1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (
         1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 0, 0, 
       Rational[-3, 
         2] $CellContext`\[Alpha]^2 $CellContext`\[CapitalMu] \
($CellContext`r[] + 
         Complex[0, 
            1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (-1 + \
$CellContext`x[]^2)/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)}, {
      Rational[1, 2] $CellContext`\[CapitalMu] ($CellContext`r[] + 
         Complex[0, 
            1] $CellContext`\[Alpha] $CellContext`x[])^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
        2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) $CellContext`r[] + \
$CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 0, 0, 
       Rational[-3, 
         2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, -1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)}, {
      0, Rational[
        3, 2] $CellContext`\[Alpha]^2 $CellContext`\[CapitalMu] \
($CellContext`r[] + 
         Complex[0, 
            1] $CellContext`\[Alpha] $CellContext`x[])^(-3) (-1 + \
$CellContext`x[]^2)/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
       Rational[
        3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, -1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 0}}, {{
      0, Complex[
        0, -1] $CellContext`\[Alpha] $CellContext`\[CapitalMu] \
$CellContext`x[] ((-3) $CellContext`r[]^2 + $CellContext`\[Alpha]^2 \
$CellContext`x[]^2) ($CellContext`r[]^2 + $CellContext`\[Alpha]^2 \
$CellContext`x[]^2)^(-3) ((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
        2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) $CellContext`r[] + \
$CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 
       Rational[-3, 
         2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, -1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
       Rational[
        3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, 
            1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)}, {
      Complex[0, 
         1] $CellContext`\[Alpha] $CellContext`\[CapitalMu] $CellContext`x[] \
((-3) $CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2) \
($CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-3) ((-2) \
$CellContext`\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-1) (
        2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) $CellContext`r[] + \
$CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 0, 
       Rational[
        3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, 
            1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
       Rational[-3, 
         2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, -1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2)}, {
      Rational[3, 
         2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, -1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
       Rational[-3, 
         2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, 
            1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
       0, -$CellContext`\[CapitalMu] $CellContext`r[] ($CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-3) ((-2) $CellContext`\
\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + $CellContext`\[Alpha]^2 \
$CellContext`x[]^2)^(-1) (-$CellContext`r[]^2 + 
        3 $CellContext`\[Alpha]^2 $CellContext`x[]^2) (
        2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) $CellContext`r[] + \
$CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2))}, {
      Rational[-3, 
         2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, 
            1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), 
       Rational[
        3, 2] $CellContext`\[Alpha] $CellContext`\[CapitalMu] ($CellContext`\
\[Alpha]^2 + $CellContext`r[] ((-2) $CellContext`\[CapitalMu] + \
$CellContext`r[]))^
        Rational[1, 2] (
         Complex[0, -1] $CellContext`r[] + $CellContext`\[Alpha] \
$CellContext`x[])^(-3) (1 - $CellContext`x[]^2)^
        Rational[
         1, 2]/((-2) $CellContext`\[CapitalMu] $CellContext`r[] + \
$CellContext`r[]^2 + $CellContext`\[Alpha]^2 $CellContext`x[]^2), \
$CellContext`\[CapitalMu] $CellContext`r[] ($CellContext`r[]^2 + \
$CellContext`\[Alpha]^2 $CellContext`x[]^2)^(-3) ((-2) $CellContext`\
\[CapitalMu] $CellContext`r[] + $CellContext`r[]^2 + $CellContext`\[Alpha]^2 \
$CellContext`x[]^2)^(-1) (-$CellContext`r[]^2 + 
        3 $CellContext`\[Alpha]^2 $CellContext`x[]^2) (
        2 (2 $CellContext`\[CapitalMu] - $CellContext`r[]) $CellContext`r[] + \
$CellContext`\[Alpha]^2 (-3 + $CellContext`x[]^2)), 0}}, {{0, 0, 0, 0}, {0, 0,
      0, 0}, {0, 0, 0, 0}, {0, 0, 0, 
     0}}}}, {-$CellContext`NP, -$CellContext`NP, -$CellContext`NP, \
-$CellContext`NP}, 
   0][-$CellContext`a, -$CellContext`b, -$CellContext`c, -$CellContext`d],
  Editable->False]], "Output",ExpressionUUID->"006f9f66-479e-4864-b5fe-\
d4ce624a0e30"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Psi0", "=", 
  RowBox[{
   RowBox[{"weyl", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}], ",", 
     RowBox[{"-", "d"}]}], "]"}], 
   RowBox[{"l", "[", "a", "]"}], 
   RowBox[{"m", "[", "b", "]"}], 
   RowBox[{"l", "[", "c", "]"}], 
   RowBox[{"m", "[", "d", "]"}]}]}]], "Input",ExpressionUUID->"0da6c691-8483-\
4646-9801-b1421ff92e2c"],

Cell[BoxData[
 FractionBox[
  RowBox[{"3", " ", 
   SuperscriptBox[
    InterpretationBox[
     StyleBox["\[Alpha]",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`\[Alpha],
     Editable->False], "2"], " ", 
   InterpretationBox[
    StyleBox["\[CapitalMu]",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`\[CapitalMu],
    Editable->False], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["x",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`x[],
       Editable->False], "2"]}], ")"}]}], 
  RowBox[{"2", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "+", 
      RowBox[{"\[ImaginaryI]", " ", 
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False]}]}], ")"}], "3"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      InterpretationBox[
       StyleBox["\[CapitalMu]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[CapitalMu],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False]}], "+", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "2"], "+", 
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], "2"], " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], "2"]}]}], ")"}]}]]], "Output",ExpressionUUID->\
"0c606736-84f6-4889-ba3a-276c6c0a4b93"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Psi1", "=", 
  RowBox[{
   RowBox[{"weyl", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}], ",", 
     RowBox[{"-", "d"}]}], "]"}], 
   RowBox[{"l", "[", "a", "]"}], 
   RowBox[{"n", "[", "b", "]"}], 
   RowBox[{"l", "[", "c", "]"}], 
   RowBox[{"m", "[", "d", "]"}]}]}]], "Input",ExpressionUUID->"b0ea8a97-86bb-\
458d-8df8-5e4ca4db3618"],

Cell[BoxData[
 FractionBox[
  RowBox[{"3", " ", "\[ImaginaryI]", " ", 
   InterpretationBox[
    StyleBox["\[Alpha]",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`\[Alpha],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[CapitalMu]",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`\[CapitalMu],
    Editable->False], " ", 
   SqrtBox[
    RowBox[{
     SuperscriptBox[
      InterpretationBox[
       StyleBox["\[Alpha]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[Alpha],
       Editable->False], "2"], "+", 
     RowBox[{
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "2"}], " ", 
         InterpretationBox[
          StyleBox["\[CapitalMu]",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`\[CapitalMu],
          Editable->False]}], "+", 
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False]}], ")"}]}]}]], " ", 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["x",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`x[],
       Editable->False], "2"]}]]}], 
  RowBox[{"2", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "+", 
      RowBox[{"\[ImaginaryI]", " ", 
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False]}]}], ")"}], "3"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      InterpretationBox[
       StyleBox["\[CapitalMu]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[CapitalMu],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False]}], "+", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "2"], "+", 
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], "2"], " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], "2"]}]}], ")"}]}]]], "Output",ExpressionUUID->\
"66c962ea-ca09-4089-8695-bb7c3ad1d7f0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Psi2", "=", 
  RowBox[{
   RowBox[{"weyl", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}], ",", 
     RowBox[{"-", "d"}]}], "]"}], 
   RowBox[{"l", "[", "a", "]"}], 
   RowBox[{"m", "[", "b", "]"}], 
   RowBox[{"mbar", "[", "c", "]"}], 
   RowBox[{"n", "[", "d", "]"}]}]}]], "Input",ExpressionUUID->"c1ee2f5f-c0db-\
4b39-9ae6-c993c78ec315"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{
    InterpretationBox[
     StyleBox["\[CapitalMu]",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`\[CapitalMu],
     Editable->False], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", 
          InterpretationBox[
           StyleBox["\[CapitalMu]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[CapitalMu],
           Editable->False]}], "-", 
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False]}], ")"}], " ", 
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False]}], "+", 
      RowBox[{
       SuperscriptBox[
        InterpretationBox[
         StyleBox["\[Alpha]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Alpha],
         Editable->False], "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "3"}], "+", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["x",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`x[],
           Editable->False], "2"]}], ")"}]}]}], ")"}]}], 
   RowBox[{"2", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], "+", 
       RowBox[{"\[ImaginaryI]", " ", 
        InterpretationBox[
         StyleBox["\[Alpha]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Alpha],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False]}]}], ")"}], "3"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "2"}], " ", 
       InterpretationBox[
        StyleBox["\[CapitalMu]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[CapitalMu],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False]}], "+", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], "2"], "+", 
      RowBox[{
       SuperscriptBox[
        InterpretationBox[
         StyleBox["\[Alpha]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Alpha],
         Editable->False], "2"], " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False], "2"]}]}], ")"}]}]]}]], "Output",ExpressionUUID->\
"5c137766-c87a-4e31-a5ce-7be1b27c0fb5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Psi3", "=", 
  RowBox[{
   RowBox[{"weyl", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}], ",", 
     RowBox[{"-", "d"}]}], "]"}], 
   RowBox[{"l", "[", "a", "]"}], 
   RowBox[{"n", "[", "b", "]"}], 
   RowBox[{"mbar", "[", "c", "]"}], 
   RowBox[{"n", "[", "d", "]"}]}]}]], "Input",ExpressionUUID->"90678609-5293-\
4c32-a309-87597745115a"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{"3", " ", "\[ImaginaryI]", " ", 
    InterpretationBox[
     StyleBox["\[Alpha]",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`\[Alpha],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox["\[CapitalMu]",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`\[CapitalMu],
     Editable->False], " ", 
    SqrtBox[
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], "2"], "+", 
      RowBox[{
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "2"}], " ", 
          InterpretationBox[
           StyleBox["\[CapitalMu]",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`\[CapitalMu],
           Editable->False]}], "+", 
         InterpretationBox[
          StyleBox["r",
           ShowAutoStyles->False,
           AutoSpacing->False],
          $CellContext`r[],
          Editable->False]}], ")"}]}]}]], " ", 
    SqrtBox[
     RowBox[{"1", "-", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], "2"]}]]}], 
   RowBox[{"2", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], "+", 
       RowBox[{"\[ImaginaryI]", " ", 
        InterpretationBox[
         StyleBox["\[Alpha]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Alpha],
         Editable->False], " ", 
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False]}]}], ")"}], "3"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "2"}], " ", 
       InterpretationBox[
        StyleBox["\[CapitalMu]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[CapitalMu],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False]}], "+", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["r",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`r[],
        Editable->False], "2"], "+", 
      RowBox[{
       SuperscriptBox[
        InterpretationBox[
         StyleBox["\[Alpha]",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`\[Alpha],
         Editable->False], "2"], " ", 
       SuperscriptBox[
        InterpretationBox[
         StyleBox["x",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`x[],
         Editable->False], "2"]}]}], ")"}]}]]}]], "Output",ExpressionUUID->\
"f74a9b2e-6e83-4fe7-98d6-15245f6792d4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Psi4", "=", 
  RowBox[{
   RowBox[{"weyl", "[", 
    RowBox[{
     RowBox[{"-", "a"}], ",", 
     RowBox[{"-", "b"}], ",", 
     RowBox[{"-", "c"}], ",", 
     RowBox[{"-", "d"}]}], "]"}], 
   RowBox[{"n", "[", "a", "]"}], 
   RowBox[{"mbar", "[", "b", "]"}], 
   RowBox[{"n", "[", "c", "]"}], 
   RowBox[{"mbar", "[", "d", "]"}]}]}]], "Input",ExpressionUUID->"3e4f13d9-\
be58-443a-8426-815d2215e023"],

Cell[BoxData[
 FractionBox[
  RowBox[{"3", " ", 
   SuperscriptBox[
    InterpretationBox[
     StyleBox["\[Alpha]",
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`\[Alpha],
     Editable->False], "2"], " ", 
   InterpretationBox[
    StyleBox["\[CapitalMu]",
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`\[CapitalMu],
    Editable->False], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["x",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`x[],
       Editable->False], "2"]}], ")"}]}], 
  RowBox[{"2", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "+", 
      RowBox[{"\[ImaginaryI]", " ", 
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], " ", 
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False]}]}], ")"}], "3"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      InterpretationBox[
       StyleBox["\[CapitalMu]",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`\[CapitalMu],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False]}], "+", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox["r",
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`r[],
       Editable->False], "2"], "+", 
     RowBox[{
      SuperscriptBox[
       InterpretationBox[
        StyleBox["\[Alpha]",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`\[Alpha],
        Editable->False], "2"], " ", 
      SuperscriptBox[
       InterpretationBox[
        StyleBox["x",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`x[],
        Editable->False], "2"]}]}], ")"}]}]]], "Output",ExpressionUUID->\
"3701c657-20bb-4791-bb52-402e3da34812"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"UndefBasis", "[", "NP", "]"}]], "Input",ExpressionUUID->"03d133bd-f3ea-4928-8352-afe4caea4c9d"],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{
  "met", ",", "cd", ",", "cdRiemann", ",", "weyl", ",", "l", ",", "n", ",", 
   "m", ",", "mbar", ",", "expr", ",", "\"\<Global`NP*\>\"", ",", 
   "\"\<Global`Psi*\>\""}], "]"}]], "Input",ExpressionUUID->"148e3f48-6125-\
4266-b3a2-04b9ef15287e"],

Cell[BoxData[
 RowBox[{"UndefConstantSymbol", "[", 
  RowBox[{"{", 
   RowBox[{"\[Alpha]", ",", "\[CapitalMu]"}], "}"}], "]"}]], "Input",Expressio\
nUUID->"15e7e208-a253-4efa-a4f0-bba7861ac07a"],

Cell[BoxData[
 RowBox[{"UndefChart", "[", "BL", "]"}]], "Input",ExpressionUUID->"3cd828f1-9c45-4b69-abd1-9e8f38d16d45"],

Cell[BoxData[
 RowBox[{"UndefManifold", "[", "M", "]"}]], "Input",ExpressionUUID->"abcfe630-10e2-4b8f-a982-e15cda7369b1"],

Cell[BoxData[
 RowBox[{"ClearxCobaCache", "[", "All", "]"}]], "Input",ExpressionUUID->"7e617930-5337-4edb-953f-a21b71cae53f"]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Extrinsic curvature computations do not yet work", "Section",ExpressionUUID->"97afd843-197b-4ab4-991b-4d04f63971c8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"<<", "xAct`xTensor`"}]], "Input",ExpressionUUID->"6ffb5116-6b78-40ad-b8e3-25826a73c749"],

Cell[CellGroupData[{

Cell[BoxData["\<\"------------------------------------------------------------\
\"\>"], "Print",ExpressionUUID->"ec7e61ad-a718-46bd-a4b6-f8c3a225f7e6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Package xAct`xPerm`  version \"\>", 
   "\[InvisibleSpace]", "\<\"1.2.3\"\>", "\[InvisibleSpace]", "\<\", \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"2015", ",", "8", ",", "23"}], "}"}]}],
  SequenceForm["Package xAct`xPerm`  version ", "1.2.3", ", ", {2015, 8, 23}],
  
  Editable->False]], "Print",ExpressionUUID->"e348ffc6-ea78-4bc0-817d-\
635ddf5136cd"],

Cell[BoxData["\<\"CopyRight (C) 2003-2015, Jose M. Martin-Garcia, under the \
General Public License.\"\>"], "Print",ExpressionUUID->"efa7e923-0433-47ed-\
a9e3-35d162a2bad8"],

Cell[BoxData["\<\"Connecting to external mac executable...\"\>"], "Print",ExpressionUUID->"9c04ad39-ce35-4231-8190-2e2fcec56d04"],

Cell[BoxData["\<\"Connection established.\"\>"], "Print",ExpressionUUID->"d1dfc49d-6796-41a5-89a5-accf8714e701"],

Cell[BoxData["\<\"------------------------------------------------------------\
\"\>"], "Print",ExpressionUUID->"9c865778-7dbe-422f-a751-a02a8d26bf78"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Package xAct`xTensor`  version \"\>", 
   "\[InvisibleSpace]", "\<\"1.1.2\"\>", "\[InvisibleSpace]", "\<\", \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"2015", ",", "8", ",", "23"}], "}"}]}],
  SequenceForm[
  "Package xAct`xTensor`  version ", "1.1.2", ", ", {2015, 8, 23}],
  Editable->False]], "Print",ExpressionUUID->"91f0ef23-a693-4716-ae82-\
213cd7f48747"],

Cell[BoxData["\<\"CopyRight (C) 2002-2015, Jose M. Martin-Garcia, under the \
General Public License.\"\>"], "Print",ExpressionUUID->"4b8836ce-6ca2-485a-\
b988-2ea0c1a35850"],

Cell[BoxData["\<\"------------------------------------------------------------\
\"\>"], "Print",ExpressionUUID->"b3a6f03e-bc28-4ad7-b0ba-bd9945b6d8c4"],

Cell[BoxData["\<\"These packages come with ABSOLUTELY NO WARRANTY; for \
details type Disclaimer[]. This is free software, and you are welcome to \
redistribute it under certain conditions. See the General Public License for \
details.\"\>"], "Print",ExpressionUUID->"5ab27e5f-d8fb-444b-8f3d-\
d349a6d4a8e9"],

Cell[BoxData["\<\"------------------------------------------------------------\
\"\>"], "Print",ExpressionUUID->"c36bc37f-5ba6-4711-a4b4-74fc14ceb617"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"$PrePrint", "=", "ScreenDollarIndices"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"$DefInfoQ", "=", "False"}], ";"}]}], "Input",ExpressionUUID->\
"7baa270e-c30e-4880-9075-9e3cd2a2e467"],

Cell[BoxData[
 RowBox[{"DefManifold", "[", 
  RowBox[{"M", ",", "4", ",", 
   RowBox[{"{", 
    RowBox[{
    "\[Mu]", ",", "\[Nu]", ",", "\[Alpha]", ",", "\[Beta]", ",", "\[Gamma]", 
     ",", "\[Delta]", ",", "\[Lambda]", ",", "\[Rho]", ",", "\[Sigma]"}], 
    "}"}]}], "]"}]], "Input",ExpressionUUID->"aaaa953d-fb17-4b9e-874f-\
4f6e87b4c575"],

Cell[BoxData[
 RowBox[{"DefMetric", "[", 
  RowBox[{
   RowBox[{"-", "1"}], ",", 
   RowBox[{"g", "[", 
    RowBox[{
     RowBox[{"-", "\[Mu]"}], ",", 
     RowBox[{"-", "\[Nu]"}]}], "]"}], ",", "CD"}], "]"}]], "Input",ExpressionU\
UID->"1cee04cc-ba3b-45dc-a62f-941c96cc7fdc"],

Cell[BoxData[
 RowBox[{"DefTensor", "[", 
  RowBox[{
   RowBox[{"u", "[", "\[Mu]", "]"}], ",", "M"}], "]"}]], "Input",ExpressionUUI\
D->"671e7617-6d34-4de9-a53d-610dce54ebf0"],

Cell[BoxData[
 RowBox[{"u", "/:", 
  RowBox[{
   RowBox[{"u", "[", "\[Mu]_", "]"}], 
   RowBox[{"u", "[", 
    RowBox[{"-", "\[Mu]_"}], "]"}]}], ":=", 
  RowBox[{"-", "1"}]}]], "Input",ExpressionUUID->"d0037232-5808-4b35-adcd-\
d354c92eca4a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DefMetric", "[", 
  RowBox[{"1", ",", 
   RowBox[{"h", "[", 
    RowBox[{
     RowBox[{"-", "\[Mu]"}], ",", 
     RowBox[{"-", "\[Nu]"}]}], "]"}], ",", "cd", ",", 
   RowBox[{"InducedFrom", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"g", ",", "u"}], "}"}]}]}], "]"}]], "Input",ExpressionUUID->\
"0eeb0977-28e1-47da-8676-da5ed7b7f099"],

Cell[BoxData[
 TemplateBox[{
  "DefMetric","old",
   "\"There are already metrics \\!\\(\\*RowBox[{\\\"{\\\", \\\"g\\\", \
\\\"}\\\"}]\\) in vbundle \\!\\(\\*InterpretationBox[StyleBox[\\\"\
\[DoubleStruckCapitalT]M\\\", Rule[AutoSpacing, False], Rule[ShowAutoStyles, \
False]], TangentM, Rule[Editable, False]]\\).\"",2,8,1,19248056930511070721,
   "Local","xAct`xTensor`DefMetric"},
  "MessageTemplate2"]], "Message", \
"MSG",ExpressionUUID->"2ee69e51-ac85-4ed1-a188-4a2f4658532c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CD", "[", 
   RowBox[{"-", "\[Mu]"}], "]"}], "[", 
  RowBox[{"u", "[", 
   RowBox[{"-", "\[Nu]"}], "]"}], "]"}]], "Input",ExpressionUUID->"0c25a2c0-\
aed3-4d6f-8446-f16f480847c9"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   RowBox[{
    SubscriptBox["\[EmptyDownTriangle]", "\[Mu]"], GridBox[{
      {"u", 
       StyleBox[GridBox[{
          {" "},
          {"\[Nu]"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}]}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`CD[-$CellContext`\[Mu]][
   $CellContext`u[-$CellContext`\[Nu]]],
  Editable->False]], "Output",ExpressionUUID->"37628652-7a7c-4025-9f66-\
85e1d83dd0fc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", "GradNormalToExtrinsicK"}]], "Input",ExpressionUUID->"8b3d887d-7339-4b6d-aa76-c1bd0df68005"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {"Kh", 
       StyleBox[GridBox[{
          {" ", " "},
          {"\[Mu]", "\[Nu]"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`ExtrinsicKh[-$CellContext`\[Mu], -$CellContext`\[Nu]],
   Editable->False], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"Au", 
        StyleBox[GridBox[{
           {" "},
           {"\[Nu]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Accelerationu[-$CellContext`\[Nu]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"\[Mu]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-$CellContext`\[Mu]],
    Editable->False]}]}]], "Output",ExpressionUUID->"1ada267b-9a23-4296-929e-\
30d8b9c86352"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"%", " ", 
   RowBox[{"u", "[", "\[Mu]", "]"}]}], "//", "Expand"}]], "Input",ExpressionUU\
ID->"d0d1c931-9597-4558-ae1b-b2e3e1ba0eab"],

Cell[BoxData[
 RowBox[{"-", 
  InterpretationBox[
   StyleBox[GridBox[{
      {"Au", 
       StyleBox[GridBox[{
          {" "},
          {"\[Nu]"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Accelerationu[-$CellContext`\[Nu]],
   Editable->False]}]], "Output",ExpressionUUID->"34964827-c5e1-4abd-8687-\
1955c4a9e9fa"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"expr", "=", 
  RowBox[{
   RowBox[{"GaussCodazzi", "[", 
    RowBox[{
     RowBox[{"RicciCD", "[", 
      RowBox[{
       RowBox[{"-", "\[Mu]"}], ",", 
       RowBox[{"-", "\[Nu]"}]}], "]"}], ",", "h"}], "]"}], "//", 
   "ProjectDerivative"}]}]], "Input",ExpressionUUID->"04eba256-01b4-45ec-8861-\
3ffa0d94f658"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"Au", 
         StyleBox[GridBox[{
            {" "},
            {"\[Mu]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                Offset[0.]}}, "RowsIndexed" -> {}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`Accelerationu[-$CellContext`\[Mu]],
     Editable->False]}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"Au", 
        StyleBox[GridBox[{
           {" "},
           {"\[Nu]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Accelerationu[-$CellContext`\[Nu]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"Kh", 
        StyleBox[GridBox[{
           {" ", " "},
           {"\[Alpha]", "\[Nu]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ExtrinsicKh[-$CellContext`\[Alpha], -$CellContext`\[Nu]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"Kh", 
        StyleBox[GridBox[{
           {" ", "\[Alpha]"},
           {"\[Mu]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ExtrinsicKh[-$CellContext`\[Mu], $CellContext`\[Alpha]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"Kh", 
        StyleBox[GridBox[{
           {" ", "\[Alpha]"},
           {"\[Alpha]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ExtrinsicKh[-$CellContext`\[Alpha], $CellContext`\[Alpha]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"Kh", 
        StyleBox[GridBox[{
           {" ", " "},
           {"\[Mu]", "\[Nu]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ExtrinsicKh[-$CellContext`\[Mu], -$CellContext`\[Nu]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"Kh", 
        StyleBox[GridBox[{
           {" ", "\[Alpha]"},
           {"\[Mu]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ExtrinsicKh[-$CellContext`\[Mu], $CellContext`\[Alpha]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"Kh", 
        StyleBox[GridBox[{
           {" ", " "},
           {"\[Nu]", "\[Alpha]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ExtrinsicKh[-$CellContext`\[Nu], -$CellContext`\[Alpha]],
    Editable->False]}], "+", 
  InterpretationBox[
   StyleBox[
    RowBox[{
     UnderscriptBox["P", "h"], "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {"u", 
           StyleBox[GridBox[{
              {"\[Alpha]"},
              {" "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`u[$CellContext`\[Alpha]],
       Editable->False], " ", 
      RowBox[{"(", 
       InterpretationBox[
        StyleBox[
         RowBox[{
          SubscriptBox["\[EmptyDownTriangle]", "\[Alpha]"], GridBox[{
            {"Kh", 
             StyleBox[GridBox[{
                {" ", " "},
                {"\[Mu]", "\[Nu]"}
               },
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                   Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
              FontSize->Rational[39, 4]]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Center}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.034999999999999996`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}]}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`CD[-$CellContext`\[Alpha]][
         $CellContext`ExtrinsicKh[-$CellContext`\[Mu], -$CellContext`\[Nu]]],
        Editable->False], ")"}]}], "]"}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Projectorh[$CellContext`u[$CellContext`\[Alpha]] \
$CellContext`CD[-$CellContext`\[Alpha]][
      $CellContext`ExtrinsicKh[-$CellContext`\[Mu], -$CellContext`\[Nu]]]],
   Editable->False], "+", 
  InterpretationBox[
   StyleBox[
    RowBox[{
     UnderscriptBox["P", "h"], "[", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        SubscriptBox["\[EmptyDownTriangle]", "\[Nu]"], GridBox[{
          {"Au", 
           StyleBox[GridBox[{
              {" "},
              {"\[Mu]"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                  Offset[0.]}}, "RowsIndexed" -> {}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Center}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`CD[-$CellContext`\[Nu]][
       $CellContext`Accelerationu[-$CellContext`\[Mu]]],
      Editable->False], "]"}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Projectorh[
    $CellContext`CD[-$CellContext`\[Nu]][
     $CellContext`Accelerationu[-$CellContext`\[Mu]]]],
   Editable->False], "+", 
  InterpretationBox[
   StyleBox[GridBox[{
      {
       RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}], 
       StyleBox[GridBox[{
          {" ", " "},
          {"\[Mu]", "\[Nu]"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Riccicd[-$CellContext`\[Mu], -$CellContext`\[Nu]],
   Editable->False], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"h", 
        StyleBox[GridBox[{
           {"\[Alpha]", " "},
           {" ", "\[Beta]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`h[$CellContext`\[Alpha], -$CellContext`\[Beta]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      UnderscriptBox["P", "h"], "[", 
      InterpretationBox[
       StyleBox[
        RowBox[{
         SuperscriptBox["\[EmptyDownTriangle]", "\[Beta]"], GridBox[{
           {"Kh", 
            StyleBox[GridBox[{
               {" ", " "},
               {"\[Alpha]", "\[Nu]"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}]}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`CD[$CellContext`\[Beta]][
        $CellContext`ExtrinsicKh[-$CellContext`\[Alpha], -$CellContext`\[Nu]]],
       Editable->False], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Projectorh[
     $CellContext`CD[$CellContext`\[Beta]][
      $CellContext`ExtrinsicKh[-$CellContext`\[Alpha], -$CellContext`\[Nu]]]],
    
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"\[Mu]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-$CellContext`\[Mu]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      UnderscriptBox["P", "h"], "[", 
      InterpretationBox[
       StyleBox[
        RowBox[{
         SubscriptBox["\[EmptyDownTriangle]", "\[Nu]"], GridBox[{
           {"Kh", 
            StyleBox[GridBox[{
               {" ", "\[Alpha]"},
               {"\[Alpha]", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}]}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`CD[-$CellContext`\[Nu]][
        $CellContext`ExtrinsicKh[-$CellContext`\[Alpha], \
$CellContext`\[Alpha]]],
       Editable->False], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Projectorh[
     $CellContext`CD[-$CellContext`\[Nu]][
      $CellContext`ExtrinsicKh[-$CellContext`\[Alpha], \
$CellContext`\[Alpha]]]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"\[Mu]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-$CellContext`\[Mu]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"h", 
        StyleBox[GridBox[{
           {" ", "\[Beta]"},
           {"\[Alpha]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`h[-$CellContext`\[Alpha], $CellContext`\[Beta]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      UnderscriptBox["P", "h"], "[", 
      InterpretationBox[
       StyleBox[
        RowBox[{
         SubscriptBox["\[EmptyDownTriangle]", "\[Beta]"], GridBox[{
           {"Kh", 
            StyleBox[GridBox[{
               {" ", "\[Alpha]"},
               {"\[Mu]", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}]}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`CD[-$CellContext`\[Beta]][
        $CellContext`ExtrinsicKh[-$CellContext`\[Mu], $CellContext`\[Alpha]]],
       
       Editable->False], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Projectorh[
     $CellContext`CD[-$CellContext`\[Beta]][
      $CellContext`ExtrinsicKh[-$CellContext`\[Mu], $CellContext`\[Alpha]]]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"\[Nu]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-$CellContext`\[Nu]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      UnderscriptBox["P", "h"], "[", 
      InterpretationBox[
       StyleBox[
        RowBox[{
         SubscriptBox["\[EmptyDownTriangle]", "\[Mu]"], GridBox[{
           {"Kh", 
            StyleBox[GridBox[{
               {" ", "\[Alpha]"},
               {"\[Alpha]", " "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}]}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`CD[-$CellContext`\[Mu]][
        $CellContext`ExtrinsicKh[-$CellContext`\[Alpha], \
$CellContext`\[Alpha]]],
       Editable->False], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Projectorh[
     $CellContext`CD[-$CellContext`\[Mu]][
      $CellContext`ExtrinsicKh[-$CellContext`\[Alpha], \
$CellContext`\[Alpha]]]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"\[Nu]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-$CellContext`\[Nu]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"Au", 
        StyleBox[GridBox[{
           {" "},
           {"\[Alpha]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Accelerationu[-$CellContext`\[Alpha]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"Au", 
        StyleBox[GridBox[{
           {"\[Alpha]"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Accelerationu[$CellContext`\[Alpha]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"\[Mu]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-$CellContext`\[Mu]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"\[Nu]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-$CellContext`\[Nu]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"Kh", 
        StyleBox[GridBox[{
           {" ", "\[Beta]"},
           {"\[Alpha]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ExtrinsicKh[-$CellContext`\[Alpha], $CellContext`\[Beta]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"Kh", 
        StyleBox[GridBox[{
           {"\[Alpha]", " "},
           {" ", "\[Beta]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`ExtrinsicKh[$CellContext`\[Alpha], -$CellContext`\[Beta]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"\[Mu]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-$CellContext`\[Mu]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"\[Nu]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-$CellContext`\[Nu]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"h", 
        StyleBox[GridBox[{
           {"\[Alpha]", " "},
           {" ", "\[Beta]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`h[$CellContext`\[Alpha], -$CellContext`\[Beta]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      UnderscriptBox["P", "h"], "[", 
      InterpretationBox[
       StyleBox[
        RowBox[{
         SuperscriptBox["\[EmptyDownTriangle]", "\[Beta]"], GridBox[{
           {"Au", 
            StyleBox[GridBox[{
               {" "},
               {"\[Alpha]"}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}]}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`CD[$CellContext`\[Beta]][
        $CellContext`Accelerationu[-$CellContext`\[Alpha]]],
       Editable->False], "]"}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Projectorh[
     $CellContext`CD[$CellContext`\[Beta]][
      $CellContext`Accelerationu[-$CellContext`\[Alpha]]]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"\[Mu]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-$CellContext`\[Mu]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"\[Nu]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-$CellContext`\[Nu]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox["(",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{
       InterpretationBox[
        StyleBox[GridBox[{
           {"u", 
            StyleBox[GridBox[{
               {"\[Beta]"},
               {" "}
              },
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.], {
                   Offset[0.034999999999999996`]}, 
                  Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                   Offset[0.]}}, "RowsIndexed" -> {}}],
             FontSize->Rational[39, 4]]}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Center}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.034999999999999996`]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`u[$CellContext`\[Beta]],
        Editable->False], " ", 
       RowBox[{"(", 
        InterpretationBox[
         StyleBox[
          RowBox[{
           SubscriptBox["\[EmptyDownTriangle]", "\[Beta]"], GridBox[{
             {"Kh", 
              StyleBox[GridBox[{
                 {" ", "\[Alpha]"},
                 {"\[Alpha]", " "}
                },
                GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
               FontSize->Rational[39, 4]]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Center}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}]}],
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`CD[-$CellContext`\[Beta]][
          $CellContext`ExtrinsicKh[-$CellContext`\[Alpha], $CellContext`\
\[Alpha]]],
         Editable->False], ")"}]}], 
      StyleBox[")",
       FontColor->RGBColor[1, 0, 0]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`Scalar[$CellContext`u[$CellContext`\[Beta]] \
$CellContext`CD[-$CellContext`\[Beta]][
       $CellContext`ExtrinsicKh[-$CellContext`\[Alpha], \
$CellContext`\[Alpha]]]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"\[Mu]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-$CellContext`\[Mu]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"u", 
        StyleBox[GridBox[{
           {" "},
           {"\[Nu]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`u[-$CellContext`\[Nu]],
    Editable->False]}]}]], "Output",ExpressionUUID->"27913377-787b-441e-a0d6-\
9cd81c7f171b"]
}, Open  ]],

Cell["\<\
Now we construct the corresponding objects explicitly using xCoba:\
\>", "Text",ExpressionUUID->"fc739014-10b4-444a-b83d-00f7edc3510b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"<<", "xAct`xCoba`"}]], "Input",ExpressionUUID->"67eeff64-a6b9-48c4-9b01-a128ed90405b"],

Cell[CellGroupData[{

Cell[BoxData["\<\"------------------------------------------------------------\
\"\>"], "Print",ExpressionUUID->"f006bfec-89af-4ad3-9962-43207803f5f5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Package xAct`xCoba`  version \"\>", 
   "\[InvisibleSpace]", "\<\"0.8.3\"\>", "\[InvisibleSpace]", "\<\", \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"2015", ",", "8", ",", "23"}], "}"}]}],
  SequenceForm["Package xAct`xCoba`  version ", "0.8.3", ", ", {2015, 8, 23}],
  
  Editable->False]], "Print",ExpressionUUID->"c6868588-9d53-4ade-9342-\
9117b17177d6"],

Cell[BoxData["\<\"CopyRight (C) 2005-2014, David Yllanes and Jose M. \
Martin-Garcia, under the General Public License.\"\>"], "Print",ExpressionUUID\
->"1779ad36-67e7-4bfe-ad24-8b860a47806d"],

Cell[BoxData["\<\"------------------------------------------------------------\
\"\>"], "Print",ExpressionUUID->"c47726a3-dfca-4cd0-a7a8-3018f67f69df"],

Cell[BoxData["\<\"These packages come with ABSOLUTELY NO WARRANTY; for \
details type Disclaimer[]. This is free software, and you are welcome to \
redistribute it under certain conditions. See the General Public License for \
details.\"\>"], "Print",ExpressionUUID->"32a0dcde-4ec9-4d34-921f-\
f43b8df18dde"],

Cell[BoxData["\<\"------------------------------------------------------------\
\"\>"], "Print",ExpressionUUID->"f34e361e-41b1-47cf-8842-8bd89a08078b"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"DefChart", "[", 
  RowBox[{"schw", ",", "M", ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"t", "[", "]"}], ",", 
     RowBox[{"r", "[", "]"}], ",", 
     RowBox[{"\[Theta]", "[", "]"}], ",", 
     RowBox[{"\[Phi]", "[", "]"}]}], "}"}]}], "]"}]], "Input",ExpressionUUID->\
"e4ecdcd5-7fde-4b58-96bf-2d3614a36cfb"],

Cell[BoxData[
 RowBox[{"DefConstantSymbol", "[", 
  RowBox[{"mass", ",", 
   RowBox[{"PrintAs", "\[Rule]", "\"\<M\>\""}]}], "]"}]], "Input",ExpressionUU\
ID->"b7dc4d2f-f234-41f1-be8a-c8daf0497efe"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"g", "=", 
    RowBox[{"CTensor", "[", 
     RowBox[{
      RowBox[{"DiagonalMatrix", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          RowBox[{"2", 
           RowBox[{"mass", "/", 
            RowBox[{"r", "[", "]"}]}]}]}], ",", 
         RowBox[{"1", "/", 
          RowBox[{"(", 
           RowBox[{"1", "-", 
            RowBox[{"2", 
             RowBox[{"mass", "/", 
              RowBox[{"r", "[", "]"}]}]}]}], ")"}]}], ",", 
         RowBox[{
          RowBox[{"r", "[", "]"}], "^", "2"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"r", "[", "]"}], "^", "2"}], 
          RowBox[{
           RowBox[{"Sin", "[", 
            RowBox[{"\[Theta]", "[", "]"}], "]"}], "^", "2"}]}]}], "}"}], 
       "]"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "schw"}], ",", 
        RowBox[{"-", "schw"}]}], "}"}]}], "]"}]}], ")"}], "[", 
  RowBox[{
   RowBox[{"-", "\[Mu]"}], ",", 
   RowBox[{"-", "\[Nu]"}]}], "]"}]], "Input",ExpressionUUID->"8cb1b6f8-e879-\
4780-b1df-a19a2eb946c4"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox[
            RowBox[{
             RowBox[{"-", "1"}], "+", 
             FractionBox[
              RowBox[{"2", " ", 
               InterpretationBox[
                StyleBox["M",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`mass,
                Editable->False]}], 
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False]]}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
              RowBox[{
                RowBox[{"-", "1"}], "+", 
                FractionBox[
                 RowBox[{"2", " ", 
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False]}], 
                 InterpretationBox[
                  StyleBox[
                  "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`r[], Editable -> False]]}]}]],
           
           Annotation[#, {1, 1} -> -1 + 2 $CellContext`mass/$CellContext`r[], 
            "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 4} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            FractionBox["1", 
             RowBox[{"1", "-", 
              FractionBox[
               RowBox[{"2", " ", 
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`mass,
                 Editable->False]}], 
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False]]}]],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
              FractionBox["1", 
               RowBox[{"1", "-", 
                 FractionBox[
                  RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False]}], 
                  InterpretationBox[
                   StyleBox[
                   "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`r[], Editable -> False]]}]]}]],
           
           Annotation[#, {2, 
             2} -> (1 - 2 $CellContext`mass/$CellContext`r[])^(-1), 
            "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 4} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            SuperscriptBox[
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False], "2"],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "3"}], "}"}], "\[Rule]", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox[
                "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                $CellContext`r[], Editable -> False], "2"]}]],
           Annotation[#, {3, 3} -> $CellContext`r[]^2, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 4} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox[
            RowBox[{
             SuperscriptBox[
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], "2"], " ", 
             SuperscriptBox[
              RowBox[{
               InterpretationBox[
                StyleBox["Sin",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                Sin,
                Editable->False], "[", 
               InterpretationBox[
                StyleBox["\[Theta]",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`\[Theta][],
                Editable->False], "]"}], "2"]}],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "4"}], "}"}], "\[Rule]", 
              RowBox[{
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox[
                  "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`r[], Editable -> False], "2"], " ", 
                SuperscriptBox[
                 RowBox[{
                   InterpretationBox[
                    StyleBox[
                    RowBox[{"Sin"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Sin, Editable -> False], "[", 
                   InterpretationBox[
                    StyleBox[
                    "\[Theta]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Theta][], Editable -> False], "]"}], 
                 "2"]}]}]],
           Annotation[#, {4, 4} -> $CellContext`r[]^2 Sin[
                $CellContext`\[Theta][]]^2, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {" ", " "},
         {"\[Mu]", "\[Nu]"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{-1 + 2 $CellContext`mass/$CellContext`r[], 0, 0, 0}, {
    0, (1 - 2 $CellContext`mass/$CellContext`r[])^(-1), 0, 0}, {
    0, 0, $CellContext`r[]^2, 0}, {0, 0, 0, $CellContext`r[]^2 Sin[
        $CellContext`\[Theta][]]^2}}, {-$CellContext`schw, \
-$CellContext`schw}, 0][-$CellContext`\[Mu], -$CellContext`\[Nu]],
  Editable->False]], "Output",ExpressionUUID->"18c9f572-fbc8-4129-bd5b-\
eaf2d37001d1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"u", "=", 
    RowBox[{"CTensor", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"1", "/", 
         RowBox[{"Sqrt", "[", 
          RowBox[{"1", "-", 
           RowBox[{"2", 
            RowBox[{"mass", "/", 
             RowBox[{"r", "[", "]"}]}]}]}], "]"}]}], ",", "0", ",", "0", ",", 
        "0"}], "}"}], ",", 
      RowBox[{"{", "schw", "}"}]}], "]"}]}], ")"}], "[", "\[Mu]", 
  "]"}]], "Input",ExpressionUUID->"3bbeddf0-46fc-4969-b9d6-a07d6fea6193"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox[
            FractionBox["1", 
             SqrtBox[
              RowBox[{"1", "-", 
               FractionBox[
                RowBox[{"2", " ", 
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`mass,
                  Editable->False]}], 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]]}]]],
            RowBox[{
              RowBox[{"{", "1", "}"}], "\[Rule]", 
              FractionBox["1", 
               SqrtBox[
                RowBox[{"1", "-", 
                  FractionBox[
                   RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False]}], 
                   InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]]}]]]}]],
           
           Annotation[#, {1} -> (1 - 2 $CellContext`mass/$CellContext`r[])^
             Rational[-1, 2], "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", "2", "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", "3", "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", "4", "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4} -> 0, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {
           1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {"\[Mu]"},
         {" "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{(1 - 2 $CellContext`mass/$CellContext`r[])^
    Rational[-1, 2], 0, 0, 0}, {$CellContext`schw}, 0][$CellContext`\[Mu]],
  Editable->False]], "Output",ExpressionUUID->"207b8379-36e6-4c15-9975-\
a02955a5771f"]
}, Open  ]],

Cell["The vector is normalized:", "Text",ExpressionUUID->"66430268-c8ce-4d09-80bd-a6d80dc17d29"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"g", "[", 
    RowBox[{
     RowBox[{"-", "\[Mu]"}], ",", 
     RowBox[{"-", "\[Nu]"}]}], "]"}], 
   RowBox[{"u", "[", "\[Mu]", "]"}], 
   RowBox[{"u", "[", "\[Nu]", "]"}]}], "//", "Simplify"}]], "Input",Expression\
UUID->"b9a932ad-85a2-4bac-b55c-c8c068024e30"],

Cell[BoxData[
 RowBox[{"-", "1"}]], "Output",ExpressionUUID->"bc2011a1-a2ab-4f31-a010-c17cfca843b6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CD", "=", 
  RowBox[{"LC", "[", "g", "]"}]}]], "Input",ExpressionUUID->"f57383c8-bff1-4c07-88f0-b957c091a9e1"],

Cell[BoxData[
 RowBox[{"CCovD", "[", 
  RowBox[{"PDschw", ",", 
   RowBox[{"CTensor", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"-", 
            FractionBox[
             InterpretationBox[
              StyleBox["M",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`mass,
              Editable->False], 
             RowBox[{
              RowBox[{"2", " ", 
               InterpretationBox[
                StyleBox["M",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`mass,
                Editable->False], " ", 
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False]}], "-", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False], "2"]}]]}], ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             InterpretationBox[
              StyleBox["M",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`mass,
              Editable->False], 
             RowBox[{
              RowBox[{"2", " ", 
               InterpretationBox[
                StyleBox["M",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`mass,
                Editable->False], " ", 
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False]}], "-", 
              SuperscriptBox[
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False], "2"]}]]}], ",", "0", ",", "0", ",", "0"}], 
          "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            RowBox[{
             InterpretationBox[
              StyleBox["M",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`mass,
              Editable->False], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "2"}], " ", 
                InterpretationBox[
                 StyleBox["M",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`mass,
                 Editable->False]}], "+", 
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False]}], ")"}]}], 
            SuperscriptBox[
             InterpretationBox[
              StyleBox["r",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`r[],
              Editable->False], "3"]], ",", "0", ",", "0", ",", "0"}], "}"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           FractionBox[
            InterpretationBox[
             StyleBox["M",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`mass,
             Editable->False], 
            RowBox[{
             RowBox[{"2", " ", 
              InterpretationBox[
               StyleBox["M",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`mass,
               Editable->False], " ", 
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False]}], "-", 
             SuperscriptBox[
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], "2"]}]], ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", 
           RowBox[{
            RowBox[{"2", " ", 
             InterpretationBox[
              StyleBox["M",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`mass,
              Editable->False]}], "-", 
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False]}], ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", 
               InterpretationBox[
                StyleBox["M",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`mass,
                Editable->False]}], "-", 
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False]}], ")"}], " ", 
            SuperscriptBox[
             RowBox[{
              InterpretationBox[
               StyleBox["Sin",
                ShowAutoStyles->False,
                AutoSpacing->False],
               Sin,
               Editable->False], "[", 
              InterpretationBox[
               StyleBox["\[Theta]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Theta][],
               Editable->False], "]"}], "2"]}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", 
           FractionBox["1", 
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False]], ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           FractionBox["1", 
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False]], ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", 
           RowBox[{
            RowBox[{"-", 
             RowBox[{
              InterpretationBox[
               StyleBox["Cos",
                ShowAutoStyles->False,
                AutoSpacing->False],
               Cos,
               Editable->False], "[", 
              InterpretationBox[
               StyleBox["\[Theta]",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`\[Theta][],
               Editable->False], "]"}]}], " ", 
            RowBox[{
             InterpretationBox[
              StyleBox["Sin",
               ShowAutoStyles->False,
               AutoSpacing->False],
              Sin,
              Editable->False], "[", 
             InterpretationBox[
              StyleBox["\[Theta]",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`\[Theta][],
              Editable->False], "]"}]}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", 
           FractionBox["1", 
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False]]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", 
           RowBox[{
            InterpretationBox[
             StyleBox["Cot",
              ShowAutoStyles->False,
              AutoSpacing->False],
             Cot,
             Editable->False], "[", 
            InterpretationBox[
             StyleBox["\[Theta]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Theta][],
             Editable->False], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           FractionBox["1", 
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False]], ",", 
           RowBox[{
            InterpretationBox[
             StyleBox["Cot",
              ShowAutoStyles->False,
              AutoSpacing->False],
             Cot,
             Editable->False], "[", 
            InterpretationBox[
             StyleBox["\[Theta]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Theta][],
             Editable->False], "]"}], ",", "0"}], "}"}]}], "}"}]}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"schw", ",", 
       RowBox[{"-", "schw"}], ",", 
       RowBox[{"-", "schw"}]}], "}"}], ",", "0"}], "]"}], ",", 
   RowBox[{"CTensor", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          FractionBox[
           RowBox[{"2", " ", 
            InterpretationBox[
             StyleBox["M",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`mass,
             Editable->False]}], 
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False]]}], ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         FractionBox["1", 
          RowBox[{"1", "-", 
           FractionBox[
            RowBox[{"2", " ", 
             InterpretationBox[
              StyleBox["M",
               ShowAutoStyles->False,
               AutoSpacing->False],
              $CellContext`mass,
              Editable->False]}], 
            InterpretationBox[
             StyleBox["r",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`r[],
             Editable->False]]}]], ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", 
         SuperscriptBox[
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False], "2"], ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", 
         RowBox[{
          SuperscriptBox[
           InterpretationBox[
            StyleBox["r",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`r[],
            Editable->False], "2"], " ", 
          SuperscriptBox[
           RowBox[{
            InterpretationBox[
             StyleBox["Sin",
              ShowAutoStyles->False,
              AutoSpacing->False],
             Sin,
             Editable->False], "[", 
            InterpretationBox[
             StyleBox["\[Theta]",
              ShowAutoStyles->False,
              AutoSpacing->False],
             $CellContext`\[Theta][],
             Editable->False], "]"}], "2"]}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "schw"}], ",", 
       RowBox[{"-", "schw"}]}], "}"}], ",", "0"}], "]"}]}], "]"}]], "Output",E\
xpressionUUID->"84698066-de1e-46e5-9841-1fee3b6c1b90"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CD", "[", 
   RowBox[{"-", "\[Mu]"}], "]"}], "[", 
  RowBox[{"g", "[", 
   RowBox[{
    RowBox[{"-", "\[Alpha]"}], ",", 
    RowBox[{"-", "\[Beta]"}]}], "]"}], "]"}]], "Input",ExpressionUUID->\
"55eae62e-18d8-452d-b984-d1808cb2f7dd"],

Cell[BoxData["0"], "Output",ExpressionUUID->"35e8b3ad-066b-4e7e-958c-e4dfe54d1f6c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"u", "[", 
  RowBox[{"-", "\[Nu]"}], "]"}]], "Input",ExpressionUUID->"5a92800c-f6bb-4454-acbc-c8be6141a342"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox[
            RowBox[{"-", 
             SqrtBox[
              RowBox[{"1", "-", 
               FractionBox[
                RowBox[{"2", " ", 
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`mass,
                  Editable->False]}], 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]]}]]}],
            RowBox[{
              RowBox[{"{", "1", "}"}], "\[Rule]", 
              RowBox[{"-", 
                SqrtBox[
                 RowBox[{"1", "-", 
                   FractionBox[
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False]}], 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]]}]]}]}]],
           
           Annotation[#, {
             1} -> -(1 - 2 $CellContext`mass/$CellContext`r[])^Rational[1, 2],
             "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", "2", "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", "3", "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", "4", "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4} -> 0, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {
           1 -> RGBColor[1, 0, 0], 2 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {" "},
         {"\[Nu]"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{-(1 - 2 $CellContext`mass/$CellContext`r[])^
     Rational[1, 2], 0, 0, 0}, {-$CellContext`schw}, 0][-$CellContext`\[Nu]],
  Editable->False]], "Output",ExpressionUUID->"8ee2f46b-3f32-4965-9ba5-\
4f2c9bfaa41d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CD", "[", 
    RowBox[{"-", "\[Mu]"}], "]"}], "[", 
   RowBox[{"u", "[", 
    RowBox[{"-", "\[Nu]"}], "]"}], "]"}], "//", "Simplify"}]], "Input",Express\
ionUUID->"006a2a68-1482-4d21-b873-522abd1d7b4a"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[GridBox[{
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"1", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {1, 4} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox[
            FractionBox[
             RowBox[{
              InterpretationBox[
               StyleBox["M",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`mass,
               Editable->False], " ", 
              SqrtBox[
               RowBox[{"1", "-", 
                FractionBox[
                 RowBox[{"2", " ", 
                  InterpretationBox[
                   StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`mass,
                   Editable->False]}], 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]]}]]}], 
             RowBox[{
              InterpretationBox[
               StyleBox["r",
                ShowAutoStyles->False,
                AutoSpacing->False],
               $CellContext`r[],
               Editable->False], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "2"}], " ", 
                 InterpretationBox[
                  StyleBox["M",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`mass,
                  Editable->False]}], "+", 
                InterpretationBox[
                 StyleBox["r",
                  ShowAutoStyles->False,
                  AutoSpacing->False],
                 $CellContext`r[],
                 Editable->False]}], ")"}]}]],
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
              FractionBox[
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                   RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                   False], $CellContext`mass, Editable -> False], " ", 
                 SqrtBox[
                  RowBox[{"1", "-", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False]}], 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]]}]]}], 
               RowBox[{
                 InterpretationBox[
                  StyleBox[
                  "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`r[], Editable -> False], " ", 
                 RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]]}]],
           
           Annotation[#, {2, 
             1} -> $CellContext`mass (1 - 
               2 $CellContext`mass/$CellContext`r[])^
              Rational[
               1, 2] $CellContext`r[]^(-1)/((-2) $CellContext`mass + \
$CellContext`r[]), "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"2", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {2, 4} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"3", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {3, 4} -> 0, "Tooltip"]& ]},
         {
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "1"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 1} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "2"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 2} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "3"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 3} -> 0, "Tooltip"]& ], 
          TagBox[
           TooltipBox["0",
            RowBox[{
              RowBox[{"{", 
                RowBox[{"4", ",", "4"}], "}"}], "\[Rule]", "0"}]],
           Annotation[#, {4, 4} -> 0, "Tooltip"]& ]}
        },
        AutoDelete->False,
        GridBoxDividers->{
         "ColumnsIndexed" -> {1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]},
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}],
       FontSize->Small], 
      StyleBox[GridBox[{
         {" ", " "},
         {"\[Nu]", "\[Mu]"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
             Offset[0.]}}, "RowsIndexed" -> {}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`xCoba`CTensor[{{0, 0, 0, 
    0}, {$CellContext`mass (1 - 2 $CellContext`mass/$CellContext`r[])^
      Rational[1, 
        2] $CellContext`r[]^(-1)/((-2) $CellContext`mass + $CellContext`r[]), 
     0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 
    0}}, {-$CellContext`schw, -$CellContext`schw}, 
   0][-$CellContext`\[Nu], -$CellContext`\[Mu]],
  Editable->False]], "Output",ExpressionUUID->"b928b506-15c6-4e68-86a6-\
aa8b345aed05"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Accelerationu", "=", 
  RowBox[{"-", 
   RowBox[{"Head", "[", 
    RowBox[{
     RowBox[{"u", "[", "\[Mu]", "]"}], 
     RowBox[{
      RowBox[{"CD", "[", 
       RowBox[{"-", "\[Mu]"}], "]"}], "[", 
      RowBox[{"u", "[", 
       RowBox[{"-", "\[Nu]"}], "]"}], "]"}]}], "]"}]}]}]], "Input",ExpressionU\
UID->"8c0e5997-6f12-4745-8b3c-0391b5018a46"],

Cell[BoxData[
 RowBox[{"CTensor", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"-", 
      FractionBox[
       InterpretationBox[
        StyleBox["M",
         ShowAutoStyles->False,
         AutoSpacing->False],
        $CellContext`mass,
        Editable->False], 
       RowBox[{
        InterpretationBox[
         StyleBox["r",
          ShowAutoStyles->False,
          AutoSpacing->False],
         $CellContext`r[],
         Editable->False], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "2"}], " ", 
           InterpretationBox[
            StyleBox["M",
             ShowAutoStyles->False,
             AutoSpacing->False],
            $CellContext`mass,
            Editable->False]}], "+", 
          InterpretationBox[
           StyleBox["r",
            ShowAutoStyles->False,
            AutoSpacing->False],
           $CellContext`r[],
           Editable->False]}], ")"}]}]]}], ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"-", "schw"}], "}"}], ",", "0"}], "]"}]], "Output",ExpressionUUID-\
>"9ba57bc4-3582-42a2-9449-f8b6782a1461"]
}, Open  ]],

Cell["\<\
The extrinsic curvature vanishes, because this is a time independent solution:\
\>", "Text",ExpressionUUID->"58162716-db6a-4fdd-a73b-375d8505f2c2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CD", "[", 
    RowBox[{"-", "\[Mu]"}], "]"}], "[", 
   RowBox[{"u", "[", 
    RowBox[{"-", "\[Nu]"}], "]"}], "]"}], "-", 
  RowBox[{
   RowBox[{"u", "[", 
    RowBox[{"-", "\[Mu]"}], "]"}], 
   RowBox[{"Accelerationu", "[", 
    RowBox[{"-", "\[Nu]"}], "]"}]}]}]], "Input",ExpressionUUID->"6286b2b6-\
201f-4861-9f50-2127075f6cfa"],

Cell[BoxData["0"], "Output",ExpressionUUID->"c3cd9e5d-d8b8-479e-8900-ba619f248715"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ExtrinsicKh", "=", "Zero"}]], "Input",ExpressionUUID->"201a5b01-cdf8-4ae4-b80a-91ebd292511b"],

Cell[BoxData["Zero"], "Output",ExpressionUUID->"c971c173-15fb-4035-aba3-171b4fffd7c0"]
}, Open  ]],

Cell["\<\
We still have problems on how to replace the symbolic metric by the explicit \
metric.\
\>", "Text",ExpressionUUID->"b3f8175b-75dd-4c9e-bc21-56e6f790a7d2"],

Cell[CellGroupData[{

Cell[BoxData["expr"], "Input",ExpressionUUID->"1f0c8601-4edc-40b1-8451-22341a403f20"],

Cell[BoxData[
 TemplateBox[{
  "InducedFrom","unknown",
   "\"Unknown \\!\\(\\*RowBox[{\\\"\\\\\\\"metric\\\\\\\"\\\"}]\\) \
\\!\\(\\*RowBox[{\\\"CTensor\\\", \\\"[\\\", RowBox[{RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{RowBox[{RowBox[{\\\"-\\\", \\\"1\\\"}], \\\
\"+\\\", FractionBox[RowBox[{\\\"2\\\", \\\" \\\", \
InterpretationBox[StyleBox[RowBox[{\\\"M\\\"}], Rule[AutoSpacing, False], \
Rule[ShowAutoStyles, False]], mass, Rule[Editable, False]]}], \
InterpretationBox[StyleBox[\\\"r\\\", Rule[AutoSpacing, False], \
Rule[ShowAutoStyles, False]], r[], Rule[Editable, False]]]}], \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\"}], \\\"}\\\"}], \\\",\\\
\", RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", FractionBox[\\\"1\\\", \
RowBox[{\\\"1\\\", \\\"-\\\", FractionBox[RowBox[{\\\"2\\\", \\\" \\\", \
InterpretationBox[StyleBox[RowBox[{\\\"M\\\"}], Rule[AutoSpacing, False], \
Rule[ShowAutoStyles, False]], mass, Rule[Editable, False]]}], \
InterpretationBox[StyleBox[\\\"r\\\", Rule[AutoSpacing, False], \
Rule[ShowAutoStyles, False]], r[], Rule[Editable, False]]]}]], \\\",\\\", \
\\\"0\\\", \\\",\\\", \\\"0\\\"}], \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \
RowBox[{\\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
SuperscriptBox[InterpretationBox[StyleBox[\\\"r\\\", Rule[AutoSpacing, \
False], Rule[ShowAutoStyles, False]], r[], Rule[Editable, False]], \
\\\"2\\\"], \\\",\\\", \\\"0\\\"}], \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \\\"0\\\", \\\",\\\", \
\\\"0\\\", \\\",\\\", RowBox[{SuperscriptBox[InterpretationBox[StyleBox[\\\"r\
\\\", Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], r[], \
Rule[Editable, False]], \\\"2\\\"], \\\" \\\", \
SuperscriptBox[RowBox[{InterpretationBox[StyleBox[RowBox[{\\\"Sin\\\"}], \
Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], Sin, Rule[Editable, \
False]], \\\"[\\\", InterpretationBox[StyleBox[\\\"\[Theta]\\\", \
Rule[AutoSpacing, False], Rule[ShowAutoStyles, False]], \\\\[Theta][], \
Rule[Editable, False]], \\\"]\\\"}], \\\"2\\\"]}]}], \\\"}\\\"}]}], \
\\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"-\\\", \
\\\"schw\\\"}], \\\",\\\", RowBox[{\\\"-\\\", \\\"schw\\\"}]}], \\\"}\\\"}], \
\\\",\\\", \\\"0\\\"}], \\\"]\\\"}]\\).\"",2,26,2,19248056930511070721,
   "Local","xAct`xTensor`InducedFrom"},
  "MessageTemplate2"]], "Message", \
"MSG",ExpressionUUID->"5464639e-e68f-4145-8121-f1049b80388a"],

Cell[BoxData[
 TemplateBox[{
  "Throw","nocatch",
   "\"Uncaught \\!\\(\\*RowBox[{\\\"Throw\\\", \\\"[\\\", \\\"Null\\\", \\\"]\
\\\"}]\\) returned to top level.\"",2,26,3,19248056930511070721,"Local"},
  "MessageTemplate"]], "Message", \
"MSG",ExpressionUUID->"4cbf9f40-be25-47b0-8152-1129716beb1a"],

Cell[BoxData[
 RowBox[{"Hold", "[", 
  RowBox[{"Throw", "[", "Null", "]"}], "]"}]], "Output",ExpressionUUID->\
"b426947d-dc4f-4c6e-9428-550ccd036e24"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"GaussCodazzi", "[", 
   RowBox[{
    RowBox[{"RicciCD", "[", 
     RowBox[{
      RowBox[{"-", "\[Mu]"}], ",", 
      RowBox[{"-", "\[Nu]"}]}], "]"}], ",", "h"}], "]"}], "//", 
  "Simplify"}]], "Input",ExpressionUUID->"0a01c288-ebb9-459f-bc1c-\
a76bb3abc39b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{"R", "[", "\[EmptyDownTriangle]", "]"}], 
        StyleBox[GridBox[{
           {" ", " "},
           {"\[Alpha]", "\[Beta]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Riccicd[-$CellContext`\[Alpha], -$CellContext`\[Beta]],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox[GridBox[{
           {GridBox[{
              {
               TagBox[
                TooltipBox["1",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], 
                   "\[Rule]", "1"}]],
                Annotation[#, {1, 1, 1, 1} -> 1, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 1, 1, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 1, 1, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "1", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 1, 1, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 1, 2, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["1",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2", ",", "2"}], "}"}], 
                   "\[Rule]", "1"}]],
                Annotation[#, {1, 1, 2, 2} -> 1, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 1, 2, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "2", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 1, 2, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "3", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 1, 3, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "3", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 1, 3, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["1",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "3", ",", "3"}], "}"}], 
                   "\[Rule]", "1"}]],
                Annotation[#, {1, 1, 3, 3} -> 1, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "3", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 1, 3, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "4", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 1, 4, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "4", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 1, 4, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "4", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 1, 4, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["1",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", "4", ",", "4"}], "}"}], 
                   "\[Rule]", "1"}]],
                Annotation[#, {1, 1, 4, 4} -> 1, "Tooltip"]& ]}
             },
             AutoDelete->False,
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}, 
               "RowsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 2, 1, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 2, 1, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 2, 1, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "1", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 2, 1, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 2, 2, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 2, 2, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 2, 2, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "2", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 2, 2, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "3", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 2, 3, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "3", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 2, 3, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "3", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 2, 3, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 2, 3, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "4", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 2, 4, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "4", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 2, 4, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "4", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 2, 4, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "4", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 2, 4, 4} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}, 
               "RowsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "3", ",", "1", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 3, 1, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "3", ",", "1", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 3, 1, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "3", ",", "1", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 3, 1, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "3", ",", "1", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 3, 1, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "3", ",", "2", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 3, 2, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "3", ",", "2", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 3, 2, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "3", ",", "2", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 3, 2, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "3", ",", "2", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 3, 2, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "3", ",", "3", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 3, 3, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "3", ",", "3", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 3, 3, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "3", ",", "3", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 3, 3, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "3", ",", "3", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 3, 3, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "3", ",", "4", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 3, 4, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "3", ",", "4", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 3, 4, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "3", ",", "4", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 3, 4, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "3", ",", "4", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 3, 4, 4} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}, 
               "RowsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "4", ",", "1", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 4, 1, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "4", ",", "1", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 4, 1, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "4", ",", "1", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 4, 1, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "4", ",", "1", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 4, 1, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "4", ",", "2", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 4, 2, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "4", ",", "2", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 4, 2, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "4", ",", "2", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 4, 2, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "4", ",", "2", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 4, 2, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "4", ",", "3", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 4, 3, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "4", ",", "3", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 4, 3, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "4", ",", "3", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 4, 3, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "4", ",", "3", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 4, 3, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "4", ",", "4", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 4, 4, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "4", ",", "4", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 4, 4, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "4", ",", "4", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 4, 4, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "4", ",", "4", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {1, 4, 4, 4} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}, 
               "RowsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}]},
           {GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 1, 1, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 1, 1, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 1, 1, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "1", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 1, 1, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 1, 2, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 1, 2, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 1, 2, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "2", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 1, 2, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "3", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 1, 3, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "3", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 1, 3, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "3", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 1, 3, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "3", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 1, 3, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "4", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 1, 4, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "4", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 1, 4, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "4", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 1, 4, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "1", ",", "4", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 1, 4, 4} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}, 
               "RowsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["1",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1", ",", "1"}], "}"}], 
                   "\[Rule]", "1"}]],
                Annotation[#, {2, 2, 1, 1} -> 1, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 2, 1, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 2, 1, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "1", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 2, 1, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 2, 2, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["1",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2", ",", "2"}], "}"}], 
                   "\[Rule]", "1"}]],
                Annotation[#, {2, 2, 2, 2} -> 1, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 2, 2, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "2", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 2, 2, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "3", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 2, 3, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "3", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 2, 3, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["1",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "3", ",", "3"}], "}"}], 
                   "\[Rule]", "1"}]],
                Annotation[#, {2, 2, 3, 3} -> 1, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "3", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 2, 3, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "4", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 2, 4, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "4", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 2, 4, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "4", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 2, 4, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["1",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2", ",", "4", ",", "4"}], "}"}], 
                   "\[Rule]", "1"}]],
                Annotation[#, {2, 2, 4, 4} -> 1, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}, 
               "RowsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "3", ",", "1", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 3, 1, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "3", ",", "1", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 3, 1, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "3", ",", "1", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 3, 1, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "3", ",", "1", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 3, 1, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "3", ",", "2", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 3, 2, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "3", ",", "2", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 3, 2, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "3", ",", "2", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 3, 2, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "3", ",", "2", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 3, 2, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "3", ",", "3", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 3, 3, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "3", ",", "3", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 3, 3, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "3", ",", "3", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 3, 3, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "3", ",", "3", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 3, 3, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "3", ",", "4", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 3, 4, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "3", ",", "4", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 3, 4, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "3", ",", "4", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 3, 4, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "3", ",", "4", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 3, 4, 4} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}, 
               "RowsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "4", ",", "1", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 4, 1, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "4", ",", "1", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 4, 1, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "4", ",", "1", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 4, 1, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "4", ",", "1", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 4, 1, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "4", ",", "2", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 4, 2, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "4", ",", "2", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 4, 2, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "4", ",", "2", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 4, 2, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "4", ",", "2", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 4, 2, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "4", ",", "3", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 4, 3, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "4", ",", "3", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 4, 3, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "4", ",", "3", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 4, 3, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "4", ",", "3", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 4, 3, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "4", ",", "4", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 4, 4, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "4", ",", "4", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 4, 4, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "4", ",", "4", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 4, 4, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"2", ",", "4", ",", "4", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {2, 4, 4, 4} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}, 
               "RowsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}]},
           {GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "1", ",", "1", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 1, 1, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "1", ",", "1", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 1, 1, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "1", ",", "1", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 1, 1, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "1", ",", "1", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 1, 1, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "1", ",", "2", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 1, 2, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "1", ",", "2", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 1, 2, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "1", ",", "2", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 1, 2, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "1", ",", "2", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 1, 2, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "1", ",", "3", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 1, 3, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "1", ",", "3", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 1, 3, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "1", ",", "3", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 1, 3, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "1", ",", "3", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 1, 3, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "1", ",", "4", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 1, 4, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "1", ",", "4", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 1, 4, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "1", ",", "4", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 1, 4, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "1", ",", "4", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 1, 4, 4} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}, 
               "RowsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "2", ",", "1", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 2, 1, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "2", ",", "1", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 2, 1, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "2", ",", "1", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 2, 1, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "2", ",", "1", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 2, 1, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "2", ",", "2", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 2, 2, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "2", ",", "2", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 2, 2, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "2", ",", "2", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 2, 2, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "2", ",", "2", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 2, 2, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "2", ",", "3", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 2, 3, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "2", ",", "3", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 2, 3, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "2", ",", "3", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 2, 3, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "2", ",", "3", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 2, 3, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "2", ",", "4", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 2, 4, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "2", ",", "4", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 2, 4, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "2", ",", "4", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 2, 4, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "2", ",", "4", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 2, 4, 4} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}, 
               "RowsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["1",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "3", ",", "1", ",", "1"}], "}"}], 
                   "\[Rule]", "1"}]],
                Annotation[#, {3, 3, 1, 1} -> 1, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "3", ",", "1", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 3, 1, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "3", ",", "1", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 3, 1, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "3", ",", "1", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 3, 1, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "3", ",", "2", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 3, 2, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["1",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "3", ",", "2", ",", "2"}], "}"}], 
                   "\[Rule]", "1"}]],
                Annotation[#, {3, 3, 2, 2} -> 1, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "3", ",", "2", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 3, 2, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "3", ",", "2", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 3, 2, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "3", ",", "3", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 3, 3, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "3", ",", "3", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 3, 3, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["1",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "3", ",", "3", ",", "3"}], "}"}], 
                   "\[Rule]", "1"}]],
                Annotation[#, {3, 3, 3, 3} -> 1, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "3", ",", "3", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 3, 3, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "3", ",", "4", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 3, 4, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "3", ",", "4", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 3, 4, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "3", ",", "4", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 3, 4, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["1",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "3", ",", "4", ",", "4"}], "}"}], 
                   "\[Rule]", "1"}]],
                Annotation[#, {3, 3, 4, 4} -> 1, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}, 
               "RowsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "4", ",", "1", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 4, 1, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "4", ",", "1", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 4, 1, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "4", ",", "1", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 4, 1, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "4", ",", "1", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 4, 1, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "4", ",", "2", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 4, 2, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "4", ",", "2", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 4, 2, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "4", ",", "2", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 4, 2, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "4", ",", "2", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 4, 2, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "4", ",", "3", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 4, 3, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "4", ",", "3", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 4, 3, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "4", ",", "3", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 4, 3, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "4", ",", "3", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 4, 3, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "4", ",", "4", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 4, 4, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "4", ",", "4", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 4, 4, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "4", ",", "4", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 4, 4, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"3", ",", "4", ",", "4", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {3, 4, 4, 4} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}, 
               "RowsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}]},
           {GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "1", ",", "1", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 1, 1, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "1", ",", "1", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 1, 1, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "1", ",", "1", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 1, 1, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "1", ",", "1", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 1, 1, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "1", ",", "2", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 1, 2, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "1", ",", "2", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 1, 2, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "1", ",", "2", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 1, 2, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "1", ",", "2", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 1, 2, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "1", ",", "3", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 1, 3, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "1", ",", "3", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 1, 3, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "1", ",", "3", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 1, 3, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "1", ",", "3", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 1, 3, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "1", ",", "4", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 1, 4, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "1", ",", "4", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 1, 4, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "1", ",", "4", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 1, 4, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "1", ",", "4", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 1, 4, 4} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}, 
               "RowsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "2", ",", "1", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 2, 1, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "2", ",", "1", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 2, 1, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "2", ",", "1", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 2, 1, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "2", ",", "1", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 2, 1, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "2", ",", "2", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 2, 2, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "2", ",", "2", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 2, 2, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "2", ",", "2", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 2, 2, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "2", ",", "2", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 2, 2, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "2", ",", "3", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 2, 3, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "2", ",", "3", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 2, 3, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "2", ",", "3", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 2, 3, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "2", ",", "3", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 2, 3, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "2", ",", "4", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 2, 4, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "2", ",", "4", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 2, 4, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "2", ",", "4", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 2, 4, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "2", ",", "4", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 2, 4, 4} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}, 
               "RowsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "3", ",", "1", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 3, 1, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "3", ",", "1", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 3, 1, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "3", ",", "1", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 3, 1, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "3", ",", "1", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 3, 1, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "3", ",", "2", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 3, 2, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "3", ",", "2", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 3, 2, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "3", ",", "2", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 3, 2, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "3", ",", "2", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 3, 2, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "3", ",", "3", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 3, 3, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "3", ",", "3", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 3, 3, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "3", ",", "3", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 3, 3, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "3", ",", "3", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 3, 3, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "3", ",", "4", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 3, 4, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "3", ",", "4", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 3, 4, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "3", ",", "4", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 3, 4, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "3", ",", "4", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 3, 4, 4} -> 0, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}, 
               "RowsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}], GridBox[{
              {
               TagBox[
                TooltipBox["1",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "4", ",", "1", ",", "1"}], "}"}], 
                   "\[Rule]", "1"}]],
                Annotation[#, {4, 4, 1, 1} -> 1, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "4", ",", "1", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 4, 1, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "4", ",", "1", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 4, 1, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "4", ",", "1", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 4, 1, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "4", ",", "2", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 4, 2, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["1",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "4", ",", "2", ",", "2"}], "}"}], 
                   "\[Rule]", "1"}]],
                Annotation[#, {4, 4, 2, 2} -> 1, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "4", ",", "2", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 4, 2, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "4", ",", "2", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 4, 2, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "4", ",", "3", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 4, 3, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "4", ",", "3", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 4, 3, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["1",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "4", ",", "3", ",", "3"}], "}"}], 
                   "\[Rule]", "1"}]],
                Annotation[#, {4, 4, 3, 3} -> 1, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "4", ",", "3", ",", "4"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 4, 3, 4} -> 0, "Tooltip"]& ]},
              {
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "4", ",", "4", ",", "1"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 4, 4, 1} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "4", ",", "4", ",", "2"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 4, 4, 2} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["0",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "4", ",", "4", ",", "3"}], "}"}], 
                   "\[Rule]", "0"}]],
                Annotation[#, {4, 4, 4, 3} -> 0, "Tooltip"]& ], 
               TagBox[
                TooltipBox["1",
                 RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", "4", ",", "4", ",", "4"}], "}"}], 
                   "\[Rule]", "1"}]],
                Annotation[#, {4, 4, 4, 4} -> 1, "Tooltip"]& ]}
             },
             AutoDelete->False,
             
             GridBoxDividers->{
              "ColumnsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}, 
               "RowsIndexed" -> {
                1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}]}
          },
          AutoDelete->False,
          
          GridBoxDividers->{
           "ColumnsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}, 
            "RowsIndexed" -> {
             1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}],
         FontSize->Small], 
        StyleBox[GridBox[{
           {" ", "\[Alpha]", " ", "\[Beta]"},
           {"\[Mu]", " ", "\[Nu]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
               Offset[0.]}}, "RowsIndexed" -> {}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xCoba`CTensor[{{{{1, 0, 0, 0}, {0, 1, 0, 0}, {0, 0, 1, 0}, {0, 0, 0, 
     1}}, {{0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}}, {{0, 0, 0,
      0}, {0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}}, {{0, 0, 0, 0}, {0, 0, 0, 
     0}, {0, 0, 0, 0}, {0, 0, 0, 0}}}, {{{0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0,
      0}, {0, 0, 0, 0}}, {{1, 0, 0, 0}, {0, 1, 0, 0}, {0, 0, 1, 0}, {0, 0, 0, 
     1}}, {{0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}}, {{0, 0, 0,
      0}, {0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}}}, {{{0, 0, 0, 0}, {0, 0, 
     0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}}, {{0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 
     0, 0}, {0, 0, 0, 0}}, {{1, 0, 0, 0}, {0, 1, 0, 0}, {0, 0, 1, 0}, {0, 0, 
     0, 1}}, {{0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}}}, {{{0, 
     0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}}, {{0, 0, 0, 0}, {0, 
     0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}}, {{0, 0, 0, 0}, {0, 0, 0, 0}, {0, 
     0, 0, 0}, {0, 0, 0, 0}}, {{1, 0, 0, 0}, {0, 1, 0, 0}, {0, 0, 1, 0}, {0, 
     0, 0, 1}}}}, {-$CellContext`schw, $CellContext`schw, -$CellContext`schw, \
$CellContext`schw}, 
     0][-$CellContext`\[Mu], $CellContext`\[Alpha], -$CellContext`\[Nu], \
$CellContext`\[Beta]],
    Editable->False]}], "+", 
  InterpretationBox[
   StyleBox[GridBox[{
      {
       StyleBox[GridBox[{
          {
           TagBox[
            TooltipBox["\<\"\[GrayCircle]\"\>",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
               FractionBox[
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False], " ", 
                  RowBox[{"(", 
                    RowBox[{
                    RowBox[{"3", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False]}], "-", 
                    InterpretationBox[
                    StyleBox[
                    
                    GridBox[{{
                    "\[CapitalGamma][\[EmptyDownTriangle],\!\(\*StyleBox[\"\
\[ScriptCapitalD]\",FontColor->RGBColor[1., 0., 0.]]\)]", 
                    StyleBox[
                    
                    GridBox[{{
                    "\!\(\*StyleBox[\"1\",FontColor->RGBColor[1., 0., 0.]]\)",
                     " ", " "}, {
                    " ", "\!\(\*StyleBox[\"2\",FontColor->RGBColor[1., 0., \
0.]]\)", "\!\(\*StyleBox[\"2\",FontColor->RGBColor[1., 0., 0.]]\)"}}, 
                    RowSpacings -> 0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`ChristoffelcdPDschw[{1, $CellContext`schw}, {
                    2, -$CellContext`schw}, {2, -$CellContext`schw}], 
                    Editable -> False], "-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    
                    GridBox[{{
                    "\[CapitalGamma][\[EmptyDownTriangle],\!\(\*StyleBox[\"\
\[ScriptCapitalD]\",FontColor->RGBColor[1., 0., 0.]]\)]", 
                    StyleBox[
                    
                    GridBox[{{
                    "\!\(\*StyleBox[\"1\",FontColor->RGBColor[1., 0., 0.]]\)",
                     " ", " "}, {
                    " ", "\!\(\*StyleBox[\"3\",FontColor->RGBColor[1., 0., \
0.]]\)", "\!\(\*StyleBox[\"3\",FontColor->RGBColor[1., 0., 0.]]\)"}}, 
                    RowSpacings -> 0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`ChristoffelcdPDschw[{1, $CellContext`schw}, {
                    3, -$CellContext`schw}, {3, -$CellContext`schw}], 
                    Editable -> False], " ", 
                    SuperscriptBox[
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"Csc"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], Csc, Editable -> False], "[", 
                    InterpretationBox[
                    StyleBox[
                    "\[Theta]", AutoSpacing -> False, ShowAutoStyles -> 
                    False], 
                    $CellContext`\[Theta][], Editable -> False], "]"}], 
                    "2"]}], "-", 
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    
                    GridBox[{{
                    "\[CapitalGamma][\[EmptyDownTriangle],\!\(\*StyleBox[\"\
\[ScriptCapitalD]\",FontColor->RGBColor[1., 0., 0.]]\)]", 
                    StyleBox[
                    
                    GridBox[{{
                    "\!\(\*StyleBox[\"1\",FontColor->RGBColor[1., 0., 0.]]\)",
                     " ", " "}, {
                    " ", "\!\(\*StyleBox[\"1\",FontColor->RGBColor[1., 0., \
0.]]\)", "\!\(\*StyleBox[\"1\",FontColor->RGBColor[1., 0., 0.]]\)"}}, 
                    RowSpacings -> 0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`ChristoffelcdPDschw[{1, $CellContext`schw}, {
                    1, -$CellContext`schw}, {1, -$CellContext`schw}], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "-", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    
                    GridBox[{{
                    "\[CapitalGamma][\[EmptyDownTriangle],\!\(\*StyleBox[\"\
\[ScriptCapitalD]\",FontColor->RGBColor[1., 0., 0.]]\)]", 
                    StyleBox[
                    
                    GridBox[{{
                    "\!\(\*StyleBox[\"1\",FontColor->RGBColor[1., 0., 0.]]\)",
                     " ", " "}, {
                    " ", "\!\(\*StyleBox[\"1\",FontColor->RGBColor[1., 0., \
0.]]\)", "\!\(\*StyleBox[\"1\",FontColor->RGBColor[1., 0., 0.]]\)"}}, 
                    RowSpacings -> 0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`ChristoffelcdPDschw[{1, $CellContext`schw}, {
                    1, -$CellContext`schw}, {1, -$CellContext`schw}], 
                    Editable -> False], " ", 
                    SuperscriptBox[
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"]}]}], ")"}]}], 
                SuperscriptBox[
                 InterpretationBox[
                  StyleBox[
                  "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                  $CellContext`r[], Editable -> False], "4"]]}]],
            
            Annotation[#, {1, 
              1} -> $CellContext`mass $CellContext`r[]^(-4) (
               3 $CellContext`mass - $CellContext`ChristoffelcdPDschw[{
                1, $CellContext`schw}, {2, -$CellContext`schw}, {
                2, -$CellContext`schw}] - $CellContext`ChristoffelcdPDschw[{
                 1, $CellContext`schw}, {3, -$CellContext`schw}, {
                 3, -$CellContext`schw}] Csc[
                  $CellContext`\[Theta][]]^2 - 2 $CellContext`r[] + 
               2 $CellContext`mass $CellContext`ChristoffelcdPDschw[{
                  1, $CellContext`schw}, {1, -$CellContext`schw}, {
                  1, -$CellContext`schw}] $CellContext`r[] - \
$CellContext`ChristoffelcdPDschw[{1, $CellContext`schw}, {
                 1, -$CellContext`schw}, {
                 1, -$CellContext`schw}] $CellContext`r[]^2), "Tooltip"]& ], 
           TagBox[
            TooltipBox["0",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", "0"}]],
            Annotation[#, {1, 2} -> 0, "Tooltip"]& ], 
           TagBox[
            TooltipBox["0",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"1", ",", "3"}], "}"}], "\[Rule]", "0"}]],
            Annotation[#, {1, 3} -> 0, "Tooltip"]& ], 
           TagBox[
            TooltipBox["0",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"1", ",", "4"}], "}"}], "\[Rule]", "0"}]],
            Annotation[#, {1, 4} -> 0, "Tooltip"]& ]},
          {
           TagBox[
            TooltipBox["0",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", "0"}]],
            Annotation[#, {2, 1} -> 0, "Tooltip"]& ], 
           TagBox[
            TooltipBox["\<\"\[GrayCircle]\"\>",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
               FractionBox[
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False], " ", 
                  RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "3"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False]}], "+", 
                    RowBox[{"2", " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], "+", 
                    RowBox[{
                    InterpretationBox[
                    StyleBox[
                    
                    GridBox[{{
                    "\[CapitalGamma][\[EmptyDownTriangle],\!\(\*StyleBox[\"\
\[ScriptCapitalD]\",FontColor->RGBColor[1., 0., 0.]]\)]", 
                    StyleBox[
                    
                    GridBox[{{
                    "\!\(\*StyleBox[\"1\",FontColor->RGBColor[1., 0., 0.]]\)",
                     " ", " "}, {
                    " ", "\!\(\*StyleBox[\"1\",FontColor->RGBColor[1., 0., \
0.]]\)", "\!\(\*StyleBox[\"1\",FontColor->RGBColor[1., 0., 0.]]\)"}}, 
                    RowSpacings -> 0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`ChristoffelcdPDschw[{1, $CellContext`schw}, {
                    1, -$CellContext`schw}, {1, -$CellContext`schw}], 
                    Editable -> False], " ", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]}], 
                    ")"}]}], 
                RowBox[{
                  SuperscriptBox[
                   InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False], "2"], " ", 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}], "2"]}]]}]],
            
            
            Annotation[#, {2, 
              2} -> $CellContext`mass $CellContext`r[]^(-2) ((-2) \
$CellContext`mass + $CellContext`r[])^(-2) ((-3) $CellContext`mass + 
               2 $CellContext`r[] + $CellContext`ChristoffelcdPDschw[{
                  1, $CellContext`schw}, {1, -$CellContext`schw}, {
                  1, -$CellContext`schw}] $CellContext`r[] ((-2) \
$CellContext`mass + $CellContext`r[])), "Tooltip"]& ], 
           TagBox[
            TooltipBox[
             FractionBox[
              RowBox[{
               InterpretationBox[
                StyleBox["M",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`mass,
                Editable->False], " ", 
               InterpretationBox[
                StyleBox[GridBox[{
                   {
                    RowBox[{"\[CapitalGamma]", "[", 
                    RowBox[{"\[EmptyDownTriangle]", ",", 
                    StyleBox["\[ScriptCapitalD]",
                    FontColor->RGBColor[1., 0., 0.]]}], "]"}], 
                    StyleBox[GridBox[{
                    {
                    StyleBox["1",
                    FontColor->RGBColor[1., 0., 0.]], " ", " "},
                    {" ", 
                    StyleBox["2",
                    FontColor->RGBColor[1., 0., 0.]], 
                    StyleBox["1",
                    FontColor->RGBColor[1., 0., 0.]]}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                    FontSize->Rational[39, 4]]}
                  },
                  
                  GridBoxAlignment->{
                   "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`ChristoffelcdPDschw[{1, $CellContext`schw}, {
                 2, -$CellContext`schw}, {1, -$CellContext`schw}],
                Editable->False]}], 
              RowBox[{
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"-", "2"}], " ", 
                  InterpretationBox[
                   StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`mass,
                   Editable->False]}], "+", 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]}], ")"}]}]],
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"2", ",", "3"}], "}"}], "\[Rule]", 
               FractionBox[
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False], " ", 
                  InterpretationBox[
                   StyleBox[
                    
                    GridBox[{{
                    "\[CapitalGamma][\[EmptyDownTriangle],\!\(\*StyleBox[\"\
\[ScriptCapitalD]\",FontColor->RGBColor[1., 0., 0.]]\)]", 
                    StyleBox[
                    
                    GridBox[{{
                    "\!\(\*StyleBox[\"1\",FontColor->RGBColor[1., 0., 0.]]\)",
                     " ", " "}, {
                    " ", "\!\(\*StyleBox[\"2\",FontColor->RGBColor[1., 0., \
0.]]\)", "\!\(\*StyleBox[\"1\",FontColor->RGBColor[1., 0., 0.]]\)"}}, 
                    RowSpacings -> 0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`ChristoffelcdPDschw[{1, $CellContext`schw}, {
                    2, -$CellContext`schw}, {1, -$CellContext`schw}], 
                   Editable -> False]}], 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                   "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`r[], Editable -> False], " ", 
                  RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]]}]],
            
            Annotation[#, {2, 
              3} -> $CellContext`mass $CellContext`ChristoffelcdPDschw[{
                1, $CellContext`schw}, {2, -$CellContext`schw}, {
                1, -$CellContext`schw}] $CellContext`r[]^(-1)/((-2) \
$CellContext`mass + $CellContext`r[]), "Tooltip"]& ], 
           TagBox[
            TooltipBox[
             FractionBox[
              RowBox[{
               InterpretationBox[
                StyleBox["M",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`mass,
                Editable->False], " ", 
               InterpretationBox[
                StyleBox[GridBox[{
                   {
                    RowBox[{"\[CapitalGamma]", "[", 
                    RowBox[{"\[EmptyDownTriangle]", ",", 
                    StyleBox["\[ScriptCapitalD]",
                    FontColor->RGBColor[1., 0., 0.]]}], "]"}], 
                    StyleBox[GridBox[{
                    {
                    StyleBox["1",
                    FontColor->RGBColor[1., 0., 0.]], " ", " "},
                    {" ", 
                    StyleBox["3",
                    FontColor->RGBColor[1., 0., 0.]], 
                    StyleBox["1",
                    FontColor->RGBColor[1., 0., 0.]]}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                    FontSize->Rational[39, 4]]}
                  },
                  
                  GridBoxAlignment->{
                   "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`ChristoffelcdPDschw[{1, $CellContext`schw}, {
                 3, -$CellContext`schw}, {1, -$CellContext`schw}],
                Editable->False]}], 
              RowBox[{
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"-", "2"}], " ", 
                  InterpretationBox[
                   StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`mass,
                   Editable->False]}], "+", 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]}], ")"}]}]],
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"2", ",", "4"}], "}"}], "\[Rule]", 
               FractionBox[
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False], " ", 
                  InterpretationBox[
                   StyleBox[
                    
                    GridBox[{{
                    "\[CapitalGamma][\[EmptyDownTriangle],\!\(\*StyleBox[\"\
\[ScriptCapitalD]\",FontColor->RGBColor[1., 0., 0.]]\)]", 
                    StyleBox[
                    
                    GridBox[{{
                    "\!\(\*StyleBox[\"1\",FontColor->RGBColor[1., 0., 0.]]\)",
                     " ", " "}, {
                    " ", "\!\(\*StyleBox[\"3\",FontColor->RGBColor[1., 0., \
0.]]\)", "\!\(\*StyleBox[\"1\",FontColor->RGBColor[1., 0., 0.]]\)"}}, 
                    RowSpacings -> 0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`ChristoffelcdPDschw[{1, $CellContext`schw}, {
                    3, -$CellContext`schw}, {1, -$CellContext`schw}], 
                   Editable -> False]}], 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                   "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`r[], Editable -> False], " ", 
                  RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]]}]],
            
            Annotation[#, {2, 
              4} -> $CellContext`mass $CellContext`ChristoffelcdPDschw[{
                1, $CellContext`schw}, {3, -$CellContext`schw}, {
                1, -$CellContext`schw}] $CellContext`r[]^(-1)/((-2) \
$CellContext`mass + $CellContext`r[]), "Tooltip"]& ]},
          {
           TagBox[
            TooltipBox["0",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"3", ",", "1"}], "}"}], "\[Rule]", "0"}]],
            Annotation[#, {3, 1} -> 0, "Tooltip"]& ], 
           TagBox[
            TooltipBox[
             FractionBox[
              RowBox[{
               InterpretationBox[
                StyleBox["M",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`mass,
                Editable->False], " ", 
               InterpretationBox[
                StyleBox[GridBox[{
                   {
                    RowBox[{"\[CapitalGamma]", "[", 
                    RowBox[{"\[EmptyDownTriangle]", ",", 
                    StyleBox["\[ScriptCapitalD]",
                    FontColor->RGBColor[1., 0., 0.]]}], "]"}], 
                    StyleBox[GridBox[{
                    {
                    StyleBox["1",
                    FontColor->RGBColor[1., 0., 0.]], " ", " "},
                    {" ", 
                    StyleBox["1",
                    FontColor->RGBColor[1., 0., 0.]], 
                    StyleBox["2",
                    FontColor->RGBColor[1., 0., 0.]]}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                    FontSize->Rational[39, 4]]}
                  },
                  
                  GridBoxAlignment->{
                   "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`ChristoffelcdPDschw[{1, $CellContext`schw}, {
                 1, -$CellContext`schw}, {2, -$CellContext`schw}],
                Editable->False]}], 
              RowBox[{
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"-", "2"}], " ", 
                  InterpretationBox[
                   StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`mass,
                   Editable->False]}], "+", 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]}], ")"}]}]],
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"3", ",", "2"}], "}"}], "\[Rule]", 
               FractionBox[
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False], " ", 
                  InterpretationBox[
                   StyleBox[
                    GridBox[{{
                    "\[CapitalGamma][\[EmptyDownTriangle],\!\(\*StyleBox[\"\
\[ScriptCapitalD]\",FontColor->RGBColor[1., 0., 0.]]\)]", 
                    StyleBox[
                    
                    GridBox[{{
                    "\!\(\*StyleBox[\"1\",FontColor->RGBColor[1., 0., 0.]]\)",
                     " ", " "}, {
                    " ", "\!\(\*StyleBox[\"1\",FontColor->RGBColor[1., 0., \
0.]]\)", "\!\(\*StyleBox[\"2\",FontColor->RGBColor[1., 0., 0.]]\)"}}, 
                    RowSpacings -> 0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`ChristoffelcdPDschw[{1, $CellContext`schw}, {
                    1, -$CellContext`schw}, {2, -$CellContext`schw}], 
                   Editable -> False]}], 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                   "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`r[], Editable -> False], " ", 
                  RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]]}]],
            
            Annotation[#, {3, 
              2} -> $CellContext`mass $CellContext`ChristoffelcdPDschw[{
                1, $CellContext`schw}, {1, -$CellContext`schw}, {
                2, -$CellContext`schw}] $CellContext`r[]^(-1)/((-2) \
$CellContext`mass + $CellContext`r[]), "Tooltip"]& ], 
           TagBox[
            TooltipBox[
             FractionBox[
              RowBox[{
               InterpretationBox[
                StyleBox["M",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`mass,
                Editable->False], " ", 
               InterpretationBox[
                StyleBox[GridBox[{
                   {
                    RowBox[{"\[CapitalGamma]", "[", 
                    RowBox[{"\[EmptyDownTriangle]", ",", 
                    StyleBox["\[ScriptCapitalD]",
                    FontColor->RGBColor[1., 0., 0.]]}], "]"}], 
                    StyleBox[GridBox[{
                    {
                    StyleBox["1",
                    FontColor->RGBColor[1., 0., 0.]], " ", " "},
                    {" ", 
                    StyleBox["2",
                    FontColor->RGBColor[1., 0., 0.]], 
                    StyleBox["2",
                    FontColor->RGBColor[1., 0., 0.]]}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                    FontSize->Rational[39, 4]]}
                  },
                  
                  GridBoxAlignment->{
                   "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`ChristoffelcdPDschw[{1, $CellContext`schw}, {
                 2, -$CellContext`schw}, {2, -$CellContext`schw}],
                Editable->False]}], 
              RowBox[{
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"-", "2"}], " ", 
                  InterpretationBox[
                   StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`mass,
                   Editable->False]}], "+", 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]}], ")"}]}]],
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"3", ",", "3"}], "}"}], "\[Rule]", 
               FractionBox[
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False], " ", 
                  InterpretationBox[
                   StyleBox[
                    
                    GridBox[{{
                    "\[CapitalGamma][\[EmptyDownTriangle],\!\(\*StyleBox[\"\
\[ScriptCapitalD]\",FontColor->RGBColor[1., 0., 0.]]\)]", 
                    StyleBox[
                    
                    GridBox[{{
                    "\!\(\*StyleBox[\"1\",FontColor->RGBColor[1., 0., 0.]]\)",
                     " ", " "}, {
                    " ", "\!\(\*StyleBox[\"2\",FontColor->RGBColor[1., 0., \
0.]]\)", "\!\(\*StyleBox[\"2\",FontColor->RGBColor[1., 0., 0.]]\)"}}, 
                    RowSpacings -> 0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`ChristoffelcdPDschw[{1, $CellContext`schw}, {
                    2, -$CellContext`schw}, {2, -$CellContext`schw}], 
                   Editable -> False]}], 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                   "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`r[], Editable -> False], " ", 
                  RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]]}]],
            
            Annotation[#, {3, 
              3} -> $CellContext`mass $CellContext`ChristoffelcdPDschw[{
                1, $CellContext`schw}, {2, -$CellContext`schw}, {
                2, -$CellContext`schw}] $CellContext`r[]^(-1)/((-2) \
$CellContext`mass + $CellContext`r[]), "Tooltip"]& ], 
           TagBox[
            TooltipBox[
             FractionBox[
              RowBox[{
               InterpretationBox[
                StyleBox["M",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`mass,
                Editable->False], " ", 
               InterpretationBox[
                StyleBox[GridBox[{
                   {
                    RowBox[{"\[CapitalGamma]", "[", 
                    RowBox[{"\[EmptyDownTriangle]", ",", 
                    StyleBox["\[ScriptCapitalD]",
                    FontColor->RGBColor[1., 0., 0.]]}], "]"}], 
                    StyleBox[GridBox[{
                    {
                    StyleBox["1",
                    FontColor->RGBColor[1., 0., 0.]], " ", " "},
                    {" ", 
                    StyleBox["3",
                    FontColor->RGBColor[1., 0., 0.]], 
                    StyleBox["2",
                    FontColor->RGBColor[1., 0., 0.]]}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                    FontSize->Rational[39, 4]]}
                  },
                  
                  GridBoxAlignment->{
                   "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`ChristoffelcdPDschw[{1, $CellContext`schw}, {
                 3, -$CellContext`schw}, {2, -$CellContext`schw}],
                Editable->False]}], 
              RowBox[{
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"-", "2"}], " ", 
                  InterpretationBox[
                   StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`mass,
                   Editable->False]}], "+", 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]}], ")"}]}]],
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"3", ",", "4"}], "}"}], "\[Rule]", 
               FractionBox[
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False], " ", 
                  InterpretationBox[
                   StyleBox[
                    
                    GridBox[{{
                    "\[CapitalGamma][\[EmptyDownTriangle],\!\(\*StyleBox[\"\
\[ScriptCapitalD]\",FontColor->RGBColor[1., 0., 0.]]\)]", 
                    StyleBox[
                    
                    GridBox[{{
                    "\!\(\*StyleBox[\"1\",FontColor->RGBColor[1., 0., 0.]]\)",
                     " ", " "}, {
                    " ", "\!\(\*StyleBox[\"3\",FontColor->RGBColor[1., 0., \
0.]]\)", "\!\(\*StyleBox[\"2\",FontColor->RGBColor[1., 0., 0.]]\)"}}, 
                    RowSpacings -> 0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`ChristoffelcdPDschw[{1, $CellContext`schw}, {
                    3, -$CellContext`schw}, {2, -$CellContext`schw}], 
                   Editable -> False]}], 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                   "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`r[], Editable -> False], " ", 
                  RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]]}]],
            
            Annotation[#, {3, 
              4} -> $CellContext`mass $CellContext`ChristoffelcdPDschw[{
                1, $CellContext`schw}, {3, -$CellContext`schw}, {
                2, -$CellContext`schw}] $CellContext`r[]^(-1)/((-2) \
$CellContext`mass + $CellContext`r[]), "Tooltip"]& ]},
          {
           TagBox[
            TooltipBox["0",
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"4", ",", "1"}], "}"}], "\[Rule]", "0"}]],
            Annotation[#, {4, 1} -> 0, "Tooltip"]& ], 
           TagBox[
            TooltipBox[
             FractionBox[
              RowBox[{
               InterpretationBox[
                StyleBox["M",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`mass,
                Editable->False], " ", 
               InterpretationBox[
                StyleBox[GridBox[{
                   {
                    RowBox[{"\[CapitalGamma]", "[", 
                    RowBox[{"\[EmptyDownTriangle]", ",", 
                    StyleBox["\[ScriptCapitalD]",
                    FontColor->RGBColor[1., 0., 0.]]}], "]"}], 
                    StyleBox[GridBox[{
                    {
                    StyleBox["1",
                    FontColor->RGBColor[1., 0., 0.]], " ", " "},
                    {" ", 
                    StyleBox["1",
                    FontColor->RGBColor[1., 0., 0.]], 
                    StyleBox["3",
                    FontColor->RGBColor[1., 0., 0.]]}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                    FontSize->Rational[39, 4]]}
                  },
                  
                  GridBoxAlignment->{
                   "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`ChristoffelcdPDschw[{1, $CellContext`schw}, {
                 1, -$CellContext`schw}, {3, -$CellContext`schw}],
                Editable->False]}], 
              RowBox[{
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"-", "2"}], " ", 
                  InterpretationBox[
                   StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`mass,
                   Editable->False]}], "+", 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]}], ")"}]}]],
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"4", ",", "2"}], "}"}], "\[Rule]", 
               FractionBox[
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False], " ", 
                  InterpretationBox[
                   StyleBox[
                    
                    GridBox[{{
                    "\[CapitalGamma][\[EmptyDownTriangle],\!\(\*StyleBox[\"\
\[ScriptCapitalD]\",FontColor->RGBColor[1., 0., 0.]]\)]", 
                    StyleBox[
                    
                    GridBox[{{
                    "\!\(\*StyleBox[\"1\",FontColor->RGBColor[1., 0., 0.]]\)",
                     " ", " "}, {
                    " ", "\!\(\*StyleBox[\"1\",FontColor->RGBColor[1., 0., \
0.]]\)", "\!\(\*StyleBox[\"3\",FontColor->RGBColor[1., 0., 0.]]\)"}}, 
                    RowSpacings -> 0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`ChristoffelcdPDschw[{1, $CellContext`schw}, {
                    1, -$CellContext`schw}, {3, -$CellContext`schw}], 
                   Editable -> False]}], 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                   "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`r[], Editable -> False], " ", 
                  RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]]}]],
            Annotation[#, {4, 
              2} -> $CellContext`mass $CellContext`ChristoffelcdPDschw[{
                1, $CellContext`schw}, {1, -$CellContext`schw}, {
                3, -$CellContext`schw}] $CellContext`r[]^(-1)/((-2) \
$CellContext`mass + $CellContext`r[]), "Tooltip"]& ], 
           TagBox[
            TooltipBox[
             FractionBox[
              RowBox[{
               InterpretationBox[
                StyleBox["M",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`mass,
                Editable->False], " ", 
               InterpretationBox[
                StyleBox[GridBox[{
                   {
                    RowBox[{"\[CapitalGamma]", "[", 
                    RowBox[{"\[EmptyDownTriangle]", ",", 
                    StyleBox["\[ScriptCapitalD]",
                    FontColor->RGBColor[1., 0., 0.]]}], "]"}], 
                    StyleBox[GridBox[{
                    {
                    StyleBox["1",
                    FontColor->RGBColor[1., 0., 0.]], " ", " "},
                    {" ", 
                    StyleBox["2",
                    FontColor->RGBColor[1., 0., 0.]], 
                    StyleBox["3",
                    FontColor->RGBColor[1., 0., 0.]]}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                    FontSize->Rational[39, 4]]}
                  },
                  
                  GridBoxAlignment->{
                   "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`ChristoffelcdPDschw[{1, $CellContext`schw}, {
                 2, -$CellContext`schw}, {3, -$CellContext`schw}],
                Editable->False]}], 
              RowBox[{
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"-", "2"}], " ", 
                  InterpretationBox[
                   StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`mass,
                   Editable->False]}], "+", 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]}], ")"}]}]],
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"4", ",", "3"}], "}"}], "\[Rule]", 
               FractionBox[
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False], " ", 
                  InterpretationBox[
                   StyleBox[
                    
                    GridBox[{{
                    "\[CapitalGamma][\[EmptyDownTriangle],\!\(\*StyleBox[\"\
\[ScriptCapitalD]\",FontColor->RGBColor[1., 0., 0.]]\)]", 
                    StyleBox[
                    
                    GridBox[{{
                    "\!\(\*StyleBox[\"1\",FontColor->RGBColor[1., 0., 0.]]\)",
                     " ", " "}, {
                    " ", "\!\(\*StyleBox[\"2\",FontColor->RGBColor[1., 0., \
0.]]\)", "\!\(\*StyleBox[\"3\",FontColor->RGBColor[1., 0., 0.]]\)"}}, 
                    RowSpacings -> 0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`ChristoffelcdPDschw[{1, $CellContext`schw}, {
                    2, -$CellContext`schw}, {3, -$CellContext`schw}], 
                   Editable -> False]}], 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                   "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`r[], Editable -> False], " ", 
                  RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]]}]],
            
            Annotation[#, {4, 
              3} -> $CellContext`mass $CellContext`ChristoffelcdPDschw[{
                1, $CellContext`schw}, {2, -$CellContext`schw}, {
                3, -$CellContext`schw}] $CellContext`r[]^(-1)/((-2) \
$CellContext`mass + $CellContext`r[]), "Tooltip"]& ], 
           TagBox[
            TooltipBox[
             FractionBox[
              RowBox[{
               InterpretationBox[
                StyleBox["M",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`mass,
                Editable->False], " ", 
               InterpretationBox[
                StyleBox[GridBox[{
                   {
                    RowBox[{"\[CapitalGamma]", "[", 
                    RowBox[{"\[EmptyDownTriangle]", ",", 
                    StyleBox["\[ScriptCapitalD]",
                    FontColor->RGBColor[1., 0., 0.]]}], "]"}], 
                    StyleBox[GridBox[{
                    {
                    StyleBox["1",
                    FontColor->RGBColor[1., 0., 0.]], " ", " "},
                    {" ", 
                    StyleBox["3",
                    FontColor->RGBColor[1., 0., 0.]], 
                    StyleBox["3",
                    FontColor->RGBColor[1., 0., 0.]]}
                    },
                    GridBoxSpacings->{"Columns" -> {
                    Offset[0.], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
                    Offset[0.]}}, "RowsIndexed" -> {}}],
                    FontSize->Rational[39, 4]]}
                  },
                  
                  GridBoxAlignment->{
                   "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {{Center}}, "RowsIndexed" -> {}},
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.034999999999999996`]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`ChristoffelcdPDschw[{1, $CellContext`schw}, {
                 3, -$CellContext`schw}, {3, -$CellContext`schw}],
                Editable->False]}], 
              RowBox[{
               InterpretationBox[
                StyleBox["r",
                 ShowAutoStyles->False,
                 AutoSpacing->False],
                $CellContext`r[],
                Editable->False], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"-", "2"}], " ", 
                  InterpretationBox[
                   StyleBox["M",
                    ShowAutoStyles->False,
                    AutoSpacing->False],
                   $CellContext`mass,
                   Editable->False]}], "+", 
                 InterpretationBox[
                  StyleBox["r",
                   ShowAutoStyles->False,
                   AutoSpacing->False],
                  $CellContext`r[],
                  Editable->False]}], ")"}]}]],
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"4", ",", "4"}], "}"}], "\[Rule]", 
               FractionBox[
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False], " ", 
                  InterpretationBox[
                   StyleBox[
                    
                    GridBox[{{
                    "\[CapitalGamma][\[EmptyDownTriangle],\!\(\*StyleBox[\"\
\[ScriptCapitalD]\",FontColor->RGBColor[1., 0., 0.]]\)]", 
                    StyleBox[
                    
                    GridBox[{{
                    "\!\(\*StyleBox[\"1\",FontColor->RGBColor[1., 0., 0.]]\)",
                     " ", " "}, {
                    " ", "\!\(\*StyleBox[\"3\",FontColor->RGBColor[1., 0., \
0.]]\)", "\!\(\*StyleBox[\"3\",FontColor->RGBColor[1., 0., 0.]]\)"}}, 
                    RowSpacings -> 0, ColumnSpacings -> 0.05, 
                    GridFrameMargins -> {{0, 0}, {0, 0}}], FontSize -> 
                    Rational[39, 4]]}}, ColumnSpacings -> 0.05, RowAlignments -> 
                    Center], AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`ChristoffelcdPDschw[{1, $CellContext`schw}, {
                    3, -$CellContext`schw}, {3, -$CellContext`schw}], 
                   Editable -> False]}], 
                RowBox[{
                  InterpretationBox[
                   StyleBox[
                   "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                   $CellContext`r[], Editable -> False], " ", 
                  RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", 
                    InterpretationBox[
                    StyleBox[
                    RowBox[{"M"}], AutoSpacing -> False, ShowAutoStyles -> 
                    False], $CellContext`mass, Editable -> False]}], "+", 
                    InterpretationBox[
                    StyleBox[
                    "r", AutoSpacing -> False, ShowAutoStyles -> False], 
                    $CellContext`r[], Editable -> False]}], ")"}]}]]}]],
            
            Annotation[#, {4, 
              4} -> $CellContext`mass $CellContext`ChristoffelcdPDschw[{
                1, $CellContext`schw}, {3, -$CellContext`schw}, {
                3, -$CellContext`schw}] $CellContext`r[]^(-1)/((-2) \
$CellContext`mass + $CellContext`r[]), "Tooltip"]& ]}
         },
         AutoDelete->False,
         GridBoxDividers->{
          "ColumnsIndexed" -> {
            1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}, 
           "RowsIndexed" -> {1 -> RGBColor[1, 0, 0], 5 -> RGBColor[1, 0, 0]}}],
        FontSize->Small], 
       StyleBox[GridBox[{
          {" ", " "},
          {"\[Mu]", "\[Nu]"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "ColumnsIndexed" -> {}, "Rows" -> {{
              Offset[0.]}}, "RowsIndexed" -> {}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`xCoba`CTensor[{{$CellContext`mass $CellContext`r[]^(-4) (
       3 $CellContext`mass - $CellContext`ChristoffelcdPDschw[{
        1, $CellContext`schw}, {2, -$CellContext`schw}, {
        2, -$CellContext`schw}] - $CellContext`ChristoffelcdPDschw[{
         1, $CellContext`schw}, {3, -$CellContext`schw}, {
         3, -$CellContext`schw}] Csc[
          $CellContext`\[Theta][]]^2 - 2 $CellContext`r[] + 
       2 $CellContext`mass $CellContext`ChristoffelcdPDschw[{
          1, $CellContext`schw}, {1, -$CellContext`schw}, {
          1, -$CellContext`schw}] $CellContext`r[] - \
$CellContext`ChristoffelcdPDschw[{1, $CellContext`schw}, {
         1, -$CellContext`schw}, {1, -$CellContext`schw}] $CellContext`r[]^2),
       0, 0, 0}, {
     0, $CellContext`mass $CellContext`r[]^(-2) ((-2) $CellContext`mass + \
$CellContext`r[])^(-2) ((-3) $CellContext`mass + 
       2 $CellContext`r[] + $CellContext`ChristoffelcdPDschw[{
          1, $CellContext`schw}, {1, -$CellContext`schw}, {
          1, -$CellContext`schw}] $CellContext`r[] ((-2) $CellContext`mass + \
$CellContext`r[])), $CellContext`mass $CellContext`ChristoffelcdPDschw[{
        1, $CellContext`schw}, {2, -$CellContext`schw}, {
        1, -$CellContext`schw}] $CellContext`r[]^(-1)/((-2) $CellContext`mass + \
$CellContext`r[]), $CellContext`mass $CellContext`ChristoffelcdPDschw[{
        1, $CellContext`schw}, {3, -$CellContext`schw}, {
        1, -$CellContext`schw}] $CellContext`r[]^(-1)/((-2) $CellContext`mass + \
$CellContext`r[])}, {
     0, $CellContext`mass $CellContext`ChristoffelcdPDschw[{
        1, $CellContext`schw}, {1, -$CellContext`schw}, {
        2, -$CellContext`schw}] $CellContext`r[]^(-1)/((-2) $CellContext`mass + \
$CellContext`r[]), $CellContext`mass $CellContext`ChristoffelcdPDschw[{
        1, $CellContext`schw}, {2, -$CellContext`schw}, {
        2, -$CellContext`schw}] $CellContext`r[]^(-1)/((-2) $CellContext`mass + \
$CellContext`r[]), $CellContext`mass $CellContext`ChristoffelcdPDschw[{
        1, $CellContext`schw}, {3, -$CellContext`schw}, {
        2, -$CellContext`schw}] $CellContext`r[]^(-1)/((-2) $CellContext`mass + \
$CellContext`r[])}, {
     0, $CellContext`mass $CellContext`ChristoffelcdPDschw[{
        1, $CellContext`schw}, {1, -$CellContext`schw}, {
        3, -$CellContext`schw}] $CellContext`r[]^(-1)/((-2) $CellContext`mass + \
$CellContext`r[]), $CellContext`mass $CellContext`ChristoffelcdPDschw[{
        1, $CellContext`schw}, {2, -$CellContext`schw}, {
        3, -$CellContext`schw}] $CellContext`r[]^(-1)/((-2) $CellContext`mass + \
$CellContext`r[]), $CellContext`mass $CellContext`ChristoffelcdPDschw[{
        1, $CellContext`schw}, {3, -$CellContext`schw}, {
        3, -$CellContext`schw}] $CellContext`r[]^(-1)/((-2) $CellContext`mass + \
$CellContext`r[])}}, {-$CellContext`schw, -$CellContext`schw}, 
    0][-$CellContext`\[Mu], -$CellContext`\[Nu]],
   Editable->False]}]], "Output",ExpressionUUID->"9aa1405d-f1c8-49ad-bfec-\
0fff9e67c428"]
}, Open  ]]
}, Closed]]
},
WindowSize->{1023, 607},
WindowMargins->{{167, Automatic}, {Automatic, 0}},
ShowSelection->True,
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (February 5, \
2018)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 85, 0, 30, "Input",ExpressionUUID->"dd850679-1c42-4d05-9c90-343324dcc8aa"],
Cell[CellGroupData[{
Cell[668, 24, 156, 4, 67, "Section",ExpressionUUID->"fb98dd1d-7f42-4647-b073-c027d32c6c22"],
Cell[CellGroupData[{
Cell[849, 32, 91, 0, 54, "Subsection",ExpressionUUID->"12900e24-d9d5-48b0-9dce-c94a7ffa32b4"],
Cell[CellGroupData[{
Cell[965, 36, 90, 0, 45, "Subsubsection",ExpressionUUID->"a56c5381-8ed5-4256-bbee-3319327c8384"],
Cell[CellGroupData[{
Cell[1080, 40, 110, 1, 30, "Input",ExpressionUUID->"6e86452c-cc64-43e8-b934-bda791638f3a"],
Cell[CellGroupData[{
Cell[1215, 45, 151, 1, 24, "Print",ExpressionUUID->"adc1681e-18b7-4770-8d68-b5a3a53deb16"],
Cell[1369, 48, 425, 10, 24, "Print",ExpressionUUID->"cfee9b16-b9d0-4a8c-89ce-cab6e2d20ccb"],
Cell[1797, 60, 174, 2, 24, "Print",ExpressionUUID->"13d439ad-cbd6-4730-a2a7-62ee81a2c5ca"],
Cell[1974, 64, 129, 0, 24, "Print",ExpressionUUID->"0626933e-9138-46b0-aca0-053f41fb9a2e"],
Cell[2106, 66, 112, 0, 24, "Print",ExpressionUUID->"ef2369c1-243d-43a1-9e2d-d96398ebc70d"],
Cell[2221, 68, 151, 1, 24, "Print",ExpressionUUID->"b6d74b84-e63c-45de-88d4-5215bd07ca69"],
Cell[2375, 71, 429, 10, 24, "Print",ExpressionUUID->"f013c6cd-22df-41f0-a832-32f4b6ded85e"],
Cell[2807, 83, 174, 2, 24, "Print",ExpressionUUID->"62cb4867-5282-4fbf-8de9-4e50764fabd1"],
Cell[2984, 87, 151, 1, 24, "Print",ExpressionUUID->"499a9353-3774-41b1-9fd9-b9f74acd0cd4"],
Cell[3138, 90, 425, 10, 24, "Print",ExpressionUUID->"dc0ac610-ebee-4a47-ab09-d0ade2d41bc9"],
Cell[3566, 102, 192, 2, 24, "Print",ExpressionUUID->"622ddad7-04b3-4635-87d1-cbc6968af3a9"],
Cell[3761, 106, 151, 1, 24, "Print",ExpressionUUID->"d1e3d131-6ec4-42e4-aa85-0cd45cdd2159"],
Cell[3915, 109, 308, 4, 44, "Print",ExpressionUUID->"f6539115-d966-4246-9222-a7ff76c69bd8"],
Cell[4226, 115, 151, 1, 24, "Print",ExpressionUUID->"0b1b0af5-f42d-411a-882b-711a21d0f1f3"]
}, Open  ]]
}, Open  ]],
Cell[4404, 120, 101, 0, 35, "Text",ExpressionUUID->"ef27e68e-55fc-4439-91a9-337e63abf187"],
Cell[4508, 122, 317, 8, 73, "Input",ExpressionUUID->"1a27909d-1cf5-4278-9469-de67d4f21aa9"],
Cell[4828, 132, 90, 0, 35, "Text",ExpressionUUID->"9c988b6d-d275-4e76-93c2-3b78fa777615"],
Cell[4921, 134, 217, 5, 30, "Input",ExpressionUUID->"c536ee93-a30c-4216-bfde-7c89f05cb095"],
Cell[5141, 141, 107, 0, 35, "Text",ExpressionUUID->"66978966-457a-426e-b645-7ada3da199f1"],
Cell[5251, 143, 280, 6, 30, "Input",ExpressionUUID->"0b2eb4cf-ce0c-43d9-a4fc-f714e1c8260e"],
Cell[5534, 151, 282, 6, 30, "Input",ExpressionUUID->"6d7c186a-4771-4b52-b62a-c1e031c2874d"]
}, Closed]],
Cell[CellGroupData[{
Cell[5853, 162, 92, 0, 37, "Subsubsection",ExpressionUUID->"c4e4573b-4cae-4f75-9ad2-cc259b048c21"],
Cell[5948, 164, 408, 10, 58, "Text",ExpressionUUID->"0ab38c02-d133-42d2-81e2-892a3be7b10f"],
Cell[6359, 176, 250, 6, 35, "Text",ExpressionUUID->"e495e735-c64e-4d38-88be-244c6b8435df"],
Cell[CellGroupData[{
Cell[6634, 186, 262, 7, 30, "Input",ExpressionUUID->"165aa8d2-a0f7-40f6-b84e-9cc85e29a34a"],
Cell[6899, 195, 246, 6, 34, "Output",ExpressionUUID->"86956409-94b0-4fe0-bc60-4a7d20cac73a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7182, 206, 116, 1, 30, "Input",ExpressionUUID->"f790bbb3-72ef-4dae-8465-09c362c3076a"],
Cell[7301, 209, 86, 0, 34, "Output",ExpressionUUID->"f01609bf-e095-4f19-8d2e-453b8c00dc15"]
}, Open  ]],
Cell[7402, 212, 238, 6, 35, "Text",ExpressionUUID->"d81b14e8-5d28-4ee5-9475-2276cecf92ad"],
Cell[CellGroupData[{
Cell[7665, 222, 109, 1, 30, "Input",ExpressionUUID->"b9d92507-cdeb-426b-8df1-2575f3b11090"],
Cell[7777, 225, 1975, 60, 69, "Output",ExpressionUUID->"4349b7ad-32b4-4c8c-ba64-4d1dd38a6880"]
}, Open  ]],
Cell[9767, 288, 176, 3, 35, "Text",ExpressionUUID->"df7121e4-1b51-4e1e-adf3-d78cd50d431a"],
Cell[CellGroupData[{
Cell[9968, 295, 120, 1, 30, "Input",ExpressionUUID->"a1317791-f4be-4474-bd65-9c1d18f2f3f6"],
Cell[10091, 298, 1575, 43, 34, "Output",ExpressionUUID->"ab93432c-0b0d-4d52-9a86-d4faa11aa320"]
}, Open  ]],
Cell[11681, 344, 100, 0, 35, "Text",ExpressionUUID->"b0f0bf3e-b3f1-4807-b397-26ff28e9b412"],
Cell[CellGroupData[{
Cell[11806, 348, 456, 13, 52, "Input",ExpressionUUID->"8b88f491-919a-4fe0-843b-8d0f622b34c8"],
Cell[12265, 363, 588, 16, 34, "Output",ExpressionUUID->"e12c5cd7-11fb-4030-b5dd-bdbb8079dad4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12890, 384, 153, 4, 30, "Input",ExpressionUUID->"83a116af-ed79-41e9-bdeb-fbc192e06dfe"],
Cell[13046, 390, 4887, 138, 75, "Output",ExpressionUUID->"f0622e5b-b807-418d-b70b-1c1900628a9b"]
}, Open  ]],
Cell[17948, 531, 221, 3, 35, "Text",ExpressionUUID->"1d98bb43-9a01-4748-9f0c-119d244eca19"],
Cell[CellGroupData[{
Cell[18194, 538, 361, 11, 30, "Input",ExpressionUUID->"88da6a6c-61ff-4d5a-91ea-d9786a95aa63"],
Cell[18558, 551, 1348, 39, 49, "Output",ExpressionUUID->"847f52f9-01ca-46e6-8988-e9346d7b3c6e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[19943, 595, 593, 19, 30, "Input",ExpressionUUID->"5b9b092b-4cc1-4337-9fc3-0b263c457f6c"],
Cell[20539, 616, 3597, 104, 49, "Output",ExpressionUUID->"2a8ac984-15e4-48fe-a40e-31eaf09d6f48"]
}, Open  ]],
Cell[24151, 723, 344, 5, 58, "Text",ExpressionUUID->"41297a39-c4e3-4cbb-bd55-bc7aa80b2452"],
Cell[CellGroupData[{
Cell[24520, 732, 658, 20, 52, "Input",ExpressionUUID->"b5f3ee3a-5b12-4224-8f02-dad888ce28f7"],
Cell[25181, 754, 5836, 148, 45, "Output",ExpressionUUID->"ea89b720-49ea-4643-8094-81df6ef5c9fe"]
}, Open  ]],
Cell[CellGroupData[{
Cell[31054, 907, 662, 20, 52, "Input",ExpressionUUID->"f8bedb07-6b34-4b90-916d-9db4f0658a71"],
Cell[31719, 929, 3244, 92, 51, "Output",ExpressionUUID->"d155d30f-31c2-4378-a1e5-e96029e39999"]
}, Open  ]],
Cell[34978, 1024, 238, 5, 35, "Text",ExpressionUUID->"66bdda0e-6c2d-41e3-9f96-02190149acf5"],
Cell[35219, 1031, 111, 0, 35, "Text",ExpressionUUID->"0929df7b-a1bf-4548-9768-2ddd981640e6"],
Cell[CellGroupData[{
Cell[35355, 1035, 153, 4, 30, "Input",ExpressionUUID->"5bdedb97-e7d8-497a-b7ed-51b9c59761bb"],
Cell[35511, 1041, 84, 0, 34, "Output",ExpressionUUID->"cf7a6dd5-f59d-471f-8a37-be9d4e2495f6"]
}, Open  ]],
Cell[35610, 1044, 102, 0, 35, "Text",ExpressionUUID->"47620db7-1479-4f32-bc6f-dc1ba9b9c4d9"],
Cell[CellGroupData[{
Cell[35737, 1048, 201, 6, 30, "Input",ExpressionUUID->"13828dec-67cb-4996-9aa3-6e0aa80e592c"],
Cell[35941, 1056, 1994, 61, 69, "Output",ExpressionUUID->"a9c048af-417c-4510-a2b6-cf02e6af19ca"]
}, Open  ]],
Cell[37950, 1120, 125, 0, 35, "Text",ExpressionUUID->"7676e574-c9b6-4bf6-9796-0ff4e64d7adc"],
Cell[CellGroupData[{
Cell[38100, 1124, 236, 7, 30, "Input",ExpressionUUID->"96b37544-729a-4500-a5bc-672e8f94751e"],
Cell[38339, 1133, 4889, 138, 75, "Output",ExpressionUUID->"2de08423-b89c-4c33-857a-1ad153c9765d"]
}, Open  ]],
Cell[43243, 1274, 108, 0, 35, "Text",ExpressionUUID->"05efb439-ec84-476c-8760-7876498018e1"],
Cell[CellGroupData[{
Cell[43376, 1278, 217, 6, 30, "Input",ExpressionUUID->"74adb551-29e0-4a17-a9d7-6a2eeda46476"],
Cell[43596, 1286, 10022, 278, 75, "Output",ExpressionUUID->"3ea464a7-d711-4330-9fc1-28a545d0dcec"]
}, Open  ]],
Cell[CellGroupData[{
Cell[53655, 1569, 115, 1, 30, "Input",ExpressionUUID->"1c82269a-1e10-4f9a-91b9-28503b9924db"],
Cell[53773, 1572, 86, 0, 34, "Output",ExpressionUUID->"a398dbff-0c6d-4b89-93a1-df36512675d3"]
}, Open  ]],
Cell[53874, 1575, 130, 0, 35, "Text",ExpressionUUID->"321c2c73-b63e-406b-9dc5-d013cdfa565d"],
Cell[CellGroupData[{
Cell[54029, 1579, 210, 6, 30, "Input",ExpressionUUID->"2cfadac6-2ef5-4e0f-ac4e-19b3dcffeedc"],
Cell[54242, 1587, 83, 0, 34, "Output",ExpressionUUID->"b42f87e7-ddfd-4cd6-bded-cc22a5a85fbe"]
}, Open  ]],
Cell[54340, 1590, 281, 6, 35, "Text",ExpressionUUID->"efc83a62-3080-45ab-8f81-bbed06272d8a"],
Cell[CellGroupData[{
Cell[54646, 1600, 258, 8, 30, "Input",ExpressionUUID->"1c6c695d-9115-4a30-939c-c27c8bbc753d"],
Cell[54907, 1610, 83, 0, 34, "Output",ExpressionUUID->"fe91d877-78ad-49db-9033-579d2ce4e1b6"]
}, Open  ]],
Cell[55005, 1613, 310, 6, 35, "Text",ExpressionUUID->"7a072495-0ca5-415f-a33c-17888d776c51"],
Cell[55318, 1621, 166, 3, 35, "Text",ExpressionUUID->"e531980a-d6f1-432c-8022-c2015c5519cc"],
Cell[CellGroupData[{
Cell[55509, 1628, 109, 1, 30, "Input",ExpressionUUID->"b1adb84f-bf1f-4a9e-8900-e203de52a72c"],
Cell[55621, 1631, 1975, 60, 69, "Output",ExpressionUUID->"bb803c29-b3c3-472c-8457-a573a6b7ffd9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[57633, 1696, 170, 4, 30, "Input",ExpressionUUID->"4e42a73c-a114-43d3-a55d-3a0a20fbc850"],
Cell[57806, 1702, 4426, 125, 39, "Output",ExpressionUUID->"85a553df-5ea6-4fdf-9131-752b87d400ae"]
}, Open  ]],
Cell[CellGroupData[{
Cell[62269, 1832, 118, 1, 30, "Input",ExpressionUUID->"9eea2aa0-225b-4a68-a093-805365050c3a"],
Cell[62390, 1835, 4426, 125, 39, "Output",ExpressionUUID->"a3a8ba3b-cffb-4fa8-a771-49efb649a4cc"]
}, Open  ]],
Cell[CellGroupData[{
Cell[66853, 1965, 174, 4, 30, "Input",ExpressionUUID->"e7541faf-1064-4ec0-a228-647e37704b37"],
Cell[67030, 1971, 1975, 60, 69, "Output",ExpressionUUID->"9e0ae923-bdcd-4e9f-8226-e27c191079cf"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[69054, 2037, 99, 0, 37, "Subsubsection",ExpressionUUID->"bbad4ff0-9a95-487d-b684-132c52ef8cb6"],
Cell[69156, 2039, 108, 0, 35, "Text",ExpressionUUID->"5f2a9822-aefe-40e9-b648-0c084d9c2c90"],
Cell[69267, 2041, 469, 12, 30, "Input",ExpressionUUID->"16ef8119-7018-4600-ae0c-9b63ac171ef6"],
Cell[69739, 2055, 133, 0, 35, "Text",ExpressionUUID->"03bb7142-0853-4dcb-889c-7d613025f837"],
Cell[69875, 2057, 197, 4, 30, "Input",ExpressionUUID->"0c749e99-4e6c-4f81-bee8-e9f468815b5f"],
Cell[70075, 2063, 996, 32, 30, "Input",ExpressionUUID->"fcd08836-ab89-476a-8975-c2881af3a34f"],
Cell[CellGroupData[{
Cell[71096, 2099, 174, 5, 30, "Input",ExpressionUUID->"f7826553-fde2-41b3-b2f7-488981eb395e"],
Cell[71273, 2106, 9481, 256, 111, "Output",ExpressionUUID->"a6d8ee2f-acbd-46cb-a192-0900da125c03"]
}, Open  ]],
Cell[80769, 2365, 236, 4, 58, "Text",ExpressionUUID->"783989b7-b712-4d43-bd48-ef6c77c4da08"],
Cell[81008, 2371, 263, 6, 30, "Input",ExpressionUUID->"65771983-f760-4090-92b2-a5033d5d0f20"],
Cell[81274, 2379, 176, 3, 35, "Text",ExpressionUUID->"04af4414-05ae-43b4-9db7-fe4a6ae21e9b"],
Cell[CellGroupData[{
Cell[81475, 2386, 288, 8, 30, "Input",ExpressionUUID->"3088145e-af6e-4f46-a4be-d16bad31aced"],
Cell[81766, 2396, 391, 12, 34, "Output",ExpressionUUID->"fc1c4d80-6a7f-4726-a201-388a4bbc3085"]
}, Open  ]],
Cell[82172, 2411, 108, 0, 35, "Text",ExpressionUUID->"1103015e-79bf-4306-ad44-d925026fa5cf"],
Cell[CellGroupData[{
Cell[82305, 2415, 207, 6, 30, "Input",ExpressionUUID->"dd693f39-3253-42a2-93e3-222209ddfdba"],
Cell[82515, 2423, 6333, 177, 87, "Output",ExpressionUUID->"bcd944d1-c1f2-47af-84b3-2e68044c487f"]
}, Open  ]],
Cell[88863, 2603, 93, 0, 35, "Text",ExpressionUUID->"cb823a76-74a4-4350-871f-0b5b692b42f9"],
Cell[CellGroupData[{
Cell[88981, 2607, 176, 5, 30, "Input",ExpressionUUID->"3c17cd50-6552-40d6-ab6f-d70609574252"],
Cell[89160, 2614, 620, 24, 61, "Output",ExpressionUUID->"7f8703a1-d7a1-4682-aed8-312ed65bf349"]
}, Open  ]],
Cell[89795, 2641, 127, 0, 35, "Text",ExpressionUUID->"a97f493a-e0e9-4390-828a-bd6eeea68a32"],
Cell[CellGroupData[{
Cell[89947, 2645, 155, 4, 30, "Input",ExpressionUUID->"9bf46615-8dcf-416d-9556-0b36df8d545d"],
Cell[90105, 2651, 4925, 140, 75, "Output",ExpressionUUID->"d8132c18-311d-4323-910c-06c1a60af65d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[95067, 2796, 134, 2, 30, "Input",ExpressionUUID->"deac5a6c-bb9f-48da-84d8-abd892435a83"],
Cell[95204, 2800, 9735, 262, 125, "Output",ExpressionUUID->"deab6ae0-c8c2-4b1d-9429-c9820cafe534"]
}, Open  ]],
Cell[104954, 3065, 111, 0, 35, "Text",ExpressionUUID->"fa19c409-b26a-47b2-bdca-bdfc8e2cf9a2"],
Cell[CellGroupData[{
Cell[105090, 3069, 147, 3, 30, "Input",ExpressionUUID->"59b3da92-0cc8-460a-8a14-33b26642e946"],
Cell[105240, 3074, 782, 28, 37, "Output",ExpressionUUID->"e5c09895-8a7f-43c4-8c0e-3f86fc8eac21"]
}, Open  ]],
Cell[CellGroupData[{
Cell[106059, 3107, 125, 1, 30, "Input",ExpressionUUID->"ae388769-f76b-4f64-a404-183823e31f51"],
Cell[106187, 3110, 100, 1, 34, "Output",ExpressionUUID->"42086c93-cab7-4252-891f-71f458b87fe3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[106324, 3116, 127, 1, 30, "Input",ExpressionUUID->"09cd3165-b354-4581-af33-c36ce2437320"],
Cell[106454, 3119, 140, 3, 34, "Output",ExpressionUUID->"6e66beab-2744-4897-941f-ae0b48e27a76"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[106643, 3128, 106, 0, 37, "Subsubsection",ExpressionUUID->"7ca90206-71af-41db-a244-1e0deb51ae61"],
Cell[106752, 3130, 417, 8, 58, "Text",ExpressionUUID->"98269a25-89bd-4c61-856c-9a5f4a6e68b3"],
Cell[107172, 3140, 149, 2, 35, "Text",ExpressionUUID->"fbf78665-b9ba-444e-9c2f-c4e0cb9b0837"],
Cell[CellGroupData[{
Cell[107346, 3146, 148, 3, 30, "Input",ExpressionUUID->"76efc5b1-8bd9-45d9-9c87-b8dab4175840"],
Cell[107497, 3151, 12530, 374, 215, "Output",ExpressionUUID->"a52a63cb-cede-4785-87be-602dc8fe3777"]
}, Open  ]],
Cell[120042, 3528, 260, 6, 35, "Text",ExpressionUUID->"a82c1392-9425-44e9-998f-3be610d604d1"],
Cell[CellGroupData[{
Cell[120327, 3538, 187, 5, 30, "Input",ExpressionUUID->"bf472f24-40d3-401e-9bb3-7573309bbafe"],
Cell[120517, 3545, 8248, 223, 97, "Output",ExpressionUUID->"8c69c896-7288-4101-84a8-285e96a63564"]
}, Open  ]],
Cell[128780, 3771, 134, 0, 35, "Text",ExpressionUUID->"67733ccf-c4ea-4436-b4d7-2ef1d67d887b"],
Cell[CellGroupData[{
Cell[128939, 3775, 253, 8, 30, "Input",ExpressionUUID->"730ad0d5-af4e-4117-9bdc-a5082987e7b7"],
Cell[129195, 3785, 83, 0, 34, "Output",ExpressionUUID->"f1d5d733-3361-4a54-9d14-1366392e739b"]
}, Open  ]],
Cell[129293, 3788, 113, 0, 35, "Text",ExpressionUUID->"51a26cde-7f4c-46ea-a31e-3de667fe2e6f"],
Cell[CellGroupData[{
Cell[129431, 3792, 551, 18, 30, "Input",ExpressionUUID->"045ef4a1-a917-46fe-a074-d93f3eb880e0"],
Cell[129985, 3812, 35655, 931, 271, "Output",ExpressionUUID->"d4e15b74-3545-4b22-aae2-b9d475ed6dac"]
}, Open  ]],
Cell[165655, 4746, 202, 3, 35, "Text",ExpressionUUID->"1dcbb78c-fa34-4dbb-a0f2-1935ad04cefe"],
Cell[CellGroupData[{
Cell[165882, 4753, 332, 10, 30, "Input",ExpressionUUID->"a6a89cc0-1ae8-46e5-a07b-ea1c9ec46c87"],
Cell[166217, 4765, 75524, 2005, 287, "Output",ExpressionUUID->"a1f6f0ee-e06c-4ef7-9f19-c74254803bc4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[241778, 6775, 112, 1, 30, "Input",ExpressionUUID->"2b1c1ce3-7405-4c8b-a9ed-c45d439d3a4c"],
Cell[241893, 6778, 86, 0, 34, "Output",ExpressionUUID->"8a3fea87-1ae6-4c2e-b173-3dda7d97a54f"]
}, Open  ]],
Cell[241994, 6781, 133, 0, 35, "Text",ExpressionUUID->"3c52aed0-891e-4041-b4de-307b2e2e8c7b"],
Cell[CellGroupData[{
Cell[242152, 6785, 217, 6, 30, "Input",ExpressionUUID->"68137498-23a7-4276-a9bf-fcdd0768de83"],
Cell[242372, 6793, 83, 0, 34, "Output",ExpressionUUID->"65d9dd7b-1854-40ac-a3a2-05ceae100d70"]
}, Open  ]],
Cell[242470, 6796, 120, 0, 35, "Text",ExpressionUUID->"38bf0981-b409-42b3-a113-396e7c5e8156"],
Cell[CellGroupData[{
Cell[242615, 6800, 205, 6, 30, "Input",ExpressionUUID->"50eca37c-e830-4283-a8b6-c5cff4833207"],
Cell[242823, 6808, 83, 0, 34, "Output",ExpressionUUID->"b3c9e351-1f2d-4c73-99c7-310346a8f1bf"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[242955, 6814, 92, 0, 37, "Subsubsection",ExpressionUUID->"77b28e3e-51fa-407f-916e-8ea0440d11f7"],
Cell[243050, 6816, 122, 0, 35, "Text",ExpressionUUID->"6505eda3-6976-4a89-9fd1-1fd023439398"],
Cell[243175, 6818, 122, 1, 30, "Input",ExpressionUUID->"93891727-6827-44f6-aac3-4cf02f346831"],
Cell[243300, 6821, 130, 1, 30, "Input",ExpressionUUID->"e6670f2b-ec81-4a33-a35f-a0cceff5a5b2"],
Cell[243433, 6824, 119, 1, 30, "Input",ExpressionUUID->"2f04506e-a681-42ca-be49-9793de8d1977"],
Cell[243555, 6827, 120, 1, 30, "Input",ExpressionUUID->"0be7eb56-c6b6-49d1-ab45-8a1dac6ec7cf"],
Cell[243678, 6830, 121, 1, 30, "Input",ExpressionUUID->"89a0c184-6cc6-4940-b2ff-1568639529c7"],
Cell[243802, 6833, 121, 1, 30, "Input",ExpressionUUID->"0ef1c1ba-2868-4f95-b63f-fc5f770b3612"],
Cell[243926, 6836, 124, 0, 35, "Text",ExpressionUUID->"f09f8222-226a-4c1a-968e-7ac0bf1c302d"],
Cell[244053, 6838, 200, 4, 30, "Input",ExpressionUUID->"b918b0ca-3235-41c4-ac38-3c7db0a9b49a"],
Cell[244256, 6844, 87, 0, 35, "Text",ExpressionUUID->"120f6191-e3f1-481a-a8b0-8a920d634ecb"],
Cell[244346, 6846, 125, 1, 30, "Input",ExpressionUUID->"39287e4b-5a84-468d-98dd-eaf0f82a1199"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[244520, 6853, 87, 0, 54, "Subsection",ExpressionUUID->"5ed7bbd1-8381-4486-ba9c-601d02a9d6e0"],
Cell[CellGroupData[{
Cell[244632, 6857, 104, 0, 45, "Subsubsection",ExpressionUUID->"7c959dd8-37dd-422c-aba9-8490132a68cb"],
Cell[244739, 6859, 270, 4, 58, "Text",ExpressionUUID->"8d230a8b-359a-4150-b24f-963b93598124"],
Cell[245012, 6865, 149, 2, 35, "Text",ExpressionUUID->"1afdfcf6-ca23-429f-a78c-374b27693560"],
Cell[245164, 6869, 244, 5, 30, "Input",ExpressionUUID->"141d7104-3697-4d14-8992-4f1f0b523baf"],
Cell[245411, 6876, 227, 5, 30, "Input",ExpressionUUID->"f931a117-2794-477e-ac64-ed04ad5fcbfe"],
Cell[245641, 6883, 122, 0, 35, "Text",ExpressionUUID->"d61a4566-14f4-4aa3-a45e-05ed83ba6a9d"],
Cell[245766, 6885, 166, 4, 30, "Input",ExpressionUUID->"3b3f8e21-01da-4745-a413-219384169ae9"],
Cell[245935, 6891, 208, 3, 35, "Text",ExpressionUUID->"4728ac42-1578-404f-8a2e-955414ff0f77"],
Cell[CellGroupData[{
Cell[246168, 6898, 394, 12, 30, "Input",ExpressionUUID->"6b8c34b1-1fc5-479b-b619-8eb1e2790994"],
Cell[246565, 6912, 646, 21, 37, "Output",ExpressionUUID->"c7d68cf1-35a2-49aa-bd97-a5bec9d9b6d1"]
}, Open  ]],
Cell[247226, 6936, 210, 5, 35, "Text",ExpressionUUID->"74103247-8b5f-45e6-97be-935b04f2d900"],
Cell[CellGroupData[{
Cell[247461, 6945, 116, 1, 30, "Input",ExpressionUUID->"56b96a5f-7005-4e0b-852f-db43f8a8f852"],
Cell[247580, 6948, 86, 0, 34, "Output",ExpressionUUID->"ca56e033-ee05-4e1f-84ec-c48dc0d41402"]
}, Open  ]],
Cell[CellGroupData[{
Cell[247703, 6953, 121, 1, 30, "Input",ExpressionUUID->"dafe208e-3b68-4d53-8a8c-452af3a376e2"],
Cell[247827, 6956, 263, 8, 34, "Output",ExpressionUUID->"0da0a11d-dd59-4431-93c1-50bd648d2ae2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[248127, 6969, 129, 1, 30, "Input",ExpressionUUID->"5523d4e7-51f3-4f9c-ae47-4cbc163b5d9f"],
Cell[248259, 6972, 194, 5, 34, "Output",ExpressionUUID->"9bbb091c-0931-4706-ac91-0e037ec4dbc6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[248490, 6982, 128, 1, 30, "Input",ExpressionUUID->"3608cff1-6e92-44a0-949c-5bdf2e3cbe25"],
Cell[248621, 6985, 105, 1, 34, "Output",ExpressionUUID->"f5abbc6f-23e9-45b8-8209-108f36a7ec6c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[248763, 6991, 122, 1, 30, "Input",ExpressionUUID->"3d94abf3-5d77-4b7e-9036-f7e900893cc1"],
Cell[248888, 6994, 83, 0, 34, "Output",ExpressionUUID->"05929b9a-496c-425c-bdd8-7ef52b6570ce"]
}, Open  ]],
Cell[CellGroupData[{
Cell[249008, 6999, 114, 1, 30, "Input",ExpressionUUID->"93c2796f-c6c2-49f0-82fc-03af2082cebf"],
Cell[249125, 7002, 668, 22, 37, "Output",ExpressionUUID->"4924c692-6372-4b1d-9783-bb51d14432ba"]
}, Open  ]],
Cell[249808, 7027, 183, 3, 35, "Text",ExpressionUUID->"7ef064c6-9c97-4e8f-a948-6fcca5b89979"],
Cell[CellGroupData[{
Cell[250016, 7034, 592, 19, 30, "Input",ExpressionUUID->"5160a158-2bed-4d12-9009-92d2b9766918"],
Cell[250611, 7055, 6346, 208, 98, "Output",ExpressionUUID->"e98cdbd1-6496-484e-ad06-f02d195f0a26"]
}, Open  ]],
Cell[CellGroupData[{
Cell[256994, 7268, 116, 1, 30, "Input",ExpressionUUID->"eaf0bb20-2b7b-4088-af7e-1fce299b87c5"],
Cell[257113, 7271, 86, 0, 34, "Output",ExpressionUUID->"0ea61de3-ad62-4786-ad61-1f83258f831e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[257236, 7276, 121, 1, 30, "Input",ExpressionUUID->"5aadad1b-3db4-42da-8ca7-0b940814dba8"],
Cell[257360, 7279, 701, 24, 34, "Output",ExpressionUUID->"c83e799b-3eef-4b69-bbd0-c385dc441874"]
}, Open  ]],
Cell[CellGroupData[{
Cell[258098, 7308, 129, 1, 30, "Input",ExpressionUUID->"22d93194-4a40-421d-addf-a1e9b10ba392"],
Cell[258230, 7311, 700, 23, 34, "Output",ExpressionUUID->"ce8f36d9-e415-44bb-b591-c389343b8e95"]
}, Open  ]],
Cell[CellGroupData[{
Cell[258967, 7339, 128, 1, 30, "Input",ExpressionUUID->"4751f3f4-fc11-451a-8a9a-3e3b58b3c141"],
Cell[259098, 7342, 105, 1, 34, "Output",ExpressionUUID->"eb64bda6-dc3d-4802-b03e-66eeabf18f97"]
}, Open  ]],
Cell[CellGroupData[{
Cell[259240, 7348, 122, 1, 30, "Input",ExpressionUUID->"8a443890-aa6d-44f9-b590-3736d50fe4bf"],
Cell[259365, 7351, 105, 1, 34, "Output",ExpressionUUID->"e7db05a5-3001-4f1b-80df-07279721465b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[259507, 7357, 141, 3, 30, "Input",ExpressionUUID->"6f7632e7-f981-40b7-bc75-b37f821e1f9d"],
Cell[259651, 7362, 86, 0, 34, "Output",ExpressionUUID->"818fde38-27a7-4031-a50d-179a4eeefb45"]
}, Open  ]],
Cell[259752, 7365, 197, 3, 35, "Text",ExpressionUUID->"f296838a-945b-47c1-826b-a27a1d0b9547"],
Cell[CellGroupData[{
Cell[259974, 7372, 344, 11, 30, "Input",ExpressionUUID->"db45d5eb-5d8f-4d03-8b04-64f362ce5407"],
Cell[260321, 7385, 86, 0, 34, "Output",ExpressionUUID->"24e33e7d-97ee-413c-925b-d74bfd166028"]
}, Open  ]],
Cell[CellGroupData[{
Cell[260444, 7390, 137, 3, 30, "Input",ExpressionUUID->"e6e741e1-4909-44b3-8b84-ed53dc20c636"],
Cell[260584, 7395, 83, 0, 34, "Output",ExpressionUUID->"7160982b-3df6-4d07-8ff6-d7b20765e223"]
}, Open  ]],
Cell[260682, 7398, 164, 3, 35, "Text",ExpressionUUID->"004f5540-e1cd-42bf-a55a-25a814a06428"],
Cell[CellGroupData[{
Cell[260871, 7405, 209, 6, 30, "Input",ExpressionUUID->"740a61e3-29ba-429e-824e-b4a54badd41e"],
Cell[261083, 7413, 207, 7, 34, "Output",ExpressionUUID->"e4dda758-85ad-4342-af5c-8e401b8114ab"]
}, Open  ]],
Cell[CellGroupData[{
Cell[261327, 7425, 113, 1, 30, "Input",ExpressionUUID->"07877824-ad76-4c16-979c-80555aa93990"],
Cell[261443, 7428, 76, 0, 45, "Output",ExpressionUUID->"31598936-36f4-47ac-b05a-ca430daca09a"]
}, Open  ]],
Cell[261534, 7431, 141, 1, 35, "Text",ExpressionUUID->"340f01dc-7a14-437b-8da4-662984703670"],
Cell[CellGroupData[{
Cell[261700, 7436, 219, 6, 30, "Input",ExpressionUUID->"7abd9cde-50ba-4234-a056-14a0adb495ad"],
Cell[261922, 7444, 470, 17, 34, "Output",ExpressionUUID->"8f8c1693-a008-401b-8d6e-0f35669406a7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[262429, 7466, 113, 1, 30, "Input",ExpressionUUID->"403e3652-2bc7-4fe7-af78-c382ea64a21f"],
Cell[262545, 7469, 94, 0, 45, "Output",ExpressionUUID->"e6111a3e-7e89-4dd8-8660-0ec78c7c7094"]
}, Open  ]],
Cell[262654, 7472, 106, 0, 35, "Text",ExpressionUUID->"8b6429f0-cbf5-4fc9-b196-b945538d5462"],
Cell[CellGroupData[{
Cell[262785, 7476, 355, 11, 30, "Input",ExpressionUUID->"d4ce6744-ea99-4805-926a-126d098fb150"],
Cell[263143, 7489, 331, 7, 24, "Message",ExpressionUUID->"cc39164a-1723-4ccd-90ad-0a615846b0a7"]
}, Open  ]],
Cell[263489, 7499, 229, 3, 35, "Text",ExpressionUUID->"bddb7097-0541-4d66-9e9c-06129d74441c"]
}, Closed]],
Cell[CellGroupData[{
Cell[263755, 7507, 112, 0, 37, "Subsubsection",ExpressionUUID->"6169964c-0c5f-4274-9979-fa25d0936ea5"],
Cell[263870, 7509, 387, 7, 150, "Text",ExpressionUUID->"3f8c5ca3-ac6b-4a8e-b249-7ab0e8214eca"],
Cell[264260, 7518, 329, 7, 58, "Text",ExpressionUUID->"d6f4b4f4-df15-4b74-8325-3777539d645e"],
Cell[CellGroupData[{
Cell[264614, 7529, 109, 1, 30, "Input",ExpressionUUID->"c4d0920f-8ffe-4a9b-9057-5613f8ea333f"],
Cell[264726, 7532, 3059, 87, 71, "Output",ExpressionUUID->"f97eed27-d287-4643-ac25-19517b0bfdce"]
}, Open  ]],
Cell[267800, 7622, 148, 2, 35, "Text",ExpressionUUID->"a5181b4b-b500-4b57-bb91-65fe9075b019"],
Cell[CellGroupData[{
Cell[267973, 7628, 82, 0, 30, "Input",ExpressionUUID->"2bcac57f-ba2f-40e1-ac78-6269adfc2f8f"],
Cell[268058, 7630, 646, 21, 37, "Output",ExpressionUUID->"253b1fb9-0117-43ff-9f7c-3158594424e7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[268741, 7656, 118, 1, 30, "Input",ExpressionUUID->"ac6436bf-8542-44e4-bf75-0e8604255a33"],
Cell[268862, 7659, 1575, 43, 34, "Output",ExpressionUUID->"b9f696a5-3076-47d6-bfdb-78f1168becc1"]
}, Open  ]],
Cell[270452, 7705, 174, 3, 35, "Text",ExpressionUUID->"8bf973d8-afec-4cbe-b646-74ed59032fa5"],
Cell[CellGroupData[{
Cell[270651, 7712, 201, 6, 30, "Input",ExpressionUUID->"f6aba3af-192e-4f88-82a1-7b4c030a78e6"],
Cell[270855, 7720, 35155, 913, 243, "Output",ExpressionUUID->"ce88d985-252f-46ac-8d2b-9dbd1e10c827"]
}, Open  ]],
Cell[306025, 8636, 164, 3, 35, "Text",ExpressionUUID->"44b82922-b73b-4f8d-9130-ae5f268e6da2"],
Cell[CellGroupData[{
Cell[306214, 8643, 82, 0, 30, "Input",ExpressionUUID->"7233428d-228d-4b9c-8d04-d9e1c54fe33e"],
Cell[306299, 8645, 6346, 208, 98, "Output",ExpressionUUID->"11d27137-f235-419f-bef1-dd426a506e74"]
}, Open  ]],
Cell[312660, 8856, 281, 4, 58, "Text",ExpressionUUID->"e02f4be7-6524-433c-92e7-0c047b642a7f"],
Cell[CellGroupData[{
Cell[312966, 8864, 361, 11, 30, "Input",ExpressionUUID->"68d57cc4-56c1-4f6f-b4a0-cd17a73d0f9c"],
Cell[313330, 8877, 1348, 39, 49, "Output",ExpressionUUID->"02a281bb-eef3-44e2-a383-b8613b419876"]
}, Open  ]],
Cell[314693, 8919, 282, 4, 58, "Text",ExpressionUUID->"c95ad66e-9517-4d46-ac2d-be4bff11851e"],
Cell[314978, 8925, 259, 4, 58, "Text",ExpressionUUID->"53172226-827a-4a5a-b91e-105ba1154da0"],
Cell[CellGroupData[{
Cell[315262, 8933, 100, 0, 30, "Input",ExpressionUUID->"19b1a999-f73f-46b9-ac49-84316d2cd7aa"],
Cell[315365, 8935, 86, 0, 34, "Output",ExpressionUUID->"98373e74-619d-4dbb-b21d-df433259d264"]
}, Open  ]],
Cell[CellGroupData[{
Cell[315488, 8940, 102, 0, 30, "Input",ExpressionUUID->"b6d1903c-f66d-473f-89c8-8e70928e731f"],
Cell[315593, 8942, 103, 0, 34, "Output",ExpressionUUID->"79b2592c-d4d4-4288-8304-e388a78aba2e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[315733, 8947, 604, 20, 30, "Input",ExpressionUUID->"9f5f5df8-bc6e-417a-964b-1852f35730a7"],
Cell[316340, 8969, 4663, 175, 60, "Output",ExpressionUUID->"4dfd674c-2fd9-4afd-b432-8cf5384f8007"]
}, Open  ]],
Cell[CellGroupData[{
Cell[321040, 9149, 113, 1, 30, "Input",ExpressionUUID->"c62d1c58-b58a-435d-863d-c1b1d14e6393"],
Cell[321156, 9152, 160, 3, 34, "Output",ExpressionUUID->"3d498d44-ad99-4ce7-b36b-c0a8914c97d1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[321353, 9160, 778, 25, 30, "Input",ExpressionUUID->"83b623f3-d20b-41d6-8eee-f4afe8487551"],
Cell[322134, 9187, 11698, 284, 75, "Output",ExpressionUUID->"3b6250db-65ff-448a-b570-1cd4a87e4647"]
}, Open  ]],
Cell[333847, 9474, 214, 3, 35, "Text",ExpressionUUID->"57614af5-afab-4778-b5c8-2ffbd766fb98"],
Cell[334064, 9479, 162, 3, 35, "Text",ExpressionUUID->"1fb680b8-5cb6-40b9-93b9-bd18a303b061"],
Cell[CellGroupData[{
Cell[334251, 9486, 109, 1, 30, "Input",ExpressionUUID->"317f5e48-178f-45dd-b559-b175d8b69d97"],
Cell[334363, 9489, 3059, 87, 71, "Output",ExpressionUUID->"6509c785-fbbc-41e3-a3fd-1de8f8b4f232"]
}, Open  ]],
Cell[337437, 9579, 143, 2, 35, "Text",ExpressionUUID->"d0738c2b-ec4f-47d3-8c87-4614e2d8a12f"],
Cell[337583, 9583, 231, 6, 30, "Input",ExpressionUUID->"c11fa16d-0305-40cf-8dbe-e97bf1c75c29"],
Cell[CellGroupData[{
Cell[337839, 9593, 109, 1, 30, "Input",ExpressionUUID->"7b3aea58-1229-4fb5-a265-d56a3e26b1aa"],
Cell[337951, 9596, 1105, 31, 38, "Output",ExpressionUUID->"a44187bb-4fe7-47c8-bc4e-414b1a0ca23b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[339093, 9632, 113, 1, 30, "Input",ExpressionUUID->"f52588c5-2a26-4f11-a986-87bf29b7b1ac"],
Cell[339209, 9635, 115, 0, 45, "Output",ExpressionUUID->"36588b76-de9e-4d4a-b68f-e71538b525fe"]
}, Open  ]],
Cell[339339, 9638, 182, 3, 35, "Text",ExpressionUUID->"72c72cd3-be63-4855-a364-75cffb093861"],
Cell[339524, 9643, 204, 5, 30, "Input",ExpressionUUID->"d39c9191-a050-46e4-bac3-9274f2f8c7c0"],
Cell[CellGroupData[{
Cell[339753, 9652, 109, 1, 30, "Input",ExpressionUUID->"c4f4c37e-ff62-4785-b9e9-a3d6dd3f1275"],
Cell[339865, 9655, 3059, 87, 71, "Output",ExpressionUUID->"4c1cf8af-28f7-4339-89b5-11816b330638"]
}, Open  ]],
Cell[342939, 9745, 174, 3, 35, "Text",ExpressionUUID->"b7cda333-f245-43bf-9b2b-1215784a68a2"],
Cell[CellGroupData[{
Cell[343138, 9752, 549, 17, 30, "Input",ExpressionUUID->"acc7070a-2505-476f-9bb3-f24b94d9bd14"],
Cell[343690, 9771, 4882, 127, 81, "Output",ExpressionUUID->"a06003ce-33dd-49a6-96ef-ded56e1adc99"]
}, Open  ]],
Cell[348587, 9901, 236, 6, 35, "Text",ExpressionUUID->"b8658ef6-ade4-4639-b5f4-98511a68ad42"],
Cell[348826, 9909, 105, 0, 35, "Text",ExpressionUUID->"233d9259-0833-4d9e-b397-90614c4b9da0"],
Cell[CellGroupData[{
Cell[348956, 9913, 163, 4, 30, "Input",ExpressionUUID->"0b1552a8-7e9a-41af-b6ec-7affd3df3dea"],
Cell[349122, 9919, 328, 7, 24, "Message",ExpressionUUID->"bbfb0a86-dad6-4e98-bae2-2a7370461fc1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[349487, 9931, 158, 4, 30, "Input",ExpressionUUID->"6ef84cf2-f42e-4d17-a3aa-78afa9c6ae44"],
Cell[349648, 9937, 480, 9, 24, "Message",ExpressionUUID->"98024ffa-9326-46b9-9dec-90be2450de86"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[350177, 9952, 101, 0, 37, "Subsubsection",ExpressionUUID->"74b040fb-5046-4994-885f-15db19cb2b19"],
Cell[350281, 9954, 213, 5, 35, "Text",ExpressionUUID->"228c234e-0901-41f2-ae43-6c9b4decd6d9"],
Cell[350497, 9961, 158, 3, 35, "Text",ExpressionUUID->"dd3198c3-ede0-4117-ab05-dd423d055bfa"],
Cell[CellGroupData[{
Cell[350680, 9968, 109, 1, 30, "Input",ExpressionUUID->"8a8ecb01-1bcc-4017-9909-83cf3b6287bd"],
Cell[350792, 9971, 3059, 87, 71, "Output",ExpressionUUID->"57955973-2ec9-4bd2-8dc5-938efe8ecb55"]
}, Open  ]],
Cell[CellGroupData[{
Cell[353888, 10063, 199, 6, 30, "Input",ExpressionUUID->"e1c624c5-b761-4638-924c-107dba4395d7"],
Cell[354090, 10071, 3980, 113, 77, "Output",ExpressionUUID->"2c354b3c-e4fb-4bed-b62a-30a7aaac2982"]
}, Open  ]],
Cell[358085, 10187, 141, 1, 35, "Text",ExpressionUUID->"0cafd586-9f82-4600-ad63-88f7019fd1ca"],
Cell[358229, 10190, 284, 8, 30, "Input",ExpressionUUID->"e0d47a26-a0c9-40f4-9b8c-79d295f9e8c0"],
Cell[CellGroupData[{
Cell[358538, 10202, 181, 5, 30, "Input",ExpressionUUID->"9a436ce9-dd56-4ab7-a83d-afbc089fcea2"],
Cell[358722, 10209, 3663, 102, 71, "Output",ExpressionUUID->"25cea661-b282-4ca8-ad41-3b6bb1030b9b"]
}, Open  ]],
Cell[362400, 10314, 209, 3, 35, "Text",ExpressionUUID->"8f7590f7-8662-4822-b187-9460c6b597b9"],
Cell[362612, 10319, 404, 13, 30, "Input",ExpressionUUID->"5cbdb200-db40-4b59-acc2-d8a9c290150a"],
Cell[CellGroupData[{
Cell[363041, 10336, 210, 6, 30, "Input",ExpressionUUID->"589e188c-4964-43a5-bd80-5a42da749d3d"],
Cell[363254, 10344, 2227, 63, 49, "Output",ExpressionUUID->"863d59c9-e40a-4ebc-9951-a916628b79e9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[365518, 10412, 210, 6, 30, "Input",ExpressionUUID->"8bbf21dc-bce0-43f6-b2eb-311413abeb8c"],
Cell[365731, 10420, 2287, 65, 49, "Output",ExpressionUUID->"60ae110b-254a-4674-8d5d-2ffb667961be"]
}, Open  ]],
Cell[368033, 10488, 281, 4, 58, "Text",ExpressionUUID->"64e12b37-52cf-456c-8ecc-4e1955b73819"],
Cell[CellGroupData[{
Cell[368339, 10496, 132, 2, 30, "Input",ExpressionUUID->"95de87c6-be26-4ab5-b331-cb7007f416f5"],
Cell[368474, 10500, 2227, 63, 49, "Output",ExpressionUUID->"66ee1588-30ff-4cc9-9576-a8bdeab39b74"]
}, Open  ]],
Cell[CellGroupData[{
Cell[370738, 10568, 116, 1, 30, "Input",ExpressionUUID->"d4b1d64a-e903-4136-a73f-4d463c3cf23b"],
Cell[370857, 10571, 2227, 63, 49, "Output",ExpressionUUID->"dbf963e1-880f-4acf-9ed0-7faa041cb491"]
}, Open  ]],
Cell[373099, 10637, 250, 4, 58, "Text",ExpressionUUID->"d916cb66-e346-48f2-b445-67af64db1d02"],
Cell[CellGroupData[{
Cell[373374, 10645, 116, 1, 30, "Input",ExpressionUUID->"b712143a-5ef0-453c-92dc-b4cc5f67bd52"],
Cell[373493, 10648, 2227, 63, 49, "Output",ExpressionUUID->"82287c28-3319-4329-b7cd-2cc76a3eb1b8"]
}, Open  ]],
Cell[375735, 10714, 175, 3, 35, "Text",ExpressionUUID->"6fbe5222-b96a-4830-ba94-70ba138afbee"],
Cell[CellGroupData[{
Cell[375935, 10721, 157, 4, 30, "Input",ExpressionUUID->"7a23604d-c239-4761-9352-2f60bf170040"],
Cell[376095, 10727, 9542, 256, 85, "Output",ExpressionUUID->"970eec32-66c6-4509-a596-484f397feb56"]
}, Open  ]],
Cell[CellGroupData[{
Cell[385674, 10988, 181, 5, 30, "Input",ExpressionUUID->"ac690413-4694-4920-ae09-5511e5e55c67"],
Cell[385858, 10995, 11302, 293, 135, "Output",ExpressionUUID->"dcdb50d7-5bf1-4760-b733-7fbb9e545ea9"]
}, Open  ]],
Cell[397175, 11291, 153, 2, 35, "Text",ExpressionUUID->"50242606-8c2e-433b-879d-5731cc216f35"],
Cell[CellGroupData[{
Cell[397353, 11297, 251, 8, 30, "Input",ExpressionUUID->"1a2b163a-15fb-4ec3-88e9-f2fe9533e272"],
Cell[397607, 11307, 16614, 426, 95, "Output",ExpressionUUID->"8993a73c-a531-480d-8543-20897a2da24e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[414258, 11738, 132, 2, 30, "Input",ExpressionUUID->"d52a1ea9-8504-4468-85fb-166949cffa03"],
Cell[414393, 11742, 5172, 129, 77, "Output",ExpressionUUID->"6ec21c66-8ce2-441d-8796-04c1e5054f69"]
}, Open  ]],
Cell[CellGroupData[{
Cell[419602, 11876, 112, 1, 30, "Input",ExpressionUUID->"1e01107a-5547-4d7a-a7a1-3385a610af97"],
Cell[419717, 11879, 83, 0, 34, "Output",ExpressionUUID->"507311c7-5df1-4614-8567-8b004b89d5af"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[419849, 11885, 91, 0, 37, "Subsubsection",ExpressionUUID->"bca63889-fe4e-4c21-b0a4-388150e2c97a"],
Cell[419943, 11887, 472, 7, 81, "Text",ExpressionUUID->"f799e780-c163-4138-b3c7-4366fe1d20c6"],
Cell[420418, 11896, 125, 0, 35, "Text",ExpressionUUID->"4bd80f2e-19e4-41db-a165-884c0eb1d1ac"],
Cell[420546, 11898, 309, 7, 30, "Input",ExpressionUUID->"72b4b84b-c494-4eb4-967b-10fac8cc932e"],
Cell[420858, 11907, 98, 0, 35, "Text",ExpressionUUID->"edd59579-0fc5-4d50-b789-22c236f6ffae"],
Cell[420959, 11909, 326, 9, 30, "Input",ExpressionUUID->"2b5abe7e-e593-4e89-a59a-65e15d4e2a16"],
Cell[421288, 11920, 154, 2, 35, "Text",ExpressionUUID->"c81d1b42-5d11-46ef-9a92-f78abb346162"],
Cell[CellGroupData[{
Cell[421467, 11926, 535, 18, 30, "Input",ExpressionUUID->"e2b24f6c-809a-42d4-a8dd-de6261718e7b"],
Cell[422005, 11946, 807, 27, 37, "Output",ExpressionUUID->"820e6ea9-f6fa-45be-9887-aba83825b3c8"]
}, Open  ]],
Cell[422827, 11976, 108, 0, 35, "Text",ExpressionUUID->"4f5e77f3-cec9-4afd-8a18-a075d38a0d63"],
Cell[CellGroupData[{
Cell[422960, 11980, 141, 3, 30, "Input",ExpressionUUID->"de5e07ce-fa08-4d69-a07d-8cbb6cbc19b1"],
Cell[423104, 11985, 765, 25, 37, "Output",ExpressionUUID->"12cacf48-bea3-4148-ba81-d319aba01cb4"]
}, Open  ]],
Cell[423884, 12013, 117, 0, 35, "Text",ExpressionUUID->"dea64438-fc84-4f2e-a8ac-fbf6affabcce"],
Cell[CellGroupData[{
Cell[424026, 12017, 250, 8, 30, "Input",ExpressionUUID->"af0c8444-e838-4758-b257-b0da5710e1d6"],
Cell[424279, 12027, 2233, 63, 49, "Output",ExpressionUUID->"efcdf8f9-eeec-4b96-a1fb-a61c609bf167"]
}, Open  ]],
Cell[426527, 12093, 239, 4, 58, "Text",ExpressionUUID->"6427ab91-0b2e-4836-9e3a-72d8e8b16540"],
Cell[CellGroupData[{
Cell[426791, 12101, 148, 3, 30, "Input",ExpressionUUID->"8793a338-2cf3-4ec8-b7ce-92da9cde20a9"],
Cell[426942, 12106, 546, 19, 37, "Output",ExpressionUUID->"0bd9c277-a0c5-4be3-81e7-95bd9994694a"]
}, Open  ]],
Cell[427503, 12128, 154, 2, 35, "Text",ExpressionUUID->"f4bcd84f-8f77-4337-971b-a25f7f933abf"],
Cell[CellGroupData[{
Cell[427682, 12134, 117, 1, 30, "Input",ExpressionUUID->"bab8c900-eaba-4bc0-9eed-84ee4fc8fbb2"],
Cell[427802, 12137, 851, 14, 30, "Message",ExpressionUUID->"5f608f1a-70c7-4aaa-9e20-01e0c2a208a2"],
Cell[428656, 12153, 9476, 200, 63, "Output",ExpressionUUID->"ea61c747-af2b-4a76-9142-78f5fd245532"]
}, Open  ]],
Cell[438147, 12356, 166, 3, 35, "Text",ExpressionUUID->"fd6c5295-2819-43ae-982f-8156212ac94e"],
Cell[CellGroupData[{
Cell[438338, 12363, 110, 1, 30, "Input",ExpressionUUID->"e422fffc-3c27-408c-a9f4-085064ba390e"],
Cell[438451, 12366, 1313, 44, 45, "Output",ExpressionUUID->"001f4126-3b96-409a-a11b-78c6e47f2ca0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[439801, 12415, 230, 6, 30, "Input",ExpressionUUID->"46243fb3-fc0d-481d-9e88-d32b3a274239"],
Cell[440034, 12423, 1165, 40, 34, "Output",ExpressionUUID->"683fbc24-4655-4c57-b6b8-560da516ee54"]
}, Open  ]],
Cell[441214, 12466, 366, 7, 58, "Text",ExpressionUUID->"b2502bad-0b45-4f75-a86f-d9e275f6b495"],
Cell[441583, 12475, 222, 3, 35, "Text",ExpressionUUID->"2b3b0cdd-035d-4732-a030-7ab68563d972"],
Cell[441808, 12480, 264, 6, 30, "Input",ExpressionUUID->"17bba426-4ef5-474f-8d1e-c729e3229d00"],
Cell[442075, 12488, 162, 3, 35, "Text",ExpressionUUID->"efacfa61-eefe-42ac-8683-76defe10bd6a"],
Cell[CellGroupData[{
Cell[442262, 12495, 242, 7, 30, "Input",ExpressionUUID->"e5fae051-0dee-4abd-af63-3481bfb20711"],
Cell[442507, 12504, 226, 6, 34, "Output",ExpressionUUID->"291daecb-60e0-4f29-a45c-8deec5335843"]
}, Open  ]],
Cell[CellGroupData[{
Cell[442770, 12515, 109, 1, 30, "Input",ExpressionUUID->"fb6201c1-f498-44d4-a1f8-76c7f89d5f60"],
Cell[442882, 12518, 1597, 48, 43, "Output",ExpressionUUID->"9881a402-ad09-4c78-86b4-fad2ae3b67f4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[444516, 12571, 127, 2, 30, "Input",ExpressionUUID->"9e69d616-1a44-4468-b566-190cc0e3c8e8"],
Cell[444646, 12575, 2769, 78, 45, "Output",ExpressionUUID->"271cfdc1-712c-4656-b6c2-8565a0c8d405"]
}, Open  ]],
Cell[CellGroupData[{
Cell[447452, 12658, 223, 7, 30, "Input",ExpressionUUID->"1ecd167e-d121-4826-99eb-c9ec841607a9"],
Cell[447678, 12667, 2769, 78, 45, "Output",ExpressionUUID->"975addba-97cf-4e8e-ac8f-fc91811c52bc"]
}, Open  ]],
Cell[CellGroupData[{
Cell[450484, 12750, 161, 4, 30, "Input",ExpressionUUID->"6d7e0202-49dc-48aa-9421-6563357c99ba"],
Cell[450648, 12756, 1597, 48, 43, "Output",ExpressionUUID->"9db1dc47-abd6-4c44-ad19-a877f17afdc4"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[452294, 12810, 123, 0, 37, "Subsubsection",ExpressionUUID->"a6d6f0f4-86c9-4d00-affb-7cb29a446f88"],
Cell[452420, 12812, 634, 9, 104, "Text",ExpressionUUID->"0242abc9-e8fb-47cd-b516-0f633ff8a9b6"],
Cell[453057, 12823, 340, 5, 58, "Text",ExpressionUUID->"a8543bc8-574b-4597-a26a-5f1f4138a2ab"],
Cell[453400, 12830, 658, 19, 30, "Input",ExpressionUUID->"89f3c1b7-d819-455a-a16f-e360c9f47e66"],
Cell[454061, 12851, 118, 0, 35, "Text",ExpressionUUID->"16a8b881-c27b-44b3-a1dc-c2ee677e17bc"],
Cell[CellGroupData[{
Cell[454204, 12855, 242, 7, 30, "Input",ExpressionUUID->"52f77bdf-4f08-4dd4-8de9-2253adb39b65"],
Cell[454449, 12864, 226, 6, 34, "Output",ExpressionUUID->"4f8388e4-d89e-47a7-bfd6-d7c84621cf67"]
}, Open  ]],
Cell[454690, 12873, 108, 0, 35, "Text",ExpressionUUID->"a0dd83d8-21b0-4a0e-a756-8f3f55ca3568"],
Cell[CellGroupData[{
Cell[454823, 12877, 169, 4, 30, "Input",ExpressionUUID->"79ed9ff7-1a86-49e3-aa30-cfa86896b317"],
Cell[454995, 12883, 275, 8, 50, "Output",ExpressionUUID->"15fcef6f-3935-4c55-b67f-abda9c285b2f"]
}, Open  ]],
Cell[455285, 12894, 118, 0, 35, "Text",ExpressionUUID->"55ec00c5-ee1b-45d4-8ef6-a1d3d4fc67e9"],
Cell[CellGroupData[{
Cell[455428, 12898, 168, 4, 30, "Input",ExpressionUUID->"7f3ebad3-0013-479e-ab43-d2e42dbaa806"],
Cell[455599, 12904, 226, 6, 34, "Output",ExpressionUUID->"a167bc87-4179-47e9-9f91-3d033a73a4b9"]
}, Open  ]],
Cell[455840, 12913, 118, 0, 35, "Text",ExpressionUUID->"e7784f3e-219e-4c0b-8fcd-0fb8dcb2fe70"],
Cell[CellGroupData[{
Cell[455983, 12917, 220, 6, 30, "Input",ExpressionUUID->"70de3f46-d8c5-4290-a4d0-e1210959f057"],
Cell[456206, 12925, 380, 12, 34, "Output",ExpressionUUID->"01160e67-6742-49c2-8fb2-bda5c91015d5"]
}, Open  ]],
Cell[456601, 12940, 134, 0, 35, "Text",ExpressionUUID->"b44992d4-1caa-44a5-89d5-c04d2885e4f9"],
Cell[CellGroupData[{
Cell[456760, 12944, 218, 6, 30, "Input",ExpressionUUID->"d4dd7230-c00a-46b0-bae6-0e6b7f974464"],
Cell[456981, 12952, 382, 12, 34, "Output",ExpressionUUID->"41a6be7a-d514-4958-b33f-a3dbe47df0c6"]
}, Open  ]],
Cell[457378, 12967, 120, 0, 35, "Text",ExpressionUUID->"785dc785-7fcf-4d0c-85d2-bb27b5fd5bf8"],
Cell[CellGroupData[{
Cell[457523, 12971, 84, 0, 30, "Input",ExpressionUUID->"50c64c12-d951-4515-8ae5-65a098c70121"],
Cell[457610, 12973, 807, 27, 37, "Output",ExpressionUUID->"9be680b8-1e96-42c8-8871-3e5fb1c879dc"]
}, Open  ]],
Cell[CellGroupData[{
Cell[458454, 13005, 239, 7, 30, "Input",ExpressionUUID->"764306ad-f502-41b1-9574-1ea3e83820e0"],
Cell[458696, 13014, 2372, 78, 37, "Output",ExpressionUUID->"57be8e6d-143f-477f-a194-d27a435a51ac"]
}, Open  ]],
Cell[461083, 13095, 201, 3, 35, "Text",ExpressionUUID->"7fb27912-f701-4efe-85d7-eefba13a0401"],
Cell[CellGroupData[{
Cell[461309, 13102, 220, 6, 30, "Input",ExpressionUUID->"358c3871-77bf-48a6-8da8-536fcf6c6fdf"],
Cell[461532, 13110, 382, 12, 34, "Output",ExpressionUUID->"ffd78b80-c14f-4a01-aaec-101d03ad5521"]
}, Open  ]],
Cell[CellGroupData[{
Cell[461951, 13127, 82, 0, 30, "Input",ExpressionUUID->"7d0cdd53-1bfa-4533-8bde-bde2be9c3327"],
Cell[462036, 13129, 226, 6, 34, "Output",ExpressionUUID->"164e81bc-1853-4826-82e6-e1731de4117c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[462299, 13140, 188, 5, 30, "Input",ExpressionUUID->"133f5e14-85e9-4900-a063-451e0111429a"],
Cell[462490, 13147, 624, 21, 37, "Output",ExpressionUUID->"7df0c12f-924f-41c2-8938-4df1ba7f6fff"]
}, Open  ]],
Cell[463129, 13171, 165, 3, 35, "Text",ExpressionUUID->"1b2ab81c-9025-49a2-adfc-9a1e95e5c9c0"],
Cell[463297, 13176, 236, 6, 30, "Input",ExpressionUUID->"e3a76a4f-79af-46a0-b174-4c0aa60ee427"],
Cell[CellGroupData[{
Cell[463558, 13186, 217, 6, 30, "Input",ExpressionUUID->"b96408b9-c5cc-4a29-be5d-eab32b5ec65d"],
Cell[463778, 13194, 5489, 144, 41, "Output",ExpressionUUID->"6c6ff3a4-d4b1-46a0-af90-2ab4284e6666"]
}, Open  ]],
Cell[469282, 13341, 125, 0, 35, "Text",ExpressionUUID->"5dfb437d-a50c-488b-a063-a2c992188c98"],
Cell[CellGroupData[{
Cell[469432, 13345, 345, 10, 30, "Input",ExpressionUUID->"a92cc83b-1770-4d24-810d-ebbf1c8ae2df"],
Cell[469780, 13357, 5080, 139, 41, "Output",ExpressionUUID->"3eea1927-5250-4656-a020-a723038777f6"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[474909, 13502, 106, 0, 37, "Subsubsection",ExpressionUUID->"97b16043-f684-454c-b371-43ff35dd67b0"],
Cell[475018, 13504, 251, 4, 58, "Text",ExpressionUUID->"ae15dff6-63fb-4a59-a483-93fbad828e8e"],
Cell[475272, 13510, 133, 0, 35, "Text",ExpressionUUID->"e0300adb-165b-4d9e-ae0e-344b80f1b8e6"],
Cell[CellGroupData[{
Cell[475430, 13514, 84, 0, 30, "Input",ExpressionUUID->"7b0a1ac3-592d-443f-90a4-ce1df3e72353"],
Cell[475517, 13516, 807, 27, 37, "Output",ExpressionUUID->"c29ad18a-36aa-40ad-a91d-cdff160ea6a2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[476361, 13548, 280, 9, 30, "Input",ExpressionUUID->"51f3ad70-0649-4506-a35e-2f3bc6161a70"],
Cell[476644, 13559, 407, 15, 34, "Output",ExpressionUUID->"a569a7a7-db0a-4044-bfd7-8a6b03eae092"]
}, Open  ]],
Cell[477066, 13577, 122, 0, 35, "Text",ExpressionUUID->"184ea674-bb58-442f-9206-87e854b11549"],
Cell[CellGroupData[{
Cell[477213, 13581, 282, 9, 30, "Input",ExpressionUUID->"22257414-f055-4d7f-822f-d3ab78d9820a"],
Cell[477498, 13592, 480, 17, 34, "Output",ExpressionUUID->"25c086bf-7ad3-4cc9-af19-4ad343795784"]
}, Open  ]],
Cell[CellGroupData[{
Cell[478015, 13614, 353, 11, 30, "Input",ExpressionUUID->"38f5f286-f955-453d-80ea-62df83df93cb"],
Cell[478371, 13627, 7394, 193, 55, "Output",ExpressionUUID->"e6a7b91d-6d56-43ef-b935-e8821ec68ad0"]
}, Open  ]],
Cell[485780, 13823, 100, 0, 35, "Text",ExpressionUUID->"d1478478-43f1-49f0-8ea5-8d48191d159f"],
Cell[CellGroupData[{
Cell[485905, 13827, 281, 9, 30, "Input",ExpressionUUID->"2e2a6bdf-acff-405d-9595-86fcb40cec24"],
Cell[486189, 13838, 100, 1, 34, "Output",ExpressionUUID->"fc841c74-85f6-4aa1-a76f-ac5226cc56b7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[486326, 13844, 352, 11, 30, "Input",ExpressionUUID->"1bafdd1c-d8cc-4d72-97a9-afb9a00d3628"],
Cell[486681, 13857, 4561, 123, 53, "Output",ExpressionUUID->"7bb1052f-3288-4204-89b0-deb72f4524bd"]
}, Open  ]],
Cell[491257, 13983, 121, 0, 35, "Text",ExpressionUUID->"6b887a04-5ec9-45e2-8c4b-817462531d6c"],
Cell[CellGroupData[{
Cell[491403, 13987, 237, 7, 30, "Input",ExpressionUUID->"27f46a65-97c2-43e1-8c21-474d8e0169ba"],
Cell[491643, 13996, 2678, 77, 45, "Output",ExpressionUUID->"703fa52b-361b-458b-809c-93e462fb4508"]
}, Open  ]],
Cell[CellGroupData[{
Cell[494358, 14078, 236, 7, 30, "Input",ExpressionUUID->"91a1c69b-7f8b-4df4-b4eb-97ae1c864ac7"],
Cell[494597, 14087, 2678, 77, 45, "Output",ExpressionUUID->"a34f8641-42cf-492c-a011-f591dd9b3a98"]
}, Open  ]],
Cell[497290, 14167, 150, 2, 35, "Text",ExpressionUUID->"92d03bdb-878c-49a4-8b0a-b433c611bb96"],
Cell[CellGroupData[{
Cell[497465, 14173, 298, 9, 30, "Input",ExpressionUUID->"6ed971af-6d5b-4a07-bd41-05fbd35479c2"],
Cell[497766, 14184, 5225, 150, 41, "Output",ExpressionUUID->"6d49f7ca-0913-4d6f-9db7-c1f6555d5aeb"]
}, Open  ]],
Cell[503006, 14337, 194, 3, 35, "Text",ExpressionUUID->"6088bd8b-9f79-46d9-9f4d-e1e836dd3cea"],
Cell[CellGroupData[{
Cell[503225, 14344, 192, 5, 30, "Input",ExpressionUUID->"1ec7a26d-21e9-4930-ba91-47e42c9cf77e"],
Cell[503420, 14351, 3329, 91, 53, "Output",ExpressionUUID->"73696d69-fa89-48d8-9042-f56c7ce7d7fe"]
}, Open  ]],
Cell[CellGroupData[{
Cell[506786, 14447, 117, 1, 30, "Input",ExpressionUUID->"b0419eaf-c192-4a52-bd17-dbd7d702b174"],
Cell[506906, 14450, 4845, 138, 41, "Output",ExpressionUUID->"45159ae7-f12b-4c35-a8fc-afc23585379a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[511788, 14593, 243, 7, 30, "Input",ExpressionUUID->"f697863b-4547-4160-b986-3dc48a3abdea"],
Cell[512034, 14602, 3329, 91, 53, "Output",ExpressionUUID->"c7374a5f-f193-426e-90e2-df6c67de4629"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[515412, 14699, 92, 0, 37, "Subsubsection",ExpressionUUID->"e796c820-b2e7-4048-94bd-7839eb847cda"],
Cell[515507, 14701, 83, 0, 35, "Text",ExpressionUUID->"b8aebb3b-74f5-4d35-87b3-414dfd6c09c4"],
Cell[515593, 14703, 121, 1, 30, "Input",ExpressionUUID->"f9688776-b262-4194-b958-fc229e57edd2"],
Cell[515717, 14706, 120, 1, 30, "Input",ExpressionUUID->"c09b74e7-8885-45a4-8254-e2dc9b70379d"],
Cell[515840, 14709, 119, 1, 30, "Input",ExpressionUUID->"cbf1f5f1-2be0-4ee4-b170-d7a9896ba713"],
Cell[515962, 14712, 122, 1, 30, "Input",ExpressionUUID->"f9d53db7-aecb-434f-871c-a1dffb3889c8"],
Cell[516087, 14715, 82, 0, 35, "Text",ExpressionUUID->"0333e380-a8d6-4363-9711-57647c2477d3"],
Cell[516172, 14717, 118, 1, 30, "Input",ExpressionUUID->"8e0e8fed-e07b-4906-a56c-48d60edb9482"],
Cell[516293, 14720, 119, 1, 30, "Input",ExpressionUUID->"28088fc1-93f3-4dcf-8cce-b999748d6246"],
Cell[516415, 14723, 121, 1, 30, "Input",ExpressionUUID->"d2501bbf-9e0b-42ac-b089-6e22080b8da2"],
Cell[516539, 14726, 198, 4, 30, "Input",ExpressionUUID->"217251f7-ea44-40eb-bd07-e992a0a7f0d8"],
Cell[516740, 14732, 125, 1, 30, "Input",ExpressionUUID->"419eeed8-f504-4d47-afdf-7231766f85e5"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[516914, 14739, 101, 0, 54, "Subsection",ExpressionUUID->"01eb46be-cc7d-41d9-a962-2fdbfa12545b"],
Cell[CellGroupData[{
Cell[517040, 14743, 102, 0, 45, "Subsubsection",ExpressionUUID->"af240dda-201d-49bc-a7de-259bac6fe361"],
Cell[517145, 14745, 322, 5, 58, "Text",ExpressionUUID->"3791cb2b-a55e-4151-8a3b-c9cd4b2837e9"],
Cell[517470, 14752, 121, 0, 35, "Text",ExpressionUUID->"6ccc7ba7-5bc5-4e81-9116-3159adf6bc08"],
Cell[517594, 14754, 245, 5, 30, "Input",ExpressionUUID->"a12e1e89-3791-4a9e-91f6-8101471c0521"],
Cell[517842, 14761, 323, 9, 30, "Input",ExpressionUUID->"bd98b2af-94d4-4fd4-b9d7-d9ff70807e8c"],
Cell[CellGroupData[{
Cell[518190, 14774, 489, 16, 30, "Input",ExpressionUUID->"8e4644aa-30e8-4cb1-82dc-f256997c56d7"],
Cell[518682, 14792, 598, 20, 37, "Output",ExpressionUUID->"408edab3-7b79-467e-9468-9861eda66697"]
}, Open  ]],
Cell[519295, 14815, 266, 6, 30, "Input",ExpressionUUID->"0ec11f19-2d03-4482-b2e6-047b07c4258e"],
Cell[519564, 14823, 257, 4, 58, "Text",ExpressionUUID->"a16a3aa6-2c85-42d0-99fc-e999c317acf0"],
Cell[CellGroupData[{
Cell[519846, 14831, 148, 3, 30, "Input",ExpressionUUID->"4ff8b86d-ea47-41f8-bd8b-c5b8a063af55"],
Cell[519997, 14836, 1959, 63, 78, "Output",ExpressionUUID->"d89de0e3-eafd-4dfc-ade1-5a0d88811521"]
}, Open  ]],
Cell[521971, 14902, 163, 3, 35, "Text",ExpressionUUID->"569d1a70-1912-4a6c-a81a-3a83f048647e"],
Cell[CellGroupData[{
Cell[522159, 14909, 206, 6, 30, "Input",ExpressionUUID->"d95bdbaf-4c48-4e06-9556-73a59194d2d3"],
Cell[522368, 14917, 1312, 39, 39, "Output",ExpressionUUID->"5a41f271-0e04-45d9-833d-69b02eb29fd0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[523717, 14961, 330, 10, 30, "Input",ExpressionUUID->"9795aa24-02e0-491d-8f23-020b1dc8a141"],
Cell[524050, 14973, 2720, 76, 61, "Output",ExpressionUUID->"ddaa6d15-e0a2-4938-aaed-8a72b185e0da"]
}, Open  ]],
Cell[CellGroupData[{
Cell[526807, 15054, 253, 8, 30, "Input",ExpressionUUID->"1286ab42-8f18-438d-b3f7-c2f49c0ba70c"],
Cell[527063, 15064, 83, 0, 34, "Output",ExpressionUUID->"56f206b2-5c24-4746-abd8-de0cfd084d40"]
}, Open  ]],
Cell[CellGroupData[{
Cell[527183, 15069, 433, 14, 30, "Input",ExpressionUUID->"a3db7985-9892-47ab-9c9a-a092b9bd5000"],
Cell[527619, 15085, 6252, 167, 89, "Output",ExpressionUUID->"f3e887c6-385a-4926-ab81-1e17d1b21ffa"]
}, Open  ]],
Cell[CellGroupData[{
Cell[533908, 15257, 116, 1, 30, "Input",ExpressionUUID->"47d79c10-c7fc-461a-bb1b-99ff92cda64c"],
Cell[534027, 15260, 6259, 168, 89, "Output",ExpressionUUID->"b9f42090-7eb2-45d9-8dea-53f54e103084"]
}, Open  ]],
Cell[540301, 15431, 172, 3, 35, "Text",ExpressionUUID->"c5c7ea12-c089-4112-8217-d68514879655"],
Cell[540476, 15436, 172, 4, 30, "Input",ExpressionUUID->"c99594c9-e9a4-4dae-94cd-ec641b0e6f9f"],
Cell[CellGroupData[{
Cell[540673, 15444, 187, 5, 30, "Input",ExpressionUUID->"06c1890a-f2ef-4f4d-ba26-d3dd0d48016e"],
Cell[540863, 15451, 7865, 191, 39, "Output",ExpressionUUID->"3cd7390c-5e64-4cf2-8a0e-e2b2b8c608f0"]
}, Open  ]],
Cell[548743, 15645, 173, 3, 35, "Text",ExpressionUUID->"567382f4-4d0a-4d0f-9106-3da6f2d1b362"],
Cell[CellGroupData[{
Cell[548941, 15652, 160, 3, 30, "Input",ExpressionUUID->"6759677b-628f-41b7-97fb-e8baceacb41b"],
Cell[549104, 15657, 8463, 232, 89, "Output",ExpressionUUID->"07aea66f-a701-4db1-8e26-e52ebaad5e89"]
}, Open  ]],
Cell[CellGroupData[{
Cell[557604, 15894, 160, 3, 30, "Input",ExpressionUUID->"8df43f75-5a10-4b2d-806c-f457bf7df670"],
Cell[557767, 15899, 22624, 589, 89, "Output",ExpressionUUID->"16e1ead9-f02d-4ba3-b120-423d4883c6f8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[580428, 16493, 115, 1, 30, "Input",ExpressionUUID->"b5959255-2fbe-49c3-8a5c-0e210617ece3"],
Cell[580546, 16496, 22624, 589, 89, "Output",ExpressionUUID->"50ad733e-83f6-40d1-bde2-e87e0f3dbf75"]
}, Open  ]],
Cell[603185, 17088, 228, 3, 35, "Text",ExpressionUUID->"6e52b122-ca97-48ef-b619-378710544d2f"],
Cell[CellGroupData[{
Cell[603438, 17095, 158, 3, 30, "Input",ExpressionUUID->"a4d3681b-1919-4b4b-a003-5b734e7b8feb"],
Cell[603599, 17100, 7865, 191, 39, "Output",ExpressionUUID->"e8356fd9-5170-4788-b95b-dd1ae5c0f558"]
}, Open  ]],
Cell[611479, 17294, 116, 0, 35, "Text",ExpressionUUID->"81884a8e-f186-4cbe-9f62-085bec08b2e6"],
Cell[CellGroupData[{
Cell[611620, 17298, 255, 7, 30, "Input",ExpressionUUID->"1619782b-c208-47f9-928a-a2f9c6921fd2"],
Cell[611878, 17307, 10008, 270, 89, "Output",ExpressionUUID->"5528fdce-e323-4283-a469-d0dc2f25ae6f"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[621935, 17583, 106, 0, 37, "Subsubsection",ExpressionUUID->"aa8d0c0f-540a-43bc-9c7b-c5df10eb698d"],
Cell[622044, 17585, 172, 3, 35, "Text",ExpressionUUID->"ddafaf57-fe4f-4663-a991-4a43e6e46f50"],
Cell[CellGroupData[{
Cell[622241, 17592, 116, 1, 30, "Input",ExpressionUUID->"9be20c86-9d32-467c-b8bb-b5c72423dbc3"],
Cell[622360, 17595, 86, 0, 34, "Output",ExpressionUUID->"a91a7795-dce9-4b49-a814-226a79f2efb6"]
}, Open  ]],
Cell[622461, 17598, 150, 2, 35, "Text",ExpressionUUID->"bdfea921-bd71-4304-9947-386f12dd6b0c"],
Cell[CellGroupData[{
Cell[622636, 17604, 116, 1, 30, "Input",ExpressionUUID->"4529a539-107f-4048-b717-93017e1bda95"],
Cell[622755, 17607, 86, 0, 34, "Output",ExpressionUUID->"6236be11-4822-4f50-b865-ec261ef4c8db"]
}, Open  ]],
Cell[622856, 17610, 115, 0, 35, "Text",ExpressionUUID->"7126ceb5-6172-4f70-b74d-6160e4f78214"],
Cell[CellGroupData[{
Cell[622996, 17614, 489, 16, 30, "Input",ExpressionUUID->"af088a77-a867-4c7f-b5a4-2213600419a3"],
Cell[623488, 17632, 598, 20, 37, "Output",ExpressionUUID->"1b23164a-7553-42d4-b7ad-7dfd1bcd58f7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[624123, 17657, 148, 3, 30, "Input",ExpressionUUID->"e7a7744d-be69-4eff-ae1f-baa3dca0706b"],
Cell[624274, 17662, 2032, 65, 78, "Output",ExpressionUUID->"24e311bb-6451-4d80-8c9a-261791e355de"]
}, Open  ]],
Cell[626321, 17730, 105, 0, 35, "Text",ExpressionUUID->"8935c0be-8ba2-42dc-a95d-d40ab38aa357"],
Cell[CellGroupData[{
Cell[626451, 17734, 217, 6, 30, "Input",ExpressionUUID->"7912cd9b-38ad-4cdc-a487-9a7ccfedde5d"],
Cell[626671, 17742, 83, 0, 34, "Output",ExpressionUUID->"db5e15d4-7fbb-4e87-8590-9261eadcf9c0"]
}, Open  ]],
Cell[626769, 17745, 106, 0, 35, "Text",ExpressionUUID->"a9832359-2401-4bc4-9b53-3d7871439f93"],
Cell[CellGroupData[{
Cell[626900, 17749, 246, 7, 30, "Input",ExpressionUUID->"1ce37c57-7b58-45de-b280-775f3ebe8beb"],
Cell[627149, 17758, 9950, 262, 121, "Output",ExpressionUUID->"e58821db-3052-45f9-a4ab-09d80d083fc3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[637136, 18025, 269, 8, 30, "Input",ExpressionUUID->"9d3b3a0e-b344-4c51-81f8-1f5c815c028a"],
Cell[637408, 18035, 9942, 262, 103, "Output",ExpressionUUID->"bb5f49ab-c977-4d4e-82fa-2d34723b0d01"]
}, Open  ]],
Cell[CellGroupData[{
Cell[647387, 18302, 205, 6, 30, "Input",ExpressionUUID->"d1307a8c-748f-4228-96cc-b485a71f5fa3"],
Cell[647595, 18310, 3537, 97, 65, "Output",ExpressionUUID->"8a14833f-57b9-4d33-9771-98ebe4fdd202"]
}, Open  ]],
Cell[CellGroupData[{
Cell[651169, 18412, 145, 3, 30, "Input",ExpressionUUID->"785ec728-1c6c-43f1-afda-324b7563f668"],
Cell[651317, 18417, 288, 10, 51, "Output",ExpressionUUID->"bf332a4a-54d7-4d62-a87c-2fc69d3e2a19"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[651654, 18433, 92, 0, 37, "Subsubsection",ExpressionUUID->"c03062c3-48b5-4998-bc4b-553a0b216818"],
Cell[651749, 18435, 122, 1, 30, "Input",ExpressionUUID->"297494aa-12f4-49f0-8236-cb946f56526a"],
Cell[651874, 18438, 119, 1, 30, "Input",ExpressionUUID->"2d49f9f0-0f27-4eec-ab17-191bc9df7e8c"],
Cell[651996, 18441, 122, 1, 30, "Input",ExpressionUUID->"2f5b8841-ee89-4441-8e0a-8c9bdf492ada"],
Cell[652121, 18444, 165, 3, 30, "Input",ExpressionUUID->"14a3cb33-0630-4108-bc57-e0dc00117aa6"],
Cell[652289, 18449, 125, 1, 30, "Input",ExpressionUUID->"ba8fe05c-96ff-4939-824d-4a3ab71a0f77"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[652463, 18456, 102, 0, 54, "Subsection",ExpressionUUID->"16db1a3d-bccd-4e44-a636-50b4ad1a9092"],
Cell[652568, 18458, 340, 5, 58, "Text",ExpressionUUID->"c4a50e8c-37f4-4776-8a85-e256bfbd7d05"],
Cell[652911, 18465, 145, 2, 35, "Text",ExpressionUUID->"9c6f6974-15cb-4fdc-9d35-960393d226ee"],
Cell[653059, 18469, 163, 3, 30, "Input",ExpressionUUID->"1cb09ff9-44cb-438e-bdea-5f2c44422e7d",
 Evaluatable->False],
Cell[653225, 18474, 125, 0, 35, "Text",ExpressionUUID->"d24a2a4b-47cb-412b-8fba-6d4d9fdee56a"],
Cell[653353, 18476, 213, 4, 30, "Input",ExpressionUUID->"0ba63123-5448-4705-be77-09f63ba5e2d3",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[653591, 18484, 118, 0, 45, "Subsubsection",ExpressionUUID->"946e877a-5088-4a19-aa0e-98ae3b6d7114"],
Cell[653712, 18486, 131, 1, 30, "Input",ExpressionUUID->"b3884d04-5227-427e-9f87-eb665d9c3dc1"],
Cell[653846, 18489, 170, 4, 30, "Input",ExpressionUUID->"603df35f-0fbe-432b-9995-9ca822008a4c"],
Cell[654019, 18495, 92, 0, 35, "Text",ExpressionUUID->"eb453612-ee59-431e-9a9f-7b163fcd22ea"],
Cell[654114, 18497, 244, 5, 30, "Input",ExpressionUUID->"7e1599a4-2877-44d8-aa63-9469d435191b"],
Cell[654361, 18504, 99, 0, 35, "Text",ExpressionUUID->"a7c63827-d8b5-4e0b-917f-d03a6ab6cce2"],
Cell[654463, 18506, 416, 11, 30, "Input",ExpressionUUID->"40f0916e-9b30-4309-93ae-e66b30634c5f"],
Cell[654882, 18519, 493, 12, 73, "Input",ExpressionUUID->"4ffee666-98a7-4225-9c39-476cc7111dfd"],
Cell[655378, 18533, 87, 0, 35, "Text",ExpressionUUID->"6562e22e-b78e-413f-af95-40649f50d312"],
Cell[655468, 18535, 354, 11, 30, "Input",ExpressionUUID->"58831832-c124-4cbe-b7e5-addfdef30319"],
Cell[CellGroupData[{
Cell[655847, 18550, 796, 23, 50, "Input",ExpressionUUID->"f92e736b-ff73-489c-99af-a57c0187c384"],
Cell[656646, 18575, 3375, 116, 57, "Output",ExpressionUUID->"f38e5fc6-5336-4633-81d5-e9aaeba7c74b"]
}, Open  ]],
Cell[660036, 18694, 194, 3, 35, "Text",ExpressionUUID->"e8cc138e-3ae2-4269-9306-229f91818529"],
Cell[660233, 18699, 555, 14, 30, "Input",ExpressionUUID->"6acfc4a5-3244-4967-a657-3f6c5fe9c4e8"],
Cell[660791, 18715, 113, 0, 35, "Text",ExpressionUUID->"41a4e9ab-6e6d-4f61-9484-60de83929c0f"],
Cell[CellGroupData[{
Cell[660929, 18719, 221, 6, 30, "Input",ExpressionUUID->"c43519c5-4aed-4365-a997-81c29cc96d90"],
Cell[661153, 18727, 3746, 121, 57, "Output",ExpressionUUID->"a748dca6-0e36-4d02-beaf-d83cd082136c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[664936, 18853, 259, 8, 30, "Input",ExpressionUUID->"6add6ba9-fa15-4cee-8549-7c8db4a880bb"],
Cell[665198, 18863, 4466, 141, 101, "Output",ExpressionUUID->"b18a7b83-d020-40cb-8dc8-e40b47aa818b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[669701, 19009, 346, 9, 30, "Input",ExpressionUUID->"c9f91c2a-010e-479d-9959-32a366c675c0"],
Cell[670050, 19020, 2872, 94, 58, "Output",ExpressionUUID->"210cd751-2645-4f34-8ee5-cec0a1302f62"]
}, Open  ]],
Cell[672937, 19117, 175, 3, 30, "Input",ExpressionUUID->"d11e843d-8986-4a01-8bb4-a604607f4c85"],
Cell[673115, 19122, 115, 0, 35, "Text",ExpressionUUID->"9adb66bd-d77c-4929-882d-152b317c4fd6"],
Cell[673233, 19124, 550, 18, 50, "Input",ExpressionUUID->"6ebd11d5-4600-4db7-9420-9e1b3fe90d7a"],
Cell[CellGroupData[{
Cell[673808, 19146, 608, 18, 30, "Input",ExpressionUUID->"0e469695-83ec-48a1-9d46-4ef6900f4d74"],
Cell[674419, 19166, 8024, 251, 109, "Output",ExpressionUUID->"19ac0a56-9ff9-431d-b974-1db28bd565c2"]
}, Open  ]],
Cell[682458, 19420, 142, 2, 35, "Text",ExpressionUUID->"34671351-a0b2-4be7-81ce-041283cc15fa"],
Cell[CellGroupData[{
Cell[682625, 19426, 300, 7, 30, "Input",ExpressionUUID->"688170f6-15d7-41d8-b1ea-64ece524b752"],
Cell[682928, 19435, 141, 3, 34, "Output",ExpressionUUID->"fb777e1e-bf30-4f28-9ee9-6c8df732408f"]
}, Open  ]],
Cell[683084, 19441, 116, 0, 35, "Text",ExpressionUUID->"f063371e-6d9f-4cc5-9e19-675db7102e8d"],
Cell[CellGroupData[{
Cell[683225, 19445, 240, 7, 30, "Input",ExpressionUUID->"180a2e3a-7392-425b-8690-d1a354937c36"],
Cell[683468, 19454, 17322, 540, 155, "Output",ExpressionUUID->"cfe08472-73eb-4e2b-afac-00df35aed157"]
}, Open  ]],
Cell[700805, 19997, 97, 0, 35, "Text",ExpressionUUID->"257ab56c-e2f7-4571-aa4a-36c507728777"],
Cell[CellGroupData[{
Cell[700927, 20001, 259, 6, 30, "Input",ExpressionUUID->"c0d3dd71-7a91-47c5-80dc-2d27929e1c27"],
Cell[701189, 20009, 141, 3, 34, "Output",ExpressionUUID->"07bc8d64-b39e-4fb9-8f89-401806c3767d"]
}, Open  ]],
Cell[701345, 20015, 283, 4, 58, "Text",ExpressionUUID->"1dddc67b-4cb7-4a5d-9e5e-a50a2e599b95"],
Cell[CellGroupData[{
Cell[701653, 20023, 205, 5, 30, "Input",ExpressionUUID->"ad3f8c5f-d29d-43d7-8a1d-f6ca14671c0f"],
Cell[701861, 20030, 141, 3, 34, "Output",ExpressionUUID->"7d7c03c9-1b17-4beb-a833-4b58e79500ce"]
}, Open  ]],
Cell[702017, 20036, 91, 0, 35, "Text",ExpressionUUID->"7b64b8c8-bf67-4e62-8c71-1f77a52ce73f"],
Cell[702111, 20038, 170, 4, 30, "Input",ExpressionUUID->"94babfc7-3724-4b7e-a6ba-a18f08ec607f"],
Cell[CellGroupData[{
Cell[702306, 20046, 145, 3, 30, "Input",ExpressionUUID->"c37ee9f8-6fce-4c66-badc-4592ae6e16de"],
Cell[702454, 20051, 83, 0, 34, "Output",ExpressionUUID->"75f9fdf0-e429-4f59-a718-e0aebab19944"]
}, Open  ]],
Cell[702552, 20054, 120, 0, 35, "Text",ExpressionUUID->"f6cc2349-a999-48a2-8aa4-08d1e2ac4a06"],
Cell[CellGroupData[{
Cell[702697, 20058, 114, 1, 30, "Input",ExpressionUUID->"1298d990-ce3c-46da-a3a9-d5481861cef3"],
Cell[702814, 20061, 9825, 304, 109, "Output",ExpressionUUID->"e2f61a64-88b5-4fb8-81ee-116798c674b0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[712676, 20370, 172, 5, 30, "Input",ExpressionUUID->"8979b816-37cc-48ea-839d-e39c15826125"],
Cell[712851, 20377, 19239, 463, 95, "Output",ExpressionUUID->"13ed93e6-f047-4605-892e-38e9d8687348"]
}, Open  ]],
Cell[CellGroupData[{
Cell[732127, 20845, 145, 3, 30, "Input",ExpressionUUID->"8794c980-7e57-4d22-9fd2-df9b007f6c76"],
Cell[732275, 20850, 14707, 486, 129, "Output",ExpressionUUID->"38830260-75e7-4224-b8e3-0146652c2952"]
}, Open  ]],
Cell[CellGroupData[{
Cell[747019, 21341, 116, 1, 30, "Input",ExpressionUUID->"6852fa8e-9d39-43f8-9e26-28edb5d7de52"],
Cell[747138, 21344, 286527, 7681, 2191, "Output",ExpressionUUID->"e8811d00-8a1e-48be-a5e6-d01c29de9762"]
}, Open  ]],
Cell[1033680, 29028, 98, 0, 35, "Text",ExpressionUUID->"fcca58b1-25ef-4582-9113-bb08ddaef2be"],
Cell[1033781, 29030, 246, 6, 30, "Input",ExpressionUUID->"2ad84f4a-6fc3-48f3-8ec3-525a978a7810"],
Cell[CellGroupData[{
Cell[1034052, 29040, 793, 25, 52, "Input",ExpressionUUID->"a480ba8c-d490-471d-99b4-26c63fd6054e"],
Cell[1034848, 29067, 138, 3, 34, "Output",ExpressionUUID->"8d4e43f4-0691-4d3b-995a-d7086110cad3"]
}, Open  ]],
Cell[1035001, 29073, 80, 0, 35, "Text",ExpressionUUID->"d9067f14-7725-4050-87d3-999b411aa4f5"],
Cell[1035084, 29075, 125, 1, 30, "Input",ExpressionUUID->"f4d09861-8c7b-444e-8579-1f83fb755182"],
Cell[1035212, 29078, 217, 5, 30, "Input",ExpressionUUID->"8f9fbfe2-c79d-47e5-a5df-8e6cea3bcb8d"],
Cell[1035432, 29085, 222, 5, 30, "Input",ExpressionUUID->"ab4283b5-5256-4fab-a404-1dda05472990"],
Cell[1035657, 29092, 122, 1, 30, "Input",ExpressionUUID->"9a912ec4-5d2b-41b9-8a6d-a65276ddec6a"],
Cell[1035782, 29095, 119, 1, 30, "Input",ExpressionUUID->"cb4db2dc-9b6c-41cb-9592-94b6b920d429"],
Cell[1035904, 29098, 121, 1, 30, "Input",ExpressionUUID->"171a2aed-f1d9-4300-865e-ec0ab1638a71"],
Cell[1036028, 29101, 87, 0, 35, "Text",ExpressionUUID->"9ccd2355-9c15-44ac-98fd-18f6fb4e625e"],
Cell[1036118, 29103, 125, 1, 30, "Input",ExpressionUUID->"0ec9c9b4-7291-41e6-a2fd-0201704a65cd"]
}, Closed]],
Cell[CellGroupData[{
Cell[1036280, 29109, 126, 0, 37, "Subsubsection",ExpressionUUID->"da9aeebf-8b52-4c1d-b5e6-e1e320aed1cd"],
Cell[1036409, 29111, 131, 1, 30, "Input",ExpressionUUID->"2df56329-73ec-4513-9109-c724b9014f49"],
Cell[1036543, 29114, 170, 4, 30, "Input",ExpressionUUID->"a4181ad7-ea56-4667-9685-b370776e3791"],
Cell[1036716, 29120, 92, 0, 35, "Text",ExpressionUUID->"74162809-8680-46df-b4ab-fe6c0d535cee"],
Cell[1036811, 29122, 244, 5, 30, "Input",ExpressionUUID->"1bc516fe-d590-494c-9c9d-1706b99001fc"],
Cell[1037058, 29129, 92, 0, 35, "Text",ExpressionUUID->"7b5214a2-e727-485b-b55e-0af9685d44b2"],
Cell[1037153, 29131, 313, 9, 30, "Input",ExpressionUUID->"e95202bf-1edb-4443-baa4-67d476fcd998"],
Cell[1037469, 29142, 115, 0, 35, "Text",ExpressionUUID->"6c2fea67-c6d8-482c-8d68-162ee8e828d5"],
Cell[1037587, 29144, 206, 5, 30, "Input",ExpressionUUID->"3297831c-356f-4bf7-a1ad-b1f857ae511b"],
Cell[CellGroupData[{
Cell[1037818, 29153, 1110, 35, 52, "Input",ExpressionUUID->"a360bb2c-dcf1-4dc0-8cd2-122120989c5c"],
Cell[1038931, 29190, 8151, 219, 49, "Output",ExpressionUUID->"41659e77-7641-464b-97a2-81d925b1d981"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1047119, 29414, 134, 1, 30, "Input",ExpressionUUID->"5a8b72c0-4db1-4e17-990a-094d1e454f22"],
Cell[1047256, 29417, 415, 13, 34, "Output",ExpressionUUID->"bd68bd28-6e93-4b88-b344-6d8eea5e7351"]
}, Open  ]],
Cell[1047686, 29433, 144, 2, 35, "Text",ExpressionUUID->"17106acf-564a-4a52-9bfc-8066e7551f83"],
Cell[1047833, 29437, 196, 5, 30, "Input",ExpressionUUID->"760753ed-9e70-4ff1-87b6-95c9ab1926da"],
Cell[CellGroupData[{
Cell[1048054, 29446, 1504, 47, 52, "Input",ExpressionUUID->"a5ecdfa5-c718-462f-ae15-f545b4ea84cc"],
Cell[1049561, 29495, 10796, 278, 77, "Output",ExpressionUUID->"3b4d5483-91a7-463b-b509-3cbe676fbff4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1060394, 29778, 137, 2, 30, "Input",ExpressionUUID->"526bcaf6-daff-4318-8d7e-5726868b70e0"],
Cell[1060534, 29782, 439, 14, 34, "Output",ExpressionUUID->"e74320c3-b0f6-4ae0-88cb-a0bf6717494f"]
}, Open  ]],
Cell[1060988, 29799, 128, 0, 35, "Text",ExpressionUUID->"a858c619-c7fd-4857-bc01-10066c7679c3"],
Cell[CellGroupData[{
Cell[1061141, 29803, 197, 4, 30, "Input",ExpressionUUID->"136dcce8-57ff-4319-b67f-132a1fb99f0d"],
Cell[1061341, 29809, 2273, 35, 24, "Message",ExpressionUUID->"2a6a5b8a-2f14-46c9-a851-c6e756ba33f3"],
Cell[1063617, 29846, 141, 3, 34, "Output",ExpressionUUID->"57d1e141-9002-4749-bd0e-ba6fcb007669"]
}, Open  ]],
Cell[1063773, 29852, 141, 2, 35, "Text",ExpressionUUID->"01a76dbe-6b1d-4073-b0e1-d0bae4dbf029"],
Cell[CellGroupData[{
Cell[1063939, 29858, 151, 3, 30, "Input",ExpressionUUID->"f8564750-6e0a-458b-b700-6324fe7e5ee8"],
Cell[1064093, 29863, 83458, 2250, 509, "Output",ExpressionUUID->"10a0d2a3-5546-44af-a3a5-368d4de51ef3"]
}, Open  ]],
Cell[1147566, 32116, 102, 0, 35, "Text",ExpressionUUID->"4b5bc727-effd-41ec-9024-5c66a404edb1"],
Cell[CellGroupData[{
Cell[1147693, 32120, 149, 3, 30, "Input",ExpressionUUID->"a1817a78-148c-4599-aba2-fd2c6ca71196"],
Cell[1147845, 32125, 86, 0, 34, "Output",ExpressionUUID->"3b888d93-4a3e-4671-a12c-e3811b9436fd"]
}, Open  ]],
Cell[1147946, 32128, 111, 0, 35, "Text",ExpressionUUID->"06fc9fe2-d1b2-47d5-9ef1-c338651e46ad"],
Cell[CellGroupData[{
Cell[1148082, 32132, 183, 4, 30, "Input",ExpressionUUID->"4ceba1e9-bbdf-4cf8-8edb-04a80b199066"],
Cell[1148268, 32138, 76168, 2152, 491, "Output",ExpressionUUID->"caba8118-7fcc-42eb-b800-39aaf5cc94b0"]
}, Open  ]],
Cell[1224451, 34293, 158, 3, 35, "Text",ExpressionUUID->"a9ab312c-2ce9-4bb1-baaf-5c4fcd600f46"],
Cell[CellGroupData[{
Cell[1224634, 34300, 520, 16, 30, "Input",ExpressionUUID->"adda1516-bb0a-40bd-8b19-7100c07c3ef5"],
Cell[1225157, 34318, 86, 0, 34, "Output",ExpressionUUID->"4888d7ad-01e5-4381-87e9-de0cfc79155d"]
}, Open  ]],
Cell[1225258, 34321, 163, 3, 35, "Text",ExpressionUUID->"6a9a8d78-beb9-4cb1-80ba-f907b814f316"],
Cell[CellGroupData[{
Cell[1225446, 34328, 155, 3, 30, "Input",ExpressionUUID->"2116066b-5ca9-45c4-ae28-3b0eb905349a"],
Cell[1225604, 34333, 86, 0, 34, "Output",ExpressionUUID->"24a8cb12-65f0-4aca-b3ac-ffcacf4208bb"]
}, Open  ]],
Cell[1225705, 34336, 96, 0, 35, "Text",ExpressionUUID->"c2d2b475-e61d-4cb7-9935-5c8cd5abd9c1"],
Cell[CellGroupData[{
Cell[1225826, 34340, 147, 3, 30, "Input",ExpressionUUID->"a6844b2e-43c1-4427-8728-d0b3f2bb6211"],
Cell[1225976, 34345, 583736, 15006, 2260, "Output",ExpressionUUID->"9dec9566-57ed-4522-a47a-d9d72be7a08a"]
}, Open  ]],
Cell[1809727, 49354, 164, 3, 35, "Text",ExpressionUUID->"c9d81ef5-9424-431d-9a9c-ed612df1b7aa"],
Cell[CellGroupData[{
Cell[1809916, 49361, 155, 3, 30, "Input",ExpressionUUID->"34aeb4aa-326f-4954-89e4-9e11d2a3e186"],
Cell[1810074, 49366, 286725, 7427, 1133, "Output",ExpressionUUID->"93702785-dc53-46cd-8ff2-66a219cadadc"]
}, Open  ]],
Cell[2096814, 56796, 108, 0, 35, "Text",ExpressionUUID->"25970f15-a0bf-4aaf-8ab1-a4edb1e3cdc5"],
Cell[CellGroupData[{
Cell[2096947, 56800, 137, 2, 30, "Input",ExpressionUUID->"d6c82b8b-f28e-4a04-ae96-73468a15f8b9"],
Cell[2097087, 56804, 439, 14, 34, "Output",ExpressionUUID->"cf5e1149-8aba-4fc4-acc4-01a85e96c020"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2097563, 56823, 141, 2, 30, "Input",ExpressionUUID->"c4983cea-c516-497e-b0fe-26cac523b064"],
Cell[2097707, 56827, 964, 32, 34, "Output",ExpressionUUID->"af25d06d-6452-41b3-b2bf-7a23e9fe774d"]
}, Open  ]],
Cell[2098686, 56862, 94, 0, 35, "Text",ExpressionUUID->"1df0f23c-eb74-4f5c-a61f-1d2cec8b562c"],
Cell[CellGroupData[{
Cell[2098805, 56866, 276, 6, 30, "Input",ExpressionUUID->"075fd3e3-87c0-4e9f-b995-34f6f914510f"],
Cell[2099084, 56874, 141, 3, 34, "Output",ExpressionUUID->"6f3ce1cb-be78-4c1a-8d5d-2f2c2cb04d04"]
}, Open  ]],
Cell[2099240, 56880, 201, 3, 35, "Text",ExpressionUUID->"a6137975-2efc-4739-9042-17dd0381ae61"],
Cell[2099444, 56885, 103, 0, 35, "Text",ExpressionUUID->"48941fa1-3ee2-4bb7-9d4f-bd5e69c158f6"],
Cell[CellGroupData[{
Cell[2099572, 56889, 145, 3, 30, "Input",ExpressionUUID->"20cb2f7f-9e1a-4298-bc0e-02527fce0cfc"],
Cell[2099720, 56894, 56873, 1847, 266, "Output",ExpressionUUID->"9cfb7acd-c706-4667-9df6-783801eb2cb7"]
}, Open  ]],
Cell[2156608, 58744, 124, 0, 35, "Text",ExpressionUUID->"95825bce-2ae8-418c-aac7-921f51ed5e0f"],
Cell[CellGroupData[{
Cell[2156757, 58748, 208, 6, 30, "Input",ExpressionUUID->"21638600-d6da-4c95-8203-f29a576bc3d1"],
Cell[2156968, 58756, 83, 0, 34, "Output",ExpressionUUID->"c8e0ec1e-cff2-435e-9bdc-b840834417aa"]
}, Open  ]],
Cell[2157066, 58759, 118, 0, 35, "Text",ExpressionUUID->"05e1e0ca-3037-499c-817b-bfabba9dec65"],
Cell[CellGroupData[{
Cell[2157209, 58763, 147, 3, 30, "Input",ExpressionUUID->"40bbc31c-0c93-4364-b3d9-aefb36d8c829"],
Cell[2157359, 58768, 54921, 1525, 347, "Output",ExpressionUUID->"e6443e6f-2ac1-4f06-9492-acccc6caa72b"]
}, Open  ]],
Cell[2212295, 60296, 107, 0, 35, "Text",ExpressionUUID->"f4201740-5e2a-4b8a-ae0e-f135ea2a4ce1"],
Cell[CellGroupData[{
Cell[2212427, 60300, 161, 3, 30, "Input",ExpressionUUID->"06c6bf48-f5c2-4e8f-bd0a-c87b6d6ac444"],
Cell[2212591, 60305, 86, 0, 34, "Output",ExpressionUUID->"95bd4597-db1e-45b4-b37c-d7b9f2b51a0f"]
}, Open  ]],
Cell[2212692, 60308, 104, 0, 35, "Text",ExpressionUUID->"d030cd31-e1ec-4e27-810d-f2f163d8f5ad"],
Cell[CellGroupData[{
Cell[2212821, 60312, 126, 1, 30, "Input",ExpressionUUID->"7ec72f6f-e9f1-47da-a623-cb1383f2f99e"],
Cell[2212950, 60315, 25798, 809, 130, "Output",ExpressionUUID->"5222e91d-f7b1-405f-abb8-47e31a8817a3"]
}, Open  ]],
Cell[2238763, 61127, 130, 0, 35, "Text",ExpressionUUID->"415f5cca-c16b-4201-99e3-08b24e56cdb0"],
Cell[CellGroupData[{
Cell[2238918, 61131, 213, 5, 30, "Input",ExpressionUUID->"4d438762-0f36-47b7-bb96-84cbd84d1bd3"],
Cell[2239134, 61138, 47333, 1377, 260, "Output",ExpressionUUID->"22f9503f-f19e-4f8d-9e7d-185af421ee0f"]
}, Open  ]],
Cell[2286482, 62518, 125, 0, 35, "Text",ExpressionUUID->"83a5afdd-56b3-407f-9ace-d4c66a47b66c"],
Cell[CellGroupData[{
Cell[2286632, 62522, 508, 16, 30, "Input",ExpressionUUID->"8ca55167-195b-4823-ab97-307efdd57999"],
Cell[2287143, 62540, 86, 0, 34, "Output",ExpressionUUID->"cf06a684-ae0c-48fe-b78c-732062614adf"]
}, Open  ]],
Cell[2287244, 62543, 114, 0, 35, "Text",ExpressionUUID->"046cef0b-ade6-4e01-a479-c83af98e47df"],
Cell[CellGroupData[{
Cell[2287383, 62547, 357, 11, 30, "Input",ExpressionUUID->"e91a6835-ef13-4c1a-b32e-3750564875b2"],
Cell[2287743, 62560, 72304, 1551, 77, "Output",ExpressionUUID->"6cad2eee-9a22-4506-bf30-e6d439c663ec"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2360084, 64116, 112, 1, 30, "Input",ExpressionUUID->"045b9d2e-4e39-4503-87be-69aef118aaec"],
Cell[2360199, 64119, 54625, 1583, 374, "Output",ExpressionUUID->"7c9bd401-901e-4e4e-9718-2c5ae5862981"]
}, Open  ]],
Cell[2414839, 65705, 100, 0, 35, "Text",ExpressionUUID->"9a727545-4d86-4bfa-9a61-a273ce717591"],
Cell[CellGroupData[{
Cell[2414964, 65709, 186, 4, 30, "Input",ExpressionUUID->"50b6a309-c669-4e9d-91de-63335b3fe4d6"],
Cell[2415153, 65715, 86, 0, 34, "Output",ExpressionUUID->"5f3245c8-d20c-4a31-bf46-d5e6abb11814"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2415276, 65720, 183, 4, 30, "Input",ExpressionUUID->"46123a57-6eaa-4712-87e0-5c070367e3c5"],
Cell[2415462, 65726, 86, 0, 34, "Output",ExpressionUUID->"f189bb66-03f5-4185-a3b6-ffd5fa4c12dd"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2415585, 65731, 153, 3, 30, "Input",ExpressionUUID->"50e486d6-a3db-4864-9289-b22207b6a547"],
Cell[2415741, 65736, 86, 0, 34, "Output",ExpressionUUID->"2ef40a10-a610-4e8e-8707-0022fafa33a7"]
}, Open  ]],
Cell[2415842, 65739, 88, 0, 35, "Text",ExpressionUUID->"a5a9e91c-e97a-4565-991c-48df964becc2"],
Cell[CellGroupData[{
Cell[2415955, 65743, 118, 1, 30, "Input",ExpressionUUID->"c60198fd-2a72-4821-b3c5-e6cf92b66f95"],
Cell[2416076, 65746, 9001558, 187026, 1764, "Output",ExpressionUUID->"3c157461-53ef-4fe3-bad1-8e3b09c49a4e"]
}, Open  ]],
Cell[11417649, 252775, 105, 0, 35, "Text",ExpressionUUID->"75ae144c-8a9c-42cd-b653-b79c9c64313f"],
Cell[CellGroupData[{
Cell[11417779, 252779, 307, 8, 30, "Input",ExpressionUUID->"1a4c0b3f-0e75-41c4-905b-31c20de71068"],
Cell[11418089, 252789, 215, 6, 34, "Output",ExpressionUUID->"2bf09d0c-e360-4a23-85dd-83210e2042c7"]
}, Open  ]],
Cell[11418319, 252798, 160, 3, 30, "Input",ExpressionUUID->"4d72d9eb-6b48-4cef-8ef8-130f36262930"],
Cell[CellGroupData[{
Cell[11418504, 252805, 118, 1, 30, "Input",ExpressionUUID->"a8bcb955-2fd1-4e5c-a55b-3253b5a5ca8d"],
Cell[11418625, 252808, 8683681, 180123, 1574, "Output",ExpressionUUID->"5ec7d667-46c6-4fe5-8ba1-a61ba25dfbe1"]
}, Open  ]],
Cell[20102321, 432934, 80, 0, 35, "Text",ExpressionUUID->"d05d2b5d-798c-4fb4-b968-c847bb40291d"],
Cell[20102404, 432936, 125, 1, 30, "Input",ExpressionUUID->"17c77f6e-1056-4dce-84df-54c1687f32b1"],
Cell[20102532, 432939, 255, 5, 30, "Input",ExpressionUUID->"cbe5241f-5a36-48fe-bdea-b3eda66c3589"],
Cell[20102790, 432946, 163, 3, 30, "Input",ExpressionUUID->"8168cebf-6ac0-42bf-973c-26d722ea9d1d"],
Cell[20102956, 432951, 120, 1, 30, "Input",ExpressionUUID->"04d9a14b-9ce9-431b-b334-4053a9adb674"],
Cell[20103079, 432954, 121, 1, 30, "Input",ExpressionUUID->"e658af7b-b911-44f5-b6fa-befae59e8a23"],
Cell[20103203, 432957, 125, 1, 30, "Input",ExpressionUUID->"b372d9b5-fe85-4099-995a-f9cce512b965"]
}, Closed]],
Cell[CellGroupData[{
Cell[20103365, 432963, 126, 0, 37, "Subsubsection",ExpressionUUID->"607bdf2e-5276-4f6d-b199-5ca097fea7b5"],
Cell[20103494, 432965, 121, 0, 35, "Text",ExpressionUUID->"b4b70708-b196-4da8-b1de-8815840ef13a"],
Cell[20103618, 432967, 131, 1, 30, "Input",ExpressionUUID->"5e98d7ad-4e48-425f-a7c6-1db94e7268c2"],
Cell[20103752, 432970, 170, 4, 30, "Input",ExpressionUUID->"995727df-2f40-4854-84d3-b23036a395d9"],
Cell[20103925, 432976, 92, 0, 35, "Text",ExpressionUUID->"ed3e69ce-d19a-4223-8ab5-3883a9f4a587"],
Cell[20104020, 432978, 244, 5, 30, "Input",ExpressionUUID->"841167af-3578-43b3-99e0-762f1db9cc00"],
Cell[20104267, 432985, 359, 10, 30, "Input",ExpressionUUID->"7ccd07f6-a545-477d-a184-02a85cff4b0a"],
Cell[20104629, 432997, 108, 0, 35, "Text",ExpressionUUID->"55ed7a7d-6f18-4853-854c-838e21d1263d"],
Cell[20104740, 432999, 252, 7, 30, "Input",ExpressionUUID->"84535cce-f26a-4603-8fde-512d32e8baae"],
Cell[CellGroupData[{
Cell[20105017, 433010, 2276, 66, 73, "Input",ExpressionUUID->"516662e3-ae66-40fd-9b29-9ac13e604741"],
Cell[20107296, 433078, 20879, 553, 63, "Output",ExpressionUUID->"35059ab4-8d5e-4832-976f-f665cdef440b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[20128212, 433636, 134, 1, 30, "Input",ExpressionUUID->"a4041dfc-b025-4111-a813-878d2f7bd99a"],
Cell[20128349, 433639, 415, 13, 34, "Output",ExpressionUUID->"6956baed-f234-4a4a-b047-8eda708f5a87"]
}, Open  ]],
Cell[20128779, 433655, 298, 7, 30, "Input",ExpressionUUID->"4b6b69c1-d17b-421e-9b7f-54b5c3059bf7"],
Cell[CellGroupData[{
Cell[20129102, 433666, 5526, 147, 367, "Input",ExpressionUUID->"3e3bd4cc-b938-402a-bb2f-2e163d0d8549"],
Cell[20134631, 433815, 48533, 1211, 143, "Output",ExpressionUUID->"89afe602-34f3-4435-8625-0edb6df939d3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[20183201, 435031, 137, 2, 30, "Input",ExpressionUUID->"4dcaa335-b77b-4c7c-be0a-925791f69a65"],
Cell[20183341, 435035, 439, 14, 34, "Output",ExpressionUUID->"8531d67c-6da0-4cbc-88ba-0972b1ec7ad1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[20183817, 435054, 197, 4, 30, "Input",ExpressionUUID->"5fa0d359-1698-4c09-9f64-84aee48c07a5"],
Cell[20184017, 435060, 5840, 82, 42, "Message",ExpressionUUID->"30b7da91-ae36-43e8-8d0b-5a6f6835da28"],
Cell[20189860, 435144, 141, 3, 34, "Output",ExpressionUUID->"c3096f7b-e28e-4798-9e0a-f57d55ff494a"]
}, Open  ]],
Cell[20190016, 435150, 141, 2, 35, "Text",ExpressionUUID->"60cc07da-6e57-4472-ab13-8db0c74b8eaa"],
Cell[CellGroupData[{
Cell[20190182, 435156, 228, 6, 30, "Input",ExpressionUUID->"a7823ee5-00a0-433c-913e-23610568c43f"],
Cell[20190413, 435164, 141, 3, 34, "Output",ExpressionUUID->"fe001018-5587-4f3f-9c77-e0c3f6e2df22"]
}, Open  ]],
Cell[20190569, 435170, 102, 0, 35, "Text",ExpressionUUID->"47ad045b-1239-43a4-ac9c-bbddea175bfa"],
Cell[CellGroupData[{
Cell[20190696, 435174, 149, 3, 30, "Input",ExpressionUUID->"032faee1-8e6e-4863-9744-b740b7800f4b"],
Cell[20190848, 435179, 86, 0, 34, "Output",ExpressionUUID->"db44f576-4aaf-459d-b3a6-6315e5557ac0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[20190971, 435184, 310, 9, 30, "Input",ExpressionUUID->"1b230da9-2ce3-42ce-8609-4c6bf391487b"],
Cell[20191284, 435195, 1794017, 37914, 143, "Output",ExpressionUUID->"b40a950a-c3fa-45d5-b25c-f6b202290361"]
}, Open  ]],
Cell[CellGroupData[{
Cell[21985338, 473114, 520, 16, 30, "Input",ExpressionUUID->"5e2c55be-db54-48b7-a92e-41db0cb7c4f0"],
Cell[21985861, 473132, 86, 0, 34, "Output",ExpressionUUID->"37b97604-ef7e-4219-a9e7-dc14a64a2f0e"]
}, Open  ]],
Cell[21985962, 473135, 114, 0, 35, "Text",ExpressionUUID->"fb14bec6-6e75-4923-b194-a3282a8a5286"],
Cell[CellGroupData[{
Cell[21986101, 473139, 155, 3, 30, "Input",ExpressionUUID->"f2171a25-2d26-42ee-998e-f34ff47d2b59"],
Cell[21986259, 473144, 86, 0, 34, "Output",ExpressionUUID->"f80ff7a3-9fcd-49a7-ab59-6fb9be58f726"]
}, Open  ]],
Cell[21986360, 473147, 170, 3, 35, "Text",ExpressionUUID->"6c5c7079-22dd-4bf8-bbe7-987cbbe2f240"],
Cell[CellGroupData[{
Cell[21986555, 473154, 487, 12, 52, "Input",ExpressionUUID->"43750bb8-7d2f-4d26-9c43-b8c977846dcf"],
Cell[21987045, 473168, 141, 3, 34, "Output",ExpressionUUID->"79d0da7f-be56-4486-933d-9321218601d8"]
}, Open  ]],
Cell[21987201, 473174, 96, 0, 35, "Text",ExpressionUUID->"57e32a65-929c-4fcc-99b8-128e399495ec"],
Cell[CellGroupData[{
Cell[21987322, 473178, 234, 7, 30, "Input",ExpressionUUID->"eb342a18-e1fa-4c37-b456-58afaa4576a9"],
Cell[21987559, 473187, 141, 3, 34, "Output",ExpressionUUID->"f06245cc-ffc3-4c1b-beaf-edb397b3c7a0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[21987737, 473195, 242, 7, 30, "Input",ExpressionUUID->"9f4ffd26-9d64-4131-b66d-588204721b75"],
Cell[21987982, 473204, 141, 3, 34, "Output",ExpressionUUID->"5ecd9673-b746-4ce8-8b2a-072d8180bf9b"]
}, Open  ]],
Cell[21988138, 473210, 112, 0, 35, "Text",ExpressionUUID->"cfaaa7ed-5141-4ce7-8c9c-8f684462d738"],
Cell[CellGroupData[{
Cell[21988275, 473214, 137, 2, 30, "Input",ExpressionUUID->"7d0aa215-18ac-4087-aea8-266725299663"],
Cell[21988415, 473218, 439, 14, 34, "Output",ExpressionUUID->"bc1888f2-e504-4a0e-9925-34ae84c48373"]
}, Open  ]],
Cell[CellGroupData[{
Cell[21988891, 473237, 141, 2, 30, "Input",ExpressionUUID->"eb281b20-46da-411a-b65c-782977c07208"],
Cell[21989035, 473241, 690, 23, 34, "Output",ExpressionUUID->"ad8d5981-4a83-4d53-90fe-7a2ba77be209"]
}, Open  ]],
Cell[21989740, 473267, 80, 0, 35, "Text",ExpressionUUID->"d41add2a-8ef1-45eb-a32f-f2b8e4170b64"],
Cell[21989823, 473269, 125, 1, 30, "Input",ExpressionUUID->"b80d9889-8feb-4271-90f6-0a7539553c6c"],
Cell[21989951, 473272, 158, 3, 30, "Input",ExpressionUUID->"b26baf97-da50-424a-adbe-590223c8f502"],
Cell[21990112, 473277, 120, 1, 30, "Input",ExpressionUUID->"9e05d0be-5789-4e9e-ad66-42b2ffa39937"],
Cell[21990235, 473280, 121, 1, 30, "Input",ExpressionUUID->"9499c0bc-9f23-4b20-b7cb-99d16d0274b3"],
Cell[21990359, 473283, 224, 5, 30, "Input",ExpressionUUID->"4ac5b5e7-cc2f-4978-af68-d5a2794959c9"],
Cell[21990586, 473290, 125, 1, 30, "Input",ExpressionUUID->"3330874e-7aa3-478e-ad31-b1ecc73b50d2"]
}, Closed]],
Cell[CellGroupData[{
Cell[21990748, 473296, 129, 0, 37, "Subsubsection",ExpressionUUID->"689c67be-83e5-4ec6-97ad-369fbf73699f"],
Cell[21990880, 473298, 131, 1, 30, "Input",ExpressionUUID->"c244aa2b-2380-4db3-b4c0-cdb8657ab5b8"],
Cell[21991014, 473301, 170, 4, 30, "Input",ExpressionUUID->"79356c5f-0170-4456-8460-5f644907ab28"],
Cell[21991187, 473307, 244, 5, 30, "Input",ExpressionUUID->"53052be0-5bbd-4bca-b0f4-8f79c72c2e1b"],
Cell[21991434, 473314, 460, 12, 30, "Input",ExpressionUUID->"2cb04f46-8acb-4708-9da1-6ba3466e7e3d"],
Cell[21991897, 473328, 297, 8, 35, "Text",ExpressionUUID->"cbcf8c55-cc9a-4e9a-b035-fdf9fb708644"],
Cell[21992197, 473338, 196, 4, 30, "Input",ExpressionUUID->"12d88a00-e2c7-4bc7-a83e-e185865db2c1"],
Cell[21992396, 473344, 1655, 54, 54, "Input",ExpressionUUID->"888ad203-54ef-45bf-a263-6342d14ceaef"],
Cell[21994054, 473400, 341, 10, 30, "Input",ExpressionUUID->"befd86d4-6a63-43c4-8749-8d0ca8a78246"],
Cell[21994398, 473412, 1601, 49, 117, "Input",ExpressionUUID->"e8caf613-4c17-4c8a-a2ed-d3e0fc067bce"],
Cell[21996002, 473463, 5173, 156, 225, "Input",ExpressionUUID->"065738be-17f0-43f9-a973-607888ecfb07"],
Cell[CellGroupData[{
Cell[22001200, 473623, 608, 17, 52, "Input",ExpressionUUID->"589317e4-b7e9-4dbf-942a-3d8596d15945"],
Cell[22001811, 473642, 141, 3, 34, "Output",ExpressionUUID->"db993d08-3798-436d-91ef-8c32a01b2f67"]
}, Open  ]],
Cell[22001967, 473648, 79, 0, 35, "Text",ExpressionUUID->"3eb0021f-0be2-40db-abf0-77ceacb346d6"],
Cell[CellGroupData[{
Cell[22002071, 473652, 427, 11, 30, "Input",ExpressionUUID->"ec057636-d78e-4ec5-8b94-7633734a0912"],
Cell[22002501, 473665, 138, 3, 34, "Output",ExpressionUUID->"810bff37-d615-4d11-8dc3-f7de5465731b"]
}, Open  ]],
Cell[22002654, 473671, 504, 16, 30, "Input",ExpressionUUID->"f39ccd96-4ad8-46fc-b19e-a5acb4f25239"],
Cell[22003161, 473689, 180, 3, 35, "Text",ExpressionUUID->"12c5240a-071d-4be3-99f2-e2c4563e871c"],
Cell[22003344, 473694, 141, 3, 30, "Input",ExpressionUUID->"887f5052-0295-4425-b1da-9d65c6aa4811"],
Cell[22003488, 473699, 154, 2, 35, "Text",ExpressionUUID->"5310526b-b2e3-48e5-807f-320b7506e06e"],
Cell[CellGroupData[{
Cell[22003667, 473705, 357, 9, 30, "Input",ExpressionUUID->"f0ac9abd-b00e-400c-a768-afe06d1a33c9"],
Cell[CellGroupData[{
Cell[22004049, 473718, 313, 8, 24, "Print",ExpressionUUID->"d5725dde-ccea-43c6-8fe0-3ea4dbe65451"],
Cell[22004365, 473728, 305, 6, 24, "Print",ExpressionUUID->"8d96f0c0-cd8a-44a5-a06b-643ea1ebc35a"],
Cell[22004673, 473736, 379, 7, 24, "Print",ExpressionUUID->"4bff6a57-5035-460d-88c8-36455a1d4d0a"],
Cell[22005055, 473745, 393, 7, 24, "Print",ExpressionUUID->"f39611aa-cd34-4275-8f0d-ecb5f4d089e8"],
Cell[22005451, 473754, 394, 11, 24, "Print",ExpressionUUID->"eb24260e-acdc-4dcd-bcff-6de4d0a6715e"],
Cell[22005848, 473767, 303, 6, 24, "Print",ExpressionUUID->"e6bd050f-856d-4282-95dc-1ab6072a95c2"],
Cell[22006154, 473775, 381, 7, 24, "Print",ExpressionUUID->"034b7548-c8c9-428c-a4cb-9827cb13a305"],
Cell[22006538, 473784, 402, 11, 24, "Print",ExpressionUUID->"3e9a63e6-e570-42b9-b2d8-a732526bad18"],
Cell[22006943, 473797, 303, 6, 24, "Print",ExpressionUUID->"7126c9f1-b462-4de6-89fb-5ea409ee2ce7"],
Cell[22007249, 473805, 381, 7, 24, "Print",ExpressionUUID->"f075da9f-bf45-479a-86c2-d3e39df4690a"],
Cell[22007633, 473814, 380, 10, 24, "Print",ExpressionUUID->"2392d952-2441-41c1-adf6-4ce5adce5b10"],
Cell[22008016, 473826, 303, 6, 24, "Print",ExpressionUUID->"759542c6-e3eb-4044-afc7-7dc52eae617f"],
Cell[22008322, 473834, 381, 7, 24, "Print",ExpressionUUID->"eedad889-6aaf-4eb0-82f2-352d55be4404"],
Cell[22008706, 473843, 265, 6, 24, "Print",ExpressionUUID->"544fc494-cbf3-4462-babb-ff2fd6a865b1"]
}, Open  ]],
Cell[22008986, 473852, 142, 3, 34, "Output",ExpressionUUID->"4532eaec-b0c4-4dd1-9b69-3154ed23a38e"]
}, Open  ]],
Cell[22009143, 473858, 123, 0, 35, "Text",ExpressionUUID->"6c3e2749-cd19-4d75-9560-e5efe5bba892"],
Cell[CellGroupData[{
Cell[22009291, 473862, 416, 11, 30, "Input",ExpressionUUID->"c5cfc235-5878-48c9-8416-ba58a1d391c8"],
Cell[CellGroupData[{
Cell[22009732, 473877, 313, 8, 24, "Print",ExpressionUUID->"5b4eb622-1bac-4766-a4c4-174390b28ce0"],
Cell[22010048, 473887, 107, 0, 24, "Print",ExpressionUUID->"f42cebd0-7447-4fff-b649-ccae272c4d70"],
Cell[22010158, 473889, 394, 11, 24, "Print",ExpressionUUID->"63c7349d-3e77-4c37-bc64-690f0524dbcf"],
Cell[22010555, 473902, 107, 0, 24, "Print",ExpressionUUID->"06be5aba-a8c9-4324-b232-14e4a2a00397"],
Cell[22010665, 473904, 431, 12, 24, "Print",ExpressionUUID->"adf91ebd-fe00-42ba-9417-c0a8fe76824c"],
Cell[22011099, 473918, 303, 6, 24, "Print",ExpressionUUID->"e824de72-aa44-4b3c-a340-1180447c103e"],
Cell[22011405, 473926, 381, 7, 24, "Print",ExpressionUUID->"4aff0834-7fde-4f38-b87a-af6fd82e6702"],
Cell[22011789, 473935, 402, 11, 24, "Print",ExpressionUUID->"e7c60326-ca1b-4759-bbf1-1ac298e1c2c8"],
Cell[22012194, 473948, 107, 0, 24, "Print",ExpressionUUID->"b382300f-2994-4d21-923d-7ec747d030b0"],
Cell[22012304, 473950, 380, 10, 24, "Print",ExpressionUUID->"6240d60c-e0af-4ff8-97c3-89875ddd251f"],
Cell[22012687, 473962, 107, 0, 24, "Print",ExpressionUUID->"38e96f55-cdfa-4e50-b417-8764ae5454b8"],
Cell[22012797, 473964, 265, 6, 24, "Print",ExpressionUUID->"d3d206bb-1de0-48c8-8d27-3418440566ec"],
Cell[22013065, 473972, 107, 0, 24, "Print",ExpressionUUID->"0e60de9e-9bdf-48ca-b40f-fb3f57de8718"],
Cell[22013175, 473974, 429, 12, 24, "Print",ExpressionUUID->"07ea4059-323d-49d0-93b6-11352799e78e"],
Cell[22013607, 473988, 303, 6, 24, "Print",ExpressionUUID->"2dcf1e98-484a-4392-8bf5-83b173949f00"],
Cell[22013913, 473996, 381, 7, 24, "Print",ExpressionUUID->"672c152c-9104-489b-a6b2-74a348ecb62c"],
Cell[22014297, 474005, 402, 8, 24, "Print",ExpressionUUID->"b095e63b-1676-470d-9c7f-ff846b512b5a"],
Cell[22014702, 474015, 407, 11, 24, "Print",ExpressionUUID->"6074bc53-c4c7-4407-b122-3d7d2d3dc756"],
Cell[22015112, 474028, 303, 6, 24, "Print",ExpressionUUID->"86891b20-ec73-4b56-bf09-c52954ed23c2"],
Cell[22015418, 474036, 383, 7, 24, "Print",ExpressionUUID->"bd900c18-e0e9-4292-ad9c-4fc6eba7503f"],
Cell[22015804, 474045, 402, 8, 24, "Print",ExpressionUUID->"5dc6c4b7-0ff6-474b-bedd-d5747b18186b"],
Cell[22016209, 474055, 355, 10, 24, "Print",ExpressionUUID->"e7ae67ca-8a95-4400-8e46-2713fc6ededc"],
Cell[22016567, 474067, 303, 6, 24, "Print",ExpressionUUID->"8db26813-cf5b-4d7f-9640-1f8b5b720eb3"],
Cell[22016873, 474075, 381, 7, 24, "Print",ExpressionUUID->"d5218eac-1900-4a3d-b82a-a76b26c816eb"],
Cell[22017257, 474084, 389, 7, 24, "Print",ExpressionUUID->"3c535dcb-a506-4015-98fc-f7c628618245"]
}, Open  ]],
Cell[22017661, 474094, 142, 3, 34, "Output",ExpressionUUID->"11eeb89d-a889-469a-bbe5-74b5463d336a"]
}, Open  ]],
Cell[22017818, 474100, 97, 0, 35, "Text",ExpressionUUID->"68998df6-b8df-4531-83e4-26afd11c9217"],
Cell[22017918, 474102, 167, 4, 30, "Input",ExpressionUUID->"3d7427f7-3a69-45bf-848e-3ebe05af339e"],
Cell[CellGroupData[{
Cell[22018110, 474110, 114, 1, 30, "Input",ExpressionUUID->"55b8d905-55c8-448c-9a30-7b3284cfbdb3"],
Cell[22018227, 474113, 86, 0, 34, "Output",ExpressionUUID->"b89c4487-706f-4845-af7b-086fddbeea73"]
}, Open  ]],
Cell[22018328, 474116, 319, 6, 30, "Input",ExpressionUUID->"78b42365-3129-4487-9aef-00c836c4cb48"],
Cell[22018650, 474124, 198, 4, 30, "Input",ExpressionUUID->"e6032f52-1840-438a-8194-ddca1d96799e"],
Cell[22018851, 474130, 119, 1, 30, "Input",ExpressionUUID->"75440453-ee80-42ad-8d78-e0d0a3153afc"],
Cell[22018973, 474133, 121, 1, 30, "Input",ExpressionUUID->"0ba4cf87-c7c2-46f6-8966-1302932f954b"],
Cell[22019097, 474136, 125, 1, 30, "Input",ExpressionUUID->"4f1fab4f-3756-4a09-bfa4-3df4bb773191"]
}, Closed]],
Cell[CellGroupData[{
Cell[22019259, 474142, 176, 3, 37, "Subsubsection",ExpressionUUID->"9d036867-c9f4-4cca-ba6d-6de5b3720599"],
Cell[22019438, 474147, 131, 1, 30, "Input",ExpressionUUID->"d4a7d416-2a01-4290-933d-f4fb5e040067"],
Cell[22019572, 474150, 170, 4, 30, "Input",ExpressionUUID->"6644f7b9-0e86-4fb5-b507-87ba97b1734d"],
Cell[22019745, 474156, 244, 5, 30, "Input",ExpressionUUID->"8e4b2a63-74ca-4ac9-a669-ff21aa5122b7"],
Cell[22019992, 474163, 416, 11, 30, "Input",ExpressionUUID->"0431fee8-090f-4552-b5f9-b01453c82d6d"],
Cell[22020411, 474176, 615, 14, 94, "Input",ExpressionUUID->"a8eca314-70b2-4177-920d-a55422fdd44d"],
Cell[22021029, 474192, 113, 0, 35, "Text",ExpressionUUID->"396513f9-2dad-4d97-9052-17775ba2f9da"],
Cell[22021145, 474194, 1407, 46, 94, "Input",ExpressionUUID->"a3099149-ef68-4caa-8576-6e861cee3bc2"],
Cell[22022555, 474242, 1246, 40, 95, "Input",ExpressionUUID->"3c2f674b-51d2-4f08-a380-e87684903fd8"],
Cell[CellGroupData[{
Cell[22023826, 474286, 520, 13, 30, "Input",ExpressionUUID->"2f46a003-9bea-4f1a-b485-d5b8c0923bbe"],
Cell[22024349, 474301, 34821, 1045, 194, "Output",ExpressionUUID->"883810c0-02aa-452a-8a91-cfc3e7c4f735"]
}, Open  ]],
Cell[22059185, 475349, 296, 9, 30, "Input",ExpressionUUID->"3e8223dd-5335-4f2c-bf91-f5e9bb62ec2b"],
Cell[22059484, 475360, 141, 3, 30, "Input",ExpressionUUID->"95da9c51-6df1-4014-9b6d-930107e94b8a"],
Cell[CellGroupData[{
Cell[22059650, 475367, 307, 8, 30, "Input",ExpressionUUID->"3c03c09c-3042-4569-bcaf-584a0092a557"],
Cell[22059960, 475377, 141, 3, 34, "Output",ExpressionUUID->"f8de657b-08e5-4363-b084-891149557fb1"]
}, Open  ]],
Cell[22060116, 475383, 94, 0, 35, "Text",ExpressionUUID->"fe7996a8-b925-46af-baf5-71ade09e0dc6"],
Cell[CellGroupData[{
Cell[22060235, 475387, 406, 11, 30, "Input",ExpressionUUID->"be115185-9d7f-4f19-9f00-448de9e4cc42"],
Cell[CellGroupData[{
Cell[22060666, 475402, 313, 8, 24, "Print",ExpressionUUID->"b1ff4fd4-8f63-48fb-92cc-60c70a17f8d1"],
Cell[22060982, 475412, 107, 0, 24, "Print",ExpressionUUID->"ff912030-38cf-46af-8071-3cb9b4118662"],
Cell[22061092, 475414, 394, 11, 24, "Print",ExpressionUUID->"284b4daa-e9bb-492b-9641-948dc7abdae9"],
Cell[22061489, 475427, 107, 0, 24, "Print",ExpressionUUID->"125608e7-04bf-46c8-9da0-d2f1b649250d"],
Cell[22061599, 475429, 431, 12, 24, "Print",ExpressionUUID->"3f1292a7-6006-4768-b1e3-121664dd6d3a"],
Cell[22062033, 475443, 303, 6, 24, "Print",ExpressionUUID->"8c962884-a079-4ce5-a26d-7b179255ee21"],
Cell[22062339, 475451, 381, 7, 24, "Print",ExpressionUUID->"58a823c9-d40d-49d8-824a-13ddeb6ef557"],
Cell[22062723, 475460, 402, 11, 24, "Print",ExpressionUUID->"70037229-f75e-4cc8-a163-e9e120456a65"],
Cell[22063128, 475473, 107, 0, 24, "Print",ExpressionUUID->"a998095a-efcf-44b1-9388-5d133cadf786"],
Cell[22063238, 475475, 380, 10, 24, "Print",ExpressionUUID->"ff7eead7-38b1-4fde-94e7-cd7918f939f7"],
Cell[22063621, 475487, 107, 0, 24, "Print",ExpressionUUID->"10ecf00c-bbfd-45f3-b93f-ed93caa957c4"],
Cell[22063731, 475489, 265, 6, 24, "Print",ExpressionUUID->"d4da6a14-cb65-41d0-ae32-d20bd88c2bc0"],
Cell[22063999, 475497, 107, 0, 24, "Print",ExpressionUUID->"f73f2cc5-8d34-4f60-b3c9-4a4a00321492"],
Cell[22064109, 475499, 429, 12, 24, "Print",ExpressionUUID->"c649fe06-b9fe-4ef5-b6ab-74fe41cae865"],
Cell[22064541, 475513, 303, 6, 24, "Print",ExpressionUUID->"af020585-d017-40ca-8d08-ad52b5b1aff8"],
Cell[22064847, 475521, 381, 7, 24, "Print",ExpressionUUID->"6826cdb7-0098-4c95-b89b-6c9280118484"],
Cell[22065231, 475530, 404, 8, 24, "Print",ExpressionUUID->"a2071fb2-88aa-4dba-8b8e-4826937a4b15"],
Cell[22065638, 475540, 407, 11, 24, "Print",ExpressionUUID->"acd8b4e5-5598-4336-97f5-f516f263ce4f"],
Cell[22066048, 475553, 303, 6, 24, "Print",ExpressionUUID->"5c982023-89c6-4fc9-a534-963acef02be0"],
Cell[22066354, 475561, 383, 7, 24, "Print",ExpressionUUID->"a019ce42-a9c7-4381-b99d-62423fa3fc9b"],
Cell[22066740, 475570, 404, 8, 24, "Print",ExpressionUUID->"bad8c5c5-e583-41f9-a190-ac449efb5b3f"]
}, Open  ]],
Cell[22067159, 475581, 142, 3, 34, "Output",ExpressionUUID->"73776096-eff6-4e9c-9358-f811ed6e9eb5"]
}, Open  ]],
Cell[22067316, 475587, 167, 4, 30, "Input",ExpressionUUID->"ceb7d1be-bd69-45dd-a6ab-8eb1a56f7f10"],
Cell[CellGroupData[{
Cell[22067508, 475595, 154, 3, 30, "Input",ExpressionUUID->"473d7b02-d38e-4be0-bcec-75f72b0cca66"],
Cell[22067665, 475600, 91, 0, 34, "Output",ExpressionUUID->"c1fa57dc-43ea-4cd0-8c21-963cac0a6ed8"]
}, Open  ]],
Cell[22067771, 475603, 141, 3, 30, "Input",ExpressionUUID->"04fc80c0-e819-4297-a1e1-450b2728fcdd"],
Cell[CellGroupData[{
Cell[22067937, 475610, 204, 6, 30, "Input",ExpressionUUID->"1ebdb396-1ca0-4cc8-9f7c-b5e606ce251e"],
Cell[22068144, 475618, 141, 3, 34, "Output",ExpressionUUID->"b3f184a3-6b7e-45c4-9bda-cb7314a985f6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[22068322, 475626, 273, 7, 30, "Input",ExpressionUUID->"f14094d1-3690-4d7a-a734-96536fd0ce24"],
Cell[22068598, 475635, 777, 20, 94, "Output",ExpressionUUID->"477a6a71-f382-4371-8210-8dd0bb71a0cd"]
}, Open  ]],
Cell[CellGroupData[{
Cell[22069412, 475660, 210, 6, 30, "Input",ExpressionUUID->"5ba1ab09-8dd7-4f7c-98fb-4d99c0414c59"],
Cell[22069625, 475668, 142, 3, 34, "Output",ExpressionUUID->"2c5ce4f2-6636-48e0-9265-1f28eabbaf17"]
}, Open  ]],
Cell[CellGroupData[{
Cell[22069804, 475676, 273, 7, 30, "Input",ExpressionUUID->"dee6bf91-0b58-4a1f-8540-73204a0a41df"],
Cell[22070080, 475685, 774, 20, 94, "Output",ExpressionUUID->"328f1f7c-d25d-4e16-b23e-2d5575dca343"]
}, Open  ]],
Cell[22070869, 475708, 198, 3, 35, "Text",ExpressionUUID->"0c99c66f-6057-4ffa-9ce1-62c0c8d3de49"],
Cell[22071070, 475713, 187, 5, 30, "Input",ExpressionUUID->"c9269579-2860-40d0-a232-c1607eda31d6"],
Cell[CellGroupData[{
Cell[22071282, 475722, 365, 12, 30, "Input",ExpressionUUID->"9c783a3c-0ba1-4eff-ba3e-6d3be5186856"],
Cell[22071650, 475736, 7050, 234, 62, "Output",ExpressionUUID->"aa942ace-92fd-4e23-9778-dedef06f350f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[22078737, 475975, 365, 12, 30, "Input",ExpressionUUID->"7880bcc2-7359-4bff-91ff-8b5cb7411739"],
Cell[22079105, 475989, 138, 3, 34, "Output",ExpressionUUID->"a347cefb-8f00-4d65-a245-9ba016f35a94"]
}, Open  ]],
Cell[CellGroupData[{
Cell[22079280, 475997, 365, 12, 30, "Input",ExpressionUUID->"4f895cae-9cd0-4edc-9572-9ab3a31f62ac"],
Cell[22079648, 476011, 138, 3, 34, "Output",ExpressionUUID->"c7ab9191-1872-428e-8ac8-4f2df3c3ae60"]
}, Open  ]],
Cell[CellGroupData[{
Cell[22079823, 476019, 365, 12, 30, "Input",ExpressionUUID->"54a04513-af43-4adb-a7f6-feb9e97a3bad"],
Cell[22080191, 476033, 7686, 249, 62, "Output",ExpressionUUID->"0ebc0a61-77bb-4d19-af02-411ef6679fc0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[22087914, 476287, 365, 12, 30, "Input",ExpressionUUID->"be99230a-9b0c-4e8d-82c0-15fdc60e9adc"],
Cell[22088282, 476301, 4222, 139, 60, "Output",ExpressionUUID->"03000617-f464-4c73-9f67-ccb33e6a8fe8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[22092541, 476445, 365, 12, 30, "Input",ExpressionUUID->"be711668-c60e-40de-a414-cdebd4ebee61"],
Cell[22092909, 476459, 139, 3, 34, "Output",ExpressionUUID->"a70e97a6-7af6-492b-8f80-7d4a35f18e51"]
}, Open  ]],
Cell[CellGroupData[{
Cell[22093085, 476467, 365, 12, 30, "Input",ExpressionUUID->"04ac1864-e35f-4cb1-b6bd-af12ab2c7c7f"],
Cell[22093453, 476481, 138, 3, 34, "Output",ExpressionUUID->"9568456a-e283-46cc-80ae-400472670aaf"]
}, Open  ]],
Cell[CellGroupData[{
Cell[22093628, 476489, 365, 12, 30, "Input",ExpressionUUID->"1a9880ad-e359-4617-9543-2b2ba33f60a0"],
Cell[22093996, 476503, 2846, 96, 60, "Output",ExpressionUUID->"8d89cabe-3d5e-4e8f-8830-74ab6fd015c1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[22096879, 476604, 365, 12, 30, "Input",ExpressionUUID->"f61ced39-8291-447c-9e25-72c67d3f19a9"],
Cell[22097247, 476618, 138, 3, 34, "Output",ExpressionUUID->"1bb2a98d-580a-4eb3-8ed5-919a84a1d0e6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[22097422, 476626, 365, 12, 30, "Input",ExpressionUUID->"0218550f-7f25-4c94-afe5-decd4a15f9de"],
Cell[22097790, 476640, 11629, 343, 84, "Output",ExpressionUUID->"db7af5ca-a688-479c-babf-2ff897e44507"]
}, Open  ]],
Cell[22109434, 476986, 328, 6, 30, "Input",ExpressionUUID->"ad36e7ac-53b9-4ef9-a0a9-6c5593525ead"],
Cell[22109765, 476994, 217, 4, 30, "Input",ExpressionUUID->"d7b99a71-5e26-4515-a83a-9e1210da6ffd"],
Cell[22109985, 477000, 119, 1, 30, "Input",ExpressionUUID->"56476189-c58d-441d-a99e-c6aaa0bea7f4"],
Cell[22110107, 477003, 121, 1, 30, "Input",ExpressionUUID->"8962383c-fa2a-4645-8300-7c0e3bb9d198"],
Cell[22110231, 477006, 125, 1, 30, "Input",ExpressionUUID->"dd60f0da-e3f8-485e-9572-064dcbd1a13d"]
}, Closed]],
Cell[CellGroupData[{
Cell[22110393, 477012, 152, 2, 37, "Subsubsection",ExpressionUUID->"0d7d934a-35db-4da3-a76e-47173a118fa3"],
Cell[CellGroupData[{
Cell[22110570, 477018, 131, 1, 30, "Input",ExpressionUUID->"6913f968-b614-44f7-af59-81c61ff578a2"],
Cell[CellGroupData[{
Cell[22110726, 477023, 151, 1, 24, "Print",ExpressionUUID->"93f4a2b6-be9f-464c-8ded-a58caa9d9ef3"],
Cell[22110880, 477026, 425, 10, 24, "Print",ExpressionUUID->"ea1a050b-68fe-4f03-a8be-71d9c3479c46"],
Cell[22111308, 477038, 174, 2, 24, "Print",ExpressionUUID->"5e53d258-d070-41a8-bbe9-d3fc3e50a4fc"],
Cell[22111485, 477042, 129, 0, 24, "Print",ExpressionUUID->"8ffed047-61d1-499e-97f7-f2b185085ca7"],
Cell[22111617, 477044, 112, 0, 24, "Print",ExpressionUUID->"91ca1bf1-0ece-4da5-ad92-3d074036ddfc"],
Cell[22111732, 477046, 151, 1, 24, "Print",ExpressionUUID->"c0d25827-4f28-4163-9063-a68eb2c86b05"],
Cell[22111886, 477049, 429, 10, 24, "Print",ExpressionUUID->"aea0eca4-cc40-41ed-8f97-ed663e366494"],
Cell[22112318, 477061, 174, 2, 24, "Print",ExpressionUUID->"ecd880b5-d190-43fa-b061-af06f29b097e"],
Cell[22112495, 477065, 151, 1, 24, "Print",ExpressionUUID->"68c5bc26-dfa2-46dd-8959-a52918105cbb"],
Cell[22112649, 477068, 425, 10, 24, "Print",ExpressionUUID->"a29c3fd4-7e47-48ac-899e-c82bcbb5fab7"],
Cell[22113077, 477080, 192, 2, 24, "Print",ExpressionUUID->"6aaf9fac-ab47-496b-b251-ea861578a0a2"],
Cell[22113272, 477084, 151, 1, 24, "Print",ExpressionUUID->"e42b5ce0-9ef3-40f6-a769-99be29a4ea66"],
Cell[22113426, 477087, 308, 4, 44, "Print",ExpressionUUID->"7b6a13e0-024f-4982-8c6f-049287218b2e"],
Cell[22113737, 477093, 151, 1, 24, "Print",ExpressionUUID->"142aa7e0-abb8-4a38-a515-2ab927d45324"]
}, Open  ]]
}, Open  ]],
Cell[22113915, 477098, 170, 4, 30, "Input",ExpressionUUID->"a4e844e4-329a-49fc-828e-c74ab19eb67b"],
Cell[22114088, 477104, 428, 11, 35, "Text",ExpressionUUID->"9caa07d0-b309-4c0e-8821-e2cf83a6db43"],
Cell[22114519, 477117, 244, 5, 30, "Input",ExpressionUUID->"342966d7-9e8f-4441-aa91-f0bc52246443"],
Cell[22114766, 477124, 465, 12, 30, "Input",ExpressionUUID->"5da829db-cdc8-449e-94da-9e64d33e2bc0"],
Cell[22115234, 477138, 261, 6, 30, "Input",ExpressionUUID->"58c1e87a-4f84-469a-a746-784989105662"],
Cell[22115498, 477146, 412, 8, 30, "Input",ExpressionUUID->"53f45de8-7f00-4368-a5d0-cd3afbec28f1"],
Cell[22115913, 477156, 205, 3, 35, "Text",ExpressionUUID->"f2bf46af-e19a-45a5-b0cf-25bc19ec8da9"],
Cell[22116121, 477161, 2708, 80, 157, "Input",ExpressionUUID->"f6f89abf-a805-4522-9c49-4dab99773923"],
Cell[22118832, 477243, 990, 29, 94, "Input",ExpressionUUID->"15819cc2-e637-4bf3-b817-a8f7be06fd90"],
Cell[22119825, 477274, 145, 2, 35, "Text",ExpressionUUID->"a35cc1a6-f0fd-469d-8cdb-89bf390710c0"],
Cell[22119973, 477278, 1226, 35, 151, "Input",ExpressionUUID->"d2829250-b7ed-4e5d-89c4-d62e79565fae"],
Cell[22121202, 477315, 1167, 34, 30, "Input",ExpressionUUID->"196795c7-2051-4901-8ff5-1e14d4a993da"],
Cell[22122372, 477351, 3646, 106, 115, "Input",ExpressionUUID->"77080c4b-ba79-4858-8d99-f044e49008ed"],
Cell[22126021, 477459, 9768, 268, 283, "Input",ExpressionUUID->"342ec9e6-a707-4303-9161-936b2d3228f7"],
Cell[22135792, 477729, 131, 0, 35, "Text",ExpressionUUID->"938353fb-22a9-4282-9c2a-dd13e1bfd0da"],
Cell[22135926, 477731, 3570, 96, 157, "Input",ExpressionUUID->"87e1e284-af59-4435-8a26-8931c20a6af9"],
Cell[22139499, 477829, 128, 0, 35, "Text",ExpressionUUID->"2e3bbd2a-6dcf-48eb-92c2-005de0326547"],
Cell[22139630, 477831, 2123, 57, 136, "Input",ExpressionUUID->"f47a0805-fd60-42e7-88c9-5426aab6b04a"],
Cell[22141756, 477890, 264, 4, 58, "Text",ExpressionUUID->"4d9b4d84-1b6b-4a0d-9fc0-fc87337d1704"],
Cell[CellGroupData[{
Cell[22142045, 477898, 3619, 115, 193, "Input",ExpressionUUID->"02a20b7d-50e2-4f75-b728-04a5fa4057a8"],
Cell[22145667, 478015, 18663, 513, 123, "Output",ExpressionUUID->"587bd23c-ad1a-434c-9fad-6e31e89a61be"]
}, Open  ]],
Cell[CellGroupData[{
Cell[22164367, 478533, 561, 17, 30, "Input",ExpressionUUID->"cdf31114-ecea-4f51-bfb9-a610cb234226"],
Cell[22164931, 478552, 15394, 511, 120, "Output",ExpressionUUID->"31262468-bec5-48ef-a687-d2e37f8a31fc"]
}, Open  ]],
Cell[22180340, 479066, 192, 3, 35, "Text",ExpressionUUID->"873bcb6a-1bcc-47ec-b544-f5910413d3ef"],
Cell[CellGroupData[{
Cell[22180557, 479073, 491, 14, 73, "Input",ExpressionUUID->"89d8bdfc-00dd-4af8-81db-a42630efeae3"],
Cell[22181051, 479089, 88, 0, 34, "Output",ExpressionUUID->"f96cfd5c-9894-40d1-a7d7-ebee85b28c84"]
}, Open  ]],
Cell[CellGroupData[{
Cell[22181176, 479094, 267, 7, 30, "Input",ExpressionUUID->"cfa25a36-6990-4ed6-8dde-ccec28fe9628"],
Cell[22181446, 479103, 1789, 68, 50, "Output",ExpressionUUID->"6d971bb7-c749-47ee-92e0-4a73519b9e2e"]
}, Open  ]],
Cell[22183250, 479174, 174, 3, 35, "Text",ExpressionUUID->"4df27674-7ab1-4448-91ed-e3acc5206565"],
Cell[CellGroupData[{
Cell[22183449, 479181, 393, 13, 30, "Input",ExpressionUUID->"67787685-a22c-46ac-9a73-9d06d94547fb"],
Cell[22183845, 479196, 41115, 1002, 145, "Output",ExpressionUUID->"63ceda0a-7d8b-48c7-8a9a-ab8059c99524"]
}, Open  ]],
Cell[22224975, 480201, 354, 5, 58, "Text",ExpressionUUID->"30d4a15c-d64a-45fe-969a-61279c66c49f"],
Cell[22225332, 480208, 104, 0, 35, "Text",ExpressionUUID->"6906dea0-543b-423d-98aa-054b045bd453"],
Cell[CellGroupData[{
Cell[22225461, 480212, 307, 8, 30, "Input",ExpressionUUID->"c4222b3f-8ac0-484c-9969-29826c40b31a"],
Cell[22225771, 480222, 141, 3, 34, "Output",ExpressionUUID->"2d96c0ce-519f-4f47-bfc6-0035baaee093"]
}, Open  ]],
Cell[CellGroupData[{
Cell[22225949, 480230, 309, 8, 30, "Input",ExpressionUUID->"147bea10-9b16-41da-9a04-fff9774a7f28"],
Cell[22226261, 480240, 142, 3, 34, "Output",ExpressionUUID->"d2514252-8883-4992-bb45-3bc03d1ecc64"]
}, Open  ]],
Cell[22226418, 480246, 167, 4, 30, "Input",ExpressionUUID->"2b571e57-0c06-42de-a1b3-719c6afd815a"],
Cell[22226588, 480252, 162, 4, 30, "Input",ExpressionUUID->"21f6937b-b073-417b-b079-612bb660aad8"],
Cell[22226753, 480258, 113, 0, 35, "Text",ExpressionUUID->"65e12a4e-77c1-4399-b4b4-df085cd0dcad"],
Cell[CellGroupData[{
Cell[22226891, 480262, 176, 5, 30, "Input",ExpressionUUID->"81452e50-7b81-4fee-be41-22f9202f6d2b"],
Cell[22227070, 480269, 778790, 16494, 89, "Output",ExpressionUUID->"8285a2a1-1949-49e7-a7e3-4cb7264669c5"]
}, Open  ]],
Cell[23005875, 496766, 119, 0, 35, "Text",ExpressionUUID->"7c7b75c8-57e5-4639-ac26-dc251eecc8e6"],
Cell[23005997, 496768, 84, 0, 35, "Text",ExpressionUUID->"89ab99d2-6296-49f4-aa58-73062af27c04"],
Cell[CellGroupData[{
Cell[23006106, 496772, 323, 10, 30, "Input",ExpressionUUID->"440ef40c-ef62-47ea-aaf0-7bece590b7af"],
Cell[23006432, 496784, 7933, 284, 60, "Output",ExpressionUUID->"9bb7bff0-5182-4e57-a277-b06652efb37b"]
}, Open  ]],
Cell[23014380, 497071, 164, 4, 30, "Input",ExpressionUUID->"ef107290-6235-4e63-9a11-1062fe931695"],
Cell[23014547, 497077, 168, 4, 30, "Input",ExpressionUUID->"d46ea0bb-e087-4dd5-b1fe-6bd71074f37e"],
Cell[CellGroupData[{
Cell[23014740, 497085, 151, 3, 30, "Input",ExpressionUUID->"3215ff84-cc57-4a46-acce-407f615b6901"],
Cell[23014894, 497090, 138, 3, 34, "Output",ExpressionUUID->"47ddd61f-1330-408f-ab9e-8a4cd663f0f5"]
}, Open  ]],
Cell[23015047, 497096, 488, 8, 81, "Text",ExpressionUUID->"d193c5d4-a97e-4586-a0f5-62482051b4ae"],
Cell[CellGroupData[{
Cell[23015560, 497108, 552, 14, 52, "Input",ExpressionUUID->"b6f87063-4e01-4a66-bae5-faab5e4472a4"],
Cell[23016115, 497124, 2109, 80, 34, "Output",ExpressionUUID->"53efb4fd-604f-48e3-96de-9c1dc9033987"]
}, Open  ]],
Cell[23018239, 497207, 354, 8, 30, "Input",ExpressionUUID->"bb17cd41-6061-45cf-967c-81a732468db6"],
Cell[CellGroupData[{
Cell[23018618, 497219, 504, 16, 73, "Input",ExpressionUUID->"e831ade3-075c-4a31-927a-d69f1c6b8229"],
Cell[23019125, 497237, 121, 1, 34, "Output",ExpressionUUID->"a2729eb2-d7de-4012-8795-e5d833165ed7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23019283, 497243, 504, 16, 73, "Input",ExpressionUUID->"639136d7-223a-47b9-a2cb-c5c3215081b5"],
Cell[23019790, 497261, 122, 1, 34, "Output",ExpressionUUID->"951bab48-d8e0-41c5-a939-48be467b5137"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23019949, 497267, 504, 16, 73, "Input",ExpressionUUID->"3fc0e863-6e45-4972-b5a7-977f9785f5e7"],
Cell[23020456, 497285, 122, 1, 34, "Output",ExpressionUUID->"e657903e-8b4d-42b6-a59b-078b2e6b406b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23020615, 497291, 504, 16, 73, "Input",ExpressionUUID->"3648f1ea-6729-4e73-911c-86bd6b54f534"],
Cell[23021122, 497309, 469, 9, 30, "Message",ExpressionUUID->"85d6b2fb-fd4a-4d0a-92e3-2f4611ee070f"],
Cell[23021594, 497320, 85, 0, 34, "Output",ExpressionUUID->"7351eedf-5ed3-4266-8803-f5429114a960"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23021716, 497325, 504, 16, 73, "Input",ExpressionUUID->"194a695b-ffb8-467d-b3ff-ff246129d314"],
Cell[23022223, 497343, 104, 0, 34, "Output",ExpressionUUID->"cda01b30-f442-4398-98a9-ed7e9f1a4983"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23022364, 497348, 504, 16, 73, "Input",ExpressionUUID->"0a2cb3d5-188d-4050-bdc2-2050d5422973"],
Cell[23022871, 497366, 122, 1, 34, "Output",ExpressionUUID->"90caeb62-63d5-433b-accd-0f0ef26f4fe7"]
}, Open  ]],
Cell[23023008, 497370, 576, 9, 73, "Input",ExpressionUUID->"647eb465-2690-4e12-893f-88758bff364c"],
Cell[23023587, 497381, 414, 8, 30, "Input",ExpressionUUID->"cf945f3c-94d3-4b4e-ac8d-b6d788276c42"],
Cell[23024004, 497391, 263, 6, 30, "Input",ExpressionUUID->"81fbd756-e237-4596-9216-8d8268d9065f"],
Cell[23024270, 497399, 119, 1, 30, "Input",ExpressionUUID->"2e7bc041-4de3-43d5-966e-67f474947d24"],
Cell[23024392, 497402, 121, 1, 30, "Input",ExpressionUUID->"86995700-433e-431d-8462-c434bccd64ea"],
Cell[23024516, 497405, 125, 1, 30, "Input",ExpressionUUID->"f94baf4d-88ab-4d7d-a519-6515985e8525"]
}, Closed]],
Cell[CellGroupData[{
Cell[23024678, 497411, 110, 0, 37, "Subsubsection",ExpressionUUID->"0ad2ed75-ce7a-4a18-960a-62d62c93e633"],
Cell[23024791, 497413, 131, 1, 30, "Input",ExpressionUUID->"35c6b5e3-84fc-4689-b0d5-c5959257432e"],
Cell[23024925, 497416, 170, 4, 30, "Input",ExpressionUUID->"be4cb538-0d51-4d70-b0f3-2da6b518420d"],
Cell[23025098, 497422, 308, 7, 30, "Input",ExpressionUUID->"6c830f30-c752-4a76-a923-ddd9312da703"],
Cell[23025409, 497431, 197, 4, 30, "Input",ExpressionUUID->"a3b64925-faf4-49b1-8a6f-78ee79c052da"],
Cell[23025609, 497437, 118, 0, 35, "Text",ExpressionUUID->"6a187ac5-259d-4157-852c-ff2588ef2edd"],
Cell[23025730, 497439, 419, 11, 30, "Input",ExpressionUUID->"ea959855-17f4-4976-8804-b3f4726003b2"],
Cell[CellGroupData[{
Cell[23026174, 497454, 824, 26, 30, "Input",ExpressionUUID->"502efa99-ee4a-4230-85ff-ca22647587f4"],
Cell[23027001, 497482, 2425, 81, 124, "Output",ExpressionUUID->"9f187f8e-9ccd-4ffb-ac8c-9f96dbaa872f"]
}, Open  ]],
Cell[23029441, 497566, 145, 3, 30, "Input",ExpressionUUID->"dd500ce7-ab82-4973-8207-5f67ecd4d0f6"],
Cell[CellGroupData[{
Cell[23029611, 497573, 288, 8, 30, "Input",ExpressionUUID->"d57ff74a-d720-48ee-841c-b89f2c00cb66"],
Cell[23029902, 497583, 2379, 78, 58, "Output",ExpressionUUID->"014ba87c-76be-4463-b46a-46a0adaf74ee"]
}, Open  ]],
Cell[23032296, 497664, 114, 0, 35, "Text",ExpressionUUID->"d4e62922-8603-4c9b-9054-2f564371b6ad"],
Cell[23032413, 497666, 1273, 35, 73, "Input",ExpressionUUID->"6da63781-4065-4a08-b6c9-022526e9139f"],
Cell[CellGroupData[{
Cell[23033711, 497705, 427, 13, 30, "Input",ExpressionUUID->"ad931b04-ea7c-4207-a3a0-8491cdcb7ea6"],
Cell[23034141, 497720, 634, 18, 34, "Output",ExpressionUUID->"710c4874-eaa0-4349-996b-b1aa955576d8"]
}, Open  ]],
Cell[23034790, 497741, 163, 3, 35, "Text",ExpressionUUID->"d502eb82-877e-4157-af03-e2607cb78dc3"],
Cell[CellGroupData[{
Cell[23034978, 497748, 197, 4, 30, "Input",ExpressionUUID->"c841d8e9-45cc-4e31-b5ad-bbcc3b9bd14e"],
Cell[23035178, 497754, 140, 3, 34, "Output",ExpressionUUID->"8b8d5580-bb70-45f5-b8ea-532c99b27deb"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23035355, 497762, 198, 4, 30, "Input",ExpressionUUID->"0ce3936b-948b-4b44-a970-b588db16e42e"],
Cell[23035556, 497768, 140, 3, 34, "Output",ExpressionUUID->"9d2eb8c3-7f97-4214-beff-e5acbed48d15"]
}, Open  ]],
Cell[23035711, 497774, 93, 0, 35, "Text",ExpressionUUID->"f8d67ce9-e37b-4c60-ade7-0fd4e36d9ade"],
Cell[CellGroupData[{
Cell[23035829, 497778, 190, 5, 30, "Input",ExpressionUUID->"3b71f9c0-66d4-490c-b024-69a23458185d"],
Cell[23036022, 497785, 9461, 254, 111, "Output",ExpressionUUID->"6b3c2590-e24e-4809-b09d-041f6ea6e7a9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23045520, 498044, 191, 5, 30, "Input",ExpressionUUID->"35f5e449-9861-4d2e-925a-ad81f41b8cf9"],
Cell[23045714, 498051, 4971, 140, 75, "Output",ExpressionUUID->"30150ae4-bdc1-41b6-b752-3f4897145c4b"]
}, Open  ]],
Cell[23050700, 498194, 90, 0, 35, "Text",ExpressionUUID->"393fbeee-c7e3-4627-b252-97d4b5b94c79"],
Cell[CellGroupData[{
Cell[23050815, 498198, 182, 4, 30, "Input",ExpressionUUID->"631bc208-a08e-4a06-b1ad-fc11383150bc"],
Cell[23051000, 498204, 9721, 261, 125, "Output",ExpressionUUID->"2279dda6-3390-4d0f-8efe-63767e63484d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23060758, 498470, 183, 4, 30, "Input",ExpressionUUID->"599a56b3-d56c-4813-811c-25ec21242ff6"],
Cell[23060944, 498476, 4967, 140, 75, "Output",ExpressionUUID->"eb15800b-0bbf-4274-ab89-b2b8fe819dd1"]
}, Open  ]],
Cell[23065926, 498619, 214, 3, 35, "Text",ExpressionUUID->"8bfdc566-714e-4947-a7f0-23adb71c1c3b"],
Cell[23066143, 498624, 98, 0, 35, "Text",ExpressionUUID->"3f9c21f1-fe35-40d5-b5ff-0619d5c9085d"],
Cell[23066244, 498626, 170, 4, 30, "Input",ExpressionUUID->"5e8d5934-1e23-4ea5-adff-fd69548fe594"],
Cell[CellGroupData[{
Cell[23066439, 498634, 116, 1, 30, "Input",ExpressionUUID->"8d215dc7-e4ba-4622-9969-0847c3f38e9d"],
Cell[23066558, 498637, 86, 0, 34, "Output",ExpressionUUID->"eaf3942d-c8d4-4670-8fce-4426502ba736"]
}, Open  ]],
Cell[23066659, 498640, 172, 4, 30, "Input",ExpressionUUID->"f2fd3a9b-f8e8-4f6d-af88-806107ec5e1d"],
Cell[CellGroupData[{
Cell[23066856, 498648, 117, 1, 30, "Input",ExpressionUUID->"cd9504ea-0e71-4ec3-986a-f4a25de9d2a5"],
Cell[23066976, 498651, 86, 0, 34, "Output",ExpressionUUID->"723e5d9d-7636-4467-8656-489aa8e88da9"]
}, Open  ]],
Cell[23067077, 498654, 149, 2, 35, "Text",ExpressionUUID->"98f8cfea-acab-4df8-ba70-4a236fa8f74a"],
Cell[CellGroupData[{
Cell[23067251, 498660, 264, 7, 30, "Input",ExpressionUUID->"51e4681a-b402-4c02-bfa7-734e0d58d3a6"],
Cell[23067518, 498669, 86, 0, 34, "Output",ExpressionUUID->"485b34cc-cc28-4c13-94ae-b4d0c93b5c8e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23067641, 498674, 268, 7, 30, "Input",ExpressionUUID->"87d6598d-d40b-42f9-bfc6-b300b0195c20"],
Cell[23067912, 498683, 8110, 248, 240, "Output",ExpressionUUID->"d9f95a53-8887-4804-8266-09d83071ae99"]
}, Open  ]],
Cell[23076037, 498934, 153, 2, 35, "Text",ExpressionUUID->"6f9f6cb0-9a75-46f8-8a6b-12d375b5b759"],
Cell[CellGroupData[{
Cell[23076215, 498940, 273, 8, 30, "Input",ExpressionUUID->"64616731-2a03-4e0d-a0aa-bf709b6ec645"],
Cell[23076491, 498950, 83, 0, 34, "Output",ExpressionUUID->"9d0a6d30-fa0b-4811-b886-1b987613367e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23076611, 498955, 275, 8, 30, "Input",ExpressionUUID->"9a41d661-b9a1-4ccf-be25-a34c0c77524f"],
Cell[23076889, 498965, 83, 0, 34, "Output",ExpressionUUID->"6121f016-fccf-4f7e-bd25-54e7a203a788"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23077009, 498970, 274, 8, 30, "Input",ExpressionUUID->"611291b7-5e20-4d55-b256-ff3714669c24"],
Cell[23077286, 498980, 83, 0, 34, "Output",ExpressionUUID->"b4ed4e21-a138-44e7-be52-c9f0d05ed455"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23077406, 498985, 274, 8, 30, "Input",ExpressionUUID->"cd6aa23d-a152-4379-8700-248eda9c15fa"],
Cell[23077683, 498995, 83, 0, 34, "Output",ExpressionUUID->"97bf0361-eaf8-4f87-9cca-f093e735768d"]
}, Open  ]],
Cell[23077781, 498998, 79, 0, 35, "Text",ExpressionUUID->"6162f825-b5d2-4547-996a-0c0150338ce1"],
Cell[CellGroupData[{
Cell[23077885, 499002, 358, 10, 30, "Input",ExpressionUUID->"d2b97670-72b4-4ff7-870e-51afdd10211c"],
Cell[23078246, 499014, 128782, 3242, 379, "Output",ExpressionUUID->"4c7399cb-7c63-4ad3-909f-d0cb9fc03b83"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23207065, 502261, 360, 10, 30, "Input",ExpressionUUID->"6452f850-f6ef-41e9-9185-b84da4c140af"],
Cell[23207428, 502273, 107207, 2735, 359, "Output",ExpressionUUID->"c286f32b-1f4b-41f6-8d2d-f79fc2d51c24"]
}, Open  ]],
Cell[23314650, 505011, 122, 0, 35, "Text",ExpressionUUID->"18fb2c87-daff-4421-9d96-3d935324191a"],
Cell[CellGroupData[{
Cell[23314797, 505015, 328, 9, 30, "Input",ExpressionUUID->"faf3eb61-6ccb-4506-adfd-9b12a5a0b0ed"],
Cell[23315128, 505026, 86, 0, 34, "Output",ExpressionUUID->"caeac4bc-82d0-4792-887d-e6a9fdf3dd6b"]
}, Open  ]],
Cell[23315229, 505029, 85, 0, 35, "Text",ExpressionUUID->"ec143c67-1953-47b0-b09d-e93d4cdfb68b"],
Cell[CellGroupData[{
Cell[23315339, 505033, 114, 1, 30, "Input",ExpressionUUID->"0caf8af4-b32a-4522-93a3-c6468301830b"],
Cell[23315456, 505036, 86, 0, 34, "Output",ExpressionUUID->"3f50d0bd-7490-426c-bf01-e1b2808c0a28"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23315579, 505041, 148, 3, 30, "Input",ExpressionUUID->"a64b1edc-e304-475b-863d-7b74ee069f4f"],
Cell[23315730, 505046, 86, 0, 34, "Output",ExpressionUUID->"071ca77c-302c-4160-a628-d6d110d6e1d5"]
}, Open  ]],
Cell[23315831, 505049, 122, 1, 30, "Input",ExpressionUUID->"a79ebafe-661a-48b0-ab35-5008166fa80b"],
Cell[23315956, 505052, 121, 1, 30, "Input",ExpressionUUID->"74094bf6-bdf7-4de9-8fb1-60fbb97fb50c"],
Cell[23316080, 505055, 235, 5, 30, "Input",ExpressionUUID->"d8938b7a-29d6-4293-a221-e379bbf22f3e"],
Cell[23316318, 505062, 130, 1, 30, "Input",ExpressionUUID->"aee87853-dd8d-4ee8-b1f5-6437c1b543b3"],
Cell[23316451, 505065, 122, 1, 30, "Input",ExpressionUUID->"e45ac56d-d1bb-4cf3-876d-e23288467604"],
Cell[23316576, 505068, 125, 1, 30, "Input",ExpressionUUID->"bb0c74e8-08b4-402f-bc1e-982492e78c8b"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[23316750, 505075, 120, 0, 54, "Subsection",ExpressionUUID->"f5bde83d-e9f5-4ba1-bced-fdbba5356522"],
Cell[23316873, 505077, 397, 9, 35, "Text",ExpressionUUID->"73c4ef54-09b5-40d7-82bc-a9cbb3c8bd49"],
Cell[CellGroupData[{
Cell[23317295, 505090, 95, 0, 45, "Subsubsection",ExpressionUUID->"d4936e9b-37eb-4f2d-9bfd-438f5312488e"],
Cell[23317393, 505092, 131, 1, 30, "Input",ExpressionUUID->"7eed4aa0-b100-422e-b9f4-5e1eb0fb267e"],
Cell[23317527, 505095, 266, 6, 52, "Input",ExpressionUUID->"9ff361b6-b92b-4812-bbe5-bc420b6ecce7"]
}, Closed]],
Cell[CellGroupData[{
Cell[23317830, 505106, 150, 2, 37, "Subsubsection",ExpressionUUID->"a796ae1d-021b-4f3c-b150-d23c08be16d3"],
Cell[23317983, 505110, 244, 5, 30, "Input",ExpressionUUID->"47b8db42-7f2b-462a-9aca-4908dd1a7c2d"],
Cell[23318230, 505117, 422, 11, 30, "Input",ExpressionUUID->"ffc67f63-116a-439f-9c19-97db4f8ab8e5"],
Cell[23318655, 505130, 141, 2, 30, "Input",ExpressionUUID->"dc18ca2c-74c6-4e02-988c-5a152b50a515"],
Cell[23318799, 505134, 2959, 90, 73, "Input",ExpressionUUID->"2fa40ded-f328-4557-b0a6-49efa3d3f5d7"],
Cell[CellGroupData[{
Cell[23321783, 505228, 174, 5, 30, "Input",ExpressionUUID->"2f5767a7-7d09-4ca6-a28b-abc00b4a8c20"],
Cell[23321960, 505235, 17579, 454, 125, "Output",ExpressionUUID->"b5b7d89c-1329-4a19-8580-12fe5935e453"]
}, Open  ]],
Cell[23339554, 505692, 141, 3, 30, "Input",ExpressionUUID->"c40d8558-a06f-45c2-b9e6-09075f663c11"],
Cell[CellGroupData[{
Cell[23339720, 505699, 298, 7, 30, "Input",ExpressionUUID->"d8ec23cb-6bee-46e0-8896-ea44e42f9963"],
Cell[23340021, 505708, 141, 3, 34, "Output",ExpressionUUID->"3cbb436c-4b22-4a29-ad22-1dac135c3869"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23340199, 505716, 368, 10, 30, "Input",ExpressionUUID->"0faa346a-375e-42b4-98be-0725ba1f3dd8"],
Cell[23340570, 505728, 141, 3, 34, "Output",ExpressionUUID->"b41fbd6d-9c1a-4538-a7be-e94d1997a9eb"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23340748, 505736, 148, 3, 30, "Input",ExpressionUUID->"ae83065f-1435-41bd-917f-de2e2d6d70bb"],
Cell[23340899, 505741, 36514, 1033, 365, "Output",ExpressionUUID->"f204a333-e98b-45ff-97a5-c036c48939f7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23377450, 506779, 116, 1, 30, "Input",ExpressionUUID->"2b871737-90de-4ed0-adbf-1921aebb6d57"],
Cell[23377569, 506782, 86, 0, 34, "Output",ExpressionUUID->"5c761e11-e9fc-4ae7-b3c1-1ad4d1391d43"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23377692, 506787, 152, 3, 30, "Input",ExpressionUUID->"68d1b995-8ac0-4ea0-8174-2961ad8b1f7d"],
Cell[23377847, 506792, 86, 0, 34, "Output",ExpressionUUID->"d7859c4d-a44a-4470-845f-66a749fbd402"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23377970, 506797, 183, 4, 30, "Input",ExpressionUUID->"65b5af94-50df-4fd2-9686-12d5093dc324"],
Cell[23378156, 506803, 86, 0, 34, "Output",ExpressionUUID->"6915e980-d723-4202-a9fa-c26547ba74e5"]
}, Open  ]],
Cell[23378257, 506806, 142, 3, 30, "Input",ExpressionUUID->"634ed61b-2141-4bca-9717-9b63bdc52e92"],
Cell[23378402, 506811, 120, 1, 30, "Input",ExpressionUUID->"07560db3-6100-42a7-8923-00c03dd1b74f"],
Cell[23378525, 506814, 143, 2, 30, "Input",ExpressionUUID->"d6ef7cdf-6998-48b1-a9fc-192e80439999"],
Cell[23378671, 506818, 121, 1, 30, "Input",ExpressionUUID->"65efd050-a3ec-4acb-b88b-9eba5d345640"],
Cell[23378795, 506821, 125, 1, 30, "Input",ExpressionUUID->"bb2e15eb-26ea-491e-890d-971f65c6b661"]
}, Closed]],
Cell[CellGroupData[{
Cell[23378957, 506827, 98, 0, 37, "Subsubsection",ExpressionUUID->"1f076a01-f8fe-4770-b642-ae2037d152b8"],
Cell[23379058, 506829, 244, 5, 30, "Input",ExpressionUUID->"2922a3ec-3a51-4d0e-9d9f-f5b7e4c4f2ee"],
Cell[23379305, 506836, 417, 11, 30, "Input",ExpressionUUID->"cf4d8934-580e-4dea-94c9-84f2a4f16338"],
Cell[23379725, 506849, 128, 1, 30, "Input",ExpressionUUID->"3e8e39f5-2f7b-43ba-8390-705e4029c0cb"],
Cell[CellGroupData[{
Cell[23379878, 506854, 1001, 33, 30, "Input",ExpressionUUID->"0c0efbc7-7bbe-4316-9bf4-b2edec60e62d"],
Cell[23380882, 506889, 2459, 80, 58, "Output",ExpressionUUID->"ec5925ac-a418-41a0-868a-6756eaf44531"]
}, Open  ]],
Cell[23383356, 506972, 141, 3, 30, "Input",ExpressionUUID->"213a1a65-818b-4a95-8cae-e42e2efea6c1"],
Cell[CellGroupData[{
Cell[23383522, 506979, 308, 8, 30, "Input",ExpressionUUID->"b2130f4c-94d7-4034-8431-8ce774e84bcd"],
Cell[23383833, 506989, 141, 3, 34, "Output",ExpressionUUID->"df39337b-17ab-4b7f-821c-9ab3f65bff4f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23384011, 506997, 373, 10, 30, "Input",ExpressionUUID->"beb96232-4b20-4ff9-a5aa-9ffc4407f147"],
Cell[23384387, 507009, 141, 3, 34, "Output",ExpressionUUID->"03910076-99b3-4d9b-aa31-dc90a1b7fe04"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23384565, 507017, 148, 3, 30, "Input",ExpressionUUID->"ae927348-5381-42ac-91a7-8659f9f57d89"],
Cell[23384716, 507022, 12652, 376, 217, "Output",ExpressionUUID->"2a87a119-10d9-4e39-bdb3-134ce074615a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23397405, 507403, 147, 3, 30, "Input",ExpressionUUID->"439020e8-7a45-47d9-bf9d-4e5346ebdd19"],
Cell[23397555, 507408, 28376, 811, 627, "Output",ExpressionUUID->"f55b0d6e-3d89-4b08-b782-c13510f38a2c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23425968, 508224, 427, 14, 30, "Input",ExpressionUUID->"fd779b76-80e2-4d6b-8030-3e5f2806bbcb"],
Cell[23426398, 508240, 879, 33, 53, "Output",ExpressionUUID->"63aa8702-e868-424f-9f5e-12cd0bffaa8b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23427314, 508278, 410, 11, 30, "Input",ExpressionUUID->"cab911fd-33ef-42f6-bfec-187862378fa0"],
Cell[23427727, 508291, 141, 3, 34, "Output",ExpressionUUID->"dfd96cef-c709-42fb-822e-76e0de790cae"]
}, Open  ]],
Cell[23427883, 508297, 208, 5, 30, "Input",ExpressionUUID->"4ccbf3f4-f224-41b3-851a-5a858356a7e6"],
Cell[CellGroupData[{
Cell[23428116, 508306, 800, 26, 52, "Input",ExpressionUUID->"f3698a04-eb6b-473e-9666-9bbe557ce731"],
Cell[23428919, 508334, 138, 3, 34, "Output",ExpressionUUID->"714aba52-c903-4538-a090-49b98be62c61"]
}, Open  ]],
Cell[23429072, 508340, 177, 3, 30, "Input",ExpressionUUID->"f77935ad-fced-4318-a4f8-966c3ebb52e1"],
Cell[23429252, 508345, 130, 1, 30, "Input",ExpressionUUID->"489b861b-cda8-4697-aba4-876fdc2259e1"],
Cell[23429385, 508348, 120, 1, 30, "Input",ExpressionUUID->"7ebfa86b-c0bb-4aec-ba24-fdf978bbf6fa"],
Cell[23429508, 508351, 121, 1, 30, "Input",ExpressionUUID->"9366acba-cab0-4a38-b414-eed103c1d2e2"],
Cell[23429632, 508354, 125, 1, 30, "Input",ExpressionUUID->"05111cf8-5641-42f3-b4f2-635bf0702487"]
}, Closed]],
Cell[CellGroupData[{
Cell[23429794, 508360, 125, 0, 37, "Subsubsection",ExpressionUUID->"23f6dd91-9974-45f6-8dbd-5969821455cf"],
Cell[23429922, 508362, 244, 5, 30, "Input",ExpressionUUID->"4cd5f5c9-d4fa-47e9-9187-3fb5ac4f1c63"],
Cell[23430169, 508369, 417, 11, 30, "Input",ExpressionUUID->"4d8ecc49-d258-48fd-b3c2-ff4825e78da9"],
Cell[23430589, 508382, 138, 2, 30, "Input",ExpressionUUID->"476e2685-468f-4c6b-9c8c-17962b683484"],
Cell[23430730, 508386, 142, 2, 30, "Input",ExpressionUUID->"69001dd4-f5ec-4d6f-8aad-19f5eeb479db"],
Cell[CellGroupData[{
Cell[23430897, 508392, 1327, 42, 52, "Input",ExpressionUUID->"4caef56c-08cd-4f33-8699-6bb29318dc8d"],
Cell[23432227, 508436, 3505, 112, 65, "Output",ExpressionUUID->"6c4c8f7e-3811-4716-841f-41a6808f6a1c"]
}, Open  ]],
Cell[23435747, 508551, 141, 3, 30, "Input",ExpressionUUID->"18aec5f2-4cbe-4d56-9441-0a12560d13ba"],
Cell[CellGroupData[{
Cell[23435913, 508558, 308, 8, 30, "Input",ExpressionUUID->"a013a42c-4d04-4395-8f7d-3825c4cf4100"],
Cell[23436224, 508568, 141, 3, 34, "Output",ExpressionUUID->"50c38814-b42e-496e-8c97-b9d9aace3b57"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23436402, 508576, 410, 11, 30, "Input",ExpressionUUID->"af95ca88-ae91-498a-9e68-1d8ed62b339e"],
Cell[23436815, 508589, 141, 3, 34, "Output",ExpressionUUID->"96e825c6-1f1b-45c2-8b89-c38879579610"]
}, Open  ]],
Cell[23436971, 508595, 167, 4, 30, "Input",ExpressionUUID->"8dc7626b-045e-4ebb-a970-45070de6f111"],
Cell[23437141, 508601, 166, 4, 30, "Input",ExpressionUUID->"aa97dc6e-4e5e-482e-a042-87e58163a033"],
Cell[CellGroupData[{
Cell[23437332, 508609, 427, 14, 30, "Input",ExpressionUUID->"b8963743-0bed-4349-8752-39cae26b7810"],
Cell[23437762, 508625, 1769, 63, 60, "Output",ExpressionUUID->"1f014cf7-8845-4122-9c7c-e5789c4fbbe9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23439568, 508693, 311, 10, 30, "Input",ExpressionUUID->"910b7d96-e9d2-4acd-a33b-88f46601ac25"],
Cell[23439882, 508705, 421, 15, 34, "Output",ExpressionUUID->"863ebde2-ca6c-4ac4-ac14-e653fd7f194c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23440340, 508725, 145, 3, 30, "Input",ExpressionUUID->"ab7ff0fb-c69a-4c4a-8cca-2216e82727ee"],
Cell[23440488, 508730, 281, 9, 34, "Output",ExpressionUUID->"fc7fbdac-7559-4cf3-8916-cecdec40ba6f"]
}, Open  ]],
Cell[23440784, 508742, 208, 5, 30, "Input",ExpressionUUID->"5ad9df2a-75b2-435b-954e-471f59472320"],
Cell[CellGroupData[{
Cell[23441017, 508751, 800, 26, 52, "Input",ExpressionUUID->"64c35874-3853-4b0a-a3d0-0080fdf061f2"],
Cell[23441820, 508779, 138, 3, 34, "Output",ExpressionUUID->"cc65028d-78d0-4e88-baa4-dd9fc7dd6acb"]
}, Open  ]],
Cell[23441973, 508785, 160, 4, 30, "Input",ExpressionUUID->"28164c90-8b57-4552-a2ac-83f94aee6961"],
Cell[CellGroupData[{
Cell[23442158, 508793, 379, 12, 30, "Input",ExpressionUUID->"05e8ee7c-08cf-4e6e-b6fe-6499f7ffaee0"],
Cell[23442540, 508807, 557, 19, 54, "Output",ExpressionUUID->"338730e9-1692-49e7-9532-437c1007b82c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23443134, 508831, 503, 16, 30, "Input",ExpressionUUID->"82e3658f-0179-4608-81be-e3e06e6a9614"],
Cell[23443640, 508849, 592, 20, 54, "Output",ExpressionUUID->"47990165-858e-4ccf-a1e1-693ad5065bfe"]
}, Open  ]],
Cell[23444247, 508872, 190, 3, 30, "Input",ExpressionUUID->"33e9cd80-fa14-450a-b4e0-e17f78b8b2c0"],
Cell[23444440, 508877, 140, 2, 30, "Input",ExpressionUUID->"252ea43d-b762-4da7-ba25-c721d3eaeabb"],
Cell[23444583, 508881, 144, 2, 30, "Input",ExpressionUUID->"62015d3f-3a21-469a-9259-ecda02f975f9"],
Cell[23444730, 508885, 120, 1, 30, "Input",ExpressionUUID->"eb4de121-6d0e-46f9-8db9-d205b4df2f47"],
Cell[23444853, 508888, 121, 1, 30, "Input",ExpressionUUID->"b03b2641-479c-4e9a-b105-f1ec32541a47"],
Cell[23444977, 508891, 125, 1, 30, "Input",ExpressionUUID->"1a30735e-9f44-47e5-9578-ed6f40eeaa8a"]
}, Closed]],
Cell[CellGroupData[{
Cell[23445139, 508897, 101, 0, 37, "Subsubsection",ExpressionUUID->"69ea66d1-0075-43b4-86e9-4988e6aaccbe"],
Cell[23445243, 508899, 244, 5, 30, "Input",ExpressionUUID->"a7a06305-ae21-44ff-b73f-f35ef3173255"],
Cell[23445490, 508906, 417, 11, 30, "Input",ExpressionUUID->"b0b1c779-5963-4cbe-8eee-20b024ad1d2c"],
Cell[23445910, 508919, 132, 1, 30, "Input",ExpressionUUID->"afed29ee-53ba-4bb8-914c-8b86cac40ce4"],
Cell[23446045, 508922, 129, 1, 30, "Input",ExpressionUUID->"44f178e0-5589-485a-86ac-f6b30c92dc53"],
Cell[23446177, 508925, 1581, 48, 52, "Input",ExpressionUUID->"733fc4b8-d0e1-417d-95d9-1b8402c9709b"],
Cell[23447761, 508975, 141, 3, 30, "Input",ExpressionUUID->"61006a03-bb7e-4b6e-881d-09f18b0a1703"],
Cell[CellGroupData[{
Cell[23447927, 508982, 308, 8, 30, "Input",ExpressionUUID->"8d392b55-5b5e-43f3-ab85-124e81130458"],
Cell[23448238, 508992, 139, 3, 34, "Output",ExpressionUUID->"758ecb3d-2b8b-4c5c-a98e-ca03c4b47264"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23448414, 509000, 410, 11, 30, "Input",ExpressionUUID->"0b9eb105-2c42-4560-b57b-484abc53a1d4"],
Cell[23448827, 509013, 140, 3, 34, "Output",ExpressionUUID->"3ba8c857-1c0b-4698-a144-338bdbf47f4a"]
}, Open  ]],
Cell[23448982, 509019, 167, 4, 30, "Input",ExpressionUUID->"0b61efdd-0a88-4aec-9d22-3de3dfdb633f"],
Cell[23449152, 509025, 101, 0, 35, "Text",ExpressionUUID->"eb51d8d7-0d75-4ce3-a481-11012b4be675"],
Cell[CellGroupData[{
Cell[23449278, 509029, 113, 1, 30, "Input",ExpressionUUID->"7344efe8-99ed-4bcc-92d1-be2e0599f9e0"],
Cell[23449394, 509032, 86, 0, 34, "Output",ExpressionUUID->"0bcbe5d5-8883-4e9d-aa4b-dd7ddcd5955f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23449517, 509037, 311, 10, 30, "Input",ExpressionUUID->"5de775f6-fd5d-47b3-a03a-a66fe5c0122e"],
Cell[23449831, 509049, 869, 32, 53, "Output",ExpressionUUID->"43e21c40-da4c-467a-bac0-d39c7fbe6495"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23450737, 509086, 314, 10, 30, "Input",ExpressionUUID->"dfe60ac7-4179-4489-8b1d-c89fefa8851e"],
Cell[23451054, 509098, 1130, 41, 59, "Output",ExpressionUUID->"d00834e6-8e47-4cbd-8659-69f6e5f7515a"]
}, Open  ]],
Cell[23452199, 509142, 245, 6, 30, "Input",ExpressionUUID->"08fcbaf8-af9c-4549-942d-41d7d145557a"],
Cell[CellGroupData[{
Cell[23452469, 509152, 738, 24, 30, "Input",ExpressionUUID->"654eda80-8695-4937-9583-54ed86805863"],
Cell[23453210, 509178, 83, 0, 34, "Output",ExpressionUUID->"9b3cacda-9909-4413-afcd-73b630888736"]
}, Open  ]],
Cell[23453308, 509181, 160, 3, 30, "Input",ExpressionUUID->"e5af2c21-2a26-42ac-89cf-4740ca544866"],
Cell[23453471, 509186, 134, 1, 30, "Input",ExpressionUUID->"c6135820-73fe-4f84-a5f3-20db7e33295b"],
Cell[23453608, 509189, 131, 1, 30, "Input",ExpressionUUID->"547b3c2b-8767-443b-a222-faaef712bd98"],
Cell[23453742, 509192, 120, 1, 30, "Input",ExpressionUUID->"93df1120-b4dc-4ee6-bfeb-6d2004f7fc76"],
Cell[23453865, 509195, 121, 1, 30, "Input",ExpressionUUID->"8bea698a-230e-4bab-a154-88ce76aa26a5"],
Cell[23453989, 509198, 125, 1, 30, "Input",ExpressionUUID->"49ac43b6-b629-4695-bb79-2d1892adb206"]
}, Closed]],
Cell[CellGroupData[{
Cell[23454151, 509204, 122, 0, 37, "Subsubsection",ExpressionUUID->"3742cd33-26c1-420b-a274-dacb1cab3b19"],
Cell[23454276, 509206, 244, 5, 30, "Input",ExpressionUUID->"ac8517fc-3cb7-4367-8a5c-c6ac89a47eee"],
Cell[23454523, 509213, 455, 12, 30, "Input",ExpressionUUID->"8c9502ba-78f6-4d34-894d-d8b4099437a2"],
Cell[23454981, 509227, 141, 2, 30, "Input",ExpressionUUID->"447b5b77-f879-4a14-ad31-fde629cdea23"],
Cell[CellGroupData[{
Cell[23455147, 509233, 607, 18, 30, "Input",ExpressionUUID->"299ce348-e793-4d0c-ac18-6a553b7790e7"],
Cell[23455757, 509253, 6804, 217, 83, "Output",ExpressionUUID->"5a9c078d-08fb-4843-8797-cfc988d3f447"]
}, Open  ]],
Cell[23462576, 509473, 141, 3, 30, "Input",ExpressionUUID->"5af9489f-f066-431b-8125-03d5a3e0541c"],
Cell[CellGroupData[{
Cell[23462742, 509480, 307, 8, 30, "Input",ExpressionUUID->"214d792a-dc77-4112-98eb-bff4bacf56d2"],
Cell[23463052, 509490, 141, 3, 34, "Output",ExpressionUUID->"56e3c156-7eb1-4911-9809-ad3db4efe334"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23463230, 509498, 372, 10, 30, "Input",ExpressionUUID->"5ef4bc20-1a2f-426b-a366-72d28e8c9c57"],
Cell[23463605, 509510, 141, 3, 34, "Output",ExpressionUUID->"752e116f-69f9-4ebf-b437-45a43792a5d0"]
}, Open  ]],
Cell[23463761, 509516, 167, 4, 30, "Input",ExpressionUUID->"987e5b2f-bffd-44f2-b3da-42f35e0c444e"],
Cell[CellGroupData[{
Cell[23463953, 509524, 113, 1, 30, "Input",ExpressionUUID->"2457b3b2-0792-40b7-9876-bb8038cf0290"],
Cell[23464069, 509527, 86, 0, 34, "Output",ExpressionUUID->"3797a011-346b-4688-aa02-54c93b741b9b"]
}, Open  ]],
Cell[23464170, 509530, 105, 0, 35, "Text",ExpressionUUID->"0958ad2e-1917-4817-a7a1-2a199bd80ed6"],
Cell[CellGroupData[{
Cell[23464300, 509534, 317, 8, 30, "Input",ExpressionUUID->"fe1bd7cc-1a55-41d7-b83f-f199429e1a75"],
Cell[23464620, 509544, 85, 0, 34, "Output",ExpressionUUID->"3838645f-6135-465b-a571-63d50b51ea23"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23464742, 509549, 204, 4, 30, "Input",ExpressionUUID->"3de8109c-2e3b-4742-8e2c-7ca67ff326e5"],
Cell[23464949, 509555, 84, 0, 34, "Output",ExpressionUUID->"747bc38c-a06b-4cf5-b18a-513a0588bba6"]
}, Open  ]],
Cell[23465048, 509558, 100, 0, 35, "Text",ExpressionUUID->"8098a326-7a0c-4003-b85c-d633b446356d"],
Cell[CellGroupData[{
Cell[23465173, 509562, 385, 11, 30, "Input",ExpressionUUID->"b67b90af-99eb-4bb9-b7d9-8d6496d4e354"],
Cell[23465561, 509575, 84, 0, 34, "Output",ExpressionUUID->"9ca83280-535d-4eab-889f-adebb7b81c33"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23465682, 509580, 145, 3, 30, "Input",ExpressionUUID->"7f44d335-4463-419a-aacf-be73ff813fdd"],
Cell[23465830, 509585, 16645, 532, 146, "Output",ExpressionUUID->"018d2b73-ba86-45ec-b20f-474e2f6bb9b5"]
}, Open  ]],
Cell[23482490, 510120, 95, 0, 35, "Text",ExpressionUUID->"4d0dca66-19e7-49aa-99e2-3895b0b8a738"],
Cell[CellGroupData[{
Cell[23482610, 510124, 712, 21, 30, "Input",ExpressionUUID->"721ae7f2-ae78-41de-b238-9ee009af16d9"],
Cell[23483325, 510147, 778, 23, 59, "Output",ExpressionUUID->"101e55c5-f848-425a-81a8-c707e529cb83"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23484140, 510175, 144, 3, 30, "Input",ExpressionUUID->"9bcf5aca-b89a-4a5d-a6bc-8c87491c6b1f"],
Cell[23484287, 510180, 113, 1, 34, "Output",ExpressionUUID->"4833e300-bc43-46e7-a73b-0e34517559a9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23484437, 510186, 251, 7, 30, "Input",ExpressionUUID->"eedd74ab-c2f5-4872-a035-4a94150a80e0"],
Cell[23484691, 510195, 86, 0, 34, "Output",ExpressionUUID->"7cc13b00-413e-4fcf-87a2-515c4f182767"]
}, Open  ]],
Cell[23484792, 510198, 222, 5, 30, "Input",ExpressionUUID->"b089a02c-6e08-47f1-9cd9-1b0abe258a2b"],
Cell[23485017, 510205, 143, 2, 30, "Input",ExpressionUUID->"37bac93b-fc00-494e-b0c4-7f95f9d9d4e1"],
Cell[23485163, 510209, 119, 1, 30, "Input",ExpressionUUID->"534aa7f9-d7e2-4872-b9a2-2ece2bb98060"],
Cell[23485285, 510212, 121, 1, 30, "Input",ExpressionUUID->"fa2830ef-35e2-4b38-8274-9a3d2015f058"],
Cell[23485409, 510215, 125, 1, 30, "Input",ExpressionUUID->"cc82fd06-1a0d-4a6f-ac93-fb514d4017c4"]
}, Closed]],
Cell[CellGroupData[{
Cell[23485571, 510221, 122, 0, 37, "Subsubsection",ExpressionUUID->"12a68b4a-08fc-407b-99df-8f1f7321e03a"],
Cell[23485696, 510223, 244, 5, 30, "Input",ExpressionUUID->"b6c20777-3ef4-424a-8a15-7960dd077cbe"],
Cell[23485943, 510230, 409, 11, 30, "Input",ExpressionUUID->"b6114ce4-9371-4978-a665-82e2c602018d"],
Cell[23486355, 510243, 192, 4, 30, "Input",ExpressionUUID->"0d7e1c71-0465-4eb6-9d15-9240595d0792"],
Cell[23486550, 510249, 567, 18, 52, "Input",ExpressionUUID->"ed7453e3-7959-4164-a10b-be1bc2d8a16f"],
Cell[CellGroupData[{
Cell[23487142, 510271, 2262, 69, 73, "Input",ExpressionUUID->"30ff07c8-e743-44f9-af98-740a48d64231"],
Cell[23489407, 510342, 10323, 326, 107, "Output",ExpressionUUID->"9a9338ef-5c3f-4578-9b9f-50ff9bb1b966"]
}, Open  ]],
Cell[23499745, 510671, 141, 3, 30, "Input",ExpressionUUID->"dab2a559-913d-462d-9592-385f209d6c0b"],
Cell[CellGroupData[{
Cell[23499911, 510678, 307, 8, 30, "Input",ExpressionUUID->"3a447a01-2d9a-4729-a091-104a7ac4b2b7"],
Cell[23500221, 510688, 141, 3, 34, "Output",ExpressionUUID->"921e251b-aaeb-4ddd-94ed-82ad28259b2c"]
}, Open  ]],
Cell[23500377, 510694, 328, 9, 30, "Input",ExpressionUUID->"dec48f3b-5377-4c53-a4da-121b93b71f2a"],
Cell[CellGroupData[{
Cell[23500730, 510707, 156, 3, 30, "Input",ExpressionUUID->"ab664741-753d-423e-9dd7-2205ab972e8e"],
Cell[23500889, 510712, 86, 0, 34, "Output",ExpressionUUID->"630b328f-3280-44c9-be7e-8fef14f6640c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23501012, 510717, 409, 11, 30, "Input",ExpressionUUID->"1684be53-32bc-4d62-a934-35644e083665"],
Cell[23501424, 510730, 141, 3, 34, "Output",ExpressionUUID->"e5040d74-c2ae-4e42-9c2d-eec604f93323"]
}, Open  ]],
Cell[23501580, 510736, 167, 4, 30, "Input",ExpressionUUID->"bea7c16d-9140-441a-ad41-304bf186c286"],
Cell[23501750, 510742, 239, 6, 30, "Input",ExpressionUUID->"940ad7a3-0a1b-477b-82d8-db56b45e527d"],
Cell[CellGroupData[{
Cell[23502014, 510752, 720, 24, 30, "Input",ExpressionUUID->"a21cc8ce-2498-464b-91d6-0f4bbdd5b78d"],
Cell[23502737, 510778, 83, 0, 34, "Output",ExpressionUUID->"c5748ead-167e-423b-a449-9a843af62312"]
}, Open  ]],
Cell[23502835, 510781, 176, 3, 35, "Text",ExpressionUUID->"dea6c461-a06d-4570-bb47-25daa6d5032e"],
Cell[23503014, 510786, 215, 4, 30, "Input",ExpressionUUID->"d7579109-332c-4f13-91ad-82ccd7fa8c42"],
Cell[CellGroupData[{
Cell[23503254, 510794, 851, 25, 30, "Input",ExpressionUUID->"8c4e8fca-be4a-49f8-83f3-fbb88da80b13"],
Cell[23504108, 510821, 7950, 216, 69, "Output",ExpressionUUID->"d10e1697-24e8-433a-bee4-a85e24edcebd"]
}, Open  ]],
Cell[23512073, 511040, 123, 0, 35, "Text",ExpressionUUID->"bb436d15-6df0-43ef-b346-8a4d74aba296"],
Cell[CellGroupData[{
Cell[23512221, 511044, 643, 21, 30, "Input",ExpressionUUID->"436c0ef0-3786-4a12-a8f1-392dc962d9e4"],
Cell[23512867, 511067, 86, 0, 34, "Output",ExpressionUUID->"94ec639e-c9ff-4cb6-b722-053acd2e4b85"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23512990, 511072, 635, 19, 30, "Input",ExpressionUUID->"3109327e-b460-41d9-8c10-750c8545c0ca"],
Cell[23513628, 511093, 56956, 1841, 493, "Output",ExpressionUUID->"624f4f40-91e6-4fd5-b7fe-c481714cc120"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23570621, 512939, 624, 20, 30, "Input",ExpressionUUID->"2bf3ad48-3808-49e9-8eed-7f5615b12058"],
Cell[23571248, 512961, 1284, 46, 34, "Output",ExpressionUUID->"0555e5c2-dd77-4e9c-9b63-892c9f213ff4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23572569, 513012, 563, 17, 32, "Input",ExpressionUUID->"2953969a-d3f3-414e-946b-94dc460470e7"],
Cell[23573135, 513031, 20166, 675, 198, "Output",ExpressionUUID->"ce8785fb-5297-46a8-bf00-1ce786de1840"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23593338, 513711, 3089, 112, 33, "Input",ExpressionUUID->"e5ecd1b4-44e5-4613-abd0-331066231bf6"],
Cell[23596430, 513825, 3078, 112, 37, "Output",ExpressionUUID->"69993895-7186-41a7-828a-50e8a33450ce"]
}, Open  ]],
Cell[23599523, 513940, 117, 0, 35, "Text",ExpressionUUID->"c1990146-b559-4a53-927d-60101f5fa43e"],
Cell[CellGroupData[{
Cell[23599665, 513944, 432, 13, 30, "Input",ExpressionUUID->"4bec6753-b488-41a2-812c-9acdaa347566"],
Cell[23600100, 513959, 83, 0, 34, "Output",ExpressionUUID->"9e518739-38de-4666-8c82-d89543dcfa12"]
}, Open  ]],
Cell[23600198, 513962, 80, 0, 35, "Text",ExpressionUUID->"2723ee0a-925c-4b27-94b0-9a7252c09fe1"],
Cell[23600281, 513964, 241, 5, 30, "Input",ExpressionUUID->"4c1aca98-bea3-4672-97e5-07fb831e30f2"],
Cell[23600525, 513971, 217, 4, 30, "Input",ExpressionUUID->"466570f7-0f25-4808-a21f-e5d7f87805a0"],
Cell[23600745, 513977, 194, 4, 30, "Input",ExpressionUUID->"77c5ba21-e68d-483e-b1fc-54602e82564b"],
Cell[23600942, 513983, 119, 1, 30, "Input",ExpressionUUID->"6570dca1-3d84-4b0f-b432-f3ec47f7b815"],
Cell[23601064, 513986, 121, 1, 30, "Input",ExpressionUUID->"846650e9-15ba-498b-aa1e-c35a0d2063ae"],
Cell[23601188, 513989, 125, 1, 30, "Input",ExpressionUUID->"062a0c73-a55e-4f12-8584-dfbf89c404cc"]
}, Closed]],
Cell[CellGroupData[{
Cell[23601350, 513995, 126, 0, 37, "Subsubsection",ExpressionUUID->"8f88bf39-48c1-48ee-9898-f5e803776026"],
Cell[23601479, 513997, 244, 5, 30, "Input",ExpressionUUID->"d16c1067-ba8f-4601-a22b-766bac137f9b"],
Cell[23601726, 514004, 520, 14, 30, "Input",ExpressionUUID->"488ad71b-ac62-4e89-852d-95b98c40dd1c"],
Cell[23602249, 514020, 262, 6, 30, "Input",ExpressionUUID->"7c04ef44-e65d-45f3-9996-1b0f6dc5bfad"],
Cell[23602514, 514028, 3569, 94, 116, "Input",ExpressionUUID->"0c2697e6-ea62-4ea0-8d2c-6d0750f1940c"],
Cell[CellGroupData[{
Cell[23606108, 514126, 174, 5, 30, "Input",ExpressionUUID->"5723f60a-45b6-47eb-ae39-7095f06aaf84"],
Cell[23606285, 514133, 67446, 1694, 235, "Output",ExpressionUUID->"a1f26f7c-161d-4781-a2ee-06509ce17218"]
}, Open  ]],
Cell[23673746, 515830, 141, 3, 30, "Input",ExpressionUUID->"4a91eb24-afbf-4e39-8cbb-6d7d308922fe"],
Cell[CellGroupData[{
Cell[23673912, 515837, 307, 8, 30, "Input",ExpressionUUID->"720dd9ae-d81b-4685-8043-d9ee9d98d4b0"],
Cell[23674222, 515847, 141, 3, 34, "Output",ExpressionUUID->"8ba20255-f419-457a-ad7b-5c74d7af3521"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23674400, 515855, 429, 12, 30, "Input",ExpressionUUID->"35dacba5-8425-4e8c-bf69-00ea59287605"],
Cell[23674832, 515869, 142, 3, 34, "Output",ExpressionUUID->"269d040b-9f19-41eb-888d-fcecf657f99c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23675011, 515877, 301, 9, 30, "Input",ExpressionUUID->"b2a2ad5c-80cf-4baf-bfd1-9c500189adc1"],
Cell[23675315, 515888, 389077, 8308, 127, "Output",ExpressionUUID->"a2dfa90a-b423-4af4-97c6-561eacb1f9bb"]
}, Open  ]],
Cell[24064407, 524199, 119, 0, 35, "Text",ExpressionUUID->"81dac4d2-750f-4e39-bbbd-eb9ef4794135"],
Cell[CellGroupData[{
Cell[24064551, 524203, 5632, 170, 220, "Input",ExpressionUUID->"189781b9-f471-4c88-9826-ead5fe5db6cf"],
Cell[24070186, 524375, 15227, 555, 129, "Output",ExpressionUUID->"e744bee0-202a-431a-bcfc-163d98874cbf"]
}, Open  ]],
Cell[24085428, 524933, 170, 3, 35, "Text",ExpressionUUID->"911b574c-1f79-4b59-b644-cea7318fd117"],
Cell[CellGroupData[{
Cell[24085623, 524940, 1309, 42, 52, "Input",ExpressionUUID->"17691984-91bd-4ccf-b903-7b45d12764ee"],
Cell[24086935, 524984, 1439, 55, 34, "Output",ExpressionUUID->"29cc4fc0-952b-4e18-ac4e-1fdd1cfe244e"]
}, Open  ]],
Cell[24088389, 525042, 107, 0, 35, "Text",ExpressionUUID->"965fa51e-b62b-4001-9efe-6830d3c249c6"],
Cell[CellGroupData[{
Cell[24088521, 525046, 667, 21, 30, "Input",ExpressionUUID->"ce9d0f9b-a75f-4290-b674-aedaeaeb0e0b"],
Cell[24089191, 525069, 2107, 78, 56, "Output",ExpressionUUID->"48618b07-32f2-41d2-82d0-c3adf4defddb"]
}, Open  ]],
Cell[24091313, 525150, 101, 0, 35, "Text",ExpressionUUID->"d20b3e42-d6f6-4d59-ba1b-0b26f22d71d4"],
Cell[CellGroupData[{
Cell[24091439, 525154, 142, 3, 30, "Input",ExpressionUUID->"3f40ddf2-e0a3-48bc-abb6-2cd43e00c471"],
Cell[24091584, 525159, 2846, 101, 58, "Output",ExpressionUUID->"5a44a203-2f5f-42df-ad41-d1890cc94161"]
}, Open  ]],
Cell[24094445, 525263, 145, 2, 35, "Text",ExpressionUUID->"8d087705-8da9-41b8-8dee-279293cf2274"],
Cell[CellGroupData[{
Cell[24094615, 525269, 246, 8, 30, "Input",ExpressionUUID->"8c7f8322-49c0-4dc2-8ece-080359f5047f"],
Cell[24094864, 525279, 113868, 2773, 253, "Output",ExpressionUUID->"4b426fc6-6d04-49b4-800e-e4124826edfc"]
}, Open  ]],
Cell[24208747, 528055, 104, 0, 35, "Text",ExpressionUUID->"b58a117a-1a53-44f0-97b9-5ca0c58a1545"],
Cell[24208854, 528057, 2058, 62, 115, "Input",ExpressionUUID->"473f64e9-a59d-4689-854a-708fdf453f30"],
Cell[CellGroupData[{
Cell[24210937, 528123, 281, 9, 30, "Input",ExpressionUUID->"0434ebb2-cce3-48a1-bbe5-5200a53dfab5"],
Cell[24211221, 528134, 83, 0, 34, "Output",ExpressionUUID->"82b580ec-b69b-41d5-aa3d-70fc5295139c"]
}, Open  ]],
Cell[24211319, 528137, 416, 6, 81, "Text",ExpressionUUID->"d2d88d9e-3332-4a90-b43c-aa4022bb4b9e"],
Cell[24211738, 528145, 198, 4, 30, "Input",ExpressionUUID->"cc73771f-fe60-412c-a94f-bf40d0b2ef3c"],
Cell[24211939, 528151, 264, 6, 30, "Input",ExpressionUUID->"dc39aeeb-e00d-4d5b-91c2-d207ddadeb4e"],
Cell[24212206, 528159, 119, 1, 30, "Input",ExpressionUUID->"834faac8-b42f-4dab-b405-5bcfe775883f"],
Cell[24212328, 528162, 121, 1, 30, "Input",ExpressionUUID->"d19bb53e-3b41-436d-a0ea-cd61a05bcdca"],
Cell[24212452, 528165, 125, 1, 30, "Input",ExpressionUUID->"063e2f7e-26c9-4095-8a32-c8ddf77d5663"]
}, Closed]],
Cell[CellGroupData[{
Cell[24212614, 528171, 107, 0, 37, "Subsubsection",ExpressionUUID->"39600f73-77f7-4c41-8c13-0643d5b61a53"],
Cell[24212724, 528173, 244, 5, 30, "Input",ExpressionUUID->"c256c676-94bc-4fd9-b3dd-aab1a581d092"],
Cell[24212971, 528180, 403, 11, 30, "Input",ExpressionUUID->"def72ac7-d3b9-4336-9d80-5623bfbbc3fa"],
Cell[24213377, 528193, 175, 4, 30, "Input",ExpressionUUID->"a988f2a6-f4f1-415d-b5bc-b9b61476f4b9"],
Cell[24213555, 528199, 2738, 94, 346, "Input",ExpressionUUID->"c5ed833e-3995-4a62-9081-0f857ead8527"],
Cell[CellGroupData[{
Cell[24216318, 528297, 2015, 65, 73, "Input",ExpressionUUID->"cebfa4a9-4c25-41fc-a4b0-1157b5925dd3"],
Cell[24218336, 528364, 7940, 254, 126, "Output",ExpressionUUID->"da2705b1-fced-4a98-bed3-5cbe443f7548"]
}, Open  ]],
Cell[24226291, 528621, 141, 3, 30, "Input",ExpressionUUID->"5bb359e6-bacb-4717-b7cf-18080fa06cdf"],
Cell[CellGroupData[{
Cell[24226457, 528628, 306, 8, 30, "Input",ExpressionUUID->"7fba5aa6-2668-4321-a181-be0fc7dd10d0"],
Cell[24226766, 528638, 141, 3, 34, "Output",ExpressionUUID->"3d3042b2-860f-4a17-965f-d5c1af9c309a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24226944, 528646, 428, 12, 30, "Input",ExpressionUUID->"9f95d11a-f8f4-4af7-a5c5-3e81f96190f0"],
Cell[24227375, 528660, 141, 3, 34, "Output",ExpressionUUID->"eb8923c3-a510-42ce-98d9-1b4cfff40089"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24227553, 528668, 156, 3, 30, "Input",ExpressionUUID->"875a7f04-27d9-4a00-a919-89a690abebb3"],
Cell[24227712, 528673, 86, 0, 34, "Output",ExpressionUUID->"4745c8f3-41f3-4ff1-9639-65757101aeae"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24227835, 528678, 170, 4, 30, "Input",ExpressionUUID->"0149f514-30b6-4e2c-8254-59ab7ee70440"],
Cell[24228008, 528684, 3259, 106, 77, "Output",ExpressionUUID->"bf1fbb90-592c-47fc-a32b-36177ee86ee6"]
}, Open  ]],
Cell[24231282, 528793, 343, 6, 30, "Input",ExpressionUUID->"3da659bb-e2b6-48ef-91dc-984114a9c5a6"],
Cell[24231628, 528801, 177, 4, 30, "Input",ExpressionUUID->"51b52eb3-7dff-4715-b762-ad53e8d53b07"],
Cell[24231808, 528807, 118, 1, 30, "Input",ExpressionUUID->"fdd544e6-2eec-4d6e-a0d9-875a13e82894"],
Cell[24231929, 528810, 121, 1, 30, "Input",ExpressionUUID->"c1a3fef4-fa9a-4596-9948-6736954a41a8"],
Cell[24232053, 528813, 125, 1, 30, "Input",ExpressionUUID->"f6c0197a-ed12-4401-bbac-bbc59a7eee7f"]
}, Closed]],
Cell[CellGroupData[{
Cell[24232215, 528819, 97, 0, 37, "Subsubsection",ExpressionUUID->"ecff7a72-c148-40f1-9465-2d37ba41a7be"],
Cell[24232315, 528821, 282, 4, 58, "Text",ExpressionUUID->"b4503a98-0e08-4224-872b-c91b8e7ae0ec"],
Cell[24232600, 528827, 244, 5, 30, "Input",ExpressionUUID->"96aa55e5-643e-44e3-b964-f9d948709b06"],
Cell[24232847, 528834, 419, 11, 30, "Input",ExpressionUUID->"63e4939a-ade9-4e93-93fd-e8e7d47655d6"],
Cell[24233269, 528847, 208, 4, 30, "Input",ExpressionUUID->"86ca9985-8f22-4f73-9ef2-9cf9075a24bd"],
Cell[24233480, 528853, 4406, 124, 115, "Input",ExpressionUUID->"52754a5e-5db1-47f7-9e3b-2f891529059b"],
Cell[24237889, 528979, 139, 3, 30, "Input",ExpressionUUID->"c2a8b746-8a1d-4e79-b9ad-4219d848d72c"],
Cell[CellGroupData[{
Cell[24238053, 528986, 310, 8, 30, "Input",ExpressionUUID->"c38d38f9-6aef-483c-a2bd-3a3de91012de"],
Cell[24238366, 528996, 141, 3, 34, "Output",ExpressionUUID->"c69ff87c-7445-4c58-af66-89f111c5afec"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24238544, 529004, 315, 8, 30, "Input",ExpressionUUID->"6097cc44-0c28-4b16-8f9f-d9344bca253f"],
Cell[24238862, 529014, 141, 3, 34, "Output",ExpressionUUID->"b1579a4b-4674-4513-8f41-8ed233713d60"]
}, Open  ]],
Cell[24239018, 529020, 167, 4, 30, "Input",ExpressionUUID->"1608e77a-6fa5-48bb-b96e-fb4b0bbd8270"],
Cell[CellGroupData[{
Cell[24239210, 529028, 297, 9, 30, "Input",ExpressionUUID->"48554663-c0e9-4886-aa77-454a79bcc388"],
Cell[24239510, 529039, 73594, 2738, 423, "Output",ExpressionUUID->"7e384298-2bb5-43a1-8e95-8c58ca5f51c7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24313141, 531782, 318, 10, 30, "Input",ExpressionUUID->"1632aa3a-3f35-422f-9360-a804b9ea988f"],
Cell[24313462, 531794, 17899, 669, 112, "Output",ExpressionUUID->"e966791a-b4a1-4aa1-a485-2754550cf077"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24331398, 532468, 152, 3, 30, "Input",ExpressionUUID->"70643e2b-c907-4059-846a-c20bdd1549e9"],
Cell[24331553, 532473, 86, 0, 34, "Output",ExpressionUUID->"1779f3cd-c856-465f-99da-220b7be1e99a"]
}, Open  ]],
Cell[24331654, 532476, 100, 0, 35, "Text",ExpressionUUID->"c6e1ef3d-c82a-4ace-a522-44d6240be544"],
Cell[24331757, 532478, 170, 4, 30, "Input",ExpressionUUID->"b1166140-cc7a-4d62-afd7-2c3c1a4b749d"],
Cell[CellGroupData[{
Cell[24331952, 532486, 251, 7, 30, "Input",ExpressionUUID->"dcf18ff6-52a9-43d6-961a-2586130cfc42"],
Cell[24332206, 532495, 141, 3, 34, "Output",ExpressionUUID->"e4f2e264-21d2-485f-9d3d-2494ec950f25"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24332384, 532503, 798, 26, 52, "Input",ExpressionUUID->"af5c06dc-0a69-4243-9b43-84f35f9e2eb3"],
Cell[24333185, 532531, 138, 3, 34, "Output",ExpressionUUID->"c664491a-9869-4ba6-8afc-d501a5e5871b"]
}, Open  ]],
Cell[24333338, 532537, 177, 3, 30, "Input",ExpressionUUID->"0c8c73aa-1cdb-4d8f-abfa-d01c70bc21c6"],
Cell[24333518, 532542, 144, 2, 30, "Input",ExpressionUUID->"0152c6ff-820f-4e1f-a8b3-b224906d9938"],
Cell[24333665, 532546, 122, 1, 30, "Input",ExpressionUUID->"43cade0a-d9bd-40ec-bab1-e373f737d135"],
Cell[24333790, 532549, 121, 1, 30, "Input",ExpressionUUID->"1b6c2fe5-651e-4156-b41f-40e78d8b80ef"],
Cell[24333914, 532552, 125, 1, 30, "Input",ExpressionUUID->"ee1235a9-ab96-43e0-ab88-e161240c4a05"]
}, Closed]],
Cell[CellGroupData[{
Cell[24334076, 532558, 138, 1, 37, "Subsubsection",ExpressionUUID->"5cac6c92-541b-4445-a6c8-8b0917f22b41"],
Cell[24334217, 532561, 244, 5, 30, "Input",ExpressionUUID->"1c65f7ad-1f22-4cf1-b70b-bc52a03c4ad9"],
Cell[24334464, 532568, 416, 11, 30, "Input",ExpressionUUID->"39de21ac-60c4-47a0-97eb-b77151a13eae"],
Cell[24334883, 532581, 192, 4, 30, "Input",ExpressionUUID->"9a4b3123-228b-4f8f-838f-3d44a277fa7c"],
Cell[CellGroupData[{
Cell[24335100, 532589, 4254, 120, 149, "Input",ExpressionUUID->"7587024d-5cc0-43a6-9777-d6cbb53d740a"],
Cell[24339357, 532711, 13185, 407, 106, "Output",ExpressionUUID->"133a5c87-3332-43cb-8b1a-3eed1ab89d64"]
}, Open  ]],
Cell[24352557, 533121, 141, 3, 30, "Input",ExpressionUUID->"2438b02b-c061-4967-8059-c15d2d6a3f8b"],
Cell[CellGroupData[{
Cell[24352723, 533128, 307, 8, 30, "Input",ExpressionUUID->"515913a5-016e-487f-a6c9-07ef185facbc"],
Cell[24353033, 533138, 141, 3, 34, "Output",ExpressionUUID->"3d3abc6e-07bb-42ca-8e45-4ae23572849d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24353211, 533146, 309, 8, 30, "Input",ExpressionUUID->"2d4640c2-79cf-40dd-ac69-791d8326ecf1"],
Cell[24353523, 533156, 141, 3, 34, "Output",ExpressionUUID->"022429d2-4bd9-4d78-bd32-6c2282a1c257"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24353701, 533164, 156, 3, 30, "Input",ExpressionUUID->"a565dd84-fa28-4f16-815c-2fb825eafb9e"],
Cell[24353860, 533169, 86, 0, 34, "Output",ExpressionUUID->"28a8d136-7421-4de0-8dd5-924f6b78d5a4"]
}, Open  ]],
Cell[24353961, 533172, 116, 1, 30, "Input",ExpressionUUID->"d0992348-7fd7-4bfe-b92d-fda8a5fb7604"],
Cell[24354080, 533175, 194, 4, 30, "Input",ExpressionUUID->"02e32f9c-3f7c-44b6-8294-e6c4a753ab79"],
Cell[24354277, 533181, 119, 1, 30, "Input",ExpressionUUID->"08ac544b-6168-41f0-a272-96f406cfae08"],
Cell[24354399, 533184, 121, 1, 30, "Input",ExpressionUUID->"3201dc53-b65e-4d38-b334-f812e98c6558"],
Cell[24354523, 533187, 125, 1, 30, "Input",ExpressionUUID->"5cfb4456-1c1e-4d58-8581-8cf30c1e6e36"]
}, Closed]],
Cell[CellGroupData[{
Cell[24354685, 533193, 110, 0, 37, "Subsubsection",ExpressionUUID->"93b220e5-639a-4e55-b7f8-01666140afc0"],
Cell[24354798, 533195, 244, 5, 30, "Input",ExpressionUUID->"6b1524e6-d92c-49c5-ac37-8aeca6326b55"],
Cell[24355045, 533202, 409, 11, 30, "Input",ExpressionUUID->"a4222e57-0bfd-45a3-a99f-e05d8a925286"],
Cell[24355457, 533215, 192, 4, 30, "Input",ExpressionUUID->"f9727074-ed6d-4c03-a31e-88e53a58c73d"],
Cell[24355652, 533221, 567, 18, 52, "Input",ExpressionUUID->"43a258e7-f8f2-4864-a8c7-8aa0827591a2"],
Cell[24356222, 533241, 141, 3, 30, "Input",ExpressionUUID->"9f5c65c3-edf4-411b-92be-59821166b8fd"],
Cell[24356366, 533246, 1409, 36, 115, "Input",ExpressionUUID->"9d25ff27-5e31-4f5c-be41-60cc17d0ca82"],
Cell[24357778, 533284, 1169, 35, 73, "Input",ExpressionUUID->"41f00e28-8e0a-4890-9fd6-d466ac95bb41"],
Cell[CellGroupData[{
Cell[24358972, 533323, 307, 8, 30, "Input",ExpressionUUID->"3a689043-7ef5-46be-aea2-c9c0a251e24d"],
Cell[24359282, 533333, 141, 3, 34, "Output",ExpressionUUID->"dee88f74-f377-4051-9ee1-1051bd772c29"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24359460, 533341, 372, 10, 30, "Input",ExpressionUUID->"b126ff0e-c1f0-41c9-ae61-1c71e30adf16"],
Cell[24359835, 533353, 141, 3, 34, "Output",ExpressionUUID->"f9a196ce-da03-41d2-997d-7a26912cae6b"]
}, Open  ]],
Cell[24359991, 533359, 167, 4, 30, "Input",ExpressionUUID->"2f540de1-5f33-4299-bb79-b6a4e6c5cba1"],
Cell[CellGroupData[{
Cell[24360183, 533367, 114, 1, 30, "Input",ExpressionUUID->"6137c1fd-c5d2-4db9-8e81-740953df2d6d"],
Cell[24360300, 533370, 86, 0, 34, "Output",ExpressionUUID->"003320a2-b157-40a0-b4f6-e4fd89ce1477"]
}, Open  ]],
Cell[24360401, 533373, 170, 3, 30, "Input",ExpressionUUID->"4ede5afd-a63b-4ace-8e33-5e556cc41fef"],
Cell[24360574, 533378, 194, 4, 30, "Input",ExpressionUUID->"c83a276f-d081-43aa-aab6-2fe09e9669d3"],
Cell[24360771, 533384, 119, 1, 30, "Input",ExpressionUUID->"7537f762-80b8-4486-ad0f-907eeacda3ff"],
Cell[24360893, 533387, 118, 1, 30, "Input",ExpressionUUID->"8cd90a8e-c6c6-4d95-875d-f5e55ab2bd9f"],
Cell[24361014, 533390, 121, 1, 30, "Input",ExpressionUUID->"fc863c88-ef21-4bc4-936d-4a6d9e8599d3"],
Cell[24361138, 533393, 125, 1, 30, "Input",ExpressionUUID->"7e81b978-3a00-48ae-868f-161ad9ac38e8"]
}, Closed]],
Cell[CellGroupData[{
Cell[24361300, 533399, 106, 0, 37, "Subsubsection",ExpressionUUID->"85872dc2-ac6e-4601-b577-c8e979ffd89a"],
Cell[24361409, 533401, 244, 5, 30, "Input",ExpressionUUID->"a77e6cb3-9180-4f8c-be21-84c3ebc0721a"],
Cell[24361656, 533408, 409, 11, 30, "Input",ExpressionUUID->"1560ee65-7e29-41ec-be20-6f018a65013e"],
Cell[24362068, 533421, 192, 4, 30, "Input",ExpressionUUID->"fe30879b-77d1-4f5b-a9a2-b6a9b91118ff"],
Cell[24362263, 533427, 8316, 222, 318, "Input",ExpressionUUID->"1b42fbb6-497f-42dd-b30a-ce9f5ce1aea3"],
Cell[CellGroupData[{
Cell[24370604, 533653, 831, 25, 30, "Input",ExpressionUUID->"1f301bdc-465c-4333-8261-3c56faf6b4e7"],
Cell[24371438, 533680, 4999, 142, 75, "Output",ExpressionUUID->"054c61b7-1230-4dcc-a1c4-dce646339354"]
}, Open  ]],
Cell[24376452, 533825, 141, 3, 30, "Input",ExpressionUUID->"9dccea9f-05de-4cc7-8695-cdb193f3f5d8"],
Cell[CellGroupData[{
Cell[24376618, 533832, 256, 6, 30, "Input",ExpressionUUID->"f3ee22e1-b33b-4b2f-83c6-f087335d7736"],
Cell[24376877, 533840, 141, 3, 34, "Output",ExpressionUUID->"89f74d5e-80e0-461c-977b-855a8a052998"]
}, Open  ]],
Cell[24377033, 533846, 167, 4, 30, "Input",ExpressionUUID->"c79d8bd7-94bd-40a9-8e94-00b651f1d174"],
Cell[CellGroupData[{
Cell[24377225, 533854, 208, 6, 30, "Input",ExpressionUUID->"7bf765db-af32-425b-a400-5fb8b58bc80e"],
Cell[24377436, 533862, 83, 0, 34, "Output",ExpressionUUID->"2d0d9dc7-ee7a-49ae-9a6a-7fe45e1581e6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24377556, 533867, 145, 3, 30, "Input",ExpressionUUID->"019b4d75-51e6-4fae-b6a7-0a11e5a5dd97"],
Cell[24377704, 533872, 2878, 103, 62, "Output",ExpressionUUID->"448f2b6f-3a63-423d-9a51-89cffaa81aaf"]
}, Open  ]],
Cell[24380597, 533978, 245, 6, 30, "Input",ExpressionUUID->"d1ffea02-ddfe-4ef2-91b0-299b16d2ca31"],
Cell[CellGroupData[{
Cell[24380867, 533988, 738, 24, 30, "Input",ExpressionUUID->"accc27d5-4375-4edd-bc69-da5ee1101b3a"],
Cell[24381608, 534014, 83, 0, 34, "Output",ExpressionUUID->"baa32ed9-c7f6-4fd3-94ec-19a8bf7205d9"]
}, Open  ]],
Cell[24381706, 534017, 126, 0, 35, "Text",ExpressionUUID->"cd07a007-d780-4709-b7c5-bb33cb0fadcb"],
Cell[24381835, 534019, 146, 3, 30, "Input",ExpressionUUID->"146736f8-a107-4d98-8747-8e048a52bc66"],
Cell[24381984, 534024, 1061, 33, 94, "Input",ExpressionUUID->"fdca994d-b9c0-4a15-bacf-98ae7c70f57c"],
Cell[CellGroupData[{
Cell[24383070, 534061, 740, 27, 30, "Input",ExpressionUUID->"a8ff9705-6e33-471c-94b2-c05efe6fb22b"],
Cell[24383813, 534090, 86, 0, 34, "Output",ExpressionUUID->"04925be7-437e-4e4e-8b78-edbe2d1d962d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24383936, 534095, 388, 12, 30, "Input",ExpressionUUID->"731eb763-52db-4849-971e-efeb3e37bc89"],
Cell[24384327, 534109, 5219, 183, 68, "Output",ExpressionUUID->"4f9408e0-71c2-410f-b98b-2fae9a2dcdf8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24389583, 534297, 386, 12, 30, "Input",ExpressionUUID->"7a67d7ee-ff00-4338-941d-4e5d9d7e6cfb"],
Cell[24389972, 534311, 2390, 89, 72, "Output",ExpressionUUID->"adf1ea0b-fc55-4186-91df-5e62a1b5ee3a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24392399, 534405, 388, 12, 30, "Input",ExpressionUUID->"f8fdf400-048e-4a32-9cae-e65774626219"],
Cell[24392790, 534419, 3518, 130, 68, "Output",ExpressionUUID->"580b8062-106b-4ffc-bdb0-0b461d97fbbe"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24396345, 534554, 389, 12, 30, "Input",ExpressionUUID->"09743b26-e319-4813-8306-3795adf26362"],
Cell[24396737, 534568, 7931, 289, 68, "Output",ExpressionUUID->"d9ddf9bf-d6b6-40cf-a32a-04a2b13f7da6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24404705, 534862, 388, 12, 30, "Input",ExpressionUUID->"cd3e8206-c815-46bc-951c-66995aff901c"],
Cell[24405096, 534876, 2390, 89, 72, "Output",ExpressionUUID->"925514fa-5aff-479c-a3d6-8586b7a5fb51"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24407523, 534970, 388, 12, 30, "Input",ExpressionUUID->"c4958191-5b2a-4c9e-b15b-3fe0fb87e801"],
Cell[24407914, 534984, 5219, 183, 68, "Output",ExpressionUUID->"5c4d2ed8-cd9c-4be5-83d5-87d20866ef42"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24413170, 535172, 388, 12, 30, "Input",ExpressionUUID->"0bb8328a-abfa-4eec-8ca3-aa1bb19532ca"],
Cell[24413561, 535186, 8236, 290, 68, "Output",ExpressionUUID->"6c597654-73eb-4a07-bcdd-c5a015107469"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24421834, 535481, 395, 12, 30, "Input",ExpressionUUID->"57745a16-f0a6-45bb-b484-54b4b95b772e"],
Cell[24422232, 535495, 3664, 131, 68, "Output",ExpressionUUID->"a15307a2-96ee-41f2-8396-6d4edad412f0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24425933, 535631, 761, 25, 30, "Input",ExpressionUUID->"3bac5169-21b6-4927-9f10-28df031f424b"],
Cell[24426697, 535658, 4069, 150, 72, "Output",ExpressionUUID->"4ad06b20-063d-462a-8724-2cc6e3cbdcc9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24430803, 535813, 759, 25, 30, "Input",ExpressionUUID->"d129cceb-557d-444e-b5bc-e496318ca620"],
Cell[24431565, 535840, 4069, 150, 72, "Output",ExpressionUUID->"286e7b6e-d131-4064-ab18-f8167a9f21cb"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24435671, 535995, 758, 25, 30, "Input",ExpressionUUID->"aec137b8-5444-4b29-a0ce-54eba613600e"],
Cell[24436432, 536022, 6621, 243, 68, "Output",ExpressionUUID->"590fc136-5a40-4c7a-a472-5bb988968e3e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24443090, 536270, 765, 25, 30, "Input",ExpressionUUID->"2a0d481b-5b02-42a1-9582-7efea880ed4f"],
Cell[24443858, 536297, 6601, 242, 68, "Output",ExpressionUUID->"99f1121a-d9c1-4f4c-b243-18479bc4be94"]
}, Open  ]],
Cell[24450474, 536542, 101, 0, 35, "Text",ExpressionUUID->"5d0726a5-4c5f-476d-82ee-f3a0fcac3c1a"],
Cell[24450578, 536544, 1415, 48, 94, "Input",ExpressionUUID->"daeb90f3-8857-43f0-96d7-98f82e5eda3c"],
Cell[CellGroupData[{
Cell[24452018, 536596, 602, 17, 30, "Input",ExpressionUUID->"83117622-98a3-448f-aae9-dcea6fe17667"],
Cell[24452623, 536615, 86, 0, 34, "Output",ExpressionUUID->"533e86a1-19be-4dc3-a41a-89a1427af52c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24452746, 536620, 594, 17, 30, "Input",ExpressionUUID->"aa48a8d4-36b8-47c2-af4d-faf31e74b7fe"],
Cell[24453343, 536639, 86, 0, 34, "Output",ExpressionUUID->"2eb13621-4651-4d2f-8137-22912c2bdfc9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24453466, 536644, 595, 17, 30, "Input",ExpressionUUID->"7a26a0a3-1a07-4381-b091-02a4bffc6fe4"],
Cell[24454064, 536663, 86, 0, 34, "Output",ExpressionUUID->"271aa7df-4b02-4935-82aa-a9b4aa879890"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24454187, 536668, 595, 17, 30, "Input",ExpressionUUID->"f8f5cdf4-fabe-4572-86e2-f7f606a1c8c4"],
Cell[24454785, 536687, 86, 0, 34, "Output",ExpressionUUID->"7770d626-44a5-4d56-a100-0b75519185e6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24454908, 536692, 567, 16, 30, "Input",ExpressionUUID->"f36bbac0-2034-4cf1-9cf1-03927c1243d9"],
Cell[24455478, 536710, 86, 0, 34, "Output",ExpressionUUID->"560eeae2-47d3-42fd-a07a-626095644dfc"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24455601, 536715, 568, 16, 30, "Input",ExpressionUUID->"1bacb82d-4073-4a8c-b839-b45757c85f59"],
Cell[24456172, 536733, 86, 0, 34, "Output",ExpressionUUID->"0386cdc2-c8f7-4df7-afbf-0dcc5e8b281d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24456295, 536738, 566, 16, 30, "Input",ExpressionUUID->"dac06bc2-1270-439e-a680-4f49c8a98d06"],
Cell[24456864, 536756, 86, 0, 34, "Output",ExpressionUUID->"38a3daec-f32f-45fe-9bbb-92cde6ba1db9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24456987, 536761, 571, 16, 30, "Input",ExpressionUUID->"abc71972-f4fe-415a-8611-9bf6619f47c0"],
Cell[24457561, 536779, 86, 0, 34, "Output",ExpressionUUID->"135cbdc7-a50d-435c-a49a-364289d492ac"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24457684, 536784, 591, 17, 30, "Input",ExpressionUUID->"b9bbd701-107f-4fb5-a37c-7d60757ed45b"],
Cell[24458278, 536803, 86, 0, 34, "Output",ExpressionUUID->"86b7f01a-215d-4698-855b-754fbb13e48f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24458401, 536808, 585, 17, 30, "Input",ExpressionUUID->"72435a32-0885-4880-88ad-3768c2672336"],
Cell[24458989, 536827, 86, 0, 34, "Output",ExpressionUUID->"7b25dda7-ca97-4702-8404-f6ff06873cc0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24459112, 536832, 585, 17, 30, "Input",ExpressionUUID->"d4fde197-258d-467a-a369-589e7bb3ecc0"],
Cell[24459700, 536851, 86, 0, 34, "Output",ExpressionUUID->"3d8a9fed-917f-4f52-8e07-a85035d5f48e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24459823, 536856, 589, 17, 30, "Input",ExpressionUUID->"577bdc3a-b265-4d98-9f72-80d4da67a64b"],
Cell[24460415, 536875, 86, 0, 34, "Output",ExpressionUUID->"5eba5731-4d86-4fe6-9c4d-4469e0ca653d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24460538, 536880, 573, 16, 30, "Input",ExpressionUUID->"8d4b4712-a2c9-458b-ba3a-8dfc4066db98"],
Cell[24461114, 536898, 86, 0, 34, "Output",ExpressionUUID->"8f05d7f3-ec1e-4935-9385-d6aeb57df3bd"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24461237, 536903, 567, 16, 30, "Input",ExpressionUUID->"b820811d-994f-4f1c-b02c-c363f6193102"],
Cell[24461807, 536921, 86, 0, 34, "Output",ExpressionUUID->"446b8787-d1a5-4683-a4f4-8efa58630f98"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24461930, 536926, 566, 16, 30, "Input",ExpressionUUID->"777367fc-86c3-4114-b99a-d2cb46e26cad"],
Cell[24462499, 536944, 86, 0, 34, "Output",ExpressionUUID->"739588ef-bb9b-4897-97bc-9f8557877b20"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24462622, 536949, 572, 16, 30, "Input",ExpressionUUID->"665cb4d4-770f-4392-9af9-f0a146c915d1"],
Cell[24463197, 536967, 86, 0, 34, "Output",ExpressionUUID->"397b659a-4633-4b3c-b5f2-34b2a2bdc554"]
}, Open  ]],
Cell[24463298, 536970, 160, 4, 30, "Input",ExpressionUUID->"032e8499-7733-450f-acf3-7ef21fb35f40"],
Cell[24463461, 536976, 145, 3, 30, "Input",ExpressionUUID->"34540822-e42b-4a2b-9ac9-235b5ae63cc5"],
Cell[CellGroupData[{
Cell[24463631, 536983, 233, 7, 30, "Input",ExpressionUUID->"24adc5b5-47fb-46ab-99d7-339007d4e3b0"],
Cell[24463867, 536992, 691521, 15071, 263, "Output",ExpressionUUID->"006f9f66-479e-4864-b5fe-d4ce624a0e30"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25155425, 552068, 419, 13, 30, "Input",ExpressionUUID->"0da6c691-8483-4646-9801-b1421ff92e2c"],
Cell[25155847, 552083, 2396, 87, 62, "Output",ExpressionUUID->"0c606736-84f6-4889-ba3a-276c6c0a4b93"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25158280, 552175, 419, 13, 30, "Input",ExpressionUUID->"b0ea8a97-86bb-458d-8df8-5e4ca4db3618"],
Cell[25158702, 552190, 3235, 117, 66, "Output",ExpressionUUID->"66c962ea-ca09-4089-8695-bb7c3ad1d7f0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25161974, 552312, 422, 13, 30, "Input",ExpressionUUID->"c1ee2f5f-c0db-4b39-9ae6-c993c78ec315"],
Cell[25162399, 552327, 3256, 113, 62, "Output",ExpressionUUID->"5c137766-c87a-4e31-a5ce-7be1b27c0fb5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25165692, 552445, 422, 13, 30, "Input",ExpressionUUID->"90678609-5293-4c32-a309-87597745115a"],
Cell[25166117, 552460, 3368, 118, 66, "Output",ExpressionUUID->"f74a9b2e-6e83-4fe7-98d6-15245f6792d4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25169522, 552583, 425, 13, 30, "Input",ExpressionUUID->"3e4f13d9-be58-443a-8426-815d2215e023"],
Cell[25169950, 552598, 2396, 87, 62, "Output",ExpressionUUID->"3701c657-20bb-4791-bb52-402e3da34812"]
}, Open  ]],
Cell[25172361, 552688, 119, 1, 30, "Input",ExpressionUUID->"03d133bd-f3ea-4928-8352-afe4caea4c9d"],
Cell[25172483, 552691, 295, 6, 30, "Input",ExpressionUUID->"148e3f48-6125-4266-b3a2-04b9ef15287e"],
Cell[25172781, 552699, 194, 4, 30, "Input",ExpressionUUID->"15e7e208-a253-4efa-a4f0-bba7861ac07a"],
Cell[25172978, 552705, 119, 1, 30, "Input",ExpressionUUID->"3cd828f1-9c45-4b69-abd1-9e8f38d16d45"],
Cell[25173100, 552708, 121, 1, 30, "Input",ExpressionUUID->"abcfe630-10e2-4b8f-a982-e15cda7369b1"],
Cell[25173224, 552711, 125, 1, 30, "Input",ExpressionUUID->"7e617930-5337-4edb-953f-a21b71cae53f"]
}, Closed]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[25173410, 552719, 122, 0, 67, "Section",ExpressionUUID->"97afd843-197b-4ab4-991b-4d04f63971c8"],
Cell[CellGroupData[{
Cell[25173557, 552723, 112, 1, 30, "Input",ExpressionUUID->"6ffb5116-6b78-40ad-b8e3-25826a73c749"],
Cell[CellGroupData[{
Cell[25173694, 552728, 151, 1, 24, "Print",ExpressionUUID->"ec7e61ad-a718-46bd-a4b6-f8c3a225f7e6"],
Cell[25173848, 552731, 425, 10, 24, "Print",ExpressionUUID->"e348ffc6-ea78-4bc0-817d-635ddf5136cd"],
Cell[25174276, 552743, 174, 2, 24, "Print",ExpressionUUID->"efa7e923-0433-47ed-a9e3-35d162a2bad8"],
Cell[25174453, 552747, 129, 0, 24, "Print",ExpressionUUID->"9c04ad39-ce35-4231-8190-2e2fcec56d04"],
Cell[25174585, 552749, 112, 0, 24, "Print",ExpressionUUID->"d1dfc49d-6796-41a5-89a5-accf8714e701"],
Cell[25174700, 552751, 151, 1, 24, "Print",ExpressionUUID->"9c865778-7dbe-422f-a751-a02a8d26bf78"],
Cell[25174854, 552754, 429, 10, 24, "Print",ExpressionUUID->"91f0ef23-a693-4716-ae82-213cd7f48747"],
Cell[25175286, 552766, 174, 2, 24, "Print",ExpressionUUID->"4b8836ce-6ca2-485a-b988-2ea0c1a35850"],
Cell[25175463, 552770, 151, 1, 24, "Print",ExpressionUUID->"b3a6f03e-bc28-4ad7-b0ba-bd9945b6d8c4"],
Cell[25175617, 552773, 308, 4, 44, "Print",ExpressionUUID->"5ab27e5f-d8fb-444b-8f3d-d349a6d4a8e9"],
Cell[25175928, 552779, 151, 1, 24, "Print",ExpressionUUID->"c36bc37f-5ba6-4711-a4b4-74fc14ceb617"]
}, Open  ]]
}, Open  ]],
Cell[25176106, 552784, 235, 6, 52, "Input",ExpressionUUID->"7baa270e-c30e-4880-9075-9e3cd2a2e467"],
Cell[25176344, 552792, 344, 8, 30, "Input",ExpressionUUID->"aaaa953d-fb17-4b9e-874f-4f6e87b4c575"],
Cell[25176691, 552802, 276, 8, 30, "Input",ExpressionUUID->"1cee04cc-ba3b-45dc-a62f-941c96cc7fdc"],
Cell[25176970, 552812, 175, 4, 30, "Input",ExpressionUUID->"671e7617-6d34-4de9-a53d-610dce54ebf0"],
Cell[25177148, 552818, 242, 7, 30, "Input",ExpressionUUID->"d0037232-5808-4b35-adcd-d354c92eca4a"],
Cell[CellGroupData[{
Cell[25177415, 552829, 358, 10, 30, "Input",ExpressionUUID->"0eeb0977-28e1-47da-8676-da5ed7b7f099"],
Cell[25177776, 552841, 483, 9, 24, "Message",ExpressionUUID->"2ee69e51-ac85-4ed1-a188-4a2f4658532c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25178296, 552855, 214, 6, 30, "Input",ExpressionUUID->"0c25a2c0-aed3-4d6f-8446-f16f480847c9"],
Cell[25178513, 552863, 1126, 32, 38, "Output",ExpressionUUID->"37628652-7a7c-4025-9f66-85e1d83dd0fc"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25179676, 552900, 126, 1, 30, "Input",ExpressionUUID->"8b3d887d-7339-4b6d-aa76-c1bd0df68005"],
Cell[25179805, 552903, 3062, 87, 38, "Output",ExpressionUUID->"1ada267b-9a23-4296-929e-30d8b9c86352"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25182904, 552995, 168, 4, 30, "Input",ExpressionUUID->"d0d1c931-9597-4558-ae1b-b2e3e1ba0eab"],
Cell[25183075, 553001, 1054, 30, 38, "Output",ExpressionUUID->"34964827-c5e1-4abd-8687-1955c4a9e9fa"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25184166, 553036, 336, 10, 30, "Input",ExpressionUUID->"04eba256-01b4-45ec-8861-3ffa0d94f658"],
Cell[25184505, 553048, 43438, 1207, 73, "Output",ExpressionUUID->"27913377-787b-441e-a0d6-9cd81c7f171b"]
}, Open  ]],
Cell[25227958, 554258, 145, 2, 35, "Text",ExpressionUUID->"fc739014-10b4-444a-b83d-00f7edc3510b"],
Cell[CellGroupData[{
Cell[25228128, 554264, 110, 1, 30, "Input",ExpressionUUID->"67eeff64-a6b9-48c4-9b01-a128ed90405b"],
Cell[CellGroupData[{
Cell[25228263, 554269, 151, 1, 24, "Print",ExpressionUUID->"f006bfec-89af-4ad3-9962-43207803f5f5"],
Cell[25228417, 554272, 425, 10, 24, "Print",ExpressionUUID->"c6868588-9d53-4ade-9342-9117b17177d6"],
Cell[25228845, 554284, 192, 2, 24, "Print",ExpressionUUID->"1779ad36-67e7-4bfe-ad24-8b860a47806d"],
Cell[25229040, 554288, 151, 1, 24, "Print",ExpressionUUID->"c47726a3-dfca-4cd0-a7a8-3018f67f69df"],
Cell[25229194, 554291, 308, 4, 44, "Print",ExpressionUUID->"32a0dcde-4ec9-4d34-921f-f43b8df18dde"],
Cell[25229505, 554297, 151, 1, 24, "Print",ExpressionUUID->"f34e361e-41b1-47cf-8842-8bd89a08078b"]
}, Open  ]]
}, Open  ]],
Cell[25229683, 554302, 418, 11, 30, "Input",ExpressionUUID->"e4ecdcd5-7fde-4b58-96bf-2d3614a36cfb"],
Cell[25230104, 554315, 197, 4, 30, "Input",ExpressionUUID->"b7dc4d2f-f234-41f1-be8a-c8daf0497efe"],
Cell[CellGroupData[{
Cell[25230326, 554323, 1130, 36, 52, "Input",ExpressionUUID->"8cb1b6f8-e879-4780-b1df-a19a2eb946c4"],
Cell[25231459, 554361, 9451, 254, 111, "Output",ExpressionUUID->"18c9f572-fbc8-4129-bd5b-eaf2d37001d1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25240947, 554620, 534, 16, 30, "Input",ExpressionUUID->"3bbeddf0-46fc-4969-b9d6-a07d6fea6193"],
Cell[25241484, 554638, 3296, 93, 97, "Output",ExpressionUUID->"207b8379-36e6-4c15-9975-a02955a5771f"]
}, Open  ]],
Cell[25244795, 554734, 96, 0, 35, "Text",ExpressionUUID->"66430268-c8ce-4d09-80bd-a6d80dc17d29"],
Cell[CellGroupData[{
Cell[25244916, 554738, 307, 9, 30, "Input",ExpressionUUID->"b9a932ad-85a2-4bac-b55c-c8c068024e30"],
Cell[25245226, 554749, 100, 1, 34, "Output",ExpressionUUID->"bc2011a1-a2ab-4f31-a010-c17cfca843b6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25245363, 554755, 134, 2, 30, "Input",ExpressionUUID->"f57383c8-bff1-4c07-88f0-b957c091a9e1"],
Cell[25245500, 554759, 12542, 374, 215, "Output",ExpressionUUID->"84698066-de1e-46e5-9841-1fee3b6c1b90"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25258079, 555138, 268, 8, 30, "Input",ExpressionUUID->"55eae62e-18d8-452d-b984-d1808cb2f7dd"],
Cell[25258350, 555148, 83, 0, 34, "Output",ExpressionUUID->"35e8b3ad-066b-4e7e-958c-e4dfe54d1f6c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25258470, 555153, 131, 2, 30, "Input",ExpressionUUID->"5a92800c-f6bb-4454-acbc-c8be6141a342"],
Cell[25258604, 555157, 3311, 94, 87, "Output",ExpressionUUID->"8ee2f46b-3f32-4965-9ba5-4f2c9bfaa41d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25261952, 555256, 249, 7, 30, "Input",ExpressionUUID->"006a2a68-1482-4d21-b873-522abd1d7b4a"],
Cell[25262204, 555265, 8535, 230, 109, "Output",ExpressionUUID->"b928b506-15c6-4e68-86a6-aa8b345aed05"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25270776, 555500, 373, 11, 30, "Input",ExpressionUUID->"8c0e5997-6f12-4745-8b3c-0391b5018a46"],
Cell[25271152, 555513, 1140, 38, 52, "Output",ExpressionUUID->"9ba57bc4-3582-42a2-9449-f8b6782a1461"]
}, Open  ]],
Cell[25272307, 555554, 157, 2, 35, "Text",ExpressionUUID->"58162716-db6a-4fdd-a73b-375d8505f2c2"],
Cell[CellGroupData[{
Cell[25272489, 555560, 377, 12, 30, "Input",ExpressionUUID->"6286b2b6-201f-4861-9f50-2127075f6cfa"],
Cell[25272869, 555574, 83, 0, 34, "Output",ExpressionUUID->"c3cd9e5d-d8b8-479e-8900-ba619f248715"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25272989, 555579, 117, 1, 30, "Input",ExpressionUUID->"201a5b01-cdf8-4ae4-b80a-91ebd292511b"],
Cell[25273109, 555582, 86, 0, 34, "Output",ExpressionUUID->"c971c173-15fb-4035-aba3-171b4fffd7c0"]
}, Open  ]],
Cell[25273210, 555585, 165, 3, 35, "Text",ExpressionUUID->"b3f8175b-75dd-4c9e-bc21-56e6f790a7d2"],
Cell[CellGroupData[{
Cell[25273400, 555592, 85, 0, 30, "Input",ExpressionUUID->"1f0c8601-4edc-40b1-8451-22341a403f20"],
Cell[25273488, 555594, 2457, 37, 51, "Message",ExpressionUUID->"5464639e-e68f-4145-8121-f1049b80388a"],
Cell[25275948, 555633, 300, 6, 24, "Message",ExpressionUUID->"4cbf9f40-be25-47b0-8152-1129716beb1a"],
Cell[25276251, 555641, 150, 3, 34, "Output",ExpressionUUID->"b426947d-dc4f-4c6e-9428-550ccd036e24"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25276438, 555649, 294, 9, 30, "Input",ExpressionUUID->"0a01c288-ebb9-459f-bc1c-a76bb3abc39b"],
Cell[25276735, 555660, 146227, 3441, 263, "Output",ExpressionUUID->"9aa1405d-f1c8-49ad-bfec-0fff9e67c428"]
}, Open  ]]
}, Closed]]
}
]
*)

